#include "PLB.h"

// Kommentar: Diese Klasse koordiniert die verschiedenen Teile des echten PLB's.

void PLB_Klasse::initialisieren(int _rang, int _groesse, int _mit_ohne)
    {
    rang = _rang;
    groesse = _groesse;
    mit_ohne = _mit_ohne;

    if(groesse == 1)
        {
        return;
        }

    strcpy(text,"da_plb");
#ifdef DA_PLB
    da.initialisieren(rang, text);
    da.oeffnen();

    * da.aus << " Mit Ohne " << mit_ohne << endl;

    * da.aus << " Vor Initialisierung_identify in PLB::init rang " << rang << endl;
#endif
// Kommentar: Anlegen der Precomputation Struktur
    precomputation.initialisierung_identify(rang, groesse);
#ifdef DA_PLB
    * da.aus << " Initialisierung_identify durch in PLB::init rang " << rang << endl;
#endif
// Kommentar: Anlegen des Ost - West sowie des Nord - Sd - Balancer - Klasse
    balancing.initialisieren(precomputation.ID_westen, precomputation.ID_osten, precomputation.groesse_g, mit_ohne);
#ifdef DA_PLB
    * da.aus << " balancing.init durch in PLB::init rang " << rang << " ID_westen " << precomputation.ID_westen << " ID_osten " << precomputation.ID_osten << " groesse_g " << precomputation.groesse_g << endl;
#endif
    balancing_ns.initialisieren(precomputation.ID_norden, precomputation.ID_sueden, precomputation.groesse_f, mit_ohne);
#ifdef DA_PLB
    * da.aus << " balancing_ns.init durch in PLB::init rang " << rang << " ID_norden " << precomputation.ID_norden << " ID_sueden " << precomputation.ID_sueden << " groesse_f " << precomputation.groesse_f << endl;
#endif
// Kommentar: Dieselben Klassen; der Rang wird bergeben
    balancing.initialisieren_rang(rang);
    balancing_ns.initialisieren_rang(rang);
#ifdef DA_PLB
    * da.aus << " balancing.init_rang und bal ns.init_rang durch in PLB::init rang " << rang << endl;
#endif
    }

void PLB_Klasse::finalisieren(void)
    {
#ifdef DA_PLB
    da.schliessen();
#endif
// Kommentar: Finalisierung der precomputation - und der balancing - Klassen
    precomputation.finalisierung_identify();
    balancing.finalisieren();
    balancing_ns.finalisieren();
    }

// Kommentar: echtes PLB mit reversem Lastausgleich
void PLB_Klasse::tun_mit(int _eigene_last, int _eigene_last_oben)
    {
    if(groesse==1)
        {
        return;
        }

// Kommentar: Die eigenen Lasten
    eigene_last = _eigene_last;
    eigene_last_oben = _eigene_last_oben;
#ifdef DA_PLB
    * da.aus << " eL " << eigene_last << " eL oben " << eigene_last_oben << endl;
#endif

// Kommentar: Weitergeben der Lasten an die Precomputation - Klasse
    precomputation.tun_mit(eigene_last, eigene_last_oben);

// Kommentar: Durchfhrung des Precomputation fr Ost - West
    precomputation.tun_ow_mit();
#ifdef DA_PLB
    * da.aus << " precomputation.lambda_west " << precomputation.lambda_west;
    * da.aus << " precomputation.lambda_ost " << precomputation.lambda_ost << endl;
    * da.aus << " precomputation.lambda_west_oben " << precomputation.lambda_west_oben << endl;
    * da.aus << " precomputation.lambda_ost_oben " << precomputation.lambda_ost_oben << endl;
#endif
// Kommentar: Balancing fr Ost - West. bergabe der Werte aus der Precomputation Klasse
    balancing.tun_ow_mit(precomputation.lambda, precomputation.lambda_west, precomputation.lambda_ost, precomputation.lambda_oben, precomputation.lambda_west_oben, precomputation.lambda_ost_oben);
#ifdef DA_PLB
    * da.aus << " Nach balancing.tun_ow_mit " << endl;
    * da.aus << " bal_lambda " << balancing.lambda << " bal_lambda_oben " << balancing.lambda_oben << endl;
#endif
// Kommentar: Weitergeben der neuen Lasten an die Precomputation Klasse
    precomputation.tun_mit(balancing.lambda, balancing.lambda_oben);
// Kommentar: Die weiteren Schritte fr den Nord - Sd - Lastausgleich. Entsprechend die Kommentare wie beim Ost - West
// Lastausgleich oben
    precomputation.tun_ns_mit();
#ifdef DA_PLB
    * da.aus << " lambda " << precomputation.lambda << " lambda_nord " << precomputation.lambda_nord << " lambda_sued " << precomputation.lambda_sued;
    * da.aus << " lambda_oben " << precomputation.lambda_oben << " lambda_nord_oben " << precomputation.lambda_nord_oben << " lambda_sued_oben " << precomputation.lambda_sued_oben << endl;
#endif
    balancing_ns.tun_ow_mit(precomputation.lambda, precomputation.lambda_nord, precomputation.lambda_sued, precomputation.lambda_oben, precomputation.lambda_nord_oben, precomputation.lambda_sued_oben);
#ifdef DA_PLB
    * da.aus << " Durch PLB tun_mit durch " << endl;
#endif
    }

// Kommentar: Echtes PLB, nur ohne reversem Lastausgleich; Kommentare entsprechend der Funktion tun_mit,
// nur mit der Lastinformation einer Gitterebene
void PLB_Klasse::tun_ohne(int _eigene_last)
    {
    if(groesse==1)
        {
        return;
        }

    eigene_last = _eigene_last;

    precomputation.tun_ohne(eigene_last);

    precomputation.tun_ow_ohne();
#ifdef DA_PLB
    * da.aus << " precomputation.lambda_west " << precomputation.lambda_west;
    * da.aus << " precomputation.lambda_ost " << precomputation.lambda_ost << endl;
#endif

    balancing.tun_ow_ohne(precomputation.lambda, precomputation.lambda_west, precomputation.lambda_ost);
#ifdef DA_PLB
    * da.aus << " Nach balancing.tun_ow_ohne " << endl;
    * da.aus << " bal_lambda " << balancing.lambda << endl;
#endif
    precomputation.tun_ohne(balancing.lambda);
    precomputation.tun_ns_ohne();
#ifdef DA_PLB
    * da.aus << " lambda " << precomputation.lambda << " lambda_nord " << precomputation.lambda_nord << " lambda_sued " << precomputation.lambda_sued << endl;
#endif
    balancing_ns.tun_ow_ohne(precomputation.lambda, precomputation.lambda_nord, precomputation.lambda_sued);
    }

// Kommentar: Wie bei dem Lastausgleich tun_mit, aber nur mit einer Lastausgleichsrunde. Nur die Balancing - Funktionsaufrufe
// mssen dazu angepasst werden. Daher: Entsprechende Kommentare wie bei tun_mit.
void PLB_Klasse::tun_mit_nur_eines(int _eigene_last, int _eigene_last_oben)
    {
    if(groesse==1)
        {
        return;
        }

    eigene_last = _eigene_last;
    eigene_last_oben = _eigene_last_oben;
#ifdef DA_PLB
    * da.aus << " eL " << eigene_last << " eL oben " << eigene_last_oben << endl;
#endif
    precomputation.tun_mit(eigene_last, eigene_last_oben);

    precomputation.tun_ow_mit();
#ifdef DA_PLB
    * da.aus << " precomputation.lambda_west " << precomputation.lambda_west;
    * da.aus << " precomputation.lambda_ost " << precomputation.lambda_ost << endl;
    * da.aus << " precomputation.lambda_west_oben " << precomputation.lambda_west_oben << endl;
    * da.aus << " precomputation.lambda_ost_oben " << precomputation.lambda_ost_oben << endl;
#endif
    balancing.tun_ow_mit_nur_eines(precomputation.lambda, precomputation.lambda_west, precomputation.lambda_ost, precomputation.lambda_oben, precomputation.lambda_west_oben, precomputation.lambda_ost_oben);
#ifdef DA_PLB
    * da.aus << " Nach balancing.tun_ow_mit " << endl;
    * da.aus << " bal_lambda " << balancing.lambda << " bal_lambda_oben " << balancing.lambda_oben << endl;
#endif
    precomputation.tun_mit(balancing.lambda, balancing.lambda_oben);
    precomputation.tun_ns_mit();
#ifdef DA_PLB
    * da.aus << " lambda " << precomputation.lambda << " lambda_nord " << precomputation.lambda_nord << " lambda_sued " << precomputation.lambda_sued;
    * da.aus << " lambda_oben " << precomputation.lambda_oben << " lambda_nord_oben " << precomputation.lambda_nord_oben << " lambda_sued_oben " << precomputation.lambda_sued_oben << endl;
#endif
    balancing_ns.tun_ow_mit_nur_eines(precomputation.lambda, precomputation.lambda_nord, precomputation.lambda_sued, precomputation.lambda_oben, precomputation.lambda_nord_oben, precomputation.lambda_sued_oben);
#ifdef DA_PLB
    * da.aus << " Durch PLB tun_mit durch " << endl;
#endif
    }

// Kommentar: Wie bei dem Lastausgleich tun_ohne, aber nur mit einer Lastausgleichsrunde. Nur die Balancing - Funktionsaufrufe
// mssen dazu angepasst werden. Daher: Entsprechende Kommentare wie bei tun_ohne.
void PLB_Klasse::tun_ohne_nur_eines(int _eigene_last)
    {
    if(groesse==1)
        {
        return;
        }

    eigene_last = _eigene_last;

    precomputation.tun_ohne(eigene_last);

    precomputation.tun_ow_ohne();
#ifdef DA_PLB
    * da.aus << " precomputation.lambda_west " << precomputation.lambda_west;
    * da.aus << " precomputation.lambda_ost " << precomputation.lambda_ost << endl;
#endif

    balancing.tun_ow_ohne_nur_eines(precomputation.lambda, precomputation.lambda_west, precomputation.lambda_ost);
#ifdef DA_PLB
    * da.aus << " Nach balancing.tun_ow_ohne " << endl;
    * da.aus << " bal_lambda " << balancing.lambda << endl;
#endif
    precomputation.tun_ohne(balancing.lambda);
    precomputation.tun_ns_ohne();
#ifdef DA_PLB
    * da.aus << " lambda " << precomputation.lambda << " lambda_nord " << precomputation.lambda_nord << " lambda_sued " << precomputation.lambda_sued << endl;
#endif
    balancing_ns.tun_ow_ohne_nur_eines(precomputation.lambda, precomputation.lambda_nord, precomputation.lambda_sued);
    }
