#ifndef ADAPTIVE_VERFEINERUNG
#define ADAPTIVE_VERFEINERUNG

#include "ausgaben.h"

#include "ep_s_bestimmen.h"
#include "ep_snb_update.h"
#include "p_s_bestimmen.h"
#include "ep_ff_bestimmen.h"
#include "punkte_update_fg.h"
#include "farbenupdate.h"

#include "extreme_vektoren.h"
#include "kommunikation4er.h"

#include "markierungsfeld.h"

#include "datei_ausgabe.h"

#include "randfeldliste_zu_zwei_zeitpunkten_verknuepfen.h"
#include "feldliste.h"

#include <string.h>

class AdaptiveVerfeinerung
    {
public:
    void tun_neu(int _t, int _ebene);
    void initialisierung(int _h, int _h_min, ParallelesRechnen * _paralleles_rechnen_h, ParallelesRechnen * _paralleles_rechnen_h_minus1, ParallelesRechnen * _paralleles_rechnen_h_minus2, ExtremeVektoren * _ev2_h_minus1, ExtremeVektoren * _ev2_h, ExtremeVektoren * _ev_h_minus1, int * _PT_grobgitter, int * _PT_feingitter, MarkierungsFeld * _neuer_punkt);
    void finalisierung(void);
    void ausgabe_felder(void);
private:
    int h, h_min;
public:
    EP_s_bestimmen ep_s_bestimmen;
private:
public:
    EP_SNBupdate ep_snb_update;
private:
public:
    P_s_bestimmen p_s_bestimmen;
private:
    EP_FFbestimmen ep_ff_bestimmen;
public: // Gendert 22.10.2015
    PunkteUpdateFG punkte_update_fg;
private:
    LoeschenEinfuegen loeschen_einfuegen;
public:
    FarbenUpdate farbenupdate;

    AussenRand aussenrand;
public:
    Kommunikation4er kommunikation4er;
public:
    PunktFeldListe P_minus;
public:
    PunktFeldListe P_plus;
private:
public:
    PunktFeldListe ep_minus;
    PunktFeldListe ep_plus;
private:
    PunktListe EP_SNB_punkte;
public:
    ParallelesRechnen * paralleles_rechnen_h_minus1;
    ParallelesRechnen * paralleles_rechnen_h;
    ParallelesRechnen * paralleles_rechnen_h_minus2; // Nur bei h>=2.
    ExtremeVektoren * ev2_h_minus1;
    ExtremeVektoren * ev2_h;
    ExtremeVektoren * ev_h_minus1;
private:
    int m, n;
    int mn;
    int m_h_minus1, n_h_minus1;
    int mn_h_minus1;
private:
    int * PT_grobgitter, * PT_feingitter;
private:
    MarkierungsFeld * neuer_punkt;
private:
    int rang;
    int groesse;
private:
    DateiAusgabe da_av;
private:
    int t;
    void dynamischer_rand_leer(char * stelle);
private:
    int i, j, k;
private:
    int test_EP_SNB(void);
    void test_EP(int k, int l, int hr);
    short int ** feld_aktuell;
    int r;
    int ep_snb_wert;
public:
    PunktFeldListe ep_plus_dazu;
public:
    int ev_typen, ev_faelle;
private:
    void bestimme_ev_faelle(void);
private:
    FeldListe * dynamischer_rand;
private:
    void fgff_test2(char * ausgabe);
private:
    bool ** besetzte_punkte;
    void besetzte_punkte_initialisieren(int _m_h_minus1, int _n_h_minus1);
private:
    void ausgabe_PT_feingitter(void);
private:
    short int * f1, * f2, * g1, * g2;
private:
    RandFeldListeZuZweiZeitpunktenVerknuepfen randfeldliste_zzz_verknuepfen;
private:
    void teste_8_3(char * text);
private:
    void ausgabe_feld_aktuell(void);
    void ausgabe_ep_snb(void);
private:
    int ii, jj;
private:
    DateiAusgabe datei_ausgabe;
private:
    char zeichenkette[35];
public:
    int iterationen;
private:
    void ausgabe_ep_snb_komplett(void);
public:
    void ueberpruefe_ep_s(char * text);
private:
    short int ** f_aussen, ** g_aussen;
    int * anzahl_aussen;
public:
    bool testen_ep_snb;
private:
    bool ** testfeld;
    short int * f_test, * g_test;
    int anzahl_aussen_i;
    int test_EP_SNB_beschraenkt(void);
    int return_test_EP_SNB_ij, return_test_einen;
    int test_EP_SNB_HR(int k, int l, int hr);
    int test_EP_SNB_ij(void);
    void testfeld_erzeugen(void);
private:
    int f_hilfe, g_hilfe;
private:
    DateiAusgabe da_testfeld;
    DateiAusgabe da_kanten;
    DateiAusgabe da_ep_ff;
    void ausgabe_testfeld(void);
private:
    void test2(char * wo);
    };

#endif
