#include "balancing.h"

// Kommentar: Hier werden die Lastausgleichsrunden durchgefhrt. Dem muss ein Precomputation Schritt vorangegangen sein.
// Es wird berechnet und gespeichert, wieviel Last nach Westen und Osten wirklich verschickt wird - ggf in mehreren
// Lastausgleichsrunden.
// Mit der Assoziation Nord entspricht West und Sd entspricht Ost kann damit auch die Nord - Sd Migration vorbereitet werden.
// Bemerkung: Ohne Einschrnkung wird bei Funktionen nur fr Osten und nur fr Westen nur die fr die Osten
// kommentiert. Die fr den Westen sind vollkommen analog, und fhren zu keinen weiteren Erkenntnissen.

// Kommentar: Es wird das Minimum zweier Integer - Zahlen bestimmt.
int Balancing::min(int a, int b)
    {
    if(a<b)
        {
        return(a);
        }
    return(b);
    }

// Kommentar: Bestimmung der Ost - West - Migrationsinformationen ohne reversen Lastausgleich
void Balancing::tun_ow_ohne(int _lambda, int _delta_westen, int _delta_osten)
    {
// Kommentar: Speichern der bergabeparameter
    lambda = _lambda;

    delta_osten = _delta_osten;

    delta_westen = _delta_westen;

#ifdef DA_BALANCING
    * da.aus << " Die bergebenen Lasten lambda " <<  lambda << endl;

    * da.aus << " delta_osten " << delta_osten << " delta_westen " << delta_westen << endl;
#endif
// Zhlen der Lastausgleichsrunden
    lastausgleichsrunden = 0;
#ifdef DA_BALANCING
    * da.aus << " Vor der Bal - Schleife rang " << rang << endl;
#endif

// Kommentar: Eine Endlosschleife, die mit abschluss_osten = abschluss_westen = true durchbrochen wird
// Endsprechend den Anmerkungen von Bhm terminiert das.
    for(;;)
        {
// Kommentar: Senden nach Osten, empfangen von dort, oder keine Aktion nach Osten
        bestimme_bal_typ_osten_ohne();
#ifdef DA_BALANCING
        * da.aus << " bal typ osten ohne " << bal_typ_osten_ohne << endl;
#endif
// Kommentar: Durchfhren der Lastmengen fr die Migration. Erkennen, ob Lastausgleich vollendet wurde.
        abschluss_osten = balancing_osten_ohne();
#ifdef DA_BALANCING
        * da.aus << " delta_osten " << delta_osten << endl;
        * da.aus << " delta_last_osten_speichern " << delta_last_osten_speichern[lastausgleichsrunden] << endl;
#endif
// Kommentar: Dasselbe fr West, wie vorher fr Ost
        bestimme_bal_typ_westen_ohne();
#ifdef DA_BALANCING
        * da.aus << " bal typ westen ohne " << bal_typ_westen_ohne << endl;
#endif
        abschluss_westen = balancing_westen_ohne();
#ifdef DA_BALANCING
        * da.aus << " delta_westen " << delta_westen << endl;
        * da.aus << " delta_last_westen_speichern " << delta_last_westen_speichern[lastausgleichsrunden] << endl;
#endif

// Kommentar: ndern der Lastsituation im Falle von Lastnderungen fr die nchste Lastausgleichsrunde - falls
// noch Last bzgl. dieses Kerns zu verschicken oder zu empfangen ist.
        for(;(senden_osten==true)||(senden_westen==true)||(empfangen_osten==true)||(empfangen_westen==true);)
            {
            senden_empfangen_beenden_ohne();
            }
// Kommentar: Beenden der Funktion falls fr diesen Knoten keine Migrationen (senden oder empfangen) mehr zu machen sind.
        if((abschluss_osten==true)&&(abschluss_westen==true))
            {
            break;
            }

// Kommentar: Aktualisierung der Lastausgleichsrunden
        lastausgleichsrunden++;
        }
    }

// Kommentar: Dasselbe wie bei tun_ow_mit, nur mit Lastnderungswerte auch fr oben. Und alle aufgerufenen
// Funktionen bekommen den Suffix mit - statt ohne. Die Kommentare sind also entsprechend denen fr tun_ow_ohne, siehe oben.
void Balancing::tun_ow_mit(int _lambda, int _delta_westen, int _delta_osten, int _lambda_oben, int _delta_westen_oben, int _delta_osten_oben)
    {
    lambda = _lambda;
    lambda_oben = _lambda_oben;

    delta_osten = _delta_osten;
    delta_osten_oben = _delta_osten_oben;

    delta_westen = _delta_westen;
    delta_westen_oben = _delta_westen_oben;

#ifdef DA_BALANCING
    * da.aus << " Die bergebenen Lasten lambda " <<  lambda << " lambda_oben " << lambda_oben << endl;
#endif
    lastausgleichsrunden = 0;
#ifdef DA_BALANCING
    * da.aus << " Vor der Bal - Schleife rang " << rang << endl;
#endif

    for(;;)
        {
        senden_westen = false;
        senden_osten = false;
        empfangen_westen = false;
        empfangen_osten = false;
#ifdef DA_BALANCING
        * da.aus << " 0 " << endl;
#endif
        bestimme_bal_typ_osten_mit();
#ifdef DA_BALANCING
        * da.aus << " 1 bal_typ_osten_mit " << bal_typ_osten_mit << endl;
        * da.aus << " delta_osten " << delta_osten << " delta_osten_oben " << delta_osten_oben << endl;
#endif
        abschluss_osten = balancing_osten_mit();
#ifdef DA_BALANCING
        * da.aus << " 2 " << endl;
#endif
        bestimme_bal_typ_westen_mit();
#ifdef DA_BALANCING
        * da.aus << " 3 bal_typ_westen_mit " << bal_typ_westen_mit << endl;
#endif
//        * da.aus << " 3 " << endl;
        abschluss_westen = balancing_westen_mit();
#ifdef DA_BALANCING
        * da.aus << " 3.5 " << endl;
#endif
        for(;(senden_osten==true)||(senden_westen==true)||(empfangen_osten==true)||(empfangen_westen==true);)
            {
            senden_empfangen_beenden_mit();
            }
        if((abschluss_osten==true)&&(abschluss_westen==true))
            {
            break;
            }
#ifdef DA_BALANCING
        * da.aus << " 4 " << endl;
        * da.aus << " 5 " << endl;
#endif
        lastausgleichsrunden++;
#ifdef DA_BALANCING
        * da.aus << " 6 " << endl;
        * da.aus << " 7 " << endl;
#endif
        }
    }

// Kommentar: Die folgenden 3 Funktionen sind nicht mehr ntig => Kein Kommentar erforderlich
void Balancing::kopiere_werte(void)
    {
    }

void Balancing::kopiere_werte_ohne(void)
    {
    }

void Balancing::kopiere_werte_mit(void)
    {
    }

// Kommentar: Der bal_typ gibt an, ob keine Migration mehr ntig ist nach Osten, oder ob dorthin Last verschickt
// oder von dort empfangen wird. Bei 'mit' bezieht sich das nur auf die Last beider Gitterebenen. Es wird durch
// insgesamt vier Bits angegeben, ob Last verschickt oder empfangen wird - fr beide Gitterebenen.
void Balancing::bestimme_bal_typ_osten_mit(void)
    {
    bal_typ_osten_mit = 0;
    if(delta_osten > 0)
        {
        bal_typ_osten_mit |= 1;
        }
    if(delta_osten < 0)
        {
        bal_typ_osten_mit |= 2;
        }
    if(delta_osten_oben > 0)
        {
        bal_typ_osten_mit |= 4;
        }
    if(delta_osten_oben < 0)
        {
        bal_typ_osten_mit |= 8;
        }
    }

// Kommentar: Der bal_typ gibt an, ob keine Migration mehr ntig ist nach Osten, oder ob dorthin Last verschickt
// oder von dort empfangen wird. Bei 'ohne' bezieht sich das nur auf die Last der einen Gitterebene.
void Balancing::bestimme_bal_typ_osten_ohne(void)
    {
    bal_typ_osten_ohne = 0;
    if(delta_osten > 0)
        {
        bal_typ_osten_ohne |= 1;
        }
    if(delta_osten < 0)
        {
        bal_typ_osten_ohne |= 2;
        }
    }

// Kommentar: Analog bestimme_bal_typ_osten_mit - nur fr Westen statt Osten
void Balancing::bestimme_bal_typ_westen_mit(void)
    {
    bal_typ_westen_mit = 0;
    if(delta_westen > 0)
        {
        bal_typ_westen_mit |= 1;
        }
    if(delta_westen < 0)
        {
        bal_typ_westen_mit |= 2;
        }
    if(delta_westen_oben > 0)
        {
        bal_typ_westen_mit |= 4;
        }
    if(delta_westen_oben < 0)
        {
        bal_typ_westen_mit |= 8;
        }
    }

// Kommentar: Analog bestimme_bal_typ_osten_ohne - nur fr Westen statt Osten
void Balancing::bestimme_bal_typ_westen_ohne(void)
    {
    bal_typ_westen_ohne = 0;
    if(delta_westen > 0)
        {
        bal_typ_westen_ohne |= 1;
        }
    if(delta_westen < 0)
        {
        bal_typ_westen_ohne |= 2;
        }
    }

void Balancing::sende_osten(void)
// Kommentar: Die zu verschickende Last nach Osten - Plus Aktualisierungen
    {
// wird erledigt durch delta_osten = 0

// Kommentar: Soviel Last kann und soll nach Osten verschickt werden.
    last_ost = min(lambda, delta_osten);
// Kommentar: Verschicken dieser Last nach Osten, damit der Kern weiss, wieviel Last ankommt.
// Man knnte diese Information auch mit der Migration selber bermitteln.
    sendebuffer_osten[0] = last_ost;
    MPI_Isend(sendebuffer_osten, 1, MPI_INT, ID_osten, TAG_BALANCING, MPI_COMM_WORLD, & request_senden_osten);
// Kommentar: Speichern dieser Information zur spteren Migration
    delta_last_osten_speichern[lastausgleichsrunden] = last_ost;
#ifdef AUSGABE_KOMMENTARE
    if(rang==5)
        {
        cout << " PLB 3.35 rang " << rang << " last_ost " << last_ost << " lastausgleichsrunden " << lastausgleichsrunden << endl;
        }
#endif
// Aktualisierung der eigenen Lastsituation
    lambda -= last_ost;
    delta_osten -= last_ost;
// Melden, dass Last verschickt worden ist.
    senden_osten = true;
    }

// Kommentar: Dasselbe wie sende_last, nur fr die Situation auf dem grberen Gitter - und entsprechend der
// Variablen dort. Daher: Keine weiteren Kommentare hier ntig.
void Balancing::sende_osten_oben(void)
    {
    last_ost_oben = min(lambda_oben, delta_osten_oben);
    sendebuffer_osten[0] = last_ost_oben;
    MPI_Isend(sendebuffer_osten, 1, MPI_INT, ID_osten, TAG_BALANCING, MPI_COMM_WORLD, & request_senden_osten);
    delta_last_osten_oben_speichern[lastausgleichsrunden] = last_ost_oben;
    lambda_oben -= last_ost_oben;
    delta_osten_oben -= last_ost_oben;
    senden_osten = true;
    }

// Kommentar: Die Schritte sind dieselben wie bei sende_osten - nur die Kommunikation erfolgt fr beide Ebenen
// gemeinsam, weil so weniger Kommunikation erfolgt. Erkannt wird das durch die Variable bal_typ_osten_mit in der
// Funktion bestimme_bal_typ_osten_mit.
void Balancing::sende_osten_beides(void)
    {
    last_ost = min(lambda, delta_osten);
    last_ost_oben = min(lambda_oben, delta_osten_oben);
#ifdef DA_BALANCING
    * da.aus << " sende_ost_beides last_ost " << last_ost << " last_ost_oben " << last_ost_oben << endl;
#endif
    sendebuffer_osten[0] = last_ost;
    sendebuffer_osten[1] = last_ost_oben;
    MPI_Isend(sendebuffer_osten, 2, MPI_INT, ID_osten, TAG_BALANCING, MPI_COMM_WORLD, & request_senden_osten);
    delta_last_osten_speichern[lastausgleichsrunden] = last_ost;
    delta_last_osten_oben_speichern[lastausgleichsrunden] = last_ost_oben;
    lambda -= last_ost;
    delta_osten -= last_ost;
    lambda_oben -= last_ost_oben;
    delta_osten_oben -= last_ost_oben;
    senden_osten = true;
    }

// Kommentar: Hier das Empfangen von Last. Der Lastwert muss durch Kommunikation erfolgen, da
// der Kern nicht weiss, wieviel Last der stliche Kern hat. Mit empfangen_osten = true wird spter
// die Kommunikation abgeschlossen, und damit die nderungen aufgrund der verschickten Last durchgefhrt.
void Balancing::empfange_osten(void)
    {
    MPI_Irecv(empfangsbuffer_osten, 1, MPI_INT, ID_osten, TAG_BALANCING, MPI_COMM_WORLD, & request_empfangen_osten);
    empfangen_osten = true;
    }

// Kommentar: Die Vollendung beim Empfangen
void Balancing::empfange_osten_beenden(void)
    {
// Kommentar: Falls Flag = false => es wird nichts von Osten empfangen, also ist nichts zu tun an dieser Stelle.
    if(empfangen_osten == false)
        {
        return;
        }

// Kommentar: Prfe, ob die Lastinformation angekommen ist.
    MPI_Test(&request_empfangen_osten, &flag, & status);
// Kommentar: Ist die Last angekommen, dann fhre die nderungsschritte aus.
    if(flag==true)
        {
// Kommentar: Bestimme die Last von Osten.
        last_ost = empfangsbuffer_osten[0];
// Kommentar: Speichere diese Last ab.
        delta_last_osten_speichern[lastausgleichsrunden] = -last_ost;
// Kommentar: ndere die eigene Lastsituation entsprechend ab.
        lambda += last_ost;
        delta_osten += last_ost;
// Kommentar: Beende den Lastempfang.
        empfangen_osten = false;
        }
    }

// Kommentar: Entsprechend empfange_osten, nur erfolgt die Kommunikation fr die obere Gitterebene
void Balancing::empfange_osten_oben(void)
    {
    MPI_Irecv(empfangsbuffer_osten, 1, MPI_INT, ID_osten, TAG_BALANCING, MPI_COMM_WORLD, & request_empfangen_osten);
    empfangen_osten = true;
    }

// Kommentar: Entsprechend empfange_osten_beenden, nur fr die obere Gitterbene und damit fr andere Variablen durchfhren.
void Balancing::empfange_osten_oben_beenden(void)
    {
    if(empfangen_osten == false)
        {
        return;
        }

    MPI_Test(&request_empfangen_osten, &flag, & status);
    if(flag == true)
        {
        last_ost_oben = empfangsbuffer_osten[0];
        delta_last_osten_oben_speichern[lastausgleichsrunden] = -last_ost_oben;
        lambda_oben += last_ost_oben;
        delta_osten_oben += last_ost_oben;
        empfangen_osten = false;
        }
    }

// Kommentar: Dasselbe wie bei empfange_osten, nur fr die Informationen fr beide Gitterebenen
void Balancing::empfange_osten_beides(void)
    {
    MPI_Irecv(empfangsbuffer_osten, 2, MPI_INT, ID_osten, TAG_BALANCING, MPI_COMM_WORLD, & request_empfangen_osten);
    empfangen_osten = true;
    }

// Kommentar: Dasselbe wie bei empfange_osten_beenden, nur die Schritte fr beide Gitterebenen durchfhren.
void Balancing::empfange_osten_beides_beenden(void)
    {
    if(empfangen_osten == false)
        {
        return;
        }
    MPI_Test(&request_empfangen_osten, &flag, & status);
    if(flag == true)
        {
        last_ost = empfangsbuffer_osten[0];
        delta_last_osten_speichern[lastausgleichsrunden] = -last_ost;
        lambda += last_ost;
        delta_osten += last_ost;
        last_ost_oben = empfangsbuffer_osten[1];
        delta_last_osten_oben_speichern[lastausgleichsrunden] = -last_ost_oben;
        lambda_oben += last_ost_oben;
        delta_osten_oben += last_ost_oben;
#ifdef DA_BALANCING
        * da.aus << " empfangen_osten_beides ID_osten " << ID_osten << " last_ost " << last_ost << " last_ost_oben " << last_ost_oben << endl;
#endif
#ifdef DA_BALANCING
        * da.aus << " delta_osten " << delta_osten << " delta_osten_oben " << delta_osten_oben << endl;
#endif
        empfangen_osten = false;
        }
    }

// Kommentar: Auch die Sendekommunikation muss beendet werden, um weiter im Programm fortzuschreiten.
void Balancing::beende_sende_osten(void)
    {
    if(senden_osten == false)
        {
        return;
        }
    MPI_Test(& request_senden_osten, &flag, & status);
    if(flag == true)
        {
        senden_osten = false;
        }
    }

// Kommentar: Die folgenden Funktionen sind wie fr den Osten, d.h. hier erfolgt kein weiterer Kommentar, da die
// Schritte genau analog zu denen fr die nach Osten sind.
void Balancing::sende_westen(void)
    {
    last_west = min(lambda, delta_westen);
    sendebuffer_westen[0] = last_west;
    MPI_Isend(sendebuffer_westen, 1, MPI_INT, ID_westen, TAG_BALANCING, MPI_COMM_WORLD, & request_senden_westen);
    delta_last_westen_speichern[lastausgleichsrunden] = last_west;
    lambda -= last_west;
    delta_westen -= last_west;
    }

void Balancing::sende_westen_oben(void)
    {
#ifdef DA_BALANCING
    * da.aus << " swo 1 " << endl;
#endif
    last_west_oben = min(lambda_oben, delta_westen_oben);
#ifdef DA_BALANCING
    * da.aus << " swo 2 " << endl;
#endif
    sendebuffer_westen[0] = last_west_oben;
#ifdef DA_BALANCING
    * da.aus << " swo 3 " << endl;
#endif
    MPI_Isend(sendebuffer_westen, 1, MPI_INT, ID_westen, TAG_BALANCING, MPI_COMM_WORLD, & request_senden_westen);
#ifdef DA_BALANCING
    * da.aus << " swo 4 " << endl;
#endif
    delta_last_westen_oben_speichern[lastausgleichsrunden] = last_west_oben;
#ifdef DA_BALANCING
    * da.aus << " swo 5 " << endl;
#endif
    lambda_oben -= last_west_oben;
    delta_westen_oben -= last_west_oben;
#ifdef DA_BALANCING
    * da.aus << " swo 6 " << endl;
#endif
    }

void Balancing::sende_westen_beides(void)
    {
    last_west = min(lambda, delta_westen);
    last_west_oben = min(lambda_oben, delta_westen_oben);
#ifdef DA_BALANCING
    * da.aus << " sende_westen_beides ID_westen " << ID_westen << " last_west " << last_west << " last_west_oben " << last_west_oben << endl;
#endif
    sendebuffer_westen[0] = last_west;
    sendebuffer_westen[1] = last_west_oben;
    MPI_Isend(sendebuffer_westen, 2, MPI_INT, ID_westen, TAG_BALANCING, MPI_COMM_WORLD, & request_senden_westen);
    delta_last_westen_speichern[lastausgleichsrunden] = last_west;
    delta_last_westen_oben_speichern[lastausgleichsrunden] = last_west_oben;
    lambda -= last_west;
    delta_westen -= last_west;
    lambda_oben -= last_west_oben;
    delta_westen_oben -= last_west_oben;
    }


void Balancing::beende_sende_westen(void)
    {
    if(senden_westen == false)
        {
        return;
        }
    MPI_Test(& request_senden_westen, &flag, & status);
    if(flag == true)
        {
        senden_westen = false;
        }
    }

// Kommentar: Bestimmung der Balancing - Informationen - nur fr eine Gitterebene. Kein reziproker Lastausgleich.
bool Balancing::balancing_osten_ohne(void)
    {
    switch(bal_typ_osten_ohne)
        {
// Kommentar: Keine Aktion => keine Migration nach Osten mehr. Die Variable abschluss_osten wird true.
        case 0:
            delta_last_osten_speichern[lastausgleichsrunden] = 0;
            return(true);
// Kommentar: Nach Osten senden, wieviel mglich / ntig ist. Die Variable abschluss_osten bleibt false.
        case 1:
            sende_osten();
            return(false);
// Kommentar: Von Osten empfangen, wieviel mglich / ntig ist. Die Variable abschluss_osten bleibt false.
        case 2:
            empfange_osten();
            return(false);
        default:
            cout << " Fehler in balancing_osten_ohne " << endl;
            exit(-1);
        }
    }

// Kommentar: Analog zu balancing_osten_ohne; vgl. also die Kommentare dort.
bool Balancing::balancing_westen_ohne(void)
    {
    switch(bal_typ_westen_ohne)
        {
        case 0:
            delta_last_westen_speichern[lastausgleichsrunden] = 0;
            return(true);
        case 1:
            sende_westen();
            return(false);
        case 2:
            empfange_westen();
            return(false);
        default:
            cout << " Fehler in balancing_westen_ohne " << endl;
            exit(-1);
        }
    }

// Kommentar: Bestimmung der Balancing - Informationen - fr beide Gitterebene. Es erfolgt ein reziproker Lastausgleich.
bool Balancing::balancing_osten_mit(void)
    {
    switch(bal_typ_osten_mit)
        {
// Kommentar: Keine Aktionen nach Osten ntig. Das wird verzeichnet, und abschliessen_osten auf true gesetzt, d.h. dafr
// keine weiteren Lastausgleichsrunden ntig.
        case 0:
            delta_last_osten_speichern[lastausgleichsrunden] = 0;
            delta_last_osten_oben_speichern[lastausgleichsrunden] = 0;
            return(true); // Beendet das Ost - Balancing!
        case 1:
            // Schicken nach Osten. Oben Osten hat kein Balancing
// Kommentar: Nur senden unten und sonst nichts. Daher machen: senden osten, und lastnderung oben = 0.
// Und vermelden: noch nicht fertig.
            sende_osten();
            delta_last_osten_oben_speichern[lastausgleichsrunden] = 0;
            return(false);
        case 2:
            // Empfangen von Osten. Oben Osten hat kein Balancing
//            empfangen_osten = true;

// Kommentar: Nur empfangen unten und sonst nichts. Daher machen: empfange osten, und lastnderung oben = 0.
// Und vermelden: noch nicht fertig.
            empfange_osten();
            delta_last_osten_oben_speichern[lastausgleichsrunden] = 0;
            return(false);
// Kommentar: Dieses ist unmglich: '<' und '>' gleichzeitig nicht mglich.
        case 3:
            //unmglich. '<' und '>' gleichzeitig geht nicht.
            cout << " Unmoeglich bal osten mit 3 delta osten " << delta_osten << " bal_typ " << bal_typ_osten_mit << endl;
            exit(-1);
// Kommentar: Nur senden oben und sonst nichts. Daher machen: senden osten oben, und lastnderung unten = 0.
// Und vermelden: noch nicht fertig.
        case 4:
            sende_osten_oben();
            delta_last_osten_speichern[lastausgleichsrunden] = 0;
            return(false);
// Kommentar: Senden von beidem. Daher machen: senden osten und senden osten oben.
// Und vermelden: noch nicht fertig.
        case 5: // beides gleichzeitig senden
            sende_osten_beides();
            return(false);
// Kommentar: Empfangen osten unten und senden oben und sonst nichts. Daher machen: empfangen_unten und senden osten oben.
// Und vermelden: noch nicht fertig.
        case 6: // Empfangen von Osten, Senden nach oben_osten
            sende_osten_oben();
            empfange_osten();
            return(false);
// Kommentar: case 7 ist unmglich, wegen senden und empfangen unten nicht mglich.
        case 7: // Unmglich, vgl. oben
            cout << " Unmoeglich bal osten mit 7 " << endl;
            exit(-1);
// Kommentar: Nur empfangen oben und sonst nichts. Daher machen: empfangen osten oben, und lastnderung unten = 0.
// Und vermelden: noch nicht fertig.
        case 8: // Kein Balancing unten, oben empfangen
            empfange_osten_oben();
            delta_last_osten_speichern[lastausgleichsrunden] = 0;
            return(false);
// Kommentar: Senden unten und empfangen oben. Daher machen: Senden unten, empfangen osten oben.
// Und vermelden: noch nicht fertig.
        case 9: // oben empfangen, unten senden
            sende_osten();
            empfange_osten_oben();
            return(false);
// Kommentar: Empfangen von beidem. Daher machen: Empfange osten und empfange osten oben.
// Und vermelden: noch nicht fertig.
        case 10: // empfange unten und oben
            empfange_osten_beides();
            return(false);
// Kommentar: Alle mglichen Flle wurden behandelt. Die verbleibenden Flle sind daher alle unmglich.
        case 11: // unmglich (8+3) und 3 unmglich
            cout << " Unmoeglich 11 bal osten mit " << endl;
            exit(-1);
        case 12: // Sende und Empfangen oben nicht mglich
            cout << " Unmoeglich 12 bal osten mit " << endl;
            exit(-1);
        case 13: // Wie 12 .
        case 14:
        case 15:
            cout << " Unmoeglich 13-15 bal osten mit " << endl;
            exit(-1);
        default:
            cout << " Ganz unmoeglich bei 4 Bits bal osten mit " << endl;
            exit(-1);
        }
    }

// Kommentar: Hiermit wird senden und empfangen beendet - fr eine Gitterebene. Jeder Schritt basiert dabei auf
// bal_typ_osten/westen_ohne; zu den Fllen vgl. balancing_osten/westen_ohne
void Balancing::senden_empfangen_beenden_ohne(void)
    {
    switch(bal_typ_osten_ohne)
        {
        case 1:
            beende_sende_osten();
            break;
        case 2:
            empfange_osten_beenden();
            break;
        }
    switch(bal_typ_westen_ohne)
        {
        case 1:
            beende_sende_westen();
            break;
        case 2:
            empfange_westen_beenden();
            break;
        }
    }

// Kommentar: Hiermit wird senden und empfangen beendet - fr beide Gitterebenen. Jeder Schritt basiert dabei auf
// bal_typ_osten/westen_mit; zu den Fllen vgl. balancing_osten/westen_mit.
void Balancing::senden_empfangen_beenden_mit(void)
    {
// Kommentar 17.09.2014:
// empfangen westen und empfangen osten zu koordinieren bei so vielen Fallunterscheidungen ist schwierig
// Die Wartezeit ist aber im Prinzip max(warten(empfangen_westen), warten(empfangen_osten)), weil
// die Rechenschritte danach nicht der Rede wert sind. Das erste von beidem Auszufhren bringt nicht relevante
// Vorteile ein - nmlich nur die paar Rechenschritte. Dafr wre das Umprogrammieren unverhltnismaig aufwendig.
    switch(bal_typ_osten_mit)
        {
        case 0:
            break;
        case 1:
            beende_sende_osten();
            break;
        case 2:
            empfange_osten_beenden();
            break;
        case 3:
            //unmglich. '<' und '>' gleichzeitig geht nicht.
            cout << " Unmoeglich osten mit " << endl;
            exit(-1);
        case 4:
            beende_sende_osten();
            break;
        case 5:
            beende_sende_osten();
            break;
        case 6:
            beende_sende_osten();
            empfange_osten_beenden();
            break;
        case 7: // Unmglich, vgl. oben
            cout << " Unmoeglich osten mit " << endl;
            exit(-1);
        case 8:
            empfange_osten_oben_beenden();
            break;
        case 9:
            beende_sende_osten();
            empfange_osten_oben_beenden();
            break;
        case 10:
            empfange_osten_beides_beenden();
            break;
        case 11: // unmglich (8+3) und 3 unmglich
            cout << " Unmoeglich 11 osten mit " << endl;
            exit(-1);
        case 12: // Sende und Empfangen oben nicht mglich
            cout << " Unmoeglich 12 osten mit " << endl;
            exit(-1);
        case 13: // Wie 12 .
        case 14:
        case 15:
            cout << " Unmoeglich 13-15 osten mit " << endl;
            exit(-1);
        default:
            cout << " Ganz unmoeglich bei 4 Bits osten mit " << endl;
            exit(-1);
        }

    switch(bal_typ_westen_mit)
        {
        case 0:
            break;
        case 1:
            beende_sende_westen();
            break;
        case 2:
            empfange_westen_beenden();
            break;
        case 3:
            //unmglich. '<' und '>' gleichzeitig geht nicht.
            cout << " Unmoeglich 3 west mit " << endl;
            exit(-1);
        case 4:
            beende_sende_westen();
            break;
        case 5:
            beende_sende_westen();
            break;
        case 6:
            beende_sende_westen();
            empfange_westen_beenden();
            break;
        case 7: // Unmglich, vgl. oben
            cout << " Unmoeglich 7 west mit " << endl;
            exit(-1);
        case 8:
            empfange_westen_oben_beenden();
            break;
        case 9:
            beende_sende_westen();
            empfange_westen_oben_beenden();
            break;
        case 10:
            empfange_westen_beides_beenden();
            break;
        case 11: // unmglich (8+3) und 3 unmglich
            cout << " Unmoeglich 11 west mit " << endl;
            exit(-1);
        case 12: // Sende und Empfangen oben nicht mglich
            cout << " Unmoeglich 12 west mit " << endl;
            exit(-1);
        case 13: // Wie 12 .
        case 14:
        case 15:
            cout << " Unmoeglich 13-15 west mit " << endl;
            exit(-1);
        default:
            cout << " Ganz unmoeglich bei 4 Bits west default " << endl;
            exit(-1);
        }
    }

// Kommentar: Die folgenden Funktionen sind fr Westen; deshalb analoge Kommentare zu denen fr Osten, vgl. oben
void Balancing::empfange_westen(void)
    {
    MPI_Irecv(empfangsbuffer_westen, 1, MPI_INT, ID_westen, TAG_BALANCING, MPI_COMM_WORLD, & request_empfangen_westen);
    empfangen_westen = true;
    }

void Balancing::empfange_westen_beenden(void)
    {
    if(empfangen_westen == false)
        {
        return;
        }
    MPI_Test(&request_empfangen_westen, &flag, & status);

    if(flag==true)
        {
        last_west = empfangsbuffer_westen[0];
        delta_last_westen_speichern[lastausgleichsrunden] = -last_west;
        lambda += last_west;
        delta_westen += last_west;
        empfangen_westen = false;
        }
    }

void Balancing::empfange_westen_oben(void)
    {
    MPI_Irecv(empfangsbuffer_westen, 1, MPI_INT, ID_westen, TAG_BALANCING, MPI_COMM_WORLD, & request_empfangen_westen);
    empfangen_westen = true;
    }

void Balancing::empfange_westen_oben_beenden(void)
    {
    if(empfangen_westen == false)
        {
        return;
        }
    MPI_Test(&request_empfangen_westen, &flag, & status);

    if(flag == true)
        {
        last_west_oben = empfangsbuffer_westen[0];
        delta_last_westen_oben_speichern[lastausgleichsrunden] = -last_west_oben;
        lambda_oben += last_west_oben;
        delta_westen_oben += last_west_oben;
        empfangen_westen = false;
        }
    }

void Balancing::empfange_westen_beides(void)
    {
    MPI_Irecv(empfangsbuffer_westen, 2, MPI_INT, ID_westen, TAG_BALANCING, MPI_COMM_WORLD, & request_empfangen_westen);
    empfangen_westen = true;
    }

void Balancing::empfange_westen_beides_beenden(void)
    {
    if(empfangen_westen == false)
        {
        return;
        }

    MPI_Test(&request_empfangen_westen, &flag, & status);

    if(flag == true)
        {
        last_west = empfangsbuffer_westen[0];
        delta_last_westen_speichern[lastausgleichsrunden] = -last_west;
        lambda += last_west;
        delta_westen += last_west;
        last_west_oben = empfangsbuffer_westen[1];
        delta_last_westen_oben_speichern[lastausgleichsrunden] = -last_west_oben;
        lambda_oben += last_west_oben;
        delta_westen_oben += last_west_oben;
        empfangen_westen = false;
        }
    }


bool Balancing::balancing_westen_mit(void)
    {
    switch(bal_typ_westen_mit)
        {
        case 0:
            delta_last_westen_speichern[lastausgleichsrunden] = 0;
            delta_last_westen_oben_speichern[lastausgleichsrunden] = 0;
            return(true); // Beendet das Ost - Balancing!
        case 1:
            // Schicken nach Osten. Oben Osten hat kein Balancing
            sende_westen();
            delta_last_westen_oben_speichern[lastausgleichsrunden] = 0;
            return(false);
        case 2:
            // Empfangen von Osten. Oben Osten hat kein Balancing
            empfange_westen();
            delta_last_westen_oben_speichern[lastausgleichsrunden] = 0;
            return(false);
        case 3:
            //unmglich. '<' und '>' gleichzeitig geht nicht.
            cout << " Unmoeglich 3 bal mit " << endl;
            exit(-1);
        case 4:
            sende_westen_oben();
            delta_last_westen_speichern[lastausgleichsrunden] = 0;
            return(false);
        case 5: // beides gleichzeitig senden
            sende_westen_beides();
            return(false);
        case 6: // Empfangen von Osten, Senden nach oben_osten
#ifdef DA_BALANCING
            * da.aus << " Vor bal west tun 6 " << endl;
#endif
            sende_westen_oben();
#ifdef DA_BALANCING
            * da.aus << " Nach sende_westen oben 6 " << endl;
#endif
            empfange_westen();
#ifdef DA_BALANCING
            * da.aus << " Nach empfange_westen 6 " << endl;
#endif
            return(false);
        case 7: // Unmglich, vgl. oben
            cout << " Unmoeglich 7 bal mit " << endl;
            exit(-1);
        case 8: // Kein Balancing unten, oben empfangen
            empfange_westen_oben();
            delta_last_westen_speichern[lastausgleichsrunden] = 0;
            return(false);
        case 9: // oben empfangen, unten senden
            sende_westen();
            empfange_westen_oben();
            return(false);
        case 10: // empfange unten und oben
            empfange_westen_beides();
            return(false);
        case 11: // unmglich (8+3) und 3 unmglich
            cout << " Unmoeglich 11 bal mit " << endl;
            exit(-1);
        case 12: // Sende und Empfangen oben nicht mglich
            cout << " Unmoeglich 12 ba mit " << endl;
            exit(-1);
        case 13: // Wie 12 .
        case 14:
        case 15:
            cout << " Unmoeglich 13-15 bal mit " << endl;
            exit(-1);
        default:
            cout << " Ganz unmoeglich bei 4 Bits bal mit " << endl;
            exit(-1);
        }
    }

// Kommentar: Das anlegen von Speicher sowie das Speichern der bergabeparameter
void Balancing::initialisieren(int _ID_westen, int _ID_osten, int _maximale_anzahl_lastausgleichsrunden, int _mit_ohne)
    {
// Kommentar: Das Speichern der bergabeparameter. Die ID's der Kerne in Ost und West ist fr die Kommunikation ntig.
    ID_osten = _ID_osten;
    ID_westen = _ID_westen;
    maximale_anzahl_lastausgleichsrunden = _maximale_anzahl_lastausgleichsrunden;
    lastausgleichsrunden = 0;
    mit_ohne = _mit_ohne;
// Kommentar: Speichern der Ergebnisse fr alle Lastausgleichsrunden
    delta_last_osten_speichern = new int [maximale_anzahl_lastausgleichsrunden];
    delta_last_westen_speichern = new int [maximale_anzahl_lastausgleichsrunden];
    if(mit_ohne == MIT)
        {
        delta_last_osten_oben_speichern = new int [maximale_anzahl_lastausgleichsrunden];
        delta_last_westen_oben_speichern = new int [maximale_anzahl_lastausgleichsrunden];
        }
// Kommentar: Setzen der Werte auf 0.
    for(i=0; i<maximale_anzahl_lastausgleichsrunden; i++)
        {
        delta_last_osten_speichern[i] = 0;
        delta_last_westen_speichern[i] = 0;
        if(mit_ohne == MIT)
            {
            delta_last_osten_oben_speichern[i] = 0;
            delta_last_westen_oben_speichern[i] = 0;
            }
        }
    last_west = 0;
    last_ost = 0;
    last_west_oben = 0;
    last_ost_oben = 0;
    }

// Kommentar: Die eigene ID bekommen.
void Balancing::initialisieren_rang(int _rang)
    {
    rang = _rang;
    strcpy(text, "da_bal");
#ifdef DA_BALANCING
    da.initialisieren(rang, text);
    da.oeffnen();
    * da.aus << " Max Anzahl lagr " << maximale_anzahl_lastausgleichsrunden << " mit_ohne " << mit_ohne << endl;
    * da.aus << " ID_osten " << ID_osten << " ID_westen " << ID_westen << endl;
#endif
    }

// Kommentar: Das Freigeben des Speichers
void Balancing::finalisieren(void)
    {
    delete delta_last_osten_speichern;
    delete delta_last_westen_speichern;
    if(mit_ohne == MIT)
        {
        delete delta_last_osten_oben_speichern;
        delete delta_last_westen_oben_speichern;
        }
#ifdef DA_BALANCING
    da.schliessen();
#endif
    }

// Kommentar: Vgl. tun_ow_mit: Die Endlosschleife wurde entfernt, damit nur eine Lastausgleichsrunde erfolgt.
// Die Variable lastausgleichsrunden hat am Ende den Korrekten Wert 1.
void Balancing::tun_ow_mit_nur_eines(int _lambda, int _delta_westen, int _delta_osten, int _lambda_oben, int _delta_westen_oben, int _delta_osten_oben)
    {
    lambda = _lambda;
    lambda_oben = _lambda_oben;

    delta_osten = _delta_osten;
    delta_osten_oben = _delta_osten_oben;

    delta_westen = _delta_westen;
    delta_westen_oben = _delta_westen_oben;

#ifdef DA_BALANCING
    * da.aus << " Die bergebenen Lasten lambda " <<  lambda << " lambda_oben " << lambda_oben << endl;
#endif
    lastausgleichsrunden = 0;
#ifdef DA_BALANCING
    * da.aus << " Vor der Bal - Schleife rang " << rang << endl;
#endif
        {
        senden_westen = false;
        senden_osten = false;
        empfangen_westen = false;
        empfangen_osten = false;
#ifdef DA_BALANCING
        * da.aus << " 0 " << endl;
#endif
        bestimme_bal_typ_osten_mit();
#ifdef DA_BALANCING
        * da.aus << " 1 bal_typ_osten_mit " << bal_typ_osten_mit << endl;
        * da.aus << " delta_osten " << delta_osten << " delta_osten_oben " << delta_osten_oben << endl;
#endif
        abschluss_osten = balancing_osten_mit();
#ifdef DA_BALANCING
        * da.aus << " 2 " << endl;
#endif
        bestimme_bal_typ_westen_mit();
#ifdef DA_BALANCING
        * da.aus << " 3 bal_typ_westen_mit " << bal_typ_westen_mit << endl;
#endif
        abschluss_westen = balancing_westen_mit();
#ifdef DA_BALANCING
        * da.aus << " 3.5 " << endl;
#endif
        for(;(senden_osten==true)||(senden_westen==true)||(empfangen_osten==true)||(empfangen_westen==true);)
            {
            senden_empfangen_beenden_mit();
            }
#ifdef DA_BALANCING
        * da.aus << " 4 " << endl;
        * da.aus << " 5 " << endl;
#endif
        lastausgleichsrunden++;
#ifdef DA_BALANCING
        * da.aus << " 6 " << endl;
        * da.aus << " 7 " << endl;
#endif
        }
    }

// Kommentar: Vgl. tun_ow_ohne: Die Endlosschleife wurde entfernt, damit nur eine Lastausgleichsrunde erfolgt.
// Die Variable lastausgleichsrunden hat am Ende den Korrekten Wert 1.
void Balancing::tun_ow_ohne_nur_eines(int _lambda, int _delta_westen, int _delta_osten)
    {
    lambda = _lambda;

    delta_osten = _delta_osten;

    delta_westen = _delta_westen;

#ifdef DA_BALANCING
    * da.aus << " Die bergebenen Lasten lambda " <<  lambda << endl;

    * da.aus << " delta_osten " << delta_osten << " delta_westen " << delta_westen << endl;
#endif
    lastausgleichsrunden = 0;
#ifdef DA_BALANCING
    * da.aus << " Vor der Bal - Schleife rang " << rang << endl;
#endif

        {
        bestimme_bal_typ_osten_ohne();
#ifdef DA_BALANCING
        * da.aus << " bal typ osten ohne " << bal_typ_osten_ohne << endl;
#endif
        abschluss_osten = balancing_osten_ohne();
#ifdef DA_BALANCING
        * da.aus << " delta_osten " << delta_osten << endl;
        * da.aus << " delta_last_osten_speichern " << delta_last_osten_speichern[lastausgleichsrunden] << endl;
#endif
        bestimme_bal_typ_westen_ohne();
#ifdef DA_BALANCING
        * da.aus << " bal typ westen ohne " << bal_typ_westen_ohne << endl;
#endif
        abschluss_westen = balancing_westen_ohne();
#ifdef DA_BALANCING
        * da.aus << " delta_westen " << delta_westen << endl;
        * da.aus << " delta_last_westen_speichern " << delta_last_westen_speichern[lastausgleichsrunden] << endl;
#endif

        for(;(senden_osten==true)||(senden_westen==true)||(empfangen_osten==true)||(empfangen_westen==true);)
            {
            senden_empfangen_beenden_ohne();
            }
        lastausgleichsrunden++;
        }
    }
