#ifndef BALANCING
#define BALANCING

#include <iostream>
#include <mpi.h>
#include <stdlib.h>
#include <string.h>

#include "datei_ausgabe.h"

using namespace std;

#ifndef MIT
#define MIT 1
#endif

#ifndef OHNE
#define OHNE 0
#endif

#ifndef TAG_BALANCING
#define TAG_BALANCING 223
#endif

class Balancing
    {
private:
public:
    int lambda, lambda_oben;
private:
    int delta_osten, delta_osten_oben, delta_westen, delta_westen_oben;
private:
    int last_ost, last_ost_oben;
    int last_west, last_west_oben;
public:
    void tun_ow_mit(int _lambda, int _delta_westen, int _delta_osten, int _lambda_oben, int _delta_westen_oben, int _delta_osten_oben);
    void tun_ow_mit_nur_eines(int _lambda, int _delta_westen, int _delta_osten, int _lambda_oben, int _delta_westen_oben, int _delta_osten_oben);
private:
    void bestimme_bal_typ_osten_mit(void);
    bool balancing_osten(void);
private:
    int min(int a, int b);
    int sendebuffer_osten[2];
    int sendebuffer_westen[2];
    int empfangsbuffer_osten[2];
    int empfangsbuffer_westen[2];
private:
    int flag;
    MPI_Status status;
    MPI_Request request_senden_osten;
    MPI_Request request_senden_westen;
    MPI_Request request_empfangen_osten;
    MPI_Request request_empfangen_westen;
private:
    int ID_osten, ID_westen, maximale_anzahl_lastausgleichsrunden;
    int mit_ohne;
private:
public:
    int * delta_last_osten_speichern;
    int * delta_last_westen_speichern;
    int * delta_last_osten_oben_speichern;
    int * delta_last_westen_oben_speichern;
private:
public:
    int lastausgleichsrunden;
private:
    int bal_typ_osten_mit;
    int bal_typ_westen_mit;
    int bal_typ_osten_ohne;
    int bal_typ_westen_ohne;
private:
public:
    void tun_ow_ohne(int _lambda, int _delta_westen, int _delta_osten);
    void tun_ow_ohne_nur_eines(int _lambda, int _delta_westen, int _delta_osten);
private:
    void bestimme_bal_typ_osten_ohne(void);
    void bestimme_bal_typ_westen_ohne(void);
    bool balancing_osten_ohne(void);
    bool balancing_osten_mit(void);
    bool balancing_westen_ohne(void);
    bool balancing_westen_mit(void);
    void kopiere_werte_ohne(void);
    void kopiere_werte_mit(void);
    void kopiere_werte(void);
    void senden_empfangen_beenden_ohne(void);
    void senden_empfangen_beenden_mit(void);
    void senden_beenden(void);
    void beende_sende_osten(void);
    void beende_sende_westen(void);
    void bestimme_bal_typ_westen_mit(void);
private:
    void sende_osten(void);
    void sende_osten_oben(void);
    void sende_osten_beides(void);
    void sende_westen(void);
    void sende_westen_oben(void);
    void sende_westen_beides(void);
    void empfange_osten(void);
    void empfange_osten_beenden(void);
    void empfange_osten_oben(void);
    void empfange_osten_oben_beenden(void);
    void empfange_osten_beides(void);
    void empfange_osten_beides_beenden(void);
    void empfange_westen(void);
    void empfange_westen_beenden(void);
    void empfange_westen_oben(void);
    void empfange_westen_oben_beenden(void);
    void empfange_westen_beides(void);
    void empfange_westen_beides_beenden(void);
private:
    bool abschluss_osten;
    bool abschluss_westen;
public:
    void initialisieren(int _ID_westen, int _ID_osten, int _maximale_anzahl_lastausgleichsrunden, int _mit_ohne);
private:
    DateiAusgabe da;
    int rang;
public:
    void initialisieren_rang(int _rang);
    void finalisieren(void);
private:
    int i;
    bool senden_osten, senden_westen, empfangen_osten, empfangen_westen;
private:
    char text[10];
    };

#endif

/*
    Soll ich bei neuen Runden die alte Information mitnehmen? Eigentlich nicht ntig, da im Allgemeinen
    nur eine Balancing Runde entsteht. Auerdem muss ich auch dafr Abfragen machen.
*/
