#include "bool_int.h"

// Kommentar: Schreibt und liest Bits in Integerwerte ein. Das dient dem Zweck, krzere Kommunikationsbuffer
// verwenden zu knnen.

// Kommentar: Die folgende Funktion setzt Werte an, die jeweils einem Bit entsprechen. Das geht mit einem Konstruktor.
BoolInt::BoolInt(void)
    {
    for(j=0, k=1; j<32; j++)
        {
        a[j] = k;
        b[j] = 4294967295 - k;
        k <<= 1;
        }
    }


// Kommentar: Hier wird der Buffer zugreifbar gemacht, plus einem offset, d.h. es wird nicht von Anfang an geschrieben.
void BoolInt::anfang(int * _int_buffer, int _offset)
    {
    int_buffer = _int_buffer;
    offset = _offset;
    j = 0;
    k = offset;
    }

// Kommentar: Das nchste Bit wird anvisiert. Wenn das letzte Bit eines Integerwertes schon belegt wurde, wird
// der nchste Integerwert verwendet.
void BoolInt::naechstes(void)
    {
    j++;
    if(j==32)
        {
        j=0;
        k++;
        }
    }

// Kommentar: Durch eine OR - Operation wird geschrieben, wenn der Wert wert true ist. Ansonsten wird das Bit genullt.
void BoolInt::schreiben(bool wert)
    {
    if(wert==true)
        {
        int_buffer[k]|=a[j];
        }
    else
        {
        int_buffer[k]&=b[j];
        }
    naechstes();
    }

// Hier wird ein Bit gelesen. Und entsprechend false oder true zurckgegeben.
bool BoolInt::lesen(void)
    {
    hilf = (int_buffer[k])&(a[j]);
    if(hilf==0)
        {
        naechstes();
        return false;
        }
    naechstes();
    return true;
    }

// Hier wird angegeben, um wieviele Stellen man einen Bufferindex vorsetzen muss, um das geschriebene
// nicht wieder zu berschreiben.
int BoolInt::laenge(void)
    {
    return(k+1);
    }
