#include "bool_short_int.h"

// Kommentar: Schreibt und liest Bits in ShortIntegerwerte ein. Das dient dem Zweck, krzere Kommunikationsbuffer
// verwenden zu knnen.

// Kommentar: Die folgende Funktion setzt Werte an, die jeweils einem Bit entsprechen. Das geht mit einem Konstruktor.
BoolShortInt::BoolShortInt(void)
    {
    for(j=0, k=1; j<16; j++)
        {
        a[j] = k;
        b[j] = 65535 - a[j];
        k <<= 1;
        }
    }

// Kommentar: Hier wird der Buffer zugreifbar gemacht, plus einem offset, d.h. es wird nicht von Anfang an geschrieben.
// lese_wert ermglicht es, nicht immer in dem Buffer zu arbeiten.
void BoolShortInt::anfang(short int * _short_int_buffer, int _offset)
    {
    short_int_buffer = _short_int_buffer;
    offset = _offset;
    j = 0;
    k = offset;
    lese_wert = short_int_buffer[k];
    }

// Kommentar: Das nchste Bit wird anvisiert. Wenn das letzte Bit eines ShortIntegerwertes schon belegt wurde, wird
// der nchste ShortIntegerwert verwendet.
void BoolShortInt::naechstes(void)
    {
    j++;
    if(j==16)
        {
        j=0;
        k++;
        }
    }

// Kommentar: Das nchste Bit wird anvisiert. Wenn das letzte Bit eines ShortIntegerwertes schon belegt wurde, wird
// der nchste ShortIntegerwert verwendet. lese_wert muss gelesen werden.
void BoolShortInt::naechstes_lesen(void)
    {
    j++;
    if(j==16)
        {
        j=0;
        k++;
        lese_wert = short_int_buffer[k];
        }
    }

// Kommentar: Durch eine OR - Operation wird geschrieben, wenn der Wert wert true ist. Ansonsten wird das Bit genullt.
void BoolShortInt::schreiben(bool wert)
    {
    if(wert==true)
        {
        short_int_buffer[k]|=a[j];
        }
    else
        {
        short_int_buffer[k]&=b[j];
        }
    naechstes();
    }

// Hier wird ein Bit gelesen. Und entsprechend false oder true zurckgegeben.
bool BoolShortInt::lesen(void)
    {
    hilf = (lese_wert)&(a[j]);
    naechstes_lesen();
    if(hilf==0)
        {
        return false;
        }
    return true;
    }

// Hier wird angegeben, um wieviele Stellen man einen Bufferindex vorsetzen muss, um das geschriebene
// nicht wieder zu berschreiben.
int BoolShortInt::laenge(void)
    {
    return(k+1);
    }
