#include "datei_ausgabe_fuer_wertevergleich.h"

// Kommentar: Diese Dateiausgabe ist nur fr den Wertevergleich speziell entwickelt worden.

// Kommentar: Bei der Dateiausgabe fr den Wertevergleich muss die Iterationszahl mit ausgegeben werden.
void DateiAusgabefuerWertevergleich::schreibe_t(int _t)
    {
    t = _t;
    }

// Kommentar: Der Ausgabewert in Abhngigkeit der ID fr den Text und der Gitterebene wird gespeichert.
// Dafr mssen die Zeiger fr die Variablen und Ebenen gespeichert werden.
void DateiAusgabefuerWertevergleich::eine_ausgabe(int _up_down_top, int _ebene, int _textID)
    {
    switch(_textID)
        {
        case U0:
            ausgabe_werte = u0[ebene];
            break;
        case E0:
            ausgabe_werte = e0[ebene];
            break;
        case R0:
            ausgabe_werte = r0[ebene];
            break;
        case RS0:
            ausgabe_werte = rS0[ebene];
            break;
        case IU0:
            ausgabe_werte = Iu0[ebene];
        default:
            cout << " DAfWV hat die Variable nicht rang " << rang << endl;
            exit(-1);
        }
    }

// Kommentar: Die folgende Dateiausgabe bildet einen header - das was vor Beginn jeder ausgegebenen Wertematrix
// stehen muss.
void DateiAusgabefuerWertevergleich::permanente_ausgabe(void)
    {
    * datei_ausgabe.aus << " Datei - Ausgabe fr Wertevergleich ";
    * datei_ausgabe.aus << " n " << n;
    * datei_ausgabe.aus << " m " << m;
    * datei_ausgabe.aus << " h_gesamt " << h_gesamt;
    * datei_ausgabe.aus << endl;
    }

// Kommentar: Mit dem Wort Ende wird die Dateiausgabe beendet.
void DateiAusgabefuerWertevergleich::abschliessende_ausgabe(void)
    {
    * datei_ausgabe.aus << " Ende " << endl;
    }

// Kommentar: Diese Funktion fhrt eine dafwv - Ausgabe durch
void DateiAusgabefuerWertevergleich::ausgeben_dafwv(int _ebene, int updowntop, int werte_variable, char * zusatztext, int up_down_top_zusatzindex)
    {
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Anfang ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: bergabeparameter speichern.
    ebene = _ebene;
    up_down_top = updowntop;
// Schritt 0: ausgabe_werte verpointern
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 0 ebene " << ebene << " rang " << rang << " ZI ";
    cout << up_down_top_zusatzindex << endl;
#endif

// Kommentar: Durch Zeigerkopie die richtige Variable markieren. Dazu wird die bergebene werte_variable gelesen.
    switch(werte_variable)
        {
        case U0:
            ausgabe_werte = u0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable u0 " << " Ebene " << ebene << endl;
                }
            break;
        case E0:
            ausgabe_werte = e0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable e0 " << endl;
                }
            break;
        case R0:
            ausgabe_werte = r0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable r0 " << endl;
                }
            break;
        case RS0:
            ausgabe_werte = rS0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable rS0 " << endl;
                }
            break;
        case IU0:
            ausgabe_werte = Iu0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable Iu0 " << endl;
                }
            break;
        default:
            cout << " Variable fr ausgeben noch nicht erkannt " << endl;
            exit(-1);
        }
// Schritt 1: punkte_indikator_matrix_schreiben bestimmen
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 1 ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: Das Flag punkte_indikator_matrix_schreiben gibt an, ob die Punkte - Indikatormatrix geschrieben werden soll.
// Diese Matrix verzeichnet bei neuer Ebene, neuem up_down oder neuem t, welche Punkte zum spteren Test
// markiert werden. Es geht dabei darum, dass in den Verfeinerungsebenen nicht alle Punkte vorhanden sind -
// und auf diesen Stellen, wo keine Punkte sind, darf auch nicht verglichen werden.
    if((ebene==ebene_v)&&(up_down_top==up_down_top_v)&&(t==t_v))
        {
        punkte_indikator_matrix_schreiben = false;
        }
    else
        {
        punkte_indikator_matrix_schreiben = true;

        ebene_v = ebene;
        up_down_top_v = up_down_top;
        t_v = t;
        }
// Schritt 2: Daten Sammeln
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 2 ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: Die Klasse WerteSammeln stellt diese Funktion bereit. Dabei werden die Werte gesammelt, denn
// verteilte Werte werden erst zusammengefhrt.
    tun();
// Schritt 3: Daten ausgeben
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 3 ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: Ausgabe des Headers: Ebene, t, Auswahl zwischen 'up', 'down' und 'top', den Text, der dazu
// mit bergeben wurde. Wichtig: Nur der rang = 0 Kern gibt aus.
    if(rang == 0)
        {
        * datei_ausgabe.aus << " Ebene " << ebene;
        * datei_ausgabe.aus << " t " << t;
        switch(updowntop)
            {
            case UP:
                * datei_ausgabe.aus << " updowntop " << "UP";
                break;
            case DOWN:
                * datei_ausgabe.aus << " updowntop " << "DOWN";
                break;
            case TOP:
                * datei_ausgabe.aus << " updowntop " << "TOP";
                break;
            default:
                cout << "Fehler in DAfWV updowntop - Darstellung rang " << rang << endl;
                exit(-1);
            }
        * datei_ausgabe.aus << " Zusatztext " << zusatztext;
        * datei_ausgabe.aus << " Zusatzindex " << up_down_top_zusatzindex << endl;
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " LLMMKK 185 Zusatzindex " << up_down_top_zusatzindex << endl;
#endif
// Kommentar: Lesen der Gre des Gitters dieser Ebene
        n_hh = n_h[ebene];
        m_hh = m_h[ebene];

// Kommentar: Ausgabe der Punkte Indikatormatrix (true genau dann, wenn der Punkt existiert, vgl. werte_sammeln), falls
// das markiert wurde.
        if(punkte_indikator_matrix_schreiben == true)
            {
            * datei_ausgabe.aus << " Indikatormatrix " << endl;
            for(i=0; i<n_hh; i++)
                {
                * datei_ausgabe.aus << i << " ";
                if(i<10)
                    {
                    * datei_ausgabe.aus << " ";
                    }
                for(j=0; j<m_hh; j++)
                    {
                    * datei_ausgabe.aus << punkte_indikator_matrix[i][j] << " ";
                    }
                * datei_ausgabe.aus << endl;
                }
            * datei_ausgabe.aus << endl;
            }
// Kommentar: Ausgabe der Wertematrix entsprechend den gesammelten Werten in WerteSammeln
        * datei_ausgabe.aus << " Wertematrix " << endl;
        for(i=0; i<n_hh; i++)
            {
            * datei_ausgabe.aus << i << " ";
            if(i<10)
                {
                * datei_ausgabe.aus << " ";
                }
            for(j=0; j<m_hh; j++)
                {
                * datei_ausgabe.aus << werte_matrix[i][j] << " ";
                }
            * datei_ausgabe.aus << endl;
            }
        * datei_ausgabe.aus << endl;
        }
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Ende ebene " << ebene << " rang " << rang << " Zusatztext " << zusatztext << endl;
#endif
    }

// Kommentar: Diese Funktion fhrt eine dafwv - Ausgabe durch, falls eine 'Kappe' existiert.
void DateiAusgabefuerWertevergleich::ausgeben_dafwv_kappe(int _ebene, int updowntop, int werte_variable, char * zusatztext, int up_down_top_zusatzindex)
    {
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Anfang ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: bergabeparameter speichern.
    ebene = _ebene;
    up_down_top = updowntop;
// Schritt 0: ausgabe_werte verpointern
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 0 ebene " << ebene << " rang " << rang << " ZI ";
    cout << up_down_top_zusatzindex << endl;
#endif

// Kommentar: Durch Zeigerkopie die richtige Variable markieren. Dazu wird die bergebene werte_variable gelesen.
    switch(werte_variable)
        {
        case U0:
            ausgabe_werte = u0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable u0 " << " Ebene " << ebene << endl;
                }
            break;
        case E0:
            ausgabe_werte = e0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable e0 " << endl;
                }
            break;
        case R0:
            ausgabe_werte = r0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable r0 " << endl;
                }
            break;
        case RS0:
            ausgabe_werte = rS0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable rS0 " << endl;
                }
            break;
        case IU0:
            ausgabe_werte = Iu0[ebene];
            if(rang == 0)
                {
                * datei_ausgabe.aus << " Variable Iu0 " << endl;
                }
            break;
        default:
            cout << " Variable fr ausgeben noch nicht erkannt " << endl;
            exit(-1);
        }
// Schritt 1: punkte_indikator_matrix_schreiben bestimmen
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 1 ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: Das Flag punkte_indikator_matrix_schreiben gibt an, ob die Punkte - Indikatormatrix geschrieben werden soll.
// Diese Matrix verzeichnet bei neuer Ebene, neuem up_down oder neuem t, welche Punkte zum spteren Test
// markiert werden. Es geht dabei darum, dass in den Verfeinerungsebenen nicht alle Punkte vorhanden sind -
// und auf diesen Stellen, wo keine Punkte sind, darf auch nicht verglichen werden.
    if((ebene==ebene_v)&&(up_down_top==up_down_top_v)&&(t==t_v))
        {
        punkte_indikator_matrix_schreiben = false;
        }
    else
        {
        punkte_indikator_matrix_schreiben = true;

        ebene_v = ebene;
        up_down_top_v = up_down_top;
        t_v = t;
        }
// Schritt 2: Daten Sammeln
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 2 ebene " << ebene << " rang " << rang << endl;
#endif
// Schritt 3: Daten ausgeben

// Kommentar: Fr die Werte in der Kappe muss nur aus der ausgabe_werte in die sptere werte_matrix
// berfhrt werden. Ohne Kappe braucht man die werte_matrix, weil man die ausgabe_werte
// Struktur nicht verndern darf. Man knnte auch ohne diese Funktion auskommen.
    tun_kappe();
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Schritt 3 ebene " << ebene << " rang " << rang << endl;
#endif

// Kommentar: Ausgabe des Headers: Ebene, t, Auswahl zwischen 'up', 'down' und 'top', den Text, der dazu
// mit bergeben wurde. Wichtig: Nur der rang = 0 Kern gibt aus.
    if(rang == 0)
        {
        * datei_ausgabe.aus << " Ebene " << ebene;
        * datei_ausgabe.aus << " t " << t;
        switch(updowntop)
            {
            case UP:
                * datei_ausgabe.aus << " updowntop " << "UP";
                break;
            case DOWN:
                * datei_ausgabe.aus << " updowntop " << "DOWN";
                break;
            case TOP:
                * datei_ausgabe.aus << " updowntop " << "TOP";
                break;
            default:
                cout << "Fehler in DAfWV updowntop - Darstellung rang " << rang << endl;
                exit(-1);
            }
        * datei_ausgabe.aus << " Zusatztext " << zusatztext;
        * datei_ausgabe.aus << " Zusatzindex " << up_down_top_zusatzindex << endl;
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " LLMMKK 350 Zusatzindex " << up_down_top_zusatzindex << endl;
#endif
// Kommentar: Lesen der Gre des Gitters dieser Ebene
        n_hh = n_h[ebene];
        m_hh = m_h[ebene];

// Kommentar: Ausgabe der Punkte Indikatormatrix (true genau dann, wenn der Punkt existiert, vgl. werte_sammeln), falls
// das markiert wurde.
        if(punkte_indikator_matrix_schreiben == true)
            {
            * datei_ausgabe.aus << " Indikatormatrix " << endl;
            for(i=0; i<n_hh; i++)
                {
                * datei_ausgabe.aus << i << " ";
                if(i<10)
                    {
                    * datei_ausgabe.aus << " ";
                    }
                for(j=0; j<m_hh; j++)
                    {
                    * datei_ausgabe.aus << punkte_indikator_matrix[i][j] << " ";
                    }
                * datei_ausgabe.aus << endl;
                }
            * datei_ausgabe.aus << endl;
            }
        * datei_ausgabe.aus << " Wertematrix " << endl;
// Kommentar: Ausgabe der Wertematrix nach WerteSammeln (hier gleich ausgabe_werte)
        for(i=0; i<n_hh; i++)
            {
            * datei_ausgabe.aus << i << " ";
            if(i<10)
                {
                * datei_ausgabe.aus << " ";
                }
            for(j=0; j<m_hh; j++)
                {
                * datei_ausgabe.aus << werte_matrix[i][j] << " ";
                }
            * datei_ausgabe.aus << endl;
            }
        * datei_ausgabe.aus << endl;
        }
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " DAfWV ausgeben Ende Kappe ebene " << ebene << " rang " << rang << " Zusatztext " << zusatztext << endl;
#endif
    }
