#include "eigenschaftspunkte.h"

// Kommentar: Aufgrund der bool'schen Matrizen feld_aktuell und

// Ist direkt in ParallelesRechnen deklariert.


// Kommentar: Ausgabe der Flags der Matrix feld_aktuell, wo die aktuelle Verfeinerungsinformation steht.
void EigenschaftsPunkte::ausgabe_aktuell_feld(void)
    {
    if((rang!=0)||(gitterebene!=1))
        {
        return;
        }
    cout << " SUW MATRIX feld_aktuell t " << t << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << " " << feld_aktuell[i][j];
            }
        cout << endl;
        }
    cout << endl;
    }

// Kommentar: Ausgabe der Flags der Matrix feld_vergangen, wo die vergangene Verfeinerungsinformation steht.
void EigenschaftsPunkte::ausgabe_vergangen_feld(void)
    {
    if((rang!=0)||(gitterebene!=1))
        {
        return;
        }
    cout << " SUW MATRIX feld_vergangen t " << t << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << " " << feld_vergangen[i][j];
            }
        cout << endl;
        }
    cout << endl;
    }

// Kommentar: Ausgabe der Liste der aktuellen Punkte mit Hilfe der Struktur pfl_aktuell. Sie enthlt die Information
// feld_aktuell, aber als Punktfeldliste, d.h. sowohl die Matrix als auch die Punkteliste
void EigenschaftsPunkte::ausgabe_aktuell(void)
    {
// Kommentar: Kopieren der Anzahl an Punkten sowie der Zeiger auf die Koordinaten
    anzahl = pfl_aktuell->anzahl;
    f_s = pfl_aktuell->f;
    g_s = pfl_aktuell->g;

    for(i=0; i<anzahl; i++)
        {
        if((rang==0)&&(gitterebene==1))
            {
// Kommentar: Ausgabe der Koordinaten
            cout << " f " << f_s[i] << " g " << g_s[i];
            }
        }
    if((rang==0)&&(gitterebene==1))
        {
        cout << endl;
        }
    }

void EigenschaftsPunkte::schieben(void)
    {
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    if(gitterebene==1)
        {
        cout << " SUN vor feld_akt44 " << feld_aktuell[4][4] << " feld_verg44 " << feld_vergangen[4][4] << " rang " << rang << " t " << t << endl;
        }
#endif

// Kommentar: Hierbei geschieht ein Reset des alten Feldes. Auf diese Weise bleibt keine alte Verfeinerungsinformation
// brig. Dafr braucht man die Strukturen pfl_vergangen, und feld_vergangen fr das Reset. Dieses Rcksetzen ist
// der Zweck der Struktur pfl_aktuell und pfl_vergangen, damit keine alten feld_vergangen Werte zu falschen
// Verfeinerungsentscheidungen fhren.
    feld_vergangen_aufloesen();

// Kommentar: EPS_PFLS ist standardmig definiert.
#ifdef EPS_PFLS
// Kommentar: Vertauschen der aktuellen und vergangenen Verfeinerungsinformationen.
    pfl_zwischenspeichern = pfl_vergangen;
    pfl_vergangen = pfl_aktuell;
    pfl_aktuell = pfl_zwischenspeichern;

    feld_zwischenspeichern = feld_vergangen;
    feld_vergangen = feld_aktuell;
    feld_aktuell = feld_zwischenspeichern;

//    feld_aktuell_auf_0_testen();
#else
// Kommentar: Vertauschen der aktuellen und vergangenen Verfeinerungsinformationen. Da die pfl - Strukturen nicht
// zugreifbar sind, mssen die Koordinaten durch f_vergangen, g_vergangen, f_aktuell und g_aktuell gespeichert werden.
    f_zwischenspeichern = f_vergangen;
    g_zwischenspeichern = g_vergangen;
    feld_zwischenspeichern = feld_vergangen;

//    index_zwischenspeichern = index_vergangen; Der Wert ist 0 und muss nicht zwischengespeichert werden

    f_vergangen = f_aktuell;
    g_vergangen = g_aktuell;
    feld_vergangen = feld_aktuell;
    index_vergangen = index_aktuell;

    f_aktuell = f_zwischenspeichern;
    g_aktuell = g_zwischenspeichern;
    feld_aktuell = feld_zwischenspeichern;
    index_aktuell = 0;
#endif
    }

// Kommentar: Selbiges 'schieben' wie eben, nur ohne die Mglichkeit, die pfl - Strukturen zu nutzen.
void EigenschaftsPunkte::schieben_neu(void)
    {
#ifndef EPS_PFLS
    f_zwischenspeichern = f_vergangen;
    g_zwischenspeichern = g_vergangen;
    feld_zwischenspeichern = feld_vergangen;

//    index_zwischenspeichern = index_vergangen; Der Wert ist 0 und muss nicht zwischengespeichert werden

    f_vergangen = f_aktuell;
    g_vergangen = g_aktuell;
    feld_vergangen = feld_aktuell;
    index_vergangen = index_aktuell;

    f_aktuell = f_zwischenspeichern;
    g_aktuell = g_zwischenspeichern;
    feld_aktuell = feld_zwischenspeichern;
    index_aktuell = 0;
#endif
    }

// Kommentar: Hierbei geschieht ein Reset des alten Feldes. Auf diese Weise bleibt keine alte Verfeinerungsinformation
// brig. Dafr braucht man die Strukturen pfl_vergangen, und feld_vergangen fr das Reset. Dieses Rcksetzen ist
// der Zweck der Struktur pfl_aktuell und pfl_vergangen, damit keine alten feld_vergangen Werte zu falschen
// Verfeinerungsentscheidungen fhren.
void EigenschaftsPunkte::feld_vergangen_aufloesen(void)
    {
#ifdef EPS_PFLS
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    ausgabe_aktuell_feld();
    ausgabe_vergangen_feld();
#endif
// Kommentar: Kopieren der Listeninformation von pfl_aktuell zwecks Ausgabe der Liste.
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    anzahl = pfl_aktuell->anzahl;
    f_s = pfl_aktuell->f;
    g_s = pfl_aktuell->g;

    for(i=0; i<anzahl; i++)
        {
        if((rang==0)&&(gitterebene==1))
            {
            cout << " f " << f_s[i] << " g " << g_s[i];
            }
        }
    if((rang==0)&&(gitterebene==1))
        {
        cout << endl;
        }
#endif

// Kommentar: Kopieren der Listeninformation von pfl_vergangen zwecks Reset der Liste.
    anzahl = pfl_vergangen->anzahl;
    f_s = pfl_vergangen->f;
    g_s = pfl_vergangen->g;

// Kommentar: Damit Reset von feld_vergangen, damit es spter nicht auf diesen Koordinaten zu falschen alten Markierungen kommt,
// zum Beispiel wenn sich ein Verfeinerungsgebiet hin und wieder zurck bewegt.
    for(i=0; i<anzahl; i++)
        {
        feld_vergangen[f_s[i]][g_s[i]] = false;
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
        if((rang==0)&&(gitterebene==1))
            {
            cout << " f " << f_s[i] << " g " << g_s[i];
            }
#endif
        }
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    if((rang==0)&&(gitterebene==1))
        {
        cout << endl;
        }
#endif
// Kommentar: pfl_vergangen wird entsprechend zurckgesetzt.
    pfl_vergangen->reset();
    #ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    ausgabe_vergangen_feld();
    #endif
#else
// Kommentar: Ohne pfl muss f_vergangen und g_vergangen genutzt werden, und anschlieend mit index_vergangen = 0 resettet werden.
    for(i=0; i<index_vergangen; i++)
        {
        feld_vergangen[f_vergangen[i]][g_vergangen[i]] = false;
        }
    index_vergangen = 0;
#endif
// Das ist vielleicht nicht richtig: Denn: Beim Lastausgleich wird die Menge (f_v, g_v) nicht verndert.

// Kommentar: Bemerkung: Es ist richtig: die Klasse Lastausgleich ruft bei nderungen von feld_aktuell und feld_vergangen
// die Funktionen 'setze_feld_aktuell_gleich_false' bzw. 'setze_feld_aktuell_gleich_true' der Klasse
// EP_s_bestimmen auf. Diese Feldnderungen sind in der Klasse Lastausgleich z.B. in der Funktion
// packen_ep_rumpf. Aber: Das zu bemerken ist schon wichtig.
    }


// Kommentar: Durch das folgende wird die Klasse EigenschaftsPunkte initialisiert.
void EigenschaftsPunkte::initialisieren_ep(int _n, int _m, int _verfeinerungstyp, int _rang)
// wird richtig finalisiert
    {
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
    cout << "In initialisieren_ep: n " << _n << " m " << _m << endl;
#endif
// Kommentar: Kopieren der bergabeparameter
    n = _n;
    m = _m;
    rang_ep = _rang;

    verfeinerungstyp = _verfeinerungstyp;

    mn = m*n;
#ifdef EPS_PFLS
// Kommentar: Anlegen der pfl - Strukturen
    pfl_aktuell_inhalt.initialisierung(m, n);
    pfl_vergangen_inhalt.initialisierung(m, n);
    pfl_aktuell = &(pfl_aktuell_inhalt);
    pfl_vergangen = &(pfl_vergangen_inhalt);
#else
// Kommentar: Anlegen der Koordinaten fr die Eigenschaftspunkte aktuell und vergangen
    f_aktuell = new int [mn];
    g_aktuell = new int [mn];
    index_aktuell = 0;

    f_vergangen = new int [mn];
    g_vergangen = new int [mn];
    index_vergangen = 0;
#endif
// Kommentar: Anlegen der Felder feld_aktuell und feld_vergangen. Man legt sie um einen Punkt um das Gitter
// {0 ... n-1) x (0 ... m-1) an, wie beim Farbenfeld, damit keine unzulssigen Zugriffe erfolgen.
    feld_aktuell = new short int * [n+2];
    feld_vergangen = new short int * [n+2];

    for(i=0; i<n+2; i++)
        {
        feld_aktuell[i] = new short int [m+2];
        feld_vergangen[i] = new short int [m+2];

        for(j=0; j<m+2 ; j++)
            {
            feld_aktuell[i][j] = false;
            feld_vergangen[i][j] = false;
            }
// Kommentar: vgl. nchsten Kommentar
        feld_aktuell[i] = feld_aktuell[i] + 1;
        feld_vergangen[i] = feld_vergangen[i]  + 1;
        }
// Kommentar: Durch die feld_aktuell und feld_vergangen - Zeigeradditionen, vgl. auch den letzten Kommentar,
// ist der Zugriff fr (-1 ..n) x (-1 .. m), d.h. so wie gewnscht.
    feld_aktuell = feld_aktuell + 1;

    feld_vergangen = feld_vergangen + 1;

// Kommentar: ep_aktuell entspricht damit feld_aktuell. Wird aber hier nicht gebraucht.
    ep_aktuell = feld_aktuell;
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
    cout << "feld_aktuell [" << n-1 << "][" << m-1 << "] = " << feld_aktuell[n-1][m-1] << endl;
#endif

// Kommentar: Bei einer Simulation werden maximal max_sim_gitter Rechtecke unabhngig voneinander bewegt.
    max_sim_gitter = 5;

// Kommentar: Speicherplatz fr die Koordinaten der Rechtecke
    f_oben = new int [max_sim_gitter];
    f_unten = new int [max_sim_gitter];
    g_links = new int [max_sim_gitter];
    g_rechts = new int [max_sim_gitter];
    }

// Kommentar: f_behalten und g_behalten hat den Zweck, in bestimmen_neu_ergaenzen die zu markierenden Punkte zwischenzuspeichern,
// damit die Matrix feld_aktuell erst nach der Identifikation der zu setzenden Punkte gendert wird.
// Denn diese Struktur muss beim Erkennen der Informationen noch nicht gendert werden.
void EigenschaftsPunkte::initialisieren_ep_vt3(int n, int m)
    {
    mn = m * n;
// Kommentar: f_behalten und g_behalten werden nun angelegt.
    f_behalten = new int [mn];
    g_behalten = new int [mn];
    }

// Kommentar: Freigeben der Informationen f_behalten und g_behalten.
void EigenschaftsPunkte::finalisieren_ep_vt3(void)
    {
    delete f_behalten;
    delete g_behalten;
    }

// Kommentar: Freigeben des bei der initialisieren_ep angelegten Speichers.
void EigenschaftsPunkte::finalisieren_ep(void)
    {
#ifdef EPS_PFLS
    pfl_aktuell_inhalt.finalisierung();
    pfl_vergangen_inhalt.finalisierung();
#else
    delete f_aktuell;
    delete g_aktuell;

    delete f_vergangen;
    delete g_vergangen;
#endif
   feld_aktuell = feld_aktuell - 1;

    feld_vergangen = feld_vergangen - 1;

    for(i=0; i<n+2; i++)
// n+2 steht bei der Initialisierung
        {
        feld_aktuell[i] = feld_aktuell[i] - 1;
        feld_vergangen[i] = feld_vergangen[i] - 1;

        delete feld_aktuell[i];
        delete feld_vergangen[i];
        }
    delete feld_aktuell;
    delete feld_vergangen;

    delete f_oben;
    delete f_unten;
    delete g_links;
    delete g_rechts;
    }

// Kommentar: Diese Funktion wird aufgerufen, um die Verfeinerungsentscheidung zu treffen.
void EigenschaftsPunkte::bestimmen_neu(void)
    {
#ifndef EPS_PFLS
    index_aktuell = 0;
#endif
// Kommentar: Relevant sind die Verfeinerungstypen 1, 3 und 4: Dafr erfolgt nun eine switch - case Anweisung.
    switch(verfeinerungstyp)
        {
// Kommentar: verfeinerungstyp = 1 => Simulation durchfhren
        case 1:
// Kommentar: NEUES_EP_AKTUALISIERUNG ist definiert.
        #ifndef NEUES_EP_AKTUALISIERUNG
// Kommentar: Das erfolgt nicht.
        exit(-1);
        #else
// Kommentar: Das erfolgt. Es werden die neuen Punkte bestimmt.
            bestimmen_simulation();
        #endif
// Kommentar: Und dann werden Punkte auf dem echten Rand entfernt.
            entferne_echten_rand();
        // eps am echten Rand muss false sein. Dafr besser den Rand durchlaufen, anstelle alle Punkte zu prfen.
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
            ausgabe_aktuell();
#endif
            break;
        case 3:
// Kommentar: Aufruf des 'Joppich' - Verfeinerungskriteriums via FAS.
            bestimmen_selbstadaptiv_tau();
            break;
        case 4:
// Kommentar: Aufruf des vom Autor entwickelten Kriteriums
            bestimmen_selbstadaptiv_tau12();
            break;
        }
    // eps am echten Rand muss false sein. Dafr besser den Rand durchlaufen, anstelle alle Punkte zu prfen.
    }

// Kommentar: Diese Funktion WIRD verwendet - zur Simulation.
void EigenschaftsPunkte::bestimmen_simulation(void)
    {
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    for(i=0; i<anzahl_v_gitter; i++)
        {
        cout << " Verfeinerungspunkte Rang " << rang << " i " << i << " f_oben " << f_oben[i] << " f_unten " << f_unten[i] << " g_links " << g_links[i] << " g_rechts " << g_rechts[i] << endl;
        }
#endif // AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
        {
// Kommentar: Da ein Zugriff auf die Gitterstrukturen da sind, wird hier das Gitter durchlaufen
        for(anfangsposition();ist_fertig_fl()==false;naechster())
            {
// Kommentar: Hier werden die Koordinaten eines Gitterpunktes gelesen.
            fff = lesen_f();
            ggg = lesen_g();

// Kommentar: Ist der Punkt am ueren Rand, dann nicht einfgen.
            if(fff==0)
               {
                continue;
                }
            if(ggg==0)
                {
                continue;
                }
            if(fff==n-1)
                {
                continue;
                }
            if(ggg==m-1)
                {
                continue;
                }
// Kommentar: Ist der Punkt ein echter Randpunkt => nicht einfgen.
            if(farbenfeld_ep[fff-1][ggg]==-1)
// Was bedeutet farbenfeld_ep?
                {
                continue;
                }
            if(farbenfeld_ep[fff+1][ggg]==-1)
                {
                continue;
                }
            if(farbenfeld_ep[fff][ggg-1]==-1)
                {
                continue;
                }
            if(farbenfeld_ep[fff][ggg+1]==-1)
                {
                continue;
                }
// Kommentar: Druchlaufe die Simulationsgitter
            for(i=0; i<anzahl_v_gitter; i++)
                {
// Kommentar: Liegt der Punkt im Rechteck, dann punkt_schreiben, d.h. feld_aktuell[fff][ggg] = true und
// pfl_aktuell.hinzu(fff,ggg)
                if((f_oben[i]<=fff)&&(fff<=f_unten[i])&&(g_links[i]<=ggg)&&(ggg <= g_rechts[i]))
                    {
                    f = fff;
                    g = ggg;

                    punkt_schreiben();
                    }
                }
            }
// Kommentar: Bemerkung: Gelscht werden braucht nicht, da mittels pfl -> vergangen alles vorher resettet wird.
        return;
        }
    }


// Kommentar: Bei dieser Funktion werden Punkte eingefgt, und damit feld_aktuell auf true gesetzt, und pfl_aktuell.hinzu
// gemacht
void EigenschaftsPunkte::punkt_schreiben(void)
// Ist f_aktuell eine EP_Liste?
    {
#ifdef EPS_PFLS
    if(pfl_aktuell->anzahl >= mn)
#else
    if(index_aktuell>=mn)
#endif
        {
        cout << " Fehler: Zu viele Punkte in EP:punkt schreiben " << endl;
        exit(-1);
        }
// Kommentar: Wurde der Punkt noch nicht eingefgt:
    if(feld_aktuell[f][g]==false)
        {
#ifdef AKTUELLE_KOMMENTARE
        ausgabe375();
#endif

// Kommentar: Fge den Punkt ein durch Wirken auf feld_aktuell und pfl_aktuell ...
        feld_aktuell[f][g] = true;
#ifdef EPS_PFLS
        pfl_aktuell->hinzu(f,g);
#else
// Kommentar: ... bzw. f_aktuell und g_aktuell. Aber: Das eigentlich nicht, weil EPS_PFLS definiert bleiben sollte.
        f_aktuell[index_aktuell] = f;
        g_aktuell[index_aktuell] = g;
        index_aktuell ++;
#endif

#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE

#ifdef EPS_PFLS
        cout << " RTV ps f " << f << " g " << g << " index " << pfl_aktuell->anzahl << " rang " << rang << endl;
#else
        cout << " RTV ps f " << f << " g " << g << " index " << index_aktuell << " rang " << rang << endl;
#endif

#endif
        }
    }

// Kommentar: Diese Funktion wird nicht mehr verwendet, da sie nur von Programm::gitterumbau verwendet wird, eine
// Funktion, die nicht mehr genommen wird, weil der Gitterumbau auch viel komplexer ist und nach adaptive Verfeinerung
// ausgelagert wurde, mit viel komplexeren Methoden.
int EigenschaftsPunkte::ID_aktuell(int ff, int gg)
// Wird nicht mehr gebraucht.
    {
    if(feld_aktuell[ff][gg]==true)
        {
        return(0);
        }
    if(feld_aktuell[ff-1][gg]==true)
        {
        if(feld_aktuell[ff][gg-1]==true)
            {
            return(1);
            }
        else
            {
            return(2);
            }
        }
    else
        {
        if(feld_aktuell[ff][gg-1]==true)
            {
            return(3);
            }
        else
            {
            if(feld_aktuell[ff-1][gg-1]==true)
                {
                return(4);
                }
            else
                {
                return(5);
                }
            }
        }
    }

// Kommentar: Diese Funktion wird nicht mehr verwendet, da sie nur von Programm::gitterumbau verwendet wird, eine
// Funktion, die nicht mehr genommen wird, weil der Gitterumbau auch viel komplexer ist und nach adaptive Verfeinerung
// ausgelagert wurde, mit viel komplexeren Methoden.
int EigenschaftsPunkte::ID_vergangen(int ff, int gg)
    {
    if(feld_vergangen[ff][gg]==true)
        {
        return(0);
        }
    if(feld_vergangen[ff-1][gg]==true)
        {
        if(feld_vergangen[ff][gg-1]==true)
            {
            return(1);
            }
        else
            {
            return(2);
            }
        }
    else
        {
        if(feld_vergangen[ff][gg-1]==true)
            {
            return(3);
            }
        else
            {
            if(feld_vergangen[ff-1][gg-1]==true)
                {
                return(4);
                }
            else
                {
                return(5);
                };
            }
        }
    }

// Kommentar: Hiermit werden beim Verfeinerungsrechteck 'nummer' die Grenzen gesetzt.
void EigenschaftsPunkte::setzen_verfeinerungs_gitter_grenzen(int _f_oben, int _f_unten, int _g_links, int _g_rechts, int nummer)
    {
    f_oben[nummer] = _f_oben;
    f_unten[nummer] = _f_unten;
    g_links[nummer] = _g_links;
    g_rechts[nummer] = _g_rechts;
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
    cout << "EP: ################### " << f_oben << " " << f_unten << " " << g_links << " " << g_rechts << endl;
#endif
    }

// Kommentar: Ausgabe der bool'schen Matrix feld_aktuell
void EigenschaftsPunkte::ausgeben_feld_aktuell(void)
    {
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
    cout << "Ausgeben Feld Aktuell" << endl;
    cout << "   " ;
    for(j=0; j<m;j++)
        {
        cout << j << " ";
        }
    cout << endl;
    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " " ;
            }
        for(j=0; j<m; j++)
            {
            if(feld_aktuell[i][j]==true)
                {
                cout << "O ";
                }
            else
                {
                cout << "- ";
                }
            }
        cout << endl;
        }
#endif
    }

// Kommentar: Der echte Rand wird entfernt. Eigentlich sollte dieser entsprechend der Funktion bestimmen_simulation
// erst gar nicht eingefgt werden.
void EigenschaftsPunkte::entferne_echten_rand(void)
    {
// Kommentar: Durchlaufe das Gitter.
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();

// Kommentar: Falls eine Koordinate gesetzt wurde ...
        if(feld_aktuell[j][k]==true)
            {
// Kommentar: ... und falls sie zum echten Rand gehrt ...
            if(teste_echter_rand()==true)
                {
// Kommentar: ... dann lsche diese Koordinate
                feld_aktuell[j][k] = false;
                pfl_aktuell->hinweg(j,k); // eingefgt am 23.4.2015, da bei einer nderung von feld_aktuell
                                         // am pfl_aktuell zu ndern ist.
                }
            }
        }
    }

// Kommentar: Es wird getestet, ob (j,k) ein echter Randpunkt ist.
bool EigenschaftsPunkte::teste_echter_rand(void)
    {
// Kommentar: berprfe die Randpunkte zu (j,k)
            switch(255-selbstnachbarn[j][k])
                {
                case 0:
                    break;
                case 1:
// Kommentar: Ist im Norden der Farbfeldwert < 0, dann return true; Die anderen Flle analog.
                    randpunkt_ueberpruefen_nord;
                    break;
                case 2:
                    randpunkt_ueberpruefen_nordost;
                    break;
                case 3:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    break;
                case 4:
                    randpunkt_ueberpruefen_ost;
                    break;
                case 5:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    break;
                case 6:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    break;
                case 7:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    break;
                case 8:
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 9:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 10:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 11:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 12:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 13:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 14:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 15:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    break;
                case 16:
                    randpunkt_ueberpruefen_sued;
                    break;
                case 17:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 18:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 19:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 20:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 21:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 22:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 23:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;

                    randpunkt_ueberpruefen_sued;

                    break;
                case 24:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 25:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 26:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 27:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 28:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    break;
                case 29:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 30:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 31:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    break;
                case 32:
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 33:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 34:
                    randpunkt_ueberpruefen_nordost;

                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 35:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 36:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 37:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 38:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 39:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 40:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 41:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 42:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 43:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 44:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 45:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 46:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 47:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 48:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 49:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 50:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 51:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 52:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 53:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 54:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 55:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 56:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 57:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 58:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 59:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 60:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    break;
                case 61:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 62:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;
                case 63:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    break;

                case 64:
                    randpunkt_ueberpruefen_west;
                    break;

                case 65:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_west;
                    break;
                case 66:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 67:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 68:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 69:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 70:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 71:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 72:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 73:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 74:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 75:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 76:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 77:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 78:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 79:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    break;
                case 80:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    break;
                case 81:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 82:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 83:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 84:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 85:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 86:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 87:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;

                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 88:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 89:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 90:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 91:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 92:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    break;
                case 93:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 94:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 95:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    break;
                case 96:
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;

                case 97:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 98:
                    randpunkt_ueberpruefen_nordost;

                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 99:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 100:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 101:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 102:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 103:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 104:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 105:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 106:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 107:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 108:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 109:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 110:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 111:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 112:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 113:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 114:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 115:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 116:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 117:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 118:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 119:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 120:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 121:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 122:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 123:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 124:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    break;
                case 125:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 126:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;
                case 127:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    break;

                case 128:
                    randpunkt_ueberpruefen_nordwest;
                    break;
                case 129:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordwest; break;
                case 130:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 131:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 132:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 133:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 134:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 135:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 136:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 137:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 138:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 139:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 140:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 141:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 142:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 143:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_nordwest; break;
                case 144:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_nordwest; break;
                case 145:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 146:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 147:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 148:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 149:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 150:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 151:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;

                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 152:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 153:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 154:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 155:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 156:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_nordwest; break;
                case 157:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 158:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 159:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_nordwest; break;
                case 160:
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 161:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 162:
                    randpunkt_ueberpruefen_nordost;

                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 163:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 164:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 165:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 166:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 167:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 168:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 169:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 170:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 171:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 172:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 173:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 174:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 175:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 176:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 177:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 178:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 179:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 180:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 181:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 182:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 183:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 184:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 185:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 186:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 187:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 188:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_nordwest; break;
                case 189:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 190:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;
                case 191:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_nordwest; break;

                case 192:
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest;
                    break;

                case 193:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 194:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 195:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 196:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 197:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 198:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 199:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 200:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 201:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 202:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 203:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 204:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 205:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 206:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 207:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 208:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 209:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 210:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 211:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 212:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 213:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 214:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 215:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;

                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 216:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 217:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 218:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 219:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 220:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest;
                    break;
                case 221:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest;
                    break;
                case 222:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest;
                    break;
                case 223:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 224:
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;

                case 225:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 226:
                    randpunkt_ueberpruefen_nordost;

                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 227:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 228:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 229:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 230:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 231:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 232:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 233:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 234:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 235:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 236:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 237:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 238:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 239:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 240:
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 241:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 242:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 243:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 244:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 245:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 246:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 247:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 248:
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 249:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 250:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 251:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 252:
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;
                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 253:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 254:
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                case 255:
                    randpunkt_ueberpruefen_nord;
                    randpunkt_ueberpruefen_nordost;
                    randpunkt_ueberpruefen_ost;
                    randpunkt_ueberpruefen_suedost;
                    randpunkt_ueberpruefen_sued;
                    randpunkt_ueberpruefen_suedwest;

                    randpunkt_ueberpruefen_west;
                    randpunkt_ueberpruefen_nordwest; break;
                }
    return(false);
    }

// Kommentar: Diese Funktion trgt nicht zum Algorithmus bei, sondern nur zum Fehler finden.
void EigenschaftsPunkte::ausgabe375(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    if((f==7)&&(g==5))
        {
        cout << " EEFFGG In Eigenschaftspunkte::ausgabe375 Punkt identifiziert / rang " << rang_ep << endl;
        }
#endif
    }

// Kommentar: Diese Funktion trgt nicht zum Algorithmus bei, sondern nur zum Fehler finden.
void EigenschaftsPunkte::ausgabe689(void)
    {
    }

// Kommentar: Das Bestimmen der Verfeinerungspunkte nach dem Kriterium von Herrn Joppich - via FAS - Schema.
void EigenschaftsPunkte::bestimmen_selbstadaptiv_tau(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " bestimmen_selbstadaptiv_tau rang " << rang << endl;
#endif
// Kommentar: Durchlaufe die Gitterpunkte
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        fff = lesen_f();
        ggg = lesen_g();

#ifdef AKTUELLE_KOMMENTARE
        cout << " RTW0 fff " << fff << " ggg " << ggg << " rang " << rang << endl;
#endif
// Kommentar: Falls der Rand des Gitters, oder der echte Rand des Gitters betroffen ist => nichts tun.
        if(fff==0)
            {
            continue;
            }
        if(ggg==0)
            {
            continue;
            }
        if(fff==n-1)
            {
            continue;
            }
        if(ggg==m-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff-1][ggg]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff+1][ggg]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff][ggg-1]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff][ggg+1]==-1)
            {
            continue;
            }
// Kommentar: Falls die Punkte nicht durch 2 teilbare Koordinaten haben => nichts tun, weil das Kriterium
// dafr nicht bestimmt werden kann.
        if((fff&1)==1)
            {
            continue;
            }
        if((ggg&1)==1)
            {
            continue;
            }
#ifdef AKTUELLE_KOMMENTARE
        cout << " FGHI fff " << fff << " ggg " << ggg << " tau_oben " << tau_oben[fff>>1][ggg>>1] << endl;
#endif
// Kommentar: Prfe, ob der Wert zum Verfeinerungskriterium tau_oben den Grenzwert bertrifft.
// Falls ja, dann fge den Gitterpunkt ein.
        if(abs(tau_oben[fff>>1][ggg>>1])>verf_krit)
            {
            f = fff;
            g = ggg;
            punkt_schreiben();
            }
        }
    }

// Kommentar: Das Bestimmen der Verfeinerungspunkte nach dem Kriterium vom Autor - motiviert durch das
// Gradienten - hnliche Kriterium von Herrn Reinhold Hess.
void EigenschaftsPunkte::bestimmen_selbstadaptiv_tau12(void)
    {
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE_NEU
    cout << " Vor bestimmen_selbstadaptiv_tau12 rang " << rang << endl;
#endif
// Kommentar: Durchlaufe die Gitterpunkte
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        fff = lesen_f();
        ggg = lesen_g();
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
        cout << " RTW fff " << fff << " ggg " << ggg << " rang " << rang << endl;
#endif
// Kommentar: Falls der Rand des Gitters, oder der echte Rand des Gitters betroffen ist => nichts tun.
        if(fff==0)
            {
            continue;
            }
        if(ggg==0)
            {
            continue;
            }
        if(fff==n-1)
            {
            continue;
            }
        if(ggg==m-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff-1][ggg]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff+1][ggg]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff][ggg-1]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff][ggg+1]==-1)
            {
            continue;
            }
// Kommentar: Falls die Punkte nicht durch 2 teilbare Koordinaten haben => nichts tun, weil das Kriterium
// dafr nicht bestimmt werden kann.
        if((fff&1)==1)
            {
            continue;
            }
        if((ggg&1)==1)
            {
            continue;
            }
#ifdef AKTUELLE_KOMMENTARE
        cout << " FGHI fff " << fff << " ggg " << ggg << " tau_oben " << tau_oben[fff>>1][ggg>>1] << endl;
#endif
// Kommentar: Prfe, ob die Linearkombination zu den Verfeinerungswerten tau_1 und tau_2 - jeweils dividiert durch die
// Grenzwerte, den Wert 1 bertrifft.
// Falls ja, dann fge den Gitterpunkt ein.
        if(abs(tau_1[fff][ggg])/verf_krit_1 + abs(tau_2[fff][ggg])/verf_krit_2 > 1)
            {
            f = fff;
            g = ggg;
            punkt_schreiben();
            }
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach bestimmen_selbstadaptiv_tau12 rang " << rang << endl;
#endif
    }

// Kommentar: abs bestimmt den Absolutwert einer double - Zahl.
double EigenschaftsPunkte::abs(double alpha)
    {
    if(alpha>=0)
        {
        return(alpha);
        }
    return(-alpha);
    }

// Kommentar: bestimmen_neu_ergaenzen wird von Programm aus aufgerufen - ein Stck nach dem Aufruf von
// bestimmen. Es geht dabei darum, dass wegen der Grobgitterabfrage zum groben Gitter Lcher entstehen knnen,
// die mit dieser Funktion geschlossen werden.
// Bemerkung: f_behalten und g_behalten hat den Zweck, in bestimmen_neu_ergaenzen die zu markierenden Punkte zwischenzuspeichern,
// damit die Matrix feld_aktuell erst nach der Identifikation der zu setzenden Punkte gendert wird.
// Denn diese Struktur muss beim Erkennen der Informationen noch nicht gendert werden.
void EigenschaftsPunkte::bestimmen_neu_ergaenzen(void)
    {
// Kommentar: Die sich zu merkenden Punkte sind am Anfang 0.
    anzahl_behalten = 0;
// Kommentar: Man durchluft das Gitter.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
// Kommentar: Man liest die Koordinaten des jeweiligen Gitterpunktes.
        fff = lesen_f();
        ggg = lesen_g();
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
        cout << " RTW2 fff " << fff << " ggg " << ggg << " rang " << rang << endl;
#endif
// Kommentar: Im Falle von Randpunkten: nichts tun
        if(fff==0)
            {
            continue;
            }
        if(ggg==0)
            {
            continue;
            }
        if(fff==n-1)
            {
            continue;
            }
        if(ggg==m-1)
            {
            continue;
            }
// Kommentar: Im Falle von echten Randpunkten: nichts tun.
        if(farbenfeld_ep[fff-1][ggg]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff+1][ggg]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff][ggg-1]==-1)
            {
            continue;
            }
        if(farbenfeld_ep[fff][ggg+1]==-1)
            {
            continue;
            }

// Kommentar: Falls auf (fff,ggg) nichts eingefgt wurde, daneben aber schon => einfgen in die Liste zu
// f_behalten und g_behalten.
        if(feld_aktuell[fff][ggg]==false)
            {
            if(feld_aktuell[fff-1][ggg-1]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff-1][ggg]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff-1][ggg+1]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff][ggg-1]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff][ggg+1]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff+1][ggg-1]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff+1][ggg]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            if(feld_aktuell[fff+1][ggg+1]==true)
                {
                f_behalten[anzahl_behalten] = fff;
                g_behalten[anzahl_behalten++] = ggg;
                continue;
                }
            }
        }
// Kommentar: Die so bestimmten Punkte zum Hinzufgen werden durch punkt_schreiben hinzugefgt.
    for(i=0; i<anzahl_behalten; i++)
        {
        f = f_behalten[i];
        g = g_behalten[i];
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
        cout << " RTW-1 f " << f << " g " << g << " rang " << rang << endl;
#endif
        punkt_schreiben();
        }
#ifdef AUSGABEN_EIGENSCHAFTSPUNKTE
    cout << " Fertig mit bestimmen_neu_ergaenzen rang " << rang << endl;
#endif
    }
