#ifndef EIGENSCHAFTSPUNKTE
#define EIGENSCHAFTSPUNKTE 1

#include <math.h>

#include "gitter.h"

#include "punkt_feld_liste.h"

#include "ausgaben.h"

#define randpunkt_ueberpruefen_nord if(farbenfeld[j-1][k]<0){return(true);}
#define randpunkt_ueberpruefen_nordost if(farbenfeld[j-1][k+1]<0){return(true);}
#define randpunkt_ueberpruefen_nordwest if(farbenfeld[j-1][k-1]<0){return(true);}
#define randpunkt_ueberpruefen_west if(farbenfeld[j][k-1]<0){return(true);}
#define randpunkt_ueberpruefen_ost if(farbenfeld[j][k+1]<0){return(true);}
#define randpunkt_ueberpruefen_suedost if(farbenfeld[j+1][k+1]<0){return(true);}
#define randpunkt_ueberpruefen_sued if(farbenfeld[j+1][k]<0){return(true);}
#define randpunkt_ueberpruefen_suedwest if(farbenfeld[j+1][k-1]<0){return(true);}

class EigenschaftsPunkte :  virtual public Gitter
    {
private:
public:
#ifdef EPS_PFLS
    PunktFeldListe pfl_aktuell_inhalt;
    PunktFeldListe pfl_vergangen_inhalt;
    PunktFeldListe * pfl_aktuell;
    PunktFeldListe * pfl_vergangen;
private:
    PunktFeldListe * pfl_zwischenspeichern;
    int anzahl;
    short int * f_s, * g_s;
#else
    int * f_aktuell;
    int * g_aktuell;

    int index_aktuell;

    int * f_vergangen;
    int * g_vergangen;

    int index_vergangen;
#endif
public:
    short int ** feld_aktuell;
    short int ** feld_vergangen;
public:
    void initialisieren_ep(int _n, int _m, int _verfeinerungstyp, int _rang);
    void finalisieren_ep(void);
private:
    int verfeinerungstyp;
public:
    void schieben(void);
    void schieben_neu(void);

    void bestimmen_neu(void);
private:
    void bestimmen_simulation(void);
private:
    void feld_vergangen_aufloesen(void);

    void punkt_schreiben(void);

    int f, g;
    int fff, ggg;

    int * f_zwischenspeichern;
    int * g_zwischenspeichern;
    short int ** feld_zwischenspeichern;
    int i, j;
private:
    double defekt_zaehler, defekt_nenner;
public:
    int ID_aktuell(int ff, int gg);
    int ID_vergangen(int ff, int gg);
public:
#ifdef KURZ_FF
    short int ** farbenfeld_ep;
#else
    int ** farbenfeld_ep;
#endif
public:
    int * f_oben, * f_unten, * g_links, * g_rechts;
    void setzen_verfeinerungs_gitter_grenzen(int _f_oben, int _f_unten, int _g_links, int _g_rechts, int nummer);
public:
    void ausgeben_feld_aktuell(void);
private:
public:
    double ** DF0_grob;
private:
    int f_grob, g_grob;
public:
    double krit_grenze;
private:
    int max_sim_gitter;
public:
    int anzahl_v_gitter;
private:
public:
    void entferne_echten_rand(void);
private:
    bool teste_echter_rand(void);
    int k;
public:
    int rang_ep;
private:
    void ausgabe375(void);
    void ausgabe689(void);
private:
    bool ist_vorhanden;
public:
    double verf_krit;
    double verf_krit_1;
    double verf_krit_2;
private:
    double abs(double alpha);
private:
    void bestimmen_selbstadaptiv_tau(void);
    void bestimmen_selbstadaptiv_tau12(void);
    int * f_behalten, * g_behalten, anzahl_behalten;
public:
    void bestimmen_neu_ergaenzen(void);
public:
    void initialisieren_ep_vt3(int n, int m);
    void finalisieren_ep_vt3(void);
private:
    void ausgabe_aktuell(void);
    void ausgabe_vergangen_feld(void);
    void ausgabe_aktuell_feld(void);
    };

#endif

