#include "ep_ff_bestimmen.h"

// Kommentar: Es wird aus P+ und P- ep-ff bestimmt - vergleiche die Dissertation. Das ist sehr einfach, muss aber
// gemacht werden.

// Kommentar: Eine Datei - Ausgabe von ep-ff zwecks Kontrolle.
void EP_FFbestimmen::ausgeben(DateiAusgabe * da_epff, int t)
    {
#ifdef AUSGABEN_DATEI
    * da_epff->aus << "EP-ff " << " t " << t << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            * da_epff->aus << ep_ff[i][j] << " ";
            }
        * da_epff->aus << endl;
        }
    * da_epff->aus << "Ende EP-ff " << endl;
#endif
    }

// Kommentar: Eine Datei - Ausgabe von ep-ff zwecks Kontrolle - mit besser strukturierter Darstellung sowie unter Ausgabe der
// Variablen t.
void EP_FFbestimmen::ausgeben_2(DateiAusgabe * da_epff, int t)
    {
    da_epff->oeffnen();
    * da_epff->aus << "EP-ff " << " t " << t << endl;
    for(i=0; i<n; i++)
        {
        * da_epff->aus << i << " ";
// Kommentar: Bei i < 10 wird ein Leerzeichen mit ausgegeben, damit alle ep-ff - Werte mit derselben y - Koordinate
// untereinander stehen.
        if(i<10)
            {
            * da_epff->aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * da_epff->aus << ep_ff[i][j] << " ";
            }
        * da_epff->aus << endl;
        }
    * da_epff->aus << "Ende EP-ff " << endl;
    da_epff->schliessen();
    }

// Kommentar: Initialisierung der Klasse EP_FFbestimmen.
void EP_FFbestimmen::initialisieren(int _m, int _n, int _rang)
// wird komplett finalisiert
    {
// Kommentar: Kopie der bergabeparameter.
    m = _m;
    n = _n;
    rang = _rang;

// Kommentar: Anlegen von Speicherplatz fr die Struktur ep_ff
    ep_ff = new short int * [n];
    for(i=0; i<n; i++)
        {
        ep_ff[i] = new short int [m];
        for(j=0; j<m; j++)
            {
            ep_ff[i][j] = 0;
            }
        }
    }

// Kommentar: Finalisieren von ep_ff, indem der angelegte Speicherplatz wieder freigegeben wird.
void EP_FFbestimmen::finalisieren(void)
    {
    for(i=0; i<n; i++)
        {
        delete ep_ff[i];
        }
    delete ep_ff;
    }

// Kommentar: Die eigentliche Funktion, die ep-ff berechnet.
void EP_FFbestimmen::tun(PunktFeldListe * _P_minus, PunktFeldListe * _P_plus)
    {
    P_plus = _P_plus;
    P_minus = _P_minus;

// Zuerst wird P+ durchlaufen, und auf den Koordinaten dieser Punkte wird 2 geschrieben.
    anzahl = P_plus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        ep_ff[P_plus->f[i]][P_plus->g[i]] = 2;
        }

// Zuerst wird P- durchlaufen, und auf den Koordinaten dieser Punkte wird 1 geschrieben.
    anzahl = P_minus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        ep_ff[P_minus->f[i]][P_minus->g[i]] = 1;
#ifdef AKTUELLE_KOMMENTARE
        if((rang==0)||(rang==4))
            {
            cout << " CCDDEE P_minus: f " << P_minus->f[i] << " g " << P_minus->g[i] << " rang " << rang << endl;
            }
#endif
        }
// Kommentar: Ergebnis: Auf P+ Punkten steht der Wert 2, auf P- Punkten der Wert 1, und sonst berall 0.
// Fr letzteres muss ep-ff aber am Ende wieder auf 0 gesetzt werden.
// Kommentar: P_minus dominiert P_plus! Warum? Eigentlich sind diese Punktemengen disjunkt!
    }

// Kommentar: Zurcksetzen der Matrix ep-ff
void EP_FFbestimmen::resetten(PunktFeldListe * _P_minus, PunktFeldListe * _P_plus)
    {
    P_plus = _P_plus;
    P_minus = _P_minus;

// Kommentar: Hier werden die Punkte zu P+ zurckgesetzt.
    anzahl = P_plus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        ep_ff[P_plus->f[i]][P_plus->g[i]] = 0;
        }

// Kommentar: Hier werden die Punkte zu P- zurckgesetzt.
    anzahl = P_minus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        ep_ff[P_minus->f[i]][P_minus->g[i]] = 0;
        }
    }
