#include "ep_s_bestimmen.h"

// Kommentar: EP_s_bestimmen bestimmt ep_plus und ep_minus aufgrund von feld_vergangen und feld_aktuell sowie den
// Punktemengen. Es basiert also auf den Eigenschaftspunkten. Es ist ein Teil von aV.

// Kommentar: Hier geschieht aufgrund von feld_vergangen und feld_aktuell die Bestimmung von ep_plus und ep_minus
// Deshalb mssen diese in Lastausgleich eigentlich nicht bestimmt werden.
// Aber: ep_plus_i und ep_minus_i werden sowohl auf dem entfernten Bereich als auch drum herum
// upgedatet. Und: Das ep_plus - und ep_minus reset in aV erfolgt am Ende, und nicht vor dem tun.
// So sind Eintrge dazwischen mglich. Warum habe ich das gelassen?

// Kommentar: Der P_minus_uebertrag sorgt dafr, dass entfernte Punkte eines grberen Gitters auch zur
// Entfernung der Punkte darunter in dem feineren Gitter erfolgt. Hier werden die Koordinaten dafr abgespeichert in ff und gg.
void EP_s_bestimmen::initialisiere_P_minus_uebertrag(void)
    {
    ff = P_minus_uebertrag->f;
    gg = P_minus_uebertrag->g;
    }

// Kommentar: Freigeben des Speichers fr diese Klasse EP_s_bestimmen
void EP_s_bestimmen::finalisiere_ep_s(void)
    {
#ifndef EPS_PFLS
// Kommentar: Falls EPS_PFLS nicht ist, und NEUES_EP_AKTUALISIERUNG auch nicht, wird fr die Alternative zu den pfl - Strukturen
// Speicherplatz freigegeben.
// f_vergangen wird nicht mehr angelegt, sondern bei tun_neu von den Eigenschaftspunkten kopiert - als Zeiger.
#ifndef NEUES_EP_AKTUALISIERUNG
    delete f_vergangen;
    delete g_vergangen;
    delete f_aktuell;
    delete g_aktuell;
#endif
#endif

// Kommentar: Falls der Randaustausch ber eine Kommunikation von Vektoren erfolgt: Lschen der Zeiger auf diese
// Informationen.
    if(vektorisieren0==JA)
        {
        delete f1_v_vektor_e;
        delete f2_v_vektor_e;
        delete g_v_vektor_e;

        delete f_h_vektor_e;
        delete g1_h_vektor_e;
        delete g2_h_vektor_e;

        delete f_rs_e;
        delete g_rs_e;

        delete anzahl_h_vektor_e;
        delete anzahl_v_vektor_e;
        delete punkteanzahl_e;
        }
// Kommentar: Ansonsten hat man den Randaustausch mit Hilfe der Koordinatensortierung, und lscht die Zeiger auf diese
// Punkte - Information.
    else
        {
        delete f_a_rs;
        delete g_a_rs;
        delete anzahl_a_rs;
        }
// Kommentar: Lschen des Speicherplatzes fr diese Punktefeldlisten
    aussenrand_punkte_aktuell->finalisierung();
    aussenrand_punkte_vergangen->finalisierung();
    delete aussenrand_punkte_aktuell;
    delete aussenrand_punkte_vergangen;
    }

//void EP_s_bestimmen::initialisiere_ep_s(ParallelesRechnen * _paralleles_rechnen, int * _PT, PunktListe * _ep_minus, PunktListe * _ep_plus, bool _h_gleich_h_min)

// Kommentar: Es erfolgt eine Initialisierung der Klasse EP_s_bestimmen.
void EP_s_bestimmen::initialisiere_ep_s(ParallelesRechnen * _paralleles_rechnen, int * _PT, PunktFeldListe * _ep_minus, PunktFeldListe * _ep_plus, bool _h_gleich_h_min)
// wird komplett finalisiert
    {
// Kommentar: Die bergabeparameter werden in Variablen kopiert.
    PT = _PT;
    paralleles_rechnen = _paralleles_rechnen;

    rang = paralleles_rechnen->rang;
    groesse = paralleles_rechnen->groesse;

    vektorisieren0 = paralleles_rechnen->vektorisieren0;

    ep_minus = _ep_minus;
    ep_plus = _ep_plus;

    h_gleich_h_min = _h_gleich_h_min;
    if(paralleles_rechnen->gitterebene==1)
        {
        h_gleich_1 = true;
        }
    else
        {
        h_gleich_1 = false;
        }
// Kommentar: m und n werden aus paralleles_rechnen ausgelesen.
    m = paralleles_rechnen->m;
    n = paralleles_rechnen->n;

// Kommentar: Die Struktur feld wird aus paralleles_rechnen - eigentlich aus der Klasse Gitter - ausgelesen.
    feld_gitter = paralleles_rechnen->feld;

// Kommentar: mn wird bestimmt.
    mn = m*n;

// Kommentar: Falls die pfl - Strukturen nicht da sind, werden entsprechende Koordinatenmengen mit Speicher versorgt.
#ifndef EPS_PFLS
#ifndef NEUES_EP_AKTUALISIERUNG
    f_vergangen = new short [mn];
    g_vergangen = new short [mn];
    f_aktuell = new short [mn];
    g_aktuell = new short [mn];
#endif
#endif
    // spter : werden die nicht von Programm bernommen?. Nein: Das hier ist nicht das Feld. Das hier sind Koordinaten.
// Kommentar: Werden in tun_neu neu gesetzt.
    anzahl_aktuell = 0;
    anzahl_vergangen = 0;

// Kommentar: Falls vektorisieren sein soll, dann anlegen der Zeiger zur Aufnahme der Zeigerinformationen fr den
// Vektor - Auenrand.
    if(vektorisieren0==JA)
        {
        f1_v_vektor_e = new short int * [groesse];
        f2_v_vektor_e = new short int * [groesse];
        g_v_vektor_e = new short int * [groesse];

        f_h_vektor_e = new short int * [groesse];
        g1_h_vektor_e = new short int * [groesse];
        g2_h_vektor_e = new short int * [groesse];

        f_rs_e = new short int * [groesse];
        g_rs_e = new short int * [groesse];

        anzahl_h_vektor_e = new int * [groesse];
        anzahl_v_vektor_e = new int * [groesse];
        punkteanzahl_e = new int * [groesse];
        }
// Kommentar: Ansonsten lege Speicherplatz fr die Auenrandpunkte an.
    else
        {
        f_a_rs = new short int * [groesse];
        g_a_rs = new short int * [groesse];
        anzahl_a_rs = new int * [groesse];
        }

#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "Initialisieren ep_s_bestimmen" << endl;
#endif

// Kommentar: Durchlaufe die IDs aller anderen Kerne.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Falls vektorisieren, dann kopiere die Zeiger auf die Randinformationen in diesem Fall via paralleles_rechnen
            if(vektorisieren0==JA)
                {
#ifdef AUSGABEN_EP_S_BESTIMMEN
                cout << "Vektorisieren0 == JA" << endl;
#endif
                f1_v_vektor_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].f1_v_vektor_e;
                f2_v_vektor_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].f2_v_vektor_e;
                g_v_vektor_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].g_v_vektor_e;

                f_h_vektor_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].f_h_vektor_e;
                g1_h_vektor_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].g1_h_vektor_e;
                g2_h_vektor_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].g2_h_vektor_e;

                f_rs_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].f_e;
                g_rs_e[i] = paralleles_rechnen -> randstruktur_kommunikation[i].g_e;

                anzahl_h_vektor_e[i] = &(paralleles_rechnen -> randstruktur_kommunikation[i].anzahl_h_vektor_e);
                anzahl_v_vektor_e[i] = &(paralleles_rechnen -> randstruktur_kommunikation[i].anzahl_v_vektor_e);
                punkteanzahl_e[i] = &(paralleles_rechnen -> randstruktur_kommunikation[i].punkteanzahl_e);
                }
// Kommentar: Ansonsten kopiere die Zeiger auf die Punkteinformation im Falle 'sortieren'.
            else
                {
#ifdef AUSGABEN_EP_S_BESTIMMEN
                cout << "Vektorisieren0 == NEIN" << endl;
#endif
                f_a_rs[i] = paralleles_rechnen -> rand_werte_kommunikation[i].f_a_rs;
                g_a_rs[i] = paralleles_rechnen -> rand_werte_kommunikation[i].g_a_rs;
#ifdef AUSGABEN_EP_S_BESTIMMEN
                cout << "Nach f_a_rs g_a_rs " << endl;
#endif
                anzahl_a_rs[i] = &(paralleles_rechnen -> rand_werte_kommunikation[i].anzahl_a_rs);
#ifdef AUSGABEN_EP_S_BESTIMMEN
                cout << "Nach anzahl_a_rs " << endl;
#endif
                }
            }
        }
// feld_aktuell und feld_vergangen werden nicht verknpft mit von ausserhalb. Wie kann man also abfragen, was da steht?
// Ich brauche diese Informationen, um Simulation und Selbstadaptivitt beides als alternativ zu realisieren.
// Vielleicht doch die Klasse Eigenschaftspunkte mit verwenden!

// Kommentar: Lege die Dateiausgabe DA_ep_s_bestimmen an.
    strcpy(zeichenkette, "da_eps");
    DA_ep_s_bestimmen.initialisieren(rang, zeichenkette); // braucht selber keinen Speicherplatz.

// Kommentar: Lege die PunktFeldListen aussenrand_punkte_aktuell bzw. aussenrand_punkte_vergangen an. Der Gebrauch davon: siehe unten.
    aussenrand_punkte_aktuell = new PunktFeldListe [1];
    aussenrand_punkte_vergangen = new PunktFeldListe [1];
    aussenrand_punkte_aktuell->initialisierung(n, m);
    aussenrand_punkte_vergangen->initialisierung(n, m);
    // spter: braucht man das?
    }

// Kommentar: Falls per Prprozessor - Direktive gewhlt, mache die Datei Ausgabe in die Datei zu DA_ep_s_bestimmen
// fr feld_aktuell und feld_vergangen.
void EP_s_bestimmen::da_ausgabe_feld_aktuell(void)
    {
#ifdef AUSGABEN_DATEI
#endif
    }

// Kommentar: Falls per Prprozessor - Direktive gewhlt, mache die Datei Ausgabe in die Datei zu DA_ep_s_bestimmen
// fr feld_aktuell und feld_vergangen. Hier wird auch der Kanal geffnet und geschlossen. Und fr i<10 wird fr
// die 'i-Ausgabe' ein Leerzeichen hinzugefgt, damit vergleichbares untereinandersteht.
void EP_s_bestimmen::da_ausgabe_feld_aktuell2(void)
    {
#ifdef AUSGABEN_DATEI_NEU
    DA_ep_s_bestimmen.oeffnen(); // wird unten geschlossen
    * DA_ep_s_bestimmen.aus << "Feld Aktuell2 " << " t " << t << endl;
    for(i=0; i<n; i++)
        {
        * DA_ep_s_bestimmen.aus << i << " ";
        if(i<10)
            {
            * DA_ep_s_bestimmen.aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * DA_ep_s_bestimmen.aus << feld_aktuell[i][j] << " ";
            }
        * DA_ep_s_bestimmen.aus << endl;
        }
    * DA_ep_s_bestimmen.aus << "Ende Feld Aktuell2, Beginn Feld_vergangen2 t " << t << endl;

    for(i=0; i<n; i++)
        {
        * DA_ep_s_bestimmen.aus << i << " ";
        if(i<10)
            {
            * DA_ep_s_bestimmen.aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * DA_ep_s_bestimmen.aus << feld_vergangen[i][j] << " ";
            }
        * DA_ep_s_bestimmen.aus << endl;
        }
    * DA_ep_s_bestimmen.aus << "Ende feld_vergangen2 " << endl;
    DA_ep_s_bestimmen.schliessen();
#endif
    }

// Kommentar: Falls per Prprozessor - Direktive gewhlt, mache die Datei Ausgabe in die Datei zu DA_ep_s_bestimmen
// fr ep_plus und ep_minus.
void EP_s_bestimmen::ep_plus_und_minus_ausgeben(void)
    {
#ifdef AUSGABEN_DATEI_NEU
    DA_ep_s_bestimmen.oeffnen(); // wird unten wieder geschlossen
    * DA_ep_s_bestimmen.aus << "EP_Plus ausgeben " << " t " << t << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            * DA_ep_s_bestimmen.aus << ep_plus->feld[i][j] << " ";
            }
        * DA_ep_s_bestimmen.aus << endl;
        }
    * DA_ep_s_bestimmen.aus << "Ende EP_Plus und Beginn EP_Minus " << " t " << t << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            * DA_ep_s_bestimmen.aus << ep_minus->feld[i][j] << " ";
            }
        * DA_ep_s_bestimmen.aus << endl;
        }
    * DA_ep_s_bestimmen.aus << "Ende EP_Minus " << endl;
    DA_ep_s_bestimmen.schliessen();
#endif
    }

// Kommentar: Die PunktFeldListen ep_minus und ep_plus werden zu Beginn oder am Ende der Schritte zurckgesetzt, vgl.
// diese Mglichkeit der PunktFeldListen
void EP_s_bestimmen::reset(void)
    {
    ep_minus->reset();
    ep_plus->reset();
    }

// Kommentar: Diese Funktion wurde zugunsten der Funktion tun_neu (s.u.) ausrangiert, und wird daher nicht kommentiert.
void EP_s_bestimmen::tun(void)
    {
#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "EP_s_bestimmen::tun Anfang rang " << rang << endl;
#endif
    feld = ep_minus->feld;
    anzahl_aktuell = 0;

#ifdef AUSGABEN_DATEI
    da_ausgabe_feld_aktuell();
#endif

    for(paralleles_rechnen->anfangsposition(); paralleles_rechnen->ist_fertig_fl()!=true; paralleles_rechnen->naechster())
        {
        f = paralleles_rechnen->lesen_f();
        g = paralleles_rechnen->lesen_g();

#ifdef AUSGABEN_EP_S_BESTIMMEN
        cout << "praf " << f << " " << g << " " << endl;
#endif

        ep_aendern(f, g);
        }

#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "EP_s_bestimmen::tun Zweites rang " << rang << endl;
#endif

    if(vektorisieren0==JA)
        {
        for(j=0; j<groesse; j++)
            {
#ifdef AUSGABEN_EP_S_BESTIMMEN
            cout << "EPsbV j " << j << " PT(j) " << PT[j] << " rang " << rang << endl;
#endif
            if(PT[j]>0)
                {
                for(i=0; i<*(anzahl_h_vektor_e[j]); i++)
                    {
                    for(a = g1_h_vektor_e[j][i], b = g2_h_vektor_e[j][i], c = f_h_vektor_e[j][i]; a<=b; a++)
                        {
                        ep_aendern(c, a);
                        }
                    }
                for(i=0; i<*(anzahl_v_vektor_e[j]); i++)
                    {
                    for(a = f1_v_vektor_e[j][i], b = f2_v_vektor_e[j][i], c = g_v_vektor_e[j][i]; a<=b; a++)
                        {
                        ep_aendern(a, c);
                        }
                    }
                for(i=0; i<*(punkteanzahl_e[j]); i++)
                    {
                    f = f_rs_e[j][i];
                    g = g_rs_e[j][i];

                    ep_aendern(f, g);
                    }
                }
            }
        }
    else
        {
        for(j=0; j<groesse; j++)
            {
#ifdef AUSGABEN_EP_S_BESTIMMEN
            cout << "EPsbS j " << j << " PT(j) " << PT[j] << " rang " << rang << endl;
#endif
            if(PT[j]>0)
                {
#ifdef AUSGABEN_EP_S_BESTIMMEN
                cout << "EPsbS2 j " << j << " Anzahl " << (*(anzahl_a_rs[j])) << " rang " << rang << endl;
#endif
                f_a_rs_j = f_a_rs[j];
                g_a_rs_j = g_a_rs[j];
                for(i=0; i<*(anzahl_a_rs[j]); i++)
                    {
                    f = int(f_a_rs_j[i]);
                    g = int(g_a_rs_j[i]);
                    ep_aendern(f, g);
                    }
                }
            }
        }

#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "EP_s_bestimmen::tun Teil 3 rang " << rang << endl;
#endif
    austragen_aussenrand_aus_ep_snb();

    if(h_gleich_h_min==true)
        {
#ifdef AUSGABEN_DATEI
        ep_plus_und_minus_ausgeben();
        DA_ep_s_bestimmen.schliessen();
#endif
        return;
        }

    for(i=0, anzahl = P_minus_uebertrag->anzahl; i<anzahl; i++)
        {
        ep_minus->hinzu(ff[i], gg[i]);
        }
#ifdef AUSGABEN_DATEI
    ep_plus_und_minus_ausgeben();
    DA_ep_s_bestimmen.schliessen();
#endif

#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "EP_s_bestimmen::tun Ende rang " << rang << endl;
#endif
    }

// Kommentar: Diese Funktion wird ausschlielich von der Funktion 'tun' verwendet, die nicht mehr gebraucht wird.
// Daher wird auch sie nicht mehr gebraucht, und daher nicht kommentiert.
inline void EP_s_bestimmen::ep_aendern(int f, int g)
    {

    if(feld_aktuell[f][g]==true)
        {
#ifndef NEUES_EP_AKTUALISIERUNG
        f_aktuell[anzahl_aktuell] = f;
        g_aktuell[anzahl_aktuell++] = g;
#endif
        if(feld_vergangen[f][g]==false)
            {
            ep_plus->hinzu(f, g);
// Punkt hinzu
            }
        return;
        }

    if(feld[f][g]!=-1)
        {
        if(feld_aktuell[f][g]==true)
            {
            ep_minus->hinweg(f, g);
#ifdef AUSGABEN_EP_S_BESTIMMEN
            cout << " epaf23feld " << feld[f][g] << endl;
#endif
            }
        return;
        }        // Das kommt wahrscheinlich ganz heraus.
//    else
        {
        if(feld_vergangen[f][g]==true)
            {
            ep_minus->hinzu(f, g);
#ifdef AKTUELLE_KOMMENTARE
            if((rang==0)||(rang==4))
                {
                cout << " DDEEFF ep-minus->hinzu f " << f << " g " << g << " rang " << rang << endl;
                }
#endif
// Punkt hinweg
            }
        }
    }

// Kommentar: Wird in FarbenfeldVerschicken verwendet. Wegen FELD_VERGANGEN_AENDERN nicht definiert sind die Aufrufe davon
// deaktiviert.
// Bemerkung: Wenn diese Funktion verwendet wrde, dann mte pfl gendert werden. So wird nur feld_vergangen gesetzt, falls
// es noch nicht gesetzt war.
void EP_s_bestimmen::vergangen_hinzu(int f, int g)
    {
    if(feld_vergangen[f][g]==false)
        {
        feld_vergangen[f][g] = true;
        ep_snb_update->hinzu(f, g);
#ifndef NEUES_EP_AKTUALISIERUNG
#ifdef WOHL_NICHT
        f_vergangen[anzahl_vergangen] = f;
        g_vergangen[anzahl_vergangen++] = g;
#endif
#endif
// Diese Speicherung hat nur den Sinn, beim verschieben diese bertragenen Feldeintrge zu lschen. Aber das macht
// eigentlich keinen Sinn, weil diese Werte durch Feld_aktuell berschrieben werden.
        }
    }

// Kommentar: Wird in FarbenfeldVerschicken verwendet. Wegen FELD_VERGANGEN_AENDERN nicht definiert sind die Aufrufe davon
// deaktiviert.
// Bemerkung: Wenn diese Funktion verwendet wrde, dann mte pfl gendert werden. So wird nur feld_vergangen auf false gesetzt,
// falls es auf true gesetzt war.
void EP_s_bestimmen::vergangen_hinweg(int f, int g)
    {
    if(feld_vergangen[f][g]==true)
        {
        feld_vergangen[f][g] = false;
        ep_snb_update->hinweg(f, g);
// Diese Speicherung hat nur den Sinn, beim verschieben diese bertragenen Feldeintrge zu lschen. Aber das macht
// eigentlich keinen Sinn, weil diese Werte durch Feld_aktuell berschrieben werden.
        }
    }

// Kommentar: Gebe die PunktFeldListen fr EP+ und EP- aus.
void EP_s_bestimmen::ausgabe(void)
    {
#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "EP_s_bestimmen.ausgabe Beginn " << endl;
    cout << "ep_plus " << endl;
    ep_plus->ausgabe();
    cout << "ep_minus " << endl;
    ep_minus->ausgabe();
    cout << "EP_s_bestimmen.ausgabe Ende " << endl;
#endif
    }

// Kommentar: Es werden die Zeiger auf feld_aktuell und feld_vergangen ausgetauscht.
void EP_s_bestimmen::schieben(void)
    {
// Kommentar: Das Lschen von feld_vergangen geschieht in Eigenschaftspunkte in der Funktion schieben und der Unterfunktion
// feld_vergangen_aufloesen.
    // Ist das nicht doppelt gemoppelt, vgl. Eigenschaftspunkte::feld_vergangen_aufloesen. 16.10.14

// Kommentar: Die Zeiger feld_aktuell und feld_vergangen werden getauscht. Da sie doppelt definiert sind -
// fr paralleles_rechnen und die adaptive Verfeinerung - mssen sie an beiden Stellen ausgetauscht werden.
    feld_zwischenspeichern = feld_aktuell;
    feld_aktuell = feld_vergangen;
    feld_vergangen = feld_zwischenspeichern;

// Ggf. Ausgabe von feld_vergangen
#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "Feld vergangen " << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << feld_vergangen[i][j] << " ";
            }
        cout << endl;
        }
#endif

// Kommentar: Wegen EPS_PFLS definiert wird das nicht mehr gebraucht. Genauer: Bei tun_neu werden auch f_vergangen usw.
// aus den Eigenschaftspunkten geladen, brauchen also nicht mehr getauscht werden.
#ifndef EPS_PFLS // wird nicht gebraucht, da bei tun_neu das alles geladen wird, 18.10.14
    anzahl_vergangen = anzahl_aktuell;
//    anzahl_aktuell = 0;
#ifndef NEUES_EP_AKTUALISIERUNG
    f_zwischenspeichern = f_vergangen;
    f_vergangen = f_aktuell;
    f_aktuell = f_zwischenspeichern;

    g_zwischenspeichern = g_vergangen;
    g_vergangen = g_aktuell;
    g_aktuell = g_zwischenspeichern;
#endif
#endif
    }

// Kommentar: Die Dateiausgabe zu dieser Klasse wird vorbereitet.
void EP_s_bestimmen::starte_dateiausgabe(void)
    {
#ifdef AUSGABEN_DATEI
    DA_ep_s_bestimmen.initialisieren(rang, "DA_ep_s_bestimmen");
#endif
    }

// Kommentar: Bei der bertragung des Auenrandes bzgl. der Eigenschaftspunkte wird auch EP-SNB verndert.
// Verschwindet dort Auenrand, dann muss die EP-SNB - Information dort entfernt werden.
void EP_s_bestimmen::austragen_aussenrand_aus_ep_snb(void)
    {
// Kommentar: Damit man statt Vektoren oder Punkte nur Punkte hat, wird der Auenrand als Punkte abgespeichert.
    generiere_aussenrand();
// Kommentar: Der vergangene Auenrand wird durchlaufen.
    for(i=0, anzahl = aussenrand_punkte_vergangen->anzahl; i<anzahl; i++)
        {
        f = (aussenrand_punkte_vergangen->f)[i];
        g = (aussenrand_punkte_vergangen->g)[i];
#ifdef AKTUELLE_KOMMENTARE
        cout << " HHIIJJ EP_s austragen aussenrand Kandidaten rang " << rang << " f " << f << " g " << g << endl;
#endif
// Kommentar: Wurde fr diesen Punkt schon eine EP-SNB Entfernung durchgefhrt, dann braucht nichts getan zu werden.
        if(ist_gesetzt[f][g]==false)
            {
            continue;
            }
// Kommentar: Ist der Punkt nicht mehr Teil des Auenrandes ...
        if(((aussenrand_punkte_aktuell->feld)[f][g]==-1)&&(feld_gitter[f][g]<0)) // Wenn (f,g) nicht mehr auf dem Prozessior P existiert
            // Datum der Erstellung: ca. 18.03.2014
            // Diese Bedingung lautet: Wenn (f,g) am Auenrand war, und jetzt weder zum Inneren noch dem Auenrand gehrt,
            // dann muss es entfernt werden. Klingt eigentlich sehr vernnpftig. Ich muss sehen, wie diese Werte in diesem
            // Falle sind. 28.03.2014
            {
// Kommentar: ... dann wird, ohne das in die Entfernungspunktemenge einzutragen, aus EP-SNB gelscht
            ep_snb_update->hinweg_ohne(f, g);
            // (f,g) nicht im Gltigkeitsbereich. Daher nur EP_SNB updaten. 29.02.2014
#ifdef AKTUELLE_KOMMENTARE
            cout << " HHIIJJ EP_s austragen aussenrand rang " << rang << " f " << f << " g " << g << endl;
#endif
            }
        }
// Diese Schleife entfernt nicht mehr existierende Auenrandpunkte
// Kommentar: Jetzt kann die vergangene Auenrndpunktemenge gelscht werden.
    aussenrand_punkte_vergangen->reset();
// Kommentar: Es erfolgt ein Austausch der aktuellen und der vergangenen Auenrandpunkte, damit bei der nchsten
// Iteration wieder EP-SNB - Information gelscht werden kann.
    aussenrand_punkte_zwischenspeichern = aussenrand_punkte_aktuell;
    aussenrand_punkte_aktuell = aussenrand_punkte_vergangen;
    aussenrand_punkte_vergangen = aussenrand_punkte_zwischenspeichern;
    }

// Kommentar: Abspeichern des aktuellen Auenrandes in aussenrand_punkte_aktuell. Das ist wegen der obigen Funktion
// 'austragen_aussenrand_aus_ep_snb' schon resettet.
void EP_s_bestimmen::generiere_aussenrand(void)
    {
// Kommentar: Falls ein vektorierter Auenrand vorliegt, dann fge entsprechend diesem Rand die Punkte ein.
    if(vektorisieren0==JA)
        {
        for(j=0; j<groesse; j++)
            {
#ifdef AUSGABEN_EP_S_BESTIMMEN
            cout << "EPsbV j " << j << " PT(j) " << PT[j] << " rang " << rang << endl;
#endif
            if(PT[j]>0)
                {
                for(i=0; i<*(anzahl_h_vektor_e[j]); i++)
                    {
                    for(a = g1_h_vektor_e[j][i], b = g2_h_vektor_e[j][i], c = f_h_vektor_e[j][i]; a<=b; a++)
                        {
                        aussenrand_punkte_aktuell->hinzu(c, a);
                        }
                    }
                for(i=0; i<*(anzahl_v_vektor_e[j]); i++)
                    {
                    for(a = f1_v_vektor_e[j][i], b = f2_v_vektor_e[j][i], c = g_v_vektor_e[j][i]; a<=b; a++)
                        {
                        aussenrand_punkte_aktuell->hinzu(a, c);
                        }
                    }
                for(i=0; i<*(punkteanzahl_e[j]); i++)
                    {
                    f = f_rs_e[j][i];
                    g = g_rs_e[j][i];

                    aussenrand_punkte_aktuell->hinzu(f, g);
                    }
                }
            }
        }
// Kommentar: Falls ein sortierter Auenrand vorliegt, dann fge entsprechend diesem Rand die Punkte ein.
    else
        {
        for(j=0; j<groesse; j++)
            {
#ifdef AUSGABEN_EP_S_BESTIMMEN
            cout << "EPsbS j " << j << " PT(j) " << PT[j] << " rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            cout << " HHIIJJ generiere Aussenrand j " << j << " PT[j] " << PT[j] << " rang " << rang << endl;
#endif
            if(PT[j]>0)
                {
#ifdef AUSGABEN_EP_S_BESTIMMEN
                cout << "EPsbS2 j " << j << " Anzahl " << (*(anzahl_a_rs[j])) << " rang " << rang << endl;
#endif
                f_a_rs_j = f_a_rs[j];
                g_a_rs_j = g_a_rs[j];
                for(i=0; i<*(anzahl_a_rs[j]); i++)
                    {
                    f = int(f_a_rs_j[i]);
                    g = int(g_a_rs_j[i]);

                    aussenrand_punkte_aktuell->hinzu(f, g);
#ifdef AKTUELLE_KOMMENTARE
                    cout << " HHIIJJ aussenrand aktuell hinzu / rang " << rang << " f " << f << " g " << g << endl;
#endif
                    }
                }
            }
        }
    }

// Hier werden aktuell die Mengen EP+ und EP- bestimmt.
void EP_s_bestimmen::tun_neu(void)
    {
// Zuerst werden die Punktelisten f_aktuell / g_aktuell / f_vergangen / g_vergangen nebst ihren Lngen
// aus der Klasse Eigenschaftspunkte gelesen.
#ifdef EPS_PFLS
    f_aktuell = paralleles_rechnen->pfl_aktuell->f;
    g_aktuell = paralleles_rechnen->pfl_aktuell->g;
    f_vergangen = paralleles_rechnen->pfl_vergangen->f;
    g_vergangen = paralleles_rechnen->pfl_vergangen->g;
    anzahl_aktuell = paralleles_rechnen->pfl_aktuell->anzahl;
    anzahl_vergangen = paralleles_rechnen->pfl_vergangen->anzahl;
#else
    f_aktuell_int = paralleles_rechnen->f_aktuell;
    g_aktuell_int = paralleles_rechnen->g_aktuell;
    f_vergangen_int = paralleles_rechnen->f_vergangen;
    g_vergangen_int = paralleles_rechnen->g_vergangen;
    anzahl_aktuell = paralleles_rechnen->index_aktuell;
    anzahl_vergangen = paralleles_rechnen->index_vergangen;
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " RTV Index Aktuell " << anzahl_aktuell << " Index Vergangen " << anzahl_vergangen << " rang " << rang << endl;
#endif


// Kommentar: Das Feld von EP- bekommt einen Zeiger.
    feld = ep_minus->feld;

// Kommentar: Durchlaufe die aktuelle Eigenschaftspunkte, d.h. dort wird verfeinert.
    for(i=0; i<anzahl_aktuell; i++)
        {
// Kommentar: Die Koordinaten der aktuellen Eigenschaftspunkte werden gelesen.
#ifdef EPS_PFLS
        f = f_aktuell[i];
        g = g_aktuell[i];
#else
        f = f_aktuell_int[i];
        g = g_aktuell_int[i];
#endif
// Falls dort noch kein Eigenschaftspunkt war, fge an der Stelle in EP+ ein. 6.10.15: Denn die Punkte mit feld_aktuell = true wurden durchlaufen, und auf feld_vergangen = false getestet.
        if(feld_vergangen[f][g] == false)
            {
            ep_plus->hinzu(f, g);
            }
// Falls dort ein Eintrag in EP- vorlag, entferne diesen.
        if(feld[f][g]!=-1)
            {
            ep_minus->hinweg(f, g);
            }
        }
#ifdef AKTUELLE_KOMMENTARE_NEU
    if(rang==1)
        {
        cout << " SUN anzahl_vergangen " << anzahl_vergangen << " t " << t << " gitterebene " << paralleles_rechnen->gitterebene << endl;
        }
#endif

// Kommentar: Durchlaufe die vergangenen Eigenschaftspunkte, d.h. dort wird verfeinert.
    for(i=0; i<anzahl_vergangen; i++)
        {
// Kommentar: Die Koordinaten der vergangenen Eigenschaftspunkte werden gelesen.
#ifdef EPS_PFLS
        f = f_vergangen[i];
        g = g_vergangen[i];
#else
        f = f_vergangen_int[i];
        g = g_vergangen_int[i];
#endif

// Kommentar: Gibt es an dieser Stelle keine Verfeinerungspunkte mehr, dann fge die Stelle in EP- ein. 6.10.15: Denn die Punkte mit feld_vergangen = true wurden durchlaufen, und auf feld_aktuell = false getestet.
        if(feld_aktuell[f][g] == false)
            {
            ep_minus->hinzu(f, g);
            }
        }
// Kommentar: Trage - entsprechend obiger Funktion 'austragen_aussenrand_aus_ep_snb' - nicht mehr existierende
// Auenrandinformation aus EP-SNB aus.
    austragen_aussenrand_aus_ep_snb();

// Kommentar: In diesem Fall ist das Gitter darber vollstndig, und damit erfolgt kein P_minus_uebertrag.
    if((h_gleich_h_min==true)||(h_gleich_1==true))
        {
// Kommentar: Optionale Dateiausgabe von EP+ und EP-.
#ifdef AUSGABEN_DATEI
        ep_plus_und_minus_ausgeben();
        DA_ep_s_bestimmen.schliessen();
#endif
        return;
        }

#ifdef P_MINUS_UEBERTRAG_GILT_NOCH // Kommentar, 6.10.15: Wegen pfl_aktuell/vergangen werden ohne den bertrag alle alten Punkte eine Ebene tiefer gelscht.
// Kommentar: Wenn darber Punkte entfernt wurden, dann lsche die entsprechenden Punkte durch vergrern von ep_minus.
    for(i=0, anzahl = P_minus_uebertrag->anzahl; i<anzahl; i++)
        {
        ep_minus->hinzu(ff[i], gg[i]);
        // Das fhrt bei EP_SNBupdate zum Einfgen in EP_SNB_Punkte, und das in P_s_bestimmen.tun zu minus_hinzu,
        // in welchem wegen feld >= 0, da die Punkte existieren, hinzugefgt wird.
        ep_plus->hinweg(ff[i], gg[i]); // Diese Zeile ist vom 24.4.2015. Den Punkt (ff[i],gg[i]) gibt es nmlich nicht mehr.
        }
#endif

// Kommentar: Optionale Dateiausgabe von EP+ und EP-.
#ifdef AUSGABEN_DATEI
    ep_plus_und_minus_ausgeben();
    DA_ep_s_bestimmen.schliessen();
#endif

#ifdef AUSGABEN_EP_S_BESTIMMEN
    cout << "EP_s_bestimmen::tun Ende rang " << rang << endl;
#endif
    }

// Kommentar: Die folgenden 6 Funktionen setzen feld_aktuell oder feld_vergangen auf false oder true. Sie werden gebraucht
// in der Klasse Lastausgleich

// Kommentar: Hier wird, falls feld_aktuell auf dem Punkt true war, er auf false gesetzt - mit Update der
// Struktur pfl_aktuell.
void EP_s_bestimmen::setze_feld_aktuell_gleich_false(int f_k, int g_k)
    {
    if(feld_aktuell[f_k][g_k]==true)
        {
        feld_aktuell[f_k][g_k] = false;
        (paralleles_rechnen->pfl_aktuell)->hinweg(f_k, g_k);
//        if((f_k==4)&&(g_k==4))
//        if(rang == 0)
#ifdef AUSGABE_SUNNY
        if((rang == 0)&&(paralleles_rechnen->gitterebene==1))
            {
            cout << " SUNNY feld_aktuell_false f " << f_k << " g " << g_k << endl;
            }
#endif
        }
    }

// Kommentar: Hier wird, falls feld_aktuell auf dem Punkt false war, er auf true gesetzt - mit Update der
// Struktur pfl_aktuell.
void EP_s_bestimmen::setze_feld_aktuell_gleich_true(int f_k, int g_k)
    {
    if(feld_aktuell[f_k][g_k]==false)
        {
        feld_aktuell[f_k][g_k] = true;
        paralleles_rechnen->pfl_aktuell->hinzu(f_k, g_k);
//        if((f_k==4)&&(g_k==4))
//        if(rang == 0)
#ifdef AUSGABE_SUNNY
        if((rang == 0)&&(paralleles_rechnen->gitterebene==1))
            {
            cout << " SUNNY feld_aktuell_true f " << f_k << " g " << g_k << endl;
            }
#endif
        }
    }

// Kommentar: Hier wird, falls feld_vergangen auf dem Punkt true war, er auf false gesetzt - mit Update der
// Struktur pfl_vergangen.
void EP_s_bestimmen::setze_feld_vergangen_gleich_false(int f_k, int g_k)
    {
    if(feld_vergangen[f_k][g_k]==true)
        {
        feld_vergangen[f_k][g_k] = false;
        paralleles_rechnen->pfl_vergangen->hinweg(f_k, g_k);
#ifdef AUSGABE_SUNNY
        if((rang == 0)&&(paralleles_rechnen->gitterebene==1))
            {
            cout << " SUNNY feld_vergangen_false f " << f_k << " g " << g_k << endl;
            }
#endif
        }
    }

// Kommentar: Hier wird, falls feld_vergangen auf dem Punkt false war, er auf true gesetzt - mit Update der
// Struktur pfl_vergangen.
void EP_s_bestimmen::setze_feld_vergangen_gleich_true(int f_k, int g_k)
    {
    if(feld_vergangen[f_k][g_k]==false)
        {
        feld_vergangen[f_k][g_k] = true;
        paralleles_rechnen->pfl_vergangen->hinzu(f_k, g_k);
#ifdef AUSGABE_SUNNY
        if((rang == 0)&&(paralleles_rechnen->gitterebene==1))
            {
            cout << " SUNNY feld_vergangen_true f " << f_k << " g " << g_k << endl;
            }
#endif
        }
    }

// Kommentar: Hier wird, falls feld_vergangen auf dem Punkt ungleich der bool'schen Hilfsvariable war, er auf denselben
// Wert gesetzt - mit Update der Struktur pfl_vergangen. Man muss dafr die 2 Flle, die die bool'sche Variable
// annehmen kann, behandeln.

void EP_s_bestimmen::setze_feld_vergangen_auf_bool(int f_k, int g_k, bool bool_hilfsvariable)
    {
    if(bool_hilfsvariable == true)
        {
        if(feld_vergangen[f_k][g_k]==false)
            {
            feld_vergangen[f_k][g_k] = true;
            paralleles_rechnen->pfl_vergangen->hinzu(f_k, g_k);
#ifdef AUSGABE_SUNNY
                {
                cout << " SUNNY X feld_vergangen_true f " << f_k << " g " << g_k << endl;
                }
#endif
            }
        }
    else
        {
        if(feld_vergangen[f_k][g_k]==true)
            {
            feld_vergangen[f_k][g_k] = false;
            paralleles_rechnen->pfl_vergangen->hinweg(f_k, g_k);
#ifdef AUSGABE_SUNNY
                {
                cout << " SUNNY X feld_vergangen_false f " << f_k << " g " << g_k << endl;
                }
#endif
            }
        }
    }
