#include "ep_snb_update.h"

// Kommentar: In der Klasse EP_SNBupdate werden Funktionen aus SNBupdate zur Aktualisierung des aktuellen EP_SNB's aufgerufen.
// Es basiert auf EP+ und EP-.

// Kommentar: Die PunkteFeldListen EP+ und EP- bewirken in dieser Funktion von EP_SNBupdate die Aktualisierung der Struktur SNB.
// Dies ist DIE Funktion dieser Klasse.
void EP_SNBupdate::tun(PunktFeldListe * EP_minus, PunktFeldListe * EP_plus)
    {
//    EP_SNB_punkte->reset();
//   Dieses reset wird am Ende gemacht, damit es nicht vom LA gelscht wird.

#ifdef AKTUELLE_KOMMENTARE
    if(rang==3)
        {
        cout << " NNMMLL 0 " << endl;
        }
#endif
// Kommentar: Zuerst geschieht ein Update fr EP_plus_dazu. Hier wird in der Klasse Gitter eingetragen oder ausgetragen, wenn
// Gitterpunkte durch den Lastausgleich dazukommen oder entfernt werden - in Funktionen wie einfuegen_ebene_auch_dynamisch.
// Fr ep-minus geschieht der Update in einer Funktion wie Lastausgelich::packen_ep_rumpf mit dem Befehl
// ep_snb_update_i->hinweg_ohne.
// Bemerkung: Es wird in Lastausgleich auch durch ep_plus_i und ep_minus_i ein Update erreicht. Dabei
// geht es aber nur um Punkte, die weiterverschickt werden.

// Kommentar: Die Anzahl von EP_plus_dazu wird gelesen.
    anzahl = EP_plus_dazu->anzahl;

// Kommentar: Wichtig: Auf den ersten Blick kommen die folgenden Befehle doppelt. Das liegt an der Prprozessor - Konstruktion
// #ifdef AUSGABEN_DATEI .. #else .. #endif. Denn bei AUSGABEN_DATEI werden auch die normalen Befehle
// ausgefhrt.
#ifdef AUSGABEN_DATEI
    da_av->aus << " EP_Plus_dazu anzahl " << anzahl << " ";

// Kommentar: EP_plus_dazu wird durchlaufen
    for(i=0; i<anzahl; i++)
        {
        f = EP_plus_dazu->f[i];
        g = EP_plus_dazu->g[i];

        da_av->aus << "(" << f << " " << g << ")";

// Kommentar: Wenn aufgrund der Kommunikation feld_vergangen auf true gesetzt wurde => einfgen. Aber: In Lastausgleich wird diese
// Variable nicht auf true gesetzt. Und: In adaptive Verfainerung::tun_neu wird EP_plus_dazu resettet, bevor
// EP_SNBupdate::tun aufgerufen wird.
        if(feld_vergangen[f][g]==true)
            {
            hinzu(f, g);
            da_av->aus << "(" << f << " " << g << ")";
            }
        }
    da_av->aus << endl;
// Kommentar: EP+ wird durchlaufen
    anzahl = EP_plus->anzahl;
    da_av->aus << " EP_plus ";
    for(i=0; i<anzahl; i++)
        {
        f = EP_plus->f[i];
        g = EP_plus->g[i];
        da_av->aus << "(" << f << " " << g << ")";
// Kommentar: Da EP_plus_dazu resettet wird, ist das hier immer true.
        if(EP_plus_dazu->feld[f][g]==-1)
            {
            da_av->aus << "(" << f << " " << g << ")";
// Kommentar: Bei EP_plus wird in EP_SNB hinzugefgt.
            hinzu(f, g);
            }
        }
    da_av->aus << endl;
// Erst EP_plus, weil EP_minus dominant ist, vgl. EP-ff bestimmen.

    da_av->aus << "EP_minus Punkte in EP_SNB_update " << endl;

// Kommentar: EP- wird durchlaufen.
    anzahl = EP_minus->anzahl;

    for(i=0; i<anzahl; i++)
        {
        da_av->aus << "(" << EP_minus->f[i] << "," << EP_minus->g[i] << ")";
// Kommentar: Bei EP_minus wird SNBupdate::hinweg(f,g) gemacht.
        hinweg(EP_minus->f[i], EP_minus->g[i]);
        }
    da_av->aus << endl;
#else
// Kommentar: EP_plus_dazu wird durchlaufen
    for(i=0; i<anzahl; i++)
        {
        f = EP_plus_dazu->f[i];
        g = EP_plus_dazu->g[i];

// Kommentar: Wenn aufgrund der Kommunikation feld_vergangen auf true gesetzt wurde => einfgen. Aber: In Lastausgleich wird diese
// Variable nicht auf true gesetzt. Und: In adaptive Verfainerung::tun_neu wird EP_plus_dazu resettet, bevor
// EP_SNBupdate::tun aufgerufen wird.
        if(feld_vergangen[f][g]==true)
            {
            hinzu(f, g);
            }
        }
// Kommentar: EP+ wird durchlaufen
    anzahl = EP_plus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        f = EP_plus->f[i];
        g = EP_plus->g[i];

// Kommentar: Da EP_plus_dazu resettet wird, ist das hier immer true.
        if(EP_plus_dazu->feld[f][g]==-1)
// Diese Abfrage ist eigentlich auch berflssig, weil nirgendwo in EP_plus_dazu etwas eingetragen wird.
            {
// Kommentar: Bei EP_plus wird in EP_SNB hinzugefgt.
            hinzu(f, g);
            }
        }
// Erst EP_plus, weil EP_minus dominant ist, vgl. EP-ff bestimmen.

// Kommentar: EP- wird durchlaufen
    anzahl = EP_minus->anzahl;

    for(i=0; i<anzahl; i++)
        {
        f = EP_minus->f[i];
        g = EP_minus->g[i];

//        if(feld_aktuell[f][g]==false) // Herausgenommen am 24.4.2015: Denn: Alles, was aufgrund
// von feld_aktuell und feld_vergangen eingefgt wird, hat diese Eigenschaft. Und fr
// P- bertrag soll es entfernt werden. Aber: Noch praktisch zu prfen!
// Was soll diese Abfrage? Bei EP- ist feld_aktuell == false, vgl. Punkt. Diese Abfrage ist berflssig.
// Na ja: Was ist mit P- bertrag, EP- der nchst hheren Ebene?
            {
// Kommentar: Bei EP_minus wird SNBupdate::hinweg(f,g) gemacht.
            hinweg(f, g);
            }
        }
#endif
    }

// Damit folgt: Wir haben EP_SNB zum neuen Gitter: Plus kommt hinzu, Minus geht hinweg.
