#include "extreme_vektoren.h"

// Kommentar: Greift auf die Funktionen der Klasse Strategie zurck, hilft beim Suchen, Einfgen und Entfernen von vielen
// Vektoren.

// Kommentar: Dient dem Aktualisieren der Struktur aufgrund des Entfernens von mv_vertikal - beim Verschicken von Punkten.
// Es wird aber nur fr eine Ebene gemacht, weil es fr die Ebene, fr die gesucht worden ist, automatisch geschieht.
void ExtremeVektoren::entferne_ebene(MV_vertikal * mv_vertikal, int ebene)
    {
// Kommentar: Die Zeiger auf die Vektorenliste der Ebene werden bestimmt - sowie die Anzahl an Vektoren.
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

// Kommentar: Die Vektoren werden durchlaufen
    for(i=0; i<index; i++)
        {
        vvektor_f1 = f1[i];
        vvektor_f2 = f2[i];
        vvektor_g = g[i];

// Kommentar: Alle Punkte zum jeweiligen Vektor werden gelscht.
        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            entfernen(j, vvektor_g);
            }
        }
    }

// Kommentar: Dient dem Aktualisieren der Struktur aufgrund des Einfgens von mv_vertikal - beim Verschicken von Punkten.
// Es wird aber nur fr eine Ebene gemacht.
void ExtremeVektoren::einfuegen_ebene(MV_vertikal * mv_vertikal, int ebene)
    {
// Kommentar: Die Zeiger auf die Vektorenliste der Ebene werden bestimmt - sowie die Anzahl an Vektoren.
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

// Kommentar: Die Vektoren werden durchlaufen
    for(i=0; i<index; i++)
        {
        vvektor_f1 = f1[i];
        vvektor_f2 = f2[i];
        vvektor_g = g[i];

// Kommentar: Alle Punkte zum jeweiligen Vektor werden eingefgt.
        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            einfuegen(j, vvektor_g);
            }
        }
    }

// Kommentar: Fr einen Lasttransfer nach Westen werden die Vektoren einer Ebene bestimmt, und in
// mv_vertikal der Ebene mit der Nummer des bergabeparameters h_LA eingefgt - unter gleichzeitigem Entfernen
// aus dieser einen Ebene. Je nach Wert von lastwert_korrektur wird dabei ebensolche gemacht oder nicht.
// Das da kein hinzu steht, bedeutet, dass der Buffer vom Anfang an beschrieben wird. Es ist ein initiales
// Ereignis, und kein hinzufgen.
// Der Sinn der Sache: Wenn der Lastausgleich und der reverse Lastausgleich nach Westen beide packen, wird fr den
// Lastausgleich bilde_west_vektoren und fr den Reversen Lastausgleich bilde_west_vektoren_hinzu aufgerufen,
// sodass beides zusammengepackt wird.
void ExtremeVektoren::bilde_west_vektoren(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
// Kommentar: Fhre die Bildung der Vektoren in Ebene h_LA durch mit der Punktegewichtung 0 am Rand.
        bilde_west_vektoren_mit_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    else
        {
// Kommentar: Fhre die Bildung der Vektoren in Ebene h_LA durch mit berall gleichem Punktgewicht.
        bilde_west_vektoren_ohne_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    }

// Kommentar: Fr einen Lasttransfer nach Westen werden die Vektoren einer Ebene bestimmt, und in
// mv_vertikal der Ebene mit der Nummer des bergabeparameters h_LA eingefgt - unter gleichzeitigem Entfernen
// aus dieser einen Ebene. Je nach Wert von lastwert_korrektur wird dabei ebensolche gemacht oder nicht.
// Das da hinzu steht, bedeutet, dass der Buffer nicht vom Anfang an beschrieben wird, sondern seine
// Addresse fortgefhrt wird. Es ist kein initiales Ereignis, und sondern ein hinzufgen. Warum, vgl. den
// Kommentar zu bilde_west_vektoren - Sinn der Sache.
void ExtremeVektoren::bilde_west_vektoren_hinzu(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
// Kommentar: Fhre die Bildung der Vektoren in Ebene h_LA durch mit der Punktegewichtung 0 am Rand - mit Fortfhrung
// eines schon beschriebenen Buffers.
        bilde_west_vektoren_hinzu_mit_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    else
        {
// Kommentar: Fhre die Bildung der Vektoren in Ebene h_LA durch mit berall gleichem Punktgewicht - mit Fortfhrung
// eines schon beschriebenen Buffers.
        bilde_west_vektoren_hinzu_ohne_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    }

// Kommentar: Vergleiche bilde_west_vektoren.
void ExtremeVektoren::bilde_ost_vektoren(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
        bilde_ost_vektoren_mit_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    else
        {
        bilde_ost_vektoren_ohne_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    }

// Kommentar: Vergleiche bilde_west_vektoren_hinzu.
void ExtremeVektoren::bilde_ost_vektoren_hinzu(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
        bilde_ost_vektoren_hinzu_mit_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    else
        {
        bilde_ost_vektoren_hinzu_ohne_lw_k(gesamtlast, mv_vertikal, h_LA);
        }
    }

// Kommentar: Vergleiche bilde_west_vektoren.
void ExtremeVektoren::bilde_nord_vektoren(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
        bilde_nord_vektoren_mit_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    else
        {
        bilde_nord_vektoren_ohne_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    }

// Kommentar: Vergleiche bilde_west_vektoren_hinzu.
void ExtremeVektoren::bilde_nord_vektoren_hinzu(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
        bilde_nord_vektoren_hinzu_mit_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    else
        {
        bilde_nord_vektoren_hinzu_ohne_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    }

// Kommentar: Vergleiche bilde_west_vektoren.
void ExtremeVektoren::bilde_sued_vektoren(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
        bilde_sued_vektoren_mit_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    else
        {
        bilde_sued_vektoren_ohne_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    }

// Kommentar: Vergleiche bilde_west_vektoren_hinzu.
void ExtremeVektoren::bilde_sued_vektoren_hinzu(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    if(lastwert_korrektur == true)
        {
        bilde_sued_vektoren_hinzu_mit_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    else
        {
        bilde_sued_vektoren_hinzu_ohne_lw_k(gesamtlast, mv_horizontal, h_LA);
        }
    }

// Kommentar: Es werden nach Westen zu transferierende Vektoren bestimmt, wobei alle Punkte gleich gewichtet werden.
// Mit dem Terminus 'hinzu' werden diese Informationen an einen entsprechenden Buffer angehngt, die
// Bufferlnge wird gelesen (und spter geschrieben). Der Sinn dabei: s.o..
inline void ExtremeVektoren::bilde_west_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
// Diese Vektoren werden angehngt: Das ist der Unterschied zu bilde_west_vektoren
    {
// Kommentar: Die zu entfernende gesamtlast wird in die Variable Restlast kopiert-
    restlast = gesamtlast;

//    west_vektoranzahl = 0;

// Kommentar: Die Vektoren nebst ihrer Anzahl werden gelesen.
    buffer_laenge = mv_vertikal->indizes[h_LA];
    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];

// Kommentar: Solange noch Last zu packen ist.
    for(;restlast>0;)
        {
// Kommentar: Finde einen westlichsten Vektor, der die maximale Last 'restlast' besitzt.
        finde_westlichsten_vektor(restlast);
// Kommentar: ndere den Wert Restlast entsprechend ab, so dass er aktuell ist.
        restlast = restlast + vvektor_f1 - vvektor_f2-1;

// Kommentar: Entferne die Punkte dieses Vektors aus der Klasse Strategie.
        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt? Das hat sich erledigt, 4.5.15.
// Kommentar: Der Vektor wird in den Buffer eingetragen, damit mv_vertikal ihn aufnimmt, mit allen Konsequenzen, die das
// hat einschlielich des Einfgens auf dem Zielkern
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
        buffer_laenge++;

//        west_vektoranzahl ++;
        }
//    buffer[0] = west_vektoranzahl;
// Kommentar: Wieviel Buffer beschrieben wurde wird jetzt gespeichert.
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Es werden nach Westen zu transferierende Vektoren bestimmt, wobei alle Punkte gleich gewichtet werden.
// Ohne den Terminus 'hinzu' werden diese Informationen direkt an den Anfang des Buffers geschrieben. Der Sinn dabei: s.o..
// Zu den Kommentaren im Code: Ganz analog zu denen in 'bilde_west_vektoren_hinzu_ohne_lw_k', siehe die vorangehende Funktion.
inline void ExtremeVektoren::bilde_west_vektoren_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
    restlast = gesamtlast;

//    west_vektoranzahl = 0;

    buffer_laenge = 0;
    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];



    for(;restlast>0;)
        {
        finde_westlichsten_vektor(restlast);
        restlast = restlast + vvektor_f1 - vvektor_f2-1;

        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
        buffer_laenge++;
        }
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog zu bilde_west_vektoren_ohne_lw_k!
inline void ExtremeVektoren::bilde_ost_vektoren_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
#ifdef AUSGABEN_EXTREME_VEKTOREN
    cout << "Bilde ost Vektoren " << endl;
#endif
    ausgeben(); // Gibt die Werte der Klasse Strategie aus!
    restlast = gesamtlast;

    buffer_laenge = 0;

    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];

    for(;restlast>0;)
        {
        finde_oestlichsten_vektor(restlast);
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
#endif
        restlast = restlast + vvektor_f1 - vvektor_f2 -1;
        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << "OST_VEKTOREN " << vvektor_f1 << " " << vvektor_f2 << " " << vvektor_g << endl;
#endif
        buffer_laenge++;
        }
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Ganz analog zu bilde_west_vektoren_hinzu_ohne_lw_k!
inline void ExtremeVektoren::bilde_ost_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
#ifdef AUSGABEN_EXTREME_VEKTOREN
    cout << "Bilde ost Vektoren " << endl;
#endif
    ausgeben(); // Gibt die Werte der Klasse Strategie aus!
    restlast = gesamtlast;

//    ost_vektoranzahl = 0;

//    buffer_laenge = 1;

    buffer_laenge = mv_vertikal->indizes[h_LA];

    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];

    for(;restlast>0;)
        {
        finde_oestlichsten_vektor(restlast);
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
#endif
        restlast = restlast + vvektor_f1 - vvektor_f2 -1;
        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << "OST_VEKTOREN " << vvektor_f1 << " " << vvektor_f2 << " " << vvektor_g << endl;
#endif
        buffer_laenge++;
        }
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Ganz analog zu bilde_west_vektoren_ohne_lw_k!
inline void ExtremeVektoren::bilde_nord_vektoren_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    restlast = gesamtlast;

//    west_vektoranzahl = 0;

    buffer_laenge = 0;
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];



    for(;restlast>0;)
        {
        finde_noerdlichsten_vektor(restlast);
        restlast = restlast + hvektor_g1 - hvektor_g2-1;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;
        }
    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Ganz analog zu bilde_west_vektoren_hinzu_ohne_lw_k!
inline void ExtremeVektoren::bilde_nord_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    restlast = gesamtlast;

    buffer_laenge = mv_horizontal->indizes[h_LA];
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];



    for(;restlast>0;)
        {
        finde_noerdlichsten_vektor(restlast);
        restlast = restlast + hvektor_g1 - hvektor_g2-1;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;
        }
    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Ganz analog zu bilde_west_vektoren_ohne_lw_k!
inline void ExtremeVektoren::bilde_sued_vektoren_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    restlast = gesamtlast;

    buffer_laenge = 0;
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];



    for(;restlast>0;)
        {
        finde_suedlichsten_vektor(restlast);
        restlast = restlast + hvektor_g1 - hvektor_g2-1;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;
        }
    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Ganz analog zu bilde_west_vektoren_hinzu_ohne_lw_k!
inline void ExtremeVektoren::bilde_sued_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
    restlast = gesamtlast;

    buffer_laenge = mv_horizontal->indizes[h_LA];
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];



    for(;restlast>0;)
        {
        finde_suedlichsten_vektor(restlast);
        restlast = restlast + hvektor_g1 - hvektor_g2-1;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;
        }
    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Ganz analog zu entferne_ebene, nur Nord - Sd statt West - Ost.
void ExtremeVektoren::entferne_ebene_ns(MV_horizontal * mv_horizontal, int ebene)
    {
    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];

    for(i=0; i<index; i++)
        {
        hvektor_g1 = g1[i];
        hvektor_g2 = g2[i];
        hvektor_f = f[i];

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            entfernen(hvektor_f, j);
            }
        }
    }

// Kommentar: Ganz analog zu einfgen_ebene, nur Nord - Sd statt West - Ost.
void ExtremeVektoren::einfuegen_ebene_ns(MV_horizontal * mv_horizontal, int ebene)
    {
    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];

    for(i=0; i<index; i++)
        {
        hvektor_g1 = g1[i];
        hvektor_g2 = g2[i];
        hvektor_f = f[i];

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            einfuegen(hvektor_f, j);
            }
        }
    }

// Kommentar: Die Merkfelder werden benutzt bei der Lastwertekorrektur, um zu erkennen, ob ein Punkt am Rand oder im Inneren liegt.
// Dementsprechend muss ein solches Merkfeld fr diese Gitterebene bergeben werden. Es wird dann in die eindimensionalen
// Feldliste kopiert, damit diese Informationen dort abgelesen werden knnen.
void ExtremeVektoren::initialisieren_merkfeld(short int ** _feld, bool _lastwert_korrektur)
    {
    feld = _feld;
    lastwert_korrektur = _lastwert_korrektur;
    for(i=0; i<n; i++)
        {
        west_ost[i].merkfeld = feld;
        west_ost[i].eigener_index = i;
        west_ost[i].HR = WEST_OST;
        }
    for(i=0; i<m; i++)
        {
        nord_sued[i].merkfeld = feld;
        nord_sued[i].eigener_index = i;
        nord_sued[i].HR = NORD_SUED;
        }
    }

// Kommentar: Hier werden die Vektoren bestimmt, wobei die Lasten am Rand mit gewichtet werden. Wegen 'hinzu'
// werden die Vektoren angehngt, damit, wenn wegen dem reversen Lastausgleich auf zwei Ebenen gleichzeitig
// nach Westen verschickt wird, das zweite Schicken 'hinzugefgt' werden kann.
inline void ExtremeVektoren::bilde_west_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
// Diese Vektoren werden angehngt: Das ist der Unterschied zu bilde_west_vektoren
    {
#ifdef AUSGABE_LWK
    cout << " bilde_west_vektoren_hinzu_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
// Kommentar: Der Wert fr die Restlast wird auf den Wert des bergabeparameters gesetzt.
    restlast = gesamtlast;

// Kommentar: Die eindim. Felder der vertikalen Vektoren plus ihrer Anzahl werden gelesen.
    buffer_laenge = mv_vertikal->indizes[h_LA];
    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];

// Kommentar: Bis zum '#else' liegt alter Programmcode vor => nicht kommentieren.
#ifdef ALTES_LWK
#else
// Kommentar: Falls das LWK gewhlt wird, wo nur Vollpunkte genommen werden, d.h. Randpunkte erst gar nicht gewhlt werden,
// wird 'bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt' aufgerufen. Da die Randpunkte vorher auch nicht gezhlt wurden,
// ist nie mehr Restlast da, als Innenpunkte da sind.
    if(lwk_vollpunkt == true)
        {
#ifdef AUSGABE_LWK
        cout << " bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt mit hinzu rang " << rang << endl;
#endif
        bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_vertikal->indizes[h_LA] = buffer_laenge;
        return;
        }
// Kommentar: Ansonsten wird ein Lastausgleich mit Randpunkten gemacht, deren Last aber mit 0 gezhlt wird.
// Man arbeitet, bis die Restlast auf 0 ist.
    for(;restlast>0;)
        {
#ifdef AUSGABE_LWK
        cout << " finde_westlichsten_vektor_lwk hinzu restlast " << restlast << endl;
#endif
// Kommentar: Man sucht eines westlichsten Vektor, dessen Innenpunkte maximal die Anzahl Restlast haben.
        finde_westlichsten_vektor_lwk(restlast);
#ifdef AUSGABE_LWK
        cout << " hinzu f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << " lastabzug " << lastabzug << endl;
#endif
// Kommentar: Die Anzahl an nicht - Randpunkten dieses Vektors ist 'lastabzug'. Das wird von der Variablen
// 'restlast' abgezogen.
        restlast -= lastabzug;

// Kommentar: Der Vektor wird aus der Klasse Strategie entfernt.
        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt? Nein. 4.5.15.

// Kommentar: Der Vektor wird in den Buffer eingetragen, damit mv_vertikal ihn aufnimmt, mit allen Konsequenzen, die das
// hat einschlielich des Einfgens auf dem Zielkern
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
        buffer_laenge++;
        }
#endif
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Hier werden die Vektoren bestimmt, wobei die Lasten am Rand mit gewichtet werden. Ohne den Terminus 'hinzu'
// werden die Vektoren nicht angehngt. Sollte wegen dem reversen Lastausgleich auf zwei Ebenen gleichzeitig
// nach Westen verschickt werden, dann erfolgt das Einfgen in den Buffer hier als erster Schritt, weil
// die Variable Bufferlange so gewhlt wird, dass auf dem Anfang des mv-vertikal - Buffers eingefgt wird.
inline void ExtremeVektoren::bilde_west_vektoren_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_west_vektoren_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
// Kommentar: Der Wert Restlast wird vom bergabeparameter bernommen.
    restlast = gesamtlast;

// Kommentar: Die Bufferlnge dieser Ebene wird zurckgesetzt,
    buffer_laenge = 0;
// Kommentar: Alle weiteren Schritte dieser Funktion: vgl. 'bilde_west_vektoren_hinzu_mit_lw_k'.
    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];


#ifdef ALTES_LWK
#else
    if(lwk_vollpunkt == true)
        {
#ifdef AUSGABE_LWK
        cout << " bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt rang " << rang << endl;
#endif
        bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_vertikal->indizes[h_LA] = buffer_laenge;
        return;
        }
    for(;restlast>0;)
        {
        finde_westlichsten_vektor_lwk(restlast);
        restlast -= lastabzug;

        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
        buffer_laenge++;
        }
#endif
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog dem Fall 'bilde_west_vektoren_mit_lw_k'.
inline void ExtremeVektoren::bilde_ost_vektoren_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_ost_vektoren_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
#ifdef AUSGABEN_EXTREME_VEKTOREN
    cout << "Bilde ost Vektoren " << endl;
#endif
    ausgeben(); // Gibt die Werte der Klasse Strategie aus!
    restlast = gesamtlast;

    buffer_laenge = 0;

    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];

#ifdef ALTES_LWK
#else
    if(lwk_vollpunkt == true)
        {
#ifdef AUSGABE_LWK
        cout << " bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt rang " << rang << endl;
#endif
        bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_vertikal->indizes[h_LA] = buffer_laenge;
        return;
        }
    for(;restlast>0;)
        {
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << "Restlast " << restlast << endl;
#endif
        vvektor_f1 = 888;
        if(rang==13)
            {
            cout << " LLMMNN restlast " << restlast << " gesamtpunkteanzahl " << gesamtpunkteanzahl << endl;
            }
#endif
        finde_oestlichsten_vektor_lwk(restlast);
#ifdef AKTUELLE_KOMMENTARE
        if(rang==13)
            {
            cout << " Nach LLMMNN restlast " << restlast << " gesamtpunkteanzahl " << gesamtpunkteanzahl << endl;
            }
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
#endif
        restlast -= lastabzug;
        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << "OST_VEKTOREN " << vvektor_f1 << " " << vvektor_f2 << " " << vvektor_g << endl;
#endif
        buffer_laenge++;
        }
#endif
    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog dem Fall 'bilde_west_vektoren_hinzu_mit_lw_k'.
inline void ExtremeVektoren::bilde_ost_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_ost_vektoren_hinzu_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
#ifdef AUSGABEN_EXTREME_VEKTOREN
    cout << "Bilde ost Vektoren " << endl;
#endif
    ausgeben(); // Gibt die Werte der Klasse Strategie aus!
    restlast = gesamtlast;

    buffer_laenge = mv_vertikal->indizes[h_LA];

    f1 = mv_vertikal->f1_speichern[h_LA];
    f2 = mv_vertikal->f2_speichern[h_LA];
    g = mv_vertikal->g_speichern[h_LA];

#ifdef ALTES_LWK
#else
    if(lwk_vollpunkt == true)
        {
#ifdef AUSGABE_LWK
        cout << " bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt bei hinzu rang " << rang << endl;
#endif
        bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_vertikal->indizes[h_LA] = buffer_laenge;
        return;
        }
    for(;restlast>0;)
        {
        finde_oestlichsten_vektor_lwk(restlast);
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
#endif
        restlast -= lastabzug;
        for(i=vvektor_f1; i<=vvektor_f2; i++)
            {
            entfernen(i,vvektor_g);
            }
        f1[buffer_laenge] = vvektor_f1;
        f2[buffer_laenge] = vvektor_f2;
        g[buffer_laenge] = vvektor_g;
#ifdef AUSGABEN_EXTREME_VEKTOREN
        cout << "OST_VEKTOREN " << vvektor_f1 << " " << vvektor_f2 << " " << vvektor_g << endl;
#endif
        buffer_laenge++;
        }
#endif

    mv_vertikal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog dem Fall 'bilde_west_vektoren_mit_lw_k'.
inline void ExtremeVektoren::bilde_nord_vektoren_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_nord_vektoren_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
    restlast = gesamtlast;

    buffer_laenge = 0;
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];

#ifdef ALTES_LWK

#else
    if(lwk_vollpunkt == true)
        {
        bilde_nord_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_horizontal->indizes[h_LA] = buffer_laenge;
        return;
        }

    for(;restlast>0;)
        {
        finde_noerdlichsten_vektor_lwk(restlast);

        restlast -= lastabzug;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;
        }

#endif
    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog dem Fall 'bilde_west_vektoren_hinzu_mit_lw_k'.
inline void ExtremeVektoren::bilde_nord_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_nord_vektoren_hinzu_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
    restlast = gesamtlast;

    buffer_laenge = mv_horizontal->indizes[h_LA];
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];

#ifdef ALTES_LWK
#else
    if(lwk_vollpunkt == true)
        {
        bilde_nord_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_horizontal->indizes[h_LA] = buffer_laenge;
        return;
        }
    for(;restlast>0;)
        {
        finde_noerdlichsten_vektor_lwk(restlast);
        restlast -= lastabzug;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;

        }
#endif

    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog dem Fall 'bilde_west_vektoren_mit_lw_k'.
inline void ExtremeVektoren::bilde_sued_vektoren_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_sued_vektoren_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
    restlast = gesamtlast;

    buffer_laenge = 0;
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];

#ifdef ALTES_LWK
#else
    if(lwk_vollpunkt == true)
        {
        bilde_sued_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_horizontal->indizes[h_LA] = buffer_laenge;
        return;
        }
    for(;restlast>0;)
        {
        finde_suedlichsten_vektor_lwk(restlast);
        restlast -= lastabzug;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;
        }

#endif

    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

// Kommentar: Analog dem Fall 'bilde_west_vektoren_hinzu_mit_lw_k'.
inline void ExtremeVektoren::bilde_sued_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA)
    {
#ifdef AUSGABE_LWK
    cout << " bilde_sued_vektoren_hinzu_mit_lw_k rang " << rang << " gesamtlast " << gesamtlast << endl;
#endif
    restlast = gesamtlast;

    buffer_laenge = mv_horizontal->indizes[h_LA];
    g1 = mv_horizontal->g1_speichern[h_LA];
    g2 = mv_horizontal->g2_speichern[h_LA];
    f = mv_horizontal->f_speichern[h_LA];

#ifdef ALTES_LWK
#else
    if(lwk_vollpunkt == true)
        {
        bilde_sued_vektoren_hinzu_mit_lwk_und_vollpunkt();
        mv_horizontal->indizes[h_LA] = buffer_laenge;
        return;
        }
    for(;restlast>0;)
        {
        finde_suedlichsten_vektor_lwk(restlast);
        restlast -= lastabzug;

        for(i=hvektor_g1; i<=hvektor_g2; i++)
            {
            entfernen(hvektor_f, i);
            }
// Das verstehe ich nicht: wird der Vektor damit nicht doppelt entfernt?
        g1[buffer_laenge] = hvektor_g1;
        g2[buffer_laenge] = hvektor_g2;
        f[buffer_laenge] = hvektor_f;
        buffer_laenge++;

        }

#endif

    mv_horizontal->indizes[h_LA] = buffer_laenge;
    }

//////////////////////////////////////////////////////
///////           Die Vollpunkte - Version    ////////
//////////////////////////////////////////////////////


//////////////////////////////////////////////////////
////////  Funktionen mit Vollpunkten     /////////////
//////////////////////////////////////////////////////

// Kommentar: Hier wird die LwK - Vektorensuche gemacht, die sich daran orentiert, Randpunkte gar nicht zu
// verschicken. Zu dem 'Terminus' hinzu: vgl. 'bilde_west_vektoren_hinzu_mit_lw_k'.
inline void ExtremeVektoren::bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt(void)
    {
#ifdef AUSGABE_LWK
    cout << " restlast beginn " << restlast << " rang " << rang << endl;
#endif
// Kommentar: Fr die westlichsten Vektoren werden Vektoren mit nur Innenpunkten gesucht. Ggf. wird dafr mehr als
// eine Spalte gebraucht.
    for(west_laenge = minimale_spalte; restlast > 0; west_laenge++)
        {
// Kommentar: Der Anfang der gewhlten Spalte wird gewhlt
        for(nord_sued[west_laenge].anfangsposition();restlast>0;)
            {
//            flag_merken = nord_sued[west_laenge].vektorbildung_weiter_lwk_vollpunkt_WO(restlast);
// Kommentar: Ein Nord - Sd - Vektor mit einer Lnge von maximal der restlast mit nur Innenpunkten wird gewhlt.
            flag_merken = nord_sued[west_laenge].vektorbildung_weiter_lwk_vollpunkt_NS(restlast);
// Kommentar: Entsprechend der Funktion 'FeldListe1DMf::search_weiter_vollpunkt_NS' wird ein Innenpunkt gesucht, und der
// dann verlngert. Gibt es keinen Innenpunkt mehr, wird das bergebene flag false, womit die Schleife unterbrochen
// und die nchste Spalte ausgewhlt wird.
            if(flag_merken == false)
                {
                break;
                }
// Kommentar: Vektoranfang und - ende werden bestimmt, und der Vektor wird geschrieben.
            vektoranfang = nord_sued[west_laenge].vektoranfang;
            f1[buffer_laenge] = vektoranfang;
            vektorende = nord_sued[west_laenge].vektorende;
            f2[buffer_laenge] = vektorende;
            g[buffer_laenge++] = west_laenge;

// Kommentar: Die Restlast wird um die Anzahl der Vektorpunkt verringert.
            restlast = restlast + vektoranfang - vektorende -1;

#ifdef AUSGABE_LWK
            cout << " vektor vertikal f1 " << vektoranfang << " f2 " << vektorende << " g " << west_laenge << " restlast " << restlast << endl;
#endif

// Kommentar: Der Vektor wird aus der Klasse Strategie entfernt.
            for(i=vektoranfang; i<=vektorende; i++)
                {
                entfernen(i, west_laenge);
                }
            }
        }
    }

// Kommentar: Hier wird die LwK - Vektorensuche gemacht, die sich daran orentiert, Randpunkte gar nicht zu
// verschicken. Das der 'Terminus' hinzu fehlt: vgl. 'bilde_west_vektoren'.
inline void ExtremeVektoren::bilde_west_vektoren_mit_lwk_und_vollpunkt(void)
    {
    buffer_laenge = 0;
    bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt();
    }

inline void ExtremeVektoren::bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt(void)
    {
#ifdef AUSGABE_LWK
    cout << " restlast beginn " << restlast << " rang " << rang << endl;
#endif
    for(ost_laenge = maximale_spalte; restlast > 0; ost_laenge--)
        {
        for(nord_sued[ost_laenge].anfangsposition();restlast>0;)
            {
            flag_merken = nord_sued[ost_laenge].vektorbildung_weiter_lwk_vollpunkt_NS(restlast);
            if(flag_merken == false)
                {
                break;
                }
            vektoranfang = nord_sued[ost_laenge].vektoranfang;
            f1[buffer_laenge] = vektoranfang;
            vektorende = nord_sued[ost_laenge].vektorende;
            f2[buffer_laenge] = vektorende;
            g[buffer_laenge++] = ost_laenge;
            restlast = restlast + vektoranfang - vektorende - 1;
#ifdef AUSGABE_LWK
            cout << " vektor vertikal f1 " << vektoranfang << " f2 " << vektorende << " g " << ost_laenge << " restlast " << restlast << endl;
#endif
            for(i=vektoranfang; i<=vektorende; i++)
                {
                entfernen(i, ost_laenge);
                }
            }
        }
    }

// Kommentar: Analog zu bilde_west_vektoren_mit_lwk_und_vollpunkt.
inline void ExtremeVektoren::bilde_ost_vektoren_mit_lwk_und_vollpunkt(void)
    {
    buffer_laenge = 0;
    bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt();
    }

// Kommentar: Analog zu bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt.
inline void ExtremeVektoren::bilde_nord_vektoren_hinzu_mit_lwk_und_vollpunkt(void)
    {
#ifdef AUSGABE_LWK
    cout << " restlast beginn " << restlast << " rang " << rang << endl;
#endif
    for(nord_laenge = minimale_zeile; restlast > 0; nord_laenge++)
        {
        for(west_ost[nord_laenge].anfangsposition();restlast>0;)
            {
            flag_merken = west_ost[nord_laenge].vektorbildung_weiter_lwk_vollpunkt_WO(restlast);
            if(flag_merken == false)
                {
                break;
                }
            vektoranfang = west_ost[nord_laenge].vektoranfang;
            g1[buffer_laenge] = vektoranfang;
            vektorende = west_ost[nord_laenge].vektorende;
            g2[buffer_laenge] = vektorende;
            f[buffer_laenge++] = nord_laenge;

            restlast = restlast + vektoranfang - vektorende - 1;

#ifdef AUSGABE_LWK
            cout << " vektor horizontal f " << nord_laenge << " g1 " << vektoranfang << " g2 " << vektorende << " restlast " << restlast << endl;
#endif

            for(i=vektoranfang; i<= vektorende; i++)
                {
                entfernen(nord_laenge, i);
                }
            }
        }
    }

// Kommentar: Analog zu bilde_west_vektoren_mit_lwk_und_vollpunkt.
inline void ExtremeVektoren::bilde_nord_vektoren_mit_lwk_und_vollpunkt(void)
    {
    buffer_laenge = 0;
    bilde_nord_vektoren_hinzu_mit_lwk_und_vollpunkt();
    }

// Kommentar: Analog zu bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt.
inline void ExtremeVektoren::bilde_sued_vektoren_hinzu_mit_lwk_und_vollpunkt(void)
    {
#ifdef AUSGABE_LWK
    cout << " restlast beginn " << restlast << " rang " << rang << endl;
#endif
    for(sued_laenge = maximale_zeile; restlast > 0; sued_laenge--)
        {
        for(west_ost[sued_laenge].anfangsposition();restlast>0;)
            {
            flag_merken = west_ost[sued_laenge].vektorbildung_weiter_lwk_vollpunkt_WO(restlast);
            if(flag_merken == false)
                {
                break;
                }
            vektoranfang = west_ost[sued_laenge].vektoranfang;
            g1[buffer_laenge] = vektoranfang;
            vektorende = west_ost[sued_laenge].vektorende;
            g2[buffer_laenge] = vektorende;
            f[buffer_laenge++] = sued_laenge;

            restlast = restlast + vektoranfang - vektorende - 1;

#ifdef AUSGABE_LWK
            cout << " vektor horizontal f " << sued_laenge << " g1 " << vektoranfang << " g2 " << vektorende << " restlast " << restlast << endl;
#endif

            for(i=vektoranfang; i<= vektorende; i++)
                {
                entfernen(sued_laenge, i);
                }
            }
        }
    }

// Kommentar: Analog zu bilde_west_vektoren_mit_lwk_und_vollpunkt.
inline void ExtremeVektoren::bilde_sued_vektoren_mit_lwk_und_vollpunkt(void)
    {
    buffer_laenge = 0;
    bilde_sued_vektoren_hinzu_mit_lwk_und_vollpunkt();
    }
