#ifndef EXTREME_VEKTOREN
#define EXTREME_VEKTOREN

#include "strategie.h"

#include "mv_vertikal.h"
#include "mv_horizontal.h"

#include "ausgaben.h"

class ExtremeVektoren : virtual public Strategie
    {
public:
    void bilde_west_vektoren(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
    void bilde_ost_vektoren(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
    void bilde_nord_vektoren(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
    void bilde_sued_vektoren(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);

    void bilde_west_vektoren_hinzu(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
    void bilde_ost_vektoren_hinzu(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
    void bilde_nord_vektoren_hinzu(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
    void bilde_sued_vektoren_hinzu(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);

inline    void bilde_west_vektoren_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_ost_vektoren_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_nord_vektoren_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
inline    void bilde_sued_vektoren_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);

inline    void bilde_west_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_ost_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_nord_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
inline    void bilde_sued_vektoren_hinzu_mit_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);

inline    void bilde_west_vektoren_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_ost_vektoren_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_nord_vektoren_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
inline    void bilde_sued_vektoren_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);

inline    void bilde_west_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_ost_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_vertikal * mv_vertikal, int h_LA);
inline    void bilde_nord_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
inline    void bilde_sued_vektoren_hinzu_ohne_lw_k(int gesamtlast, MV_horizontal * mv_horizontal, int h_LA);
private:
    int restlast, gesamtlast;
    int buffer_laenge;
    int west_vektorenzahl;
    int i, j;
    int * f1, * f2, * g;
    int * g1, * g2, * f;
    int index;
public:
    void entferne_ebene(MV_vertikal * mv_vertikal, int ebene);
    void einfuegen_ebene(MV_vertikal * mv_vertikal, int ebene);
    void entferne_ebene_ns(MV_horizontal * mv_horizontal, int ebene);
    void einfuegen_ebene_ns(MV_horizontal * mv_horizontal, int ebene);
public:
    void initialisieren_merkfeld(short int ** _feld, bool _lastwert_korrektur);
private:
    short int ** feld;
    int ii;
    bool lastwert_korrektur;
public:
    bool lwk_vollpunkt;
private:
    int west_laenge;
    int ost_laenge;
    int nord_laenge;
    int sued_laenge;
public:
    inline void bilde_west_vektoren_hinzu_mit_lwk_und_vollpunkt(void);
    inline void bilde_west_vektoren_mit_lwk_und_vollpunkt(void);
    inline void bilde_ost_vektoren_hinzu_mit_lwk_und_vollpunkt(void);
    inline void bilde_ost_vektoren_mit_lwk_und_vollpunkt(void);
    inline void bilde_nord_vektoren_hinzu_mit_lwk_und_vollpunkt(void);
    inline void bilde_nord_vektoren_mit_lwk_und_vollpunkt(void);
    inline void bilde_sued_vektoren_hinzu_mit_lwk_und_vollpunkt(void);
    inline void bilde_sued_vektoren_mit_lwk_und_vollpunkt(void);
private:
    bool flag_merken;
private:
    int vektoranfang, vektorende;
    };

#endif
