#include "farbenfeld_verschicken.h"

// Welches Farbenfeld wird verschickt? Das Normale, oder das von der Nachkorrektur?
// Wenn ich z.B. oben_west_senden anschaue tippe ich auf das normale Farbenfeld.

// Zu ep_aktuell verschicken: Ich brauche das wahrscheinlich nicht: Es geht um das genaue Timing:
// Es ist so: Auf Ebene k geschieht EP_bestimmen.
// Ja, das Problem besteht darin, dass ich ep_vergangen brauche, und sich das durch den Lastausgleich auf allen Ebenen
// verndert. Das Aktuelle wird ja vor der adaptiven Verfeinerung immer wieder berechnet. Ich muss das ganz genau
// berlegen, und danach dann umsetzen. Das Umsetzen ist vielleicht einfacher als das berlegen.

// Gut: Ich brauche nur EP_vergangen. Das auf dem Feld (muss mit bermittelt werden), und auch auf dem Rand.
// Also muss es mit bermittelt werden, und die nderungen mssen auch in f_vergangen und g_vergangen aufgenommen werden.
// Ich brauche also eine Verbindung von ep_s_bestimmen zu farbenfeld_verschicken.

// Aufgabe: vvektor_west... UND(!) vvektor_ost... verwenden.Beides bei packen ieS. Erledigt. Hoffentlich stimmt das auch.
// Denn. Der Index und Buffer kommt von mvf. Also egal, ob OSTEN oder WESTEN, also doppelt gemoppelt.
// Bei Nord Sued werde ich das nur einmal machen!
// Aufgabe: Nur fr den Bedarf von ep - Werten den ep - Transfer machen. Erledigt.

// Kommentar: Diese Klasse ist Teil der Migration, also der Klasse Lastausgleich. Hier geht es NICHT um die Zwischenkorrektur,
// sondern um das Umlaufen des Farbenfeldes beim ganz normalen Einpacken bzw. Auspacken eines Vektors.
// Wichtig ist hier aber das Testfeld: Man geht dabei davon aus, dass genau die Stellen von verschickten Punkten
// markiert sind, damit fr diese die Farbenfeldinformation weder gepackt noch entpackt wird! Vor dem
// aufrufen der Pack - und Entpackschritte muss daher dieses Testfeld korrekt markiert sein.
// Bemerkung: Hier geschieht nur das Umlaufen fr den Lasttransfer nach Westen und Osten, d.h. nur
// Nord - Sd - Vektoren werden hier umlaufen.

// Kommentar: Die Finalisierung des Testfeldes, d.h. dessen Speicherplatz wird freigegeben.
void FarbenfeldVerschicken::finalisieren_fv(void)
    {
    for(ii=0; ii<n; ii++)
        {
        delete testfeld[ii];
        }
    delete testfeld;
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
    delete f_merken;
    delete g_merken;
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
    }

// Kommentar: Die Initialisierung des Testfeldes, insbesondere die Allokation des Speichers fr das Testfeld.
void FarbenfeldVerschicken::initialisieren_fv(int _n, int _m)
    {

// Kommentar: Kopieren der bergabeparameter.
    n = _n;
    m = _m;

// Kommentar: Setzen von Parametern fr Testausgaben.
    test_f = 22;
    test_g = 7;
    test_rang = 10;
    test_rang = 14;

// Kommentar: Anlegen des m x n Testfeldes mit bool'schen oder Integer - Werten.
#ifdef KURZ_TESTFELD_FV
    testfeld = new bool * [n];
#else
    testfeld = new int * [n];
#endif
    for(ii=0; ii<n; ii++)
        {
#ifdef KURZ_TESTFELD_FV
        testfeld[ii] = new bool [m];
#else
        testfeld[ii] = new int [m];
#endif
// Kommentar: Reset des Testfeldes.
        for(jj=0; jj<m; jj++)
            {
            testfeld[ii][jj] = false;
            }
        }
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
    mn = m*n;
    f_merken = new short int [mn];
    g_merken = new short int [mn];
    index_merken = 0;
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
    }

// Kommentar: Der Vektor (_f1,_f2,_g) wird umlaufen. Nicht markierte Felder werden zum Senden eingepackt,
// wobei wegen 'mit_ep' auch markiert wird, wenn farbenfeld_vergangen - erkannt ber ep_update - true bzw.
// false war. Bei true wird dem Farbwert der Wert 512 hinzuddiert, und die EP+ Information auf hinweg, und EP- auf hinzu
// gesetzt, und feld_vergangen auf false.
// Wichtig: Wegen 'west' wird der Sendebuffer nach Westen beschrieben mit dem entsprechenden Index fr Westen.
// Sonst wrde nach Westen dasselbe passieren wie nach Osten.
void FarbenfeldVerschicken::vvektor_einfuegen_fv_west_senden_mit_ep(int _f1, int _f2, int _g)
    {
// Ich meine, mit rechts bis unten geschieht ein Umlauf um den Vektor
// Kommentar: Die bergabeparameter werden kopiert.
    f1 = _f1;
    f2 = _f2;
    g = _g;

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xi" << " rang " << rang << endl;
#endif

// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_mit_ep' fr den Vektor (f1-1,f2+1,g+1), also
// dem Vektor rechts.
    rechts_west_senden_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xii" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_mit_ep' fr den Vektor (f1-1,f2+1,g-1), also
// den Vektor links.
    links_west_senden_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xiii" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_mit_ep' fr den Punkt (f1-1,g), also den
// Punkt oben.
    oben_west_senden_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xiv" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_mit_ep' fr den Punkt (f2+1,g), also den
// Punkt unten.
    unten_west_senden_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xv" << " rang " << rang << endl;
#endif
    }

// Kommentar: Mache dasselbe wie bei 'vvektor_einfuegen_fv_west_senden_mit_ep', nur ohne ep-update->farbenfeld_vergangen
// sowie EP+ und EP- zu verndern. Das optionale ndern der Farbwerte in den Buffer um den Wert 512 entfllt hier auch.
// Es werden dieselben 4 Funktionen fr ein Umlaufen aufgerufen, nur mit dem Suffix 'ohne' statt mit.
void FarbenfeldVerschicken::vvektor_einfuegen_fv_west_senden_ohne_ep(int _f1, int _f2, int _g)
    {
// Ich meine, mit rechts bis unten geschieht ein Umlauf um den Vektor
// Kommentar: Die bergabeparameter werden kopiert.
    f1 = _f1;
    f2 = _f2;
    g = _g;

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xi" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_ohne_ep' fr den Vektor (f1-1,f2+1,g+1), also
// dem Vektor rechts.
    rechts_west_senden_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xii" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_ohne_ep' fr den Vektor (f1-1,f2+1,g-1), also
// den Vektor links.
    links_west_senden_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xiii" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_ohne_ep' fr den Punkt (f1-1,g), also den
// Punkt oben.
    oben_west_senden_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xiv" << " rang " << rang << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_senden_ohne_ep' fr den Punkt (f2+1,g), also den
// Punkt unten.
    unten_west_senden_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xv" << " rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu vvektor_einfuegen_fv_west_senden_mit_ep - nur mit dem sendenbuffer_osten statt sendebuffer_westen,
// sowie dem Index dazu.
void FarbenfeldVerschicken::vvektor_einfuegen_fv_ost_senden_mit_ep(int _f1, int _f2, int _g)
// Wird gar nicht verwendet! Warum? Man hat doch auch einen Sendebuffer fr den Transfer nach Osten.
    {
    f1 = _f1;
    f2 = _f2;
    g = _g;

    rechts_ost_senden_mit_ep();
    links_ost_senden_mit_ep();
    oben_ost_senden_mit_ep();
    unten_ost_senden_mit_ep();
    }

// Kommentar: Analog zu vvektor_einfuegen_fv_west_senden_ohne_ep - nur mit dem sendenbuffer_osten statt sendebuffer_westen,
// sowie dem Index dazu.
void FarbenfeldVerschicken::vvektor_einfuegen_fv_ost_senden_ohne_ep(int _f1, int _f2, int _g)
// Wird gar nicht verwendet! Warum? Man hat doch auch einen Sendebuffer fr den Transfer nach Osten.
    {
    f1 = _f1;
    f2 = _f2;
    g = _g;

    rechts_ost_senden_ohne_ep();
    links_ost_senden_ohne_ep();
    oben_ost_senden_ohne_ep();
    unten_ost_senden_ohne_ep();
    }

// Kommentar: Der Vektor (_f1,_f2,_g) wird umlaufen. Nicht markierte Felder(!) werden beim Empfangen ausgepackt,
// wobei ein Farbwert > 500 zum Schreiben des Farbwertes 'farbwert-512' fhrt, und zu nderungen in
// EP+ und EP-. Fr einen Farbwert < 500 wird nur dieser Farbwert geschrieben.
// Bemerkung Falls FELD_VERGANGEN_AENDERN definiert ist - ist es nicht - wird fr einen Farbwert > 500
// ep_update->vergangen_hinzu geschrieben, sonst ep_update->vergangen_hinweg.
// Wichtig: Wegen 'west' wird der Sendebuffer nach Westen beschrieben mit dem entsprechenden Index fr Westen.
// Sonst wrde nach Westen dasselbe passieren wie nach Osten.
void FarbenfeldVerschicken::vvektor_einfuegen_fv_west_empfangen_mit_ep(int _f1, int _f2, int _g)
    {
// Kommentar: Kopie der bergabeparameter.
    f1 = _f1;
    f2 = _f2;
    g = _g;

//    empfangsbuffer_west_laenge = empfangsbuffer_west[0] * 3 +1;
// Empfangsbuffer_west_laenge wird durch FarbenfelderVerschicken::entpacken bestimmt!
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c i alpha mit" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_mit_ep' fr den Vektor (f1-1,f2+1,g+1), also
// dem Vektor rechts
    rechts_west_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c ii beta mit" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_mit_ep' fr den Vektor (f1-1,f2+1,g-1), also
// den Vektor links.
    links_west_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c iii gamma mit" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_mit_ep' fr den Punkt (f1-1,g), also den
// Punkt oben.
    oben_west_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c iv delta mit" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_mit_ep' fr den Punkt (f2+1,g), also den
// Punkt unten.
    unten_west_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c v epsilon mit " << endl;
#endif
    }

// Kommentar: Mache dasselbe wie bei 'vvektor_einfuegen_fv_west_empfangen_mit_ep', nur ohne auf einen Farbwert > 500
// abzufragen - der wird nicht eintreten - sowie ohne irgendetwas zu tun auer den Farbwert zu ndern -
// insbesondere nicht fr EP+, EP- sowie ep_update.
// Es werden dieselben 4 Funktionen fr ein Umlaufen aufgerufen, nur mit dem Suffix 'ohne' statt mit.
void FarbenfeldVerschicken::vvektor_einfuegen_fv_west_empfangen_ohne_ep(int _f1, int _f2, int _g)
    {
// Kommentar: Kopiere die Vektorparameter
    f1 = _f1;
    f2 = _f2;
    g = _g;

//    empfangsbuffer_west_laenge = empfangsbuffer_west[0] * 3 +1;
// Empfangsbuffer_west_laenge wird durch FarbenfelderVerschicken::entpacken bestimmt!
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c i alpha" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_ohne_ep' fr den Vektor (f1-1,f2+1,g+1), also
// dem Vektor rechts
    rechts_west_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c ii beta" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_ohne_ep' fr den Vektor (f1-1,f2+1,g-1), also
// den Vektor links.
    links_west_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c iii gamma" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_ohne_ep' fr den Punkt (f1-1,g), also den
// Punkt oben.
    oben_west_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c iv delta" << endl;
#endif
// Kommentar: Mache die Schritte des Kommentars zu 'vvektor_einfuegen_fv_west_empfangen_ohne_ep' fr den Punkt (f2+1,g), also den
// Punkt unten.
    unten_west_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c v epsilon" << endl;
#endif
    }

// Kommentar: Vllig analog zu vvektor_einfuegen_fv_west_empfangen_mit_ep
void FarbenfeldVerschicken::vvektor_einfuegen_fv_ost_empfangen_mit_ep(int _f1, int _f2, int _g)
    {
// Warum wird das nicht gebraucht?
    f1 = _f1;
    f2 = _f2;
    g = _g;

//    empfangsbuffer_ost_laenge = empfangsbuffer_ost[0] * 3 +1;

// Empfangsbuffer_ost_laenge wird durch FarbenfelderVerschicken::entpacken bestimmt!
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "vvektor einfuegen ost rechts rang " << rang << endl;
#endif
    rechts_ost_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "vvektor einfuegen ost links rang " << rang << endl;
#endif
    links_ost_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "vvektor einfuegen ost oben rang " << rang << endl;
#endif
    oben_ost_empfangen_mit_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "vvektor einfuegen ost unten rang " << rang << endl;
#endif
    unten_ost_empfangen_mit_ep();
    }

// Kommentar: Vllig analog zu vvektor_einfuegen_fv_west_empfangen_ohne_ep
void FarbenfeldVerschicken::vvektor_einfuegen_fv_ost_empfangen_ohne_ep(int _f1, int _f2, int _g)
    {
// Warum wird das nicht gebraucht?
    f1 = _f1;
    f2 = _f2;
    g = _g;

//    empfangsbuffer_ost_laenge = empfangsbuffer_ost[0] * 3 +1;

// Empfangsbuffer_ost_laenge wird durch FarbenfelderVerschicken::entpacken bestimmt!
    rechts_ost_empfangen_ohne_ep();
    links_ost_empfangen_ohne_ep();
    oben_ost_empfangen_ohne_ep();
    unten_ost_empfangen_ohne_ep();

    }

// Kommentar: Der Gitterpunkt (f1-1,g) wird fr die Funktion vvektor_einfuegen_fv_west_senden_mit_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::oben_west_senden_mit_ep(void)
    {
// Kommentar: Wenn f1 = 0, dann ist nichts zu tun
    if(f1>0)
        {
// Kommentar: Ist das testfeld an dieser Stelle true, dann ist nichts zu tun, weil ein anderer Vektor dieses Feld berdeckt.
// Dort ist das Farbenfeld bekannt, und alles um EP+,EP- und farbenfeld vergangen wird dort direkt erledigt.
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(f1-1,g);
#endif
// Kommentar: Das Farbenfeld an dieser Stelle wird gelesen.
            ff = farbenfeld[f1-1][g]; // Man braucht das Farbenfeld doch fr alle Ebenen. Klappt auch, vgl. Farbenfelder verschicken::packen.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden oben west mit ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
// Kommentar: Ist feld_vergangen dort true?
            if(ep_update->feld_vergangen[f1-1][g]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden oben west mit ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff+512 << " m " << m << endl;
#endif
// Kommentar: Dann schreibe den Farbwert + 512 und - was momentan deaktiviert ist - ndere EP+ und EP- ab.
                sendebuffer_west[sendebuffer_west_laenge] = ff+512;
                sendebuffer_west_laenge ++;
                packen_ep_plus_minus_mit_ep(f1-1, g);
                }
            else
                {
// Kommentar: Ansonsten schreibe den Farbwert selber.
                sendebuffer_west[sendebuffer_west_laenge] = ff;
                sendebuffer_west_laenge ++;
                }
            }
        }
    }

// Kommentar: Analog zu 'oben_west_senden_mit_ep'.
void FarbenfeldVerschicken::oben_ost_senden_mit_ep(void)
    {
    if(f1>0)
        {
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(f1-1,g);
#endif
            ff = farbenfeld[f1-1][g];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden oben ost mit ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[f1-1][g]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden oben ost mit ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer_ost[sendebuffer_ost_laenge] = ff+512;
                sendebuffer_ost_laenge ++;
                packen_ep_plus_minus_mit_ep(f1-1, g);
                }
            else
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                sendebuffer_ost_laenge ++;
                }
            }
        }
    }

// Kommentar: Analog zu 'oben_west_senden_mit_ep'.
void FarbenfeldVerschicken::unten_west_senden_mit_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(f2+1,g);
#endif
            ff = farbenfeld[f2+1][g];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden unten west mit ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[f2+1][g]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden unten west mit ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer_west[sendebuffer_west_laenge] = ff + 512;
                packen_ep_plus_minus_mit_ep(f2+1, g);
                }
            else
                {
                sendebuffer_west[sendebuffer_west_laenge] = ff;
                }
            sendebuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'oben_west_senden_mit_ep'.
void FarbenfeldVerschicken::unten_ost_senden_mit_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(f2+1,g);
#endif
            ff = farbenfeld[f2+1][g];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden unten ost mit ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[f2+1][g]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden unten ost mit ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer_ost[sendebuffer_ost_laenge] = ff + 512;
                packen_ep_plus_minus_mit_ep(f2+1, g);
                }
            else
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                }
            sendebuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Die Gitterpunkte des NS - Vektors(f1-1,f2+1,g+1) werden fr die Funktion vvektor_einfuegen_fv_west_senden_mit_ep
// abgehandelt, vgl. den Kommentar dort.
void FarbenfeldVerschicken::rechts_west_senden_mit_ep(void)
    {
// Kommentar: Die drei Vektorparameter werden gespeichert.
    a = f1-1;
    b = f2+1;
    c = g+1;
// Kommentar: Ist der Vektor nicht mehr Teil des Gitters => Funktion beenden.
    if(c==m)
        {
        return;
        }
// Kommentar: Ist der Vektor oben nicht mehr Teil des Gitters => setze oben auf 0
    if(a==-1)
        {
        a = 0;
        }
// Kommentar: Ist der Vektor unten nicht mehr Teil des Gitters => setze unten auf n-1 (letzte Zeile).
    if(b==n)
        {
        b = n-1;
        }

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xi a " << a << " b " << b << " c " << c << " m " << m << " n " << n << endl;
#endif

// Durchlaufe die Vektorkoordinaten
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2020xi 1" << endl;
#endif
// Kommentar: Ist das testfeld an dieser Stelle true, dann ist fr diesen Punkt (ii,c) nichts zu tun, weil ein anderer
// Vektor dieses Feld berdeckt.
// Dort ist das Farbenfeld bekannt, und alles um EP+,EP- und farbenfeld vergangen wird dort direkt erledigt.
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2020xi 2" << endl;
#endif
// Kommentar: Das Farbenfeld an dieser Stelle wird gelesen.
            ff = farbenfeld[ii][c];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2020xi 3 ff " << ff << " ii " << ii << " c " << c << endl;
            cout << "!2020xi 3.5 ep_update->feld_vergangen[ii][c] " << ep_update->feld_vergangen[ii][c] << endl;
            cout << "xxxx senden rechts west mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif

//            if((ff>=0)&&(ep_aktuell[i][c]==true))   // Welches ep_aktuell ist damit gemeint? Das der Eigenschaftspunkte.
                                                    // Aber: Die mssen mitverschickt werden, aber nicht auf dem ueren Rand.
                                                    // Und das Farbenfeld muss nur auf dem ueren Rand verschickt werden,
                                                    // weil es fr alle zu verschickenden Punkte eine eindeutige Farbe haben
                                                    // - den des empfangenden Prozessors. Denn: EP - Randaustausch erfolgt
                                                    // vor jeder Verfeinerung. Aber: Was ist mit EP_vergangen?
                                                    // Da ich ep_vergangen brauche - auch auf dem Rand - mte ep_aktuell mit
                                                    // bertragen werden.
// Kommentar: Ist feld_vergangen dort true?
            if(ep_update->feld_vergangen[ii][c]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "!2020xi 4" << endl;
                cout << "xxxx senden rechts west mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff+512 << " m " << m << endl;
#endif
// Kommentar: Dann schreibe den Farbwert + 512 und - was momentan deaktiviert ist - ndere EP+ und EP- ab.
                sendebuffer_west[sendebuffer_west_laenge] = ff+512;
                packen_ep_plus_minus_mit_ep(ii, c);
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "!2020xi 5" << endl;
#endif
                }
            else
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "!2020xi 6" << endl;
#endif
// Kommentar: Ansonsten schreibe nur den Farbwert.
                sendebuffer_west[sendebuffer_west_laenge] = ff;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "!2020xi 7" << endl;
#endif
                }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2020xi 8" << endl;
#endif
// Kommentar: Gehe zum nchsten Bufferelement.
            sendebuffer_west_laenge ++;
            }
        }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xi Ende" << endl;
#endif
    }

// Kommentar: Analog zu 'rechts_west_senden_mit_ep'.
void FarbenfeldVerschicken::rechts_ost_senden_mit_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g+1;
    if(c==m)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(ii,c);
#endif
//            sendebuffer_ost[sendebuffer_ost_laenge] = farbenfeld[i][c];
            ff = farbenfeld[ii][c];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[ii][c]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer_ost[sendebuffer_ost_laenge] = ff+512;
                packen_ep_plus_minus_mit_ep(ii, c);
                }
            else
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                }
            sendebuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_senden_mit_ep'.
void FarbenfeldVerschicken::links_west_senden_mit_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(ii,c);
#endif
            ff = farbenfeld[ii][c];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links west mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[ii][c]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden links west mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer_west[sendebuffer_west_laenge] = ff + 512;
                packen_ep_plus_minus_mit_ep(ii, c);
                }
            else
                {
                sendebuffer_west[sendebuffer_west_laenge] = ff;
                }
            sendebuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_senden_mit_ep'.
void FarbenfeldVerschicken::links_ost_senden_mit_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(ii,c);
#endif
            ff = farbenfeld[ii][c];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[ii][c]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden links ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer_ost[sendebuffer_ost_laenge] = ff + 512;
                packen_ep_plus_minus_mit_ep(ii, c);
                }
            else
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                }
            sendebuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Setze des Testfeld auf true. Wird zum Markieren des Testfeldes in FarbenfelderVerschicken gebraucht.
void FarbenfeldVerschicken::einfuegen_fv(int f, int g)
    {
    testfeld[f][g] = true;
    }

// Kommentar: Setze des Testfeld auf false. Wird zum Re - Markieren des Testfeldes in FarbenfelderVerschicken gebraucht.
void FarbenfeldVerschicken::entfernen_fv(int f, int g)
    {
    testfeld[f][g] = false;
    }



//////////////////////////////////////////////
//////////////////////////////////////////////

// Kommentar: Der Gitterpunkt (f1-1,g) wird fr die Funktion vvektor_einfuegen_fv_west_empfangen_mit_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::oben_west_empfangen_mit_ep(void)
    {
// Kommentar: Bei f1 = 0 passiert nichts.
    if(f1>0)
        {
// Kommentar: Ist das testfeld = true => dort wurde ein Vektor hin entpackt => nichts tun.
// Dort ist das Farbenfeld bekannt, und alles um EP+,EP- und farbenfeld vergangen wird dort direkt erledigt.
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(f1-1,g);
#endif
// Lese den Farbenfeld - Wert aus dem Empfangsbuffer.
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben west mit ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
// Kommentar: Ist der Wert > 500, dann
            if(ff>=500)
                {
// Kommentar: Ist der Farbwert der des eigenen Kerns, dann nicht tun, weil dieser Farbwert schon auf diesem Kern liegt.
                if(ff-512!=rang)
                    {
// Kommentar: Ansonste schreibe ins Farbenfeld den gelesenen Farbwert - 512.
                    farbenfeld[f1-1][g] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
// Kommentar: Falls FELD_VERGANGEN_AENDERN definiert ist, ndere ep_update. FELD_VERGANGEN_AENDERN ist eigentlich nicht definiert.
                    ep_update->vergangen_hinzu(f1-1, g);
                    test(" owem + ",f1-1,g);
#endif
// Kommentar: ndere EP+ und EP-.
                    entpacken_ep_plus_minus_mit_ep(f1-1, g);
                    }
                }
// Kommentar: Ist ff < 500
            else
                {
// Kommentar: Ist der Farbwert der des eigenen Kerns, dann nicht tun, weil der Farbwert schon auf diesem Kern liegt.
                if(ff!=rang)
                    {
// Kommentar: Schreibe den Farbenfeld - Wert.
                    farbenfeld[f1-1][g] = ff;
#ifdef FELD_VERGANGEN_AENDERN
// Kommentar: Falls FELD_VERGANGEN_AENDERN definiert ist, ndere ep_update. FELD_VERGANGEN_AENDERN ist eigentlich nicht definiert.
                    ep_update->vergangen_hinweg(f1-1, g);
                    test(" owem - ",f1-1,g);
#endif
                    }
                }
// Kommentar: Aktualisiere die Bufferstelle.
            empfangsbuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_empfangen_mit_ep'.
void FarbenfeldVerschicken::unten_west_empfangen_mit_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(f2+1,g);
#endif
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten west mit ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[f2+1][g] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(f2+1, g);
                    test(" uwem + ",f2+1,g);
#endif
                    entpacken_ep_plus_minus_mit_ep(f2+1, g);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[f2+1][g] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(f2+1, g);
                    test(" uwem - ",f2+1,g);
#endif
                    }
                }
            empfangsbuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Der Vektor (f1-1,f2+1,g+1) wird fr die Funktion vvektor_einfuegen_fv_west_empfangen_mit_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::rechts_west_empfangen_mit_ep(void)
    {
// Kommentar: Fixiere die Parameter des zu behandelnden Vektors.
    a = f1-1;
    b = f2+1;
    c = g+1;
// Kommentar: Ist die x - Koordinate nicht mehr auf dem Gitter, dann ist nichts zu tun.
    if(c==m)
        {
        return;
        }
// Kommentar: Ist die obere y - Koordinate nicht mehr auf dem Feld, setze sie auf 0.
    if(a==-1)
        {
        a = 0;
        }
// Kommentar: Ist die untere y - Koordinate nicht mehr auf dem Feld, setze sie auf n-1.
    if(b==n)
        {
        b = n-1;
        }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c rechts mit ep a " << a << " b " << b << " c " << c << endl;
#endif
// Kommentar: Durchlaufe den Vektor.
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
       cout << "!2048c i . ii " << ii << " c " << c << endl;
#endif
// Kommentar: Ist das testfeld = true => dort wurde ein Vektor hin entpackt => nichts tun.
// Dort ist das Farbenfeld bekannt, und alles um EP+,EP- und farbenfeld vergangen wird dort direkt erledigt.
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. empfangsbuffer_west_laenge " << empfangsbuffer_west_laenge << endl;
            // Wo wird die empfangsbuffer_west_laenge deklariert?
            cout << " empfangsbuffer_west " << empfangsbuffer_west[empfangsbuffer_west_laenge] << endl;
#endif
// Kommentar: Lese den Farbenfeld - Wert.
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen rechts west mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
            cout << " ff " << ff << endl;
#endif
// Kommentar: Ist er grer als 500 ...
            if(ff>=500)
                {
// Kommentar: ... und nicht gleich dem eigenen rang ist, denn wenn das so ist, dann ist dieser Wert schon vorhanden.
                if(ff-512!=rang)
                    {
// Kommentar: Schreibe den Farbenfeld - Wert - 512.
                    farbenfeld[ii][c] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
// Kommentar: Falls FELD_VERGANGEN_AENDERN definiert ist, ndere ep_update. FELD_VERGANGEN_AENDERN ist eigentlich nicht definiert.
                    ep_update->vergangen_hinzu(ii, c);
                    test(" rwem + ",ii,c);
#endif
// Kommentar: ndere EP+ und EP-.
                    entpacken_ep_plus_minus_mit_ep(ii, c);
                    }
                }
// Kommentar: Falls der Farbwert < 500 ...
            else
                {
// Kommentar: ... und nicht gleich dem eigenen rang, weil sonst der Farbwert schon da steht.
                if(ff!=rang)
                    {
// Kommentar: Schreibe den Farbenfeld - Wert
                    farbenfeld[ii][c] = ff;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << "Vor ep_update " << endl;
                    cout << " ep_update m " << ep_update->m << endl;
#endif
#ifdef FELD_VERGANGEN_AENDERN
// Kommentar: Falls FELD_VERGANGEN_AENDERN definiert ist, ndere ep_update. FELD_VERGANGEN_AENDERN ist eigentlich nicht definiert.
                    ep_update->vergangen_hinweg(ii, c);
                    test(" rwem - ",ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << "Nach ep_update " << endl;
#endif
                    }
                }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " <<  endl;
#endif
// Kommentar: Aktualisiere die Empfangsbufferlnge.
            empfangsbuffer_west_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " <<  endl;
#endif
            }
        }
    }

// Kommentar: Vllig analog zu 'rechts_west_empfangen_mit_ep'.
void FarbenfeldVerschicken::links_west_empfangen_mit_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2048c i ." << endl;
#endif
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. " <<  endl;
#endif
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen links west mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[ii][c] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(ii, c);
                    test(" lwem + ",ii,c);
#endif
                    entpacken_ep_plus_minus_mit_ep(ii, c);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[ii][c] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(ii, c);
                    test(" lwem - ",ii,c);
#endif
                    }
                }

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " << endl;
#endif
            empfangsbuffer_west_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " << endl;
#endif
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_empfangen_mit_ep'.
void FarbenfeldVerschicken::oben_ost_empfangen_mit_ep(void)
    {
    if(f1>0)
        {
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(f1-1,g);
#endif
            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben ost mit ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[f1-1][g] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(f1-1, g);
                    test(" ooem + ",f1-1,g);
#endif
                    entpacken_ep_plus_minus_mit_ep(f1-1, g);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[f1-1][g] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(f1-1, g);
                    test(" ooem - ",f1-1,g);
#endif
                    }
                }
            empfangsbuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'unten_west_empfangen_mit_ep'.
void FarbenfeldVerschicken::unten_ost_empfangen_mit_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(f2+1,g);
#endif

            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten ost mit ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[f2+1][g] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(f2+1, g);
                    test(" uoem + ",f2+1,g);
#endif
                    entpacken_ep_plus_minus_mit_ep(f2+1, g);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[f2+1][g] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(f2+1, g);
                    test(" uoem - ",f2+1,g);
#endif
                    }
                }
            empfangsbuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'rechts_west_empfangen_mit_ep'.
void FarbenfeldVerschicken::rechts_ost_empfangen_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << " rechts drin rang " << rang << endl;
#endif
    a = f1-1;
    b = f2+1;
    c = g+1;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << " a " << a << " b " << b << " c " << c << " m " << m << " n " << n << " rang " << rang << endl;
#endif
    if(c==m)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << " ii " << ii << " c " << c << " rang " << rang << endl;
#endif
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(ii,c);
#endif
            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[ii][c] = ff - 512;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << " vor vergangen_hinzu rang " << rang << endl;
#endif
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(ii, c);
                    test(" roem + ",ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << " nach vergangen_hinzu rang " << rang << endl;
#endif
                    entpacken_ep_plus_minus_mit_ep(ii, c);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[ii][c] = ff;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << " vor feld vergangen rang " << rang << endl;
#endif
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(ii, c);
                    test(" roem - ",ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << " nach feld vergangen rang " << rang << endl;
#endif
                    }
                }

            empfangsbuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'links_west_empfangen_mit_ep'.
void FarbenfeldVerschicken::links_ost_empfangen_mit_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;
    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(ii,c);
#endif
            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen links ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[ii][c] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(ii, c);
                    test(" loem + ",ii,c);
#endif
                    entpacken_ep_plus_minus_mit_ep(ii, c);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[ii][c] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(ii, c);
                    test(" loem - ",ii,c);
#endif
                    }
                }

            empfangsbuffer_ost_laenge ++;
            }
        }
    }

/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/////////////// Ohne ep  ////////////////////////////
/////////////////////////////////////////////////////

// Kommentar: Der Gitterpunkt (f1-1,g) wird fr die Funktion vvektor_einfuegen_fv_west_senden_ohne_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::oben_west_senden_ohne_ep(void)
    {
// Kommentar: Ist f1 = 0, dann ist nichts zu tun, da dieser Punkt nicht auf dem Gitter existiert.
    if(f1>0)
        {
// Kommentar: Ist das testfeld true, dann haben wir den Fall, dass ein anderer Vektor dorthin bermittelt wurde.
// Dort ist das Farbenfeld bekannt, und alles um EP+,EP- und farbenfeld vergangen wird dort direkt erledigt.
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(f1-1,g);
#endif
// Kommentar: Ansonsten: Lese den Farbenfeldwert.
            ff = farbenfeld[f1-1][g]; // Man braucht das Farbenfeld doch fr alle Ebenen. Klappt auch, vgl. Farbenfelder verschicken::packen.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden oben west ohne ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
// Kommentar: Und schreibe ihn in den Buffer.
                sendebuffer_west[sendebuffer_west_laenge] = ff;
                sendebuffer_west_laenge ++;
                }
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_senden_ohne_ep'.
void FarbenfeldVerschicken::oben_ost_senden_ohne_ep(void)
    {
    if(f1>0)
        {
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(f1-1,g);
#endif
            ff = farbenfeld[f1-1][g];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden oben ost ohne ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                sendebuffer_ost_laenge ++;
                }
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_senden_ohne_ep'.
void FarbenfeldVerschicken::unten_west_senden_ohne_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(f2+1,g);
#endif
            ff = farbenfeld[f2+1][g];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden unten west ohne ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
                sendebuffer_west[sendebuffer_west_laenge] = ff;
                }
            sendebuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_senden_ohne_ep'.
void FarbenfeldVerschicken::unten_ost_senden_ohne_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(f2+1,g);
#endif
            ff = farbenfeld[f2+1][g];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden unten ost ohne ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                }
            sendebuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Der Vektor (f1-1,f2+1,g+1) wird fr die Funktion vvektor_einfuegen_fv_west_senden_ohne_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::rechts_west_senden_ohne_ep(void)
    {
// Kommentar: Die Vektorparameter werden fixiert.
    a = f1-1;
    b = f2+1;
    c = g+1;
// Kommentar: Die folgenden drei if's: wie in rechts_west_senden_mit_ep.
    if(c==m)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xi a " << a << " b " << b << " c " << c << " m " << m << " n " << n << endl;
#endif

// Kommentar: Durchlaufe den Vektor.
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2020xi 1" << endl;
#endif
// Kommentar: Falls das testfeld = true ist, dann an dieser Stelle nichts tun, da dort das Farbenfeld bekannt ist,
// und alles um EP+,EP- und farbenfeld vergangen wird dort direkt erledigt.
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2020xi 2" << endl;
#endif
// Kommentar: Lese den Farbenfeld - Wert.
            ff = farbenfeld[ii][c];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts west ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
            cout << "!2020xi 3 ff " << ff << " ii " << ii << " c " << c << endl;
#endif

//            if((ff>=0)&&(ep_aktuell[i][c]==true))   // Welches ep_aktuell ist damit gemeint? Das der Eigenschaftspunkte.
                                                    // Aber: Die mssen mitverschickt werden, aber nicht auf dem ueren Rand.
                                                    // Und das Farbenfeld muss nur auf dem ueren Rand verschickt werden,
                                                    // weil es fr alle zu verschickenden Punkte eine eindeutige Farbe haben
                                                    // - den des empfangenden Prozessors. Denn: EP - Randaustausch erfolgt
                                                    // vor jeder Verfeinerung. Aber: Was ist mit EP_vergangen?
                                                    // Da ich ep_vergangen brauche - auch auf dem Rand - mte ep_aktuell mit
                                                    // bertragen werden.
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "!2020xi 6" << endl;
#endif
// Kommentar: Schreibe den Farbenfeldwert in den Buffer, und aktualisiere die Bufferlnge.
                sendebuffer_west[sendebuffer_west_laenge] = ff;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "!2020xi 7" << endl;
#endif
                }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2020xi 8" << endl;
#endif
            sendebuffer_west_laenge ++;
            }
        }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2020xi Ende" << endl;
#endif
    }

// Kommentar: Vllig analog zu 'rechts_west_senden_ohne_ep'.
void FarbenfeldVerschicken::rechts_ost_senden_ohne_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g+1;
    if(c==m)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(ii,c);
#endif
//            sendebuffer_ost[sendebuffer_ost_laenge] = farbenfeld[i][c];
            ff = farbenfeld[ii][c];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts ost ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                }
            sendebuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'rechts_west_senden_ohne_ep'.
void FarbenfeldVerschicken::links_west_senden_ohne_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_westen(ii,c);
#endif
            ff = farbenfeld[ii][c];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links west ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                {
                sendebuffer_west[sendebuffer_west_laenge] = ff;
                }
            sendebuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'rechts_west_senden_ohne_ep'.
void FarbenfeldVerschicken::links_ost_senden_ohne_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_osten(ii,c);
#endif
            ff = farbenfeld[ii][c];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links ost ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                {
                sendebuffer_ost[sendebuffer_ost_laenge] = ff;
                }
            sendebuffer_ost_laenge ++;
            }
        }
    }

//////////////////////////////////////////////
//////////////////////////////////////////////

// Kommentar: Der Gitterpunkt (f1-1,g) wird fr die Funktion vvektor_einfuegen_fv_west_empfangen_ohne_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::oben_west_empfangen_ohne_ep(void)
    {
// Kommentar: Bei f1 = 0 ist nichts 'oben zu tun'.
    if(f1>0)
        {
// Kommentar: Ist das testfeld an der Stelle true, dann wird dort ein Vektor entpackt, und das Farbenfeld korrekt geschrieben.
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
// Kommentar: Lese den neuen Farbwert aus dem Empfangsbuffer.
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(f1-1,g);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben west ohne ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif

                {
// Kommentar: Wenn der Farbfeldwert den eigenen Rang hat, dann liegt er schon auf dem eigenen Kern, dann
// muss nicht geschrieben werden.
                if(ff!=rang)
                    {
// Kommentar: Schreibe den gelesenen Farbwert ins Farbenfeld.
                    farbenfeld[f1-1][g] = ff;
                    }
                }
// Kommentar: Und aktualisiere die Bufferstelle.
            empfangsbuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_empfangen_ohne_ep'.
void FarbenfeldVerschicken::unten_west_empfangen_ohne_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(f2+1,g);
#endif
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten west ohne ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[f2+1][g] = ff;
                    }
                }
            empfangsbuffer_west_laenge ++;
            }
        }
    }

// Kommentar: Der Gittervektor (f1-1,f2+1,g+1) wird fr die Funktion vvektor_einfuegen_fv_west_empfangen_ohne_ep abgehandelt,
// vgl. den Kommentar dort.
void FarbenfeldVerschicken::rechts_west_empfangen_ohne_ep(void)
    {
// Kommentar: Fixiere die Vektorparameter.
    a = f1-1;
    b = f2+1;
    c = g+1;
// Kommentar: Ist der Vektor rechts vom Gitter, dann nichts tun.
    if(c==m)
        {
        return;
        }
// Kommentar: Ist er oben nicht mehr auf dem Gitter => setze oben auf 0.
    if(a==-1)
        {
        a = 0;
        }
// Kommentar: Ist er unten nicht mehr auf dem Gitter => setze unten auf n-1.
    if(b==n)
        {
        b = n-1;
        }
// Kommentar: Durchlaufe den Vektor.
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
       cout << "!2048c i . ii " << ii << " c " << c << endl;
#endif
// Kommentar: Ist das testfeld true, dann wird dort ein anderer Vektor entpackt, und der Farbwert dort korrekt geschrieben -
// nmlich mit dem Farbwert des sendenden Kerns.
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c ii .. empfangsbuffer_west_laenge " << empfangsbuffer_west_laenge << endl;
#endif
            // Wo wird die empfangsbuffer_west_laenge deklariert?
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << " empfangsbuffer_west " << empfangsbuffer_west[empfangsbuffer_west_laenge] << endl;
#endif
// Kommentar: Lese den Farbwert aus den Empfangsbuffer.
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen rechts west ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                {
// Kommentar: Ist der Farbwert gleich dem eigenen rang, ist nichts zu tun, weil dort der Farbwert schon steht.
                if(ff!=rang)
                    {
// Kommentar: Ansonsten beschreibe das Farbfeld mit dem gelesenen Wert.
                    farbenfeld[ii][c] = ff;
                    }
                }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " <<  endl;
#endif
// Kommentar: Und aktualisiere die Bufferposition.
            empfangsbuffer_west_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " <<  endl;
#endif
            }
        }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c Ende " << endl;
#endif
    }

// Kommentar: Vllig analog zu 'rechts_west_empfangen_ohne_ep'.
void FarbenfeldVerschicken::links_west_empfangen_ohne_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;
//    if(c==0)
    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    cout << "!2048c Links a " << a << " b " << b << " c " << c << endl;
#endif
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2048c i . ii " << ii << " c " << c << endl;
#endif
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_westen(ii,c);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. empfangsbuffer_west_laenge " << empfangsbuffer_west_laenge << endl;
#endif
            ff = empfangsbuffer_west[empfangsbuffer_west_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen links west ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[ii][c] = ff;
                    }
                }
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " << endl;
#endif
            empfangsbuffer_west_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " << endl;
#endif
            }
        }
    }

// Kommentar: Vllig analog zu 'oben_west_empfangen_ohne_ep'.
void FarbenfeldVerschicken::oben_ost_empfangen_ohne_ep(void)
    {
    if(f1>0)
        {
        if(testfeld[f1-1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f1-1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(f1-1,g);
#endif
//            farbenfeld[f1-1][g] = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben ost ohne ep rang " << rang << " f " << f1-1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[f1-1][g] = ff;
                    }
                }
            empfangsbuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'unten_west_empfangen_ohne_ep'.
void FarbenfeldVerschicken::unten_ost_empfangen_ohne_ep(void)
    {
    if(f2<n-1)
        {
        if(testfeld[f2+1][g]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f2+1,g);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(f2+1,g);
#endif
            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten ost ohne ep rang " << rang << " f " << f2+1 << " g " << g << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[f2+1][g] = ff;
                    }
                }
            empfangsbuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'rechts_west_empfangen_ohne_ep'.
void FarbenfeldVerschicken::rechts_ost_empfangen_ohne_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g+1;
    if(c==m)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(ii,c);
#endif

            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
                {
                if(ff!=rang)
                    {
                    farbenfeld[ii][c] = ff;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << "xxxx empfangen rechts ost ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                    }
                }

            empfangsbuffer_ost_laenge ++;
            }
        }
    }

// Kommentar: Vllig analog zu 'rechts_west_empfangen_ohne_ep'.
void FarbenfeldVerschicken::links_ost_empfangen_ohne_ep(void)
    {
    a = f1-1;
    b = f2+1;
    c = g-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==n)
        {
        b = n-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[ii][c]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(ii,c);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_osten(ii,c);
#endif

            ff = empfangsbuffer_ost[empfangsbuffer_ost_laenge];
                {
                if(ff!=rang)
                    {
                    farbenfeld[ii][c] = ff;
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                    cout << "xxxx empfangen links ost ohne ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
                    }
                }

            empfangsbuffer_ost_laenge ++;
            }
        }
    }


/////////////////////////////////////////////////////
////////// Ohne ep Ende /////////////////////////////
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////

// Kommentar: Der Vektor (_f,_g1,_g2) wird umlaufen.  Nicht markierte Felder werden zum Senden eingepackt,
// wobei wegen 'mit_ep' auch markiert wird, wenn farbenfeld_vergangen - erkannt ber ep_update - true bzw.
// false war. Bei true wird dem Farbwert der Wert 512 hinzuddiert, und die EP+ Information auf hinweg, und EP- auf hinzu
// gesetzt, und feld_vergangen auf false.
// Bemerkung: Hier wird - im Gegensatz zu west und ost - kein Westbuffer oder Ostbuffer verwendet, sondern ein ns - Buffer
// Der wird dann vor Aufruf der Funktion zugeteilt. Auf diese Weise hat man nur die Hlfte an Funktionen,
// weil fr Nord und Sd jeweils dieselbe Funktion benutzt werden kann.
void FarbenfeldVerschicken::hvektor_einfuegen_fv_ns_senden_mit_ep(int _f, int _g1, int _g2)
    {
// Kommentar: Kopiere die bergabeparameter - das sind hier die Vektorparameter.
    f = _f;
    g1 = _g1;
    g2 = _g2;

// Kommentar: Umlaufe den Vektor oben, rechts, unten und links frs Senden. Rufe die Funktionen mit dem Suffix 'mit_ep' auf.
    rechts_ns_senden_mit_ep();
    links_ns_senden_mit_ep();
    oben_ns_senden_mit_ep();
    unten_ns_senden_mit_ep();
    }

// Kommentar: Wie bei 'hvektor_einfuegen_fv_ns_senden_mit_ep', nur das diesmal kein Eintrag in EP+ und EP- sowie
// sowie farbenfeld_vergangen erfolgt.
void FarbenfeldVerschicken::hvektor_einfuegen_fv_ns_senden_ohne_ep(int _f, int _g1, int _g2)
    {
// Kommentar: Kopiere die bergabeparameter - das sind hier die Vektorparameter.
    f = _f;
    g1 = _g1;
    g2 = _g2;

// Kommentar: Umlaufe den Vektor oben, rechts, unten und links frs Senden. Rufe die Funktionen mit dem Suffix 'ohne_ep' auf.
    strcpy(zeichenkette, " 0 ");
    ausgabe_sl(zeichenkette);
    rechts_ns_senden_ohne_ep();
    strcpy(zeichenkette, " 1 ");
    ausgabe_sl(zeichenkette);
    links_ns_senden_ohne_ep();
    strcpy(zeichenkette, " 2 ");
    ausgabe_sl(zeichenkette);
    oben_ns_senden_ohne_ep();
    strcpy(zeichenkette, " 3 ");
    ausgabe_sl(zeichenkette);
    unten_ns_senden_ohne_ep();
    strcpy(zeichenkette, " 4 ");
    ausgabe_sl(zeichenkette);
    }

// Kommentar: Der Vektor (_f,_g1,_g2) wird umlaufen. Nicht markierte Felder(!) werden beim Empfangen ausgepackt,
// wobei ein Farbwert > 500 zum Schreiben des Farbwertes 'farbwert-512' fhrt, und zu nderungen in
// EP+ und EP-. Fr einen Farbwert < 500 wird nur dieser Farbwert geschrieben.
// Bemerkung Falls FELD_VERGANGEN_AENDERN definiert ist - ist es nicht - wird fr einen Farbwert > 500
// ep_update->vergangen_hinzu geschrieben, sonst ep_update->vergangen_hinweg.
// Bemerkung: Hier wird - im Gegensatz zu west und ost - kein Westbuffer oder Ostbuffer verwendet, sondern ein ns - Buffer
// Der wird dann vor Aufruf der Funktion zugeteilt. Auf diese Weise hat man nur die Hlfte an Funktionen,
// weil fr Nord und Sd jeweils dieselbe Funktion benutzt werden kann.
void FarbenfeldVerschicken::hvektor_einfuegen_fv_ns_empfangen_mit_ep(int _f, int _g1, int _g2)
    {
// Kommentar: Kopiere die bergabeparameter - das sind hier die Vektorparameter.
    f = _f;
    g1 = _g1;
    g2 = _g2;

 //   empfangsbuffer_west_laenge = empfangsbuffer_west[0] * 3 +1;

// Kommentar: Umlaufe den Vektor oben, rechts, unten und links frs Empfangen. Rufe die Funktionen mit dem Suffix 'mit_ep' auf.
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " 1 ");
    einpunktausgabe_FFV(zeichenkette);
#endif
    rechts_ns_empfangen_mit_ep();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " 2 ");
    einpunktausgabe_FFV(zeichenkette);
#endif
    links_ns_empfangen_mit_ep();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " 3 ");
    einpunktausgabe_FFV(zeichenkette);
#endif
    oben_ns_empfangen_mit_ep();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " 4 ");
    einpunktausgabe_FFV(zeichenkette);
#endif
    unten_ns_empfangen_mit_ep();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " 5 ");
    einpunktausgabe_FFV(zeichenkette);
#endif
    }

// Kommentar: Eine Hilfsausgabe - per #ifdef auskommentierbar.
void FarbenfeldVerschicken::ausgabe_el(char * position)
    {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    if(gitterebene == 3)
        {
        cout << " zzzz empfangen rang " << rang << " position " << position << " el " << empfangsbuffer_laenge << endl;
        }
#endif
    }

// Kommentar: Eine Hilfsausgabe - per #ifdef auskommentierbar.
void FarbenfeldVerschicken::ausgabe_sl(char * position)
    {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    if(gitterebene == 3)
        {
        cout << " zzzz empfangen rang " << rang << " position " << position << " sl " << sendebuffer_laenge << endl;
        }
#endif
    }

// Kommentar: Mache dasselbe wie bei 'hvektor_einfuegen_fv_ns_empfangen_mit_ep', nur ohne auf einen Farbwert > 500
// abzufragen - der wird nicht eintreten - sowie ohne irgendetwas zu tun auer den Farbwert zu ndern -
// insbesondere nicht fr EP+, EP- sowie ep_update.
// Es werden dieselben 4 Funktionen fr ein Umlaufen aufgerufen, nur mit dem Suffix 'ohne' statt mit.
void FarbenfeldVerschicken::hvektor_einfuegen_fv_ns_empfangen_ohne_ep(int _f, int _g1, int _g2)
    {
// Kommentar: Kopiere die Vektorbergabeparameter.
    f = _f;
    g1 = _g1;
    g2 = _g2;

 //   empfangsbuffer_ost_laenge = empfangsbuffer_ost[0] * 3 +1;

// Kommentar: Umlaufe den Vektor oben, rechts, unten und links frs Empfangen. Rufe die Funktionen mit dem Suffix 'ohne_ep' auf.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    ausgabe_el(" 0 ");
    cout << " 2048 c 1 rang " << rang << endl;
#endif
    rechts_ns_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    ausgabe_el(" 1 ");
    cout << " 2048 c 2 rang " << rang << endl;
#endif
    links_ns_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    ausgabe_el(" 2 ");
    cout << " 2048 c 3 rang " << rang << endl;
#endif
    oben_ns_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    ausgabe_el(" 3 ");
    cout << " 2048 c 4 rang " << rang << endl;
#endif
    unten_ns_empfangen_ohne_ep();
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
    ausgabe_el(" 4 ");
    cout << " 2048 c 5 rang " << rang << endl;
#endif
    }

// Kommentar: Fr das Packen im Falle von 'mit_ep' werden die ep - Strukturen so gendert, als htte es einen Eintrag
// dort nie gegeben. Ist aber momentan deaktiviert.
inline void FarbenfeldVerschicken::packen_ep_plus_minus_mit_ep(int fff, int ggg)
    {
// Diese Funktion wird vorbergehend entfernt: Denn hier werden falsche Aktionen vermutet, und
// gebraucht wird sie nicht, weil vor jeder adaptiven Verfeinerung der Auenrand von EP bertragen wird.
    return;
    if(ff==rang)
        {
        return;
        }
    ep_plus_i->hinweg(fff, ggg);
    ep_minus_i->hinzu(fff, ggg);
    ep_update->feld_vergangen[fff][ggg] = false;
    }

// Kommentar: Diese Funktion ist momentan deaktiviert.
inline void FarbenfeldVerschicken::packen_ep_plus_minus_ohne_ep(int fff, int ggg)
    {
// Diese Funktion wird vorbergehend entfernt: Denn hier werden falsche Aktionen vermutet, und
// gebraucht wird sie nicht, weil vor jeder adaptiven Verfeinerung der Auenrand von EP bertragen wird.
    return;
    if(ff==rang)
        {
        return;
        }
    if(ep_update->feld_vergangen[fff][ggg]==false)
        {
        return;
        }
    ep_plus_i->hinweg(fff, ggg);
    ep_minus_i->hinzu(fff, ggg);
    }

// Kommentar: Diese Funktion ist momentan deaktiviert.
inline void FarbenfeldVerschicken::entpacken_ep_plus_minus_mit_ep(int fff, int ggg)
    {
// Diese Funktion wird vorbergehend entfernt: Denn hier werden falsche Aktionen vermutet, und
// gebraucht wird sie nicht, weil vor jeder adaptiven Verfeinerung der Auenrand von EP bertragen wird.
    return;
    if(ff-512==rang)
        {
        return;
        }
    ep_plus_i->hinzu(fff, ggg);
    ep_minus_i->hinweg(fff, ggg);
    }

///////////////////////////////////////////////////
//////// senden / empfangen ns  ///////////////////
///////////////////////////////////////////////////

// Kommentar: Analog zu 'oben_west_senden_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::links_ns_senden_mit_ep(void)
    {
    if(g1>0)
        {
        if(testfeld[f][g1-1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g1-1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(f,g1-1);
#endif
            ff = farbenfeld[f][g1-1]; // Man braucht das Farbenfeld doch fr alle Ebenen. Klappt auch, vgl. Farbenfelder verschicken::packen.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links ns mit ep rang " << rang << " f " << f << " g " << g1-1 << " ff " << ff << " m " << m << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, "links_ns_senden_mit_ep");
            ausgabe_senden(f, g1-1, zeichenkette);
#endif
            if(ep_update->feld_vergangen[f][g1-1]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden links ns mit ep rang " << rang << " f " << f << " g " << g1-1 << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer[sendebuffer_laenge] = ff+512;
                sendebuffer_laenge ++;
                packen_ep_plus_minus_mit_ep(f, g1-1);
                }
            else
                {
                sendebuffer[sendebuffer_laenge] = ff;
                sendebuffer_laenge ++;
                }
            }
        }
    }

// Kommentar: Analog zu 'links_ns_senden_mit_ep'.
void FarbenfeldVerschicken::rechts_ns_senden_mit_ep(void)
    {
    if(g2<m-1)
        {
        if(testfeld[f][g2+1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g2+1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(f,g2+1);
#endif
            ff = farbenfeld[f][g2+1]; // Man braucht das Farbenfeld doch fr alle Ebenen. Klappt auch, vgl. Farbenfelder verschicken::packen.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links ns mit ep rang " << rang << " f " << f << " g " << g2+1 << " ff " << ff << " m " << m << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, "rechts_ns_senden_mit_ep");
            ausgabe_senden(f, g2+1, zeichenkette);
#endif
            if(ep_update->feld_vergangen[f][g2+1]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden links ns mit ep rang " << rang << " f " << f << " g " << g2+1 << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer[sendebuffer_laenge] = ff+512;
                sendebuffer_laenge ++;
                packen_ep_plus_minus_mit_ep(f, g2+1);
                }
            else
                {
                sendebuffer[sendebuffer_laenge] = ff;
                sendebuffer_laenge ++;
                }

            }
        }
    }

// Kommentar: Analog zu 'rechts_west_senden_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::oben_ns_senden_mit_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f-1;
    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(c,ii);
#endif
            ff = farbenfeld[c][ii];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[c][ii]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer[sendebuffer_laenge] = ff+512;
                packen_ep_plus_minus_mit_ep(c, ii);
                }
            else
                {
                sendebuffer[sendebuffer_laenge] = ff;
                }
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, "oben_ns_senden_mit_ep");
            ausgabe_senden(c, ii, zeichenkette);
#endif
//            ausgabe_senden(c, ii, "oben_ns_senden_mit_ep");
            sendebuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_senden_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::unten_ns_senden_mit_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f+1;
    if(c==n)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(c,ii);
#endif

            ff = farbenfeld[c][ii];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            if(ep_update->feld_vergangen[c][ii]==true)
                {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
                cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff+512 << " m " << m << endl;
#endif
                sendebuffer[sendebuffer_laenge] = ff+512;
                packen_ep_plus_minus_mit_ep(c, ii);
                }
            else
                {
                sendebuffer[sendebuffer_laenge] = ff;
                }
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, "unten_ns_senden_mit_ep");
            ausgabe_senden(c, ii, zeichenkette);
#endif
            sendebuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'oben_west_senden_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::links_ns_senden_ohne_ep(void)
    {
    if(g1>0)
        {
        if(testfeld[f][g1-1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g1-1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(f,g1-1);
#endif
            ff = farbenfeld[f][g1-1]; // Man braucht das Farbenfeld doch fr alle Ebenen. Klappt auch, vgl. Farbenfelder verschicken::packen.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links ns mit ep rang " << rang << " f " << f << " g " << g1-1 << " ff " << ff << " m " << m << endl;
#endif
                {
#ifdef AKTUELLE_KOMMENTARE
                strcpy(zeichenkette, "links_ns_senden_ohne_ep");
                ausgabe_senden(f, g1-1, zeichenkette);
#endif
                sendebuffer[sendebuffer_laenge] = ff;
                sendebuffer_laenge ++;
                }
            }
        }
    }

// Kommentar: Analog zu 'oben_west_senden_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::rechts_ns_senden_ohne_ep(void)
    {
    if(g2<m-1)
        {
        if(testfeld[f][g2+1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g2+1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(f,g2+1);
#endif
            ff = farbenfeld[f][g2+1]; // Man braucht das Farbenfeld doch fr alle Ebenen. Klappt auch, vgl. Farbenfelder verschicken::packen.
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden links ns mit ep rang " << rang << " f " << f << " g " << g2+1 << " ff " << ff << " m " << m << endl;
#endif
                {
#ifdef AKTUELLE_KOMMENTARE
                strcpy(zeichenkette, "rechts_ns_senden_ohne_ep");
                ausgabe_senden(f, g2+1, zeichenkette);
#endif
                sendebuffer[sendebuffer_laenge] = ff;
                sendebuffer_laenge ++;
                }
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_senden_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::oben_ns_senden_ohne_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f-1;
    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(c,ii);
#endif
            ff = farbenfeld[c][ii];
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, "oben_ns_senden_ohne_ep");
            ausgabe_senden(c, ii, zeichenkette);
#endif

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif
            sendebuffer[sendebuffer_laenge] = ff;
            sendebuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_senden_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::unten_ns_senden_ohne_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f+1;
    if(c==n)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_sendebuffer_ns(c,ii);
#endif
            ff = farbenfeld[c][ii];

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx senden rechts ost mit ep rang " << rang << " f " << ii << " g " << c << " ff " << ff << " m " << m << endl;
#endif

#ifdef AKTUELLE_KOMMENTARE
            if(gitterebene == 3)
                {
                cout << " xxxx unten senden ns ohne ep rang " << rang << " f " << c << " g " << ii << " ff " << ff << " sl " << sendebuffer_laenge << endl;
                }
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, "unten_ns_senden_ohne_ep");
            ausgabe_senden(c, ii, zeichenkette);
#endif
#endif

            sendebuffer[sendebuffer_laenge] = ff;

            sendebuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'oben_west_empfangen_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::rechts_ns_empfangen_mit_ep(void)
    {
    if(g2<m-1)
        {
        if(testfeld[f][g2+1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g2+1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(f,g2+1);
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten west mit ep rang " << rang << " f " << f << " g " << g2+1 << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[f][g2+1] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(f, g2+1);
                    test(" rnsem + ",f,g2+1);
#endif
#ifdef AKTUELLE_KOMMENTARE
                    entpacken_ep_plus_minus_mit_ep(f, g2+1);
                    strcpy(zeichenkette, "rechts_ns_empfangen_mit_ep");
#endif
                    ausgabe_empfangen(f, g2+1, zeichenkette);
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[f][g2+1] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(f, g2+1);
                    test(" rnsem - ",f,g2+1);
#endif
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "rechts_ns_empfangen_mit_ep");
                    ausgabe_empfangen(f, g2+1, zeichenkette);
#endif
                    }
                }
            empfangsbuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'oben_west_empfangen_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::links_ns_empfangen_mit_ep(void)
    {
    if(g1>0)
        {
        if(testfeld[f][g1-1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g1-1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(f,g1-1);
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten west mit ep rang " << rang << " f " << f << " g " << g1-1 << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[f][g1-1] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(f, g1-1);
                    test(" lnsem + ",f,g1-1);
#endif
                    entpacken_ep_plus_minus_mit_ep(f, g1-1);
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "links_ns_empfangen_mit_ep");
                    ausgabe_empfangen(f, g1-1, zeichenkette);
#endif
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[f][g1-1] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(f, g1-1);
                    test(" lnsem - ",f,g1-1);
#endif
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "links_ns_empfangen_mit_ep");
                    ausgabe_empfangen(f, g1-1, zeichenkette);
#endif
                    }
                }
            empfangsbuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_empfangen_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::oben_ns_empfangen_mit_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2048c i ." << endl;
#endif
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(c,ii);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. " <<  endl;
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben ns mit ep rang " << rang << " f " << c << " g " << ii << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[c][ii] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(c, ii);
                    test(" onsem + ",c,ii);
#endif
                    entpacken_ep_plus_minus_mit_ep(c, ii);
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "oben_ns_empfangen_mit_ep");
                    ausgabe_empfangen(c, ii, zeichenkette);
#endif
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[c][ii] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(c, ii);
                    test(" onsem - ",c,ii);
#endif
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "oben_ns_empfangen_mit_ep");
                    ausgabe_empfangen(c, ii, zeichenkette);
#endif
                    }
                }

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " << endl;
#endif
            empfangsbuffer_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " << endl;
#endif
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_empfangen_mit_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::unten_ns_empfangen_mit_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f+1;
    if(c==n)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2048c i ." << endl;
#endif
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(c,ii);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. " <<  endl;
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben ns mit ep rang " << rang << " f " << c << " g " << ii << " ff " << ff << " m " << m << endl;
#endif
            if(ff>=500)
                {
                if(ff-512!=rang)
                    {
                    farbenfeld[c][ii] = ff - 512;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinzu(c, ii);
                    test(" unsem + ",c,ii);
#endif
                    entpacken_ep_plus_minus_mit_ep(c, ii);
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "unten_ns_empfangen_mit_ep");
                    ausgabe_empfangen(c, ii, zeichenkette);
#endif
                    }
                }
            else
                {
                if(ff!=rang)
                    {
                    farbenfeld[c][ii] = ff;
#ifdef FELD_VERGANGEN_AENDERN
                    ep_update->vergangen_hinweg(c, ii);
                    test(" unsem - ",c,ii);
#endif
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "unten_ns_empfangen_mit_ep");
                    ausgabe_empfangen(c, ii, zeichenkette);
#endif
                    }
                }

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " << endl;
#endif
            empfangsbuffer_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " << endl;
#endif
            }
        }
    }

// Kommentar: Analog zu 'oben_west_empfangen_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::rechts_ns_empfangen_ohne_ep(void)
    {
    if(g2<m-1)
        {
        if(testfeld[f][g2+1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g2+1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(f,g2+1);
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen rechts ns mit ep rang " << rang << " f " << f << " g " << g2+1 << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[f][g2+1] = ff;
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "rechts_ns_empfangen_ohne_ep");
                    ausgabe_empfangen(f, g2+1, zeichenkette);
#endif
                    }
                }
            empfangsbuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'oben_west_empfangen_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::links_ns_empfangen_ohne_ep(void)
    {
    if(g1>0)
        {
        if(testfeld[f][g1-1]==false)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(f,g1-1);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(f,g1-1);
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen unten west mit ep rang " << rang << " f " << f << " g " << g1-1 << " ff " << ff << " m " << m << endl;
#endif

                {
                if(ff!=rang)
                    {
                    farbenfeld[f][g1-1] = ff;
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "links_ns_empfangen_ohne_ep");
                    ausgabe_empfangen(f, g1-1, zeichenkette);
#endif
                    }
                }
            empfangsbuffer_laenge ++;
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_empfangen_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::oben_ns_empfangen_ohne_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f-1;

    if(c<0)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2048c i ." << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        if(gitterebene == 3)
            {
            cout << " zzzzz " << " rang " << rang << " f " << c << " g " << ii << " testfeld " << testfeld[c][ii] << endl;
            }
#endif
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(c,ii);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. " <<  endl;
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "xxxx empfangen oben ns mit ep rang " << rang << " f " << c << " g " << ii << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[c][ii] = ff;
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "oben_ns_empfangen_ohne_ep");
                    ausgabe_empfangen(c, ii, zeichenkette);
#endif
                    }
                }

#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " << endl;
#endif
            empfangsbuffer_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " << endl;
#endif
            }
        }
    }

// Kommentar: Analog zu 'rechts_west_empfangen_ohne_ep' - aber mit sendebuffer statt sendebuffer_west, und sendebuffer_laenge
// statt sendebuffer_laenge_west, damit Nord und Sd beide diese Funktion verwenden knnen.
void FarbenfeldVerschicken::unten_ns_empfangen_ohne_ep(void)
    {
    a = g1-1;
    b = g2+1;
    c = f+1;
    if(c==n)
        {
        return;
        }
    if(a==-1)
        {
        a = 0;
        }
    if(b==m)
        {
        b = m-1;
        }
    for(ii=a; ii<=b; ii++)
        {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
        cout << "!2048c i ." << endl;
#endif
        if(testfeld[c][ii]!=true)
            {
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
            testfeld_hinzufuegen(c,ii);
#endif // BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
#ifdef AUSGABE_FARBENUMLAUF
            ausgabe_empfangsbuffer_ns(c,ii);
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .. " <<  endl;
#endif
            ff = empfangsbuffer[empfangsbuffer_laenge];
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << " xxxx empfangen unten ns ohne ep rang " << rang << " f " << c << " g " << ii << " ff " << ff << " m " << m << endl;
#endif
                {
                if(ff!=rang)
                    {
                    farbenfeld[c][ii] = ff;
#ifdef AKTUELLE_KOMMENTARE
                    strcpy(zeichenkette, "unten_ns_empfangen_ohne_ep");
                    ausgabe_empfangen(c, ii, zeichenkette);
#endif
                    }
                }
#ifdef AKTUELLE_KOMMENTARE
            if(gitterebene == 3)
                {
                cout << " xxxx unten empfangen ns ohne ep rang " << rang << " f " << c << " g " << ii << " ff " << ff << " el " << empfangsbuffer_laenge << endl;
                }
#endif
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i ... " << endl;
#endif
            empfangsbuffer_laenge ++;
            }
        else
            {
#ifdef AUSGABEN_FARBENFELD_VERSCHICKEN
            cout << "!2048c i .... " << endl;
#endif
            }
        }
    }

// Kommentar: Werte fr die optionalen Ausgaben zum Fehlerfinden setzen.
FarbenfeldVerschicken::FarbenfeldVerschicken(void)
    {
    gitterebene_w = 1;
    f_w = 2;
    g_w = 5;
    }

// Kommentar: Optionale Ausgaben zum Fehlerfinden.
void FarbenfeldVerschicken::ausgabe_empfangen(int f_test, int g_test, char * position)
    {
    if(gitterebene == gitterebene_w)
        {
        if(f_w == f_test)
            {
            if(g_w == g_test)
                {
                cout << " gitter_w empfangen // rang " << rang << " position " << position << " ebene " << gitterebene << " f " << f_w << " g " << g_w << " gelesen " << ff << " farbenfeld " << farbenfeld[f_w][g_w] << endl;
                }
            }
        }
    if(gitterebene != gitterebene_w)
        {
        if(f_w == f_test)
            {
            if(g_w == g_test)
                {
                cout << " gitter_x empfangen // rang " << rang << " gitterebene " << gitterebene << " position " << position << " ebene " << gitterebene << " f " << f_w << " g " << g_w << " gelesen " << ff << endl;
                }
            }
        }
    }

// Kommentar: Optionale Ausgaben zum Fehlerfinden.
void FarbenfeldVerschicken::ausgabe_senden(int f_test, int g_test, char * position)
    {
    if(gitterebene == gitterebene_w)
        {
        if(f_w == f_test)
            {
            if(g_w == g_test)
                {
                cout << " gitter_w senden // rang " << rang << " position " << position << " ebene " << gitterebene << " f " << f_w << " g " << g_w << " gelesen " << ff << " farbenfeld " << farbenfeld[f_w][g_w] << endl;
                }
            }
        }
    if(gitterebene != gitterebene_w)
        {
        if(f_w == f_test)
            {
            if(g_w == g_test)
                {
                cout << " gitter_x senden // rang " << rang << " gitterebene " << gitterebene << " position " << position << " ebene " << gitterebene << " f " << f_w << " g " << g_w << " gelesen " << ff << endl;
                }
            }
        }
    }

// Kommentar: Optionale Ausgaben zum Fehlerfinden.
void FarbenfeldVerschicken::einpunktausgabe_FFV(char * position)
    {
    if(rang == 3)
        {
        if(gitterebene == 1)
            {
            cout << " epaFFV // rang " << rang << " position " << position << " ff " << farbenfeld[2][5] << endl;
            }
        }
    }

// Kommentar: Optionale Ausgaben zum Fehlerfinden.
void FarbenfeldVerschicken::test(char * text, int f, int g)
    {
    if((rang==test_rang)&&(f == test_f)&&(g==test_g))
        {
        cout << " FFV-Test text " << text << endl;
        cout << " lwem + a " << a << " b " << b << " c " << c << endl;
        }
    }

#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
inline void FarbenfeldVerschicken::testfeld_hinzufuegen(int f_hinzu, int g_hinzu)
    {
    testfeld[f_hinzu][g_hinzu] = true;
    f_merken[index_merken] = f_hinzu;
    g_merken[index_merken++] = g_hinzu;
    }

void FarbenfeldVerschicken::testfeld_reset(void)
    {

    for(ii=0; ii<index_merken; ii++)
        {
        testfeld[f_merken[ii]][g_merken[ii]] = false;
        }
    index_merken = 0;
    }
#endif


void FarbenfeldVerschicken::ausgabe_sendebuffer_osten(int ff, int gg)
    {
    if(gitterebene!=3)
        {
        return;
        }
    cout << " Farbbuffer Osten Senden rang " << rang << " i " << sendebuffer_ost_laenge << " f " << ff << " g " << gg << " buffereintrag " << farbenfeld[ff][gg] << endl; //sendebuffer_ost[sendebuffer_ost_laenge] << endl;
    }

void FarbenfeldVerschicken::ausgabe_sendebuffer_westen(int ff, int gg)
    {
    if(gitterebene!=3)
        {
        return;
        }
    cout << " Farbbuffer Westen Senden rang " << rang << " i " << sendebuffer_west_laenge << " f " << ff << " g " << gg << " buffereintrag " << farbenfeld[ff][gg] << endl; //sendebuffer_west[sendebuffer_west_laenge] << endl;
    }

void FarbenfeldVerschicken::ausgabe_empfangsbuffer_osten(int ff, int gg)
    {
    if(gitterebene!=3)
        {
        return;
        }
    cout << " Farbbuffer Osten Empfangen rang " << rang << " i " << empfangsbuffer_ost_laenge << " f " << ff << " g " << gg << " buffereintrag " << empfangsbuffer_ost[empfangsbuffer_ost_laenge] << endl;
    }

void FarbenfeldVerschicken::ausgabe_empfangsbuffer_westen(int ff, int gg)
    {
    if(gitterebene!=3)
        {
        return;
        }
    cout << " Farbbuffer Westen Empfangen rang " << rang << " i " << empfangsbuffer_west_laenge << " f " << ff << " g " << gg << " buffereintrag " << empfangsbuffer_west[empfangsbuffer_west_laenge] << endl;
    }

void FarbenfeldVerschicken::ausgabe_empfangsbuffer_ns(int ff, int gg)
    {
    if(gitterebene!=3)
        {
        return;
        }
    cout << " Farbbuffer ns Empfangen rang " << rang << " i " << empfangsbuffer_laenge << " f " << ff << " g " << gg << " buffereintrag " << empfangsbuffer[empfangsbuffer_laenge] << endl;
    }

void FarbenfeldVerschicken::ausgabe_sendebuffer_ns(int ff, int gg)
    {
    if(gitterebene!=3)
        {
        return;
        }
    cout << " Farbbuffer ns Senden rang " << rang << " i " << sendebuffer_laenge << " f " << ff << " g " << gg << " buffereintrag " << farbenfeld[ff][gg] << endl; //sendebuffer[sendebuffer_laenge] << endl;
    }
