#ifndef FARBENFELD_VERSCHICKEN
#define FARBENFELD_VERSCHICKEN 1

#include "ep_s_bestimmen.h"
#include "situationsdaten.h"

class FarbenfeldVerschicken :   virtual public SituationsDaten
    {
public:
#ifdef KURZ_FF
    short int ** farbenfeld;
#else
    int ** farbenfeld;
#endif
    void initialisieren_fv(int _n, int _m);
    void finalisieren_fv(void);
#ifdef KURZ_TESTFELD_FV
    bool ** testfeld;
#else
    int ** testfeld;
#endif
    int faktor;
private:
    int ii;
    int jj;
public:
    void einfuegen_fv(int f, int g);
    void entfernen_fv(int f, int g);
    void vvektor_einfuegen_fv_west_senden_mit_ep(int _f1, int _f2, int _g);
    void vvektor_einfuegen_fv_ost_senden_mit_ep(int _f1, int _f2, int _g);
    void vvektor_einfuegen_fv_west_empfangen_mit_ep(int _f1, int _f2, int _g);
    void vvektor_einfuegen_fv_ost_empfangen_mit_ep(int _f1, int _f2, int _g);

    void vvektor_einfuegen_fv_west_senden_ohne_ep(int _f1, int _f2, int _g);
    void vvektor_einfuegen_fv_ost_senden_ohne_ep(int _f1, int _f2, int _g);
    void vvektor_einfuegen_fv_west_empfangen_ohne_ep(int _f1, int _f2, int _g);
    void vvektor_einfuegen_fv_ost_empfangen_ohne_ep(int _f1, int _f2, int _g);
public:
#ifdef KURZ_MVF
    short int * sendebuffer_west;
    short int * empfangsbuffer_west;
    short int * sendebuffer_ost;
    short int * empfangsbuffer_ost;
    short int * sendebuffer_west2;
    short int * sendebuffer_ost2;

    short int * sendebuffer;
    short int * empfangsbuffer;
#else
    int * sendebuffer_west;
    int * empfangsbuffer_west;
    int * sendebuffer_ost;
    int * empfangsbuffer_ost;
    int * sendebuffer_west2;
    int * sendebuffer_ost2;
#endif

    int sendebuffer_west_laenge;
    int sendebuffer_ost_laenge;
    int empfangsbuffer_laenge;

    int sendebuffer_laenge;
    // Was ist das fuer ein Wert? Die Laenge bestimmt sich doch mit dem Entpacken!
private:
    int a,b,c;
    int f1, f2, g;

    void rechts_west_senden_mit_ep(void);
    void links_west_senden_mit_ep(void);
    void oben_west_senden_mit_ep(void);
    void unten_west_senden_mit_ep(void);

    void rechts_ost_senden_mit_ep(void);
    void links_ost_senden_mit_ep(void);
    void oben_ost_senden_mit_ep(void);
    void unten_ost_senden_mit_ep(void);

    void rechts_west_empfangen_mit_ep(void);
    void links_west_empfangen_mit_ep(void);
    void oben_west_empfangen_mit_ep(void);
    void unten_west_empfangen_mit_ep(void);

    void rechts_ost_empfangen_mit_ep(void);
    void links_ost_empfangen_mit_ep(void);
    void oben_ost_empfangen_mit_ep(void);
    void unten_ost_empfangen_mit_ep(void);

////////////////////////////////////////////

    void rechts_west_senden_ohne_ep(void);
    void links_west_senden_ohne_ep(void);
    void oben_west_senden_ohne_ep(void);
    void unten_west_senden_ohne_ep(void);

    void rechts_ost_senden_ohne_ep(void);
    void links_ost_senden_ohne_ep(void);
    void oben_ost_senden_ohne_ep(void);
    void unten_ost_senden_ohne_ep(void);

    void rechts_west_empfangen_ohne_ep(void);
    void links_west_empfangen_ohne_ep(void);
    void oben_west_empfangen_ohne_ep(void);
    void unten_west_empfangen_ohne_ep(void);

    void rechts_ost_empfangen_ohne_ep(void);
    void links_ost_empfangen_ohne_ep(void);
    void oben_ost_empfangen_ohne_ep(void);
    void unten_ost_empfangen_ohne_ep(void);

public:
public:
    int empfangsbuffer_west_laenge, empfangsbuffer_ost_laenge;
public:
    void vvektor_einfuegen_fv_nord_senden(int _f, int _g1, int _g2);
    void vvektor_einfuegen_fv_sued_senden(int _f, int _g1, int _g2);
    void vvektor_einfuegen_fv_nord_empfangen(int _f, int _g1, int _g2);
    void vvektor_einfuegen_fv_sued_empfangen(int _f, int _g1, int _g2);

    void hvektor_einfuegen_fv_ns_senden_mit_ep(int _f, int _g1, int _g2);
    void hvektor_einfuegen_fv_ns_senden_ohne_ep(int _f, int _g1, int _g2);
    void hvektor_einfuegen_fv_ns_empfangen_mit_ep(int _f, int _g1, int _g2);
    void hvektor_einfuegen_fv_ns_empfangen_ohne_ep(int _f, int _g1, int _g2);
private:
    int f, g1, g2;

    void rechts_ns_senden_mit_ep(void);
    void links_ns_senden_mit_ep(void);
    void oben_ns_senden_mit_ep(void);
    void unten_ns_senden_mit_ep(void);

    void rechts_ns_senden_ohne_ep(void);
    void links_ns_senden_ohne_ep(void);
    void oben_ns_senden_ohne_ep(void);
    void unten_ns_senden_ohne_ep(void);

    void rechts_ns_empfangen_mit_ep(void);
    void links_ns_empfangen_mit_ep(void);
    void oben_ns_empfangen_mit_ep(void);
    void unten_ns_empfangen_mit_ep(void);

    void rechts_ns_empfangen_ohne_ep(void);
    void links_ns_empfangen_ohne_ep(void);
    void oben_ns_empfangen_ohne_ep(void);
    void unten_ns_empfangen_ohne_ep(void);
public:
    short int ** ep_aktuell, ** ep_vergangen, ** ep_wechsel;
    EP_s_bestimmen * ep_update;
    int ff;
public:
    PunktFeldListe ** ep_plus, ** ep_minus;
    PunktFeldListe * ep_plus_i, * ep_minus_i;
private:
    inline void packen_ep_plus_minus_mit_ep(int fff, int ggg);
    inline void packen_ep_plus_minus_ohne_ep(int fff, int ggg);
    inline void entpacken_ep_plus_minus_mit_ep(int fff, int ggg);
protected:
    int gitterebene;
private:
    void ausgabe_el(char * position);
    void ausgabe_sl(char * position);
public:
    FarbenfeldVerschicken(void);
    void ausgabe_empfangen(int f_test, int g_test, char * position);
    void ausgabe_senden(int f_test, int g_test, char * position);
    int gitterebene_w;
    int f_w, g_w;
private:
    void einpunktausgabe_FFV(char * position);
private:
    char zeichenkette[50];
private:
    int test_rang, test_f, test_g;
    void test(char * text, int f, int g);
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
private:
    short int * f_merken, * g_merken;
    int index_merken;
    inline void testfeld_hinzufuegen(int f_hinzu, int g_hinzu);
protected:
    void testfeld_reset(void);
private:
    int mn;
#endif
    void ausgabe_sendebuffer_osten(int ff, int gg);
    void ausgabe_sendebuffer_westen(int ff, int gg);
    void ausgabe_sendebuffer_ns(int ff, int gg);
    void ausgabe_empfangsbuffer_osten(int ff, int gg);
    void ausgabe_empfangsbuffer_westen(int ff, int gg);
    void ausgabe_empfangsbuffer_ns(int ff, int gg);
    };

#endif

