// Kommentar: Der mvf_buffer->index hlt die aktuelle Position im Buffer fest!

#include "farbenfelder_verschicken.h"

// Kommentar: Diese Klasse wird in Lastausgleich - der Migrationsklasse - definiert. Hier wird der Umlauf um das
// verschickte Gebiet realisiert zwecks Farbenfeld - Transfers sowie ggf. ep - nderungen im Bereich dieses Umlaufes.
// Dabei werden die Funktionen der Klasse FarbenfeldVerschicken aufgerufen. Diese Klasse koordiniert das setzen
// der richtigen Variablen und Aufruf der richtigen Funktionen, whrend das Packen und Entpacken in der Klasse
// FarbenfeldVerschicken erfolgt.

// Kommentar: Diese Funktion setzt das Farbenfeld der gewhlten Ebene.
#ifdef KURZ_FF
void FarbenfelderVerschicken::initialisieren_fv1(int h, short int ** _farbenfeld)
#else
void FarbenfelderVerschicken::initialisieren_fv1(int h, int ** _farbenfeld)
#endif
    {
    farbenfelder[h] = _farbenfeld; // Das gilt auch fr das farbenfeld von farbenfeld_verschicken.
    }

// Kommentar: Das ist die eigentliche Initialisierungsfunktion.
void FarbenfelderVerschicken::initialisieren_hfv(int _h_gesamt, int _rang, int _zielrang_west, int _zielrang_ost, int _zielrang_nord, int _zielrang_sued)
    {
    // finalisierung komplett
// Kommentar: Die bergabeparameter werden gespeichert. Insbesondere die Ebene des Umlaufes, der eigene Rand sowie
// der Farbwert der Zielkerne.
    h_gesamt = _h_gesamt;
    rang = _rang;
    zielrang_west = _zielrang_west;
    zielrang_ost = _zielrang_ost;
    zielrang_nord = _zielrang_nord;
    zielrang_sued = _zielrang_sued;

// Kommentar: Die Zeiger auf die Strukturen Farbenfelder aller Ebenen sowie ep_update und EP+ und EP- werden vorbereitet.
// Es wird dafr Speicherplatz bereitgestellt. Das ist bei Zeigern letztlich aber nicht viel Speicherplatz.
#ifdef KURZ_FF
    farbenfelder = new short int ** [h_gesamt];
#else
    farbenfelder = new int ** [h_gesamt];
#endif
    ep_updates = new EP_s_bestimmen * [h_gesamt];
    ep_plus = new PunktFeldListe * [h_gesamt];
    ep_minus = new PunktFeldListe * [h_gesamt];
    }

// Kommentar: Das Finalisieren erfolgt durch die Freigabe des bei der Initialisierung angelegten Speicherplatzes.
void FarbenfelderVerschicken::finalisieren_hfv(void)
    {
    delete farbenfelder;
    // Ab hier neu hinzu.
    delete ep_updates;
    delete ep_plus;
    delete ep_minus;
    }

/////////////////////////////////////////////////////////////////
/////////  Packen Westen  ///////////////////////////////////////
/////////////////////////////////////////////////////////////////

// Kommentar: Es geschieht ein Packen aufgrund der Struktur mv der Klasse MV_vertikal in den MVFBuffer mvf_buffer.
void FarbenfelderVerschicken::packen_westen(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
// Kommentar: Das ist eine Hilfsausgabe.
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020 // h_gesamt " << h_gesamt << " rang " << rang << endl;
    cout << " Die ersten 5 ints ";
    for(i=0; i<5; i++)
        {
        cout << mvf_buffer->buffer[i] << " ";
        }
    cout << endl;
#endif
// Kommentar: Die einzelnen Gitterebenen von der feinsten bis zur grbsten Ebene werden durchlaufen.
    for(i=0; i<h_gesamt; i++)
        {
// Kommentar: Setzen der Variablen 'gitterebene'.
        gitterebene = i;
// Kommentar: Laden der Vektoren aus mv.
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
        index = mv->indizes[i];
// Kommentar: Laden von Farbenfeld und ep - Informationen fr die Gitterebene.
        farbenfeld = farbenfelder[i]; // Das geschieht fr die Schritte eine Ebene tiefer.
        ep_update = (ep_updates[i]);
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
// Kommentar: Laden der Gittermae der Gitterebene.
        m = m_h[i];
        n = n_h[i];
// Kommentar: Schreiben der Informationen des mvf_buffer's in sendebuffer_West und sendebuffer_west_laenge.
        sendebuffer_west = mvf_buffer -> buffer;
        sendebuffer_west_laenge = mvf_buffer -> index;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020a swl " << sendebuffer_west_laenge << " mv-index " << index << " rang " << rang << endl;
#endif
// Kommentar: Wenn fr die Gitterebene ep - Informationen vorliegen und gebraucht werden ...
        if(ep_ebenen[i]==true)
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << "!2020 packen westen mit ep rang " << rang << " i " << i << endl;
#endif
// Kommentar: ... dann packe nach fr den Westen mit ep - Information. (Funktion dieser Klasse FarbenfelderVerschicken)
            packen_westen_eines_mit_ep();
            }
// Kommentar: Ansonsten ...
        else
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << "!2020 packen westen ohne ep rang " << rang << " i " << i << endl;
#endif
// Kommentar: ... dann packe nach fr den Westen ohne ep - Information. (Funktion dieser Klasse FarbenfelderVerschicken)
            packen_westen_eines_ohne_ep();
            }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020b" << " rang " << rang << endl;
#endif
// Kommentar: Schreibe den Index zurck nach mvf_buffer, damit dieser aktualisiert wird.
        mvf_buffer -> index = sendebuffer_west_laenge;
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2021" << " rang " << rang << endl;
#endif
    }

// Kommentar: Fr die oben geladene Gitterebene wird die Farbenfeld - Information gepackt.
void FarbenfelderVerschicken::packen_westen_eines_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020v" << " rang " << rang << endl;
#endif
// Kommentar: Markiere das Testfeld fr die zum Verschicken nach Westen bestimmten Punkte.
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020w" << " rang " << rang << " index " << index << endl;
#endif

// Kommentar: Durchlaufe die zum Verschicken bestimmten Vektoren dieser Ebene.
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020x" << " rang " << rang << " f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
// Kommentar: Rufe die FarbenfeldVerschicken Funktion auf frs senden nach Westen mit ep.
        vvektor_einfuegen_fv_west_senden_mit_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020y" << " rang " << rang << endl;
#endif
        }
// Kommentar: Am Ende wird das Farbenfeld wieder zurck auf false gesetzt.
    deaktiviere_farbenfeld_verschicken();
    }

// Kommentar: Es ist dasselbe wie bei packen_westen_eines_mit_ep, bis darauf, das statt
// vvektor_einfuegen_fv_west_senden_mit_ep die Funktion vvektor_einfuegen_fv_west_senden_ohne_ep
// aufgerufen wird.
void FarbenfelderVerschicken::packen_westen_eines_ohne_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020v" << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020w" << " rang " << rang << " index " << index << endl;
#endif

    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020x" << " rang " << rang << " f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
        vvektor_einfuegen_fv_west_senden_ohne_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020y" << " rang " << rang << endl;
#endif
        }
    deaktiviere_farbenfeld_verschicken();
    }

/////////////////////////////////////////////////////////////////
////////////// Packen Osten /////////////////////////////////////
/////////////////////////////////////////////////////////////////

// Kommentar: Analog zu packen_westen.
void FarbenfelderVerschicken::packen_osten(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020 // h_gesamt " << h_gesamt << " rang " << rang << endl;
    cout << " Die ersten 5 ints ";
    for(i=0; i<5; i++)
        {
        cout << mvf_buffer->buffer[i] << " ";
        }
    cout << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020 Ebene " << i << " rang " << rang << endl;
#endif
        gitterebene = i;
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
        index = mv->indizes[i];
        farbenfeld = farbenfelder[i]; // Das geschieht fr die Schritte eine Ebene tiefer.
        ep_update = (ep_updates[i]);
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        m = m_h[i];
        n = n_h[i];
        sendebuffer_ost = mvf_buffer -> buffer;
        sendebuffer_ost_laenge = mvf_buffer -> index;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020a swl " << sendebuffer_ost_laenge << " mv-index " << index << " rang " << rang << endl;
#endif
        if(ep_ebenen[i]==true)
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << "!2020 packen osten mit ep rang " << rang << " i " << i << endl;
#endif
            packen_osten_eines_mit_ep();
            }
        else
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << "!2020 packen osten ohne ep rang " << rang << " i " << i << endl;
#endif
            packen_osten_eines_ohne_ep();
            }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020b" << " rang " << rang << endl;
#endif
        mvf_buffer -> index = sendebuffer_ost_laenge;
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2021" << " rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu packen_westen_eines_mit_ep.
void FarbenfelderVerschicken::packen_osten_eines_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020v" << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020w" << " rang " << rang << " index " << index << endl;
#endif

    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020x" << " rang " << rang << " f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
        vvektor_einfuegen_fv_ost_senden_mit_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020y" << " rang " << rang << endl;
#endif
        }
    deaktiviere_farbenfeld_verschicken();
    }

// Kommentar: Analog zu packen_westen_eines_ohne_ep.
void FarbenfelderVerschicken::packen_osten_eines_ohne_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020v" << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020w" << " rang " << rang << " index " << index << endl;
#endif

    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020x" << " rang " << rang << " f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
        vvektor_einfuegen_fv_ost_senden_ohne_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020y" << " rang " << rang << endl;
#endif
        }
    deaktiviere_farbenfeld_verschicken();
    }

//////////////////////////////////////////////////
///////// entpacken westen ///////////////////////
//////////////////////////////////////////////////

// Kommentar: Analog zu 'packen_westen_eines_mit_ep', nur dass jetzt die Funktion vvektor_einfuegen_fv_west_empfangen_mit_ep
// statt der Funktion vvektor_einfuegen_fv_west_senden_mit_ep aufgerufen wird - weil statt packen entpacken geschieht.
void FarbenfelderVerschicken::entpacken_westen_eines_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048a mit ep " << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048b" << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048c // f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
        vvektor_einfuegen_fv_west_empfangen_mit_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048d" << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048e " << endl;
#endif
    deaktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048f" << endl;
#endif
    }

// Kommentar: Analog zu entpacken_westen_eines_mit_ep, nur das statt des Aufrufs von vvektor_einfuegen_fv_west_empfangen_mit_ep
// die Funktion vvektor_einfuegen_fv_west_empfangen_ohne_ep aufgerufen wird.
void FarbenfelderVerschicken::entpacken_westen_eines_ohne_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048a ohne ep " << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048b" << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048c // f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
        vvektor_einfuegen_fv_west_empfangen_ohne_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048d" << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048e " << endl;
#endif
    deaktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048f" << endl;
#endif
    }

// Kommentar: Die gepackten und dabei entfernten Punkte bekommen die Farbe des Zielranges.
void FarbenfelderVerschicken::ueberschreiben(int zielrang)
    {
    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            farbenfeld[j][vvektor_g] = zielrang;
            }
        }
    }

// Kommentar: Wenn Punkte aus dem Westen entpackt sind, wird das Farbenfeld - und ggf. zustzliche ep - Information -
// aus dem Buffer gelesen und in die Struktur Farbenfeld geschrieben. Die Vektoren stehen in der MV_vertikal Struktur mv,
// und die Farbenfeld - Werte im mvf_buffer.
void FarbenfelderVerschicken::entpacken_westen(MVFBuffer * mvf_buffer, MV_vertikal * mv)
    {
// Kommentar: Lese den mvf_buffer, um die Variablen empfangsbuffer_west und empfangsbuffer_west_laenge zur Benutzung der
// FarbenfeldVerschicken - Funktionen zu beschreiben.
    mvf_buffer->index_bestimmen();
    empfangsbuffer_west = mvf_buffer -> buffer;
    empfangsbuffer_west_laenge = mvf_buffer -> index;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2040" << endl;
#endif
// Kommentar: Durchlaufe die Gitterebenen vom Feinsten zum Grbsten.
    for(i=0; i<h_gesamt; i++)
        {
// Kommentar: Man merke sich die Gitterebene.
        gitterebene = i;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2041 Ebene " << i << endl;
#endif
// Kommentar: Man lese die Vektoren der jeweils ausgewhlten Gitterebene.
        f1 = mv->f1_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2042" << endl;
#endif
        f2 = mv->f2_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2043" << endl;
#endif
        g = mv->g_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2044" << endl;
#endif
        index = mv->indizes[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2045" << endl;
#endif
// Kommentar: Man lese Farbenfeld und ep - Informationen der ausgewhlten Gitterebene.
        farbenfeld = farbenfelder[i];
        ep_update = (ep_updates[i]);
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
// Kommentar: Man lese die Gittermae dieser Gitterebene.
        m = m_h[i];
        n = n_h[i];
// Kommentar: Die folgende Zeile ist herauszunehmen. Beim Einfgen der Punkte wird auch das Farbenfeld an dieser
// Stelle korrekt geschrieben. NEU: 5.5.15
#ifdef ZAEHLER_ALT
        ueberschreiben(zielrang_west);
#endif
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048 ewl " << empfangsbuffer_west_laenge << endl;
#endif
// Kommentar: Falls auf dieser Ebene ep - Informationen vorliegen,
        if(ep_ebenen[i]==true)
            {
// Kommentar: Dann rufe entpacken_westen mit_ep auf.
            entpacken_westen_eines_mit_ep();
            }
// Kommentar: Ansonsten:
        else
            {
// Kommentar: Dann rufe entpacken_westen ohne_ep auf.
            entpacken_westen_eines_ohne_ep();
            }
//        entpacken_eines();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2049" << endl;
#endif
// Kommentar: Sichere die neuen Informationen durch aktualisieren von mvf_buffer -> index.
        mvf_buffer -> index = empfangsbuffer_west_laenge;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2050" << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2051 Fertig: Farbenfeld ist entpackt" << endl;
#endif
    }

//////////////////////////////////////////////////
///////// entpacken osten  ///////////////////////
//////////////////////////////////////////////////

// Kommentar: Vllig analog zu entpacken_westen_eines_mit_ep.
void FarbenfelderVerschicken::entpacken_osten_eines_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048a mit ep " << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048b mit ep " << " rang " << rang << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048c mit ep // f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << " rang " << rang << endl;
#endif
        vvektor_einfuegen_fv_ost_empfangen_mit_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048d mit ep " << " rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048e mit ep " << " rang " << rang << endl;
#endif
    deaktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048f mit ep " << " rang " << rang << endl;
#endif
    }

// Kommentar: Vllig analog zu entpacken_westen_eines_ohne_ep.
void FarbenfelderVerschicken::entpacken_osten_eines_ohne_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048a" << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048b" << " rang " << rang << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048c // f1 " << f1[j] << " f2 " << f2[j] << " g " << g[j] << " rang " << rang << endl;
#endif
        vvektor_einfuegen_fv_ost_empfangen_ohne_ep(f1[j], f2[j], g[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048d" << " rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048e " << " rang " << rang << endl;
#endif
    deaktiviere_farbenfeld_verschicken();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048f" << " rang " << rang << endl;
#endif
    }

// Kommentar: Vllig analog zu entpacken_westen.
void FarbenfelderVerschicken::entpacken_osten(MVFBuffer * mvf_buffer, MV_vertikal * mv)
    {
    mvf_buffer->index_bestimmen();
    empfangsbuffer_ost = mvf_buffer -> buffer;
    empfangsbuffer_ost_laenge = mvf_buffer -> index;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2040 rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2041 rang " << rang << endl;
#endif
        gitterebene = i;
        f1 = mv->f1_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2042" << " rang " << rang << endl;
#endif
        f2 = mv->f2_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2043" << " rang " << rang << endl;
#endif
        g = mv->g_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2044" << " rang " << rang << endl;
#endif
        index = mv->indizes[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2045" << " rang " << rang << endl;
#endif
        farbenfeld = farbenfelder[i];
        ep_update = (ep_updates[i]);
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        m = m_h[i];
        n = n_h[i];
#ifdef ZAEHLER_ALT // NEU: Ab 5.5.15 herausgenommen.
        ueberschreiben(zielrang_ost);
#endif
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048 eol " << empfangsbuffer_ost_laenge << " rang " << rang << " ep_ebenen[i] " << ep_ebenen[i] << endl;
#endif
        if(ep_ebenen[i]==true)
            {
            entpacken_osten_eines_mit_ep();
            }
        else
            {
            entpacken_osten_eines_ohne_ep();
            }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2049" << " rang " << rang << endl;
#endif
        mvf_buffer -> index = empfangsbuffer_ost_laenge;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2050" << " rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2051 Fertig: Farbenfeld ist entpackt" << " rang " << rang << endl;
#endif
    }

// Kommentar: Das Farbenfeld wird auf den verschickten bzw. empfangenen Vektoren mit true markiert.
void FarbenfelderVerschicken::aktiviere_farbenfeld_verschicken(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "Index " << index << endl;
#endif
// Kommentar: Durchlaufe die Vektoren fr diese Ebene.
    for(l=0; l<index; l++)
        {
// Kommentar: Setze die Koordinaten des l. Vektors.
        vvektor_f1 = f1[l];
        vvektor_f2 = f2[l];
        vvektor_g = g[l];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
// Kommentar: Durchlaufe die Punkte des Vektors.
        for(k=vvektor_f1; k<=vvektor_f2; k++)
            {
// Kommentar: Setze dort das Farbenfeld auf true.
            einfuegen_fv(k, vvektor_g);
            }
        }
    }

// Kommentar: Das Farbenfeld wird auf den verschickten bzw. empfangenen Vektoren auf false gesetzt - um das
// Farbenfeld fr den nchsten Schritt wieder vorzubereiten - jeder Eintrag ist danach wieder false.
void FarbenfelderVerschicken::deaktiviere_farbenfeld_verschicken(void)
    {
// Kommentar: Durchlaufe die Vektoren fr diese Ebene.
    for(l=0; l<index; l++)
        {
// Kommentar: Setze die Koordinaten des l. Vektors.
        vvektor_f1 = f1[l];
        vvektor_f2 = f2[l];
        vvektor_g = g[l];
// Kommentar: Durchlaufe die Punkte des Vektors.
        for(k=vvektor_f1; k<=vvektor_f2; k++)
            {
// Kommentar: Setze dort das Farbenfeld auf false.
            entfernen_fv(k, vvektor_g);
            }
        }
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
    testfeld_reset();
#endif
    }

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
///////////////   Nord Sd  //////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

///////// packen /////////////////

// Kommentar: Analog zu packen_westen - nur mit sendebuffer statt sendebuffer_west - vgl. FarbenfeldVerschicken.
// Dieser wird vom mhf_buffer geladen, wobei darber die Zuordnung kommt, sei es Sden oder Norden.
void FarbenfelderVerschicken::packen_ns(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020 // h_gesamt " << h_gesamt << " rang " << rang << endl;
    cout << " Die ersten 5 ints ";
    for(i=0; i<5; i++)
        {
        cout << mhf_buffer->buffer[i] << " ";
        }
    cout << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020 Ebene " << i << " rang " << rang << endl;
#endif
        gitterebene = i;
        f = mv->f_speichern[i];
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        index = mv->indizes[i];
        farbenfeld = farbenfelder[i]; // Das geschieht fr die Schritte eine Ebene tiefer.
        ep_update = (ep_updates[i]);
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        m = m_h[i];
        n = n_h[i];
        sendebuffer = mhf_buffer -> buffer;
        sendebuffer_laenge = mhf_buffer -> index;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020a snsl " << sendebuffer_laenge << " mv-index " << index << " rang " << rang << endl;
#endif
        if(ep_ebenen[i]==true)
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << "!2020 packen westen mit ep rang " << rang << " i " << i << endl;
#endif
            packen_ns_eines_mit_ep();
            }
        else
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << "!2020 packen westen ohne ep rang " << rang << " i " << i << endl;
#endif
            packen_ns_eines_ohne_ep();
            }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020b" << " rang " << rang << endl;
#endif
        mhf_buffer -> index = sendebuffer_laenge;
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2021" << " rang " << rang << endl;
#endif
    }

// Kommentar: Vllig analog zu packen_westen_eines_mit_ep, nur mit dem Befehl hvektor_einfuegen_fv_ns_senden_mit_ep
// statt vvektor_einfuegen_fv_west_senden_mit_ep.
void FarbenfelderVerschicken::packen_ns_eines_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020v" << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken_ns();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020w" << " rang " << rang << " index " << index << endl;
#endif

    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020x" << " rang " << rang << " f " << f[j] << " g1 " << g1[j] << " g2 " << g2[j] << endl;
#endif
        hvektor_einfuegen_fv_ns_senden_mit_ep(f[j], g1[j], g2[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020y" << " rang " << rang << endl;
#endif
        }
    deaktiviere_farbenfeld_verschicken_ns();
    }

// Kommentar: Analog zu packen_westen_eines_ohne_ep.
void FarbenfelderVerschicken::packen_ns_eines_ohne_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020v" << " rang " << rang << endl;
#endif
    aktiviere_farbenfeld_verschicken_ns();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2020w" << " rang " << rang << " index " << index << endl;
#endif

    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020x" << " rang " << rang << " f " << f[j] << " g1 " << g1[j] << " g2 " << g2[j] << endl;
#endif
        hvektor_einfuegen_fv_ns_senden_ohne_ep(f[j], g1[j], g2[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2020y" << " rang " << rang << endl;
#endif
        }
    deaktiviere_farbenfeld_verschicken_ns();
    }

//////////// entpacken /////////////

// Kommentar: Analog zu entpacken_westen_eines_mit_ep.
void FarbenfelderVerschicken::entpacken_ns_eines_mit_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048a mit ep " << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "entpacken_ns_eines_mit_ep vorher");
    einpunktausgabe_LA(zeichenkette);
#endif
    aktiviere_farbenfeld_verschicken_ns();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "nach aktivieren: entpacken_ns_eines_mit_ep vorher");
    einpunktausgabe_LA(zeichenkette);
#endif
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048b" << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048c // f " << f[j] << " g1 " << g1[j] << " g2 " << g2[j] << endl;
#endif
        hvektor_einfuegen_fv_ns_empfangen_mit_ep(f[j], g1[j], g2[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048d" << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048e " << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "vor deaktivieren: entpacken_ns_eines_mit_ep nachher");
    einpunktausgabe_LA(zeichenkette);
#endif
    deaktiviere_farbenfeld_verschicken_ns();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    strcpy(zeichenkette, "entpacken_ns_eines_mit_ep nachher");
    einpunktausgabe_LA(zeichenkette);
    cout << "!2048f" << endl;
#endif
    }

// Kommentar: Analog zu entpacken_westen_eines_ohne_ep.
void FarbenfelderVerschicken::entpacken_ns_eines_ohne_ep(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048a ohne ep " << endl;
#endif
    aktiviere_farbenfeld_verschicken_ns();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048b" << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048c // f " << f[j] << " g1 " << g1[j] << " g2 " << g2[j] << endl;
#endif
        hvektor_einfuegen_fv_ns_empfangen_ohne_ep(f[j], g1[j], g2[j]);
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2048d" << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048e " << endl;
#endif
    deaktiviere_farbenfeld_verschicken_ns();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2048f" << endl;
#endif
    }

// Kommentar: Analog zu 'ueberschreiben'
void FarbenfelderVerschicken::ueberschreiben_ns(int zielrang)
    {
    for(k=0; k<index; k++)
        {
        hvektor_f = f[k];
        hvektor_g1 = g1[k];
        hvektor_g2 = g2[k];

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            farbenfeld[hvektor_f][j] = zielrang;
            }
        }
    }

// Kommentar: Analog zu entpacken_westen.
void FarbenfelderVerschicken::entpacken_ns(MHFBuffer * mhf_buffer, MV_horizontal * mv)
    {
    mhf_buffer->index_bestimmen();
    empfangsbuffer = mhf_buffer -> buffer;
    empfangsbuffer_laenge = mhf_buffer -> index;

#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2040 rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2041 rang " << rang << " Ebene " << i << endl;
#endif
        gitterebene = i;
#ifdef AKTUELLE_KOMMENTARE
        cout << " yyyy entpacken rang " << rang << " i " << i << " el " << empfangsbuffer_laenge << endl;
#endif
        f = mv->f_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2042 rang " << rang << endl;
#endif
        g1 = mv->g1_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2043 rang " << rang << endl;
#endif
        g2 = mv->g2_speichern[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2044 rang " << rang << endl;
#endif
        index = mv->indizes[i];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2045 rang " << rang << endl;
#endif
        farbenfeld = farbenfelder[i];
        ep_update = (ep_updates[i]);
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        m = m_h[i];
        n = n_h[i];
#ifdef ZAEHLER
        ueberschreiben_ns(zielrang_west);
#endif
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2046 rang " << rang << endl;
        cout << "!2047 rang " << rang << endl;

        cout << "!2048 rang " << rang << " ensl " << empfangsbuffer_laenge << endl;
#endif
        if(ep_ebenen[i]==true)
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << " !2048 vor 'mit_ep' rang " << rang << endl;
#endif
            entpacken_ns_eines_mit_ep();
            }
        else
            {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
            cout << " !2048 vor 'ohne_ep' rang " << rang << endl;
#endif
            entpacken_ns_eines_ohne_ep();
            }
//        entpacken_eines();
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2049 rang " << rang << endl;
#endif
        mhf_buffer -> index = empfangsbuffer_laenge;
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "!2050 rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "!2051 rang " << rang << " Fertig: Farbenfeld ist entpackt" << endl;
#endif
    }


// aktivieren deaktivieren /////////

// Kommentar: Analog zu aktiviere_farbenfeld_verschicken.
void FarbenfelderVerschicken::aktiviere_farbenfeld_verschicken_ns(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "Index " << index << endl;
#endif
    for(l=0; l<index; l++)
        {
        hvektor_f = f[l];
        hvektor_g1 = g1[l];
        hvektor_g2 = g2[l];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif
        for(k=hvektor_g1; k<=hvektor_g2; k++)
            {
            einfuegen_fv(hvektor_f, k);
            }
        }
    }

// Kommentar: Analog zu deaktiviere_farbenfeld_verschicken.
void FarbenfelderVerschicken::deaktiviere_farbenfeld_verschicken_ns(void)
    {
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
    cout << "Index " << index << endl;
#endif
    for(l=0; l<index; l++)
        {
        hvektor_f = f[l];
        hvektor_g1 = g1[l];
        hvektor_g2 = g2[l];
#ifdef AUSGABEN_FARBENFELDER_VERSCHICKEN
        cout << "f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif
        for(k=hvektor_g1; k<=hvektor_g2; k++)
            {
            entfernen_fv(hvektor_f, k);
            }
        }
#ifdef BESCHLEUNIGEN_FARBENFELD_VERSCHICKEN
    testfeld_reset();
#endif
    }

// Kommentar: Eine Ausgabe frs Fehlerfinden. Soll bei Tests deaktiviert sein. Kann bei zu kleinen Gittern
// zu einem Fehler fhren.
void FarbenfelderVerschicken::einpunktausgabe_LA(char * position)
    {
    }
