#ifndef FARBENFELDER_VERSCHICKEN
#define FARBENFELDER_VERSCHICKEN 1

#include <string.h>

#include "mv_vertikal.h"
#include "mv_horizontal.h"
#include "mvf_buffer.h"
#include "mhf_buffer.h"
#include "farbenfeld_verschicken.h"

class FarbenfelderVerschicken : public FarbenfeldVerschicken
    {
public:
    void packen_westen(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    void packen_osten(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    void entpacken_westen(MVFBuffer * mvf_buffer, MV_vertikal * mv);
    void entpacken_osten(MVFBuffer * mvf_buffer, MV_vertikal * mv);

    void packen_ns(MV_horizontal * mv, MHFBuffer * mhf_buffer);
    void entpacken_ns(MHFBuffer * mvf_buffer, MV_horizontal * mv);
private:
    int h_gesamt;
    void packen_westen_eines_mit_ep(void);
    void packen_osten_eines_mit_ep(void);
    void packen_westen_eines_ohne_ep(void);
    void packen_osten_eines_ohne_ep(void);
    void entpacken_westen_eines_mit_ep(void);
    void entpacken_osten_eines_mit_ep(void);
    void entpacken_westen_eines_ohne_ep(void);
    void entpacken_osten_eines_ohne_ep(void);

    void packen_ns_eines_mit_ep(void);
    void packen_ns_eines_ohne_ep(void);
    void entpacken_ns_eines_mit_ep(void);
    void entpacken_ns_eines_ohne_ep(void);

    int * f1, *f2, *g, index;
    int * f, *g1, *g2;
    int i, j, k, l;
    int vvektor_f1, vvektor_f2, vvektor_g;
    void aktiviere_farbenfeld_verschicken(void);
    void deaktiviere_farbenfeld_verschicken(void);

    int hvektor_f, hvektor_g1, hvektor_g2;
    void aktiviere_farbenfeld_verschicken_ns(void);
    void deaktiviere_farbenfeld_verschicken_ns(void);
public:
#ifdef KURZ_FF
    short int *** farbenfelder;
#else
    int *** farbenfelder;
#endif
    void initialisieren_hfv(int _h_gesamt, int _rang, int _zielrang_west, int _zielrang_ost, int _zielrang_nord, int _zielrang_sued);
private:
    int zielrang_west, zielrang_ost;
    int zielrang_nord, zielrang_sued;
    void ueberschreiben(int zielrang);
    void ueberschreiben_ns(int zielrang);
public:
    void finalisieren_hfv(void);
#ifdef KURZ_FF
    void initialisieren_fv1(int h, short int ** farbenfeld);
#else
    void initialisieren_fv1(int h, int ** farbenfeld);
#endif
private:
    int anfangssumme;
public:
    EP_s_bestimmen ** ep_updates;
public:
    int * m_h, * n_h;
    int * ep_ebenen;
private:
    void einpunktausgabe_LA(char * position);
private:
    char zeichenkette [70];
    };

#endif

