#ifndef FARBENUPDATE
#define FARBENUPDATE

#include <iostream>

using namespace std;

#include "ausgaben.h"
#include "feldliste.h"
#include "kommunikation4er.h"

#include "datei_ausgabe.h"

#include "ep_snb_update.h"

#define punkt_farbpunkt_einfuegen_0_ost fu_punkt_farbpunkt_einfuegen_0_ost()
#define punkt_farbpunkt_einfuegen_0_nordost fu_punkt_farbpunkt_einfuegen_0_nordost()
#define punkt_farbpunkt_einfuegen_0_suedost fu_punkt_farbpunkt_einfuegen_0_suedost()
#define punkt_farbpunkt_einfuegen_0_sued fu_punkt_farbpunkt_einfuegen_0_sued()
#define punkt_farbpunkt_einfuegen_0_suedwest fu_punkt_farbpunkt_einfuegen_0_suedwest()
#define punkt_farbpunkt_einfuegen_0_west fu_punkt_farbpunkt_einfuegen_0_west()
#define punkt_farbpunkt_einfuegen_0_nordwest fu_punkt_farbpunkt_einfuegen_0_nordwest()
#define punkt_farbpunkt_einfuegen_0_nord fu_punkt_farbpunkt_einfuegen_0_nord()

#define punkt_farbpunkt_einfuegen_2_ost fu_punkt_farbpunkt_einfuegen_2_ost()
#define punkt_farbpunkt_einfuegen_2_nordost fu_punkt_farbpunkt_einfuegen_2_nordost()
#define punkt_farbpunkt_einfuegen_2_suedost fu_punkt_farbpunkt_einfuegen_2_suedost()
#define punkt_farbpunkt_einfuegen_2_sued fu_punkt_farbpunkt_einfuegen_2_sued()
#define punkt_farbpunkt_einfuegen_2_suedwest fu_punkt_farbpunkt_einfuegen_2_suedwest()
#define punkt_farbpunkt_einfuegen_2_west fu_punkt_farbpunkt_einfuegen_2_west()
#define punkt_farbpunkt_einfuegen_2_nordwest fu_punkt_farbpunkt_einfuegen_2_nordwest()
#define punkt_farbpunkt_einfuegen_2_nord fu_punkt_farbpunkt_einfuegen_2_nord()

#define punkt_farbpunkt_entfernen_ost fu_punkt_farbpunkt_entfernen_ost()
#define punkt_farbpunkt_entfernen_nordost fu_punkt_farbpunkt_entfernen_nordost()
#define punkt_farbpunkt_entfernen_suedost fu_punkt_farbpunkt_entfernen_suedost()
#define punkt_farbpunkt_entfernen_sued fu_punkt_farbpunkt_entfernen_sued()
#define punkt_farbpunkt_entfernen_suedwest fu_punkt_farbpunkt_entfernen_suedwest()
#define punkt_farbpunkt_entfernen_west fu_punkt_farbpunkt_entfernen_west()
#define punkt_farbpunkt_entfernen_nordwest fu_punkt_farbpunkt_entfernen_nordwest()
#define punkt_farbpunkt_entfernen_nord fu_punkt_farbpunkt_entfernen_nord()

#define HR_OST 0
#define HR_SUED 8
#define HR_WEST 16
#define HR_NORD 24

class FarbenUpdate
    {
private:
    int ** feingitter_snb;
    short int ** ep_ff;
    FeldListe * dynamischer_rand;
    Kommunikation4er * kommunikation4er;

public:
    void initialisieren(short int ** _fgff, short int ** _ggff, int ** _feingitter_snb, short int ** _ep_ff, FeldListe * _dynamischer_rand, Kommunikation4er * _kommunikation4er, int * _PT_feingitter, DateiAusgabe * _da_fu, int ** _grobgitter_feld, int ** _feingitter_feld, EP_SNBupdate * _ep_snb_update);
    void finalisieren(void);
    void initialisieren_punkte(short int * _punkte_f, short int * _punkte_g);
    void vervollstaendigen(void);
private:
    int f, g;
private:
public: // Spter wieder umkehren 20.10.14
    short int ** fgff;
private:
    short int ** ggff;
    int * PT_feingitter;
private:
    int groesse, rang;
    int m, n;
    int m_minus1, n_minus1;
private:
    int i, j;
private:
    char * empfangsbuffer;
private:
    int anfangsposition;
    int endposition;
private:
    DateiAusgabe * da_fu;
private:
    int farb_information;
public:
    short int * f2, * g2;
public:
    int anzahl2;
public:
    short int * punkte_f, * punkte_g;
private:
    int punkteanzahl;
private:
    int fgff_speichern;
private:
    int fgff_eintrag;
    int farbe;
    int eintrag;
private:
    PunktFeldListe punktfeldliste; // Fr den 'Gegentest': Ob alle fehlenden Punkte getroffen wurden.
    PunktFeldListe unwissende_punkte;
private:
    int snb_ep_ff;
    int ep_ff_wert;
    int farbe1, farbe2;
    int koord_f_1, koord_g_1;
    int aggregierter_wert;
    int aggregierter_wertHR;
private:
    char * merken;
    short int * merken_si;
    short int lese_short_int(int index);
public:
    void einfuegen(void);
    void entfernen(void);
    void vervollstaendigen_einfuegen(void);
    void vervollstaendigen_entfernen(void);
private:
    int f_schlange, g_schlange;
private:
    void fu_farbpunkt_einfuegen_nordost_funktion(void);
    void fu_farbpunkt_einfuegen_nordwest_funktion(void);
    void fu_farbpunkt_einfuegen_suedost_funktion(void);
    void fu_farbpunkt_einfuegen_suedwest_funktion(void);

    void entfernen_ein_punkt(void);
private:
    int f_d_2, g_d_2;
    int ** grobgitter_feld;
    int ** feingitter_feld;
private:
    void einfuegen_ein_punkt_ep_ff_0(int _f, int _g);
    void einfuegen_ein_punkt_ep_ff_2(int _f, int _g);
    void entfernen_ein_punkt(int _f, int _g);

    void fu_punkt_farbpunkt_einfuegen_0_ost(void);
    void fu_punkt_farbpunkt_einfuegen_0_nordost(void);
    void fu_punkt_farbpunkt_einfuegen_0_suedost(void);
    void fu_punkt_farbpunkt_einfuegen_0_sued(void);
    void fu_punkt_farbpunkt_einfuegen_0_suedwest(void);
    void fu_punkt_farbpunkt_einfuegen_0_west(void);
    void fu_punkt_farbpunkt_einfuegen_0_nordwest(void);
    void fu_punkt_farbpunkt_einfuegen_0_nord(void);

    void direktes_einfuegen0(void);
    void direktes_einfuegen2(void);
    void direktes_entfernen(void);

    void indirektes_einfuegen0_ost(void);
    void indirektes_einfuegen0_west(void);
    void indirektes_einfuegen0_nord(void);
    void indirektes_einfuegen0_sued(void);

    void indirektes_einfuegen0_nordost(void);
    void indirektes_einfuegen0_nordwest(void);
    void indirektes_einfuegen0_suedost(void);
    void indirektes_einfuegen0_suedwest(void);

    void indirekter_farbpunkt(int f_s, int g_s);
    void indirekter_farbpunkt_entfernen(int f_s, int g_s);
private:
    short int farbe_short_int;
    char farbe_char;
    char farbe_char_m1;
    short int f_si, g_si;

    void fu_punkt_farbpunkt_einfuegen_2_ost(void);
    void fu_punkt_farbpunkt_einfuegen_2_nordost(void);
    void fu_punkt_farbpunkt_einfuegen_2_suedost(void);
    void fu_punkt_farbpunkt_einfuegen_2_sued(void);
    void fu_punkt_farbpunkt_einfuegen_2_suedwest(void);
    void fu_punkt_farbpunkt_einfuegen_2_west(void);
    void fu_punkt_farbpunkt_einfuegen_2_nordwest(void);
    void fu_punkt_farbpunkt_einfuegen_2_nord(void);

    void fu_punkt_farbpunkt_entfernen_ost(void);
    void fu_punkt_farbpunkt_entfernen_nordost(void);
    void fu_punkt_farbpunkt_entfernen_suedost(void);
    void fu_punkt_farbpunkt_entfernen_sued(void);
    void fu_punkt_farbpunkt_entfernen_suedwest(void);
    void fu_punkt_farbpunkt_entfernen_west(void);
    void fu_punkt_farbpunkt_entfernen_nordwest(void);
    void fu_punkt_farbpunkt_entfernen_nord(void);

    void indirektes_entfernen_ost(void);
    void indirektes_entfernen_sued(void);
    void indirektes_entfernen_west(void);
    void indirektes_entfernen_nord(void);
private:
    void fgff_ausgabe(void);
private:
    short int ggff_speichern;
private:
    bool ist_unwissend(int f, int g);
public:
    void reset_unwissend(void);
public:
    DateiAusgabe * da_eez;
public:
    int iterationen;
private:
    int anzahl;
private:
    bool auf_alpha_eingefuegt;
private:
    int erweitertes_snb_0;
private:
    void stellvertretendes_einfuegen(void);

    void stellvertretend_ost(void);
    void stellvertretend_west(void);
    void stellvertretend_nord(void);
    void stellvertretend_sued(void);

    void stellvertretend_nordost(void);
    void stellvertretend_nordwest(void);
    void stellvertretend_suedost(void);
    void stellvertretend_suedwest(void);

    void stellvertretend_nord_nordost(void);
    void stellvertretend_nord_nordwest(void);
    void stellvertretend_sued_suedost(void);
    void stellvertretend_sued_suedwest(void);

    void stellvertretend_ost_nordost(void);
    void stellvertretend_west_nordwest(void);
    void stellvertretend_ost_suedost(void);
    void stellvertretend_west_suedwest(void);
private:
    int farbe_schlange;
private:
    EP_SNBupdate * ep_snb_update;
    int f_grob, g_grob;
private:
    void entfernen_korrigieren_sued(void);
    void entfernen_korrigieren_suedwest(void);
    void entfernen_korrigieren_west(void);
    void entfernen_korrigieren_nordwest(void);
    void entfernen_korrigieren_suedost(void);
    void entfernen_korrigieren_ost(void);
    void entfernen_korrigieren_nordost(void);
    void entfernen_korrigieren_nord(void);
    void entfernen_korrigieren(void);
private:
    int ggff_hilfe;
    int fgff_hilfe;
private:
    void stellvertretung_fg_gleich_gg_nord(void);
    void stellvertretung_fg_gleich_gg_sued(void);
    void stellvertretung_fg_gleich_gg_west(void);
    void stellvertretung_fg_gleich_gg_ost(void);
public:
    int t;
public:
    short int ** ep_snb;
    short int ** feld_aktuell;
    int f_schlange_div_2, g_schlange_div_2;
private:
    void test2fu(char * wo);
    void test3fu(char * wo);
private:
    char text[10];
private:
    void test_entfernen(int ff, int gg, int farbe_ff_gg, char * stelle);
    void test_einfuegen(int f_p, int g_p, char farbe_char, int farbe_zielprozessor, char * stelle);
    };

#endif

