#include "farbmatrix.h"

// Kommentar: Hier wird zweierlei bestimmt: Einmal zur Anzahl der Kerne - gekennzeichnet durch die Variable groesse -
// die Kernanzahl in x - und y - Richtung. Und dann die Angabe zu den Himmelsrichtungen Nord, Ost, Sd und West, welcher Kern
// sich in dieser Himmelsrichtung zu dem Kern mit der ID befindet. Das kann man hinterher in nord(ID), ost(ID) usw.
// abfragen.

// Kommentar: Hier wird der Speicherplatz, der fr diese Klasse gebraucht wird, wieder freigegeben.
void FarbMatrix::beenden(void)
    {
    delete west;
    delete ost;
    delete nord;
    delete sued;
    }

// Kommentar: Hier wird der bentigte Speicherplatz angelegt, und die oben angegebenen Informationen werden bestimmt - fr
// die Flle groesse ist 1, 4 oder 16.
void FarbMatrix::starten(int _groesse)
    {
// Wird durch beenden finalisiert.

// Kommentar: Der Parameter groesse wird gespeichert.
    groesse = _groesse;

// Kommentar: Je nach dem Wert von groesse wird die Anzahl an Kernen in Ost - West durch m bzw. Nord - Sd - Richtung durch n
// bestimmt.

    switch(groesse)
        {
        case 1:
            m = 1;
            n = 1;
            break;
        case 2:
            m = 2;
            n = 1;
            break;
        case 4:
            m = 2;
            n = 2;
            break;
        case 8:
            m = 4;
            n = 2;
        case 16:
            m = 4;
            n = 4;
            break;
        }

// Hier wird der Speicherplatz fr die Strukturen west, ost, nord und sued angelegt,
    west = new int [groesse];
    ost = new int [groesse];
    nord = new int [groesse];
    sued = new int [groesse];

// Kommentar: Je nachdem, wie der Wert von groesse ist, werden zu allen Kernen der nrdliche, sdliche, stliche und westliche
// Kern dazu angegeben. Existiert kein Kern, dann wird -1 an dieser Stelle angegeben.
    switch(groesse)
        {
// Kommentar: Fr die Flle 1 und 4 wird das 'per Hand' ausgerechnet.
        case 1:
            west[0] = -1;
            ost[0] = -1;
            nord[0] = -1;
            sued[0] = -1;
            break;
        case 2:
            west[0] = -1;
            ost[0] = 1;
            nord[0] = -1;
            sued[0] = -1;
            ost[1] = -1;
            west[1] = 0;
            nord[1] = -1;
            sued[1] = -1;
            break;
        case 4:
            west[0] = -1;
            west[1] = 0;
            west[2] = -1;
            west[3] = 2;
            ost[0] = 1;
            ost[1] = -1;
            ost[2] = 3;
            ost[3] = -1;
            nord[0] = -1;
            nord[1] = -1;
            nord[2] = 0;
            nord[3] = 1;
            sued[0] = 2;
            sued[1] = 3;
            sued[2] = -1;
            sued[3] = -1;
            break;
        case 8:
            west[0] = -1;
            west[1] = 0;
            west[2] = 1;
            west[3] = 2;
            west[4] = -1;
            west[5] = 4;
            west[6] = 5;
            west[7] = 6;
            ost[0] = 1;
            ost[1] = 2;
            ost[2] = 3;
            ost[3] = -1;
            ost[4] = 5;
            ost[5] = 6;
            ost[6] = 7;
            ost[7] = -1;
            for(i=0;i<4; i++)
                {
                nord[i] = -1;
                nord[i+4] = i;
                sued[i+4] = -1;
                sued[i] = i+4;
                }
            break;
// Kommentar: Fr den Fall 16 wird das per Schleifen bestimmt. Es wird der Fall 'west' verdeutlicht.
        case 16:
// Kommentar: Der westliche Kern hat im Allgemeinen eine um 1 niedrigere ID.
            for(i=0; i<groesse; i++)
                {
                west[i] = i-1;
                }
// Kommentar: Wenn der Kern aber am westlichen Rand liegt - was fr die ID'S 0, 4, 8 und 12 der Fall ist, hat man westlich davon
// eine ID von -1. In den Fllen wird die ID i-1 davon nerschrieben.
            for(i=0; i<groesse; i= i+4)
                {
                west[i] = -1;
                }
// Kommentar: Die anderen Flle gelten analog.
            for(i=0; i<groesse; i++)
                {
                ost[i] = i+1;
                }
            for(i=3; i<groesse; i=i+4)
                {
                ost[i] = -1;
                }
            for(i=4; i<groesse; i++)
                {
                nord[i] = i-4;
                }
            for(i=0; i<4; i++)
                {
                nord[i] = -1;
                }
            for(i=0; i<12; i++)
                {
                sued[i] = i+4;
                }
            for(i=12; i<16; i++)
                {
                sued[i] = -1;
                }
            break;
        }
    }
