#include "feldliste_sortiert.h"

// Kommentar: Die sortierte Feldliste besteht aus 1-dim. West-Ost Feldlisten. Die Anzahl an Punkten pro Feldliste wird in anzahl_f gespeichert.
// Beim Durchlauf durch die Liste muss die Schnittstelle der Feldliste erhalten bleiben. Also: Setzen der Liste an den Anfang, die Wahl des nchsten
// Elementes, und die Prfung, ob das Ende der Liste erreicht ist. Ferner das Lesen der Koordinaten. Um die Position in der Liste festzulegen
// hat man die f-Koordinate aktuelles_f, die Position in der 1-dim. Feldliste bzgl. aktuelles_f sowie die entsprechende Positionierung in der 1-dim. Feldliste.

// Kommentar: Hier erfolgt eine Prfung, ob die Feldliste leer ist.
bool FeldListeSortiert::ist_leer(void)
    {
// Kommentar: Durch die Gesamtpunktanzahl wird erkannt, ob die Liste leer ist.
    if(gesamtanzahl==0)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Hier wird zum Durchlaufen der Liste von einer Position der Liste zur nchsten Position gegangen. Dafr wird entweder das nchste Element in der
// 1-dim.-Feldliste markiert, und falls man am Ende der Feldliste ist, wird die nchste nichtleere 1-dim. Feldliste gesucht, und der erste Eintrag markiert.
void FeldListeSortiert::naechster(void)
    {
// Kommentar: Das Feld nchster zeigt immer auf den nchsten Eintrag, und der Index Position gibt an, wieviele Eintrge schon gelesen wurden. Ist er gleich
// der Gesamtanzahl, ist man am Listenende angekommen, und es kann kein nchster Eintrag bestimmt werden. Durch position++ wird dann aber das Listenende markiert.
    if(position<gesamtanzahl)
        {
        position++;
        if(nummer_f<anzahl_f[aktuelles_f])
            {
            nummer_f++;
            wo_feldlisten[aktuelles_f].naechster();
            }
        else
            {
            for(aktuelles_f++;anzahl_f[aktuelles_f]==0;aktuelles_f++)
                {
                ;
                }
            wo_feldlisten[aktuelles_f].anfangsposition();
            nummer_f = 1;
            }
        }
    else
        {
        position++;
        }
//    cout << " Position " << position << " Gesamtanzahl " << gesamtanzahl << endl;
    }

// Kommentar: Hier wird geprft, ob man beim Durchlauf am Ende der Liste angekommen ist.
bool FeldListeSortiert::ist_fertig_fl(void)
    {
// Kommentar: Bei leerer Liste ist man immer am Listenende angekommen. Ansonsten gibt der Vergleich der Variablen position und gesamtanzahl an, ob das Listenende erreicht ist.
    if(gesamtanzahl==0)
        {
        return(true);
        }
    if(position > gesamtanzahl)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Es werden die Koordinaten des aktuellen Listenelementes gelesen. Zuerst die Koordinate f, die durch die Variable aktuelles_f festgelegt ist.
int FeldListeSortiert::lesen_f(void)
    {
// Kommentar: Man gibt f an der Stelle des aktuellen Indexes position zurck.
    return(aktuelles_f);
    }

// Kommentar: Dann wird die Koordinate g gelesen. Dieses erfolgt durch die WO-Feldliste.
int FeldListeSortiert::lesen_g(void)
    {
    return(wo_feldlisten[aktuelles_f].lesen());
    }

// Kommentar: Die Anfangsposition der zu lesenden Elemente wird gesetzt. Das ist nicht die Anfangsposition der Liste selber.
void FeldListeSortiert::anfangsposition(void)
    {
// Kommentar: Falls die Liste nicht leer ist, gibt die Variable nord den Wert fr aktuelles f an, die Position ist 1, und die 1-d-Feldliste in Bezug auf aktuelles_f
// wird an den Anfang gesetzt.
    if(gesamtanzahl>=1)
        {
        position = 1;
        aktuelles_f = nord;
        nummer_f = 1;
        wo_feldlisten[aktuelles_f].anfangsposition();
        }
    }

// Kommentar: Am Anfang wird die Struktur geleert.
void FeldListeSortiert::leeren(void)
    {
// Zuerst werden die Feldlisten geleert, und anzahl_f auf 0 gesetzt, wo das nicht schon der Fall ist.
    for(i=nord; i<=sued; i++)
        {
        if(anzahl_f[i]>=1)
            {
            wo_feldlisten[i].leeren();
            anzahl_f[i] = 0;
            }
        }

// Kommentar: Die Gesamtanzahl und die Variablen nord und sued werden fr eine leere Liste gesetzt.
    gesamtanzahl = 0;
    sued = -1;
    nord = nn;

// Kommentar: Und dann wird das Feld gelscht. Das hier macht man nur am Anfang, weil das Lschen des Feldes auf diese Weise
// sonst schneller machbar ist ber einen Durchlauf durch die Liste.
    for(i=0; i<nn; i++)
        {
        for(j=0; j < mm; j++)
            {
            feld[i][j] = -1;
            }
        }
    }

// Kommentar: Hier wird die Feldliste komplett gefllt.
void FeldListeSortiert::fuellen(void)
    {
// Kommentar: Zuerst werden die Feldlisten geleert, und das 1-d-Feld anzahl_f auf 0 gesetzt.
    for(i=nord; i<=sued; i++)
        {
        if(anzahl_f[i]>=1)
            {
            wo_feldlisten[i].leeren();
            anzahl_f[i] = 0;
            }
        }
// Kommentar: Dann werden alle Punkte eingefgt.
    gesamtanzahl = 0;
    for(i=0; i<nn; i++)
        {
        for(j=0; j < mm; j++)
            {
            einfuegen_fl(i,j);
            }
        }
// Kommentar: Und am Ende werden die Variablen nord und sued fr ein volles Gitter auf 0 und n-1 gesetzt.
    nord = 0;
    sued = nn-1;
    }

// Kommentar: Hier wird die Feldliste initialisiert. Dafr werden alle verwendeten Felder angelegt, und die Startwerte einer leeren Liste gesetzt.
void FeldListeSortiert::initialisieren_fl(int _n, int _m, int _rang)
// finalisieren hier OK.
    {
// Kommentar: Die Parameter werden gespeichert.
    nn = _n;
    mm = _m;
    rang_fl = _rang;
    n_plus2 = _n+2;
    m_plus2 = _m+2;

    gesamtanzahl = 0;
    anzahl_f = new int [nn];
    for(i=0; i<nn; i++)
        {
        anzahl_f[i] = 0;
        }

    wo_feldlisten = new FeldListe1D[nn];
    for(i=0; i<nn; i++)
        {
        wo_feldlisten[i].initialisieren(mm);
        }
    nord = nn;
    sued = -1;

    feld_speichern = new int * [n_plus2];
    feld = new int * [n_plus2];
    for(i=0; i<n_plus2; i++)
        {
        feld_speichern[i] = new int [m_plus2];
        for(j=0; j < m_plus2; j++)
            {
            feld_speichern[i][j] = -1;
            }
        }
    for(i=0; i<n_plus2; i++)
        {
        feld[i] = feld_speichern[i] +1;
        }

    feld = feld + 1;
    }

// Komemntar: Hier wird der Speicherplatz, der beim Initialisieren angelegt worden ist, wieder freigegeben.
void FeldListeSortiert::finalisieren_fl(void)
    {

    for(i=0; i<nn; i++)
        {
        wo_feldlisten[i].finalisieren();
        }
    delete wo_feldlisten;
    delete anzahl_f;

    for(i=0; i<n_plus2; i++)
        {
        delete feld_speichern[i];
        }
    delete feld_speichern;
    feld = feld - 1;
    delete feld;
    }

// Kommentar: Hier wird ein Element der Liste hinzugefgt, indem es in die entsprechende 1-d-Feldliste eingefgt und das entsprechende anzahl_f Feld inkrementiert wird.
// Dann mssen noch die Variablen nord und sued ggf. angepasst werden. Schlielich wird die Listenlnge um 1 erhht, und das Feld so markiert, dass klar ist, dass
// der Punkt auf diesem Kern existiert.
void FeldListeSortiert::einfuegen_fl(int ff, int gg)
    {
    anzahl_f[ff]++;
    wo_feldlisten[ff].einfuegen(gg);
    if(ff<nord)
        {
        nord = ff;
        }
    if(ff>sued)
        {
        sued = ff;
        }
    gesamtanzahl++;
    feld[ff][gg] = 4;
    }

// Kommentar: Hier wird ein Element der Liste entfernt. Hier wird alles umgekehrt gemacht wie beim Einfgen. Nur bei der Aktualisierung von nord und sued
// muss ggf. die nchste nichtleere Feldliste gesucht werden.
void FeldListeSortiert::entfernen_fl(int ff, int gg)
    {
    feld[ff][gg] = -1;
    gesamtanzahl--;
    wo_feldlisten[ff].entfernen(gg);
    anzahl_f[ff]--;
    if(gesamtanzahl==0)
        {
        sued = -1;
        nord = nn;
        }
    else
        {
        if((ff==nord)&&(anzahl_f[ff]==0))
            {
            for(i=ff+1; anzahl_f[i]==0;i++)
                {
                ;
                }
            nord = i;
            }
        if((ff==sued)&&(anzahl_f[ff]==0))
            {
            for(i=ff-1; anzahl_f[i]==0;i--)
                {
                ;
                }
            sued = i;
            }
        }
    }

// Kommentar: Hier wird der Wert des 2 - dimensionalen Feldes zurckgegeben, damit geprft werden kann, ob es auf der Position
// (ff,gg) einen Punkt in der Liste gibt.
int FeldListeSortiert::teste_f(int ff, int gg)
// Wird -1 sein, genau dann, wenn in (ff, gg) kein Punkt mehr ist.
// Das geht nur mit feld[ff][gg] = -1 beim loeschen.
    {
    nummer = feld[ff][gg];
    return(nummer);
    }
