#include "gemeinsame_buffer.h"

// Kommentar: Bei dieser Klasse werden Buffer angelegt, die mehrfach verwendet werden sollen.

// Kommentar: Es werden Parameter bergeben, und gem dieser Parameter wird Speicherplatz allokiert.
void GemeinsameBuffer::initialisieren(int _n, int _m, int _groesse, int _rang, int _h_kappe, int _oben_nicht_adaptiv)
    {
// Kommentar: m, n, groesse und rang werden bergeben, mn und mn2 werden berechnet.
    n = _n;
    m = _m;
    groesse = _groesse;
    rang = _rang;
    h_kappe = _h_kappe;
    oben_nicht_adaptiv = _oben_nicht_adaptiv;
    mn = m*n;
    mn2 = mn*2;
    mn2_plus1 = mn2 + 1;
    mn4_plus2 = mn2_plus1 * 2;
    if((h_kappe!=-1)&&(oben_nicht_adaptiv==false))
        {
        buffergroesse = mn2;
        }
    else
        {
        buffergroesse = mn;
        }

// Kommentar: Es werden Zeiger auf eine Liste von Sendebuffern und Empfangsbuffern angelegt. Es handelt sich dabei um double - Buffer.
    sendebuffer = new double * [groesse];
    empfangsbuffer = new double * [groesse];
// Kommentar: Zu jedem anderen Kern wird ein double - Sende - und Empfangsbuffer angelegt.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            sendebuffer[i] = new double [buffergroesse]; // nderung 10.11.15
            empfangsbuffer[i] = new double [buffergroesse];
            }
        }
#ifdef GEMEINSAME_BUFFER_SI
// Kommentar: Bei Definition dieser Prprozessorvariablen werden zu jedem anderen Kern short int Buffer der Lnge mn2 angelegt.
    sendebuffer_si = new short int * [groesse];
    empfangsbuffer_si = new short int * [groesse];
    for(i=0; i<groesse; i++)
        {
            {
            sendebuffer_si[i] = new short int [mn4_plus2];
            empfangsbuffer_si[i] = &(sendebuffer_si[i][mn2_plus1]);
            }
        }
#endif
    }

// Kommentar: Die eben angelegten Buffer werden finalisiert, wobei die Short Int Buffer nur freigegeben werden, wenn die
// Prprozessorvariable definiert ist.
void GemeinsameBuffer::finalisieren(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete sendebuffer[i];
            delete empfangsbuffer[i];
#ifdef GEMEINSAME_BUFFER_SI
            delete sendebuffer_si[i];
#endif
            }
        }
    delete sendebuffer;
    delete empfangsbuffer;
#ifdef GEMEINSAME_BUFFER_SI
    delete sendebuffer_si[rang];
    delete sendebuffer_si;
    delete empfangsbuffer_si; // hinzugenommen: nderung vom 6.2.16
#endif
    }
