#include "gitter_sammeln.h"

// Kommentar: Die Idee dieser Klasse besteht darin, alle Punkte des Gitters vektoriell in einen Buffer zu sammeln,
// um dieses beispielsweise auszugeben.

// Kommentar: Die Klasse wird initialisiert. Dabei werden die Gittermae, der Rang sowie das 2 - dimensionale Feld der Feldliste
// bergeben.
void GitterSammeln::initialisieren_gitter_sammeln(int _n, int _m, int ** _feld_sammeln, int _rang)
    {
// Kommentar: Speichern der bergabeparameter
    nn = _n;
    mm = _m;

    n_minus1 = nn - 1;
    m_minus1 = mm - 1;

    rang_gs = _rang;

// Kommentar: Anlegen einer Punktfeldliste der richtigen Gre - entsprechend den bergebenen Variablen.
    pfl.initialisierung(mm,nn);
    feld_sammeln = _feld_sammeln;
    feld_pfl = pfl.feld;
    }

// Kommentar: Bei der Finalisierung wird nur der Speicherplatz der Punktfeldliste freigegeben.
void GitterSammeln::finalisieren_gitter_sammeln(void)
    {
    pfl.finalisierung();
    }

// Kommentar: Die Anfangsposition des zu schreibenden Buffers wird gesetzt.
void GitterSammeln::sammeln_start(void)
    {
    index_sammeln = 2;
    }

// Kommentar: Ist der Buffer geschrieben, kann die Punktfeldliste wieder freigegeben werden.
void GitterSammeln::sammeln_ende(void)
    {
    pfl.reset();
    }

// Kommentar: Zu jedem Punkt werden die nrdlichen und sdlichen Punkte in einen Vektor zusammengefat.
void GitterSammeln::sammeln_punkt_bearbeiten_nord_sued(int _f, int _g)
    {
// Kommentar: Die bergebenen Parameter werden gespeichert.
    f = _f;
    g = _g;
// Kommentar: Gab es schon einen Eintrag, dann wurde dieser Punkt schon bearbeitet.
    if(feld_pfl[f][g]!=-1)
        {
        return;
        }
// Kommentar: Bestimme, wie weit nach Norden und Sden gegangen werden kann, ohne das dazwischen eine Lcke entsteht - d.h. ein
// Punkt dazwischen nicht auf diesem Gitter existiert.
    f_noerdlich = sammeln_nord();
    f_suedlich = sammeln_sued();
// Kommentar: Speichere diesen Gitter - Vektor im Buffer.
    koordinaten[index_sammeln++] = f_noerdlich;
    koordinaten[index_sammeln++] = f_suedlich;
    koordinaten[index_sammeln++] = g;
// Komemntar: Und markiere alle im Vektor enthaltenen Punkte.
    for(i=f_noerdlich; i<=f_suedlich; i++)
        {
        pfl.hinzu(i, g);
        }
    }

// Kommentar: Man guckt, wie weit man nach Norden gehen kann, ohne das eine Lcke im Feld existiert.
int GitterSammeln::sammeln_nord(void)
    {
    for(i=f-1; i>=0; i--)
        {
        if(feld_sammeln[i][g]<0)
            {
            break;
            }
        }
    return(i+1);
    }

// Kommentar: Man guckt, wie weit man nach Sden gehen kann, ohne das eine Lcke im Feld existiert.
int GitterSammeln::sammeln_sued(void)
    {
    for(i=f+1; i<=m_minus1; i++)
        {
        if(feld_sammeln[i][g]<0)
            {
            break;
            }
        }
    return(i-1);
    }
