#include "grosse_lastausgleichssteuerung.h"

// Kommentar: Fhrt fr die PLB - Variante mit Matrix - Bestimmung die Simulation eines vollstndigen Lastausgleiches durch, wobei die Lasttransferwerte
// gespeichert werden. Die Variable ist_oben ist dabei auf true oder false gesetzt.
void GrosseLastAusgleichsSteuerung::tun(int _eigene_last, int _eigene_last_oben)
    {
// Kommentar: Die Lastmengen werden kopiert.
    eigene_last = _eigene_last;
    eigene_last_oben = _eigene_last_oben;

#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " GLAS rang " << rang << " eL " << eigene_last << " eLo " << eigene_last_oben << endl;
#endif // AKTUELLE_KOMMENTARE

// Kommentar: Die Lastmatrix wird bestimmt. Dabei wird die Klasse LastMengenBestimmung verwendet.
    bestimme_lastmatrix();

#ifdef AKTUELLE_KOMMENTARE_GLAS
    ausgabe_lastmatrix_mit();
#endif // AKTUELLE_KOMMENTARE

#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " Bestimme Lastmatrix durch rang " << rang << endl;
#endif

// Kommentar: Berechnet die Lastdurchschnitte in den Spalten der Lastmatrix.
    berechne_ns_durchschnitte();
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " Berechne ns_durchschnitte durch rang " << rang << endl;
#endif

// Kommentar: Berechnet die Lastdurchschnitte in den Zeilen der Lastmatrix.
    berechne_wo_durchschnitte();
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " Berechne wo_durchschnitte durch rang " << rang << endl;
#endif

// Kommentar: Bestimme das Maximum der Durchschnitte der Spalten der Lastmatrix
    bestimme_max_ns();
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " bestimme_max_ns durch rang " << rang << endl;
#endif

// Kommentar: Bestimme das Maximum der Durchschnitte der Zeilen der Lastmatrix
    bestimme_max_wo();
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " bestimme_max_wo durch rang " << rang << endl;
#endif

// Kommentar: Welches relative Maximum - nach WO oder NS - ist besser? Eine Bewertung also.
// Wenn das relative Maximum grer ist, whle den anderen Lastausgleich als erstes.
    if(max_ns > max_wo)
// Entscheidung, welcher Lastausgleich besser ist.
        {

// Kommentar: Fhre die West - Ost - Lastausgleichsrunden zuerst durch. Aber insgesamt werden beide durchgefhrt.
        was_zuerst = WO;
#ifdef AKTUELLE_KOMMENTARE_GLAS
        cout << " Vor erst_wo_dann_ns rang " << rang << endl;
#endif
        erst_wo_dann_ns();
        }
    else
        {
// Kommentar: Fhre die Nord - Sd - Lastausgleichsrunden zuerst durch. Aber insgesamt werden beide durchgefhrt.
        was_zuerst = NS;
#ifdef AKTUELLE_KOMMENTARE_GLAS
        cout << " Vor erst_ns_dann_wo rang " << rang << endl;
#endif
        erst_ns_dann_wo();
        }
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " grosseL.tun durch rang " << rang << endl;
#endif

// Kommentar: Eine Ausgabe - Funktion zu Debugging - Zwecken wird ausgefhrt.
#ifdef AKTUELLE_KOMMENTARE
    lastdifferenzen.ausgabe_indizes();
#endif
#ifdef NEUER_CODE

// Kommentar: Die Anzahl der Lastausgleichsrunden fr alle Lastzeilen wird mit Hilfe des maximalen WO - Lastausgleichsrundenindexes bestimmt.
// Denn fr alle Zeilen muss dieselbe Anzahl an Lastausgleichsrunden erfolgen - wenn auch mit Leerrunden.
    for(index_wo_max = indizes_wo[0], i=1; i<groesse_f; i++)
        {
        indizes_wo_i = indizes_wo[i];
        if(index_wo_max < indizes_wo_i)
            {
            index_wo_max = indizes_wo_i;
            }
        }

// Kommentar: Mache dasselbe fr die Nord - Sd - Lastausgleichsrundenindizes.
    for(index_ns_max = indizes_ns[0], i=1; i<groesse_g; i++)
        {
        indizes_ns_i = indizes_ns[i];
        if(index_ns_max < indizes_ns_i)
            {
            index_ns_max = indizes_ns_i;
            }
        }
// Dient alles dem Zweck, fr alle Prozessoren fr WO und NS dieselbe Anzahl an Lastausgleichsrunden zu schaffen,
// weil sie fr die Zwischenkorrektur des Lastausgleiches gebraucht werden.

// Kommentar: Speichere die eben berechneten Indizes ab.
    lastdifferenzen.index_wo = index_wo_max;
    lastdifferenzen.index_ns = index_ns_max;

    index_wo = indizes_wo[rang_f];
    index_ns = indizes_ns[rang_g];

// Kommentar: Im folgenden werden die Lasttransferwerte fr die Nullrunden gespeichert - damit alle Kerne dieselbe Anzahl an
// Lastausgleichsrunden durchfhren.
    if(ist_oben == true)
        {
        for(i=index_wo; i<index_wo_max; i++)
            {
            lastdifferenzen.west[i] = 0;
            lastdifferenzen.west_oben[i] = 0;
            lastdifferenzen.ost[i] = 0;
            lastdifferenzen.ost_oben[i] = 0;
            }
        for(i=index_ns; i<index_ns_max; i++)
            {
            lastdifferenzen.sued[i] = 0;
            lastdifferenzen.sued_oben[i] = 0;
            lastdifferenzen.nord[i] = 0;
            lastdifferenzen.nord_oben[i] = 0;
            }
        }
    else
        {
        for(i=index_wo; i<index_wo_max; i++)
            {
            lastdifferenzen.west[i] = 0;
            lastdifferenzen.ost[i] = 0;
            }
        for(i=index_ns; i<index_ns_max; i++)
            {
            lastdifferenzen.sued[i] = 0;
            lastdifferenzen.nord[i] = 0;
            }
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " GLAS rang " << rang << " was zuerst wo " << was_zuerst << endl;
    cout << " GLAS rang " << rang << " #wo " << index_wo << " #wo_max " << index_wo_max << " ";
    for(i=0; i<index_wo_max; i++)
        {
        cout  << " LTW " << i << " West " << lastdifferenzen.west[i] << " West-oben " << lastdifferenzen.west_oben[i];
        cout  << " Ost " << lastdifferenzen.ost[i] << " Ost-oben " << lastdifferenzen.ost_oben[i];
        }
    cout << endl;
    cout << " GLAS rang " << rang << " #ns " << index_ns << " #ns_max " << index_ns_max << " ";
    for(i=0; i<index_ns_max; i++)
        {
        cout << " LTW " << i << " Nord " << lastdifferenzen.nord[i] << " Nord-oben " << lastdifferenzen.nord_oben[i];
        cout << " Sued " << lastdifferenzen.sued[i] << " Sued-oben " << lastdifferenzen.sued_oben[i];
        }
    cout << endl;
#endif
#endif
    }

void GrosseLastAusgleichsSteuerung::tun_ohne_option(int _eigene_last, int _eigene_last_oben)
    {
// Kommentar: Die Lastmengen werden kopiert.
    eigene_last = _eigene_last;
    eigene_last_oben = _eigene_last_oben;

#ifdef AKTUELLE_KOMMENTARE
    cout << " GLAS rang " << rang << " eL " << eigene_last << " eLo " << eigene_last_oben << endl;
#endif // AKTUELLE_KOMMENTARE

// Kommentar: Die Lastmatrix wird bestimmt. Dabei wird die Klasse LastMengenBestimmung verwendet.
    bestimme_lastmatrix();

#ifdef AKTUELLE_KOMMENTARE
    ausgabe_lastmatrix_mit();
#endif // AKTUELLE_KOMMENTARE

#ifdef AKTUELLE_KOMMENTARE
    cout << " Bestimme Lastmatrix durch rang " << rang << endl;
#endif

#ifdef GLAS_ERST_WO_DANN_NS
    erst_wo_dann_ns();
    was_zuerst = WO;
#else
    erst_ns_dann_wo();
    was_zuerst = NS;
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " grosseL.tun durch rang " << rang << endl;
#endif

// Kommentar: Eine Ausgabe - Funktion zu Debugging - Zwecken wird ausgefhrt.
    lastdifferenzen.ausgabe_indizes();
#ifdef NEUER_CODE

// Kommentar: Die Anzahl der Lastausgleichsrunden fr alle Lastzeilen wird mit Hilfe des maximalen WO - Lastausgleichsrundenindexes bestimmt.
// Denn fr alle Zeilen muss dieselbe Anzahl an Lastausgleichsrunden erfolgen - wenn auch mit Leerrunden.
    for(index_wo_max = indizes_wo[0], i=1; i<groesse_f; i++)
        {
        indizes_wo_i = indizes_wo[i];
        if(index_wo_max < indizes_wo_i)
            {
            index_wo_max = indizes_wo_i;
            }
        }

// Kommentar: Mache dasselbe fr die Nord - Sd - Lastausgleichsrundenindizes.
    for(index_ns_max = indizes_ns[0], i=1; i<groesse_g; i++)
        {
        indizes_ns_i = indizes_ns[i];
        if(index_ns_max < indizes_ns_i)
            {
            index_ns_max = indizes_ns_i;
            }
        }
// Dient alles dem Zweck, fr alle Prozessoren fr WO und NS dieselbe Anzahl an Lastausgleichsrunden zu schaffen,
// weil sie fr die Zwischenkorrektur des Lastausgleiches gebraucht werden.

// Kommentar: Speichere die eben berechneten Indizes ab.
    lastdifferenzen.index_wo = index_wo_max;
    lastdifferenzen.index_ns = index_ns_max;

    index_wo = indizes_wo[rang_f];
    index_ns = indizes_ns[rang_g];

// Kommentar: Im folgenden werden die Lasttransferwerte fr die Nullrunden gespeichert - damit alle Kerne dieselbe Anzahl an
// Lastausgleichsrunden durchfhren.
    if(ist_oben == true)
        {
        for(i=index_wo; i<index_wo_max; i++)
            {
            lastdifferenzen.west[i] = 0;
            lastdifferenzen.west_oben[i] = 0;
            lastdifferenzen.ost[i] = 0;
            lastdifferenzen.ost_oben[i] = 0;
            }
        for(i=index_ns; i<index_ns_max; i++)
            {
            lastdifferenzen.sued[i] = 0;
            lastdifferenzen.sued_oben[i] = 0;
            lastdifferenzen.nord[i] = 0;
            lastdifferenzen.nord_oben[i] = 0;
            }
        }
    else
        {
        for(i=index_wo; i<index_wo_max; i++)
            {
            lastdifferenzen.west[i] = 0;
            lastdifferenzen.ost[i] = 0;
            }
        for(i=index_ns; i<index_ns_max; i++)
            {
            lastdifferenzen.sued[i] = 0;
            lastdifferenzen.nord[i] = 0;
            }
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " GLAS rang " << rang << " was zuerst wo " << was_zuerst << endl;
    cout << " GLAS rang " << rang << " #wo " << index_wo << " #wo_max " << index_wo_max << " ";
    for(i=0; i<index_wo_max; i++)
        {
        cout  << " LTW " << i << " West " << lastdifferenzen.west[i] << " West-oben " << lastdifferenzen.west_oben[i];
        cout  << " Ost " << lastdifferenzen.ost[i] << " Ost-oben " << lastdifferenzen.ost_oben[i];
        }
    cout << endl;
    cout << " GLAS rang " << rang << " #ns " << index_ns << " #ns_max " << index_ns_max << " ";
    for(i=0; i<index_ns_max; i++)
        {
        cout << " LTW " << i << " Nord " << lastdifferenzen.nord[i] << " Nord-oben " << lastdifferenzen.nord_oben[i];
        cout << " Sued " << lastdifferenzen.sued[i] << " Sued-oben " << lastdifferenzen.sued_oben[i];
        }
    cout << endl;
#endif
#endif
    }

// Kommentar: Man macht den vollstndigen Lastausgleich, indem alle dafr ntigen Lastausgleichsrunden erfolgen. Zuerst wird der Lastausgleich in Bezug
// auf die Zeilen der Lastmatrix - fr West nach Ost - durchgefhrt.
void GrosseLastAusgleichsSteuerung::erst_wo_dann_ns(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " In erst_wo_dann_ns rang_f " << rang_f << " groesse_f " << groesse_f << " rang " << rang << endl;
#endif

// Kommentar: Man geht die Lastzeilen durch.
    for(zeile=0; zeile<groesse_f; zeile++)
        {
#ifdef AKTUELLE_KOMMENTARE
        cout << " erst_wo_dann_ns zeile " << zeile << " rang " << rang << endl;
#endif

// Kommentar: Enthlt die Lastzeile den eigenen Kern, ...
        if(zeile==rang_f)
            {

// Kommentar: ... dann fhre die Lastsimulation nebst dem Abspeichern der Lasttransferwerte durch.
            mache_arbeitsvektor_iterationen_mit_deltaLM_wo();
            }
        else
            {
// Kommentar: ... ansonsten fhre die Lastsimulation ohne das Abspeichern der Lasttransferwerte durch. Hier muss die Nummer der Lastzeile mit bergeben werden.
            mache_arbeitsvektor_iterationen_ohne_deltaLM_wo(zeile);
            }
        }
#ifdef NEUER_CODE
// Kommentar: Die West - Ost - Lastausgleichsrunden - Anzahlen fr die zeilen != rang wurden schon gespeichert. Nun speichere diese Zahlen auch fr die Zeile mit
// dem eigenen Kern.
    index_wo = lastdifferenzen.index_wo;
    indizes_wo[rang_f] = index_wo;
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " erst wo_ns nach wo ");
    ausgabe_arbeitsmatrix(zeichenkette);
// Damit sind die wo Berechnungen abgeschlossen.
    cout << " In erst_wo_dann_ns: nach den wo - Berechnungen " << endl;
    cout << " In Glas: vor ns rang " << rang << " west " << lastdifferenzen.west[0] << " ost " << lastdifferenzen.ost[0] << endl;
#endif
#ifdef NEUER_CODE
// Kommentar: Nun mache dasselbe wie eben fr die Lastzeilen nun fr die Lastspalten, also den Nord - Sd - Lastausgleich.
    for(spalte=0; spalte<groesse_g; spalte++)
        {
        if(spalte==rang_g)
            {
            mache_arbeitsvektor_iterationen_mit_deltaLM_ns();
            }
        else
            {
            mache_arbeitsvektor_iterationen_ohne_deltaLM_ns(spalte);
            }
        }
    index_ns = lastdifferenzen.index_ns;
    indizes_ns[rang_g] = index_ns;
#else
    mache_arbeitsvektor_iterationen_mit_deltaLM_ns();
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " erst wo_ns nach ns ");
    ausgabe_arbeitsmatrix(zeichenkette);
    cout << " In Glas: nach ns rang " << rang << " west " << lastdifferenzen.west[0] << " ost " << lastdifferenzen.ost[0] << endl;
    cout << " In erst_wo_dann_ns: nach den ns - Berechnungen " << endl;
#endif
// Und: Das wars.
    }

// Kommentar: Diese Funktion ist analog zu erst_wo_dann_ns, nur in der Reihenflge erst Nord - Sd, dann West - Ost - der simulierten Lastausgleichsrunden.
// Kommentar: Da analog: Keine weiteren Kommentare dazu.
void GrosseLastAusgleichsSteuerung::erst_ns_dann_wo(void)
    {
    for(spalte=0; spalte<groesse_g; spalte++)
        {
        if(spalte==rang_g)
            {
            mache_arbeitsvektor_iterationen_mit_deltaLM_ns();
            }
        else
            {
            mache_arbeitsvektor_iterationen_ohne_deltaLM_ns(spalte);
            }
        }
// Damit sind die wo Berechnungen abgeschlossen.
#ifdef NEUER_CODE
    index_ns = lastdifferenzen.index_ns;
    indizes_ns[rang_g] = index_ns;
#endif
#ifdef NEUER_CODE
    for(zeile=0; zeile<groesse_f; zeile++)
        {
#ifdef AKTUELLE_KOMMENTARE
        cout << " erst_wo_dann_ns zeile " << zeile << " rang " << rang << endl;
#endif
        if(zeile==rang_f)
            {
            mache_arbeitsvektor_iterationen_mit_deltaLM_wo();
            }
        else
            {
            mache_arbeitsvektor_iterationen_ohne_deltaLM_wo(zeile);
            }
        }
    index_wo = lastdifferenzen.index_wo;
    indizes_wo[rang_f] = index_wo;
#else
    mache_arbeitsvektor_iterationen_mit_deltaLM_wo();
#endif
// Und: Das wars.
    }

// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_wo, siehe unten. Daher keine weiteren Kommentare.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_ns(void)
    {
    if(ist_oben==true)
        {
        mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_ns();
        }
    else
        {
        mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_ns();
        }
    }

// Kommentar: Analog zu kopiere_wo_arbeitsmatrix_nach_arbeitsvektor, siehe unten. Daher keine weiteren Kommentare.
void GrosseLastAusgleichsSteuerung::kopiere_ns_arbeitsmatrix_nach_arbeitsvektor(int spaltennummer)
    {
    for(i=0; i<groesse_f; i++)
        {
        arbeitsvektor[i] = arbeitsmatrix[i][spaltennummer];
        }
    }

// Kommentar: Analog zu kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren, siehe unten. Daher keine weiteren Kommentare.
void GrosseLastAusgleichsSteuerung::kopiere_ns_arbeitsmatrix_nach_arbeitsvektoren(int spaltennummer)
    {
    for(i=0; i<groesse_f; i++)
        {
        arbeitsvektor[i] = arbeitsmatrix[i][spaltennummer];
        arbeitsvektor_oben[i] = arbeitsmatrix_oben[i][spaltennummer];
        }
    }

// Kommentar: Analog zu kopiere_wo_arbeitsvektor_nach_arbeitsmatrix, siehe unten. Daher keine weiteren Kommentare.
void GrosseLastAusgleichsSteuerung::kopiere_ns_arbeitsvektor_nach_arbeitsmatrix(int spaltennummer)
    {
    for(i=0; i<groesse_f; i++)
        {
        arbeitsmatrix[i][spaltennummer] = arbeitsvektor[i];
        }
    }

// Kommentar: Analog zu kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix, siehe unten. Daher keine weiteren Kommentare.
void GrosseLastAusgleichsSteuerung::kopiere_ns_arbeitsvektoren_nach_arbeitsmatrix(int spaltennummer)
    {
    for(i=0; i<groesse_f; i++)
        {
        arbeitsmatrix[i][spaltennummer] = arbeitsvektor[i];
        arbeitsmatrix_oben[i][spaltennummer] = arbeitsvektor_oben[i];
        }
    }

// Kommentar: Hier wird die Zeile der Nummer zeilennummer in den Arbeitsvektor kopiert.
void GrosseLastAusgleichsSteuerung::kopiere_wo_arbeitsmatrix_nach_arbeitsvektor(int zeilennummer)
    {
    for(i=0; i<groesse_g; i++)
        {
        arbeitsvektor[i] = arbeitsmatrix[zeilennummer][i];
        }
    }

// Kommentar: Hier wird die Zeile der Nummer zeilennummer in den Arbeitsvektor kopiert, und die entsprechende Zeile
// der oberen Arbeitsmatrix in den arbeitsvektor_oben.
void GrosseLastAusgleichsSteuerung::kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren(int zeilennummer)
    {
    for(i=0; i<groesse_g; i++)
        {
        arbeitsvektor[i] = arbeitsmatrix[zeilennummer][i];
        arbeitsvektor_oben[i] = arbeitsmatrix_oben[zeilennummer][i];
        }
    }

// Kommentar: Hier wird der Arbeitsvektor in die Zeile der Nummer zeilennummer kopiert.
void GrosseLastAusgleichsSteuerung::kopiere_wo_arbeitsvektor_nach_arbeitsmatrix(int zeilennummer)
    {
    for(i=0; i<groesse_g; i++)
        {
        arbeitsmatrix[zeilennummer][i] = arbeitsvektor[i];
        }
    }

// Kommentar: Hier wird der Arbeitsvektor in die Zeile der Nummer zeilennummer kopiert. Mache dasselbe auch fr die obere
// Arbeitsmatrix und den oberen Arbeitsvektor.
void GrosseLastAusgleichsSteuerung::kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(int zeilennummer)
    {
    for(i=0; i<groesse_g; i++)
        {
        arbeitsmatrix[zeilennummer][i] = arbeitsvektor[i];
        arbeitsmatrix_oben[zeilennummer][i] = arbeitsvektor_oben[i];
        }
    }

// Kommentar: Analog zu ist_ausgeglichen_wo. Daher kein eigener Kommentar.
bool GrosseLastAusgleichsSteuerung::ist_ausgeglichen_ns(void)
    {
    int i;

    min_wert = arbeitsvektor[0];
    max_wert = min_wert;

    for(i=1; i<groesse_f; i++)
        {
        if(arbeitsvektor[i] < min_wert)
            {
            min_wert = arbeitsvektor[i];
            }
        if(arbeitsvektor[i] > max_wert)
            {
            max_wert = arbeitsvektor[i];
            }
        }
    if(min_wert+1>=max_wert)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Es wird geprft, ob die Last ausgeglichen ist, um die Lastausgleichsrunden beenden zu knnen.
bool GrosseLastAusgleichsSteuerung::ist_ausgeglichen_wo(void)
    {
    int i;

// Kommentar: Man bestimmt zuerst den Minimalwert und den Maximalwert der Arbeitsvektoreintrge.

    min_wert = arbeitsvektor[0];
    max_wert = min_wert;

    for(i=1; i<groesse_g; i++)
        {
        if(arbeitsvektor[i] < min_wert)
            {
            min_wert = arbeitsvektor[i];
            }
        if(arbeitsvektor[i] > max_wert)
            {
            max_wert = arbeitsvektor[i];
            }
        }

// Kommentar: Zum Minimalwert muss wegen Rundungen 1 addiert werden. Ist der Maximalwert nicht grer als das, kann man von
// einem vollstndigen Lastausgleich ausgehen.
    if(min_wert+1>=max_wert)
        {
        return(true);
        }
    return(false);
    }

#ifndef PLB_STANDARD
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_ns(void)
    {
    lastdifferenzen.reset_ns();
    // Geht mit nur einem / zwei Indizes, weil es nur so oft aufgerufen wird.
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektor(rang_g);
    for(;ist_ausgeglichen_ns()!=true;)
        {
        lastvektorauswertung_ns.ablauf_vektorupdate(arbeitsvektor);

        lastdifferenzen.hinzu_nord(lastvektorauswertung_ns.west_differenz_vektor[rang_f]);
        lastdifferenzen.hinzu_sued(lastvektorauswertung_ns.ost_differenz_vektor[rang_f]);
        lastdifferenzen.index_ns_inkrementieren();
        }
    kopiere_ns_arbeitsvektor_nach_arbeitsmatrix(rang_g);
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_ns(void)
    {
    lastdifferenzen.reset_ns();
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektor(rang_g);
    if(ist_ausgeglichen_ns()==true)
        {
        return;
        }
    lastvektorauswertung_ns.precomputation(arbeitsvektor);
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "NSmit");
    lastvektorauswertung_ns.ausgabe_vL(zeichenkette);
#endif

    do
        {
        lastvektorauswertung_ns.balancing();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "NS_mit");
        lastvektorauswertung_ns.ausgabe_bal(zeichenkette, lastdifferenzen.index_ns);
#endif

        lastdifferenzen.hinzu_nord(lastvektorauswertung_ns.west_differenz_vektor[rang_f]);
        lastdifferenzen.hinzu_sued(lastvektorauswertung_ns.ost_differenz_vektor[rang_f]);
        lastdifferenzen.index_ns_inkrementieren();
        }
    while(ist_ausgeglichen_ns()!=true);
    kopiere_ns_arbeitsvektor_nach_arbeitsmatrix(rang_g);
    }
#endif

#ifndef PLB_STANDARD
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_ns(void)
    {
    lastdifferenzen.reset_ns();
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektoren(rang_g);
    for(;ist_ausgeglichen_ns()!=true;)
        {
        lastvektorauswertung_ns.ablauf_vektorupdate(arbeitsvektor);

        lastdifferenzen.hinzu_nord(lastvektorauswertung_ns.west_differenz_vektor[rang_f]);
        lastdifferenzen.hinzu_sued(lastvektorauswertung_ns.ost_differenz_vektor[rang_f]);

        lastvektorauswertung_ns.ablauf_vektorupdate(arbeitsvektor_oben);

        lastdifferenzen.hinzu_nord_oben(lastvektorauswertung_ns.west_differenz_vektor[rang_f]);
        lastdifferenzen.hinzu_sued_oben(lastvektorauswertung_ns.ost_differenz_vektor[rang_f]);

        lastdifferenzen.index_ns_inkrementieren();
        }
#ifdef AKTUELLE_KOMMENTARE
    lastdifferenzen.ausgabe_ns();
    lastdifferenzen.ausgabe_ns_oben();
    lastdifferenzen.ausgabe_ns_ns_oben();
#endif
    kopiere_ns_arbeitsvektoren_nach_arbeitsmatrix(rang_g);
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_ns(void)
    {
    lastdifferenzen.reset_ns();
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektoren(rang_g);
    if(ist_ausgeglichen_ns()==true)
        {
        return;
        }
    lastvektorauswertung_ns.precomputation(arbeitsvektor);
    lastvektorauswertung_ns_oben.precomputation(arbeitsvektor_oben);
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "NSmit");
    lastvektorauswertung_ns.ausgabe_vL(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "NSmit_oben");
    lastvektorauswertung_ns_oben.ausgabe_vL(zeichenkette);
#endif
    do
        {
        lastvektorauswertung_ns.balancing();
        lastvektorauswertung_ns_oben.balancing();

#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "NS_mit");
        lastvektorauswertung_ns.ausgabe_bal(zeichenkette, lastdifferenzen.index_ns);
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "NS_mit_oben");
        lastvektorauswertung_ns_oben.ausgabe_bal(zeichenkette, lastdifferenzen.index_ns);
#endif

        lastdifferenzen.hinzu_nord(lastvektorauswertung_ns.west_differenz_vektor[rang_f]);
        lastdifferenzen.hinzu_sued(lastvektorauswertung_ns.ost_differenz_vektor[rang_f]);

        lastdifferenzen.hinzu_nord_oben(lastvektorauswertung_ns_oben.west_differenz_vektor[rang_f]);
        lastdifferenzen.hinzu_sued_oben(lastvektorauswertung_ns_oben.ost_differenz_vektor[rang_f]);

        lastdifferenzen.index_ns_inkrementieren();
        }
    while(ist_ausgeglichen_ns()!=true);
    kopiere_ns_arbeitsvektoren_nach_arbeitsmatrix(rang_g);
    }
#endif
//////////////////////////////////////////////////
//////////////////////////////////////////////////

// Kommentar: Analog zu mache_arbeitsvektor_iterationen_ohne_deltaLM_wo, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_ns(int vektornummer)
    {
    if(ist_oben==true)
        {
        mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_ns(vektornummer);
        }
    else
        {
        mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_ns(vektornummer);
        }
    }

#ifndef PLB_STANDARD
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_wo, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_ns(int vektornummer)
    {
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektor(vektornummer);
#ifdef NEUER_CODE
    ein_index_ns = 0;
#endif
    for(;ist_ausgeglichen_ns()!=true;)
        {
        lastvektorauswertung_ns.ablauf_vektorupdate(arbeitsvektor);
#ifdef NEUER_CODE
        ein_index_ns++;
#endif
        }
#ifdef NEUER_CODE
    indizes_ns[vektornummer] = ein_index_ns;
#endif
    kopiere_ns_arbeitsvektor_nach_arbeitsmatrix(vektornummer);
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_ns(int vektornummer)
    {
    ein_index_ns = 0;
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektor(rang_g);
    if(ist_ausgeglichen_ns()==true)
        {
        indizes_ns[vektornummer] = 0;
        return;
        }
    lastvektorauswertung_ns.precomputation(arbeitsvektor);
#ifdef AKTUELLE_KOMMENTARE_OHNE
    lastvektorauswertung_ns.ausgabe_vL("NSohne");
#endif

    do
        {
        lastvektorauswertung_ns.balancing();
#ifdef AKTUELLE_KOMMENTARE_OHNE
        strcpy(zeichenkette, "NS_ohne");
        lastvektorauswertung_ns.ausgabe_bal(zeichenkette);
#endif
        ein_index_ns++;
        }
    while(ist_ausgeglichen_ns()!=true);
#ifdef NEUER_CODE
    indizes_ns[vektornummer] = ein_index_ns;
#endif
    kopiere_ns_arbeitsvektor_nach_arbeitsmatrix(rang_g);
    }
#endif

#ifndef PLB_STANDARD
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_wo, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_ns(int vektornummer)
    {
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektoren(vektornummer);
#ifdef NEUER_CODE
    ein_index_ns = 0;
#endif
    for(;ist_ausgeglichen_ns()!=true;)
        {
        lastvektorauswertung_ns.ablauf_vektorupdate(arbeitsvektor);
        lastvektorauswertung_ns.ablauf_vektorupdate(arbeitsvektor_oben);
#ifdef NEUER_CODE
        ein_index_ns++;
#endif
        }
#ifdef NEUER_CODE
    indizes_ns[vektornummer] = ein_index_ns;
#endif
    kopiere_ns_arbeitsvektoren_nach_arbeitsmatrix(vektornummer);
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#, siehe unten.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_ns(int vektornummer)
    {
    ein_index_ns = 0;
    kopiere_ns_arbeitsmatrix_nach_arbeitsvektoren(vektornummer);
    if(ist_ausgeglichen_ns()==true)
        {
        indizes_ns[vektornummer] = ein_index_ns;
        return;
        }
    lastvektorauswertung_ns.precomputation(arbeitsvektor);
    lastvektorauswertung_ns_oben.precomputation(arbeitsvektor_oben);
#ifdef AKTUELLE_KOMMENTARE_OHNE
    lastvektorauswertung_ns.ausgabe_vL("NSohne");
#endif
#ifdef AKTUELLE_KOMMENTARE_OHNE
    lastvektorauswertung_ns_oben.ausgabe_vL("NSohne_oben");
#endif
    do
        {
        lastvektorauswertung_ns.balancing();
        lastvektorauswertung_ns_oben.balancing();
#ifdef AKTUELLE_KOMMENTARE_OHNE
        strcpy(zeichenkette, "NS_ohne");
        lastvektorauswertung_ns.ausgabe_bal(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE_OHNE
        strcpy(zeichenkette, "NS_ohne_oben");
        lastvektorauswertung_ns_oben.ausgabe_bal(zeichenkette);
#endif

        ein_index_ns++;
        }
    while(ist_ausgeglichen_ns()!=true);

    indizes_ns[vektornummer] = ein_index_ns;
    kopiere_ns_arbeitsvektoren_nach_arbeitsmatrix(vektornummer);
    }
#endif
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Kommentar: Hier wird die West - Ost - Lastausgleichsrunden Simulation in der Lastzeile rang_f bis zum Lastausgleich durchgefhrt, und die
// Lasttransfermengen werden gespeichert. Fr die anderen Zeilen verwende man mache_arbeitsvektor_iterationen_ohne_deltaLM_wo(zeile).
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_wo(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor mache_arbeitsvektor_iterationen_mit_deltaLW_wo rang " << rang << endl;
#endif

// Kommentar: Hier wird nur unterschieden,ob diese Funktion fr einen reversen Lastausgleich den Lastausgleich realisiert, oder nur fr
// einen einfachen Lastausgleich. Entsprechend werden die mache_arbeitsvektor_iterationen_mit_deltaLM_mit/ohne_oben_wo - Funktionen
// aufgerufen.
    if(ist_oben==true)
        {
        mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo();
        }
    else
        {
        mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo();
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach mache_arbeitsvektor_iterationen_mit_deltaLW_wo rang " << rang << endl;
#endif
    }

#ifndef PLB_STANDARD
// Kommentar: Es wird eine Ost - West Precomputation und Balancing - Simulation gemacht. Dabei werden die Lasttransfermengen in den Variablen
// lastdifferenzen gespeichert. Das macht man in der Kerntopologie - Zeile des eigenen Kerns, whrend in den anderen Zeilen wohl simuliert, aber
// nicht gespeichert wird.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo(void)
    {
// Kommentar: Zuerst werden die Indizes der Lastdifferenzenvektoren auf 0 gesetzt.
    lastdifferenzen.reset_wo();
    // Geht mit nur einem / zwei Indizes, weil es nur so oft aufgerufen wird.

// Kommentar: Gespeichert ist der Vektor in der Lastmatrix. Die i.ten Zeile der Matrix wird nach dem Arbeitsvektor kopiert. In der Zeile rang_f.
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektor(rang_f);

// Kommentar: Die folgenden Schritte macht man, bis die wo - Zeile der Lastmatrix ausgeglichen ist.
    for(;ist_ausgeglichen_wo()!=true;)
        {
// Kommentar: Eine Precomputation - Berechnung mit der Simulation einer Lastausgleichsrunde.
        lastvektorauswertung_wo.ablauf_vektorupdate(arbeitsvektor);

// Kommentar: Die Lastdifferenzen werden gespeichert (mit_deltaLM)
        lastdifferenzen.hinzu_west(lastvektorauswertung_wo.west_differenz_vektor[rang_g]);
        lastdifferenzen.hinzu_ost(lastvektorauswertung_wo.ost_differenz_vektor[rang_g]);

// Kommentar: Der wo_index wird inkrementiert, da eine Lastausgleichsrunde erfolgt ist.
        lastdifferenzen.index_wo_inkrementieren(); // Stimmt es, ns zu inkrementieren,oder muss index_wo inkrementiert werden? 23.09.2014
        }
// Kommentar: Und am Ende wird der 'Last - ausgeglichene' Arbeitsvektor wieder in die arbeitsmatrix kopiert - in der Zeile rang_f.
    kopiere_wo_arbeitsvektor_nach_arbeitsmatrix(rang_f);
    }
#else
// Kommentar: Fr den PLB_STANDARD wird nur diese Funktion kommentiert. Die anderen Funktionen mit/ohne deltaLW, mit/ohne oben und ns und wo
// gehen analog
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo(void)
    {
// Kommentar: Zuerst mssen die Lastdifferenzenindizes - die hier fr alle Lastausgleichsrunden berechnet werden - zurckgesetzt werden.
    lastdifferenzen.reset_wo();
// Kommentar: Man kopiert aus der bestimmten Matrix in den frs Balancing zu analysierenden Vektor.
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektor(rang_f);
// Kommentar: Falls ausgeglichen, so ist man fertig.
    if(ist_ausgeglichen_wo()==true)
        {
        return;
        }
// Kommentar: Fhre die Precomputation durch.
    lastvektorauswertung_wo.precomputation(arbeitsvektor);
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "WOmit");
    lastvektorauswertung_wo.ausgabe_vL(zeichenkette);
#endif
// Kommentar: Es werden alle Lastausgleichsrunden durchlaufen.
    do
        {
// Kommentar: Zuerst geschieht das Balancing
        lastvektorauswertung_wo.balancing();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "WO_mit");
        lastvektorauswertung_wo.ausgabe_bal(zeichenkette, lastdifferenzen.index_wo);
#endif

// Kommentar: Dann werden die Lasttransferwerte in der Klasse LastDifferenzen gesichert.
        lastdifferenzen.hinzu_west(lastvektorauswertung_wo.west_differenz_vektor[rang_g]);
        lastdifferenzen.hinzu_ost(lastvektorauswertung_wo.ost_differenz_vektor[rang_g]);
        lastdifferenzen.index_wo_inkrementieren();
        }
// Kommentar: Das geschieht, bis der Lastvektor ausgeglichen ist.
    while(ist_ausgeglichen_wo()!=true);
// Kommentar: Am Ende wird die Lastmatrix aktualisiert.
    kopiere_wo_arbeitsvektor_nach_arbeitsmatrix(rang_f);
    }
#endif

// Kommentar: Diese Funktion gibt den Arbeitsvektor aus - wegen dem Debugging.
void GrosseLastAusgleichsSteuerung::ausgabe_arbeitsvektor_wo(void)
    {
    cout << " AV_wo rang " << rang;
    for(i=0; i<groesse_g; i++)
        {
        cout << " av[" << i << "]= " << arbeitsvektor[i];
        }
    cout << endl;
    }

#ifndef PLB_STANDARD
// Kommentar: Es wird eine Ost - West Precomputation und Balancing - Simulation gemacht, auch fr den reversen Lastausgleich. Dabei werden die
// Lasttransfermengen in den Variablen lastdifferenzen gespeichert. Das macht man in der Kerntopologie - Zeile des eigenen Kerns, whrend in
// den anderen Zeilen wohl simuliert, aber nicht gespeichert wird.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo rang " << rang << endl;
#endif

// Kommentar: Zuerst werden die Indizes der Lastdifferenzenvektoren auf 0 gesetzt.
    lastdifferenzen.reset_wo();
#ifdef AKTUELLE_KOMMENTARE
    cout << " 1 rang " << rang << endl;
#endif

// Kommentar: Gespeichert ist der Vektor in der Lastmatrix sowie der Lastmatrix oben. Die i.ten Zeile der Matrix wird nach dem Arbeitsvektor kopiert.
// In der Zeile rang_f. Entsprechendes geschieht fr die Matrix oben und den Arbeitsvektor oben.
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren(rang_f);
#ifdef AKTUELLE_KOMMENTARE
    cout << " 1.5 rang " << rang << " av[0] " << arbeitsvektor[0] << " av[1] " << arbeitsvektor[1] << endl;
    cout << " 1.5 rang " << rang << " av_oben[0] " << arbeitsvektor_oben[0] << " av_oben[1] " << arbeitsvektor_oben[1] << endl;
    cout << " 2 rang " << rang << endl;
#endif

// Kommentar: Solange die Last nicht vollstndig ausgeglichen ist, mache noch eine / die erste Lastausgleichsrunde.
    for(;ist_ausgeglichen_wo()!=true;)
        {
#ifdef AKTUELLE_KOMMENTARE
        cout << " 3 rang " << rang << endl;
        ausgabe_arbeitsvektor_wo();
#endif

// Kommentar: Man mache die Precomputation und einen simulierten Lastausgleichsschritt.
        lastvektorauswertung_wo.ablauf_vektorupdate(arbeitsvektor);
#ifdef AKTUELLE_KOMMENTARE
        cout << " 4 rang " << rang << endl;

        cout << " Lastdifferenzen index_wo " << lastdifferenzen.index_wo ;
        cout << " Lastdifferenzen index_wo oben " << lastdifferenzen.index_wo_oben << endl ;

        cout << " 4.5 rang " << rang << " west ";
        cout << lastvektorauswertung_wo.west_differenz_vektor[rang_g] << " ost " << lastvektorauswertung_wo.ost_differenz_vektor[rang_g] << endl;
#endif

// Kommentar: Man speichere die bestimmten Lasttransfermengen in lastdifferenzen ab.
        lastdifferenzen.hinzu_west(lastvektorauswertung_wo.west_differenz_vektor[rang_g]);
        lastdifferenzen.hinzu_ost(lastvektorauswertung_wo.ost_differenz_vektor[rang_g]);
#ifdef AKTUELLE_KOMMENTARE
        cout << " 5 rang " << rang << endl;
#endif
// Kommentar: Nun mache man dieselben 3 Schritte fr den oberen Lastausgleich.
        lastvektorauswertung_wo.ablauf_vektorupdate(arbeitsvektor_oben);
#ifdef AKTUELLE_KOMMENTARE
        cout << " 6 rang " << rang << endl;
#endif
        lastdifferenzen.hinzu_west_oben(lastvektorauswertung_wo.west_differenz_vektor[rang_g]);
        lastdifferenzen.hinzu_ost_oben(lastvektorauswertung_wo.ost_differenz_vektor[rang_g]);
#ifdef AKTUELLE_KOMMENTARE
        cout << " 6.5 rang " << rang << " hinzu_west " << lastdifferenzen.west[lastdifferenzen.index_wo];
        cout << " hinzu_ost " << lastdifferenzen.ost[lastdifferenzen.index_wo] << endl;
#endif

// Kommentar: Da eine Lastausgleichsrunde durchgefhrt wurde, wird der Lastausgleichsrunden - Index inkrementiert.
        lastdifferenzen.index_wo_inkrementieren();
#ifdef AKTUELLE_KOMMENTARE
        cout << " 7 rang " << rang << endl;
#endif
        }
// Kommentar: Ausgaben frs Debugging.
#ifdef AKTUELLE_KOMMENTARE
    lastdifferenzen.ausgabe_wo();
    lastdifferenzen.ausgabe_wo_oben();
#endif

// Kopiere den genderten Vektor zurck in die Lastmatrix.
    kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(rang_f);
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo rang " << rang << endl;
#endif
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo(void)
    {
    lastdifferenzen.reset_wo();
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren(rang_f);
    if(ist_ausgeglichen_wo()==true)
        {
        return;
        }
    lastvektorauswertung_wo.precomputation(arbeitsvektor);
    lastvektorauswertung_wo_oben.precomputation(arbeitsvektor_oben);
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "WOmit");
    lastvektorauswertung_wo.ausgabe_vL(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "WOmit_oben");
    lastvektorauswertung_wo_oben.ausgabe_vL(zeichenkette);
#endif
    do
        {
        lastvektorauswertung_wo.balancing();
        lastvektorauswertung_wo_oben.balancing();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "WO_mit");
        lastvektorauswertung_wo.ausgabe_bal(zeichenkette, lastdifferenzen.index_wo);
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "WO_mit_oben");
        lastvektorauswertung_wo_oben.ausgabe_bal(zeichenkette, lastdifferenzen.index_wo);
#endif

        lastdifferenzen.hinzu_west(lastvektorauswertung_wo.west_differenz_vektor[rang_g]);
        lastdifferenzen.hinzu_ost(lastvektorauswertung_wo.ost_differenz_vektor[rang_g]);

        lastdifferenzen.hinzu_west_oben(lastvektorauswertung_wo_oben.west_differenz_vektor[rang_g]);
        lastdifferenzen.hinzu_ost_oben(lastvektorauswertung_wo_oben.ost_differenz_vektor[rang_g]);

        lastdifferenzen.index_wo_inkrementieren();
        }
    while(ist_ausgeglichen_wo()!=true);
    kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(rang_f);
    }

#endif

//////////////////////////////////////////////////
//////////////////////////////////////////////////

// Kommentar: Hier wird die West - Ost - Lastausgleichsrunden Simulation in der Lastzeile vektornummer bis zum Lastausgleich durchgefhrt, und die
// Lasttransfermengen werden nicht gespeichert.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_wo(int vektornummer)
    {
// Kommentar: Hier wird nur unterschieden,ob diese Funktion fr einen reversen Lastausgleich den Lastausgleich realisiert, oder nur fr
// einen einfachen Lastausgleich. Entsprechend werden die mache_arbeitsvektor_iterationen_ohne_deltaLM_mit/ohne_oben_wo - Funktionen
// aufgerufen.
    if(ist_oben==true)
        {
        mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_wo(vektornummer);
        }
    else
        {
        mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_wo(vektornummer);
        }
    }

#ifndef PLB_STANDARD
// Kommentar: Hier werden die Precomputation Berechnungen und Balancing - Lastausgleichssimulationen fr die Lastzeile unter der vektornummer
// durchgefhrt. Man macht dasselbe wie bei mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo, nur mit den 2 Unterschieden, dass
// erstens statt der Zeile rang_f die Zeile vektornummer verwendet wird, und die Lasttransferwerte nicht geschrieben werden.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_wo(int vektornummer)
    {
#ifdef NEUER_CODE
    ein_index_wo = 0;
#endif
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektor(vektornummer);
    for(;ist_ausgeglichen_wo()!=true;)
        {
        lastvektorauswertung_wo.ablauf_vektorupdate(arbeitsvektor);
#ifdef NEUER_CODE
        ein_index_wo++;
#endif
        }
#ifdef NEUER_CODE
    indizes_wo[vektornummer] = ein_index_wo;
#endif
    kopiere_wo_arbeitsvektor_nach_arbeitsmatrix(vektornummer);
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#. Einzige Ausnahme: Wegen 'ohne' ist der Eintrag aus der Lsatmatrix nicht eineindeutig,
// weshalb die Zuordnung ber eine Vektornummer notwendig ist.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_wo(int vektornummer)
    {
    ein_index_wo = 0;
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektor(vektornummer);
    if(ist_ausgeglichen_wo()==true)
        {
        indizes_wo[vektornummer] = ein_index_wo;
        return;
        }
    lastvektorauswertung_wo.precomputation(arbeitsvektor);
#ifdef AKTUELLE_KOMMENTARE_OHNE
    lastvektorauswertung_wo.ausgabe_vL("WOohne");
#endif
    do
        {
        lastvektorauswertung_wo.balancing();
#ifdef AKTUELLE_KOMMENTARE_OHNE
        strcpy(zeichenkette, "WO_ohne");
        lastvektorauswertung_wo.ausgabe_bal(zeichenkette);
#endif
        ein_index_wo++;
        }
    while(ist_ausgeglichen_wo()!=true);

    indizes_wo[vektornummer] = ein_index_wo;
    kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(vektornummer);
    }
#endif

#ifndef PLB_STANDARD
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_wo, nur das Precomputation und simuliertes Balancing
// auch auf der Gitterebene 'oben' durchgefhrt werden.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_wo(int vektornummer)
    {
#ifdef NEUER_CODE
    ein_index_wo = 0;
#endif
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren(vektornummer);
    for(;ist_ausgeglichen_wo()!=true;)
        {
        lastvektorauswertung_wo.ablauf_vektorupdate(arbeitsvektor);
        lastvektorauswertung_wo.ablauf_vektorupdate(arbeitsvektor_oben);
#ifdef NEUER_CODE
        ein_index_wo++;
#endif
        }
#ifdef NEUER_CODE
    indizes_wo[vektornummer] = ein_index_wo;
#endif
    kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(vektornummer);
    }
#else
// Kommentar: Analog zu mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo nach '#else#. Einzige Ausnahme: Wegen 'ohne' ist der Eintrag aus der Lsatmatrix nicht eineindeutig,
// weshalb die Zuordnung ber eine Vektornummer notwendig ist.
void GrosseLastAusgleichsSteuerung::mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_wo(int vektornummer)
    {
    ein_index_wo = 0;
    kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren(vektornummer);
    if(ist_ausgeglichen_wo()==true)
        {
        indizes_wo[vektornummer] = ein_index_wo;
        return;
        }
    lastvektorauswertung_wo.precomputation(arbeitsvektor);
    lastvektorauswertung_wo_oben.precomputation(arbeitsvektor_oben);
#ifdef AKTUELLE_KOMMENTARE_OHNE
    lastvektorauswertung_wo.ausgabe_vL("WOohne");
#endif
#ifdef AKTUELLE_KOMMENTARE_OHNE
    lastvektorauswertung_wo_oben.ausgabe_vL("WOohne_oben");
#endif

    do
        {
        lastvektorauswertung_wo.balancing();
        lastvektorauswertung_wo_oben.balancing();
#ifdef AKTUELLE_KOMMENTARE_OHNE
        strcpy(zeichenkette, "WO_ohne");
        lastvektorauswertung_wo.ausgabe_bal(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE_OHNE
        strcpy(zeichenkette, "WO_ohne_oben");
        lastvektorauswertung_wo_oben.ausgabe_bal(zeichenkette);
#endif
        ein_index_wo++;
        }
    while(ist_ausgeglichen_wo()!=true);

    indizes_wo[vektornummer] = ein_index_wo;
    kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(vektornummer);
    }
#endif

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Kommentar: Analog zu berechne_wo_durchschnitte. Daher keine eigenen Kommentare.
void GrosseLastAusgleichsSteuerung::berechne_ns_durchschnitte(void)
    {
    if(ist_oben==true)
        {
        berechne_ns_durchschnitte_mit();
        }
    else
        {
        berechne_ns_durchschnitte_ohne();
        }
    }

// Kommentar: Die Durchschnitte der Lasten werden berechnet. Diese Funktion verzweigt auf zwei Funktionen, die diese Durchschnitte durchfhren,
// je nachdem, ob ist_oben true oder false ist.
void GrosseLastAusgleichsSteuerung::berechne_wo_durchschnitte(void)
    {
    if(ist_oben==true)
        {
        berechne_wo_durchschnitte_mit();
        }
    else
        {
        berechne_wo_durchschnitte_ohne();
        }
    }

// Kommentar: Diese Funktion ist analog zu berechne_wo_durchschnitte_ohne. Daher: Hier keine eigenen Kommentare.
void GrosseLastAusgleichsSteuerung::berechne_ns_durchschnitte_ohne(void)
    {
    for(j=0; j<groesse_g; j++)
        {
        for(hilfslast = 0, i=0; i<groesse_f; i++)
            {
            hilfslast = hilfslast + arbeitsmatrix[i][j];
            }
        last_ns_durchschnitt[j] = hilfslast / groesse_f;
        }
    }

// Kommentar: Diese Funktion ist analog zu berechne_wo_durchschnitte_mit. Daher: Hier keine eigenen Kommentare.
void GrosseLastAusgleichsSteuerung::berechne_ns_durchschnitte_mit(void)
    {
    for(j=0; j<groesse_g; j++)
        {
        for(hilfslast = 0, hilfslast_oben = 0, i=0; i<groesse_f; i++)
            {
            hilfslast = hilfslast + arbeitsmatrix[i][j];
            hilfslast_oben = hilfslast_oben + arbeitsmatrix_oben[i][j];
            }
        last_ns_durchschnitt[j] = hilfslast / groesse_f;
        last_ns_durchschnitt_oben[j] = hilfslast_oben / groesse_f;
        }
    }

// Kommentar: Diese Funktion ist analog zu bestimme_max_wo. Daher werden keine eigenen Kommentare geschrieben.
void GrosseLastAusgleichsSteuerung::bestimme_max_ns(void)
    {
    for(max_ns = 0, j=0; j<groesse_g; j++)
        {
        last = last_ns_durchschnitt[j];
        if(max_ns<last)
            {
            max_ns = last;
            }
        }
    }

// Kommentar: Hier wird der Maximalwert der Lastdurchschnitte berechnet.
void GrosseLastAusgleichsSteuerung::bestimme_max_wo(void)
    {
// Kommentar: Man liest fr jede Zeile der Durchschnittswert, und bestimmt das Maximum darber.
    for(max_wo = 0, i=0; i<groesse_f; i++)
        {
        last = last_wo_durchschnitt[i];
        if(max_wo<last)
            {
            max_wo = last;
            }
        }
    }

// Kommentar: Man berechnet die Durchschnittswerte der Lastzeilen
void GrosseLastAusgleichsSteuerung::berechne_wo_durchschnitte_ohne(void)
    {
// Kommentar: Man durchluft die Lastzeilen.
    for(i=0; i<groesse_f; i++)
        {
// Kommentar: Man bestimmt die Lastsumme der Zeile.
        for(hilfslast = 0, j=0; j<groesse_g; j++)
            {
            hilfslast = hilfslast + arbeitsmatrix[i][j];
            }
// Kommentar: Der Lastdurchschnitt ist die  Lastsumme, durch die Anzahl der Kerne pro Lastzeile.
        last_wo_durchschnitt[i] = hilfslast / groesse_g;
        }
    }

// Kommentar: Man berechnet die Durchschnittswerte der Lastzeilen, aber auch in Bezug auf die Lastwerte der oberen Lastmatrix.
void GrosseLastAusgleichsSteuerung::berechne_wo_durchschnitte_mit(void)
    {
// Kommentar: Man durchluft die Lastzeilen.
    for(i=0; i<groesse_f; i++)
        {
// Kommentar: Man bestimmt die 'Lastsumme' und 'Lastsumme oben' der Zeile.
        for(hilfslast = 0, j=0; j<groesse_g; j++)
            {
            hilfslast = hilfslast + arbeitsmatrix[i][j];
            hilfslast_oben = hilfslast_oben + arbeitsmatrix_oben[i][j];
            }
// Kommentar: Man bestimmt die Durchschnittswerte aufrund der 'Lastsumme' und 'Lastsumme oben'.
        last_wo_durchschnitt[i] = hilfslast / groesse_g;
        last_wo_durchschnitt_oben[i] = hilfslast_oben / groesse_g;
        }
    }

// Kommentar: Eine Ausgabe zu Debugging - Zwecken. Ohne Kommentare.
void GrosseLastAusgleichsSteuerung::ausgabe_arbeitsmatrix(char * text)
    {
    cout << " Ausgabe Arbeitsmatrix " << text << " rang " << rang;
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            cout << " i " << i << " j " << j << " am " << arbeitsmatrix[i][j];
            }
        }
    cout << endl;

    if(ist_oben==true)
        {
        cout << " Ausgabe Arbeitsmatrix oben " << text << " rang " << rang;
        for(i=0; i<groesse_f; i++)
            {
            for(j=0; j<groesse_g; j++)
                {
                cout << " i " << i << " j " << j << " am " << arbeitsmatrix_oben[i][j];
                }
            }
        cout << endl;
        }
    }

// Kommentar: Kopiert die Lasten aller Kerne in die 'Arbeitsmatrix' sowie die 'Arbeitsmatrix oben'.
void GrosseLastAusgleichsSteuerung::kopiere_lastmatrix_mit(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " kopiere_lastmatrix_mit rang " << rang << " ";
#endif
    for(i=0; i<groesse_f; i++)
        {
        for(j=0, k=0; j<groesse_g_2; k++)
            {
            arbeitsmatrix[i][k] = last_alle_prozessoren[i][j++];
            arbeitsmatrix_oben[i][k] = last_alle_prozessoren[i][j++];
#ifdef AKTUELLE_KOMMENTARE
            cout << " am (i,k) " << i << " " << k << " last " << arbeitsmatrix[i][k];
#endif
            }
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
// Kopiere Lastmengen
    }

// Kommentar: Kopiert die Lasten aller Kerne in die 'Arbeitsmatrix', aber nicht in die 'Arbeitsmatrix oben'.
void GrosseLastAusgleichsSteuerung::kopiere_lastmatrix_ohne(void)
    {
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            arbeitsmatrix[i][j] = last_alle_prozessoren[i][j];
            }
        }
// Kopiere Lastmengen
    }

// Kommentar: Bestimme die Lastmartizen auf beiden Gitterebenen mit Hilfe des Baumlastausgleiches.
void GrosseLastAusgleichsSteuerung::bestimme_lastmatrix_PLB_mit(void)
    {
// Kommentar: Mache die Lastmengenbestimmung mit Hilfe der Klasse LastMengenBestimmung - im Fall PLBxPLB_MIT.
    lastmengenbestimmung.tun(PLBxPLB_MIT);
// Bestimme Lastmengen

// Kommentar: Danach kopiere die ermittelten Werte in die Lastmatrizen.
    kopiere_lastmatrix_mit();
    }

// Kommentar: Bestimme die Lastmartizen auf einer Gitterebene mit Hilfe des Baumlastausgleiches.
void GrosseLastAusgleichsSteuerung::bestimme_lastmatrix_PLB_ohne(void)
    {
// Kommentar: Mache die Lastmengenbestimmung mit Hilfe der Klasse LastMengenBestimmung - im Fall PLBxPLB_OHNE.
    lastmengenbestimmung.tun(PLBxPLB_OHNE);
// Kommentar: Danach kopiere die ermittelten Werte in die Lastmatrix.
    kopiere_lastmatrix_ohne();
    }

// Kommentar: Bestimme die Lastmartizen auf beiden Gitterebenen mit Hilfe der vollstndigen Kommunikation - entsprechend der Dissertation. Man hat den unterliegenden
// vollstndigen Graphen dabei immer nur in jeder der 2 Dimensionen, d.h. bei 16 Kernen nur einen K_4.
void GrosseLastAusgleichsSteuerung::bestimme_lastmatrix_KN_mit(void)
    {
// Kommentar: Mache die Lastmengenbestimmung mit Hilfe der Klasse LastMengenBestimmung - im Fall KNxKN_MIT.
    lastmengenbestimmung.tun(KNxKN_MIT);
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " In GLAS: vor kopieren_lastmatrix_mit rang " << rang << endl;
#endif

// Kommentar: Danach kopiere die ermittelten Werte in die Lastmatrizen.
    kopiere_lastmatrix_mit();
#ifdef AKTUELLE_KOMMENTARE_GLAS
    cout << " In GLAS: nach kopieren_lastmatrix_mit rang " << rang << endl;
#endif
    }

// Kommentar: Wie bestimme_lastmatrix_KN_mit, nur eben nur fr eine Gitterebene.
void GrosseLastAusgleichsSteuerung::bestimme_lastmatrix_KN_ohne(void)
    {
// Kommentar: Mache die Lastmengenbestimmung mit Hilfe der Klasse LastMengenBestimmung.
    lastmengenbestimmung.tun(KNxKN_OHNE);
// Kommentar: Danach kopiere die ermittelten Werte in die Lastmatrix.
    kopiere_lastmatrix_ohne();
    }

// Kommentar: Hier wird die Lastmatrix bestimmt. Zuerst wird die eigene Last - evtl. auch mit dem Lastwert der oberen Gitterebene -
// nach der Klasse LastMengenBestimmung kopiert.
void GrosseLastAusgleichsSteuerung::bestimme_lastmatrix(void)
    {
    lastmengenbestimmung.setze_eigene_last(eigene_last);
    if(ist_oben==true)
        {
        lastmengenbestimmung.setze_eigene_last_oben(eigene_last_oben);
        }

// Kommentar: Dann wird - entsprechend der Variablen plb_kn sowie ist_oben - die jeweils passende der vier Lastmengenbestimmungen
// bestimme_lastmatrix_PLB_mit, bestimme_lastmatrix_PLB_ohne, bestimme_lastmatrix_KN_mit sowie bestimme_lastmatrix_KN_ohne durchgefhrt.
    if(plb_kn==PLB)
        {
        if(ist_oben==true)
            {
#ifdef AKTUELLE_KOMMENTARE_GLAS
            cout << " bl PLB mit rang " << rang << endl;
#endif
            bestimme_lastmatrix_PLB_mit();
            }
        else
        if(ist_oben==true)
            {
#ifdef AKTUELLE_KOMMENTARE_GLAS
            cout << " bl PLB ohne rang " << rang << endl;
#endif
            bestimme_lastmatrix_PLB_ohne();
            }
        }
    else
        {
        if(ist_oben==true)
            {
#ifdef AKTUELLE_KOMMENTARE_GLAS
            cout << " bl KN mit rang " << rang << endl;
#endif
            bestimme_lastmatrix_KN_mit();
            }
        else
        if(ist_oben==true)
            {
#ifdef AKTUELLE_KOMMENTARE_GLAS
            cout << " bl KN ohne rang " << rang << endl;
#endif
            bestimme_lastmatrix_KN_ohne();
            }
        }
    }

// Kommentar: Hier wird diese Klasse finalisiert. Zu den einzelnen Variablen vergleiche man die Initialisierung.
void GrosseLastAusgleichsSteuerung::finalisieren(void)
    {
    delete indizes_ns;
    delete indizes_wo;

    lastmengenbestimmung.finalisieren_normal();
    delete arbeitsvektor;
    delete arbeitsvektor_oben;

    for(i=0; i<groesse_f; i++)
        {
        delete arbeitsmatrix[i];
        delete arbeitsmatrix_oben[i];
        }
    delete arbeitsmatrix;
    delete arbeitsmatrix_oben;

    lastvektorauswertung_wo.finalisieren();
    lastvektorauswertung_ns.finalisieren();

#ifdef PLB_STANDARD
    lastvektorauswertung_wo_oben.finalisieren();
    lastvektorauswertung_ns_oben.finalisieren();
#endif // PLB_STANDARD

    delete last_ns_durchschnitt;
    delete last_ns_durchschnitt_oben;
    delete last_wo_durchschnitt;
    delete last_wo_durchschnitt_oben;

    lastdifferenzen.finalisieren();
    }

// Kommentar: Hier wird die Klasse initialisiert. Es werden groesse, rang sowie die Variable ist_oben bergeben.
void GrosseLastAusgleichsSteuerung::initialisieren(int _groesse, int _rang, bool _ist_oben)
// hat richtige Funktion finalisieren, s.o.
    {
// Zuerst werden die bergebenen Parameter gespeichert.
    groesse = _groesse;
    rang = _rang;
    ist_oben = _ist_oben;

// Kommentar: Eine Instanz der Klasse LastMengenBestimmung wird initialisiert.
    lastmengenbestimmung.initialisieren_normal(rang, groesse);
// Kommentar: Die Anzahl an Kernen in Ost - West - und Nord - Sd - Richtung werden von dieser Klasse abgelesen.
    groesse_f = lastmengenbestimmung.groesse_f;
    groesse_g = lastmengenbestimmung.groesse_g;

// Kommentar: Das Maximum beider Werte wird gespeichert - weil die bearbeiteten Vektoren maximal diese Lnge haben.
    if(groesse_f < groesse_g)
        {
        max_vektor = groesse_g;
        }
    else
        {
        max_vektor = groesse_f;
        }

// Kommentar: Ein Zeiger auf die Lastmatrix der Klasse LastMengenBestimmung wird angelegt.
    last_alle_prozessoren = lastmengenbestimmung.last_alle_prozessoren;

// Kommentar: Der Speicherplatz fr einen Arbeitsvektor und den Arbeitsvektor oben wird angelegt. Er hat maximal die Gre max_vektor.
    arbeitsvektor = new int [max_vektor];
    arbeitsvektor_oben = new int [max_vektor];

// Kommentar: Die Arbeitsmatrix, und die Arbeitsmatrix oben werden angelegt.
    arbeitsmatrix = new int * [groesse_f];
    arbeitsmatrix_oben = new int * [groesse_f];
    for(i=0; i<groesse_f; i++)
        {
        arbeitsmatrix[i] = new int [groesse_g];
        arbeitsmatrix_oben[i] = new int [groesse_g];
        }

// Kommentar: Die Werte von groesse_f und groesse_g werden verdoppelt abgespeichert.
    groesse_f_2 = groesse_f << 1;
    groesse_g_2 = groesse_g << 1;
// Kommentar: Die Zeile und Spalte des eigenen Kerns in der Lastmatrix werden von der Instanz der Klasse LastMengenBestimmung abgelesen.
    rang_f = lastmengenbestimmung.position_f;
    rang_g = lastmengenbestimmung.position_g;

// Kommentar: Die Instanzen lastvektorauswertung_wo und lastvektorauswertung der Klasse LastVektorAuswertung werden angelegt mit Angabe
// der Vektorgre, und der rang daran bergeben.
    lastvektorauswertung_wo.initialisieren(groesse_g, rang);
    lastvektorauswertung_ns.initialisieren(groesse_f, rang);
    lastvektorauswertung_wo.rang = rang;
    lastvektorauswertung_ns.rang = rang;
#ifdef PLB_STANDARD
    lastvektorauswertung_wo_oben.initialisieren(groesse_g, rang);
    lastvektorauswertung_ns_oben.initialisieren(groesse_f, rang);
    lastvektorauswertung_wo_oben.rang = rang;
    lastvektorauswertung_ns_oben.rang = rang;
#endif

// Kommentar: Der Speicher fr die durchschnittlichen Lastwerte wird angelegt.
    last_ns_durchschnitt = new int [groesse_g];
    last_ns_durchschnitt_oben = new int [groesse_g];
    last_wo_durchschnitt = new int [groesse_f];
    last_wo_durchschnitt_oben = new int [groesse_f];

// Kommentar: Der Speicherplatz fr eine Instanz der Klasse LastDifferenzen wird angelegt.
    lastdifferenzen.initialisieren(groesse_f, groesse_g, rang);

// Kommentar: Der Speicherplatz zum Merken der Anzahl an Lastausgleichsrunden wird angelegt.
    indizes_wo = new int [groesse_f];
    indizes_ns = new int [groesse_g];
    }

// Kopiere Lastmengen

void GrosseLastAusgleichsSteuerung::ausgabe_lastmatrix_mit(void)
    {
    cout << " GLAS rang " << rang << " Lastmatrix ";
    for(i=0, k=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            cout << k++ << " " << arbeitsmatrix[i][j] << "/" << arbeitsmatrix_oben[i][j] << " ";
            }
        }
    cout << endl;
    }
