#ifndef GROSSE_LASTAUSGLEICHSSTEUERUNG
#define GROSSE_LASTAUSGLEICHSSTEUERUNG

#include <string.h>

#include "lastmengenbestimmung.h"
#include "lastvektorauswertung.h"
#include "lastmatrix.h"
#include "lastmatrix_kopieren.h"
#include "lastdifferenzen.h"

#include "lastausgleichssteuerung.h"

#ifndef NEUER_CODE
#define NEUER_CODE
#endif

#ifndef WO
#define WO 0
#endif

#ifndef NS
#define NS 1
#endif

class GrosseLastAusgleichsSteuerung
    {
private:
    LastMengenBestimmung lastmengenbestimmung;
    LastVektorAuswertung lastvektorauswertung_wo, lastvektorauswertung_ns;
#ifdef PLB_STANDARD
    LastVektorAuswertung lastvektorauswertung_wo_oben, lastvektorauswertung_ns_oben;
#endif
private:
    int * lastvektor_ns, * lastvektor_ow;
public:
    int plb_kn;
    int hilfslast, hilfslast_oben;
public:
    void tun(int _eigene_last, int _eigene_last_oben);
    void tun_ohne_option(int _eigene_last, int _eigene_last_oben);
private:
    int eigene_last, eigene_last_oben;
private:
    void bestimme_lastmatrix(void);
    void berechne_ns_durchschnitte(void);
    void berechne_ns_durchschnitte_mit(void);
    void berechne_ns_durchschnitte_ohne(void);
    void berechne_wo_durchschnitte(void);
    void berechne_wo_durchschnitte_mit(void);
    void berechne_wo_durchschnitte_ohne(void);
    void bestimme_max_ns(void);
    void bestimme_max_wo(void);
    void erst_wo_dann_ns(void);
    void erst_ns_dann_wo(void);
    void mache_arbeitsvektor_iterationen_mit_deltaLM_ns(void);
    void mache_arbeitsvektor_iterationen_ohne_deltaLM_ns(int vektornummer);
    void mache_arbeitsvektor_iterationen_mit_deltaLM_wo(void);
    void mache_arbeitsvektor_iterationen_ohne_deltaLM_wo(int vektornummer);
    void mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_ns(void);
    void mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_ns(void);
    void mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_ns(int vektornummer);
    void mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_ns(int vektornummer);
    void mache_arbeitsvektor_iterationen_mit_deltaLM_ohne_oben_wo(void);
    void mache_arbeitsvektor_iterationen_mit_deltaLM_mit_oben_wo(void);
    void mache_arbeitsvektor_iterationen_ohne_deltaLM_ohne_oben_wo(int vektornummer);
    void mache_arbeitsvektor_iterationen_ohne_deltaLM_mit_oben_wo(int vektornummer);

    void kopiere_ns_arbeitsmatrix_nach_arbeitsvektor(int spaltennummer);
    void kopiere_ns_arbeitsmatrix_nach_arbeitsvektoren(int spaltennummer);
    void kopiere_ns_arbeitsvektor_nach_arbeitsmatrix(int spaltennummer);
    void kopiere_ns_arbeitsvektoren_nach_arbeitsmatrix(int spaltennummer);

    void kopiere_wo_arbeitsmatrix_nach_arbeitsvektor(int zeilennummer);
    void kopiere_wo_arbeitsmatrix_nach_arbeitsvektoren(int zeilennummer);
    void kopiere_wo_arbeitsvektor_nach_arbeitsmatrix(int zeilennummer);
    void kopiere_wo_arbeitsvektoren_nach_arbeitsmatrix(int zeilennummer);

    void bestimme_lastmatrix_PLB_mit(void);
    void bestimme_lastmatrix_PLB_ohne(void);
    void bestimme_lastmatrix_KN_mit(void);
    void bestimme_lastmatrix_KN_ohne(void);

    bool ist_ausgeglichen_wo(void);
    bool ist_ausgeglichen_ns(void);

    void kopiere_lastmatrix_mit(void);
    void kopiere_lastmatrix_ohne(void);
private:
    int max_ns, max_wo;
    int max_wert, min_wert;
private:
    int groesse, rang, rang_f, rang_g, groesse_f, groesse_g, max_groesse;
    int groesse_g_2, groesse_f_2;
private:
    int zeile, spalte;
private:
    bool ist_oben;
private:
public:
    LastDifferenzen lastdifferenzen;
private:
    int * arbeitsvektor;
    int * arbeitsvektor_oben;
    int ** arbeitsmatrix;
    int ** arbeitsmatrix_oben;
private:
    int i, j, k;
    int * last_ns_durchschnitt;
    int * last_ns_durchschnitt_oben;
    int * last_wo_durchschnitt;
    int * last_wo_durchschnitt_oben;
    int last;
    int ** last_alle_prozessoren;
    int max_vektor;
public:
    void initialisieren(int _groesse, int _rang, bool _ist_oben);
    void finalisieren(void);
public:
    int was_zuerst;
private:
    void ausgabe_arbeitsvektor_wo(void);
private:
    void ausgabe_arbeitsmatrix(char * text);
private:
    char zeichenkette[30];
private:
    int * indizes_wo, * indizes_ns;
    int ein_index_wo, ein_index_ns;
    int index_wo, index_ns, index_wo_max, index_ns_max;
    int indizes_wo_i, indizes_ns_i;
private:
    void ausgabe_lastmatrix_mit(void);
    };

#endif
