#ifndef IDENTIFY
#define IDENTIFY

#include <mpi.h>
#include <string.h>

#include "ausgaben.h"

#define RAND_WESTEN 0
#define IM_WESTEN 1
#define MITTE_WO 2
#define IM_OSTEN 3
#define RAND_OSTEN 4
#define RAND_NORDEN 5
#define IM_NORDEN 6
#define MITTE_NS 7
#define IM_SUEDEN 8
#define RAND_SUEDEN 9

#define TAG_PRECOMPUTATION 222

#include "datei_ausgabe.h"

class Identify
    {
protected:
    DateiAusgabe da;
private:
    int groesse;
protected:
    int rang;
public:
    void initialisierung_identify(int _rang, int _groesse);
    void finalisierung_identify(void);
private:
protected:
public:
    int groesse_f, groesse_g;
protected:
    int groesse_g_div_2;
    int groesse_f_div_2;
    int rang_f, rang_g;
public:
    int ID_osten, ID_westen, ID_norden, ID_sueden;
protected:
    int position_ow, position_ns;
    int anzahl_westen;
    int anzahl_osten;
    int anzahl_norden;
    int anzahl_sueden;
private:
    void bestimme_groessen(void);
    void bestimme_raenge(void);
    void bestimme_nachbar_IDs(void);
    void bestimme_positionen(void);
    void bestimme_position_ow(void);
    void bestimme_position_ns(void);
    void bestimme_anzahlen(void);
protected:
    int mitte_ow, mitte_ns;
private:
    void bestimme_mitten(void);
private:
    int * raenge_ow, * raenge_ns;
private:
    void kreiere_raenge(void);
    void delete_raenge(void);
    int hilfsvariable1;
    int i;
private:
    MPI_Group MPI_GROUP_WORLD1, gruppe_ow;
    MPI_Group MPI_GROUP_WORLD2, gruppe_ns;
protected:
    MPI_Comm MPI_COMM_OW, MPI_COMM_NS;
private:
    void kreiere_kommunikatoren(void);
    void delete_kommunikatoren(void);
private:
    int ow_rang, ns_rang;
    int ow_rang_s, ns_rang_s;
private:
protected:
    int lokal_rang_mitte_ns;
    int lokal_rang_mitte_ow;
private:
    int * hilfsraenge_ow;
    int * hilfsraenge_ns;
private:
    void bestimme_lokale_raenge(void);
private:
    char text[15];
    };

#endif
