#include "kleine_randstruktur_kommunikation.h"

// Kommentar: Hier wird diese Klasse mit diversen Strukturen verbunden, die Speicherplatz enthalten. Dazu gehren:
// Die kleinen Innenrandpunkte, die kleinen Auenrandpunkte, die innere Signatur, die uere Signatur, und dann
// double - Buffer frs Senden und Empfangen. Diese werden auch dazu bentigt, die Signatur zu packen, bzw. zu entpacken.
// Am Ende werden noch Parameter bergeben.
// Warum die kleine Randstruktur auch mit der RandStrukturKommunikation geht, vergleiche den Kommentar am Ende dieser Klasse.
void KleineRandStrukturKommunikation::initialisieren_kRSK(short int * _f_innen_klein, short int * _g_innen_klein, short int * _f_aussen_klein, short int * _g_aussen_klein, double * _sendebuffer, double * _empfangsbuffer, int _zielrang, bool * _signatur_innen, bool * _signatur_aussen, int _mn, int _rang)
    {
// Kommentar: Die folgenden Zeiger wurden schon in dem Anfangskommentar erlutert.
    f_innen_klein = _f_innen_klein;
    g_innen_klein = _g_innen_klein;

    f_aussen_klein = _f_aussen_klein;
    g_aussen_klein = _g_aussen_klein;

    signatur_innen = _signatur_innen;
    signatur_aussen = _signatur_aussen;

    sendebuffer = _sendebuffer;
    empfangsbuffer = _empfangsbuffer;

    si_buffer_senden = (short int *) sendebuffer;
    si_buffer_empfangen = (short int *) empfangsbuffer;

// Kommentar: Der Zielrang ist der Rand des Kerns, mit dem kommuniziert wird.
    zielrang = _zielrang;
// Kommentar: mn2 ist die Maximallnge der double - Buffer.
    mn2 = _mn;
// Kommentar: Und das hier ist der eigene Rang des Kerns.
    rang_kk = _rang;
    }

// Kommentar: Es wird die Kommunikation der Kleinen Randstruktur - senden und empfangen in Bezug auf den eigenen und den Zielrang
// - initiiert. Dabei wird vor dem Senden der Sendebuffer beschrieben.
void KleineRandStrukturKommunikation::randaustausch1_initiieren(void)
    {
// Kommentar: Hier wird der Empfang der Werte des Auenrandes initiiert, bei dem der Kern mit dem Zielrang die Werte seiner
// kleine Innenstruktur in Bezug auf variable1 schreibt.Bemerkung: mn ist die maximale Bufferlnge.
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 500, MPI_COMM_WORLD, & empfangs_request);
// Kommentar: Dieser Kern schreibt die Werte, die die variable1 auf der Position seiner kleinen Innenrandpunkte annimmt,
// in den Sendebuffer. Dabei haben die Innenrandstruktur von diesem Kern dieselben Punkte in derselben Reihenfolge
// wie die Auenrandstruktur des Zielkernes, und umgekehrt.
    for(i=0; i<anzahl_innen_klein; i++)
        {
        sendebuffer[i] = variable1[f_innen_klein[i]][g_innen_klein[i]];
        }
// Kommentar: Die eben in den Sendebuffer eingetragenen Werte der Variablen 1 werden an den Kern mit dem Zielrang
// verschickt.
    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 500, MPI_COMM_WORLD, & sende_request);
    }

// Kommentar:Es wird getestet, ob die bei der Funktion randaustausch1_initiieren initiierte Kommunikation
// abgeschlossen wird. In dem Fall wird der Rand mit Hilfe der kleinen Auenstruktur aktualisiert.
bool KleineRandStrukturKommunikation::randaustausch1_testen(void)
    {
// Kommentar: Zuerst wird getestet, ob das Senden und Empfangen erfolgreich abgeschlossen worden ist.
// Falls nein, so wird false zurckgegeben.
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
// Ansonsten wird der Empfangsbuffer mit Hilfe der kleinen Auenrandstruktur entpackt - und zwar wird dabei die
// variable1 beschrieben.
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable1[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
    return(true);
    }

// Kommentar: Analog zu randaustausch1_initiieren, nur das bzgl. der Variablen 2 gepackt wird.
void KleineRandStrukturKommunikation::randaustausch2_initiieren(void)
    {
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 501, MPI_COMM_WORLD, & empfangs_request);
    for(i=0; i<anzahl_innen_klein; i++)
        {
        sendebuffer[i] = variable2[f_innen_klein[i]][g_innen_klein[i]];
        }

    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 501, MPI_COMM_WORLD, & sende_request);
    }

// Kommentar: Analog zu randaustausch1_testen, nur das bzgl. der Variablen 2 entpackt wird.
bool KleineRandStrukturKommunikation::randaustausch2_testen(void)
    {
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable2[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
    return(true);
    }

// Kommentar: Analog zu randaustausch1_initiieren, nur das bzgl. der Variablen 3 gepackt wird.
void KleineRandStrukturKommunikation::randaustausch3_initiieren(void)
    {
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 502, MPI_COMM_WORLD, & empfangs_request);
    for(i=0; i<anzahl_innen_klein; i++)
        {
        sendebuffer[i] = variable3[f_innen_klein[i]][g_innen_klein[i]];
        }

    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 502, MPI_COMM_WORLD, & sende_request);
    }

// Kommentar: Analog zu randaustausch1_testen, nur das bzgl. der Variablen 3 entpackt wird.
bool KleineRandStrukturKommunikation::randaustausch3_testen(void)
    {
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable3[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
    return(true);
    }

// Kommentar: Analog zu randaustausch1_initiieren, nur das bzgl. der Variablen 4 gepackt wird.
void KleineRandStrukturKommunikation::randaustausch4_initiieren(void)
    {
#ifdef AUSGABEN_KRK
    cout << " 1 " << endl;
#endif
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 503, MPI_COMM_WORLD, & empfangs_request);
#ifdef AUSGABEN_KRK
    cout << " 2 anzahl_innen_klein " << anzahl_innen_klein << " ebene " << gitterebene << " KommFarbe " << komm_farbe << " rang " << rang_kk << endl;
#endif
    for(i=0; i<anzahl_innen_klein; i++)
        {
#ifdef AUSGABEN_KRK
        cout << " f " << f_innen_klein[i] << " g " << g_innen_klein[i] << endl;
#endif
        sendebuffer[i] = variable4[f_innen_klein[i]][g_innen_klein[i]];
        }
#ifdef AUSGABEN_KRK
    cout << " 3 " << endl;
#endif
    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 503, MPI_COMM_WORLD, & sende_request);
#ifdef AUSGABEN_KRK
    cout << " 4 " << endl;
#endif
    }

// Kommentar: Analog zu randaustausch1_testen, nur das bzgl. der Variablen 4 entpackt wird.
bool KleineRandStrukturKommunikation::randaustausch4_testen(void)
    {
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor variable 4 lesen rang " << rang_kk << " anzahl_aussen_klein " << anzahl_aussen_klein << endl;
#endif
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable4[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach variable 4 lesen rang " << rang_kk << endl;
#endif
    return(true);
    }

// Kommentar: Analog zu randaustausch1_initiieren, nur das bzgl. der Variablen 5 gepackt wird.
void KleineRandStrukturKommunikation::randaustausch5_initiieren(void)
    {
//    MPI_Irecv(empfangsbuffer, anzahl_aussen_klein, MPI_DOUBLE, zielrang, 504, MPI_COMM_WORLD, & empfangs_request);
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 504, MPI_COMM_WORLD, & empfangs_request);
    for(i=0; i<anzahl_innen_klein; i++)
        {
        sendebuffer[i] = variable5[f_innen_klein[i]][g_innen_klein[i]];
        }

    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 504, MPI_COMM_WORLD, & sende_request);
    }

// Kommentar: Analog zu randaustausch1_testen, nur das bzgl. der Variablen 5 entpackt wird.
bool KleineRandStrukturKommunikation::randaustausch5_testen(void)
    {
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable5[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
    return(true);
    }

// Kommentar: Die Signatur wird bitweise in den si_buffer_senden geschrieben.
void KleineRandStrukturKommunikation::schreibe_signatur_in_buffer(void)
    {
// Kommentar: Zuerst wird an die Klasse bool_short_int der Buffer si_buffer_senden sowie das Offset 0 bergeben.
    bool_short_int.anfang(si_buffer_senden, 0);

// Kommentar: Durchlaufe den Innenrand.
    for(i=0; i<anzahl_rs; i++)
        {
// Kommentar: Und schreibe das Bit fr die Signatur der Innenstruktur in den Buffer mit Hilfe der Klasse bool_short_int.
        if(signatur_innen[i]==true)
            {
            bool_short_int.schreiben(true);
            }
        else
            {
            bool_short_int.schreiben(false);
            }
        }
    }

// Kommentar: Soll zurckgeben, wieviel double - Zahlen fr eine vorgegebene Anzahl an bool'schen Werten gebraucht werden.
// Eine bool'sche Variable braucht ein Byte, ein double 8 Byte (sizeof verwenden). Also :8, entspricht >> 3.
int KleineRandStrukturKommunikation::berechne_offset(int anzahl_bool_in_double)
    {
    return(1+(anzahl_bool_in_double>>3)); // nderung 19.10.15: Ein double hat 8 Byte (sizeof(double)=8)
    }

//void KleineRandStrukturKommunikation::randaustausch23_initiieren(void)

// Kommentar: Nicht analog zu randaustausch1_initiieren. Hierbei wird die Signatur mitbertragen. Sie wird an den
// Anfang des bertragenen Buffers gepackt. Wenn diese Funktion als erstes aufgerufen wird, liegt die
// Signatur vor, und die brigen Funktionen knnen ihre Rnder korrekt bertragen. Nur fr die Variablen '23' wird die Signatur bertragen.
// Nach der Signatur werden die Werte gepackt und bertragen und entpackt. Deshalb wird mit berechne_offset berechnet, wo die Variablenwerte
// hin geschrieben und von wo sie gelesen werden.
void KleineRandStrukturKommunikation::randaustausch23_initiieren(int _anzahl_rs)
    {
#ifdef AUSGABEN_KRK
    cout << " Beginn KleineRandStrukturKommunikation::randaustausch23_initiieren / rang " << rang_kk << endl;
#endif
// Kommentar: Die Lnge der Signatur wird bergeben.
    anzahl_rs = _anzahl_rs;
// Kommentar: Dann wird die Signatur in den Sendebuffer geschrieben.
    schreibe_signatur_in_buffer();
// Fehler: Es wird anzahl_innen_klein_mal_2 berechnet, aber nicht fr MPI_Isend verwendet.
// Diesen Fehler habe ich schon korrigiert.
#ifdef AUSGABEN_KRK
    cout << "1" << endl;
#endif
#ifdef AUSGABEN_KRK
    cout << "2" << endl;
#endif
// Kommentar: Der Empfang einer solchen Nachricht des Partnerkerns wird initiiert.
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 505, MPI_COMM_WORLD, & empfangs_request);
#ifdef AUSGABEN_KRK
    cout << "3 anzahl " << anzahl_innen_klein_mal_2 << endl;
#endif
// Kommentar: Um die Signatur nicht zu berschreiben, bekommt das Schreiben der Variablen - Werte eine Anfangsposition
// nach der Signatur.
    j = berechne_offset(anzahl_rs);

// Kommentar: Jetzt werden die Variablenwerte gem der kleinen Innenrandstruktur in den sendebuffer geschrieben - ab
// der Anfangsposition.
    for(i=0; i<anzahl_innen_klein; i++)
        {
#ifdef AUSGABEN_KRK
        cout << "4" << endl;
        cout << "f " << f_innen_klein[i] << endl;
        cout << "g " << g_innen_klein[i] << endl;
        cout << "v " << variable2[f_innen_klein[i]][g_innen_klein[i]] << endl;
        cout << "s " << sendebuffer[i] << endl;
#endif
        sendebuffer[j++] = variable2[f_innen_klein[i]][g_innen_klein[i]];
#ifdef AUSGABEN_KRK
        cout << "5" << endl;
#endif
        sendebuffer[j++] = variable3[f_innen_klein[i]][g_innen_klein[i]];
#ifdef AUSGABEN_KRK
        cout << "6" << endl;
#endif
        }
#ifdef AUSGABEN_KRK
    cout << "7" << endl;
#endif

// Kommentar: Und am Ende wird die Nachricht mit SIgnatur und Variablenwerten verschickt an den Partnerkern mit der
// ID zielrang.
    MPI_Isend(sendebuffer, j, MPI_DOUBLE, zielrang, 505, MPI_COMM_WORLD, & sende_request);
#ifdef AUSGABEN_KRK
    cout << "8" << endl;
#endif
    }

// Kommentar: Wenn die Kommunikation noch nicht abgeschlossen ist, wird nur false zurckgegeben. Ansonsten
// wird die Auen - Signatur aus dem Buffer entpackt, und true zurckgegeben.
bool KleineRandStrukturKommunikation::randaustausch23_testen(int _anzahl_a_rs)
    {
// Kommentar: Wenn das Senden nicht abgeschlossen ist => return false.
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
// Kommentar: Wenn das Empfangen nicht abgeschlossen ist => return false.
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
// Ansonsten bergebe man die Lnge des Auenrandes.
    anzahl_a_rs = _anzahl_a_rs;
#ifdef AKTUELLE_KOMMENTARE
    cout << " GGFFEE anzahl_a_rs " << anzahl_a_rs << endl;
#endif
// Kommentar: Dann schreibe man die Signatur des Auenrandes.
    lese_die_signatur_aus_buffer();
// Kommentar: ... und gebe true zurck.
    return(true);
    }

// Kommentar: Hier werden die Variablenwerte ausgepackt.
void KleineRandStrukturKommunikation::randaustausch23_einfuegen(void)
    {
#ifdef AUSGABEN_KRK
    cout << " anzahl_a_rs " << anzahl_a_rs << " anzahl_aussen_klein " << anzahl_aussen_klein << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " GGFFEE anzahl_a_rs " << anzahl_a_rs << " anzahl_aussen_klein " << anzahl_aussen_klein << " rang " << rang_kk << " rang_ziel " << rang_ziel;
#endif

// Kommentar: Zuerst berechnet man mit anzahl_a_rs, d.h. der Auenrandlnge, ab welcher Adresse die Variablen
// gepackt wurden.
// Bemerkung: anzahl_a_rs ist bekannt, weil randaustausch23_testen vor dieser Funktion aufgerufen wird.
    j = berechne_offset(anzahl_a_rs);

// Kommentar: Dann werden die variable2 und variable3 gema der kleinen Auenrandstruktur aus dem Empfangsbuffer beschrieben
// - mit jeweils einem Inkrement dex Indexes.
    for(i=0; i<anzahl_aussen_klein; i++)
        {
#ifdef AUSGABEN_KRK
        cout << " i " << i << " f_aussen_klein " << f_aussen_klein[i] << " g_aussen_klein " << g_aussen_klein[i] << " j " << j << " rang " << rang_kk << endl;
#endif
        variable2[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[j++];
        variable3[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[j++];
#ifdef AKTUELLE_KOMMENTARE
        cout << " i " << i << " f_a_k " << f_aussen_klein[i] << " g_a_k " << g_aussen_klein[i];
        cout << " r0 " << variable2[f_aussen_klein[i]][g_aussen_klein[i]];
        cout << " Iu0 " << variable3[f_aussen_klein[i]][g_aussen_klein[i]];
#endif
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
    }

// Kommentar: Die Signatur der kleinen Auenstruktur wird bitweise aus dem si_buffer_emmpfangen gelesen.
void KleineRandStrukturKommunikation::lese_die_signatur_aus_buffer(void)
    {
// Kommentar: Zuerst wird die Struktur bool_short_int mit dem Buffer si_buffer_empfangen verknpft.
    bool_short_int.anfang(si_buffer_empfangen, 0);
// Kommentar: Dann wird der Auenrand durchlaufen, und die Signatur der Auenrandstruktur Bit fr Bit beschrieben,
// nach dem, was aus der Struktur bool_short_int gelesen worden ist.
    for(i=0; i<anzahl_a_rs; i++)
        {
        if(bool_short_int.lesen()==true)
            {
            signatur_aussen[i] = true;
            }
        else
            {
            signatur_aussen[i] = false;
            }
        }
    }

// Kommentar: Analog zu randaustausch1_initiieren, nur das bzgl. der Variablen 6 gepackt wird.
void KleineRandStrukturKommunikation::randaustausch6_initiieren(void)
    {
//    MPI_Irecv(empfangsbuffer, anzahl_aussen_klein, MPI_DOUBLE, zielrang, 506, MPI_COMM_WORLD, & empfangs_request);
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 506, MPI_COMM_WORLD, & empfangs_request);
    for(i=0; i<anzahl_innen_klein; i++)
        {
        sendebuffer[i] = variable6[f_innen_klein[i]][g_innen_klein[i]];
        }

    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 506, MPI_COMM_WORLD, & sende_request);
    }

// Kommentar: Analog zu randaustausch1_testen, nur das bzgl. der Variablen 6 entpackt wird.
bool KleineRandStrukturKommunikation::randaustausch6_testen(void)
    {
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable6[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
    return(true);
    }

// Kommentar: Analog zu randaustausch1_initiieren, nur das bzgl. der Variablen 7 gepackt wird.
void KleineRandStrukturKommunikation::randaustausch7_initiieren(void)
    {
    MPI_Irecv(empfangsbuffer, mn2, MPI_DOUBLE, zielrang, 507, MPI_COMM_WORLD, & empfangs_request);
    for(i=0; i<anzahl_innen_klein; i++)
        {
        sendebuffer[i] = variable7[f_innen_klein[i]][g_innen_klein[i]];
        }

    MPI_Isend(sendebuffer, anzahl_innen_klein, MPI_DOUBLE, zielrang, 507, MPI_COMM_WORLD, & sende_request);
    }

// Kommentar: Analog zu randaustausch1_testen, nur das bzgl. der Variablen 7 entpackt wird.
bool KleineRandStrukturKommunikation::randaustausch7_testen(void)
    {
    MPI_Test(&sende_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    MPI_Test(&empfangs_request, &flag, & status);
    if(flag == false)
        {
        return(false);
        }
    for(i=0; i<anzahl_aussen_klein; i++)
        {
        variable7[f_aussen_klein[i]][g_aussen_klein[i]] = empfangsbuffer[i];
        }
    return(true);
    }

// Kommentar: Die kleine Randstruktur funktioniert auch mit der Randstrukturkommunikation. Zuerst wird mittels
// bilde_kleine_randstruktur_innen f_innen_klein und g_innen_klein und die signatur_innen geschrieben.
// Die Werte werden mit f_innen_klein und g_innen_klein eingelesen, und die signatur_innen wird bermittelt.
// Dann wird damit beim Empfnger die signatur_aussen. Mit der Funktion bilde_kleine_randstruktur_aussen wird
// damit f_aussen_klein und g_aussen_klein. Damit wird dann der Buffer eingelesen. Fertig.
