#include "kommunikation4er.h"

// Kommentar: In dieser Klasse Kommunikation4er wird die Kommunikation von Punkteupdate entfernen gefolgt von Farbenupdate einfuegen
// und Farbenupdate entfernen protokolliert, und dann verschickt. Der Empfnger bekommt zu jeder Farbe der
// Gemeinschaftstopologien von feinem und grobem Gitter die Anfangs - und Endpositionen der Eintrge im Buffer, sowie den Zugriff
// auf den jeweiligen Buffer.

// Kommentar: Hier wird der fr die Klasse bereitgestellt Speicherplatz freigegeben. Zu den Variablen vergleiche man die Initialisierung.
void Kommunikation4er::finalisieren(void)
    {
    delete sendebuffer;
    delete empfangsbuffer;

    delete sendebuffer_index;
    delete empfangsbuffer_index;

    delete sende_request;
    delete empfange_request;

    delete PT_feingitter_und_grobgitter;

    delete fu_einfuegen_anfang;
    delete fu_einfuegen_ende;
    delete fu_entfernen_anfang;
    delete fu_entfernen_ende;
    delete pu_einfuegen_anfang;
    delete pu_einfuegen_ende;
    delete pu_entfernen_anfang;
    delete pu_entfernen_ende;

#ifdef KOMM4ER_FELDER
    for(i=0; i<groesse; i++)
        {
        punktfeldliste[i].finalisierung();
        }
    delete punktfeldliste;
#endif
    }

// Kommentar: Hier wird die Klasse initialisiert, also mit Speicherplatz sowie den ntigen Parametern bzw. Zeigern auf bentigte Strukturen versorgt.
void Kommunikation4er::initialisieren(ParallelesRechnen * _paralleles_rechnen, int * _PT_feingitter, int * _PT_grobgitter, bool ** _testfeld, short int * _f_test, short int * _g_test)
// wird richtig finalisiert
    {
// Kommentar: Speicherung von bergabeparametern. Das Feld paralleles Rechnen gibt z.B. weitere Parameter mit, whrend die Tests zum Speichern
// schon geschriebener Eintrge dienen - was nun von der Punktfeldliste bernommen wird, siehe unten.
    paralleles_rechnen = _paralleles_rechnen;
    testfeld = _testfeld;
    f_test = _f_test;
    g_test = _g_test;

// Kommentar: Die folgenden Parameter werden von paralleles Rechnen bernommen.
    groesse = paralleles_rechnen -> groesse;
    rang = paralleles_rechnen -> rang;

    n = paralleles_rechnen -> n;
    m = paralleles_rechnen -> m;

#ifdef AKTUELLE_KOMMENTARE
    cout << " Komm4er / rang " << rang << " groesse " << groesse << " n " << n << " m " << m << endl;
#endif

// Kommentar: Die Zeiger auf Sendebuffer und Empfangsbuffer werden angelegt.
    sendebuffer = new char * [groesse];
    empfangsbuffer = new char * [groesse];

#ifdef AUSGABEN_KOMMUNIKATION4ER
    cout << "Sendebuffer und Empfangsbuffer sind vorbereitet " << endl;
#endif

// Kommentar: Die Indizes fr Sendebuffer und Empfangsbuffer werden angelegt.
    sendebuffer_index = new int [groesse];
    empfangsbuffer_index = new int [groesse];

// Kommentar: Die Requests frs Senden und Empfangen werden angelegt.
    sende_request = new MPI_Request[groesse];
    empfange_request = new MPI_Request[groesse];

// Kommentar: Die bergabeparameter fr die Kerntopologie werden gespeichert, und der Speicherplatz fr die neue, gemeinsame
// Kern - Topologie wird angelegt.
    PT_feingitter = _PT_feingitter;
    PT_grobgitter = _PT_grobgitter;
    PT_feingitter_und_grobgitter = new int [groesse];

// Kommentar: Die Positionen fr den Anfang und das Ende der Bufferindizes zu jeder Aufgabe werden angelegt. pu_einfuegen wird, vgl. die Dissertation,
// eigentlich nicht gebraucht.
    fu_einfuegen_anfang = new int [groesse];
    fu_einfuegen_ende = new int [groesse];
    fu_entfernen_anfang = new int [groesse];
    fu_entfernen_ende = new int [groesse];
    pu_einfuegen_anfang = new int [groesse];
    pu_einfuegen_ende = new int [groesse];
    pu_entfernen_anfang = new int [groesse];
    pu_entfernen_ende = new int [groesse];

// Die Empfangsbufferlnge wird in Zeile 12518 der Klasse Programm geschrieben.
//    empfangsbuffer_laenge = paralleles_rechnen -> m * paralleles_rechnen -> n;

    anzahl_test = 0;

// Kommentar: Die Punktfeldliste wird angelegt, um zu speichern, was an Punkten schon belegt worden ist, und in O(Gitterpunktanzahl) zurckgesetzt
// zu werden.
#ifdef KOMM4ER_FELDER
    punktfeldliste = new PunktFeldListe [groesse];
    for(i=0; i<groesse; i++)
        {
        punktfeldliste[i].initialisierung(m, n);
        }
#endif
    }

// Kommentar: Hier wird die gemischte Topologie berechnet. Die Eintrge sind > 0, genau dann, wenn eine Verbindung bzgl. dieser
// Kern - Topologie existiert.
void Kommunikation4er::gemischte_topologie_bestimmen(void)
    {
// Kommentar: Man durchluft alle Kern ID's.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
// Kommentar: Und addiert im Falle fremder ID's die beiden Topologiewerte.
            {
            PT_feingitter_und_grobgitter[i] = PT_feingitter[i] + PT_grobgitter[i];
            }
        else
            {
            PT_feingitter_und_grobgitter[i] = 0;
            }
        }
    }

// Kommentar: Man setzt den Beginn der Sendebufferindizes auf die erste Speicherposition, in diesem Fall 8.
void Kommunikation4er::beginn_fu_einfuegen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            sendebuffer_index[i] = 8;
            }
        }
    }

// Kommentar: Man beendet fr diese Klasse das Einfgen beim Farbenupdate.
void Kommunikation4er::ende_fu_einfuegen(void)
    {
// Kommentar: Es werden alle ID's von bezglich der gemeinsamen Kerntopologie benachbarten Kerne durchlaufen.
    for(i=0; i<groesse; i++)
        {
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " 1. PT_feingitter_und_grobgitter [" << i << "] = " << PT_feingitter_und_grobgitter[i] << endl;
#endif
        if(PT_feingitter_und_grobgitter[i]>0)
            {
// Kommentar: Der aktuelle Sendebufferindex wird fr den Kern i auf die Position 0+1 geschrieben. Denn es wird ein
// short int in einen char - Buffer geschrieben.
            schreibe_short_int(i, 0, sendebuffer_index[i]);
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Kommunikation4er::ende_fu_einfuegen << rang " << rang << " i " << i << " sendebuffer_index[i] " << sendebuffer_index[i] << endl;
            cout << " Kommunikation4er::ende_fu_einfuegen << rang " << rang << " lesen " << lese_short_int(i, 0) << endl;
#endif
//            sendebuffer[i][0] = sendebuffer_index[i];

// Kommentar: Und es wird die Punktfeldliste zu dem Kern mit der ID gelscht.
#ifdef KOMM4ER_FELDER
            punktfeldliste[i].reset();
#endif
            }
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " Ende 1. PT " << endl;
#endif
        }
    }

// Kommentar: Analog zu Ende_fu_einfuegen, nur, dass der Sendebufferindex auf die Position 2+3 geschrieben wird.
// Damit beendet man fr diese Klasse die Aktion pu_entfernen.
void Kommunikation4er::ende_pu_entfernen(void)
    {
    for(i=0; i<groesse; i++)
        {
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " 2. PT_feingitter_und_grobgitter [" << i << "] = " << PT_feingitter_und_grobgitter[i] << endl;
#endif
        if(PT_feingitter_und_grobgitter[i]>0)
            {
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Kommunikation4er::ende_pu_entfernen << rang " << rang << " lesen fu_einfuegen " << lese_short_int(i, 0) << endl;
#endif
            schreibe_short_int(i, 2, sendebuffer_index[i]);
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Kommunikation4er::ende_pu_entfernen << rang " << rang << " lesen fu_einfuegen " << lese_short_int(i, 0) << endl;
#endif
//            sendebuffer[i][0] = sendebuffer_index[i];
#ifdef KOMM4ER_FELDER
            punktfeldliste[i].reset();
#endif
            }
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " Ende 2. PT " << endl;
#endif
        }
    }

// Kommentar: Analog zu ende_fu_einfuegen, nur eben am Ende des Punkteupdates einfgen, was eigentlich nicht
// stattfindet. Im Gegensatz zu ende_fu_einfuegen wird hier der Sendebufferindex auf Position 4+5 geschrieben.
void Kommunikation4er::ende_pu_einfuegen(void)
    {
    for(i=0; i<groesse; i++)
        {
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " 3. PT_feingitter_und_grobgitter [" << i << "] = " << PT_feingitter_und_grobgitter[i] << endl;
#endif
        if(PT_feingitter_und_grobgitter[i]>0)
            {
            schreibe_short_int(i, 4, sendebuffer_index[i]);
#ifdef KOMM4ER_FELDER
            punktfeldliste[i].reset();
#endif
            }
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " Ende 3. PT " << endl;
#endif
        }
    }

// Kommentar: Analog zu ende_fu_einfuegen, nur eben am Ende des Farbenupdates entfernen. Im Gegensatz zu
// ende_fu_einfuegen wird hier der Sendebufferindex auf Position 6+7 geschrieben.
void Kommunikation4er::ende_fu_entfernen(void)
    {
    for(i=0; i<groesse; i++)
        {
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " 4. PT_feingitter_und_grobgitter [" << i << "] = " << PT_feingitter_und_grobgitter[i] << endl;
#endif
        if(PT_feingitter_und_grobgitter[i]>0)
            {
            schreibe_short_int(i, 6, sendebuffer_index[i]);
//            sendebuffer[i][0] = sendebuffer_index[i];
#ifdef KOMM4ER_FELDER
            punktfeldliste[i].reset();
#endif
            }
#ifdef AUSGABEN_KOMMUNIKATION4ER
        cout << " Ende 4. PT " << endl;
#endif
        }
    }

// Kommentar: Hier in der Nachbereitung werden die Buffergrenzen von Punkteupdate entfernen, Farbenupdate einfgen und Farbenupdate entfernen
// bestimmt, damit die zugreifende Struktur einfach die Buffer auslesen kann.
void Kommunikation4er::nachbereitung(void)
    {
// Kommentar: Es werden alle ID's von bezglich der gemeinsamen Kerntopologie benachbarten Kerne durchlaufen.
    for(i=0; i<groesse; i++)
        {
        if(PT_feingitter_und_grobgitter[i]>0)
            {
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 1 " << " Nachbereitung " << endl;
#endif
// Kommentar: Die Anfangsposition von Farbenupdate einfuegen ist 8.
            fu_einfuegen_anfang[i] = 8;
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 2 " << endl;

#endif
// Kommentar: Die Endposition des FU - Einfgen - Buffers wird aus dem Anfangselement des Buffers gelesen - fr den Kern der ID i.
            fu_einfuegen_ende[i] = lese_short_int(i, 0);
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " rang " << rang << " i " << i << " fu_einfuegen_ende[i] " << fu_einfuegen_ende[i] << " lese_si " << lese_short_int(i, 0) << endl;
            cout << " Rang " << rang << " i " << i << " 3 " << endl;
#endif

// Kommentar: Das ist auch gleichzeitig der Anfang des Buffers fr Punkteupdate entfernen.
            pu_entfernen_anfang[i] = fu_einfuegen_ende[i];
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 4 " << endl;
#endif

// Kommentar: Das Ende dieses Buffers wie der Anfang des Buffer fr Punkteupdate einfgen steht auf den Elementen 2 und 3 des
// Buffers - fr den Kern der ID i.
            pu_entfernen_ende[i] = lese_short_int(i, 2);
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 5 " << endl;
#endif
            pu_einfuegen_anfang[i] = pu_entfernen_ende[i];
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 6 " << endl;
#endif
// Kommentar: Das Ende dieses Buffers wie der Anfang des Buffer fr Farbenupdate entfernen steht auf den Elementen 4 und 5 des
// Buffers - fr den Kern der ID i.
            pu_einfuegen_ende[i] = lese_short_int(i, 4);
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 7 " << endl;
#endif
            fu_entfernen_anfang[i] = pu_einfuegen_ende[i];
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 8 " << endl;
#endif
// Kommentar: Das Ende dieses Buffers steht auf den Elementen 6 und 7 des Buffers - fr den Kern der ID i.
            fu_entfernen_ende[i] = lese_short_int(i, 6);
#ifdef AUSGABEN_KOMMUNIKATION4ER
            cout << " Rang " << rang << " i " << i << " 9 " << endl;
#endif
            }
        }
    }

// Kommunikation: Nachdem die Buffer geschrieben sind, knnen sie verschickt werden. Die Kommunikation macht ein Senden und
// Empfangen zu allen Kernen der fr beide Gitterebenen gemeinsamen Kerntopologie.
void Kommunikation4er::kommunizieren_starten(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(PT_feingitter_und_grobgitter[i] > 0)
// Das ist schlau: Denn auf dem feinen Gitter sind gewisse Informationen nicht da.
            {

            if(rang==i)
                {
                cout << "Fehler: Prozessortopologie in Kommunikation4er falsch" << endl;
                exit(-1);
                }
            if(sendebuffer_index[i]>empfangsbuffer_laenge)
                {
                cout << " Fehler: Zu langer Buffer fr Kommunikation4er rang " << rang << endl;
                exit(-1);
                }

// Kommentar: Die Sendebufferlnge entspricht dem Bufferindex.
            MPI_Isend(sendebuffer[i], sendebuffer_index[i], MPI_CHAR, i, 400, MPI_COMM_WORLD, &(sende_request[i]));

// Kommentar: Die Empfangsbufferlnge wurde von der Klasse Programm - Zeile 12518 - geschrieben.
            MPI_Irecv(empfangsbuffer[i], empfangsbuffer_laenge, MPI_CHAR, i, 400, MPI_COMM_WORLD, &(empfange_request[i]));
            }
        }
    }

// Kommentar: Hier wird getestet, ob fr alle Kerne der gemeinsamen Kerntopologie Senden und Empfangen abgeschlossen sind.
// Das geht mithilfe der Sende - und Empfangsrequests.
bool Kommunikation4er::kommunikation_fertig(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(rang != i)
            {
            if(PT_feingitter_und_grobgitter[i] > 0)
                {
                MPI_Test(&(sende_request[i]), &flag, &sende_status);
                if(flag==false)
                    {
                    return(false);
                    }
                MPI_Test(&(empfange_request[i]), &flag, &empfange_status);
                if(flag==false)
                    {
                    return(false);
                    }
                }
            }
        }
    return(true);
    }

//void Kommunikation4er::einfuegen_pu(int f, int g, int farbe_zielprozessor)

// Kommentar: Hier geschieht ein Einfgen eines Elementes, das der Zielprozessor auf den Koordinaten (f,g) lschen soll.
void Kommunikation4er::entfernen_pu(int f, int g, int farbe_zielprozessor)
    {
// Kommentar: Ist die Farbe keinem Kern zuzuordnen, dann mache nichts.
    if(farbe_zielprozessor < 0)
        { return; }

// Kommentar: Wurde dieses Element zu diesem Zweck schon markiert, dann mache nichts.
#ifdef KOMM4ER_FELDER
    if(punktfeldliste[farbe_zielprozessor].feld[f][g]>=0)
        {
        return;
        }

// Kommentar: Markiere fr diesen Zielprozessor diese Feld - Koordinate.
    punktfeldliste[farbe_zielprozessor].hinzu(f,g);
#endif

// Kommentar: Dann lese den Index, und schreibe die short int - Koordinaten f und g in den Buffer, und kopiere den um 4 erhhten Index zurck.
    index = sendebuffer_index[farbe_zielprozessor];

    schreibe_short_int(farbe_zielprozessor, index, f);
    index = index + 2;
    schreibe_short_int(farbe_zielprozessor, index, g);
    index = index + 2;
    sendebuffer_index[farbe_zielprozessor] = index;
    }

// Kommentar: Hier geschieht ein Einfgen eines Farbwertes, das der Zielprozessor auf den Koordinaten (f,g) in fgff eintragen soll.
void Kommunikation4er::einfuegen_fu(short int f, short int g, char farbe, int farbe_zielprozessor)
// Farbe_Zielprozessor: An wen die Information geht. char farbe, welche Farbe eingetragen wird. 15.10.2014
// Ich knnte auch ohne die Farbe, wen das Ziel der PaarKern ist. Aber: Das wird dann komplizierter zu packen sein.
    {
// Kommentar: Diese Funktion funktioniert wie entfernen_pu, nur dass neben den Koordinaten (f,g) auch noch der Farbwert der
// einzutragenden Farbe gespeichert wird. Daher erhht sich der Index dieser Funktion statt um 4 um 5 - je Eintrag.
    if(farbe_zielprozessor < 0)
        { return; }
#ifdef KOMM4ER_FELDER
    if(punktfeldliste[farbe_zielprozessor].feld[f][g]>=0)
        {
        return;
        }
    punktfeldliste[farbe_zielprozessor].hinzu(f,g);
#endif
#ifdef AUSGABE_KOMM4ER
    if((farbe_zielprozessor==0)&&(f == 9)&&(g == 10))
        {
        int farbe_int;
        farbe_int = farbe;
        cout << " YYYX 2 einfuegen_fu rang " << rang << " farbe " << farbe_int << endl;
        }
#endif
// Warum kein testfeld? Das ist noch zu korrigieren.
    index = sendebuffer_index[farbe_zielprozessor];
    farbe_int = (int) farbe;
#ifdef AAHH
    if((rang==3)&&(farbe_zielprozessor==2)&&(farbe==0)&&(f == 19)&&(g==7))
        {
        cout << " AAHH einfuegen fu " << endl;
        }
#endif
#ifdef AUSGABEN_KOMMUNIKATION4ER
    cout << " Komm4er::einfuegen_fu index " << index << " f " << f << " g " << g;
    cout << " farbe " << farbe_int << " zielP " << farbe_zielprozessor << " rang " << rang << endl;
#endif
    schreibe_short_int(farbe_zielprozessor, index, f);
    index = index + 2;
    schreibe_short_int(farbe_zielprozessor, index, g);
    index = index + 2;
    sendebuffer[farbe_zielprozessor][index++] = farbe;
    sendebuffer_index[farbe_zielprozessor] = index;
    }

// Kommentar: Diese Funktion funktioniert wie entfernen_pu, siehe oben. Nur das hier kein Punkt entfernt, sondern
// der Zielkern auf die bertragene Koordinate den Wert -1 in sein Feingitterfarbenfeld schreiben soll. Die
// Funktionsweise beider Funktionen ist aber identisch.
void Kommunikation4er::entfernen_fu(short int f, short int g, int farbe_zielprozessor)
    {
    if(farbe_zielprozessor < 0)
        { return; }
#ifdef KOMM4ER_FELDER
    if(punktfeldliste[farbe_zielprozessor].feld[f][g]>=0)
        {
        return;
        }
    punktfeldliste[farbe_zielprozessor].hinzu(f,g);
#endif
//    if(farbe_zielprozessor == rang)
//        { return; }   // 6.2.16: Diese Kommentare lasse ich, weil so ein return diskussionsbedrftig ist, vgl. die Dissertation.
#ifdef AUSGABEN_KOMMUNIKATION4ER
    cout << " entfernen_fu rang " << rang << " farbe_zielprozessor " << farbe_zielprozessor << " f " << f << " g " << g << endl;
    if((farbe_zielprozessor==0)&&(f==16)&&(g==15))
        {
        cout << " Punkt-Lschen-Befehl von Kern mit rang " << rang << endl;
        }
#endif
    index = sendebuffer_index[farbe_zielprozessor];
    schreibe_short_int(farbe_zielprozessor, index, f);
    index = index + 2;
    schreibe_short_int(farbe_zielprozessor, index, g);
    index = index + 2;
    sendebuffer_index[farbe_zielprozessor] = index;
    }

// Kommentar: Es wird ein Integerwert durch Zeigermanipulation in einen short int - Buffer geschrieben.
void Kommunikation4er::schreibe_short_int(int farbe, int index, int wert)
    {
    merken = &(sendebuffer[farbe][index]);
    merken_si = (short int *) merken;
    merken_si[0] = wert;
    }

// Kommentar: Es wird ein Integerwert durch Zeigermanipulation aus einem short int - Buffer gelesen.
short int Kommunikation4er::lese_short_int(int farbe, int index)
    {
    merken = &(empfangsbuffer[farbe][index]);
    merken_si = (short int *) merken;
    return(merken_si[0]);
    }

