#ifndef KOMMUNIKATION4ER
#define KOMMUNIKATION4ER

#include <mpi.h>
#include "paralleles_rechnen.h"

class Kommunikation4er
    {
public:
    char ** sendebuffer;
    char ** empfangsbuffer;
private:
    int * sendebuffer_index, * empfangsbuffer_index;
public:
    int empfangsbuffer_laenge;
private:
    int * PT_feingitter; // Prozessortopologie/Kerntopologie;
private:
    int * PT_grobgitter;
public:
    int * PT_feingitter_und_grobgitter;

public:
    void initialisieren(ParallelesRechnen * _paralleles_rechnen, int * _PT_feingitter, int * _PT_grobgitter, bool ** _testfeld, short int * _f_test, short int * _g_test);
    void finalisieren(void);
private:
    ParallelesRechnen * paralleles_rechnen;
public:
    int groesse, rang;
    void einfuegen_pu(int f, int g, int farbe_zielprozessor);
    void einfuegen_fu(short int f, short int g, char farbe, int farbe_zielprozessor);

    void entfernen_pu(int f, int g, int farbe_zielprozessor);
    void entfernen_fu(short int f, short int g, int farbe_zielprozessor);
private:
    int index;
private:
    MPI_Request * sende_request;
    MPI_Request * empfange_request;
    int flag;
    MPI_Status sende_status, empfange_status;
public:
    bool kommunikation_fertig(void);
public:
    void kommunizieren_starten(void);
private:
    int i;
public:
    int * fu_einfuegen_anfang, * fu_einfuegen_ende;
    int * fu_entfernen_anfang, * fu_entfernen_ende;
    int * pu_einfuegen_anfang, * pu_einfuegen_ende;
    int * pu_entfernen_anfang, * pu_entfernen_ende;
public:
    void beginn_fu_einfuegen(void);
    void ende_fu_einfuegen(void);
    void ende_pu_einfuegen(void);
    void ende_pu_entfernen(void);
    void ende_fu_entfernen(void);
public:
    int n, m;
private:
    void schreibe_short_int(int farbe, int index, int wert);
    short int lese_short_int(int farbe, int index);
    char * merken;
    short int * merken_si;
public:
    void nachbereitung(void);
private:
public:
    void gemischte_topologie_bestimmen(void);
    int farbe_int;
private:
    bool ** testfeld;
    short int * f_test;
    short int * g_test;
    int anzahl_test;
private:
#ifdef KOMM4ER_FELDER
    PunktFeldListe * punktfeldliste;
#endif
    };

#endif
