#include "la_kommunikationen.h"

// Kommentar: Hier werden die Kommunikationen der Klasse Lastausgleich - wo die Migration gemacht wird - durchgefhrt.
// Erlutert werden nur die Funktionen fr den Westen. Fr den Osten hat man nur einen anderen Namen, und verwendet ID_ost statt ID_west,
// und fr Nord und Sd verwendet man statt eines mvf_buffer's einen mhf_buffer.

// Kommentar: In der Initialisierung werden die ID's in Bezug auf die 4 Himmelsrichtungen bergeben und gespeichert, dazu fr die Empfangsbufferlnge
// mn, und es wird der Rang bergeben und gespeichert.
void LAKommunikationen::initialisieren(int _ID_west, int _ID_ost, int _ID_nord, int _ID_sued, int _mn, int _rang)
    {
    ID_west = _ID_west;
    ID_ost = _ID_ost;
    ID_nord = _ID_nord;
    ID_sued = _ID_sued;
    mn = _mn;
    rang = _rang;
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAKini " << " rang " << rang << " ID_west " << ID_west << " ID_ost " << ID_ost << " ID_nord " << ID_nord << " ID_sued " << ID_sued << endl;
#endif
    }

// Kommentar: Der mvf - Buffer wird nach Westen verschickt.
void LAKommunikationen::initiiere_senden_west_mvf(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
// Kommentar: Der mvf - Buffer der Lnge mvf_buffer->index wird nach Westen verschickt. Die Kommunikation dafr wird hier initiiert.
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_SHORT, ID_west, 1000, MPI_COMM_WORLD, &request_senden_west_mvf);
#else
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_INT, ID_west, 1000, MPI_COMM_WORLD, &request_senden_west_mvf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_west_mvf Tag 1000 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Entsprechend dem sende nach Westen Requests fr mvf - Buffer wird hier geprft, ob die nach Westen zum Senden initiierte Kommunikation
// abgeschlossen ist. Wenn ja, return true, ansonsten return false.
bool LAKommunikationen::test_senden_west_mvf(void)
    {
    int flag;

    MPI_Test(&request_senden_west_mvf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Der mvf - Buffer fr das Verschicken in Bezug auf die obere Gitterebene wird nach Westen verschickt.
void LAKommunikationen::initiiere_senden_west_mvf_oben(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
// Kommentar: Der mvf - Buffer der Lnge mvf_buffer->index wird nach Westen verschickt. Die Kommunikation dafr wird hier initiiert.
// Das Request hierfr trgt den Suffix oben, und damit kann diese Kommunikation von initiiere_senden_west_mvf unterschieden werden.
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_SHORT, ID_west, 1010, MPI_COMM_WORLD, &request_senden_west_mvf_oben);
#else
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_INT, ID_west, 1010, MPI_COMM_WORLD, &request_senden_west_mvf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_west_mvf Tag 1000 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Entsprechend dem sende nach Westen Requests fr mvf - Buffer fr oben wird hier geprft, ob die nach Westen zum Senden initiierte Kommunikation
// abgeschlossen ist. Wenn ja, return true, ansonsten return false.
bool LAKommunikationen::test_senden_west_mvf_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_west_mvf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Der Werte - Buffer wird nach Westen verschickt.
void LAKommunikationen::initiiere_senden_west_werte(WerteBuffer * werte_buffer)
    {
// Kommentar: Der Werte - Buffer der Lnge werte_buffer->index wird nach Westen verschickt. Die Kommunikation dafr wird hier initiiert.
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_west, 1001, MPI_COMM_WORLD, &request_senden_west_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_west_werte Tag 1001 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Entsprechend dem sende nach Westen Requests fr Werte wird hier geprft, ob die nach Westen zum Senden der Werte initiierte Kommunikation
// abgeschlossen ist. Wenn ja, return true, ansonsten return false.
bool LAKommunikationen::test_senden_west_werte(void)
    {
    int flag;

    MPI_Test(&request_senden_west_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Der Werte - Buffer fr oben wird nach Westen verschickt.
void LAKommunikationen::initiiere_senden_west_werte_oben(WerteBuffer * werte_buffer)
    {
// Kommentar: Der Werte - Buffer der Lnge werte_buffer->index fr oben wird nach Westen verschickt. Die Kommunikation dafr wird hier initiiert.
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_west, 1011, MPI_COMM_WORLD, &request_senden_west_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_west_werte Tag 1001 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Entsprechend dem sende nach Westen Requests fr Werte fr oben wird hier geprft, ob die nach Westen zum Senden der Werte initiierte Kommunikation fr oben
// abgeschlossen ist. Wenn ja, return true, ansonsten return false.
bool LAKommunikationen::test_senden_west_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_west_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Die folgenden 'Ost - Funktionen' entsprechen den West - Funktionen oben. Daher hierfr keine weiteren Kommentare.
void LAKommunikationen::initiiere_senden_ost_mvf(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_SHORT, ID_ost, 1002, MPI_COMM_WORLD, &request_senden_ost_mvf);
#else
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_INT, ID_ost, 1002, MPI_COMM_WORLD, &request_senden_ost_mvf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_ost_mvf Tag 1002 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_ost_mvf(void)
    {
    int flag;

    MPI_Test(&request_senden_ost_mvf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_ost_mvf_oben(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_SHORT, ID_ost, 1012, MPI_COMM_WORLD, &request_senden_ost_mvf_oben);
#else
    MPI_Isend(mvf_buffer->buffer, mvf_buffer->index, MPI_INT, ID_ost, 1012, MPI_COMM_WORLD, &request_senden_ost_mvf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_ost_mvf Tag 1002 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_ost_mvf_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_ost_mvf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_ost_werte(WerteBuffer * werte_buffer)
    {
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK vor senden_ost_werte " << endl;
#endif
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_ost, 1003, MPI_COMM_WORLD, &request_senden_ost_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_ost_werte Tag 1003 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_ost_werte(void)
    {
    int flag;

    MPI_Test(&request_senden_ost_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_ost_werte_oben(WerteBuffer * werte_buffer)
    {
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK vor senden_ost_werte " << endl;
#endif
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_ost, 1013, MPI_COMM_WORLD, &request_senden_ost_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK senden_ost_werte Tag 1003 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_ost_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_ost_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }
// EMPFANGEN !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1

// Kommentar: Der Empfang der mvf - Buffer von Westen - nicht oben - wird hier initiiert.
void LAKommunikationen::initiiere_empfangen_west_mvf(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
// Kommentar: Das geschieht hier mit MPI_Irecv. Der Buffer kann maximal die Lnge mn haben. Das Request ist zum Empfangen
// von Westen fr den mvf - Buffer nicht oben gewhlt.
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_SHORT, ID_west, 1002, MPI_COMM_WORLD, &request_empfangen_west_mvf);
#else
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_INT, ID_west, 1002, MPI_COMM_WORLD, &request_empfangen_west_mvf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_west_mvf Tag 1002 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Es wird geprft, ob der Empfang des mvf - Buffers von Westen - nicht - oben - abgeschlossen ist. Es wird ein entsprechendes
// Request verwendet.
bool LAKommunikationen::test_empfangen_west_mvf(void)
    {
    int flag;

    MPI_Test(&request_empfangen_west_mvf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Der Empfang der mvf - Buffer von Westen - hier fr oben - wird hier initiiert.
void LAKommunikationen::initiiere_empfangen_west_mvf_oben(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
// Kommentar: Das geschieht hier mit MPI_Irecv. Der Buffer kann maximal die Lnge mn haben. Das Request ist zum Empfangen
// von Westen fr den mvf - Buffer fr oben gewhlt.
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_SHORT, ID_west, 1012, MPI_COMM_WORLD, &request_empfangen_west_mvf_oben);
#else
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_INT, ID_west, 1012, MPI_COMM_WORLD, &request_empfangen_west_mvf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_west_mvf Tag 1002 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Es wird geprft, ob der Empfang des mvf - Buffers von Westen - fr oben - abgeschlossen ist. Es wird ein entsprechendes
// Request verwendet.
bool LAKommunikationen::test_empfangen_west_mvf_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_west_mvf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Analog zu initiiere_empfangen_west_mvf, nur dass hier der Werte - Buffer statt des mvf - Buffers empfangen wird.
void LAKommunikationen::initiiere_empfangen_west_werte(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_west, 1003, MPI_COMM_WORLD, &request_empfangen_west_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_west_werte Tag 1003 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu test_empfangen_west_mvf, nur dass hier der Empfang des Werte - Buffers statt des mvf - Buffers getestet wird.
bool LAKommunikationen::test_empfangen_west_werte(void)
    {
    int flag;

    MPI_Test(&request_empfangen_west_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Analog zu initiiere_empfangen_west_werte, nur das hier der Buffer fr oben - mit dem entsprechenden Request - verschickt wird.
void LAKommunikationen::initiiere_empfangen_west_werte_oben(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_west, 1013, MPI_COMM_WORLD, &request_empfangen_west_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_west_werte Tag 1003 ID_west " << ID_west << " rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu test_empfangen_west_werte, nur dass hier der Empfang des Werte - Buffers oben statt des Werte Buffers unten getestet wird,
// vgl. das entsprechende Request.
bool LAKommunikationen::test_empfangen_west_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_west_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Die Empfangen und Test auf Empfang Funktionen fr Osten kommen hier dran - analog zu den entsprechenden Funktionen fr Westen.
// Daher keine weiteren Kommentare.
void LAKommunikationen::initiiere_empfangen_ost_mvf(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_SHORT, ID_ost, 1000, MPI_COMM_WORLD, &request_empfangen_ost_mvf);
#else
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_INT, ID_ost, 1000, MPI_COMM_WORLD, &request_empfangen_ost_mvf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_ost_mvf Tag 1000 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_ost_mvf(void)
    {
    int flag;

    MPI_Test(&request_empfangen_ost_mvf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_ost_mvf_oben(MVFBuffer * mvf_buffer)
    {
#ifdef KURZ_MVF
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_SHORT, ID_ost, 1010, MPI_COMM_WORLD, &request_empfangen_ost_mvf_oben);
#else
    MPI_Irecv(mvf_buffer->buffer, mn, MPI_INT, ID_ost, 1010, MPI_COMM_WORLD, &request_empfangen_ost_mvf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_ost_mvf Tag 1000 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_ost_mvf_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_ost_mvf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_ost_werte(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_ost, 1001, MPI_COMM_WORLD, &request_empfangen_ost_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_west_werte Tag 1001 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_ost_werte(void)
    {
    int flag;

    MPI_Test(&request_empfangen_ost_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_ost_werte_oben(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_ost, 1011, MPI_COMM_WORLD, &request_empfangen_ost_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << "LAK empfangen_west_werte Tag 1001 ID_ost " << ID_ost << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_ost_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_ost_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

////////////////////////////////////////////////////////
////////////    Nord   Sued   //////////////////////////
////////////////////////////////////////////////////////

// Kommentar: Und hier kommen die Funktionen fr Norden und Sden dran. Hier wird der mhf_Buffer statt des mvf - Buffers verwendet, und
// natrlich tragen die Requests hier andere Namen. Aber im Prinzip sind es dieselben Funktionen wie fr Osten und Westen. Daher keine
// weiteren Kommentare dazu.

void LAKommunikationen::initiiere_senden_nord_mhf(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_SHORT, ID_nord, 1100, MPI_COMM_WORLD, &request_senden_nord_mhf);
#else
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_INT, ID_nord, 1100, MPI_COMM_WORLD, &request_senden_nord_mhf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_nord_mhf Tag 1100 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_nord_mhf(void)
    {
    int flag;

    MPI_Test(&request_senden_nord_mhf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_nord_mhf_oben(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_SHORT, ID_nord, 1110, MPI_COMM_WORLD, &request_senden_nord_mhf_oben);
#else
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_INT, ID_nord, 1110, MPI_COMM_WORLD, &request_senden_nord_mhf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_nord_mhf Tag 1110 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_nord_mhf_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_nord_mhf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_nord_werte(WerteBuffer * werte_buffer)
    {
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_nord, 1101, MPI_COMM_WORLD, &request_senden_nord_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_nord_werte Tag 1101 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_nord_werte(void)
    {
    int flag;

    MPI_Test(&request_senden_nord_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_nord_werte_oben(WerteBuffer * werte_buffer)
    {
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_nord, 1111, MPI_COMM_WORLD, &request_senden_nord_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_nord_werte Tag 1101 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_nord_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_nord_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_sued_mhf(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_SHORT, ID_sued, 1102, MPI_COMM_WORLD, &request_senden_sued_mhf);
#else
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_INT, ID_sued, 1102, MPI_COMM_WORLD, &request_senden_sued_mhf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_sued_mhf Tag 1102 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_sued_mhf(void)
    {
    int flag;

    MPI_Test(&request_senden_sued_mhf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_sued_mhf_oben(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_SHORT, ID_sued, 1112, MPI_COMM_WORLD, &request_senden_sued_mhf_oben);
#else
    MPI_Isend(mhf_buffer->buffer, mhf_buffer->index, MPI_INT, ID_sued, 1112, MPI_COMM_WORLD, &request_senden_sued_mhf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_sued_mhf Tag 1112 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_sued_mhf_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_sued_mhf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_sued_werte(WerteBuffer * werte_buffer)
    {
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns vor senden_sued_werte " << endl;
#endif
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_sued, 1103, MPI_COMM_WORLD, &request_senden_sued_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_sued_werte Tag 1103 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_sued_werte(void)
    {
    int flag;

    MPI_Test(&request_senden_sued_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_senden_sued_werte_oben(WerteBuffer * werte_buffer)
    {
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns vor senden_sued_werte " << endl;
#endif
    MPI_Isend(werte_buffer->buffer, werte_buffer->index, MPI_DOUBLE, ID_sued, 1113, MPI_COMM_WORLD, &request_senden_sued_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns senden_sued_werte_oben Tag 1113 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_senden_sued_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_senden_sued_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }
// EMPFANGEN !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1

void LAKommunikationen::initiiere_empfangen_nord_mhf(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_SHORT, ID_nord, 1102, MPI_COMM_WORLD, &request_empfangen_nord_mhf);
#else
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_INT, ID_nord, 1102, MPI_COMM_WORLD, &request_empfangen_nord_mhf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_nord_mhf Tag 1102 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_nord_mhf(void)
    {
    int flag;

    MPI_Test(&request_empfangen_nord_mhf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_nord_mhf_oben(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_SHORT, ID_nord, 1112, MPI_COMM_WORLD, &request_empfangen_nord_mhf_oben);
#else
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_INT, ID_nord, 1112, MPI_COMM_WORLD, &request_empfangen_nord_mhf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_nord_mhf Tag 1102 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_nord_mhf_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_nord_mhf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }


void LAKommunikationen::initiiere_empfangen_nord_werte(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_nord, 1103, MPI_COMM_WORLD, &request_empfangen_nord_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_nord_werte Tag 1103 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_nord_werte(void)
    {
    int flag;

    MPI_Test(&request_empfangen_nord_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_nord_werte_oben(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_nord, 1113, MPI_COMM_WORLD, &request_empfangen_nord_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_nord_werte Tag 1103 ID_nord " << ID_nord << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_nord_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_nord_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_sued_mhf(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_SHORT, ID_sued, 1100, MPI_COMM_WORLD, &request_empfangen_sued_mhf);
#else
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_INT, ID_sued, 1100, MPI_COMM_WORLD, &request_empfangen_sued_mhf);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_sued_mhf Tag 1100 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_sued_mhf(void)
    {
    int flag;

    MPI_Test(&request_empfangen_sued_mhf, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_sued_mhf_oben(MHFBuffer * mhf_buffer)
    {
#ifdef KURZ_MHF
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_SHORT, ID_sued, 1110, MPI_COMM_WORLD, &request_empfangen_sued_mhf_oben);
#else
    MPI_Irecv(mhf_buffer->buffer, mn, MPI_INT, ID_sued, 1110, MPI_COMM_WORLD, &request_empfangen_sued_mhf_oben);
#endif
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_sued_mhf Tag 1110 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_sued_mhf_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_sued_mhf_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_sued_werte(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_sued, 1101, MPI_COMM_WORLD, &request_empfangen_sued_werte);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_sued_werte Tag 1101 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_sued_werte(void)
    {
    int flag;

    MPI_Test(&request_empfangen_sued_werte, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }

void LAKommunikationen::initiiere_empfangen_sued_werte_oben(WerteBuffer * werte_buffer)
    {
    MPI_Irecv(werte_buffer->buffer, mn, MPI_DOUBLE, ID_sued, 1111, MPI_COMM_WORLD, &request_empfangen_sued_werte_oben);
#ifdef AUSGABEN_LA_KOMMUNIKATIONEN
    cout << " LAK ns empfangen_sued_werte_oben Tag 1111 ID_sued " << ID_sued << " rang " << rang << endl;
#endif
    }

bool LAKommunikationen::test_empfangen_sued_werte_oben(void)
    {
    int flag;

    MPI_Test(&request_empfangen_sued_werte_oben, &flag, & status);
    if(flag==true)
        {
        return(true);
        }
    return(false);
    }
