#ifndef LA_KOMMUNIKATIONEN
#define LA_KOMMUNIKATIONEN 1

#include <mpi.h>

#include <iostream>

using namespace std;

#include "mvf_buffer.h"
#include "mhf_buffer.h"
#include "werte_buffer.h"

class LAKommunikationen
    {
private:
    MPI_Status status;
private:
    MPI_Request request_senden_west_mvf;
    MPI_Request request_senden_west_werte;
    MPI_Request request_senden_ost_mvf;
    MPI_Request request_senden_ost_werte;
    MPI_Request request_empfangen_west_mvf;
    MPI_Request request_empfangen_west_werte;
    MPI_Request request_empfangen_ost_mvf;
    MPI_Request request_empfangen_ost_werte;

    MPI_Request request_senden_west_mvf_oben;
    MPI_Request request_senden_west_werte_oben;
    MPI_Request request_senden_ost_mvf_oben;
    MPI_Request request_senden_ost_werte_oben;
    MPI_Request request_empfangen_west_mvf_oben;
    MPI_Request request_empfangen_west_werte_oben;
    MPI_Request request_empfangen_ost_mvf_oben;
    MPI_Request request_empfangen_ost_werte_oben;

    MPI_Request request_senden_nord_mhf;
    MPI_Request request_senden_nord_werte;
    MPI_Request request_senden_sued_mhf;
    MPI_Request request_senden_sued_werte;
    MPI_Request request_empfangen_nord_mhf;
    MPI_Request request_empfangen_nord_werte;
    MPI_Request request_empfangen_sued_mhf;
    MPI_Request request_empfangen_sued_werte;

    MPI_Request request_senden_nord_mhf_oben;
    MPI_Request request_senden_nord_werte_oben;
    MPI_Request request_senden_sued_mhf_oben;
    MPI_Request request_senden_sued_werte_oben;
    MPI_Request request_empfangen_nord_mhf_oben;
    MPI_Request request_empfangen_nord_werte_oben;
    MPI_Request request_empfangen_sued_mhf_oben;
    MPI_Request request_empfangen_sued_werte_oben;
public:
    void initialisieren(int _ID_west, int _ID_ost, int _ID_nord, int _ID_sued, int _mn, int _rang);
    void initiiere_senden_west_mvf(MVFBuffer * mvf_buffer);
    bool test_senden_west_mvf(void);
    void initiiere_senden_west_werte(WerteBuffer * werte_buffer);
    bool test_senden_west_werte(void);
    void initiiere_senden_ost_mvf(MVFBuffer * mvf_buffer);
    bool test_senden_ost_mvf(void);
    void initiiere_senden_ost_werte(WerteBuffer * werte_buffer);
    bool test_senden_ost_werte(void);
    void initiiere_empfangen_west_mvf(MVFBuffer * mvf_buffer);
    bool test_empfangen_west_mvf(void);
    void initiiere_empfangen_west_werte(WerteBuffer * werte_buffer);
    bool test_empfangen_west_werte(void);
    void initiiere_empfangen_ost_mvf(MVFBuffer * mvf_buffer);
    bool test_empfangen_ost_mvf(void);
    void initiiere_empfangen_ost_werte(WerteBuffer * werte_buffer);
    bool test_empfangen_ost_werte(void);

    void initiiere_senden_west_mvf_oben(MVFBuffer * mvf_buffer);
    bool test_senden_west_mvf_oben(void);
    void initiiere_senden_west_werte_oben(WerteBuffer * werte_buffer);
    bool test_senden_west_werte_oben(void);
    void initiiere_senden_ost_mvf_oben(MVFBuffer * mvf_buffer);
    bool test_senden_ost_mvf_oben(void);
    void initiiere_senden_ost_werte_oben(WerteBuffer * werte_buffer);
    bool test_senden_ost_werte_oben(void);
    void initiiere_empfangen_west_mvf_oben(MVFBuffer * mvf_buffer);
    bool test_empfangen_west_mvf_oben(void);
    void initiiere_empfangen_west_werte_oben(WerteBuffer * werte_buffer);
    bool test_empfangen_west_werte_oben(void);
    void initiiere_empfangen_ost_mvf_oben(MVFBuffer * mvf_buffer);
    bool test_empfangen_ost_mvf_oben(void);
    void initiiere_empfangen_ost_werte_oben(WerteBuffer * werte_buffer);
    bool test_empfangen_ost_werte_oben(void);
public:
    void initiiere_senden_nord_mhf(MHFBuffer * mhf_buffer);
    bool test_senden_nord_mhf(void);
    void initiiere_senden_nord_werte(WerteBuffer * werte_buffer);
    bool test_senden_nord_werte(void);
    void initiiere_senden_sued_mhf(MHFBuffer * mhf_buffer);
    bool test_senden_sued_mhf(void);
    void initiiere_senden_sued_werte(WerteBuffer * werte_buffer);
    bool test_senden_sued_werte(void);
    void initiiere_empfangen_nord_mhf(MHFBuffer * mhf_buffer);
    bool test_empfangen_nord_mhf(void);
    void initiiere_empfangen_nord_werte(WerteBuffer * werte_buffer);
    bool test_empfangen_nord_werte(void);
    void initiiere_empfangen_sued_mhf(MHFBuffer * mhf_buffer);
    bool test_empfangen_sued_mhf(void);
    void initiiere_empfangen_sued_werte(WerteBuffer * werte_buffer);
    bool test_empfangen_sued_werte(void);

    void initiiere_senden_nord_mhf_oben(MHFBuffer * mhf_buffer);
    bool test_senden_nord_mhf_oben(void);
    void initiiere_senden_nord_werte_oben(WerteBuffer * werte_buffer);
    bool test_senden_nord_werte_oben(void);
    void initiiere_senden_sued_mhf_oben(MHFBuffer * mhf_buffer);
    bool test_senden_sued_mhf_oben(void);
    void initiiere_senden_sued_werte_oben(WerteBuffer * werte_buffer);
    bool test_senden_sued_werte_oben(void);
    void initiiere_empfangen_nord_mhf_oben(MHFBuffer * mhf_buffer);
    bool test_empfangen_nord_mhf_oben(void);
    void initiiere_empfangen_nord_werte_oben(WerteBuffer * werte_buffer);
    bool test_empfangen_nord_werte_oben(void);
    void initiiere_empfangen_sued_mhf_oben(MHFBuffer * mhf_buffer);
    bool test_empfangen_sued_mhf_oben(void);
    void initiiere_empfangen_sued_werte_oben(WerteBuffer * werte_buffer);
    bool test_empfangen_sued_werte_oben(void);

private:
    int ID_west, ID_ost, mn;
    int ID_nord, ID_sued;
    int rang;
    };

#endif
