#ifndef LASTAUSGLEICH
#define LASTAUSGLEICH 2

#define ISOLIERT 0
#define RECHTER_RAND 1
#define LINKER_RAND 2
#define MITTE 3
#define OBIGER_RAND 4
#define UNTERER_RAND 5


#ifndef LA_OBEN_IMMER_AUSGLEICHEN
#define LA_OBEN_IMMER_AUSGLEICHEN
#endif

#include "lastmengen.h"

#include "paralleles_rechnen.h"

#include "extreme_vektoren.h"

#include "farbenfelder_verschicken.h"

#include "aus_mv_zu_mvf_buffer.h"
#include "aus_mvf_buffer_zu_mv.h"

#include "aus_mv_zu_mhf_buffer.h"
#include "aus_mhf_buffer_zu_mv.h"

#include "werte_verschicken.h"

#include "mv_projektionen.h"
#include "mv_projektionen_ns.h"

#include "la_kommunikationen.h"

#include "nachkorrektur.h"

#include "farbmatrix.h"

#include "ausgaben.h"

#include "bool_int.h"
#include "bool_short_int.h"

#include "ep_s_bestimmen.h"

#include "punkt_feld_liste.h"

#include "timer.h"

#include "mv_horizontal.h"
#include "mhf_buffer.h"

#include "ep_snb_update.h"

#include "markierungsfeld.h"

#include <string.h>

// Bemerkung: Ich brauche Tester fr ev wie fr ev2. Fr ev wird wie mit Gitter - Liste verglichen

class LastAusgleich
    {
public:
    void initialisieren_pr(int _n, int _m, int _h_min, int _h_max, int _groesse, int _rang, int _h_kappe);
    void finalisieren_pr(void);
    void finalisierung_ausfuehren(void);
#ifdef GEMEINSAME_BUFFER
    void initialisierung_ausfuehren(double ** sendebuffer, double ** empfangsbuffer);
#else
    void initialisierung_ausfuehren(void);
#endif

private:
    LastMengen lastmengen;
public:
    ParallelesRechnen ** paralleles_rechnen_l;
private:
    int n, m;
private:
    int h_min;
private:
    int h_max, h_gesamt, groesse, rang;
private:
    int i, j, k;
private:
    void lasttransfer_anfangsmenge(int h);
private:
public:
    void lt_durchfuehren2_wo(int rang, int _gitterebene);
    void lt_durchfuehren1_ns(int _rang, int _gitterebene);
    void lt_durchfuehren2_ns(int _rang, int _gitterebene);
private:
    int gitterebene, gitterebene_plus1;
private:
    int NBI_horizontal;
    int NBI_horizontal_machen(int rang, int p_anzahl);
    int NBI_vertikal;
    int NBI_vertikal_machen(int rang, int p_anzahl);
    int sende_west, sende_ost, empfange_west, empfange_ost;
    int sende_nord, sende_sued, empfange_nord, empfange_sued;
    int sende_west_oben, sende_ost_oben;
    int sende_nord_oben, sende_sued_oben;
    void SendeEmpfangsFaelle(int NBI_h);
    void SendeEmpfangsFaelle_ns(int NBI_h);

private:
    MV_vertikal mv_osten;
    MV_vertikal mv_westen;
    MV_vertikal mv_hilfe_westen;
    MV_vertikal mv_hilfe_osten;

    MV_horizontal mv_norden;
    MV_horizontal mv_sueden;

    MV_horizontal mv_hilfe_norden;
    MV_horizontal mv_hilfe_sueden;

    MVFBuffer mvf_buffer_westen;
    MVFBuffer mvf_buffer_osten;

    MVFBuffer mvf_buffer_westen_oben;
    MVFBuffer mvf_buffer_osten_oben;

    MHFBuffer mhf_buffer_norden;
    MHFBuffer mhf_buffer_sueden;

    MHFBuffer mhf_buffer_norden_oben;
    MHFBuffer mhf_buffer_sueden_oben;
private:
    int h_LA;
private:
    MVProjektionen mv_projektionen;
    MVProjektionenNS mv_projektionen_ns;
private:
    int ** ID_ost, ** ID_west;
private:
    void finalisieren_LA(void);

#ifdef GEMEINSAME_BUFFER
    void initialisieren_LA(double ** sendebuffer, double ** empfangsbuffer);
#else
    void initialisieren_LA(void);
#endif
public:
    FarbenfelderVerschicken farbenfelder_verschicken;
private:
    ausMVzuMVFBuffer aus_mv_zu_mvf_buffer;
    ausMVFBufferzuMV aus_mvf_buffer_zu_mv;

    ausMVzuMHFBuffer aus_mv_zu_mhf_buffer;
    ausMHFBufferzuMV aus_mhf_buffer_zu_mv;
private:
    void packen_west_mv(int gesamtlast);
    void packen_west_ieS(void);
    void packen_west_abschliessen(void);

    void packen_ost_mv(int gesamtlast);

    void packen_west_oben_mv(int gesamtlast);
    void packen_west_oben_ieS(void);
    void packen_west_oben_abschliessen(void);

    void packen_ost_oben_mv(int gesamtlast);

    void entpacken_west(MVFBuffer * mvf_buffer);

    void entpacken_ost(MVFBuffer * mvf_buffer);
private:
public:
    ExtremeVektoren * ev;
    ExtremeVektoren * ev2;
    // Was bedeutet es, ev und ev2 zu haben? Doch: ev2 wohl fr den doppelten Lastausgleich!
private:
    ExtremeVektoren ev_i;

private:
    ParallelesRechnen * pr_i, * paralleles_rechnen_i;
    ParallelesRechnen * pr_i_minus1, * pr_i_plus1;
private:
    LAKommunikationen la_kommunikationen;
    WerteVerschicken werte_verschicken;
private:
    bool empfange_west_mvf, empfange_west_werte;
    bool empfange_west_mvf_oben, empfange_west_werte_oben;
    bool empfange_nord_mhf, empfange_nord_werte;
    bool empfange_nord_mhf_oben, empfange_nord_werte_oben;


    WerteBuffer werte_buffer_westen, werte_buffer_osten;
    WerteBuffer werte_buffer_westen_oben, werte_buffer_osten_oben;
    WerteBuffer werte_buffer_norden, werte_buffer_sueden;
    WerteBuffer werte_buffer_norden_oben, werte_buffer_sueden_oben;

    bool empfange_ost_mvf, empfange_ost_werte;
    bool sende_west_mvf, sende_west_werte;
    bool sende_ost_mvf, sende_ost_werte;

    bool empfange_ost_mvf_oben, empfange_ost_werte_oben;
    bool sende_west_mvf_oben, sende_west_werte_oben;
    bool sende_ost_mvf_oben, sende_ost_werte_oben;

    bool empfange_sued_mhf, empfange_sued_werte;
    bool sende_nord_mhf, sende_nord_werte;
    bool sende_sued_mhf, sende_sued_werte;

    bool empfange_sued_mhf_oben, empfange_sued_werte_oben;
    bool sende_nord_mhf_oben, sende_nord_werte_oben;
    bool sende_sued_mhf_oben, sende_sued_werte_oben;
private:
    void nachkorrektur_durchfuehren(void);

    void nachkorrektur_west_senden(void);
    void nachkorrektur_west_empfangen(void);

    void nachkorrektur_ost_senden(void);
    void nachkorrektur_ost_empfangen(void);
public:
    void aktiviere_ist_nachbarn(void);
private:
public:
    Nachkorrektur nachkorrektur;
private:
    // Was ist mit der Nachkorrektur fr EV2?
    void nachkorrektur_durchfuehren_sendebuffer_bestimmen(void);
    void nachkorrektur_durchfuehren_sendebuffer_bestimmen_abschliessen(void);
private:
    int m_hilfe, n_hilfe;
private:
    bool ist_fertig_west;
    bool ist_fertig_ost;
    bool ist_fertig;
private:
    void komplettieren_west(void);
    void komplettieren_ost(void);
private:
    int o;
    void einfuegen(int * empfangsbuffer, int h);
    void entfernen(int * sendebuffer, int h, int zielrang);

    void kontrahieren(int * buffer);

private:

    int * empfangsbuffer;
    int * sendebuffer;
private:
    void kopiere_sendebuffer(int * ziel, int * quelle);

private:
    int vektoranzahl;
    int sendebuffer_laenge;
    int empfangsbuffer_laenge;
    int l;
    int vvektor_f1, vvektor_f2, vvektor_g;
    int laenge;
public:
    void ausgeben(void);
private:
    void komplettieren_nord(void);
    void komplettieren_sued(void);
    void kontrahieren_v(int * buffer);
    void einfuegen_v(int * empfangsbuffer, int h);
    void entfernen_v(int * sendebuffer, int h, int zielrang);
private:
public:
    ExtremeVektoren * ev_h_minus1;
    ExtremeVektoren * ev2_h_minus1;
private:
    int hvektor_g1, hvektor_g2, hvektor_f;
private:
    int * n_h, * m_h;
private:
    FarbMatrix farbmatrix;
private:
#ifdef KURZ_NKFF
    short int ** nk_farbenfeld_speichern;
    short int * nk_farbenfeld_speichern2;
#else
    int ** nk_farbenfeld_speichern;
    int * nk_farbenfeld_speichern2;
#endif
private:
    int * f1, * f2, * g, index;
    int * g1, * g2, * f;
    void entferne_ebene(MV_vertikal * mv_vertikal, int ebene);
    void entferne_ebene_fuer_ev(MV_vertikal * mv_vertikal, int ebene);
    void entferne_ebene_fuer_ev2(MV_vertikal * mv_vertikal, int ebene);
    ExtremeVektoren * ev_ebene, * ev2_ebene, * ev2_ebene_plus1;
    int f_2, g_2;
    void einfuegen_ebene(MV_vertikal * mv_vertikal, int ebene);
private:
public:
    int west_differenz_oben, ost_differenz_oben;
    int nord_differenz_oben, sued_differenz_oben;
private:
public:
    int west_differenz, ost_differenz;
    int nord_differenz, sued_differenz;
private:
    void lt_vorab(void);
    void lt_vorab_ns(void);
    void test_und_entpacken(void);
    void test_und_entpacken_ns(void);
private:
    void packen_ost_ieS(void);
    void packen_ost_abschliessen(void);
private:
    void packen_ost_oben_ieS(void);
    void packen_ost_oben_abschliessen(void);
private:
    int sende_west_speichern, sende_ost_speichern;
    int sende_nord_speichern, sende_sued_speichern;
    bool nichts;
public:
    short int *** ep_aktuell;
private:
    int offset;
    BoolInt bool_int;
    BoolShortInt bool_short_int;
    int f1_h, f2_h, g_h;
    int g1_h, g2_h, f_h;
private:
    void packen_ep(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    void packen_ep_ns(MV_horizontal * mv, MHFBuffer * mhf_buffer);
    void entpacken_ep(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    void entpacken_ep_ns(MV_horizontal * mv, MHFBuffer * mhf_buffer);
public:
    int * ist_nachbar_zaehler_ml;
public:
    void setze_ebene_ebenen_zaehler(int * PT_ml);
public:
    EP_s_bestimmen ** ep_updates;
    EP_s_bestimmen * ep_updates_i;
public:
    int * ep_ebenen;
    int ep_ebenen_hw;
private:
    void test003(char * text);
private:
    void signum(int faktor);
    void signum2(int faktor);
public:
    void initialisierung_ev(int _ev_typen);
private:
    int ev_typen;
public:
    int ev_dim;
// ev_dim = 1 => kein reziproker Lastausgleich
// ev_dim = 2 => reziproker Lastausgleich
private:
    void entferne_ebeneEV(MV_vertikal * mv_vertikal, int ebene);
    void entferne_ebeneEV2(MV_vertikal * mv_vertikal, int ebene);

    void einfuegen_ebeneEV(MV_vertikal * mv_vertikal, int ebene);
    void einfuegen_ebeneEV2(MV_vertikal * mv_vertikal, int ebene);
private:
    inline void packen_west_oben_mvEVEV(int gesamtlast);
    inline void packen_west_oben_mvEV2EV2(int gesamtlast);

    inline void entpacken_westEV(MVFBuffer * mvf_buffer);
    inline void entpacken_westEV2(MVFBuffer * mvf_buffer);

    inline void entpacken_ostEV(MVFBuffer * mvf_buffer);
    inline void entpacken_ostEV2(MVFBuffer * mvf_buffer);
    inline void entpacken_nordEV(MHFBuffer * mvf_buffer);
    inline void entpacken_nordEV2(MHFBuffer * mvf_buffer);

    inline void entpacken_suedEV(MHFBuffer * mvf_buffer);
    inline void entpacken_suedEV2(MHFBuffer * mvf_buffer);

    void entpacken_sued(MHFBuffer * mhf_buffer);
    void entpacken_nord(MHFBuffer * mhf_buffer);

    inline void packen_ost_oben_mvEVEV(int gesamtlast);
    inline void packen_ost_oben_mvEV2EV2(int gesamtlast);

    void packen_west_mvEV(int gesamtlast);
    void packen_west_mvEV2(int gesamtlast);
    void packen_west_mvEV2_mit_oben(int gesamtlast);

    void packen_ost_mvEV(int gesamtlast);
    void packen_ost_mvEV2(int gesamtlast);
    void packen_ost_mvEV2_mit_oben(int gesamtlast);

    void packen_nord_mvEV(int gesamtlast);
    void packen_nord_mvEV2(int gesamtlast);
    void packen_nord_mvEV2_mit_oben(int gesamtlast);

    void packen_sued_mvEV(int gesamtlast);
    void packen_sued_mvEV2(int gesamtlast);
    void packen_sued_mvEV2_mit_oben(int gesamtlast);

public:
    PunktFeldListe ** ep_plus, ** ep_minus;
    PunktFeldListe * ep_plus_i, * ep_minus_i;
    EP_SNBupdate ** ep_snb_update, * ep_snb_update_i;

    void entferne_ep_listen_ns(MV_horizontal * mv_horizontal);
    void einfuegen_ep_listen_ns(MV_horizontal * mv_horizontal);
private:
    short int *** felder_aktuell, ** feld_aktuell;
public:
    void setze_felder_aktuell(short int ** _feld_aktuell, int ebene);
private:
    bool bool_hilfsvariable;
public:
    Timer timer_la_gesamt;
    Timer timer_la_test_und_entpacken;
    Timer timer_la_anfang;
    Timer timer_la_senden;
    Timer timer_la_nachkorrektur;
    Timer timer_la_nachkorrektur1;
    Timer timer_la_nachkorrektur1a;
    Timer timer_la_nachkorrektur1b;
    Timer timer_la_nachkorrektur2;
    Timer timer_la_nachkorrektur2a;
    Timer timer_la_nachkorrektur2b;
    Timer timer_la_packen;
    Timer timer_la_senden_ies;
private:
    void entferne_ebeneEV_ns(MV_horizontal * mv_horizontal, int ebene);
    void entferne_ebeneEV2_ns(MV_horizontal * mv_horizontal, int ebene);
    void einfuegen_ebeneEV_ns(MV_horizontal * mv_horizontal, int ebene);
    void einfuegen_ebeneEV2(MV_horizontal * mv_horizontal, int ebene);
private:
    void packen_sued_ieS(void);
    void packen_sued_oben_ieS(void);
    void packen_nord_ieS(void);
    void packen_nord_oben_ieS(void);

    void einfuegen_ebeneEV2_ns(MV_horizontal * mv_horizontal, int ebene);

    inline void packen_nord_mv(int gesamtlast);
    inline void packen_sued_mv(int gesamtlast);
    inline void packen_nord_oben_mv(int gesamtlast);
    inline void packen_sued_oben_mv(int gesamtlast);

    void packen_nord_abschliessen(void);
    void packen_nord_oben_abschliessen(void);

    void packen_sued_abschliessen(void);
    void packen_sued_oben_abschliessen(void);

    inline void packen_nord_oben_mvEVEV(int gesamtlast);
    inline void packen_nord_oben_mvEV2EV2(int gesamtlast);

    inline void packen_sued_oben_mvEVEV(int gesamtlast);
    inline void packen_sued_oben_mvEV2EV2(int gesamtlast);

private:
    void einpunktausgabe(char * position);
    void positionsausgabe(char * text);
private:
    char zeichenkette[100];
private:
    void fgff_info(char * text);
private:
    int anzahl;
private:
    void LA_vollenden_ep_plus(void);
    void LA_vollenden_ep_minus(void);
public:
    void LA_vollenden(void);
public:
    int t;
private:
    void ausgabe_ep_minus_wert(char * text);
private:
    int eigene_last;
    void prototyp(void);
private:
    int h_kappe;
    int h_gesamt_variante;
public:
    void initialisieren_zusatz(MarkierungsFeld * _neuer_punkt_ebenen, bool _ist_zusammen_aV_LA);
private:
    MarkierungsFeld * neuer_punkt_ebenen;
private:
    bool ist_zusammen_aV_LA;
private:
    short int ** hilfsfeld;
/////////////////////////////
private:
    inline void packen_ep_mit_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    inline void packen_ep_ohne_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    inline void packen_ep_rumpf(void);
    inline void packen_ep_rumpf_mit_markierungsfeld(void);
    inline void entpacken_ep_mit_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    inline void entpacken_ep_ohne_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer);
    inline void entpacken_ep_rumpf(void);
    inline void entpacken_ep_rumpf_mit_markierungsfeld(void);

    inline void packen_ep_ns_mit_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer);
    inline void packen_ep_ns_ohne_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer);
    inline void packen_ep_ns_rumpf(void);
    inline void packen_ep_ns_rumpf_mit_markierungsfeld(void);
    inline void entpacken_ep_ns_mit_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer);
    inline void entpacken_ep_ns_ohne_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer);
    inline void entpacken_ep_ns_rumpf(void);
    inline void entpacken_ep_ns_rumpf_mit_markierungsfeld(void);
private:
    void test_la1(char * wo);
    void code103(char * text);
public:
    bool ev_gilt;
    bool ev2_gilt;
private:
    inline void packen_markierungsfeld(void);
    inline void entpacken_markierungsfeld(void);
    inline void packen_ns_markierungsfeld(void);
    inline void entpacken_ns_markierungsfeld(void);
private:
    MarkierungsFeld * hilfsmarkierung;
    };

#endif
