#ifndef LASTAUSGLEICHSSTEUERUNG
#define LASTAUSGLEICHSSTEUERUNG

#include "lastmengenbestimmung.h"
#include "lastvektorauswertung.h"

#ifndef PLB
#define PLB 0
#endif

#ifndef KN
#define KN 1
#endif

#ifndef VEKTOREN
#define VEKTOREN 0
#endif

#ifndef MATRIX
#define MATRIX 1
#endif

#ifndef OHNE
#define OHNE 0
#endif

#ifndef MIT
#define MIT 1
#endif

#ifndef FAKTOR
#define FAKTOR 1.01
#endif

#ifndef KEIN_TUN
#define KEIN_TUN 1
#endif

#ifndef ERST_NS_DANN_WO
#define ERST_NS_DANN_WO 2
#endif

#ifndef NUR_NS
#define NUR_NS 3
#endif

#ifndef ERST_WO_DANN_NS
#define ERST_WO_DANN_NS 4
#endif

#ifndef NUR_WO
#define NUR_WO 5
#endif

#ifndef SELBER_ENTSCHEIDEN
#define SELBER_ENTSCHEIDEN 6
#endif

#ifndef FEHLER_LA
#define FEHLER_LA -1
#endif

#include "ausgaben.h"

class LastAusgleichsSteuerung
    {
    LastMengenBestimmung lastmengenbestimmung;
    LastVektorAuswertung lastvektorauswertung_wo, lastvektorauswertung_ns;

public:
    void initialisierung(int _groesse, int _rang);
    void finalisierung(void);
private:
    int groesse, rang, position_f, position_g, groesse_f, groesse_g;
    int groesse_g_2, groesse_f_2;
    int groesse_g_2_p1, groesse_f_2_p1;
    int position_g_2, position_f_2;
    int position_g_2_p1, position_f_2_p1;
    int agg_wert, max_wert;
    int lh_wert, lv_wert;
private:
    int * lastvektor_horizontal, * lastvektor_vertikal;
public:
    int plb_kn;
private:
public:
    void horizontaler_vektor_ohne(int eigene_last);
    void vollende_horizontaler_vektor_ohne(void);
    void horizontaler_vektor_ohne_alles(int _eigene_last);
    void vertikaler_vektor_ohne_alles(int _eigene_last);
    void vertikaler_vektor_ohne(int eigene_last);
    void vollende_vertikaler_vektor_ohne(void);
    void horizontaler_vektor_mit_alles(int _eigene_last, int _eigene_last_oben);
    void horizontaler_vektor_mit(int eigene_last, int eigene_last_oben);
    void vollende_horizontaler_vektor_mit(void);
    void vertikaler_vektor_mit(int eigene_last, int eigene_last_oben);
    void vollende_vertikaler_vektor_mit(void);
    void vollende_matrix_mit_erst_ns(void);

    int komplette_entscheidung_matrix_mit(int _eigene_last, int _eigene_last_oben);
    int teilweise_entscheidung_matrix_mit(int _eigene_last, int _eigene_last_oben);
    int komplette_entscheidung_matrix_ohne(int _eigene_last);
    int teilweise_entscheidung_matrix_ohne(int _eigene_last);
private:
    int i, j, k;
public:
    int west_differenz, ost_differenz, nord_differenz, sued_differenz;
    int west_differenz_oben, ost_differenz_oben, nord_differenz_oben, sued_differenz_oben;

    void matrix_ohne(int eigene_last);
    void vollende_matrix_ohne(void);
    void matrix_mit(int eigene_last, int eigene_last_oben);
    void vollende_matrix_mit(void);
    void matrix_ohne_erst_ns(int eigene_last);
    void vollende_matrix_ohne_erst_ns(void);
    void matrix_mit_erst_ns(int eigene_last, int eigene_last_oben);
private:
    int ** last_alle_prozessoren;
private:
    int durchschnitt, maximum;
public:
    void matrix_ausgeglichen(void);
    void matrix_ausgeglichen_mit(void);
    bool ausgeglichen;
    int a_ij;
public:
    bool horizontaler_vektor_machen;
    bool vertikaler_vektor_machen;
private:
    int maximum_wo, maximum_ns, durchschnitt_wo, durchschnitt_ns;
private:
    double epsilon_vektor, epsilon_matrix;
private:
    void initialisieren_epsilons(void);
public:
    void vertikaler_vektor_mit_alles(int _eigene_last, int _eigene_last_oben);
    };

#endif
