#include "lastmatrix.h"

// Kommentar: Hier kommt es zu einer Bewertung der Lastmatrix - fr Lastausgleichsentscheidungen.

// Kommentar: Eine Initialisierung der Klasse
void LastMatrix::initialisieren(bool _ist_oben, int _groesse_f, int _groesse_g)
    {
// Die bergabeparameter werden gespeichert.
    ist_oben = _ist_oben;
    groesse_f = _groesse_f;
    groesse_g = _groesse_g;
    groesse = groesse_f * groesse_g;

// Kommentar: Mit ist_oben = true wird auch die Matrix fr oben angelegt, ansonsten nur die Matrix fr das
// eine Gitter.
    if(ist_oben == true)
        {
        matrix = new int * [groesse_f];
        matrix_oben = new int * [groesse_f];

        for(i=0; i<groesse_f; i++)
            {
            matrix[i] = new int [groesse_g];
            matrix_oben[i] = new int [groesse_g];
            }
        }
    else
        {
        matrix = new int * [groesse_f];

        for(i=0; i<groesse_f; i++)
            {
            matrix[i] = new int [groesse_g];
            }
        }
    }

// Kommentar: Hier wird bewertet, ob die Last ausgeglichen ist.
bool LastMatrix::ist_ausgeglichen(void)
    {
// Kommentar: Hier wird bewerten aufgerufen. Man bestimmt die Gesamtlast und die Maximallast.
    bewerten();
// Kommentar: Wenn beide Ebenen einbezogen werden ...
    if(ist_oben == true)
        {
// Kommentar: Falls beide Lastungleichungen erfllt sind, dann return true, ansonsten return false.
        if((bewerte_koeffizienten()==true)&&(bewerte_koeffizienten_oben()==true))
            {
            return(true);
            }
        return(false);
        }
// Kommentar: Falls die Lastungleichung erfllt ist, dann return true, ansonsten return false.
    if(bewerte_koeffizienten()==true)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Liegt ein vollstndiger Lastausgleich auf der Hauptlastausgleichsebene vor?
bool LastMatrix::bewerte_koeffizienten(void)
    {
// Man prft, ob Anzahl an Kernen * maximaler Kernlast unter der Gesamtlast liegt. Falls ja, dann liegt ein vollstndiger
// Lastausgleich vor, ansonsten nicht.
    if(groesse * (max_last-1) <= gesamtlast)
        {
        return(true);
        }
    else
        {
        return(false);
        }
    }

// Kommentar: Liegt ein vollstndiger Lastausgleich auf der grberen Ebene vor? Die Kommentare sind analog zu denen
// der Funktion bewerte_koeffizienten.
bool LastMatrix::bewerte_koeffizienten_oben(void)
    {
    if(groesse * (max_last_oben-1) <= gesamtlast_oben)
        {
        return(true);
        }
    else
        {
        return(false);
        }
    }

// Kommentar: Es werden die Lastmaxima und die Gesamtlast bestimmt.
void LastMatrix::bewerten(void)
    {
    if(ist_oben == true)
        {
        bewerten_mit();
        }
    else
        {
        bewerten_ohne();
        }
    }

// Kommentar: Bestimme Maximum der Last sowie die Lastsumme auf der Hauptausgleichsebene.
void LastMatrix::bewerten_ohne(void)
    {
    max_last = 0;
    gesamtlast = 0;
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            matrix_ij = matrix[i][j];
// Kommentar: Gesamtlast += Einzellast
            gesamtlast = gesamtlast + matrix_ij;
// Kommentar: max_last = max(max_last, Einzellast)
            if(max_last < matrix_ij)
                {
                max_last = matrix_ij;
                }
            }
        }
    }

// Kommentar: Bestimme Maximum der Last sowie die Lastsumme auf beiden Lastausgleichsebenen.
void LastMatrix::bewerten_mit(void)
    {
// Kommentare: vgl. bewerten_ohne.
    max_last = 0;
    max_last_oben = 0;
    gesamtlast = 0;
    gesamtlast_oben = 0;
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            matrix_ij = matrix[i][j];
            matrix_ij_oben = matrix_oben[i][j];
            gesamtlast_oben = gesamtlast_oben + matrix_ij_oben;
            gesamtlast = gesamtlast + matrix_ij;
            if(max_last < matrix_ij)
                {
                max_last = matrix_ij;
                }
            if(max_last_oben < matrix_ij_oben)
                {
                max_last_oben = matrix_ij_oben;
                }
            }
        }
    }
