#include "lastmatrix_kopieren.h"

// Kommentar: Hier werden zwei Lastmatrizen über Zeiger erfasst, und Teile oder die gesamte Matrix per Befehl kopiert.

// Kommentar: Hier wird die Klasse LastMatrixKopieren initialisiert,  und dabei werden die Zeiger auf die Matrizen gespeichert,
// sowie die Zahl der Kerne pro Spalte und Zeile der Kerntopologie (-> groesse_f und groesse_g) sowie die eigene Position des Kernes
// in Ost - West Richtung (rang_g) oder Nord - Süd Richtung (rang_f).
void LastMatrixKopieren::initialisieren(LastMatrix * _ziel, LastMatrix * _quelle, bool _ist_oben, int _groesse_f, int _groesse_g, int _rang_f, int _rang_g)
    {
// Kommentar: Die Parameter werden gespeichert.
    quelle = _quelle;
    ziel = _ziel;
    ist_oben = _ist_oben;
    groesse_f = _groesse_f;
    groesse_g = _groesse_g;
    rang_f = _rang_f;
    rang_g = _rang_g;
    }

// Kommentar: Hier wird die ganze Matrix kopiert.
void LastMatrixKopieren::kopieren(void)
    {
// Kommentar: Wenn Lastausgleich auf beidenen Gitterebenen erfolgt, dann kopiere die Lastmatrix auf beiden Ebenen.
    if(ist_oben == true)
        {
        kopieren_mit_oben();
        }
// Kommentar: Ansonsten kopiere die Lastmatrix nur auf einer Ebene.
    else
        {
        kopieren_ohne_oben();
        }
    }

// Kommentar: Hier wird eine Spalte der Matrix kopiert.
void LastMatrixKopieren::kopieren_ns(void)
    {
// Kommentar: Wenn Lastausgleich auf beidenen Gitterebenen erfolgt, dann kopiere die Spalte für den Kern auf beiden Ebenen.
    if(ist_oben == true)
        {
        kopieren_ns_mit_oben();
        }
// Kommentar: Ansonsten kopiere die Spalte, in der der Kern ist, auf nur einer Ebene.
    else
        {
        kopieren_ns_ohne_oben();
        }
    }

// Kommentar: Analog zu kopieren_ns, nur für eine Zeile der Matrix.
void LastMatrixKopieren::kopieren_wo(void)
    {
    if(ist_oben == true)
        {
        kopieren_wo_mit_oben();
        }
    else
        {
        kopieren_wo_ohne_oben();
        }
    }

// Kommentar: Hier wird die ganze Matrix kopiert, aber nur für die untere Ebene.
void LastMatrixKopieren::kopieren_ohne_oben(void)
    {
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            ziel->matrix[i][j] = quelle->matrix[i][j];
            }
        }
    }

// Kommentar: Hier wird eine Spalte der Matrix kopiert, aber nur für die untere Ebene.
void LastMatrixKopieren::kopieren_ns_ohne_oben(void)
    {
    for(i=0; i<groesse_f; i++)
        {
// Kommentar: Die Spalte (i,rang_g) wird kopiert.
        ziel->matrix[i][rang_g] = quelle->matrix[i][rang_g];
        }
    }

// Kommentar: Hier wird eine Zeile der Matrix kopiert, aber nur für die untere Ebene.
void LastMatrixKopieren::kopieren_wo_ohne_oben(void)
    {
    for(j=0; j<groesse_g; j++)
        {
// Kommentar: Die Zeile (rang_f,j) wird kopiert.
        ziel->matrix[rang_f][j] = quelle->matrix[rang_f][j];
        }
    }

// Kommentar: Hier wird die ganze Matrix kopiert, und zwar für beide Ebenen.
void LastMatrixKopieren::kopieren_mit_oben(void)
    {
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            ziel->matrix[i][j] = quelle->matrix[i][j];
            ziel->matrix_oben[i][j] = quelle->matrix_oben[i][j];
            }
        }
    }

// Kommentar: Hier wird eine Spalte der Matrix kopiert, und zwar für beide Ebenen.
void LastMatrixKopieren::kopieren_ns_mit_oben(void)
    {
    for(i=0; i<groesse_f; i++)
        {
// Kommentar: Die Spalte (i,rang_g) wird kopiert.
        ziel->matrix[i][rang_g] = quelle->matrix[i][rang_g];
        ziel->matrix_oben[i][rang_g] = quelle->matrix_oben[i][rang_g];
        }
    }

// Kommentar: Hier wird eine Zeile der Matrix kopiert, und zwar für beide Ebenen.
void LastMatrixKopieren::kopieren_wo_mit_oben(void)
    {
    for(j=0; j<groesse_g; j++)
        {
// Kommentar: Die Zeile (rang_f,j) wird kopiert.
        ziel->matrix[rang_f][j] = quelle->matrix[rang_f][j];
        ziel->matrix_oben[rang_f][j] = quelle->matrix_oben[rang_f][j];
        }
    }

