#include "lastmengenbestimmung.h"

// Kommentar: Hier geschieht die Lastmengenbestimmung. Damit ist gemeint, dass die Lastwerte von anderen Kernen gesammelt werden, vgl. die
// Dissertation.

// Kommentar: Hier wird der eigene Lastwert gesetzt - im Falle der Lastberechnungen nur fr eine Gitterebene, also ohne reversen Lastausgleich.
void LastMengenBestimmung::setze_last(int _last)
    {
// Kommentar: Speichere den Lastwert ab.
    eigene_last = _last;
    }

// Kommentar: Hier wird der eigene Lastwert gesetzt - im Falle der Lastberechnungen fr zwei Gitterebenen, also mit reversem Lastausgleich.
void LastMengenBestimmung::setze_last_vektor(int _last, int _last_oben)
    {
// Kommentar: Speichere die zwei Lastwerte ab.
    eigene_last = _last;
    eigene_last_oben = _last_oben;

#ifdef AKTUELLE_KOMMENTARE
    cout << " AABBCC Lasten " << " last " << eigene_last << " last-oben " << eigene_last_oben << " rang " << rang << endl;
#endif

// Kommentar: Speichere die zwei Lastwerte vektoriell ab.
    eigene_last_vektor[0] = _last;
    eigene_last_vektor[1] = _last_oben;
    }

// Kommentar: Zu Testzwecken, d.h. zum Test, ob alle bentigten Lastinformationen tatschlich beschafft werden, werden Anfangslastwerte gesetzt.
// Dann kann man sehen, ob die Lastmengen - Kommunikation erfolgreich war.
void LastMengenBestimmung::setze_lastmenge(void)
    {
// Kommentar: Je nach rang wird individuell ein Lastwert gesetzt - fr beide zur Kommunikation mglichen Gitterebenen.
    switch(rang)
        {
        case 0:
            eigene_last = 20;
            eigene_last_oben = 10;
            break;

        case 1:
            eigene_last = 15;
            eigene_last_oben = 10;
            break;

        case 2:
            eigene_last = 25;
            eigene_last_oben = 10;
            break;

        case 3:
            eigene_last = 20;
            eigene_last_oben = 10;
            break;


        case 4:
            eigene_last = 30;
            eigene_last_oben = 10;
            break;

        case 5:
            eigene_last = 35;
            eigene_last_oben = 10;
            break;

        case 6:
            eigene_last = 15;
            eigene_last_oben = 10;
            break;

        case 7:
            eigene_last = 10;
            eigene_last_oben = 10;
            break;

        case 8:
            eigene_last = 25;
            eigene_last_oben = 10;
            break;

        case 9:
            eigene_last = 29;
            eigene_last_oben = 10;
            break;

        case 10:
            eigene_last = 21;
            eigene_last_oben = 10;
            break;

        case 11:
            eigene_last = 18;
            eigene_last_oben = 10;
            break;

        case 12:
            eigene_last = 24;
            eigene_last_oben = 10;
            break;

        case 13:
            eigene_last = 36;
            eigene_last_oben = 10;
            break;

        case 14:
            eigene_last = 27;
            eigene_last_oben = 10;
            break;

        case 15:
            eigene_last = 32;
            eigene_last_oben = 10;
            break;
        }
// Kommentar: Hier wird noch einmal die Last so gesetzt, dass man hinterher genau sehen kann, ob die richtigen Lastwerte kommuniziert worden sind.
    eigene_last = rang + 1;
    eigene_last_oben = 101 + rang;
// Kommentar: Danach werden die Werte auch im Lastvektor abgespeichert.
    eigene_last_vektor[0] = eigene_last;
    eigene_last_vektor[1] = eigene_last_oben;
    }

// Kommentar: Hier wird der Lastwert fr den eigenen Kern auf der unteren Gitterebene gesetzt - bzw. in die erste Stelle des Lastvektors gesetzt - fr den
// unteren Lastwert.
void LastMengenBestimmung::setze_eigene_last(int _eigene_last)
    {
    eigene_last = _eigene_last;
    eigene_last_vektor[0] = eigene_last;
#ifdef AKTUELLE_KOMMENTARE
    cout << " AABBCC Last " << eigene_last << " rang " << rang << endl;
#endif
    }

// Kommentar: Hier wird der Lastwert fr den eigenen Kern auf der oberen Gitterebene gesetzt - bzw. in die zweite Stelle des Lastvektors gesetzt - fr den
// oberen Lastwert.
void LastMengenBestimmung::setze_eigene_last_oben(int _eigene_last_oben)
    {
    eigene_last_oben = _eigene_last_oben;
    eigene_last_vektor[1] = eigene_last_oben;
#ifdef AKTUELLE_KOMMENTARE
    cout << " AABBCC Last-oben " << eigene_last_oben << " rang " << rang << endl;
#endif
    }

// Kommentar: Die Klasse wird hier finalisiert. Zu den Strukturen vergleiche man die Initialisierung mit der Funktion initialisieren_normal.
void LastMengenBestimmung::finalisieren_normal(void)
    {
    finalisiere_farbmatrix();
    finalisieren();
    }

// Kommentar: Hier wird die Klasse initialisiert. Dafr werden die Funktionen initialisieren und initialisieren_farbmatrix aufgerufen.
void LastMengenBestimmung::initialisieren_normal(int _rang, int _groesse)
// Wird komplett finalisiert
    {
    initialisieren(_rang, _groesse);
#ifdef AUSGABEN
    cout << "Vor initialisiere_farbmatrix " << endl;
#endif
    initialisiere_farbmatrix();
    }

// Kommentar: Hier wird ein Teil dieser Klasse finalisiert. Zu den Strukturen vgl. man die Funktion initialisieren.
void LastMengenBestimmung::finalisieren(void)
    {

    delete identitaeten_horizontal;
    delete identitaeten_vertikal;

    delete sende_requests_horizontal;
    delete empfangs_requests_horizontal;

    delete sende_requests_vertikal;
    delete empfangs_requests_vertikal;

    delete last_vertikal;
    delete last_horizontal;

    for(i=0; i<groesse_f; i++)
        {
        delete last_alle_prozessoren[i];
        }

    delete last_alle_prozessoren;

    delete hilfsvektor;

    }

// Kommentar: Neben initialisieren_farbmatrix die Initialisierungsfunktion dieser Klasse. Es werdendie Anzahl der Kerne der horizontalen
// und vertikalen Kerntopologie bestimmt, und entsprechend Speicher angelegt - wobei im Falle des reziproken Lastausgleichs
// der doppelte Speicherplatz angelegt werden muss - mit groesse_f_2 oder groesse_g_2.
void LastMengenBestimmung::initialisieren(int _rang, int _groesse)
    {
// Kommentar: Zuerst werden die bergabeparameter gespeichert.
    rang = _rang;
    groesse = _groesse;

// Kommentar: In den verschiedenen Fllen von Kerngesamtanzahlen werden die Anzahl an horizontalen und vertikalen Kernen festgelegt.
    if(groesse == 1)
        {
        groesse_f = 1;
        groesse_g = 1;
        }

    if(groesse==2)
        {
        groesse_f = 1;
        groesse_g = 2;
        }

    if(groesse==4)
        {
        groesse_f = 2;
        groesse_g = 2;
        }

    if(groesse==8)
        {
        groesse_f = 2;
        groesse_g = 4;
        }

    if(groesse==16)
        {
        groesse_f = 4;
        groesse_g = 4;
        }

    cout << "groesse_f " << groesse_f << " groesse_g " << groesse_g << endl;

// Kommentar: Diese werden mit 2 multipliziert, und der resultierende Wert wird gespeichert.
    groesse_f_2 = groesse_f << 1;
    groesse_g_2 = groesse_g << 1;

// Kommentar: Hier wird angelegt, welche ID's die Kerne in horizontaler und vertikaler Kerntopologie
// bzgl. dieses Kernes haben.
    identitaeten_horizontal = new int [groesse_g];
    identitaeten_vertikal = new int [groesse_f];

// Kommentar: Die Sende - und Empfangsrequest fr die horizontale Kommunikation werden angelegt.
    sende_requests_horizontal = new MPI_Request [groesse_g];
    empfangs_requests_horizontal = new MPI_Request [groesse_g];

// Kommentar: Die Sende - und Empfangsrequest fr die vertikale Kommunikation werden angelegt.
    sende_requests_vertikal = new MPI_Request [groesse_f];
    empfangs_requests_vertikal = new MPI_Request [groesse_f];

// Kommentar: Die Lasten fr den vertikalen, den horizontalen, und fr die Lastmatrizen werden angelegt.
    last_vertikal = new int [groesse_f_2];
    last_horizontal = new int [groesse_g_2];
    last_alle_prozessoren = new int * [groesse_f];
    for(i=0; i<groesse_f; i++)
        {
        last_alle_prozessoren[i] = new int [groesse_g_2];
        }
// Kommentar: Die Variable Gre Mal 2 = Anzahl an Kernen verdoppelt wird angelegt.
    groesse_2 = groesse << 1;
// Kommentar: Ein Hilfsvektor dieser Gre wird angelegt.
    hilfsvektor = new int [groesse_2];
// Kommentar: Es wird mit der Variable rang verschiedene Berechnungen durchgefhrt.
    rang_durch_4 = rang >> 2;
    rang_durch_4_mal_8 = (rang >> 2) << 3;
    rang_durch_4_mal_4 = (rang >> 2) << 2;
    rang_mal_2 = rang << 1;
    }

// Kommentar: Das hier ist die einfache Maximierungsfunktion zweier Integerwerte.
int LastMengenBestimmung::max(int f, int g)
    {
    if(f>g)
        {
        return(f);
        }
    return(g);
    }

// Kommentar: Hier wird die Farbmatrix angelegt. Damit bekommt jeder Kern mit einer horizontalen und vertikalen
// Farbe / ID eine globale Farbe / ID zugeordnet. Das gilt fr alle Kerne.
void LastMengenBestimmung::initialisiere_farbmatrix(void)
    {
// Kommentar: Zuerst wird die Farbmatrix angelegt.
    farbmatrix = new int * [groesse_f];
    for(i=0; i<groesse_f; i++)
        {
        farbmatrix[i] = new int [groesse_g];
        }
// Kommentar: Dann wird in Abhngigkeit der Kerngesamtanzahl die Farbmatrix beschrieben.
    switch(groesse)
        {
        case 1:
            farbmatrix[0][0] = 0;
            break;

        case 2:
            farbmatrix[0][0] = 0;
            farbmatrix[0][1] = 1;
            break;

        case 4:
            farbmatrix[0][0] = 0;   farbmatrix[0][1] = 1;
            farbmatrix[1][0] = 2;   farbmatrix[1][1] = 3;
            break;

        case 8:
            farbmatrix[0][0] = 0;   farbmatrix[0][1] = 1;   farbmatrix[0][2] = 2; farbmatrix[0][3] = 3;
            farbmatrix[1][0] = 4;   farbmatrix[1][1] = 5;   farbmatrix[1][2] = 6; farbmatrix[1][3] = 7;
            break;

        case 16:
            farbmatrix[0][0] = 0;   farbmatrix[0][1] = 1;   farbmatrix[0][2] = 2; farbmatrix[0][3] = 3;
            farbmatrix[1][0] = 4;   farbmatrix[1][1] = 5;   farbmatrix[1][2] = 6; farbmatrix[1][3] = 7;
            farbmatrix[2][0] = 8;   farbmatrix[2][1] = 9;   farbmatrix[2][2] = 10; farbmatrix[2][3] = 11;
            farbmatrix[3][0] = 12;   farbmatrix[3][1] = 13;   farbmatrix[3][2] = 14; farbmatrix[3][3] = 15;
            break;
        }
// Kommentar: Am Ende wird fr den eigenen Kern angelegt, welche Kerne in der eigenen Spalte und Zeile der Gesamtkerntopologie liegen.
    farbmatrix_auswerten();
    }

// Kommentar: Hier wird der Speicherplatz der Farbmatrix freigegeben.
void LastMengenBestimmung::finalisiere_farbmatrix(void)
    {
    for(i=0; i<groesse_f; i++)
        {
        delete farbmatrix[i];
        }
    delete farbmatrix;
    }

// Kommentar: Es wird fr den eigenen Kern angelegt, welche Kerne in der eigenen Spalte und Zeile der Gesamtkerntopologie liegen.
void LastMengenBestimmung::farbmatrix_auswerten(void)
    {
// Kommentar: Zuerst wird Spalte und Zeile der Kerntopologie fr den eigenen Kern gesucht und gefunden.
    for(i=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            if(farbmatrix[i][j]==rang)
                {
// Kommentar: Dann wird die Zeile der Kerntopologie mit den Farbwerte der anderen Kerne beschrieben.
                for(k=0; k<groesse_g; k++)
                    {
                    identitaeten_horizontal[k] = farbmatrix[i][k];
                    }

// Kommentar: Dann wird die Spalte der Kerntopologie mit den Farbwerte der anderen Kerne beschrieben.
                for(k=0; k<groesse_f; k++) // Kommentar: nderung am 10.8.2015
                    {
                    identitaeten_vertikal[k] = farbmatrix[k][j];
                    }
// Kommentar: Und am Ende wird die Zeile und Spalte fr den eigenen Kern abgespeichert.
                position_f = i;
                position_g = j;
                position_f_2 = position_f << 1;
                position_g_2 = position_g << 1;
                return;
                }
            }
        }
    }

// Kommentar: Hier geschieht eine all to all Kommunikation in der zeilenweisen - Kerntopologie im Falle des reversen Lastausgleiches.
void LastMengenBestimmung::kommunikation_starten_horizontal_mit(void)
    {
// Kommentar: Es werden alle Kerne der Zeile der Kerntopologie durchlaufen.
    for(i=0; i<groesse_g; i++)
        {
// Kommentar: Der eigene Kern wird ausgeschlossen.
        if(identitaeten_horizontal[i]!=rang)
            {
// Kommentar: Der eigene Lastvektor aus 2 Integerwerten fr die 2 Gitterebenen wird verschickt.
            MPI_Isend(eigene_last_vektor, 2, MPI_INT, identitaeten_horizontal[i], 100, MPI_COMM_WORLD, & (sende_requests_horizontal[i]));
// Kommentar: Die empfangenen Lastwerte werden empfangen und direkt unter 2 * i entpackt. So sind alle anderen Lastwerte an entsprechender
// Position vorhanden - nach Abschlu der Kommunikation.
            MPI_Irecv(&(last_horizontal[i<<1]), 2, MPI_INT, identitaeten_horizontal[i], 100, MPI_COMM_WORLD, & (empfangs_requests_horizontal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen! Bei ev2: Zwei Lastwerte
// auf demselben Prozessor direkt nebeneinander. Die Lastvektoren entstehen durch auslassen jedes zweiten
// Wertes.
            }
// Beim eigenen Kern wird der eigene Lastvektor nach last_horizontal kopiert.
        else
            {
            i_2 = i<<1;
            for(j=0; j<=1; j++)
                {
                last_horizontal[i_2+j]=eigene_last_vektor[j];
                }
            }
        }
    }

// Kommentar: Analog zu kommunikation_starten_horizontal_mit, nur eben fr die Kerntopologiespalte, statt der Kerntopologiezeile. Daher
// keine weiteren Kommentare.
void LastMengenBestimmung::kommunikation_starten_vertikal_mit(void)
    {
    for(i=0; i<groesse_f; i++)
        {
        if(identitaeten_vertikal[i]!=rang)
            {
            MPI_Isend(eigene_last_vektor, 2, MPI_INT, identitaeten_vertikal[i], 101, MPI_COMM_WORLD, & (sende_requests_vertikal[i]));
            MPI_Irecv(&(last_vertikal[i<<1]), 2, MPI_INT, identitaeten_vertikal[i], 101, MPI_COMM_WORLD, & (empfangs_requests_vertikal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen! Bei ev2: Zwei Lastwerte
// auf demselben Prozessor direkt nebeneinander. Die Lastvektoren entstehen durch auslassen jedes zweiten
// Wertes.
            }
        else
            {
            i_2 = i<<1;
            for(j=0; j<=1; j++)
                {
                last_vertikal[i_2+j]=eigene_last_vektor[j];
                }
            }
        }
    }

// Kommentar: Hier geschieht eine all to all Kommunikation in der spaltenweisen - Kerntopologie im Falle des einfachen Lastausgleiches.
void LastMengenBestimmung::kommunikation_starten_vertikal_ohne(void)
    {
// Kommentar: Es werden alle Kerne der Spalte der Kerntopologie durchlaufen.
    for(i=0; i<groesse_f; i++)
        {
// Kommentar: Der eigene Kern wird ausgeschlossen.
        if(identitaeten_vertikal[i]!=rang)
            {
// Kommentar: Der eigene Lastvektor aus einem Integerwert fr die eine Gitterebenen wird verschickt.
            MPI_Isend(eigene_last_vektor, 1, MPI_INT, identitaeten_vertikal[i], 101, MPI_COMM_WORLD, & (sende_requests_vertikal[i]));
// Kommentar: Die empfangenen Lastwerte werden empfangen und direkt unter i entpackt. So sind alle anderen Lastwerte an entsprechender
// Position vorhanden - nach Abschlu der Kommunikation.
            MPI_Irecv(&(last_vertikal[i]), 1, MPI_INT, identitaeten_vertikal[i], 101, MPI_COMM_WORLD, & (empfangs_requests_vertikal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen!
            }
// Beim eigenen Kern wird der eigene Lastvektor nach last_vertikal kopiert.
        else
            {
            last_vertikal[i] = eigene_last;
            }
        }
    }

// Kommentar: Fast analog zu kommunikation_starten_horizontal_mit. Der Unterschied: Es wird hier die Lastmatrix last_alle_prozessoren
// beschrieben. Hier wird nur der Unterschied kommentiert.
void LastMengenBestimmung::kommunikation_alle_starten_horizontal_mit(void)
    {
// Kommentar: Hier wird die Zeile aus der Matrix last_alle_prozessoren als Zeiger zugreifbar bekommen.
    lastvektor = last_alle_prozessoren[position_f];

    for(i=0; i<groesse_g; i++)
        {
        if(identitaeten_horizontal[i]!=rang)
            {
            MPI_Isend(eigene_last_vektor, 2, MPI_INT, identitaeten_horizontal[i], 102, MPI_COMM_WORLD, & (sende_requests_horizontal[i]));
// Kommentar: Die Last wird bezglich obigen Zeigers entpackt.
            MPI_Irecv(&(lastvektor[i<<1]), 2, MPI_INT, identitaeten_horizontal[i], 102, MPI_COMM_WORLD, & (empfangs_requests_horizontal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen! Bei ev2: Zwei Lastwerte
// auf demselben Prozessor direkt nebeneinander. Die Lastvektoren entstehen durch auslassen jedes zweiten
// Wertes.
            }
        else
            {
            i_2 = i<<1;
            for(j=0; j<=1; j++)
                {
// Kommentar: Und die eigene Last wird bezglich dieses Zeigers beschrieben.
                lastvektor[i_2+j]=eigene_last_vektor[j];
                }
            }
        }
    }

// Kommentar: Nicht analog zu kommunikation_alle_starten_horizontal_mit, da hier mehr Integerwerte verschickt werden. Es soll nmlich durch
// diese Kommunikation jeder Kern die komplette Lastmatrix haben.
void LastMengenBestimmung::kommunikation_alle_starten_vertikal_mit(void)
    {
// Kommentar: Den Lastvektor der eigenen Kerntopologiezeile muss man kennen.
    lastvektor = last_alle_prozessoren[position_f];

// Kommentar: Dann durchluft man die Spalte bzgl. der Kerntopologie
    for(i=0; i<groesse_f; i++)
        {
// Kommentar: Mit allen anderen Kernen wir kommuniziert.
        if(identitaeten_vertikal[i]!=rang)
            {
// Kommentar: Der Lastvektor der eigenen Kerntopologiezeile wird verschickt. Die Lnge ist gre_g Mal 2.
            MPI_Isend(lastvektor, groesse_g_2, MPI_INT, identitaeten_vertikal[i], 103, MPI_COMM_WORLD, & (sende_requests_vertikal[i]));
// Kommentar: Der empfangene Lastvektor wird in die Zeile i der Matrix last_alle_prozessoren kopiert, mit derselben Lnge gre_g Mal 2.
// Nach Abschlu der Kommunikation haben alle Kerne die Lastwerte aller anderen Kerne.
            MPI_Irecv(last_alle_prozessoren[i], groesse_g_2, MPI_INT, identitaeten_vertikal[i], 103, MPI_COMM_WORLD, & (empfangs_requests_vertikal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen! Bei ev2: Zwei Lastwerte
// auf demselben Prozessor direkt nebeneinander. Die Lastvektoren entstehen durch auslassen jedes zweiten
// Wertes.
            }
        }
    }

// Kommentar: Analog zu kommunikation_starten_vertikal_ohne, nur mit einer Zeile der Kerntopologie, statt der Spalte der Kerntopologie,
// weshalb hier keine eigenen Kommentare ntig sind.
void LastMengenBestimmung::kommunikation_starten_horizontal_ohne(void)
    {
    for(i=0; i<groesse_g; i++)
        {
        if(identitaeten_horizontal[i]!=rang)
            {
            MPI_Isend(eigene_last_vektor, 1, MPI_INT, identitaeten_horizontal[i], 100, MPI_COMM_WORLD, & (sende_requests_horizontal[i]));
            MPI_Irecv(&(last_horizontal[i]), 1, MPI_INT, identitaeten_horizontal[i], 100, MPI_COMM_WORLD, & (empfangs_requests_horizontal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen!
            }
        else
            {
            last_horizontal[i] = eigene_last;
            }
        }
    }

// Kommentar: Analog zu kommunikation_alle_starten_horizontal_ohne mit dem Unterschied, dass statt 2 Lastwerten nur der fr die eine
// Gitterebene verschickt, und auch fr jeden Kern der horizontalen Kerntopologie entpackt wird. Auerdem wird auch nur ein eigener
// Lastwert nach lastvektor(i) kopiert.
void LastMengenBestimmung::kommunikation_alle_starten_horizontal_ohne(void)
    {
    lastvektor = last_alle_prozessoren[position_f];

    for(i=0; i<groesse_g; i++)
        {

        if(identitaeten_horizontal[i]!=rang)
            {
            MPI_Isend(eigene_last_vektor, 1, MPI_INT, identitaeten_horizontal[i], 102, MPI_COMM_WORLD, & (sende_requests_horizontal[i]));
            MPI_Irecv(&(lastvektor[i]), 1, MPI_INT, identitaeten_horizontal[i], 102, MPI_COMM_WORLD, & (empfangs_requests_horizontal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen! Bei ev2: Zwei Lastwerte
// auf demselben Prozessor direkt nebeneinander. Die Lastvektoren entstehen durch auslassen jedes zweiten
// Wertes.
            }
        else
            {
            lastvektor[i] = eigene_last;
            }
        }
    }

// Kommentar: Analog zu kommunikation_alle_starten_vertikal_mit, nur, dass statt eines Vektors der Lnge groesse Mal 2, einen der Lnge
// groesse zu verschicken. Denn soviel Information hat eine Zeile bzgl. der Kerntopologie, wenn nur ein Lastwerte pro Kern vorliegt.
void LastMengenBestimmung::kommunikation_alle_starten_vertikal_ohne(void)
    {
    lastvektor = last_alle_prozessoren[position_f];

    for(i=0; i<groesse_f; i++)
        {

        if(identitaeten_vertikal[i]!=rang)
            {
            MPI_Isend(lastvektor, groesse_g, MPI_INT, identitaeten_vertikal[i], 103, MPI_COMM_WORLD, & (sende_requests_vertikal[i]));
            MPI_Irecv(last_alle_prozessoren[i], groesse_g, MPI_INT, identitaeten_vertikal[i], 103, MPI_COMM_WORLD, & (empfangs_requests_vertikal[i]));
// Das ist eine vollstndige Kommunikation fr die jeweiligen Zeilen! Bei ev2: Zwei Lastwerte
// auf demselben Prozessor direkt nebeneinander. Die Lastvektoren entstehen durch auslassen jedes zweiten
// Wertes.
            }
        }
    }

// Kommentar: Hier geschieht die Lastkommunikation ber einen Baum - vergleiche die Dissertation. Zuerst den horizontalen Fall, und ohne
// reversen Lastausgleich.
void LastMengenBestimmung::kommunikation_PLB_starten_horizontal_ohne(void)
    {
// Kommentar: Man unterscheidet die Anzahl an Kernen.
    switch(groesse_g)
        {
        case 1:
// Kommentar: Nur ein Kern: Dann muss nicht kommuniziert werden. Dann wird der eigene Lastwert nach last_horizontal kopiert.
            last_horizontal[0] = eigene_last;
            break;
        case 2:
// Kommentar: Nur zwei Kerne: Dann kann die Kommunikation mit der all to all Kommunikation, s.o., erfolgen. Dazu besteht hier kein Unterschied.
            kommunikation_starten_horizontal_ohne();
// Kommentar: Neben des Startens der Kommunikation muss noch das Ankommen der Nachrichten abgewartet werden. Danach ist der Vektor
// last_horizontal einsetzbar.
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;
        case 4:
// Kommentar: Bei 4 Kernen nebeneinander muss fr jeden Kern etwas anderes gemacht werden. Man unterscheidet die Kerne nach ihren letzten beiden Bits. Dabei
// ist noch zu bemerken, dass die Arbeit der Kerne genau umgekehrt ist, wie in der Dissertation dargestellt: Der Kern mit dem Rang 0(mod 4) tut, was dort P_3 tut,
// der mit Rang 1(mod 4) tut, was P_2 tut, usw..
            switch(rang & 3)
                {
// Kommentar: Im Fall 0(mod 3) wird von Kern rang+1 sein Lastwert empfangen, und von Kern rang+2 die Lastwerte der Kerne rang+2 und rang+3, d.h. die Buffer
// sind unterschiedlich lang. Der Wert von Kern rang+1 wird auf die Stelle 1, die Werte von Kern rang+2 auf die Stellen 2 und 3 kopiert.
                case 0:
                    MPI_Irecv(&(last_horizontal[1]), 1, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[1]));
                    MPI_Irecv(&(last_horizontal[2]), 2, MPI_INT, rang + 2, 106, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
// Kommentar: Nach Initiierung der Kommunikation wird die eigene Last auf Stelle 0 kopiert.
                    last_horizontal[0] = eigene_last;
// Kommentar: Nun wird abgewartet, bis die Kommunikation mit den Kernen rang+1 und rang+2 abgeschlossen ist.
                    for(;testen_1_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }
// Kommentar: Danach wird an den Kern rang+1 der ganze Vektor verschickt (seinen eigenen Wert mte man ihm nicht zuschicken. Der Buffer
// wre dann eins krzer, aber mte noch nachbearbeitet werden. Das ginge aber schon.
                    MPI_Isend(&(last_horizontal[0]), 4, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[1]));
//                    MPI_Isend(&(last_horizontal[0]), 4, MPI_INT, rang + 2, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));

// Kommentar: Kern rang+2 bentigt nur die ersten beiden Lastwerte. Deswegen werden nur diese Werte diesem Kern zugeschickt.
                    MPI_Isend(&(last_horizontal[0]), 2, MPI_INT, rang + 2, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
// Kommentar: Dann wird noch getestet, ob das Senden abgeschlossen ist. Wenn ja, dann ist fr diesen Kern diese Kommunikation abgeschlossen.
                    for(;testen_1_2_senden_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
// Kommentar: Das hier passiert fr den Kern mit rang(mod 3) = 1. Zuerst verschickt er an den Kern rang-1 seinen Lastwert.
                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));
// Kommentar: Dann wird kontrolliert, ob die Sendeoperation an den Kern mit rang = 0(mod 4) abgeschlossen ist.
                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }
// Kommentar: Dann Initiiert er den Empfang von Kern rang-1 fr den ganzen Lastvektor.
                    MPI_Irecv(&(last_horizontal[0]), 4, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
// Kommentar: Wenn diese Information angekommen ist, steht der Lastvektor zur Verfgung. 0 steht fr rang = 0(mod 4).
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
// Kommentar: Die folgenden Schritte erfolgen, wenn rang = 2(mod 4) erfllt ist.
// Kommentar: Zuerst wird der Lastwert von Kern rang+1 empfangen. Es wird auf Position 3 empfangen.
                    MPI_Irecv(&(last_horizontal[3]), 1, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[3]));
// Kommentar: Der eigene Lastwert wird auf Position 2 kopiert.
                    last_horizontal[2] = eigene_last;
// Kommentar: Dann wird gewartet, bis ebger Empfang erfolgt ist. Der Sender war rang+1 mit rang+1 = 3(mod 4)
                    for(;testen_3_empfangen_horizontal()==false;)
                        {
                        ;
                        }
// Kommentar: Dann werden beide Lastwerte - ab Position 2 - an den Kern rang - 2 (rang-2 = 0(mod 4))) verschickt, und diese Kommunikation abgewartet.
                    MPI_Isend(&(last_horizontal[2]), 2, MPI_INT, rang - 2, 106, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));
                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }
//                    MPI_Irecv(&(last_horizontal[0]), 4, MPI_INT, rang - 2, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));

// Kommentar: Dann bekommt man von Kern rang-2 die ersten beiden Lastwerte der Zeile ab Position 0 zugeschickt. Dort werden sie auch eingetragen.
                    MPI_Irecv(&(last_horizontal[0]), 2, MPI_INT, rang - 2, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
// Kommentar: Dann wird die entsprechende Kommunikation abgewartet.
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
//                    MPI_Isend(&(last_horizontal[0]), 4, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[3]));

// Kommentar: Damm verbleibt es noch, dem Kern rang+1 alle 3 ersten Informationen des Lastvektors zuzuschicken: Man initiiert das Senden, und wartet
// den Erfolg dieser Kommunikation ab.
                    MPI_Isend(&(last_horizontal[0]), 3, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[3]));
                    for(;testen_3_senden_horizontal()==false;)
                        {
                        ;
                        }
// Kommentar: Damit ist die Arbeit von Kern rang = 2(mod 4) abgeschlossen.
                    break;
                case 3:
//                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));

// Kommentar: Das geschieht hier fr den Kern mit rang = 3(mod 4). Er kommuniziert nur mit dem Kern rang-1. Zuerst schickt er
// seinen Lastwert an Kern rang-1.
                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
// Kommentar: Dann wird die eigene Last auf Position 3 des Lastvektors kopiert.
                    last_horizontal[3] = eigene_last;
// Kommentar: Dann wird die Kommunikation abgewartet.
                    for(;testen_2_senden_horizontal()==false;)
                        {
                        ;
                        }
//                    MPI_Irecv(&(last_horizontal[0]), 4, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));

// Kommentar: Dann wird der Empfang der Lastwerte auf den ersten drei Positionen vom Kern rang-1 initiiert, und anschlieend abgewartet.
                    MPI_Irecv(&(last_horizontal[0]), 3, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    for(;testen_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }
// Kommentar: Und das wars.
                    break;
                }
        }
    }

// Kommentar: Analog zu kommunikation_PLB_starten_horizontal_ohne, nur dass die Information nicht in den last_horizontal - Vektor
// kopiert wird, sondern in die position_f. Zeile der Lastmatrix last_alle_prozessoren. Die Funktionsweise ist sonst vllig gleich.
void LastMengenBestimmung::kommunikation_alle_PLB_starten_horizontal_ohne(void)
    {
    switch(groesse_g)
        {
        case 1:
            last_alle_prozessoren[0][0] = eigene_last; // nderung vom 10.8.2015
            break;
        case 2:
            kommunikation_alle_starten_horizontal_ohne();
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;
        case 4:
            lastvektor = last_alle_prozessoren[position_f];
            switch(rang & 3)
                {
                case 0:
                    MPI_Irecv(&(lastvektor[1]), 1, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[1]));
                    MPI_Irecv(&(lastvektor[2]), 2, MPI_INT, rang + 2, 106, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    lastvektor[0] = eigene_last;
                    for(;testen_1_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(lastvektor[0]), 4, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[1]));
                    MPI_Isend(&(lastvektor[0]), 2, MPI_INT, rang + 2, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
                    for(;testen_1_2_senden_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));
                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(lastvektor[0]), 4, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
                    MPI_Irecv(&(lastvektor[3]), 1, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[3]));
                    lastvektor[2] = eigene_last;
                    for(;testen_3_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(lastvektor[2]), 2, MPI_INT, rang - 2, 106, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));
                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(lastvektor[0]), 2, MPI_INT, rang - 2, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(lastvektor[0]), 3, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[3]));
                    for(;testen_3_senden_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 3:
                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
                    for(;testen_2_senden_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(lastvektor[0]), 3, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    for(;testen_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                }
        }
    }

// Kommentar: Diese Funktion entspricht vom Prinzip der Funktion kommunikation_alle_PLB_starten_horizontal_ohne.  Der Unterschied besteht darin,
// dass nicht nur ein Lastwert pro Kern vorhanden ist, sondern es sind 2, nmlich fr jede Gitterebene einer. Deswegen werden doppelt so viele
// Lastwerte geschrieben, und die kommunizierten Vektoren sind doppelt so lang - ab der doppelt so groen Anfangsposition. Ansonsten gibt es da
// keine Unterschiede.
void LastMengenBestimmung::kommunikation_alle_PLB_starten_horizontal_mit(void)
    {
    switch(groesse_g)
        {
        case 1:
            last_alle_prozessoren[0][0] = eigene_last;
            last_alle_prozessoren[0][1] = eigene_last_oben; // gendert am 10.8.2015.
            break;
        case 2:
            kommunikation_alle_starten_horizontal_mit();
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;
        case 4:
            lastvektor = last_alle_prozessoren[position_f];
            switch(rang & 3)
                {
                case 0:
                    MPI_Irecv(&(lastvektor[2]), 2, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[1]));

                    MPI_Irecv(&(lastvektor[4]), 4, MPI_INT, rang + 2, 106, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    lastvektor[0] = eigene_last;
                    lastvektor[1] = eigene_last_oben;

                    for(;testen_1_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }

                    MPI_Isend(&(lastvektor[0]), 8, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[1]));
                    MPI_Isend(&(lastvektor[0]), 4, MPI_INT, rang + 2, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
                    for(;testen_1_2_senden_horizontal()==false;)
                        {
                        ;
                        }

                    break;
                case 1:
                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));

                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }

                    MPI_Irecv(&(lastvektor[0]), 8, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }

                    break;
                case 2:

                    MPI_Irecv(&(lastvektor[6]), 2, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[3]));
                    lastvektor[4] = eigene_last;
                    lastvektor[5] = eigene_last_oben;

                    for(;testen_3_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(lastvektor[4]), 4, MPI_INT, rang - 2, 106, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));

                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }

                    MPI_Irecv(&(lastvektor[0]), 4, MPI_INT, rang - 2, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(lastvektor[0]), 6, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[3]));
                    for(;testen_3_senden_horizontal()==false;)
                        {
                        ;
                        }

                    break;
                case 3:

                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));

                    for(;testen_2_senden_horizontal()==false;)
                        {
                        ;
                        }

                    MPI_Irecv(&(lastvektor[0]), 6, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    for(;testen_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }

                    break;
                }
        }
    }

// Kommentar: Analog zu kommunikation_PLB_starten_horizontal_ohne, nur, dass in den Vektor last_vertikal geschrieben wird, und dass
// die Vektoren der Lastspalte genommen werden. Man hat deswegen bei der switch Anweisung im Fall groesse_f = 4 den Parameter (rang >> 2),
// statt (rang & 3). Und man schickt bzw. empfngt statt von Kern rang+offset von Kern rang + 4*offset, also statt rang+1 rang+4, statt
// rang+2 rang+8, statt rang+3 rang+12, statt rang-1 rang-4, usw.. Weil das die Kerne sind, die in derselben Spalte bzgl. der Kerntopologie
// liegen.
void LastMengenBestimmung::kommunikation_PLB_starten_vertikal_ohne(void)
    {
    switch(groesse_f)
        {
        case 1:
            last_vertikal[0] = eigene_last;
            break;
        case 2:
            kommunikation_starten_vertikal_ohne();
            for(;ist_fertig_vertikal()==false;)
                {
                ;
                }
            break;
        case 4:
#ifdef WARTEN
            for(i=0; i<rang*4000000; i++)
                {
                cout << "";
                }
#endif
            cout << "Vertikal ohne. rang " << rang << " rang >> 2 " << (rang >> 2) << endl;
            switch(rang >> 2)
                {
                case 0:
                    MPI_Irecv(&(last_vertikal[1]), 1, MPI_INT, rang + 4, 105, MPI_COMM_WORLD, &(empfangs_requests_vertikal[1]));
                    MPI_Irecv(&(last_vertikal[2]), 2, MPI_INT, rang + 8, 106, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    last_vertikal[0] = eigene_last;
                    for(;testen_1_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    cout << "Erster Schritt durch. rang " << rang << endl;
                    MPI_Isend(&(last_vertikal[0]), 4, MPI_INT, rang + 4, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[1]));
//                    MPI_Isend(&(last_vertikal[0]), 4, MPI_INT, rang + 8, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    MPI_Isend(&(last_vertikal[0]), 2, MPI_INT, rang + 8, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_1_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 4, 105, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_vertikal[0]), 4, MPI_INT, rang - 4, 107, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
                    MPI_Irecv(&(last_vertikal[3]), 1, MPI_INT, rang + 4, 105, MPI_COMM_WORLD, &(empfangs_requests_vertikal[3]));
                    last_vertikal[2] = eigene_last;
                    for(;testen_3_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_vertikal[2]), 2, MPI_INT, rang - 8, 106, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_vertikal[0]), 2, MPI_INT, rang - 8, 107, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_vertikal[0]), 3, MPI_INT, rang + 4, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[3]));
                    for(;testen_3_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 3:

                    last_vertikal[3] = eigene_last;
                    MPI_Isend(&eigene_last, 1, MPI_INT, rang - 4, 105, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_vertikal[0]), 3, MPI_INT, rang - 4, 107, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    for(;testen_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                }
            break;
        }
    cout << "Durch kommunikation_PLB_starten_vertikal_ohne durch " << endl;
    }

// Kommentar: Hier wird getestet, ob die Nachrichten der Kerne mit rang = 1(mod 4) und rang = 2 (mod 4) angekommen sind.
bool LastMengenBestimmung::testen_1_2_empfangen_horizontal(void)
    {
// Kommentar: Die entsprechenden Kerne haben die empfangs_requests_horizontal[1] und [2]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    for(i=1; i<3; i++)
        {
        MPI_Test(& (empfangs_requests_horizontal[i]), & flag, & status);
        if(flag==false)
            {
            return(false);
            }
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten der Kerne mit rang = 1(mod 4) und rang = 2 (mod 4) abgeschickt worden sind.
bool LastMengenBestimmung::testen_1_2_senden_horizontal(void)
    {
// Kommentar: Die entsprechenden Kerne haben die sende_requests_horizontal[1] und [2]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    for(i=1; i<3; i++)
        {
        MPI_Test(& (sende_requests_horizontal[i]), & flag, & status);
        if(flag==false)
            {
            return(false);
            }
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten des Kerns mit rang = 0(mod 4) abgeschickt worden sind.
bool LastMengenBestimmung::testen_0_senden_horizontal(void)
    {
// Kommentar: Der entsprechende Kern hat das sende_requests_horizontal[0]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    MPI_Test(& (sende_requests_horizontal[0]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten des Kerns mit rang = 0(mod 4) angekommen sind.
bool LastMengenBestimmung::testen_0_empfangen_horizontal(void)
    {
// Kommentar: Der entsprechende Kern hat das empfangs_requests_horizontal[0]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    MPI_Test(& (empfangs_requests_horizontal[0]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten des Kerns mit rang = 2(mod 4) angekommen sind.
bool LastMengenBestimmung::testen_2_empfangen_horizontal(void)
    {
// Kommentar: Der entsprechende Kern hat das empfangs_requests_horizontal[2]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    MPI_Test(& (empfangs_requests_horizontal[2]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten des Kerns mit rang = 2(mod 4) abgeschickt worden sind.
bool LastMengenBestimmung::testen_2_senden_horizontal(void)
    {
// Kommentar: Der entsprechende Kern hat das sende_requests_horizontal[2]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    MPI_Test(& (sende_requests_horizontal[2]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten des Kerns mit rang = 3(mod 4) angekommen sind.
bool LastMengenBestimmung::testen_3_empfangen_horizontal(void)
    {
// Kommentar: Der entsprechende Kern hat das empfangs_requests_horizontal[3]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    MPI_Test(& (empfangs_requests_horizontal[3]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten des Kerns mit rang = 3(mod 4) abgeschickt worden sind.
bool LastMengenBestimmung::testen_3_senden_horizontal(void)
    {
// Kommentar: Der entsprechende Kern hat das sende_requests_horizontal[3]. Die diesen Requests zugeordneten
// Flags mssen true sein, damit die Gesamtfunktion true ist.
    MPI_Test(& (sende_requests_horizontal[3]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

//////////////////////////////////////////////////////////////
/////////////// Ab hier: requests vertikal ///////////////////
//////////////////////////////////////////////////////////////

// Kommentar: Analog zu testen_1_2_empfangen_horizontal. Nur, dass die vertikalen Empfangs - Requests verwendet
// werden statt der horizontalen Empfangs - Requests.
bool LastMengenBestimmung::testen_1_2_empfangen_vertikal(void)
    {
    for(i=1; i<3; i++)
        {
        MPI_Test(& (empfangs_requests_vertikal[i]), & flag, & status);
        if(flag==false)
            {
            return(false);
            }

        }
    return(true);
    }

// Kommentar: Analog zu testen_1_2_senden_horizontal. Nur, dass die vertikalen Sende - Requests verwendet
// werden statt der horizontalen Sende - Requests.
bool LastMengenBestimmung::testen_1_2_senden_vertikal(void)
    {
    for(i=1; i<3; i++)
        {
        MPI_Test(& (sende_requests_vertikal[i]), & flag, & status);
        if(flag==false)
            {
            return(false);
            }

        }
    return(true);
    }

// Kommentar: Analog zu testen_0_senden_horizontal. Nur, dass ein vertikales Sende - Request verwendet
// wird statt des horizontalen Sende - Requests.
bool LastMengenBestimmung::testen_0_senden_vertikal(void)
    {
    MPI_Test(& (sende_requests_vertikal[0]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Analog zu testen_0_empfangen_horizontal. Nur, dass ein vertikales Empfangs - Request verwendet
// wird statt des horizontalen Empfangs - Requests.
bool LastMengenBestimmung::testen_0_empfangen_vertikal(void)
    {
    MPI_Test(& (empfangs_requests_vertikal[0]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Analog zu testen_2_empfangen_horizontal. Nur, dass ein vertikales Empfangs - Request verwendet
// wird statt des horizontalen Empfangs - Requests.
bool LastMengenBestimmung::testen_2_empfangen_vertikal(void)
    {
    MPI_Test(& (empfangs_requests_vertikal[2]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Analog zu testen_2_senden_horizontal. Nur, dass ein vertikales Sende - Request verwendet
// wird statt des horizontalen Sende - Requests.
bool LastMengenBestimmung::testen_2_senden_vertikal(void)
    {
    MPI_Test(& (sende_requests_vertikal[2]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Analog zu testen_3_empfangen_horizontal. Nur, dass ein vertikales Empfangs - Request verwendet
// wird statt des horizontalen Empfangs - Requests.
bool LastMengenBestimmung::testen_3_empfangen_vertikal(void)
    {
    MPI_Test(& (empfangs_requests_vertikal[3]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Analog zu testen_3_senden_horizontal. Nur, dass ein vertikales Sende - Request verwendet
// wird statt des horizontalen Sende - Requests.
bool LastMengenBestimmung::testen_3_senden_vertikal(void)
    {
    MPI_Test(& (sende_requests_vertikal[3]), & flag, & status);
    if(flag==false)
        {
        return(false);
        }
    return(true);
    }

// Kommentar: Hier wird die Funktion aufgerufen, die unterscheidet, welche Kommunikation zu tun ist, und diese dann durchfhrt.
// Welche Kommunikation durchgefhrt wird, gibt der bergabeparameter typ an.
void LastMengenBestimmung::tun(int typ)
    {
// Kommentar: Es geschieht eine switch - case - Anweisung in Bezug auf den bergabeparameter durchgefhrt.
    switch(typ)
        {
// Kommentar: Wenn eine vollstndige Kommunikation nur fr eine horizontale Kerntopologie - Linie erfolgen soll,
// und das fr nur eine Gitterebene.
        case KN_HORIZONTAL_OHNE:
// Kommentar: Starte die entsprechende Kommunikation.
            kommunikation_starten_horizontal_ohne();
// Kommentar: Warte, bis diese Kommunikation abgeschlossen ist.
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;

// Kommentar: Wenn eine vollstndige Kommunikation nur fr eine horizontale Kerntopologie - Linie erfolgen soll,
// und das fr zwei Gitterebenen.
        case KN_HORIZONTAL_MIT:
// Kommentar: Starte die entsprechende Kommunikation.
            kommunikation_starten_horizontal_mit();
// Kommentar: Warte, bis diese Kommunikation abgeschlossen ist.
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;

// Kommentar: Wenn eine vollstndige Kommunikation nur fr eine vertikale Kerntopologie - Linie erfolgen soll,
// und das fr nur eine Gitterebene.
        case KN_VERTIKAL_OHNE:
// Kommentar: Starte die entsprechende Kommunikation.
            kommunikation_starten_vertikal_ohne();
// Kommentar: Warte, bis diese Kommunikation abgeschlossen ist.
            for(;ist_fertig_vertikal()==false;)
                {
                ;
                }
            break;

// Kommentar: Wenn eine vollstndige Kommunikation nur fr eine vertikale Kerntopologie - Linie erfolgen soll,
// und das fr zwei Gitterebenen.
        case KN_VERTIKAL_MIT:
// Kommentar: Starte die entsprechende Kommunikation.
            kommunikation_starten_vertikal_mit();
// Kommentar: Warte, bis diese Kommunikation abgeschlossen ist.
            for(;ist_fertig_vertikal()==false;)
                {
                ;
                }
            break;

// Kommentar: Fhre eine vollstndige Kommunikation durch, einmal fr eine vertikale Kerntopologie, und dann fr die
// horizontale Kerntopologie. Dabei werden die Funktionen mit dem Wort 'alle' aufgerufen. Im Endeffekt hat man
// auf jedem Kern die volle Lastinformation - allerdings nur fr eine Gitterebene.
        case KNxKN_OHNE:
// Kommentar: Starte die horizontale Kommunikation, als ersten Schritt zur Bildung einer Lastmatrix, aber nur fr eine
// Gitterebene.
            kommunikation_alle_starten_horizontal_ohne();
// Kommentar: Warte, bis diese Kommunikation abgeschlossen ist.
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
#ifdef AKTUELLE_KOMMENTARE
            cout << "Einmal durch Rang: " << rang << " KNxKN ohne " << endl;
#endif

// Kommentar: Starte die vertikale Kommunikation, als zweiten Schritt zur Bildung einer Lastmatrix, aber nur fr eine
// Gitterebene.
            kommunikation_alle_starten_vertikal_ohne();
// Kommentar: Warte, bis diese Kommunikation abgeschlossen ist.
            for(;ist_fertig_vertikal()==false;)
                {
                ;
                }
#ifdef AKTUELLE_KOMMENTARE
            cout << "Zweimal durch Rang: " << rang << " KNxKN ohne " << endl;
#endif
            break;

// Kommentar: Analog zu KNxKN_OHNE, nur dass hier die Funktionen aufgerufen werden, die fr die Lastmatrix - Bestimmung
// von 2 Gitterebenen zustndig sind.
        case KNxKN_MIT:
#ifdef AKTUELLE_KOMMENTARE_LMB
            cout << " Beginn LMB rang " << rang << " KNxKN mit " << endl;
#endif
            kommunikation_alle_starten_horizontal_mit();
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
#ifdef AKTUELLE_KOMMENTARE_LMB
            cout << "Einmal durch Rang: " << rang << " KNxKN mit " << endl;
#endif
            kommunikation_alle_starten_vertikal_mit();
            for(;ist_fertig_vertikal()==false;)
                {
                ;
                }
#ifdef AKTUELLE_KOMMENTARE_LMB
            cout << "Zweimal durch Rang: " << rang << " KNxKN mit " << endl;
#endif
            break;

// Kommentar: Hier erfolgt die Kommunikation ber einen Baum nur fr den horizontalen Lastausgleich, und fr nur eine
// Gitterebene. Das wird mit einem Befehl erledigt.
        case PLB_HORIZONTAL_OHNE:
            kommunikation_PLB_starten_horizontal_ohne();
            break;
// Kommentar: Hier erfolgt die Kommunikation ber einen Baum nur fr den horizontalen Lastausgleich, und fr zwei
// Gitterebenen. Das wird mit einem Befehl erledigt.
        case PLB_HORIZONTAL_MIT:
            kommunikation_PLB_starten_horizontal_mit();
            break;

// Kommentar: Hier erfolgt die Kommunikation ber einen Baum nur fr den vertikalen Lastausgleich, und fr nur eine
// Gitterebene. Das wird mit einem Befehl erledigt.
        case PLB_VERTIKAL_OHNE:
            kommunikation_PLB_starten_vertikal_ohne();
            break;

// Kommentar: Hier erfolgt die Kommunikation ber einen Baum nur fr den vertikalen Lastausgleich, und fr zwei
// Gitterebenen. Das wird mit einem Befehl erledigt.
        case PLB_VERTIKAL_MIT:
            kommunikation_PLB_starten_vertikal_mit();
            break;

// Kommentar: Bilde die Lastmatrix ber zwei Bume - einen in horizontaler, und einen vertikal - fr nur eine Gitterebene.
        case PLBxPLB_OHNE:
//            kommunikation_alle_PLB_starten_horizontal_ohne();

            if(groesse==8)
                {
                kommunikation_PLB_starten_horizontal_ohne();
                kopiere_lastvektor_zu_last_alle_prozessoren_ohne();
                kommunikation_alle_starten_vertikal_ohne();
                for(;ist_fertig_vertikal()==false;)
                    {
                    ;
                    }
                break;
                }

// Kommentar: Zuerst bilde den Lastvektor in horizontaler Kerntopologielinie.
            kommunikation_PLB_starten_horizontal_ohne();
// Kommentar: Kopiere die gebildeten Lastvektor in den Hilfsvektor, aber den Hilfsvektor an der Stelle, die der Zeilennummer
// entspricht, wenn man die Lastmatrix in den Hilfsvektor kopiert.
            kopiere_lastvektor_horizontal_zu_hilfsvektor_ohne();
// Kommentar: Kommuniziere die Hilfsvektorenteile zu den Kernen in vertikaler Kerntopologielinie, so dass der Hilfsvektor
// jeweils der Lastmatrix entspricht. Dabei sind die jeweiligen Zeilen sozusagen hintereinandergehngt.
            kommunikation_alle_PLB_starten_vertikal_ohne();
// Kommentar: Am Ende kopiere den Hilfsvektor in die Lastmatrix - wobei nur eine Gitterebene behandelt wird.
            kopiere_hilfsvektor_zu_matrix_ohne();
            break;

// Kommentar: Diese Funktion ist veraltet, und wird daher nicht mehr gebraucht.
        case PLBxPLB_MIT_ALT:
            cout << " vor horizontal rang " << rang << endl;
            kommunikation_alle_PLB_starten_horizontal_mit();
            cout << " nach horizontal rang " << rang << endl;
            kommunikation_alle_PLB_starten_vertikal_mit();
            cout << " durch rang " << rang << endl;
            break;

// Kommentar: Analog zu PLBxPLB_OHNE, nur das das hier fr den doppelten Lastausgleich erfolgt, und alle Funktionen den
// Suffix mit statt des Suffix ohne haben.
        case PLBxPLB_MIT:

// Kommentar: Im Falle von groesse=8 wird horizontal mit jeweils vier Kernen die Kommunikation ber einen Baum gemacht, und dann vertikal mit jeweils
// zwei Kernen die KN-Kommunikation.
            if(groesse==8)
                {
                kommunikation_PLB_starten_horizontal_mit();
                kopiere_lastvektor_zu_last_alle_prozessoren_mit();
                kommunikation_alle_starten_vertikal_mit();
                for(;ist_fertig_vertikal()==false;)
                    {
                    ;
                    }
                break;
                }
#ifdef AUSGABEN_LMB_NEU
            cout << " vor horizontal rang " << rang << endl;
#endif
            kommunikation_PLB_starten_horizontal_mit();
#ifdef AUSGABEN_LMB_NEU
            cout << " nach horizontal rang " << rang << endl;
#endif
            kopiere_lastvektor_horizontal_zu_hilfsvektor_mit();
            kommunikation_alle_PLB_starten_vertikal_mit();
            kopiere_hilfsvektor_zu_matrix_mit();
#ifdef AUSGABEN_LMB_NEU
            cout << " durch rang " << rang << endl;
#endif
            break;

        default:
            cout << "Fehler in Lastmengenbestimmung: Ungltiger Typ: Typ- ID " << typ << endl;
            exit(-1);
        }
    ausgeben(typ);
    }

// Kommentar: Hier wird im Fall der vollstndigen horizontalen Kommunikation getestet, ob die Kommunikation
// abgeschlossen ist.
bool LastMengenBestimmung::ist_fertig_horizontal(void)
    {
// Kommentar: Man durchluft die horizontale Kerntopologielinie, bis auf den eigenen Kern ...
    for(i=0; i<groesse_g; i++)
        {
        if(identitaeten_horizontal[i]!=rang)
            {
// Kommentar: Und testet mit Hilfe des Sende - und Empfangs - Requests, ob Senden - und Empfangen zu den jeweiligen Kernen
// abgeschlossen sind.
            MPI_Test(& (sende_requests_horizontal[i]), &flag, & status);
            if(flag==false)
                {
                return(false);
                }
            MPI_Test(& (empfangs_requests_horizontal[i]), & flag, & status);
            if(flag==false)
                {
                return(false);
                }
            }
        }
    return(true);
    }

// Kommentar: Hier wird im Fall der vollstndigen vertikalen Kommunikation getestet, ob die Kommunikation
// abgeschlossen ist.
bool LastMengenBestimmung::ist_fertig_vertikal(void)
    {
// Kommentar: Man durchluft die vertikalen Kerntopologielinie, bis auf den eigenen Kern ...
    for(i=0; i<groesse_f; i++)
        {
        if(identitaeten_vertikal[i]!=rang)
            {
// Kommentar: Und testet mit Hilfe des Sende - und Empfangs - Requests, ob Senden - und Empfangen zu den jeweiligen Kernen
// abgeschlossen sind.
            MPI_Test(& (sende_requests_vertikal[i]), &flag, & status);
            if(flag==false)
                {
                return(false);
                }
            MPI_Test(& (empfangs_requests_vertikal[i]), & flag, & status);
            if(flag==false)
                {
                return(false);
                }
            }
        }
    return(true);
    }

// Kommentar: Hier werden zu Debugging - Zwecken die Laststrukturen ausgegeben, fr die mit den hier vorgestellten Methoden die
// Lastwerte bestimmt wurden.
void LastMengenBestimmung::ausgeben(int typ)
    {
#ifdef AUSGABEN_LMB_NEU
    cout << " LMB ausgeben rang " << rang << endl;
#endif
#ifdef WARTEN
    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
#endif

    switch(typ)
        {
        case KN_HORIZONTAL_OHNE:
        case PLB_HORIZONTAL_OHNE:
#ifdef AUSGABEN_LMB
            for(i=0; i<groesse_g; i++)
                {
                cout << last_horizontal[i] << " ";
                }
            cout << endl;
#endif
            break;

        case KN_HORIZONTAL_MIT:
        case PLB_HORIZONTAL_MIT:
#ifdef AUSGABEN_LMB
            for(i=0; i<groesse_g_2; i++)
                {
                cout << last_horizontal[i] << " ";
                }
            cout << endl;
#endif
            break;

        case KN_VERTIKAL_OHNE:
        case PLB_VERTIKAL_OHNE:
#ifdef AUSGABEN_LMB
            for(i=0; i<groesse_f; i++)
                {
                cout << last_vertikal[i] << " ";
                }
            cout << endl;
#endif
            break;

        case KN_VERTIKAL_MIT:
        case PLB_VERTIKAL_MIT:
#ifdef AUSGABEN_LMB
            cout << " Rang " << rang << " ";
            for(i=0; i<groesse_f_2; i++)
                {
                cout << last_vertikal[i] << " ";
                }
            cout << endl;
#endif
            break;

        case KNxKN_OHNE:
        case PLBxPLB_OHNE:
#ifdef AUSGABEN_LMB
            cout << "Rang: " << rang << " ";
            for(i=0; i<groesse_f; i++)
                {
                for(j=0; j<groesse_g; j++)
                    {
                    cout << last_alle_prozessoren[i][j] << " ";
                    }
                }
            cout << endl;
#endif
            break;

        case KNxKN_MIT:
        case PLBxPLB_MIT:
#ifdef AUSGABEN_LMB
            cout << "Rang: " << rang << " ";
            for(i=0; i<groesse_f; i++)
                {
                for(j=0; j<groesse_g_2; j++)
                    {
                    cout << last_alle_prozessoren[i][j] << " ";
                    }
                }
            cout << endl;
#endif
            break;

        default:
            cout << "Fehler in Lastmengenbestimmung.ausgeben: Ungltiger Typ " << endl;
            exit(-1);
        }
    }

// Kommentar: Der Vektor last_horizontal wird an der Stelle in den Hilfsvektor kopiert, der der Stelle in der Lastmatrix last_alle_vektoren
// entspricht, wenn die Zeilen der Lastmatrix hintereinandergehangen werden. Das geschieht hier im Falle der Lastbestimmung zweier Gitterebenen.
void LastMengenBestimmung::kopiere_lastvektor_horizontal_zu_hilfsvektor_mit(void)
    {
    for(i=0; i<groesse_g_2; i++)
        {
        hilfsvektor[i+rang_durch_4_mal_8] = last_horizontal[i];
        }
    }

// Kommentar: Der Vektor last_horizontal wird an der Stelle in den Hilfsvektor kopiert, der der Stelle in der Lastmatrix last_alle_vektoren
// entspricht, wenn die Zeilen der Lastmatrix hintereinandergehangen werden. Das geschieht hier im Falle der Lastbestimmung einer Gitterebene.
void LastMengenBestimmung::kopiere_lastvektor_horizontal_zu_hilfsvektor_ohne(void)
    {
    for(i=0; i<groesse_g; i++)
        {
        hilfsvektor[i+rang_durch_4_mal_4] = last_horizontal[i];
        }
    }


// Kommentar: Diese Funktion entspricht vom Prinzip der Funktion kommunikation_alle_PLB_starten_horizontal_ohne.  Der Unterschied besteht darin,
// dass nicht nur ein Lastwert pro Kern vorhanden ist, sondern es sind 2, nmlich fr jede Gitterebene einer. Deswegen werden doppelt so viele
// Lastwerte geschrieben, und die kommunizierten Vektoren sind doppelt so lang - ab der doppelt so groen Anfangsposition. Ansonsten gibt es da
// keine Unterschiede.
void LastMengenBestimmung::kommunikation_PLB_starten_horizontal_mit(void)
    {
    switch(groesse_g)
        {
        case 1:
            last_horizontal[0] = eigene_last;
            last_horizontal[1] = eigene_last_oben;
            break;
        case 2:
            kommunikation_starten_horizontal_mit();
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;
        case 4:
            switch(rang & 3)
                {
                case 0:
                    MPI_Irecv(&(last_horizontal[2]), 2, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[1]));
                    MPI_Irecv(&(last_horizontal[4]), 4, MPI_INT, rang + 2, 106, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    last_horizontal[0] = eigene_last;
                    last_horizontal[1] = eigene_last_oben;
                    for(;testen_1_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_horizontal[0]), 8, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[1]));
                    MPI_Isend(&(last_horizontal[0]), 4, MPI_INT, rang + 2, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
                    for(;testen_1_2_senden_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));
                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_horizontal[0]), 8, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
                    // Es reichen auch 6 Integer. Einen hat Prozessor 1. Dann muss aber kopiert werden.
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
                    MPI_Irecv(&(last_horizontal[6]), 2, MPI_INT, rang + 1, 105, MPI_COMM_WORLD, &(empfangs_requests_horizontal[3]));
                    last_horizontal[4] = eigene_last;
                    last_horizontal[5] = eigene_last_oben;
                    for(;testen_3_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_horizontal[4]), 4, MPI_INT, rang - 2, 106, MPI_COMM_WORLD, &(sende_requests_horizontal[0]));
                    for(;testen_0_senden_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_horizontal[0]), 4, MPI_INT, rang - 2, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[0]));
                    for(;testen_0_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_horizontal[0]), 6, MPI_INT, rang + 1, 107, MPI_COMM_WORLD, &(sende_requests_horizontal[3]));
                    for(;testen_3_senden_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                case 3:
                    last_horizontal[6] = eigene_last;
                    last_horizontal[7] = eigene_last_oben;
                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 1, 105, MPI_COMM_WORLD, &(sende_requests_horizontal[2]));
                    for(;testen_2_senden_horizontal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_horizontal[0]), 6, MPI_INT, rang - 1, 107, MPI_COMM_WORLD, &(empfangs_requests_horizontal[2]));
                    for(;testen_2_empfangen_horizontal()==false;)
                        {
                        ;
                        }
                    break;
                }
        }
    }

// Kommentar: Analog zu kommunikation_PLB_starten_horizontal_ohne, nur, dass in den Hilfsvektor geschrieben wird, und dass
// die Kerne der Kerntopologiespalte genommen werden. Man hat deswegen bei der switch Anweisung im Fall groesse_f = 4 den Parameter (rang >> 2),
// statt (rang & 3). Und man schickt bzw. empfngt statt von Kern rang+offset von Kern rang + 4*offset, also statt rang+1 rang+4, statt
// rang+2 rang+8, statt rang+3 rang+12, statt rang-1 rang-4, usw.. Weil das die Kerne sind, die in derselben Spalte bzgl. der Kerntopologie
// liegen.
// Ferner werden hier fr jeden Eintrag in kommunikation_PLB_starten_horizontal_ohne 8 Eintrge gemacht - weil man ganze Lastzeilen bermittelt,
// die bei 4 Kernen mit 2 Gitterebenen 8 Werte ausmachen. Damit hat man als Eintrge in den Hilfsvektor die Positionen wie
// in kommunikation_PLB_starten_horizontal_ohne Mal 8 der Lnge in kommunikation_PLB_starten_horizontal_ohne Mal 8. Damit werden
// die Zeilen transferiert, statt der Werte in den Spalten, und es werden komplette Spalten verschickt.
// Ansonsten luft alles ab wie in kommunikation_PLB_starten_horizontal_ohne.
void LastMengenBestimmung::kommunikation_alle_PLB_starten_vertikal_mit(void)
    {
    switch(groesse_f) // nderung 16.10.15
        {
        case 1:
            last_horizontal[0] = eigene_last;
            last_horizontal[1] = eigene_last_oben;
            break;
        case 2:
            kommunikation_starten_horizontal_mit();
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;
        case 4:
            switch(rang_durch_4)
                {
                case 0:
                    MPI_Irecv(&(hilfsvektor[8]), 8, MPI_INT, rang + 4, 115, MPI_COMM_WORLD, &(empfangs_requests_vertikal[1]));
                    MPI_Irecv(&(hilfsvektor[16]), 16, MPI_INT, rang + 8, 116, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    for(;testen_1_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(hilfsvektor[0]), 32, MPI_INT, rang + 4, 117, MPI_COMM_WORLD, &(sende_requests_vertikal[1]));
                    MPI_Isend(&(hilfsvektor[0]), 16, MPI_INT, rang + 8, 117, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_1_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
                    MPI_Isend(&(hilfsvektor[8]), 8, MPI_INT, rang - 4, 115, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(hilfsvektor[0]), 32, MPI_INT, rang - 4, 117, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    // Es reichen auch 6 Integer. Einen hat Prozessor 1. Dann muss aber kopiert werden.
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
                    MPI_Irecv(&(hilfsvektor[24]), 8, MPI_INT, rang + 4, 115, MPI_COMM_WORLD, &(empfangs_requests_vertikal[3]));
                    for(;testen_3_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(hilfsvektor[16]), 16, MPI_INT, rang - 8, 116, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(hilfsvektor[0]), 16, MPI_INT, rang - 8, 117, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(hilfsvektor[0]), 24, MPI_INT, rang + 4, 117, MPI_COMM_WORLD, &(sende_requests_vertikal[3]));
                    for(;testen_3_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 3:
                    MPI_Isend(&(hilfsvektor[24]), 8, MPI_INT, rang - 4, 115, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(hilfsvektor[0]), 24, MPI_INT, rang - 4, 117, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    for(;testen_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                }
        }
    }

// Kommentar: Hier wird der Hilfsvektor in die Lastmatrix kopiert, wobei die ganze Lastmatrix geschrieben wird. Das geschieht im Fall
// der Lastbestimmung zweier Gitterebenen.
void LastMengenBestimmung::kopiere_hilfsvektor_zu_matrix_mit(void)
    {
    for(i=0, k=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g_2; j++)
            {
            last_alle_prozessoren[i][j] = hilfsvektor[k++];
            }
        }
    }

// Kommentar: Hier wird der Hilfsvektor in die Lastmatrix kopiert, wobei die ganze Lastmatrix geschrieben wird. Das geschieht im Fall
// der Lastbestimmung einer Gitterebene.
void LastMengenBestimmung::kopiere_hilfsvektor_zu_matrix_ohne(void)
    {
    for(i=0, k=0; i<groesse_f; i++)
        {
        for(j=0; j<groesse_g; j++)
            {
            last_alle_prozessoren[i][j] = hilfsvektor[k++];
            }
        }
    }

// Kommentar: Das ist hier analog zu kommunikation_PLB_starten_vertikal_ohne, nur dass hier zwei Lastwerte geschrieben werden,
// und immer statt einer Lastinformation 2 Lastinformationen bermittelt werden. Damit bekommt der Lastvektor last_vertikal
// statt eines Eintrages an der Stelle k der Lnge l einen Eintrag an der Stelle 2*k der Lnge 2*l. Sonst ist alles
// analog zu kommunikation_PLB_starten_vertikal_ohne.
void LastMengenBestimmung::kommunikation_PLB_starten_vertikal_mit(void)
    {
    switch(groesse_f) // nderung 16.10.15
        {
        case 1:
            last_vertikal[0] = eigene_last;
            last_vertikal[1] = eigene_last_oben;
            break;
        case 2:
            kommunikation_starten_vertikal_mit();
            for(;ist_fertig_vertikal()==false;)
                {
                ;
                }
            break;
        case 4:
#ifdef WARTEN
            for(i=0; i<rang*4000000; i++)
                {
                cout << "";
                }
#endif
            switch(rang >> 2)
                {
                case 0:
                    MPI_Irecv(&(last_vertikal[2]), 2, MPI_INT, rang + 4, 105, MPI_COMM_WORLD, &(empfangs_requests_vertikal[1]));
                    MPI_Irecv(&(last_vertikal[4]), 4, MPI_INT, rang + 8, 106, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    last_vertikal[0] = eigene_last;
                    last_vertikal[1] = eigene_last_oben;
                    for(;testen_1_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_vertikal[0]), 8, MPI_INT, rang + 4, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[1]));
                    MPI_Isend(&(last_vertikal[0]), 4, MPI_INT, rang + 8, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_1_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 4, 105, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_vertikal[0]), 8, MPI_INT, rang - 4, 107, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
                    MPI_Irecv(&(last_vertikal[6]), 2, MPI_INT, rang + 4, 105, MPI_COMM_WORLD, &(empfangs_requests_vertikal[3]));
                    last_vertikal[4] = eigene_last;
                    last_vertikal[5] = eigene_last_oben;
                    for(;testen_3_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_vertikal[4]), 4, MPI_INT, rang - 8, 106, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_vertikal[0]), 4, MPI_INT, rang - 8, 107, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(last_vertikal[0]), 6, MPI_INT, rang + 4, 107, MPI_COMM_WORLD, &(sende_requests_vertikal[3]));
                    for(;testen_3_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 3:
//                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 4, 105, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    last_vertikal[6] = eigene_last;
                    last_vertikal[7] = eigene_last_oben;
                    MPI_Isend(eigene_last_vektor, 2, MPI_INT, rang - 4, 105, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(last_vertikal[0]), 6, MPI_INT, rang - 4, 107, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    for(;testen_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                }
            break;
        }
    }

// Kommentar: Diese Funktion ist analog zur Funktion kommunikation_alle_PLB_starten_vertikal_mit, nur, dass statt der bermittlung
// von jeweils k * 8 Werten auf den Koordinaten i * 8 nur k * 4 Werte auf den Koordinaten i * 4 des Hilfsvektors bermittelt werden.
// Alle anderen Schritte laufen genauso ab.
void LastMengenBestimmung::kommunikation_alle_PLB_starten_vertikal_ohne(void)
    {
    switch(groesse_f) // nderung 16.10.15
        {
        case 1:
            last_horizontal[0] = eigene_last;
            break;
        case 2:
            kommunikation_starten_horizontal_ohne();
            for(;ist_fertig_horizontal()==false;)
                {
                ;
                }
            break;
        case 4:
            switch(rang_durch_4)
                {
                case 0:
                    MPI_Irecv(&(hilfsvektor[4]), 4, MPI_INT, rang + 4, 115, MPI_COMM_WORLD, &(empfangs_requests_vertikal[1]));
                    MPI_Irecv(&(hilfsvektor[8]), 8, MPI_INT, rang + 8, 116, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    for(;testen_1_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(hilfsvektor[0]), 16, MPI_INT, rang + 4, 117, MPI_COMM_WORLD, &(sende_requests_vertikal[1]));
                    MPI_Isend(&(hilfsvektor[0]), 8, MPI_INT, rang + 8, 117, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_1_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 1:
                    MPI_Isend(&(hilfsvektor[4]), 4, MPI_INT, rang - 4, 115, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(hilfsvektor[0]), 16, MPI_INT, rang - 4, 117, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    // Es reichen auch 6 Integer. Einen hat Prozessor 1. Dann muss aber kopiert werden.
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 2:
                    MPI_Irecv(&(hilfsvektor[12]), 4, MPI_INT, rang + 4, 115, MPI_COMM_WORLD, &(empfangs_requests_vertikal[3]));
                    for(;testen_3_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(hilfsvektor[8]), 8, MPI_INT, rang - 8, 116, MPI_COMM_WORLD, &(sende_requests_vertikal[0]));
                    for(;testen_0_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(hilfsvektor[0]), 8, MPI_INT, rang - 8, 117, MPI_COMM_WORLD, &(empfangs_requests_vertikal[0]));
                    for(;testen_0_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Isend(&(hilfsvektor[0]), 12, MPI_INT, rang + 4, 117, MPI_COMM_WORLD, &(sende_requests_vertikal[3]));
                    for(;testen_3_senden_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                case 3:
                    MPI_Isend(&(hilfsvektor[12]), 4, MPI_INT, rang - 4, 115, MPI_COMM_WORLD, &(sende_requests_vertikal[2]));
                    for(;testen_2_senden_vertikal()==false;)
                        {
                        ;
                        }
                    MPI_Irecv(&(hilfsvektor[0]), 12, MPI_INT, rang - 4, 117, MPI_COMM_WORLD, &(empfangs_requests_vertikal[2]));
                    for(;testen_2_empfangen_vertikal()==false;)
                        {
                        ;
                        }
                    break;
                }
        }
    }

void LastMengenBestimmung::kopiere_lastvektor_zu_last_alle_prozessoren_ohne(void)
    {
    lastvektor = last_alle_prozessoren[position_f];
    for(i=0; i<groesse_g; i++)
        {
        lastvektor[i] = last_horizontal[i];
        }
    }

void LastMengenBestimmung::kopiere_lastvektor_zu_last_alle_prozessoren_mit(void)
    {
    lastvektor = last_alle_prozessoren[position_f];
    for(i=0; i<groesse_g_2; i++)
        {
        lastvektor[i] = last_horizontal[i];
        }
    }
