#ifndef LASTMENGENBESTIMMUNG
#define LASTMENGENBESTIMMUNG

#include "ausgaben.h"

#include <mpi.h>
#include <iostream>
#include <stdlib.h>

#define KN_HORIZONTAL_OHNE 0
#define KN_HORIZONTAL_MIT 1
#define KN_VERTIKAL_OHNE 2
#define KN_VERTIKAL_MIT 3
#define KNxKN_OHNE 4
#define KNxKN_MIT 5
#define PLB_HORIZONTAL_OHNE 6
#define PLB_HORIZONTAL_MIT 7
#define PLB_VERTIKAL_OHNE 8
#define PLB_VERTIKAL_MIT 9
#define PLBxPLB_OHNE 10
#define PLBxPLB_MIT 11
#define PLBxPLB_MIT_ALT 12

using namespace std;

class LastMengenBestimmung
    {
private:
public:
    int * last_horizontal;
    int * last_vertikal;
    int ** last_alle_prozessoren;
private:
    int * lastvektor;
    int * hilfsvektor;
public:
    void setze_last(int _last);
    void setze_last_vektor(int _last, int _last_oben);
private:
    int eigene_last, eigene_last_oben, eigene_last_vektor[2];
public:
    void setze_eigene_last(int _eigene_last);
    void setze_eigene_last_oben(int _eigene_last_oben);
public:
    void setze_lastmenge(void);
private:
    int rang, groesse;
    int groesse_2;
public:
    int groesse_f, groesse_g;
private:
    int groesse_f_2, groesse_g_2;
public:
    void initialisieren_normal(int _rang, int _groesse);
    void finalisieren_normal(void);
private:
    void initialisieren(int _rang, int _groesse);
    void initialisiere_farbmatrix(void);
    void finalisieren(void);
    void finalisiere_farbmatrix(void);
    void farbmatrix_auswerten(void);
private:
    int * identitaeten_horizontal, * identitaeten_vertikal;
private:
    MPI_Request * sende_requests_vertikal;
    MPI_Request * empfangs_requests_vertikal;
    MPI_Request * sende_requests_horizontal;
    MPI_Request * empfangs_requests_horizontal;

    MPI_Status status;
    int flag;
private:
    int max(int f, int g);
private:
    int ** farbmatrix;
    int i, j, k, l;
    int i_2;
public:
    int position_f, position_g;
private:
    int position_f_2, position_g_2;
private:
public:
    void kommunikation_starten_horizontal_mit(void);
    void kommunikation_starten_horizontal_ohne(void);
    void kommunikation_starten_vertikal_mit(void);
    void kommunikation_starten_vertikal_ohne(void);
private:
    bool ist_fertig_horizontal(void);
    bool ist_fertig_vertikal(void);

    void kommunikation_alle_starten_horizontal_mit(void);
    void kommunikation_alle_starten_vertikal_mit(void);
    void kommunikation_alle_starten_horizontal_ohne(void);
    void kommunikation_alle_starten_vertikal_ohne(void);
public:
    void kommunikation_PLB_starten_horizontal_ohne(void);
    void kommunikation_PLB_starten_horizontal_mit_alt(void);
    void kommunikation_PLB_starten_horizontal_mit(void);
    void kommunikation_PLB_starten_vertikal_ohne(void);
    void kommunikation_PLB_starten_vertikal_mit(void);
    void kommunikation_PLB_starten_vertikal_mit_alt(void);

    void kommunikation_alle_PLB_starten_horizontal_ohne(void);
    void kommunikation_alle_PLB_starten_horizontal_mit(void);

    void kommunikation_alle_PLB_starten_vertikal_ohne_alt(void);
    void kommunikation_alle_PLB_starten_vertikal_ohne(void);
    void kommunikation_alle_PLB_starten_vertikal_mit(void);
    void kommunikation_alle_PLB_starten_vertikal_mit_alt(void);

public:
    void tun(int typ);
public:
    void ausgeben(int typ);

private:
    bool testen_0_senden_horizontal(void);
    bool testen_2_senden_horizontal(void);
    bool testen_3_senden_horizontal(void);
    bool testen_1_2_senden_horizontal(void);
    bool testen_0_empfangen_horizontal(void);
    bool testen_2_empfangen_horizontal(void);
    bool testen_3_empfangen_horizontal(void);
    bool testen_1_2_empfangen_horizontal(void);

    bool testen_0_senden_vertikal(void);
    bool testen_2_senden_vertikal(void);
    bool testen_3_senden_vertikal(void);
    bool testen_1_2_senden_vertikal(void);
    bool testen_0_empfangen_vertikal(void);
    bool testen_2_empfangen_vertikal(void);
    bool testen_3_empfangen_vertikal(void);
    bool testen_1_2_empfangen_vertikal(void);
private:
    int rang_durch_4;
    int rang_mal_2;
    int rang_durch_4_mal_8;
    int rang_durch_4_mal_4;
    void kopiere_hilfsvektor_zu_matrix_mit(void);
    void kopiere_hilfsvektor_zu_matrix_ohne(void);
    void kopiere_lastvektor_horizontal_zu_hilfsvektor_mit(void);
    void kopiere_lastvektor_horizontal_zu_hilfsvektor_ohne(void);
private:
    void kopiere_lastvektor_zu_last_alle_prozessoren_ohne(void);
    void kopiere_lastvektor_zu_last_alle_prozessoren_mit(void);
    };

#endif
