#include "loeschen_einfuegen.h"

// Kommentar: Hier wird alles gemacht, für ein Einfügen bzw. ein Entfernen eines Punktes. Diese Klasse wird insbesondere gebraucht
// in der Klasse PunktUpdateFG, wo ganze Punktlisten eingefügt bzw. entfernt werden.

// Kommentar: Mit dieser Funktion wird nur u0(f,g) auf 0 gesetzt - wenn der Punkt nicht ganz am Gitterrand gemäß den
// Gittermaßen sich befindet.
void LoeschenEinfuegen::berechne_u0_in_neuem_punkt(int f, int g)
    {
// Kommentar: Ganz am Rand bzgl. der Gittermaße => nichts tun.
    if((f==0)||(f==n_h_minus1_minus1)||(g==0)||(g==m_h_minus1_minus1))
        {
        return;
        }
// Kommentar: Sonst löschen des Wertes u0 an der Stelle des übergebenen Punktes.
    paralleles_rechnen_h_minus1->u0[f][g] = 0;
#ifdef AKTUELLE_KOMMENTARE
    if(g==11)
        {
        cout << " u0 neuer Punkt f " << f << " g " << g << " rang " << paralleles_rechnen_h_minus1->rang << endl;
        }
#endif
    }

// Kommentar: Hier wird (f,g) eingefügt, wobei nur ev geändert wird.
void LoeschenEinfuegen::einfaches_einfuegen_feingitterEV(int f, int g)
    {
// Kommentar: Das Farbenfeld bekommt an der Stelle (f,g) den Wert rang geschrieben.
    paralleles_rechnen_h_minus1->farbenfeld[f][g] = rang;
// Kommentar: Und u0 bekommt den Wert 0 geschrieben - bis auf den Rand bzgl. der Gittermaße.
    berechne_u0_in_neuem_punkt(f, g);

#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "In AdaptiveVerfeinerung::fuege_punkt_ein : f " << f << " g " << g << " h " << h << endl;
#endif

    #ifndef AUCH_DYNAMISCH
    paralleles_rechnen_h_minus1->punkt_hinzufuegen(f, g);
    #else
// Kommentar: Als nächstes wird der Punkt in die Klasse Gitter eingefügt, wobei gleichsam der Gitterrand in der entsprechenden
// Feldliste aktualisiert wird.
    paralleles_rechnen_h_minus1->punkt_hinzufuegen_dynamisch(f, g);
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    if((f==18)&&(g==14))
        {
        cout << " AAPP pr-einfuegen feld " << paralleles_rechnen_h_minus1->feld[f][g] << endl;
        }
#endif
    #endif

// Kommentar: Das es hier ein neuer Punkt ist, der entsteht, wird er in die Liste 'neuer_punkt' aufgenommen. Das ist
// insbesondere für die Prolongation eine wichtige Klasse.
    neuer_punkt->setzen(f, g); // Was bedeutet neuer Punkt? Eine Markierung setzen. Warum?

#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "LTE Rang " << rang << " f " << f << " g " << g << " " << endl;
#endif

#ifndef SEQUENTIELL
// Kommentar: Und am Ende wird - bedingungslos - in ev_h_minus1 - eingefügt. Bei ev geschieht das immer.
    ev_h_minus1->einfuegen(f, g);
#endif
    }

// Kommentar: Hier wird (f,g) eingefügt, wobei nur ev2 geändert wird.
void LoeschenEinfuegen::einfaches_einfuegen_feingitterEV2(int f, int g)
    {
// Kommentar: Das Farbenfeld bekommt an der Stelle (f,g) den Wert rang geschrieben.
    paralleles_rechnen_h_minus1->farbenfeld[f][g] = rang;
// Kommentar: Und u0 bekommt den Wert 0 geschrieben - bis auf den Rand bzgl. der Gittermaße.
    berechne_u0_in_neuem_punkt(f, g);

#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "In AdaptiveVerfeinerung::fuege_punkt_ein : f " << f << " g " << g << " h " << h << endl;
#endif

    #ifndef AUCH_DYNAMISCH
    paralleles_rechnen_h_minus1->punkt_hinzufuegen(f, g);
    #else
// Kommentar: Als nächstes wird der Punkt in die Klasse Gitter eingefügt, wobei gleichsam der Gitterrand in der entsprechenden
// Feldliste aktualisiert wird.
    paralleles_rechnen_h_minus1->punkt_hinzufuegen_dynamisch(f, g);
    #endif

#ifdef AKTUELLE_WERTE
#ifdef NP_WERTE
    cout << " NP: f " << f << " g " << g << endl;
#endif
#endif

// Kommentar: Das es hier ein neuer Punkt ist, der entsteht, wird er in die Liste 'neuer_punkt' aufgenommen. Das ist
// insbesondere für die Prolongation eine wichtige Klasse.
    neuer_punkt->setzen(f, g); // Was bedeutet neuer Punkt? Eine Markierung setzen. Warum?

#ifndef SEQUENTIELL
// Kommentar: Im Gegensatz zur Funktion 'einfaches_einfuegen_feingitterEVEV2' wird hier ev2 schon auf der untersten Ebene
// gebraucht, also bei ev2_h_minus1 für die Ebenen h>=1.
    if(h>=1)    // Da eine Ebene tiefer eingefügt wird, und man ev2 nur für oben braucht, reicht
                // eine Änderung für h>=2 aus. // Bei modifiziertem ev2 reicht schon h>=1.
                // Warum braucht man ev2 nur für oben? h=1 ist die unterste Ebene, da es für den 'scan' (EP)  gilt.
        {
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
        cout << "Lastausgleich ev2_h_minus1 : f " << f << " g " << g << " h " << h << endl;
#endif
// Kommentar: Bei der adaptiven Verfeinerung entsteht etwas ganz Neues, so dass darunter noch kein Gitterpunkt existieren kann.
// Deswegen wird bedingungslos eingefügt.
        ev2_h_minus1->einfuegen(f,g); // Es gibt noch nichts darunter, also bedingungslos einfuegen
// Da der Punkt erst jetzt existiert, ist darunter kein Punkt selben Ranges. Der Rang darunter ist -1.
// h>1, weil bei h=1 auf Ebene h-1 = 0 nichts eingefügt wird.
// Das stimmt alles nicht. Kein pauschales einfügen, und auf Ebene 0 muss auch eingefügt werden.
// Was ist Ebene 0? Eigentlich ist es die Ebene des Einfügens.
        }
// Kommentar: Aber ein Punkt darüber wird gelöscht. Zuerst werden die Grobgitterkoordinaten bestimmt.
    f_2 = f >> 1;
    g_2 = g >> 1;

// Kommentar: Dann wird geprüft, ob ein gemeinsamer Punkt vorliegt.
    if((f_2 << 1) == f)
        {
        if((g_2 << 1) == g)
            {
//  Diese if's braucht man, weil sonst kein Punkt darüber existiert.
//            if(paralleles_rechnen_h->farbenfeld[f_2][g_2]==rang)
//            if(paralleles_rechnen_h->feld[f_2][g_2]>=0)   // Punkt wurde potentiell eingefuegt in (f,g,h-1), es gibt keine
                                                            // Behinderung dazu. Also Kompensation in jedem Fall durchführen.
                                                            // Der Punkt darüber existiert in jedem Fall. Als bisher unterster Punkt.

//  Wir brauchen hier das if nicht, weil, wenn farbenfeld(h-1)(f,g)==rang ist, das dann auch für
//  eine Ebene drüber gilt.
                {
// Kommentar: Wenn ja, dann wird dieser Punkt entfernt. Den muss es ja geben, sonst würde es diesen Punkt (f,g) darunter nicht geben.
// Das muss nicht per if - Anweisung geprüft werden.
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
                cout << " Pruefe vor ev2_h in loeschen einfuegen rang " << rang << " f_2 " << f_2 << " g_2 " << g_2 << " h " << h << " ebene ";
                cout << paralleles_rechnen_h->gitterebene << " pr_h(f_2,g_2) " << paralleles_rechnen_h->feld[f_2][g_2] << endl;
#endif
                ev2_h->entfernen(f_2,g_2);
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
                cout << " Pruefe nach ev2_h in loeschen einfuegen rang " << rang << " f_2 " << f_2 << " g_2 " << g_2 << endl;
#endif
                }
            // Und welche Ebene ist das?
            }
        }
#endif

#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "LTE Rang " << rang << " f " << f << " g " << g << " " << endl;
#endif
    }

// Kommentar: Hier geschieht das einfache - löschen im Fall, dass nur ev geführt werden muss.
void LoeschenEinfuegen::einfaches_loeschen_feingitterEV(int f, int g)
    {
//  Beim Loeschen: Immer erst ev / ev2 korrigieren, und dann die Punkt loeschen.
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "Vor ev_h_minus1->entfernen f " << f << " g " << g << endl;
#endif

#ifndef SEQUENTIELL
// Kommentar: Es wird bedingungslos aus ev_h_minus1 gelöscht - aus der Klasse Extreme Vektoren der Feingitterebene.
    ev_h_minus1->entfernen(f, g);
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "Vor Punkt entfernen f " << f << " g " << g << endl;
#endif
#endif

    #ifndef AUCH_DYNAMISCH
    paralleles_rechnen_h_minus1->punkt_entfernen(f, g);
    #else
// Kommentar: Aus dem Gitter wird der Punkt bedingungslos gelöscht. In diesem Fall mit einem Update der Randstruktur. Die wird
// nämlich in diesem Programm gebraucht.
    paralleles_rechnen_h_minus1->punkt_entfernen_dynamisch(f, g);
    #endif
// Kommentar: Und beim Löschen eines Punktes muss das Farbenfeld an dieser Stelle -1 werden.
    paralleles_rechnen_h_minus1->farbenfeld[f][g] = -1;
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "Nach Punkt entfernen " << endl;
#endif

// Damit wird die Klasse Strategie korrigiert. Wie aber dasselbe mit der Klasse Gitter? Via Punkt aufloesen (s.u.).
// Dort wird auch auf die Klasse Gitter zugegriffen.


// Hier kann der Fall auftreten, dass in ev2 kein Punkt steht, obwohl einer existiert. Also:
// Evtl. muss hier geprüft werden, ob das Farbenfeld dort = rang ist.
//    zaehle_farben->entfernen_av(f, g);
// Dieser Befehl wird aufgehoben, da das Entfernen sonst doppelt gemoppelt wird.
// Muss diese Funktion nicht auch mit EV2 geändert werden? Vielleicht 2 Zähler verwenden?
// Das muss zuerst analysiert werden, weil evtl. mit ist_nachbar(ev)=true auch
// ist_nachbar(ev2) = true gilt. Wahrscheinlich gilt sogar die Äquivalenz, weil nur Überdeckungen
// hinzugefügt bzw. entfernt werden.

// Bemerkung zu diesem Befehl: Er kann immer stehenbleiben, weil die Gitterumbauebene - wie
// auch die Lastausgleichebene - immer unterhalb von h_kappe liegen!!!
//    punkt_aufloesen(f, g);
// Das geht in die Klasse Aufloesung. Fuers zaehlen wichtig ist die Wirkung davon, d.h. wo
// das aufloesen bekannt wird. Dafür braucht man wohl die Klasse uebermitteln.
    }

// Kommentar: Hier wird auf dem feinen Gitter, und auch für die Struktur ev2 gelöscht, nicht aber für ev.
void LoeschenEinfuegen::einfaches_loeschen_feingitterEV2(int f, int g)
// Morgen korrigieren. Habe ich heute (30.01.2013) schon gemacht.
// Ist so richtig. h>=1 gilt aber immer. Das ist schon für die niedrigste Ebene. Wichtig: Angewendet von aV und nicht LA / LT.
// Dann sind die Punkte drüber da, und beim Einfügen ist auch noch nichts drunter da. Beim entfernen wird drüber
// eingefügt. So ist alles richtig.
// Datum: 02.04.2014
    {
//  Beim Loeschen: Immer erst ev / ev2 korrigieren, und dann die Punkt loeschen.
//    lastausgleich.lasttransfer_h_minus1->entfernen(f, g);
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "Vor Punkt entfernen f " << f << " g " << g << endl;
#endif

#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    if((f==6)&&(g==16))
        {
        cout << " LS 6,16 h " << h << " rang " << rang << " pr-h_minus1-gitterebene " << paralleles_rechnen_h_minus1->gitterebene;
        cout << " pr-h_minus2(2f,2g) " << paralleles_rechnen_h_minus2->feld[f+f][g+g] << endl;
        }
#endif // AUSGABEN_LOESCHEN_EINFUEGEN

#ifndef SEQUENTIELL
// Kommentar: Erst wird der Fall h>=2 behandelt.
    if(h>=2) // Löschen analog zum Einfügen nur bei 2 Ebenen höher
        {
//        if(paralleles_rechnen_h_minus1->feld[f][g]>=0)  // Es muss nicht gecheckt werden, dass 2 Ebenen
                                                        // tiefer kein Punkt liegt, weil sonst dieser Punkt
                                                        // auf dieser Ebene schon entfernt wäre.
                                                        // Nein: Punkte werden nicht entfernt! Es muss gecheckt werden, dass
                                                        // 2 Ebenen tiefer kein Punkt mehr liegt.

// Kommentar: Dieser Fall wird genau so behandelt wie in 'einfaches_loeschen_feingitterEVEV2'
        if(paralleles_rechnen_h_minus2->feld[f+f][g+g]<0)
            {
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
            cout << "Vor ev2_h_minus1->entfernen(f,g); " << endl;
#endif
            ev2_h_minus1->entfernen(f,g);
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
            cout << "Nach ev2_h_minus1->entfernen(f,g); " << endl;
#endif
            }
// Kommentar: Die Kompensation für ev2 eine Ebene höher erfolgt immer, mit der Idee, dass auch bei nicht vorhandenem ev2_h_minus1 ev2_h gelöscht werden kann, wenn
// später durch löschen einer Ebene tiefer paralleles_rechnen_h_minus2 < 0 werden wird.
        einfaches_loeschen_feingitter_kompensation(f, g);
        // Sonst nichts loeschen, weil der Punkt (f,g,h-1) nicht 'unten' ist, also in ev2 nicht existiert.
        }
    else
        {
// Kommentar: Der Fall h = 0 ist irrelevant. Ein  'Grobgitter - einfügen' aufgrund der Löschung des Feingitterelementes kann
// nicht erfolgen. Und fürs fein Gitter kann nichts eingefügt werden, weil die Ebene h = -1 unzulässig ist.
        if(h==1) // Hier braucht kein Test auf loeschen gemacht werden, weil der Punkt per Definition unten sein muss.
            {
// Kommentar: Hier kann auch der Grobgitterpunkt in ev2 eingefügt werden, wenn der Punkt darunter gelöscht wird.
            einfaches_loeschen_feingitter_kompensation(f, g);
// Kommentar: Und den Punkt darunter muss man löschen. Er existiert auch, weil das für die unterste Ebene immer gilt.
            ev2_h_minus1->entfernen(f,g); // Und bei modifiziertem ev
            }
        }
#endif
    #ifndef AUCH_DYNAMISCH
    paralleles_rechnen_h_minus1->punkt_entfernen(f, g);
    #else
// Kommentar: Aus dem Gitter wird der Punkt bedingungslos gelöscht. In diesem Fall mit einem Update der Randstruktur. Die wird
// nämlich in diesem Programm gebraucht.
    paralleles_rechnen_h_minus1->punkt_entfernen_dynamisch(f, g);
    #endif
// Kommentar: Und beim Löschen eines Punktes muss das Farbenfeld an dieser Stelle -1 werden.
    paralleles_rechnen_h_minus1->farbenfeld[f][g] = -1;
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    cout << "Nach Punkt entfernen " << endl;
#endif

// Damit wird die Klasse Strategie korrigiert. Wie aber dasselbe mit der Klasse Gitter? Via Punkt aufloesen (s.u.).
// Dort wird auch auf die Klasse Gitter zugegriffen.


// Hier kann der Fall auftreten, dass in ev2 kein Punkt steht, obwohl einer existiert. Also:
// Evtl. muss hier geprüft werden, ob das Farbenfeld dort = rang ist.
//    zaehle_farben->entfernen_av(f, g);
// Dieser Befehl wird aufgehoben, da das Entfernen sonst doppelt gemoppelt wird.
// Muss diese Funktion nicht auch mit EV2 geändert werden? Vielleicht 2 Zähler verwenden?
// Das muss zuerst analysiert werden, weil evtl. mit ist_nachbar(ev)=true auch
// ist_nachbar(ev2) = true gilt. Wahrscheinlich gilt sogar die Äquivalenz, weil nur Überdeckungen
// hinzugefügt bzw. entfernt werden.

// Bemerkung zu diesem Befehl: Er kann immer stehenbleiben, weil die Gitterumbauebene - wie
// auch die Lastausgleichebene - immer unterhalb von h_kappe liegen!!!
//    punkt_aufloesen(f, g);
// Das geht in die Klasse Aufloesung. Fuers zaehlen wichtig ist die Wirkung davon, d.h. wo
// das aufloesen bekannt wird. Dafür braucht man wohl die Klasse uebermitteln.
    }

// Kommentar: Hier wird ein Grobgitterpunkt in ev2 eingefügt, wenn der Feingitterpunkt darunter gelöscht wird.
inline void LoeschenEinfuegen::einfaches_loeschen_feingitter_kompensation(int f, int g)
    {
// Kommentar: Man geht davon aus, dass im Fall ev2 auch EV2 definiert ist. Standardmäßig ist EV2 definiert.
    #ifdef EV2
// Kommentar: Zuerst wird geprüft, ob ein gemeinsamer Punkt vorliegt.
    f_2 = f >> 1;
    g_2 = g >> 1;

#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
    if((f==6)&&(g==16))
        {
        cout << " Punkt (6,16) wurde entfernt. ev2 korrigieren rang " << rang << " pr[2](3,8) " << paralleles_rechnen_h->feld[f_2][g_2] << endl;
        }
#endif

    if(((f_2)<<1)==f)
        {
        if(((g_2)<<1)==g)
            {
            if(paralleles_rechnen_h->feld[f_2][g_2]>=0) // Nur einfügen in ev2_h, wenn der Grobgitterpunkt dazu vorhanden ist.
                                                        // Der aber ist vorhanden, weil der Punkt darunter existiert. Bei sukzessivem Entfernen gilt das nicht, weshalb diese Zeile dastehen muss.
                {
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
                cout << " Vor ev2_h->einfuegen(" << f_2 << "," << g_2 << ");" << endl;
#endif
// Kommentar: Da der Feingitterpunkt gelöscht wird, muss der Grobgitterpunkt eingefügt werden.
                ev2_h->einfuegen(f_2,g_2);
#ifdef AUSGABEN_LOESCHEN_EINFUEGEN
                cout << " Nach ev2_h->einfuegen(" << f_2 << "," << g_2 << ");" << endl;
#endif
                }
            }
        }
    #endif
    }

// Kommentar: Hier wird die Funktion LoeschenEinfuegen initialisiert. Dabei werden Parameter übergeben, aber kein Speicherplatz
// allokiert, weshalb auch nicht finalisiert werden muss.
void LoeschenEinfuegen::initialisieren(int _h, ParallelesRechnen * _paralleles_rechnen_h_minus2, ParallelesRechnen * _paralleles_rechnen_h_minus1, ParallelesRechnen * _paralleles_rechnen_h, ExtremeVektoren * _ev2_h_minus1, ExtremeVektoren * _ev2_h, ExtremeVektoren * _ev_h_minus1, MarkierungsFeld * _neuer_punkt)
// kein Speicher wird hier allokiert
    {
// Die wichtigen Parameter werden übergeben, und man hat Zugriff auf das parallele_rechnen, ev und ev2 für die Ebenen h und h-1.
// Beim parallelen Rechnen sogar auf die Ebene h-2. UNd auf die Struktur neuer_punkt, um diese zu aktualisieren. Die Werte rang
// und h werden ebenfalls übergeben. Alles das wird in diese Klasse hineinkopiert.
    h = _h;
    paralleles_rechnen_h_minus2 = _paralleles_rechnen_h_minus2;
    paralleles_rechnen_h_minus1 = _paralleles_rechnen_h_minus1;
    paralleles_rechnen_h = _paralleles_rechnen_h;
    ev2_h_minus1 = _ev2_h_minus1;
    ev2_h = _ev2_h;
    ev_h_minus1 = _ev_h_minus1;
    rang = paralleles_rechnen_h -> rang;
    neuer_punkt = _neuer_punkt;
    n_h_minus1_minus1 = (paralleles_rechnen_h_minus1->n)-1;
    m_h_minus1_minus1 = (paralleles_rechnen_h_minus1->m)-1;
    }

//  Mit ev und ev2: Was bedeutet das? Und die Ebenen: Z.B. ein Verfeinerungsgitter: Was dann? Trotzdem 2 Ebenen von
//  extremen Vektoren? Präzise überlegen! Noch in Lastausgleich gucken!
//
//  Welche Ebene ist h? Und:
