#ifndef LOESCHEN_EINFUEGEN
#define LOESCHEN_EINFUEGEN

#include "ausgaben.h"
#include "paralleles_rechnen.h"
#include "extreme_vektoren.h"
#include "markierungsfeld.h"

class LoeschenEinfuegen
    {
public:
    void einfaches_einfuegen_feingitterEV(int f, int g);
    void einfaches_einfuegen_feingitterEV2(int f, int g);
    void einfaches_loeschen_feingitterEV(int f, int g);
    void einfaches_loeschen_feingitterEV2(int f, int g);
    void initialisieren(int _h, ParallelesRechnen * _paralleles_rechnen_h_minus2, ParallelesRechnen * _paralleles_rechnen_h_minus1, ParallelesRechnen * _paralleles_rechnen_h, ExtremeVektoren * _ev2_h_minus1, ExtremeVektoren * _ev2_h, ExtremeVektoren * _ev_h_minus1, MarkierungsFeld * _neuer_punkt);
private:
    ExtremeVektoren * ev2_h_minus1, * ev2_h, * ev_h_minus1;
    ParallelesRechnen * paralleles_rechnen_h_minus2;
    ParallelesRechnen * paralleles_rechnen_h_minus1;
    ParallelesRechnen * paralleles_rechnen_h;
private:
    int rang;
private:
    int f_2, g_2;
private:
    void berechne_u0_in_neuem_punkt(int f, int g);
private:
    MarkierungsFeld * neuer_punkt;
private:
    int h;
private:
    inline void einfaches_loeschen_feingitter_kompensation(int f, int g);
private:
    int n_h_minus1_minus1, m_h_minus1_minus1;
    };

#endif
