#include "lwk_anzahl_bestimmen.h"

// Wo wird ist_nachbar auf 0 gesetzt? Sonst: Schnellrand geht schnell.

// Kommentar: Hier geht es um eine Markierung der echten Randpunkte. Bei dieser Klasse werden dabei aber keine Rnder bestimmt,
// und die Kerntopologie wird auch nicht mitbestimmt.

// Kommentar: Es wird geprft, ob ein Nachbarfeld von (f,g) ohne Punkt ist. Wenn ja, dann liegt ein echter Rand vor, und
// auf der Position (f,g) wird markiert. Fr das uere Quadrat um das Gitter gilt das immer, weil das Farbenfeld auf nicht
// definierten Punkten immer negativ ist.
void LwKAnzahlBestimmen::lwk_pruefen(int f_s, int g_s)
    {
    if(farbenfeld[f_s][g_s]<0)
        {
        markierungsfeld_ev->setzen(f, g);
        }
    }

// Kommentar: Die Klasse wird initialisiert mit dem zu durchlaufenden dynamischer_rand, und selbstnachbarn und farbenfeld dienen
// den Entscheidungen.
void LwKAnzahlBestimmen::initialisieren(FeldListe * _dynamischer_rand, int ** _selbstnachbarn, short int ** _farbenfeld)
    {
    dynamischer_rand = _dynamischer_rand;
    selbstnachbarn = _selbstnachbarn;
    farbenfeld = _farbenfeld;
    }

// Kommentar: Hier wird ein Zeiger auf das Markierungsfeld bergeben - auch eine Art Initialisierung.
void LwKAnzahlBestimmen::initialisieren_lwk(MarkierungsFeldEV * _markierungsfeld_ev)
    {
    markierungsfeld_ev = _markierungsfeld_ev;
    }

// Kommentar: Hier wird die Markierung durchgefhrt.
void LwKAnzahlBestimmen::tun(void)
    {
// Kommentar: Zuerst wird die alte Markierung entfernt.
    markierungsfeld_ev->reset();
// Kommentar: Dann wird der Rand durchlaufen - mit Hilfe der Struktur dynamischer Rand, bei der nur Randpunkte in der Liste sind.
    for(dynamischer_rand->anfangsposition(); dynamischer_rand->ist_fertig_fl()==false; dynamischer_rand->naechster())
        {
        f = dynamischer_rand->lesen_f();
        g = dynamischer_rand->lesen_g();

// Kommentar: Die Richtungen der nicht eigenen Gitterpunkte werden aufgerufen.
        switch(255 - selbstnachbarn[f][g])
            {
               case 0:
                   break;
               case 1:
// Kommentar: Und fr jede solcher Richtungen wird obige Prffunktion lwk_pruefen an der Position Himmelsrichtung(f,g) aufgerufen.
                   lwk_pruefen_nord;
                   break;
               case 2:
                   lwk_pruefen_nordost;
                   break;
               case 3:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   break;
               case 4:
                   lwk_pruefen_ost;
                   break;
               case 5:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   break;
               case 6:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   break;
               case 7:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   break;
               case 8:
                   lwk_pruefen_suedost;
                   break;
               case 9:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   break;
               case 10:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   break;
               case 11:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   break;
               case 12:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   break;
               case 13:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   break;
               case 14:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   break;
               case 15:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   break;
               case 16:
                   lwk_pruefen_sued;
                   break;
               case 17:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   break;
               case 18:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   break;
               case 19:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   break;
               case 20:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   break;
               case 21:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   break;
               case 22:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   break;
               case 23:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   break;
               case 24:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 25:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 26:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 27:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 28:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 29:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 30:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 31:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   break;
               case 32:
                   lwk_pruefen_suedwest;
                   break;
               case 33:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedwest;
                   break;
               case 34:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   break;
               case 35:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   break;
               case 36:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   break;
               case 37:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   break;
               case 38:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   break;
               case 39:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   break;
               case 40:
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 41:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 42:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 43:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 44:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 45:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 46:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 47:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   break;
               case 48:
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 49:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 50:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 51:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 52:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 53:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 54:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 55:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 56:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 57:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 58:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 59:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 60:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 61:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 62:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 63:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   break;
               case 64:
                   lwk_pruefen_west;
                   break;
               case 65:
                   lwk_pruefen_nord;
                   lwk_pruefen_west;
                   break;
               case 66:
                   lwk_pruefen_nordost;
                   lwk_pruefen_west;
                   break;
               case 67:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_west;
                   break;
               case 68:
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   break;
               case 69:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   break;
               case 70:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   break;
               case 71:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   break;
               case 72:
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 73:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 74:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 75:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 76:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 77:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 78:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 79:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   break;
               case 80:
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 81:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 82:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 83:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 84:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 85:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 86:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 87:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 88:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 89:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 90:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 91:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 92:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 93:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 94:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 95:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   break;
               case 96:
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 97:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 98:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 99:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 100:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 101:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 102:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 103:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 104:
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 105:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 106:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 107:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 108:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 109:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 110:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 111:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 112:
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 113:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 114:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 115:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 116:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 117:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 118:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 119:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 120:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 121:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 122:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 123:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 124:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 125:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 126:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 127:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   break;
               case 128:
                   lwk_pruefen_nordwest;
                   break;
               case 129:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordwest;
                   break;
               case 130:
                   lwk_pruefen_nordost;
                   lwk_pruefen_nordwest;
                   break;
               case 131:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_nordwest;
                   break;
               case 132:
                   lwk_pruefen_ost;
                   lwk_pruefen_nordwest;
                   break;
               case 133:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_nordwest;
                   break;
               case 134:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_nordwest;
                   break;
               case 135:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_nordwest;
                   break;
               case 136:
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 137:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 138:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 139:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 140:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 141:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 142:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 143:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_nordwest;
                   break;
               case 144:
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 145:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 146:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 147:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 148:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 149:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 150:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 151:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 152:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 153:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 154:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 155:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 156:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 157:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 158:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 159:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_nordwest;
                   break;
               case 160:
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 161:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 162:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 163:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 164:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 165:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 166:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 167:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 168:
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 169:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 170:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 171:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 172:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 173:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 174:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 175:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 176:
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 177:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 178:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 179:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 180:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 181:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 182:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 183:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 184:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 185:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 186:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 187:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 188:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 189:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 190:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 191:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_nordwest;
                   break;
               case 192:
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 193:
                   lwk_pruefen_nord;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 194:
                   lwk_pruefen_nordost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 195:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 196:
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 197:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 198:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 199:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 200:
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 201:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 202:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 203:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 204:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 205:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 206:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 207:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 208:
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 209:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 210:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 211:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 212:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 213:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 214:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 215:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 216:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 217:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 218:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 219:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 220:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 221:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 222:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 223:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 224:
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 225:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 226:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 227:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 228:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 229:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 230:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 231:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 232:
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 233:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 234:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 235:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 236:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 237:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 238:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 239:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 240:
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 241:
                   lwk_pruefen_nord;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 242:
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 243:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 244:
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 245:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 246:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 247:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 248:
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 249:
                   lwk_pruefen_nord;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 250:
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 251:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 252:
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 253:
                   lwk_pruefen_nord;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 254:
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
               case 255:
                   lwk_pruefen_nord;
                   lwk_pruefen_nordost;
                   lwk_pruefen_ost;
                   lwk_pruefen_suedost;
                   lwk_pruefen_sued;
                   lwk_pruefen_suedwest;
                   lwk_pruefen_west;
                   lwk_pruefen_nordwest;
                   break;
            }
        }
    }
