#include "markierung.h"

// Kommentar: Hier wird ein 2 - dimensionales Feld markiert und remarkiert. Dafür werden übergebene Koordinatenlisten verwendet.
// Benötigt wird diese Markierung bei der Klasse Randinterpolation.

// Kommentar: Standardmäßig liegt keine Markierung vor.
Markierung::Markierung(void)
    {
    laenge = 0;
    };

// void Markierung::initialisieren(int _m, int _n, int ** _feld, short int * _f_liste, short int * _g_liste)

// Kommentar: Übergeben wird das Feld, für das die Markierungen durchgeführt werden sollen, sowie die Koordinatenliste, die die
// Markierungsinformationen speichern sollen.
void Markierung::initialisieren(int ** _feld, short int * _f_liste, short int * _g_liste)
    {

// Kommentar: Die Parameter werden abgespeichert.
    f_liste = _f_liste;
    g_liste = _g_liste;

    laenge = 0;

    feld = _feld;
    }

// Kommentar: Eine Markierung wird gesetzt an der Stelle (f,g).
void Markierung::setzen(int f, int g)
    {
// Kommentar: Wenn das Feld an der Stelle negativ ist - bzw. genauer hier -1 ist - dann wird es auf 2 gesetzt. Damit ist bei der
// Randinterpolation das Feld an der Stelle markiert. Und dann werden die hierbei verwendeten Koordinaten gespeichert.
    if(feld[f][g] == -1)
        {
        feld[f][g] = 2;
        f_liste[laenge] = f;
        g_liste[laenge++] = g;
        }
    }

// Kommentar: Durch das Reset werden die Markierungen wieder umgekehrt.
void Markierung::reset(void)
    {
// Kommentar: Die Koordinatenliste wird durchlaufen, und für die verzeichneten Koordinaten wird wieder der urspüngliche Wert -1
// geschrieben.
    for(i=0; i<laenge; i++)
        {
        feld[f_liste[i]][g_liste[i]] = -1;
        }
// Am Ende wird dann die Koordinatenliste wieder geleert.
    laenge = 0;
    }
