#include "markierungsfeld.h"

// Kommentar: Hier wird ein Markierungsfeld gebildet. Damit kann man z.B. ablesen, ob man ein Aktion wie das Schreiben der
// Koordinaten eines Punktes in einen Buffer schon gemacht hat.

// Kommentar: Der Konstruktor setzt die Kontrollliste auf leer.
MarkierungsFeld::MarkierungsFeld(void)
    {
    laenge = 0;
    test_variable1 = 1234;
    };

//void MarkierungsFeld::initialisieren(int _m, int _n)

// Kommentar: Die benötigen Felder werden hier angelegt. Dabei werden die Gitter - Parameter n und m übergeben.
void MarkierungsFeld::initialisieren(int _n, int _m) //geändert am 16.4.15
// mit korrekter Finalisierung
    {
// Die Parameter werden gespeichert, und m*n wird gespeichert.
    m = _m;
    n = _n;
    mn = m*n;

// Kommentar: Eine Liste wird angelegt, die alle möglichen Gitterpunkte aufnehmen kann.
    f_liste = new short int [mn];
    g_liste = new short int [mn];
    laenge = 0;
    test_variable2 = 2345;

// Kommentar: Ein Feld der Maße n x m wird angelegt, um die Markierungen zu speichern.
    feld = new short int * [n];

    for(i=0; i<n; i++)
        {
        feld[i] = new short int [m];
        for(j=0; j<m; j++)
            {
            feld[i][j] = false;
            }
        }
    }

// Kommentar: Hier wird der angelegte Speicherplatz wieder freigegeben.
void MarkierungsFeld::finalisieren(void)
    {
// Kommentar: Zuerst wird der Speicherplatz des Markierungsfeldes freigegeben.
    for(i=0; i<n; i++)
        {
        delete feld[i];
        }
    delete feld;

// Kommentar: Und dann wird der Speicherplatz der Koordinatenlisten wieder freigegeben.
    delete f_liste;
    delete g_liste;
    }

// Kommentar: Hier wird eine Markierung gesetzt.
void MarkierungsFeld::setzen(int f, int g)
    {
// Kommentar: Ist der Punkt noch nicht markiert.
    if(feld[f][g]==false)
        {
// Kommentar: Dann markiere den Punkt, und nehme ihn in die Koordinatenliste auf.
        feld[f][g] = true;
        f_liste[laenge] = f;
        g_liste[laenge++] = g;
        }
    }

// Kommentar: Hiermit kommt es zu einer vollständigen Remarkierung.
void MarkierungsFeld::reset(void)
    {
// Kommentar: Man durchläuft die Koordinatenliste, und remarkiert das Feld an den gespeicherten Koordinaten.
    for(i=0; i<laenge; i++)
        {
        feld[f_liste[i]][g_liste[i]] = false;
        }
// Kommentar: Am Ende wir die Koordinatenliste geleert.
    laenge = 0;
    }
