#ifndef MULTI_LEVEL_RANDUEBERTRAGUNG
#define MULTI_LEVEL_RANDUEBERTRAGUNG 1

#include "ausgaben.h"

#include <mpi.h>
#include <iostream>

using namespace std;

class MultiLevelRanduebertragung
    {
private:
public:
#ifdef KURZ_RK
    short int ** sendebuffer;
    short int ** empfangsbuffer;
#else
    int ** sendebuffer;
    int ** empfangsbuffer;
#endif
private:
    int rang, groesse, n, m;
public:
    int buffergroesse;
public:

#ifdef GEMEINSAME_BUFFER_SI
    void initialisierung(int _n, int _m, int _groesse, int _rang, short int ** _sendebuffer, short int ** _empfangsbuffer);
#else
    void initialisierung(int _n, int _m, int _groesse, int _rang);
#endif
    void finalisierung(void);
private:
    int i;
    MPI_Request * sende_request, * empfangs_request;
    MPI_Status sende_status, empfangs_status;
public:
    int * multi_level_indizes;
    void senden(int i);
    void empfangen(int i);
public:
    bool test_senden(int i);
    bool test_empfangen(int i);
private:
    int flag;
    };

// Was macht diese Klasse; und wo werden die Buffer geschrieben? Vgl. Kommentare in multi_level_randuebertragung.cpp.

#endif

