#include "mv_horizontal.h"

// Kommentar: Hier werden die Ost - West - Vektoren gespeichert, die verschickt werden sollen, und zwar für alle Gitterebenen.

// Kommentar: Hier werden die Vektoren für alle Gitterebenen ausgegeben - fürs Debugging.
void MV_horizontal::ausgeben(char * text)
    {
#ifdef AUSGABEN_MV_horizontal
    cout << " MV_horizontal::ausgeben " << text << " h_gesamt " << h_gesamt << " rang " << rang;
    for(i=0; i<h_gesamt; i++)
        {
        cout << " Anzahl (" << i << "): " << indizes[i];
        for(j=0; j<indizes[i]; j++)
            {
            cout << " f " << f_speichern[i][j];
            cout << " g1 " << g1_speichern[i][j];
            cout << " g2 " << g2_speichern[i][j]; // << " rang " << rang << endl;
            if((i==2)&&(f_speichern[i][j]==13)&&(g1_speichern[i][j]<=8)&&(8<=g2_speichern[i][j]))
                {
                cout << " Jetzt wird MV_horizontal von (2,13,8) erreicht. rang " << rang << " text " << text << endl;
                }
            if((i==1)&&(f_speichern[i][j]==26)&&(g1_speichern[i][j]<=16)&&(16<=g2_speichern[i][j]))
                {
                cout << " Jetzt wird MV_horizontal von (1,26,16) erreicht. rang " << rang << " text " << text << endl;
                }
            }
        }
    cout << endl;
#endif
    }

void MV_horizontal::pruefe(int gitterebene, int f, int g, char * text)
    {
    for(j=0; j<indizes[gitterebene]; j++)
        {
        if((f_speichern[gitterebene][j]==f)&&(g1_speichern[gitterebene][j]<=g)&&(g2_speichern[gitterebene][j]>=g))
            {
            cout << " EEE rang " << rang << " Text " << text << " f " << f << " g " << g << endl;
            }
        }
    }

// Kommentar: Hier werden die Zeiger auf die Vektorenlisten wieder freigegeben. Dazu der Speicherplatz für die Indizes zu jeder
// Gitterebene.
void MV_horizontal::finalisieren(void)
    {
    delete indizes;
    delete f_speichern;
    delete g1_speichern;
    delete g2_speichern;
    }

// Kommentar: Hier wird die Klasse initialisiert: Die wichtigsten Parameter werden übergeben, sowie der Speicherplatz einer mv_vertikal Klasse.
void MV_horizontal::initialisieren(int _m, int _n, int _h_min, int _h_max, int _rang, MV_vertikal * mv_vertikal, int _h_kappe)
// wird richtig finalisiert
    {
#ifdef AUSGABEN_MV_horizontal
    cout << "MV vertikal initialisieren " << endl;
#endif

// Kommentar: Die wichtigsten Parameter werden übergeben, bzw. berechnet.
    m = _m;
    n = _n;
    h_min = _h_min;
    h_max = _h_max;
    h_gesamt = 1 + h_min + h_max;
    rang = _rang;
    h_kappe = _h_kappe;

// Kommentar: Die Indizes für jede Gitterebene werden angelegt.
    indizes = new int [h_gesamt];
// Kommentar: Die Zeiger für die Koordinatenlisten werden angelegt.
    f_speichern = new int * [h_gesamt];
    g1_speichern = new int * [h_gesamt];
    g2_speichern = new int * [h_gesamt];

// Kommentar: Die Gitterebenen werden durchlaufen.
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_MV_horizontal
//        cout << "mn_hilfe " << mn_hilfe << endl;
#endif

// Kommentar: Und der Speicherplatz der vertikalen Vektoren wird auf die horizontalen Vektoren übertragen.
        f_speichern[i] = mv_vertikal->f1_speichern[i];
        g1_speichern[i] = mv_vertikal->f2_speichern[i];
        g2_speichern[i] = mv_vertikal->g_speichern[i];
        }
#ifdef AUSGABEN_MV_horizontal
    cout << "MV vertikal ist initialisiert " << endl;
#endif

// Am Ende werden alle Vektorlisten oberhalb der Kappe geleert.
    if(h_kappe!=-1)
        {
        for(i=h_kappe+1; i<h_gesamt; i++)
            {
            indizes[i] = 0;
            }
        }
    }

// Kommentar: Hier werden die Multi - Level - Indizes zurückgesetzt auf 0.
void MV_horizontal::reset(void)
    {
    for(i=0; i<h_gesamt; i++)
        {
        indizes[i] = 0;
        }
    }
