#include "mv_projektionen_ns.h"

// Kommentar: Diese Klasse dient der Projektion von horizontal verlaufenden Vektoren, was beim Nord - Sd - Lastausgleich der Fall
// ist. Die Funktionsweise entspricht den Projektionen in der Klasse MVProjektionen. Deswegen muss hier nichts kommentiert werden,
// weil alles ganz analog vor sich geht.

void MVProjektionenNS::durchfuehren(MV_horizontal * mv, int h_LA)
    {
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!2010" << endl;
#endif
    fein_projektionen(mv, h_LA);
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!2011" << endl;
#endif
    grob_projektionen(mv, h_LA);
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!2012" << endl;
#endif
    }

void MVProjektionenNS::initialisieren(int _h_gesamt, int _rang, int _h_kappe)
// wird finalisiert
    {
    h_gesamt = _h_gesamt;
    rang = _rang;
#ifdef KURZ_FF
    farbenfelder = new short int ** [h_gesamt];
#else
    farbenfelder = new int ** [h_gesamt];
#endif

    n = new int [h_gesamt];
    m = new int [h_gesamt];

    h_kappe = _h_kappe;
    h_gesamt_minus1 = h_gesamt - 1;
    }

void MVProjektionenNS::finalisieren(void)
    {
    delete farbenfelder;
    delete n;
    delete m;
    }

#ifdef KURZ_FF
void MVProjektionenNS::schreibe_farbenfeld(int _h, short int ** _farbenfeld, int _n, int _m)
#else
void MVProjektionenNS::schreibe_farbenfeld(int _h, int ** _farbenfeld, int _n, int _m)
#endif
    {
    farbenfelder[_h] = _farbenfeld;
    n [_h] = _n;
    m [_h] = _m;
    }

void MVProjektionenNS::fein_projektionen(MV_horizontal * mv, int h_LA)
    {
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "Fein Projektionen " << endl;
#endif
    for(h=h_LA; h>0; h--)
        {
#ifdef AUSGABEN_MV_PROJEKTIONEN
        cout << " h " << h << endl;
#endif
        fein_projektion(mv, h);
        }
    }



void MVProjektionenNS::fein_projektion(MV_horizontal * mv, int h)
    {
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!20000 rang " << rang << endl;
#endif
    vektoranzahl = mv->indizes[h];

#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!20001" << " rang " << rang << endl;
#endif

    f_oben = mv->f_speichern[h];
    g1_oben = mv->g1_speichern[h];
    g2_oben = mv->g2_speichern[h];

#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!20002" << " rang " << rang << endl;
#endif

    h_minus_1 = h-1;

    f_unten = mv->f_speichern[h_minus_1];
    g1_unten = mv->g1_speichern[h_minus_1];
    g2_unten = mv->g2_speichern[h_minus_1];

#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!20003" << " rang " << rang << endl;
#endif

    n_minus_1 = n[h] - 1;
    n_h_minus1 = n[h_minus_1];
    n_h_minus1_minus1 = n_h_minus1 - 1;


#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!20004" << " rang " << rang << endl;
#endif

    schreibindex = 0;

    farbenfeld = farbenfelder[h_minus_1];
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "!20005 vektoranzahl " << vektoranzahl << " rang " << rang << endl;
#endif
    for(i=0; i<vektoranzahl; i++)
        {
        hvektor_f = f_oben[i];
        hvektor_g1 = g1_oben[i];
        hvektor_g2 = g2_oben[i];

        hvektor_g1_hier=hvektor_g1 << 1;
        hvektor_g2_hier=hvektor_g2 << 1;
        if(hvektor_g2_hier < n_h_minus1_minus1)
            {
            hvektor_g2_hier ++;
            }
        hvektor_f_hier =hvektor_f  << 1;

        vektor_schreiben(hvektor_f_hier, hvektor_g1_hier, hvektor_g2_hier);

        if(hvektor_f<n_minus_1)
                {
                vektor_schreiben(hvektor_f_hier+1, hvektor_g1_hier, hvektor_g2_hier);
                }
        }
    mv->indizes[h_minus_1] = schreibindex;
    }

void MVProjektionenNS::vektor_einfuegen(int f, int g1, int g2)
    {
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "Vektor einfuegen f " << f << " g1 " << g1 << " g2 " << g2 << " rang " << rang << endl;
#endif
    f_unten[schreibindex] = f;
    g1_unten[schreibindex] = g1;
    g2_unten[schreibindex] = g2;
    schreibindex++;
    }

void MVProjektionenNS::vektor_schreiben(int hvektor_f_hier, int hvektor_g1_hier, int hvektor_g2_hier)
// Wie genau funktioniert das? Es geht darum, Vektoren zu bilden, solange es gleich dem Rang ist.
    {
    if(farbenfeld[hvektor_f_hier][hvektor_g1_hier]==rang)
        {
        g1_merken = hvektor_g1_hier;
        zustand = MITTEN;
        }
    else
        {
        zustand = ANFANG;
        }
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "Vor der Schleife " << " rang " << rang << endl;
#endif
    for(k=hvektor_g1_hier;k<=hvektor_g2_hier;k++)
        {
#ifdef AUSGABEN_MV_PROJEKTIONEN
        cout << " k " << k << " f " << hvektor_f_hier << " ff[f][k] " << farbenfeld[hvektor_f_hier][k] << " rang " << rang << endl;
#endif

        if(zustand == ANFANG)
            {
            if(farbenfeld[hvektor_f_hier][k]!=rang)
                {
                continue;
                }
            g1_merken = k;
            zustand = MITTEN;
            continue;
            }
        if(farbenfeld[hvektor_f_hier][k]==rang)
            {
            continue;
            }
        vektor_einfuegen(hvektor_f_hier, g1_merken, k-1);
        zustand = ANFANG;
        continue;
        }
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "Schleife zu Ende " << " rang " << rang << endl;
#endif
    if(zustand == MITTEN)
        {
        vektor_einfuegen(hvektor_f_hier, g1_merken, hvektor_g2_hier);
        }
    }

void MVProjektionenNS::grob_projektionen(MV_horizontal * mv, int h_LA)
    {
#ifdef AUSGABEN_MV_PROJEKTIONEN
    cout << "Grob Projektionen " << endl;
    cout << "h_LA " << h_LA << " h_gesamt " << h_gesamt << endl;
#endif
    if(h_kappe == -1)
        {
        for(h=h_LA; h<h_gesamt_minus1; h++)
            {
#ifdef AUSGABEN_MV_PROJEKTIONEN
            cout << "h " << h << endl;
#endif
            grob_projektion(mv, h);
            }
#ifdef AUSGABEN_MV_PROJEKTIONEN
        cout << endl;
#endif
        }
    else
        {
        for(h=h_LA; h<h_kappe; h++)
            {
#ifdef AUSGABEN_MV_PROJEKTIONEN
            cout << "h " << h << endl;
#endif
            grob_projektion(mv, h);
            }
#ifdef AUSGABEN_MV_PROJEKTIONEN
        cout << endl;
#endif
        }
    }

void MVProjektionenNS::projektionen_bis_eine_ebene_hoeher(MV_horizontal * mv, int h_LA)
    {
    fein_projektionen(mv, h_LA);
    grob_projektion(mv, h_LA);
    }


void MVProjektionenNS::grob_projektion(MV_horizontal * mv, int h)
    {
    vektoranzahl = mv->indizes[h];

    f_unten = mv->f_speichern[h];
    g1_unten = mv->g1_speichern[h];
    g2_unten = mv->g2_speichern[h];

    h_plus_1 = h+1;

    f_oben = mv->f_speichern[h_plus_1];
    g1_oben = mv->g1_speichern[h_plus_1];
    g2_oben = mv->g2_speichern[h_plus_1];

    for(i=0, k=0; i<vektoranzahl; i++)
        {
        hvektor_f = f_unten[i];
        hvektor_g1 = g1_unten[i];
        hvektor_g2 = g2_unten[i];
        if((hvektor_f&1)==1)
            {
            continue;
            }
        if((hvektor_g1&1)==1)
            {
            hvektor_g1 ++;
            }
        if((hvektor_g2&1)==1)
            {
            hvektor_g2--;
            }
        if(hvektor_g1>hvektor_g2)
            {
            continue;
            }
        f_oben[k] = hvektor_f >> 1;

        g1_oben[k] = hvektor_g1 >> 1;

        g2_oben[k] = hvektor_g2 >> 1;

        k++;
        }
    mv->indizes[h+1] = k;
    }

// Kommentar: Die folgende Funktion gibt die in MVProjektionen gespeicherten Vektoren zu Debugging - Zwecken aus.
void MVProjektionenNS::ausgeben(char * text, MV_horizontal * mv)
    {
    for(h=0; h<h_gesamt;h++)
        {
        f = mv->f_speichern[h];
        g1 = mv->g1_speichern[h];
        g2 = mv->g2_speichern[h];
        vektoranzahl = mv->indizes[h];
        cout << " MVP " << text << " Ausgeben MVProjektionenNS Ebene " << h << " vektoranzahl " << vektoranzahl << " Rang " << rang;
        for(i=0; i<vektoranzahl; i++)
            {
// Die Vektorkoordinaten werden gelesen.
            hvektor_f = f[i];
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            if((h == 1)&&(hvektor_f==7)&&(hvektor_g1<=10)&&(hvektor_g2>=10))
                {
                cout << " Code X ";
                }
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2;
            }
        cout << endl;
        }
    }
