#include "nachkorrektur.h"

// Kommentar: In dieser Klasse wird die Zwischenkorrektur durchgefhrt - in der Weise, wie sie in der Dissertation beschrieben ist.
// Am Anfang war es keine Zwischenkorrektur, sondern eine Nachkorrektur, von der der Name geblieben ist. Durch eine nderung im
// Timing ist es gelungen, die Klasse zu vereinfachen, und gewisse Kommunikatinen berflssig zu machen.
// Bemerkung: Hier ist die Zwischenkorrektur fr den Ost - West - Lastausgleich und den Nord - Sd - Lastausgleich in einer Klasse.
// Die Funktionen mit dem Suffix '_ns' dienen der Nord - Sd - Zwischenkorrektur. Da beides analog ist, werden diese Funktionen
// nicht kommentiert.

// Soviel ist zu schreiben: Die Nachkorrektur schreibt f,g,h,farbwert in die Buffer,
// und liest sie dann in das Farbenfeld ein. Das macht diese Klasse.
// Welche f,g,h,farbwert geschrieben werden, muss noch geklaert werden.

////////////////////
//  logisch sammeln:
//  ---------------
//  logisch und senden und empfangen wird aufgerufen. Beim senden und empfangen wird
//  ist_nachbarn - mig eine Kommunikationsuntergruppe definiert, die sich dynamisch ndert.
//  gesendet werden die beim logisch sammeln gebildeten Buffer. Auf die kommt man so:
//  sow wird eingetragen in den Buffer. Danach bis zu zwei leere Speicherzellen. Diese nehmen die
//  Anzahlen der Eintrge in die Buffer auf.
//  Dann geschieht je nachdem wie das Sendeflag ist sammeln(mv_west) und sammeln(mv_ost)
//  Durch nkk::nachbereitung werden diese Buffer 'getrennt'. Bei Ihnen geht man die Hierarchie durch.
//  Ebene fr Ebene erfolgt die Nachbereitung, so dass die Zuordnung zu den Stufen eindeutig ist.
//  Und die Nachbereitung fr die eine Farbe schliesst sich an die Nachbereitung fr die andere Farbe an.
//  In einfuegen wird nkk[farbwert].einfuegen[f][g] aufgerufen, wodurch in den lokalen Buffern
//  nur zwei Werte pro Punkt zu speichern sind.
//  Ich glaube, dass das richtig funktioniert: Sammeln westen bzw. Osten je nachdem, ob
//  sende_west oder sende_ost true ist. Aber auch bei sende_west_oben sollte sende_west true sein.
//  Wie wird sende_west bzw. sende_ost uebergeben?
////////////////////

// Kommentar: Hiermit werden die Buffer fr die Kommunikation nach West oder Ost. Hierbei erfolgt aber
// entweder keine Kommunikation, nur die Kommunikation nach Westen, nur nach Osten, oder beide Kommunikationen.
void Nachkorrektur::vorbereiten(void)
// Was geschieht in dieser Funktion? Es geschieht keine Kommunikation selber!
    {
// Kommentar: Es werden die Buffer zu allen Kernen bzgl. der Punktnachbarschaft vorbereitet.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] >0)
                {
#ifdef AUSGABEN_NACHKORREKTUR
                cout << "Schreibe sow " << sow << " // rang " << rang << endl;
#endif

// Kommentar: Die Vorbereitung erfolgt in der Klasse NachkorrekturKommunikation, und ist abhngig von der Variablen sow,
// die angibt, zu welchem Kern - nach Ost und West - gesendet wird. Die Nachkorrektur bezieht ihre nderungsinformationen
// immer vom sendenden Kern.
                nachkorrektur_kommunikation[i].vorbereiten(sow);
                }
            }
        }
    }

// Kommentar: Analog zu vorbereiten. Nur eben fr den Nord - Sd - Lastausgleich.
void Nachkorrektur::vorbereiten_ns(void)
// Was geschieht in dieser Funktion? Es geschieht keine Kommunikation selber!
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] >0)
                {
#ifdef AUSGABEN_NACHKORREKTUR
                cout << "Schreibe sns " << sns << " // rang " << rang << endl;
#endif
                nachkorrektur_kommunikation[i].vorbereiten_ns(sns);
                }
            }
        }
    }

// Kommentar: Hier wird die Variable sow bestimmt. Falls nach Westen gesendet wird, so wird Bit 1 gesetzt. Falls nach Osten
// gesendet wird, wird das Bit 2 gesetzt. sow hat somit einen Zulssigkeitsbereicht von 0 bis 3.
// 0: Kein Senden
// 1: Senden nur nach Westen
// 2: Senden nur nach Osten
// 3: Senden nach Westen und Osten
int Nachkorrektur::sende_ost_west(bool senden_west, bool senden_ost)
// Wofr genau ist diese Variable sow da? Wo wird sie verwendet?
// Es wird zurueckgegeben, wieviel Mal(!) gesendet wird.
// Es wird erfasst, inwieweit nach Westen bzw. Osten gesendet bzw. von dort empfangen wird.
// Die Idee:    Man gibt diese Variable per Kommunikation weiter, und der Empfnger kennt
//              die Kommunikations - Situation des Senders.

//  Im Falle von EV2 hat man das Problem, dass man auch senden_west_oben und senden_ost_oben als Flle hat.
//  Und das msste schon beim Lasttransfer erfasst werden.
//  Wo wird diese Funktion aufgerufen? In der Funktion 'logisch'.
    {
    int return_wert;

    if(senden_west==true)
        {
        return_wert = 1;
        }
    else
        {
        return_wert = 0;
        }
    if(senden_ost==true)
        {
        return_wert = return_wert + 2;
        }
    return(return_wert);
    }

// Kommentar: Analog zu sende_ost_west. Nur eben fr den Nord - Sd - Lastausgleich.
int Nachkorrektur::sende_nord_sued(bool senden_nord, bool senden_sued)
// Wofr genau ist diese Variable sow da? Wo wird sie verwendet?
// Es wird zurueckgegeben, wieviel Mal(!) gesendet wird.
// Es wird erfasst, inwieweit nach Westen bzw. Osten gesendet bzw. von dort empfangen wird.
// Die Idee:    Man gibt diese Variable per Kommunikation weiter, und der Empfnger kennt
//              die Kommunikations - Situation des Senders.

//  Im Falle von EV2 hat man das Problem, dass man auch senden_west_oben und senden_ost_oben als Flle hat.
//  Und das msste schon beim Lasttransfer erfasst werden.
//  Wo wird diese Funktion aufgerufen? In der Funktion 'logisch'.
    {
    int return_wert;

    if(senden_nord==true)
        {
        return_wert = 1;
        }
    else
        {
        return_wert = 0;
        }
    if(senden_sued==true)
        {
        return_wert = return_wert + 2;
        }
    return(return_wert);
    }

// Kommentar: Diese Funktion bernimmt das Packen der Zwischenkorrekturinformationen. Sie wird aufgerufen von der Funktion
// logisch_sammeln, die auch noch die Kommunikation bernimmt (senden, empfangen). Diese Funktion logisch hat die Information,
// ob nach westen oder osten Last versendet wird.
void Nachkorrektur::logisch(void)
// Was macht diese Funktion? Man sammelt Punkte, die am Rand liegen und verschickt werden, also beides gleichzeitig sind,
// und schickt sie dann an den Prozessor mit dem Farbenfeld des anderen Ranges.
// Frage: geht auch beides? Ja! Aber was ist mit Nachkorrektur fr die Kommunikation oben. Da geht es um senden und empfangen.
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Vor sow rang " << rang << endl;
#endif

// Kommentar: Zuerst wird sow berechnet, vgl. den Anfangskommentar der Funktion sende_ost_west.
    sow = sende_ost_west(sende_west, sende_ost);

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "sow " << sow << " // rang " << rang << endl;
#endif

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Vor vorbereiten rang " << rang << endl;
#endif

// Kommentar: Dann werden dementsprechend die Buffer vorbereitet, die zu den gem der Kerntopologie benachbarten Kernen
// verschickt werden.
    vorbereiten();

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Nach vorbereiten rang " << rang << endl;
#endif

// Kommentar: Wenn nach Westen gesammelt wird.
    if(sende_west==true)
        {
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "Vor sammeln west rang " << rang << endl;
#endif
// Kommentar: Bestimme die ID des sich bzgl. der Lastausgleichskerntopologie im Westen befindenden Kernes.
        zielfarbe = farbmatrix_westen[rang];
// Kommentar: Und sammele die Multi - Level - Informationen fr den Westen basierend auf den Informationen von mv_west,
// wobei der Buffer, in den geschrieben wird, so organisiert ist: Fr jede Gitterebene wird gespeichert, und dann wird
// der Index, unter dem die Anzahl verschickter Punkte gespeichert wird, hochgezhlt. Deswegen kann sammeln(mv_ost)
// direkt nach sammeln(mv_west) erfolgen, weil dieser Index, der angibt, wohin fr eine Ebene die Zwischenkorrekturinformation
// gesammelt werden, hochzhlt. Dieser Index hat die Bezeichnung index_anzahlen.
        sammeln(mv_west);
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "Nach sammeln west rang " << rang << endl;
#endif
        }
//  Muss dazwischen nicht etwas gesetzt werden? Das erfolgt in nkk.nachbereitung. Es wird dabei index_anzahlen
//  inkrementiert.

// Kommentar: Jetzt geschieht dasselbe, nur fr den Osten. Da das analog erfolgt, ist eine zustzliche Kommentierung nicht erforderlich.
    if(sende_ost==true)
        {
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "Vor sammeln ost rang " << rang << endl;
#endif
        zielfarbe = farbmatrix_osten[rang];
#ifdef AKTUELLE_KOMMENTARE
        if(rang==1)
            {
            cout << " Zielfarbe - Ost " << zielfarbe << endl;
            }
#endif
        sammeln(mv_ost);
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "Nach sammeln ost rang " << rang << endl;
#endif
        }
    }

// Kommentar: Analog zu logisch. Nur eben fr den Nord - Sd - Lastausgleich.
void Nachkorrektur::logisch_ns(void)
// Was macht diese Funktion? Man sammelt Punkte, die am Rand liegen und verschickt werden, also beides gleichzeitig sind,
// und schickt sie dann an den Prozessor mit dem Farbenfeld des anderen Ranges.
// Frage: geht auch beides? Ja! Aber was ist mit Nachkorrektur fr die Kommunikation oben. Da geht es um senden und empfangen.
    {
#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << " Vor sns rang " << rang << " sende_nord " << sende_nord << " sende_sued " << sende_sued << endl;
#endif

    sns = sende_nord_sued(sende_nord, sende_sued);

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << " sns " << sns << " // rang " << rang << endl;
#endif

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << "Vor vorbereiten rang " << rang << endl;
#endif

    vorbereiten_ns();

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << "Nach vorbereiten rang " << rang << endl;
#endif

    if(sende_nord==true)
        {
#ifdef AUSGABEN_NACHKORREKTUR_NEUER
        cout << "Vor sammeln_ns west rang " << rang << endl;
#endif
        zielfarbe = farbmatrix_norden[rang];
        sammeln_ns(mv_nord);
#ifdef AUSGABEN_NACHKORREKTUR_NEUER
        cout << "Nach sammeln_ns west rang " << rang << endl;
#endif
        }
//  Muss dazwischen nicht etwas gesetzt werden? Das erfolgt in nkk.nachbereitung. Es wird dabei index_anzahlen
//  inkrementiert.
    if(sende_sued==true)
        {
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "Vor sammeln ost rang " << rang << endl;
#endif
        zielfarbe = farbmatrix_sueden[rang];
        sammeln_ns(mv_sued);
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "Nach sammeln ost rang " << rang << endl;
#endif
        }
    }

// Kommentar: Hier wird fr eine Himmelsrichtung und fr alle Ebenen die Zwischenkorrekturinformation gesammelt.
// Das basiert auf der Information von _mv, die verzeichnet, welche Gitterpunkte nach der Himmelsrichtung verschickt werden.
void Nachkorrektur::sammeln(MV_vertikal * _mv)
// Bemerkung: sammeln geht immer zu allen Nachbarprozessoren. nachbereitung enthlt eine solche Schleife.
//
//  Hier werden aufgrund _mv Multivektoren die Buffer fr die nkk geschrieben.
    {
// Kommentar: Zuerst wird der bergabezeiger auf mv gespeichert.
    mv = _mv;
// Kommentar: Dann werden alle Gitterebenen durchlaufen. Bei einer Kappe bruchte eigentlich nur bis einschlielich der Kappe
// gepackt werden.
    for(h=0; h<h_gesamt; h++)
        {
// Kommentar: Farbenfeld und Selbstnachbarn werden fr die ausgewhlte Ebene in den Zeigern farbenfeld und selbstnachbarn gespeichert.
        farbenfeld = farbenfelder[h];
        selbstnachbarn = selbstnachbaren[h];
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "sammeln 1 rang " << rang << " Ebene " << h << endl;
#endif
// Kommentar: Nun werden die Zwischenkorrekturinformationen fr diese Ebene gesammelt, und im Nachkorrektur -
// Kommunikationsbuffer gespeichert.
        sammeln_eine_ebene(h);
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "sammeln 2 rang " << rang << " Ebene " << h << endl;
#endif
        // Bei sammeln eine Ebene muss der Index stimmen. Wo wird der Index gesetzt? Ist er anfnglich 0?
// Kommentar: Die Anzahl an bermittelten Punkten wird gespeichert, und der Index auf diesen Speicherbereich
// des Buffers - index_anzahlen - wird inkrementiert.
        nachbereitung();
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "sammeln 3 rang " << rang << " Ebene " << h << endl;
#endif
        // Hier muss doch beruecksichtigt werden, ob schon das zweite Mal gesammelt wurde. In
        // 'nachbereitung' wird das irgendwie nicht bercksichtigt.
        }
    }

// Kommentar: Analog zu sammeln. Nur eben fr den Nord - Sd - Lastausgleich.
void Nachkorrektur::sammeln_ns(MV_horizontal * _mh)
// Bemerkung: sammeln geht immer zu allen Nachbarprozessoren. nachbereitung enthlt eine solche Schleife.
//
//  Hier werden aufgrund _mv Multivektoren die Buffer fr die nkk geschrieben.
    {
    mh = _mh;
    for(h=0; h<h_gesamt; h++)
        {
        farbenfeld = farbenfelder[h];
        selbstnachbarn = selbstnachbaren[h];
#ifdef AUSGABEN_NACHKORREKTUR_NEUER
        cout << "sammeln_ns 1 rang " << rang << " Ebene " << h << endl;
#endif
        sammeln_eine_ebene_ns(h);
#ifdef AUSGABEN_NACHKORREKTUR_NEUER
        cout << "sammeln_ns 2 rang " << rang << " Ebene " << h << endl;
#endif
        // Bei sammeln eine Ebene muss der Index stimmen. Wo wird der Index gesetzt? Ist er anfnglich 0?
        nachbereitung();
#ifdef AUSGABEN_NACHKORREKTUR_NEUER
        cout << "sammeln_ns 3 rang " << rang << " Ebene " << h << endl;
#endif
        // Hier muss doch beruecksichtigt werden, ob schon das zweite Mal gesammelt wurde. In
        // 'nachbereitung' wird das irgendwie nicht bercksichtigt.
        }
    }

// Kommentar: Hier werden die Zwischenkorrekturinformationen fr eine Ebene gesammelt.
void Nachkorrektur::sammeln_eine_ebene(int h)
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "sammeln_eine_ebene 1 rang " << rang << " Ebene " << h << endl;
#endif

// Kommentar: Zuerst werden die Vektorinformationen des Sendens fr diese Gitterebene beschafft.
    f1 = mv->f1_speichern[h];
    f2 = mv->f2_speichern[h];
    g = mv -> g_speichern[h];
    index = mv -> indizes[h];

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "sammeln_eine_ebene 2 rang " << rang << " index " << index << " Ebene " << h << endl;
#endif

// Kommentar: Dann werden die Vektoren durchlaufen.
    for(i=0; i<index; i++)
        {
        vvektor_f1 = f1[i];
        vvektor_f2 = f2[i];
        vvektor_g = g[i];

#ifdef AKTUELLE_KOMMENTARE
        if((rang==1)&&(h==0)&&(zielfarbe==2))
            {
            cout << " sammeln eine ebene: f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
            }
#endif

#ifdef AUSGABEN_NACHKORREKTUR
        cout << "(" << vvektor_f1 << "," << vvektor_f2 << "," << vvektor_g << ")";
#endif

// Kommentar: Und dann werden die Gitterpunkte fr diesen Vektor durchlaufen.
        for(k=vvektor_f1; k<=vvektor_f2; k++)
            {
// Kommentar: Und dann werden die Zwischenkorrekturinformationen fr einen dieser Punkte bestimmt.
            fuer_einen_punkt_bestimmen(k,vvektor_g);
            }
        }
#ifdef AUSGABEN_NACHKORREKTUR
    cout << endl;
    cout << "sammeln_eine_ebene 3 rang " << rang << " Ebene " << h << endl;
#endif
    }

// Kommentar: Analog zu sammeln_eine_ebene. Nur eben fr den Nord - Sd - Lastausgleich.
void Nachkorrektur::sammeln_eine_ebene_ns(int h)
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "sammeln_eine_ebene 1 rang " << rang << " Ebene " << h << endl;
#endif
    g1 = mh->g1_speichern[h];
    g2 = mh->g2_speichern[h];
    f = mh -> f_speichern[h];
    index = mh -> indizes[h];

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "sammeln_eine_ebene 2 rang " << rang << " index " << index << " Ebene " << h << endl;
#endif

    for(i=0; i<index; i++)
        {
        hvektor_g1 = g1[i];
        hvektor_g2 = g2[i];
        hvektor_f = f[i];

#ifdef AUSGABEN_NACHKORREKTUR
        cout << "(" << hvektor_f << "," << hvektor_g1 << "," << hvektor_g2 << ")";
#endif

        for(k=hvektor_g1; k<=hvektor_g2; k++)
            {
#ifdef AKTUELLE_KOMMENTARE
            if((rang==1)&&(hvektor_f==3)&&(k==5))
                {
                cout << " MMNNOO sammeln_eine_ebene h " << h << endl;
                }
#endif
            fuer_einen_punkt_bestimmen(hvektor_f, k);
            }
        }
#ifdef AUSGABEN_NACHKORREKTUR
    cout << endl;
    cout << "sammeln_eine_ebene 3 rang " << rang << " Ebene " << h << endl;
#endif
    }

// Kommentar: Hier erfolgt die Nachbereitung der ermittelten und gepackten Zwischenkorrekturinformationen.
void Nachkorrektur::nachbereitung(void)
    {
// Kommentar: Es wird zu allen punktbenachbarten Kernen  die Nachbereitung durchgefhrt.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
// Kommentar: Diese nachkorrektur_kommunikation existiert zu allen anderen Kernen, wird aber nur fr die
// punktbenachbarten Kerne hier durchgefhrt.
                nachkorrektur_kommunikation[i].nachbereitung();
                }
            }
        }
    }

// Kommentar: Das ist die zentrale Funktion, die die Zwischenkorrekturinformationen packt, und deren Kommunikation
// initiiert. Sie wird ergnzt durch die Funktion logisch_entpacken, bei der die hier erzeugten
// Informationen entpackt werden.
void Nachkorrektur::logisch_sammeln(void)
    {
// Warum senden und empfangen? Schliesslich ist es doch so, dass ggf. nur gesendet und nur
// empfangen wird. Gute Frage!
// Die Idee hierbei: Man kann es bei einem benachbarten Prozessor nicht wissen, ob der nur sendet
// oder nur empfngt, oder beides macht. Deswegen muss beides kommuniziert werden, weil beides
// zutreffen kann.
#ifdef AUSGABEN_NACHKORREKTUR_NEU
    ausgabe_nachbarn();
#endif

// Kommentar: Es wird eine Schleife zu allen Kernen durchlaufen.
    for(i=0; i<groesse; i++)
        {

// Kommentar: Dann wird die Punktnachbarschaftskerntopologie in die variable noch_zu_entpacken kopiert, die hier verwendet wird.
        noch_zu_entpacken[i] = ist_nachbar_zaehler_ml[i];
#ifdef AUSGABEN_NACHKORREKTUR
        cout << " logisch_sammeln rang " << rang << " i " << i << " noch_zu_entpacken " << noch_zu_entpacken[i] << endl;
#endif
        }

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Vor logisch rang " << rang << endl;
#endif

// Kommentar: Die Zwischenkorrekturinformationen werden gepackt.
    logisch();

//  Vielleicht logisch umbenennen. Was ist hier logisch?

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Nach logisch rang " << rang << endl;
#endif

// Kommentar: Und Senden und Empfangen werden initiiert.
    senden();

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Nach senden rang " << rang << endl;
#endif

    empfangen();

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Nach empfangen rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu logisch_sammeln. Nur eben fr den Nord - Sd - Lastausgleich.
void Nachkorrektur::logisch_sammeln_ns(void)
    {
// Warum senden und empfangen? Schliesslich ist es doch so, dass ggf. nur gesendet und nur
// empfangen wird. Gute Frage!
// Die Idee hierbei: Man kann es bei einem benachbarten Prozessor nicht wissen, ob der nur sendet
// oder nur empfngt, oder beides macht. Deswegen muss beides kommuniziert werden, weil beides
// zutreffen kann.

    for(i=0; i<groesse; i++)
        {
        noch_zu_entpacken[i] = ist_nachbar_zaehler_ml[i];
        }

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << "Vor logisch_ns rang " << rang << endl;
#endif

    logisch_ns();

//  Vielleicht logisch umbenennen. Was ist hier logisch?

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << "Nach logisch_ns rang " << rang << endl;
#endif

    senden();

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << "Nach senden rang " << rang << endl;
#endif

    empfangen();

#ifdef AUSGABEN_NACHKORREKTUR_NEUER
    cout << "Nach empfangen rang " << rang << endl;
#endif
    }

// Kommentar: 'logisch_entpacken' schaut nach, ob Zwischenkorrektur - Kommunikationen angekommen sind, und entpackt diese Informationen.
// Wenn alle Informationen bearbeitet wird, wird true zurckgegeben. Ist noch Arbeit briggeblieben, wird false zurckgegeben.
bool Nachkorrektur::logisch_entpacken(void)
// Hier wird auf Kommunikation getestet. Von welcher Kommunikation? Wo wird diese Kommunikation initiiert?
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << " Code 5: rang " << rang;
    for(i=0; i<groesse; i++)
        {
        cout << " noch zu entpacken (" << i << ") " << noch_zu_entpacken[i];
        }
    cout << endl;
#endif
// Kommentar: Die Rckgabevariable rueckwert wird auf true gesetzt.
    rueckwert = true;
// Kommentar: Es wird alles durchlaufen, was es an Punktnachbarkernen gibt, fr die noch nicht entpackt worden ist.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(noch_zu_entpacken[i] > 0)
                {
// Kommentar: Ist dafr die Nachricht angekommen.
                if((nachkorrektur_kommunikation[i]).test_empfangen()==true)
                    {
#ifdef AUSGABEN_NACHKORREKTUR
                    cout << "NK0 " << nachkorrektur_kommunikation[i].empfangsbuffer[0] << endl;
#endif
                    // Dieses ist vor(!) dem Entpacken und damit unabhngig von dem setzen
                    // des anfnglichen Indexes fr das Entpacken!
                    timer_la_nk_entpacken.starten();
// Kommentar: Dann entpacke die Nachricht zum Kern i, und nehme die ID des Kerns aus der Liste der Kerne mit noch zu entpackenden
// Zwischenkorrekturinformation heraus.
#ifdef AUSGABEN_NACHKORREKTUR
                    cout << " !LA6a - logisch entpacken vor entpacken(" << i << ") rang " << rang << endl;
#endif
                    entpacken(i);
#ifdef AUSGABEN_NACHKORREKTUR
                    cout << " !LA6a - logisch entpacken nach entpacken(" << i << ")" << endl;
#endif
                    timer_la_nk_entpacken.stoppen();
#ifdef AUSGABEN_NACHKORREKTUR
                    ausgeben_nk_farbenfeld();
#endif
                    noch_zu_entpacken[i]=false;
                    log_ent_tv.ankunft(i);
#ifdef AUSGABEN_NACHKORREKTUR
                    cout << "Wurde entpackt i " << i << " // rang " << rang << endl;
#endif
                    }
// Kommentar: Ist die Nachricht zu dem noch auspacken mssenden Kern nicht vorhanden, markiere den Rckwert auf false -
// die gesamte Zwischenkorrekturinformation ist dann noch nicht beendet.
                else
                    {
                    rueckwert = false;
                    }
                }
            }
        }
#ifdef AUSGABEN_TIMER_VEKTOR
    if(rueckwert==true)
        {
        log_ent_tv.ausgabe();
        }
#endif
    return(rueckwert);
    }

// Kommentar: Analog zu logisch_entpacken. Nur eben fr den Nord - Sd - Lastausgleich.
bool Nachkorrektur::logisch_entpacken_ns(void)
// Hier wird auf Kommunikation getestet. Von welcher Kommunikation? Wo wird diese Kommunikation initiiert?
    {
    rueckwert = true;
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(noch_zu_entpacken[i] > 0)
                {
                if((nachkorrektur_kommunikation[i]).test_empfangen()==true)
                    {
#ifdef AUSGABEN_NACHKORREKTUR
                    cout << "NK0 " << nachkorrektur_kommunikation[i].empfangsbuffer[0] << endl;
#endif
                    // Dieses ist vor(!) dem Entpacken und damit unabhngig von dem setzen
                    // des anfnglichen Indexes fr das Entpacken!
                    timer_la_nk_entpacken.starten();
                    entpacken_ns(i);
                    timer_la_nk_entpacken.stoppen();
#ifdef AUSGABEN_NACHKORREKTUR
                    ausgeben_nk_farbenfeld();
#endif
                    noch_zu_entpacken[i]=false;
                    log_ent_tv.ankunft(i);
#ifdef AUSGABEN_NACHKORREKTUR
                    cout << "Wurde entpackt i " << i << " // rang " << rang << endl;
#endif
                    }
                else
                    {
                    rueckwert = false;
                    }
                }
            }
        }
#ifdef AUSGABEN_TIMER_VEKTOR
    if(rueckwert==true)
        {
        log_ent_tv.ausgabe();
        }
#endif
    return(rueckwert);
    }

// Kommentar: Hier wird die Nachricht vom Kern mit der ID 'lokaler_rang' verarbeitet. Das sie angekommen ist, ist gewhrleistet.
void Nachkorrektur::entpacken(int lokaler_rang)
    {
// Kommentar: Der Empfangsbuffer der Nchricht wird auf den Zeiger empfangsbuffer kopiert - damit der entpackt werden kann.
    empfangsbuffer = nachkorrektur_kommunikation[lokaler_rang].empfangsbuffer; // Wichtig: Nur so stimmt das Entpacken
// Kommentar: Es wird erkannt, zu welchem Kern - nach Ost und / oder West, oder gar nicht - er sendet.
    sow = empfangsbuffer[0];

#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Entpacken sow " << sow << " // rang " << rang << endl;
#endif

// Wir haben zwei Indizes im Folgenden: Den auf die Informationen, wieviel Punkte verzeichnet sind - das ist der Zeiger in den
// header, oder pih. Und dann den Zeiger auf die aktuelle Bufferposition, dass ist der pib.
    pih = 1; // p = position_in_header, pib = position_in_buffer

// Kommentar: Je nach sow werden verschiedene Aktionen durchgefhrt:
    switch(sow)
        {
// Kommentar: sow = 0: Dann ist nichts zu tun.
        case 0:
            break;
// Kommentar: sow = 1: Dann entpackt der Kern der ID lokaler_rang nach Westen. Der Buffer beginnt bei 1 + h_gesamt, und der
// Kern lokaler Rang hat den Empfnger farbmatrix_westen[lokaler_rang].
        case 1:
            pib = 1 + h_gesamt;
            entpacken_inneres(farbmatrix_westen[lokaler_rang]);
            break;
        case 2:
// Kommentar: sow = 2: Dann entpackt der Kern der ID lokaler_rang nach Westen. Der Buffer beginnt bei 1 + h_gesamt, und der
// Kern lokaler Rang hat den Empfnger farbmatrix_osten[lokaler_rang]. Unter dieser ID werden die Punkte dann ins Farbenfeld
// entpackt.
            pib = 1 + h_gesamt;
            entpacken_inneres(farbmatrix_osten[lokaler_rang]);
            break;
        case 3:
// Kommentar: sow = 3: Dann entpackt der Kern der ID lokaler_rang nach Westen und Osten. Der Buffer beginnt bei 1 + 2*h_gesamt
// (Es werden die sow Information und 2 Header - Informationen bentigt.), und das Entpacken geschieht erst nach Westen mit den
// Farbwerten farbmatrix_westen[lokaler_rang], und dann nach Osten mit den Farbwerten farbmatrix_osten[lokaler_rang].
// Wichtig ist hierbei, dass dieselbe Reihenfolge wie beim Packen eingehalten wird, dass nmlich erst nach Westen, und
// dann nach Osten entpackt wird.
            pib = 1 + h_gesamt + h_gesamt;
            entpacken_inneres(farbmatrix_westen[lokaler_rang]);
            entpacken_inneres(farbmatrix_osten[lokaler_rang]);
            break;
        default:
            cout << "Fehler in Nachkorrektur::entpacken // sow " << sow << " // rang " << rang << endl;
            exit(-1);
        }
    }

// Kommentar: Analog zu entpacken. Nur eben fr den Nord - Sd - Lastausgleich.
void Nachkorrektur::entpacken_ns(int lokaler_rang)
    {
    empfangsbuffer = nachkorrektur_kommunikation[i].empfangsbuffer; // Wichtig: Nur so stimmt das Entpacken
    sns = empfangsbuffer[0];
#ifdef AUSGABEN_NACHKORREKTUR
    cout << " Entpacken sns " << sns << " // rang " << rang << " lokaler_rang " << lokaler_rang << endl;
#endif

    pih = 1; // p = position_in_header, pib = position_in_buffer
    switch(sns)
        {
        case 0:
            break;
        case 1:
            pib = 1 + h_gesamt;
            entpacken_inneres(farbmatrix_norden[lokaler_rang]);
            break;
        case 2:
            pib = 1 + h_gesamt;
            entpacken_inneres(farbmatrix_sueden[lokaler_rang]);
            break;
        case 3:
            pib = 1 + h_gesamt + h_gesamt;
            entpacken_inneres(farbmatrix_norden[lokaler_rang]);
            entpacken_inneres(farbmatrix_sueden[lokaler_rang]);
            break;
        default:
            cout << "Fehler in Nachkorrektur::entpacken // sns " << sns << " // rang " << rang << endl;
            exit(-1);
        }
    }

// Kommentar: Dieser Test testet, ob eine irrgulre Kern - ID vorliegt.
void Nachkorrektur::test(int farbe)
    {
    if(farbe==-1)
        {
        cout << " Fehler in Nachkorrektur::test: Test ist falsch. Sollte unmglich sein. rang " << rang << endl;
        exit(-1);
        }
    }

// Kommentar: Hier wird nk_farbenfelder ausgegeben. Die Struktur wird wohl nicht gebraucht.
void Nachkorrektur::ausgeben_nk_farbenfeld(void)
    {
#ifdef NK_FARBENFELDER
    warten();
    m_hilfe = m;
    n_hilfe = n;
#ifdef AUSGABEN_NACHKORREKTUR
    cout << endl << "NK_Farbenfelder // rang " << rang << endl;

    for(h=0; h<h_gesamt; h++)
        {
        cout << " h: " << h << "   ";
        for(j=0; j<n_hilfe; j++)
            {
            for(k=0; k<m_hilfe; k++)
                {
                cout << nk_farbenfelder[h][j][k] << " ";
                }
            cout << endl;
            }

        n_hilfe = (n_hilfe+1)/2;
        m_hilfe = (m_hilfe+1)/2;
        }
#endif
#endif
    }

// Kommentar: Jetzt wird der Buffer entpackt. Im Wesentlichen passiert nichts anderes, als dass auf den Positionen, die aus dem
// Buffer entpackt werden, die bergebene Farbe ins Farbenfeld geschrieben wird.
// Bemerkung: Man braucht keine Funktion entpacken_inneres_ns, weil in dem Fall diese Funktion genommen werden kann, weil nur
// die Zielfarbe im Nord - Sd - Fall eine andere ist. Die Methode ist diesselbe.
void Nachkorrektur::entpacken_inneres(int farbe) // Woher die Farbe kommt? Direkt von PT, und der Buffer kommt auch von PT.
// Was genau macht diese Funktion? Wird das nk_farbenfeld geschrieben?
// Aber wenn auch: Dann wird auch ins Farbenfeld geschrieben! Es sieht so aus, dass das hier passiert.
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "In entpacken_inneres " << endl;
#endif

// Kommentar: Wenn die bergebene Farbe unzulssig ist => Fehlermeldung.
    test(farbe);

// Kommentar: Man durchluft die Gitterebenen.
    for(h=0; h<h_gesamt; h++)
        {
//      anzahlen = empfangsbuffer[pih];

// Kommentar: Man liest im Header nach, wieviele Buffereintrge auf der aktuellen Ebene da sind.
        anzahlen = empfangsbuffer[pih++];
// Was ist pih? Position in header. Aber unabhngig von h.
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "NK_Anzahlen in entpacken inneres " << anzahlen << " // rang " << rang << " h " << h << endl;
#endif

// Kommentar: Das Farbenfeld der Gitterebene wird auf den Zeiger farbenfeld verknpft => Zugriff auf das Farbenfeld dieser Ebene.
        farbenfeld = farbenfelder[h];
// Kommentar: Das nk_farbenfeld wird nicht mehr gebraucht.
#ifdef NK_FARBENFELDER
        nk_farbenfeld = nk_farbenfelder[h];
#endif

// Kommentar: Der Buffer wird soweit durchlaufen, wie es 'anzahlen' viele Punktkoordinaten im Buffer gibt.
        for(j=0; j<anzahlen; j++)
            {
// Kommentar: Ein Punkt wird aus dem Buffer gelesen, und der Bufferindex entsprechend erhht.
            ff = empfangsbuffer[pib];
            // empfangsbuffer, oder empfangsbuffer[farbe]; in der Header - Datei: int * empfangsbuffer;
            // In entpacken: empfangsbuffer = nachkorrektur_kommunikation[i].empfangsbuffer
            // Daher ist das hier korrekt.
            pib ++;
            gg = empfangsbuffer[pib];
            pib ++;
#ifdef AKTUELLE_KOMMENTARE
            if((i==1)&&(farbe==2))
                {
                cout << " entpacken_inneres EI " << " ff " << ff  << " gg " << gg << " rang " << rang << endl;
                }

            if((ff==14)&&(gg==24))
                {
                cout << " entpacken_inneres EI " << " i " << i << " farbe " << farbe << " rang " << rang << endl;
                }
#endif
#ifdef AUSGABEN_NACHKORREKTUR
            cout << " ff " << ff  << " gg " << gg << endl;
#endif

// Kommentar: Schreibe die bergebene Farbe - das ist die ID des Empfngers der Punkte - ins Farbenfeld an die Stelle des Punktes.
            farbenfeld[ff][gg] = farbe;
// Kommentar: Das Schreiben ins berflssige nk_farbenfeld kann entfallen.
#ifdef NK_FARBENFELDER
            nk_farbenfeld[ff][gg] = farbe; // Braucht man wohl nicht!
#endif
            }
        }
    }

// Kommentar: Hier geschieht keine Ausgabe mehr, weil buffer_ausgeben in nachkorrektur_kommunikation praktisch leer ist.
void Nachkorrektur::buffer_ausgeben(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
                nachkorrektur_kommunikation[i].buffer_ausgeben();
                }
            }
        }
    }

// Kommentar: Diese Funktion initiiert das Empfangen der Zwischenkorrekturinformationen.
void Nachkorrektur::empfangen(void)
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Ist Nachbar in Nachkorrektur: // rang " << rang << endl;
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            cout << ist_nachbar_zaehler_ml[i] << " ";
            }
        }
    cout << endl;
#endif

// Kommentar: Zu den bzgl. der Punktnachbarschaftskerntopologie benachbarten Kernen wird die Funktion 'empfangen' der Klasse
// nachkorrektur_kommunikation aufgerufen.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
#ifdef AUSGABEN_NACHKORREKTUR
                cout << "initiiere_empfangen i " << i << " // rang " << rang << endl;
#endif
                nachkorrektur_kommunikation[i].empfangen();
                }
            }
        }
    }

// Kommentar: Fr alle Punkte der Kerntopologie benachbarter Gitterpunkte wird der Sendebuffer auf 2 reduziert.
// Der Sendebufferindex gibt die Lnge des Sendebuffers an. Da dieser bei der Funktion vorbereiten in
// nachkorrektur_kommunikation den sendebuffer_index richtig setzt, ist diese Funktion eigentlich komplett
// berflssig.
void Nachkorrektur::sendebuffer_zuruecksetzen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
                nachkorrektur_kommunikation[i].sendebuffer_index = 2;
                }
            }
        }
    }

// Kommentar: Hier wird das Senden der Zwischenkorrekturinformationen initiert.
void Nachkorrektur::senden(void)
    {
// Kommentar: Zu allen punktbenachbarten Kernen wird die Funktion Senden der Klasse nachkorrektur_kommunikation aufgerufen.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
#ifdef AKTUELLE_KOMMENTARE
            if((rang==1)&&(i==2))
                {
                cout << " NK::senden inzaehler " << ist_nachbar_zaehler_ml[i] << endl;
                }
#endif
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
                nachkorrektur_kommunikation[i].senden();
                }
            }
        }

    }

// Kommentar: Hier wird getestet, ob die Nachrichten von allen punktbenachbarten Kernen angekommen sind.
// Sind sie alle angekommen, dann return true. Sonst return false.
bool Nachkorrektur::test_empfangen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
                if((ist_empfangen[i])==false)
                    {
                    return(false);
                    }
                }
            }
        }
    return(true);
    }

// Kommentar: Hier wird getestet, ob die Nachrichten von allen punktbenachbarten Kernen verschickt worden sind.
// Sind sie alle verschickt, dann return true. Sonst return false.
bool Nachkorrektur::test_senden(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(ist_nachbar_zaehler_ml[i] > 0)
                {
                if((nachkorrektur_kommunikation[i]).test_senden()==false)
                    {
                    return(false);
                    }
                }
            }
        }
    return(true);
    }

// Kommentar: Hier wird die Nachkorrektur finalisiert.
void Nachkorrektur::finalisieren_nk()
    {
// Kommentar: Der Speicherplatz des Timer - Vektors wird wieder freigegeben.
    log_ent_tv.finalisieren();

////////////////////////////////////////////////////////////////////

// Kommentar: Der Speicherplatz fr die Farbmatrix - speichern der ID's des stlichen, sdliche, westlichen und nrdlichen Kerns -
// wird freigegeben.
    farbmatrix.beenden();
// Kommentar: Hier wird der Speicherplatz von flags freigegeben, die festhalten, was empfangen wurde.
    delete ist_empfangen;
// Kommentar: Hier wird der Speicherplatz von flags freigegeben, die festhalten, was noch zu entpacken ist.
    delete noch_zu_entpacken;

// Kommentar: Freigeben des Speicherplatzes der Nachkorrektur - Kommunikationen - fr alle ID's.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            nachkorrektur_kommunikation[i].finalisieren_nkk();
            }
        }

    delete nachkorrektur_kommunikation;

    }

// Kommentar: Initialisieren der Nachkorrektur. Es werden Parameter und die Strukturen MV_vertikal bzw. MV_horizontal bergeben.
// Letztere geben an, welche Vektoren ein Kern verschickt hat.
void Nachkorrektur::initialisieren_nk(int _n, int _m, int _groesse, int _rang, int _h_gesamt, MV_vertikal * _mv_west, MV_vertikal * _mv_ost, MV_horizontal * _mv_nord, MV_horizontal * _mv_sued)
    {
// Kommentar: Die Hauptparameter werden gespeichert.
    groesse = _groesse;
    rang = _rang;
    n = _n;
    m = _m;

    h_gesamt = _h_gesamt;

// Kommentar: Die Nachkorrektur_Kommunikation wird zu allen Kernen angelegt.
    nachkorrektur_kommunikation = new NachkorrekturKommunikation[groesse];
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Nachkorrektur Kommunikation Groesse " << groesse << " Rang " << rang << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            nachkorrektur_kommunikation[i].initialisieren_nkk(n, m, i, h_gesamt, rang);
            }
// Der Eigenrang in initialisieren_nkk ist gleich der Prozessor_ID.
// Das stimmt mit der Liste_Invers nicht ueberein.
        }

// Kommentar: Die Flags ist_empfangen und noch_zu_entpacken (Erklrung beim Finalisieren) werden angelegt.
    ist_empfangen = new int [groesse];
    noch_zu_entpacken = new int [groesse];

    mv_west = _mv_west;
    mv_ost = _mv_ost;
    mv_nord = _mv_nord;
    mv_sued = _mv_sued;

// Kommentar: Die Farbmatrix wird angelegt, also auch mit Speicherplatz versorgt.
    farbmatrix.starten(groesse);
    farbmatrix_westen = farbmatrix.west;
    farbmatrix_osten = farbmatrix.ost;
    farbmatrix_norden = farbmatrix.nord;
    farbmatrix_sueden = farbmatrix.sued;

// Kommentar: Ein Timer wird initialisiert.
    log_ent_tv.initialisieren(groesse, rang);
    }

// Kommentar: Hier werden die Koordinaten eines Punktes in die Klasse nachkorrektur_kommunikation eingetragen. Dabei
// gibt der bergabeparameter an, in welche dieser Klassen der Punkt eingefgt wird.
void Nachkorrektur::einfuegen(int f, int g, int farbenfeld_wert)
    {
// Bisheriger Fehler: Der Addressat stimmt noch nicht.
// Das ist der, der die Information bekommt.
// Die Information muss eigentlich weitergeleitet werden. Brauche ich dafr eine
// zustzliche Kommunikation?
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "Nachkorrektur einfuegen f " << f << " g " << g << " farbenfeld " << farbenfeld_wert << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    if((h == 3)&&(f == 1)&&(g == 2))
        {
        cout << " Nachkorrektur einfuegen rang " << rang << " ebene " << h << " f " << f << " g " << g << " farbenfeld " << farbenfeld_wert << endl;
        }
    if((h == 0)&&(f==14)&&(g==24))
        {
        cout << " Nachkorrektur einfuegen Ne rang " << rang << " ebene " << h << " f " << f << " g " << g << " farbenfeld " << farbenfeld_wert << " Zielfarbe " << zielfarbe << endl;
        }
    if((h==2)&&(f==4)&&(g==6))
        {
        cout << " Code 102: Nachkorrektur rang " << rang << " ebene " << h << " f " << f << " g " << g << " farbenfeld " << farbenfeld_wert << " Zielfarbe " << zielfarbe << " noch_zu entpacken " << noch_zu_entpacken[farbenfeld_wert] << " ist_nachbar_zaehler_ml " << ist_nachbar_zaehler_ml[farbenfeld_wert] << endl;
        }
#endif

// Kommentar: Ein negativer Farbwert, oder der eigene Farbwert fhren zu keiner Kommunikation.
    if(farbenfeld_wert<0)
        {
        return;
        }
    if(farbenfeld_wert==rang)
        {
        return;
        }
//    if(farbenfeld_wert!=zielfarbe)
// Kommentar: 14.10.15: Diese Zeile muss raus. Wenn man vorher die Nachbarschaft 4 5 hat, und 4->5 und 5->6, so ist auf Kern 4 die Zielfarbe 5 (4->5), und der farbenfeld_wert 5 wegen
// der Nachbarschaft 4 5. Aber: 6 muss informiert werden, dass neben ihm eine 5 steht. Also muss auf Kern 5 die Nachbarschaft 5 sein, bevor er an 6 schickt. Also kann man nicht
// warten, bis diese Information von Kern 4 mit normalem Packen und Entpacken ankommt.
// Der Zielpunkt hat diese Information schon. Ohne das wre der Buffer zu lange.
// Aber: auch nicht doppelt eintragen. Dafr 'sorgt' die Klasse nachkorrektur_kommunikation.
// Aber: Wie kommt man an die 'richtige' Zielfarbe? Sie wird in farb_sendebuffer_bestimmen
// uebergeben.
// Bei der neuen Variante: Da gibt es keinen Aufruf von farb_sendebuffer_bestimmen.
// Da wird gleich in sammeln_eine_ebene fuer_einen_punkt_bestimmen aufgerufen. Damit
// habe ich keine Zielfarbe gesetzt!.

// Bemerkung: Diese Abfrage farbenfeld_wert!=zielfarbe macht den Buffer krzer. Aber dann muss diese
// Information (f,g,h) direkt eingefgt werden. Wenn sie fehlt, gibt es eine Fehlermeldung.
// Problem: Diese Information wird schon gebraucht, bevor die Nachricht abgeschickt wird.
// Also: Bei Gleichheit wird diese Information auch ankommen, aber der Zielfarbeprozessor packt vorher(!)
// seine falschen Farben und bermittelt sie, bevor noch diese Information geschrieben wird.
// Einen solchen Fall hatte ich. Deswegen diese if - Anweisung lschen.
// 19.9.15: Leider habe ich den genauen Fall ncht protokolliert. Kann das nicht prfen. Im Prinzip kann aber mit der if - Anweisung ein Fehler auftreten.
        {
        // nachkorrektur_kommunikation[farbenfeld_wert].einfuegen(f, g, h, zielfarbe);

// Kommentar: Die Gitterebene wird nur zu Debugging - Zwecken geschrieben.
#ifdef AKTUELLE_KOMMENTARE_NK
        nachkorrektur_kommunikation[farbenfeld_wert].gitterebene = h;
#endif
// Kommentar: Hier wird der Punkt in die richtige Instanz von nachkorrektur_kommunikation eingefgt.
// Mit dieser Zeile wird die gesamte Kommunikation der Zwischenkorrektur begrndet. Nur das wird bermittelt,
// und beim Empfang wieder in das richtige Farbenfeld geschrieben.
        nachkorrektur_kommunikation[farbenfeld_wert].einfuegen(f, g);
#ifdef AKTUELLE_KOMMENTARE
        if((rang==1)&&(farbenfeld_wert==4)&&(f==3)&&(g==5))
            {
            cout << " MMNNOO zwischenkorrektur h " << h << endl;
            }
        // nachkorrektur_kommunikation[liste_invers[farbenfeld_wert]].einfuegen(f, g, h, zielfarbe);
        // Dort wird doppeltes eintragen vermieden.
#ifdef AUSGABEN_NACHKORREKTUR
        cout << "nachkorrektur NK : " ; // << liste_invers[farbenfeld_wert];
        cout << " farbenfeld " << farbenfeld_wert;
        cout << " f ";
        // Was ist liste_invers[farbenfeld_wert] ?
        cout << f << " g " << g; // << " h " << h << " zielfarbe " << zielfarbe << " Rang " << rang << endl;
        cout << " rang " << rang << endl;
#endif
#endif
// Wie ist das Zusammenspiel von farbenfeld_wert, liste_invers[farbenfeld_wert],
// Zielfarbe und Rang? Der Prozessor mit der ID rang schickt Last an den Prozessor mit der
// ID zielfarbe, wobei der Prozessor mit dem  Farbenfeld darueber zu informieren ist.
        }
    }

// Kommentar: Die folgende Funktion wird nicht mehr verwendet.
#ifdef KURZ_FF
#ifdef KURZ_NK
void Nachkorrektur::farb_sendebuffer_bestimmen(short int ** _farbenfeld, int ** _selbstnachbarn,
                                                int short * _sendebuffer, int _zielfarbe, int _h)
#else
void Nachkorrektur::farb_sendebuffer_bestimmen(short int ** _farbenfeld, int ** _selbstnachbarn,
                                                int * _sendebuffer, int _zielfarbe, int _h)
#endif
#else
#ifdef KURZ_NK
void Nachkorrektur::farb_sendebuffer_bestimmen(int ** _farbenfeld, int ** _selbstnachbarn,
                                                int short * _sendebuffer, int _zielfarbe, int _h)
#else
void Nachkorrektur::farb_sendebuffer_bestimmen(int ** _farbenfeld, int ** _selbstnachbarn,
                                                int * _sendebuffer, int _zielfarbe, int _h)
#endif
#endif
    {
    farbenfeld = _farbenfeld;
    selbstnachbarn = _selbstnachbarn;
    sendebuffer = _sendebuffer;

    zielfarbe = _zielfarbe;

    h = _h;

    for(i=0; i<groesse; i++)
        {
        nachkorrektur_kommunikation[i].h_aktuell = h;
        }

    laenge = sendebuffer[0];
    for(i=0, j=1; i<laenge; i++)
        {
        vvektor_f1 = sendebuffer[j];
        j++;
        vvektor_f2 = sendebuffer[j];
        j++;
        vvektor_g = sendebuffer[j];
        j++;

        for(k=vvektor_f1; k<=vvektor_f2; k++)
            {
            fuer_einen_punkt_bestimmen(k,vvektor_g);
            // Die Vektoren sind die zu uebertragenden Punkte. Was genau macht 'fuer einen punkt bestimmen'?
            }
        }
    }

// Kommentar: Hiermit werden die Zwischenkorrekturinformationen ermittelt - fr einen Punkt. Es werden die Koordinaten eines
// Punktes bergeben.
void Nachkorrektur::fuer_einen_punkt_bestimmen(int f, int g)
    {
#ifdef AUSGABEN_NACHKORREKTUR
    cout << "FEPB .......... f " << f << " g " << g << " 255-s " << 255 - selbstnachbarn[f][g];
    cout << " zielfarbe " << zielfarbe << " ";
#endif
// Das ist nur die Menge der uebertragenen Punkte.
#ifdef AKTUELLE_KOMMENTARE
    if((rang==1)&&(f==3)&&(g==5))
        {
        cout << " MMNNOO fuer einen punkt bestimmen 255-snb " << 255 - selbstnachbarn[f][g] << endl;
        }
#endif

// Kommentar: Fr Nachbarpunkte von (f,g), die nicht auf dem eigenen Kern liegen, wird die obige Funktion einfgen aufgerufen.
// Damit werden die Nachbarpunkte des Verschickten auf anderen Kernen erkannt, und diesen das Verschicken von (f,g)
// mitgeteilt.
    switch(255-selbstnachbarn[f][g])
        {
        case 0:
            break;
        case 1:
            einfuegen_nord;
            break;
        case 2:
            einfuegen_nordost;
            break;
        case 3:
            einfuegen_nord;
            einfuegen_nordost;
            break;
        case 4:
            einfuegen_ost;
            break;
        case 5:
            einfuegen_nord;
            einfuegen_ost;
            break;
        case 6:
            einfuegen_nordost;
            einfuegen_ost;
            break;
        case 7:
            einfuegen_nord;
            einfuegen_nordost;
            einfuegen_ost;
            break;
        case 8:
            einfuegen_suedost;
            break;
        case 9:
            einfuegen_nord;
            einfuegen_suedost;
            break;
                case 10:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    break;
                case 11:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    break;
                case 12:
                    einfuegen_ost;
                    einfuegen_suedost;
                    break;
                case 13:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    break;
                case 14:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    break;
                case 15:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    break;
                case 16:
                    einfuegen_sued;
                    break;
                case 17:
                    einfuegen_nord;
                    einfuegen_sued;

                    break;
                case 18:
                    einfuegen_nordost;
                    einfuegen_sued;

                    break;
                case 19:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;

                    break;
                case 20:
                    einfuegen_ost;
                    einfuegen_sued;

                    break;
                case 21:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;

                    break;
                case 22:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;

                    break;
                case 23:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;

                    einfuegen_sued;

                    break;
                case 24:
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 25:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 26:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 27:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 28:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    break;
                case 29:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 30:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 31:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    break;
                case 32:
                    einfuegen_suedwest;
                    break;
                case 33:
                    einfuegen_nord;
                    einfuegen_suedwest;
                    break;
                case 34:
                    einfuegen_nordost;

                    einfuegen_suedwest;
                    break;
                case 35:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedwest;
                    break;
                case 36:
                    einfuegen_ost;
                    einfuegen_suedwest;
                    break;
                case 37:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    break;
                case 38:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    break;
                case 39:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    break;
                case 40:
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 41:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 42:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 43:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 44:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 45:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 46:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 47:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    break;
                case 48:
                    einfuegen_sued;
                    einfuegen_suedwest;
                    break;
                case 49:
                    einfuegen_nord;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 50:
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 51:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 52:
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 53:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 54:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 55:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 56:
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 57:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 58:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 59:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 60:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;
                    break;
                case 61:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 62:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;
                case 63:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    break;

                case 64:
                    einfuegen_west;
                    break;

                case 65:
                    einfuegen_nord;
                    einfuegen_west;
                    break;
                case 66:
                    einfuegen_nordost;
                    einfuegen_west;
                    break;
                case 67:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_west;
                    break;
                case 68:
                    einfuegen_ost;
                    einfuegen_west;
                    break;
                case 69:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_west;
                    break;
                case 70:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_west;
                    break;
                case 71:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_west;
                    break;
                case 72:
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 73:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 74:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 75:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 76:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 77:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 78:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 79:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    break;
                case 80:
                    einfuegen_sued;
                    einfuegen_west;
                    break;
                case 81:
                    einfuegen_nord;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 82:
                    einfuegen_nordost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 83:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 84:
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 85:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 86:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 87:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;

                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 88:
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 89:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 90:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 91:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 92:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_west;
                    break;
                case 93:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 94:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 95:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    break;
                case 96:
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;

                case 97:
                    einfuegen_nord;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 98:
                    einfuegen_nordost;

                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 99:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 100:
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 101:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 102:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 103:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 104:
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 105:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 106:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 107:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 108:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 109:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 110:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 111:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 112:
                    einfuegen_sued;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 113:
                    einfuegen_nord;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 114:
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 115:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 116:
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 117:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 118:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 119:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 120:
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 121:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 122:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 123:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 124:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;
                    einfuegen_west;
                    break;
                case 125:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 126:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;
                case 127:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    break;

                case 128:
                    einfuegen_nordwest;
                    break;
                case 129:
                    einfuegen_nord;
                    einfuegen_nordwest; break;
                case 130:
                    einfuegen_nordost;
                    einfuegen_nordwest; break;
                case 131:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_nordwest; break;
                case 132:
                    einfuegen_ost;
                    einfuegen_nordwest; break;
                case 133:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_nordwest; break;
                case 134:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_nordwest; break;
                case 135:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_nordwest; break;
                case 136:
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 137:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 138:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 139:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 140:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 141:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 142:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 143:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_nordwest; break;
                case 144:
                    einfuegen_sued;
                    einfuegen_nordwest; break;
                case 145:
                    einfuegen_nord;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 146:
                    einfuegen_nordost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 147:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 148:
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 149:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 150:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 151:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;

                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 152:
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 153:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 154:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 155:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 156:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_nordwest; break;
                case 157:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 158:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 159:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_nordwest; break;
                case 160:
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 161:
                    einfuegen_nord;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 162:
                    einfuegen_nordost;

                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 163:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 164:
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 165:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 166:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 167:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 168:
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 169:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 170:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 171:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 172:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 173:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 174:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 175:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 176:
                    einfuegen_sued;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 177:
                    einfuegen_nord;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 178:
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 179:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 180:
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 181:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 182:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 183:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 184:
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 185:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 186:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 187:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 188:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;
                    einfuegen_nordwest; break;
                case 189:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 190:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;
                case 191:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_nordwest; break;

                case 192:
                    einfuegen_west;
                    einfuegen_nordwest;
                    break;

                case 193:
                    einfuegen_nord;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 194:
                    einfuegen_nordost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 195:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 196:
                    einfuegen_ost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 197:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 198:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 199:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 200:
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 201:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 202:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 203:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 204:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 205:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 206:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 207:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 208:
                    einfuegen_sued;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 209:
                    einfuegen_nord;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 210:
                    einfuegen_nordost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 211:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 212:
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 213:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 214:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 215:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;

                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 216:
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 217:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 218:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 219:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_west;
                    einfuegen_nordwest; break;

                case 220:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_west;
                    einfuegen_nordwest;
                    break;
                case 221:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest;
                    break;
                case 222:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest;
                    break;
                case 223:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 224:
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;

                case 225:
                    einfuegen_nord;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 226:
                    einfuegen_nordost;

                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 227:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 228:
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 229:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 230:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 231:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 232:
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 233:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 234:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 235:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 236:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 237:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 238:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 239:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 240:
                    einfuegen_sued;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 241:
                    einfuegen_nord;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 242:
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 243:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 244:
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 245:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 246:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 247:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 248:
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 249:
                    einfuegen_nord;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 250:
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 251:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 252:
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;
                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 253:
                    einfuegen_nord;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 254:
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;
                case 255:
                    einfuegen_nord;
                    einfuegen_nordost;
                    einfuegen_ost;
                    einfuegen_suedost;
                    einfuegen_sued;
                    einfuegen_suedwest;

                    einfuegen_west;
                    einfuegen_nordwest; break;

        }
#ifdef AUSGABEN_NACHKORREKTUR
    cout << " ENDE FEPB rang " << rang << endl;
#endif
    }

// Kommentar: Eine rangabhngige Wartefunktion, um die Ausgaben zu strukturieren.
void Nachkorrektur::warten(void)
    {
#ifdef WARTEN
    int i;

    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
#endif
    }

// Kommentar: Die Zhler sind berflssig, aber die PT wird gebraucht.
void Nachkorrektur::setze_ebene_ebenen_zaehler(int * PT_ml)
    {
// Kommentar: Die punktbenachbarte Kernnachbarschaft - hier fr Multi Level, da Multi Level gepackt wird - wird an diese Klasse bergeben.
    ist_nachbar_zaehler_ml = PT_ml;
    }

// Kommentar: Eine unwichtige Funktion
void Nachkorrektur::ausgabe_nachbarn(void)
    {
    cout << " Nachkorrektur ausgabe nachbarn rang " << rang << " ";
    for(i=0; i<groesse; i++)
        {
        if((i!=rang)&&(ist_nachbar_zaehler_ml[i]>0))
            {
            cout << i << " ";
            }
        }
    cout << endl;
    }
