#ifndef NACHKORREKTUR
#define NACHKORREKTUR 1

#include <iostream>
#include <stdlib.h>
#include <string.h>

using namespace std;

#define einfuegen_nord einfuegen(f, g, farbenfeld[f-1][g])
#define einfuegen_nordost einfuegen(f, g, farbenfeld[f-1][g+1])
#define einfuegen_ost einfuegen(f, g, farbenfeld[f][g+1])
#define einfuegen_suedost einfuegen(f, g, farbenfeld[f+1][g+1])
#define einfuegen_sued einfuegen(f, g, farbenfeld[f+1][g])
#define einfuegen_suedwest einfuegen(f, g, farbenfeld[f+1][g-1])
#define einfuegen_west einfuegen(f, g, farbenfeld[f][g-1])
#define einfuegen_nordwest einfuegen(f, g, farbenfeld[f-1][g-1])


#include "nachkorrektur_kommunikation.h"

#include "ausgaben.h"

#include "farbmatrix.h"

#include "datei_ausgabe.h"

#include "timer.h"
#include "timer_vektor.h"

#include "mv_horizontal.h"

class Nachkorrektur
    {
private:
    NachkorrekturKommunikation * nachkorrektur_kommunikation;
public:
    int ** selbstnachbarn;
#ifdef KURZ_FF
    short int ** farbenfeld;
#else
    int ** farbenfeld;
#endif
#ifdef KURZ_NKFF
    short int ** nk_farbenfeld;
#else
    int ** nk_farbenfeld;
#endif

#ifdef KURZ_NK
    short int * sendebuffer;
#else
    int * sendebuffer;
#endif
    int zielfarbe;
    int h;
public:
#ifdef KURZ_FF
#ifdef KURZ_NK
    void farb_sendebuffer_bestimmen(short int ** _farbenfeld, int ** _selbstnachbarn, int short * _sendebuffer, int _zielfarbe, int _h);
#else
    void farb_sendebuffer_bestimmen(short int ** _farbenfeld, int ** _selbstnachbarn, int * _sendebuffer, int _zielfarbe, int _h);
#endif
#else
#ifdef KURZ_NK
    void farb_sendebuffer_bestimmen(int ** _farbenfeld, int ** _selbstnachbarn, int short * _sendebuffer, int _zielfarbe, int _h);
#else
    void farb_sendebuffer_bestimmen(int ** _farbenfeld, int ** _selbstnachbarn, int * _sendebuffer, int _zielfarbe, int _h);
#endif
#endif
private:
    void einfuegen(int f, int g, int farbenfeld_wert);
    int laenge, i, j, k;
    int vvektor_f1, vvektor_f2, vvektor_g;
    int hvektor_g1, hvektor_g2, hvektor_f;
    void fuer_einen_punkt_bestimmen(int f, int g);
public:
    void initialisieren_nk(int _n, int _m, int _groesse, int _rang, int _h_gesamt, MV_vertikal * _mv_west, MV_vertikal * _mv_ost,  MV_horizontal * _mv_nord, MV_horizontal * _mv_sued);
    void finalisieren_nk(void);
private:
    int m, n, groesse, rang;
private:
    int m_hilfe, n_hilfe;
public:
    int * liste;
    int * liste_invers;
    int listenlaenge;
    void sendebuffer_zuruecksetzen(void);
    int * ist_empfangen;
#ifdef KURZ_FF
    short int *** farbenfelder;
#else
    int *** farbenfelder;
#endif
#ifdef KURZ_NKFF
    short int *** nk_farbenfelder;
#else
    int *** nk_farbenfelder;
#endif
    int *** selbstnachbaren;
    int h_gesamt;
    int bufferlaenge, bufferindex;
    int a, b, c, d;
    void empfangen(void);
    void senden(void);
    bool test_empfangen(void);
private:
#ifdef KURZ_NK
    short int * empfangsbuffer;
#else
    int * empfangsbuffer;
#endif
public:
    bool test_senden(void);
    void buffer_ausgeben(void);
    void schliesse_buffer(void);
public:
    void null_einfuegen_anfang(void);
    void null_einfuegen_mitte(void);

    void empfange_erstes(void);
    void empfange_zweites(void);

    void setze_anfang(void);
    void setze_mitte(void);
    void setze_ende(void);
private:
    MV_vertikal * mv_west, * mv_ost;
    MV_horizontal * mv_nord, * mv_sued;
    void sammeln_eine_ebene(int h);
    void sammeln_eine_ebene_ns(int h);
private:
    int sende_ost_west(bool senden_west, bool senden_ost);
    int sende_nord_sued(bool senden_nord, bool senden_sued);
    void vorbereiten(void);
    void vorbereiten_ns(void);
    int sow;
    int sns;
    int * noch_zu_entpacken;
private:
    int * f1, *f2, *g, index;
    int * g1, *g2, *f;
public:
    void logisch_sammeln(void);
    void logisch_sammeln_ns(void);
    bool logisch_entpacken(void);
    bool logisch_entpacken_ns(void);
private:
    bool rueckwert;
public:
    void entpacken(int lokaler_rang);
    void entpacken_ns(int lokaler_rang);
private:
    void entpacken_inneres(int farbe);
    void entpacken_inneres_ns(int farbe);
private:
    int ff, gg;
private:
    FarbMatrix farbmatrix;
    int * farbmatrix_westen, * farbmatrix_osten;
    int * farbmatrix_norden, * farbmatrix_sueden;
private:
    int body_index, header_index;
    int * sendebuffer_west_farbe_ebenen, * sendebuffer_ost_farbe_ebenen;
    int * empfangsbuffer_west_farbe_ebenen, * empfangsbuffer_ost_farbe_ebenen;

private:
    int * sendebuffer_west, * sendebuffer_ost;
    int * empfangsbuffer_west, * empfangsbuffer_ost;
    bool west_bearbeitet, ost_bearbeitet;
public:
    int sende_west, sende_ost, empfange_west, empfange_ost;
    int sende_nord, sende_sued, empfange_nord, empfange_sued;
private:
    void sammeln(MV_vertikal * mv);
    void sammeln_ns(MV_horizontal * _mh);
private:
    int pih, pib;
private:
    void test(int farbe);
    int anzahlen;
private:
    void nachbereitung(void);
private:
    MV_vertikal * mv;
    MV_horizontal * mh;
private:
    void logisch(void);
    void logisch_ns(void);
    void ausgeben_nk_farbenfeld(void);
    void warten(void);
public:
    int zaehler;
public:
    int * ist_nachbar_zaehler_ml;
public:
    void setze_ebene_ebenen_zaehler(int * PT_ml);
public:
    DateiAusgabe * da_eez;
public:
    Timer timer_la_nk_entpacken;
    TimerVektor log_ent_tv;
private:
    char zeichenkette[40];
private:
    void ausgabe_nachbarn(void);
    };

#endif
