#include "nachkorrektur_kommunikation.h"

// Kommentar: Das hier ist die Kommunikationsklasse zur Klasse Nachkorrektur, in der die Zwischenkorrektur ausgefhrt wird.

// NachkorrekturKommunikation: (f,g,h,farbe) sind die Werte beim Einfuegen.

// Komemntar: Hiermit wird fr das Senden der Sendebuffer vorbereitet. Abhngig ist das von der Variablen sow, die festhlt,
// ob nach Westen oder Osten gesendet wird.
void NachkorrekturKommunikation::vorbereiten(int senden_ost_west)
// Was geschieht hier? Es werden nur Positionsvariablen geschrieben. Keine Kommunikation erfolgt wegen dem hier.
// In gewisser Weise schon: Man bekommt mitgeteilt, wieviel Mal gesendet wird. Je nachdem wird der Index
// fuer den Buffer gesetzt, der den Namen index_positionen trgt. So steht Speicherplatz zur Verfgung, um
// die Laengen auf den Ebenen abzuspeichern!

// Wo wird die Variable index_positionen verwendet? Und warum wird nicht der Sendebuffer Index auf 1 gesetzt,
// weil er ja hiermit 1 Wert sendebuffer[0] enthlt?

//  Und noch das: Beim packen bzw. schreiben wird die 0 wieder berschrieben. Das geht so nicht!
    {

// Kommentar: An die Stelle 0 wird - fr den Empfnger - der Wert sow geschrieben.
    sendebuffer[0] = senden_ost_west;

    index_anzahlen = 1;
    wurde_geschrieben = 0;
// Kommentar: Anzahlen gibt an, wieviele Punkte geschrieben worden sind.
    anzahlen = 0;

// Kommentar: Durch die folgende switch - Anweisung in Bezug auf die senden_ost_west Variable wird index_positionen festgelegt.
// Das ist die Stelle, an der in den Buffer geschrieben wird.
    switch(senden_ost_west)
        {
// Kommentar: Kein Senden nach Osten und Westen => Der Header hat eine Gre von 1.
        case 0:
            index_positionen = 1;
            break;
        case 1:
        case 2:
// Kommentar: Nur nach Osten oder Westen senden => Der Header hat eine Gre von 1 (fr sow) + h_gesamt (die Punktanzahlen)
            index_positionen = h_gesamt + 1;
            break;
        case 3:
// Kommentar: Nach Osten und Westen senden => Der Header hat eine Gre von 1 (fr sow) + 2* h_gesamt (die Punktanzahlen
// nach Ost und West)
            index_positionen = h_gesamt + h_gesamt + 1;
            break;
        default:
            cout << "Fehler in NachKorrekturKommunikation::vorbereiten" << endl;
            break;
        }
// Kommentar: Der sendebuffer_index bekommt diesen Wert.
    sendebuffer_index = index_positionen; // oder sendebuffer_index = index_positionen - nach unterem switch!
    }

// Kommentar: Hier wird eine Funktion analog zu vorbereiten geschrieben. Die Kommentare sind also dieselben.
void NachkorrekturKommunikation::vorbereiten_ns(int senden_nord_sued)
// Was geschieht hier? Es werden nur Positionsvariablen geschrieben. Keine Kommunikation erfolgt wegen dem hier.
// In gewisser Weise schon: Man bekommt mitgeteilt, wieviel Mal gesendet wird. Je nachdem wird der Index
// fuer den Buffer gesetzt, der den Namen index_positionen trgt. So steht Speicherplatz zur Verfgung, um
// die Laengen auf den Ebenen abzuspeichern!

// Wo wird die Variable index_positionen verwendet? Und warum wird nicht der Sendebuffer Index auf 1 gesetzt,
// weil er ja hiermit 1 Wert sendebuffer[0] enthlt?

//  Und noch das: Beim packen bzw. schreiben wird die 0 wieder berschrieben. Das geht so nicht!
    {
    sendebuffer[0] = senden_nord_sued;

    index_anzahlen = 1;
    wurde_geschrieben = 0;
    anzahlen = 0;

    switch(senden_nord_sued)
        {
        case 0:
            index_positionen = 1;
            break;
        case 1:
        case 2:
            index_positionen = h_gesamt + 1;
            break;
        case 3:
            index_positionen = h_gesamt + h_gesamt + 1;
            break;
        default:
            cout << "Fehler in NachKorrekturKommunikation::vorbereiten" << endl;
            break;
        }
    sendebuffer_index = index_positionen; // oder sendebuffer_index = index_positionen - nach unterem switch!
    }

// Kommentar: Diese Nachbereitung erfolgt immer nach einer bearbeiteten Gitterebene.
void NachkorrekturKommunikation::nachbereitung(void)
    {
// Muss hier nicht auch beruecksichtigt werden, ob schon fuers zweite Mal gepackt wurde?

// Es geht so: Nachdem eine Ebene geschrieben wurde, wird die Laenge in den Index - Bereich geschrieben.
// index_anzahlen ist der entsprechende Index.
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << "Nachbereitung index_anzahlen " << index_anzahlen << " anzahlen " << anzahlen;
    cout << " // rang " << rang << endl;
#endif
// Kommentar: In den Header des Buffers wird die Anzahl geschriebener Punkte geschrieben.
    sendebuffer[index_anzahlen] = anzahlen;
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << "Nachbereitung index_anzahlen " << index_anzahlen << " anzahlen " << anzahlen;
    cout << " // rang " << rang << endl;
#endif

// Komentar: Dann ist die anzahl 0 fr die nchste Gitterebene da, d.h., wieviele Punkte dann dort zu diesem
// Kern geschickt werden.
    anzahlen = 0;
// Kommentar: Im Header geht man einen Schritt weiter.
    index_anzahlen ++;
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << " Vor testfelder_ruecksetzen rang " << rang << endl;
#endif

// Kommentar: Das Testfeld wird fr die nchste zu bearbeitende Gitterebene zurckgesetzt. Ziel des Testfeldes: Keine doppelten Eintrge,
// damit der Buffer nicht unntig lang wird.
    testfelder_ruecksetzen();
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << " Nach testfelder_ruecksetzen rang " << rang << endl;
#endif
    }

// Kommentar: Abschicken der Nachricht.
void NachkorrekturKommunikation::senden(void)
    {
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << "NKsenden " << sendebuffer[0] << " laenge " << sendebuffer_index << " // rang " << rang << endl;
    cout << "NKsenden ";

    for(i=1; i<index_positionen; i++)
        {
        cout << sendebuffer[i] << " ";
        }
    cout << endl;
#endif
#ifdef KURZ_NK
// Kommentar: Der Sendebuffer der Lnge sendebuffer_index wird an den Kern geschickt, unter dessen ID diese Klasse gespeichert ist.
    MPI_Isend(sendebuffer, sendebuffer_index, MPI_SHORT, eigenfarbe, 200, MPI_COMM_WORLD, & sende_request);
#else
    MPI_Isend(sendebuffer, sendebuffer_index, MPI_INT, eigenfarbe, 200, MPI_COMM_WORLD, & sende_request);
#endif
    }

// Kommentar: Empfangen der Nachricht.
void NachkorrekturKommunikation::empfangen(void)
    {
#ifdef KURZ_NK
// Kommentar: Der Empfangsbuffer der Maximalgre buffer_groesse wird von dem Kern empfangen, unter dessen ID diese Klasse gespeichert ist.
    MPI_Irecv(empfangsbuffer, buffer_groesse, MPI_SHORT, eigenfarbe, 200, MPI_COMM_WORLD, & empfangs_request);
#else
    MPI_Irecv(empfangsbuffer, buffer_groesse, MPI_INT, eigenfarbe, 200, MPI_COMM_WORLD, & empfangs_request);
#endif
    }

// Kommentar: Hier wird geprft, ob die Nachricht empfangen wurde.
bool NachkorrekturKommunikation::test_empfangen(void)
    {
    MPI_Test(& empfangs_request, &flag, & empfangs_status);

    return(flag);
    }

// Kommentar: Hier wird geprft, ob die Nachricht abgeschickt worden ist.
bool NachkorrekturKommunikation::test_senden(void)
    {
    MPI_Test(& sende_request, &flag, & sende_status);

    return(flag);
    }

// Kommentar: Diese Funktion sollte mal den sendebuffer ausgeben - zu Debugging Zwecken.
// Jetzt tun sie im Prinzip nichts.
void NachkorrekturKommunikation::buffer_ausgeben(void)
    {
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << "NNK - Buffer ausgeben: ";

    int anzahl;
    anzahl = sendebuffer[0];
#endif
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << anzahl << endl;
#endif

#ifdef AUSGABEN_NK_KOMMUNIKATION
    int index;

    index = 1;
    for(i=0; i<anzahl; i++)
        {
        cout << " f " << sendebuffer[index];
        index ++;
        cout << " g " << sendebuffer[index];
        index ++;
        cout << " h " << sendebuffer[index];
        index ++;
        cout << " ZF " << sendebuffer[index];
        index ++;
        }
#endif
    }

// void NachkorrekturKommunikation::einfuegen(int f, int g, int h, int zielfarbe)

// Hier wird ein Element in den Sendebuffer eingetragen. Die bergabe - Koordinaten sind f und g.
void NachkorrekturKommunikation::einfuegen(int f, int g)
    {
#ifdef AUSGABEN
    cout << "** " << f << " " << g << " **";
#endif
// Das testfeld ist 2 dimensional. Aber das hier ist offensichtlich von h abhaengig,
// muss also entweder 3 dimensional gemacht werden, oder nach jedem neuen h
// resettet werden.

#ifdef AKTUELLE_KOMMENTARE_NK
    if(gitterebene == 3)
        {
        if((f == 1)&&(g == 2))
            {
            cout << " NKK::einfuegen rang " << rang << " eigenfarbe " << eigenfarbe << " testfeld " << testfeld_nk[f][g] << endl;
            }
        }
#endif

// Kommentar: Wurde dieser Punkt auf dieser Ebene zu diesem Kern in diesem Migrationsschritt schon einmal eingetragen, dann trage
// nichts ein.
    if(testfeld_nk[f][g]==true)
        {
        return;
        }
// Kommentar: Ansonsten markiere das Testfeld so, dass hier kein weiterer Eintrag erfolgt, und merke sich die Koordinaten fr ein
// spteres Zurcksetzen des Testfeldes.
    testfeld_nk[f][g] = true;
    f_nk[anzahl_nk] = f;
    g_nk[anzahl_nk] = g;
    anzahl_nk ++;
// Kommentar: Die Variable anzahlen wird um eins erhht, um festzuhalten, wieviele Punkte in den Buffer eingetragen wurden.
    anzahlen ++;
// Kommentar: Dann trage die Koordinaten in den Buffer ein mit Inkrementierung des Indexes.
    sendebuffer[sendebuffer_index] = f;
    sendebuffer_index++;
    sendebuffer[sendebuffer_index] = g;

    sendebuffer_index ++;
// Kommentar: Man vermerkt, dass geschrieben worden ist.
    wurde_geschrieben = 1;
    }

// Kommentar: Am Ende der Prozedur wird das Testfeld resettet, damit es wieder benutzt werden kann.
void NachkorrekturKommunikation::testfelder_ruecksetzen(void)
    {
#ifdef AUSGABEN_NK_KOMMUNIKATION
    cout << " Anzahl_nk " << anzahl_nk << " rang " << rang << endl;
#endif

// Kommentar: Man hat anzahl_nk Eintrge im Testfeld ...
    for(j=0; j<anzahl_nk; j++)
        {
// Kommentar: ... die auf der Position (f_nk(j),g_nk(j)) gelscht werden.
        testfeld_nk[f_nk[j]][g_nk[j]] = false;
        }
// Kommentar: Danach gibt es keinen Eintrag im Testfeld mehr.
    anzahl_nk = 0; // hinzugefgt am 01.04.2015. nderung nur an dieser Stelle ntig.
    }

// Kommentar: Diese Funktion ist analog zur Funktion testfelder_ruecksetzen. Also kein weiterer Kommentar hierzu.
void NachkorrekturKommunikation::reset(void)
    {
    for(i=0; i<anzahl_nk; i++)
// anzahl_nk ++ sieht falsch aus.
        {
        testfeld_nk[f_nk[i]][g_nk[i]] = false;
        }
    anzahl_nk = 0;
    }

// Kommentar: Diese Klasse wird finalisiert.
void NachkorrekturKommunikation::finalisieren_nkk(void)
    {
// Kommentar: Sendebuffer und Empfangsbuffer werden freigegeben.
    delete sendebuffer;
    delete empfangsbuffer;

// Kommentar: Der Koordinatenspeicher fr die Testfeldeintrge wird gelscht.
    delete f_nk;
    delete g_nk;

// Kommentar: Und das Testfeld wird gelscht.
    for(i=0; i<n; i++)
        {
        delete testfeld_nk[i];
        }

    delete testfeld_nk;
    }

// Kommentar: Diese Klasse wird hier initialisiert.
void NachkorrekturKommunikation::initialisieren_nkk(int _n, int _m, int _eigenfarbe, int _h_gesamt, int _rang)
//  Erfolgt aus Nachkorrektur::initialisieren_nk, und das von lastausgleich aus.
    {
// Kommentar: Zuerst werden die bergabe - Parameter gespeichert.
    m = _m;
    n = _n;
    eigenfarbe = _eigenfarbe;

    rang = _rang;

// Kommentar: Dann wird eine plausible Lnge fr die Buffer angegeben. Es mssen wirklich nicht viele Punkte bermittelt werden.
    buffer_groesse = 12 * (m+n);

#ifdef KURZ_NK
    sendebuffer = new short int [12 * (m+n)];
    empfangsbuffer = new short int [12 * (m+n)];
#else
    sendebuffer = new int [12 * (m+n)];
    empfangsbuffer = new int [12 * (m+n)];
#endif

// Kommentar: Hier der Speicherplatz fr die Koordinaten von Mehrfacheintrgen.
    f_nk = new int [3*(m+n)];
    g_nk = new int [3 * (m+n)];

    anzahl_nk = 0;

// Kommentar: Und dann wird das Testfeld angelegt.
    testfeld_nk = new int * [n];

    for(i=0; i<n; i++)
        {
        testfeld_nk[i] = new int[m];
        for(j=0; j<m; j++)
            {
            testfeld_nk[i][j] = false;
            }
        }
    h_gesamt = _h_gesamt;
    }
