#ifndef NACHKORREKTUR_KOMMUNIKATION
#define NACHKORREKTUR_KOMMUNIKATION 1

#include <iostream>

using namespace std;

#include <mpi.h>

#include "ausgaben.h"

class NachkorrekturKommunikation
    {
#ifdef KURZ_NK
private:
    short int * sendebuffer;
public:
    short int * empfangsbuffer;
#else
private:
    int * sendebuffer;
public:
    int * empfangsbuffer;
#endif
public:
    int sendebuffer_index;
private:
    MPI_Request sende_request;
    MPI_Request empfangs_request;

    MPI_Status sende_status;
    MPI_Status empfangs_status;
    int flag;

    int m, n;
public:
    void initialisieren_nkk(int _n, int _m, int _eigenfarbe, int _h_gesamt, int _rang);
    void finalisieren_nkk(void);
private:
    int ** testfeld_nk;
public:
    int * f_nk, * g_nk, anzahl_nk;
    void einfuegen(int f, int g); // farbe: Auf welchem Prozessor liegt nun der Punkt (f,g,h)?
    int h_aktuell;
private:
    int i, j;
public:
    void senden(void);
    int eigenfarbe;
private:
    void reset(void);
    int buffer_groesse;
public:
    void empfangen(void);
    void schliesse_buffer(void);
    bool test_empfangen(void);
    bool test_senden(void);

    void buffer_ausgeben(void);
public:
    void null_einfuegen_anfang(void);
    void null_einfuegen_mitte(void);

    void empfange_erstes(void);
    void empfange_zweites(void);

    void setze_anfang(void);
    void setze_mitte(void);
    void setze_ende(void);
private:
    int index_anzahlen, index_positionen;
    int anzahlen, wurde_geschrieben;

    int h_gesamt;
public:
    void vorbereiten(int senden_ost_west);
    void vorbereiten_ns(int senden_nord_sued);
private:
public:
    void nachbereitung(void);
private:
    void testfelder_ruecksetzen(void);
private:
    int rang;
public:
    int gitterebene;
    };


#endif

