#include "p_s_bestimmen.h"

// Kommentar: Die Klasse P_s_bestimmen bestimmt die Punkte, die dem feineren Gitter hinzuzufgen sind, bzw. aus ihm zu entfernen
// sind, um genau die Punkte zu haben, die 5 x 5 Feingitterpunktberdeckungen der Grobgitterpunkte, die das Verfeinerungskriterium
// erfllen.

// Kommentar: Optional - aufgrund der Prprozessorvariablen AUSGABEN_P_S_BESTIMMEN - werden P+ und P- ausgegeben.
void P_s_bestimmen::ausgabe(void)
    {
#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << "P_s_bestimmen.ausgabe Beginn " << endl;
    cout << "p_plus rang " << rang << endl;

// Kommentar: Hier wird P+ ausgegeben.
    P_plus->ausgabe();
    cout << "p_minus rang " << rang << endl;

// Kommentar: Hier wird P- ausgegeben.
    P_minus->ausgabe();

    cout << "P_s_bestimmen.ausgabe Ende rang " << rang << endl;
#endif
    }

// Kommentar: In dieser Funktion werden beide Punktmengen bestimmt - P+ und P-.
void P_s_bestimmen::tun(void)
    {

// Kommentar: Zuerst werden P+ und P- leer gemacht. Es werden dann aus diesen Listen keine Elemente mehr entfernt, sondern
// es werden nur Punkte hinzugefgt.
    P_plus->reset();
    P_minus->reset();

// Kommentar: Nun soll die Menge EP_SNB_punkte durchlaufen werden. Die Punkteanzahl von dort wird hier gemerkt - fr einen
// schnelleren Zugriff.
    anzahl = EP_SNB_punkte->anzahl;

#ifdef AUSGABEN_P_S_BESTIMMEN
#ifdef AKTUELLE_KOMMENTARE
    cout << " EP_SNB_punkte rang " << rang << " t " << paralleles_rechnen->t << " gitterebene" << paralleles_rechnen->gitterebene << " anzahl " << anzahl << " ";
#endif
#endif

// Kommentar: Die Menge EP_SNB_punkte wird durchlaufen.
    for(i=0; i<anzahl; i++)
        {
        f = EP_SNB_punkte->f[i];
        g = EP_SNB_punkte->g[i];

#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_P_S_BESTIMMEN
        cout << "(f " << f << " g " << g << " EPSNB " << EP_SNB[f][g] << " ep_akt " << ep_aktuell[f][g] << ")";
#endif
        if((rang==1)&&(f==13)&&(g==5))
            {
            cout << " DDEEFF 1,13,5 " << " EPSNB " << EP_SNB[f][g] << " ep_akt " << ep_aktuell[f][g] << endl;
            }
#endif

#ifdef AKTUELLE_KOMMENTARE_NEU
        if((rang==3)&&(f==8)&&(g==6))
            {
            cout << " OPQR 1 " << endl;
            }
#endif

// Kommentar Es werden die Feingitterkoordinaten zu den Grobgitterkoordinaten (f,g) bestimmt.
        fg_f = f << 1;
        fg_g = g << 1;

// Kommentar: Und bezglich dieser Koordinaten werden die P- - Punkte gebildet - mit der Funktion p_minus_bilden.
        p_minus_bilden(fg_f, fg_g);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << endl;

// Kommentar: Optional wird nun P- ausgegeben
    for(i=0; i<P_minus->anzahl; i++)
        {
        cout << "(f" << P_minus->f[i] << "g" << P_minus->g[i] << ")";
        }

    cout << endl;
#endif

// Kommentar: Es wird die Menge EP+ durchlaufen.
    anzahl = EP_plus->anzahl;

    for(i=0; i<anzahl; i++)
        {
        f = EP_plus->f[i];
        g = EP_plus->g[i];

#ifdef AUSGABEN_P_S_BESTIMMEN
        cout << "PPJ rang " << rang;
        cout << " f " << f << " g " << g << " 255-snb " << 255-selbstnachbarn[f][g];

        cout << " 255-EP_SNB " << 255-EP_SNB[f][g];
#endif
// Kommentar: An dieser Stelle war die Abfrage nach dem inneren Punkt herausgenommen.

// Kommentar: Der Feingitterpunkt darunter wird bestimmt.
        fg_f = f << 1;
        fg_g = g << 1;

// Kommentar: Zu dem Feingitterpunkt wird die Funktion p_plus_bilden aufgerufen.
        p_plus_bilden(fg_f, fg_g);
        }

#ifdef AUSGABEN_P_S_BESTIMMEN

// Kommentar: Bei diesem optional ausgefhrten Code werden P+ und P- ausgegeben.
    cout << endl;
    cout << " Ausgaben P_minus P_plus rang " << rang << endl;
    cout << " P_minus rang " << rang << " ";
    for(i=0; i<P_minus->anzahl; i++)
        {
        cout << "(f" << P_minus->f[i] << "g" << P_minus->g[i] << ")";
        }
    cout << endl;
    cout << " P_plus rang " << rang << " ";
    for(i=0; i<P_plus->anzahl; i++)
        {
        cout << "(f" << P_plus->f[i] << "g" << P_plus->g[i] << ")";
        }
    cout << endl;
#endif

    }

void P_s_bestimmen::p_s_test(void)
// Hier werden ggf. Tests fr P+ und P- aufgerufen.
    {
#ifdef AV_TESTS
    if(P_minus->anzahl < P_plus->anzahl)
        {
        p_s_test_durchlaufe_P_minus();
        }
    else
        {
        p_s_test_durchlaufe_P_plus();
        }
#endif
    }

// Hier wird geprft, ob unter den P- Eintrgen ein P+ Punkt ist. Da die Punktmengen disjunkt sind, wre dieses ein Fehler.
void P_s_bestimmen::p_s_test_durchlaufe_P_minus(void)
    {
    anzahl = P_minus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        f = P_minus->f[i];
        g = P_minus->g[i];
        if(P_plus->feld[f][g]!=-1)
            {
            cout << " Fehler: Doppelbelegung von (" << f << "," << g << ") in P_s_bestimmen::p_s_test_durchlaufe_P_minus rang " << rang << endl;
            exit(-1);
            }
        }
    }

// Hier wird geprft, ob unter den P+ Eintrgen ein P- Punkt ist. Da die Punktmengen disjunkt sind, wre dieses ein Fehler.
void P_s_bestimmen::p_s_test_durchlaufe_P_plus(void)
    {
    anzahl = P_plus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        f = P_plus->f[i];
        g = P_plus->g[i];
        if(P_minus->feld[f][g]!=-1)
            {
            cout << " Fehler: Doppelbelegung von (" << f << "," << g << ") in P_s_bestimmen::p_s_test_durchlaufe_P_plus rang " << rang << endl;
            exit(-1);
            }
        }
    }

// Kommentar: Diese Funktion 'minus_hinzu' fgt einen Punkt in die P- Liste ein. Dabei geschieht noch eine Prfung. Der Punkt
// (ffff,gggg) wird bergeben.
inline void P_s_bestimmen::minus_hinzu(int ffff, int gggg)
    {
// Kommentar: Wenn es dort keinen Punkt gibt - und fgff ist auf dem Inneren plus Auenrand korrekt - kann man ihn auch nicht
// entfernen.
    if(fgff[ffff][gggg]<0)
        {
        return;
        }

// Kommentar: Ansonsten wird (ffff,gggg) in die Liste P- aufgenommen.
    P_minus->hinzu(ffff, gggg);
#ifdef AUSGABEN_P_S_BESTIMMEN
    if(ffff==14)
        {
        if(gggg==28)
            {
            cout << " P_Minus (14,28) aktiviert rang " << rang << endl;
            }
        }
#endif
    }

// Kommentar: Diese Funktion p_minus_bilden kmmert sich - gem der Dissertation - darum, gem der Information EP-SNB
// die 4 Punkte (fff,ggg), (fff+1,ggg), (fff,ggg+1) und (fff+1,ggg+1) daraufhin zu prfen, ob sie dazukommen, und sie,
// falls sie dazukommen sollen, auch in die Liste von P- aufzunehmen - durch aufrufen der Funktion minus_hinzu.
inline void P_s_bestimmen::p_minus_bilden(int fff, int ggg)
    {
// Kommentar: Bei ep_aktuell(Grobgitterpunkt (f,g)) = true kann keiner der oben genannten Punkte entfernt werden.
// Man muss diesen 'Test' machen, weil EP-SNB den mittleren Punkt nicht einschliet - nur die Punkte drum herum.
    if(ep_aktuell[f][g]==true)
        {
        return;
        }

#ifdef AKTUELLE_KOMMENTARE
    if((rang==4)&&(f==9)&&(g==0))
        {
        cout << " DDEEFF EP_SNB[9][0] ep_aktuell nicht true " << EP_SNB[f][g] << endl;
        }
#endif

//  AAII
#ifdef AUSGABE_AAII
    if((rang==0)&&(f==9)&&(g==12))
        {
        cout << " AAII EP_SNB " << EP_SNB[f][g] << endl;
        }
#endif

// Kommentar: Jetzt wird mittels EP - SNB festgelegt, welche der 4 Punkte entsprechend EP-SNB zu P- hinzugefgt werden knnten.
// Das muss fr jeden der 256 Flle geprft werden. Die meisten Flle gehren zum Default, weil soviel EP - Information auf true
// ist, dass die 4 Punkte auf jeden Fall erhalten bleiben.
    switch(EP_SNB[f][g]) // EP_SNB oder 255 - EP_SNB
        {
// Kommentar: Kein EP_SNB - Eintrag => alle 4 Punkte kommen fr eine Entfernung in Frage. Alle weiteren Flle mssen
// fr jede EP_SNB - Zahl durchberlegt werden - vergleiche quch die Dissertation, wo zwei weitere Flle erkrt werden.
        case 0: // LEER
            minus_hinzu(fff, ggg);
            minus_hinzu(fff+1, ggg);
            minus_hinzu(fff, ggg+1);
            minus_hinzu(fff+1, ggg+1);
            break;
        case 128: // NORD_WEST
            minus_hinzu(fff+1, ggg);
            minus_hinzu(fff, ggg+1);
            minus_hinzu(fff+1, ggg+1);
            break;
// Linke Seite
        case 64:    // WEST
        case 192:   // WEST und NORD_WEST
        case 96:    // WEST und SUED_WEST
        case 224:   // WEST und NORD_WEST und SUED_WEST
        case 160:   // NORD_WEST und SUED_WEST
        case 32:    // SUED_WEST
            minus_hinzu(fff, ggg+1);
            minus_hinzu(fff+1, ggg+1);
            break;
// Obere Seite
        case 2:     // NORD_OST
        case 1:     // NORD
        case 3:     // NORD und NORD_OST
        case 129:   // NORD und NORD_WEST
        case 130:   // NORD_OST und NORD_WEST
        case 131:   // NORD und NORD_OST und NORD_WEST
            minus_hinzu(fff+1, ggg);
            minus_hinzu(fff+1, ggg+1);
            break;
// Links und oben
        case 66:    // 64 + 2
        case 194:   // 192 + 2
        case 98:    // 96 + 2
        case 226:   // 224 + 2
        case 162:   // 160 + 2
        case 34:    // 32 + 2

        case 65:    // 64 + 1
        case 193:   // 192 + 1
        case 97:    // 96 + 1
        case 225:   // 224 + 1
        case 161:   // 160 + 1
        case 33:    // 32 + 1

        case 67:    // 64 + 3
        case 195:   // 192 + 3
        case 99:    // 96 + 3
        case 227:   // 224 + 3
        case 163:   // 160 + 3
        case 35:    // 32 + 3

            minus_hinzu(fff+1, ggg+1);
            break;
        default: // VOLL
            break;
        }
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese vier
// Feingitter - Punkte im Norden zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_nord(void)
    {
    P_plus_hinzu(ff-2, gg);
    P_plus_hinzu(ff-1, gg);
    P_plus_hinzu(ff-2, gg+1);
    P_plus_hinzu(ff-1, gg+1);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese zwei
// Feingitter - Punkte im Nordosten zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_nordost(void)
    {
    P_plus_hinzu(ff-2, gg+2);
    P_plus_hinzu(ff-1, gg+2);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese zwei
// Feingitter - Punkte im Osten zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_ost(void)
    {
    P_plus_hinzu(ff, gg+2);
    P_plus_hinzu(ff+1, gg+2);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, wird dieser eine
// Feingitter - Punkt im Sdosten zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_suedost(void)
    {
    P_plus_hinzu(ff+2, gg+2);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese zwei
// Feingitter - Punkte im Sden zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_sued(void)
    {
    P_plus_hinzu(ff+2, gg);
    P_plus_hinzu(ff+2, gg+1);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese zwei
// Feingitter - Punkte im Sdwesten zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_suedwest(void)
    {
    P_plus_hinzu(ff+2, gg-2);
    P_plus_hinzu(ff+2, gg-1);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese vier
// Feingitter - Punkte im Westen zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_west(void)
    {
    P_plus_hinzu(ff, gg-2);
    P_plus_hinzu(ff+1, gg-2);
    P_plus_hinzu(ff, gg-1);
    P_plus_hinzu(ff+1, gg-1);
    }

// Kommentar: Unter den 5 x 5 Punkten, die zu einem Grobgitterpunkt eingetragen werden, werden diese vier
// Feingitter - Punkte im Nordwesten zu P+ hinzugefgt - wenn das ntig ist.
// Bemerkung: P_plus_hinzu hat auch noch eine Bedingung zu stellen.
void P_s_bestimmen::punkt_einfuegen_funktion_nordwest(void)
    {
    P_plus_hinzu(ff-2, gg-2);
    P_plus_hinzu(ff-1, gg-2);
    P_plus_hinzu(ff-2, gg-1);
    P_plus_hinzu(ff-1, gg-1);
    }

// Kommentar: Dieser Punkt (f_hilfe,g_hilfe) wird hinzugefgt zu P+. Es gibt da aber noch eine Bedingung.
void P_s_bestimmen::P_plus_hinzu(int f_hilfe, int g_hilfe)
    {
#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << "PPH f " << f_hilfe << " g " << g_hilfe;
#endif

// Kommentar: Es darf an dieser Stelle noch keinen Punkt geben. Denn nur dann kann man einen Punkt einfgen.
    if(feld[f_hilfe][g_hilfe] <0) // Die ueren Randpunkte werden spter entfernt.
//    if(fgff[f_hilfe][g_hilfe] <0) // Ich hoffe, dass das so geht. Sonst msste ich eine Klasse anlegen, die andauernde 012 - en enthlt.
// Dieser if - Befehl: Was ist die Idee dabei? Ah so: Dass da bisher kein Punkt darauf war.
// Dieser Befehl ist nicht falsch: P_plus_hinzu stimmt zwar nicht entfernt auf einem anderen Gitter; beim sich anschliessenden
// Scan von P_plus geht man aber nur den Rand durch!
//    if(besetzte_punkte[f_hilfe][g_hilfe]==false)
        {
#ifdef AUSGABEN_P_S_BESTIMMEN
        cout << "PPHII f " << f_hilfe << " g " << g_hilfe;
#endif
        P_plus->hinzu(f_hilfe, g_hilfe);
#ifdef AUSGABEN_P_S_BESTIMMEN
        if((f_hilfe==18)&&(g_hilfe==14))
            {
            cout << " AAPP " << endl;
            }
#endif
        }
    }


// Kommentar: Hier geschieht das Hinzufgen von P+ - Punkten an der Feingitterstelle (fff,ggg).
inline void P_s_bestimmen::p_plus_bilden(int fff, int ggg)
    {
    ff = fff;
    gg = ggg;

#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << "PPB " << endl;
#endif

// Kommentar: Zentral werden diese vier Punkte (fff,ggg), (fff+1,ggg), (fff,ggg+1) und (fff+1,ggg+1) hinzugefgt - modulo der
// Prfung fr P_plus_hinzu. Das gilt fr jede Feingitterkoordinate zu einem Grobgittereintrag in EP+.
    P_plus_hinzu(ff, gg);
    P_plus_hinzu(ff+1, gg);
    P_plus_hinzu(ff, gg+1);
    P_plus_hinzu(ff+1, gg+1);
#ifdef AUSGABEN_P_S_BESTIMMEN_NEU
    if((rang==0)&&(f==2)&&(g==4))
        {
        cout << " OOMMNN (0,2,4,1) 255 - EP_SNB " << 255 - EP_SNB[f][g] << " Ebene " << paralleles_rechnen->gitterebene << endl;
        }
#endif

// Kommentar: Alle weiteren Eintragungen in den 8 Himmelsrichtungen geschieht so, wie in der Dissertation erklrt.
// Im Folgenden gibt es zu jeder EP-SNB - Zahl genau die Himmelsrichtungen, fr die nicht eingefgt werden muss.
// Um gekehrt gibt 255 - EP_SNB an, in welcher Himmelsrichtung trotzdem noch eingefgt werden muss.
// Insgesamt spart man gegenber 25 Eintragungen viel - auch beim sequentiellen Algorithmus.
    switch(255 - EP_SNB[f][g]) // 255 - EP_SNB oder EP_SNB alleine, vgl. P_minus_bilden
    // 255 - EP_SNB[f][g] msste stimmen, weil dann geschrieben wird, wenn beim Nachbarn kein EP ist.
// Hier sparen gegenber 25 Punkte einfuegen! EP_SNB ist in der groben Ebene.
        {
                case 0:
                    break;
                case 1:
                    punkt_einfuegen_nord;
                    break;
                case 2:
                    punkt_einfuegen_nordost;
                    break;
                case 3:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    break;
                case 4:
                    punkt_einfuegen_ost;
                    break;
                case 5:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    break;
                case 6:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    break;
                case 7:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    break;
                case 8:
                    punkt_einfuegen_suedost;
                    break;
                case 9:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    break;
                case 10:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    break;
                case 11:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    break;
                case 12:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    break;
                case 13:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    break;
                case 14:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    break;
                case 15:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    break;
                case 16:
                    punkt_einfuegen_sued;
                    break;
                case 17:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;

                    break;
                case 18:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    break;
                case 19:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    break;
                case 20:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    break;
                case 21:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    break;
                case 22:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    break;
                case 23:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;

                    punkt_einfuegen_sued;

                    break;
                case 24:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 25:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 26:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 27:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 28:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    break;
                case 29:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 30:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 31:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    break;
                case 32:
                    punkt_einfuegen_suedwest;
                    break;
                case 33:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedwest;
                    break;
                case 34:
                    punkt_einfuegen_nordost;

                    punkt_einfuegen_suedwest;
                    break;
                case 35:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedwest;
                    break;
                case 36:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    break;
                case 37:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    break;
                case 38:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    break;
                case 39:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    break;
                case 40:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 41:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 42:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 43:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 44:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 45:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 46:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 47:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    break;
                case 48:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    break;
                case 49:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 50:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 51:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 52:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 53:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 54:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 55:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 56:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 57:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 58:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 59:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 60:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    break;
                case 61:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 62:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;
                case 63:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    break;

                case 64:
                    punkt_einfuegen_west;
                    break;

                case 65:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_west;
                     break;
                case 66:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_west;
                     break;
                case 67:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_west;
                     break;
                case 68:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                     break;
                case 69:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                     break;
                case 70:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                     break;
                case 71:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                     break;
                case 72:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 73:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 74:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 75:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 76:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 77:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 78:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 79:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                     break;
                case 80:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                     break;
                case 81:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 82:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 83:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 84:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 85:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 86:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 87:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;

                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 88:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 89:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 90:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 91:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 92:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                     break;
                case 93:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 94:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 95:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                     break;
                case 96:
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;

                case 97:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 98:
                    punkt_einfuegen_nordost;

                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 99:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 100:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 101:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 102:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 103:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 104:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 105:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 106:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 107:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 108:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 109:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 110:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 111:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 112:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 113:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 114:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 115:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 116:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 117:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 118:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 119:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 120:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 121:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 122:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 123:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 124:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                     break;
                case 125:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 126:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;
                case 127:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                     break;

                case 128:
                    punkt_einfuegen_nordwest;
                     break;
                case 129:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordwest;  break;
                case 130:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_nordwest;  break;
                case 131:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_nordwest;  break;
                case 132:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_nordwest;  break;
                case 133:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_nordwest;  break;
                case 134:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_nordwest;  break;
                case 135:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_nordwest;  break;
                case 136:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 137:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 138:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 139:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 140:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 141:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 142:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 143:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_nordwest;  break;
                case 144:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_nordwest;  break;
                case 145:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 146:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 147:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 148:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 149:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 150:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 151:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;

                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 152:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 153:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 154:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 155:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 156:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_nordwest;  break;
                case 157:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 158:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 159:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_nordwest;  break;
                case 160:
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 161:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 162:
                    punkt_einfuegen_nordost;

                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 163:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 164:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 165:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 166:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 167:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 168:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 169:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 170:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 171:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 172:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 173:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 174:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 175:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 176:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 177:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 178:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 179:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 180:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 181:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 182:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 183:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 184:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 185:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 186:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 187:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 188:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_nordwest;  break;
                case 189:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 190:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;
                case 191:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_nordwest;  break;

                case 192:
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;
                     break;

                case 193:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 194:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 195:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 196:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 197:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 198:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 199:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 200:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 201:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 202:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 203:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 204:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 205:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 206:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 207:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 208:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 209:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 210:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 211:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 212:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 213:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 214:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 215:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;

                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 216:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 217:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 218:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 219:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 220:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;
                     break;
                case 221:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;
                     break;
                case 222:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;
                     break;
                case 223:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 224:
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;

                case 225:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 226:
                    punkt_einfuegen_nordost;

                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 227:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 228:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 229:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 230:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 231:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 232:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 233:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 234:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 235:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 236:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 237:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 238:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 239:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 240:
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 241:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 242:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 243:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 244:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 245:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 246:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 247:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 248:
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 249:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 250:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 251:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 252:
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;
                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 253:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 254:
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;
                case 255:
                    punkt_einfuegen_nord;
                    punkt_einfuegen_nordost;
                    punkt_einfuegen_ost;
                    punkt_einfuegen_suedost;
                    punkt_einfuegen_sued;
                    punkt_einfuegen_suedwest;

                    punkt_einfuegen_west;
                    punkt_einfuegen_nordwest;  break;

        }
#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << "ENDE PPB " << endl;
#endif
    }

// Kommentar: Selbsterklrend liegt hier eine Initialisierung vor.
void P_s_bestimmen::initialisieren(ParallelesRechnen * _paralleles_rechnen, int ** _feld, short int ** _EP_SNB, PunktFeldListe * _P_minus, PunktFeldListe * _P_plus, PunktFeldListe * _EP_minus, PunktFeldListe * _EP_plus, PunktListe * _EP_SNB_punkte, short int ** _fgff)
    {
    paralleles_rechnen = _paralleles_rechnen;
    feld = _feld;
    EP_SNB = _EP_SNB;

    EP_minus = _EP_minus;
    EP_plus = _EP_plus;

    P_minus = _P_minus;
    P_plus = _P_plus;

    EP_SNB_punkte = _EP_SNB_punkte;

    rang = paralleles_rechnen -> rang;
    groesse = paralleles_rechnen -> groesse;
    selbstnachbarn = paralleles_rechnen -> selbstnachbarn;
    #ifdef AKTUELLE_KOMMENTARE
    paralleles_rechnen -> selbstnachbarn_ausgeben();
    #endif
    ggff = paralleles_rechnen -> farbenfeld;
    fgff = _fgff;
    }

// Kommentar: Hier wird finalisiert.
void P_s_bestimmen::finalisieren_aussenrand(void)
    {
    if(vektorisieren0==JA)
        {
        delete f1_v_vektor_e;
        delete f2_v_vektor_e;
        delete g_v_vektor_e;

        delete f_h_vektor_e;
        delete g1_h_vektor_e;
        delete g2_h_vektor_e;

        delete f_rs_e;
        delete g_rs_e;

        delete anzahl_h_vektor_e;
        delete anzahl_v_vektor_e;
        delete punkteanzahl_e;
        }
    else
        {
        delete f_a_rs;
        delete g_a_rs;
        delete anzahl_a_rs;
        }
    }

// Kommentar: Hier wird initialisiert.
void P_s_bestimmen::initialisieren_aussenrand(ParallelesRechnen * _paralleles_rechnen_h_minus1, int * _PT_feingitter)
// wird komplett finalisiert
    {
    paralleles_rechnen_h_minus1 = _paralleles_rechnen_h_minus1;
    vektorisieren0 = paralleles_rechnen_h_minus1->vektorisieren0;
    PT_feingitter = _PT_feingitter;

    if(vektorisieren0==JA)
        {
        f1_v_vektor_e = new short int * [groesse];
        f2_v_vektor_e = new short int * [groesse];
        g_v_vektor_e = new short int * [groesse];

        f_h_vektor_e = new short int * [groesse];
        g1_h_vektor_e = new short int * [groesse];
        g2_h_vektor_e = new short int * [groesse];

        f_rs_e = new short int * [groesse];
        g_rs_e = new short int * [groesse];

        anzahl_h_vektor_e = new int * [groesse];
        anzahl_v_vektor_e = new int * [groesse];
        punkteanzahl_e = new int * [groesse];
        }
    else
        {
        f_a_rs = new short int * [groesse];
        g_a_rs = new short int * [groesse];
        anzahl_a_rs = new int * [groesse];
        }

#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << "Initialisieren ep_s_bestimmen" << endl;
#endif

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(vektorisieren0==JA)
                {
#ifdef AUSGABEN_P_S_BESTIMMEN
                cout << "Vektorisieren0 == JA" << endl;
#endif
                f1_v_vektor_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].f1_v_vektor_e;
                f2_v_vektor_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].f2_v_vektor_e;
                g_v_vektor_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].g_v_vektor_e;

                f_h_vektor_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].f_h_vektor_e;
                g1_h_vektor_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].g1_h_vektor_e;
                g2_h_vektor_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].g2_h_vektor_e;

                f_rs_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].f_e;
                g_rs_e[i] = paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].g_e;

                anzahl_h_vektor_e[i] = &(paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].anzahl_h_vektor_e);
                anzahl_v_vektor_e[i] = &(paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].anzahl_v_vektor_e);
                punkteanzahl_e[i] = &(paralleles_rechnen_h_minus1 -> randstruktur_kommunikation[i].punkteanzahl_e);
                }
            else
                {
#ifdef AUSGABEN_P_S_BESTIMMEN
                cout << "Vektorisieren0 == NEIN" << endl;
#endif
                f_a_rs[i] = paralleles_rechnen_h_minus1 -> rand_werte_kommunikation[i].f_a_rs;
                g_a_rs[i] = paralleles_rechnen_h_minus1 -> rand_werte_kommunikation[i].g_a_rs;
#ifdef AUSGABEN_P_S_BESTIMMEN
                cout << "Nach f_a_rs g_a_rs " << endl;
#endif
                anzahl_a_rs[i] = &(paralleles_rechnen_h_minus1 -> rand_werte_kommunikation[i].anzahl_a_rs);
#ifdef AUSGABEN_P_S_BESTIMMEN
                cout << "Nach anzahl_a_rs " << endl;
#endif
                }
            }
        }
    }

void P_s_bestimmen::p_plus_update(void)
// Was genau macht diese Funktion? Sie lscht den Rand aus p_plus. Warum? Den Auenrand. Das knnte Sinn machen aus diesem Grund:
// Auf dem Gebiet selber hat man keinen 2 er, weil dort schon Punkte existieren. Auf dem Auenrand existieren auch schon Punkte.
// Dort knnen auch keine 2er sein.
    {
#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << " P_plus_update / rang " << rang << endl;
#endif

    if(vektorisieren0==JA)
        {
        for(j=0; j<groesse; j++)
            {
#ifdef AUSGABEN_P_S_BESTIMMEN
            cout << "EPsbV j " << j << " PT(j) " << PT_feingitter[j] << " rang " << rang << endl;
#endif
            if(PT_feingitter[j]>0)
                {
                for(i=0; i<*(anzahl_h_vektor_e[j]); i++)
                    {
                    for(a = g1_h_vektor_e[j][i], b = g2_h_vektor_e[j][i], c = f_h_vektor_e[j][i]; a<=b; a++)
                        {
                        P_plus->hinweg(c, a);
                        }
                    }
                for(i=0; i<*(anzahl_v_vektor_e[j]); i++)
                    {
                    for(a = f1_v_vektor_e[j][i], b = f2_v_vektor_e[j][i], c = g_v_vektor_e[j][i]; a<=b; a++)
                        {
                        P_plus->hinweg(a, c);
                        }
                    }
                for(i=0; i<*(punkteanzahl_e[j]); i++)
                    {
                    f = f_rs_e[j][i];
                    g = g_rs_e[j][i];

                    P_plus->hinweg(f, g);
                    }
                }
            }
        }
    else
        {
        for(j=0; j<groesse; j++)
            {
#ifdef AUSGABEN_P_S_BESTIMMEN
            cout << "EPsbS j " << j << " PT(j) " << PT_feingitter[j] << " rang " << rang << endl;
#endif
            if(PT_feingitter[j]>0)
                {
#ifdef AUSGABEN_P_S_BESTIMMEN
                cout << "EPsbS2 j " << j << " Anzahl " << (*(anzahl_a_rs[j])) << " rang " << rang << endl;
#endif
                f_a_rs_j = f_a_rs[j];
                g_a_rs_j = g_a_rs[j];
                for(i=0; i<*(anzahl_a_rs[j]); i++)
                    {
                    f = int(f_a_rs_j[i]);
                    g = int(g_a_rs_j[i]);
#ifdef AUSGABEN_P_S_BESTIMMEN
                    cout << " f " << f << " g " << g;
#endif

                    P_plus->hinweg(f, g);
                    }
#ifdef AUSGABEN_P_S_BESTIMMEN
                cout << endl;
#endif
                }
            }
        }
#ifdef AUSGABEN_P_S_BESTIMMEN
    cout << " Ende P_plus_update / rang " << rang << endl;
#endif
    }

