#include "paralleles_rechnen.h"

// Kommentar: Die Kommunikation der ep_s am Rand allokiert Speicher. Der wird hier freigegeben.
void ParallelesRechnen::finalisieren_kommunikation_ep_s(void)
    {
    kommunikation_ep_s.finalisieren_kb();
    kommunikation_ep_s.finalisieren_kep();
    }

// Kommentar: Die Kommunikation der ep_s am Rand wird hier initialisiert. Die Kommunikation wird hier
// mglich gemacht - vergleiche die Randaustausche hier.
void ParallelesRechnen::initialisieren_kommunikation_ep_s(int * _PT)
    {
// Kommentar: Man braucht die Kerntopologie PT, damit der Randaustausch eingeschrnkt bleibt.
    PT = _PT;
// Kommentar: Die Klasse kommunikation_ep_s wird initialisiert - mit der Kernanzahl und eigenen ID, der Kerntopologie
// und Bufferlnge mn.
    kommunikation_ep_s.initialisieren_kb(groesse, rang, PT, mn);
// Kommentar: Es muss auch noch der Typ von Rand angegeben werden. Fr den Randaustausch, damit dabei die boolschen Werte fr die
// richtigen Punkte bertragen werden.
    kommunikation_ep_s.initialisieren_kep(vektorisieren0, rang);

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Die Buffer der Kommunikation_ep werden mit den Buffern der RandstukturKommunikation verknpft -
// um Speicherplatz zu sparen.
            kommunikation_ep_s.sendebuffer[i] = randstruktur_kommunikation[i].sendebuffer;
            kommunikation_ep_s.empfangsbuffer[i] = randstruktur_kommunikation[i].empfangsbuffer;

            // Sind diese Buffer schon mit Speicherplatz versehen? Eigentlich Ja wegen multi_level Verknuepfung in Zeile
            // Programm 198, und Aufruf dieser Funktion in Zeile 669 in Programm.

            if(vektorisieren0==JA)
                {
// Kommentar: Bei vektorisieren0 = JA werden ferner die Randlisten zum Senden und Empfangen nach kommunikation_ep_s
// kopiert - fr alle Kerne.
                kommunikation_ep_s.f1_v_vektor_e[i] = randstruktur_kommunikation[i].f1_v_vektor_e;
                kommunikation_ep_s.f2_v_vektor_e[i] = randstruktur_kommunikation[i].f2_v_vektor_e;
                kommunikation_ep_s.g_v_vektor_e[i] = randstruktur_kommunikation[i].g_v_vektor_e;

                kommunikation_ep_s.f_h_vektor_e[i] = randstruktur_kommunikation[i].f_h_vektor_e;
                kommunikation_ep_s.g1_h_vektor_e[i] = randstruktur_kommunikation[i].g1_h_vektor_e;
                kommunikation_ep_s.g2_h_vektor_e[i] = randstruktur_kommunikation[i].g2_h_vektor_e;

                kommunikation_ep_s.f_rs_e[i] = randstruktur_kommunikation[i].f_e;
                kommunikation_ep_s.g_rs_e[i] = randstruktur_kommunikation[i].g_e;

                kommunikation_ep_s.f1_v_vektor[i] = randstruktur_kommunikation[i].f1_v_vektor;
                kommunikation_ep_s.f2_v_vektor[i] = randstruktur_kommunikation[i].f2_v_vektor;
                kommunikation_ep_s.g_v_vektor[i] = randstruktur_kommunikation[i].g_v_vektor;

                kommunikation_ep_s.f_h_vektor[i] = randstruktur_kommunikation[i].f_h_vektor;
                kommunikation_ep_s.g1_h_vektor[i] = randstruktur_kommunikation[i].g1_h_vektor;
                kommunikation_ep_s.g2_h_vektor[i] = randstruktur_kommunikation[i].g2_h_vektor;

                kommunikation_ep_s.f_rs[i] = randstruktur_kommunikation[i].f_rs;
                kommunikation_ep_s.g_rs[i] = randstruktur_kommunikation[i].g_rs;

                kommunikation_ep_s.anzahl_h_vektor_e[i] = &(randstruktur_kommunikation[i].anzahl_h_vektor_e);
                kommunikation_ep_s.anzahl_v_vektor_e[i] = &(randstruktur_kommunikation[i].anzahl_v_vektor_e);
                kommunikation_ep_s.punkteanzahl_e[i] = &(randstruktur_kommunikation[i].punkteanzahl_e);

                kommunikation_ep_s.anzahl_h_vektor[i] = &(randstruktur_kommunikation[i].anzahl_h_vektor);
                kommunikation_ep_s.anzahl_v_vektor[i] = &(randstruktur_kommunikation[i].anzahl_v_vektor);
                kommunikation_ep_s.punkteanzahl[i] = &(randstruktur_kommunikation[i].punkteanzahl);
                }
            else
                {
// Kommunikation bei vektorisieren0 = sortieren werden die Innenrandpunktmengen und die Auenrandpunktmengen fr alle
// Kerne nach kommunikation_ep_s gebracht.
                kommunikation_ep_s.f_i_rs[i] = rand_werte_kommunikation[i].f_rs;
                kommunikation_ep_s.g_i_rs[i] = rand_werte_kommunikation[i].g_rs;
                kommunikation_ep_s.anzahl_i_rs[i] = &(rand_werte_kommunikation[i].anzahl_rs);

                kommunikation_ep_s.f_a_rs[i] = rand_werte_kommunikation[i].f_a_rs;
                kommunikation_ep_s.g_a_rs[i] = rand_werte_kommunikation[i].g_a_rs;
                kommunikation_ep_s.anzahl_a_rs[i] = &(rand_werte_kommunikation[i].anzahl_a_rs);
                }
            }
        }
    }

// Kommentar: Hier erfolgt ein ep - Randaustausch, aber ohne nderung von EP-SNB.
void ParallelesRechnen::randaustausch_ep_neu_ohne_ep_snb_update(void)
    {
// Kommentar: Kopiere feld_aktuell und feld_vergangen von kommunikation_ep_s.
    kommunikation_ep_s.ep_aktuell = feld_aktuell;
    kommunikation_ep_s.ep_vergangen = feld_vergangen;

#ifdef EPS_PFLS
// Kommentar: Kopiere pfl_aktuell und pfl_vergangen von kommunikation_ep_s.
    kommunikation_ep_s.pfl_aktuell = pfl_aktuell;
    kommunikation_ep_s.pfl_vergangen = pfl_vergangen;
#else
#ifdef NEUES_EP_AKTUALISIERUNG
    kommunikation_ep_s.f_aktuell = f_aktuell;
    kommunikation_ep_s.g_aktuell = g_aktuell;
    kommunikation_ep_s.index_aktuell = index_aktuell; // bei diesen 3 Zeilen bin ich mit nicht so klar. 20.10.14
#endif
#endif

#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 1 rang " << rang << endl;
#endif
// Kommentar: Packen die ep_s - da KEP_FV definiert ist sowohl fr feld_aktuell als auch feld_vergangen
    kommunikation_ep_s.packen();
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 2.0 rang " << rang << endl;
#endif
// Kommentar: Die Kommunikation wird gestartet, und es wird bis zum Ende gewartet.
    kommunikation_ep_s.kommunizieren_starten();
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 2.0a rang " << rang << endl;
#endif

    for(;kommunikation_ep_s.kommunikation_fertig()==false;)
        {
        ;
        }
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 3 rang " << rang << endl;
#endif
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << " QWER vor komm_eps_entpacken rang " << rang << endl;
#endif
// Kommentar: Dann wird entpackt, aber ohne EP-SNB zu ndern.
    kommunikation_ep_s.entpacken_ohne_ep_snb_update();
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << " QWER nach komm_eps_entpacken rang " << rang << endl;
#endif
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 4 rang " << rang << endl;
#endif
    }

// Kommentar: Hier erfolgt ein ep - Randaustausch, aber mit nderung von EP-SNB.
// Die Kommentare sind gleich - bis auf das Entpacken.
void ParallelesRechnen::randaustausch_ep_neu(void)
    {
// Kommentar: Kopiere feld_aktuell und feld_vergangen von kommunikation_ep_s.
    kommunikation_ep_s.ep_aktuell = feld_aktuell;
    kommunikation_ep_s.ep_vergangen = feld_vergangen;
    kommunikation_ep_s.ep_snb_update = ep_snb_update;
#ifdef EPS_PFLS
// Kommentar: Kopiere pfl_aktuell und pfl_vergangen von kommunikation_ep_s.
    kommunikation_ep_s.pfl_aktuell = pfl_aktuell;
    kommunikation_ep_s.pfl_vergangen = pfl_vergangen;
#else
#ifdef NEUES_EP_AKTUALISIERUNG
    kommunikation_ep_s.f_aktuell = f_aktuell;
    kommunikation_ep_s.g_aktuell = g_aktuell;
    kommunikation_ep_s.index_aktuell = index_aktuell;
#endif
#endif

#ifdef AUSGABEN_PARALLELES_RECHNEN
    if(vektorisieren0==JA)
        {
        if(rang==3)
            {
            cout << " PR::REP 0 rang 3 randstruktur_kommunikation[2].punkteanzahl " << randstruktur_kommunikation[2].punkteanzahl << " rsk[2].f_rs[0] ";
            cout << randstruktur_kommunikation[2].f_rs[0] << " rsk[2].g_rs[0] " << randstruktur_kommunikation[2].g_rs[0] << endl;
            }
        }
#endif
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 1 rang " << rang << endl;
#endif
// Kommentar: Packen die ep_s - da KEP_FV definiert ist sowohl fr feld_aktuell als auch feld_vergangen
    kommunikation_ep_s.packen();
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 2 rang " << rang << endl;
#endif
// Kommentar: Die Kommunikation wird gestartet, und es wird bis zum Ende gewartet.
    kommunikation_ep_s.kommunizieren_starten();
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 2a rang " << rang << endl;
#endif
    for(;kommunikation_ep_s.kommunikation_fertig()==false;)
        {
        ;
        }
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 3 rang " << rang << endl;
#endif
// Kommentar: Dann wird entpackt, aber mit dem ndern von EP-SNB.
    kommunikation_ep_s.entpacken();
#ifndef EPS_PFLS
#ifdef NEUES_EP_AKTUALISIERUNG
    index_aktuell = kommunikation_ep_s.index_aktuell;
#endif
#endif
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "PR::REP 4 rang " << rang << endl;
#endif
    }

// Kommentar: Im Falle der Sortierung: Gebe den Rand aus.
void ParallelesRechnen::randausgabe(void)
    {
// Kommentar: Im Fall von vektorisieren0 = JA geschieht keine Ausgabe.
    if(vektorisieren0==JA)
        {
        return;
        }
// Kommentar: Ansonsten wird zu jedem anderen Kern Innenrand und Auenrand ausgegeben.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Der Befehl dazu lautet randausgabe_eines(farbe).
            randausgabe_eines(i);
            }
        }
    }

// Kommentar: Zu einem Kern werden Innenrand und Auenrand ausgegeben.
void ParallelesRechnen::randausgabe_eines(int farbe)
    {
#ifdef AUSGABEN_PARALLELES_RECHNEN
// Kommentar: Am Anfang werden rang, die Farbe des Kerns, zu dem man den Rand hat, und die Gitterebene dieser Instanz
// von parallelem Rechnen ausgegeben.
    cout << " Innen / rang " << rang << " farbe " << farbe << " Ebene " << gitterebene;

// Kommentar: Zuerst die Ausgabe des Innenrandes. Zuerst wird die Anzahl an Punkten gelesen.
    anzahl = rand_werte_kommunikation[farbe].anzahl_rs;

// Kommentar: Man durchluft die Liste und gibt die Koordinaten (f,g) aus.
    for(kk=0; kk<anzahl; kk++)
        {
        cout << " f " << rand_werte_kommunikation[farbe].f_rs[kk] << " g " << rand_werte_kommunikation[farbe].g_rs[kk] << " ";
        }
    cout << endl;

// Kommentar: Dann macht man das Ganze noch einmal fr den Auenrand.
    cout << " Aussen / rang " << rang << " farbe " << farbe << " Ebene " << gitterebene;

    anzahl = rand_werte_kommunikation[farbe].anzahl_a_rs;

    for(kk=0; kk<anzahl; kk++)
        {
        cout << " f " << rand_werte_kommunikation[farbe].f_a_rs[kk] << " g " << rand_werte_kommunikation[farbe].g_a_rs[kk] << " ";
        }
    cout << endl;

// Kommentar: Und dann macht man das ganze fr die nicht sortierten Randpunkte der Klasse Gitter - im Gegensatz dazu
// wurden eben die Informationen aus der Klasse 'rand_werte_kommunikation' beschafft.

    cout << " Innen2 / rang " << rang << " farbe " << farbe << " Ebene " << gitterebene;


    anzahl = anzahl_rs[farbe];
    for(kk=0; kk<anzahl; kk++)
        {
        cout << " f " << f_rs[farbe][kk] << " g " << g_rs[farbe][kk] << " ";
        }
    cout << endl;
    cout << " Aussen2 / rang " << rang << " farbe " << farbe << " Ebene " << gitterebene;
    anzahl = anzahl_a_rs[farbe];
    for(kk=0; kk<anzahl; kk++)
        {
        cout << " f " << f_a_rs[farbe][kk] << " g " << g_a_rs[farbe][kk] << " ";
        }
    cout << endl;
#endif
    }

// Kommentar: Hier geschieht auch ein Randaustausch von ep. Aber das her wird nicht bitweise gepackt.
// Dennoch kann das hier benutzt werden, weshalb es kommentiert wird.
void ParallelesRechnen::randaustausch_ep(void)
    {
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "Randaustausch_ep 00 / rang " << rang << endl;
#endif
// Kommentar: Der Zeiger auf feld_aktuell wird kopiert.
    ep_aktuell = feld_aktuell;
#ifdef AUSGABEN_PARALLELES_RECHNEN
    cout << "ep_aktuell[0][0] " << ep_aktuell[0][0] << endl;
#endif
// Kommentar: Falls der Rand mit Hilfe der Vektorbertragung geschieht.
    if(vektorisieren0==JA)
        {
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep A01 / rang " << rang << endl;
#endif
// Kommentar: Packe die ep - Information in der Klasse Randstrukturkommunikation.
        packen_ep();
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep A02 / rang " << rang << endl;
#endif
// Kommentar: Starte die Kommunikation, und warte, bis sie fertig ist.
        kommunikation_starten_ep();

        for(;ist_fertig_ep()==false;)
            {
            ;
            }
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep A03 / rang " << rang << endl;
#endif
// Kommentar: Entpacke diese Information in der Klasse Randstrukturkommunikation.
        entpacken_ep();
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep A04 / rang " << rang << endl;
#endif
        }
    else
        {
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep B01 / rang " << rang << endl;
#endif
// Kommentar: Packe die ep - Information in der Klasse Randwertekommunikation.
        packen_ep2();
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep B02 / rang " << rang << endl;
#endif
// Kommentar: Starte die Kommunikation, und warte, bis sie fertig ist.
        kommunikation_starten_ep2();

        for(;ist_fertig_ep2()==false;)
            {
            ;
            }
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep B03 / rang " << rang << endl;
#endif
// Kommentar: Entpacke diese Information in der Klasse Randwertekommunikation.
        entpacken_ep2();
#ifdef AUSGABEN_PARALLELES_RECHNEN
        cout << "Randaustausch_ep B04 / rang " << rang << endl;
#endif
        }
    }

// Kommentar: Hier werden u0 - Ausgaben gemacht zu Debugging - Zwecken.
void ParallelesRechnen::u0_testen(int t, char * text)
    {
#ifdef U0_TESTEN
    cout << " u0_testen Anfang / rang " << rang << " ebene " << gitterebene << " t " << t << " text " << text << endl;
    for(anfangsposition(); ist_fertig_fl()==false; naechster())
        {
        i = lesen_f();
        j = lesen_g();

        if((i==7)&&(j==9)&&(gitterebene==2)&&(t==2))
            {
            if(strcmp(text, "MLAT_1_oben anfang ")==0)
                {
                u0_ausgabe_drum_herum(t, text);
                }
            }

        if((rang==1)&&(i==14)&&(j==19)&&(gitterebene==1))
            {
            if(strcmp(text, "MLAT_1_unten ende ")==0)
                {
                u0_ausgabe_drum_herum(t, text);
                }
            }

        }
#endif
    }

// Kommentar: Hier werden u0 - , e0 - , rS0 - , f0 - Ausgaben gemacht zu Debugging - Zwecken.
void ParallelesRechnen::u0_ausgabe_drum_herum(int t, char * text)
    {
    cout << " (u0,e0) von (" << i-1 << "," << j-1 << ") bis (" << i+1 << "," << j+1 << ") auf P" << rang << " mit Zeitpunkt t " << t << " " << text << " Ebene " << gitterebene << endl;
    for(k=-1; k<=1; k++)
        {
        for(l=-1; l<=1; l++)
            {
            cout << "(" << u0[k+i][l+j] << "," << e0[k+i][l+j] << "," << rS0[k+i][l+j] << "," << f0[k+i][l+j] <<  ")";
            }
        cout << " Ebene " << gitterebene << endl;
        }
    cout << endl << " Ende dieser Matrix " << endl;
    }
