#ifndef PRECOMPUTATION
#define PRECOMPUTATION

#include <mpi.h>
#include "identify.h"
#include <stdlib.h>

class Precomputation : virtual public Identify
    {
private:
    int eigene_last, eigene_last_oben;
public:
    int lambda, lambda_oben;
private:
    void kommunikation_west_starten_mit(void);
private:
    int sendebuffer_westen[2];
    int sendebuffer_osten[2];
    int sendebuffer_norden[2];
    int sendebuffer_sueden[2];
    int empfangsbuffer_osten[2];
    int empfangsbuffer_westen[2];
    int empfangsbuffer_norden[2];
    int empfangsbuffer_sueden[2];
private:
    int flag;
    MPI_Status status;
    MPI_Request sende_request_osten;
    MPI_Request sende_request_westen;
    MPI_Request sende_request_norden;
    MPI_Request sende_request_sueden;
    MPI_Request empfange_request_osten;
    MPI_Request empfange_request_westen;
    MPI_Request empfange_request_norden;
    MPI_Request empfange_request_sueden;
private:
    int teilsumme_westen, teilsumme_westen_oben, teilsumme_osten, teilsumme_osten_oben;
private:
    void empfange_osten_mit(void);
    void empfange_osten_ohne(void);
    void empfange_westen_mit(void);
    void empfange_westen_ohne(void);
    void berechne_lambdas_ow_mit(void);
private:
public:
    int lambda_west, lambda_west_oben;
    int lambda_ost, lambda_ost_oben;
public:
    Precomputation(void);
private:
    int gemeinsame_last_vektor[2];
    int gemeinsame_last;
    int gemeinsame_last_oben;
public:
    void tun_mit(int _eigene_last, int _eigene_last_oben);
    void tun_ohne(int _eigene_last);
    void tun_ow_mit(void);
    void tun_ow_ohne(void);
    void tun_ns_mit(void);
    void tun_ns_ohne(void);
private:
    void kommunikation_ow_mit(void);
    void kommunikation_ow_ohne(void);
private:
    void berechne_lambdas_ow_ohne(void);
private:
    void kommunikation_ns_mit(void);
    void kommunikation_ns_ohne(void);
    void berechne_lambdas_ns_mit(void);
    void berechne_lambdas_ns_ohne(void);

    void empfange_sueden_mit(void);
    void empfange_sueden_ohne(void);
    void empfange_norden_mit(void);
    void empfange_norden_ohne(void);
private:
    int teilsumme_norden, teilsumme_norden_oben, teilsumme_sueden, teilsumme_sueden_oben;
private:
public:
    int lambda_nord, lambda_nord_oben;
    int lambda_sued, lambda_sued_oben;
private:
    void kommunikation_ns_mit_2(void);
    void kommunikation_ow_mit_2(void);
    void kommunikation_ns_ohne_2(void);
    void kommunikation_ow_ohne_2(void);
    void berechne_lambdas_ow_mit_2(void);
    void berechne_lambdas_ns_mit_2(void);
    void berechne_lambdas_ow_ohne_2(void);
    void berechne_lambdas_ns_ohne_2(void);
    };

#endif
