#ifndef PROGRAMM
#define PROGRAMM 1

#include "lastausgleich.h"

#include "adaptive_verfeinerung.h"

#include "ausgaben.h"

#include "parallel_ausgeben_ii.h"

#include "timer.h"

#include "zyklus_rechnen.h"

#include "uebertrage_gitterwerte.h"

#include "multi_level_randuebertragung.h"

#include "liste.h"

#include "auf_ab.h"

#include "lastausgleichssteuerung.h"

#include "strategie_tester.h"

#include "gemeinsame_buffer.h"

#include "adaptive_verfeinerung.h"
#include "update_pt_schnell.h"
#include "update_pt_schnell_lwk.h"

#include "punktemenge.h"

#include <iostream>
#include <fstream>
#include <string.h>

#include "prozessor_topologien.h"

using namespace std;

#include "datei_ausgabe.h"

#include "schreibe_gp_datafile.h"
#include "schreibe_gp_commandfile.h"

#include "grosse_lastausgleichssteuerung.h"

#include "lwk_anzahl_bestimmen.h"

#include "punkt_feld_liste_werte.h"

#include "PLB.h"

#ifndef KEIN_TUN
#define KEIN_TUN 1
#endif

#ifndef ERST_NS_DANN_WO
#define ERST_NS_DANN_WO 2
#endif

#ifndef NUR_NS
#define NUR_NS 3
#endif

#ifndef ERST_WO_DANN_NS
#define ERST_WO_DANN_NS 4
#endif

#ifndef NUR_WO
#define NUR_WO 5
#endif

#ifndef SELBER_ENTSCHEIDEN
#define SELBER_ENTSCHEIDEN 6
#endif

#ifndef FEHLER_LA
#define FEHLER_LA -1
#endif

class Programm :   virtual public ZyklusRechnen
    {
private:
    LastAusgleich lastausgleich;
public:
    void tun (int _n, int _m, int _h_max, int _h_min, int _groesse, int _rang, int verfeinerungstyp, int _h_kappe, Liste liste_auf, Liste liste_ab, Liste liste_oben, int lt_variante, int _lt_anzahl, AufAb * _auf_ab, int _plb_kn, int _mit_ohne, int _matrix_vektor, int _vektorisieren, int _wertekontrollebene, int _adaptiver_zyklus, int _rand_typ, bool _mit_ohne_ep, int _womit_verknuepfen, int _mue1, int _mue2, double _krit_grenze);

private:
    int i, j, k, l;

private:
    int groesse, rang;
private:
    int h_max;
    int h_min;
    int h_gesamt;
    int h_gesamt_variante;
    int n_hilfe, m_hilfe;
    int rand_typ;
    bool mit_ohne_ep;

private:
    int jj, ll;
    int m, n;
    ParallelesRechnen * paralleles_rechnen_h_minus1;
    ParallelesRechnen * paralleles_rechnen_h;
    int ID_vorher, ID_nachher;
private:
    int ii, a, b, kk, kkk;
    int * hilfsbuffer;
private:
    int farbenfeldfarbenfeld;
private:
    #ifdef dimensionen1
    double wert1;
    double ** x0;
    #endif
    #ifdef dimensionen2
    double wert1, wert2;
    double ** x0, ** x1;
    #endif
    #ifdef dimensionen3
    double wert1, wert2, wert3;
    double ** x0, ** x1, ** x2;
    #endif
    #ifdef dimensionen4
    double wert1, wert2, wert3, wert4;
    double ** x0, ** x1, ** x2, ** x3;
    #endif
    double ** u0, ** u0_h, ** u0_h_minus1;

private:
    Werte1d * hilfsbuffer_w;
    int f, g;
private:
    int nn, mm;
    int n_minus1, m_minus1;
    int ** rand_markierungsfeld;
    int * f_markierungsfeld, * g_markierungsfeld;
    int m_index;
private:
#ifdef KURZ_FF
    short int ** farbenfeld_h, ** farbenfeld_h_minus1;
#else
    int ** farbenfeld_h, ** farbenfeld_h_minus1;
#endif
private:
    int anfang;
private:
    #ifdef dimensionen1
    double ** x0_h, ** x0_h_minus1;
    double ** y0_h, ** y0_h_minus1;
    #endif
    #ifdef dimensionen2
    double ** x0_h, ** x0_h_minus1;
    double ** x1_h, ** x1_h_minus1;
    #endif
    #ifdef dimensionen3
    double ** x0_h, ** x0_h_minus1;
    double ** x1_h, ** x1_h_minus1;
    double ** x2_h, ** x2_h_minus1;
    #endif
    #ifdef dimensionen4
    double ** x0_h, ** x0_h_minus1;
    double ** x1_h, ** x1_h_minus1;
    double ** x2_h, ** x2_h_minus1;
    double ** x3_h, ** x3_h_minus1;
    #endif
private:
    void verfeinerungsgitter_definieren(int simulationsnummer);
    int f_oben, f_unten, g_links, g_rechts;
private:
    void bilden(int f, int g);
    int h, hh, hhh;

private:
    void eines_aufloesen(int f, int g);
    int ff, gg;

    int h_minus1;
    int randlaenge;
private:
    int c;
    int iterationen;
private:
    int ** IDs;
private:
    double start_zeit, ende_zeit;
    ParallelAusgebenII parallel_ausgeben_ii;
    Timer timer1, timer2, timer_rest1, timer_rest2, timer3, timer4, timer5, timer_aufloesen, timer_einfuegen;
    Timer timer_aendern;
    Timer timer_la, timer_av, timer_grobgitterzyklus, timer_nachbereitung;
    Timer timer_wertekontrolle;
    Timer timer_gp_datafile_schreiben;
    Timer timer_mlat_3_bis_4_unten;
    Timer timer_verf_gitter_def;
    Timer timer_tests;
    Timer timer_runter_rechnen;
    Timer timer_ep_bestimmen;
    Timer timer_pt_rand;
    Timer timer_schieben;
    Timer timer_bestimme_innenpunkte;
    Timer timer_restriktion0;
    Timer timer_mlat1_unten;
    Timer alles;

private:
    int ** ist_nachbar;
    int * ist_nachbar_ml;

private:
    int laenge;
private:
    int anzahl_rand_innen;
#ifdef KURZ_PUNKTE
    short int * f_rand_innen, * g_rand_innen;
#else
    int * f_rand_innen, * g_rand_innen;
#endif
//  Kommentar: ZaehleFarben wird in aufloesen deklariert, weil es einerseits dort gebraucht wird, und andererseits
//  hiernach ableitet. Das ist eine praktische Wahl.
private:
    UebertrageGitterwerte uebertrage_gitterwerte;
    UebertrageGitterwerte uebertrage_gitterwerte_2;
    int h_kappe_plus1;
private:
    void koordinaten_sammeln(int h);
    void koordinaten_eintragen_und_werte_sammeln(int h);
    void werte_sammeln(int h);
    #ifdef KURZ
    short int * koordinaten;
    #else
    int * koordinaten;
    #endif
    void werte_verstreuen(int h);
private:
    MultiLevelRanduebertragung multi_level_randuebertragung;
    void multi_level_buffer_verknuepfen(void);
    void multi_level_randuebertragung_tun2(void);
    void multi_level_randuebertragung_tun3(void);
    void vorbereitung(int i);
    void vorbereitung2(int i);
    void vorbereitung3(int i);
    void vorbereitung4(int ebene);
    int * multi_level_indizes;
    int multi_level_anfangsindex;
    int multi_level_index;
    void multi_level_einfuegen2(int i);
    int * sende_flag_feld, * empfangs_flag_feld;
private:
    bool gesamttest(void);
private:
    void ist_nachbar_ausgeben(void);
    int f_2, g_2;
private:
    void aktualisiere_ist_nachbar(void);
private:
    ExtremeVektoren * ev2_h_minus1, * ev_h_minus1;
private:
    int lt_anzahl;
private:
    void grober_zyklus_flexibel(void);
    void grober_zyklus_flexibel_nicht_adaptiv(void);
    void grober_zyklus_flexibel_swe(void);
private:
    AufAb * auf_ab;
private:
    int markiere_oben;
private:
    int plb_kn, mit_ohne, matrix_vektor;
private:
    LastAusgleichsSteuerung lastausgleichssteuerung;
    GrosseLastAusgleichsSteuerung grosse_lastausgleichssteuerung;
private:
    void lt_durchfuehren_wo(int kk);
    void lt_durchfuehren_ns(void);
    int lt_variante;
private:
    int eigene_last, eigene_last_oben;
private:
    void update_oben_wo(void);
    void update_oben_ns(void);
private:
    int west_differenz, ost_differenz, west_differenz_oben, ost_differenz_oben;
    int nord_differenz, sued_differenz, nord_differenz_oben, sued_differenz_oben;
private:
    int h_schranke;
private:
    StrategieTester strategie_tester;
    int m_merken, n_merken;
    bool strategie_testen(void);
private:
    bool teste_uebereinander(int gitterebene);
private:
    int vektorisieren;
    int wertekontrollebene, wertekontrollebene_speichern;
public:
    ifstream ein;
    ofstream * aus;
private:
    double vergleichswert1, vergleichswert2, vergleichswert3, vergleichswert4;
private:
    int n_speichern;
private:
    double ** wk_x0, ** wk_x1, ** wk_x2, ** wk_x3;
private:
    GemeinsameBuffer gemeinsame_buffer;
private:
    void tester(char * text);
private:
    int adaptiver_zyklus;
private:
    bool ** ri_feld;
    bool ** ri_grob_feld;
    int n_grob, m_grob;
private:
    short int * merken_f, * merken_g, merken_index;
private:
    short int * f1, * f2, * g1, * g2, * f3, * g3, * f4, * g4, ** testfeld4;
    AdaptiveVerfeinerung * adaptive_verfeinerung;
    void adaptive_verfeinerung_initialisieren(void);
    void adaptive_verfeinerung_finalisieren(void);
private:
    int * ebenen_zaehler;
    int * PT_feingitter;
    int * ist_nachbar_zaehler_ml; // ml = multi-level
private:
    int mn;
    short int *** selbstnachbarn_ep;
private:
    PunkteMenge * punktemengen;
    short int * f_pm, * g_pm;
public:
    bool punkt_aenderung_dynamisch;
private:
    ProzessorTopologien prozessor_topologien;
private:
    void PT_verknuepfen(int _womit_verknuepfen);
    void PT_entknuepfen(void);
    int verteilt_h_max;
    void setze_ist_nachbar_auf_0(void);
    void setze_ist_nachbar_auf_0_fuer_k_minus_1(void);
    void update_PT_rand(void);
    UpdatePTschnell * update_pt_schnell;
    UpdatePTschnellLwK * update_pt_schnell_lwk;
    int hilfe;
    void update_PT_schnell_rand_eine_ebene(int ebene);
    void update_PT_schnell_rand(void);
    void update_PT_schnell_rand_ohne_lwk(void);
    void update_PT_schnell_rand_nach_adapt(void);
    void update_PT_schnell_rand_nach_adapt_optimieren(void);
    void update_PT_schnell_rand_nach_adapt_alt(void);
    void update_PT_gemischt_rand(int h);
private:
    int womit_verknuepfen;
private:
    void ausgeben_groesse(void);
private:
    ParallelAusgeben parallel_ausgeben;
private:
    void kleine_vorbereitung(void);
private:
    DateiAusgabe da_programm;
    DateiAusgabe da_eez;
private:
    void dynamischer_rand_leer(char * stelle);
private:
    void lastausgleich_programm(int kk);
    void lastausgleich_programm_nicht_immer_LA(int kk);
    void lastausgleich_programm_immer_LA(int kk);
private:
    void ev_ausgaben(void);
private:
    int * ep_ebenen;
    int * ep_ebenen2;
    int ep_ebenen_hw;
private:
    int datafile_zaehler;
public:
    bool gp_ausgabe;
    bool gp_mit_io;
private:
    SchreibeGPDatafile schreibe_gp_datafile;
    void gp_datafile_schreiben(void);
    SchreibeGPCommandfile schreibe_gp_commandfile;
private:
    void test_uebereinander(void);
private:
    void teste_dynamischen_rand(void);
private:
    void teste_SNB(void);
private:
    void ev_tests(void);
    void ev_test(void);
    void ev2_test(void);
    int f_s, g_s, ff_s, gg_s;
    void zweiter_ev2_test(void);
    void erster_ev2_test(void);
    int tiefster_punkt(int f, int g);

private:
    FeldListe * dynamischer_rand;
    short int * ff1, * ff2, * gg1, * gg2;
private:
    short int * punkte_f, * punkte_g;
private:
    void fgff_test(char * ausgabe);
    void fgff_test2(char * ausgabe);
    void ep_plus_test(char * ausgabe);
private:
public:
    int iterationsgesamtzahl;
private:
    void ausgeben_farbenfelder(char * text);
public:
    int ev_typen;
private:
    bool ev_gilt;
    bool ev2_gilt;
private:
    void PT_ausgabe(char * text);
private:
    void test_125(void);
    void test_116(char * text, int k);
public:
    int simulationsnummer;
private:
    void verfeinerungsgitter_definierenEINGITTER(void);
    void verfeinerungsgitter_definierenEINGITTER_BESCHRAENKT(void);
    void verfeinerungsgitter_definierenEINGITTER_GROSS(void);
    void verfeinerungsgitter_definierenEINGITTER_UNBEWEGT(void);
    void verfeinerungsgitter_definierenAUFSCHLAG(void);
    void verfeinerungsgitter_definierenZUSAMMENSTOSS(void);
    void verfeinerungsgitter_definierenKOMPLETT(void);
private:
    void w_ausgabe(char * text);
private:
    double summe_zeiten;
private:
    double ** arbeit;
    int * f_arbeit, * g_arbeit;
    int anzahl;
private:
    void differenzen_uebertragen_MIT_ns(void);
    void differenzen_uebertragen_MIT_wo(void);
    void differenzen_uebertragen_OHNE_ns(void);
    void differenzen_uebertragen_OHNE_wo(void);
    void differenzen_ausgeben(void);
    void differenzen_ausgeben_wo(void);
private:
    int anteil10, anteil210, anteil410;
private:
    int iii;
public:
    bool immer_LA;
    int entscheide_matrix;
private:
    void erst_ns_dann_wo_OHNE(void);
    void erst_wo_dann_ns_OHNE(void);
    void erst_ns_dann_wo_MIT(void);
    void erst_wo_dann_ns_MIT(void);
private:
    int welcher_fall;
private:
    char zeichenkette[140];
    int systemwert;
private:
    void sprung(void);
public:
    int uebergebe_vgitter;
public:
    bool sortieren_testen_flag;
private:
    void notiz(char * text);
private:
    void fgff_testen18_1(char * text);
private:
    void ueberpruefe_ep_s(char * text);
    void test_feld_vergangen_373(char * text);
    void test_feld_vergangen_385(char * text);
public:
    bool testen_ep_snb;
private:
    void test_ep_minus(char * text);
    PunktFeldListe * ep_minus;
private:
    inline void eigene_last_oben_bestimmen(int kk);
    inline void eigene_last_bestimmen(int kk);
private:
    void setze_felder(void);
private:
    bool ist_oben;
private:
    void grosser_lastausgleich_programm(int kk);
    void grosser_lastausgleich_programm_wo(int kk);
    void grosser_lastausgleich_programm_ns(int kk);
public:
    bool gL;
private:
    int * lasten_mit_drunter, * lasten_ohne_drunter;
    int farbe;
    void lasten_sammeln(void);
public:
    bool immer_oben_la;
public:
    bool lastwerte_korrektur;
public:
    int lwk_typ;
    int lwk_intervall_laenge, lwk_intervall_anfang;
private:
    void setzen_flag_lwk_vollpunkt(bool lwk_vollpunkt);
public:
    bool oben_nicht_adaptiv;
private:
    bool momentan_lwk_vollpunkt;
private:
    int anzahl_verfeinerungsebenen_ab_0;
private:
    LwKAnzahlBestimmen * lwk_anzahl_bestimmen;
public:
    char * auswertung_dateiname;
public:
    bool echtes_plb;
private:
    PLB_Klasse plb;
    void plb_lastausgleich_programm(int kk);
    void plb_lastausgleich_programm_nur_eines(int kk);
    void grosser_lastausgleich_programm_wo_plb(int kk);
    void grosser_lastausgleich_programm_ns_plb(int kk);
private:
    void test386(char * text);
private:
    DateiAusgabe da;
    int lar_ow, lar_ns;
    void ausgabe_plb(void);
private:
    short int plb_reduce_send[2], plb_reduce_recv[2];
    int anzahl_wo, anzahl_ns;
private:
    void w_ausgabe3(void);
public:
    bool ist_zusammen_aV_LA;
public:
    double verf_krit;
    double verf_krit_1;
    double verf_krit_2;
    double t_konst;
public:
    bool balancen;
private:
    char texta[100];
public:
    int gp_ausgabe_mod;
    int counter;
private:
    double zeit;
public:
    bool gp_mit_aufteilung;
private:
    int returnwert_system;
private:
    DateiAusgabe da_programm2;
private:
    bool reverser_la;
private:
    int hilfsvariable;
private:
    PunktFeldListe * was_ist_geloescht;
public:
    bool glas_option; // GroeLastAusgleichsSteuerung mit Option
private:
    void bestimme_innenpunkte_alle_ebenen(void);
private:
    void abschluss_senden_werte_verstreuen(void);
    bool ist_abgeschickt;
private:
    void aktualisiere_PT_durch_rand(void);
private:
    void pruefen1(char * text);
    void pruefen2(char * text);
private:
    void lastausgleich_programm_2Kerne(int kk);
private:
    double laufzeit, * laufzeiten, max_laufzeit;
    ofstream * da_laufzeiten;
public:
    double wert_pause;
public:
    double ** u0_gp_daten;
    int n_h_min, m_h_min;
private:
    void koordinaten_und_werte_sammeln_2(int h);
private:
    void pruefe_gittermasse(int punktanzahl, int gitterebenen);
    int hilfswert;
    };

#endif
