#include "prolongation.h"

//  Prolongiert wird, indem unten die Koordinaten durchgegangen werden, und je nach Fall von
//  oben die Werte dazu genommen werden. Prolongation[0] prolongiert von 1 auf 0, vgl. ZyklusRechnen.

// Kommentar: Diese Funktion dient Debugging - Zwecken: Die Menge neuer Punkte - also durch die parallele adaptive Verfeinerung
// bestimmte neue Punkte - wird hier ausgegeben. Denn: Die Prolongation wird fr neue Punkte anders ausgefhrt.

void Prolongation::ausgabe_neue_punkte(int untere_ebene)
    {
#ifdef AUSGABEN_PROLONGATION
    cout << " Ausgabe neue Punkte untere_ebene " << untere_gitterebene << " rang " << rang << " t " << t << endl;
    festgestellt = false;
/*
    if(untere_gitterebene==0)
        {
        if(neuer_punkt->feld[52][38]==true)
            {
            cout << " AAA rang " << rang << endl;
            }
        }
*/
// Kommentar: Die Randpunktmenge auf dem feineren Gitter wird durchlaufen, und im Fall, dass ein neuer Punkt darunter ist
// wird der ausgegeben.
    for(i=0; i<anzahl_rand_innen_unten; i++)
        {
        ff = f_rand_innen_unten[i];
        gg = g_rand_innen_unten[i];

        if(neuer_punkt->feld[ff][gg]==true)
            {
            cout << "(" << ff << "," << gg << ")";
            if((ff==22)&&(gg==47))
                {
                festgestellt = true;
                }
            }

        }

// Kommentar: Die Innenpunktmenge auf dem feineren Gitter wird durchlaufen, und im Fall, dass ein neuer Punkt darunter ist
// wird der ausgegeben.
    for(i=0; i<anzahl_innen_unten; i++)
        {
        ff = f_innen_unten[i];
        gg = g_innen_unten[i];

        if(neuer_punkt->feld[ff][gg]==true)
            {
            cout << "(" << ff << "," << gg << ")";
            if((ff==22)&&(gg==47))
                {
                festgestellt = true;
                }
            }
        }

    cout << endl;

    if(festgestellt==true)
        {
        cout << " ZZZ untere_ebene " << untere_gitterebene << " rang " << rang << " t " << t << endl;
        }

    cout << " Ende Ausgabe neue Punkte " << endl;
#endif
    }

// Kommentar: Hier wird eine Prolongation fr den Fall durchgefhrt, dass das feinere Gitter genau auf der Ebene h_kappe ist.
// Insbesondere ist die bi_quadratische Interpolation dann sequentiell, und nicht adaptiv.
// Bemerkung: Die Variablen, fr die diese Interpolation durchgefhrt wird, mssen vorher verknpft werden. Durchgefhrt wird diese
// Interpolation mit dem Ziel u0_unten auf dem feinen Gitter, sowie der Quelle u0_oben auf dem groben Gitter.
void Prolongation::bi_quadratische_interpolation_kappe(void)
    {
#ifdef AUSGABEN_DATEI_101214
    da_zr->oeffnen();
    * da_zr->aus << " bi_quad_inter_kappe anzahl " << anzahl_kappe << " ";
#endif

// Kommentar: Die Punktmenge der Kappe wird durchlaufen.
    for(i=0; i<anzahl_kappe; i++)
        {
        ff = f_kappe[i];
        gg = g_kappe[i];

#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "(" << ff << "," << gg << ")";
#endif
        // Test auf innere Punkte

// Kommentar: Die Grobgitterkoordinaten zu den bestimmten Koordinaten werden bestimmt. Da im allgemeinen kein gemeinsamer Punkt
// vorliegt, liegen Grobgitterpunkt und Feingitterpunkt im allgemeinen auch versetzt. Das bercksichtigt aber die
// bi - quadratische Interpolation
        ff2 = ff >> 1;
        gg2 = gg >> 1;


// Kommentar: Nun wird die bi quadratisch Interpolation zu Feingitterkoordinaten und Grobgitterkoordinaten durchgefhrt. Und bezgl. der
// Feingittervariablen u0_unten als Ziel der Interpolation, und u0_oben als Quelle der Interpolation.
        bi_quad_interpolation();
        }
#ifdef AUSGABEN_DATEI_101214
    * da_zr->aus << endl;
    da_zr->schliessen();
#endif
    }

// Kommentar: Hier wird die bi_quadratische Interpolation fr die Randpunktmenge des feineren unteren Gitters durchgefhrt. Es ist korrekt, auf dem unteren
// Gitter zwischen Rand und Innerem zu unterscheiden, denn fr den Randaustausch wird gg_u0 bzw. gg_e0 durchgefhrt fr die Feingitterpunktrandmenge.
// Inneres unten erfllt die Eigenschaft, dass die Grobgitterpunkte darber schon vor dem Randaustausch da sind.
void Prolongation::bi_quadratische_interpolation_rand(void)
    {
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " BCDE bi_quad_inter_rand ariu " << anzahl_rand_innen_unten << " " << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    da_zr->oeffnen();
    * da_zr->aus << " bi_quad_inter_rand ariu " << anzahl_rand_innen_unten << " ";
#endif
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " BCDE nach da_zr " << endl;
#endif
// Kommentar: Der untere Rand wird durchlaufen.
    for(i=0; i<anzahl_rand_innen_unten; i++)
        {
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 1 " << endl;
#endif
        ff = f_rand_innen_unten[i];
        gg = g_rand_innen_unten[i];

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 2 " << endl;
#endif

#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "(" << ff << "," << gg << ")";
#endif
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 3 " << endl;
#endif

        // Test auf innere Punkte

// Kommentar: Der zugehrige Grobgitterpunkt - der ggf. versetzt ist - wird bestimmt.
        ff2 = ff >> 1;
        gg2 = gg >> 1;

//        bi_quad_interpolation(); Diese Zeile am 27.06.2014 durch die folgenden Zeilen ersetzt:
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " BCDE ff " << ff << " gg " << gg << endl;
#endif
// Kommentar: Falls der Gitterpunkt auf dem feinen Gitter schon existiert hat, dann fhre die normalen bi-quadratische Interpolation
// bzgl. der Variablen u0 auf dem groben und feinen Gitter aus.
        if(neuer_punkt->feld[ff][gg]==false)
            {
            bi_quad_interpolation();
            }
// Kommentar: Ansonsten mache eine Interpolation von u0 auf dem groben Gitter nach e0 auf dem feinen Gitter, und setze auf dem feinen Gitter u0 auf 0.
// Was fr neue Punkte numerisch der beste Startwert ist, ist aber eine numerische Fragestellung.
        else
            {
            bi_quad_interpolation_u0e0();
            u0_unten[ff][gg] = 0;
            }
        }
#ifdef AUSGABEN_DATEI_101214
    * da_zr->aus << endl;
    da_zr->schliessen();
#endif

////////////////////////////////////////////////////////////////////////////////////

// Kommentar: Bei dem Rand unten geht es auch immer um den echten Rand. Auch der ist abzuarbeiten. Da der fr jeden Gitterpunkt
// genauso wie der andere Rand abzuarbeiten ist, braucht er nicht kommentiert zu werden. Die Kommentare wren dieselben.
    for(i=0; i<anzahl_rand_innen_unten_echter_rand; i++)
        {
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 1 " << endl;
#endif
        ff = f_rand_innen_unten_echter_rand[i];
        gg = g_rand_innen_unten_echter_rand[i];

        if((ff==22)&&(gg==47))
            {
            cout << " BBB Typ 2 rang " << rang << endl;
            }
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 2 " << endl;
#endif

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 3 " << endl;
#endif

        ff2 = ff >> 1;
        gg2 = gg >> 1;

//        bi_quad_interpolation(); Diese Zeile am 27.06.2014 durch die folgenden Zeilen ersetzt:
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " BCDE ff " << ff << " gg " << gg << endl;
#endif
        if(neuer_punkt->feld[ff][gg]==false)
            {
            bi_quad_interpolation();
            }
        else
            {
            bi_quad_interpolation_u0e0();
            u0_unten[ff][gg] = 0;
            }
        }
    }

// Kommentar: Hier wird die bi_quadratische Interpolation fr die Innenpunktmenge des feineren unteren Gitters durchgefhrt. Es ist korrekt, auf dem unteren
// Gitter zwischen Rand und Innerem zu unterscheiden, denn fr den Randaustausch wird gg_u0 bzw. gg_e0 durchgefhrt fr die Feingitterpunktrandmenge.
// Inneres unten erfllt die Eigenschaft, dass die Grobgitterpunkte darber schon vor dem Randaustausch da sind.
void Prolongation::bi_quadratische_interpolation_innen(void)
    {
#ifdef AUSGABEN_PROLONGATION
    cout << "BQ anzahl_innen_unten " << anzahl_innen_unten << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    da_zr->oeffnen();
    * da_zr->aus << " bi_quad_inter_innen aiu " << anzahl_innen_unten << " ";
#endif
// Kommentar: Man durchluft die Innenpunktmenge des feineren Gitters.
    for(i=0; i<anzahl_innen_unten; i++)
        {
        ff = f_innen_unten[i];
        gg = g_innen_unten[i];

        if((ff==22)&&(gg==47))
            {
            cout << " BBB Typ 0 rang " << rang << endl;
            }
#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "((" << ff << "," << gg << "))";
#endif

// Kommentar: Die Innenrandpunktmenge hat per Definition einen Selbstnachbarnwert auf seinen Koordinaten von 255.
        if(selbstnachbarn[ff][gg]!=255)
            {
            continue;
            }
#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "(" << ff << "," << gg << ")";
#endif
        // Test auf innere Punkte

        ff2 = ff >> 1;
        gg2 = gg >> 1;

#ifdef AUSGABEN_PROLONGATION
        cout << " (" << ff << " " << gg << ") ";
#endif

// Kommentar: Nun kommt eine Interpolation in einer Weise dran, wie sie schon bei der Randpunktmenge kommentiert worden ist.
// Also kann man die Kommentare von dort bernehmen.
        if(neuer_punkt->feld[ff][gg]==false)
            {
#ifdef AUSGABEN_DATEI_101214
            * da_zr->aus << "*";
#endif
            bi_quad_interpolation();
            }
        else
            {
#ifdef GEMEINSAME_PROLONGATION
            bi_quad_interpolation_u0e0(); // Das andere macht keinen Sinn.
#else
#ifdef AUSGABEN_DATEI_101214
            * da_zr->aus << "#";
#endif
            bi_quad_interpolation_u0e0();
#endif
            u0_unten[ff][gg] = 0;
            }
        }
#ifdef AUSGABEN_PROLONGATION
    cout << "BQ Ende " << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    * da_zr->aus << endl;
    da_zr->schliessen();
#endif
    }

// Kommentar: Hier wird die bi quadratische Interpolation durchgefhrt. Die Bedingungen sind so:
// Die Zielvariable auf dem feinen Gitter ist u0_unten, die Quellvariable ist u0_oben auf dem grober Gitter. An Koordinaten wird
// verwendet: (ff,gg) ist die Feingitterkoordinate, und (ff2,gg2) ist die zugehrige Grobgitterkoordinate, wobei beide
// Punkte versetzt zueinander sein knnen.
void Prolongation::bi_quad_interpolation(void)
    {
// Kommentar: Wenn ein gemeinsamer Punkt vorliegt ...
    if((ff&1)==0)
        {
        if((gg&1)==0)
            {
            #ifdef dimensionen1
// Kommentar: Dann kopiere direkt den Wert vom groben Gitter aufs feine Gitter.
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
// Kommentar: aktiv ist standardmig auf false eingestellt.
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            y2_unten[ff][gg] = y2_oben[ff2][gg2];
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            y2_unten[ff][gg] = y2_oben[ff2][gg2];
            y3_unten[ff][gg] = y3_oben[ff2][gg2];
            #endif
    //        cout << "Bin vorbei" << endl;
            }
// Kommentar: Hier ist ff = 0(mod 2), und gg = 1(mod 2). In dem Fall werden die Werte auf den Koordinaten (ff2,gg2) und (ff2,gg2+1)
// linear interpoliert.
        else
            {
            #ifdef dimensionen1
// Kommentar: Man sieht hier die eben angesprochene lineare Interpolation der angegebenen Gitterpunktwerte.
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
#ifdef AKTUELLE_WERTE
            if((ff==8)&&(gg==15))
                {
                cout << " HHJJII y0_unten (" << ff << "," << gg << ") = " << y0_unten[ff][gg] << " y0_oben(ff2,gg2) ";
                cout << y0_oben[ff2][gg2] << " y0_oben(ff2,gg2+1) " << y0_oben[ff2][gg2+1] << endl;
                }
#endif
// Kommentar: aktiv steht auf false - standardmig.
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2][gg2+1])/2;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2][gg2+1])/2;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2][gg2+1])/2;
            #endif
            }
        }
// Kommentar: Ab hier ist ff = 1(mod 2)
    else
        {
// Kommentar: Hier ist der Fall ff = 1(mod 2) und gg = 0(mod 2). Hier wird eine vertikale lineare Interpolation der Gitterwerte
// durchgefhrt.
        if((gg&1)==0)
            {
            #ifdef dimensionen1
// Kommentar: Das ist die lineare Interpolation der Grobgitterwerte auf den Koordinaten (ff2,gg2) und (ff2+1,gg2).
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
#ifdef AKTUELLE_KOMMENTARE_NEU
            if((ff==25)&&(gg==8))
                {
                cout << " HIJ Mittelwert (25,8) oben : " << y0_oben[ff2][gg2] << " unten " << y0_oben[ff2+1][gg2];
                cout << " Mittelwert " << y0_unten[ff][gg] << " rang " << rang << " t " << t << endl;
                }
#endif
// Kommentar: 'aktiv' ist immer false.
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2])/2;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2])/2;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2+1][gg2])/2;
            #endif
            }
// Kommentar: Nach dem 'else' ist der Fall ff = 1(mod 2), und gg = 1(mod 2). Hier wird der Mittelwert aller 4 Grobgitterpunkte
// drum herum bestimmt.
        else
            {
            #ifdef dimensionen1
// Kommentar: Hier wird der eben beschrieben Mittelwert der Grobgitterwerte berechnet.
// Genauso - je nach Fall von ff(mod 2)  und gg(mod 2) - muss die biquadratisch Interpolationdurchgefhrt.
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
// Kommentar: aktiv steht immer noch auf false.
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2]+y2_oben[ff2][gg2+1]+y2_oben[ff2+1][gg2+1])/4;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2]+y2_oben[ff2][gg2+1]+y2_oben[ff2+1][gg2+1])/4;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2+1][gg2]+y3_oben[ff2][gg2+1]+y3_oben[ff2+1][gg2+1])/4;
            #endif
            }
        }
    }

// Kommentar: Hier geschieht genau dasselbe wie in der Funktion 'bi_quad_interpolation', mit dem einzigen Unterschied, dass
// unten auf dem feinen Gitter e0 beschrieben wird. Die Quelle bleibt u0 auf dem groben Gitter.
void Prolongation::bi_quad_interpolation_u0e0(void)
    {
    if((ff&1)==0)
        {
        if((gg&1)==0)
            {
            #ifdef dimensionen1
            e0_unten[ff][gg] = u0_oben[ff2][gg2];
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            y2_unten[ff][gg] = y2_oben[ff2][gg2];
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            y2_unten[ff][gg] = y2_oben[ff2][gg2];
            y3_unten[ff][gg] = y3_oben[ff2][gg2];
            #endif
            }
        else
            {
            #ifdef dimensionen1
            e0_unten[ff][gg] = (u0_oben[ff2][gg2]+u0_oben[ff2][gg2+1])/2;
#ifdef AKTUELLE_KOMMENTARE_NEU
            if((ff==8)&&(gg==15))
                {
                cout << " KKJJII e0_unten (" << ff << "," << gg << ") = " << e0_unten[ff][gg] << " u0_oben(ff2,gg2) ";
                cout << u0_oben[ff2][gg2] << " u0_oben(ff2,gg2+1) " << u0_oben[ff2][gg2+1] << endl;
                }
#endif
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2][gg2+1])/2;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2][gg2+1])/2;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2][gg2+1])/2;
            #endif
            }
        }
    else
        {

        if((gg&1)==0)
            {
            #ifdef dimensionen1
            e0_unten[ff][gg] = (u0_oben[ff2][gg2]+u0_oben[ff2+1][gg2])/2;
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2])/2;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2])/2;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2+1][gg2])/2;
            #endif
            }
        else
            {
            #ifdef dimensionen1
            e0_unten[ff][gg] = (u0_oben[ff2][gg2]+u0_oben[ff2+1][gg2]+u0_oben[ff2][gg2+1]+u0_oben[ff2+1][gg2+1])/4;
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2]+y2_oben[ff2][gg2+1]+y2_oben[ff2+1][gg2+1])/4;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2]+y2_oben[ff2][gg2+1]+y2_oben[ff2+1][gg2+1])/4;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2+1][gg2]+y3_oben[ff2][gg2+1]+y3_oben[ff2+1][gg2+1])/4;
            #endif
            }
        }
    }

// Markierungsfeld: Erzeugt man einen neuen Punkt bei der Adaption, dann hat man keinen alten Wert an dieser Stelle.
// Daher mssen fr die Prolongation diese Punkte markiert werden.
// Fr die Kappe spielt das keine Rolle, weil im groben Bereich keine Punkte erzeugt oder vernichtet werden.

// Kommentar: Wie oben kommentiert, nimmt die Variable aktiv den Wert false an. Direkt von zu Beginn an.
Prolongation::Prolongation(void)
    {
    aktiv = false;
    }

// Kommentar: Hier wird die Klasse Prolongation initialisiert. Das eigentliche sind eigentlich die Variablen, und die
// werden nicht hier beschrieben, sondern direkt verknpft von Zyklus Rechnen aus.
void Prolongation::initialisiere(int _n, int _m, MarkierungsFeld * _neuer_punkt, DateiAusgabe * _da_zr)
    {
// Die Gittermae werden gespeichert.
    n = _n;
    m = _m;

// Kommentar: Die Variable merke_bi_quad dient nur Debugging - Zwecken. Man wollte sehen, an welchen Stellen interpoliert wird,
// und welche Werte dabei berechnet werden.
    aktiv = true;
// Kommentar: aktiv = false. Nur beim Debugging wre es anders zu setzen.
    aktiv = false;
// Kommentar: Diese Variable hilft zu unterscheiden, ob ein Feingitterpunkt neu entstanden ist, oder ob es ihn schon gegeben
// hat. Wird gebraucht, und daher auch abgespeichert.
    neuer_punkt = _neuer_punkt;
// Kommentar: Das dient der Dateiausgabe, also dem Debugging.
    da_zr = _da_zr;
    }

// Kommentar: Hier werden - im Falle der Kappe - die Punktmenge auf der Ebene der Kappe bergeben. Genauer: Es wird fr den
// Kern mit der ID 0 das ganze Gitter angelegt, und fr die anderen Kerne ist es die leere Menge.
void Prolongation::initialisiere_kappe(short int * _f_kappe, short int * _g_kappe, int _anzahl_kappe)
    {
// Kommentar: Die Koordinaten (f_kappe,g_kappe) werden bergeben. Man kann auch die anzahl_kappe bergeben. Da sie konstant
// m * n ist bzw. 0 muss sie nicht aktualisiert werden.
    f_kappe = _f_kappe;
    g_kappe = _g_kappe;
    anzahl_kappe = _anzahl_kappe;
    }

// Kommentar: Wenn Speicherplatz angelegt wird, dann muss er auch freigegeben werden. In diesem Fall geht es aber hchstens um
// den Speicherplatz des Feldes merke_bi_quad. Aber: Die Funktion finalisieren wird auf jeden Fall beibehalten.
void Prolongation::finalisiere(void)
    {
// Kommentar: Momentar wird kein Speicherplatz freigegeben.
    }



// Kommentar: Diese Funktion ist analog zur Funktion bi_quad_interpolation, nur dass, statt in u0_unten zu schreiben, in
// v6_unten geschrieben wird, und statt u0_oben zu lesen, v9_oben gelesen wird. Das sind die Variablen
// in Bezug auf die von mir genderte Version der Hess'schen Implementierung der SWE.
void Prolongation::bi_quad_interpolation_swe(void)
    {
    if((ff&1)==0)
        {
        if((gg&1)==0)
            {
#ifdef NIEMALS
            #ifdef dimensionen1
            v6_unten[ff][gg] = v9_oben[ff2][gg2];
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            y2_unten[ff][gg] = y2_oben[ff2][gg2];
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = y0_oben[ff2][gg2];
            y1_unten[ff][gg] = y1_oben[ff2][gg2];
            y2_unten[ff][gg] = y2_oben[ff2][gg2];
            y3_unten[ff][gg] = y3_oben[ff2][gg2];
            #endif
#endif
            v6_unten[ff][gg] = v9_oben[ff2][gg2];
            }
        else
            {;
#ifdef NIEMALS
            #ifdef dimensionen1
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
#ifdef AKTUELLE_WERTE
#endif
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2][gg2+1])/2;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2][gg2+1])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2][gg2+1])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2][gg2+1])/2;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2][gg2+1])/2;
            #endif
#endif
            v6_unten[ff][gg] = (v9_oben[ff2][gg2]+v9_oben[ff2][gg2+1])/2;
            }
        }
    else
        {

        if((gg&1)==0)
            {
#ifdef NIEMALS
            #ifdef dimensionen1
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
#ifdef AKTUELLE_KOMMENTARE_NEU
#endif
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2])/2;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2])/2;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2])/2;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2])/2;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2+1][gg2])/2;
            #endif
#endif
            v6_unten[ff][gg] = (v9_oben[ff2][gg2]+v9_oben[ff2+1][gg2])/2;
            }
        else
            {
#ifdef NIEMALS
            #ifdef dimensionen1
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            if(aktiv==true)
                {
                merke_bi_quad[ff][gg] = y0_unten[ff][gg];
                }
            #endif
            #ifdef dimensionen2
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            #endif
            #ifdef dimensionen3
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2]+y2_oben[ff2][gg2+1]+y2_oben[ff2+1][gg2+1])/4;
            #endif
            #ifdef dimensionen4
            y0_unten[ff][gg] = (y0_oben[ff2][gg2]+y0_oben[ff2+1][gg2]+y0_oben[ff2][gg2+1]+y0_oben[ff2+1][gg2+1])/4;
            y1_unten[ff][gg] = (y1_oben[ff2][gg2]+y1_oben[ff2+1][gg2]+y1_oben[ff2][gg2+1]+y1_oben[ff2+1][gg2+1])/4;
            y2_unten[ff][gg] = (y2_oben[ff2][gg2]+y2_oben[ff2+1][gg2]+y2_oben[ff2][gg2+1]+y2_oben[ff2+1][gg2+1])/4;
            y3_unten[ff][gg] = (y3_oben[ff2][gg2]+y3_oben[ff2+1][gg2]+y3_oben[ff2][gg2+1]+y3_oben[ff2+1][gg2+1])/4;
            #endif
#endif
            v6_unten[ff][gg] = (v9_oben[ff2][gg2]+v9_oben[ff2+1][gg2]+v9_oben[ff2][gg2+1]+v9_oben[ff2+1][gg2+1])/4;
            }
        }
    }

// Kommentar: Hier wird die bi - quadratische Interpolation bzgl. der genderten SWE's durchgefhrt. Man lese dazu auch den
// Kommentar von 'bi_quadratische_interpolation_rand'.
void Prolongation::bi_quadratische_interpolation_rand_swe(void)
    {
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " BCDE bi_quad_inter_rand ariu " << anzahl_rand_innen_unten << " " << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    da_zr->oeffnen();
    * da_zr->aus << " bi_quad_inter_rand ariu " << anzahl_rand_innen_unten << " ";
#endif
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " BCDE nach da_zr " << endl;
#endif
// Kommentar: Der Rand der Feingittermenge wird durchlaufen.
    for(i=0; i<anzahl_rand_innen_unten; i++)
        {
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 1 " << endl;
#endif
        ff = f_rand_innen_unten[i];
        gg = g_rand_innen_unten[i];
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 2 " << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "(" << ff << "," << gg << ")";
#endif
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 3 " << endl;
#endif
        // Test auf innere Punkte
// Dann werden die Grobgitterkoordinaten bestimmt, die gegenber den Feingitterkoordinaten (ff,gg) positionsmig leicht
// versetzt sein knnen.
        ff2 = ff >> 1;
        gg2 = gg >> 1;
//        bi_quad_interpolation(); Diese Zeile am 27.06.2014 durch die folgenden Zeilen ersetzt:
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " BCDE ff " << ff << " gg " << gg << endl;
#endif
// Kommentar: Und schlielich wird der Operator bzgl. der abgenderten SWE's aufgerufen.
        bi_quad_interpolation_swe();
        }
#ifdef AUSGABEN_DATEI_101214
    * da_zr->aus << endl;
#endif

//////////////////////////////////////////////////////

// Kommentar: Und hier wird dasselbe nochmal fr die echten Randpunkte des feinen Gitters durchgefhrt.
    for(i=0; i<anzahl_rand_innen_unten_echter_rand; i++)
        {
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 1 " << endl;
#endif
        ff = f_rand_innen_unten_echter_rand[i];
        gg = g_rand_innen_unten_echter_rand[i];
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 2 " << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "(" << ff << "," << gg << ")";
#endif
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " 3 " << endl;
#endif
        // Test auf innere Punkte

        ff2 = ff >> 1;
        gg2 = gg >> 1;
//        bi_quad_interpolation(); Diese Zeile am 27.06.2014 durch die folgenden Zeilen ersetzt:
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " BCDE ff " << ff << " gg " << gg << endl;
#endif
        bi_quad_interpolation_swe();
        }
#ifdef AUSGABEN_DATEI_101214
    da_zr->schliessen();
#endif
    }

// Kommentar: Zum Sinn dieser Funktion vgl. den Kommentar zu 'bi_quadratische_interpolation_innen'. Hier wird nun geschrieben,
// wie eine Interpolation fr die Innenpunktmenge des feinen Gitters durchgefhrt werden kann.
void Prolongation::bi_quadratische_interpolation_innen_swe(void)
    {
#ifdef AUSGABEN_PROLONGATION
    cout << "BQ anzahl_innen_unten " << anzahl_innen_unten << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    da_zr->oeffnen();
    * da_zr->aus << " bi_quad_inter_innen aiu " << anzahl_innen_unten << " ";
#endif

// Kommentar: Die Innenpunktmenge des feinen Gitters wird durchlaufen.
    for(i=0; i<anzahl_innen_unten; i++)
        {
        ff = f_innen_unten[i];
        gg = g_innen_unten[i];
#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "((" << ff << "," << gg << "))";
#endif
// Kommentar: Die folgende Zeile ist eigentlich nie erfllt bei inneren Punkten.
        if(selbstnachbarn[ff][gg]!=255)
            {
            continue;
            }
#ifdef AUSGABEN_DATEI_101214
        * da_zr->aus << "(" << ff << "," << gg << ")";
#endif
        // Test auf innere Punkte
// Die zugehrige Grobgitterkoordinate wird berechnet.
        ff2 = ff >> 1;
        gg2 = gg >> 1;

#ifdef AUSGABEN_PROLONGATION
        cout << " (" << ff << " " << gg << ") ";
#endif

// Kommentar: Und schlielich wird der Operator bzgl. der abgenderten SWE's aufgerufen.
        bi_quad_interpolation_swe();
        }
#ifdef AUSGABEN_PROLONGATION
    cout << "BQ Ende " << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    * da_zr->aus << endl;
    da_zr->schliessen();
#endif
    }
