#ifndef PROLONGATION

#define PROLONGATION 1

#include "ausgaben.h"

#include "markierungsfeld.h"

#include "datei_ausgabe.h"

#include <iostream>

using namespace std;

class Prolongation
    {
private:
public:
    #ifdef dimensionen1
    double ** y0_unten,** y0_oben;
    #endif
    #ifdef dimensionen2
    double ** y0_unten,** y0_oben;
    double ** y1_unten,** y1_oben;
    #endif
    #ifdef dimensionen3
    double ** y0_unten,** y0_oben;
    double ** y1_unten,** y1_oben;
    double ** y2_unten,** y2_oben;
    #endif
    #ifdef dimensionen4
    double ** y0_unten,** y0_oben;
    double ** y1_unten,** y1_oben;
    double ** y2_unten,** y2_oben;
    double ** y3_unten,** y3_oben;
    #endif
    double ** e0_unten, ** u0_oben, ** u0_unten;
    double ** v6_unten, ** v9_oben;

#ifdef KURZ_PUNKTE
    short int * f_innen_unten, * g_innen_unten;
    short int * f_rand_innen_unten, * g_rand_innen_unten;
    short int * f_rand_innen_unten_echter_rand, * g_rand_innen_unten_echter_rand;
#else
    int * f_innen_unten, * g_innen_unten;
    int * f_rand_innen_unten, * g_rand_innen_unten;
#endif
    int anzahl_innen_unten;
    int anzahl_rand_innen_unten;
    int anzahl_rand_innen_unten_echter_rand;
public:
    void bi_quadratische_interpolation_rand(void);
    void bi_quadratische_interpolation_innen(void);
private:
    int ff, gg;
    void bi_quad_interpolation(void);
    void bi_quad_interpolation_u0e0(void);

    int i, j;

    int ff2, gg2;
public:
#ifdef KURZ_MF
    bool ** markierungsfeld;
#else
    int ** markierungsfeld;
#endif
    MarkierungsFeld * neuer_punkt;

public:
    int rang;
private:
    double ** merke_bi_quad;
    int m, n;
public:
    void initialisiere(int _n, int _m, MarkierungsFeld * _neuer_punkt, DateiAusgabe * _da_zr);
    void finalisiere(void);

    Prolongation(void);
private:
    bool aktiv;
public:
    int ** selbstnachbarn;
private:
    DateiAusgabe * da_zr;
public:
    void ausgabe_neue_punkte(int untere_ebene);
public:
    int t;
private:
    short int * f_kappe, * g_kappe;
    int anzahl_kappe;
public:
    void bi_quadratische_interpolation_kappe(void);
    void initialisiere_kappe(short int * _f_kappe, short int * _g_kappe, int _anzahl_kappe);
private:
    void bi_quad_interpolation_swe(void);
public:
    void bi_quadratische_interpolation_rand_swe(void);
    void bi_quadratische_interpolation_innen_swe(void);
public:
    int untere_gitterebene;
    bool festgestellt;
    };

#endif
