#include "punkt_feld_liste_werte.h"

// Kommentar: Das hier entspricht im Wesentlichen der Klasse PunktFeldListe. Der einzige Unterschied ist der, dass nun auch
// noch Werte gelesen und geschrieben werden knnen. Also wird eine Zusatzinformation bereitgestellt.

// Kommentar: Diese Klasse wird initialsiert.
void PunktFeldListeWerte::initialisierung(int _m, int _n)
// Wird jetzt unten komplett finalisiert.
    {
// Kommentar: Analog zur Initialisierung der Klasse PunktFeldListe. Es wird nur ein 2 - dimensionales short int Feld 'werte'
// angelegt, und mit -1 beschrieben.
    m = _m;
    n = _n;
    mn = m * n;

    f = new short int [mn];
    g = new short int [mn];
    feld = new short int * [n];
    werte = new short int * [n];
    for(i=0; i<n; i++)
        {
        feld[i] = new short int [m];
        werte[i] = new short int [m];
        for(j=0; j<m; j++)
            {
            feld[i][j] = -1;
            werte[i][j] = -1;
            }
        }
    anzahl = 0;
    }

// Kommentar: Analog zur Finalisierung der PunktFeldListe, mit dem einzigen Unterschied, dass auch der Speicherplatz
// fr die Zusatzinformation Werte freigegeben wird.
void PunktFeldListeWerte::finalisierung(void)
    {
    for(i=0; i<n; i++)
        {
        delete feld[i];
        delete werte[i];
        }
    delete feld;
    delete werte;
    // Neu hinzu:
    delete f;
    delete g;
    }

// Kommentar: Analog zur Funktion hinzu der Klasse PunktFeldListe, nur, dass das Feld Werte auf den Koordinaten mit dem Wert
// wert beschrieben wird.
void PunktFeldListeWerte::hinzu(int ff, int gg, int wert)
    {
    if(ff < 0)
        {
        return;
        }
    if(gg < 0)
        {
        return;
        }
    if(ff >= n)
        {
        return;
        }
    if(gg >= m)
        {
        return;
        }
#ifdef AUSGABEN_PUNKT_FELDLISTE
    if((ff==8)&&(gg==3))
        {
        cout << " (PFL 8,3) " << feld[ff][gg] << " ";
        }
#endif
    if(feld[ff][gg]==-1)
        {
        feld[ff][gg] = anzahl;
        f[anzahl] = ff;
        g[anzahl] = gg;
        anzahl ++;
        }
    werte[ff][gg] = wert;
    }

// Kommentar: Analog zur Funktion hinweg der Klasse 'PunktFeldListe', nur dass auf der Position (ff,gg) das Feld werte mit -1
// beschrieben wird.
void PunktFeldListeWerte::hinweg(int ff, int gg)
    {
/*
    if(ff < 0)
        {
        return;
        }
    if(gg < 0)
        {
        return;
        }
    if(ff >= n)
        {
        return;
        }
    if(gg >= m)
        {
        return;
        }
Die wurden schon einmal kontrolliert! Zur mglichen Prfung diesen Code behalten. 8.2.16
*/
    position = feld[ff][gg];
    if(position == -1) // Falls feld[ff][gg]==-1, so existiert in (ff,gg) kein Punkt, und es ist nichts zu tun.
        {
        return;
        }
    anzahl --;
    f_hilfe = f[anzahl];
    g_hilfe = g[anzahl];
    feld[f_hilfe][g_hilfe] = position;
    f[position] = f_hilfe;
    f[position] = f_hilfe;
    g[position] = g_hilfe;
    feld[ff][gg] = -1; // Hinzugefgt. Fehlte bisher.
    werte[ff][gg] = -1;
    }

// Kommentar: Analog zur Funktion reset in der Klasse PunktFeldListe, nur dass das Feld werte berall -1 wird.
void PunktFeldListeWerte::reset(void)
    {
    for(i=0; i<anzahl; i++)
        {
        f_i = f[i];
        g_i = g[i];
        feld[f_i][g_i] = -1;
        werte[f_i][g_i] = -1;
        }
    anzahl = 0;
    }

// Kommentar: Analog zur Funktion ausgabe in der Klasse PunktFeldListe.
void PunktFeldListeWerte::ausgabe(void)
    {
#ifdef AUSGABEN_PUNKT_FELDLISTE
    cout << "PFLa ";

    for(i=0; i<anzahl; i++)
        {
        cout << f[i] << " " << g[i] << " ";
        }
    cout << endl;
#endif
    }

// Kommentar: Analog zur Funktion ausgabe_feld in der Klasse PunktFeldListe.
void PunktFeldListeWerte::ausgabe_feld(DateiAusgabe * da)
    {
#ifdef AUSGABEN_DATEI_NEU
    * da->aus << "PFL 2" << endl;

    for(i=0; i<n; i++)
        {
        * da->aus << i << " ";
        if(i<10)
            {
            * da->aus << " ";
            }
        for(j=0; j<m; j++)
            {
            if(feld[i][j]==-1)
                {
                * da->aus << "0" << " ";
                }
            else
                {
                * da->aus << "1" << " ";
                }
            }
        * da->aus << endl;
        }
    for(i=0; i<anzahl; i++)
        {
        * da->aus << "(" << f[i] << "," << g[i] << ")";
        }
    * da->aus << endl << " Anzahl " << anzahl << endl;
    * da->aus << "Ende PFL 2" << endl;
#endif
    }

// Kommentar: Analog zur Funktion entferne_besetzte_punkte in der Klasse PunktFeldListe.
void PunktFeldListeWerte::entferne_besetzte_punkte(void)
    {
    for(i=0; i<anzahl; i++)
        {
        besetzte_punkte[f[i]][g[i]] = false;
        }
    }

// Kommentar: Analog zur Funktion fuege_besetzte_punkte_ein in der Klasse PunktFeldListe.
void PunktFeldListeWerte::fuege_besetzte_punkte_ein(void)
    {
    for(i=0; i<anzahl; i++)
        {
        besetzte_punkte[f[i]][g[i]] = true;
        }
    }

