#include "punkt_liste.h"

// Kommentar: Hier geschieht etwas ähnliches wie in der Punktfeldliste. Es liegt eine eindimensionale Liste vor um
// Koordinaten zu speichern. Und es wird dazu ein zweidimensionales Feld angelegt, wobei gespeicherte Punkte
// in diesem Feld auf die Listeneinträge verweisen. Auf diese Weise können Punkte schnell entfernt werden.
// In dieser Klasse jedoch werden nur Punkte hinzugefügt, bzw. die ganze Punktmenge geleert.

// Kommentar: Die PunktListe wird initialisiert. Es werden die Gittermaße übergeben.
void PunktListe::initialisierung(int _m, int _n)
// Jetzt wird sie korrekt finalisiert
    {
// Kommentar: Die wichtigsten Parameter werden angelegt.
    m = _m;
    n = _n;
    mn = m * n;

#ifdef AUSGABEN_PUNKT_LISTE
    cout << "Punkt Liste:: m " << m << " n " << n << endl;
#endif

// Kommentar: Die Punktlisten der Koordinaten f und g werden angelegt.
    f = new short int [mn];
    g = new short int [mn];
#ifdef PUNKTE_FELD_LISTE_INT
// Kommentar: Dann wird das 2 - dimensionale Feld angelegt, und mit false beschrieben.
    feld = new int * [n];
#else
    feld = new short int * [n];
#endif
    for(i=0; i<n; i++)
        {
#ifdef PUNKTE_FELD_LISTE_INT
        feld[i] = new int [m];
#else
        feld[i] = new short int [m];
#endif
        for(j=0; j<m; j++)
            {
            feld[i][j] = false;
            }
        }
// Kommentar: Die Listenlänge am Anfang ist 0.
    anzahl = 0;
    }

// Kommentar: Bei der Finalisierung werden das Feld und die Punktlisten freigegeben.
void PunktListe::finalisierung(void)
    {
    for(i=0; i<n; i++)
        {
        delete feld[i];
        }
    delete feld;

    delete f;
    delete g;
    }

// Kommentar: Ein Punkt wird hinzugefügt.
void PunktListe::hinzu(int ff, int gg)
    {
// Kommentar: Zuerst wird geprüft, dass die Gittermaße nicht überschritten werden.
    if(ff < 0)
        {
        return;
        }
    if(gg < 0)
        {
        return;
        }
    if(ff >= n)
        {
        return;
        }
    if(gg >= m)
        {
        return;
        }
// Kommentar: Falls das Feld noch keinen Eintrag hat, dann wird es auf true gesetzt, und die Koordinaten in den
// Koordinatenlisten eingetragen. Die Länge der Liste wird um eins erhöht.
    if(feld[ff][gg]==false)
        {
        feld[ff][gg] = true;
        f[anzahl] = ff;
        g[anzahl] = gg;
        anzahl ++;
        }
    }

// Kommentar: Die ganze Struktur wird in den Ausgangszustand versetzt.
void PunktListe::reset(void)
    {
// Kommentar: Das Feld wird auf den eingetragenen Koordinaten auf false gesetzt.
    for(i=0; i<anzahl; i++)
        {
        feld[f[i]][g[i]] = false;
        }
// Die Länge der Liste wird zu 0.
    anzahl = 0;
    }

// Kommentar: Das ist eine Ausgabe zu Debugging - Zwecken.
void PunktListe::ausgabe(void)
    {
#ifdef AUSGABEN_PUNKT_LISTE
    cout << "PLa ";
    for(i=0; i<anzahl; i++)
        {
        cout << f[i] << " " << g[i] << " ";
        }
    cout << endl;
#endif
    }

// Kommentar: Das ist eine Datei - Ausgabe zu Debugging - Zwecken.
void PunktListe::ausgabe_feld(DateiAusgabe * da)
    {
#ifdef AUSGABEN_DATEI
    da->aus << "PFL 2" << endl;

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            da->aus << feld[i][j] << " ";
            }
        da->aus << endl;
        }
    da->aus << "Ende PFL 2" << endl;
#endif
    }
