#include "punkte_update_fg.h"

// Kommentar: Mit dieser Klasse werden Punkte eingefgt und entfernt - gem P+ und P-.

// Kommentar: Man fgt alle Punkte aus P+ ein.
void PunkteUpdateFG::einfuegen(PunktFeldListe * _P_plus) //, LoeschenEinfuegen * loeschen_einfuegen)
    {
// Kommentar: Der Zeiger auf P+ wird kopiert.
    P_plus = _P_plus;

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << " PunkteUpdateFG::einfuegen rang " << rang << " Fall " << ev_faelle << endl;
#endif

// Kommentar: Einfgen geschieht je nach dem Wert von ev_Faelle verschieden:
    switch(ev_faelle)
        {
        case TYP_EV:
// Kommentar: Das gilt fr die ev_typen TYP_EV und TYP_EVEV, vgl. die Funktion bestimme_ev_faelle.
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
            cout << " AAPP in derPunkteUpdate Funktion einfuegen " << endl;
#endif

// Kommentar: In diesem Fall wird einfuegenEV aufgerufen.
            einfuegenEV();
            break;
// Kommentar: Das gilt fr die ev_typen TYP_EV2 und TYP_EV2EV2, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EV2:
// Kommentar: In diesem Fall wird einfuegenEV2 aufgerufen.
            einfuegenEV2();
            break;
// Kommentar: Das gilt fr den ev_typen TYP_EVEV2, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EVEV2:
            cout << " Falscher Typ " << endl;
            exit(-1);
        }
    }

// Kommentar: Man entfernt alle Punkte aus P-.
void PunkteUpdateFG::entfernen(PunktFeldListe * _P_minus) //, LoeschenEinfuegen * loeschen_einfuegen)
    {
// Kommentar: Der Zeiger auf P- wird kopiert.
    P_minus = _P_minus;

#ifdef AAFF
    if(rang==0)
        {
        cout << " AAFF PU ent ev_faelle " << ev_faelle << endl;
        }
#endif

// Kommentar: Entfernen geschieht je nach dem Wert von ev_Faelle verschieden:
    switch(ev_faelle)
        {
// Kommentar: Das gilt fr die ev_typen TYP_EV und TYP_EVEV, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EV:
// Kommentar: In diesem Fall wird entfernenEV aufgerufen.
            entfernenEV();
            break;
// Kommentar: Das gilt fr die ev_typen TYP_EV2 und TYP_EV2EV2, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EV2:
// Kommentar: In diesem Fall wird entfernenEV2 aufgerufen.
            entfernenEV2();
            break;
// Kommentar: Das gilt fr den ev_typen TYP_EVEV2, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EVEV2:
            cout << " Falscher Typ " << endl;
            exit(-1);
        }
    }

// Kommentar: Hier wird ein Punkteupdate aufgrund von stellvertretendem Punkteentfernen durchgefhrt. Es geht dabei immer nur
// ums Entfernen, weil man niemals kommuniziert, um einzufgen. Wo eingefgt wird, kennt der Einfgende Kern die ntigen
// Informationen dazu.
void PunkteUpdateFG::vervollstaendigen(void)
    {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << " Vervollstaendigen rang " << rang << endl;
#endif
    switch(ev_faelle)
        {
// Kommentar: Das gilt fr die ev_typen TYP_EV und TYP_EVEV, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EV:
// Kommentar: In diesem Fall wird vervollstaendigenEV aufgerufen.
            vervollstaendigenEV();
            break;
// Kommentar: Das gilt fr die ev_typen TYP_EV2 und TYP_EV2EV2, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EV2:
// Kommentar: In diesem Fall wird vervollstaendigenEV2 aufgerufen.
            vervollstaendigenEV2();
            break;
// Kommentar: Das gilt fr den ev_typen TYP_EVEV2, vgl. die Funktion bestimme_ev_faelle.
        case TYP_EVEV2:
            cout << " Falscher Typ " << endl;
            exit(-1);
            break;
        }
    }

// Hier werden die Punkte aus dem Kommunikation4er Empfangsbuffer gelesen, und die Punkte, die eingetragen sind, werden dann
// entfernt.
void PunkteUpdateFG::vervollstaendigenEV(void)
    {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << " VervollstaendigenEV rang " << rang << endl;
#endif
// Kommentar: Man durchluft die ID's der punktbenachbarten Kerne.
    for(i=0; i<groesse; i++)
        {
        if(PT_feingitter[i] > 0)
            {
// Kommentar: Empfangsbuffer sowie Anfangsposition und Entposition der Eintrge in dem Buffer werden aus der Klasse
// Kommunikation4er gelesen
            empfangsbuffer = kommunikation4er->empfangsbuffer[i];

            anfangsposition = kommunikation4er->pu_entfernen_anfang[i];
            endposition = kommunikation4er->pu_entfernen_ende[i];

// Kommentar: Der Buffer wird durchlaufen.
            for(j=anfangsposition; j<endposition;)
                {
// Kommentar: f und g werden gelesen, wobei j = j + 2 erfolgt, weil der Buffer ein char - Buffer ist, aber es werden short ints,
// doppelt so lang sind, gelesen. Man verwendet die Funktion lese_short_int.
                f = lese_short_int(j);
                j = j+2;
                g = lese_short_int(j);
                j = j+2;

// Kommentar: Der Punkt muss nun gelscht werden. In vervollstaendigenEV per Befehl einfaches_loeschen_feingitterEV.
                loeschen_einfuegen.einfaches_loeschen_feingitterEV(f, g);
// Kommentar: Und es muss - ausser unten auf Ebene 0 - festgehalten werden, dass der Punkt gelscht wurde, damit was_ist_geloescht_oben korrekt ist.
                if(gitterebene>1)
                    {
                    was_ist_geloescht_unten->hinzu(f,g);
                    }
                }
            }
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " VervollstaendigenEV zu Ende rang " << rang << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu vervollstaendigenEV, bis auf die Art des Lschens. Deshalb wird diese eine genderte
// Zeile kommentiert.
void PunkteUpdateFG::vervollstaendigenEV2(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " VervollstaendigenEV2 rang " << rang << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(PT_feingitter[i] > 0)
            {
            empfangsbuffer = kommunikation4er->empfangsbuffer[i];

            anfangsposition = kommunikation4er->pu_entfernen_anfang[i];
            endposition = kommunikation4er->pu_entfernen_ende[i];
            for(j=anfangsposition; j<endposition;)
                {
                f = lese_short_int(j);
                j = j+2;
                g = lese_short_int(j);
                j = j+2;

// Kommentar: Der Punkt muss nun gelscht werden. In vervollstaendigenEV2 per Befehl einfaches_loeschen_feingitterEV2.
                loeschen_einfuegen.einfaches_loeschen_feingitterEV2(f, g);
                if(gitterebene>1)
                    {
                    was_ist_geloescht_unten->hinzu(f,g);
                    }
                }
            }
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " VervollstaendigenEV2 zu Ende rang " << rang << endl;
#endif
    }

// Kommentar: DIe Klasse wird initialisiert. Dabei werden die passenden Parameter und Zeiger bergeben, und sie werden gespeichert.
void PunkteUpdateFG::initialisieren(short int ** _fgff, short int ** _ggff, int * _PT_feingitter, int _h,  Kommunikation4er * _kommunikation4er, int ** _feingitter_feld, int ** _grobgitter_feld)
// Keine Speicherallokation
    {
// Kommentar: Die Farbenfelder werden bergeben.
    feingitter_farbenfeld = _fgff;
    grobgitter_farbenfeld = _ggff;

// Kommentar: Die Felder der Feldlisten werden bergeben.
    grobgitter_feld = _grobgitter_feld;
    feingitter_feld = _feingitter_feld;

// Kommentar: Die Kerntopologie, h, die Kommunikation4er Klasse sowie groesse und rang werden bergeben und gespeichert.
    PT_feingitter = _PT_feingitter;
    h = _h;
    kommunikation4er = _kommunikation4er;
    groesse = kommunikation4er->groesse;
    rang = kommunikation4er->rang;
#ifdef AKTUELLE_KOMMENTARE
    cout << " IN PUFG rang " << rang << endl;
#endif
    }

// Kommentar: Hier werden short ints aus einem char - Buffer gelesen. Deshalb muss der Index immer ein Vielfaches von 2 sein.
short int PunkteUpdateFG::lese_short_int(int index)
    {
    merken = &(empfangsbuffer[index]);
    merken_si = (short int *) merken;
    return(merken_si[0]);
    }

/////////////////////////////////////////////////////////////////
/////////// Einfuegen / Entfernen ///////////////////////////////
/////////////////////////////////////////////////////////////////

// Kommentar: Hier werden die Punkte aus P_minus entfernt.
#ifdef PU_LASSEN
void PunkteUpdateFG::entfernenEV(void)
    {
// Kommentar: Die Punkte aus P- werden durchlaufen.
    anzahl = P_minus->anzahl;

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << "av 5a" << endl;
#endif

    for(i=0; i<anzahl; i++)
        {
        f = P_minus->f[i];
        g = P_minus->g[i];

// Kommentar: Die halben Punktwerte - fr Grobgitterkoordinaten - werden bestimmt und gespeichert.
        f_halbe = f >> 1;
        g_halbe = g >> 1;

// Kommentar: Wenn das Grobgitter - und Feingitterfeld hier Eintrge haben, oder aber der Grobgittereintrag erst durch die Adaptivitt entfernt wurde, was in was_ist_geloescht_oben
// gespeichert wird ... .
#ifdef ALT
        if(grobgitter_feld[f_halbe][g_halbe]>=0)
#endif // ALT
        if((grobgitter_feld[f_halbe][g_halbe]>=0)||(was_ist_geloescht_oben->feld[f_halbe][g_halbe]>=0))
            {
            if(feingitter_feld[f][g]>=0)
                {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
                cout << "le f " << f << " g " << g << endl;
#endif

// Kommentar: Dann lsche den Gitterpunkt. In 'entfernenEV' durch Aufruf von 'einfaches_loeschen_feingitterEV'.
                loeschen_einfuegen.einfaches_loeschen_feingitterEV(f, g);
// Kommentar: Das Lschen muss gemerkt werden, wenn mehr als 2 adaptive Ebenen darunter liegen, damit was_ist_geloescht_oben auf diese Information zugreifen kann.
                if(gitterebene>1)
                    {
                    was_ist_geloescht_unten->hinzu(f,g);
                    }
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
                cout << "le fertig f " << f << " g " << g << endl;
#endif
                }
// Kommentar: Wenn der Punkt zwar existiert (feingitter_farbenfeld[f][g]>=0), aber nicht auf diesem Gitter - wegen
// feingitter_feld[f][g] < 0 - dann kommuniziere die Koordinaten zu dem Kern, wo dieser Punkt existiert - zum Lschen.
            else
                {
                if(feingitter_farbenfeld[f][g]>=0)
                    {
                    kommunikation4er->entfernen_pu(f, g, int(feingitter_farbenfeld[f][g]));
                    }
                // Falls kein Punkt existiert, kann ich den nicht in die Kommunikation einfuegen.
                // Es geht um das Loeschen.
                // Die Idee ist so: (f_halbe*2, g_halbe*2) existiert. Nein: Das tut es nicht! Wrde es das,
                // dann wre der fgff - Wert OK. So aber geht es nicht.
                }
            }
        }

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << "av 5b 4 " << endl;
#endif
    }
#else
#endif

// Kommentar: Hier werden die Punkte aus P+ eingefgt.
void PunkteUpdateFG::einfuegenEV(void)
    {
// Kommentar: Die Punkte aus P+ werden durchlaufen.
    anzahl = P_plus->anzahl;
    for(i=0; i<anzahl; i++)
        {
        f = P_plus->f[i];
        g = P_plus->g[i];

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
        if((f==18)&&(g==14))
            {
            cout << " AAPP PunkteUpdate " << endl;
            }
#endif
// Die Grobgitterkoordinate dazu - ggf. versetzt - wird bestimmt.
        f_halbe = f >> 1;
        g_halbe = g >> 1;

// Kommentar: Wenn dort auf dem groben Gitter an dieser Koordinate ein Punkt existiert, dann ist dieser Kern fr das Einfgen
// des Punktes zustndig.
        if(grobgitter_feld[f_halbe][g_halbe]>=0)
            {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
            cout << "Einfuegen PU f " << f << " g " << g << endl;
#endif

// Kommentar: Dann fge den Gitterpunkt ein, und da hier die Funktion einfuegenEV ist mit einfaches_einfuegen_feingitterEV.
            loeschen_einfuegen.einfaches_einfuegen_feingitterEV(f, g);
            }
        }
    }

// Kommentar: Diese Funktion ist analog zu entfernenEV, nur dass hier beim Lschen statt einfaches_loeschen_feingitterEV
// einfaches_loeschen_feingitterEV2 aufgerufen wird.
#ifdef PU_LASSEN
void PunkteUpdateFG::entfernenEV2(void)
    {
    anzahl = P_minus->anzahl;

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << "av 5a" << endl;
#endif

    for(i=0; i<anzahl; i++)
        {
        f = P_minus->f[i];
        g = P_minus->g[i];

        f_halbe = f >> 1;
        g_halbe = g >> 1;

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
        if((f==26)&&(g==10))
            {
            cout << " APUF 26,10 gg_f " << grobgitter_feld[f_halbe][g_halbe] << " fg_f " << feingitter_feld[f][g] << " wigo_f " << was_ist_geloescht_oben->feld[f_halbe][g_halbe] << endl;
            }
#endif

#ifdef ALT
        if(grobgitter_feld[f_halbe][g_halbe]>=0)
#endif
        if((grobgitter_feld[f_halbe][g_halbe]>=0)||(was_ist_geloescht_oben->feld[f_halbe][g_halbe]>=0))
            {
            if(feingitter_feld[f][g]>=0)
                {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
                cout << "le f " << f << " g " << g << endl;
#endif
                loeschen_einfuegen.einfaches_loeschen_feingitterEV2(f, g);
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
                if((f==6)&&(g==16))
                    {
                    cout << " Lschen 6,16 rang " << rang << endl;
                    }
#endif
                if(gitterebene>1)
                    {
                    was_ist_geloescht_unten->hinzu(f,g);
                    }
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
                cout << "le fertig f " << f << " g " << g << endl;
#endif
                }
            else
                {
                if(feingitter_farbenfeld[f][g]>=0)
                    {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
                    if((f==26)&&(g==10))
                        {
                        cout << " APUF innen 26,10 gg_f " << grobgitter_feld[f_halbe][g_halbe] << " fg_f " << feingitter_feld[f][g] << " wigo_f " << was_ist_geloescht_oben->feld[f_halbe][g_halbe] << endl;
                        }
#endif
                    kommunikation4er->entfernen_pu(f, g, int(feingitter_farbenfeld[f][g]));
                    }
                // Falls kein Punkt existiert, kann ich den nicht in die Kommunikation einfuegen.
                // Es geht um das Loeschen.
                // Die Idee ist so: (f_halbe*2, g_halbe*2) existiert. Nein: Das tut es nicht! Wrde es das,
                // dann wre der fgff - Wert OK. So aber geht es nicht.
                }
            }
        }

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << "av 5b 5 " << endl;
#endif
    }
#else
#endif

// Kommentar: Diese Funktion ist analog zu einfuegenEV, nur dass hier beim Lschen statt einfaches_einfuegen_feingitterEV
// einfaches_einfuegen_feingitterEV2 aufgerufen wird.
void PunkteUpdateFG::einfuegenEV2(void)
    {
    anzahl = P_plus->anzahl;

#ifdef AAFF
    if(rang==0)
        {
        cout << " AAFF entfernenEV2 " << endl;
        }
#endif

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
    cout << "av 5c " << endl;
#endif

    for(i=0; i<anzahl; i++)
        {
        f = P_plus->f[i];
        g = P_plus->g[i];

#ifdef AUSGABE_AALL
        if((f==126)&&(g==992))
            {
            cout << " AALL Punkt 126/992 drin rang " << rang << endl;
            }
#endif

        f_halbe = f >> 1;
        g_halbe = g >> 1;

#ifdef AUSGABEN_PUNKTE_UPDATE_FG
        cout << " Einfuegen Kandidat PU f " << f << " g " << g << " gg_feld[f/2][g/2] " << grobgitter_feld[f_halbe][g_halbe] << endl;
#endif

        if(grobgitter_feld[f_halbe][g_halbe]>=0)
            {
#ifdef AUSGABEN_PUNKTE_UPDATE_FG
            cout << " Einfuegen PU f " << f << " g " << g << endl;
#endif
            loeschen_einfuegen.einfaches_einfuegen_feingitterEV2(f, g);
            }

        }
    }
