#include "rand_interpolation.h"

/*
    Falls der Zielpunkt dieselbe Farbe hat, wie der Prozessorpunkt, der ausgewhlt wird, dann markiert man die
    per Randaustausch bekommenen Werte.
*/

// Kommentar: Bei dieser Funktion wird eine komplette Randinterpolation durchgefhrt.
void RandInterpolation::tun(void)
    {
#ifdef AKTUELLE_WERTE
    if(rang==2)
        {
        strcpy(zeichenkette, "");
        feld_ausgeben(zeichenkette);
        }
#endif
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 1 rang " << rang << endl;
#endif

// Kommentar: Setzt die Sendeindizes und die Empfangsflags zurck.
    reset();
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 2 rang " << rang << endl;
#endif
// Kommentar: Macht zweierlei:
// 1. Es werden Markierungsfunktionen aufgerufen. Falls gemeinsame Punkte als Nachbarpunkte zu mittleren Punkten
// existieren, kann der Grobgitterrandaustausch zum Markieren benutzt werden.
// 2. Es werden Punktwerte bertragen, falls auf den zu interpolierenden mittleren Punkte die gemeinsamen Nachbarpunkte
// auf einem anderen Kern liegen. Fr den Fall sind die folgenden drei Kommunikationsbefehle da.
    ausfuehren_packen_markieren();
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 3 rang " << rang << endl;
#endif
// Kommentar: Man initiiert die Kommunikation fr die bertragenen Punkte aus ausfuehren_packen_markieren.
// Man verwendet fr die Kommunikation die Vaterklasse UebertrageGrobgitterU.
    kommunikation_initiieren();
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 4 rang " << rang << endl;
#endif
// Kommentar: Man wartet ab, bis die Kommunikation erfolgt ist. Die Funktion ist ebenfalls in UebertrageGrobgitterU.
    for(;ist_fertig()==false;)
        {
        ;
        }
#ifdef JJIIHH_TEXT
    cout << " JJIIHH nach ist_fertig rang " << rang << endl;
#endif
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 5 rang " << rang << endl;
#endif
// Kommentar: Hier werden die Grobgitter u0 - Punkte entpackt - bzw. es wird im Falle der Shallow Water Equations v6 entpackt.
//
    entpacken();
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 6 rang " << rang << endl;
#endif
// Kommentar: Man interpoliert den Rand unter der Bedingung, wie weit die Grobgitterinformation reicht, mglichst aber
// kubisch.
    rand_interpolieren();
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 7 rang " << rang << endl;
#endif
// Kommentar: Es erfolgt eine Entfernung der Markierungen, damit die Struktur Feld der Feldliste wieder korrekte Werte bekommt.
// Das konnte fr die Dauer der Randinterpolation kurzfrstig gendert werden.
    markierung.reset();
    reset_markierungsfelder(); // Braucht man das berhaupt?
    // Wo wird auf 2 gesetztes wieder zurckgesetzt?
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Randinterpolation::tun 8 rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << endl;
#endif
    }

// Kommentar: Hier werden der angelegte Speicherplatz der Vaterklasse UebertrageGrobgitterU freigegeben, vgl. diese Klasse.
void RandInterpolation::finalisieren_randinterpolation(void)
    {
    finalisierenUGU();
    }

// Kommentar: Hier werden bergebene Variablen - unter ihnen der sendebuffer und empfangsbuffer - gespeichert.
// Auer bei der Initialisierung der Vaterklasse UebertrageGrobgitterU wird kein Speicher angelegt.
void RandInterpolation::initialisieren_randinterpolation(ParallelesRechnen * _paralleles_rechnen_h, ParallelesRechnen * _paralleles_rechnen_h_minus1, Werte1d ** _sendebuffer, Werte1d ** _empfangsbuffer)
    {
// Kommentar: Die Strukturen paralleles Rechnen fr die Ebenen h und h-1 werden zugreifbar.
    paralleles_rechnen_h = _paralleles_rechnen_h;
    paralleles_rechnen_h_minus1 = _paralleles_rechnen_h_minus1;
// Kommentar: Sendebuffer und Empfangsbuffer werden bergeben. Die sind in der Klasse UebertrageGrobgitterU angelegt,
// weshalb auch nur diese Klasse darauf zugreift.
    sendebuffer = _sendebuffer;
    empfangsbuffer = _empfangsbuffer;

// Kommentar: Die Gittermae des groben und feinen Gitters werden bestimmt.
    m_grob = paralleles_rechnen_h -> m;
    n_grob = paralleles_rechnen_h -> n;

    m = paralleles_rechnen_h_minus1 -> m;
    n = paralleles_rechnen_h_minus1 -> n;

// Kommentar: Beim groben Gitter werden weitere Gittervariablen bestimmt.
    m_minus1_grob = m_grob - 1;
    m_minus2_grob = m_grob - 2;
    m_minus3_grob = m_grob - 3;

    n_minus1_grob = n_grob - 1;
    n_minus2_grob = n_grob - 2;
    n_minus3_grob = n_grob - 3;

// Kommentar: groesse und rang werden gelesen.
    groesse = paralleles_rechnen_h -> groesse;
    rang = paralleles_rechnen_h -> rang;
    eigenrang = rang;
// Kommentar: Seelbstnachbarn wird fr beide Gitterebenen gelesen.
    selbstnachbarn_grob = paralleles_rechnen_h -> selbstnachbarn;
    selbstnachbarn_fein = paralleles_rechnen_h_minus1 -> selbstnachbarn;
// Kommentar: Die Farbenfelder beider Ebenen werden zugreifbar gemacht.
    ggff = paralleles_rechnen_h -> farbenfeld;
    fgff = paralleles_rechnen_h_minus1 -> farbenfeld;
// Kommentar: Bentigter Speicherplatz fr die Vaterklasse UebertrageGrobgitterU wird angelegt.
    initialisierenUGU(groesse, rang, m, n, paralleles_rechnen_h->feld);
// Kommentar: u0 wird frs grobe und feine Gitter per Zeiger zugeordnet. Im Fall der von mir genderten Version der Hess'schen Implementierung der Shallow Water Equations
// wird hier die Variable v6 der Randinterpolation unterzogen.
#ifndef SHALLOW_WATER_EQUATIONS
    u0_grob = paralleles_rechnen_h -> u0;
    u0_fein = paralleles_rechnen_h_minus1 -> u0;
#else
//  Kommentar: vielleicht so, 5.12.14
    u0_grob = paralleles_rechnen_h -> v6;
    u0_fein = paralleles_rechnen_h_minus1 -> v6;
#endif
    // Vom 5.12.14: Auf diese Weise geschieht die 'richtige' Randinterpolation. Wenn von r auf h, dann u0_grob = paralleles_rechnen_h -> v9.
// Kommentar: Die Struktur Feld des groben Gitters wird zugreifbar gemacht.
    feld = paralleles_rechnen_h->feld;
    }

// Kommentar: Fr den sdlichen Punkt (j+1,k) auf dem feinen Gitter sollen - (j,k) auf dem feinen Gitter entspricht (jj,kk)
// auf dem groben Gitter - die Punkte nrdlich von (jj,kk), ab (jj,kk), fr die Interpolation verwertbar gemacht werden.
// Ist (j+1,k) auf dem eigenen Kern, dann kann das ohne Kommunikation erfolgen, weil (j,k) und (jj,kk) auf dem
// eigenen Gitter liegen. Die Funktion dafr lautet 'nord_markieren_fuer_sued'. Ansonsten muss kommuniziert werden.
// Die Funktion dafr lautet 'nord_uebertragen_fuer_sued'.
// Bemerkung: Beides kann sich kombinieren. Wenn die ersten nrdlichen Grobgitterpunkte durch 'Markierung'
// verfgbar werden, dann knnen immer noch weiter nrdliche Grobgitterpunkte durch 'bertragung' verfgbar gemacht werden.
void RandInterpolation::scan_nordpunkte_fuer_sued(void)
    {
// Kommentar: Fr den Punkt (j+1,k) sollen Grobgitterinformationen bereitgestellt werden, und zwar von Norden her.
// Um Markierung und bertragung zu unterscheiden, muaa der Farbwert dieses Punktes bestimmt werden.
    farbe = fgff[j+1][k];   //Bei Ecke fgff(1,0).
//    farbe = ggff[jj+1][kk]; // nderung 31.10.2014: hier ggff fr fgff. 8.2.16: Diese nderung lassen wegen Klarheit in der Programmierung.
#ifdef AUSGABE_EFGH
    if((j==8)&&(k==20))
        {
        cout << " EFGH 20 (8,20) rang " << rang << " t " << t << " farbe " << farbe << endl;
        }
#endif
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Sued nach nord eigenrang " << eigenrang << " rang " << rang << endl;
#endif

// Kommentar: Entspricht der Farbwert dem Rang, so wird markiert. Denn der Punkt (j,k) ist in der eigenen Randliste.
// Damit sind (j+1,k) und der Grobgitterpunkt (jj,kk) auf demselben Kern, und der Grobgitterrandaustausch kann fr
// (j+1,k) verfgbar gemacht werden.
    if(farbe == rang)
        {
#ifdef AUSGABEN_RAND_INTERPOLATION
        cout << "Sued nach nord markieren Beginn rang " << rang << endl;
#endif
        nord_markieren_fuer_sued();
#ifdef AUSGABEN_RAND_INTERPOLATION
        cout << "Sued nach nord markieren Ende rang " << rang << endl;
#endif
        }
    else
        {
// Kommentar: Ansonsten muss der Farbwert >= 0 sein. Andernfalls muss auf(j+1,k) ja nicht interpoliert werden,
// und man braucht die Grobgitterwerte nicht.
        if(farbe>=0)
            {
#ifdef AUSGABEN_RAND_INTERPOLATION
            cout << "Sued nach nord uebertragen Beginn rang " << rang << endl;
#endif
// Kommentar: In diesem Fall liegen (j+1,k) und (jj,kk) auf verschiedenen Kernen, und der eigene Kern mit dem Punkt (jj,kk)
// schickt seine Grobgitterinformationen nrdlich ab (jj,kk) zum Kern mit dem Punkt (j+1,k)
            nord_uebertragen_fuer_sued();
#ifdef AUSGABEN_RAND_INTERPOLATION
            cout << "Sued nach nord uebertragen Ende rang " << rang << endl;
#endif
            }
        else    // Was bei farbe <0? Z.B. farbe == -3? Das wre die andere Ecke im Sd - Westen. Dann nichts ntig, weil
                // fr den Wert nichts gebraucht wird.
            {
            ;
            }
        }
    }

//void RandInterpolation::sued_nach_nord_markieren(void)  // Genau einen Wert markieren? Den ersten fremden Wert.

// Kommentar: Da (jj,kk) mit (j,k) auf dem eigenen Kern liegt, braucht der nicht markiert werden. Markiert wird
// die Feldliste von Gitter mit Werten von 2, wenn vorher -1 eingetragen war. Man liet damit ab,
// ob der Grobgitterwert verfgbar ist. Da (jj,kk) auf dem eigenen Kern liegt, liegt dort eine
// Markierung vor. Man guckt dann weiter nach Norden, weil immer noch entsprechend der Funktion
// scan_nordpunkte_fuer_sued fr (j+1,k) nrdliche Grobgitterpunkte verfgbar gemacht werden.
// Wegen des Grobgitterrandaustausches reichen die Grobgitterwerte eines weiter als man selber hat, und genau
// soweit wird im Folgenden markiert.
void RandInterpolation::nord_markieren_fuer_sued(void)  // Genau einen Wert markieren? Den ersten fremden Wert.
    {
    if(jj>=1)
        {
// Kommentar: Ist (jj-1,kk) der erste nicht eigene Punkt, dann wird der Markiert. Eigene Punkte sind immer markiert.
        if(ggff[jj-1][kk]!=eigenrang)
            {
            markierung.setzen(jj-1, kk);
            return;
            }
        }
    else    // Bei Ecke (0, 0) hier:
        {
        //markiere(0, 0); // Aufpassen: nicht doppelt markieren!
                        // Vorsicht: Es knnte ein Verfeinerungsgitter 'oben anstoen.
        markierung.setzen(0, kk);
        return;
        }
// Kommentar: Andernfalls kann auch noch weiter markiert werden, aber nur, wenn dort noch kein eigener Gitterpunkt existiert.
#ifdef AUCH_PLUS_2
    if(jj>=2)
        {
        if(ggff[jj-2][kk]!=eigenrang) // Was ist im anderen Fall? Gar keine Markierung? Ja, weil schon alles vorhanden ist in der FeldListe.
            {
            markierung.setzen(jj-2, kk);
            }
        }
#endif
    }

// Kommentar: Einfacher Aufruf der Funktion uebertrage der Vaterklasse UebertrageGrobgitterU.
inline void RandInterpolation::uebertrage_bedingt(int farbe, int jj, int kk)
    {
#ifdef AUSGABE_EFGH
    if((jj==8)&&(kk==3))
        {
        cout << " EFGH 6 (8,3) farbe " << farbe << " rang " << rang << " j " << j << " k " << k << endl;
        }
#endif
    uebertrage(farbe, jj, kk);
    }

// Kommentar: Mit dieser Funktion wird im Fall farbe(j+1,k)!=rang Information fr den Kern des Punktes (j+1,k)
// bereitgestellt. Man versucht die Grobgitterpunkte ab (jj,kk) Richtung Norden zu bertragen.
void RandInterpolation::nord_uebertragen_fuer_sued(void)
// Wieviele Werte sind zu uebertragen? Bei kubischer Interpolation von - ja von wo aus?
    {
// Kommentar: Zuerst wird der Wert auf der Stelle (jj,kk) an den Kern von (j+1,k) bermittelt.
    uebertrage(farbe, jj, kk);
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "sued_nach_nord uebertragen 1 rang " << rang << endl;
#endif
    if(j==0)
        {
        return; //  Ist Ecke. Der zu bertragene Wert ist durch Randaustausch bereits da.
        }
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "sued_nach_nord uebertragen 2 rang " << rang << endl;
#endif

// Kommentar: Ist der nrdliche Punkt kein eigener, dann kann der, wegen Randaustausch noch bertragen werden.
    if(ggff[jj-1][kk]!=eigenrang)
        {
#ifdef AUSGABEN_RAND_INTERPOLATION
        cout << "sued_nach_nord uebertragen 2a rang " << rang << endl;
#endif
#ifdef AUSGABEN_RAND_INTERPOLATION
        cout << "sued_nach_nord uebertragen 2b rang " << rang << endl;
#endif
        uebertrage_bedingt(farbe, jj-1, kk);
// Kommentar: Aber noch weiter geht es nicht, es sei denn, dass dieser Punkt wieder auf dem eigenen Kern liegt.
// Das ist der Fall der Punkte A,B,C in Reihe, wo A und C auf demselben, aber anderen Kern als B liegen.
        if((jj>=2)&&(feld[jj-2][kk]>=0))
            {
            uebertrage_bedingt(farbe, jj-2, kk);
            }
        // dieses if ist vom 3.11.14. Idee: Falls alternierend die Farben auftreten, kann voll bertragen werden.
#ifdef AUSGABEN_RAND_INTERPOLATION
        cout << "sued_nach_nord uebertragen 2c rang " << rang << endl;
#endif
        return;
        }
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "sued_nach_nord uebertragen 3 rang " << rang << " farbe " << farbe << " jj " << jj << " kk " << kk << endl;
#endif
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "sued_nach_nord uebertragen 4 rang " << rang << endl;
#endif
// Falls aber ggff[jj-1][kk]==eigenrang ist - und das ist der Fall, weil sonst vorher ein return geschieht,
// dann knnen noch die Punkte (jj-1,kk) und (jj-2,kk) bermittelt werden - wenn das Gitter es zult -
// weil (jj-1,kk) auf dem eigenen Kern liegt, und (jj-2,kk) durch Grobgitterkommunikation bestimmt worden ist.
    uebertrage_bedingt(farbe, jj-1, kk);
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "sued_nach_nord uebertragen 5 rang 324 " << rang << endl;
#endif
    if(jj>=2) // Hinzugefgt Gendert am 5.10.15
        {
        uebertrage_bedingt(farbe, jj-2, kk);
        }
// Hier sind ggf. jj-2 >= 0, weil j >= 1 ist. Aber warum ist die Farbe korrekt? Wegen
// der Abfrage 'if(ggff[jj-1][kk]!=eigenrang)'
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "sued_nach_nord uebertragen 6 rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu scan_nordpunkte_fuer_sued.
void RandInterpolation::scan_suedpunkte_fuer_nord(void)
    {
    farbe = fgff[j-1][k];
//    farbe = ggff[jj-1][kk]; // nderung 31.10.2014: hier ggff fr fgff. 9.2.16: Lassen zu Kontrollzwecken
#ifdef AKTUELLE_WERTE
    if((j==13)&&(k==10))
        {
        cout << " JJIIHH farbe " << farbe << " rang " << eigenrang << " ggff " << ggff[jj+1][kk] << endl;
        }
#endif
    if(farbe == eigenrang)
        {
        sued_markieren_fuer_nord();
        }
    else
        {
        if(farbe>=0)
            {
            sued_uebertragen_fuer_nord();
            }
        }
    }

// Kommentar: Geht analog zu 'nord_markieren_fuer_sued'
void RandInterpolation::sued_markieren_fuer_nord(void)
    {
    if(jj>=n_minus1_grob)
        {
        markierung.setzen(jj, kk); // Das einfach weglassen. 18.08.2014
        // 18.08.2014: to do : Das eigentlich weglassen, weil, wo ein Punkt existiert, auch markiert ist.
        // Diese Markierung bewirkt normalerweise gar nichts.
        return;
        }
    if(ggff[jj+1][kk]!=eigenrang)
        {
        markierung.setzen(jj+1, kk);
        return;
        }
#ifdef AUCH_PLUS_2
// #ifdef, da nur der Auenrand markiert werden soll.
    if(jj<n_minus2_grob)
        {
        if(ggff[jj+2][kk]!=eigenrang)
            {
            markierung.setzen(jj+2, kk);
            }
        }
#endif
// 16.08.2014: Warum darf ich diese Marierungen setzen? Weil sie ber den Rand herausreichen, aber bekannt sind.
// Was luft dabei nur verkehrt.
    }

// Kommentar: Analog zu 'nord_uebertragen_fuer_sued'.
void RandInterpolation::sued_uebertragen_fuer_nord(void)
// Wieviele Werte sind zu uebertragen? Bei kubischer Interpolation von - ja von wo aus?
// Man muss auch aufpassen, nur bekannte Werte zu bertragen. Sonst schreibt man noch falsche u0 - Werte.
    {
    uebertrage(farbe, jj, kk);
    if(jj >= n_minus1_grob)
        {
        return;
        }

    if(ggff[jj+1][kk]!=eigenrang) // Was ist mit ggff = -3? Also jj+1 >= n.
        {
        uebertrage_bedingt(farbe, jj+1, kk);
        if((jj<n_minus2_grob)&&(feld[jj+2][kk]>=0))
            {
            uebertrage_bedingt(farbe, jj+2, kk);
            }
        // dieses if ist vom 3.11.14. Idee: Falls alternierend die Farben auftreten, kann voll bertragen werden.
        return;
        }
    uebertrage_bedingt(farbe, jj+1, kk);
    if(jj<n_minus2_grob) // Hinzugefgt
        {
        uebertrage_bedingt(farbe, jj+2, kk);
#ifdef AKTUELLE_WERTE
        if((j==13)&&(k==12))
            {
            cout << " JJIIHH jj+2 " << jj+2 << " kk " << kk << endl;
            }
#endif
        }
    }

// Kommentar: Analog zu scan_nordpunkte_fuer_sued.
void RandInterpolation::scan_ostpunkte_fuer_west(void)
    {
    farbe = fgff[j][k-1];
//    farbe = ggff[jj][kk-1]; // nderung 31.10.2014: hier ggff fr fgff

#ifdef AUSGABE_EFGH
    if((j==16)&&(k==6))
        {
        cout << " EFGH 4 (16,6) rang " << rang << " farbe " << farbe << endl;
        }

    if((j==16))
        {
        cout << " EFGH 15 (16,6) rang " << rang << " farbe " << farbe << endl;
        }
#endif

    if(farbe == eigenrang)
        {
        ost_markieren_fuer_west();
        }
    else
        {
        if(farbe>=0)
            {
            ost_uebertragen_fuer_west();
            }
        }
    }

// Kommentar: Geht analog zu 'nord_markieren_fuer_sued'
void RandInterpolation::ost_markieren_fuer_west(void)
// Eine solche Markierung ist eigentlich nicht zulssig, weil eine Markierung nur bertragene Werte
// betreffen sollte. Denn hier ist eigentlich keine zustzliche Information entstanden.
    {
    if(kk>=m_minus1_grob)
        {
        markierung.setzen(jj, kk);
        }
    if(ggff[jj][kk+1]!=eigenrang)
        {
        markierung.setzen(jj, kk+1);
        // Das ist korrekt, weil so der Auenrand erkannt wird.
        }
#ifdef AUCH_PLUS_2
    if(kk<m_minus2_grob)
        {
        if(ggff[jj][kk+2]!=eigenrang)
            {
            markierung.setzen(jj, kk+2);
            // Das ist nicht korrekt, wenn es ber den Auenrand hinausgeht!
            }
        }
#endif
    }

// Kommentar: Analog zu 'nord_uebertragen_fuer_sued'.
void RandInterpolation::ost_uebertragen_fuer_west(void)
// Wieviele Werte sind zu uebertragen? Bei kubischer Interpolation von - ja von wo aus?
// Wichtig: Nach Osten.
    {
#ifdef AUSGABE_EFGH
    if(j==8)
        {
        cout << " EFGH 2 in RI ost fuer west (8," << k << ") farbe " << farbe << " rang " << rang << endl;
        }
#endif
    uebertrage(farbe, jj, kk);
    if(kk>=m_minus1_grob)
        {
        return;
        }
    if(ggff[jj][kk+1]!=eigenrang)
        {
        uebertrage_bedingt(farbe, jj, kk+1);
        if((kk<m_minus2_grob)&&(feld[jj][kk+2]>=0))
            {
            uebertrage_bedingt(farbe, jj, kk+2);
            }
        // dieses if ist vom 3.11.14
        return;
        }
    uebertrage_bedingt(farbe, jj, kk+1);
    if(kk<m_minus2_grob) // Hinzugefgt
        {
        uebertrage_bedingt(farbe, jj, kk+2);
        }
    }

//void RandInterpolation::scan_ost_nach_west(void)

// Kommentar: Analog zu scan_nordpunkte_fuer_sued.
void RandInterpolation::scan_westpunkte_fuer_ost(void)
    {
    farbe = fgff[j][k+1];
    if(farbe == eigenrang)
        {
        west_markieren_fuer_ost();
        }
    else
        {
        if(farbe>=0)
            {
            west_uebertragen_fuer_ost();
            }
        }
    }

// Kommentar: Geht analog zu 'nord_markieren_fuer_sued'
void RandInterpolation::west_markieren_fuer_ost(void)
    {
    if(kk == 0)
        {
        markierung.setzen(jj, kk);
        return;
        }
    if(ggff[jj][kk-1]!=eigenrang)
        {
        markierung.setzen(jj, kk-1);
        return;
        }
#ifdef AUCH_PLUS_2
    if(kk>1)
        {
        if(ggff[jj][kk-2]!=eigenrang)
            {
            markierung.setzen(jj, kk-2);
            }
        }
#endif
    }

// Kommentar: Analog zu 'nord_uebertragen_fuer_sued'.
void RandInterpolation::west_uebertragen_fuer_ost(void)
//void RandInterpolation::ost_nach_west_uebertragen(void)
// Wieviele Werte sind zu uebertragen? Bei kubischer Interpolation von - ja von wo aus?
    {
#ifdef AUSGABE_EFGH
    if(jj==8)
        {
        cout << " EFGH 5 in RI west fr ost (8," << kk << ") farbe " << farbe << " rang " << rang << endl;
        }
#endif
    uebertrage(farbe, jj, kk);
    if(k==0)
        {
        return;
        }

    if(ggff[jj][kk-1]!=eigenrang)
        {
        uebertrage_bedingt(farbe, jj, kk-1);
        if((kk>=2)&&(feld[jj][kk-2]>=0))
            {
            uebertrage_bedingt(farbe, jj, kk-2);
            }
        // dieses if ist vom 3.11.14
#ifdef AUSGABE_EFGH
        if(jj==8)
            {
            cout << " EFGH 7 Ende in RI west fr ost (8," << kk << ") farbe " << farbe << " rang " << rang << endl;
            }
#endif
        return;
        }
#ifdef AKTUELLE_WERTE
    if((j==2)&&(k==6))
        {
        cout << " KKJJII (2,6) iv " << endl;
        }
#endif
    uebertrage_bedingt(farbe, jj, kk-1);
    if(kk>=2) // Hinzugefgt.
        {
#ifdef AKTUELLE_WERTE
        if((j==2)&&(k==6))
            {
            cout << " KKJJII (2,6) v " << endl;
            }
#endif
        uebertrage_bedingt(farbe, jj, kk-2);
        }
#ifdef AUSGABE_EFGH
    if(jj==8)
        {
        cout << " EFGH 8 Ende in RI west fr ost (8," << kk << ") farbe " << farbe << " rang " << rang << endl;
        }
#endif
    }

// Kommentar: Wird in der switch case Anweisung der Funktion 'ausfuehren_packen_markieren' aufgerufen.
// Sie markiert die Variable erkennene_randsituation, wenn in der angegebenen Richtung kein Gitterpunkt existiert.
void RandInterpolation::scan_nordwest(void)
    {
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Beginn scan_nordwest rang " << rang << " j " << j << " k " << k << endl;
#endif

    if(fgff[j-1][k-1]<0)
        {
        erkennene_randsituation |= RI_NORDWEST;
        }
    return;
    }

// Kommentar: Analog zu scan_nordwest.
void RandInterpolation::scan_suedwest(void)
    {
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Beginn scan_suedwest rang " << rang << " j " << j << " k " << k << endl;
#endif
    if(fgff[j+1][k-1]<0)
        {
        erkennene_randsituation |= RI_SUEDWEST;
        }
    return;
    }

// Kommentar: Analog zu scan_nordwest.
void RandInterpolation::scan_nordost(void)
    {
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Beginn scan_nordost rang " << rang << " j " << j << " k " << k << endl;
#endif
    if(fgff[j-1][k+1]<0)
        {
        erkennene_randsituation |= RI_NORDOST;
        }
    return;

    }

// Kommentar: Analog zu scan_nordwest.
void RandInterpolation::scan_suedost(void)
    {
#ifdef AUSGABEN_RAND_INTERPOLATION
    cout << "Beginn scan_suedost rang " << rang << " j " << j << " k " << k << endl;
#endif
    if(fgff[j+1][k+1]<0)
        {
        erkennene_randsituation |= RI_SUEDOST;
        }
    return;
    }

// Kommentar: Die Funktion zur Markierung oder Kommunikation von Grobgitterpunkten, die fr die sich anschlieende
// Durchfhrung der Interpolation bentigt werden.
void RandInterpolation::ausfuehren_packen_markieren(void)
    {
// Kommentar: Der Feingitterrand wird durchlaufen.
    for(dynamischer_rand_fein->anfangsposition();dynamischer_rand_fein->ist_fertig_fl()==false;dynamischer_rand_fein->naechster())
        {
// Kommentar: Zur Erkennung der Randsituation muss die Variable erkenne_randsituation auf 0 gesetzt werden.
        erkennene_randsituation = 0;
// Kommentar: Dann wird der Feingitterpunkt gelesen.
        j = dynamischer_rand_fein->lesen_f();
        k = dynamischer_rand_fein->lesen_g();
// Kommentar: Nur fr gemeinsame Punkte kann die Grobgitterinformation beschafft werden, bzw. die Grobgittermarkierung
// vorgenommen werden.
        if((j&1)==1)
            {
            continue;
            }
        if((k&1)==1)
            {
            continue;
            }
#ifdef AKTUELLE_WERTE_NEU
        if(j==16)
            {
            cout << " EFGH 3 (16," << k << ") rang " << rang << endl;
            }
#endif
// Kommentar: Man beschafft die Grobgitterkoordinaten zum Feingitterpunkt.
        jj = j >> 1;
        kk = k >> 1;
// Kommentar: Man prft durch diese switch case - Anweisung des feinen Gitters, ob in den Himmelsrichtungen
// Nordost, Nordwest, Sdost und Sdwest keine Gitterpunkte sind. So kann der Typ von Feingitterrand an der Stelle (j,k)
// erkannt werden. Ob z.B. eine Linie von Nord nach Sd ist, wo links Punkte daneben sind, aber rechts nicht,
// oder ob z.B. eine Ecke von existierenden Punkten vorliegt, oder eine nach innen gewlbte Ecke.
            switch(255-selbstnachbarn_fein[j][k])
                {
                case 0:
                    break;
                case 1:
                    ;
                    break;
                case 2:
                    scan_nordost();
                    break;
                case 3:
                    ;
                    scan_nordost();;
                    break;
                case 4:
                    ;
                    break;
                case 5:
                    ;
                    ;
                    break;
                case 6:
                    scan_nordost();;
                    ;
                    break;
                case 7:
                    ;
                    scan_nordost();;
                    ;
                    break;
                case 8:
                    scan_suedost();;
                    break;
                case 9:
                    ;
                    scan_suedost();;
                    break;
                case 10:
                    scan_nordost();;
                    scan_suedost();;
                    break;
                case 11:
                    ;
                    scan_nordost();;
                    scan_suedost();
                    break;
                case 12:
                    ;
                    scan_suedost();;
                    break;
                case 13:
                    ;
                    ;
                    scan_suedost();;
                    break;
                case 14:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    break;
                case 15:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    break;
                case 16:
                    ;
                    break;
                case 17:
                    ;
                    ;

                    break;
                case 18:
                    scan_nordost();;
                    ;

                    break;
                case 19:
                    ;
                    scan_nordost();;
                    ;

                    break;
                case 20:
                    ;
                    ;

                    break;
                case 21:
                    ;
                    ;
                    ;

                    break;
                case 22:
                    scan_nordost();;
                    ;
                    ;

                    break;
                case 23:
                    ;
                    scan_nordost();;
                    ;

                    ;

                    break;
                case 24:
                    scan_suedost();;
                    ;

                    break;
                case 25:
                    ;
                    scan_suedost();;
                    ;

                    break;
                case 26:
                    scan_nordost();;
                    scan_suedost();;
                    ;

                    break;
                case 27:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;

                    break;
                case 28:
                    ;
                    scan_suedost();;
                    ;
                    break;
                case 29:
                    ;
                    ;
                    scan_suedost();;
                    ;

                    break;
                case 30:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    break;
                case 31:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    break;
                case 32:
                    scan_suedwest();
                    break;
                case 33:
                    ;
                    scan_suedwest();;
                    break;
                case 34:
                    scan_nordost();;

                    scan_suedwest();;
                    break;
                case 35:
                    ;
                    scan_nordost();;
                    scan_suedwest();;
                    break;
                case 36:
                    ;
                    scan_suedwest();;
                    break;
                case 37:
                    ;
                    ;
                    scan_suedwest();;
                    break;
                case 38:
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    break;
                case 39:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    break;
                case 40:
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 41:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 42:
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 43:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 44:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 45:
                    ;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 46:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 47:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    break;
                case 48:
                    ;
                    scan_suedwest();;
                    break;
                case 49:
                    ;
                    ;
                    scan_suedwest();;

                    break;
                case 50:
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    break;
                case 51:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    break;
                case 52:
                    ;
                    ;
                    scan_suedwest();;

                    break;
                case 53:
                    ;
                    ;
                    ;
                    scan_suedwest();;

                    break;
                case 54:
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    break;
                case 55:
                    ;
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    break;
                case 56:
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;
                case 57:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;
                case 58:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;
                case 59:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;
                case 60:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;
                    break;
                case 61:
                    ;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;
                case 62:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;
                case 63:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    break;

                case 64:
                    ;
                    break;

                case 65:
                    ;
                    ;
                    break;
                case 66:
                    scan_nordost();;
                    ;
                    break;
                case 67:
                    ;
                    scan_nordost();;
                    ;
                    break;
                case 68:
                    ;
                    ;
                    break;
                case 69:
                    ;
                    ;
                    ;
                    break;
                case 70:
                    scan_nordost();;
                    ;
                    ;
                    break;
                case 71:
                    ;
                    scan_nordost();;
                    ;
                    ;
                    break;
                case 72:
                    scan_suedost();;
                    ;
                    break;
                case 73:
                    ;
                    scan_suedost();;
                    ;
                    break;
                case 74:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    break;
                case 75:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    break;
                case 76:
                    ;
                    scan_suedost();;
                    ;
                    break;
                case 77:
                    ;
                    ;
                    scan_suedost();;
                    ;
                    break;
                case 78:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    break;
                case 79:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    break;
                case 80:
                    ;
                    ;
                    break;
                case 81:
                    ;
                    ;

                    ;
                    break;
                case 82:
                    scan_nordost();;
                    ;

                    ;
                    break;
                case 83:
                    ;
                    scan_nordost();;
                    ;

                    ;
                    break;
                case 84:
                    ;
                    ;

                    ;
                    break;
                case 85:
                    ;
                    ;
                    ;

                    ;
                    break;
                case 86:
                    scan_nordost();;
                    ;
                    ;

                    ;
                    break;
                case 87:
                    ;
                    scan_nordost();;
                    ;

                    ;

                    ;
                    break;
                case 88:
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 89:
                    ;
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 90:
                    scan_nordost();;
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 91:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 92:
                    ;
                    scan_suedost();;
                    ;
                    ;
                    break;
                case 93:
                    ;
                    ;
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 94:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 95:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    ;
                    break;
                case 96:
                    scan_suedwest();;
                    ;
                    break;

                case 97:
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 98:
                    scan_nordost();;

                    scan_suedwest();;
                    ;
                    break;
                case 99:
                    ;
                    scan_nordost();;
                    scan_suedwest();;
                    ;
                    break;
                case 100:
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 101:
                    ;
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 102:
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 103:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 104:
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 105:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 106:
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 107:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 108:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 109:
                    ;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 110:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 111:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    break;
                case 112:
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 113:
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 114:
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 115:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 116:
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 117:
                    ;
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 118:
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 119:
                    ;
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 120:
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 121:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 122:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 123:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 124:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;
                    ;
                    break;
                case 125:
                    ;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 126:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;
                case 127:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    break;

                case 128:
                    scan_nordwest();
                    break;
                case 129:
                    ;
                    scan_nordwest(); break;
                case 130:
                    scan_nordost();;
                    scan_nordwest(); break;
                case 131:
                    ;
                    scan_nordost();;
                    scan_nordwest(); break;
                case 132:
                    ;
                    scan_nordwest(); break;
                case 133:
                    ;
                    ;
                    scan_nordwest(); break;
                case 134:
                    scan_nordost();;
                    ;
                    scan_nordwest(); break;
                case 135:
                    ;
                    scan_nordost();;
                    ;
                    scan_nordwest(); break;
                case 136:
                    scan_suedost();;
                    scan_nordwest(); break;
                case 137:
                    ;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 138:
                    scan_nordost();;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 139:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 140:
                    ;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 141:
                    ;
                    ;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 142:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 143:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_nordwest(); break;
                case 144:
                    ;
                    scan_nordwest(); break;
                case 145:
                    ;
                    ;

                    scan_nordwest(); break;
                case 146:
                    scan_nordost();;
                    ;

                    scan_nordwest(); break;
                case 147:
                    ;
                    scan_nordost();;
                    ;

                    scan_nordwest(); break;
                case 148:
                    ;
                    ;

                    scan_nordwest(); break;
                case 149:
                    ;
                    ;
                    ;

                    scan_nordwest(); break;
                case 150:
                    scan_nordost();;
                    ;
                    ;

                    scan_nordwest(); break;
                case 151:
                    ;
                    scan_nordost();;
                    ;

                    ;

                    scan_nordwest(); break;
                case 152:
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 153:
                    ;
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 154:
                    scan_nordost();;
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 155:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 156:
                    ;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 157:
                    ;
                    ;
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 158:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 159:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    scan_nordwest(); break;
                case 160:
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 161:
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 162:
                    scan_nordost();;

                    scan_suedwest();;
                    scan_nordwest(); break;
                case 163:
                    ;
                    scan_nordost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 164:
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 165:
                    ;
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 166:
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 167:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 168:
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 169:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 170:
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 171:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 172:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 173:
                    ;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 174:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 175:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 176:
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 177:
                    ;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 178:
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 179:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 180:
                    ;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 181:
                    ;
                    ;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 182:
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 183:
                    ;
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 184:
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 185:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 186:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 187:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 188:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;
                    scan_nordwest(); break;
                case 189:
                    ;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 190:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;
                case 191:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    scan_nordwest(); break;

                case 192:
                    ;
                    scan_nordwest();
                    break;

                case 193:
                    ;
                    ;
                    scan_nordwest(); break;
                case 194:
                    scan_nordost();;
                    ;
                    scan_nordwest(); break;
                case 195:
                    ;
                    scan_nordost();;
                    ;
                    scan_nordwest(); break;
                case 196:
                    ;
                    ;
                    scan_nordwest(); break;
                case 197:
                    ;
                    ;
                    ;
                    scan_nordwest(); break;
                case 198:
                    scan_nordost();;
                    ;
                    ;
                    scan_nordwest(); break;
                case 199:
                    ;
                    scan_nordost();;
                    ;
                    ;
                    scan_nordwest(); break;
                case 200:
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 201:
                    ;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 202:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 203:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 204:
                    ;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 205:
                    ;
                    ;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 206:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 207:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_nordwest(); break;
                case 208:
                    ;
                    ;
                    scan_nordwest(); break;
                case 209:
                    ;
                    ;

                    ;
                    scan_nordwest(); break;
                case 210:
                    scan_nordost();;
                    ;

                    ;
                    scan_nordwest(); break;
                case 211:
                    ;
                    scan_nordost();;
                    ;

                    ;
                    scan_nordwest(); break;
                case 212:
                    ;
                    ;

                    ;
                    scan_nordwest(); break;
                case 213:
                    ;
                    ;
                    ;

                    ;
                    scan_nordwest(); break;
                case 214:
                    scan_nordost();;
                    ;
                    ;

                    ;
                    scan_nordwest(); break;
                case 215:
                    ;
                    scan_nordost();;
                    ;

                    ;

                    ;
                    scan_nordwest(); break;
                case 216:
                    scan_suedost();;
                    ;
                    ;
                    scan_nordwest(); break;
                case 217:
                    ;
                    scan_suedost();;
                    ;
                    ;
                    scan_nordwest(); break;
                case 218:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    ;
                    scan_nordwest(); break;
                case 219:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    ;
                    scan_nordwest(); break;
                case 220:
                    ;
                    scan_suedost();;
                    ;
                    ;
                    scan_nordwest();
                    break;
                case 221:
                    ;
                    ;
                    scan_suedost();;
                    ;

                    ;
                    scan_nordwest();
                    break;
                case 222:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    ;
                    scan_nordwest();
                    break;
                case 223:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;

                    ;
                    scan_nordwest(); break;
                case 224:
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;

                case 225:
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 226:
                    scan_nordost();;

                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 227:
                    ;
                    scan_nordost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 228:
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 229:
                    ;
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 230:
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 231:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 232:
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 233:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 234:
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 235:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 236:
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 237:
                    ;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 238:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 239:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 240:
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 241:
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 242:
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 243:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 244:
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 245:
                    ;
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 246:
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 247:
                    ;
                    scan_nordost();;
                    ;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 248:
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 249:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 250:
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 251:
                    ;
                    scan_nordost();;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 252:
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;
                    ;
                    scan_nordwest(); break;
                case 253:
                    ;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 254:
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                case 255:
                    ;
                    scan_nordost();;
                    ;
                    scan_suedost();;
                    ;
                    scan_suedwest();;

                    ;
                    scan_nordwest(); break;
                }
// Kommentar: Hiermit ist durch den Wert von 'erkennene_randsituation' bestimmt, wie die Randsituation um (j,k)
// aussieht. Entsprechend wird in der Funktion agieren_des_erkannten entsprechend die Funktionen wie
// scan_nordpunkte_fuer_sued, scan_suedpunkte_fuer_nord, scan_ostpunkte_fuer_west und scan_westpunkte_fuer_ost
// aufgerufen.
        agieren_des_erkannten();
        }
    }

// Kommentar: In der Funktion 'ausfuehren_packen_markieren' wurde der Wert 'erkennene_randsituation', der
// Werte zwischen 0 und 15 annehmen kann, geschrieben worden. Entsprechend diesem Wert werden an dieser Stelle
// nun aus den Funktionen scan_nordpunkte_fuer_sued, scan_suedpunkte_fuer_nord, scan_ostpunkte_fuer_west und
// scan_westpunkte_fuer_ost die passenden aufgerufen. Wir erlutern das an einem Beispiel.
void RandInterpolation::agieren_des_erkannten(void)
    {
/* Folgende Aktionen:   scan_nordpunkte_fuer_sued
                        scan_suedpunkte_fuer_nord
                        scan_ostpunkte_fuer_west
                        scan_westpunkte_fuer_ost */

#ifdef AKTUELLE_WERTE_NEU
    if((j==16)&&(k==4))
        {
        cout << " EFGH 10 (16,4) rang " << rang << " erkenne_randsituation " << erkennene_randsituation << endl;
        }
#endif

// Kommentar: Die switch case Anweisung wurde bereits motiviert: Die Variable erkennene_randsituation
// speichert die Randsituation an der Stelle (j,k), und entsprechend werden Informationen in Nord Sd oder
// West - Ost Richtung ber Funktionen wie scan_suedpunkte_fuer_nord beschafft.
    switch(erkennene_randsituation)
        {
        case 0:
            // Kein Rand
            break;
        case 1:
// Kommentar (Fall 1): Hier ist die Situation so: Nur nach Nord Ost gibt es keine Punkte. Man hat damit so eine innere Ecke:
//   *******
//   *******
//   ******+******
//   *************
// Mit + ist der Punkt (j,k) markiert. Man sieht, dass der nrdliche und der stliche Punkt Randpunkte sind
// fr die eine Randinterpolation gemacht werden muss. Fr den nrdlichen Punkt braucht man Grobgitterinformation
// in sdlicher Richtung, fr den stlichen Punkt in westlicher Richtung. Daher sind die Funktionen
// scan_suedpunkte_fuer_nord und scan_westpunkte_fuer_ost aufzurufen.

            // Nur NordOst -> Nach Nord und nach Ost
            scan_suedpunkte_fuer_nord();
            scan_westpunkte_fuer_ost();
            break;

// Kommentar: Analog Fall 1: Nur fr eine Himmelsrichtung gibt es keinen Punkt aus.
        case 2:
            // Nur NordWest -> Nach Nord und nach West
            scan_suedpunkte_fuer_nord();
            scan_ostpunkte_fuer_west();
            break;

// Kommentar (Fall 3): Hier ist der Fall so:
//
//        ***********+********
//        ********************
// Es gibt ber (j,l) keine Punkte, aber darunter schon. Also muss nur nach Osten und Westen interpoliert werden.
// Also Aufruf von 'scan_westpunkte_fuer_ost' und 'scan_ostpunkte_fuer_west'.
        case 3:
            // NordOst und NordWest -> waagerecht: Nach West und nach Ost
#ifdef AUSGABE_EFGH
            if((j==16)&&(k==4))
                {
                cout << " EFGH 12 (16,4) rang " << rang << endl;
                }
#endif
            scan_westpunkte_fuer_ost();
#ifdef AUSGABE_EFGH
            if((j==16)&&(k==4))
                {
                cout << " EFGH 13 (16,4) rang " << rang << endl;
                }
#endif
            scan_ostpunkte_fuer_west();
#ifdef AUSGABE_EFGH
            if((j==16)&&(k==4))
                {
                cout << " EFGH 14 (16,4) rang " << rang << endl;
                }
#endif
            break;

// Kommentar: Analog Fall 1: Nur fr eine Himmelsrichtung gibt es keinen Punkt aus.
        case 4:
            // SuedOst -> Nach Sued und nach Ost
            scan_nordpunkte_fuer_sued();
            scan_westpunkte_fuer_ost();
            break;

// Kommentar: Analog Fall 2: Fr zwei benachbarte Himmelsrichtungen gibt es keinen Punkt aus.
        case 5:
            // NordOst und SuedOst -> senkrecht: Nach Sued und nach Nord
            scan_nordpunkte_fuer_sued();
            scan_suedpunkte_fuer_nord();
            break;
// Kommentar (Fall 6): Das sieht so aus:
//     *******
//     *******
//     ******+*******
//           ********
//           ********
// Damit mssen in diesem Fall alle 4 scan - Funktionen aufgerufen werden. Man hat einfach eine Doppelecke, wobei eine
// Ecke wie in Fall 7 behandelt wird.
        case 6:
            // SuedOst und NordWest
            //cout << " Fehler in RI: Diagonale -1 sen case 6 j " << j  << " k " << k << endl;
            // Ist wie Fall 9 KEIN Fehler: Wenn auf dem groben Gitter (0,0) und (2,2) Verfeinerungspunkte sind,
            // tritt dieser Fall natrlich auf an der Stelle (1,1) des groben Gitters.
            // Jetzt noch sagen, wie programmieren.
            scan_nordpunkte_fuer_sued();
            scan_suedpunkte_fuer_nord();
            scan_ostpunkte_fuer_west();
            scan_westpunkte_fuer_ost();
            break;
        case 7:
// Kommentar (Fall 7):
//           ****+
//           *****
//           *****
// Damit - mit NordOst und NordWest und SdOst - hat man eine Ecke wie eben beschrieben. Dort mssen fr den
// sdlichen Punkt nrdliche Grobgitterpunkte bereitstehen, und fr den westlichen Feingitterpunkt stliche
// Grobgitterpunkte.
            // NordOst und NordWest und SuedOst
            // Ecke 1: nichts tun; doch tun:
            scan_nordpunkte_fuer_sued();
            scan_ostpunkte_fuer_west();
            break;

        case 8:
// Kommentar: Vgl. Fall 1
            // SuedWest -> Nach Sued und nach West
            scan_nordpunkte_fuer_sued();
            scan_ostpunkte_fuer_west();
            break;
        case 9:
// Kommentar: Analog zu Fall 6.
            // SuedWest und NordOst
            scan_nordpunkte_fuer_sued();
            scan_suedpunkte_fuer_nord();
            scan_ostpunkte_fuer_west();
            scan_westpunkte_fuer_ost();

//            cout << " Fehler in RI: Diagonale -1 sen case 9 j"  << j  << " k " << k << endl;
// Kein Fehler, vgl. case 6: Kommentar,
            break;
        case 10:
// Kommentar: Analog zu Fall 2.
            // SuedWest und NordWest -> senkrecht: Nach Sued und nach Nord
            scan_nordpunkte_fuer_sued();
            scan_suedpunkte_fuer_nord();
            break;
        case 11:
// Kommentar: Analog zu Fall 7.
            // SuedWest und NordOst und NordWest
            // Ecke 2: nichts tun: doch tun
            scan_westpunkte_fuer_ost();
            scan_nordpunkte_fuer_sued();
            break;
        case 12:
            // SuedWest und SuedOst -> waagerecht: Nach West und nach Ost
// Kommentar: Analog zu Fall 2.
            scan_westpunkte_fuer_ost();
            scan_ostpunkte_fuer_west();
            break;
        case 13:
// Kommentar: Analog zu Fall 7.
            // SuedWest und SuedOst und NordOst
            // Ecke 3: Nichts tun: doch tun
            scan_suedpunkte_fuer_nord();
            scan_ostpunkte_fuer_west();
            break;
        case 14:
// Kommentar: Analog zu Fall 7.
            // SuedWest und SuedOst und NordWest
            scan_suedpunkte_fuer_nord();
            scan_westpunkte_fuer_ost();
            break;
        case 15:
// Kommentar: Bei alle 4 Himmelsrichtungen mit Farbwert < 0 htte man einen isolierten Punkt, der wegen der 5 x 5
// berdeckungen nicht eintreten kann. Also muss fr diesen Fall eine Fehlermeldung ausgegeben werden.
            // Alle Himmelsrichtungen
            cout << " RI: Fehler: Alle Himmelsrichtungen " << endl;
            cout << " j " << j << " k " << k << " ri_ebene " << ri_ebene << " rang " << rang << " 2473 " << endl;
            ausgeben_farbenfeld();
            exit(-1);
            break;
        }
    }

// Kommentar: Mit dieser Funktion wird das Farbenfeld ausgegeben. Frs Debugging.
void RandInterpolation::ausgeben_farbenfeld(void)
    {
    cout << " Ausgeben Farbenfeld " << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << fgff[i][j] << " ";
            }
        cout << endl;
        }
    }

// Kommentar: Interpolieren Nord bedeutet, dass interpoliert wird, wenn (j,k) beim Randdurchlauf des feinen Gitters
// in der Funktion rand_interpolieren nrdlich kein Gitterpunkt existiert. Man hat dann eine west - ost - Interpolation
// an der Stelle (j,k)
void RandInterpolation::interpolieren_nord(void)
    {
// Kommentar: Bis hierhin ist in (j,k) nur ein Randpunkt vorhanden, wo im Norden kein Punkt auf dem eigenen Kern liegt.
// Hiermit wird geprft, ob nrdlich nichts existiert. Das ist nun der Fall, und es kommt zur Randinterpolation.
    if(fgff[j-1][k] < 0)
        {
#ifdef AKTUELLE_WERTE
        cout << "(" << j << "," << k << ")";
#endif
// Kommentar: Wenn (j,k) ein gemeinsamer Punkt ist ...
        if(((j&1)==0)&&((k&1)==0))
            {
// Kommentar: Dann kopiere den Grobgitterwert. Ob das numerisch sinnvoll ist, oder ob besser der Feingitterwert bleibt.
// sei dahingestellt. So stellen nur die Grobgitterpunkt fr die Feingitter - Randlinie eine Quelle dar.
            u0_fein[j][k] = u0_grob[j>>1][k>>1];
            //return;
            }// Diesen Befehl nachtrglich. Sie macht Sinn. Aber: testen auf fgff = -1 daneben
        else
// Kommentar: Hier liegt jetzt ein Gitterpunkt zwischen gemeinsamen Gitterpunkten vor. Denn am Rand gibt es nur
// gemeinsame Gitterpunkte, und solche Zwischenpunkte. Fr diese Zwischenpunkte kommt es jetzt zu einer
// Interpolation der Grobgitterwerte. Wegen fgff(j-1,k) erfolgt diese Interpolation in West - Ost - Richtung,
// und der Zwischenpunkt liegt horizontal zwischen gemeinsamen Punkten.
            {
            rand_interpolation_west_ost();
            }
        }
    }

// Kommentar: Analog zu interpolieren_nord.
void RandInterpolation::interpolieren_sued(void)
    {
    if(fgff[j+1][k] < 0)
        {
#ifdef AKTUELLE_WERTE
        cout << "(" << j << "," << k << ")";
#endif
        if(((j&1)==0)&&((k&1)==0))
            {
            u0_fein[j][k] = u0_grob[j>>1][k>>1];
            }// Diesen Befehl nachtrglich. Sie macht Sinn. Aber: testen auf fgff = -1 daneben
        else
            {
            rand_interpolation_west_ost();
            }
        }
    }

// Kommentar: Analog zu interpolieren_nord.
void RandInterpolation::interpolieren_west(void)
    {
    if(fgff[j][k-1] < 0)
        {
#ifdef AKTUELLE_WERTE
        cout << "(" << j << "," << k << ")";
#endif
        if(((j&1)==0)&&((k&1)==0))
            {
            u0_fein[j][k] = u0_grob[j>>1][k>>1];
            }// Diesen Befehl nachtrglich. Sie macht Sinn. Aber: testen auf fgff = -1 daneben
        else
            {
            rand_interpolation_nord_sued();
            }
        }
    }

// Kommentar: Analog zu interpolieren_nord.
void RandInterpolation::interpolieren_ost(void)
    {
    if(fgff[j][k+1] < 0)
        {
#ifdef AKTUELLE_WERTE
        cout << "(" << j << "," << k << ")";
#endif
        if(((j&1)==0)&&((k&1)==0))
            {
            u0_fein[j][k] = u0_grob[j>>1][k>>1];
            }// Diesen Befehl nachtrglich. Sie macht Sinn. Aber: testen auf fgff = -1 daneben
        else
            {
            rand_interpolation_nord_sued();
            }
        }
    }

// Kommentar: Hier liegt der zu interpolierende Punkt horizontal zwischen Grobgitterpunkten.
void RandInterpolation::rand_interpolation_west_ost(void)
    {
    // k muss ungerade sein, damit k-1 und k+1 gerade sind
// Die folgenden Abfragen sind eigentlich selbstverstndich erfllt bei einer horizontalen Randinterpolation, vgl. die
// Bemerkung zu rand_interpolation_west_ost. Denn: Der Punkt ist (j,k), und j soll gerade, k aber ungerad sein.
    if((k&1)==0)
        {
        return;
        }
    if((j&1)==1) // j muss gerade sein
        {
        return;
        }
// Kommentar: Wir nehmen den Grobgitterpunkt links vom Punkt (j,k).
    jj = j >> 1;
    kk = (k-1) >> 1;
#ifdef AKTUELLE_WERTE
    cout << " WEST_OST ";
#endif
// Kommentar: Je nachdem, wie markiert wurde - beim bertragen wird auch die Struktur Feld mit Werte >= 0 beschrieben,
// werden die Grobgitterpunkte (jj,kk)(jj,kk-1) und (jj,kk-2) erkannt - dass sie im maximalen Gitterbereich
// (0,...,n-1)x(0,...,m-1) existieren - und das Feld dort einen Eintrag >= 0 hat. Die Werte 0 bis 2
// reichen bis zur ersten Abweichung von Feld >= 0. Ist Feld(jj,kk-1) < 0, so ist Feld(jj,kk-2) nicht mehr zu prfen.
    links = bestimme_wieviel_nach_links();
// Kommentar: Je nachdem, wie markiert wurde - beim bertragen wird auch die Struktur Feld mit Werte >= 0 beschrieben,
// werden die Grobgitterpunkte (jj,kk+1)(jj,kk+2) und (jj,kk+3) erkannt - dass sie im maximalen Gitterbereich
// (0,...,n-1)x(0,...,m-1) existieren - und das Feld dort einen Eintrag >= 0 hat. Die Werte 0 bis 2
// reichen bis zur ersten Abweichung von Feld >= 0.
    rechts = bestimme_wieviel_nach_rechts();

#ifdef AKTUELLE_WERTE
    if((j==16)&&(k==1))
        {
        cout << " DEFG (16,1) links " << links << " rechts " << rechts << " t " << t << " feld[8][3] " << feld[8][3] << endl;
        }

    if((j==6)&&(k==15))
        {
        cout << " DEF (6,15) links " << links << " rechts " << rechts << " u0_fein " << u0_fein[6][15] << " t " << t << endl;
        }
#endif

// Kommentar: Hier wird eine Kombination von links*4 + rechts genommen, um genau zu wissen, wieviel Information
// fr die Interpolation bereitsteht, um ein mglichst hohe Ordnung der Interpolation (max. kubisch), und dann
// eine mglichst symmetrische Interpolation zu erreichen.
    switch((links<<2)+rechts)
        {
// Kommentar: Fall 0: links = 0, rechts = 0. Die Information reicht von (jj,kk) bis (jj,kk+1). Daher nur eine
// lineare Interpolation.
        case 0: // Links 0 Rechts 0 lineare Interpolation, sollte gar nicht vorkommen
            u0_fein[j][k] = 0.5*(u0_grob[jj][kk]+u0_grob[jj][kk+1]);
            break;
// Kommentar: Fall 1: links = 0, rechts = 1. Die Information reicht von (jj,kk) bis (jj,kk+2). Daher nur eine
// quadratische Interpolation, die unsymmetrisch ist, mit dem mittleren Punkt (jj,kk+1). Die Sttzstellen von
// a x^2 + b x + c sind -1,1,3 bei Aufrufposition 0.
        case 1: // Links 0 Rechts 1 => quadratische Interpolation, sollte hchstens bei Ecken vorkommen
            u0_fein[j][k] = 0.375 * u0_grob[jj][kk] + 0.75 * u0_grob[jj][kk+1] - 0.125 * u0_grob[jj][kk+2];
            break;
// Kommentar: Fall 2: links 0, rechts 2. Die Information reicht von (jj,kk) bid (jj, kk+3). Eine asymetrische
// kubisch Interpolation. Sie wird berechnet  durch a x^3 + b x^2 + c x + d auf den Stellen -1, 1, 3 und 5 fr die Stelle 0.
        case 2: // Links 0 Rechts 2 => kubische Interpolation asymmetrisch
            u0_fein[j][k] = 0.3125 * u0_grob[jj][kk] + 0.9375 * u0_grob[jj][kk+1] - 0.3125 * u0_grob[jj][kk+2] + 0.0625 * u0_grob[jj][kk+3];
#ifdef AKTUELLE_WERTE
            if((j==16)&&(k==1))
                {
                cout << " DEFG (16,1) jj,kk bis kk+3 " << u0_grob[jj][kk] << " " << u0_grob[jj][kk+1] << " ";
                cout << u0_grob[jj][kk+2] << " " << u0_grob[jj][kk+3] << " rang " << rang << endl;
                }
#endif
            break;
        case 3:
        case 7:
        case 11:
// Kommentar: Diese Werte sind unmglich, weil rechts 3 wre, ein Wert, der als Funktionswert von 'bestimme_wieviel_nach_rechts'
// nicht in Frage kommt.
        default:
            cout << " Fehler: Programmfehler in RandInterpolation wert links " << links << " rechts " << rechts << " links<<2+rechts " << ((links<<2)+rechts) << endl;
            exit(-1);
        case 4: // Links 1 Rechts 0 => quadratische Interpolation
// Kommentar: Fall 4: links 1, rechts 0. Analog zu oben.
            u0_fein[j][k] = -0.125 * u0_grob[jj][kk-1] + 0.75 * u0_grob[jj][kk] + 0.375 * u0_grob[jj][kk+1];
            break;
// Kommentar: Flle 5,6,9,10: links >= 1, rechts >= 1. Die Information (jj,kk-1) bis (jj,kk-2) liegen vor. Daher
// eine symmetrisch kubische Interpolation mit den Sttzstellen -3, -1, 1 und 3 und dem Interpolationspunkt 0.
        case 5: // Links 1 Rechts 1 => kubische Interpolation symmetrisch
        case 6: // Links 1 Rechts 2 => selbiges
        case 9: // Links 2 Rechts 1 => selbiges
        case 10: // Links 2 Rechts 2 => selbiges
            u0_fein[j][k] = -0.0625 * u0_grob[jj][kk-1] + 0.5625 * u0_grob[jj][kk] + 0.5625 * u0_grob[jj][kk+1] - 0.0625 * u0_grob[jj][kk+2];
            break;
// Kommentar: Fall 8: links 2 rechts 0 => analog zu Fall 2.
        case 8: // Links 2 Rechts 0 => kubische Interpolation asymetrisch. Formel vom 23.2.2016
            u0_fein[j][k] = 0.0625 * u0_grob[jj][kk-2] - 0.3125 * u0_grob[jj][kk-1] + 0.9375 * u0_grob[jj][kk] + 0.3125 * u0_grob[jj][kk+1];
            break;
        }
    }

// Kommentar: Hier wird im Grobgitter bestimmt, wiewiel der Werte fr Feld auf den Stellen (jj,kk), (jj,kk-1) und (jj,kk-2)
// >= 0 sind - wenn sie ins Gitter bzgl. der Gittermae passen.
int RandInterpolation::bestimme_wieviel_nach_links(void)
    {
// Kommentar: kk<0 ist irreglr.
    if(kk<0)
        {
        cout << " Fehler: Falsches kk in bestimme_wieviel_nach_links kk " << kk << endl;
        exit(-1);
        }
// Kommentar: kk = 0 => die Werte reichen nur bis (jj,kk)
    if(kk==0)
        {
        return(0);
        }
// Kommentar: kk = 1 => die Werte reichen maximal bis (jj,kk-1). Und das ist (jj,0). Das Feld wird dann geprft.
    if(kk==1)
        {
        if(feld[jj][0]>=0)
            {
            return(1);
            }
        else
            {
            return(0);
            }
        }
// Kommentar: Andernfalls ist gengend Platz, d.h. es wird erst feld(jj,kk-1)  und dann feld(jj,kk-2) geprft - und
// je nachdem wird eine Lnge zwischen 0 und 2 zurckgegeben.
        {
        if(feld[jj][kk-1]>=0)
            {
            if(feld[jj][kk-2]>=0)
                {
                return(2);
                }
            else
                {
                return(1);
                }
            }
        else
            {
            return(0);
            }
        }
    }

// Kommentar: Hier wird im Grobgitter bestimmt, wiewiel der Werte fr Feld auf den Stellen (jj,kk+1), (jj,kk+2) und (jj,kk+3)
// >= 0 sind - wenn sie ins Gitter bzgl. der Gittermae passen.
// Rest analog zu bestimme_wieviel_nach_links.
int RandInterpolation::bestimme_wieviel_nach_rechts(void)
    {
    if(kk==m_minus2_grob) // kk ist k-1 / 2, also k+1 / 2 maximal m_minus1_grob
        {
        return(0);
        }
    if(kk==m_minus3_grob)
        {
        if(feld[jj][m_minus1_grob]>=0)
            {
            return(1);
            }
        else
            {
            return(0);
            }
        }
//    if(kk<m_minus2_grob) 9.2.16: Ist es mglich, dass kk==m_minus1_grob ist?
        {
        if(feld[jj][kk+2]>=0)
            {
            if(feld[jj][kk+3]>=0)
                {
                return(2);
                }
            else
                {
                return(1);
                }
            }
        else
            {
            return(0);
            }
        }
    }

// Kommentar: Analog zu 'rand_interpolation_west_ost'. Daher keine weiteren Kommentare.
void RandInterpolation::rand_interpolation_nord_sued(void)
    {
    // k muss gerade sein
    if((k&1)==1)
        {
        return;
        }
    if((j&1)==0) // j muss ungerade sein, damit j+1 und j-1 gerade sind
        {
        return;
        }

    jj = (j-1) >> 1;
    kk = k >> 1;
#ifdef AKTUELLE_WERTE
    cout << " NORD_SUED ";
#endif
    oben = bestimme_wieviel_nach_oben();
    unten = bestimme_wieviel_nach_unten();

#ifdef AKTUELLE_WERTE
    if((j==31)&&(k==36))
        {
        cout << " JJIIHH oben " << oben << " unten " << unten << " " << " j " << j << " k " << k << " ";
        cout << " " << u0_grob[jj-2][kk] << " " << u0_grob[jj-1][kk] << " " << u0_grob[jj][kk] << " " << u0_grob[jj+1][kk] << " " << u0_grob[jj+2][kk] << endl;
        }
#endif
#ifdef AKTUELLE_WERTE
    cout << "(" << j << "," << k << "," << u0_fein[j][k] << ",";
#endif
    switch((oben<<2)+unten)
        {
        case 0: // Oben 0 Unten 0 lineare Interpolation, sollte gar nicht vorkommen
            u0_fein[j][k] = 0.5*(u0_grob[jj][kk]+u0_grob[jj+1][kk]);
            break;
        case 1: // Oben 0 Unten 1 => quadratische Interpolation, sollte hchstens bei Ecken vorkommen
            u0_fein[j][k] = 0.375 * u0_grob[jj][kk] + 0.75 * u0_grob[jj+1][kk] - 0.125 * u0_grob[jj+2][kk];
            break;
        case 2: // Oben 0 Unten 2 => kubische Interpolation asymmetrisch
            u0_fein[j][k] = 0.3125 * u0_grob[jj][kk] + 0.9375 * u0_grob[jj+1][kk] - 0.3125 * u0_grob[jj+2][kk] + 0.0625 * u0_grob[jj+3][kk];
            break;
        case 3:
        case 7:
        case 11:
        default:
            cout << " Fehler: Programmfehler in RandInterpolation " << endl;
            exit(-1);
        case 4: // Oben 1 Unten 0 => quadratische Interpolation
            u0_fein[j][k] = -0.125 * u0_grob[jj-1][kk] + 0.75 * u0_grob[jj][kk] + 0.375 * u0_grob[jj+1][kk];
            break;
        case 5: // Oben 1 Unten 1 => kubische Interpolation symmetrisch
        case 6: // Oben 1 Unten 2 => selbiges
        case 9: // Oben 2 Unten 1 => selbiges
        case 10: // Oben 2 Unten 2 => selbiges
            u0_fein[j][k] = -0.0625 * u0_grob[jj-1][kk] + 0.5625 * u0_grob[jj][kk] + 0.5625 * u0_grob[jj+1][kk] - 0.0625 * u0_grob[jj+2][kk];
            break;
        case 8: // Oben 2 unten 0 => kubische Interpolation assymetrisch
            u0_fein[j][k] = 0.0625 * u0_grob[jj-2][kk] - 0.3125 * u0_grob[jj-1][kk] + 0.9375 * u0_grob[jj][kk] + 0.3125 * u0_grob[jj+1][kk];
            break;
        }
#ifdef AKTUELLE_WERTE
    cout << u0_fein[j][k] << ")";
#endif
    }

// Kommentar: Analog zu 'bestimme_wieviel_nach_links'. Daher: Keine weiteren Kommentare.
int RandInterpolation::bestimme_wieviel_nach_oben(void)
    {
    if(jj==0)
        {
        return(0);
        }
    if(jj==1)
        {
        if(feld[0][kk]>=0)
            {
            return(1);
            }
        else
            {
            return(0);
            }
        }
        {
        if(feld[jj-1][kk]>=0)
            {
            if(feld[jj-2][kk]>=0)
                {
                return(2);
                }
            else
                {
                return(1);
                }
            }
        else
            {
            return(0);
            }
        }
    }

// Kommentar: Analog zu 'bestimme_wieviel_nach_rechts'. Daher: Keine weiteren Kommentare.
int RandInterpolation::bestimme_wieviel_nach_unten(void)
    {
    if(jj==n_minus2_grob)
        {
        return(0);
        }
    if(jj==n_minus3_grob)
        {
        if(feld[n_minus1_grob][kk]>=0)
            {
            return(1);
            }
        else
            {
            return(0);
            }
        }
//    if(jj<n_minus2_grob) 9.2.16: s.o.
        {
        if(feld[jj+2][kk]>=0)
            {
            if(feld[jj+3][kk]>=0)
                {
                return(2);
                }
            else
                {
                return(1);
                }
            }
        else
            {
            return(0);
            }
        }
    }

// Kommentar: Hier wird nur der Feingitterrand durchlaufen, und es wird nur bei Randpunkten in den Himmelsrichtungen
// Ost, Sd, Nord und West geprft, ob dort nichts existiert. Die Funktion rand_interpolieren ruft dafr die
// entsprechenden Funktionen interpolieren_nord, interpolieren_ost, interpolieren_sued und interpolieren_west auf,
// wenn dort kein eigener Gitterpunkt liegt, weil dort auch nichts sein knnte. Die interpolieren - Funktionen
// machen dann alles weitere, bis hin zur kubischen Interpolation - falls dies ntig und mglich ist.
void RandInterpolation::rand_interpolieren(void)
    {
// Kommentar: Der Feingitterrand wird durchlaufen.
    for(dynamischer_rand_fein->anfangsposition();dynamischer_rand_fein->ist_fertig_fl()==false;dynamischer_rand_fein->naechster())
        {
        j = dynamischer_rand_fein->lesen_f();
        k = dynamischer_rand_fein->lesen_g();

// Kommentar: Die Verbindungen zu nicht eigenen Gitterpunkten werden per switch - case - Anweisung geprft - aber nur
// in Nord, Ost, Sd oder West - Richtung.
            switch(255-selbstnachbarn_fein[j][k])
                {
                case 0:
                    break;
                case 1:
// Kommentar: Ist in Nord - Richtung kein eigener Punkt, so wird interpolieren_nord aufgerufen.
                    interpolieren_nord();
                    break;
                case 2:
// Kommentar: Bei case = 2 ist nur in Nord - Ost - Richtung kein eigener Punkt. Dieser Fall gehrt nicht zu den
// Richtungen Nord, Ost, Sd und West, und es wird daher gar nichts gemacht.
                    ;
                    break;
                case 3:
// Kommentar: Usw.
                    interpolieren_nord();
                    ;
                    break;
                case 4:
                    interpolieren_ost();
                    break;
                case 5:
                    interpolieren_nord();
                    interpolieren_ost();
                    break;
                case 6:
                    ;
                    interpolieren_ost();
                    break;
                case 7:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    break;
                case 8:
                    ;
                    break;
                case 9:
                    interpolieren_nord();
                    ;
                    break;
                case 10:
                    ;
                    ;
                    break;
                case 11:
                    interpolieren_nord();
                    ;
                    ;
                    break;
                case 12:
                    interpolieren_ost();
                    ;
                    break;
                case 13:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    break;
                case 14:
                    ;
                    interpolieren_ost();
                    ;
                    break;
                case 15:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    break;
                case 16:
                    interpolieren_sued();
                    break;
                case 17:
                    interpolieren_nord();
                    interpolieren_sued();

                    break;
                case 18:
                    ;
                    interpolieren_sued();

                    break;
                case 19:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    break;
                case 20:
                    interpolieren_ost();
                    interpolieren_sued();

                    break;
                case 21:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();

                    break;
                case 22:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();

                    break;
                case 23:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();

                    interpolieren_sued();

                    break;
                case 24:
                    ;
                    interpolieren_sued();

                    break;
                case 25:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    break;
                case 26:
                    ;
                    ;
                    interpolieren_sued();

                    break;
                case 27:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();

                    break;
                case 28:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    break;
                case 29:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    break;
                case 30:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    break;
                case 31:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    break;
                case 32:
                    ;
                    break;
                case 33:
                    interpolieren_nord();
                    ;
                    break;
                case 34:
                    ;

                    ;
                    break;
                case 35:
                    interpolieren_nord();
                    ;
                    ;
                    break;
                case 36:
                    interpolieren_ost();
                    ;
                    break;
                case 37:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    break;
                case 38:
                    ;
                    interpolieren_ost();
                    ;
                    break;
                case 39:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    break;
                case 40:
                    ;
                    ;
                    break;
                case 41:
                    interpolieren_nord();
                    ;
                    ;
                    break;
                case 42:
                    ;
                    ;
                    ;
                    break;
                case 43:
                    interpolieren_nord();
                    ;
                    ;
                    ;
                    break;
                case 44:
                    interpolieren_ost();
                    ;
                    ;
                    break;
                case 45:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    ;
                    break;
                case 46:
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    break;
                case 47:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    break;
                case 48:
                    interpolieren_sued();
                    ;
                    break;
                case 49:
                    interpolieren_nord();
                    interpolieren_sued();
                    ;

                    break;
                case 50:
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 51:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 52:
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    break;
                case 53:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    break;
                case 54:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    break;
                case 55:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    break;
                case 56:
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 57:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 58:
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 59:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 60:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;
                    break;
                case 61:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 62:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    break;
                case 63:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    break;

                case 64:
                    interpolieren_west();
                    break;

                case 65:
                    interpolieren_nord();
                    interpolieren_west();
                    break;
                case 66:
                    ;
                    interpolieren_west();
                    break;
                case 67:
                    interpolieren_nord();
                    ;
                    interpolieren_west();
                    break;
                case 68:
                    interpolieren_ost();
                    interpolieren_west();
                    break;
                case 69:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_west();
                    break;
                case 70:
                    ;
                    interpolieren_ost();
                    interpolieren_west();
                    break;
                case 71:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    interpolieren_west();
                    break;
                case 72:
                    ;
                    interpolieren_west();
                    break;
                case 73:
                    interpolieren_nord();
                    ;
                    interpolieren_west();
                    break;
                case 74:
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 75:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 76:
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 77:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 78:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 79:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 80:
                    interpolieren_sued();
                    interpolieren_west();
                    break;
                case 81:
                    interpolieren_nord();
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 82:
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 83:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 84:
                    interpolieren_ost();
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 85:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 86:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 87:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();

                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 88:
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 89:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 90:
                    ;
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 91:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 92:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    interpolieren_west();
                    break;
                case 93:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 94:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 95:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    break;
                case 96:
                    ;
                    interpolieren_west();
                    break;

                case 97:
                    interpolieren_nord();
                    ;
                    interpolieren_west();
                    break;
                case 98:
                    ;

                    ;
                    interpolieren_west();
                    break;
                case 99:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 100:
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 101:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 102:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 103:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    break;
                case 104:
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 105:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 106:
                    ;
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 107:
                    interpolieren_nord();
                    ;
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 108:
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 109:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 110:
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 111:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    break;
                case 112:
                    interpolieren_sued();
                    ;
                    interpolieren_west();
                    break;
                case 113:
                    interpolieren_nord();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 114:
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 115:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 116:
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 117:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 118:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 119:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 120:
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 121:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 122:
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 123:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 124:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;
                    interpolieren_west();
                    break;
                case 125:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 126:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;
                case 127:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    break;

                case 128:
                    ;
                    break;
                case 129:
                    interpolieren_nord();
                    ; break;
                case 130:
                    ;
                    ; break;
                case 131:
                    interpolieren_nord();
                    ;
                    ; break;
                case 132:
                    interpolieren_ost();
                    ; break;
                case 133:
                    interpolieren_nord();
                    interpolieren_ost();
                    ; break;
                case 134:
                    ;
                    interpolieren_ost();
                    ; break;
                case 135:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ; break;
                case 136:
                    ;
                    ; break;
                case 137:
                    interpolieren_nord();
                    ;
                    ; break;
                case 138:
                    ;
                    ;
                    ; break;
                case 139:
                    interpolieren_nord();
                    ;
                    ;
                    ; break;
                case 140:
                    interpolieren_ost();
                    ;
                    ; break;
                case 141:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    ; break;
                case 142:
                    ;
                    interpolieren_ost();
                    ;
                    ; break;
                case 143:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    ; break;
                case 144:
                    interpolieren_sued();
                    ; break;
                case 145:
                    interpolieren_nord();
                    interpolieren_sued();

                    ; break;
                case 146:
                    ;
                    interpolieren_sued();

                    ; break;
                case 147:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    ; break;
                case 148:
                    interpolieren_ost();
                    interpolieren_sued();

                    ; break;
                case 149:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();

                    ; break;
                case 150:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();

                    ; break;
                case 151:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();

                    interpolieren_sued();

                    ; break;
                case 152:
                    ;
                    interpolieren_sued();

                    ; break;
                case 153:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    ; break;
                case 154:
                    ;
                    ;
                    interpolieren_sued();

                    ; break;
                case 155:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();

                    ; break;
                case 156:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ; break;
                case 157:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    ; break;
                case 158:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    ; break;
                case 159:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    ; break;
                case 160:
                    ;
                    ; break;
                case 161:
                    interpolieren_nord();
                    ;
                    ; break;
                case 162:
                    ;

                    ;
                    ; break;
                case 163:
                    interpolieren_nord();
                    ;
                    ;
                    ; break;
                case 164:
                    interpolieren_ost();
                    ;
                    ; break;
                case 165:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    ; break;
                case 166:
                    ;
                    interpolieren_ost();
                    ;
                    ; break;
                case 167:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    ; break;
                case 168:
                    ;
                    ;
                    ; break;
                case 169:
                    interpolieren_nord();
                    ;
                    ;
                    ; break;
                case 170:
                    ;
                    ;
                    ;
                    ; break;
                case 171:
                    interpolieren_nord();
                    ;
                    ;
                    ;
                    ; break;
                case 172:
                    interpolieren_ost();
                    ;
                    ;
                    ; break;
                case 173:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    ;
                    ; break;
                case 174:
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    ; break;
                case 175:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    ; break;
                case 176:
                    interpolieren_sued();
                    ;
                    ; break;
                case 177:
                    interpolieren_nord();
                    interpolieren_sued();
                    ;

                    ; break;
                case 178:
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 179:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 180:
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    ; break;
                case 181:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    ; break;
                case 182:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    ; break;
                case 183:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    ; break;
                case 184:
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 185:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 186:
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 187:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 188:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;
                    ; break;
                case 189:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 190:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    ; break;
                case 191:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    ; break;

                case 192:
                    interpolieren_west();
                    ;
                    break;

                case 193:
                    interpolieren_nord();
                    interpolieren_west();
                    ; break;
                case 194:
                    ;
                    interpolieren_west();
                    ; break;
                case 195:
                    interpolieren_nord();
                    ;
                    interpolieren_west();
                    ; break;
                case 196:
                    interpolieren_ost();
                    interpolieren_west();
                    ; break;
                case 197:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_west();
                    ; break;
                case 198:
                    ;
                    interpolieren_ost();
                    interpolieren_west();
                    ; break;
                case 199:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    interpolieren_west();
                    ; break;
                case 200:
                    ;
                    interpolieren_west();
                    ; break;
                case 201:
                    interpolieren_nord();
                    ;
                    interpolieren_west();
                    ; break;
                case 202:
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 203:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 204:
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 205:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 206:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 207:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 208:
                    interpolieren_sued();
                    interpolieren_west();
                    ; break;
                case 209:
                    interpolieren_nord();
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 210:
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 211:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 212:
                    interpolieren_ost();
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 213:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 214:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 215:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();

                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 216:
                    ;
                    interpolieren_sued();
                    interpolieren_west();
                    ; break;
                case 217:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    interpolieren_west();
                    ; break;
                case 218:
                    ;
                    ;
                    interpolieren_sued();
                    interpolieren_west();
                    ; break;
                case 219:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();
                    interpolieren_west();
                    ; break;
                case 220:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    interpolieren_west();
                    ;
                    break;
                case 221:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    ;
                    break;
                case 222:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    ;
                    break;
                case 223:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();

                    interpolieren_west();
                    ; break;
                case 224:
                    ;
                    interpolieren_west();
                    ; break;

                case 225:
                    interpolieren_nord();
                    ;
                    interpolieren_west();
                    ; break;
                case 226:
                    ;

                    ;
                    interpolieren_west();
                    ; break;
                case 227:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 228:
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 229:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 230:
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 231:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_west();
                    ; break;
                case 232:
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 233:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 234:
                    ;
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 235:
                    interpolieren_nord();
                    ;
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 236:
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 237:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 238:
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 239:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    ;
                    interpolieren_west();
                    ; break;
                case 240:
                    interpolieren_sued();
                    ;
                    interpolieren_west();
                    ; break;
                case 241:
                    interpolieren_nord();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 242:
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 243:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 244:
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 245:
                    interpolieren_nord();
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 246:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 247:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 248:
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 249:
                    interpolieren_nord();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 250:
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 251:
                    interpolieren_nord();
                    ;
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 252:
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;
                    interpolieren_west();
                    ; break;
                case 253:
                    interpolieren_nord();
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 254:
                    ;
                    interpolieren_ost();
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;
                case 255:
                    interpolieren_nord();
                    ;
                    interpolieren_ost();
                    ;
                    interpolieren_sued();
                    ;

                    interpolieren_west();
                    ; break;

                }
        }
    }
