#ifndef RAND_INTERPOLATION
#define RAND_INTERPOLATION

#define RI_NORDOST 1
#define RI_NORDWEST 2
#define RI_SUEDOST 4
#define RI_SUEDWEST 8

#include "feldliste.h"
#include "paralleles_rechnen.h"
#include "uebertrage_grobgitter_u.h"
#include "datei_ausgabe.h"
#include "ausgaben.h"

class RandInterpolation :   public UebertrageGrobgitterU
    {
private:
    short int ** u_h_vorhanden;
    short int ** fgff, ** ggff;
public:
    FeldListe * dynamischer_rand_fein;
private:
    int eigenrang;
public:
    void initialisieren_randinterpolation(ParallelesRechnen * _paralleles_rechnen_h, ParallelesRechnen * _paralleles_rechnen_h_minus1, Werte1d ** _sendebuffer, Werte1d ** _empfangsbuffer);
    void finalisieren_randinterpolation(void);
private:
    int farbe;
    int n_minus3_grob;
    int m_minus3_grob;
    int n_minus2_grob;
    int m_minus2_grob;
    int n_minus1_grob;
    int m_minus1_grob;
    int n_grob, m_grob;
private:
private:
    ParallelesRechnen * paralleles_rechnen_h, * paralleles_rechnen_h_minus1;
    int m, n;
    int groesse, rang;
    int * sende_indizes;
    int * empfangs_indizes;
private:
    int i, j, ii, jj, k, kk;
private:
    double ** u0_fein;
private:
    int links, rechts, oben, unten;
public:
    void tun(void);
private:
    void ausfuehren_packen_markieren(void);
    void rand_interpolieren(void);
public:
private:
    void scan_nordpunkte_fuer_sued(void);
    void nord_markieren_fuer_sued(void);
    void nord_uebertragen_fuer_sued(void);
    void scan_suedpunkte_fuer_nord(void);
    void sued_markieren_fuer_nord(void);
    void sued_uebertragen_fuer_nord(void);
    void scan_ostpunkte_fuer_west(void);
    void ost_markieren_fuer_west(void);

    void ost_uebertragen_fuer_west(void);
    void scan_westpunkte_fuer_ost(void);
    void west_markieren_fuer_ost(void);
    void west_uebertragen_fuer_ost(void);
    void scan_nordwest(void);
    void scan_suedwest(void);
    void scan_nordost(void);
    void scan_suedost(void);
    void interpolieren_nord(void);
    void interpolieren_sued(void);
    void interpolieren_west(void);
    void interpolieren_ost(void);
    void rand_interpolation_west_ost(void);
    void rand_interpolation_nord_sued(void);
    int bestimme_wieviel_nach_links(void);
    int bestimme_wieviel_nach_rechts(void);

    int bestimme_wieviel_nach_oben(void);
    int bestimme_wieviel_nach_unten(void);

private:
    int ** selbstnachbarn_grob;
    int ** selbstnachbarn_fein;
private:
    int erkennene_randsituation;
    void agieren_des_erkannten(void);
public:
    int ri_ebene;
private:
    void ausgeben_farbenfeld(void);
private:
    inline void uebertrage_bedingt(int farbe, int jj, int kk);
public:
    int t;
private:
    int ** feld;
private:
    char zeichenkette[10];
    };

#endif

// Problem: RandInterpolation immer nur fr 2 Gitter, oder fr alle Gitter des Mehrgitters?
// In letzterem Fall habe ich Markierungsfelder fr alle Gitter.
// Wenn RandInterpolation nur fr zwei Gitter gilt, mssen die Markierungen bertragen werden via Zeigern.
// Wenn diese RI, dann braucht man keine Ebene zu bergeben.
// Programmieren kann ich beides - welches ist warum besser?
// Vielleicht nur fr 2 Gitter - denn dann kann ich mich darauf konzentrieren.
// Aber bei Multi - Level RI brauche ich auch nur die Zeiger zu 'laden', und arbeite dann mit je zwei Ebenen weiter.
// So muss ich aber Markierungsfelder in Zyklus anlegen.
// 'Vorschlag': Ich beginne mit zwei Ebenen, und ... . Mit 2 Ebenen hat diesen Vorteil:
// Ich habe die Strukturen schon durch Zeiger verknpft. Verliere dafr keine Laufzeit. Aber:
// In einer ML - Struktur knnte ich auch Zeiger speichern. Msste sie aber dann laden.
// Nur umgekehrt: Man htte alles kompakt beisammen, auch die Markierungsfelder. So muss alles in ZyklusRechnen bestimmt werden.
// Ich kann auch eine zustzliche Klasse ML_RandInterpolation anlegen!

