#include "rand_werte_kommunikation.h"

// Kommentar: Mit dieser Funktion wird ep_aktuell, das Feld der aktuellen Eigenschaftspunkte, bergeben.
// Allerdings werden die Zeiger von ep_aktuell und ep_vergangen immer wieder gegeneinander vertauscht, d.h.
// diese Funktion muss in jeder Interation einmal aufgerufen werden.
void RandWerteKommunikation::initialisieren_kommunikation_ep(short int ** _ep_aktuell)
    {
    ep_aktuell = _ep_aktuell;
    }

#ifdef dimensionen1
// Kommentar: Hier werden nur Variablen bergeben; aber es wird kein Speicherplatz angelegt.
void RandWerteKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0)
#endif
#ifdef dimensionen2
void RandWerteKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1)
#endif
#ifdef dimensionen3
void RandWerteKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1, double ** _x2, double ** _y2)
#endif
#ifdef dimensionen4
void RandWerteKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1, double ** _x2, double ** _y2, double ** _x3, double ** _y3)
#endif
    {
    #ifdef dimensionen1
    x0 = _x0;
    y0 = _y0;
    #endif

    #ifdef dimensionen2
    x0 = _x0;
    y0 = _y0;
    x1 = _x1;
    y1 = _y1;
    #endif

    #ifdef dimensionen3
    x0 = _x0;
    y0 = _y0;
    x1 = _x1;
    y1 = _y1;
    x2 = _x2;
    y2 = _y2;
    #endif

    #ifdef dimensionen4
    x0 = _x0;
    y0 = _y0;
    x1 = _x1;
    y1 = _y1;
    x2 = _x2;
    y2 = _y2;
    x3 = _x3;
    y3 = _y3;
    #endif
    }

// Kommentar: Hier werden die aufgelisteten Variablen an diese Klasse bergeben: u0, gg_u0,r0, f0, Iu0, rS0, e0, Lu0
// und u0_hilf, damit in diese Variablen entpackt werden kann, und sie beim Packen gelesen werden knnen.
void RandWerteKommunikation::initialisieren_kommunikation_rest(double ** _u0, double ** _gg_u0, double ** _r0, double ** _f0, double ** _Iu0, double ** _rS0, double ** _e0, double ** _Lu0, double ** _u0_hilf)//, double ** _ILu0)
    {
    u0 = _u0;
    gg_u0 = _gg_u0;
    r0 = _r0;
    f0 = _f0;
    Iu0 = _Iu0;
    rS0 = _rS0;
    e0 = _e0;
    Lu0 = _Lu0;
    u0_hilf = _u0_hilf;
//    ILu0 = _ILu0;
    }

#ifdef GEMEINSAME_BUFFER
// Kommentar: Es werden die Standardparameter wie m,n, rang, eigenfarbe bergeben, und dann die Punktliste
// fr den Innen - und Auenrand. Der Sende - und Empfangsbuffer fr die Werte wird bergeben, oder neu angelegt -
// in Abhngigkeit der Prprozessor - Variablen GEMEINSAME_BUFFER. Die Buffer fr dsa Verschicken von ep
// werden angelegt.
void RandWerteKommunikation::initialisieren(int _n, int _m, int _eigenfarbe, short int * _f_rs, short int * _g_rs, short int * _f_a_rs, short int * _g_a_rs, int _rang, double * _sendebuffer, double * _empfangsbuffer)
#else
void RandWerteKommunikation::initialisieren(int _n, int _m, int _eigenfarbe, short int * _f_rs, short int * _g_rs, short int * _f_a_rs, short int * _g_a_rs, int _rang)
#endif
// wird finalisiert
    {
    n = _n;
    m = _m;
    mn = n * m;
// Die eigenfarbe ist die Identitt der RandWerteKommunikation in der Klasse RandStrukutur.
    eigenfarbe = _eigenfarbe;
    rang = _rang;
    f_rs = _f_rs;
    g_rs = _g_rs;
    f_a_rs = _f_a_rs;
    g_a_rs = _g_a_rs;
#ifdef GEMEINSAME_BUFFER
    sende_werte_buffe = _sendebuffer;
    empfange_werte_buffe = _empfangsbuffer;
#else
    sende_werte_buffe = new double[mn];
    empfange_werte_buffe = new double[mn];
#endif
    sende_ep_buffer = new bool[((mn>>3)+1)<<3];
    empfange_ep_buffer = new bool[((mn>>3)+1)<<3];
    }

// Kommentar: Hier werden die aufgrund der Funktion initialisieren angelegten Strukturen wieder freigegeben.
void RandWerteKommunikation::finalisieren(void)
    {
#ifdef GEMEINSAME_BUFFER
#else
// Kommentar: Das hier wird freigegeben, wenn keine gemeinsam genutzten Buffer angelegt worden sind.
    delete sende_werte_buffe;
    delete empfange_werte_buffe;
#endif
// Kommentar: Die Buffer fr die ep - Kommunikation werden in jedem Fall wieder freigegeben.
    delete sende_ep_buffer;
    delete empfange_ep_buffer;
    }

// Kommentar: Hier werden die Anzahlen der Innen - und Auenrandpunktmengen an diese Klasse bergeben.
void RandWerteKommunikation::setze_anzahlen(int _anzahl_rs, int _anzahl_a_rs)
    {
    anzahl_rs = _anzahl_rs;
    anzahl_a_rs = _anzahl_a_rs;
    }



// Kommentar: Hier wird die Innenrandpunktmenge via cout ausgegeben.
void RandWerteKommunikation::randmenge_packen_ausgeben(void)
    {
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << "rpa anzahl_a_rs " << anzahl_a_rs << " / ";
    for(i=0; i<anzahl_rs; i++)
        {
        cout << f_rs[i] << " " << g_rs[i] << " / ";
        }
    cout << endl;
#endif
    }

// Kommentar: Die ep - Information wird - entsprechend der bergebenen Struktur ep_aktuell - gepackt in den Sendebuffer.
void RandWerteKommunikation::packen_ep(void)
    {
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << "In PEP" << endl;
#endif
// Kommentar: Man geht an den Anfang des Buffers.
    k=0;

#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << "PEP . rang " << rang << " eigenfarbe " << eigenfarbe << " anzahl_rs " << anzahl_rs << endl;
#endif

// Kommentar: Die Innenrandpunktmenge wird durchlaufen ...
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
        cout << " a " << a << " b " << b << endl;
        cout << " ep_aktuell[0][0] " << ep_aktuell[0][0] << endl;
        cout << " y0 " << ep_aktuell[a][b] << endl;
#endif

// Kommentar: ... und die Werte von ep_aktuell an der Stelle des Punktes wird in den Sendebuffer geschrieben, nebst einer
// Inkrementierung des Indexes.
        sende_ep_buffer[k++] = ep_aktuell[a][b];
        }

#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << endl;
#endif
    }

// Kommentar: Die ep - Information wird - entsprechend der bergebenen Struktur ep_aktuell - entpackt aus dem Empfangsbuffer.
void RandWerteKommunikation::entpacken_ep(void)
    {
// Kommentar: Man geht an den Anfang des Buffers.
    k=0;
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << "epep" << endl;
#endif

// Kommentar: Man durchluft die Auenrandpunktmenge ...
    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
        cout << " a " << a << " b " << b << " buf " << empfange_ep_buffer[k];
#endif

// Kommentar: Und liet den Empfangsbuffer nebst Indexinkrementierung, und schreibt nach ep_aktuell an der Stelle des jeweiligen
// Auenrandpunktes.
        ep_aktuell[a][b] = empfange_ep_buffer[k++];
        }
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << "Ende_epep " << endl;
#endif
    }

// Kommentar: Hier wird die Auenrandpunktmenge ausgegeben - zum Debuggen.
void RandWerteKommunikation::randmenge_entpacken_ausgeben(void)
    {
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << "rea anzahl_a_rs " << anzahl_a_rs << " / ";
    for(i=0; i<anzahl_a_rs; i++)
        {
        cout << f_a_rs[i] << " " << g_a_rs[i] << " / ";
        }
    cout << endl;
#endif
    }

// Kommentar: Hier wird die Kommunikation von eingetragenen Werten zwecks Randaustausch initiiert.
void RandWerteKommunikation::werte_kommunikation_starten(void)
    {
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << " RWK WKS Rang " << rang << " farbe " << eigenfarbe << " anzahl_rs " << anzahl_rs << " anzahl_a_rs " << anzahl_a_rs << endl;
#endif
    if(anzahl_rs<0)
        {
        cout << "In RWK : Anzahl_rs " << anzahl_rs << " Rang " << rang << " farbe " << eigenfarbe << endl;
        exit(-1);
        }
// Kommentar: Der Wert eigenfarbe gibt die ID des Partnerkerns an. Unter dieser ID ist diese Klasse RSK in der
// Klasse RandStruktur angelegt. k ist die Lnge des Buffers, und es werden double - Werte verschickt.
    MPI_Isend(sende_werte_buffe, k, MPI_DOUBLE, eigenfarbe, 2, MPI_COMM_WORLD, & sende_request);
//    MPI_Isend(sende_werte_buffe, anzahl_rs, MPI_DOUBLE, eigenfarbe, 2, MPI_COMM_WORLD, & sende_request);

// Kommentar: Empfangen wird auch vom Partnerkern mit der ID eigenfarbe, und mn+100 ist die maximale Bufferlnge.
// Es werden auch double - Werte verschickt.
    MPI_Irecv(empfange_werte_buffe, mn+100, MPI_DOUBLE, eigenfarbe, 2, MPI_COMM_WORLD, & empfangs_request);
// Die eigenfarbe: Das ist doch nicht das Kommunikationsziel ! Doch: eigenfarbe!=rang !
// Das ist wie bei der RandStrukturKommunikation.
    }

// Kommentar: Hier ist eine Kommunikation zum Randaustausch der ep - Information. Die Buffer, mit denen
// gearbeitet wird, lauten sendebuffer_ep und empfangsbuffer_ep. Die Lngen werden auf ein Vielfaches der Zahl 8
// angehoben, und es werden Bytes verschickt - ein Byte fr ein Flag. Fr alles weitere - wie die eigenfarbe -
// vergleiche man die Kommentare der vorangehenden Kommunikationen.
void RandWerteKommunikation::kommunikation_starten_ep(void)
    {
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << " RWK EP_KS Rang " << rang << " farbe " << eigenfarbe << " anzahl_rs " << anzahl_rs << " anzahl_a_rs " << anzahl_a_rs << endl;
#endif
    if(anzahl_rs<0)
        {
        cout << "In RWK : Anzahl_rs " << anzahl_rs << " Rang " << rang << " farbe " << eigenfarbe << endl;
        exit(-1);
        }
    MPI_Isend(sende_ep_buffer, (k>>3)+1, MPI_BYTE, eigenfarbe, 3, MPI_COMM_WORLD, & sende_request_ep);
    MPI_Irecv(empfange_ep_buffer, ((mn+100)>>3) + 1, MPI_BYTE, eigenfarbe, 3, MPI_COMM_WORLD, & empfangs_request_ep);
// Die eigenfarbe: Das ist doch nicht das Kommunikationsziel ! Doch: eigenfarbe!=rang !
// Das ist wie bei der RandStrukturKommunikation.
    }

// Kommentar: Hier wird mit Hilfe von sende_request_ep und empfangs_request_ep getestet, ob die Kommunikationen
// der ep - Randinformation abgeschlossen sind. Falls nein, so gebe false zurck. Ist das Senden und Empfangen
// abgeschlossen, so wird true zurckgegeben.
bool RandWerteKommunikation::ist_fertig_ep(void)
    {

    MPI_Test(& sende_request_ep, &flag, & sende_status);
    if(flag==false)
        {
        return(false);
        }


    MPI_Test(& empfangs_request_ep, &flag, & empfangs_status);

    if(flag==false)
        {
        return(false);
        }

    return(true);
    }

// Kommentar: Hier wird mit Hilfe von sende_request und empfangs_request getestet, ob die Kommunikationen
// entweder der Werte abgeschlossen sind. Falls nein, so gebe false zurck. Ist das Senden und Empfangen
// abgeschlossen, so wird true zurckgegeben.
bool RandWerteKommunikation::ist_fertig(void)
    {
    MPI_Test(& sende_request, &flag, & sende_status);
    if(flag==false)
        {
        return(false);
        }


    MPI_Test(& empfangs_request, &flag, & empfangs_status);

    if(flag==false)
        {
        return(false);
        }

    return(true);
    }

// Kommentar: Hier wird die kleine Innenrandstruktur gebildet. Man bildet dabei zweierlei:
// Einmal die Signatur fr alle Innenrandpunkte.
// Und dann eine Punktliste (f_innen_klein,g_innen_klein), die die Innenrandpunkte in derselben Reihenfolge auswhlt,
// wobei die Innenrandpunkte eine 'true' - Signatur haben.
void RandWerteKommunikation::bilde_kleine_randstruktur_innen(void)
    {
// Zuerst Innen: Was macht diese Funktion?
// Diese
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << " RWK::bilde_kleine_randstruktur_innen / rang " << rang << " ebene " << gitterebene << " komm-farbe " << komm_farbe << endl;
#endif

// Kommentar: Die Anzahl der kleinen Innenpunkte wird zurckgesetzt.
    anzahl_innen_klein = 0;

// Kommentar: Der Innenrand wird durchlaufen.
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

// Kommentar: Existiert ein Gitterpunkt darunter.
        if(testen(a, b) == true)
            {
// Kommentar: Dann speichere den Punkt im kleinen Innenrand ab - in fortlaufender Reihenfolge. Und vermerke in der Signatur
// zu dem Innenpunkt den Wert true, was heit, dass hier ein Punkt des kleinen Innenrandes vorliegt.
            f_innen_klein[anzahl_innen_klein] = a;
            g_innen_klein[anzahl_innen_klein++] = b;
            signatur_innen[i] = true;
            }
        else
            {
// Kommentar: Ansonsten schreibe false in die Signatur. Nach dem Verschicken der Signatur - Information kann dann
// eine eindeutige Zuordnung des Auenrandes zu dem kleinen Auenrand erfolgen.
            signatur_innen[i] = false;
            }
        }
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << " anzahl_innen_klein " << anzahl_innen_klein << " rang " << rang << endl;
#endif
    }
// Danach aussen:

// Kommentar: Mit Hilfe des Auenrandes und der zugehrigen auen - Signatur wird die kleine Randstruktur fr den
// Auenrand gebildet.
void RandWerteKommunikation::bilde_kleine_randstruktur_aussen(void)
    {
// Kommentar: Die kleine Auenrandpunktmenge wird anfangs auf 'leer' gesetzt.
    anzahl_aussen_klein = 0;

#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << " RandWerteKommunikation::bilde_kleine_randstruktur_aussen / rang " << rang << " anzahl_a_rs " << anzahl_a_rs << endl;
#endif

// Dann werden die Punkte des Auenrandes durchlaufen, und bei einer Signatur von true in Bezug auf eine fortlaufenden Numerierung
// wird der jeweilige Punkt in die kleine Auenrandliste aufgenommen. Wichtig dabei: Die jeweilige Signatur
// pat genau zu dem ausgewhlten Punkt.
    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
        if((a==8)&&(b==3))
            {
            cout << " RWK Code A4 signatur aussen " << signatur_aussen[i] << endl;
            }
#endif

        if(signatur_aussen[i] == true)
                                    // Dieser Test funktioniert auf dem Gitter, aber aussen auch?
                                    // EP_SNB aussen ist ggf. ungleich EP_SNB innen auf dem anderen Gitter.
                                    // Das war mir zum Zeitpunkt der Fertigstellung dieses Testes nicht klar.
                                    // Das bleibt zu analysieren. Wir kriegen das hin, ggf. muss etwas mehr an Punkten in
                                    // diese Struktur als unbedingt notwendig ist.
            {
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
            cout << " anzahl_aussen_klein " << anzahl_aussen_klein;
            cout << " a " << a << " b " << b << endl;
#endif
            f_aussen_klein[anzahl_aussen_klein] = a;
            g_aussen_klein[anzahl_aussen_klein++] = b;
            }
        }
#ifdef AUSGABEN_RAND_WERTE_KOMMUNIKATION
    cout << " anzahl_aussen_klein " << anzahl_aussen_klein << endl;
#endif
// Warum Innen(P, Q) = Aussen(Q, P) ist, wird hier nicht klar. Noch muss das nicht bereinstimmen, vgl. oben.
// Es stimmt auch nicht berein. Den Widerspruch dafr habe ich gefunden. Und bewiesen.

    }

// Kommentar: Gem der Innenrandpunktmenge werden die u0 - Werte in den Sendebuffer gepackt.
void RandWerteKommunikation::packen_werte_u0(void)
    {
// Kommentar: Man beginnt beim ersten Buffereintrag.
    k=0;

// Kommentar: Fr alle Punkte der Innenrandpunktmenge wird an der Stelle k u0 an der Stelle des Punktes in den
// Sendebuffer geschrieben, und k um Eins erhht.
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = u0[a][b];
        }
    }

// Kommentar: Gem der Innenrandpunktmenge werden die u0 - Werte der Red - Punkte der Innenrandpunktmenge in den Sendebuffer gepackt.
void RandWerteKommunikation::packen_werte_u0_red(void)
    {
// Kommentar: Gehe an den Anfang des Sendebuffers.
    k=0;

// Kommentar: Es werden alle Innenrandpunkte durchlaufen
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

// Kommentar: Ist der Punkt ein red - Punkt - wegen gerader Koordinatensumme, vgl. die weissen Felder eines Schachbrettes -
// dann wird der Wert der Variablen u0 an der Stelle des Punktes in den Sendebuffer gepackt.
        if(((a+b)&1)==0)
            {
            sende_werte_buffe[k++] = u0[a][b];
            }
        }
    }

// Kommentar: Gem der Innenrandpunktmenge werden die u0 - Werte der Black - Punkte der Innenrandpunktmenge in den Sendebuffer gepackt.
void RandWerteKommunikation::packen_werte_u0_black(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

// Kommentar: Ist der Punkt ein black - Punkt - wegen ungerader Koordinatensumme, vgl. die schwarzen Felder eines Schachbrettes -
// dann wird der Wert der Variablen u0 an der Stelle des Punktes in den Sendebuffer gepackt.
        if(((a+b)&1)==1)
            {
            sende_werte_buffe[k++] = u0[a][b];
            }
        }
    }

// Kommentar: Zu den Randpunkten der Innenrandpunktmenge, die Grobgitterpunkte darber haben, werden die gg_u0 - Werte
// auf diesen Grobgitterpunkten gepackt.
void RandWerteKommunikation::packen_werte_gg_u0(void)
    {
// Kommentar: Man beginnt am Anfang des Buffers.
    k=0;

// Kommentar: Es wird die Innenrandpunktmenge durchlaufen.
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

// Kommentar: Sind beide Koordinaten geradzahlig, d.h. es liegt ein Grobgitterpunkt darber, so ...
        if((a&1)==0)
            {
            if((b&1)==0)
                {
#ifdef AUSGABE_RAND_WERTE_KOMMUNIKATION
                cout << " a " << a << " b " << b << " a>>1 " << (a>>1) << " b>>1 " << (b>>1) << " m " << m << " n " << n << endl;
                cout << " gg_u0[0][0] " << gg_u0[0][0] << endl;
                cout << " gg_u0 " << gg_u0[a>>1][b>>1] << endl;
#endif
// Packe die Werte der Variablen gg_u0 - die ein Zeiger auf die u0 Variable auf dem grberen Gitter ist - an der
// Grobgitterstelle ( = Gitterkoordinaten / 2) in den Sendebuffer fr Werte, und Inkrementiere den Index.
                sende_werte_buffe[k++] = gg_u0[a>>1][b>>1];
                }
            }
        }
    }

// Kommentar: Hier werden die Werte von u0 auf dem feinen Gitter gepackt.
void RandWerteKommunikation::packen_werte_fg_u0(void)
    {
// Kommentar: Der Algorithmus beginnt wieder mit dem Index an der Stelle des Bufferanfangs.
    k=0;

// Kommentar: Durchlaufe die Innenrandpunktmenge.
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

// Kommentar: Packe die u0 - Werte auf dem feineren Gitter an den Feingitterkoordinaten (= Koordinaten Mal 2) des
// durchlaufenen Gitterpunktes.
        sende_werte_buffe[k++] = fg_u0[a<<1][b<<1];
        }
    }

// Kommentar: Analog zu  packen_werte_fg_u0, nur mit der Variablen fg_v6 der von mir abgewandelten Version der Hess'schen Implementierung der SWE, statt der
// Variablen fg_u0.
void RandWerteKommunikation::packen_werte_fg_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = fg_v6[a<<1][b<<1];
        }
    }

// Kommentar: Analog zu paken_werte_gg_u0, nur mit der Variablen gg_e0, statt der Variablen gg_u0.
void RandWerteKommunikation::packen_werte_gg_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        if((a&1)==0)
            {
            if((b&1)==0)
                {
                sende_werte_buffe[k++] = gg_e0[a>>1][b>>1];
                }
            }
        }
    }

// Kommentar: Analog zu  packen_werte_fg_u0, nur mit der Variable fg_v9 der von mir abgewandelten Version der Hess'schen Implementierung der SWE, statt der
// Variablen fg_u0.
void RandWerteKommunikation::packen_werte_gg_v9(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        if((a&1)==0)
            {
            if((b&1)==0)
                {
//                cout << " a " << a << " b " << b << " a>>1 " << (a>>1) << " b>>1 " << (b>>1) << " m " << m << " n " << n << endl;
//                cout << " gg_u0[0][0] " << gg_u0[0][0] << endl;
//                cout << " gg_u0 " << gg_u0[a>>1][b>>1] << endl;
                sende_werte_buffe[k++] = gg_v9[a>>1][b>>1];
                }
            }
        }
    }

// Kommentar: Zu den Randpunkten der Innenrandpunktmenge, die Grobgitterpunkte darber haben, werden die gg_e0 - Werte nebst
// den gg_u0 - Werte auf diesen Grobgitterpunkten gepackt.
void RandWerteKommunikation::packen_werte_gg_e0_und_u0(void)
    {
// Kommentar: Man beginnt am Anfang des Buffers.
    k=0;

// Kommentar: Es wird die Innenrandpunktmenge durchlaufen.
    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

// Kommentar: Sind beide Koordinaten geradzahlig, d.h. es liegt ein Grobgitterpunkt darber, so ...
        if((a&1)==0)
            {
            if((b&1)==0)
                {
// Packe die Werte der Variablen gg_e0 - die ein Zeiger auf die u0 Variable auf dem grberen Gitter ist - nebst der
// Variablen gg_u0 an der Grobgitterstelle ( = Gitterkoordinaten / 2) in den Sendebuffer fr Werte, und Inkrementiere
// nach jedem Schreiben in den Sendebuffer den Index.
                sende_werte_buffe[k++] = gg_e0[a>>1][b>>1];
                sende_werte_buffe[k++] = gg_u0[a>>1][b>>1];
                }
            }
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen u0_hilf, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_u0_hilf(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = u0_hilf[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen Lu0, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_Lu0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = Lu0[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen r0, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_r0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = r0[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen v6 (SWE - Abwandlungs - Variable),
// statt der Variablen u0.
void RandWerteKommunikation::packen_werte_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = v6[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen f0, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_f0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = f0[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur das beim Packen zu zwei Variablen - Iu0 und r0, in den
// Sendebuffer gepackt wird, statt nur der einen Variablen u0.
void RandWerteKommunikation::packen_werte_Iu0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = Iu0[a][b];
        sende_werte_buffe[k++] = r0[a][b];
        }
    }

// Analog zu packen_werte_Iu0r0, nur das hier die Werte der Variablen u0 und r0 gepackt werden.
void RandWerteKommunikation::packen_werte_u0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = u0[a][b];
        sende_werte_buffe[k++] = r0[a][b];
        }
    }

// Analog zu packen_werte_u0_r0, nur dass ggf. noch die Variable u0 ausgegeben wird - frs Debugging.
void RandWerteKommunikation::packen_werte_u0r0_mit_ausgabe(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

#ifdef AKTUELLE_KOMMENTARE
        cout << " RWK pw u0r0 a " << a << " b " << b << " wert " << u0[a][b] << endl;
#endif

        sende_werte_buffe[k++] = u0[a][b];
        sende_werte_buffe[k++] = r0[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen Iu0, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_Iu0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = Iu0[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen rS0, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_rS0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = rS0[a][b];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur mit der Verwendung der Variablen e0, statt der Variablen u0.
void RandWerteKommunikation::packen_werte_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = e0[a][b];
        }
    }

// Kommentar: Hier wird der Empfangsbuffer entpackt, und die Werte in die Variable u0 geschrieben.
void RandWerteKommunikation::entpacken_werte_u0(void)
    {
// Kommentar: Der Buffer wird vom Anfang her gelesen.
    k=0;

// Kommentar: Der Auenrand wird durchlaufen.
    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

// Kommentar: Der Empfangsbufferwert wird nach u0 an der Koordinate des jeweiligen Punktes geschrieben, und der Index
// wird Inkrementiert.
        u0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Hier wird der Empfangsbuffer entpackt, und die Werte in die Variable u0 geschrieben - allerdings nur fr Red
// - Punkte.
void RandWerteKommunikation::entpacken_werte_u0_red(void)
    {
// Kommentar: Entpackt wird am dem Bufferanfang.
    k=0;

// Kommentar: Der Auenrand wird durchlaufen.
    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

// Kommentar: Wenn der Punkt ein Red - Punkt ist, d.h. eine gerade Koordinatensumme hat ...
        if(((a+b)&1)==0)
            {
// Kommentar: ... dann wird der Empfangsbufferwert nach u0 an der Koordinate des jeweiligen Punktes geschrieben, und der Index
// wird Inkrementiert.
            u0[a][b] = empfange_werte_buffe[k++];
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_u0_red, nur dass black - Punkte entpackt werden - Punkte mit ungerader Koordinatensumme.
void RandWerteKommunikation::entpacken_werte_u0_black(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        if(((a+b)&1)==1)
            {
            u0[a][b] = empfange_werte_buffe[k++];
            }
        }
    }

// Kommentar: Hier wird auch entpackt, aber es werden die Grobgitter - u0 - Werte 'ber' der Punktmenge entpackt.
void RandWerteKommunikation::entpacken_werte_gg_u0(void)
    {
// Kommentar: Man beginnt bei dem Buffer vom Anfang an.
    k=0;

// Kommentar: Der Auenrand wird durchlaufen.
    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

// Kommentar: Hat der gelesene Punkt gerade Koordinaten, d.h. liegt ein Grobgitterpunkt darber, ...
        if((a&1)==0)
            {
            if((b&1)==0)
                {
// Kommentar: ... so wird gg_u0 - der Zeiger auf die u0 Variable des groben Gitters - an der zugehrigen Grobgitterkoordinate
// (geteilt durch 2) entpackt - mit einem Inkrement des Indexes.
                gg_u0[a>>1][b>>1] = empfange_werte_buffe[k++];
                }
            }

        }
    }

// Kommentar: Hier wird auch entpackt, aber es werden die Feingitter - u0 - Werte 'unter' der Punktmenge entpackt.
void RandWerteKommunikation::entpacken_werte_fg_u0(void)
    {
// Kommentar: Man beginnt bei dem Buffer vom Anfang an.
    k=0;

// Kommentar: Der Auenrand wird durchlaufen.
    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

// Kommentar: Zu jedem Punkt wird der Empfangsbuffer nach fg_u0 - das ist der Zeiger auf die u0 - Variable des feineren Gitter
//  - an der Feingitterstelle zu dem Punkt (Koordinaten Mal 2) entpackt - mit Inkrement des Indexes.
        fg_u0[a<<1][b<<1] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_fg_u0, nur mit der Variable fg_v6 statt fg_u0. v6 ist eine Variable der von mir abgewandelten Version der Hess'schen Implementierung der SWE.
void RandWerteKommunikation::entpacken_werte_fg_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        fg_v6[a<<1][b<<1] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_gg_u0, nur mit der Variablen gg_e0, statt gg_u0.
void RandWerteKommunikation::entpacken_werte_gg_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        if((a&1)==0)
            {
            if((b&1)==0)
                {
                gg_e0[a>>1][b>>1] = empfange_werte_buffe[k++];
                }
            }

        }
    }

// Kommentar: Analog zu entpacken_werte_gg_u0, nur mit der Variablen gg_v9, statt gg_u0. v9 ist eine Variable der von mir abgewandelten Version der Hess'schen Implementierung der SWE.
void RandWerteKommunikation::entpacken_werte_gg_v9(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        if((a&1)==0)
            {
            if((b&1)==0)
                {
                gg_v9[a>>1][b>>1] = empfange_werte_buffe[k++];
                }
            }

        }
    }

// Kommentar: Analog zu entpacken_werte_gg_u0, nur mit den Variablen gg_e0 und gg_u0, statt gg_u0. Dabei werden
// die Bufferwerte - sntsprechend dem packen - abwechselnd in gg_e0 und gg_u0 entpackt.
void RandWerteKommunikation::entpacken_werte_gg_e0_und_u0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        if((a&1)==0)
            {
            if((b&1)==0)
                {
                gg_e0[a>>1][b>>1] = empfange_werte_buffe[k++];
                gg_u0[a>>1][b>>1] = empfange_werte_buffe[k++];
                }
            }

        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Variablen Lu0, statt u0.
void RandWerteKommunikation::entpacken_werte_Lu0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        Lu0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Variablen r0, statt u0.
void RandWerteKommunikation::entpacken_werte_r0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        r0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Variablen v6, statt u0. Zu v6 als SWE - Ersatzvariable wurde schon geschrieben.
void RandWerteKommunikation::entpacken_werte_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        v6[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Variablen f0, statt u0.
void RandWerteKommunikation::entpacken_werte_f0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        f0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit den Variablen Iu0 und r0, statt u0. Dabei werden
// die Bufferwerte - sntsprechend dem packen - abwechselnd in Iu0 und r0 entpackt.
void RandWerteKommunikation::entpacken_werte_Iu0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        Iu0[a][b] = empfange_werte_buffe[k++];
        r0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_Iu0r0, nur mit den Variablen u0 und r0 statt Iu0 und r0.
void RandWerteKommunikation::entpacken_werte_u0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        u0[a][b] = empfange_werte_buffe[k++];
/*
#ifdef TROTTENBERG
        u0[a][b] = Iu0[a][b];
#endif
*/
        r0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0r0, nur das ggf. u0 via cout ausgegeben wird.
void RandWerteKommunikation::entpacken_werte_u0r0_mit_ausgabe(void)
    {
    k=0;

#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ ewma ";
#endif

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];
#ifdef AKTUELLE_KOMMENTARE
        cout << " a " << a << " b " << b;
#endif
        u0[a][b] = empfange_werte_buffe[k++];
#ifdef AKTUELLE_KOMMENTARE
        cout << " u0 " << u0[a][b];
#endif
        r0[a][b] = empfange_werte_buffe[k++];
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Verwendung der Variablen Iu0, statt der Variablen u0.
void RandWerteKommunikation::entpacken_werte_Iu0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        Iu0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Verwendung der Variablen rS0, statt der Variablen u0.
void RandWerteKommunikation::entpacken_werte_rS0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        rS0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur mit der Verwendung der Variablen e0, statt der Variablen u0.
void RandWerteKommunikation::entpacken_werte_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        e0[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu packen_werteIu0r0, nur, dass hier 4 SWE* - Variablen (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
// v1, v2, v3 und v4 gepackt werden.
void RandWerteKommunikation::packen_werte_v1v2v3v4(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = v1[a][b];
        sende_werte_buffe[k++] = v2[a][b];
        sende_werte_buffe[k++] = v3[a][b];
        sende_werte_buffe[k++] = v4[a][b];
        }
    }

// Kommentar: Analog zu entpacken_werteIu0r0, nur, dass hier 4 SWE* - Variablen (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
// v1, v2, v3 und v4 entpackt werden.
void RandWerteKommunikation::entpacken_werte_v1v2v3v4(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        v1[a][b] = empfange_werte_buffe[k++];
        v2[a][b] = empfange_werte_buffe[k++];
        v3[a][b] = empfange_werte_buffe[k++];
        v4[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu packen_werte_v1v2v3v4, nur dass hier die Variablen v5, v6 und v7 gepackt werden. Das sind SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::packen_werte_v5v6v7(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = v5[a][b];
        sende_werte_buffe[k++] = v6[a][b];
        sende_werte_buffe[k++] = v7[a][b];
        }
    }

// Kommentar: Analog zu entpacken_werte_v1v2v3v4, nur dass hier die Variablen v5, v6 und v7 entpackt werden. Das sind SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::entpacken_werte_v5v6v7(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        v5[a][b] = empfange_werte_buffe[k++];
        v6[a][b] = empfange_werte_buffe[k++];
        v7[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu packen_werte_v1v2v3v4, nur dass hier die Variablen v8 und v9 gepackt werden. Das sind SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::packen_werte_v8v9(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = v8[a][b];
        sende_werte_buffe[k++] = v9[a][b];
        }
    }

// Kommentar: Analog zu entpacken_werte_v1v2v3v4, nur dass hier die Variablen v8 und v9 entpackt werden. Das sind SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::entpacken_werte_v8v9(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        v8[a][b] = empfange_werte_buffe[k++];
        v9[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu packen_werte_v1v2v3v4, nur dass hier die Variablen v4, v6 und v11 gepackt werden. Das sind SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::packen_werte_v4v6v11(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        sende_werte_buffe[k++] = v4[a][b];
        sende_werte_buffe[k++] = v6[a][b];
        sende_werte_buffe[k++] = v11[a][b];
        }
    }

// Kommentar: Analog zu entpacken_werte_v1v2v3v4, nur dass hier die Variablen v4, v6 und v11 entpackt werden. Das sind SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::entpacken_werte_v4v6v11(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        v4[a][b] = empfange_werte_buffe[k++];
        v6[a][b] = empfange_werte_buffe[k++];
        v11[a][b] = empfange_werte_buffe[k++];
        }
    }

// Kommentar: Analog zu packen_werte_u0_red, nur dass hier die red - Punkte von v6 statt u0 gepackt werden. v6 ist eine SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::packen_werte_v6_red(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        if(((a+b)&1)==0)
            {
            sende_werte_buffe[k++] = v6[a][b];
            }
        }
    }

// Kommentar: Analog zu packen_werte_u0_black, nur dass hier die black - Punkte von v6 statt u0 gepackt werden. v6 ist eine SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::packen_werte_v6_black(void)
    {
    k=0;

    for(i=0; i<anzahl_rs; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        if(((a+b)&1)==1)
            {
            sende_werte_buffe[k++] = v6[a][b];
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_u0_red, nur dass hier die red - Punkte von v6 statt u0 entpackt werden. v6 ist eine SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::entpacken_werte_v6_red(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        if(((a+b)&1)==0)
            {
            v6[a][b] = empfange_werte_buffe[k++];
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_u0_black, nur dass hier die black - Punkte von v6 statt u0 entpackt werden. v6 ist eine SWE* - Variablen. (SWE* als meine Version der Implementierung von Herrn Hess der SWE)
void RandWerteKommunikation::entpacken_werte_v6_black(void)
    {
    k=0;

    for(i=0; i<anzahl_a_rs; i++)
        {
        a = f_a_rs[i];
        b = g_a_rs[i];

        if(((a+b)&1)==1)
            {
            v6[a][b] = empfange_werte_buffe[k++];
            }
        }
    }

