#ifndef RAND_WERTE_KOMMUNIKATION
#define RAND_WERTE_KOMMUNIKATION

#include <mpi.h>

#include <iostream>

using namespace std;

#include "ausgaben.h"

#include "kleine_randstruktur_kommunikation.h"
#include "kleine_randstruktur_test.h"

class RandWerteKommunikation :  public KleineRandStrukturKommunikation,
                                public KleineRandStrukturTest
    {
public:
    double ** y0, ** x0;
    double ** y1, ** x1;
    double ** y2, ** x2;
    double ** y3, ** x3;

    double ** u0;
    double ** gg_u0;
    double ** gg_e0;
    double ** gg_v9;
    double ** fg_u0;
    double ** fg_v6;
    double ** r0;
    double ** f0;
    double ** Iu0;
    double ** rS0; // rechte Seite
    double ** e0;
    double ** Lu0;
    double ** u0_hilf;
    double ** v1;
    double ** v2;
    double ** v3;
    double ** v4;
    double ** v5;
    double ** v6;
    double ** v7;
    double ** v8;
    double ** v9;
    double ** v10;
    double ** v11;

private:
    short int ** ep_aktuell;
    bool * sende_ep_buffer;
    bool * empfange_ep_buffer;
public:
    void initialisieren_kommunikation_ep(short int ** _ep_aktuell);
    #ifdef dimensionen1
    void initialisieren_kommunikation(double ** _x0, double ** _y0);
    #endif
    #ifdef dimensionen2
    void initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1);
    #endif
    #ifdef dimensionen3
    void initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1, double ** _x2, double ** _y2);
    #endif
    #ifdef dimensionen4
    void initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1, double ** _x2, double ** _y2, double ** _x3, double ** _y3);
    #endif
    void initialisieren_kommunikation_rest(double ** _u0, double ** _gg_u0, double ** _r0, double ** _f0, double ** _Iu0, double ** _rS0, double ** _e0, double ** _Lu0, double ** _u0_hilf);//, double ** _ILu0);

#ifdef GEMEINSAME_BUFFER
    void initialisieren(int _n, int _m, int _eigenfarbe, short int * _f_rs, short int * _g_rs, short int * _f_a_rs, short int * _g_a_rs, int _rang, double * _sendebuffer, double * _empfangsbuffer);
#else
    void initialisieren(int _n, int _m, int _eigenfarbe, short int * _f_rs, short int * _g_rs, short int * _f_a_rs, short int * _g_a_rs, int _rang);
#endif
    void finalisieren(void);
    void setze_anzahlen(int _anzahl_rs, int _anzahl_a_rs);
public:
    short int * f_rs, * g_rs, * f_a_rs, * g_a_rs;
    int anzahl_rs, anzahl_a_rs;
private:
public:
    double * sende_werte_buffe;
    double * empfange_werte_buffe;


public:
    void kopiere_x_nach_y(void);
private:
    int k, i, a, b;
private:
    MPI_Request sende_request;
    MPI_Request empfangs_request;

    MPI_Request sende_request_ep;
    MPI_Request empfangs_request_ep;

    MPI_Status sende_status;
    MPI_Status empfangs_status;
    int flag;
public:
    bool ist_fertig(void);
    void werte_kommunikation_starten(void);
public:
    int eigenfarbe;
private:
    int n, m, mn;
private:
    int rang;
public:
    void randmenge_packen_ausgeben(void);
    void randmenge_entpacken_ausgeben(void);
public:
    void kommunikation_starten_ep(void);
    bool ist_fertig_ep(void);
    void packen_ep(void);
    void entpacken_ep(void);
public:
    void bilde_kleine_randstruktur_innen(void);
    void bilde_kleine_randstruktur_aussen(void);

public:
    void packen_werte_u0(void);
    void packen_werte_u0_red(void);
    void packen_werte_u0_black(void);
    void packen_werte_gg_u0(void);
    void packen_werte_fg_u0(void);
    void packen_werte_gg_e0(void);
    void packen_werte_gg_e0_und_u0(void);
    void packen_werte_Lu0(void);
    void packen_werte_r0(void);
    void packen_werte_f0(void);
    void packen_werte_Iu0(void);
    void packen_werte_Iu0r0(void);
    void packen_werte_u0r0(void);
    void packen_werte_u0r0_mit_ausgabe(void);
    void packen_werte_rS0(void);
    void packen_werte_e0(void);
    void packen_werte_u0_hilf(void);

    void entpacken_werte_u0(void);
    void entpacken_werte_u0_red(void);
    void entpacken_werte_u0_black(void);
    void entpacken_werte_gg_u0(void);
    void entpacken_werte_fg_u0(void);
    void entpacken_werte_gg_e0(void);
    void entpacken_werte_gg_e0_und_u0(void);
    void entpacken_werte_Lu0(void);
    void entpacken_werte_r0(void);
    void entpacken_werte_f0(void);
    void entpacken_werte_Iu0(void);
    void entpacken_werte_Iu0r0(void);
    void entpacken_werte_u0r0(void);
    void entpacken_werte_u0r0_mit_ausgabe(void);
    void entpacken_werte_rS0(void);
    void entpacken_werte_e0(void);
public:
    void packen_werte_fg_v6(void);
    void packen_werte_gg_v9(void);
    void entpacken_werte_gg_v9(void);
    void packen_werte_v6(void);
    void entpacken_werte_v6(void);
    void entpacken_werte_fg_v6(void);
    void packen_werte_v1v2v3v4(void);
    void entpacken_werte_v1v2v3v4(void);
    void packen_werte_v5v6v7(void);
    void entpacken_werte_v5v6v7(void);
    void packen_werte_v8v9(void);
    void entpacken_werte_v8v9(void);
    void packen_werte_v4v6v11(void);
    void entpacken_werte_v4v6v11(void);
    void packen_werte_v6_red(void);
    void entpacken_werte_v6_red(void);
    void packen_werte_v6_black(void);
    void entpacken_werte_v6_black(void);
    };

#endif
