#include "randstruktur.h"

// Man macht eine vollstaendige Kommunikation. Das ist nicht richtig! Man muss die Vektoren- und Punkteanzahlen bercksichtigen!

// Kommentar: Diese Funktion bewirkt die Randkommunikationen. Dabei verwendet sie im Falle der Randbestimmung ber
// Kommunikation von Vektoren (vektorisieren0 = JA) die Klasse RandStrukturKommunikation, andernfalls
// die Klasse RandWerteKommunikation. Die Kommunikation besteht im Wesentlichen aus packen, Kommunikation starten,
// prfen, ob die Nachrichten angekommen sind, plus dem Entpacken der Nachrichten.


//////////////////////////////////////////////////////////////
/////////////// fr RandstrukturKommunikation ////////////////
//////////////////////////////////////////////////////////////

// Kommentar: Hier wird die Eigenschaftspunkteinformation gepackt - mit Untersttzung der Klasse RandStrukturKommunikation.
void RandStruktur::packen_ep(void)
    {
// Kommentar: Man durchlaufe die ID's der anderen Kerne.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Falls der Kern einen gemeinsamen Rand mit diesem Kern hat ...
            if(anzahl_rs[i]!=0)
                {
// Kommentar: ... dann packt man die ep - Information.
                randstruktur_kommunikation[i].packen_ep();
                }
            }
        }
    }

// Kommentar: Hier wird die Eigenschaftspunkteinformation entpackt - mit Untersttzung der Klasse RandstrukturKommunikation.
void RandStruktur::entpacken_ep(void)
    {
// Kommentar: Man durchlaufe die ID's der anderen Kerne.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Falls der Kern einen gemeinsamen Rand mit diesem Kern hat ...
            if(anzahl_rs[i]!=0)
                {
// Kommentar: ... dann entpackt man die ep - Information.
                randstruktur_kommunikation[i].entpacken_ep();
                }
            }
        }
    }

// Kommentar: Hier wird geprft, ob die Eigenschaftspunkteinformation angekommen ist - mit Untersttzung der Klasse
// RandstrukturKommunikation.
bool RandStruktur::ist_fertig_ep(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
// Kommentar: Wenn die Klasse RandStrukturKommunikation erkennt, dass eine ep-Kommunikation noch nicht abgeschlossen ist,
// dann gebe false zurck.
                if(randstruktur_kommunikation[i].ist_fertig_ep()==false)
                    {
                    return(false);
                    }

                }
            }
        }
// Kommentar: Wenn alle ep-Kommunikationen abgeschlossen sind, gebe true zurck.
    return(true);
    }

// Kommentar: Starte mit Hilfe der Klasse RandStrukturKommunikation die EP - Kommunikation
void RandStruktur::kommunikation_starten_ep(void)
    {
// Kommentar: Fr alle Punkte - benachbarten Kerne starte die ep - Kommuikation in der Klasse RandStrukturKommunikation.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                randstruktur_kommunikation[i].kommunikation_starten_ep();
                }
            }
        }
    }

// Kommentar: Startet die Kommunikation der Randwerte in der Klasse RandStrukturKommunikation.
void RandStruktur::randwerte_kommunikation_starten(void)
    {
    for(i=0; i<groesse; i++)
        {
// Kommentar: Das geschieht fr alle Kerne, die punktbenachbart sind zu dem eigenen Kern.
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                randstruktur_kommunikation[i].werte_kommunikation_starten();
                }
            }
        }
    }

////////////////////////////////////////////////////////////////////
//////////////// Fr RandWerteKommunikation ////////////////////////
////////////////////////////////////////////////////////////////////

// Kommentar: Hier wird die Eigenschaftspunkteinformation gepackt - mit Untersttzung der Klasse RandWerteKommunikation.
void RandStruktur::packen_ep2(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Vor packen_ep2" << endl;
#endif
// Kommentar: Fr alle Punkt - benachbarte Kerne mache packen_ep der Klasse RandWerteKommunikation.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                rand_werte_kommunikation[i].packen_ep();
                }
            }
        }
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Nach packen_ep2" << endl;
#endif
    }

// Kommentar: Hier wird die Eigenschaftspunkteinformation entpackt - mit Untersttzung der Klasse RandWerteKommunikation.
// Kommentare entsprechend den bisherigen Kommentaren hier.
void RandStruktur::entpacken_ep2(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Entpacken_ep nur fr Kerne, die eine Punktenachbarschaft haben.
            if(anzahl_rs[i]!=0)
                {
                rand_werte_kommunikation[i].entpacken_ep();
                }
            }
        }
    }

// Kommentar: Hier wird geprft, ob die Eigenschaftspunkteinformation angekommen ist - mit Untersttzung der Klasse
// RandWerteKommunikation.
bool RandStruktur::ist_fertig_ep2(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
// Kommentar: Wenn die Klasse RandWerteKommunikation erkennt, dass eine ep-Kommunikation noch nicht abgeschlossen ist,
// dann gebe false zurck.
                if(rand_werte_kommunikation[i].ist_fertig_ep()==false)
                    {
                    return(false);
                    }

                }
            }
        }
// Kommentar: Wenn alle ep - Kommunikationen abgeschlossen sind, gebe true zurck.
    return(true);
    }

// Kommentar: Die ep-Kommunikation wird initiiert - in der Klasse RandWerteKommunikation.
void RandStruktur::kommunikation_starten_ep2(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                rand_werte_kommunikation[i].kommunikation_starten_ep();
                }
            }
        }
    }

// Kommentar: Startet die Kommunikation der Randwerte in der Klasse RandWerteKommunikation. Die 2 steht fr
// die Struktur RandWerteKommunikation.
void RandStruktur::randwerte_kommunikation_starten_2(void)
    {
    for(i=0; i<groesse; i++)
        {
// Kommentar: Das geschieht fr alle Kerne, die punktbenachbart sind zu dem eigenen Kern.
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
// Neuer Befehl. Stimmt er?
                {
                rand_werte_kommunikation[i].werte_kommunikation_starten();
                }
            }
        }
    }

// Kommentar: Diese Funktion dient der Prfung, ob bei der RandWerteKommunikation die Kommunikation erfolgreich beendet worden ist.
bool RandStruktur::ist_fertig_2(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                if(rand_werte_kommunikation[i].ist_fertig()==false)
                    {
                    return(false);
                    }
                }
            }
        }
    return(true);
    }


////////////////////////////////////////////////////////////////////

// Kommentar: Das Testfeld ist markiert an den Auenrandpunkten. Nun wird es verglichen mit (f_a_rs,g_a_rs)(kernID)
// Die KernID wird bergeben.
void RandStruktur::teste_aussen_testfeld(int i)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "a_rs: (f,g). i = " << i << " Rang " << rang << " ";
    for(j=0; j<anzahl_a_rs[i]; j++)
        {
        cout << "(" << f_a_rs[i][j] << "," << g_a_rs[i][j] << ")" ;
        }
    cout << "a_rs Ende" << endl;
#endif
#ifdef WARTEN
    verzoegern2();
#endif

// Kommentar: f_a_rs, g_a_rs werden durchlaufen.
    for(j=0; j<anzahl_a_rs[i]; j++)
        {
// Kommentar: Ist das Testfeld nicht markiert => Fehlermeldung, dass in Testfeld eine Markierung fehlt.
        if(testfeld[i][f_a_rs[i][j]][g_a_rs[i][j]]==false)
            {
            cout << "Fehler in RandStruktur::teste_aussen_testfeld: Punkt im testfeld nicht da. ";
            cout << " i " << i << " j " << j << " f_a_rs[i][j] " << f_a_rs[i][j] << " g_a_rs[i][j] " << g_a_rs[i][j];
            cout << " rang " << rang << " anderer Kern " << i << endl;

            if(rang==1)
                {
                randstruktur_kommunikation[0].ausgeben_pv();
                }
            if(rang==0)
                {
                randstruktur_kommunikation[1].ausgeben_empfangen();
                }
#ifdef DA_RANDSTRUKTUR
            * da_randstruktur.aus << endl << "Fehler im Testfeld " << endl;
            for(k=0; k<n; k++)
                {
                for(j=0; j<m; j++)
                    {
                    * da_randstruktur.aus << testfeld[i][k][j] << " ";
                    }
                * da_randstruktur.aus << endl;
                }
            * da_randstruktur.aus << endl;
            * da_randstruktur.aus << randstruktur_kommunikation[i].anzahl_h_vektor_e << " " << randstruktur_kommunikation[i].anzahl_v_vektor_e << " ";
            * da_randstruktur.aus << randstruktur_kommunikation[i].punkteanzahl_e << endl;
#endif
            exit(-1);
            }
// Kommentar: Remarkiere das Testfeld an der aktuellen Stelle in f_a_rs, g_a_rs.
        testfeld[i][f_a_rs[i][j]][g_a_rs[i][j]]=false;
        }

// Kommentar: Durchlaufe das Testfeld. Ist eine Stelle trotz Remarkierung zurckgeblieben, dann wurde das Testfeld
// zu viel markiert => Gebe eine entsprechende Fehlermeldung aus.
    for(j=0; j<n; j++)
        {
        for(k=0; k<m; k++)
            {
            if(testfeld[i][j][k]==true)
                {
                cout << "Fehler in RandStruktur::teste_aussen_testfeld: Punkt im testfeld zuviel rang " << rang << " Anderer Kern " << i << " Gitterebene " << gitterebene << endl;
                cout << " i " << i << " j " << j << " k " << k << endl;

                speichere_k = k;
                speichere_j = j;

                if(rang==1)
                    {
                    randstruktur_kommunikation[0].ausgeben_pv();
                    }
                if(rang==0)
                    {
                    randstruktur_kommunikation[1].ausgeben_empfangen();
                    }

                cout << " Farbenfeld ausgeben rang " << rang << endl;
                rs_farbenfeld_ausgeben();

#ifdef DA_RANDSTRUKTUR
                for(j=0; j<n; j++)
                    {
                    for(k=0; k<m; k++)
                        {
                        * da_randstruktur.aus << testfeld[i][j][k] << " ";
                        }
                    * da_randstruktur.aus << endl;
                    }
                * da_randstruktur.aus << endl << endl;
#endif
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                testfeld[i][j][k] = 0;
                                }
                            }
                        for(l=0; l<anzahl_rs[i]; l++)
                            {
                            testfeld[i][f_rs[i][l]][g_rs[i][l]] = 1;
                            }
#ifdef DA_RANDSTRUKTUR
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                * da_randstruktur.aus << testfeld[i][j][k] << " ";
                                }
                            * da_randstruktur.aus << endl;
                            }
#endif
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                testfeld[i][j][k] = 0;
                                }
                            }
                        for(l=0; l<anzahl_rs[i]; l++)
                            {
                            testfeld[i][randstruktur_kommunikation[i].f_rs[l]][randstruktur_kommunikation[i].g_rs[l]] = 1;
                            }
#ifdef DA_RANDSTRUKTUR
                        * da_randstruktur.aus << endl;
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                * da_randstruktur.aus << testfeld[i][j][k] << " ";
                                }
                            * da_randstruktur.aus << endl;
                            }
                        * da_randstruktur.aus << endl;

                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                testfeld[i][j][k] = 0;
                                }
                            }
                        if(rang==0)
                            {
                            * da_randstruktur.aus << " anzahl_a_rs[1] " << anzahl_a_rs[1] << endl;
                            for(l=0; l<anzahl_a_rs[1]; l++)
                                {
                                testfeld[i][f_a_rs[1][l]][g_a_rs[1][l]] = 1;
                                }
                            for(j=0; j<n; j++)
                                {
                                for(k=0; k<m; k++)
                                    {
                                    * da_randstruktur.aus << testfeld[i][j][k] << " ";
                                    }
                                * da_randstruktur.aus << endl;
                                }
                            }
                        * da_randstruktur.aus << " Farbenfeld Rang " << rang << " gitterebene " << gitterebene << endl;
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                if(farbenfeld[j][k]==-1)
                                    {
                                    * da_randstruktur.aus << "* ";
                                    }
                                else
                                    {
                                    * da_randstruktur.aus << farbenfeld[j][k] << " ";
                                    }
                                }
                            * da_randstruktur.aus << endl;
                            }
                        * da_randstruktur.aus << endl;
                * da_randstruktur.aus << "Fehler in RandStruktur::teste_aussen_testfeld: Punkt im testfeld zuviel rang " << rang << " Anderer Kern " << i << " Gitterebene " << gitterebene << endl;
                * da_randstruktur.aus << " i " << i << " j " << speichere_j << " k " << speichere_k << endl;
                * da_randstruktur.aus << " vertikale Vektoren " << randstruktur_kommunikation[i].anzahl_v_vektor_e;
                * da_randstruktur.aus << " horizontale Vektoren " << randstruktur_kommunikation[i].anzahl_h_vektor_e;
                * da_randstruktur.aus << " Punkte " << randstruktur_kommunikation[i].punkteanzahl_e << endl;
                if(randstruktur_kommunikation[i].anzahl_h_vektor_e>0)
                    {
                    * da_randstruktur.aus << " hV f " << randstruktur_kommunikation[i].f_h_vektor_e[0];
                    * da_randstruktur.aus << " hV g1 " << randstruktur_kommunikation[i].g1_h_vektor_e[0];
                    * da_randstruktur.aus << " hV g2 " << randstruktur_kommunikation[i].g2_h_vektor_e[0] << endl;
                    }
#endif
                exit(-1);
                }
            }
        }
    }

// Kommentar: Eine Ausgabe der vektorisierten Innenrandmenge der Klasse RandStrukturKommunikation.
void RandStruktur::ausgeben_vektorisieren(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Gebe die Innenrandmengen zum Kern i aus.
            randstruktur_kommunikation[i].ausgeben_pv();
            }
        }
    }

// Kommentar: Eine Ausgabe der durch Kommunikation bestimmten vektorisierten Auenrandmenge der Klasse RandStrukturKommunikation.
void RandStruktur::ausgeben_empfangen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Gebe die nach Empfang der Innenrandmengen eingetragenen Auenrandmenge zum Kern i aus.
            randstruktur_kommunikation[i].ausgeben_empfangen();
            }
        }
    }

// Kommentar: Vektorisiert die Mengen f_rs und g_rs in der Klasse RandStrukturPV, einer Vaterklasse von
// RandStrukturKommunikation.
void RandStruktur::vektorisieren(void)
    {

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
// Kommentar: Vektorisiere die Innenrandmenge zu dem Kern der ID i.
            {
            randstruktur_kommunikation[i].vektorisieren(anzahl_rs[i]);
            }
        }
    }

// Kommentar: Anlegen der Strukturen RandStrukturKommunikation und RandWerteKommunikation.
void RandStruktur::initialisieren_struktur(int _groesse)
    {
    randstruktur_kommunikation = new RandStrukturKommunikation [_groesse];
    rand_werte_kommunikation = new RandWerteKommunikation [_groesse];
    }

// Kommentar: Freigeben der Strukturen RandStrukturKommunikation und RandWerteKommunikation.
void RandStruktur::finalisieren_struktur(int _groesse)
    {
    delete randstruktur_kommunikation;
    delete rand_werte_kommunikation;
    }

// Kommentar: Initialisieren der Klasse RandStrukturPV, einer Vaterklasse der Klasse RandStrukturKommunikation.
// Dabei wird auch Speicherplatz allokiert, und zwar fr die horizontalen und vertikalen Vektoren, und die verbleibenden Punkte.
void RandStruktur::initialisieren_vektorisieren(void)
    {
//    initialisieren_struktur(groesse);
// wird richtig finalisiert

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
// Kommentar: Zu allen anderen Kernen
            {
// Kommentar: Initialisiere die Klasse RandStrukturPV mit den bergebenen Werten / Strukturen, sowie mit den
// Strukturen, die den vektorisierten Innenrand aufnehmen werden.
            randstruktur_kommunikation[i].initialisieren(testfeld[i], n, m, f_rs[i], g_rs[i], i, rang);
            // wird richtig finalisiert
            }
        }
    }

// Kommentar: Befreit die Strukturen, die den vektorisierten Innenrand aufgenommen haben.
void RandStruktur::finalisieren_vektorisieren(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            randstruktur_kommunikation[i].finalisieren();
            }
        }
    }
#ifdef GEMEINSAME_BUFFER_SI
#ifdef GEMEINSAME_BUFFER
// Kommentar: Hier werden die Strukturen der RandWerteKommunikation angelegt, plus der Vergleichsbuffer, falls
// die Struktur RandWerteKommunikation getestet werden soll.
void RandStruktur::initialisieren_ohne_vektorisieren(double ** sendebuffer, double ** empfangsbuffer, short int ** sendebuffer_si, short int ** empfangsbuffer_si)
#else
void RandStruktur::initialisieren_ohne_vektorisieren(short int ** sendebuffer_si, short int ** empfangsbuffer_si)
#endif
#else
#ifdef GEMEINSAME_BUFFER
void RandStruktur::initialisieren_ohne_vektorisieren(double ** sendebuffer, double ** empfangsbuffer)
#else
void RandStruktur::initialisieren_ohne_vektorisieren(void)
#endif
#endif
    {
    #ifdef SORTIEREN_TESTEN
    mn = m*n;
    mn2_plus1 = mn*2 +1;
#ifdef GEMEINSAME_BUFFER_SI
// Kommentar: bernehmen der Sende - und Empfangsbuffer, falls das Ergebnis der Sortierung geprft werden soll. Oder sie werden
// allokiert.
    vergleichs_buffer = sendebuffer_si;
    vergleichs_buffer_ankommen = empfangsbuffer_si;
#else
    vergleichs_buffer = new short int * [groesse];
    vergleichs_buffer_ankommen = new short int * [groesse];
#endif
// Kommentar: Diese Request dienen der Kommunikation beim Testen der durch Sortierung geordneten Randstrukturen.
    sende_requests = new MPI_Request [groesse];
    empfange_requests = new MPI_Request [groesse];

    #endif

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
#ifdef AUSGABEN_RANDSTRUKTUR
            cout << "RWK initialisieren i " << i << endl;
#endif
            #ifdef GEMEINSAME_BUFFER
// Komentar: Hier werden die Rand Werte Kommunikationen initialisiert - ggf. inclusive der Mitbenutzung von Buffern.
            rand_werte_kommunikation[i].initialisieren(n, m, i, f_rs[i], g_rs[i], f_a_rs[i], g_a_rs[i], rang, sendebuffer[i], empfangsbuffer[i]);
            #else
            rand_werte_kommunikation[i].initialisieren(n, m, i, f_rs[i], g_rs[i], f_a_rs[i], g_a_rs[i], rang);
            #endif
            // wird richtig finalisiert
            #ifdef SORTIEREN_TESTEN
            #ifndef GEMEINSAME_BUFFER_SI
// Kommentar: Diese Buffer werden angelegt zur berprfung der durch Sortierung geordneten Randstrukturen.
//            vergleichs_buffer[i] = new short int [mn];
//            vergleichs_buffer_ankommen[i] = new short int [mn];
            vergleichs_buffer[i] = new short int [mn2_plus1];
            vergleichs_buffer_ankommen[i] = new short int [mn2_plus1];
            // wird finalisiert
            #endif
            #endif
            }
        }

    }

// Kommentar: Hier werden die eben prsentierten initialisierten Strukturen finalisiert, d.h. es wird genau der
// Speicher freigegeben, der in der eben dargestellten Initialisierung angelegt worden ist.
void RandStruktur::finalisieren_ohne_vektorisieren(void)
    {

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            #ifndef GEMEINSAME_BUFFER
// Kommentar: Die Rand Werte Kommunikationen werden finalisiert.
            rand_werte_kommunikation[i].finalisieren();
            // wird richtig finalisiert
            #endif
            #ifdef SORTIEREN_TESTEN
            #ifndef GEMEINSAME_BUFFER_SI
// Kommentar: Die Vergleichsbuffer fr den Korrektheitstests werden befreit, falls die Buffer nicht bernommen wurden.
            delete vergleichs_buffer[i];
            delete vergleichs_buffer_ankommen[i];
            #endif
            #endif
            }
        }

    #ifdef SORTIEREN_TESTEN

#ifndef GEMEINSAME_BUFFER_SI
// Kommentar: Die Zusammenfassenden Zeiger der Vergleichsstrukturen werden befreit, falls die Buffer nicht
// bergeben wurden.
    delete vergleichs_buffer;
    delete vergleichs_buffer_ankommen;
#endif
// Kommentar: Die Requests werden freigegeben.
    delete sende_requests;
    delete empfange_requests;

    #endif
    }

// Kommentar: Hier wird die Klasse RandStrukturKommunikation finalisiert, d.h. der dort angelegte Spericherplatz wird freigegeben.
void RandStruktur::finalisieren_kommunikation_struktur(void)
    {

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Zu allen anderen Kernen wird die Finalisierung durchgefhrt.
            randstruktur_kommunikation[i].finalisieren_kommunikation();
            }
        }

    }

// Kommentar: Diese Struktur hier bewirkt nichts. Also: Keine Kommentierung.
void RandStruktur::finalisieren_kommunikation_werte(void)
    {
    // richtig: hier wird kein Speicherplatz freigegeben
    }

// Kommentar: Die Klassen RandStrukturKommunikation werden initialisiert.
void RandStruktur::initialisieren_kommunikation_struktur(void)
// wird finalisiert, s.o.
    {
// Kommentar: Zu allen anderen Farben oder Rngen
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            #ifdef dimensionen1
// Kommentar: Initialisierung der Klassen RandStrukturKommunikation
            randstruktur_kommunikation[i].initialisieren_kommunikation(x0, y0);
            #endif
            #ifdef dimensionen2
            randstruktur_kommunikation[i].initialisieren_kommunikation(x0, x1, y0, y1);
            #endif
            #ifdef dimensionen3
            randstruktur_kommunikation[i].initialisieren_kommunikation(x0, x1, x2, y0, y1, y2);
            #endif
            #ifdef dimensionen4
            randstruktur_kommunikation[i].initialisieren_kommunikation(x0, x1, x2, x3, y0, y1, y2, y3);
            #endif
// Kommentar: Die Variablenzeiger werden bergeben an die Klasse RandStrukturkommunikation.
            randstruktur_kommunikation[i].initialisieren_kommunikation_rest(u0, gg_u0, r0, f0, Iu0, rS0, e0, Lu0, u0_hilf);
            // Hier wird kein Speicher angelegt.
// Kommentar: Gitterebene und Eigenrang werden bergeben an die Klasse RandStrukturkommunikation.
            randstruktur_kommunikation[i].gitterebene = gitterebene;
            randstruktur_kommunikation[i].komm_farbe = i;
            }
        }
    }

#ifdef GEMEINSAME_BUFFER
// Kommentar: Sende - und Empfangsbuffer werden an die Klassen der RandStrukturKommunikation bergeben - fr alle anderen Rnge,
// falls Randbuffer verfgbar sind.
void RandStruktur::initialisieren_kommunikation_struktur_werte(double ** sendebuffer, double ** empfangsbuffer)
// Wird finalisiert
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            randstruktur_kommunikation[i].initialisieren_werte(sendebuffer[i], empfangsbuffer[i]);
            // wird finalisiert
            }
        }
    }
#else
// Kommentar: Sonst werden die Buffer direkt in der Klasse RandStrukturKommunikation allokiert.
void RandStruktur::initialisieren_kommunikation_struktur_werte(void)
// wird finalisiert
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            randstruktur_kommunikation[i].initialisieren_werte();
            // wird finalisiert
            }
        }
    }
#endif

// Kommentar: Fr den zweiten Fall werden die fr die Klasse RandStrukturKommunikation allokierten Buffer
// hier wieder freigegeben. Wegen der Prprozessor if - Anweisung ist diese Funktion aber fr beide
// Flle geeignet.
void RandStruktur::finalisieren_kommunikation_struktur_werte(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            randstruktur_kommunikation[i].finalisieren_werte();
            }
        }
    }

// Kommentar: Analog zu initialisieren_kommunikation_struktur, nur dass hier die Kommunikation der RandWerteKommunikation
// initialisiert wird, anstelle der Klasse RandStrukturKommunikation
void RandStruktur::initialisieren_kommunikation_werte(void)
    {

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            #ifdef dimensionen1
// Kommentar: Anlegen der Kommunikation der Klassen RandWerteWerteKommunikation fr alle anderen Farben.
            rand_werte_kommunikation[i].initialisieren_kommunikation(x0, y0);
            // Kein Speicherplatz wird hier angelegt
            #endif
            #ifdef dimensionen2
            rand_werte_kommunikation[i].initialisieren_kommunikation(x0, x1, y0, y1);
            #endif
            #ifdef dimensionen3
            rand_werte_kommunikation[i].initialisieren_kommunikation(x0, x1, x2, y0, y1, y2);
            #endif
            #ifdef dimensionen4
            rand_werte_kommunikation[i].initialisieren_kommunikation(x0, x1, x2, x3, y0, y1, y2, y3);
            #endif
// Kommentar: Anlegen der anderen Variablen sowie von Gitterebene und eigenem Rang der Klassen der RandWerteKommunikation.
            rand_werte_kommunikation[i].initialisieren_kommunikation_rest(u0, gg_u0, r0, f0, Iu0, rS0, e0, Lu0, u0_hilf);
            rand_werte_kommunikation[i].gitterebene = gitterebene;
            rand_werte_kommunikation[i].komm_farbe = i;
            }
        }
    }

// Kommentar: Anlegen der Kommunikation der Eigenschaftspunkte der Klassen RandWerteKommunikation zu allen anderen Farben.
void RandStruktur::initialisieren_kommunikation_ep(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            rand_werte_kommunikation[i].initialisieren_kommunikation_ep(ep_aktuell);
            }
        }
    }

// Kommentar: Diese Funktion wird von der Klasse RandStrukturKommunikation aus aufgerufen. Fr alle
// Kerne, die punktebenachbart sind, rufen die Klassen RSK (RandStrukturKommunikation) die Funktion packen auf.
void RandStruktur::packen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                randstruktur_kommunikation[i].packen();
                }
            }
        }
    }

// Kommentar: Hier wird der Auenrand, im Fall mit keinem gemeinsamen Rand, wieder gelscht.
void RandStruktur::bereinigen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]==0)
                {
                randstruktur_kommunikation[i].bereinigen();
                }
            }
        }
    }

// Kommentar: Diese Funktion wird von der Klasse RandStrukturKommunikation aus aufgerufen. Fr alle
// Kerne, die punktebenachbart sind, rufen die Klassen RSK (RandStrukturKommunikation) die Funktion entpacken auf.
void RandStruktur::entpacken(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                randstruktur_kommunikation[i].entpacken();
                }
            }
        }
    }

// Kommentar: Diese Funktion wird von der Klasse RandStrukturKommunikation aus aufgerufen. Fr alle
// Kerne, die punktebenachbart sind, rufen die Klassen RSK (RandStrukturKommunikation) die Funktion kommunikation_starten auf.
void RandStruktur::kommunikation_starten(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Kommunikation Starten KS in RandStruktur. Rang " << rang;
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                cout << " i " << i;
                }
            }
        }
    cout << endl << "Diese i werden gestartet " << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                randstruktur_kommunikation[i].kommunikation_starten();
                }
            }
        }
    }

// Kommentar: Diese Funktion wird von der Klasse RandStrukturKommunikation aus aufgerufen. Fr alle
// Kerne, die punktebenachbart sind, rufen die Klassen RSK (RandStrukturKommunikation) die Funktion ist_fertig auf.
bool RandStruktur::ist_fertig(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(anzahl_rs[i]!=0)
                {
                if(randstruktur_kommunikation[i].ist_fertig()==false)
                    {
                    return(false);
                    }
                }
            }
        }
    return(true);
    }

// Kommentar: Wurden die Testfelder mit den Punkten des Innenrandes markiert, so wird es hier demarkiert.
void RandStruktur::reset_testfeld_rs(void)
    {
// Kommentar: Die anderen Farben werden durchlaufen.
    for(i=0; i<groesse;i++)
        {
        if(i!=rang)
            {
            anzahl_rs_farbe = anzahl_rs[i];
// Kommentar: Die Innenrandpunktmenge wird durchlaufen, und testfeld(i) an der Stelle der Punkte wird auf false gesetzt.
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_rs[i][j]][g_rs[i][j]] = false;
                }
            }
        }

    }

// Kommentar: Das ist dieselbe Funktion wie 'reset_testfeld_rs'.
void RandStruktur::randstruktur_reset(void)
    {
    for(i=0; i<groesse;i++)
        {
        if(i!=rang)
            {
            anzahl_rs_farbe = anzahl_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_rs[i][j]][g_rs[i][j]] = false;
                }
            }
        }
    }

// Kommentar: Wurde das Testfeld(KernID) fr Innenrand und Auenrand markiert, so wird es mit dieser Funktion
// remarkiert.
void RandStruktur::randstruktur_reset_beide(void)
    {
    for(i=0; i<groesse;i++)
        {
// Kommentar Durchlaufe alle anderen Rnge.
        if(i!=rang)
            {
// Kommentar: Remarkiere testfeld(i) bzgl. des Innenrandes.
            anzahl_rs_farbe = anzahl_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_rs[i][j]][g_rs[i][j]] = false;
                }
            anzahl_rs[i] = 0;
// Kommentar: Remarkiere testfeld(i) bzgl. des Auenrandes.
            anzahl_rs_farbe = anzahl_a_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_a_rs[i][j]][g_a_rs[i][j]] = false;
                }
            anzahl_a_rs[i] = 0;
            }
        }
    }

// Kommentar: Wurde das Testfeld(KernID) fr Innenrand und Auenrand markiert, so wird es mit dieser Funktion der Aussenrand
// remarkiert.
void RandStruktur::randstruktur_reset_testfeld_aussenrand(void)
    {
    for(i=0; i<groesse;i++)
        {
// Kommentar Durchlaufe alle anderen Rnge.
        if(i!=rang)
            {
// Kommentar: Remarkiere testfeld(i) bzgl. des Auenrandes.
            anzahl_rs_farbe = anzahl_a_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_a_rs[i][j]][g_a_rs[i][j]] = false;
                }
            }
        }
    }

void RandStruktur::randstruktur_reset_testfeld_aussenrand_abschliessen(void)
    {
    for(i=0; i<groesse;i++)
        {
// Kommentar Durchlaufe alle anderen Rnge.
        if(i!=rang)
            {
            anzahl_a_rs[i] = 0;
            }
        }
    }

// Kommentar: Hier wird getestet, ob das Testfeld true Eintrge hat. In dem Fall erfolgen gewisse Ausgaben, und es wird false zurckgegeben.
bool RandStruktur::randstruktur_leer(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            for(j=0; j<n; j++)
                {
                for(k=0; k<m; k++)
                    {
                    if(testfeld[i][j][k]==true)
                        {
                        cout << " Code 40: Feld nicht leer : rang " << rang << " zu Kern i " << i << " Stelle (" << j << "," << k << ")" << " gitterebene " << gitterebene << endl;
#ifdef DA_RANDSTRUKTUR
                        * da_randstruktur.aus << " Code 40: Feld nicht leer : rang " << rang << " zu Kern i " << i << " Stelle (" << j << "," << k << ")" << endl;
#endif
                        for(l=0; l<anzahl_rs[i]; l++)
                            {
                            if((f_rs[i][l]==j)&&(g_rs[i][l]==k))
                                {
                                cout << " Code 41: Ist in Liste f_rs/g_rs vorhanden rang " << rang << endl;
#ifdef DA_RANDSTRUKTUR
                                * da_randstruktur.aus << " Code 41: Ist in Liste f_rs/g_rs vorhanden rang " << rang << endl;
#endif
                                }
                            }
#ifdef DA_RANDSTRUKTUR
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                * da_randstruktur.aus << testfeld[i][j][k] << " ";
                                }
                            * da_randstruktur.aus << endl;
                            }
                        * da_randstruktur.aus << endl << endl;
#endif
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                testfeld[i][j][k] = 0;
                                }
                            }
                        for(l=0; l<anzahl_rs[i]; l++)
                            {
                            testfeld[i][f_rs[i][l]][g_rs[i][l]] = 1;
                            }
#ifdef DA_RANDSTRUKTUR
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                * da_randstruktur.aus << testfeld[i][j][k] << " ";
                                }
                            * da_randstruktur.aus << endl;
                            }
#endif
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                testfeld[i][j][k] = 0;
                                }
                            }
                        for(l=0; l<anzahl_rs[i]; l++)
                            {
                            testfeld[i][randstruktur_kommunikation[i].f_rs[l]][randstruktur_kommunikation[i].g_rs[l]] = 1;
                            }
#ifdef DA_RANDSTRUKTUR
                        * da_randstruktur.aus << endl;
                        for(j=0; j<n; j++)
                            {
                            for(k=0; k<m; k++)
                                {
                                * da_randstruktur.aus << testfeld[i][j][k] << " ";
                                }
                            * da_randstruktur.aus << endl;
                            }
#endif

                        return(false);
                        }
                    }
                }
            }
        }
    return(true);
    }

// Kommentar: Wie eben, nur das nur die Testfelder remarkiert werden, nicht aber die Innenrand - und Auenrandmengen
// leer gemacht werden.
void RandStruktur::randstruktur_reset_testfeld_fuer_beide(void)
    {
    for(i=0; i<groesse;i++)
        {
        if(i!=rang)
            {
// Kommentar: Remarkiere testfeld(i) bzgl. des Innenrandes.
            anzahl_rs_farbe = anzahl_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_rs[i][j]][g_rs[i][j]] = false;
                }
//            anzahl_rs[i] = 0; // Das wird immer vorher gemacht, vor der Bestimmung der beiden Randpunktemengen.
// Kommentar: Remarkiere testfeld(i) bzgl. des Auenrandes.
            anzahl_rs_farbe = anzahl_a_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
#ifdef AUSGABEN_RANDSTRUKTUR
                if((rang==1)&&(gitterebene==1)&&(f_a_rs[i][j]==1)&&(g_a_rs[i][j]==6))
                    {
                    cout << "Es wird das Testfeld auf (1,1,1,6) geloescht " << endl;
                    }
#endif
                testfeld[i][f_a_rs[i][j]][g_a_rs[i][j]] = false;
                }
            }
        }
    }

// Kommentar: Hier wird die testfelder des Auenrandes remarkiert.
void RandStruktur::reset_testfeld_a_rs(void)
    {
    for(i=0; i<groesse;i++)
        {

        if(i!=rang)
            {
            anzahl_rs_farbe = anzahl_a_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                testfeld[i][f_a_rs[i][j]][g_a_rs[i][j]] = false;
                }
//            anzahl_a_rs[i] = 0;
            }
        }
    }

// Kommentar: Diese Funktion wird von der Klasse Gitter aus aufgerufen - bei der Bildung der Randliste.
// Es wird die Liste (f_rs,g_rs)(i) geschrieben. Bemerkung: Eingefgt werden soll auf (i,j) im Innenrand,
// whrend der Farbwert vom Auenrand herkommt.
void RandStruktur::randpunkt_einfuegen(int i, int j, int farbe)
// Der Randpunkt wird eingefuegt. Es geht dabei um die Struktur, welche Punkte den Rand bilden zu dem
// jeweiligen Prozessor mit der Farbe 'farbe'. Das wird im Anschluss vektorisiert.
// Man hat dann Vektoren, welche Werte am Rand zu uebertragen sind.
// bei '-1'sen ist nichts zu uebertragen.

// Frage: Wenn Lastausgleich gemacht wird, ist danach das auch wieder zu machen? Ich denke schon.
// Frage: Ueber alle Ebenen? Ueber alle Ebenen. Es geschieht dabei keine Kommunikation.
    {
// Kommentar: Ist der Farbwert zu gro => Fehlermeldung
    if(farbe >= groesse)
        {
        cout << "Fehler in RandStruktur::randpunkt_einfuegen: Zu grosse Farbe. Farbe " << farbe << endl;
        exit(-1);
        }

// Kommentar: Ist der Farbwert negativ => return. Hier werden nur Farbwerte von 0 ... groesse-1 bearbeitet.
    if(farbe == -1)
        {
        return;
        }
    if(farbe == -2)
        {
        return;
        }
    if(farbe == rang)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "re i: " << i << " j: " << j << endl;
#endif
        return;
        }
// Wenn (i,j) die Gittermae berschreiten => return. Das wird nicht behandelt.
    if(i<0)
        {
        return;
        }

    if(j<0)
        {
        return;
        }
    if(i>=n)
        {
        return;
        }
    if(j>=m)
        {
        return;
        }

// Kommentar: Wurde der Punkt schon einmal in die Liste eingetragen, dann mache nichts.
    if(testfeld[farbe][i][j]==true)
        {
        return;
        }

// Kommentar: Ansonsten verzeichne, dass dieser Punkt schon einmal eingetragen worden ist.
    testfeld[farbe][i][j] = true;

// Kommentar: Und nehme ihn in die Liste (f_rs,g_rs) auf.
    anzahl_rs_farbe = anzahl_rs[farbe];
    f_rs[farbe][anzahl_rs_farbe] = i;
    g_rs[farbe][anzahl_rs_farbe] = j;
// Kommentar: Und erhhe den Index um 1.
    anzahl_rs_farbe ++;
    anzahl_rs[farbe]=anzahl_rs_farbe;
    }

// Kommentar: Diese Funktion macht dasselbe wie randpunkt_einfuegen, mit dem Unterschied, dass
// bei farbe < 0 der Punkt bei der Lastwertekorrektur eingefgt wird. So wird gleichzeitig
// die Randstruktur geschrieben, und auch noch LWK gemacht.  Bemerkung: Eingefgt werden soll auf (i,j) im Innenrand,
// whrend der Farbwert vom Auenrand herkommt.
void RandStruktur::randpunkt_einfuegen_mit_minus1_merken(int i, int j, int farbe)
// Der Randpunkt wird eingefuegt. Es geht dabei um die Struktur, welche Punkte den Rand bilden zu dem
// jeweiligen Prozessor mit der Farbe 'farbe'. Das wird im Anschluss vektorisiert.
// Man hat dann Vektoren, welche Werte am Rand zu uebertragen sind.
// bei '-1'sen ist nichts zu uebertragen.

// Frage: Wenn Lastausgleich gemacht wird, ist danach das auch wieder zu machen? Ich denke schon.
// Frage: Ueber alle Ebenen? Ueber alle Ebenen. Es geschieht dabei keine Kommunikation.
    {

// Kommentar: s.o. bei randpunkt_einfuegen
    if(farbe >= groesse)
        {
        cout << "Fehler in RandStruktur::randpunkt_einfuegen: Zu grosse Farbe. Farbe " << farbe << endl;
        exit(-1);
        }
// Kommentar: Wenn neben dem Punkt eine Farbe < 0 existiert, liegt ein echter Randpunkt vor. Der kann in die
// Struktur lastwerte_korrektur_punkte eingefgt werden.
    if(farbe < 0)
        {
        lastwerte_korrektur_punkte.setzen(i,j);
        return;
        }
// Kommentar: Das ist eigentlich unmglich, weil selbstnachbarn das ausschliet. Jedenfalls entsteht dadurch kein
// Randpunkt zu einem anderen Kern.
    if(farbe == rang)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "re i: " << i << " j: " << j << endl;
#endif
        return;
        }

// Kommentar: Hlt der Punkt die Gittermae nicht ein, kann er nicht in eine Randstruktur eingefgt werden.
    if(i<0)
        {
        return;
        }

    if(j<0)
        {
        return;
        }
    if(i>=n)
        {
        return;
        }
    if(j>=m)
        {
        return;
        }
// Kommentar: Der Rest analog zur Funktion randpunkt_einfuegen.
    if(testfeld[farbe][i][j]==true)
        {
        return;
        }
    testfeld[farbe][i][j] = true;
    anzahl_rs_farbe = anzahl_rs[farbe];
    f_rs[farbe][anzahl_rs_farbe] = i;
    g_rs[farbe][anzahl_rs_farbe] = j;
    anzahl_rs_farbe ++;
    anzahl_rs[farbe]=anzahl_rs_farbe;
    }

// Kommentar: Hier wird - wie oben - das Testfeld in Bezug auf den Innenrand remarkiert.
void RandStruktur::reset(void)
    {
    for(k=0; k<groesse; k++)
        {
        if(k==rang)
            {
            continue;
            }
        for(l=0; l<anzahl_rs[k]; l++)
            {
            testfeld[k][f_rs[k][l]][g_rs[k][l]] = false;
            }
        }
    }

// Kommentar: Hier werden die Innenrandpunktmengen leer gemacht.
void RandStruktur::reset_punktemenge(void)
    {
    for(k=0; k<groesse; k++)
        {
        if(k==rang)
            {
            continue;
            }
        anzahl_rs[k] = 0;
        }
    }

// Kommentar: Hier werden die Innen - und Auenrandpunktmengen fr alle Kerne remarkiert.
void RandStruktur::reset_beide(void)
    {
    for(k=0; k<groesse; k++)
        {
// Kommentar: Fr alle Kerne != dem eigenen Kern.
        if(k==rang)
            {
            continue;
            }
// Remarkiere die Innenrandpunktmenge zum Kern k.
        for(l=0; l<anzahl_rs[k]; l++)
            {
            testfeld[k][f_rs[k][l]][g_rs[k][l]] = false;
            }

// Remarkiere die Auenrandpunktmenge zum Kern k.
        for(l=0; l<anzahl_a_rs[k]; l++)
            {
            testfeld[k][f_a_rs[k][l]][g_a_rs[k][l]] = false;
            }
        }
    }

// Kommentar: Hier werden zu allen Kernen die Innen - und Auenrandpunktmengen geleert.
void RandStruktur::reset_beide_punktemenge(void)
    {
    for(k=0; k<groesse; k++)
        {
        if(k==rang)
            {
            continue;
            }

        anzahl_rs[k] = 0;

        anzahl_a_rs[k] = 0;
        }
    }

// Kommentar: Hier wird, zu Debugging - Zwecken, die Innenrandpunktmenge ausgegeben.
void RandStruktur::randpunkteliste_ausgeben(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            cout << "Randpunkteliste: zu Farbe " << i << " ";
            anzahl_rs_farbe = anzahl_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                cout << "(" << f_rs[i][j] << " " << g_rs[i][j] << ") ";
                }
            cout << endl;
            }
        }
#endif
    }

// Kommentar: Hier wird der Speicherplatz fr ein boolsches Testfeld angelegt - zu allen Kernen auer dem eigenen.
void RandStruktur::initialisieren_testfeld(void)
// wird richtig finalisiert, s.u.
    {
#ifdef KURZ_TESTFELD
    testfeld = new bool ** [groesse];
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Initialisieren Testfeld groesse " << groesse << " n " << n << " m " << m << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            testfeld[i] = new bool * [n];
            for(j=0; j<n; j++)
                {
                testfeld[i][j] = new bool [m];
                for(k=0; k<m; k++)
                    {
                    testfeld[i][j][k] = false;
                    }
                }
            }
        }
#else
// Kommentar: Das Testfeld kann auch als Integer - Testfeld angelegt werden, bentigt dann aber mehr Speicherplatz.
    testfeld = new int ** [groesse];
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Initialisieren Testfeld groesse " << groesse << " n " << n << " m " << m << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            testfeld[i] = new int * [n];
            for(j=0; j<n; j++)
                {
                testfeld[i][j] = new int [m];
                for(k=0; k<m; k++)
                    {
                    testfeld[i][j][k] = false;
                    }
                }
            }
        }
#endif
// Kommentar: Und dann wird der Speicherplatz fr die Innenrandpunktmengen angelegt.
    f_rs = new short int * [groesse];
    g_rs = new short int * [groesse];
    anzahl_rs = new int [groesse];

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            f_rs[i] = new short int [mn];
            g_rs[i] = new short int [mn];
            anzahl_rs[i] = 0;
            }
        }
    }

// Kommentar: Hier wird der Speicherplatz fr die Testfelder sowie die Innenrandpunktmengen wieder freigegeben.
void RandStruktur::finalisieren_testfeld(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            for(j=0; j<n; j++)
                {
                delete testfeld[i][j];
                }
            delete testfeld[i];
            }
        }
    delete testfeld;

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete f_rs[i];
            delete g_rs[i];
            }
        }
    delete f_rs;
    delete g_rs;
    delete anzahl_rs;
    }

// Kommentar: Hier wird der Speicherplatz fr die Testfelder, die Innen - und Auenrandpunktmengen sowie die
// Koordinatensortierung angelegt.
void RandStruktur::initialisieren_testfelder(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "initialisieren von f_a_rs und g_a_rs " << endl;
#endif
// Kommentar: Legt den Speicher fr die Testfelder und die Innenrandpunktmenge an.
    initialisieren_testfeld();
    // Mglicherweise wird diese Funktion doppelt aufgerufen.
    // Wird richtig finalisiert

// Kommentar: Legt den SPeicherplatz fr die Auenrandpunktmengen an.
    f_a_rs = new short int * [groesse];
    g_a_rs = new short int * [groesse];
    anzahl_a_rs = new int [groesse];
    // wird richtig finalisiert
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            f_a_rs[i] = new short int [mn];
            g_a_rs[i] = new short int [mn];
            anzahl_a_rs[i] = 0;
            }
        }
    // wird richtig finalisiert

// Kommentar: Initialisiert die Koordinatensortierung.
    koordinaten_sortierung.initialisieren(mn);
    // wird richtig finalisiert.
    }

// Kommentar: Finalisiert die Testfelder, die Innen - und Auenrandpunktmengen sowie die Koordinatensortierung.
void RandStruktur::finalisieren_testfelder(void)
    {
// Kommentar: Finalisiert die Testfelder sowie die Innenrandpunktmenge.
    finalisieren_testfeld();

// Kommentar: Gibt den Speicherplatz der Auenrandpunktmengen wieder frei.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete f_a_rs[i];
            delete g_a_rs[i];
            }
        }
    delete f_a_rs;
    delete g_a_rs;
    delete anzahl_a_rs;

// Kommentar: Finalisiert die Koordinaten - Sortierung.
    koordinaten_sortierung.finalisieren();
    }

// Kommentar: Prft, ob zum Kern der bergebenen ID eine Punktnachbarschaft existiert.
bool RandStruktur::ist_nicht_leer(int i)
    {
//    return((randstruktur_kommunikation[i]).ist_nicht_leer()); 9.2.16: Lassen, um ggf. zu nutzen.

// Kommentar: Bei anzahl_rs[i] > 0 existiert ein gemeinsamer Rand => return true.
    if(anzahl_rs[i]>0)
        {
        return(true);
        }
// Kommentar: Ansonsten existiert kein gemeinsamer Rand => return false.
    return(false);
    }

// Kommentar: Die Strukturen ist_nachbar und ist_nachbar_ml werden fr diese Gitterebene aktualisiert.
// Dafr mssen sie zuvor auf 0 gesetzt werden. Dann stimmt das.
void RandStruktur::aktualisiere_ist_nachbar(void)
// Diese Funktion wird von der folgenden Funktion aufgerufen: void Programm::bestimme_prozessornachbarn(void)
    {
// Kommentar: Wenn die RandStrukturKommunikation die verwendete Randstruktur ist ...
    if(vektorisieren0==JA)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "ain " << " JA " << endl;
#endif
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
// Kommentar: Prfe, ob zu i eine Punktnachbarschaft existiert.
                if ((randstruktur_kommunikation[i]).ist_nicht_leer()==true)
                // Die Funktion : bool RandStrukturPV::ist_nicht_leer(void)
                // Und was ist bei randwerte_kommunikation?
                    {
// Falls ja, dann wird diese Information zu ist_nachbar[i] und ist_nachbar_ml[i] hinzugefgt, wobei zu bemerken ist, dass
// ist_nachbar_ml einen Zeiger in paralleles_rechnen fr alle Gitterebenen hat, um diese Information ber
// alle Gitterebenen zu aggregieren.
                    ist_nachbar[i] = ist_nachbar[i] | 1;
                    ist_nachbar_ml[i] = ist_nachbar_ml[i] | 1;
                    }
                }
            }
        }
    else
// Kommentar: Hier ist die Klasse RandWerteKommunikation die Struktur, die die Randinformation enthlt.
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "ain " << " NEIN " << endl;
#endif
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
// Kommentar: Prfe, ob zu i eine Punktnachbarschaft existiert.
                if (ist_nachbar_randwerte(i)==true)
                // Die Funktion : bool RandStrukturPV::ist_nicht_leer(void)
                // Und was ist bei randwerte_kommunikation?
                    {
// Falls ja, dann wird diese Information zu ist_nachbar[i] und ist_nachbar_ml[i] hinzugefgt, wobei zu bemerken ist, dass
// ist_nachbar_ml einen Zeiger in paralleles_rechnen fr alle Gitterebenen hat, um diese Information ber
// alle Gitterebenen zu aggregieren.
                    ist_nachbar[i] = ist_nachbar[i] | 1;
                    ist_nachbar_ml[i] = ist_nachbar_ml[i] | 1;
                    }
                }
            }
        }
    }

// Kommentar: Hier werden Auenrand - und Innenrandpunktmengen aktualisiert. Wichtig fr die Testfelder: Diese Mengen
// sind strikt disjunkt. Die Farbe ist natrlich die Farbe des Auenrandpunktes.
void RandStruktur::randpunkte_einfuegen(int i, int j, int farbe, int kk, int ll)
// Der Randpunkt wird eingefuegt. Es geht dabei um die Struktur, welche Punkte den Rand bilden zu dem
// jeweiligen Prozessor mit der Farbe 'farbe'. Das wird im Anschluss vektorisiert.
// Man hat dann Vektoren, welche Werte am Rand zu uebertragen sind.
// bei '-1'sen ist nichts zu uebertragen.

// Frage: Wenn Lastausgleich gemacht wird, ist danach das auch wieder zu machen? Ich denke schon.
// Frage: Ueber alle Ebenen? Ueber alle Ebenen. Es geschieht dabei keine Kommunikation.
    {
// Kommentar: Das hier ist eigentlich unmglich. Das Farbenfeld hat keine solchen Eintrge. Falls doch => Fehlermeldung
// ausgeben.

    if(farbe >= groesse)
        {
        cout << "Fehler in RandStruktur::randpunkt_einfuegen: Zu grosse Farbe. Farbe " << farbe << " f " << i << " g " << j << " rang " << rang << " ebene " << gitterebene << " kk " << kk << " ll " << ll << endl;
        exit(-1);
        }

// Kommentar: Ist die farbe < 0 oder = rang => Diese Punktkombination stellt keine randrelevante Information dar. Also
// wird diese Funktion dann beendet.
    if(farbe < 0)
        {
        return;
        }
    if(farbe == rang)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "Fehler wegen farbe == rang " << endl;

        cout << "re i: " << i << " j: " << j << " rang " << rang << " ebene " << gitterebene << " kk " << kk << " ll " << ll << " snb " << selbstnachbarn[i][j] << " 255-snb " << 255-selbstnachbarn[i][j] << endl;
#endif
        return;
        }

#ifdef AUSGABEN_RANDSTRUKTUR
    if((kk==1)&&(ll==6)&&(rang==1)&&(gitterebene==1))
        {
        cout << " 1611 farbe " << farbe << " testfeld " << testfeld[farbe][kk][ll] << " i " << i << " j " << j;
        cout << " dynamischer_rand(i,j).feld " << dynamischer_rand.feld[i][j] << endl;
        }
#endif

// Zuerst wird in die Auenrandpunktmenge eingetragen. Dafr darf keine Markierung auf Position (kk,ll) vorliegen.
    if(testfeld[farbe][kk][ll]==false)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "kk "  << kk << " ll " << ll << endl;
#endif
// Kommentar: Um ein zweites Eintragen zu verhindern wird das Testfeld zur Farbe markiert.
        testfeld[farbe][kk][ll] = true;
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "Durch Testfeld - Abfrage durch " << endl;
#endif
// Kommentar: Und das Punktepaar wird in die Auenrandpunktliste eingetragen.
        anzahl_rs_farbe = anzahl_a_rs[farbe];
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "Durch Anzahl_a_rs durch " << endl;
#endif
        f_a_rs[farbe][anzahl_rs_farbe] = kk;
        g_a_rs[farbe][anzahl_rs_farbe] = ll;
        anzahl_rs_farbe ++;
        anzahl_a_rs[farbe]=anzahl_rs_farbe;
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << " farbe " << farbe << " anzahl_a_rs[farbe] " << anzahl_a_rs[farbe] << endl;
#endif
        if((rang==1)&&(gitterebene==0)&&(farbe==0))
            {
            cout << " randstruktur kk " << kk << " ll " << ll << endl;
            }
#endif
        }

// Kommentar: Es wird geprft, ob (i,j) die Gittermae einhlt. Das sollte eigentlich der Fall sein, und eher
// fr die potentiellen Auenrandpunkte geprft werden.
    if(i<0)
        {
        return;
        }

    if(j<0)
        {
        return;
        }
    if(i>=n)
        {
        return;
        }
    if(j>=m)
        {
        return;
        }

// Kommentar: Wurde der Punkt (i,j) schon einmal eingetragen in die Innenrandliste, dann kein zweites Mal.
    if(testfeld[farbe][i][j]==true)
        {
        return;
        }

#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " i " << i << " j " << j;
#endif

// Kommentar: Ansonsten vermerke im Testfeld den Eintrag in die Innenrandliste ...
    testfeld[farbe][i][j] = true;
    anzahl_rs_farbe = anzahl_rs[farbe];
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " anzahl " << anzahl_rs_farbe << endl;
#endif
// Kommentar: ... und trage den Gitterpunkt in die Innenrandpunktliste ein.
    f_rs[farbe][anzahl_rs_farbe] = i;
    g_rs[farbe][anzahl_rs_farbe] = j;
    anzahl_rs_farbe ++;
    anzahl_rs[farbe]=anzahl_rs_farbe;
    }

// Kommentar: Hier geschieht dasselbe wie bei randpunkte_einfuegen, nur dass die Lastwertekorrektur gleich
// mitbehandelt wird. Hier wird nur die Absweichung zu randpunkte_einfuegen kommentiert.
void RandStruktur::randpunkte_einfuegen_mit_minus1_merken(int i, int j, int farbe, int kk, int ll)
// Der Randpunkt wird eingefuegt. Es geht dabei um die Struktur, welche Punkte den Rand bilden zu dem
// jeweiligen Prozessor mit der Farbe 'farbe'. Das wird im Anschluss vektorisiert.
// Man hat dann Vektoren, welche Werte am Rand zu uebertragen sind.
// bei '-1'sen ist nichts zu uebertragen.

// Frage: Wenn Lastausgleich gemacht wird, ist danach das auch wieder zu machen? Ich denke schon.
// Frage: Ueber alle Ebenen? Ueber alle Ebenen. Es geschieht dabei keine Kommunikation.
    {

    if(farbe >= groesse)
        {
        cout << "Fehler in RandStruktur::randpunkt_einfuegen: Zu grosse Farbe. Farbe " << farbe << " f " << i << " g " << j << " rang " << rang << " ebene " << gitterebene << " kk " << kk << " ll " << ll << endl;
        exit(-1);
        }

// Kommentar: Hier die einzige Abweichung zur Funktion randpunkte_einfuegen: Falls die farbe < 0 ist, wird zwar an den
// Innen - und Auenrandpunktlisten nichts gemacht - wie oben. Aber der Punkt (i,j) ist ein echter Randpunkt und wird daher
// in die Struktur 'lastwerte_korrektur_punkte' eingefgt.
    if(farbe < 0)
        {
        lastwerte_korrektur_punkte.setzen(i,j); // (i,j) sind die Punkte auf dem Innenrand, (kk,ll) die Punkte mit farbe < 0
        return;
        }
    if(farbe == rang)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "Fehler wegen farbe == rang " << endl;

        cout << "re i: " << i << " j: " << j << " rang " << rang << " ebene " << gitterebene << " kk " << kk << " ll " << ll << " snb " << selbstnachbarn[i][j] << " 255-snb " << 255-selbstnachbarn[i][j] << endl;
#endif
        return;
        }

#ifdef AUSGABEN_RANDSTRUKTUR
    if((kk==1)&&(ll==6)&&(rang==1)&&(gitterebene==1))
        {
        cout << " 1611 farbe " << farbe << " testfeld " << testfeld[farbe][kk][ll] << " i " << i << " j " << j;
        cout << " dynamischer_rand(i,j).feld " << dynamischer_rand.feld[i][j] << endl;
        }
#endif

    if(testfeld[farbe][kk][ll]==false)
        {
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "kk "  << kk << " ll " << ll << endl;
#endif
        testfeld[farbe][kk][ll] = true;
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "Durch Testfeld - Abfrage durch " << endl;
#endif
        anzahl_rs_farbe = anzahl_a_rs[farbe];
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << "Durch Anzahl_a_rs durch " << endl;
#endif
        f_a_rs[farbe][anzahl_rs_farbe] = kk;
        g_a_rs[farbe][anzahl_rs_farbe] = ll;
        anzahl_rs_farbe ++;
        anzahl_a_rs[farbe]=anzahl_rs_farbe;
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_RANDSTRUKTUR
        cout << " farbe " << farbe << " anzahl_a_rs[farbe] " << anzahl_a_rs[farbe] << endl;
#endif
        if((rang==1)&&(gitterebene==0)&&(farbe==0))
            {
            cout << " randstruktur kk " << kk << " ll " << ll << endl;
            }
#endif
        }

    if(i<0)
        {
        return;
        }

    if(j<0)
        {
        return;
        }
    if(i>=n)
        {
        return;
        }
    if(j>=m)
        {
        return;
        }

    if(testfeld[farbe][i][j]==true)
        {
        return;
        }

#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " i " << i << " j " << j;
#endif

    testfeld[farbe][i][j] = true;
    anzahl_rs_farbe = anzahl_rs[farbe];
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " anzahl " << anzahl_rs_farbe << endl;
#endif
    f_rs[farbe][anzahl_rs_farbe] = i;
    g_rs[farbe][anzahl_rs_farbe] = j;
    anzahl_rs_farbe ++;
    anzahl_rs[farbe]=anzahl_rs_farbe;
    }

// Kommentar: Diese Funktion prft, ob zur Farbe farbe ein Eintrag in der Auenrandpunktliste da ist.
// Das ist aber eigentlich genau dann der Fall, wenn auch ein Eintrag in der Innenrandpunktliste vorhanden ist.
bool RandStruktur::ist_nachbar_randwerte(int farbe)
    {
    if(anzahl_a_rs[farbe]>0)
        {
        return(true);
        }
    return(false);
    }

// Kommentar: Hier werden die Innen und Auenrandpunktmengen sortiert.
void RandStruktur::sortieren(void)
    {
    for(i=0; i<groesse; i++)
        {
// Kommentar: Fr die ID's aller anderen Kerne ...
        if(rang!=i)
            {
// Kommentar: Bei mehr als einem Innenrand - Gitterpunkt wird der Innenrand zu dem Kern der ID sortiert.
            anzahl_rs_farbe = anzahl_rs[i];
            if(anzahl_rs_farbe>=2)
                {
                koordinaten_sortierung.tun(f_rs[i], g_rs[i], anzahl_rs_farbe);
                }
// Kommentar: Bei mehr als einem Auenrand - Gitterpunkt wird der Auenrand zu dem Kern der ID sortiert.
            anzahl_rs_farbe = anzahl_a_rs[i];
            if(anzahl_rs_farbe>=2)
                {
                koordinaten_sortierung.tun(f_a_rs[i], g_a_rs[i], anzahl_rs_farbe);
                }

            }
        }
    }

// Kommentar: Die Lngen der Innenrandpunktmengen und Auenrandpunktmengen werden zur Klasse RandWerteKommunikation kopiert.
void RandStruktur::setze_anzahlen(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(rang!=i)
            {
            rand_werte_kommunikation[i].setze_anzahlen(anzahl_rs[i], anzahl_a_rs[i]);
            }
        }
    }

// Kommentar: Die Version der Randpunktbestimmung mit Hilfe von Sortierung wird berprft.
bool RandStruktur::sortieren_testen(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Sortieren testen senden . Rang " << rang << " ebene " << gitterebene << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Die Innenrandpunktmengen zum Kern i werden gepackt und an Kern i verschickt, und im Gegenzug von Kern i empfangen.
            sortieren_testen_einen_senden(i);
            }
        }
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Sortieren testen warten rang " << rang << endl;
#endif

// Kommentar: Die Kommunikation wird abgewartet.
    for(;ist_fertig_sortieren()==false;)
        {
        ;
        }
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " Sortieren testen empfangen rang " << rang << endl;
#endif
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Das Empfangene wird mit dem Sortierten Punkt fr Punkt verglichen. Bei einer Abweichung wird false zurckgegeben.
            if(sortieren_testen_einen_empfangen(i)==false)
                {
                return(false);
                }
            }
        }

#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Sortieren testen fertig rang " << rang << " ebene " << gitterebene << endl;
#endif

// Kommentar: Ohne eine Abweichung ist alles gut gegangen, und true wird zurckgegeben.
    return(true);
    }

// Kommentar: Zu allen anderen Kernen wird der Auenrand ausgegeben.
void RandStruktur::ausgabe_a_rs(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Gebe den Auenrand zu Kern i aus.
            ausgabe_a_rs_nr(i);
            }
        }
#endif
    }

// Kommentar: Man verschickt die Innenrandpunktmenge zur ID nr an den Kern nr.
void RandStruktur::sortieren_testen_einen_senden(int nr)
    {
    k=0;
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " nr " << nr << " rang " << rang << endl;
#endif
// Kommentar: Das ist die Lnge des Innenrandes.
    anzahl_rs_farbe = anzahl_rs[nr];
    if((rang==1)&&(t==2)&&(gitterebene==0)&&(nr==3))
        {
        cout << " P1: Anzahl gemeinsame Gitterpunkte von P1 und P3 " << anzahl_rs_farbe << endl;
        }
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " anzahl " << anzahl_rs_farbe << endl;
#endif
    vergleichs_buffer[nr][k++] = anzahl_rs_farbe;
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " groesse " << groesse << " rang " << rang << " farbe " << nr << " laenge " << vergleichs_buffer[nr][0] << " mn2+1 " << mn2_plus1 << endl;
    cout << " groesse " << groesse << " rang " << rang << " farbe " << nr << " laenge " << vergleichs_buffer[nr][0] << " mn " << mn << " mn2+1 " << mn2_plus1 << endl;
#endif

// Kommentar: Alle Innenrandpunkte werden in den Vergleichsbuffer kopiert.
    for(l=0; l<anzahl_rs_farbe; l++)
        {
        vergleichs_buffer[nr][k++] = f_rs[nr][l];
        vergleichs_buffer[nr][k++] = g_rs[nr][l];
        }
#ifdef AUSGABEN_RANDSTRUKTUR
#ifdef DA_RANDSTRUKTUR
    * da_randstruktur.aus << endl;
    * da_randstruktur.aus << " Code 15: rang " << rang << " nr " << nr << endl;
    * da_randstruktur.aus << " Lnge " << anzahl_rs_farbe;
    for(l=0; l<anzahl_rs_farbe; l++)
        {
        * da_randstruktur.aus << " f " << f_rs[nr][l] << " g " << g_rs[nr][l];
        }
    * da_randstruktur.aus << endl;
    * da_randstruktur.aus << endl;
#endif
#endif
#ifdef AUSGABEN_RANDSTRUKTUR
    for(l=0; l<anzahl_rs_farbe; l++)
        {
        cout << vergleichs_buffer[nr][l] << " ";
        }
    cout << endl;
#endif
    for(l=0; l<mn2_plus1; l++)
        {
        vergleichs_buffer_ankommen[nr][l] = l;
        }
    cout << " RandStruktur sortieren testen Kommunikation k " << k << " mn " << mn << " rang " << rang << endl;
// Kommentar: Der Vergleichsbuffer wird verschickt.
    MPI_Isend(vergleichs_buffer[nr], k, MPI_SHORT, nr, 300, MPI_COMM_WORLD, & sende_requests[nr]);
// Kommentar: Und der Vergleichsbuffer von Kern nr wird empfangen, und in den Buffer vergleichs_buffer_ankommen geschrieben.
    MPI_Irecv(vergleichs_buffer_ankommen[nr], mn2_plus1, MPI_SHORT, nr, 300, MPI_COMM_WORLD, & empfange_requests[nr]);
    }

// Kommentar: Hier wird geprft, ob alle Sende - und Empfangsoperationen bzgl. der Funktion 'sortieren_testen_einen_senden'
// abgeschlossen sind, und mit dem Entpacken losgelegt werden kann.
bool RandStruktur::ist_fertig_sortieren(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            MPI_Test(& (sende_requests[i]), &flag, & status);
            if(flag==false)
                {
                return(false);
                }
            MPI_Test(& (empfange_requests[i]), & flag, & status);
            if(flag==false)
                {
                return(false);
                }
            }
        }
    return(true);
    }

// Kommentar: In diesem Fall ist die Sortierungstest - Kommunikation abgeschlossen, und man vergleicht
// den empfangenen Buffer mit dem Auenrandbuffer.
bool RandStruktur::sortieren_testen_einen_empfangen(int nr)
    {
    k=0;
// Zuerst wird die Lnge des Auenrandes mit der des Buffers verglichen. Bei Abweichung lge schon hier ein Fehler vor.
    anzahl_rs_farbe = anzahl_a_rs[nr];
    if(anzahl_rs_farbe == 0)
        {
        return(true); //Stimmt das?
        }
    if(vergleichs_buffer_ankommen[nr][k++] != anzahl_rs_farbe)
        {
// Kommentar: Zur Fehlermeldung gehren diverse Informationen, die dann ausgegeben werden.
        cout << " Fehler in RandStruktur sortieren: Laengen stimmen nicht; nr = " << nr << " rang " << rang << " gitterebene " << gitterebene << endl;
        cout << " vgl buffer " << vergleichs_buffer_ankommen[nr][0] << " anzahl_farbe " << anzahl_rs_farbe << " "; // << endl;

        for(i=0; i<2*vergleichs_buffer_ankommen[nr][0]; i++)
            {
            cout << vergleichs_buffer_ankommen[nr][i] << " ";
            }
        cout << " // ";
        for(i=0; i<anzahl_rs_farbe; i++)
            {
            cout << " f " << f_a_rs[nr][i] << " g " << g_a_rs[nr][i] << " fgff " << farbenfeld[f_a_rs[nr][i]][g_a_rs[nr][i]];
            }
        cout << endl;
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " Fehler in RandStruktur sortieren: Laengen stimmen nicht; nr = " << nr << " rang " << rang << " gitterebene " << gitterebene << endl;
        * da_randstruktur.aus << " vgl buffer " << vergleichs_buffer_ankommen[nr][0] << " anzahl_farbe " << anzahl_rs_farbe << " "; // << endl;

        for(i=0; i<2*vergleichs_buffer_ankommen[nr][0]; i++)
            {
            * da_randstruktur.aus << vergleichs_buffer_ankommen[nr][i] << " ";
            }
        * da_randstruktur.aus << " // ";
        for(i=0; i<anzahl_rs_farbe; i++)
            {
            * da_randstruktur.aus << " f " << f_a_rs[nr][i] << " g " << g_a_rs[nr][i] << " fgff " << farbenfeld[f_a_rs[nr][i]][g_a_rs[nr][i]];
            }
        * da_randstruktur.aus << endl;
        * da_randstruktur.aus << endl;
        for(i=0; i<n; i++)
            {
            for(j=0; j<m; j++)
                {
                * da_randstruktur.aus << farbenfeld[i][j] << " ";
                }
            * da_randstruktur.aus << endl;
            }
        * da_randstruktur.aus << endl;
#endif
        return(false);
        exit(-1);
        }

// Kommentar: Nun wird der Empfangsbuffer mit der Auenrandpunktmenge verglichen.
    for(l=0; l<anzahl_rs_farbe; l++)
        {
// Kommentar: Zuerst wird die f - Koordinate verglichen. Bei Abweichung wird eine Fehlermeldung ausgegeben.
        if(vergleichs_buffer_ankommen[nr][k++] != f_a_rs[nr][l])
            {
            cout << "Fehler in RandStruktur sortieren empfangen; f; l = " << l << " anzahl = " << anzahl_rs_farbe << " rang " << rang << " nr " << nr << endl;
            cout << " vgl buffer " << vergleichs_buffer_ankommen[nr][k-1] << " f " << f_a_rs[nr][l] << endl;
            cout << " vgl buffer " << vergleichs_buffer_ankommen[nr][k] << " g " << g_a_rs[nr][l] << endl;

            for(l=0, k=1; l<anzahl_rs_farbe; l++)
                {
                cout << " l " << l << " f_strukt " << f_a_rs[nr][l] << " g_strukt " << g_a_rs[nr][l] << " f_buf ";
                cout <<  vergleichs_buffer_ankommen[nr][k++] << " g_buf " ;
                cout << vergleichs_buffer_ankommen[nr][k++] << " rang " << rang << endl;
                }
            return(false);
            exit(-1);
            }
// Kommentar: Danach wird die g - Koordinate verglichen. Bei Abweichung wird eine Fehlermeldung ausgegeben.
        if(vergleichs_buffer_ankommen[nr][k++] != g_a_rs[nr][l])
            {
            cout << "Fehler in RandStruktur sortieren empfangen; g " << endl;
            return(false);
            exit(-1);
            }
        }
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Erfolgreich RandStruktur sortiert. nr " << nr << endl;
#endif
// Kommentar: Sind keine Fehler aufgetreten, wird return zurckgegeben.
    return(true);
    }

// Kommentar: Hier wird der Auenrand zum Kern mit der ID nr ausgegeben.
void RandStruktur::ausgabe_a_rs_nr(int nr)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "ausgabe_a_rs / rang " << rang << " nr " << nr;
    for(l=0; l<anzahl_a_rs[nr]; l++)
        {
        cout << " f " << f_a_rs[nr][l] << " g " << g_a_rs[nr][l];
        }
    cout << endl;
#endif
    }

// Kommentar: Wieder eine Rang - abhngige - Wartefunktion zur Strukturierung der Ausgabe - frs Debugging.
void RandStruktur::verzoegern2(void)
    {
#ifdef AUSGABEN
    #ifdef WARTEN
    int i;

    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
    cout << "------------------------------------------------------ Rang " << rang << endl;
    #endif
#endif
    }

// Kommentar: Finalisiere die Randstrukturen fr die 'kleine Kommunikation', d.h. ein eingeschrnkter Randaustausch nur ber
// existierenden Feingitterpunkten.
void RandStruktur::finalisieren_rs(void)
    {
#ifdef AUSGABEN_ENDE
    cout << " Ende 3f1 rang " << rang << endl;
#endif

// Kommentar: Die testflags ermglichen die Prfung, ob eine Kommunikation erfolgt ist. Hier wird fr sie Speicherplatz
// angelegt.
    delete testflags;

#ifdef AUSGABEN_ENDE
    cout << " Ende 3f2 rang " << rang << endl;
#endif

// Kommentar: Die Signatur gibt an, ob sich unter einem Gitterpunkt ein Gitterpunkt befindet. Whrend die
// Innen - Signatur direkt vom Gitter abgelesen wird, wird die Auensignatur aufgrund der bei der
// Kommunikation bertragenen Bits gesetzt. Beide Strukturen werden hier befreit.

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete signatur_innen[i];
            delete signatur_aussen[i];
            }
        }
    delete signatur_innen;
    delete signatur_aussen;
#ifdef AUSGABEN_ENDE
    cout << " Ende 3f3 rang " << rang << endl;
#endif

// Kommentar: Hier werden die Innen - und Auenrandpunktmengen der Punkte gespeichert, wo feine
// Gitterpunkte darunter existieren - fr einen schnelleren Randaustausch, da ein kleinerer Buffer zu
// verschicken ist. Diese Strukturen werden hier befreit.

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete f_aussen_klein[i];
            delete g_aussen_klein[i];
            }
        }
    delete f_aussen_klein;
    delete g_aussen_klein;

#ifdef AUSGABEN_ENDE
    cout << " Ende 3f4 rang " << rang << endl;
#endif

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete f_innen_klein[i];
            delete g_innen_klein[i];
            }
        }
    delete f_innen_klein;
    delete g_innen_klein;
#ifdef AUSGABEN_ENDE
    cout << " Ende 3f5 rang " << rang << endl;
#endif
    }

// Kommentar: Eine Initialisierung der Strukturen fr den 'kleinen Randaustausch'.

void RandStruktur::initialisieren_rs(void)
// wird befreit
    {
    mn = m*n;
    mn2_plus1 = mn*2 + 1;

// Kommentar: Hier werden die Innen - und Auenrandpunktmengen der Punkte gespeichert, wo feine
// Gitterpunkte darunter existieren - fr einen schnelleren Randaustausch, da ein kleinerer Buffer zu
// verschicken ist.

    f_innen_klein = new short int * [groesse];
    g_innen_klein = new short int * [groesse];

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            f_innen_klein[i] = new short int [mn];
            g_innen_klein[i] = new short int [mn];
            }
        }

    f_aussen_klein = new short int * [groesse];
    g_aussen_klein = new short int * [groesse];

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            f_aussen_klein[i] = new short int [mn];
            g_aussen_klein[i] = new short int [mn];
            }
        }

// Kommentar: Die Signatur gibt an, ob sich unter einem Gitterpunkt ein Gitterpunkt befindet. Whrend die
// Innen - Signatur direkt vom Gitter abgelesen wird, wird die Auensignatur aufgrund der bei der
// Kommunikation bertragenen Bits gesetzt.

    signatur_innen = new bool * [groesse];
    signatur_aussen = new bool * [groesse];

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            signatur_innen[i] = new bool [mn];
            signatur_aussen[i] = new bool [mn];
            }
        }

// Kommentar: Hier werden die kleinen Randstrukturpunktmengen entweder in die Klasse RandStrukturKommunikation oder in die Klasse
// RandWerteKommunikation kopiert - zusammen mit Buffer, der Signaturen und maximaler Bufferlnge sowie dem eigenen Rang.
// In welche der beiden Strukturen es kopiert wird hngt von der Variablen vektorisieren0 ab. 'kRSK' steht fr kleine
// RandStrukturKommunikation'. Diese Klasse ist Vaterklasse sowohl fr die RandStrukturKommunikation als auch die
// RandWerteKommunikation.
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                randstruktur_kommunikation[i].initialisieren_kRSK(f_innen_klein[i], g_innen_klein[i], f_aussen_klein[i], g_aussen_klein[i], randstruktur_kommunikation[i].sende_werte_buffer, randstruktur_kommunikation[i].empfange_werte_buffer, i, signatur_innen[i], signatur_aussen[i], mn, rang);
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                rand_werte_kommunikation[i].initialisieren_kRSK(f_innen_klein[i], g_innen_klein[i], f_aussen_klein[i], g_aussen_klein[i], rand_werte_kommunikation[i].sende_werte_buffe, rand_werte_kommunikation[i].empfange_werte_buffe, i, signatur_innen[i], signatur_aussen[i], mn, rang);
                }
            }
        }

// Kommentar: Die testflags ermglichen die Prfung, ob eine Kommunikation erfolgt ist. Hier wird fr sie Speicherplatz
// angelegt.
    testflags = new int [groesse];
    }

// Kommentar: Hier wird die Vaterklasse KleineRandStrukturTest zu den Klassen RandStrukturKommunikation und
// RandWerteKommunikation initialisiert. Je nach Wert der Variablen vektorisieren0 wird sie von einer
// der Tochterklassen aus aufgerufen.bergeben wird ep_aktuell, EP-SNB, das Farbenfeld, die eigene Gitterebene sowie
// die Feldliste des Gitters darunter - um die Signaturen bestimmen zu knnen.
void RandStruktur::initialisieren_fuer_kRST(short int ** _EP_aktuell, short int ** _EP_SNB, short int ** _farbenfeld, int _ebene, int ** _feld)
    {
    feld_darunter = _feld;
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                randstruktur_kommunikation[i].initialisieren_kRST(_EP_aktuell, _EP_SNB, _farbenfeld, _ebene, _feld);
                // Keine Allokation
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                rand_werte_kommunikation[i].initialisieren_kRST(_EP_aktuell, _EP_SNB, _farbenfeld, _ebene, _feld);
                // Keine Allokation
                }
            }
        }
    }

// Kommentar: Hier geschieht der Randaustausch ber einem Verfeinerungsbereich fr die Variable der Nummer 1.
void RandStruktur::kleiner_randaustausch1(void)
    {
// Zuerst der Fall mit vektorisieren0 = JA, d.h. es wird die Struktur RandStrukturKommunikation verwendet.
    if(vektorisieren0==JA)
        {
// Kommentar: Man durchlaufe die ID's aller anderen Kerne.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
// Kommentar: Wenn berhaupt ein Auenrand zum Kern i existiert ...
                if(anzahl_rs[i]!=0)
//                if(randstruktur_kommunikation[i].anzahl_innen_klein!=0) // anzahl_innen_klein dient doch nicht den Vektoren. Hm.
                    {
// Kommentar: ... dann initiiere den Randaustausch fr die Variable der Nummer 1, und setze dieses Testflag auf false.
                    randstruktur_kommunikation[i].randaustausch1_initiieren();
                    testflags[i] = false;
                    }
                }
            }
// Kommentar: testen() prft, ob mindestens eines der auf false gesetzten Testflags noch false ist.
// Solange ist die Kommunikation noch nicht beendet.
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
// Kommentar: Dann behandele wieder alle Kerne mit einem vorhandenen Innenrand.
                    if(anzahl_rs[i]!=0)
//                    if(randstruktur_kommunikation[i].anzahl_innen_klein!=0)
                        {
// Kommentar: Und fr ein i mit testflags(i) = false
                        if(testflags[i] == false)
                            {
// Kommentar: Solange die Kommunikation zu diesem Kern nicht abgeschlossen ist, mache nichts, und das Testflag bleibt false.
// Ansonsten entpacke den Empfangsbuffer bzgl. der kleinen Auenrandpunktmenge bzgl der Variable 1. Dann setze das Testflag auf true.
                            testflags[i] = randstruktur_kommunikation[i].randaustausch1_testen();
                            }
                        }
                    }
                }
            }
        }
// Danach der Fall mit vektorisieren0 = NEIN, d.h. es wird die Struktur RandWerteKommunikation verwendet.
    else
        {
// Kommentar: Man durchlaufe die ID's aller anderen Kerne.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
// Kommentar: Es muss hier anzahl_rs(i) abgefragt werden - ob die Randlisten einen Eintrag haben. Man kann die
// Abfrage if(rand_werte_kommunikation[i].anzahl_innen_klein!=0) nicht bringen, weil sie im Gegensatz zu anzahl_rs(i)
// assymetrisch sein kann. Sie kann auf einem Kern erfllt sein, und auf einem Nachbarkern nicht, weil
// nur auf einer Seite des Randes Verfeinerungen vorliegen.
                if(anzahl_rs[i]!=0)
// anzahl_innen_klein stammt hier nicht von der Klasse Gitter, sondern von der Klasse RandWerteKommunikation.
// Sie wird schon vor der Bit - bertragung gebildet, und kann, da die Innenrandpunktmengen den Auenrandpunktmengen
// auch bei der kleinen Kommunikation entsprechen, direkt abgelesen werden - nachdem die Signatur bestimmt worden ist.
// Dann steht dieser Wert, in Bezug auf den jeweiligen Kern i, zur Verfgung.
                    {
// Kommentar: Fr diesen Kern wird die RandWerteFunktion randaustausch1_initiieren aufgerufen. Dabei werden die
// Variablenwerte der Variablen 1 gepackt, und die Nachricht abgeschickt, bzw. bei diesem Kern empfangen.
                    rand_werte_kommunikation[i].randaustausch1_initiieren();
// Kommentar: Nach dem Abschicken sind die Nachrichten noch nicht da, und die Testflags mssen auf false gesetzt werden.
                    testflags[i] = false;
                    }
                }
            }
// Kommentar: testen() prft, ob mindestens eines der auf false gesetzten Testflags noch false ist.
// Solange ist die Kommunikation noch nicht beendet.
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
// Kommentar: Siehe in dieser Funktion oben den Kommentar zu anzahl_rs(i)!=0. anzahl_rs gibt an, ob es eine
// Punktnachbarschaft gibt. Ob es eine kleine Punktnachbarschaft gibt kann man nicht ermitteln.
                    if(anzahl_rs[i]!=0)

// Kommentar: Dann behandele wieder alle Kerne mit einem vorhandenen kleinen Innenrand.
                        {
// Kommentar: Und fr ein i mit testflags(i) = false
                        if(testflags[i] == false)
                            {
// Kommentar: Solange die Kommunikation zu diesem Kern nicht abgeschlossen ist, mache nichts, und das Testflag bleibt false.
// Ansonsten entpacke den Empfangsbuffer bzgl. der kleinen Auenrandpunktmenge bzgl der Variable 1. Dann setze das Testflag auf true.
                            testflags[i] = rand_werte_kommunikation[i].randaustausch1_testen();
                            }
                        }
                    }
                }
            }
        }
    }

// Kommentar: In der Funktion 'kleiner_randaustausch1' wird die ganze Kommunikation in einem durchgefhrt. Der Computer kann dann
// aber zwischen der Initiierung und dem Entpacken nicht arbeiten. Zu diesem Zweck wurde diese Funktion gesplittet.
// Hier der erste Teil von 'kleiner_randaustausch1'. Die Kommentare knnen direkt von dieser Funktion abgelesen werden.
void RandStruktur::kleiner_randaustausch1_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch1_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch1_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Hier der zweite - abschlieende Teil von 'kleiner_randaustausch1'. Damit wird der 'kleine Randaustausch'
// abgeschlossen. Die Kommentare dazu kann man in 'kleiner_randaustausch1' nachlesen.
bool RandStruktur::kleiner_randaustausch1_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch1_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = rand_werte_kommunikation[i].randaustausch1_testen();

                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 2 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch2_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch2_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch2_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 2 - statt der Variablen 1 -
// der Randaustausch geschieht.
bool RandStruktur::kleiner_randaustausch2_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch2_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = rand_werte_kommunikation[i].randaustausch2_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Es wird geprft, ob alles entpacken worden ist. Falls ja, wird true zurckgegeben, ansonsten false.
bool RandStruktur::testen(void)
    {
// Kommentar: Eigentlich wird diese if - Abfrage nicht gebraucht, weil in beiden Fllen dasselbe geschieht.
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
// Kommentar: Alle anderen Kerne mit Punktnachbarschaft werden auf ihr testflag hin berprft. Ist nur eines false,
// so wird 'false' zurckgegeben.
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        return(false);
                        }
                    }
                }
            }
// Kommentar: Sind alle betrachteten Flags true, dann wird true zurckgegeben.
        return(true);
        }
// Kommentar: Da dieselben Befehle erfolgen, ist auch der gleiche Kommentar anzunehmen.
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        return(false);
                        }
                    }
                }
            }
        return(true);
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1, nur dass bzgl. der Variablen 2 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch2(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch2_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = randstruktur_kommunikation[i].randaustausch2_testen();
                            }
                        }
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch2_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = rand_werte_kommunikation[i].randaustausch2_testen();
                            }
                        }
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1, nur dass bzgl. der Variablen 3 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch3(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch3_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = randstruktur_kommunikation[i].randaustausch3_testen();
                            }
                        }
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch3_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = rand_werte_kommunikation[i].randaustausch3_testen();
                            }
                        }
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1, nur dass bzgl. der Variablen 4 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch4(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch4_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = randstruktur_kommunikation[i].randaustausch4_testen();
                            }
                        }
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch4_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = rand_werte_kommunikation[i].randaustausch4_testen();
                            }
                        }
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1, nur dass bzgl. der Variablen 5 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch5(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch5_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = randstruktur_kommunikation[i].randaustausch5_testen();
                            }
                        }
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch5_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        for(;testen()==false;)
            {
            for(i=0; i<groesse; i++)
                {
                if(i!=rang)
                    {
                    if(anzahl_rs[i]!=0)
                        {
                        if(testflags[i] == false)
                            {
                            testflags[i] = rand_werte_kommunikation[i].randaustausch5_testen();
                            }
                        }
                    }
                }
            }
        }
    }

// Kommentar: Mit dieser Funktion wird die kleine Randstruktur gebildet.
void RandStruktur::bilde_kleine_randstruktur(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << " bilde_kleine_randstruktur / rang " << rang << endl;
#endif
// Kommentar: Im Falle der 'Vektorisierung' wird zu allen Kernen mit Punktnachbarschaften in der Klasse
// RandStrukturKommunikation die kleinen Innnenpunktmengen (f_innen_klein, g_innen_klein) sowie die Signatur innen bestimmt.
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
// Kommentar: Aufruf der Funktion zur Bildung der kleinen Innenrnder sowie der Innen - Signatur.
                    randstruktur_kommunikation[i].bilde_kleine_randstruktur_innen();
                    }
                }
            }
        }
// Kommentar: Im Falle der 'Sortierung' wird zu allen Kernen mit Punktnachbarschaften in der Klasse
// RandWerteKommunikation die kleinen Innnenpunktmengen (f_innen_klein, g_innen_klein) sowie die Signatur innen bestimmt.
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
// Kommentar: Aufruf der Funktion zur Bildung der kleinen Innenrnder sowie der Innen - Signatur.
                    rand_werte_kommunikation[i].bilde_kleine_randstruktur_innen();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden die 7 Variablen gesetzt, fr alle anderen Kerne, entweder in der RandStrukturKommunikation
// oder in der RandWerteKommunikation.
void RandStruktur::setze_variablen(double ** _variable1, double ** _variable2, double ** _variable3, double ** _variable4, double ** _variable5, double ** _variable6, double ** _variable7)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                randstruktur_kommunikation[i].variable1 = _variable1;
                randstruktur_kommunikation[i].variable2 = _variable2;
                randstruktur_kommunikation[i].variable3 = _variable3;
                randstruktur_kommunikation[i].variable4 = _variable4;
                randstruktur_kommunikation[i].variable5 = _variable5;
                randstruktur_kommunikation[i].variable6 = _variable6;
                randstruktur_kommunikation[i].variable7 = _variable7;
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
#ifdef AUSGABEN_RANDSTRUKTUR
                cout << "Setze Variablen i " << i << " rang " << rang << endl;
#endif
                rand_werte_kommunikation[i].variable1 = _variable1;
                rand_werte_kommunikation[i].variable2 = _variable2;
                rand_werte_kommunikation[i].variable3 = _variable3;
                rand_werte_kommunikation[i].variable4 = _variable4;
                rand_werte_kommunikation[i].variable5 = _variable5;
                rand_werte_kommunikation[i].variable6 = _variable6;
                rand_werte_kommunikation[i].variable7 = _variable7;
                }
            }
        }
    }

// Kommentar: Hier werden die 7 MLAT - Variablen mit der eben erluterten Funktion nach der Klasse RandStrukturKommunikation
// bzw. der Klasse RandWerteKommunikation gebracht.
void RandStruktur::setze_MLAT_variablen(void)
    {
    setze_variablen(u0, r0, Iu0, rS0, e0, Lu0, ILu0);
    }

// Kommentar: Wenn die Werte der jeweiligen Variablen eingetragen wurden, wird hiermit die Wertekommunikation
// initiiert. Im Falle des Konzeptes des 'Vektorisierens' lautet die Funktion dazu randwerte_kommunikation_starten,
// im Falle des Konzeptes der 'Sortierung' lautet sie randwerte_kommunikation_starten_2.
void RandStruktur::randwerte_kommunikation_starten_fu(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Randwerte_kommunikation_starten_fu rang " << rang << endl;
#endif
    if(vektorisieren0 == JA)
        {
        randwerte_kommunikation_starten();
        }
    else
        {
        randwerte_kommunikation_starten_2();
        }
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Randwerte_kommunikation_starten_fu rang " << rang << " ENDE " << endl;
#endif
    }

// Kommentar: Hier wird geprft, ob die Randwerte - Kommunikation abgeschlossen ist. Im Falle vektorisieren0 = JA
// wird die Funktion ist_fertig aufgerufen, um das zu prfen, und andernfalls wird ist_fertig_2 aufgerufen, um
// beim Konzept 'Sortierung' auf das Ende der Kommunikation zu prfen.
bool RandStruktur::ist_fertig_fu(void)
    {
    if(vektorisieren0 == JA)
        {
        return(ist_fertig());
        }
    else
        {
        return(ist_fertig_2());
        }
    }

// Kommentar: Hier werden die Werte der Variablen u0 gepackt. Man hat dafr die Funktionen packen_werte_u0 in den
// Klassen RandStrukturKommunikation (RSK) und RandWerteKommunikation (RWK), die je nach Wert von vektorisieren_u0 aufgerufen werden.
// Das wird fr alle punktbenachbarten Kerne durchgefhrt. Die Punkte, fr die gepackt wird, entsprechend dem
// Rand (Kern ID), entweder die der RSK oder der RWK.
void RandStruktur::packen_randwerte_u0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_u0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur das nicht alle Randpunkte gepackt werden, sondern nur die Red - Randpunkte -
// das sind die Punkte mit gerader Koordinatensumme.
void RandStruktur::packen_randwerte_u0_red(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_u0_red();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_u0_red();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur das nicht alle Randpunkte gepackt werden, sondern nur die Black - Randpunkte -
// das sind die Punkte mit ungerader Koordinatensumme.
void RandStruktur::packen_randwerte_u0_black(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_u0_black();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_u0_black();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden fr alle Punkte (f,g) der Randpunktmengen - entweder der RSK oder der RWK - wenn grobe Gitterpunkte
// darber existieren, die Grobgitterwerte an der Stelle (f/2,g/2) gepackt. Der Funktionsname dafr lautet
// in beiden Strukturen packen_werte_gg_u0. Die Zeiger auf die Grobgitterwerte sind in den Klassen RSK und RWK angelegt.
void RandStruktur::packen_randwerte_gg_u0(void)
    {
    if(vektorisieren0 == JA)
        {
// Fr alle punktbenachbarten Kerne wird packen_werte_gg_u0 in der RSK(i) aufgerufen.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_gg_u0();
                    }
                }
            }
        }
    else
        {
// Fr alle punktbenachbarten Kerne wird packen_werte_gg_u0 in der RWK(i) aufgerufen.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_gg_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_u0, nur fr die Variable e0, statt der Variablen u0.
void RandStruktur::packen_randwerte_gg_e0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_gg_e0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_gg_e0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_u0, nur fr die SWE Variable v9, statt der Variablen u0.
void RandStruktur::packen_randwerte_gg_v9(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_gg_v9();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_gg_v9();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur das statt der u0 - Werte der Randpunkte (f,g) die u0 - Werte an der Stelle (2f,2g)
// des feinen Gitters darunter gepackt - und spter entpackt - werden. Dafr sind in den Klassen RSK bzw. RWK
// die Zeiger auf u0 des feineren Gitters angelegt.
void RandStruktur::packen_randwerte_fg_u0(void)
    {
    if(vektorisieren0 == JA)
        {
// Fr alle punktbenachbarten Kerne wird packen_werte_fg_u0 in der RSK(i) aufgerufen.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_fg_u0();
                    }
                }
            }
        }
    else
        {
// Fr alle punktbenachbarten Kerne wird packen_werte_fg_u0 in der RWK(i) aufgerufen.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_fg_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie entpacken_randwerte_u0, nur das statt der u0 - Werte der Randpunkte (f,g) die u0 - Werte an der Stelle (2f,2g)
// des feinen Gitters darunter entpackt werden. Dafr sind in den Klassen RSK bzw. RWK die Zeiger auf u0 des feineren Gitters angelegt.
void RandStruktur::entpacken_randwerte_fg_u0(void)
    {
    if(vektorisieren0 == JA)
        {
// Fr alle punktbenachbarten Kerne wird entpacken_werte_fg_u0 in der RSK(i) aufgerufen.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_fg_u0();
                    }
                }
            }
        }
    else
        {
// Fr alle punktbenachbarten Kerne wird entpacken_werte_fg_u0 in der RWK(i) aufgerufen.
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_fg_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_u0, nur dass hier die Grobgitterwerte zu e0 und u0 an der Stelle (../2,../2) gepackt werden,
// statt nur die Grobgitter - Variable u0 an dieser Stelle zu packen. Dabei sind in RSK bzw. RWK die Zeiger auf die Variablen
// e0 und u0 des groben Gitters angelegt.
void RandStruktur::packen_randwerte_gg_e0_und_u0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
// Kommentar: Hier werden fr die (f,g) Punkte mit geraden Koordinaten die Werte von e0 und u0 an der Stelle (f/2,g/2)
// auf dem groben Gitter gepackt.
                    randstruktur_kommunikation[i].packen_werte_gg_e0_und_u0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
// Kommentar: Hier werden fr die (f,g) Punkte mit geraden Koordinaten die Werte von e0 und u0 an der Stelle (f/2,g/2)
// auf dem groben Gitter gepackt.
                    rand_werte_kommunikation[i].packen_werte_gg_e0_und_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt der Werte der Variablen u0 die Werte der Variablen u0_hilf gepackt werden.
void RandStruktur::packen_randwerte_u0_hilf(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_u0_hilf();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_u0_hilf();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_u0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_u0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0_red, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_u0_red(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_u0_red();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_u0_red();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0_black, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_u0_black(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_u0_black();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_u0_black();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_u0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_gg_u0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_gg_u0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_gg_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_e0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_gg_e0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_gg_e0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_gg_e0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_v9, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_gg_v9(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_gg_v9();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_gg_v9();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_gg_e0_und_u0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_gg_e0_und_u0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_gg_e0_und_u0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_gg_e0_und_u0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen Lu0 gepackt werden.
void RandStruktur::packen_randwerte_Lu0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_Lu0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_Lu0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_Lu0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_Lu0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_Lu0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_Lu0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen r0 gepackt werden.
void RandStruktur::packen_randwerte_r0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_r0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_r0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_r0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_r0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_r0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_r0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen f0 gepackt werden.
void RandStruktur::packen_randwerte_f0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_f0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_f0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_f0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_f0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_f0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_f0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen Iu0 gepackt werden.
void RandStruktur::packen_randwerte_Iu0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_Iu0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_Iu0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_Iu0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_Iu0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_Iu0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_Iu0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen Iu0 und r0 gepackt werden.
// Dabei werden die Werte von Iu0 und r0 hintereinander in die Buffer geschrieben.
void RandStruktur::packen_randwerte_Iu0r0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_Iu0r0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_Iu0r0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_Iu0r0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_Iu0r0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_Iu0r0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_Iu0r0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_Iu0r0, nur dass statt den Werten der Variablen Iu0 und r0
// die Werte der Variablen u0 und r0 gepackt werden.
void RandStruktur::packen_randwerte_u0r0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_u0r0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if((rang==0)&&(gitterebene==0)&&(i==1))
                        {
                        rand_werte_kommunikation[i].packen_werte_u0r0_mit_ausgabe();
                        }
                    else
                        {
                        rand_werte_kommunikation[i].packen_werte_u0r0();
                        }
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0r0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_u0r0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_u0r0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if((rang==1)&&(i==0))
                        {
                        rand_werte_kommunikation[i].entpacken_werte_u0r0_mit_ausgabe();
                        }
                    else
                        {
                        rand_werte_kommunikation[i].entpacken_werte_u0r0();
                        }
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen rS0 gepackt werden.
void RandStruktur::packen_randwerte_rS0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_rS0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_rS0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_rS0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_rS0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_rS0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_rS0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_u0, nur dass statt den Werten der Variablen u0 die Werte der Variablen e0 gepackt werden.
void RandStruktur::packen_randwerte_e0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_e0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_e0();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_e0, nur dass statt gepackt entpackt wird.
void RandStruktur::entpacken_randwerte_e0(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_e0();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_e0();
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 3 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch3_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch3_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch3_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 3 - statt der Variablen 1 -
// der Randaustausch geschieht.
bool RandStruktur::kleiner_randaustausch3_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch3_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = rand_werte_kommunikation[i].randaustausch3_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 4 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch4_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch4_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch4_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 4 - statt der Variablen 1 -
// der Randaustausch geschieht.
bool RandStruktur::kleiner_randaustausch4_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch4_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
#ifdef AKTUELLE_KOMMENTARE
                        cout << " WWXXYY rang " << rang << " i " << i << endl;
#endif
                        testflags[i] = rand_werte_kommunikation[i].randaustausch4_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Hier wird die Liste der Gitterpunkte des 'kleinen' Innenrandes zu Debugging - Zwecken ausgegeben. Je
// nach Wert der Variablen vektorisieren0 wird dafr entweder die Klasse RSK oder die Klasse RWK bemht.
void RandStruktur::ausgabe_klein(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Ausgabe klein. rang " << rang << " ";
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                cout << " i " << i << " rsk.aik " << randstruktur_kommunikation[i].anzahl_innen_klein << " ";
                }
            }
        cout << endl;
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                cout << " i " << i << " rwk.aik " << rand_werte_kommunikation[i].anzahl_innen_klein << " ";
                }
            }
        cout << endl;
        }
#endif
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 5 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch5_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch5_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch5_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 5 - statt der Variablen 1 -
// der Randaustausch geschieht.
bool RandStruktur::kleiner_randaustausch5_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch5_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = rand_werte_kommunikation[i].randaustausch5_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 2 und der Variablen 3
// - statt der Variablen 1 - der Randaustausch geschieht. Dabei werden die Werte der beiden Variablen gepackt.
void RandStruktur::kleiner_randaustausch23_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch23_initiieren(anzahl_rs[i]);
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        ausgaben_anzahl_innen_aussen_klein();
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
#ifdef AKTUELLE_KOMMENTARE
                    cout << " VVWWXX kri rang " << rang << " i " << i << " anzahl " << anzahl_rs[i] << endl;
#endif
                    rand_werte_kommunikation[i].randaustausch23_initiieren(anzahl_rs[i]);
#ifdef AUSGABEN_RANDSTRUKTUR
                    cout << "Nach rand_werte_kommunikation[i].randaustausch23_initiieren i " << i << " rang " << rang << endl;
#endif
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Hier wird mit Hilfe der Klasse RWK zu jedem anderen Kern der Umfang des kleinen Innenrandes und des kleinen
// Auenrandes angegeben - frs Debugging.
void RandStruktur::ausgaben_anzahl_innen_aussen_klein(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR
    cout << "Anzahlen Innen / Aussen klein / rang " << rang;
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            cout << " i " << i << " Anzahl Innen " << rand_werte_kommunikation[i].anzahl_innen_klein;
            cout << " Anzahl Aussen " << rand_werte_kommunikation[i].anzahl_aussen_klein;
            }
        }
    cout << endl;
#endif
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 2 und Variablen 3
// - statt der Variablen 1 - der Randaustausch geschieht. Dabei werden die Werte beider Variablen entpackt.
bool RandStruktur::kleiner_randaustausch23_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
#ifdef AUSGABEN_RANDSTRUKTUR
                        if((groesse>=4)&&(rang==0)&&(i==1))
                            {
                            cout << " Code A3 RSK t " << t << " Anzahl a " << randstruktur_kommunikation[i].anzahl_punkte_aussen() << endl;
                            }
#endif
                        testflags[i] = randstruktur_kommunikation[i].randaustausch23_testen(randstruktur_kommunikation[i].anzahl_punkte_aussen());
// Kommentar: Hier muss die Auenpunktanzahl berechnet werden, da wohl anzahl_rs (Innenrandpunktanzahl), nicht aber anzahl_a_rs (Auenrandpunktanzahl) bekannt ist, wenn man vektorisiert.
                        if(testflags[i]==true)
                            {
                            randstruktur_kommunikation[i].bilde_kleine_randstruktur_aussen();
                            randstruktur_kommunikation[i].randaustausch23_einfuegen();
                            }
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
#ifdef AUSGABEN_RANDSTRUKTUR
                        cout << " kra testen 1 / rang " << rang << endl;
#endif
#ifdef AUSGABEN_RANDSTRUKTUR
                        if((groesse>=4)&&(rang==0)&&(i==1))
                            {
                            cout << " Code A3 RWK t " << t << " Anzahl a " << anzahl_a_rs[i] << endl;
                            }
#endif
                        testflags[i] = rand_werte_kommunikation[i].randaustausch23_testen(anzahl_a_rs[i]);
#ifdef AUSGABEN_RANDSTRUKTUR
                        cout << " kra testen 1e / rang " << rang << endl;
#endif
                        if(testflags[i]==true)
                            {
#ifdef AUSGABEN_RANDSTRUKTUR
                            cout << " kra testen 2 / rang " << rang << endl;
#endif
                            rand_werte_kommunikation[i].bilde_kleine_randstruktur_aussen();
#ifdef AUSGABEN_RANDSTRUKTUR
                            cout << " kra testen 3 / rang " << rang << endl;
#endif
                            rand_werte_kommunikation[i].rang_ziel = i;
                            rand_werte_kommunikation[i].randaustausch23_einfuegen();
#ifdef AUSGABEN_RANDSTRUKTUR
                            cout << " kra testen 4 / rang " << rang << endl;
#endif
                            }
                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 6 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch6_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch6_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch6_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 6 - statt der Variablen 1 -
// der Randaustausch geschieht.
bool RandStruktur::kleiner_randaustausch6_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch6_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = rand_werte_kommunikation[i].randaustausch6_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_initiieren, nur dass bzgl. der Variablen 7 - statt der Variablen 1 -
// der Randaustausch geschieht.
void RandStruktur::kleiner_randaustausch7_initiieren(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].randaustausch7_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].randaustausch7_initiieren();
                    testflags[i] = false;
                    }
                }
            }
        }
    }

// Kommentar: Alles analog zur Funktion kleiner_randaustausch1_testen, nur dass bzgl. der Variablen 7 - statt der Variablen 1 -
// der Randaustausch geschieht.
bool RandStruktur::kleiner_randaustausch7_testen(void)
    {
    if(vektorisieren0==JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = randstruktur_kommunikation[i].randaustausch7_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    if(testflags[i] == false)
                        {
                        testflags[i] = rand_werte_kommunikation[i].randaustausch7_testen();
                        }
                    }
                }
            }
        return(testen());
        }
    }

// u0, r0, Iu0, rS0, e0, Lu0, ILu0

// Kommentar: Hier geschieht eine Dateiausgabe, dessen Zeiger bergeben wird, fr die Innenrandpunkte und
// Auenrandpunkte - fr die Klasse RandWerteKommunikation. Im Falle von vektorisieren0 = Ja, d.h. fr
// die Klasse RandStrukturKommunikation geschieht nichts.
void RandStruktur::ausgabe_randstruktur_sortieren(DateiAusgabe * da_zr)
    {
    if(vektorisieren0==JA)
        {
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                * da_zr -> aus << " Innenrand rang " << rang << " i " << i << endl;
                for(j=0; j<rand_werte_kommunikation[i].anzahl_rs; j++)
                    {
                    * da_zr->aus << "(" << rand_werte_kommunikation[i].f_rs[j] << ",";
                    * da_zr->aus << rand_werte_kommunikation[i].g_rs[j] << ")";
                    }
                * da_zr -> aus << endl;
                }
            }
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                * da_zr -> aus << " Auenrand rang " << rang << " i " << i << endl;
                for(j=0; j<rand_werte_kommunikation[i].anzahl_a_rs; j++)
                    {
                    * da_zr->aus << "(" << rand_werte_kommunikation[i].f_a_rs[j] << ",";
                    * da_zr->aus << rand_werte_kommunikation[i].g_a_rs[j] << ")";
                    }
                * da_zr -> aus << endl;
                }
            }
        }
    }

// Kommentar: Analog zu ausgabe_randstruktur_sortieren, nur dass hier die kleinen Rnder ausgegeben werden.
void RandStruktur::ausgabe_randstruktur_sortieren_klein(DateiAusgabe * da_zr)
    {
#ifdef AUSGABEN_DATEI_101214
    if(vektorisieren0==JA)
        {
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                * da_zr -> aus << " Innenrand klein rang " << rang << " i " << i << endl;
                for(j=0; j<rand_werte_kommunikation[i].anzahl_innen_klein; j++)
                    {
                    * da_zr->aus << "(" << rand_werte_kommunikation[i].f_innen_klein[j] << ",";
                    * da_zr->aus << rand_werte_kommunikation[i].g_innen_klein[j] << ")";
                    }
                * da_zr -> aus << endl;
                }
            }
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                * da_zr -> aus << " Auenrand rang " << rang << " i " << i << endl;
                for(j=0; j<rand_werte_kommunikation[i].anzahl_aussen_klein; j++)
                    {
                    * da_zr->aus << "(" << rand_werte_kommunikation[i].f_aussen_klein[j] << ",";
                    * da_zr->aus << rand_werte_kommunikation[i].g_aussen_klein[j] << ")";
                    }
                * da_zr -> aus << endl;
                }
            }
        }
#endif
    }

// Kommentar: Hier wird das Flag, das angibt, ob eine Lastwertekorrektur erfolgen soll, bergeben an die
// Klasse RandStruktur.
void RandStruktur::initialisieren_lastwerte_korrektur(bool _lastwerte_korrektur)
    {
    lastwerte_korrektur = _lastwerte_korrektur;
    }

// Kommentar: Die Menge lastwerte_korrektur_punkte wird optional initialisiert.
void RandStruktur::allokiere_lwk_punkte(void)
    {
// Kommentar: Falls eine Lastwerte - Korrektur durchgefhrt werden soll, ...
    if(lastwerte_korrektur == true)
        {
// Kommentar: ... dann lege das entpsrechende MarkierungsFeldEV an.
        lastwerte_korrektur_punkte.initialisieren(n, m);
        }
    }

// Kommentar: Verknpfe der Zeiger die eindimensionale Markierungsfeld - Feldliste in die Struktur
// lastwerte_korrektur_punkte hinein.
void RandStruktur::initialisieren_lw_k(FeldListe1DMf * _feldliste_wo)
    {
        {
#ifdef AUSGABEN_LWK
        cout << " Feldliste_wo bertragen nach paralleles_rechnen rang " << rang << " ebene " << gitterebene << endl;
#endif
        lastwerte_korrektur_punkte.initialisieren_ev(_feldliste_wo, rang, gitterebene);
        }
    }

// Kommentar: Hier geschieht die Finalisierung zur Initialisierungsfunktion allokiere_lwk_punkte. Optional
// wird der fr die Klasse lastwerte_korrektur_punkte verwendete Speicherplatz wieder freigegeben.
void RandStruktur::finalisieren_lw_k(void)
    {
    if(lastwerte_korrektur == true)
        {
        lastwerte_korrektur_punkte.finalisieren();
        }
    }

// Kommentar: Hier werden 4 Variablen der von mir genderten Version der Implementierung von Herrn Hess der Shallow Water Equations gepackt. Man macht das,
// indem man zu einem Punkt die Werte der Variablen hintereinander in den Buffer schreibt.
// Das geschieht hier fr alle punktebenachbarten Kerne durch den Aufruf von packen_werte_v1v2v3v4
// entweder in der Klasse RSK, oder in der Klasse RWK.
void RandStruktur::packen_randwerte_v1v2v3v4(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v1v2v3v4();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v1v2v3v4();
                    }
                }
            }
        }
    }

// Kommentar: Wie packen_randwerte_v1v2v3v4, nur dass die Werte aus dem Buffer in die Variablen geschrieben werden,
// also entpackt wird, anstelle des umgekehrten Schrittes, was beim Packen geschieht.
void RandStruktur::entpacken_randwerte_v1v2v3v4(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v1v2v3v4();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v1v2v3v4();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden 3 Variablen der von mir genderten Version der Implementierung von Herrn Hess der SWE gepackt. Analog zu packen_randwerte_v1v2v3v4.
void RandStruktur::packen_randwerte_v5v6v7(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v5v6v7();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v5v6v7();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden 3 Variablen der von mir genderten Version der Implementierung von Herrn Hess der SWE gepackt. Analog zu packen_randwerte_v1v2v3v4.
void RandStruktur::entpacken_randwerte_v5v6v7(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v5v6v7();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v5v6v7();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden 2 Variablen der von mir genderten Version der Implementierung von Herrn Hess der SWE gepackt. Analog zu packen_randwerte_v1v2v3v4.
void RandStruktur::packen_randwerte_v8v9(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v8v9();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v8v9();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden 3 Variablen der von mir genderten Version der Implementierung von Herrn Hess der SWE gepackt. Analog zu packen_randwerte_v1v2v3v4.
void RandStruktur::entpacken_randwerte_v8v9(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v8v9();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v8v9();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden 3 Variablen der von mir genderten Version der Implementierung von Herrn Hess der SWE gepackt. Analog zu packen_randwerte_v1v2v3v4.
void RandStruktur::packen_randwerte_v4v6v11(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v4v6v11();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v4v6v11();
                    }
                }
            }
        }
    }

// Kommentar: Hier werden 3 Variablen der von mir genderten Version der Implementierung von Herrn Hess der SWE gepackt. Analog zu packen_randwerte_v1v2v3v4.
void RandStruktur::entpacken_randwerte_v4v6v11(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v4v6v11();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v4v6v11();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird eine Variable der von mir genderten Version der Implementierung von Herrn Hess der SWE auf den Red-Punkten gepackt. Analog zu packen_randwerte_u0_red.
void RandStruktur::packen_randwerte_v6_red(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v6_red();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v6_red();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird eine Variable der von mir genderten Version der Implementierung von Herrn Hess der SWE auf den Black-Punkten gepackt. Analog zu packen_randwerte_u0_black.
void RandStruktur::packen_randwerte_v6_black(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v6_black();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v6_black();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird eine Variable der von mir genderten Version der Implementierung von Herrn Hess der SWE auf den Red-Punkten entpackt. Analog zu entpacken_randwerte_u0_red.
void RandStruktur::entpacken_randwerte_v6_red(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v6_red();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v6_red();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird eine Variable der von mir genderten Version der Implementierung von Herrn Hess der SWE auf den Black-Punkten entpackt. Analog zu entpacken_randwerte_u0_black.
void RandStruktur::entpacken_randwerte_v6_black(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v6_black();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v6_black();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird in Bezug auf die Variable v6 der genderten SWE Feingitterinformation auf der Position (2f,2g)
// fr Gitterpunkte (f,g) gepackt, vgl. packen_randwerte_fg_u0.
void RandStruktur::packen_randwerte_fg_v6(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_fg_v6();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_fg_v6();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird in Bezug auf die Variable v6 der SWE's Feingitterinformation auf der Posiition (2f,2g)
// fr Gitterpunkte (f,g) entpackt, vgl. entpacken_randwerte_fg_u0.

void RandStruktur::entpacken_randwerte_fg_v6(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_fg_v6();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_fg_v6();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird eine Variable der von mir genderten Version der Implementierung von Herrn Hess der Shallow Water Equations gepackt. Analog zu packen_randwerte_u0.
void RandStruktur::packen_randwerte_v6(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].packen_werte_v6();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].packen_werte_v6();
                    }
                }
            }
        }
    }

// Kommentar: Hier wird eine Variable der von mir genderten Version der Implementierung von Herrn Hess der Shallow Water Equations entpackt. Analog zu entpacken_randwerte_u0.
void RandStruktur::entpacken_randwerte_v6(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    randstruktur_kommunikation[i].entpacken_werte_v6();
                    }
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                if(anzahl_rs[i]!=0)
                    {
                    rand_werte_kommunikation[i].entpacken_werte_v6();
                    }
                }
            }
        }
    }

// Kommentar: Bei der Implementierung der SWE durch Herrn Hess wurden hier 5 Konstanten verwendet. Diese bekommen hier andere Werte
// als bei der Implementation der SWE von Herrn Hess.
RandStruktur::RandStruktur(void)
    {
    konstante1 = 1.0;
    konstante2 = 2.0;
    konstante3 = 3.0;
    konstante4 = 4.0;
    konstante5 = 5.0;
    }

// Kommentar: Die 11 Variablen der genderten Version der Implementierung von Herrn Hess der SWE (andere Bezeichnungen als bei Herrn Hess) werden entweder in die RSK's oder die RWK's kopiert.
void RandStruktur::initialisieren_v_s(void)
    {
    if(vektorisieren0 == JA)
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                randstruktur_kommunikation[i].v1 = v1;
                randstruktur_kommunikation[i].v2 = v2;
                randstruktur_kommunikation[i].v3 = v3;
                randstruktur_kommunikation[i].v4 = v4;
                randstruktur_kommunikation[i].v5 = v5;
                randstruktur_kommunikation[i].v6 = v6;
                randstruktur_kommunikation[i].v7 = v7;
                randstruktur_kommunikation[i].v8 = v8;
                randstruktur_kommunikation[i].v9 = v9;
                randstruktur_kommunikation[i].v10 = v10;
                randstruktur_kommunikation[i].v11 = v11;
                }
            }
        }
    else
        {
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                rand_werte_kommunikation[i].v1 = v1;
                rand_werte_kommunikation[i].v2 = v2;
                rand_werte_kommunikation[i].v3 = v3;
                rand_werte_kommunikation[i].v4 = v4;
                rand_werte_kommunikation[i].v5 = v5;
                rand_werte_kommunikation[i].v6 = v6;
                rand_werte_kommunikation[i].v7 = v7;
                rand_werte_kommunikation[i].v8 = v8;
                rand_werte_kommunikation[i].v9 = v9;
                rand_werte_kommunikation[i].v10 = v10;
                rand_werte_kommunikation[i].v11 = v11;
                }
            }
        }
    }

void RandStruktur::rs_farbenfeld_ausgeben(void)
    {
    cout << " farbenfeld rang " << rang << " t " << t << endl;

    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << " Ende farbenfeld rang " << rang << " t " << t << endl;
    }
