#ifndef RANDSTRUKTUR
#define RANDSTRUKTUR 1

#include <iostream>

#include "situationsdaten.h"

#include "randstruktur_kommunikation.h"
#include "rand_werte_kommunikation.h"

#include "ausgaben.h"

#include "koordinaten_sortierung.h"

#include "feldliste.h"
#include "feldliste_1d.h"

#include "datei_ausgabe.h"

#include "markierungsfeld.h"
#include "markierungsfeld_ev.h"

using namespace std;

class RandStruktur :    virtual public SituationsDaten
    {
public:
    void randpunkt_einfuegen(int i, int j, int farbe);
    void randpunkt_einfuegen_mit_minus1_merken(int i, int j, int farbe);
    void randpunkte_einfuegen(int i, int j, int farbe, int k, int l);
    void randpunkte_einfuegen_mit_minus1_merken(int i, int j, int farbe, int k, int l);
private:
public:
#ifdef KURZ_TESTFELD
    bool *** testfeld;
#else
    int *** testfeld;
#endif
public:
    void initialisieren_testfeld(void);
    void initialisieren_testfelder(void);
    void finalisieren_testfeld(void);
    void finalisieren_testfelder(void);
private:
    int i, j, k, l;
public:
    short int ** f_rs, ** g_rs;
public:
    short int ** f_a_rs, ** g_a_rs;
private:
public:
    int * anzahl_rs;
public:
    int * anzahl_a_rs;
private:
public:
    int anzahl_rs_farbe;
public:
    void randpunkteliste_ausgeben(void);
public:
    void vektorisieren(void);
public:
    void initialisieren_vektoren(void);
private:
public:
    RandStrukturKommunikation * randstruktur_kommunikation;
    RandWerteKommunikation * rand_werte_kommunikation;
public:
    void initialisieren_vektorisieren(void);
    void finalisieren_vektorisieren(void);
    void ausgeben_vektorisieren(void);
    void initialisieren_kommunikation_struktur(void);
    void finalisieren_kommunikation_struktur(void);
    void initialisieren_kommunikation_werte(void);
    void finalisieren_kommunikation_werte(void);
    void packen(void);
    void bereinigen(void);
    void entpacken(void);
    void kommunikation_starten(void);
    bool ist_fertig(void);
    void ausgeben_empfangen(void);
public:
    double ** x0, ** y0;
    double ** x1, ** y1;
    double ** x2, ** y2;
    double ** x3, ** y3;

    double ** u0;
    double ** gg_u0;
    double ** gg_e0;
    double ** gg_v9;
    double ** fg_u0;
    double ** r0;
    double ** Iu0;
    double ** f0;
    double ** If0;
    double ** tau;
    double ** tau_oben;
    double ** tau_1, ** tau_2;
    double ** rS0; // rechte Seite
    double ** e0;
    double ** Lu0, ** ILu0;
    double ** DF0; // DiskretisierungsFehler;
    double ** u0_hilf;
    double ** exakt;

// Variablen: u0, r0, e0, rS0.

    double ** v1; // u
    double ** v2; // v
    double ** v3; // h
    double ** v4; // uh
    double ** v5; // vh
    double ** v6; // hh
    double ** fg_v6;
    double ** v7; // f
    double ** v8; // c
    double ** v9; // r
    double ** v10; // he
    double ** v11; // hs
    double * vf;
    double * vf_2;
    double ** laden;

    double var1; // um
    double var2; // vm
    double var3; // hm
    double var4;
    double var5;
    double var6;
    double var7;
    double var8;
    double var9;
    double var10;
    double var11;
    double var12;

    double konstante1;
    double konstante2;
    double konstante3;
    double konstante4;
    double konstante5;

    double * x_i, * y_j;
    double x, y;

    double h_x, h_y, h_xh_y, eins_durch_h_xh_y;

    short int ** ep_aktuell;
    void randwerte_kommunikation_starten(void);
    void reset(void);
    void reset_beide(void);
    void reset_punktemenge(void);
    void reset_beide_punktemenge(void);
    void reset_testfeld_a_rs(void);
    void reset_testfeld_rs(void);
    void randstruktur_reset_testfeld_aussenrand(void);
    void randstruktur_reset_testfeld_aussenrand_abschliessen(void);
    bool randstruktur_leer(void);

    int * ist_nachbar;
    int * ist_nachbar_ml;
public:
    void aktualisiere_ist_nachbar(void);
private:
public:
    void randstruktur_reset(void);
    void randstruktur_reset_beide(void);
public:
    bool ist_nicht_leer(int i);
public:
    void initialisieren_struktur(int _groesse);
    void finalisieren_struktur(int _groesse);
private:
    KoordinatenSortierung koordinaten_sortierung;
public:
    void sortieren(void);
public:
    void randwerte_kommunikation_starten_2(void);
    bool ist_fertig_2(void);
    void packen_randwerte_2(int plizit);
    void packen_randwerte_x_2(int plizit);
    void entpacken_randwerte_2(int plizit);
#ifdef GEMEINSAME_BUFFER_SI
#ifdef GEMEINSAME_BUFFER
void initialisieren_ohne_vektorisieren(double ** sendebuffer, double ** empfangsbuffer, short int ** sendebuffer_si, short int ** empfangsbuffer_si);
#else
void initialisieren_ohne_vektorisieren(short int ** sendebuffer_si, short int ** empfangsbuffer_si);
#endif
#else
#ifdef GEMEINSAME_BUFFER
void initialisieren_ohne_vektorisieren(double ** sendebuffer, double ** empfangsbuffer);
#else
void initialisieren_ohne_vektorisieren(void);
#endif
#endif


    void finalisieren_ohne_vektorisieren(void);
public:
    void teste_aussen_testfeld(int i);
private:
    short int ** vergleichs_buffer, ** vergleichs_buffer_ankommen;
    MPI_Request * sende_requests;
    MPI_Request * empfange_requests;
    MPI_Status status;
    int flag;
public:
    bool sortieren_testen(void);
private:
    void sortieren_testen_einen_senden(int nr);
    bool sortieren_testen_einen_empfangen(int nr);
    bool ist_fertig_sortieren(void);
public:
    void verzoegern2(void);
public:
    void setze_anzahlen(void);
public:
#ifdef GEMEINSAME_BUFFER
    void initialisieren_kommunikation_struktur_werte(double ** sendebuffer, double ** empfangsbuffer);
#else
    void initialisieren_kommunikation_struktur_werte(void);
#endif
    void finalisieren_kommunikation_struktur_werte(void);
public:
    void ausgabe_a_rs(void);
    void ausgabe_a_rs_nr(int nr);
public:
    void packen_ep(void);
    void entpacken_ep(void);
    bool ist_fertig_ep(void);
    void kommunikation_starten_ep(void);

    void packen_ep2(void);
    void entpacken_ep2(void);
    bool ist_fertig_ep2(void);
    void kommunikation_starten_ep2(void);
public:
    void initialisieren_kommunikation_ep(void);
public:
    int vektorisieren0;
private:
    bool ist_nachbar_randwerte(int farbe);
private:
    short int ** f_innen_klein, ** g_innen_klein;
    short int ** f_aussen_klein, ** g_aussen_klein;
public:
    void initialisieren_rs(void);
    void finalisieren_rs(void);
    void initialisieren_fuer_kRST(short int ** _EP_aktuell, short int ** _EP_SNB, short int ** _farbenfeld, int _ebene, int ** _feld);
private:
    int * testflags;
    bool testen(void);
public:
    void kleiner_randaustausch1(void);
    void kleiner_randaustausch2(void);
    void kleiner_randaustausch3(void);
    void kleiner_randaustausch4(void);
    void kleiner_randaustausch5(void);

    void kleiner_randaustausch1_initiieren(void);
    void kleiner_randaustausch2_initiieren(void);
    void kleiner_randaustausch3_initiieren(void);
    void kleiner_randaustausch4_initiieren(void);
    void kleiner_randaustausch5_initiieren(void);
    void kleiner_randaustausch6_initiieren(void);
    void kleiner_randaustausch7_initiieren(void);
    void kleiner_randaustausch23_initiieren(void);

    bool kleiner_randaustausch1_testen(void);
    bool kleiner_randaustausch2_testen(void);
    bool kleiner_randaustausch3_testen(void);
    bool kleiner_randaustausch4_testen(void);
    bool kleiner_randaustausch5_testen(void);
    bool kleiner_randaustausch6_testen(void);
    bool kleiner_randaustausch7_testen(void);
    bool kleiner_randaustausch23_testen(void);

    void bilde_kleine_randstruktur(void);

    void setze_variablen(double ** _variable1, double ** _variable2, double ** _variable3, double ** _variable4, double ** _variable5, double ** _variable6, double ** _variable7);
    void setze_MLAT_variablen(void);
public:
    void randwerte_kommunikation_starten_fu(void);
    bool ist_fertig_fu(void);
public:
    void packen_randwerte_u0(void);
    void entpacken_randwerte_u0(void);

    void packen_randwerte_u0_red(void);
    void entpacken_randwerte_u0_red(void);

    void packen_randwerte_u0_black(void);
    void entpacken_randwerte_u0_black(void);

    void packen_randwerte_gg_u0(void);
    void entpacken_randwerte_gg_u0(void);

    void packen_randwerte_fg_u0(void);
    void entpacken_randwerte_fg_u0(void);

    void packen_randwerte_gg_e0(void);
    void entpacken_randwerte_gg_e0(void);

    void packen_randwerte_gg_e0_und_u0(void);
    void entpacken_randwerte_gg_e0_und_u0(void);

    void packen_randwerte_u0_hilf(void);

    void packen_randwerte_Lu0(void);
    void entpacken_randwerte_Lu0(void);

    void packen_randwerte_r0(void);
    void entpacken_randwerte_r0(void);

    void packen_randwerte_f0(void);
    void entpacken_randwerte_f0(void);

    void packen_randwerte_Iu0(void);
    void entpacken_randwerte_Iu0(void);

    void packen_randwerte_Iu0r0(void);
    void entpacken_randwerte_Iu0r0(void);

    void packen_randwerte_u0r0(void);
    void entpacken_randwerte_u0r0(void);

    void packen_randwerte_rS0(void);
    void entpacken_randwerte_rS0(void);

    void packen_randwerte_e0(void);
    void entpacken_randwerte_e0(void);
public:
    void ausgabe_klein(void);
public:
    int gitterebene;
    int ** selbstnachbarn;
protected:
    void randstruktur_reset_testfeld_fuer_beide(void);
public:
    FeldListe dynamischer_rand;
private:
    void ausgaben_anzahl_innen_aussen_klein(void);
private:
    bool ** signatur_innen, ** signatur_aussen;
public:
    int t;
public:
#ifdef KURZ_FF
    short int ** farbenfeld;
#else
    int ** farbenfeld;
#endif
public:
    void ausgabe_randstruktur_sortieren(DateiAusgabe * da_zr);
    void ausgabe_randstruktur_sortieren_klein(DateiAusgabe * da_zr);
public:
    int ** feld_darunter;
    short int  ** farbenfeld_darunter;
private:
protected:
public:
    bool lastwerte_korrektur;
public:
    MarkierungsFeldEV lastwerte_korrektur_punkte;
public:
    void initialisieren_lw_k(FeldListe1DMf * _feldliste_wo);
    void initialisieren_lastwerte_korrektur(bool _lastwerte_korrektur);
    void finalisieren_lw_k(void);
protected:
    void allokiere_lwk_punkte(void);
public:
    RandStruktur(void);
public:
    void initialisieren_v_s(void);
public:
    void packen_randwerte_gg_v9(void);
    void entpacken_randwerte_gg_v9(void);
    void packen_randwerte_v1v2v3v4(void);
    void entpacken_randwerte_v1v2v3v4(void);
    void packen_randwerte_v5v6v7(void);
    void entpacken_randwerte_v5v6v7(void);
    void packen_randwerte_v8v9(void);
    void entpacken_randwerte_v8v9(void);
    void packen_randwerte_v4v6v11(void);
    void entpacken_randwerte_v4v6v11(void);
    void packen_randwerte_v6_red(void);
    void entpacken_randwerte_v6_red(void);
    void packen_randwerte_v6_black(void);
    void entpacken_randwerte_v6_black(void);
    void packen_randwerte_fg_v6(void);
    void entpacken_randwerte_fg_v6(void);
    void packen_randwerte_v6(void);
    void entpacken_randwerte_v6(void);
public:
    DateiAusgabe da_randstruktur;
private:
    void rs_farbenfeld_ausgeben(void);
    int speichere_j, speichere_k;
private:
    int mn2_plus1;
    };

#endif
