#include "randstruktur_bilden.h"

// Vorkommentar: Die Klasse RandStrukturkommunikation behandelt die Rnder im Falle der Bestimmung der Rnder
// durch Kommunikation der Vektoren des Randes (vektorisieren0 = JA), und die Klasse RandWerteKommunikation behandelt
// die Rnder in Falle der 'Sortierungsstrategie' (vektorisieren0 = NEIN) von Innenrand - und Auenrandpunkten.


// Kommentar: Die Strukturen fr randstruktur_bilden werden freigegeben. Das betrifft insbesondere die Strukturen
// der Klasse Gitter - sowie die Randstrukturen, die in der Vaterklasse Randstruktur der Klasse Gitter bestehen.
void RandStrukturBilden::finalisieren(void)
    {
// Kommentar: Eine unwichtige Ausgabe.
    if(rang==0)
        {
        cout << " Anfang finalisieren rang 0 " << endl;
        }
// Kommentar: Im Falle der Bildung der Randstruktur durch Vektorenkommunikation ...
    if(vektorisieren0==JA)
        {
// Kommentar: Freigeben der Werte der Struktur RandStrukturKommunikation
        finalisieren_kommunikation_struktur_werte();
// Kommentar: Freigeben Kommunikationsstruktur der Klasse RandStrukturKommunikation
        finalisieren_kommunikation_struktur();
// Kommentar: Freigeben der Klasse RandStrukturKommunikation selber
        finalisieren_vektorisieren();
        }
    else
        {
// Kommentar: Finalisierung der Struktur RandWerteKommunikation. Ggf. werden auch Teststrukturen finalisiert - wenn sie
// verwendet wurden.
        finalisieren_ohne_vektorisieren();
// Kommentar: Hier wird nichts freigegeben.
        finalisieren_kommunikation_werte();
        }
// Alles (s.o.) wird richtig finalisiert
    if(rang==0)
        {
        cout << " Mitte finalisieren rang 0 " << endl;
        }
// Kommentar: Falls der Rand mit Hilfe der Kommunikation von Vektoren gebildet wird ...
    if(vektorisieren0==JA)
        {
//        finalisieren_testfeld();
        #ifdef VEKTORISIEREN_TESTEN
// Kommentar: Ein Testfeld wird befreit; (f,g) fr rs und a_rs, also z.B. f_a_rs oder f_rs werden befreit.
// Ferner wird die KoordinatenSortierung finalisiert.
        finalisieren_testfelder();
        #else
// Kommentar: Hier geben nur das Testfeld und f_rs und g_rs ihren Speicher frei.
        finalisieren_testfeld();
        #endif
        }
    else
        {
// Vgl. den Kommentar zu finalisieren_testfelder 10 Zeilen hher.
        finalisieren_testfelder();
        }

// Kommentar: Eine unwichtige Ausgabe
    if(rang==0)
        {
        cout << " Vor finalisieren gitter rang 0 " << endl;
        }

// Kommentar: Die Klasse Gitter wird finalisiert, d.h. sie gibt den durch sie belegten Speicherplatz wieder frei.
#ifdef DA_RANDSTRUKTUR
    da_randstruktur.schliessen();
#endif
    finalisieren_gitter();
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << "Gitter ist finalisiert " << endl;
#endif
    if(rang==0)
        {
        cout << " Ende finalisieren rang 0 " << endl;
        }
    }

// Kommmentar: Es wird ohne Rand finalisiert. Insbesondere die Klassen RandStrukturkommunikation und RandWertekommunikation
// bekamen in diesem Fall keinen Speicher zugeteilt. Das macht insbesondere bei der Kappe Sinn - wenn nur sequentiell
// gerechnet wird. Dann braucht man keinen Rand.
void RandStrukturBilden::finalisieren_ohne_rand(void)
    {
// Kommentar: Hier wird nur die Klasse Gitter finalisiert - Kommentar dazu: siehe oben.
    finalisieren_gitter();
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << "Gitter ist finalisiert " << endl;
#endif
    }

#ifdef GEMEINSAME_BUFFER_SI
#ifdef GEMEINSAME_BUFFER
// Kommentar: Hier wird die Klasse RandStrukturBilden initialisiert, d.h. der entsprechende Speicher wird zugeteilt.
void RandStrukturBilden::initialisieren(int _n, int _m, int _groesse, int _rang, double ** sendebuffer, double ** empfangsbuffer, short int ** sendebuffer_si, short int ** empfangsbuffer_si)
#else
void RandStrukturBilden::initialisieren(int _n, int _m, int _groesse, int _rang, short int ** sendebuffer_si, short int ** empfangsbuffer_si)
#endif
#else
#ifdef GEMEINSAME_BUFFER
void RandStrukturBilden::initialisieren(int _n, int _m, int _groesse, int _rang, double ** sendebuffer, double ** empfangsbuffer)
#else
void RandStrukturBilden::initialisieren(int _n, int _m, int _groesse, int _rang)
#endif
#endif
// wird richtig finalisiert
    {
    zeit_finden.starten_rang(_rang);
#ifdef AKTUELLE_KOMMENTARE
    cout << " initialisieren Beginn rang " << _rang << " n " << _n << " m " << _m << endl;
#endif
    strcpy(texta, " zeit_finden 112 ");
    zeit_finden.ausgabe(texta);
// Kommentar: Die Parameter n, m, groesse und rang werden kopiert. Keine Allokation hierbei.
    initialisieren_SD( _n, _m, _groesse, _rang); // legt keinen Speicher an.
    strcpy(texta, " zeit_finden 114 ");
    zeit_finden.ausgabe(texta);
// Kommentar: Die Klasse Gitter wird initialisiert, wobei insbesondere der bentigte Spericher angelegt wird, als auch
// Variablenwerte - wie bei f0 - gesetzt werden.

#ifdef AKTUELLE_KOMMENTARE
    cout << " vor initialisieren_gitter rang " << rang << " n " << n << " m " << m << endl;
#endif
    initialisieren_gitter( _n, _m, _groesse, _rang);
#ifdef AKTUELLE_KOMMENTARE
    cout << " nach initialisieren_gitter rang " << rang << " n " << n << " m " << m << endl;
#endif
#ifdef DA_RANDSTRUKTUR
    switch(gitterebene)
        {
        case 0:
            strcpy(zeichenkette, "DA_Randstruktur0E");
            break;
        case 1:
            strcpy(zeichenkette, "DA_Randstruktur1E");
            break;
        case 2:
            strcpy(zeichenkette, "DA_Randstruktur2E");
            break;
        case 3:
            strcpy(zeichenkette, "DA_Randstruktur3E");
            break;
        case 4:
            strcpy(zeichenkette, "DA_Randstruktur4E");
            break;
        case 5:
            strcpy(zeichenkette, "DA_Randstruktur5E");
            break;
        }
    da_randstruktur.initialisieren(rang, zeichenkette);
    da_randstruktur.oeffnen();
#endif
    strcpy(texta, " zeit_finden 116 ");
    zeit_finden.ausgabe(texta);
    // finalisieren_gitter befreit das wieder, siehe gitter.cpp

// Kommentar: Falls die Randstrukturen durch Vektorkommunikation gebildet werden ...
    if(vektorisieren0==JA)
        {
        #ifdef VEKTORISIEREN_TESTEN
// Hier werden f_rs, g_rs, f_a_rs, g_a_rs, das Testfeld und die Koordinaten Sortierung angelegt.
        initialisieren_testfelder();
        // wird richtig finalisiert
        #else
// Hier wird nur das Testfeld und f_rs und g_rs angelegt.
        initialisieren_testfeld();
        // wird richtig finalisiert. Und immer alternativ zu initialisieren_testfelder aufgerufen.
        #endif
        }
    else
        {
// Hier werden f_rs, g_rs, f_a_rs, g_a_rs, das Testfeld und die Koordinaten Sortierung angelegt.
        initialisieren_testfelder();
        // wird richtig finalisiert
        }

#ifdef AKTUELLE_KOMMENTARE
    cout << " In RandstrukturBilden::initialisieren Zeile 203 rang " << rang << " n " << n << " m " << m << endl;
#endif

    strcpy(texta, " zeit_finden 135 ");
    zeit_finden.ausgabe(texta);

    // Das Pandon dazu wird wieder freigegeben.
// Kommentar: Nun werden Farbenfeld und Selbstnachabrn ausgegeben. Diese Ausgaben knnen aber unterdrckt werden,
// indem AUSGABEN_GITTER nicht definiert wird.
    ausgeben_farbenfeld();
    ausgeben_selbstnachbarn();

    strcpy(texta, " zeit_finden 143 ");
    zeit_finden.ausgabe(texta);

#ifdef AKTUELLE_KOMMENTARE
    cout << " In RandstrukturBilden::initialisieren Zeile 220 rang " << rang << " n " << n << " m " << m << endl;
#endif

// Kommentar: Hier wieder zuerst vektorisieren0 = JA behandeln.
    if(vektorisieren0==JA)
        {
// Kommentar: Wenn getestet werden soll ...
        #ifdef VEKTORISIEREN_TESTEN
// Kommentar: reset (f_rs, g_rs) und (f_a_rs, g_a_rs)
        reset_beide_punktemenge();
//        randstruktur_bilden_beide();
// Kommentar: bilde (f_rs, g_rs) und (f_a_rs, g_a_rs). Die Idee: Man vergleicht dann (f_a_rs, g_a_rs) mit den
// verschickten Vektoren / Punkte - Kombinationen.
        randstruktur_bilden_beide_fuer_init();
// Kommentar: Fr den Vergleich wird ein Testfeld bentigt. Das muss auf false gesetzt werden.
        reset_testfeld_a_rs();
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
// Kommentar: Falls hier Ausgaben ntig werden, dann gebe insbesondere (f_a_rs, g_a_rs) aus.
        cout << "Durch Randstruktur bilden beide durch. Rang = " << rang << " n " << n << endl;
        cout << "RandStruktur bilden beide 2 " << endl;
        cout << "f_a / g_a " << endl;
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                for(j=0; j<anzahl_a_rs[i]; j++)
                    {
                    cout << "(" << f_a_rs[i][j] << " " << g_a_rs[i][j] << ")";
                    }
                cout << endl;
                }
            }
#endif
        #else
// Kommentar: Ohne Test braucht man nur (f_rs,g_rs), und nur diese Menge muss resettet werden.
        reset_punktemenge();

// Kommentar: Ohne Test muss nur die Menge (f_rs, g_rs) gebildet werden. Das geschieht ber die angegebene Gitterfunktion.
        randstruktur_bilden_fuer_init();
        #endif
// Kommentar: Je nach Prprozessorvariablen wird die Randpunktliste ausgegeben.
        randpunkteliste_ausgeben();

        }
    else
        {
// Kommentar: Im Falle vektorisieren0 = NEIN, also der 'Sortierung des Randes', mssen die Rand - und Auenrandmenge
// bestimmt werden, und das geschieht gemeinsam. Zuvor werden beide Mengen resettet.
#ifdef AKTUELLE_KOMMENTARE
    cout << " In RandstrukturBilden::initialisieren Zeile 271 rang " << rang << " n " << n << " m " << m << endl;
#endif
        reset_beide_punktemenge();
#ifdef AUSGABEN_LWK
        cout << " DDFFHH rbb in RS_bilden tritt auf " << " rang " << rang << " ebene " << gitterebene << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " In RandstrukturBilden::initialisieren Zeile 279 rang " << rang << " n " << n << " m " << m << endl;
#endif
        randstruktur_bilden_beide_fuer_init();
// Durch reset_beide werden beide Testfelder resettet - nicht die Punktmengen.
#ifdef AKTUELLE_KOMMENTARE
    cout << " In RandstrukturBilden::initialisieren Zeile 284 rang " << rang << " n " << n << " m " << m << endl;
#endif
        reset_beide();
#ifdef AKTUELLE_KOMMENTARE
    cout << " In RandstrukturBilden::initialisieren Zeile 288 rang " << rang << " n " << n << " m " << m << endl;
#endif
// Kommentar: Optionale Ausgabe von (f_a_rs, g_a_rs).s
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "Durch Randstruktur bilden beide durch. Rang = " << rang << " n " << n << endl;
        cout << "RandStruktur bilden beide 1 " << endl;
        cout << "f_a / g_a " << endl;
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                for(j=0; j<anzahl_a_rs[i]; j++)
                    {
                    cout << "(" << f_a_rs[i][j] << " " << g_a_rs[i][j] << ")";
                    }
                cout << endl;
                }
            }
#endif
        }

#ifdef AKTUELLE_KOMMENTARE
    cout << " initialisieren Mitte 1 rang " << _rang << " n " << n << " m " << m << endl;
#endif

    strcpy(texta, " zeit_finden 212 ");
    zeit_finden.ausgabe(texta);

// Kommentar: Im Fall vektorisieren0 = JA (Kommentar s.o.)
    if(vektorisieren0==JA)
        {
// Kommentar: Die Klasse RandStrukturKommunikation wird initialisiert, bekommt also insbesondere Speicherplatz zugeteilt.
        initialisieren_vektorisieren();
        // wird finalisiert
#ifdef AUSGABEN
        cout << "Vor Vektorisieren in RandStrukturBilden am Anfang" << endl;
#endif
// Kommentar: Die Klasse RandStrukturKommunikation fhrt die Vektorisierung der Randpunktmenge (f_rs, g_rs) durch.
        vektorisieren();
#ifdef AUSGABEN
        cout << "Vektorisieren in RandStrukturBilden ausgefuehrt am Anfang" << endl;
#endif
// Kommentar: Je nach Prprozessorvariable werden die Vektoren ausgegeben.
        ausgeben_vektorisieren();

// Kommentar: Es werden an die Klasse SandstrukturKommunikation die Variablenzeiger der Klasse Gitter bergeben -
// zusammen mit der Gitterebene sowie dem eigenen Rang.
        initialisieren_kommunikation_struktur();
        // wird finalisiert, s.o.
#ifdef GEMEINSAME_BUFFER
// Kommentar: Die Klasse RandStrukturKommunikation bekommt Speicherplatz fr ihre Kommunikation zugeteilt.
        initialisieren_kommunikation_struktur_werte(sendebuffer, empfangsbuffer);
#else
        initialisieren_kommunikation_struktur_werte();
#endif
        // wird finalisiert

// Kommentar: Nun werden die Vektoren verschickt, und entpackt, und das Angekommene ggf. ausgegeben.
        packen();

        kommunikation_starten();

        for(;ist_fertig()==false;)
            {
            ;
            }

        entpacken();
        bereinigen();


        if((gitterebene==0)&&(rang==0))
            {
            cout << " Code 33: " << randstruktur_kommunikation[1].anzahl_v_vektor_e << " ";
            cout << randstruktur_kommunikation[1].anzahl_h_vektor_e << " ";
            cout << randstruktur_kommunikation[1].punkteanzahl_e << " " << endl;
            }

        ausgeben_empfangen();

#ifdef VEKTORISIEREN_TESTEN
// Kommentar: Und dann kommt es optional zu einem Test zwischen Empfangen und dem in (f_a_rs, g_a_rs) bestimmten
// Auenpunkten.
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vektorisieren_testen 337 " << endl;
#endif
        vektorisieren_testen();
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vektorisieren_testen 339 " << endl;
#endif
#endif

        }
    else
// Hier ist vektorisieren0 = NEIN.
        {
#ifdef AKTUELLE_KOMMENTARE
        cout << " initialisieren Mitte 1a rang " << _rang << " n " << n << " m " << m << endl;
#endif
#ifdef GEMEINSAME_BUFFER_SI
#ifdef GEMEINSAME_BUFFER
// Kommentar: Hier wird die Klasse RandWerteKommunikation initialisiert. Die Sende - und Empfangs - Requests werden angelegt.
// Fr eine optionalen Test werden optional Vergleichsbuffer angelegt.
        initialisieren_ohne_vektorisieren(sendebuffer, empfangsbuffer, sendebuffer_si, empfangsbuffer_si);
#else
        initialisieren_ohne_vektorisieren(sendebuffer_si, empfangsbuffer_si);
#endif
    // wird finalisiert
#else

#ifdef GEMEINSAME_BUFFER
        initialisieren_ohne_vektorisieren(sendebuffer, empfangsbuffer);
#else
        initialisieren_ohne_vektorisieren();
    // wird finalisiert
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " initialisieren Mitte 1b rang " << _rang << endl;
#endif
// Kommentar: Die Randstrukturen stehen zur Verfgung und werden jetzt sortiert.
        sortieren();
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
// Kommentar: Eine optionale Ausgabe der Auenrandstruktur.
        cout << "Durch Sortieren durch " << endl;
        for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                for(j=0; j<anzahl_a_rs[i]; j++)
                    {
                    cout << "[" << f_a_rs[i][j] << " " << g_a_rs[i][j] << "]";
                    }
                cout << endl;
                }
            }
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " initialisieren Mitte 1c rang " << _rang << endl;
#endif
// Kommentar: Die Klasse RandWerteKommunikation bekommt die Anzahlen der Randpunktlisten von der Klasse Gitter 'mitgeteilt'.
        setze_anzahlen();
        #ifdef SORTIEREN_TESTEN
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "Vor sortieren_testen " << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " initialisieren Mitte 1d rang " << _rang << endl;
#endif
// Kommentar: Falls die Vorgehendsweise der Randsortierung getestet werden soll ...
        if(sortieren_testen_flag == true)
            {
// Kommentar: ... dann mache den Test. Dafr muss dann der Innenrand kommuniziert werden, und das angekommene mit
// dem Auenrand verglichen werden.
            sortieren_testen_rb();
            }
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "Durch sortieren_testen durch " << endl;
#endif
        #endif

#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "Vor initialisieren_kommunikation " << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " initialisieren Mitte 1e rang " << _rang << endl;
#endif
// Kommentar: Hier werden die Matrix - Variablen der Klasse Gitter an die Klasse RandWerteKommunikation bergeben,
// wobei diese aus der Klasse Gitter stammen. Ferner werden der eigene Rang sowie die Gitterebene bergeben.
        initialisieren_kommunikation_werte();
        // wird finalisiert
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "Durch initialisieren_kommunikation durch " << endl;
#endif
        }

    strcpy(texta, " zeit_finden 325 ");
    zeit_finden.ausgabe(texta);

#ifdef AKTUELLE_KOMMENTARE
    cout << " initialisieren Mitte 2 rang " << _rang << endl;
#endif

#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << "Durch ausgeben_empfangen durch " << endl;
#endif
#ifdef BESTIMME_INNENPUNKTE
// Kommentar: Das wird auskommentiert. Sonst wrden die Randpunktmengen fr Zyklus Rechnen vorbereitet.
    bestimme_innenpunkte();
#endif
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << "Durch bestimme innenpunkte durch " << endl;
#endif
// Kommentar: Hier werden die MLAT - Variablen nach variable1 - variable7 geschrieben - nach RandStrukturkommunikation oder
// RandWerteKommunikation.
    setze_MLAT_variablen();
#ifdef AKTUELLE_KOMMENTARE
    cout << " RS:init Ende rang " << rang << " n " << n << endl;
#endif
    strcpy(texta, " zeit_finden 352 ");
    zeit_finden.ausgabe(texta);
    }

// Kommentar: Hier wird die Funktion sortieren_testen aufgerufen - falls die Sortierungsstrategie auf Korrektheit getestet wird.
void RandStrukturBilden::sortieren_testen_rb(void)
    {
    ergebnis = sortieren_testen();
    if(ergebnis==false)
        {
        exit(-1);
        }
    }

// Kommentar: Je nachdem, ob vektorisieren0 JA oder NEIN ist, wird die Randstruktur der RandStrukturKommunikation oder der
// Randwertekommunikation getestet.
void RandStrukturBilden::randstruktur_testen(void)
    {
    if(vektorisieren0==JA)
        {
        #ifdef VEKTORISIEREN_TESTEN
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vektorisieren_testen 479 " << endl;
#endif
        vektorisieren_testen();
        #endif
        }
    else
        {
        #ifdef SORTIEREN_TESTEN
        sortieren_testen_rb();
        #endif
        }
    }

// Kommentar: Testen der RandStrukturKommunikation - falls VEKTORISIEREN_TESTEN definiert ist.
void RandStrukturBilden::vektorisieren_testen(void)
    {
    #ifdef VEKTORISIEREN_TESTEN
// Kommentar: Zuerst wird das Testfeld resettet.
    for(i=0; i<groesse; i++)
            {
            if(i!=rang)
                {
                for(j=0; j<n; j++)
                    {
                    for(k=0; k<m; k++)
                        {
                        testfeld[i][j][k] = false;
                        }
                    }
// Kommentar: Hiermit wird mit der durch Kommunikation bestimmte Auenrandpunktmenge - bestimmt durch
// horizontale und vertikale Vektoren sowie der Restpunktmenge - zur Markierung der Testfelder verwendet.
                randstruktur_kommunikation[i].schreibe_aussen_testfeld(testfeld[i]);
//                randstruktur_kommunikation[i].gebe_testfeld_aus(testfeld[i]);

// Kommentar: Diese Markierung wird verglichen mit den Mengen (f_a_rs, g_a_rs), die durch die Bestimmung
// beider Randpunktmengen entstanden ist.
                teste_aussen_testfeld(i);
                }
            }

    #endif
    }

// Kommentar: Bereitet die Randstrukturen vor.
void RandStrukturBilden::vorbereiten(void)
    {
// Kommentar: Ruft  vorbereiten2 auf, vgl. diese Funktion 5 Zeilen tiefer.
    vorbereiten2();
// Kommentar: Bestimmt mit Hilfe der Anzahlen der Randeintrge entweder der RandStrukturKommunikation oder der
// RandWerteKommunikation ist_nachbar und ist_nachbar_ml - fr die Kerntopologien.
    aktualisiere_ist_nachbar();
    }

// Kommentar: Bildet in beiden Fllen - vektorisieren0 = JA oder NEIN - die jeweiligen Randstrukturen.
void RandStrukturBilden::vorbereiten2(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor da_randstruktur.aus rang " << rang << endl;
#ifdef DA_RANDSTRUKTUR
    * da_randstruktur.aus << " In vorbereiten 2 " << endl;
#endif
    cout << " Nach da_randstruktur.aus rang " << rang << endl;
#endif
// Kommentar: Im Fall vektorisieren0 = JA (Kommentar s.o.)
    if(vektorisieren0==JA)
        {
        #ifdef VEKTORISIEREN_TESTEN

        if(randstruktur_leer()==false)
            {
            cout << " Fehler: Code 51: Testfeld nicht leer Rang " << rang << endl;
            exit(-1);
            }

// Kommentar: reset (f_rs, g_rs) und (f_a_rs, g_a_rs)
        reset_beide_punktemenge();
// Kommentar: bilde (f_rs, g_rs) und (f_a_rs, g_a_rs). Die Idee: Man vergleicht dann (f_a_rs, g_a_rs) mit den
// verschickten Vektoren / Punkte - Kombinationen.
        randstruktur_bilden_beide();
    if((gitterebene==0)&&(rang==0))
        {
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vorbereiten 2 " << " anzahl rs [1] " << anzahl_rs[1] << " anzahl a rs[1] " << anzahl_a_rs[1] << endl;
#endif
        cout << " vorbereiten 2 " << " anzahl rs [1] " << anzahl_rs[1] << " anzahl a rs[1] " << anzahl_a_rs[1] << endl;
        }
// Kommentar: Fr den Vergleich wird ein Testfeld bentigt. Das muss auf false gesetzt werden.
         randstruktur_reset_testfeld_aussenrand(); // Gendert am 20.8.2015
//        randstruktur_reset_testfeld_fuer_beide();
// Kommentar: Sortiert die bestimmten Punktmengen.
        sortieren();
        #else
// Kommentar: Falls kein Test abluft:
// Kommentar: Ohne Test braucht man nur (f_rs,g_rs), und nur diese Menge muss resettet werden.
        reset_punktemenge();
// Kommentar: Ohne Test muss nur die Menge (f_rs, g_rs) gebildet werden. Das geschieht ber die angegebene Gitterfunktion.
        randstruktur_bilden();
// Kommentar: Das resettet das Testfeld fr (f_rs, g_rs). Das wird im Folgenden fr die Vektorisierung gebraucht.
//        randstruktur_reset(); // Wird beim Vektorisieren gelscht. Herausgeommen am 20.8.2015,
        #endif
// Kommentar: Die Klasse RandStrukturKommunikation fhrt die Vektorisierung der Randpunktmenge (f_rs, g_rs) durch.
        vektorisieren();

#ifdef VEKTORISIEREN_TESTEN
        if(randstruktur_leer()==false)
            {
            cout << " Fehler: Code 50: Testfeld nicht leer Rang " << rang << endl;
            exit(-1);
            }

// Kommentar: Optional wird vektorisieren getestet durch einen Vergleich der Auenrandvektorpunktmenge mit der
// Auenrandpunktmenge, die in Gitter ohne Kommunikation bestimmt wurde.

        if((gitterebene==1)&&(rang==0))
            {
            cout << " Code 35: " << randstruktur_kommunikation[1].anzahl_v_vektor_e << " ";
            cout << randstruktur_kommunikation[1].anzahl_h_vektor_e << " ";
            cout << randstruktur_kommunikation[1].punkteanzahl_e << " " << endl;
            }
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vektorisieren_testen 652 " << endl;
#endif
//        vektorisieren_testen(); // Wird gemacht, aber nach der Multi - Level - Randaustausch - Operation.
#endif
        }
    else
// Kommentar: Hier wird das Konzept Sortierung realisiert.
        {
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "1");
        notiz(zeichenkette);
#endif
// Kommentar: Beide Punktmengen mssen genullt werden.
        reset_beide_punktemenge();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "2");
        notiz(zeichenkette);
        cout << " Code D1 vor randstruktur_bilden beide rang " << rang << endl;
#endif
// Kommentar: Dann wird die Randstruktur fr Innenrand und Auenrand durch Sammeln bestimmt. Dabei wird auch die
// dynamische Randstruktur verwendet, um den Rand schnell zu durchlaufen.
        randstruktur_bilden_beide();
#ifdef AKTUELLE_KOMMENTARE
        cout << " Code 9: rang " << rang << " gitterebene " << gitterebene;
        for(i=0; i<groesse; i++)
            {
            cout << " anzahl_rs(" << i << ")" << anzahl_rs[i];
            }
        cout << endl;
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " Code 9: rang " << rang << " gitterebene " << gitterebene;
        for(i=0; i<groesse; i++)
            {
            * da_randstruktur.aus << " anzahl_rs(" << i << ")" << anzahl_rs[i] << " anzahl_a_rs " << anzahl_a_rs[i];
            }
        * da_randstruktur.aus << endl;
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "3");
        notiz(zeichenkette);
#endif
//#ifdef SORTIERUNG_OHNE_TESTFELD // nderung 19.08.2015 // Deswegen lassen 9.2.16
// Kommentar: Normalerweise braucht man beim Konzept Sortierung kein Testfeld. Sonst wrde der Reset Sinn machen.
        randstruktur_reset_testfeld_fuer_beide();
///#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "4");
        notiz(zeichenkette);
#endif
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "RandStruktur bilden beide 3 " << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "5");
        notiz(zeichenkette);
#endif
// Kommentar: Nun werden die Innenrandpunktmenge und die Auenrandpunktmenge sortiert - damit die Innenrandmenge
// von Kern A zu B gleich der Auenrandmenge von Kern B zu A ist - fr jedes Paar (A,B) von Kernen.
        sortieren();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "6");
        notiz(zeichenkette);
#endif
// Die Punktmengenlngen werden nach RandWerteKommunikation kopiert.
        setze_anzahlen();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "7");
        notiz(zeichenkette);
#endif
        #ifdef SORTIEREN_TESTEN
// Kommentar: Optional wird die Auenrandmenge B von mit einer Kommunikation der Innenpunktmenge von A verglichen.
        sortieren_testen_rb();
        #endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "8");
        notiz(zeichenkette);
#endif
        }
    }

// Kommentar: Bildet in beiden Fllen - vektorisieren0 = JA oder NEIN - die jeweiligen Randstrukturen.
void RandStrukturBilden::vorbereiten3(void)
    {
#ifdef AKTUELLE_KOMMENTARE
#ifdef DA_RANDSTRUKTUR
    * da_randstruktur.aus << " In vorbereiten 3 " << endl;
#endif
#endif
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << " In vorbereiten3 / rang " << rang << " gitterebene " << gitterebene << endl;
#endif // AUSGABEN_RANDSTRUKTUR_BILDEN
// Kommentar: Im Fall vektorisieren0 = JA (Kommentar s.o.)
    if(vektorisieren0==JA)
        {
        #ifdef VEKTORISIEREN_TESTEN

        if(randstruktur_leer()==false)
            {
            cout << " Fehler: Code 51: Testfeld nicht leer Rang " << rang << endl;
            exit(-1);
            }

// Kommentar: reset (f_rs, g_rs) und (f_a_rs, g_a_rs)
        reset_beide_punktemenge();
// Kommentar: bilde (f_rs, g_rs) und (f_a_rs, g_a_rs). Die Idee: Man vergleicht dann (f_a_rs, g_a_rs) mit den
// verschickten Vektoren / Punkte - Kombinationen.
        randstruktur_bilden_beide();
#ifdef AKTUELLE_KOMMENTARE
    if((gitterebene==0)&&(rang==0))
        {
        cout << " Code 50: anzahl rs [1] " << anzahl_rs[1] << " anzahl a rs[1] " << anzahl_a_rs[1] << endl;
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " Code 50: anzahl rs [1] " << anzahl_rs[1] << " anzahl a rs[1] " << anzahl_a_rs[1] << endl;
#endif
        }
#endif
// Kommentar: Fr den Vergleich wird ein Testfeld bentigt. Das muss auf false gesetzt werden.
         randstruktur_reset_testfeld_aussenrand(); // Gendert am 20.8.2015
// Kommentar: Sortiert die bestimmten Punktmengen.
        sortieren();
        #else
// Kommentar: Falls kein Test abluft:
// Kommentar: Ohne Test braucht man nur (f_rs,g_rs), und nur diese Menge muss resettet werden.
        reset_punktemenge();
// Kommentar: Ohne Test muss nur die Menge (f_rs, g_rs) gebildet werden. Das geschieht ber die angegebene Gitterfunktion.
        randstruktur_bilden();
// Kommentar: Das resettet das Testfeld fr (f_rs, g_rs). Das wird im Folgenden fr die Vektorisierung gebraucht.
//        randstruktur_reset(); // Wird beim Vektorisieren gelscht. Herausgeommen am 20.8.2015,
        #endif
// Kommentar: Die Klasse RandStrukturKommunikation fhrt die Vektorisierung der Randpunktmenge (f_rs, g_rs) durch.

#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << " Bis vor vektorisieren / rang " << rang << endl;
#endif // AUSGABEN_RANDSTRUKTUR_BILDEN
        vektorisieren();

        packen();

        kommunikation_starten();

        for(;ist_fertig()==false;)
            {
            ;
            }

        entpacken();
        bereinigen();

#ifdef VEKTORISIEREN_TESTEN
        if(randstruktur_leer()==false)
            {
            cout << " Fehler: Code 50: Testfeld nicht leer Rang " << rang << endl;
            exit(-1);
            }

// Kommentar: Optional wird vektorisieren getestet durch einen Vergleich der Auenrandvektorpunktmenge mit der
// Auenrandpunktmenge, die in Gitter ohne Kommunikation bestimmt wurde.

        if((gitterebene==1)&&(rang==0))
            {
            cout << " Code 35: " << randstruktur_kommunikation[1].anzahl_v_vektor_e << " ";
            cout << randstruktur_kommunikation[1].anzahl_h_vektor_e << " ";
            cout << randstruktur_kommunikation[1].punkteanzahl_e << " " << endl;
            }
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vektorisieren_testen 844 " << endl;
#endif
#endif
        }
    else
// Kommentar: Hier wird das Konzept Sortierung realisiert.
        {
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "1");
        notiz(zeichenkette);
#endif
// Kommentar: Beide Punktmengen mssen genullt werden.
        reset_beide_punktemenge();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "2");
        notiz(zeichenkette);
#endif
// Kommentar: Dann wird die Randstruktur fr Innenrand und Auenrand durch Sammeln bestimmt. Dabei wird auch die
// dynamische Randstruktur verwendet, um den Rand schnell zu durchlaufen.
        randstruktur_bilden_beide();
#ifdef AKTUELLE_KOMMENTARE
        cout << " Code 9: rang " << rang << " gitterebene " << gitterebene;
        for(i=0; i<groesse; i++)
            {
            cout << " anzahl_rs(" << i << ")" << anzahl_rs[i];
            }
        cout << endl;
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " Code 9: rang " << rang << " gitterebene " << gitterebene;
        for(i=0; i<groesse; i++)
            {
            * da_randstruktur.aus << " anzahl_rs(" << i << ")" << anzahl_rs[i] << " anzahl_a_rs " << anzahl_a_rs[i];
            }
        * da_randstruktur.aus << endl;
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "3");
        notiz(zeichenkette);
#endif
        randstruktur_reset_testfeld_fuer_beide();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "4");
        notiz(zeichenkette);
#endif
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "RandStruktur bilden beide 3 " << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "5");
        notiz(zeichenkette);
#endif
// Kommentar: Nun werden die Innenrandpunktmenge und die Auenrandpunktmenge sortiert - damit die Innenrandmenge
// von Kern A zu B gleich der Auenrandmenge von Kern B zu A ist - fr jedes Paar (A,B) von Kernen.
        sortieren();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "6");
        notiz(zeichenkette);
#endif
// Die Punktmengenlngen werden nach RandWerteKommunikation kopiert.
        setze_anzahlen();
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "7");
        notiz(zeichenkette);
#endif
        #ifdef SORTIEREN_TESTEN
// Kommentar: Optional wird die Auenrandmenge B von mit einer Kommunikation der Innenpunktmenge von A verglichen.
        sortieren_testen_rb();
        #endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "8");
        notiz(zeichenkette);
#endif
        }
    }

void RandStrukturBilden::test_vektorisieren(int wo)
    {
#ifdef AKTUELLE_KOMMENTARE
#ifdef DA_RANDSTRUKTUR
    * da_randstruktur.aus << " vektorisieren_testen 932 " << wo << endl;
#endif
#endif
    vektorisieren_testen();
#ifdef VEKTORISIEREN_TESTEN
    randstruktur_reset_testfeld_aussenrand_abschliessen();
#endif
    }

// Kommentar: Man vergleiche diese Funktion mit vorbereiten2. Der Sinn ist derselbe, die Rnder fr den Randaustausch
// bereitzustellen, und ggf. die Strukturen zu testen.
void RandStrukturBilden::updaten_rand(int k, int t)
    {
    if(vektorisieren0==JA)
        {
#ifdef AUSGABEN
        cout << "Zu Beginn von updaten_rand. Rang " << rang << endl;
#endif
        #ifdef VEKTORISIEREN_TESTEN
        reset_beide_punktemenge();
        randstruktur_bilden_beide();
        reset_testfeld_a_rs();
        sortieren();
        setze_anzahlen();
        #else
        reset_punktemenge();
#ifdef AUSGABEN
        cout << "Randstruktur reset durch " << endl;
#endif
        randstruktur_bilden();
        randstruktur_reset();
        #endif
#ifdef AUSGABEN
        cout << "Vor Vektorisieren in RandStrukturBilden " << endl;
#endif
        vektorisieren();
#ifdef AUSGABEN
        cout << "Vektorisieren in RandStrukturBilden ausgefuehrt " << endl;
#endif
        packen();
#ifdef AUSGABEN
        cout << "Durch Packen durch. Rang " << rang << endl;
#endif
        kommunikation_starten();
#ifdef AUSGABEN
        cout << "Durch Kommunikation_starten durch. Rang  " << rang << " k " << k << " t " << t << endl;
#endif
        for(;ist_fertig()==false;)
            {
            ;
            }
#ifdef AUSGABEN
        cout << "Durch ist_fertig durch " <<  rang << " k " << k << " t " << t << endl;
#endif
        entpacken();
        bereinigen();


#ifdef VEKTORISIEREN_TESTEN
#ifdef DA_RANDSTRUKTUR
        * da_randstruktur.aus << " vektorisieren_testen 790 " << endl;
#endif
        vektorisieren_testen();
#endif
#ifdef BESTIMME_INNENPUNKTE
        bestimme_innenpunkte();
#endif
        }
    else
        {
        reset_beide_punktemenge();
        randstruktur_bilden_beide();
        reset_beide();
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
        cout << "RandStruktur bilden beide 4 " << endl;
#endif
        sortieren();
        setze_anzahlen(); // Erst einmal sehen, ob das so geht.
        #ifdef SORTIEREN_TESTEN
        sortieren_testen_rb();
        #endif
#ifdef BESTIMME_INNENPUNKTE
        bestimme_innenpunkte();
#endif
        }
    }

// Kommentar: Diese Funktion wird nicht aufgerufen, und wird daher nicht gebraucht.
int RandStrukturBilden::aussenrand_bilden(void)
    {
    if(vektorisieren0==JA)
        {
        return(aussenrand_bilden_durch_vektoren());
        }
    else
        {
        return(aussenrand_bilden_bei_sortierung());
        }
    }

// Kommentar: Diese Funktion hat den Zweck, je nach Rang lnger zu warten, damit die cout - Ausgaben
// in der Reihenfolge der Rnge und damit strukturiert statt durcheinander erfolgen.
void RandStrukturBilden::verzoegern(void)
    {
#ifdef AUSGABEN
    #ifdef WARTEN
    int i;

    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
    cout << "------------------------------------------------------ Rang " << rang << endl;
    #endif
#endif
    }

// Kommentar: Eine Ausgabe zu Debugging - Zwecken.
void RandStrukturBilden::notiz(char * text)
    {
    if((rang==3)&&(t==2))
        {
        cout << " RSBnotiz " << text << endl;
        }
    }

#ifdef GEMEINSAME_BUFFER_SI
#ifdef GEMEINSAME_BUFFER
// Kommentar: Diese Initialisierung nimmt die Randstrukturen aus, und kann daher nur fr
// sequentielles Rechnen - oberhalb von h_kappe - eingesetzt werden.
void RandStrukturBilden::initialisieren_ohne_rand(int _n, int _m, int _groesse, int _rang, double ** sendebuffer, double ** empfangsbuffer, short int ** sendebuffer_si, short int ** empfangsbuffer_si)
#else
void RandStrukturBilden::initialisieren_ohne_rand(int _n, int _m, int _groesse, int _rang, short int ** sendebuffer_si, short int ** empfangsbuffer_si)
#endif
#else
#ifdef GEMEINSAME_BUFFER
void RandStrukturBilden::initialisieren_ohne_rand(int _n, int _m, int _groesse, int _rang, double ** sendebuffer, double ** empfangsbuffer)
#else
void RandStrukturBilden::initialisieren_ohne_rand(int _n, int _m, int _groesse, int _rang)
#endif
#endif
// wird richtig finalisiert
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " initialisieren ohne_rand Beginn rang " << _rang << " gitterebene " << gitterebene << endl;
#endif
// Kommentar: Die Parameter n, m, groesse und rang werden bis zur Urvater - Klasse SituationsDaten verfgbar gemacht.
// Darauf kann auch die Klasse Randstruktur zugreifen.
    initialisieren_SD( _n, _m, _groesse, _rang); // legt keinen Speicher an.
// Kommentar: Alle Strukturen der Klasse Gitter werden damit initialisiert.
    initialisieren_gitter( _n, _m, _groesse, _rang);
    // finalisieren_gitter befreit das wieder, siehe gitter.cpp


// Kommentar: Je nach der Prprozessorvariablen AUSGABEN_GITTER werden Farbenfeld und Selbstnachbarn ausgegeben.
    ausgeben_farbenfeld();
    ausgeben_selbstnachbarn();

#ifdef AKTUELLE_KOMMENTARE
    cout << " initialisieren Mitte 1 rang " << _rang << endl;
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " initialisieren Mitte 2 rang " << _rang << endl;
#endif

#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << "Durch ausgeben_empfangen durch " << endl;
#endif
#ifdef BESTIMME_INNENPUNKTE
// Kommentar: Diese Funktion wird hier nicht aufgerufen.
    bestimme_innenpunkte();
#endif
#ifdef AUSGABEN_RANDSTRUKTUR_BILDEN
    cout << "Durch bestimme innenpunkte durch " << endl;
#endif
// Kommentar: Hier werden die MLAT - Variablen nach variable1 - variable7 geschrieben - nach RandStrukturkommunikation oder
// RandWerteKommunikation.
    setze_MLAT_variablen();
#ifdef AKTUELLE_KOMMENTARE
    cout << " RS:init Ende rang " << rang << " n " << n << endl;
#endif
    }
