#include "randstruktur_kommunikation.h"

// Kommentar: Gebe die Randvektoren und Randpunkte aus, die per Kommunikation empfangen wurden. Das ist der Auenrand.
// Aber nur fr den Kern, der dieser Klasse zugeordnet ist.

void RandStrukturKommunikation::ausgeben_empfangen(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << " Code A1: Empfangs . Rang " << rang << " Anzahl H-Vektor_e " << anzahl_h_vektor_e << " Anzahl V-Vektor_e " << anzahl_v_vektor_e << " Punktanzahl_e " << punkteanzahl_e << endl;

// Kommentar: Gebe die horizontalen Vektoren des Auenrandes aus.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        cout << "Empfangs H-Vektor Nr. " << i << " | f " << f_h_vektor_e[i] << " | g1 " << g1_h_vektor_e[i] << " | g2 " << g2_h_vektor_e[i] << " Farbe " << eigenfarbe << " Rang " << rang << endl;
        }
// Kommentar: Gebe die vertikalen Vektoren des Auenrandes aus.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        cout << "Empfangs V-Vektor Nr. " << i << " | f1 " << f1_v_vektor_e[i] << " | f2 " << f2_v_vektor_e[i] << " | g " << g_v_vektor_e[i] << " Farbe " << eigenfarbe << " Rang " << rang << endl;
        }
// Kommentar: Gebe die restlichen Punkte des Auenrandes aus.
    for(i=0; i<punkteanzahl_e; i++)
        {
        cout << "Empfangs Einzelpunkt f " << f_e[i] << " | g " << g_e[i] << " Farbe " << eigenfarbe << " Rang " << rang << endl;
        }
    cout << "RandStrukturKommunikation Ende " << endl;
#endif
    }

// Kommentar: Hier wird in die Punktemenge (f_e,g_e) die Punkte der Vektorenlisten hinzugefgt. Nach Abschlu dieser
// Funktion hat man eine Auenrandpunktmenge - wie bei der RandWerteKommunikation. Man mte nur noch dasselbe fr
// die Innenrandpunktmenge machen, und knnte dann einen punktbasierten Randaustausch vornehmen.

void RandStrukturKommunikation::erzeuge_aussen_punkte(void)
    {
// Kommentar: bernehme die Punktmenge (f_e,g_e) bis zur punkteanzahl_e. punkteanzahl_alle ist die
//  Punkteanzahl aller Punkte.
    punkteanzahl_alle = punkteanzahl_e;
// Kommentar: Fge die Punkte der horizontalen Vektoren hinzu.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        for(j=g1_h_vektor_e[i]; j<=g2_h_vektor_e[i]; j++)
            {
            f_e[punkteanzahl_alle] = f_h_vektor_e[i];
            g_e[punkteanzahl_alle] = j;
            punkteanzahl_alle++;
            }
        }
// Kommentar: Frge die Punkte der vertikalen Vektoren hinzu.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        for(j=f1_v_vektor_e[i]; j<=f2_v_vektor_e[i]; j++)
            {
            f_e[punkteanzahl_alle] = j;
            g_e[punkteanzahl_alle] = g_v_vektor_e[i];
            punkteanzahl_alle++;
            }
        }
    }
#ifdef KURZ_TESTFELD
// Kommentar: Gebe das in der Vaterklasse RandStrukturPV definierte testfeld aus.
void RandStrukturKommunikation::gebe_testfeld_aus(bool ** testfeld)
#else
void RandStrukturKommunikation::gebe_testfeld_aus(int ** testfeld)
#endif
    {
// Kommentar: Zu Beginn wird ggf. zur Strukturierung der Ausgabe in Abhngigkeit des Randes gewartet.
#ifdef WARTEN
    verzoegern();
#endif
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << "Testfeld . Rang " << rang << " Farbe " << eigenfarbe << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << testfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Testfeld Ende " << endl;
#endif
    }

#ifdef KURZ_TESTFELD
// Kommentar: Das Testfeld wird mit den Auenrandpunkten markiert.
void RandStrukturKommunikation::schreibe_aussen_testfeld(bool ** testfeld)
#else
void RandStrukturKommunikation::schreibe_aussen_testfeld(int ** testfeld)
#endif
    {
// Kommentar: Markiere das Testfeld mit den horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        for(j=g1_h_vektor_e[i]; j<=g2_h_vektor_e[i]; j++)
            {
            testfeld[f_h_vektor_e[i]][j] = true;
            }
        }
// Kommentar: Markiere das Testfeld mit den vertikalen Vektoren.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        for(j=f1_v_vektor_e[i]; j<=f2_v_vektor_e[i]; j++)
            {
            testfeld[j][g_v_vektor_e[i]] = true;
            }
        }
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    if(punkteanzahl_e!=0)
        {
        cout << "RSK Rang " << rang << " Farbe " << eigenfarbe << " Punkteanzahl " << punkteanzahl_e << endl;
        }
#endif
// Kommentar: Markiere das Testfeld mit den verbliebenen Punkten.
    for(i=0; i<punkteanzahl_e; i++)
        {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << " f " << f_e[i] << " g " << g_e[i] << " / ";
#endif
        testfeld[f_e[i]][g_e[i]] = true;
        }
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << endl;
#endif
    }

// Kommentar: Mit dieser Funktion wird ep_aktuell, das Feld der aktuellen Eigenschaftspunkte, bergeben.
// Allerdings werden die Zeiger von ep_aktuell und ep_vergangen immer wieder gegeneinander vertauscht, d.h.
// diese Funktion muss in jeder Interation einmal aufgerufen werden.
void RandStrukturKommunikation::initialisieren_kommunikation_ep(short int ** _ep_aktuell)
    {
    ep_aktuell = _ep_aktuell;
    }

#ifdef dimensionen1
// Kommentar: Hier wird fr die per Kommunikation empfangenen Auenrandstrukturen Speicher angelegt.
void RandStrukturKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0)
#endif
#ifdef dimensionen2
void RandStrukturKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1)
#endif
#ifdef dimensionen3
void RandStrukturKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1, double ** _x2, double ** _y2)
#endif
#ifdef dimensionen4
void RandStrukturKommunikation::initialisieren_kommunikation(double ** _x0, double ** _y0, double ** _x1, double ** _y1, double ** _x2, double ** _y2, double ** _x3, double ** _y3)
#endif
// wird richtig finalisiert
    {
// Kommentar: Zuerst werden Variablen bergeben.

    #ifdef dimensionen1
    x0 = _x0;
    y0 = _y0;
    #endif

    #ifdef dimensionen2
    x0 = _x0;
    y0 = _y0;
    x1 = _x1;
    y1 = _y1;
    #endif

    #ifdef dimensionen3
    x0 = _x0;
    y0 = _y0;
    x1 = _x1;
    y1 = _y1;
    x2 = _x2;
    y2 = _y2;
    #endif

    #ifdef dimensionen4
    x0 = _x0;
    y0 = _y0;
    x1 = _x1;
    y1 = _y1;
    x2 = _x2;
    y2 = _y2;
    x3 = _x3;
    y3 = _y3;
    #endif

#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << "f1_v_vektor_e m+n+10 " << m+n+10 << endl;
#endif

#ifdef KURZ_RAND_ELEMENTE

// Kommentar: Und dann wird fr die vertikalen Vektoren Speicher angelegt.
    f1_v_vektor_e = new short int [mn+10];

    f2_v_vektor_e = new short int [mn+10];
    g_v_vektor_e = new short int [mn+10];
// Kommentar: Und dann wird fr die horizontalen Vektoren Speicher angelegt.
    f_h_vektor_e = new short int [mn+10];
    g1_h_vektor_e = new short int [mn+10];
    g2_h_vektor_e = new short int [mn+10];
// Kommentar: Und dann wird fr die verbliebenen Punkte Speicher angelegt.
    f_e = new short int [mn+100];
    g_e = new short int [mn+100];
#else

// Kommentar: Wie eben, nur das Integerwerte allokiert werden.
    f1_v_vektor_e = new int [mn+10];

    f2_v_vektor_e = new int [mn+10];
    g_v_vektor_e = new int [mn+10];

    f_h_vektor_e = new int [mn+10];
    g1_h_vektor_e = new int [mn+10];
    g2_h_vektor_e = new int [mn+10];


    f_e = new int [mn+100];
    g_e = new int [mn+100];
#endif

// Kommentar: Die drei Strukturen vertikale Vektoren, horizontale Vektoren und Restpunktmenge werden leer angelegt-
    anzahl_v_vektor_e = 0;
    anzahl_h_vektor_e = 0;
    punkteanzahl_e = 0;
    }

// Kommentar: Hier werden die aufgelisteten Variablen an diese Klasse bergeben: u0, gg_u0,r0, f0, Iu0, rS0, e0, Lu0
// und u0_hilf, damit in diese Variablen entpackt werden kann, und sie beim Packen gelesen werden knnen.
void RandStrukturKommunikation::initialisieren_kommunikation_rest(double ** _u0, double ** _gg_u0, double ** _r0, double ** _f0, double ** _Iu0, double ** _rS0, double ** _e0, double ** _Lu0, double ** _u0_hilf)
    {
    u0 = _u0;
    gg_u0 = _gg_u0;
    r0 = _r0;
    f0 = _f0;
    Iu0 = _Iu0;
    rS0 = _rS0;
    e0 = _e0;
    Lu0 = _Lu0;
    u0_hilf = _u0_hilf;
    }

#ifdef GEMEINSAME_BUFFER
// Kommentar: Hier werden der Klasse ein Sende - und Empfangsbuffer zur Verfgung gestellt - entweder von
// woanders zum Mitbenutzen, also Speicherplatzsparen zur Verfgung gestellt, oder hier angelegt.
void RandStrukturKommunikation::initialisieren_werte(double * _sende_werte_buffer, double * _empfange_werte_buffer)
    {
// Kommentar: Hier werden der Sende - und Empfangsbuffer bergeben.
    sende_werte_buffer = _sende_werte_buffer;
    empfange_werte_buffer = _empfange_werte_buffer;
    }
#else
void RandStrukturKommunikation::initialisieren_werte(void)
// wird korrekt finalisiert, s.u.
    {
// Kommentar: Hier werden der Sende - und Empfangsbuffer angelegt.
    sende_werte_buffer = new double [mn+100];
    empfange_werte_buffer = new double [mn+100];
    }
#endif

// Kommentar: Hier werden die Auenrandstrukturen vom belegten Speicherplatz befreit.
void RandStrukturKommunikation::finalisieren_kommunikation(void)
    {

// Kommentar: Deallokiere den Speicher fr die vertikalen Vektoren.
    delete f1_v_vektor_e;

    delete f2_v_vektor_e;
    delete g_v_vektor_e;

// Kommentar: Deallokiere den Speicher fr die horizontalen Vektoren.
    delete f_h_vektor_e;
    delete g1_h_vektor_e;
    delete g2_h_vektor_e;

// Kommentar: Deallokiere den Speicher fr die Restpunktmenge.
    delete f_e;
    delete g_e;
    }

// Kommentar: Falls fr die Buffer zur Wertekommunikation Speicher angelegt wurde, wird der jetzt wieder an dsa System
// zurckgegeben.
void RandStrukturKommunikation::finalisieren_werte(void)
    {
#ifndef GEMEINSAME_BUFFER
    delete sende_werte_buffer;
    delete empfange_werte_buffer;
#endif
    }

// Kommentar: Die ep - Information wird - entsprechend der bergebenen Struktur ep_aktuell - gepackt in den Sendebuffer.
void RandStrukturKommunikation::packen_ep(void)
    {
// Kommentar: Der Bufferindex wird auf den Bufferanfang gesetzt.
    k=0;

// Kommentar: Die vertikale Vektormenge wird durchlaufen.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
// Kommentar: Der vertikale Vektor wird durchlaufen.
        for(j = a; j<=b; j++)
            {
// Kommentar: Fr die einzelnen Punkte wird ep_aktuell in den Sendebuffer kopiert, wobei der Sendebufferindex inkrementiert wird.
            sendebuffer_ep[k++] = ep_aktuell[j][c];
            }
        }

// Kommentar: Mache dasselbe fr die horizontale Vektormenge.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];
        for(j = b; j<=c; j++)
            {
            sendebuffer_ep[k++] = ep_aktuell[a][j];
            }
        }

// Kommentar: Kopiere ep_aktuell in Bezug auf die Restpunktmenge in den Sendebuffer.
    for(i=0; i<punkteanzahl; i++)
        {
        sendebuffer_ep[k++] = ep_aktuell[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Die ep - Information wird - entsprechend der bergebenen Struktur ep_aktuell - entpackt aus dem Empfangsbuffer.
void RandStrukturKommunikation::entpacken_ep(void)
    {
// Kommentar: Der Bufferindex wird auf den Bufferanfang gesetzt.
    k=0;
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << "Anfang entpacken werte " << endl;
#endif
// Kommentar: Die vertikale Vektormenge wird durchlaufen.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << "VVektor: f1 " << a << " f2 " << b << " g " << c << endl;
#endif
// Kommentar: Der vertikale Vektor wird durchlaufen.
        for(j = a; j<=b; j++)
            {
// Kommentar: Fr die einzelnen Punkte wird ep_aktuell aus dem Empfangsbuffer kopiert, wobei der Empfangsbufferindex
// inkrementiert wird.
            ep_aktuell[j][c] = empfangsbuffer_ep[k++];
            }
        }

// Kommentar: Mache dasselbe fr die horizontale Vektormenge.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << "HVektor f " << a << " g1 " << b << " g2 " << c  << endl;
#endif
        for(j = b; j<=c; j++)
            {
            ep_aktuell[a][j] = empfangsbuffer_ep[k++];
            }
        }

// Kommentar: Kopiere in die Variable ep_aktuell in Bezug auf die Restpunktmenge aus dem Empfangsbuffer.
    for(i=0; i<punkteanzahl_e; i++)
        {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << "Punkt f " << f_e[i] << " g " << g_e[i] << endl;
#endif
        ep_aktuell[f_e[i]][g_e[i]] = empfangsbuffer_ep[k++];
        }
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << "Ende entpacken Werte" << endl;
#endif
    }

// Kommentar: Diese Funktion packt die Innenrandstruktur dieser Klasse in einen Sendebuffer.
// Die Idee dabei: Die verschickte Innenrandstruktur wird zur Auenrandstruktur des empfangenden Kerns.
void RandStrukturKommunikation::packen(void)
    {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << "Packen in RandStrukturKommunikation. Rang " << rang << endl;

    if((komm_farbe==2)&&(rang==0)&&(gitterebene==0))
        {
        cout << " Code 41: a_v " << anzahl_v_vektor << " a_h " << anzahl_h_vektor << " p " << punkteanzahl << endl;
        }
#endif

// Kommentar: Zuerst ist die Lnge der Vektormengen und der Punktmenge in den Sendebuffer zu schreiben.
    sendebuffer[0] = anzahl_v_vektor;
    sendebuffer[1] = anzahl_h_vektor;
    sendebuffer[2] = punkteanzahl;

// Kommentar: Alle weiteren Eintrge werden ab dem dritten Element in den Buffer eingetragen.
    k = 3;

// Kommentar: Trage die Koordinaten aller vertikalen Vektoren in den Buffer ein.
    for(i=0; i<anzahl_v_vektor; i++)
        {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << "f1 " << f1_v_vektor[i] << " f2 " << f2_v_vektor[i] << " g " << g_v_vektor[i] << endl;
#endif
        sendebuffer[k] = f1_v_vektor[i];
        k++;
        sendebuffer[k] = f2_v_vektor[i];
        k++;
        sendebuffer[k] = g_v_vektor[i];
        k++;
        }

// Kommentar: Trage die Koordinaten aller horizontalen Vektoren in den Buffer ein.
    for(i=0; i<anzahl_h_vektor; i++)
        {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << " f " << f_h_vektor[i] << " g1 " << g1_h_vektor[i] << " g2 " << g2_h_vektor[i] << endl;
#endif
        sendebuffer[k] = f_h_vektor[i];
        k++;
        sendebuffer[k] = g1_h_vektor[i];
        k++;
        sendebuffer[k] = g2_h_vektor[i];
        k++;
        }
// Kommentar: Trage die Koordinaten aller verbliebenen Punkte in den Buffer ein.
    for(i=0; i<punkteanzahl; i++)
        {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
        cout << " f " << f_rs[i] << " g " << g_rs[i] << endl;
#endif
        sendebuffer[k] = f_rs[i];
        k++;
        sendebuffer[k] = g_rs[i];
        k++;
        }
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << "Ende Packen. Rang " << rang << endl;
#endif
    }

// Kommentar: Diese Funktion packt die Innenrandstruktur dieser Klasse in einen Sendebuffer. Im Gegensatz
// zur vorhergehenden Funktion packen muss das nicht ab dem ersten Bufferelement erfolgen, sondern
// ab einer beliebigen Stelle des Buffers. Dazu wird am Ende der Sendebufferindex zurckgegeben, so dass
// man diese Beschreibungen des Buffers aneinanderhngen kann.
// Bemerkung: Auch hier ist die Idee: Die verschickte Innenrandstruktur wird zur Auenrandstruktur des empfangenden Kerns.

int RandStrukturKommunikation::schreibe_in_sendebuffer(int _sendebuffer_index)
    {
    sendebuffer_index = _sendebuffer_index;

// Kommentar: Zuerst ist die Lnge der Vektormengen und der Punktmenge in den Sendebuffer zu schreiben.
    sendebuffer[sendebuffer_index++] = anzahl_v_vektor;
    sendebuffer[sendebuffer_index++] = anzahl_h_vektor;
    sendebuffer[sendebuffer_index++] = punkteanzahl;

// Kommentar: Alle weiteren Eintrge werden ab dem auf die 3 Eintrge folgenden Element in den Buffer eingetragen.
    k = sendebuffer_index;

// Kommentar: Trage die Koordinaten aller vertikalen Vektoren in den Buffer ein.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        sendebuffer[k] = f1_v_vektor[i];
        k++;
        sendebuffer[k] = f2_v_vektor[i];
        k++;
        sendebuffer[k] = g_v_vektor[i];
        k++;
        }

// Kommentar: Trage die Koordinaten aller horizontalen Vektoren in den Buffer ein.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        sendebuffer[k] = f_h_vektor[i];
        k++;
        sendebuffer[k] = g1_h_vektor[i];
        k++;
        sendebuffer[k] = g2_h_vektor[i];
        k++;
        }

// Kommentar: Trage die Koordinaten aller verbliebenen Punkte in den Buffer ein.
    for(i=0; i<punkteanzahl; i++)
        {
        sendebuffer[k] = f_rs[i];
        k++;
        sendebuffer[k] = g_rs[i];
        k++;
        }
// Kommentar: Gebe den Sendebufferindex zurck.
    return(k);
    }

// Kommentar: Dieses ist die spiegelbildliche Funktion zu 'schreibe_in_sendebuffer'. Es werden aus den empfangenen
// Vektoren und Punkte die Auenrandstruktur gebildet. Mit dem Vektorisieren und dieser Innenrand - zu Auenrand - Kommunikation
// hat man nachher die Mglichkeit zum Randaustausch nur mit den Werten der Variablen.
int RandStrukturKommunikation::lese_aus_empfangsbuffer(int _empfangsbuffer_index)
    {
    empfangsbuffer_index = _empfangsbuffer_index;

// Kommentar: Zuerst werden die Anzahlen an Vektoren sowie die Anzahl an Punkten gelesen.
    anzahl_v_vektor_e = empfangsbuffer[empfangsbuffer_index++];
    anzahl_h_vektor_e = empfangsbuffer[empfangsbuffer_index++];
    punkteanzahl_e = empfangsbuffer[empfangsbuffer_index++];

    l = empfangsbuffer_index;

// Kommentar: Dann werden die vertikalen Vektoren eingelesen.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        f1_v_vektor_e[i] = empfangsbuffer[l];
        l++;
        f2_v_vektor_e[i] = empfangsbuffer[l];
        l++;
        g_v_vektor_e[i] = empfangsbuffer[l];
        l++;
        }

// Kommentar: Dann werden die horizontalen Vektoren eingelesen.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        f_h_vektor_e[i] = empfangsbuffer[l];
        l++;
        g1_h_vektor_e[i] = empfangsbuffer[l];
        l++;
        g2_h_vektor_e[i] = empfangsbuffer[l];
        l++;
        }

// Kommentar: Am Ende werden die Punkte eingelesen.
    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e[i] = empfangsbuffer[l];
        l++;
        g_e[i] = empfangsbuffer[l];
        l++;
        }
    return(l);
    }

// Kommentar: Bei keinem gemeinsamen Rand wird nicht kommuniziert, sondern gelscht.
void RandStrukturKommunikation::bereinigen(void)
    {
    anzahl_v_vektor_e = 0;
    anzahl_h_vektor_e = 0;
    punkteanzahl_e = 0;
    }

// Kommentar: Diese Funktion ist hnlich zu der Funktion 'lese_aus_empfangsbuffer', nur dass hier direkt
// an den Anfang des Buffers geschrieben wird - statt die Anfangsposition offen zu lassen - und dass
// der Empfangsbufferindex nicht zurckgegeben wird. Damit kann man hier aneinandergehngte Eintrge
// verschiedener Auenrandstrukturen nicht aus einem gemeinsamen Buffer entpacken - im Gegensatz zur Funktion
// 'lese_aus_empfangsbuffer'.
// Bemerkung: Da analog zu 'lese_aus_empfangsbuffer' - mit den genannten Einschrnkungen - wird hier nicht weiter kommentiert.
void RandStrukturKommunikation::entpacken(void)
    {
    anzahl_v_vektor_e = empfangsbuffer[0];
    anzahl_h_vektor_e = empfangsbuffer[1];
    punkteanzahl_e = empfangsbuffer[2];

    l = 3;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        f1_v_vektor_e[i] = empfangsbuffer[l];
        l++;
        f2_v_vektor_e[i] = empfangsbuffer[l];
        l++;
        g_v_vektor_e[i] = empfangsbuffer[l];
        l++;
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        f_h_vektor_e[i] = empfangsbuffer[l];
        l++;
        g1_h_vektor_e[i] = empfangsbuffer[l];
        l++;
        g2_h_vektor_e[i] = empfangsbuffer[l];
        l++;
        }
    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e[i] = empfangsbuffer[l];
        l++;
        g_e[i] = empfangsbuffer[l];
        l++;
        }
    }

// Kommentar: Hier wird die Kommunikation von eingetragenen Werten zwecks Randaustausch initiiert.
void RandStrukturKommunikation::werte_kommunikation_starten(void)
    {
// Kommentar: Der Wert eigenfarbe gibt die ID des Partnerkerns an. Unter dieser ID ist diese Klasse RSK in der
// Klasse RandStruktur angelegt. k ist die Lnge des Buffers, und es werden double - Werte verschickt.
    MPI_Isend(sende_werte_buffer, k, MPI_DOUBLE, eigenfarbe, 1, MPI_COMM_WORLD, & sende_request);
// Kommentar: Empfangen wird auch vom Partnerkern mit der ID eigenfarbe, und mn+100 ist die maximale Bufferlnge.
// Es werden auch double - Werte verschickt.
    MPI_Irecv(empfange_werte_buffer, mn+100, MPI_DOUBLE, eigenfarbe, 1, MPI_COMM_WORLD, & empfangs_request);
    }

// Kommentar: Hier wird die Kommunikation gestartet, die zur Bildung des Auenrandes - durch verschicken
// der Innenrandstruktur - bentigt wird. Die eigenfarbe ist die Farbe, unter der diese Klasse in
// der Klasse Randstruktur abgespeichert ist - und bestimmt die Farbe des Kerns, in Bezug auf den der Randaustausch
// erfolgen soll. Es werden Integer oder Short Integer verschickt, und k ist die Sendebufferlnge, und die
// maximale Empfangsbufferlnge ist mn+100.
void RandStrukturKommunikation::kommunikation_starten(void)
    {
#ifdef KURZ_RK
    MPI_Isend(sendebuffer, k, MPI_SHORT, eigenfarbe, 0, MPI_COMM_WORLD, & sende_request);
    MPI_Irecv(empfangsbuffer, mn+100, MPI_SHORT, eigenfarbe, 0, MPI_COMM_WORLD, & empfangs_request);
#else
    MPI_Isend(sendebuffer, k, MPI_INT, eigenfarbe, 0, MPI_COMM_WORLD, & sende_request);
    MPI_Irecv(empfangsbuffer, mn+100, MPI_INT, eigenfarbe, 0, MPI_COMM_WORLD, & empfangs_request);
#endif
    }

// Kommentar: Hier ist eine Kommunikation zum Randaustausch der ep - Information. Die Buffer, mit denen
// gearbeitet wird, lauten sendebuffer_ep und empfangsbuffer_ep. Die Lngen werden auf ein Vielfaches der Zahl 8
// angehoben, und es werden Bytes verschickt - ein Byte fr ein Flag. Fr alles weitere - wie die eigenfarbe -
// vergleiche man die Kommentare der vorangehenden Kommunikationen.
void RandStrukturKommunikation::kommunikation_starten_ep(void)
    {
    MPI_Isend(sendebuffer_ep, ((k>>3)+1)<<3, MPI_BYTE, eigenfarbe, 3, MPI_COMM_WORLD, & sende_request_ep);
    MPI_Irecv(empfangsbuffer_ep, (((mn+100)>>3)+1)<<3, MPI_BYTE, eigenfarbe, 3, MPI_COMM_WORLD, & empfangs_request_ep);
    }

// Kommentar: Hier wird mit Hilfe von sende_request_ep und empfangs_request_ep getestet, ob die Kommunikationen
// der ep - Randinformation abgeschlossen sind. Falls nein, so gebe false zurck. Ist das Senden und Empfangen
// abgeschlossen, so wird true zurckgegeben.
bool RandStrukturKommunikation::ist_fertig_ep(void)
    {

    MPI_Test(& sende_request_ep, &flag, & sende_status);
    if(flag==false)
        {
        return(false);
        }


    MPI_Test(& empfangs_request_ep, &flag, & empfangs_status);

    if(flag==false)
        {
        return(false);
        }

    return(true);
    }

// Kommentar: Hier wird mit Hilfe von sende_request und empfangs_request getestet, ob die Kommunikationen
// entweder der Werte oder der Innenrandstruktur abgeschlossen sind. Falls nein, so gebe false zurck. Ist das Senden und Empfangen
// abgeschlossen, so wird true zurckgegeben.
bool RandStrukturKommunikation::ist_fertig(void)
    {

    MPI_Test(& sende_request, &flag, & sende_status);
    if(flag==false)
        {
        return(false);
        }


    MPI_Test(& empfangs_request, &flag, & empfangs_status);

    if(flag==false)
        {
        return(false);
        }

    return(true);
    }

// Kommentar: Zu Debugging - Zwecken wurde entsprechend dem Rang der Programmablauf verzgert - fr eine
// strukturiertere Ausgabe.
void RandStrukturKommunikation::verzoegern(void)
    {
#ifdef AUSGABEN
    #ifdef WARTEN
    int i;

    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
    cout << "------------------------------------------------------ Rang " << rang << endl;
    #endif
#endif
    }

//int RandStrukturKommunikation::aussenrand_bestimmen(short int * f_gesamt, short int * g_gesamt, int anzahl_gesamt, short int ** testfeld_aussenrand)

// Kommentar: Hier werden die Punkte des Auenrandes in eine Liste (f_aussen,g_aussen) kopiert, und das testfeld_aussen
// dort markiert. Dieses geschieht in (f_aussen,g_aussen) ab der angegebenen Adresse.
// Bemerkung: Bereits markierte Punkte werden nicht in die Liste aufgenommen.
int RandStrukturKommunikation::aussenrand_bestimmen(int anzahl_aussen)
    {
// Kommentar: Die Position, an die die Koordinaten geschrieben werden sollen, wird von der bergebenen Variablen bernommen.
    pos = anzahl_aussen;

// Kommentar: Die Restpunktliste wird durchlaufen ...
    for(i=0; i<punkteanzahl_e; i++)
        {
        j = f_e[i];
        k = g_e[i];

// Kommentar: ... und im Falle eines nicht markierter Punktes, wird der markiert und in die Punktliste aufgenommen.
        if(testfeld_aussen[j][k]==false)
            {
            f_aussen[pos] = j;
            g_aussen[pos++] = k;
            testfeld_aussen[j][k] = true;
            }
        }

// Kommentar: Man mache selbiges fr die Punktemengen der horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        j = f_h_vektor_e[i];
        k1 = g1_h_vektor_e[i];
        k2 = g2_h_vektor_e[i];
        for(l=k1; l<=k2; l++)
            {
            if(testfeld_aussen[j][l]==false)
                {
                f_aussen[pos] = j;
                g_aussen[pos++] = l;
                testfeld_aussen[j][l] = true;
                }
            }
        }

// Kommentar: Und man mache selbiges fr die Punktemengen der vertikalen Vektoren.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        j1 = f1_v_vektor_e[i];
        j2 = f2_v_vektor_e[i];
        k = g_v_vektor_e[i];
        for(l=j1; l<=j2; l++)
            {
            if(testfeld_aussen[l][k]==false)
                {
                f_aussen[pos] = l;
                g_aussen[pos++] = k;
                testfeld_aussen[l][k] = true;
                }
            }
        }
// Kommentar: Am Ende wird die Position auf den nchsten Eintrag zurckgegeben.
    return(pos);
    }

// Kommentar: Hier wird zurckgegeben, aus wievielen Punkten der Auenrand besteht.
int RandStrukturKommunikation::anzahl_punkte_aussen(void)
    {
// Kommentar: Das hier ist die Zahl der Restpunkte.
    pos = punkteanzahl_e;

// Kommentar: Die horizontalen Vektoren werden durchlaufen, und die Lnge der Vektoren (k2-k1+1) wird zu pos hinzuaddiert.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        k1 = g1_h_vektor_e[i];
        k2 = g2_h_vektor_e[i];

        pos = pos + (k2-k1+1);
        }

// Kommentar: Die vertikalen Vektoren werden durchlaufen, und die Lnge der Vektoren (j2-j1+1) wird zu pos hinzuaddiert.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        j1 = f1_v_vektor_e[i];
        j2 = f2_v_vektor_e[i];

        pos = pos + (j2-j1+1);
        }
// Kommentar: Am Ende wird die so bestimmte Anzahl an Punkten zurckgegeben.
    return(pos);
    }

// Kommentar: Hier wird die kleine Innenrandstruktur gebildet. Man bildet dabei zweierlei:
// Einmal die Signatur fr alle Innenrandpunkte in der Reihenfolgen vertikale Vektoren, horizontale Vektoren und Restpunktemenge.
// Und dann eine Punktliste (f_innen_klein,g_innen_klein), die die Innenrandpunkte in derselben Reihenfolge auswhlt,
// wobei die Innenrandpunkte eine 'true' - Signatur haben.
void RandStrukturKommunikation::bilde_kleine_randstruktur_innen(void)
    {
// Zuerst Innen:
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << " RSK::bilde_kleine_randstruktur_innen / rang " << rang << endl;
#endif
// Kommentar: Die Anzahl der kleinen Innenpunkte, und die Anzahl aller Innenpunkte werden zurckgesetzt.
    anzahl_innen_klein = 0;
    anzahl_punkte_innen = 0;

// Kommentar: Zuerst werden die vertikalen Vektoren durchlaufen.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
// Kommentar: Ein ausgewhlter Vektor wird durchlaufen.
        for(j = a; j<=b; j++)
            {
// Kommentar: Hat der Punkt darunter einen anderen Gitterpunkt ...
            if(testen(j, c) == true)
                {
// Kommentar: Dann speichere ihn in der kleinen Innenrandpunktliste ab, und schreibe in die Innen Signatur true.
                f_innen_klein[anzahl_innen_klein] = j;
                g_innen_klein[anzahl_innen_klein++] = c;
                signatur_innen[anzahl_punkte_innen++] = true;
                }
            else
                {
// Kommentar: Ansonsten speichere keinen Punkt ab, und markiere die Innen - Signatur mit false.
                signatur_innen[anzahl_punkte_innen++] = false;
                }
            }
        }

// Kommentar: Mache dasselbe mit allen horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];
        for(j = b; j<=c; j++)
            {
            if(testen(a, j) == true)
                {
                f_innen_klein[anzahl_innen_klein] = a;
                g_innen_klein[anzahl_innen_klein++] = j;
                signatur_innen[anzahl_punkte_innen++] = true;
                }
            else
                {
                signatur_innen[anzahl_punkte_innen++] = false;
                }
            }
        }
// Kommentar: Und am Ende mache dasselbe mit der Restpunktmenge.
    for(i=0; i<punkteanzahl; i++)
        {
        a = f_rs[i];
        b = g_rs[i];

        if(testen(a, b) == true)
            {
            f_innen_klein[anzahl_innen_klein] = a;
            g_innen_klein[anzahl_innen_klein++] = b;
            signatur_innen[anzahl_punkte_innen++] = true;
            }
        else
            {
            signatur_innen[anzahl_punkte_innen++] = false;
            }
        }
    }

// Kommentar: Bilde die kleine Auenrandstruktur, wobei eine Auen - Signatur zur Verfgung steht. Diese muss
// durch Kommunikation zuvor bestimmt werden.
void RandStrukturKommunikation::bilde_kleine_randstruktur_aussen(void)
// Danach aussen:
    {
// Kommentar: Die kleine Auenrandpunktmenge wird anfangs auf 'leer' gesetzt.
    anzahl_aussen_klein = 0;

// Dann werden die Punkte aller vertikalen Vektoren durchlaufen, und bei einer Signatur der fortlaufenden Numerierung
// von true wird der jeweilige Punkt in die kleine Auenrandliste aufgenommen. Wichtig dabei: Die jeweilige Signatur
// pat genau zu dem ausgewhlten Punkt.

//    for(i=0; i<anzahl_v_vektor_e; i++)
    for(i=0, k=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];
        for(j = a; j<=b; j++, k++)
            {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
            if((j==8)&&(c==3))
                {
                cout << " RSK Code A4 signatur aussen " << signatur_aussen[k] << endl;
                }
#endif

            if(signatur_aussen[k] == true)
                {
                f_aussen_klein[anzahl_aussen_klein] = j;
                g_aussen_klein[anzahl_aussen_klein++] = c;
                }
            }
        }

// Kommentar: Mache dasselbe fr die horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];
        for(j = b; j<=c; j++, k++)
            {
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
            if((j==8)&&(c==3))
                {
                cout << " RSK Code A4 signatur aussen " << signatur_aussen[k] << endl;
                }
#endif
            if(signatur_aussen[k] == true)
                {
                f_aussen_klein[anzahl_aussen_klein] = a;
                g_aussen_klein[anzahl_aussen_klein++] = j;
                }
            }
        }

// Kommentar: Und am Ende macht man dasselbe fr die verbliebenen Restpunkte.
    for(i=0; i<punkteanzahl_e; i++)
        {
        a = f_e[i];
        b = g_e[i];

        if(signatur_aussen[k++] == true)
            {
            f_aussen_klein[anzahl_aussen_klein] = a;
            g_aussen_klein[anzahl_aussen_klein++] = b;
            }
        }
    }

// Kommentar: Gem der Innenrandstruktur werden die u0 - Werte in den Sendebuffer gepackt.
void RandStrukturKommunikation::packen_werte_u0(void)
    {
// Kommentar: Man beginnt beim ersten Buffereintrag.
    k=0;

// Kommentar: Fr alle Punkte aller horizontalen Vektoren wird an der Stelle k u0 an der Stelle des Punktes in den
// Sendebuffer geschrieben, und k um Eins erhht.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = u0[j][c];
            }
        }
// Komemntar: Mache dasselbe fr alle horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = u0[a][j];
            }
        }
// Kommentar: Man macht am Ende dasselbe fr alle Restpunkte.
    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = u0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Gem der Innenrandstruktur werden die u0 - Werte der Red - Punkte der Innenrandstruktur in den Sendebuffer gepackt.
void RandStrukturKommunikation::packen_werte_u0_red(void)
    {
// Kommentar: Gehe an den Anfang des Sendebuffers.
    k=0;

// Kommentar: Es werden wiederrum alle Punkte aller vertikalen Vektoren durchlaufen.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
// Kommentar: Liegt ein Red - Punkt vor, d.h. ist die Koordinatensumme gerade ...
            if(((j+c)&1)==0)
                {
// Kommentar: Dann schreibe den u0 - Wert dieses Punktes in den Sendebuffer an der angegebenen Stelle, die im Anschlu
// um Eins erhht wird.
                sende_werte_buffer[k++] = u0[j][c];
                }
            }
        }
// Kommentar: Mache dasselbe fr die horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==0)
                {
                sende_werte_buffer[k++] = u0[a][j];
                }
            }
        }

// Kommentar: Und am Ende mache man dasselbe fr die Restpunktmenge.
    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];
        if(((f_rs_i+g_rs_i)&1)==0)
            {
            sende_werte_buffer[k++] = u0[f_rs_i][g_rs_i];
            }
        }
    }

// Kommentar: Analog zu packen_werte_u0_red, nur dass nur die Punkte mit ungerader Koordinatensumme gepackt werden.
void RandStrukturKommunikation::packen_werte_u0_black(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            if(((j+c)&1)==1)
                {
                sende_werte_buffer[k++] = u0[j][c];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==1)
                {
                sende_werte_buffer[k++] = u0[a][j];
                }
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];
        if(((f_rs_i+g_rs_i)&1)==1)
            {
            sende_werte_buffer[k++] = u0[f_rs_i][g_rs_i];
            }
        }
    }

// Kommentar: Zu den Randpunkten der Innenrandstruktur, die Grobgitterpunkte darber haben, werden die gg_u0 - Werte
// auf diesen Grobgitterpunkten gepackt.
void RandStrukturKommunikation::packen_werte_gg_u0(void)
    {
// Kommentar:Man beginne beim Buffer direkt am Anfang.
    k=0;

// Kommentar: Man durchlaufe alle vertikalen Vektoren.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];

// Kommentar: Ist die g - Koordinate ungerade, dann gehe zum nchsten Vektor ber.
        if((c&1)==1)
            {
            continue;
            }
// Kommentar: Bilde aus der g - Koordinate die Grobgitter - g - Koordinate c_halbe.
        c_halbe = c >> 1;
// Kommentar: Dann durchlaufe man die f - Koordinaten des Vektors.
        for(j = a; j<=b; j++)
            {
// Kommentar: Ist die f - Koordinate gerade, dann halbiere sie, und schreibe den Wert von gg_u0 (ein Zeiger auf die u0 - Matrix
// des grberen Gitters) an der Grobgitterkoordinate (j/2,c/2) in den Sendebuffer, wobei im Anschlu der Index inkrementiert wird.
            if((j&1)==0)
                {
                sende_werte_buffer[k++] = gg_u0[j>>1][c_halbe];
                }
            }
        }

// Kommentar: Man mache dasselbe fr die horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a>>1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                sende_werte_buffer[k++] = gg_u0[a_halbe][j>>1];
                }
            }
        }

// Kommentar: Und am Ende mache man dasselbe fr die Restpunktmenge.
    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];

        if((f_rs_i&1)==0)
            {
            if((g_rs_i&1)==0)
                {
                sende_werte_buffer[k++] = gg_u0[f_rs_i>>1][g_rs_i>>1];
                }
            }
        }
    }

// Kommentar: Analog zu packen_werte_gg_u0, nur dass die Werte von gg_e0 statt der Werte von gg_u0 gepackt werden.
void RandStrukturKommunikation::packen_werte_gg_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        if((c&1)==1)
            {
            continue;
            }
        c_halbe = c >> 1;
        for(j = a; j<=b; j++)
            {
            if((j&1)==0)
                {
                sende_werte_buffer[k++] = gg_e0[j>>1][c_halbe];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a>>1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                sende_werte_buffer[k++] = gg_e0[a_halbe][j>>1];
                }
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];

        if((f_rs_i&1)==0)
            {
            if((g_rs_i&1)==0)
                {
                sende_werte_buffer[k++] = gg_e0[f_rs_i>>1][g_rs_i>>1];
                }
            }
        }
    }

// Kommentar: Analog zu packen_werte_gg_u0, nur dass die Werte von gg_v9 statt der Werte von gg_u0 gepackt werden.
// Die Variable v9 wird dabei fr die generte Version der Implementierung von Herrn Hess der Shallow Water Equations bentigt.
void RandStrukturKommunikation::packen_werte_gg_v9(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        if((c&1)==1)
            {
            continue;
            }
        c_halbe = c >> 1;
        for(j = a; j<=b; j++)
            {
            if((j&1)==0)
                {
                sende_werte_buffer[k++] = gg_v9[j>>1][c_halbe];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a>>1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                sende_werte_buffer[k++] = gg_v9[a_halbe][j>>1];
                }
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];

        if((f_rs_i&1)==0)
            {
            if((g_rs_i&1)==0)
                {
                sende_werte_buffer[k++] = gg_v9[f_rs_i>>1][g_rs_i>>1];
                }
            }
        }
    }

// Kommentar: Analog zu packen_werte_gg_u0, nur dass die Werte von gg_e0 und gg_u0 statt der Werte von gg_u0 gepackt werden.
// Kommentiert wird dabei nur die nderung im Code zu packen_werte_gg_u0.
void RandStrukturKommunikation::packen_werte_gg_e0_und_u0(void)
    {
    k=0;

#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << " packen gg_e0_und_u0 1 rang " << rang << endl;
#endif
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        if((c&1)==1)
            {
            continue;
            }
        c_halbe = c >> 1;
        for(j = a; j<=b; j++)
            {
            if((j&1)==0)
                {
                j_durch_2 = j >> 1;
// Kommentar: Statt nur gg_u0 an der Grobgitterstelle in den Buffer zu schreiben - nebst Inkrementierung des Indexes -
// werden nacheinander gg_e0 und gg_u0 in den Buffer geschrieben - nebst der Inkrementierung des Indexes.
                sende_werte_buffer[k++] = gg_e0[j_durch_2][c_halbe];
                sende_werte_buffer[k++] = gg_u0[j_durch_2][c_halbe];
                }
            }
        }

#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << " packen gg_e0_und_u0 2 rang " << rang << " k " << k << endl;
#endif

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a>>1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                j_durch_2 = j >> 1;
// Kommentar: Statt nur gg_u0 an der Grobgitterstelle in den Buffer zu schreiben - nebst Inkrementierung des Indexes -
// werden nacheinander gg_e0 und gg_u0 in den Buffer geschrieben - nebst der Inkrementierung des Indexes.
                sende_werte_buffer[k++] = gg_e0[a_halbe][j_durch_2];
                sende_werte_buffer[k++] = gg_u0[a_halbe][j_durch_2];
                }
            }
        }

#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << " packen gg_e0_und_u0 3 rang " << rang << " k " << k << endl;
#endif

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];

        if((f_rs_i&1)==0)
            {
            if((g_rs_i&1)==0)
                {
                f_rs_i_durch_2 = f_rs_i >> 1;
                g_rs_i_durch_2 = g_rs_i >> 1; // gendert am 12.9.2015
// Kommentar: Statt nur gg_u0 an der Grobgitterstelle in den Buffer zu schreiben - nebst Inkrementierung des Indexes -
// werden nacheinander gg_e0 und gg_u0 in den Buffer geschrieben - nebst der Inkrementierung des Indexes.
                sende_werte_buffer[k++] = gg_e0[f_rs_i_durch_2][g_rs_i_durch_2];
                sende_werte_buffer[k++] = gg_u0[f_rs_i_durch_2][g_rs_i_durch_2];
                }
            }
        }
#ifdef AUSGABEN_RANDSTRUKTUR_KOMMUNIKATION
    cout << " packen gg_e0_und_u0 4 rang " << rang << " k " << k << endl;
#endif
    }

// Kommentar: Analog zu packen_werte_u0. Nur mit der Verwendung der Variablen u0_hilf, statt der Variablen u0.
void RandStrukturKommunikation::packen_werte_u0_hilf(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = u0_hilf[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = u0_hilf[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = u0_hilf[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0. Nur mit der Verwendung der Variablen Lu0, statt der Variablen u0.
void RandStrukturKommunikation::packen_werte_Lu0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = Lu0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = Lu0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = Lu0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0. Nur mit der Verwendung der Variablen r0, statt der Variablen u0.
void RandStrukturKommunikation::packen_werte_r0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = r0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = r0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = r0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0. Nur mit der Verwendung der Variablen v6 der genderten SWE, statt der Variablen u0.
// Die Implementierung der SWE's ist die von Herrn Hess.
void RandStrukturKommunikation::packen_werte_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = v6[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = v6[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = v6[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0. Nur mit der Verwendung der Variablen f0, statt der Variablen u0.
void RandStrukturKommunikation::packen_werte_f0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = f0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = f0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = f0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0. Nur mit der Verwendung der Variablen Iu0, statt der Variablen u0.
void RandStrukturKommunikation::packen_werte_Iu0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = Iu0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = Iu0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = Iu0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0. Nur werden hier 2 Variablen gepackt - Iu0 und r0. Der Unterschied zu packen_werte_u0
// wird fr die vertikalen Vektoren kommentiert.
void RandStrukturKommunikation::packen_werte_Iu0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
// Kommentar: Fr jeden Punkt (j,c) des vertikalen Vektors (a,b,c) wird erst Iu0(j,c) gefolgt von r0(j,c) in den
// Werte - Sendebuffer geschrieben.
            sende_werte_buffer[k++] = Iu0[j][c];
            sende_werte_buffer[k++] = r0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = Iu0[a][j];
            sende_werte_buffer[k++] = r0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = Iu0[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = r0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_Iu0r0, nur dass hier die Variablen u0 und r0 gepackt werden.
void RandStrukturKommunikation::packen_werte_u0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = u0[j][c];
            sende_werte_buffer[k++] = r0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = u0[a][j];
            sende_werte_buffer[k++] = r0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = u0[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = r0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur dass hier die Variable rS0 gepackt wird.
void RandStrukturKommunikation::packen_werte_rS0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = rS0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = rS0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = rS0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu packen_werte_u0, nur dass hier die Variable e0 gepackt wird.
void RandStrukturKommunikation::packen_werte_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = e0[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = e0[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = e0[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: hnlich wie packen_werte_u0. Dennoch wird das hier kommentiert, damit das Konzept des Entpackens klar wird.
void RandStrukturKommunikation::entpacken_werte_u0(void)
    {
// Kommentar: Man geht an den Anfang des Buffers.
    k=0;

// Es werden die vertikalen Vektoren des Auenrandes durchlaufen, und fr jeden Vektor die Punktmengen ...
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
// Kommentar: ... und fr jeden Punkt wird aus dem Empfangsbuffer in die Variable u0 an der Stelle des Punktes geschrieben,
// nebst einer Inkrementierung des Indexes.
            u0[j][c]=empfange_werte_buffer[k++];
            }
        }

// Kommentar: Man mache dasselbe fr die horizontalen Auenrandvektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            u0[a][j] = empfange_werte_buffer[k++];
            }
        }

// Kommentar: Man mache dasselbe auch fr die Auenrandrestpunktmengen.
    for(i=0; i<punkteanzahl_e; i++)
        {
        u0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Es wird in die red - Punkte des Auenrandes entpackt - bzgl. der Variablen u0.
void RandStrukturKommunikation::entpacken_werte_u0_red(void)
    {
// Kommentar: Man geht an den Anfang des Buffers.
    k=0;

// Es werden die vertikalen Vektoren des Auenrandes durchlaufen, und fr jeden Vektor die Punktmengen ...
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
// Kommentar: ... und fr jeden red - Punkt wird aus dem Empfangsbuffer in die Variable u0 an der Stelle des Punktes geschrieben,
// nebst einer Inkrementierung des Indexes. Red - Punkte haben eine gerade Koordinatensumme - entsprechend den
// weien Feldern eines richtig aufgestellten Schach - oder Damebrettes.
            if(((j+c)&1)==0)
                {
                u0[j][c]=empfange_werte_buffer[k++];
                }
            }
        }


// Kommentar: Man mache dasselbe fr die horizontalen Auenrandvektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==0)
                {
                u0[a][j] = empfange_werte_buffer[k++];
                }
            }
        }

// Kommentar: Man mache dasselbe fr die Auenrandrestpunktmenge.
    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if(((f_e_i+g_e_i)&1)==0)
        u0[f_e_i][g_e_i] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Man macht dasselbe wie in entpacken_werte_u0_black, nur dass nur die Black - Punkte entpackt werden.
// Black - Punkte haben eine ungerade Koordinatensumme - wie die schwarzen Felder eines richtig aufgestellten
// Schachbrettes.
void RandStrukturKommunikation::entpacken_werte_u0_black(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            if(((j+c)&1)==1)
                {
                u0[j][c]=empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==1)
                {
                u0[a][j] = empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if(((f_e_i+g_e_i)&1)==1)
        u0[f_e_i][g_e_i] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Hier wird in die Auenrandstruktur entpackt, aber nur fr Punkte, wo Grobgitterpunkte darber existieren,
// und es wird nur in die Grobgitterwerte der Variablen u0 geschrieben.
void RandStrukturKommunikation::entpacken_werte_gg_u0(void)
    {
// Kommentar: Man geht an den Anfang des Buffers.
    k=0;

// Kommentar: Man durchlaufe alle vertikalen Vektoren.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

// Kommentar: Ist die g - Koordinate ungerade, dann gehe zum nchsten Vektor ber.
        if((c&1)==1)
            {
            continue;
            }
        c_halbe = c >> 1;

// Kommentar: Dann durchlaufe man die f - Koordinaten des Vektors.
        for(j = a; j<=b; j++)
            {
// Kommentar: Ist die f - Koordinate gerade, dann halbiere sie, und schreibe den empfangenen Wert in die Variable gg_u0
// (das ist die u0 Variable des grberen Gitters) an der Grobgitterkoordinate (j/2,c/2). Im Anschlu wird der Index inkrementiert.
            if((j&1)==0)
                {
                gg_u0[j>>1][c_halbe]=empfange_werte_buffer[k++];
                }
            }
        }

// Kommentar: Mache dasselbe fr die horizontalen Auenrandvektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a >> 1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                gg_u0[a_halbe][j>>1] = empfange_werte_buffer[k++];
                }
            }
        }

// Kommentar: Mache dasselbe fr die Auenrandrestpunktmenge.
    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if((f_e_i&1)==0)
            {
            if((g_e_i&1)==0)
                {
                gg_u0[f_e_i>>1][g_e_i>>1] = empfange_werte_buffer[k++];
                }
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_gg_u0, wobei nur in gg_e0 statt in gg_u0 geschrieben wird.
void RandStrukturKommunikation::entpacken_werte_gg_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        if((c&1)==1)
            {
            continue;
            }

        c_halbe = c >> 1;

        for(j = a; j<=b; j++)
            {
            if((j&1)==0)
                {
                gg_e0[j>>1][c_halbe]=empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a >> 1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                gg_e0[a_halbe][j>>1] = empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if((f_e_i&1)==0)
            {
            if((g_e_i&1)==0)
                {
                gg_e0[f_e_i>>1][g_e_i>>1] = empfange_werte_buffer[k++];
                }
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_gg_u0, wobei nur in gg_v9 statt in gg_u0 geschrieben wird.
// gg_v9 ist eine Variable der abgenderten Version der Implementierung von Herrn Hess der SWE.
void RandStrukturKommunikation::entpacken_werte_gg_v9(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        if((c&1)==1)
            {
            continue;
            }

        c_halbe = c >> 1;

        for(j = a; j<=b; j++)
            {
            if((j&1)==0)
                {
                gg_v9[j>>1][c_halbe]=empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a >> 1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                gg_v9[a_halbe][j>>1] = empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if((f_e_i&1)==0)
            {
            if((g_e_i&1)==0)
                {
                gg_v9[f_e_i>>1][g_e_i>>1] = empfange_werte_buffer[k++];
                }
            }
        }
    }

// Kommentar: Fast analog zu entpacken_werte_gg_u0, wobei hier in gg_e0 und gg_u0 statt nur in gg_u0 geschrieben wird.
// Es wird der Unterschied zu entpacken_werte_gg_u0 fr die vertikalen Auenrandvektoren kommentiert.
void RandStrukturKommunikation::entpacken_werte_gg_e0_und_u0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        if((c&1)==1)
            {
            continue;
            }

        c_halbe = c >> 1;

        for(j = a; j<=b; j++)
            {
            if((j&1)==0)
                {
                j_durch_2 = j >> 1;
// Kommentar: Statt nur nach gg_u0 zu entpacken, wird nach gg_e0 gefolgt von gg_u0 entpackt.
                gg_e0[j_durch_2][c_halbe]=empfange_werte_buffer[k++];
                gg_u0[j_durch_2][c_halbe]=empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        if((a&1)==1)
            {
            continue;
            }

        a_halbe = a >> 1;

        for(j = b; j<=c; j++)
            {
            if((j&1)==0)
                {
                j_durch_2 = j >> 1;
                gg_e0[a_halbe][j_durch_2] = empfange_werte_buffer[k++];
                gg_u0[a_halbe][j_durch_2] = empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if((f_e_i&1)==0)
            {
            if((g_e_i&1)==0)
                {
                f_e_i_durch_2 = f_e_i>>1;
                g_e_i_durch_2 = g_e_i>>1;
                gg_e0[f_e_i_durch_2][g_e_i_durch_2] = empfange_werte_buffer[k++];
                gg_u0[f_e_i_durch_2][g_e_i_durch_2] = empfange_werte_buffer[k++];
                }
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier die Variable Lu0 entpackt wird.
void RandStrukturKommunikation::entpacken_werte_Lu0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            Lu0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            Lu0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        Lu0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier die Variable r0 entpackt wird.
void RandStrukturKommunikation::entpacken_werte_r0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            r0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            r0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        r0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier die Variable v6 entpackt wird. v6 ist eine Variable der
// genderten Version der Implementierung von Herrn Hess der SWE.
void RandStrukturKommunikation::entpacken_werte_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            v6[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            v6[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        v6[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier statt u0 die Variable f0 entpackt wird.
void RandStrukturKommunikation::entpacken_werte_f0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            f0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            f0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier statt u0 die Variable Iu0 entpackt wird.
void RandStrukturKommunikation::entpacken_werte_Iu0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            Iu0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            Iu0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        Iu0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier statt u0 die Variablen Iu0 und r0 entpackt werden.
void RandStrukturKommunikation::entpacken_werte_Iu0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
// Kommentar: Bis hierhin wie in entpacken_werte_u0. Nun wird zuerst in Iu0 entpackt, nebst Inkrementierung des Indexes,
// gefolgt vom Entpacken nach r0, nebst der Inkrementierung des Indexes.
            Iu0[j][c]=empfange_werte_buffer[k++];
            r0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            Iu0[a][j] = empfange_werte_buffer[k++];
            r0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        Iu0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        r0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_Iu0r0, nur dass hier statt Iu0 und r0 die Variablen u0 und r0 entpackt werden.
void RandStrukturKommunikation::entpacken_werte_u0r0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            u0[j][c]=empfange_werte_buffer[k++];
            r0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            u0[a][j] = empfange_werte_buffer[k++];
            r0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        u0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        r0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier statt u0 die Variable rS0 entpackt wird.
void RandStrukturKommunikation::entpacken_werte_rS0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            rS0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            rS0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        rS0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0, nur dass hier statt u0 die Variable e0 entpackt wird.
void RandStrukturKommunikation::entpacken_werte_e0(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            e0[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            e0[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        e0[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Hier werden die Werte von u0 auf dem feinen Gitter gepackt.
void RandStrukturKommunikation::packen_werte_fg_u0(void)
    {
// Kommentar: Es beginnt wieder mit dem Bufferanfang.
    k=0;

// Kommentar: Die vertikalen Vektoren werden durchlaufen.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];

// Kommentar: Die Koordinaten des Vektors werden verdoppelt. Das macht man, um an die Feingitterkoordinaten der
// auf dem feineren Gitter zu kommen. Damit auch nur die Punkte echt darunter erreicht werden, darf man bei dem
// entstehenden Vektor nur jeden 2.ten Eintrag nehmen. Die Schrittweite ist daher 2, was durc h die Anweisung j=j+2
// gemacht wird. So hat man genau die Feingitterkoordinaten, die das doppelte der Gitterkoordinaten ber dem feinen
// Gitter sind.
        a_doppelt = a << 1;
        b_doppelt = b << 1;
        c_doppelt = c << 1;

        for(j = a_doppelt; j<=b_doppelt; j=j+2)
            {
// Kommentar: Der Werte des feineren Gitters steht in fg_u0, und entsteht durch eine Verknpfung des u0 Zeigers
// eine Klasse hher. Der fg_u0 - Wert an der Feingitterkoordinate wird nun in den Sendebuffer geschrieben, und der Index
// wird inkrementiert.
            sende_werte_buffer[k++] = fg_u0[j][c_doppelt];
            }
        }

// Kommentar: Man macht dasselbe fr den horizontalen Vektor.
    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        a_doppelt = a << 1;
        b_doppelt = b << 1;
        c_doppelt = c << 1;

        for(j = b_doppelt; j<=c_doppelt; j=j+2)
            {
            sende_werte_buffer[k++] = fg_u0[a_doppelt][j];
            }
        }

// Kommentar: Dann werden die Punkte (f_rs_i,g_rs_i) der Restpunktliste durchlaufen, und fg_u0 an der Stelle (2f_rs_i,2g_rs_i)
// gelesen, und in den Sendebuffer geschrieben, nebst Inkrementierung des Indexes.
    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];

        sende_werte_buffer[k++] = fg_u0[f_rs_i<<1][g_rs_i<<1];
        }
    }

// Kommentar: Analog zu packen_werte_fg_u0, nur dass statt fg_u0 fg_v6 gelesen wird.
void RandStrukturKommunikation::packen_werte_fg_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];

        a_doppelt = a << 1;
        b_doppelt = b << 1;
        c_doppelt = c << 1;

        for(j = a_doppelt; j<=b_doppelt; j=j+2)
            {
            sende_werte_buffer[k++] = fg_v6[j][c_doppelt];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        a_doppelt = a << 1;
        b_doppelt = b << 1;
        c_doppelt = c << 1;

        for(j = b_doppelt; j<=c_doppelt; j=j+2)
            {
            sende_werte_buffer[k++] = fg_v6[a_doppelt][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];

        sende_werte_buffer[k++] = fg_v6[f_rs_i<<1][g_rs_i<<1];
        }
    }

// Kommentar: Hier werden die Feingitterwerte fg_u0 entpackt.
void RandStrukturKommunikation::entpacken_werte_fg_u0(void)
    {
// Kommentar: Es beginnt am Bufferanfang.
    k=0;

// Kommentar: Die Auenrandvektoren werden durchlaufen. Die Koordinaten werden verdoppelt, von dem entstehenden
// Vektor wird aber nur jeder 2.te Eintrag gelesen, so dass genau die Feingitterwerte unter den Gitterpunkten
// durchlaufen werden.
    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        c_doppelt = c << 1;
        a_doppelt = a << 1;
        b_doppelt = b << 1;

        for(j = a_doppelt; j<=b; j=j+2)
            {
// Kommentar: Dann wird der Bufferwert in die Feingitterkoordinate zu den Auenrandvektorkoordinaten (siehe eben) geschrieben,
// nebst einer Inkrementierung des Bufferindexes. Der Buffer lautet empfange_werte_buffer.
            fg_u0[j][c_doppelt]=empfange_werte_buffer[k++];
            }
        }

// Kommentar: Mache dasselbe fr die horizontalen Vektoren.
    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        c_doppelt = c << 1;
        a_doppelt = a << 1;
        b_doppelt = b << 1;

        for(j = b_doppelt; j<=c_doppelt; j=j+2)
            {
            fg_u0[a_doppelt][j] = empfange_werte_buffer[k++];
            }
        }

// Kommentar: Am Ende schreibe die Bufferwerte in die Variable fg_u0 an den Feingitterkoordinaten (Punktkoordinate Mal 2)
// der Punkte der Restpunktliste.
    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];

        fg_u0[f_e_i<<1][g_e_i<<1] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_fg_u0, nur dass in die Variable fg_v6 statt in die Variable fg_u0 entpackt wird.
// fg_v6 ist der Feingitterwert der Variablen v6, mit der hier eine genderte Version der Implementierung von Herrn Hess der SWE
// geschrieben wurde.
void RandStrukturKommunikation::entpacken_werte_fg_v6(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        c_doppelt = c << 1;
        a_doppelt = a << 1;
        b_doppelt = b << 1;

        for(j = a_doppelt; j<=b; j=j+2)
            {
            fg_v6[j][c_doppelt]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        c_doppelt = c << 1;
        a_doppelt = a << 1;
        b_doppelt = b << 1;

        for(j = b_doppelt; j<=c_doppelt; j=j+2)
            {
            fg_v6[a_doppelt][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];

        fg_v6[f_e_i<<1][g_e_i<<1] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu packen_werte_Iu0r0, nur dass hier 4 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v1, v2, v3 und v4, gepackt werden.
void RandStrukturKommunikation::packen_werte_v1v2v3v4(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = v1[j][c];
            sende_werte_buffer[k++] = v2[j][c];
            sende_werte_buffer[k++] = v3[j][c];
            sende_werte_buffer[k++] = v4[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = v1[a][j];
            sende_werte_buffer[k++] = v2[a][j];
            sende_werte_buffer[k++] = v3[a][j];
            sende_werte_buffer[k++] = v4[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = v1[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v2[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v3[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v4[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu entpacken_werte_Iu0r0, nur dass hier 4 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v1, v2, v3 und v4, entpackt werden.
void RandStrukturKommunikation::entpacken_werte_v1v2v3v4(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            v1[j][c]=empfange_werte_buffer[k++];
            v2[j][c]=empfange_werte_buffer[k++];
            v3[j][c]=empfange_werte_buffer[k++];
            v4[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            v1[a][j] = empfange_werte_buffer[k++];
            v2[a][j] = empfange_werte_buffer[k++];
            v3[a][j] = empfange_werte_buffer[k++];
            v4[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        v1[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v2[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v3[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v4[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu packen_werte_Iu0r0, nur dass hier 3 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v5, v6 und v7 gepackt werden.
void RandStrukturKommunikation::packen_werte_v5v6v7(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = v5[j][c];
            sende_werte_buffer[k++] = v6[j][c];
            sende_werte_buffer[k++] = v7[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = v5[a][j];
            sende_werte_buffer[k++] = v6[a][j];
            sende_werte_buffer[k++] = v7[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = v5[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v6[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v7[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu entpacken_werte_Iu0r0, nur dass hier 3 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v5, v6 und v7, entpackt werden.
void RandStrukturKommunikation::entpacken_werte_v5v6v7(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            v5[j][c]=empfange_werte_buffer[k++];
            v6[j][c]=empfange_werte_buffer[k++];
            v7[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            v5[a][j] = empfange_werte_buffer[k++];
            v6[a][j] = empfange_werte_buffer[k++];
            v7[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        v5[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v6[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v7[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu packen_werte_Iu0r0, nur dass hier 2 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v8 und v9, gepackt werden.
void RandStrukturKommunikation::packen_werte_v8v9(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = v8[j][c];
            sende_werte_buffer[k++] = v9[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = v8[a][j];
            sende_werte_buffer[k++] = v9[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = v8[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v9[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu entpacken_werte_Iu0r0, nur dass hier 2 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v8 und v9, entpackt werden.
void RandStrukturKommunikation::entpacken_werte_v8v9(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            v8[j][c]=empfange_werte_buffer[k++];
            v9[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            v8[a][j] = empfange_werte_buffer[k++];
            v9[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        v8[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v9[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu packen_werte_Iu0r0, nur dass hier 3 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v4, v6 und v11, gepackt werden.
void RandStrukturKommunikation::packen_werte_v4v6v11(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            sende_werte_buffer[k++] = v4[j][c];
            sende_werte_buffer[k++] = v6[j][c];
            sende_werte_buffer[k++] = v11[j][c];
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            sende_werte_buffer[k++] = v4[a][j];
            sende_werte_buffer[k++] = v6[a][j];
            sende_werte_buffer[k++] = v11[a][j];
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        sende_werte_buffer[k++] = v4[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v6[f_rs[i]][g_rs[i]];
        sende_werte_buffer[k++] = v11[f_rs[i]][g_rs[i]];
        }
    }

// Kommentar: Analog zu entpacken_werte_Iu0r0, nur dass hier 3 Variablen der genderten Version der Implementierung von Herrn Hess der SWE,
// v4, v6 und v11, entpackt werden.
void RandStrukturKommunikation::entpacken_werte_v4v6v11(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            v4[j][c]=empfange_werte_buffer[k++];
            v6[j][c]=empfange_werte_buffer[k++];
            v11[j][c]=empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            v4[a][j] = empfange_werte_buffer[k++];
            v6[a][j] = empfange_werte_buffer[k++];
            v11[a][j] = empfange_werte_buffer[k++];
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        v4[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v6[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        v11[f_e[i]][g_e[i]] = empfange_werte_buffer[k++];
        }
    }


// Kommentar: Analog zu packen_werte_u0_red, nur dass hier die Variable v6 der genderten Version der Implementierung von Herrn Hess der SWE
// auf red-Punkten, die charakterisiert sind durch eine gerade Koordinatensumme, gepackt wird.
void RandStrukturKommunikation::packen_werte_v6_red(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            if(((j+c)&1)==0)
                {
                sende_werte_buffer[k++] = v6[j][c];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==0)
                {
                sende_werte_buffer[k++] = v6[a][j];
                }
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];
        if(((f_rs_i+g_rs_i)&1)==0)
            {
            sende_werte_buffer[k++] = v6[f_rs_i][g_rs_i];
            }
        }
    }

// Kommentar: Analog zu packen_werte_u0_black, nur dass hier die Variable v6 der genderten Version der Implementierung von Herrn Hess der SWE
// auf black-Punkten, die charakterisiert sind durch eine ungerade Koordinatensumme, gepackt wird.
void RandStrukturKommunikation::packen_werte_v6_black(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor; i++)
        {
        a = f1_v_vektor[i];
        b = f2_v_vektor[i];
        c = g_v_vektor[i];
        for(j = a; j<=b; j++)
            {
            if(((j+c)&1)==1)
                {
                sende_werte_buffer[k++] = v6[j][c];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor; i++)
        {
        a = f_h_vektor[i];
        b = g1_h_vektor[i];
        c = g2_h_vektor[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==1)
                {
                sende_werte_buffer[k++] = v6[a][j];
                }
            }
        }

    for(i=0; i<punkteanzahl; i++)
        {
        f_rs_i = f_rs[i];
        g_rs_i = g_rs[i];
        if(((f_rs_i+g_rs_i)&1)==1)
            {
            sende_werte_buffer[k++] = v6[f_rs_i][g_rs_i];
            }
        }
    }

// Kommentar: Analog zu entpacken_werte_u0_red, nur dass hier die Variable v6 der genderten Version der Implementierung von Herrn Hess der SWE
// auf red-Punkten, die charakterisiert sind durch eine gerade Koordinatensumme, entpackt wird.
void RandStrukturKommunikation::entpacken_werte_v6_red(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            if(((j+c)&1)==0)
                {
                v6[j][c]=empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==0)
                {
                v6[a][j] = empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if(((f_e_i+g_e_i)&1)==0)
        v6[f_e_i][g_e_i] = empfange_werte_buffer[k++];
        }
    }

// Kommentar: Analog zu entpacken_werte_u0_black, nur dass hier die Variable v6 der genderten Version der Implementierung von Herrn Hess der SWE
// auf black-Punkten, die charakterisiert sind durch eine ungerade Koordinatensumme, entpackt wird.
void RandStrukturKommunikation::entpacken_werte_v6_black(void)
    {
    k=0;

    for(i=0; i<anzahl_v_vektor_e; i++)
        {
        a = f1_v_vektor_e[i];
        b = f2_v_vektor_e[i];
        c = g_v_vektor_e[i];

        for(j = a; j<=b; j++)
            {
            if(((j+c)&1)==1)
                {
                v6[j][c]=empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<anzahl_h_vektor_e; i++)
        {
        a = f_h_vektor_e[i];
        b = g1_h_vektor_e[i];
        c = g2_h_vektor_e[i];

        for(j = b; j<=c; j++)
            {
            if(((j+a)&1)==1)
                {
                v6[a][j] = empfange_werte_buffer[k++];
                }
            }
        }

    for(i=0; i<punkteanzahl_e; i++)
        {
        f_e_i = f_e[i];
        g_e_i = g_e[i];
        if(((f_e_i+g_e_i)&1)==1)
        v6[f_e_i][g_e_i] = empfange_werte_buffer[k++];
        }
    }
