#include "randstukturpv.h"

// Kommentar: In dieser Klasse wird die Innenrandpunktmenge ber eine Vektorisierung zu einer 3 - fach Struktur:
// horizontale und vertikale Vektoren, dazu eine Restpunktmenge, die nicht vektorisierbar ist.

// Kommentar: Hier wird die Innenrandstruktur aus horizontalen und vertikalen Vektoren sowie Punkten ausgegeben.
void RandStrukturPV::ausgeben_pv(void)
    {
#ifdef AUSGABEN_PV
// Kommentar: Gebe zuerst die horizontalen Vektoren aus.
    cout << " Code A1: Beginne ausgeben in RandStrukturPV . Rang " << rang << " Anzahl H-Vektor " << anzahl_h_vektor << " Anzahl V-Vektor " << anzahl_v_vektor << " Punktanzahl " << punkteanzahl << endl;
    for(i=0; i<anzahl_h_vektor; i++)
        {
        cout << "H-Vektor Nr. " << i << " | f " << f_h_vektor[i] << " | g1 " << g1_h_vektor[i] << " | g2 " << g2_h_vektor[i] << " Farbe " << eigenfarbe << endl;
        }
// Kommentar: Gebe danach die vertikalen Vektoren aus.
    for(i=0; i<anzahl_v_vektor; i++)
        {
        cout << "V-Vektor Nr. " << i << " | f1 " << f1_v_vektor[i] << " | f2 " << f2_v_vektor[i] << " | g " << g_v_vektor[i] << " Farbe " << eigenfarbe << endl;
        }
// Am Ende gebe die Restpunktmenge aus.
    for(i=0; i<punkteanzahl; i++)
        {
        cout << "Einzelpunkt f " << f_rs[i] << " | g " << g_rs[i] << " Farbe " << eigenfarbe << endl;
        }
    cout << "Beende ausgeben in RandStrukturPV" << endl;
#endif
    }

#ifdef KURZ_TESTFELD
// Hier wird die Struktur RandStrukturPV initialisiert. bergeben werden dabei das bentigte Testfeld, m und n,
// die Innenrandpunktmenge, die eigene ID in der Klasse RandStruktur genannt eigenfarbe, sowie der Rang.
void RandStrukturPV::initialisieren(bool ** _testfeld, int _n, int _m, short int * _f_rs, short int * _g_rs, int _eigenfarbe, int _rang)
#else
void RandStrukturPV::initialisieren(int ** _testfeld, int _n, int _m, short int * _f_rs, short int * _g_rs, int _eigenfarbe, int _rang)
#endif
    {
    cout << "Es wird RSPV initialisiert " << endl;
// Komemntar: Zuerst werden die bergebenen Variablen / Strukturen gespeichert.
    testfeld = _testfeld;
    m = _m;
    n = _n;

    rang = _rang;

    n_minus1 = n-1;
    m_minus1 = m-1;

    f_rs = _f_rs;
    g_rs = _g_rs;
    eigenfarbe = _eigenfarbe;
// Kommentar: mn wird verwendet, um Punktlisten Speicher bereitzustellen.
    mn = m*n;

// Hiermit werden der Innenrandstruktur - horizontale und vertikale Vektorliste plus einer Punktliste - Speicherplatz zugeteilt.
    initialisieren_vektoren();

// Dieser Speicherplatz wird eigentlich nur fr die Tocherterklasse RandStukturKommunikation angelegt.
// Er knnte also auch dort angelegt werden.
    sendebuffer_ep = new bool [((mn>>3)+1)<<3];
    empfangsbuffer_ep = new bool [((mn>>3)+1)<<3];
    }

void RandStrukturPV::finalisieren(void)
    {
// Kommentar: Der Speicherplatz fr ep - Information wird freigegeben.
    delete sendebuffer_ep;
    delete empfangsbuffer_ep;

// Kommentar: Der Speicherplatz fr die Innenrandstruktur wird hier freigegeben.
    finalisieren_vektoren();
    }

// Kommentar: Hier wird die Vektorisierung der Randpunktmenge durchgefhrt. bergeben wird die Gre der
// Innenrandpunktmenge, d.h. die Anzahl der Punkte dieser Menge.
// Bemerkung: Das Testfeld ist berall false - bis auf die Innenrandpunkte.
void RandStrukturPV::vektorisieren(int anzahl)
    {
#ifdef AUSGABEN
    cout << "Es wird vektorisiert. " << endl;
#endif
// Zuerst wird eine leere Innenrandstruktur angelegt.
    punkteanzahl = 0;
    anzahl_h_vektor = 0;
    anzahl_v_vektor = 0;

#ifdef AUSGABEN
    if((rang==0)&&(eigenfarbe==1)&&(m==9)&&(n==9))
        {
        cout << " Code 53: anzahl " << anzahl << endl;
        }
#endif

// Kommentar: Die Innenrandpunktmenge wird durchlaufen.
    for(i=0; i<anzahl; i++)
        {
// Kommentar: Der jeweils nchste Punkt wird ausgewhlt.
        ff = f_rs[i];
        gg = g_rs[i];

#ifdef AUSGABEN
        if((rang==0)&&(eigenfarbe==1)&&(m==9)&&(n==9))//&&(ff == 2)&&(gg==5))
            {
            cout << " Code 52: testfeld[" << ff << "][" << gg << "]" << testfeld[ff][gg] << endl;
            }
#endif

// Kommentar: Wenn das Testfeld false ist an dieser Stelle, dann ist der Punkt schon in einer der drei Strukturen
// horizontaler und vertikaler Vektormengen bzw. der Punktmenge enthalten. Dann wird er nicht weiter bearbeitet.
        if(testfeld[ff][gg]==false)
            {
            continue;
            }

// Kommentar: Wenn nach oben hin mindestens ein Punkt in der verbleibenden Punktmenge existiert ...
        if(ff>0)
            {
            if(testfeld[ff-1][gg]==true)
                {
// Kommentar: Dann verlngere den Punkt zu einem Nord - Sd - Vektor, indem so weit wie mglich nach Norden
// und Sden nach Randpunkten gesucht wird. Nach diesem Schritt gehe zum nchsten Innenrandpunkt ber.
                vektor_nord_sued(ff, gg);
                continue;
                }
            }

// Kommentar: Kann man den Punkt nicht nach Nordn verlngern, dafr aber nach Sden, dann verlngere man den Punkt
// soweit wie mglich.
        if(ff<n_minus1)
            {
            if(testfeld[ff+1][gg]==true)
                {
                vektor_sued(ff, gg);
// Kommentar: Nachdem der Vektor gefunden und eingetragen und das testfeld dort auf false gesetzt wurde,
// gehe zum nchsten Randpunkt ber.
                continue;
                }
            }
// Kommentar: Kommt der Computer an diese Stelle im Programm, so konnte der Punkt nicht zu einem Nord - Sd - Vektor
// verlngert werden. Dann wird - auf analoge Weise - versucht, ihn zu einem West - Ost - Vektor zu verlngern.
// Wenn das gelingt, dann wird der West - Ost - Vektor gespeichert, und das Testfeld in dem Bereich auf false gesetzt.
        if(gg>0)
            {
            if(testfeld[ff][gg-1]==true)
                {
                vektor_west_ost(ff, gg);
                continue;
                }
            }
        if(gg < m_minus1)
            {
            if(testfeld[ff][gg+1]==true)
                {
                vektor_ost(ff, gg);
                continue;
                }
            }
// Kommentar: Wenn auch das nicht mglich ist, so wird der Punktder Punktliste hinzugefgt.
        f_rs[punkteanzahl] = ff; // Damit wird die alte Punkteliste berschrieben. Es geht aber!
        g_rs[punkteanzahl] = gg;
        punkteanzahl++;
// Kommentar: In diesem Fall muss das Testfeld dort auf false gesetzt werden. 16.7.2015
        testfeld[ff][gg] = false;  // Die Zeile ist vom 16.7.2015
        }
    }

// Kommentar: Hier wird der Punkt (ff,gg), der um 1 nach Norden verlngerbar ist, soweit wie mglich nach Norden,
// und falls mglich auch soweit wie mglich nach Sden verlngert.
void RandStrukturPV::vektor_nord_sued(int ff, int gg)
    {
#ifdef AUSGABEN
    cout << "Es wird ein Vektor Nord Sued gebildet." << endl;
#endif
// Kommentar: Durchlaufe die Punkte ab Koordinate (ff-2,gg) bis zur Koordinate (0,gg) solange weiter, wie das Testfeld an der
// jeweiligen Stelle true ist. Bei false wird die Schleife unterbrochen, und die Koordinate (j,gg) ist 1 weiter nrdlich
// als mglich, d.h. der Vektor beginnt ab (j+1,gg).
    for (j=ff-1; j>=0; j--)
        {
        if(testfeld[j][gg]==false)
            {
            break;
            }
        }
    // Der Vektor beginnt nun ab j+1

// Kommentar: Durchlaufe nun die mglichen Punkte ab (ff+1,gg) Richtung Sden. Maximal wird dabei der Wert n-1 erreicht.
    for(k=ff+1; k<n; k++)
        {
// Kommentar: Ist das Testfeld an einer Stelle false, ist der Vektor unterbrochen. Also steige man dann aus der Schleife aus.
        if(testfeld[k][gg]==false)
            {
            break;
            }
//        testfeld[k][gg] = false;
        }

// Kommentar: Der Vektor mit verbliebenen Punkten reicht von (j+1,gg) bis (k-1,gg).
// In dem Bereich wird nun das Testfeld auf false gesetzt, und anschlieend dieser Vektor der vertikalen Vektorliste
// hinzugefgt.
    for(l=j+1; l<=k-1; l++)
        {
        testfeld[l][gg] = false;
        }

    vertikaler_vektor(j+1, k-1, gg);
#ifdef AUSGABEN
    cout << "Der Vektor Nord Sued wurde gefunden " << endl;
#endif
    }

// Kommentar: Ein nicht nach Norden verlngerbarer Vektor wird nach Sden verlngert.
void RandStrukturPV::vektor_sued(int ff, int gg)
    {
#ifdef AUSGABEN
    cout << "Es wird ein Vektor Sued gebildet. " << endl;
#endif

// Kommentar: Da der Vektor schon bis (ff+1,gg) reicht, werden die Stellen (ff+2,gg) bis (n-1,gg) untersucht, bis zum
// ersten false - Wert des Testfeldes.
    for(k=ff+1; k<n; k++) // nderung vom 16.7.2015
        {
        if(testfeld[k][gg]==false)
            {
            break;
            }
//        testfeld[k][gg] = false;
        }

// Kommentar: Damit reicht der Nord - Sd - Vektor von (ff,gg) bis (k-1,gg). Entsprechend wird das Testfeld auf false gesetzt,
// und der Vektor in die Vektorliste vertikaler Vektoren aufgenommen.
    for(l=ff; l<=k-1; l++)
        {
        testfeld[l][gg] = false;
        }
    vertikaler_vektor(ff, k-1, gg);
    }

// Kommentar: Analog zu vektor_nord_sued. Hier wird der gefundene Vektor in die horizontale Vektorliste eingefgt.
void RandStrukturPV::vektor_west_ost(int ff, int gg)
    {
#ifdef AUSGABEN
    cout << "Es wird ein Vektor West - Ost gebildet. ff " << ff << endl;
#endif

    for (j=gg-1; j>=0; j--)
        {
        if(testfeld[ff][j]==false)
            {
            break;
            }
        }
    // Der Vektor beginnt nun ab j+1
    for(k=gg+1; k<m_minus1; k++)
        {
        if(testfeld[ff][k]==false)
            {
            break;
            }
        }
    for(l=j+1; l<k; l++)
        {
        testfeld[ff][l] = false;
        }

    horizontaler_vektor(ff, j+1, k-1);


    }

// Kommentar: Analog zu vektor_sued. Hier wird der gefundene Vektor in die horizontale Vektorliste eingefgt.
void RandStrukturPV::vektor_ost(int ff, int gg)
    {
#ifdef AUSGABEN
    cout << "Es wird ein Vektor Ost gebildet. ff " << ff << endl;
#endif
    for(k=gg+1; k<m; k++) // nderung vom 16.7.2015
        {
        if(testfeld[ff][k]==false)
            {
            break;
            }
        }
    for(l=gg; l<k; l++)
        {
        testfeld[ff][l] = false;
        }

    horizontaler_vektor(ff, gg, k-1);

    }

// Kommentar: Mit dieser Funktion wird ein horizontaler Vektor in die entsprechende Vektorliste eingefgt.
void RandStrukturPV::horizontaler_vektor(int f, int g1, int g2)
    {
    f_h_vektor[anzahl_h_vektor] = f;
    g1_h_vektor[anzahl_h_vektor] = g1;
    g2_h_vektor[anzahl_h_vektor] = g2;
    anzahl_h_vektor++;
    }

// Kommentar: Mit dieser Funktion wird ein vertikaler Vektor in die entsprechende Vektorliste eingefgt.
void RandStrukturPV::vertikaler_vektor(int f1, int f2, int g)
    {
    f1_v_vektor[anzahl_v_vektor] = f1;
    f2_v_vektor[anzahl_v_vektor] = f2;
    g_v_vektor[anzahl_v_vektor] = g;
    anzahl_v_vektor++;
    }

// Kommentar: Hier werden die Listen fr die horizontalen und vertikalen Vektoren angelegt.
void RandStrukturPV::initialisieren_vektoren(void)
    {
    cout << "Initialisieren_vektoren . Rang " << rang << " m " << m << " n " << n << " Eigenfarbe " << eigenfarbe << endl;

// Kommentar: m*n ist die maximale Lnge so einer Liste
    mn = m*n;
#ifdef KURZ_RAND_ELEMENTE
// Kommentar: Lege den Speicher fr die vertikalen Vektoren an. In diesem Falle besteht die Liste aus short - Integer - Werten.
    f1_v_vektor = new short int [mn+10];
    f2_v_vektor = new short int [mn+10];
    g_v_vektor = new short int [mn+10];

// Kommentar: Lege den Speicher fr die horizontalen Vektoren an. In diesem Falle besteht die Liste aus short - Integer - Werten.
    f_h_vektor = new short int [mn+10];
    g1_h_vektor = new short int [mn+10];
    g2_h_vektor = new short int [mn+10];
#else
// Kommentar: Lege den Speicher fr die vertikalen Vektoren an. In diesem Falle besteht die Liste aus Integer - Werten.
    f1_v_vektor = new int [mn+10];
    f2_v_vektor = new int [mn+10];
    g_v_vektor = new int [mn+10];

// Kommentar: Lege den Speicher fr die horizontalen Vektoren an. In diesem Falle besteht die Liste aus Integer - Werten.
    f_h_vektor = new int [mn+10];
    g1_h_vektor = new int [mn+10];
    g2_h_vektor = new int [mn+10];
#endif
    }

// Kommentar: Hier wird zuerst der Speicherplatz fr die vertikalen, und danach fr die horizontalen Vektoren freigegeben.
void RandStrukturPV::finalisieren_vektoren(void)
    {
    delete f1_v_vektor;
    delete f2_v_vektor;
    delete g_v_vektor;

    delete f_h_vektor;
    delete g1_h_vektor;
    delete g2_h_vektor;
    }

// Kommentar: Das Folgende ist eine Prffunktion fr die Kerntopologie. Es wird geprft, ob die Randstruktur komplett leer ist.
bool RandStrukturPV::ist_nicht_leer(void)
    {
//  Man knnte das auch ber anzahl_rs[i] prfen.

// Kommentar: Gibt es Punkte => nicht leer.
    if(punkteanzahl>0)
        {
        return(true);
        }
// Kommentar: Gibt es vertikale Vektoren => nicht leer.
    if(anzahl_v_vektor>0)
        {
        return(true);
        }
// Kommentar: Gibt es horizontale Vektoren => nicht leer.
    if(anzahl_h_vektor>0)
        {
        return(true);
        }
// Kommentar: Gibt es gar nichts von den dreien => leer.
    return(false);
    }
