#ifndef RECHNEN
#define RECHNEN 1

#include <iostream>

using namespace std;

#include "gitter.h"
#include "markierungsfeld.h"

// Kommentar: Die folgenden Formeln stellen meine Abwandlungen von Formeln der Implementierung von Herrn Hess der Shallow Water Equations dar.

#ifndef V1_fg_1
#define V1_fg_1 0.12*(v1[ff][gg]+v1[ff+1][gg]+v1[ff][gg+1]+v1[ff+1][gg+1])
#endif

#ifndef V1_fg_2
#define V1_fg_2 0.125*(v1[ff][gg]+v1[ff+1][gg]-v1[ff][gg+1]-v1[ff+1][gg+1])*konstante1
#endif

#ifndef V1_fg_3
#define V1_fg_3 0.127*(v1[ff][gg]-v1[ff+1][gg]-v1[ff][gg+1]+v1[ff+1][gg+1])*konstante1
#endif

#ifndef V1_fg_4
#define V1_fg_4 0.129*(-v1[ff][gg]+v1[ff+1][gg]-v1[ff][gg+1]+v1[ff+1][gg+1])*konstante1
#endif

#ifndef V2_fg_1
#define V2_fg_1 0.214*(v2[ff][gg]+v2[ff+1][gg]+v2[ff][gg+1]+v2[ff+1][gg+1])
#endif

#ifndef V2_fg_2
#define V2_fg_2 0.2125*(v2[ff][gg]+v2[ff+1][gg]-v2[ff][gg+1]-v2[ff+1][gg+1])*konstante1
#endif

#ifndef V2_fg_3
#define V2_fg_3 0.2127*(v2[ff][gg]-v2[ff+1][gg]-v2[ff][gg+1]+v2[ff+1][gg+1])*konstante1
#endif

#ifndef V2_fg_4
#define V2_fg_4 0.2129*(-v2[ff][gg]+v2[ff+1][gg]-v2[ff][gg+1]+v2[ff+1][gg+1])*konstante1
#endif

#ifndef V3_fg_1
#define V3_fg_1 0.316*(v3[ff][gg]+v3[ff+1][gg]+v3[ff][gg+1]+v3[ff+1][gg+1])
#endif

#ifndef V3_fg_2
#define V3_fg_2 0.3125*(v3[ff][gg]+v3[ff+1][gg]-v3[ff][gg+1]-v3[ff+1][gg+1])*konstante1
#endif

#ifndef V3_fg_3
#define V3_fg_3 0.3127*(v3[ff][gg]-v3[ff+1][gg]-v3[ff][gg+1]+v3[ff+1][gg+1])*konstante1
#endif

#ifndef V3_fg_4
#define V3_fg_4 0.3129*(-v3[ff][gg]+v3[ff+1][gg]-v3[ff][gg+1]+v3[ff+1][gg+1])*konstante1
#endif

#ifndef V4_fg_1
#define V4_fg_1 0.416*(v4[ff][gg]+v4[ff+1][gg]+v4[ff][gg+1]+v4[ff+1][gg+1])
#endif

#ifndef V4_fg_2
#define V4_fg_2 0.4125*(v4[ff][gg]+v4[ff+1][gg]-v4[ff][gg+1]-v4[ff+1][gg+1])*konstante1
#endif

#ifndef V4_fg_3
#define V4_fg_3 0.4127*(v4[ff][gg]-v4[ff+1][gg]-v4[ff][gg+1]+v4[ff+1][gg+1])*konstante1
#endif

#ifndef V4_fg_4
#define V4_fg_4 0.4129*(-v4[ff][gg]+v4[ff+1][gg]-v4[ff][gg+1]+v4[ff+1][gg+1])*konstante1
#endif

#ifndef V5_fg_1
#define V5_fg_1 0.15*(v5[ff][gg]+v5[ff+1][gg]+v5[ff][gg+1]+v5[ff+1][gg+1])
#endif

#ifndef V5_fg_2
#define V5_fg_2 0.4125*(v5[ff][gg]+v5[ff+1][gg]-v5[ff][gg+1]-v5[ff+1][gg+1])*konstante1
#endif

#ifndef V5_fg_3
#define V5_fg_3 0.4127*(v5[ff][gg]-v5[ff+1][gg]-v5[ff][gg+1]+v5[ff+1][gg+1])*konstante1
#endif

#ifndef V5_fg_4
#define V5_fg_4 0.4129*(-v5[ff][gg]+v5[ff+1][gg]-v5[ff][gg+1]+v5[ff+1][gg+1])*konstante1
#endif


#ifndef V6_fg_1
#define V6_fg_1 0.16*(v6[ff][gg]+v6[ff+1][gg]+v6[ff][gg+1]+v6[ff+1][gg+1])
#endif

#ifndef V6_fg_2
#define V6_fg_2 0.4125*(v6[ff][gg]+v6[ff+1][gg]-v6[ff][gg+1]-v6[ff+1][gg+1])*konstante2
#endif

#ifndef V6_fg_3
#define V6_fg_3 0.4127*(v6[ff][gg]-v6[ff+1][gg]-v6[ff][gg+1]+v6[ff+1][gg+1])*konstante3
#endif

#ifndef V6_fg_4
#define V6_fg_4 0.4129*(-v6[ff][gg]+v6[ff+1][gg]-v6[ff][gg+1]+v6[ff+1][gg+1])*konstante4
#endif

#ifndef V7_fg_1
#define V7_fg_1 0.17*(v7[ff][gg]+v7[ff+1][gg]+v7[ff][gg+1]+v7[ff+1][gg+1])
#endif

#ifndef V7_fg_2
#define V7_fg_2 0.4125*(v7[ff][gg]+v7[ff+1][gg]-v7[ff][gg+1]-v7[ff+1][gg+1])*konstante2
#endif

#ifndef V7_fg_3
#define V7_fg_3 0.4127*(v7[ff][gg]-v7[ff+1][gg]-v7[ff][gg+1]+v7[ff+1][gg+1])*konstante3
#endif


#ifndef V8_fg_1
#define V8_fg_1 0.18*(v8[ff][gg]+v8[ff+1][gg]+v8[ff][gg+1]+v8[ff+1][gg+1])
#endif

class Rechnen : virtual public Gitter
    {
private:
    int i, j, k;
    int ff, gg;
public:
    void vorglaetter(short int * _f, short int * _g, int anzahl);
    void nachglaetter(short int * _f, short int * _g, int anzahl);
    void vorglaetter_f(short int * _f, short int * _g, int anzahl);
    void nachglaetter_f(short int * _f, short int * _g, int anzahl);
    void loeser(short int * _f, short int * _g, int anzahl);
    void loeser_f(short int * _f, short int * _g, int anzahl);
    void residuum_berechnen(short int * _f, short int * _g, int anzahl);
    void berechne_grobe_rechte_seite(short int * _f, short int * _g, int anzahl);
    void berechne_grobe_rechte_seite_volles_gitter_darunter(short int * _f, short int * _g, int anzahl);
    void korrektur_nach_loesen(short int * _f, short int * _g, int anzahl);
    void korrektur_auf_feinem_gitter(short int * _f, short int * _g, int anzahl);
    void kopiere_Iu0_nach_u0(short int * _f, short int * _g, int anzahl);
    void berechne_e0(short int * _f, short int * _g, int anzahl);
    void berechne_Lu0(short int * _f, short int * _g, int anzahl);
    void berechne_DF0(short int * _f, short int * _g, int anzahl);
    void berechne_tau(short int * _f, short int * _g, int anzahl);
    void berechne_tau12(short int * _f, short int * _g, int anzahl);
    void rueckkopieren_u0(short int * _f, short int * _g, int anzahl);
public:
    int ** rand_markierungsfeld;
    double hilf_west, hilf_nord, hilf_ost, hilf_sued;
    MarkierungsFeld * neuer_punkt;
public:
    void rechnen_nur_als_punktelast(short int * _f, short int * _g, int anzahl);
    void rechnen_nur_als_punktelastI(short int * _f, short int * _g, int anzahl);
    void rechnen_nur_als_punktelastII(short int * _f, short int * _g, int anzahl);
private:
    void rechnen_nur_als_punktelast_red(short int * _f, short int * _g, int anzahl);
    void rechnen_nur_als_punktelast_black(short int * _f, short int * _g, int anzahl);
public:
    int wieviel_punktelast;
private:
    int max_punkte;
public:
    double ** arbeit;
public:
    int wieviel_mal_rand(short int * _f, short int * _g, int anzahl);
private:
    int wieviel_mal_rand_zahl;
public:
    int * f_arbeit, * g_arbeit;
public:
    int punkteanzahl;
private:
    public:
    double faktor;
private:
    int f2, g2;
public:
// red
    void vorglaetter_red(short int * _f, short int * _g, int anzahl);
    void nachglaetter_red(short int * _f, short int * _g, int anzahl);
    void vorglaetter_f_red(short int * _f, short int * _g, int anzahl);
    void nachglaetter_f_red(short int * _f, short int * _g, int anzahl);
    void loeser_red(short int * _f, short int * _g, int anzahl);
    void loeser_f_red(short int * _f, short int * _g, int anzahl);
// black
    void vorglaetter_black(short int * _f, short int * _g, int anzahl);
    void nachglaetter_black(short int * _f, short int * _g, int anzahl);
    void vorglaetter_f_black(short int * _f, short int * _g, int anzahl);
    void nachglaetter_f_black(short int * _f, short int * _g, int anzahl);
    void loeser_black(short int * _f, short int * _g, int anzahl);
    void loeser_f_black(short int * _f, short int * _g, int anzahl);
public:
    void reset_u0(short int * _f, short int * _g, int anzahl);
    void kopiere_u0_e0(short int * _f, short int * _g, int anzahl);
public:
    void loesen_vorher_teil1(short int * _f, short int * _g, int anzahl);
    void loesen_vorher_teil2(short int * _f, short int * _g, int anzahl);
    void loesen_vorher_teil3(short int * _f, short int * _g, int anzahl);
    void loesen_vorher_teil4(short int * _f, short int * _g, int anzahl);
    void loesen_vorher_teil5(short int * _f, short int * _g, int anzahl);
    void loesen_vorher_teil6(short int * _f, short int * _g, int anzahl);
    void loesen_nachher_teil1(short int * _f, short int * _g, int anzahl);
    void loesen_nachher_teil2(short int * _f, short int * _g, int anzahl);
public:
    void glaetten_swe(short int * _f, short int * _g, int anzahl);
    void glaetten_swe_black(short int * _f, short int * _g, int anzahl);
    void glaetten_swe_red(short int * _f, short int * _g, int anzahl);
private:
public:
    long int zaehlen_rechnungsschritte;
public:
    void gebe_e0_aus(short int * _f, short int * _g, int anzahl);
    };

#endif
