#include "restriktion.h"

// Kommentar: Bei der Restriktion wird kein Speicher allokiert, also wird auch kein Speicher freigegeben.

void Restriktion::finalisieren(void)
    {
    }

#ifdef KURZ_FF
// Kommentar: Hier wird diese Klasse Restriktion initialisiert. Dabei wird keni Speicher allokiert, wohl aber bergeben.
void Restriktion::initialisieren(int _n_oben, int _m_oben, short int ** _farbenfeld_unten, int _rang, int _ebene, int ** _snb_unten, short int * _f_s, short int * _g_s)
#else
void Restriktion::initialisieren(int _n_oben, int _m_oben, int ** _farbenfeld_unten, int _rang, int _ebene, int ** _snb_unten, short int * _f_s, short int * _g_s)
#endif
    {
// Kommentar: Es werden m_oben und n_oben bergeben.
    m_oben = _m_oben;
    n_oben = _n_oben;
// Kommentar: Daraus werden m_unten und n_unten per Formel abgeleitet.
    m_unten = 2*m_oben - 1;
    n_unten = 2*n_oben -1;
// Kommentar: Dann hat man noch - um Zeit zu sparen - von den Paramtern m und n 1 oder 2 abgezogen, und das zu speichern,
// weil das gebraucht wird.
    m_minus1_oben = m_oben-1;
    n_minus1_oben = n_oben - 1;
    n_minus1_unten = n_unten - 1;
    n_minus2_unten = n_unten -2;
    m_minus1_unten = m_unten -1;
    m_minus2_unten = m_unten -2;

// Kommentar: Fr die Funktionen full_weighting_innen_VARIABLE_ohne_rand_unten, mit typischen Ersetzungen fr VARIABLE,
// wird das Farbenfeld unten bentigt, um whrend der Randkommunikation auf dem unteren Gitter schon fr eine
// relevante Punktmenge Restriktionen durchfhren zu knnen.
    farbenfeld_unten = _farbenfeld_unten;
// Kommentar: Rang ist der eigene Rang des Kerns, und die Ebene ist die obere Gitterebene. Beides ist fr
// Debugging - Ausgaben da.
    rang = _rang;
    ebene = _ebene;

//    alle_nicht_inneren_punkte.initialisierung(m_oben, n_oben);

// Kommentar: Hier wird Speicher bereitgestellt, um die nicht sofort berechenbaren oberen Innenpunkte zu speichern.
    f_s = _f_s;
    g_s = _g_s;

// Kommentar: Diese Variable - selbstnachbarn des unteren Gitters - ist ntig, um zu entscheiden, welche Punkte
// zwischengespeichert werden, um fr die brigen Punkte whrend der Kommunikation die Restriktions - Berechnungen
// durchzufhren.
    snb_unten = _snb_unten;

// Kommentar: Hier werden nur 2 Konstanten gespeichert.
    konstante2 = 2.0;
    konstante3 = 3.0;
    }

// Kommentar: Bei der Restriktion braucht man Zugriff auf die Variablen des grberen und des feineren Gitters.
// Die in diesem Sinne hier verwendeten Variablen werden an diese Klasse Restriktion bergeben, und hier gespeichert.
void Restriktion::initialisieren_u0r0(double ** _u0_unten, double ** _u0_oben, double ** _r0_unten, double ** _r0_oben, double ** _Iu0_oben, double ** _rS0_oben, double ** _f0_unten, double ** _f0_oben)
    {
// Kommentar: Die Variablennamen ohne die Suffixe sind klar benannt. Der Suffix oben steht fr eine Variable des grberen
// Gitters, der Suffix unten steht fr eine Variable des feineren Gitters.
    u0_unten = _u0_unten;
    u0_oben = _u0_oben;
    r0_unten = _r0_unten;
    r0_oben = _r0_oben;
    Iu0_oben = _Iu0_oben;
    rS0_oben = _rS0_oben;
    f0_unten = _f0_unten;
    f0_oben = _f0_oben;
    }

// Kommentar: Fr die Initialisierung der Variablen fr die Restriktion der Implementierung fr Mehrgitterverfahren von Herrn Hess der Shallow Water Equations - an denen von mir
// Vernderungen vorgenommen wurden - werden die Variablen v6, v7 und v8 auf dem feineren Gitter sowie die Variable v9
// auf dem grberen Gitter bentigt, die hier bergeben werden.
void Restriktion::initialisieren_swe(double ** _v6_unten, double ** _v7_unten, double ** _v8_unten, double ** _v9_oben)
    {
    v6_unten = _v6_unten;
    v7_unten = _v7_unten;
    v8_unten = _v8_unten;
    v9_oben = _v9_oben;
    }

// Kommentar: Hier geschieht ein Full - Weighting fr die Innenpunkte des grberen Gitters fr die Variable u0.
// Dieses sequentiell zu berechnen geht.
// Das parallel zu rechnen macht aber keinen Sinn, weil nur da whrend der Kommunikation gerechnet werden kann, wo auf dem unteren
// Gitter Innenpunkte vorliegen. Deshalb werden statt dieser Funktion die Funktionen full_weighting_innen_u0_ohne_rand_unten
// und full_weighting_innen_u0_abschluss aufgerufen.
void Restriktion::full_weighting_innen_u0(void)
    {
// Kommentar: Die Variablen y0_unten und y0_oben sind die Variablen, fr die der Full Weighting - Operator die Restriktion
// durchfhrt. Diese mssen wie angegeben verknpft werden, um eine Interpolation bzgl. der Variablen u0
// durchzufhren.
    y0_unten = u0_unten;
    y0_oben = Iu0_oben;
    full_weighting_innen();
    }

// Kommentar: Hier geschieht ein Full - Weighting fr die Randpunkte des grberen Gitters fr die Variable u0.
void Restriktion::full_weighting_rand_innen_u0(void)
    {
// Kommentar: Die Variablen y0_unten und y0_oben sind die Variablen, fr die der Full Weighting - Operator die Restriktion
// durchfhrt. Diese mssen wie angegeben verknpft werden, um eine Interpolation bzgl. der Variablen u0
// durchzufhren.
    y0_unten = u0_unten;
    y0_oben = Iu0_oben;
// Mit diesem Befehl wird dsa Full Weighting auf dem Rand fr die Variable u0 durchgefhrt.
    full_weighting_rand_innen();
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende full_weighting_rand_innen u0 / rang " << endl;
#endif
    }

// Kommentar: Hier geschieht ein Full - Weighting fr die Innenpunkte des grberen Gitters fr die Variable r0.
// Kommentar: Diese Funktion kann nur im sequentiellen Fall benutzt werden, weil nur gerechnet werden kann, wenn der
// Feingitterpunkt ein innerer Punkt ist, aber nicht der Grobgitterpunkt.
void Restriktion::full_weighting_innen_r0(void)
    {
// Kommentar: Die Variablen y0_unten und y0_oben sind die Variablen, fr die der Full Weighting - Operator die Restriktion
// durchfhrt. Diese mssen wie angegeben verknpft werden, um eine Interpolation bzgl. der Variablen r0
// durchzufhren.
    y0_unten = r0_unten;
    y0_oben = r0_oben;
    full_weighting_innen();
    }

// Kommentar: Analog zu full_weighting_innen_r0, nur dass oben die Variable rS0_oben beschrieben wird.
void Restriktion::full_weighting_innen_r0rS0(void)
    {
    y0_unten = r0_unten;
    y0_oben = rS0_oben;
    full_weighting_innen();
    }

// Kommentar: Das hier ist nicht analog zu den vorhergehenden Restriktionen, weil hier eine Injektion gemacht wird. Insbesondere
// wird die Funktion 'injektion' aufgerufen - statt eine der full_weighting Funktionen aufzurufen.
void Restriktion::injektion_nach_u0_und_Iu0(void)
    {
// Kommentar: Die Quelle der Informationen ist u0_unten, und so, wie die Funktion injektion geschrieben ist, wird
// oben sowohl u0_oben als auch Iu0_oben beschrieben.
    y0_unten = u0_unten;
    y0_oben = u0_oben;
    y1_oben = Iu0_oben;
// Kommentar: Durchfhrung der Injektion.
    injektion();
    }

// Kommentar: Hier geschieht ein Full - Weighting fr die Randpunkte des grberen Gitters fr die Variable r0.
// Diese Funktion wird allgemein gebraucht, da sie auch insbesondere mit den Funktionen
// full_weighting_innen_u0_ohne_rand_unten und full_weighting_innen_u0_abschluss zusammenarbeiten kann.
void Restriktion::full_weighting_rand_innen_r0(void)
    {
// Kommentar: Die Quelle der Werte ist r0 auf dem feineren Gitter (r0_unten), und geschrieben wird in r0 des
// grberen Gitters (r0_oben).
    y0_unten = r0_unten;
    y0_oben = r0_oben;
// Kommentar: Aufgerufen wird full_weighting_rand_innen.
    full_weighting_rand_innen();
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende full_weighting_rand_innen r0 / rang " << endl;
#endif
    }

// Kommentar: Analog zu full_weighting_rand_innen_r0, nur dass die Variable f0 am Rand einer Restriktion unterzogen wird.
void Restriktion::full_weighting_rand_innen_f0(void)
    {
    y0_unten = f0_unten;
    y0_oben = f0_oben;
    full_weighting_rand_innen();
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende full_weighting_rand_innen r0 / rang " << endl;
#endif
    }

// Kommentar: Analog zu full_weighting_rand_innen_r0, nur dass die Variable r0 auf dem feineren Gitter die Quelle der
// Informationen der Restriktion ist, und rS0 auf dem grberen Gitter das Ziel der Restriktion ist.
void Restriktion::full_weighting_rand_innen_r0rS0(void)
    {
    y0_unten = r0_unten;
    y0_oben = rS0_oben;
    full_weighting_rand_innen();
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende full_weighting_rand_innen r0 / rang " << endl;
#endif
    }

// Kommentar: Analog zu full_weighting_innen_r0, nur dass unten die Variable Lu0 gelesen und oben die Variable
// ILu0 beschrieben wird.
void Restriktion::full_weighting_innen_Lu0(void)
    {
    y0_unten = Lu0_unten;
    y0_oben = ILu0_oben;
    full_weighting_innen();
    }

// Kommentar: Analog zu full_weighting_rand_innen_r0, nur dass unten die Variable Lu0 gelesen und oben die Variable
// ILu0 beschrieben wird.
void Restriktion::full_weighting_rand_innen_Lu0(void)
    {
    y0_unten = Lu0_unten;
    y0_oben = ILu0_oben;
    full_weighting_rand_innen();
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende full_weighting_rand_innen Lu0 / rang " << endl;
#endif
    }

// Zu viele Restriktionen: Oben braucht nur das gemacht werden, wo darunter auch etwas ist. Sogar sequentiell.

// Kommentar: Hier wird eine Injektion gemacht, die allerdings oben zwei Werte beschreibt. Da es eine Injektion ist, muss
// keine Rand ausgetauscht werden, weshalb direkt nacheinander Rand und Inneres behandelt werden. Die Anzahlen der Gitterpunkte
// oben mssen vorher aus Zyklus Rechnen hierher kopiert werden.
void Restriktion::injektion(void)
    {
#ifdef AKTUELLE_WERTE
    cout << " Injektion rang " << rang << endl;
#endif
// 16.08.2014: Das stimmt doch nicht bei einem Gitter darunter, was nicht komplett ist.
// Doch: Es klappt mit den 'kleinen Gittern'.

// Kommentar: Zuerst wird der Rand oben durchlaufen, und die Werte auf den Punkten darunter an diese Stellen kopiert.
    for(i=0; i<anzahl_rand_innen_oben; i++)
        {
        ff = f_rand_innen_oben[i];
        gg = g_rand_innen_oben[i];
// Kommentar: Die Stellen darunter haben in Bezug auf die Koordinaten den doppelten Wert.
        ff_unten = ff << 1;
        gg_unten = gg << 1;

        if(feld_ebene[ff_unten][gg_unten]==-1)
            {
            continue;
            }
// Kommentar: Der Wert unten wird gelesen ...
        hilfswert_oben = y0_unten[ff_unten][gg_unten];

// Kommentar: Und dann nach oben kopiert.
        y0_oben[ff][gg] = hilfswert_oben;
        y1_oben[ff][gg] = hilfswert_oben;
        }
// Kommentar: Danach macht man dasselbe fr den echten Rand. 12.2.16
    for(i=0; i<anzahl_rand_innen_oben_echter_rand; i++)
        {
        ff = f_rand_innen_oben_echter_rand[i];
        gg = g_rand_innen_oben_echter_rand[i];

        ff_unten = ff << 1;
        gg_unten = gg << 1;

        if(feld_ebene[ff_unten][gg_unten]==-1)
            {
            continue;
            }

        hilfswert_oben = y0_unten[ff_unten][gg_unten];

        y0_oben[ff][gg] = hilfswert_oben;
        y1_oben[ff][gg] = hilfswert_oben;
        }
// Kommentar: Danach macht man dasselbe fr die Innenmenge.
    for(i=0; i<anzahl_innen_oben; i++)
        {
        ff = f_innen_oben[i];
        gg = g_innen_oben[i];
        ff_unten = ff << 1;
        gg_unten = gg << 1;

        if(feld_ebene[ff_unten][gg_unten]==-1)
            {
            continue;
            }

        hilfswert_oben = y0_unten[ff_unten][gg_unten];

        y0_oben[ff][gg] = hilfswert_oben;
        y1_oben[ff][gg] = hilfswert_oben;
        }
    }

// Kommentar: Hier wird das Full Weighting auf dem Rand in Bezug auf das obere Gitter durchgefhrt.
void Restriktion::full_weighting_rand_innen(void)
    {
#ifdef AUSGABEN
    cout << "Full Weighting: n_minus1_oben = " << n_minus1_oben << " m_minus_1_oben : " << m_minus1_oben << endl << endl;
#endif

// Kommentar: Der Rand oben wird durchlaufen ...
    for(i=0; i<anzahl_rand_innen_oben; i++)
        {
        ff = f_rand_innen_oben[i];
        gg = g_rand_innen_oben[i];
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX full weighting ebene " << ebene << " rang " << rang << " ff " << ff << " gg " << gg << endl;
#endif
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif
// Kommentar: Und der Full Weighting - Operator bzwgl. der Variablen y0_oben (zum Schreiben) und y0_unten (zum Lesen)
// ausgefhrt.
        fw_operator();
#ifdef AKTUELLE_KOMMENTARE
        if(y0_oben[ff][gg] > 2000)
            {
            cout << " Restriktionsfehler ff " << ff << " gg " << gg << " nicht vorhanden " << nicht_vorhanden << " rang " << rang << " i " << i;
            cout << " ff_u " << ff_unten << " gg_u " << gg_unten;
            cout << " y0 " << y0_oben[ff][gg] << " u0_unten .. " << u0_unten[ff_unten][gg_unten];
            cout << " y0_unten -- " << y0_unten[ff_unten-1][gg_unten-1] << " -+ " << y0_unten[ff_unten-1][gg_unten+1] << " ";
            cout << " +- " << y0_unten[ff_unten+1][gg_unten-1] << " ++ " << y0_unten[ff_unten+1][gg_unten+1] << " ";
            cout << " .- " << y0_unten[ff_unten][gg_unten-1] << " .+ " << y0_unten[ff_unten][gg_unten+1] << " ";
            cout << " -. " << y0_unten[ff_unten-1][gg_unten] << " +. " << y0_unten[ff_unten+1][gg_unten] << " ";
            cout << " .. " << y0_unten[ff_unten][gg_unten];
            cout << " fgff(.-) " << farbenfeld_unten[ff_unten][gg_unten-1];
            cout << " fgff(--) " << farbenfeld_unten[ff_unten-1][gg_unten-1];
            cout << " fgff(+-) " << farbenfeld_unten[ff_unten+1][gg_unten-1] << endl;
            }
#endif
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende Full Weighting 1" << endl;
#endif

// Kommentar: Hier werden die Variablen (f_rand_innen_echter_rand,g_rand_innen_echter_rand) aus der Klasse Gitter abgearbeitet.
    for(i=0; i<anzahl_rand_innen_oben_echter_rand; i++)
        {
        ff = f_rand_innen_oben_echter_rand[i];
        gg = g_rand_innen_oben_echter_rand[i];

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX full weighting Rand Innen Oben echter Rand Ebene " << ebene << " rang " << rang << " i " << i << " ff " << ff << " gg " << gg << " m_oben " << m_oben << " m_unten " << m_unten << endl;
#endif
        fw_operator();
        }
    }

// Kommentar: Hier wird das Full Weighting auf dem inneren Gebiet in Bezug auf das obere Gitter durchgefhrt.
void Restriktion::full_weighting_innen(void)
    {
#ifdef AUSGABEN
    cout << "Nach Teil 1 " << endl << endl;

    cout << "FW anzahl_innen_oben " << anzahl_innen_oben << " rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << " full_weighting ";
#endif
// Kommentar: Die innere Punktmenge des oberen Gitters wird durchlaufen.
    for(i=0; i<anzahl_innen_oben; i++)
        {
        ff = f_innen_oben[i];
        gg = g_innen_oben[i];
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif
// Kommentar: Und der Full Weighting Operator in Bezug auf y0_unten gelesen und y0_oben geschrieben.
        fw_operator();
#ifdef AKTUELLE_WERTE
        cout << "(" << ff << "," << gg << "," << y0_oben[ff][gg] << ")";
#endif
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende FW 2" << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << endl;
#endif
    }


////////////////////////////////////////////////////////////
///////////////  Die neuen fw - Funktionen    //////////////
///////////////  19.08.2014                   //////////////
////////////////////////////////////////////////////////////

// Kommentar: Das hier ist auch ein Full Weighting Restriktions - Operator. Der Unterschied zum anderen
// Full - Weighting Operator besteht nur darin, dass ff_unten und gg_unten - die Koordinaten auf dem feineren
// Gitter - dabei nicht in der Funktion mit dem fw - Operator berechnet werden, sondern dort, wo die Funktion
// aufgerufen wird. Alle weiteren Teile des Operators entsprechen sich, weshalb diese Funktion nicht fr sich
// kommentiert werden muss.


// Kommentar: Diese Funktion ist wichtig bei der parallelen Behandlung des Full - Weighting Operators. Nur auf diese
// Weise darf dieser Fall behandelt werden. Es wird das Innere des oberen Gitters bearbeitet. Dabei wird die Restriktion aber
// nur fr solche Gitterpunkte berechnet, die auf dem feineren Gitter darunter innere Punkte sind. Dafr ist nur zu prfen,
// ob selbstnachbarn auf dem feinen Gitter auf den Feingitterkoordinaten gleich 255 ist.
// Andernfalls wird der Grobgitterpunkt gespeichert, um nach dem Empfang der Randkommunikation auf dem feineren Gitter
// abgearbeitet zu werden. Die Funktionen dazu haben das Suffix 'abschluss'.
void Restriktion::full_weighting_innen_ohne_rand_unten(void)
    {
#ifdef AUSGABEN
    cout << "Nach Teil 1 " << endl << endl;

    cout << "FW anzahl_innen_oben " << anzahl_innen_oben << " rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << " full_weighting ";
#endif
// Kommentar: Die zu speichernde Punktmenge mit dem Suffix 's' wird erst leer gemacht.
    anzahl_s = 0;
// Kommentar: Dann werden die Innenpunkte oben durchlaufen.
    for(i=0; i<anzahl_innen_oben; i++)
        {
        ff = f_innen_oben[i];
        gg = g_innen_oben[i];
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX Y full weighting ebene " << ebene << " rang " << rang << " ff " << ff << " gg " << gg << endl;
#endif
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif
// Kommentar: Dazu werden die unteren Punkte berechnet. Wichtig: Nun wird der 2.te fw - Operator verwendet, weil vor dessen
// Aufruf snb_unten abgefragt werden muss an den unteren Koordinaten. Sonst mten ff_unten und gg_unten zweimal berechnet werden.
        ff_unten = ff << 1;
        gg_unten = gg << 1;

// Kommentar: Ist unten ein Randpunkt vorhanden, dann wird er nur zur spteren Berechnung gespeichert.
        if(snb_unten[ff_unten][gg_unten]!=255)
            {
//            alle_nicht_inneren_punkte.hinzu(ff, gg);
            f_s[anzahl_s] = ff;
            g_s[anzahl_s++] = gg;
            continue;
            }

// Kommentar: Ansonsten liegen fr den Gitterpunkt alle bentigten Werte vor, und es kommt zur Berechnung des Full Weightings
// auf diesen Koordinaten.
        fw_operator_ohne_ff_gg_berechnung();
#ifdef AKTUELLE_WERTE
        cout << "(" << ff << "," << gg << "," << y0_oben[ff][gg] << ")";
#endif
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende FW 2" << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << endl;
#endif
    }

// Kommentar: Hier wird das full_weighting nur fr innere Punkte unten - also auf dem feinen Gitter - in Bezug auf die Variable
// u0 durchgefhrt.
void Restriktion::full_weighting_innen_u0_ohne_rand_unten(void)
    {
// Kommentar: Es wird auf dem feineren Gitter unten die Variable u0 und auf dem grberen Gitter oben die Variable Iu0
// gesetzt.
    y0_unten = u0_unten;
    y0_oben = Iu0_oben;
// Kommentar: Und dann wird das Full Weighting nur fr Innenpunkte des feineren Gitters durchgefhrt. Die nicht Innenpunkte unten
// werden ja fr den 'Abschluss' gespeichert.
    full_weighting_innen_ohne_rand_unten();
    }


// Kommentar: Analog zu 'full_weighting_innen_u0_ohne_rand_unten' - nur mit den Variablen r0 auf dem feineren und grberen Gitter.
void Restriktion::full_weighting_innen_r0_ohne_rand_unten(void)
    {
    y0_unten = r0_unten;
    y0_oben = r0_oben;
    full_weighting_innen_ohne_rand_unten();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_ohne_rand_unten' - nur mit den Variablen f0 auf dem feineren und grberen Gitter.
void Restriktion::full_weighting_innen_f0_ohne_rand_unten(void)
    {
    y0_unten = f0_unten;
    y0_oben = f0_oben;
    full_weighting_innen_ohne_rand_unten();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_ohne_rand_unten' - nur mit den Variablen r0 auf dem feineren und der Variablen rS0
// auf dem grberen Gitter.
void Restriktion::full_weighting_innen_r0rS0_ohne_rand_unten(void)
    {
    y0_unten = r0_unten;
    y0_oben = rS0_oben;
    full_weighting_innen_ohne_rand_unten();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_ohne_rand_unten' - nur mit den Variablen Lu0 auf dem feineren und ILu0 auf dem grberen Gitter.
void Restriktion::full_weighting_innen_Lu0_ohne_rand_unten(void)
    {
    y0_unten = Lu0_unten;
    y0_oben = ILu0_oben;
    full_weighting_innen();
    }

// Kommentar: Hier werden die bei der Funktion 'full_weighting_innen_ohne_rand_unten' gespeicherten - also noch nicht berechneten -
// Punkte einer Restriktion unterzogen.
void Restriktion::full_weighting_innen_abschluss(void)
    {
#ifdef AUSGABEN
    cout << "Nach Teil 1 " << endl << endl;

    cout << "FW anzahl_innen_oben " << anzahl_innen_oben << " rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << " full_weighting ";
#endif
// Kommentar: Die bei der Funktion 'full_weighting_innen_ohne_rand_unten' gespeicherten Punkte werden nun durchlaufen.
    for(i=0; i<anzahl_s; i++)
        {
        ff = f_s[i];
        gg = g_s[i];
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif

// Kommentar: ff_unten und gg_unten - die Koordinaten auf dem feineren Gitter - werden berechnet.
        ff_unten = ff << 1;
        gg_unten = gg << 1;

// Kommentar: Der Full Weighting - Operator wird aufgerufen.
        fw_operator_ohne_ff_gg_berechnung();
#ifdef AKTUELLE_WERTE
        cout << "(" << ff << "," << gg << "," << y0_oben[ff][gg] << ")";
#endif
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende FW 2" << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << endl;
#endif
    anzahl_s = 0;
    }

/////////////////////////////////////////////////////////////
///// Abschlsse  ///////////////////////////////////////////
/////////////////////////////////////////////////////////////

// Kommentar: Hier wird das full_weighting nur fr die verbliebenen Punkte (f_s,g_s) in Bezug auf die Variable u0 auf dem feineren
// und Iu0 auf dem grberen Gitter durchgefhrt.
//
void Restriktion::full_weighting_innen_u0_abschluss(void)
    {
// Kommentar: Zuerst werden die Zeiger y0_unten und y0_oben auf die Variablen verknpft.
    y0_unten = u0_unten;
    y0_oben = Iu0_oben;
// Kommentar: Und dann wird ebige Funktion - Full weighting abschluss - aufgerufen, um fr die verbleibenen Punkte das Full
// Weighting zu berechnen.
    full_weighting_innen_abschluss();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_abschluss' - nur mit den Variablen r0 auf dem feineren und r0 auf dem
// grberen Gitter.
void Restriktion::full_weighting_innen_r0_abschluss(void)
    {
    y0_unten = r0_unten;
    y0_oben = r0_oben;
    full_weighting_innen_abschluss();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_abschluss' - nur mit den Variablen f0 auf dem feineren und f0 auf dem
// grberen Gitter.
void Restriktion::full_weighting_innen_f0_abschluss(void)
    {
    y0_unten = f0_unten;
    y0_oben = f0_oben;
    full_weighting_innen_abschluss();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_abschluss' - nur mit den Variablen r0 auf dem feineren und rS0 auf dem
// grberen Gitter.
void Restriktion::full_weighting_innen_r0rS0_abschluss(void)
    {
    y0_unten = r0_unten;
    y0_oben = rS0_oben;
    full_weighting_innen_abschluss();
    }

// Kommentar: Analog zu 'full_weighting_innen_u0_abschluss' - nur mit den Variablen Lu0 auf dem feineren und ILu0 auf dem
// grberen Gitter.
void Restriktion::full_weighting_innen_Lu0_abschluss(void)
    {
    y0_unten = Lu0_unten;
    y0_oben = ILu0_oben;
    full_weighting_innen_abschluss();
    }

// Kommentar: Hier wird ein in Bezug auf die Implementierung von Herrn Hess der Shallow Water Equations von mir abgewandelter Full Weighting-Operator geschrieben.
// Dabei wird er auf Punkten, die einen echten Rand haben, nicht berechnet.
void Restriktion::fw_operator_swe(void)
    {
// Kommentar: Zuerst werden die Feingitter - Koordinaten berechnet.
    ff_unten = ff << 1;
    gg_unten = gg << 1;

// Kommentar: Dann wird geprft, ob unten ein echter Randpunkt vorliegt. Genauer: Die Abfrage, ob der Punkt an den maximalen
// Gittergrenzen liegt, kann, wie auch hier, auf dem groben Gitter erfolgen. Denn die Gittermae von grobem und feinem Gitter
// sind eindeutig ineinander umzurechnen. Das farbenfeld muss aber auf dem feineren Gitter geprft werden, weil nur dort
// geklrt werden kann, ob die ntigen Informationen vorliegen.
    if((ff==0)||(farbenfeld_unten[ff_unten-1][gg_unten]==-1))
        {
        return;
        }

    if((gg==0)||(farbenfeld_unten[ff_unten][gg_unten-1]==-1))
        {
        return;
        }
    if((ff==n_minus1_oben)||(farbenfeld_unten[ff_unten+1][gg_unten]==-1))
        {
        return;
        }
    if((gg==m_minus1_oben)||(farbenfeld_unten[ff_unten][gg_unten+1]==-1))
        {
        return;
        }
// Kommentar: Es wird v9_hilf in Abhngigkeit von v7, v8 und v9 berechnet. Es werden Punkte sn den angegebenen Stellen bestimmt.
// Dabei gilt: vf_2_unten sind Konstanten, die deshalb an beliebigen Stellen bestimmt werden. Fr die Variable v6 werden auch Zahlen
// wie v6_unten(ff_unten-2)(gg_unten) zur Rechnung bentigt. Das geht mit dem Randaustausch fg_v6 auf dem grberen Gitter, weil
// ber (ff_unten-2,gg_unten) ein Grobgitterpunkt liegt, an dessen Stelle dann der Wert fr die Koordinate (ff_unten-2,gg_unten)
// gepackt wird - vgl. die Dissertation. Deswegen werden nur zulssige Werte in die Berechnung einbezogen.
    v9_hilf = (v7_unten[ff_unten][gg_unten]+v8_unten[ff_unten][gg_unten]+vf_2_unten[2*ff_unten+1]+vf_2_unten[2*ff_unten]+vf_2_unten[2*ff_unten-1]);
    v9_hilf += v6_unten[ff_unten-1][gg_unten] + v6_unten[ff_unten+1][gg_unten] + v6_unten[ff_unten][gg_unten-1]+ v6_unten[ff_unten][gg_unten+1];
    v9_hilf += v6_unten[ff_unten-2][gg_unten] + v6_unten[ff_unten+2][gg_unten] + v6_unten[ff_unten][gg_unten-2]+ v6_unten[ff_unten][gg_unten+2];
    v9_hilf += (v7_unten[ff_unten][gg_unten]-v8_unten[ff_unten][gg_unten]-vf_2_unten[2*ff_unten+1]+vf_2_unten[2*ff_unten]-vf_2_unten[2*ff_unten-1]);
    v9_hilf = v9_hilf/konstante2;
    v9_hilf = v9_hilf/konstante3;
    }

// Kommentar: Hier wird das Full Weighting Abschluss gemacht - es wird Full Weighting fr die beim Aufruf der Funktion
// 'full_weighting_innen_ohne_rand_unten_swe' gespeicherten Punkte durchgefhrt.

void Restriktion::full_weighting_innen_abschluss_swe(void)
    {
#ifdef AUSGABEN
    cout << "Nach Teil 1 " << endl << endl;

    cout << "FW anzahl_innen_oben " << anzahl_innen_oben << " rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << " full_weighting ";
#endif
// Kommentar: Man durchluft die Punkte, die beim Aufruf der Funktion 'full_weighting_innen_ohne_rand_unten_swe' gespeichert
// worden sind.
    for(i=0; i<anzahl_s; i++)
        {
        ff = f_s[i];
        gg = g_s[i];
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif

// Kommentar: Dann werden die Feingitterkoordinaten berechnet.
        ff_unten = ff << 1;
        gg_unten = gg << 1;

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX vor hw SWE fwiah rang " << rang << endl;
#endif

// Kommentar: Und es wird der Restriktions-Operator, der dem der Implementierung von Herrn Hess der SWE hnlich ist, aufgerufen.
        fw_operator_swe();

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX nach hw SWE fwish rang " << rang << " ff " << ff << " gg " << gg << " m_oben " << m_oben << " n_oben " << n_oben << " m_unten " << m_unten << " n_unten " << n_unten << endl;
#endif
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende FW 2" << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << endl;
#endif
// Kommentar: Am Ende wird die gespeicherte Menge geleert. (evtl. berflssig)
    }

// Kommentar: Diese Funktion ist wichtig bei der parallelen Behandlung des Full - Weighting Operators. Nur auf diese
// Weise darf dieser Fall behandelt werden. Es wird das Innere des oberen Gitters bearbeitet. Dabei wird die Restriktion aber
// nur fr solche Gitterpunkte berechnet, die auf dem feineren Gitter darunter innere Punkte sind. Dafr ist nur zu prfen,
// ob selbstnachbarn auf dem feinen Gitter auf den Feingitterkoordinaten gleich 255 ist.
// Andernfalls wird der Grobgitterpunkt gespeichert, um nach dem Empfang der Randkommunikation auf dem feineren Gitter
// abgearbeitet zu werden. Die Funktion dazu hat das Suffix 'abschluss'.
// Bemerkung: Hier wird ein in Bezug auf die Implementierung von Herrn Hess der Shallow Water Equations von mir abgewandelter Full Weighting-Operator durchgefhrt.
void Restriktion::full_weighting_innen_ohne_rand_unten_swe(void)
    {
#ifdef AUSGABEN
    cout << "Nach Teil 1 " << endl << endl;

    cout << "FW anzahl_innen_oben " << anzahl_innen_oben << " rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << " full_weighting ";
#endif
// Kommentar: Die zu speichernde Punktmenge wird geleert.
    anzahl_s = 0;
// Kommentar: Die innere Punktmenge des grberen Gitters wird durchlaufen.
    for(i=0; i<anzahl_innen_oben; i++)
        {
        ff = f_innen_oben[i];
        gg = g_innen_oben[i];
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX Y full weighting fwioruh ebene " << ebene << " rang " << rang << " ff " << ff << " gg " << gg << endl;
#endif
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif

// Kommentar: Die Feingitterkoordinaten werden berechnet-
        ff_unten = ff << 1;
        gg_unten = gg << 1;

// Kommentar: Ist unten ein Randpunkt vorhanden, dann wird er nur zur spteren Berechnung gespeichert.
        if(snb_unten[ff_unten][gg_unten]!=255)
            {
//            alle_nicht_inneren_punkte.hinzu(ff, gg);
            f_s[anzahl_s] = ff;
            g_s[anzahl_s++] = gg;
            continue;
            }

// Kommentar: Hier wird ein in Bezug auf die Implementierung von Herrn Hess der Shallow Water Equations von mir abgewandelter Full Weighting-Operator aufgerufen.
        fw_operator_swe();

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX Y nach hw SWE fwioruh rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende FW 2" << endl;
#endif
#ifdef AKTUELLE_WERTE
    cout << endl;
#endif
    }

// Kommentar: Es geht hier wieder um das Full-Weighting der Implementierung von Herrn Hess der SWE, das von mir abgewandelt wurde. Hier werden die
// Restriktionswerte fr die Randpunkte in Bezug auf das grbere Gitter berechnet.
void Restriktion::full_weighting_rand_innen_swe(void)
    {
#ifdef AUSGABEN
    cout << "Full Weighting rih: n_minus1_oben = " << n_minus1_oben << " m_minus_1_oben : " << m_minus1_oben << endl << endl;
#endif
// Kommentar: Die Randmenge des grberen Gitters wird durchlaufen.
    for(i=0; i<anzahl_rand_innen_oben; i++)
        {
        ff = f_rand_innen_oben[i];
        gg = g_rand_innen_oben[i];

// Kommentar: Die Feingitterkoordinaten zu den Grobgitterkoordinaten werden berechnet.
        ff_unten = ff << 1;
        gg_unten = gg << 1;

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX full weighting vor Operator rih ebene " << ebene << " rang " << rang << " ff " << ff << " gg " << gg << endl;
#endif
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif
// Kommentar: Der Full Weighting Operator in Bezug auf die von mir genderte Version der Implementierung von Herrn Hess der SWE wird aufgerufen.
        fw_operator_swe();
#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX nach hw SWE rih rang " << rang << endl;
#endif

        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Ende Full Weighting 1" << endl;
#endif
// Kommentar: Hier werden die Variablen (f_rand_innen_echter_rand,g_rand_innen_echter_rand) aus der Klasse Gitter abgearbeitet.
    for(i=0; i<anzahl_rand_innen_oben_echter_rand; i++)
        {
        ff = f_rand_innen_oben_echter_rand[i];
        gg = g_rand_innen_oben_echter_rand[i];
// Kommentar: Die Feingitterkoordinaten zum ausgewhlte Gitterpunkt werden berechnet.
        ff_unten = ff << 1;
        gg_unten = gg << 1;

#ifdef AKTUELLE_KOMMENTARE_NEU
        cout << " VWX full weighting vor Operator rih ebene " << ebene << " rang " << rang << " ff " << ff << " gg " << gg << " m_oben " << m_oben << " m_unten " << m_unten << endl;
#endif
#ifdef AUSGABEN
        cout << " (" << ff << " " << gg << ") ";
#endif
// Kommentar: Der Full Weighting Operator in Bezug auf die von mir genderte Version der Implementierung von Herrn Hess der SWE wird aufgerufen.
        fw_operator_swe();
        }
    }

// Kommentar: Hier wird der Full Weighting Operator ausgefhrt. Die Koordinaten des oberen Gitters lauten (ff,gg).
// Die des unteren Gitters werden berechnet. Die geschriebene Variable ist y0_oben, die gelesene Variable ist y0_unten.
void Restriktion::fw_operator(void)
    {
// Kommentar: Zuerst werden die unteren Koordinaten bestimmt.
    ff_unten = ff << 1;
    gg_unten = gg << 1;

// Kommentar: Es wird eine Zahl mit der Bezeichnung nicht_vorhanden beschrieben. Sie hat insgesamt 4 Bits. Das erste Bit
// gibt an, ob links oben ein echter Rand vorliegt. Entsprechend wird die Zahl nicht_vorhanden auf 0 oder 1 gesetzt.
    if((ff==0)||(gg==0)||(farbenfeld_unten[ff_unten-1][gg_unten-1]==-1))
        {
        nicht_vorhanden = 1;
        }
    else
        {
        nicht_vorhanden = 0;
        }
// Kommentar: Dann wird geprft, ob links unten ein echter Rand vorliegt. In dem Fall wird das 2. Bit gesetzt.
    if((gg==0)||(ff==n_minus1_oben)||(farbenfeld_unten[ff_unten+1][gg_unten-1]==-1))
        {
        nicht_vorhanden = nicht_vorhanden | 2;
        }
// Kommentar: Dann wird geprft, ob rechts unten ein echter Rand vorliegt. In dem Fall wird das 3. Bit gesetzt.
    if((ff==n_minus1_oben)||(gg==m_minus1_oben)||(farbenfeld_unten[ff_unten+1][gg_unten+1]==-1))
        {
        nicht_vorhanden = nicht_vorhanden | 4;
        }
// Kommentar: Als letztes wird geprft, ob rechts oben ein echter Rand vorliegt. In dem Fall wird das 4. Bit gesetzt.
    if((gg==m_minus1_oben)||(ff==0)||(farbenfeld_unten[ff_unten-1][gg_unten+1]==-1))
        {
        nicht_vorhanden = nicht_vorhanden | 8;
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << " ff " << ff << " gg " << gg << " nicht_vorhanden " << nicht_vorhanden << " Rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    if((ebene==2)&&(ff==1)&&(gg==1))
        {
        cout << " FGHI (t" << t << ",e2,1,1) rang " << rang << " nv " << nicht_vorhanden << endl;
        }
#endif
// Kommentar: Nun geschieht eine switch - case Anweisung auf die eben bestimmte Zahl nicht vorhanden. Es gibt bei
// 4 Bits eigentlich 16 Mglichkeiten. Einige sind aber auszuschliessen, wie z.B. der Fall, dass berall echte Rnder
// vorliegen.
    switch(nicht_vorhanden)
        {
// Kommentar: Fall 0: D.h. in keiner der vier Richtungen liegt eine echter Rand vor. Dann wird, gem dem Buch von Herrn Joppich, dsa Full Weighting berechnet
// durch die Formel, die aus dem Operator
//
//               1 2 1
//     1/16      2 4 2
//               1 2 1
//
// abgeleitet wird. Genau nach dieser Formel wird gerechnet.
// Bemerkung: Es wird nur der Fall mit der Prprozessorvariablen dimensionen1 angenommen. Der Rest kann ignoriert werden. Das gilt fr alle Flle.
        case 0:
#ifdef AUSGABEN
            cout << "In Restriktion: ff " << ff << " gg " << gg << " ff_unten " << ff_unten << " gg_unten " <<  gg_unten << " m_unten " << m_unten << " n_unten " << n_unten << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            if((t==6)&&(ebene==2)&&(ff==1)&&(gg==1))
                {
                cout << " FGH (t6,e2,1,1): rang " << rang << " r0_unten ";
                for(j=-1;j<=1; j++)
                    {
                    for(k=-1; k<=1; k++)
                        {
                        cout << "(" << j << "," << k << ") : " << y0_unten[ff_unten+j][gg_unten+k];
                        }
                    }
                cout << endl;
                }
#endif
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten+1]+
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten+1]+
                                        2*( y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten+1]+
                                            y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten+1][gg_unten]) +
                                        4 * y1_unten[ff_unten][gg_unten]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten+1]+
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten+1]+
                                        2*( y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten+1]+
                                            y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten+1][gg_unten]) +
                                        4 * y1_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten+1]+
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten+1]+
                                        2*( y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten+1]+
                                            y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten+1][gg_unten]) +
                                        4 * y2_unten[ff_unten][gg_unten]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten+1]+
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten+1]+
                                        2*( y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten+1]+
                                            y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten+1][gg_unten]) +
                                        4 * y1_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten+1]+
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten+1]+
                                        2*( y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten+1]+
                                            y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten+1][gg_unten]) +
                                        4 * y2_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y3_unten[ff_unten-1][gg_unten-1] + y3_unten[ff_unten-1][gg_unten+1]+
                                        y3_unten[ff_unten+1][gg_unten-1] + y3_unten[ff_unten+1][gg_unten+1]+
                                        2*( y3_unten[ff_unten][gg_unten-1] + y3_unten[ff_unten][gg_unten+1]+
                                            y3_unten[ff_unten-1][gg_unten] + y3_unten[ff_unten+1][gg_unten]) +
                                        4 * y3_unten[ff_unten][gg_unten]);
            #endif
            break;

// Kommentar: Fall 1: Man hat oben einen Rand. Nach dem Buch von Herrn Joppich hat man einen Operator
//
//                0 0 0
//   1/16         2 4 2
//                2 4 2
//
// Und genau das wird im Folgenden programmiert.
        case 1:
            // Linke obere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten-1][gg_unten+1]+
                                        3*y0_unten[ff_unten+1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten+1]+2*y0_unten[ff_unten+1][gg_unten+1]);
            break;
        case 2:
            // Linke untere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten+1][gg_unten+1]+
                                        3*y0_unten[ff_unten-1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten+1]+2*y0_unten[ff_unten-1][gg_unten+1]);
            break;
        case 4:
            // Rechte untere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten+1][gg_unten-1]+
                                        3*y0_unten[ff_unten-1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten-1]+2*y0_unten[ff_unten-1][gg_unten-1]);
            break;
        case 8:
            // Rechte obere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten-1][gg_unten-1]+
                                        y0_unten[ff_unten][gg_unten+1]+y0_unten[ff_unten+1][gg_unten+1]+
                                        3*y0_unten[ff_unten+1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten-1]+2*y0_unten[ff_unten+1][gg_unten-1]);
            break;
        case 9:
            // Ist oben am Rand
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten+1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten+1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten+1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten+1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten+1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten+1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten+1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten+1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten+1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten+1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y3_unten[ff_unten+1][gg_unten-1]+y3_unten[ff_unten][gg_unten-1]+
                                        y3_unten[ff_unten+1][gg_unten+1]+y3_unten[ff_unten][gg_unten+1]+
                                        2*(y3_unten[ff_unten+1][gg_unten]+y3_unten[ff_unten][gg_unten]));
            #endif
            break;

// Kommentar: Hier hat man den Fall, dass links ein echter Rand vorliegt. Damit hat man einen analogen Fall
// zum Fall 1. Das braucht nicht weiter kommentiert zu werden.
        case 3:
            // Ist links am Rand
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif

            break;

// Kommentar: Fall 3: Das ist so, dass man den echten Rand oben und links hat, also eine linke obere Ecke vorliegt.
// Der Operator dafr lautet - nach dem Joppich - Buch:
//
//         0 0 0
//   1/16  0 4 4
//         0 4 4

//        case 3:
        case 11:
            // Ist Ecke links oben
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten+1][gg_unten] + y1_unten[ff_unten+1][gg_unten+1]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten+1][gg_unten] + y1_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten+1][gg_unten] + y2_unten[ff_unten+1][gg_unten+1]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten+1][gg_unten] + y1_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten+1][gg_unten] + y2_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten] + y3_unten[ff_unten][gg_unten+1] +
                                        y3_unten[ff_unten+1][gg_unten] + y3_unten[ff_unten+1][gg_unten+1]);
            #endif
            break;
// Kommentar: Analog zu Fall 1.
        case 6:
            // Ist Rand unten
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten-1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten-1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten-1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten-1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten-1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten-1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten-1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten-1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten-1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten-1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y3_unten[ff_unten-1][gg_unten-1]+y3_unten[ff_unten][gg_unten-1]+
                                        y3_unten[ff_unten-1][gg_unten+1]+y3_unten[ff_unten][gg_unten+1]+
                                        2*(y3_unten[ff_unten-1][gg_unten]+y3_unten[ff_unten][gg_unten]));
            #endif

            break;

// Kommentar: Das entspricht Fall 3 - einer Ecke. Alle weiteren Flle sind schon analog behandelt worden, oder
// sind unmglich. Also sind keine weiteren Kommentaren zum Full Weighting Operator ntig.
        case 7:
            // Ist Ecke links unten
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten-1][gg_unten+1]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten-1][gg_unten+1]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten] + y3_unten[ff_unten][gg_unten+1] +
                                        y3_unten[ff_unten-1][gg_unten] + y3_unten[ff_unten-1][gg_unten+1]);
            #endif
            break;

        case 12:
            // Rand rechts
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            y1_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten-1][gg_unten]+
                                        y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten+1][gg_unten]+
                                        2 * (y1_unten[ff_unten][gg_unten-1]+y1_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            y1_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten-1][gg_unten]+
                                        y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten+1][gg_unten]+
                                        2 * (y1_unten[ff_unten][gg_unten-1]+y1_unten[ff_unten][gg_unten]));
            y2_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten-1][gg_unten]+
                                        y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten+1][gg_unten]+
                                        2 * (y2_unten[ff_unten][gg_unten-1]+y2_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            y1_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten-1][gg_unten]+
                                        y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten+1][gg_unten]+
                                        2 * (y1_unten[ff_unten][gg_unten-1]+y1_unten[ff_unten][gg_unten]));
            y2_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten-1][gg_unten]+
                                        y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten+1][gg_unten]+
                                        2 * (y2_unten[ff_unten][gg_unten-1]+y2_unten[ff_unten][gg_unten]));
            y3_oben[ff][gg] = 0.125 * ( y3_unten[ff_unten-1][gg_unten-1]+y3_unten[ff_unten-1][gg_unten]+
                                        y3_unten[ff_unten+1][gg_unten-1]+y3_unten[ff_unten+1][gg_unten]+
                                        2 * (y3_unten[ff_unten][gg_unten-1]+y3_unten[ff_unten][gg_unten]));
            #endif
            break;

        case 13:
// Rechte obere Ecke
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten]);
            y3_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten-1] + y3_unten[ff_unten][gg_unten] +
                                        y3_unten[ff_unten+1][gg_unten-1] + y3_unten[ff_unten+1][gg_unten]);
            #endif
            break;
        case 14:
            // Ecke rechts unten
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten]);
            y3_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten-1] + y3_unten[ff_unten][gg_unten] +
                                        y3_unten[ff_unten-1][gg_unten-1] + y3_unten[ff_unten-1][gg_unten]);
            #endif
            break;
        case 5:
            // Doppel Ecke links oben zu rechts unten
            y0_oben[ff][gg] = 0.125 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten+1][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*y0_unten[ff_unten+1][gg_unten+1]);
            break;
        case 10:
            y0_oben[ff][gg] = 0.125 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten-1][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten+1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*y0_unten[ff_unten+1][gg_unten+1]);
            break;

        default:
            cout << "Fehler in Restriktion: ein unmglicher Fall : nicht_vorhanden " << nicht_vorhanden << endl;
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Am Ende des Operators" << endl;
#endif
    }

// Kommentar: Wie fw_operator, nur dass die Variablen ff und gg nicht berechnet werden.
void Restriktion::fw_operator_ohne_ff_gg_berechnung(void)
    {
// Kommentar: Es wird eine Zahl mit der Bezeichnung nicht_vorhanden beschrieben. Sie hat insgesamt 4 Bits. Das erste Bit
// gibt an, ob links oben ein echter Rand vorliegt. Entsprechend wird die Zahl nicht_vorhanden auf 0 oder 1 gesetzt.
    if((ff==0)||(gg==0)||(farbenfeld_unten[ff_unten-1][gg_unten-1]==-1))
        {
        nicht_vorhanden = 1;
        }
    else
        {
        nicht_vorhanden = 0;
        }
// Kommentar: Dann wird geprft, ob links unten ein echter Rand vorliegt. In dem Fall wird das 2. Bit gesetzt.
    if((gg==0)||(ff==n_minus1_oben)||(farbenfeld_unten[ff_unten+1][gg_unten-1]==-1))
        {
        nicht_vorhanden = nicht_vorhanden | 2;
        }
// Kommentar: Dann wird geprft, ob rechts unten ein echter Rand vorliegt. In dem Fall wird das 3. Bit gesetzt.
    if((ff==n_minus1_oben)||(gg==m_minus1_oben)||(farbenfeld_unten[ff_unten+1][gg_unten+1]==-1))
        {
        nicht_vorhanden = nicht_vorhanden | 4;
        }
// Kommentar: Als letztes wird geprft, ob rechts oben ein echter Rand vorliegt. In dem Fall wird das 4. Bit gesetzt.
    if((gg==m_minus1_oben)||(ff==0)||(farbenfeld_unten[ff_unten-1][gg_unten+1]==-1))
        {
        nicht_vorhanden = nicht_vorhanden | 8;
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << " ff " << ff << " gg " << gg << " nicht_vorhanden " << nicht_vorhanden << " Rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    if((ebene==2)&&(ff==1)&&(gg==1))
        {
        cout << " FGHI (t" << t << ",e2,1,1) rang " << rang << " nv " << nicht_vorhanden << endl;
        }
#endif
// Kommentar: Nun geschieht eine switch - case Anweisung auf die eben bestimmte Zahl nicht vorhanden. Es gibt bei
// 4 Bits eigentlich 16 Mglichkeiten. Einige sind aber auszuschliessen, wie z.B. der Fall, dass berall echte Rnder
// vorliegen.
    switch(nicht_vorhanden)
        {
// Kommentar: Fall 0: D.h. in keiner der vier Richtungen liegt eine echter Rand vor. Dann wird, gem dem Buch von Herrn Joppich, dsa Full Weighting berechnet
// durch die Formel, die aus dem Operator
//
//               1 2 1
//     1/16      2 4 2
//               1 2 1
//
// abgeleitet wird. Genau nach dieser Formel wird gerechnet.
// Bemerkung: Es wird nur der Fall mit der Prprozessorvariablen dimensionen1 angenommen. Der Rest kann ignoriert werden. Das gilt fr alle Flle.
        case 0:
#ifdef AUSGABEN
            cout << "In Restriktion: ff " << ff << " gg " << gg << " ff_unten " << ff_unten << " gg_unten " <<  gg_unten << " m_unten " << m_unten << " n_unten " << n_unten << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            if((t==6)&&(ebene==2)&&(ff==1)&&(gg==1))
                {
                cout << " FGH (t6,e2,1,1): rang " << rang << " r0_unten ";
                for(j=-1;j<=1; j++)
                    {
                    for(k=-1; k<=1; k++)
                        {
                        cout << "(" << j << "," << k << ") : " << y0_unten[ff_unten+j][gg_unten+k];
                        }
                    }
                cout << endl;
                }
#endif
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten+1]+
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten+1]+
                                        2*( y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten+1]+
                                            y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten+1][gg_unten]) +
                                        4 * y1_unten[ff_unten][gg_unten]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten+1]+
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten+1]+
                                        2*( y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten+1]+
                                            y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten+1][gg_unten]) +
                                        4 * y1_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten+1]+
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten+1]+
                                        2*( y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten+1]+
                                            y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten+1][gg_unten]) +
                                        4 * y2_unten[ff_unten][gg_unten]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten+1]+
                                        2*( y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten+1]+
                                            y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten+1][gg_unten]) +
                                        4 * y0_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten+1]+
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten+1]+
                                        2*( y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten+1]+
                                            y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten+1][gg_unten]) +
                                        4 * y1_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten+1]+
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten+1]+
                                        2*( y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten+1]+
                                            y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten+1][gg_unten]) +
                                        4 * y2_unten[ff_unten][gg_unten]);
            y0_oben[ff][gg] = 0.0625 * (y3_unten[ff_unten-1][gg_unten-1] + y3_unten[ff_unten-1][gg_unten+1]+
                                        y3_unten[ff_unten+1][gg_unten-1] + y3_unten[ff_unten+1][gg_unten+1]+
                                        2*( y3_unten[ff_unten][gg_unten-1] + y3_unten[ff_unten][gg_unten+1]+
                                            y3_unten[ff_unten-1][gg_unten] + y3_unten[ff_unten+1][gg_unten]) +
                                        4 * y3_unten[ff_unten][gg_unten]);
            #endif
            break;

// Kommentar: Fall 1: Man hat oben einen Rand. Nach dem Buch von Herrn Joppich hat man einen Operator
//
//                0 0 0
//   1/16         2 4 2
//                2 4 2
//
// Und genau das wird im Folgenden programmiert.
        case 1:
            // Linke obere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten-1][gg_unten+1]+
                                        3*y0_unten[ff_unten+1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten+1]+2*y0_unten[ff_unten+1][gg_unten+1]);
            break;
        case 2:
            // Linke untere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten+1][gg_unten+1]+
                                        3*y0_unten[ff_unten-1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten+1]+2*y0_unten[ff_unten-1][gg_unten+1]);
            break;
        case 4:
            // Rechte untere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten+1][gg_unten-1]+
                                        3*y0_unten[ff_unten-1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten-1]+2*y0_unten[ff_unten-1][gg_unten-1]);
            break;
        case 8:
            // Rechte obere Ecke, innere Ecke
            y0_oben[ff][gg] = 0.0625 * (y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten-1][gg_unten-1]+
                                        y0_unten[ff_unten][gg_unten+1]+y0_unten[ff_unten+1][gg_unten+1]+
                                        3*y0_unten[ff_unten+1][gg_unten]+4*y0_unten[ff_unten][gg_unten]+
                                        3*y0_unten[ff_unten][gg_unten-1]+2*y0_unten[ff_unten+1][gg_unten-1]);
            break;
        case 9:
            // Ist oben am Rand

            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten+1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten+1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten+1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten+1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten+1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten+1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten+1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten+1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten+1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten+1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y3_unten[ff_unten+1][gg_unten-1]+y3_unten[ff_unten][gg_unten-1]+
                                        y3_unten[ff_unten+1][gg_unten+1]+y3_unten[ff_unten][gg_unten+1]+
                                        2*(y3_unten[ff_unten+1][gg_unten]+y3_unten[ff_unten][gg_unten]));
            #endif
            break;

// Kommentar: Hier hat man den Fall, dass links ein echter Rand vorliegt. Damit hat man einen analogen Fall
// zum Fall 1. Das braucht nicht weiter kommentiert zu werden.
        case 3:
            // Ist links am Rand
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1] +
                                        2 * (y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1]));
            #endif

            break;

// Kommentar: Fall 3: Das ist so, dass man den echten Rand oben und links hat, also eine linke obere Ecke vorliegt.
// Der Operator dafr lautet - nach dem Joppich - Buch:
//
//         0 0 0
//   1/16  0 4 4
//         0 4 4

        case 11:
            // Ist Ecke links oben

            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten+1][gg_unten] + y1_unten[ff_unten+1][gg_unten+1]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten+1][gg_unten] + y1_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten+1][gg_unten] + y2_unten[ff_unten+1][gg_unten+1]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten+1][gg_unten] + y0_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten+1][gg_unten] + y1_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten+1][gg_unten] + y2_unten[ff_unten+1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten] + y3_unten[ff_unten][gg_unten+1] +
                                        y3_unten[ff_unten+1][gg_unten] + y3_unten[ff_unten+1][gg_unten+1]);
            #endif
            break;
// Kommentar: Analog zu Fall 1.
        case 6:
            // Ist Rand unten
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten-1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten-1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten-1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten-1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten-1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten-1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*(y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten][gg_unten-1]+
                                        y1_unten[ff_unten-1][gg_unten+1]+y1_unten[ff_unten][gg_unten+1]+
                                        2*(y1_unten[ff_unten-1][gg_unten]+y1_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten][gg_unten-1]+
                                        y2_unten[ff_unten-1][gg_unten+1]+y2_unten[ff_unten][gg_unten+1]+
                                        2*(y2_unten[ff_unten-1][gg_unten]+y2_unten[ff_unten][gg_unten]));
            y0_oben[ff][gg] = 0.125 * ( y3_unten[ff_unten-1][gg_unten-1]+y3_unten[ff_unten][gg_unten-1]+
                                        y3_unten[ff_unten-1][gg_unten+1]+y3_unten[ff_unten][gg_unten+1]+
                                        2*(y3_unten[ff_unten-1][gg_unten]+y3_unten[ff_unten][gg_unten]));
            #endif

            break;
// Kommentar: Das entspricht Fall 3 - einer Ecke. Alle weiteren Flle sind schon analog behandelt worden, oder
// sind unmglich. Also sind keine weiteren Kommentaren zum Full Weighting Operator ntig.
        case 13:
            // Ist Ecke links unten
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten-1][gg_unten+1]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten-1][gg_unten+1]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten] + y0_unten[ff_unten][gg_unten+1] +
                                        y0_unten[ff_unten-1][gg_unten] + y0_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten] + y1_unten[ff_unten][gg_unten+1] +
                                        y1_unten[ff_unten-1][gg_unten] + y1_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten] + y2_unten[ff_unten][gg_unten+1] +
                                        y2_unten[ff_unten-1][gg_unten] + y2_unten[ff_unten-1][gg_unten+1]);
            y0_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten] + y3_unten[ff_unten][gg_unten+1] +
                                        y3_unten[ff_unten-1][gg_unten] + y3_unten[ff_unten-1][gg_unten+1]);
            #endif
            break;

        case 12:
            // Rand rechts
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            y1_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten-1][gg_unten]+
                                        y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten+1][gg_unten]+
                                        2 * (y1_unten[ff_unten][gg_unten-1]+y1_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            y1_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten-1][gg_unten]+
                                        y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten+1][gg_unten]+
                                        2 * (y1_unten[ff_unten][gg_unten-1]+y1_unten[ff_unten][gg_unten]));
            y2_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten-1][gg_unten]+
                                        y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten+1][gg_unten]+
                                        2 * (y2_unten[ff_unten][gg_unten-1]+y2_unten[ff_unten][gg_unten]));
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.125 * ( y0_unten[ff_unten-1][gg_unten-1]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten-1]+y0_unten[ff_unten+1][gg_unten]+
                                        2 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten][gg_unten]));
            y1_oben[ff][gg] = 0.125 * ( y1_unten[ff_unten-1][gg_unten-1]+y1_unten[ff_unten-1][gg_unten]+
                                        y1_unten[ff_unten+1][gg_unten-1]+y1_unten[ff_unten+1][gg_unten]+
                                        2 * (y1_unten[ff_unten][gg_unten-1]+y1_unten[ff_unten][gg_unten]));
            y2_oben[ff][gg] = 0.125 * ( y2_unten[ff_unten-1][gg_unten-1]+y2_unten[ff_unten-1][gg_unten]+
                                        y2_unten[ff_unten+1][gg_unten-1]+y2_unten[ff_unten+1][gg_unten]+
                                        2 * (y2_unten[ff_unten][gg_unten-1]+y2_unten[ff_unten][gg_unten]));
            y3_oben[ff][gg] = 0.125 * ( y3_unten[ff_unten-1][gg_unten-1]+y3_unten[ff_unten-1][gg_unten]+
                                        y3_unten[ff_unten+1][gg_unten-1]+y3_unten[ff_unten+1][gg_unten]+
                                        2 * (y3_unten[ff_unten][gg_unten-1]+y3_unten[ff_unten][gg_unten]));
            #endif
            break;
        case 7:
// Rechte obere Ecke

            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten+1][gg_unten-1] + y0_unten[ff_unten+1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten+1][gg_unten-1] + y1_unten[ff_unten+1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten+1][gg_unten-1] + y2_unten[ff_unten+1][gg_unten]);
            y3_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten-1] + y3_unten[ff_unten][gg_unten] +
                                        y3_unten[ff_unten+1][gg_unten-1] + y3_unten[ff_unten+1][gg_unten]);
            #endif
            break;

        case 14:
            // Ecke rechts unten
            #ifdef dimensionen1
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            #endif
            #ifdef dimensionen2
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten]);
            #endif
            #ifdef dimensionen3
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten]);
            #endif
            #ifdef dimensionen4
            y0_oben[ff][gg] = 0.25 * (  y0_unten[ff_unten][gg_unten-1] + y0_unten[ff_unten][gg_unten] +
                                        y0_unten[ff_unten-1][gg_unten-1] + y0_unten[ff_unten-1][gg_unten]);
            y1_oben[ff][gg] = 0.25 * (  y1_unten[ff_unten][gg_unten-1] + y1_unten[ff_unten][gg_unten] +
                                        y1_unten[ff_unten-1][gg_unten-1] + y1_unten[ff_unten-1][gg_unten]);
            y2_oben[ff][gg] = 0.25 * (  y2_unten[ff_unten][gg_unten-1] + y2_unten[ff_unten][gg_unten] +
                                        y2_unten[ff_unten-1][gg_unten-1] + y2_unten[ff_unten-1][gg_unten]);
            y3_oben[ff][gg] = 0.25 * (  y3_unten[ff_unten][gg_unten-1] + y3_unten[ff_unten][gg_unten] +
                                        y3_unten[ff_unten-1][gg_unten-1] + y3_unten[ff_unten-1][gg_unten]);
            #endif
            break;
        case 5:
            // Doppel Ecke links oben zu rechts unten
            y0_oben[ff][gg] = 0.125 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten+1][gg_unten-1]+
                                        y0_unten[ff_unten+1][gg_unten]+y0_unten[ff_unten-1][gg_unten]+
                                        y0_unten[ff_unten-1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*y0_unten[ff_unten+1][gg_unten+1]);
            break;
        case 10:
            y0_oben[ff][gg] = 0.125 * (y0_unten[ff_unten][gg_unten-1]+y0_unten[ff_unten-1][gg_unten-1]+
                                        y0_unten[ff_unten-1][gg_unten]+y0_unten[ff_unten+1][gg_unten]+
                                        y0_unten[ff_unten+1][gg_unten+1]+y0_unten[ff_unten][gg_unten+1]+
                                        2*y0_unten[ff_unten+1][gg_unten+1]);
            break;

        default:
            cout << "Fehler in Restriktion: ein unmglicher Fall : nicht_vorhanden " << nicht_vorhanden << endl;
        }
#ifdef AUSGABEN_RESTRIKTION
    cout << "Am Ende des Operators" << endl;
#endif
    }
