#include "schreibe_gp_commandfile.h"

// Kommentar: Hiermit wird eine Klasse geschrieben, die die berechneten Gitterpunkte visualisiert - auch auf mehreren Kernen.

// Kommentar: Hier wird ein Wert in einen lesbaren Text konvertiert. Denn gnuplot liest Text ein.
void SchreibeGPCommandfile::konvertieren(int wert)
    {
    sprintf(zahl,"%d",wert);
    }

// Kommentar: Es wird der Befehl geschrieben, eine dreidimensionale Darstellung der Punktwerte darzustellen.
void SchreibeGPCommandfile::generiere_gesamtname(void)
    {
// Kommentar: Der gnuplot - Befehl 'splot' wird dazu geschrieben, wobei die Eingabedatei die Form
// 'o:\gp_daten\datafile1.dat' hat, wenn die Zahl 1 ist. 'with lines' steht da, um die Punkte durch Linien zu verbinden.
#ifdef PC_LINUX

#endif
#ifndef LINUX
    strcpy(gesamtname, "splot 'o:\\gp_daten\\datafile");
#else
    strcpy(gesamtname, "splot 'datafile");
#endif
    konvertieren(i);
    strcat(gesamtname, zahl);
    strcat(gesamtname, ".dat'");
    strcat(gesamtname, " with lines");
    cout << " Gesamtname " << gesamtname << endl;
    }

// Kommentar: Hier wird der Befehl geschrieben, die Punktaufteilung auf das verfeinerte Gitter darzustellen.
void SchreibeGPCommandfile::generiere_gesamtname2(void)
    {
// Kommentar: Zuerst der plot - Befehl: Zuerst der Bereich [-1:n] x [-1:m], wobei m und n die Gittermaße sind.
    strcpy(gesamtname, "plot [-1:");
    konvertieren(n+1);
    strcat(gesamtname, zahl);
    strcat(gesamtname, "][-1:");
    konvertieren(m+1);
    strcat(gesamtname, zahl);
    strcat(gesamtname, "] ");
// Kommentar: Dann werden zu jedem Kern 'seine' Gitterpunkte eingelesen.
    for(j=0; j<groesse; j++)
        {
// Kommentar: Der Dateiname ist vom Typ: o:\gp_daten\datafile1t2.dat' für j = 1 (Kern')  und i = 2 (Iteration)
        konvertieren(j);
#ifndef LINUX
        strcat(gesamtname, "'o:\\gp_daten\\datafile");
#else
        strcat(gesamtname, "'datafile");
#endif
        strcat(gesamtname, zahl);
        strcat(gesamtname, "t");
        konvertieren(i);
        strcat(gesamtname, zahl);
        strcat(gesamtname, ".dat'");

        strcat(gesamtname, " using 1:2:(0.02) with points ");

        if(j!=groesse-1)
            {
            strcat(gesamtname, ", ");
            }
        }
    cout << " Gesamtname2 " << gesamtname << endl;
    }

// Kommentar: Hier wird das Commandfile für anzahl viele Schritte in die Datei o:\gp_daten\commandfile geschrieben - unter Verwendung
// der Funktion generiere_gesamtname. D.h. hiermit wird die Wertentwicklung dargestellt.
void SchreibeGPCommandfile::tun(int anzahl)
    {
// Kommentar: Die Datei wird geöffnet.
#ifndef LINUX
    aus = new ofstream("O:\\gp_daten\\commandfile", ios::out);
#else
    aus = new ofstream("commandfile", ios::out);
#endif

#ifdef PC_LINUX
    * aus << "set term 'wxt' size 1920,1080 " << endl;
#endif
// Kommentar: Die Iterationen werden durchlaufen.
    for(i=0, counter = 0; i<anzahl; i++)
        {
        if(counter!=gp_ausgabe_mod)
            {
            counter++;
            continue;
            }
        counter = 0;
// Kommentar: Der Name jedes Befehls an gnuplot wird bestimmt, und in '* aus' abgespeichert.
        generiere_gesamtname();
        * aus << gesamtname << endl;
        * aus << "pause " << wert_pause << endl;
        }
    delete aus;
    }

// Kommentar: Analog zu tun, nur dass jetzt die Befehle aus generiere_gesamtname2 geschrieben werden.
void SchreibeGPCommandfile::tun2(int anzahl, int _n, int _m, int _groesse)
    {
    n = _n;
    m = _m;
    groesse = _groesse;

    cout << " SGPC n " << n << " m " << m << " groesse " << groesse << endl;

#ifndef LINUX
    aus = new ofstream("O:\\gp_daten\\commandfile2", ios::out);
#else
    aus = new ofstream("commandfile2", ios::out);
#endif

#ifdef PC_LINUX
    * aus << "set term 'wxt' size 1920,1080 " << endl;
#endif

    for(i=1; i<=anzahl; i++)
        {
        generiere_gesamtname2();
        * aus << gesamtname << endl;
        * aus << "pause " << wert_pause << endl;
        }

    delete aus;
    }
