#include "snb_update.h"

// Kommentar: Diese Klasse bewirkt, dass man auf den Koordinaten (f,g) genau wei, wo drum herum die
// Eigenschaftspunkte existieren. Durch die Verwendung einer Zahl. Sofortigen Zugriff hat man dann durch switch case -
// Anweisungen bezglich dieser Zahl.
// Auerdem: Fr das sptere Entfernen von Punkten braucht man die Punktemenge, fr die das untersucht wird -
// EP_SNB_punkte. Diese wird zuvor geleert, und dann hier bei 'hinweg' aufgefllt.

// Kommentar: Ausgabe der Werte von SNB, die die Information von EP-SNB speichert.
void SNBupdate::ausgeben(void)
    {
#ifdef AUSGABEN_DATEI
    da_av->aus << "EP-SNB" << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            da_av->aus << SNB[i][j] << " ";
            }
        da_av->aus << endl;
        }
    da_av->aus << "Ende EP-SNB " << endl;
#endif
    }

// Kommentar:Anlegen der Informationen dieser Klasse SNBupdate.
void SNBupdate::initialisierung(int _n, int _m, DateiAusgabe * _da_av, PunktListe * _EP_SNB_punkte, int _rang)
// wird richtig finalisiert
    {
// Kommentar: Kopieren der bergabeparameter.
    n = _n;
    m = _m;
    rang = _rang;

    da_av = _da_av;

    EP_SNB_punkte = _EP_SNB_punkte;

// Kommentar: Weitere Parameter basierend auf n und m
    n_plus_2 = n + 2;
    m_plus_2 = m + 2;

    n_minus1 = n-1;
    m_minus1 = m-1;

// Kommentar: Anlegen der Struktur SNB. DIe Struktur SNB - Hilfe dient nur dem Zweck, SNB anzulegen.
    SNB_hilfe = new short int * [n_plus_2];
    SNB = new short int * [n_plus_2];
    for(i=0; i<n_plus_2; i++)
        {
        SNB_hilfe[i] = new short int [m_plus_2];
        for(j=0; j<m_plus_2; j++)
            {
            SNB_hilfe[i][j] = 0;
            // Alle Punkte sind geloescht.
            }
        }
    for(i=0; i<n_plus_2; i++)
        {
        SNB[i] = SNB_hilfe[i] + 1;
        }
    SNB = SNB + 1;

// Die Struktur ist_gesetzt wird angelegt. Mit ihr kann man feststellen, ob auf einer Stelle schon eine Eintragung
// im Sinne von 'hinzu' getroffen worden ist.
    ist_gesetzt = new bool * [n];
    for(i=0; i<n; i++)
        {
        ist_gesetzt[i] = new bool [m];
        for(j=0; j<m; j++)
            {
            ist_gesetzt[i][j] = false;
            }
        }
    }

// Kommentar: Freigabe des in der Klasse initialisierung angelegten Speicherplatzes.
void SNBupdate::finalisierung(void)
    {
#ifdef AUSGABEN_ENDE
    cout << " Ende 3g8i rang " << rang << endl;
#endif
// Kommentar: Freigabe von ist_gesetzt.
    for(i=0; i<n; i++)
        {
        delete ist_gesetzt[i];
        }
    delete ist_gesetzt;

#ifdef AUSGABEN_ENDE
    cout << " Ende 3g8ii rang " << rang << endl;
#endif

// Kommentar: Freigabe von SNB_hilfe
    for(i=0; i<n_plus_2; i++)
        {
        delete SNB_hilfe[i];
        }

#ifdef AUSGABEN_ENDE
    cout << " Ende 3g8iii rang " << rang << endl;
#endif

    delete SNB_hilfe;

#ifdef AUSGABEN_ENDE
    cout << " Ende 3g8iv rang " << rang << endl;
#endif

// Kommentar:
// Freigabe von SNB.
    SNB = SNB - 1;

    delete SNB;
#ifdef AUSGABEN_ENDE
    cout << " Ende 3g8v rang " << rang << endl;
#endif
    }

// Kommentar: Es wird EP_SNB durch Hinzufgung eines Punktes mit der Verfeinerungseigenschaft aktualisiert. Nicht der
// Punkt wird eingefgt, sondern die Verfeinerungseigenschaft wird jetzt durch diesen Punkt erfllt.
void SNBupdate::hinzu(int f, int g)
    {
// Kommentar: Fge hinzu aus fr alle Himmelsrichtungen in Bezug auf (f,g).
    hinzu_nordwest(f,g);
    hinzu_west(f,g);
    hinzu_suedwest(f,g);
    hinzu_sued(f,g);
    hinzu_nord(f,g);
    hinzu_nordost(f,g);
    hinzu_ost(f,g);
    hinzu_suedost(f,g);
// Kommentar: Setze ist_gesetzt, um zu wissen, dass (f,g) belegt ist, so dass er insbesondere nicht wieder aufgerufen wird.
// Vgl. z.B. EP_s_bestimmen::austragen_aussenrand_aus_ep_snb.
    ist_gesetzt[f][g] = true;
    }

// Kommentar: Es wird EP_SNB durch Entfernung eines Punktes mit der Verfeinerungseigenschaft aktualisiert. Nicht der
// Punkt wird entfernt, sondern die Verfeinerungseigenschaft wird jetzt durch diesen Punkt nicht mehr erfllt.
void SNBupdate::hinweg(int f, int g)
    {
#ifdef AKTUELLE_KOMMENTARE
    if(rang==6)
        {
        cout << " EEFFGG hinweg f " << f << " g " << g << endl;
        if((f==16)&&(g==13))
            {
            cout << " KKLLMM (r6,f16,g13) mit " << endl;
            }
        }
#endif

#ifdef AKTUELLE_KOMMENTARE
    vf = 16;
    vg = 12;
#endif
// Kommentar: Ausfgen von hinweg fr alle Himmelsrichtungen in Bezug auf (f,g).
    hinweg_nordwest(f,g);
    hinweg_west(f,g);
    hinweg_suedwest(f,g);
    hinweg_sued(f,g);
    hinweg_nord(f,g);
    hinweg_nordost(f,g);
    hinweg_ost(f,g);
    hinweg_suedost(f,g);
    EP_SNB_punkte->hinzu(f, g);
// Kommentar: ist_gesetzt wird wieder auf false gesetzt - an dieser Stelle gibt es keine Verfeinerungseigenschaft mehr.
    ist_gesetzt[f][g] = false;
    }

// Kommentar: Es wird EP_SNB durch Entfernung eines Punktes mit der Verfeinerungseigenschaft aktualisiert. Nicht der
// Punkt wird entfernt, sondern die Verfeinerungseigenschaft wird jetzt durch diesen Punkt nicht mehr erfllt.
// Der Unterschied zu hinweg besteht darin, dass statt der Funktion hinweg_Himmelsrichtung hinweg_Himmelsrichtung_ohne
// aufgerufen wird. Dabei kommt es zu keinem Eintrag in EP_SNB_Punkte, d.h. es wird wohl EP_SNB gendert, nicht
// aber die Menge zur Bestimmung der zu entfernenden Gitterpunkte.
void SNBupdate::hinweg_ohne(int f, int g)
    {
#ifdef AKTUELLE_KOMMENTARE
    if(rang==6)
        {
        cout << " EEFFGG hinweg f " << f << " g " << g << endl;
        if((f==16)&&(g==13))
            {
            cout << " KKLLMM (r6,f16,g13) ohne " << endl;
            }
        }
#endif

// Kommentar: Ausfgen von hinweg_..._ohne fr alle Himmelsrichtungen in Bezug auf (f,g).
    hinweg_nordwest_ohne(f,g);
    hinweg_west_ohne(f,g);
    hinweg_suedwest_ohne(f,g);
    hinweg_sued_ohne(f,g);
    hinweg_nord_ohne(f,g);
    hinweg_nordost_ohne(f,g);
    hinweg_ost_ohne(f,g);
    hinweg_suedost_ohne(f,g);
// Kommentar: Die Eigenschaftsinformation auf true gilt nicht mehr an dieser Stelle.
    ist_gesetzt[f][g] = false;
    }

// Kommentar: In Nord - West Richtung wird die Himmelsrichtung Sd - Ost durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_nordwest(int i, int j)
    {
    SNB[i-1][j-1] |= SUED_OST;
    }

// Kommentar: In West Richtung wird die Himmelsrichtung Ost durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_west(int i, int j)
    {
    SNB[i][j-1] |= OST;
    }

// Kommentar: In Sd - West Richtung wird die Himmelsrichtung Nord - Ost durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_suedwest(int i, int j)
    {
    SNB[i+1][j-1] |= NORD_OST;
    }

// Kommentar: In Sd Richtung wird die Himmelsrichtung Nord durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_sued(int i, int j)
    {
    SNB[i+1][j] |= NORD;
    }

// Kommentar: In Sd - Ost Richtung wird die Himmelsrichtung Nord - West durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_suedost(int i, int j)
    {
    SNB[i+1][j+1] |= NORD_WEST;
    }

// Kommentar: In Ost Richtung wird die Himmelsrichtung West durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_ost(int i, int j)
    {
    SNB[i][j+1] |= WEST;
    }

// Kommentar: In Nord - Ost Richtung wird die Himmelsrichtung Sd - West durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_nordost(int i, int j)
    {
    SNB[i-1][j+1] |= SUED_WEST;
    }

// Kommentar: In Nord Richtung wird die Himmelsrichtung Sd durch eine OR - Anweisung gesetzt.
// Da SNB ber die Rnder reicht, kann hier ohne if - Abfrage ausgekommen werden.
void SNBupdate::hinzu_nord(int i, int j)
    {
    SNB[i-1][j] |= SUED;
    }

// Kommentar: In Nord - West Richtung wird die Himmelsrichtung Sd - Ost durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_nordwest(int i, int j)
    {
    if(i==0)
        {
        return;
        }
    if(j==0)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i-1==vf)&&(j-1==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg nordwest " << endl;
        }
#endif
    SNB[i-1][j-1] &= _SUED_OST;
    EP_SNB_punkte->hinzu(i-1, j-1);
    }

// Kommentar: In West Richtung wird die Himmelsrichtung Ost durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_west(int i, int j)
    {
    if(j==0)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i==vf)&&(j-1==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg west " << endl;
        }
#endif
    SNB[i][j-1] &= _OST;
    EP_SNB_punkte->hinzu(i, j-1);
    }

// Kommentar: In Sd - West Richtung wird die Himmelsrichtung Nord - Ost durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_suedwest(int i, int j)
    {
    if(j==0)
        {
        return;
        }
    if(i==n_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i+1==vf)&&(j-1==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg suedwest " << endl;
        }
#endif
    SNB[i+1][j-1] &= _NORD_OST;
    EP_SNB_punkte->hinzu(i+1, j-1);
    }

// Kommentar: In Sd Richtung wird die Himmelsrichtung Nord durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_sued(int i, int j)
    {
    if(i==n_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i+1==vf)&&(j==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg sued t " << t << endl;
        }
#endif
    SNB[i+1][j] &= _NORD;
    EP_SNB_punkte->hinzu(i+1, j);
    }

// Kommentar: In Sd - Ost Richtung wird die Himmelsrichtung Nord - West durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_suedost(int i, int j)
    {
    if(i==n_minus1)
        {
        return;
        }
    if(j==m_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i+1==vf)&&(j+1==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg suedost " << endl;
        }
#endif
    SNB[i+1][j+1] &= _NORD_WEST;
    EP_SNB_punkte->hinzu(i+1, j+1);
    }

// Kommentar: In Ost Richtung wird die Himmelsrichtung West durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_ost(int i, int j)
    {
    if(j==m_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i==vf)&&(j+1==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg ost " << endl;
        }
#endif
    SNB[i][j+1] &= _WEST;
    EP_SNB_punkte->hinzu(i, j+1);
    }

// Kommentar: In Nord - Ost Richtung wird die Himmelsrichtung Sd - West durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_nordost(int i, int j)
    {
    if(i==0)
        {
        return;
        }
    if(j==m_minus1)
        {
        return;
        }

#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i-1==vf)&&(j+1==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg nordost " << endl;
        }
#endif
    SNB[i-1][j+1] &= _SUED_WEST;
    EP_SNB_punkte->hinzu(i-1, j+1);
    }

// Kommentar: In Nord Richtung wird die Himmelsrichtung Sd durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung in EP_SNB_Punkte eingefgt. Deswegen erfolgt / erfolgen hier eine / zwei
// if - Abfragen, um irregulre EP_SNB_Punkte . Eintrge abzufangen.
void SNBupdate::hinweg_nord(int i, int j)
    {
    if(i==0)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==6)&&(i-1==vf)&&(j==vg))
        {
        cout << " KKLLMM vf 16 vg 12 hinweg nord t " << t << endl;
        }
#endif
    SNB[i-1][j] &= _SUED;
    EP_SNB_punkte->hinzu(i-1, j);
    }

// Kommentar: In Nord - West Richtung wird die Himmelsrichtung Sd - Ost durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_nordwest_ohne(int i, int j)
    {
    if(i==0)
        {
        return;
        }
    if(j==0)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
#endif
    SNB[i-1][j-1] &= _SUED_OST;
    }

// Kommentar: In West Richtung wird die Himmelsrichtung Ost durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_west_ohne(int i, int j)
    {
    if(j==0)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
#endif
    SNB[i][j-1] &= _OST;
    }

// Kommentar: In Sd - West Richtung wird die Himmelsrichtung Nord - Ost durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_suedwest_ohne(int i, int j)
    {
    if(j==0)
        {
        return;
        }
    if(i==n_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
#endif
    SNB[i+1][j-1] &= _NORD_OST;
    }

// Kommentar: In Sd Richtung wird die Himmelsrichtung Nord durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_sued_ohne(int i, int j)
    {
    if(i==n_minus1)
        {
        return;
        }
    SNB[i+1][j] &= _NORD;
    }

// Kommentar: In Sd - Ost Richtung wird die Himmelsrichtung Nord - West durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_suedost_ohne(int i, int j)
    {
    if(i==n_minus1)
        {
        return;
        }
    if(j==m_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
#endif
    SNB[i+1][j+1] &= _NORD_WEST;
    }

// Kommentar: In Ost Richtung wird die Himmelsrichtung West durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_ost_ohne(int i, int j)
    {
    if(j==m_minus1)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
#endif
    SNB[i][j+1] &= _WEST;
    }

void SNBupdate::hinweg_nordost_ohne(int i, int j)
// Kommentar: In Nord - Ost Richtung wird die Himmelsrichtung Sd - West durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
    {
    if(i==0)
        {
        return;
        }
    if(j==m_minus1)
        {
        return;
        }

#ifdef AKTUELLE_KOMMENTARE
#endif

    SNB[i-1][j+1] &= _SUED_WEST;
    }

// Kommentar: In Nord Richtung wird die Himmelsrichtung Sd durch eine AND - Anweisung gelscht.
// Ferner wird in dieser Himmelsrichtung nicht in EP_SNB_Punkte eingefgt. Deswegen sind die if - Abfragen verzichtbar.
void SNBupdate::hinweg_nord_ohne(int i, int j)
    {
    if(i==0)
        {
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
#endif
    SNB[i-1][j] &= _SUED;
    }
