#include "sortierung.h"

// Kommentar: Eine Liste von Integerzahlen wird sortiert - mit dem Merge Sort in O(n log n) vielen Schritten.

// Kommentar: Der Speicherplatz fr die Sortierung wird bereitgestellt. Dabei muss die maximale Anzahl sortierender Variablen
// festgelegt werden.
void Sortierung::initialisieren(int _laenge)
    {
// Kommentar: Die laenge ist die Maximalzahl von Zahlen, die sortiert werden. a und b sind Felder, die Speicherplatz fr die
// Sortierung bereitstellen.
    laenge = _laenge;
    a = new int [laenge];
    b = new int [laenge];
    // Wird richtig finalisiert
    }

// Kommentar: Wenn die Lnge berschritten wird, gebe eine Fehlermeldung aus.
void Sortierung::test_laenge(void)
    {
    if(o-1>=laenge)
        {
        cout << "Test_laenge schlgt an " << endl;
        exit(-1);
        }
    }

// Kommentar: Hiermit werden die Zahlen des Feldes a ausgegeben.
void Sortierung::ausgeben(int anzahl_ausgeben)
    {
    for(i=0; i<anzahl_ausgeben; i++)
        {
        cout << " a (" << i << ")" << a[i] << endl;
        }
    }

// Kommentar: Mit dieser Finalisierung werden die Felder a und b freigegeben.
void Sortierung::finalisieren(void)
    {
    delete a;
    delete b;
    }

// Kommentar: Hier wird ein Wert in das Feld a geschrieben.
void Sortierung::schreiben(int wert, int index)
    {
    a[index] = wert;
    }

// Kommentar: Hier wird ein Wert aus dem Feld a gelesen.
int Sortierung::lesen(int index)
    {
    return(a[index]);
    }

// Kommentar: Hier werden die Felder a und b mittels Zeigermanipulationen getauscht.
void Sortierung::tauschen(void)
    {
    c = a;
    a = b;
    b = c;
    }

// Kommentar: Hier wird die Sortierung durchgefhrt. bergeben wird die Anzahl der zu sortierenden Elemente.
void Sortierung::tun(int _anzahl)
    {
// Kommentar: Der berparameter wird gespeichert.
    anzahl = _anzahl;
// Kommentar: Man hat bei einer Zahl, d.h. anzahl = 1, 0 Lufe.
    laeufe = 0;
    vergleichs_anzahl = 2;
// Kommentar: Man vergleicht die vergleichsanzahl mit der Anzahl, und verdoppelt danach diese Zahl nebst Inkrementierung der lufe -
// Variablen. Insgesamt ist nach dieser Schleife der Wert der Variablen laeufe die abgrundete Zahl von log_2 (anzahl).
    for(;vergleichs_anzahl<=anzahl;)
        {
        vergleichs_anzahl = vergleichs_anzahl << 1;
        laeufe ++;
        }
// Kommentar: Wenn die anzahl keine 2er Potenz ist, dann wird ein Lauf zugegeben, damit die aufgerundete Zah von log_2 (anzahl)
// hufig der Algorithmus durchlaufen wird.
    if(vergleichs_anzahl >> 1 !=anzahl)
        {
        laeufe++;
        }
// Kommentar: Die listen_anzahl ist am Anfang gleich der Anzahl an zu sortierenden Elementen.
    listen_anzahl = anzahl;
    anfang = 0;
// Kommentar: Diese Schleife wird laeufe - hufig durchlaufen. Die Variable k beginnt bei 1, und wird dann immer verdoppelt.
    for(i=0, k=1, o=0; i<laeufe; i++, k=k<<1)
        {

// Kommentar: Die Listenanzahl wird halbiert, weil sich die Listenlnge verdoppelt.
        listen_anzahl = listen_anzahl >> 1;

#ifdef AUSGABE_SORTIERUNG
        cout << "Listen Anzahl  " << listen_anzahl << endl;
#endif
// Kommentar: Jeder Lauf beginnt mit anfang = 0 und o = 0.
        anfang = 0;

        o = 0;

// Kommentar: Man durchluft die einzelnen Listen.
        for(l=0; l<listen_anzahl; l++)
            {
// Kommentar: Wir haben zwei Listen: Die erste ist von m = anfang bis m_ziel - 1 = anfang + k - 1,
// die zweite ist von n = anfang + k bis n_ziel -1 = anfang + 2*k -1.
// Der Wert anfang wird fr die nchsten Listen auf anfang + 2 * k erhht.
            m = anfang;
            n = anfang + k;
            anfang = n + k;
            m_ziel = n;

            n_ziel = anfang;

// Kommentar: Man hat eine Endlosschleife, bis beide Listen durchgearbeitet worden sind.
            for(wiederholen=true; wiederholen==true;)
                {
// Kommentar: Nun werden die Listen elementweise verglichen. Ist das aktuelle Element der ersten Liste kleiner,
// dann wird es nach b kopiert, wobei der Index o fr b inkrementiert wird. Die Position m auf die erste Liste
// wird auch inkrementiert.
                if(a[m]<a[n])
                    {
                    b[o++] = a[m];
                    m++;
// Kommentar: War es das letzte Element von a, dann werden die brigen Elemente von b hintenan kopiert, und die Endlosschleife
// wird beendet.
                    if(m==m_ziel)
                        {
                        for(j=n; j<n_ziel; j++)
                            {
                            b[o++] = a[j];
                            test_laenge();
                            }
                        wiederholen = false;
                        }
                    }
// Kommentar: Ist das Element der ersten Liste grer, wird von der zweiten Liste das Element n nach b kopiert, n und o werden inkrementiert.
                else
                    {
                    b[o++] = a[n];
                    test_laenge();
                    n++;
// Und wenn es das letzte Element von b war, werden die brigen Elemente von a hintenan kopiert, wobei dann die Endlosschleife verlassen wird.
                    if(n==n_ziel)
                        {
                        for(j=m; j<m_ziel; j++)
                            {
                            b[o++] = a[j];
                            test_laenge();
                            }
                        wiederholen = false;
                        }
                    }
                }
            }
// Kommentar: Soweit wurden die Listen ineinander sortiert. Nun muss das Ende der Gesamtliste abgearbeitet werden.
// Zuerst werden die Anfangs - Positionen der letzten Listen bestimmt.
        m = anfang;
        n = anfang + k;
// Kommentar: Falls es keine zweite Liste gibt, werden die letzten Elemente nach b kopiert, und die Sortierung ist
// abgeschlossen.
        if(n >= anzahl)
            {
            for(j=m; j<anzahl; j++)
                {
                b[o++] = a[j];
                test_laenge();
                }
            }
        else
            {
// Kommentar: Ansonsten bekommen beiede Listen ihr Zielelement.
            m_ziel = n;
            n_ziel = anzahl;
// Kommentar: Danach wird obiges Sortieren mit den neuen Parametern durchgefhrt.
            for(wiederholen=true; wiederholen==true;)
                {
                if(a[m]<a[n])
                    {
                    b[o++] = a[m];
                    test_laenge();
                    m++;
                    if(m==m_ziel)
                        {
                        for(j=n; j<n_ziel; j++)
                            {
                            b[o++] = a[j];
                            test_laenge();
                            }
                        wiederholen = false;
                        }
                    }
                else
                    {
                    b[o++] = a[n];
                    test_laenge();
                    n++;
                    if(n==n_ziel)
                        {
                        for(j=m; j<m_ziel; j++)
                            {
                            b[o++] = a[j];
                            test_laenge();
                            }
                        wiederholen = false;
                        }
                    }
                }
            }
// Kommentar: Nachdem die k - elementigen Mengen ineinander sortiert worden sind, werden die Felder a und b getauscht.
// Sonst mte b nach a kopiert werden.
        tauschen();
        }

    }
