#include "stack1d.h"

// Kommentar: Der Stack wird benötigt, um Elemente bei der doppelt verketteten Liste auszuwählen, bzw. sie wieder zurückzugeben.

// Kommentar: Diese Klasse wird initialisiert. Dabei wird die maximale Anzahl an zu vergebenden Nummern vorher festgelegt.
void Stack1D::initialisieren(int laenge)
    {
// Kommentar: Der Speicherplatz für den Stack wird angelegt.
    stack = new int [laenge];

// Kommentar: Die Nummern 0 bis laenge - 1 werden auf den Stack gelegt.
    for(i=0; i<laenge; i++)
        {
        stack[i] = i;
        }
// Kommentar: Die Position zeigt auf den letzten Eintrag. Der ist zu Beginn laenge - 1.
    position = laenge - 1;
// Kommentar: Und die laenge als Wert wird gespeichert.
    laenge_speichern = laenge;
    }

// Kommentar: Hier erfolgt das Finalisieren der Klasse. Dabei wird aber nur der Speicher der Struktur 'stack' freigegeben.
void Stack1D::finalisieren(void)
    {
    delete stack;
    }

// Kommentar: Das aktuelle Element wird gelesen.
int Stack1D::lesen(void)
    {
// Kommentar: Gelesen wird der Stack stack auf der Position position. Der Index wird dann dekrementiert, und der gelesene Wert
// wird zurückgegeben.
    returnwert = stack[position];
    position --;
    return(returnwert);
    }

// Kommentar: Es wird ein Wert an den Stack zurückgegeben.
void Stack1D::schreiben(int wert)
    {
// Kommentar: Hier muss umgekeht wie in lesen vorgegangen werden. Deshalb wird zuerst der Index position Inkrementiert, und dann
// wird der Wert auf diesem Index in den Stack geschrieben.
    position ++;
    stack[position] = wert;
    }

// Kommentar: Der Stack wird zurückgesetzt. Hier fehlt das Einspeichern der Nummern. Die position wird mit dem initialen Element
// belegt. Diese Funktion so nicht verwenden.
void Stack1D::reset(void)
    {
    position = laenge_speichern - 1;
    }

// Kommentar: Hier wird die Anzahl vergebener Nummern zurückgegeben. Bei position laenge_speichern - 1 ist die Länge 0.
// Bei position 0 ist die Länge der Liste laenge_speichern - 1. Die folgende Formel erfüllt beide Bedingungen.
int Stack1D::anzahl(void)
    {
    return(laenge_speichern - 1 - position);
    }

// Kommentar: Das ist eine Ausgabe aller gespeicherten Nummern. Das auszugeben macht aber nur Sinn bis zur Position position.
// So also nicht aufrufen.
void Stack1D::komplettausgabe(void)
    {
    for(i=0; i<laenge_speichern; i++)
        {
        cout << " AAOO(" << i << ") stack " << stack[i] << " ";
        }
    cout << endl;
    }
