#include "strategie.h"

// Kommentar: Diese Klasse dient dem Zweck, schnell stlichste, westlichste, nrdlichste oder sdlichste Punkte zu finden.
// Das wird bei der Punktauswahl der Klasse Lastausgleich fr den Lastausgleich gebraucht.

// Kommentar: Hier wird geprft, dass im Testfeld berall fr Punkte der Klasse Strategie true steht. Und: Alle solchen
// Markierungen werden dann auch entfernt, damit hinterher getestet werden kann, dass nicht mehr eingetragen wurde,
// als hier durchlaufen werden kann.
bool Strategie::tester_vertikal_2(bool ** tester_feld)
    {
// Kommentar: Man durchluft alle nord_sued 1d - Feldlisten
    for(i=0; i<m; i++)
        {
// Kommentar: Dann wird die i.te Feldliste durchlaufen.
        nord_sued[i].anfangsposition();
        for(;nord_sued[i].ist_fertig()==false;nord_sued[i].naechster())
            {
// Kommentar: Damit liest man den Gitterpunkt (i,j). Ist das Testfeld dort false, dann liegt ein Fehler vor. Dann return false.
            j = nord_sued[i].lesen();
            if(tester_feld[j][i]==false)
                {
                return(false);
                }
// Kommentar: Ansonsten wird das Feld dort gelscht.
            tester_feld[j][i] = false;
            }
        }
// Kommentar: Alles OK? Dann return true.
    return(true);
    }

// Kommentar: Analog zu tester_vertikal_2, nur das hier, mit demselben Zweck, west_ost - Feldlisten durchlaufen werden.
bool Strategie::tester_horizontal_2(bool ** tester_feld)
    {
    for(i=0; i<n; i++)
        {
        west_ost[i].anfangsposition();
        for(;west_ost[i].ist_fertig()==false;west_ost[i].naechster())
            {
            j = west_ost[i].lesen();
            if(tester_feld[i][j]==false)
                {
                cout << " th2 i " << i << " j " << j << endl;
                return(false);
                }
            tester_feld[i][j] = false;
            }
        }
    return(true);
    }

// Kommentar: Mit dieser Testfunktion werden im Feld alle Punkte der Klasse markiert.
void Strategie::tester_vertikal(bool ** tester_feld)
    {
// Kommentar: Alle Nord - Sd - Feldlisten werden ausgewhlt.
    for(i=0; i<m; i++)
        {
        nord_sued[i].anfangsposition();
// Kommentar: Die i.te Feldliste wird durchlaufen.
        for(;nord_sued[i].ist_fertig()==false;nord_sued[i].naechster())
            {
// Kommentar: Und fr die aufgrund dieser Durchufe gefundenen Punkte wird das tester_feld markiert.
            tester_feld[nord_sued[i].lesen()][i] = true;
            }
        }
    }

// Kommentar: Analog zu tester_vertikal, nur dass hier die west_ost - Feldlisten durchlaufen werden.
void Strategie::tester_horizontal(bool ** tester_feld)
    {
    for(i=0; i<n; i++)
        {
        west_ost[i].anfangsposition();
        for(;west_ost[i].ist_fertig()==false;west_ost[i].naechster())
            {
            tester_feld[i][west_ost[i].lesen()] = true;
            }
        }
    }

// Kommentar: Hier werden, frs Debugging, die Nord - Sd - und die Ost - West - Feldlisten durchlaufen.
void Strategie::ausgeben(void)
    {
#ifdef AUSGABEN_STRATEGIE
    cout << "Strategie.ausgeben() rang " << rang << endl;
    for(i=0; i<m; i++)
        {
        nord_sued[i].anfangsposition();
        for(;nord_sued[i].ist_fertig()==false;nord_sued[i].naechster())
            {
            cout << "(" << nord_sued[i].lesen() << "," << i << ")";
            }
        cout << endl;
        }
    for(i=0; i<n; i++)
        {
        west_ost[i].anfangsposition();
        for(;west_ost[i].ist_fertig()==false;west_ost[i].naechster())
            {
            cout << "(" << i << "," << west_ost[i].lesen() << ")";
            }
        cout << endl;
        }
#endif
    }

// Kommentar: Hier wird die Klasse Strategie finalisiert.
void Strategie::finalisieren(void)
    {
// Das Ausgabefeld, fr welches eine 0 / 1 Markierung gemacht und ausgegeben wird, wird angelegt.
    for(i=0; i<n; i++)
        {
        delete ausgabefeld[i];
        }
    delete ausgabefeld;

// Kommentar: Die einzelnen West - Ost - und Nord - Sd - Feldlisten werden aufgelst.
    for(i=0; i<n; i++)
        {
        (west_ost[i]).finalisieren();
        }
    for(i=0; i<m; i++)
        {
        (nord_sued[i]).finalisieren();
        }
////////////////////////////////////////////////

// Kommentar: Das Testfeld hier ist eindimensional. Es wird an die Feldlisten weitergebenen. Dafr wird der Speicher freigegeben.
    delete testfeld;
// Kommentar: Dieses Feld ist auch eindimensional, und wird auch an die Feldlisten weitergegeben. Auch hierfr wird der Speicher
// freigegeben.
    delete testfeld_indexliste;

// Kommentar: Die Zeiger auf die West - Ost - und Nord - Sd - Feldlisten werden freigegeben.
    delete west_ost;
    delete nord_sued;

// Kommentar: Die Felder, die die Punktanzahlen der 1 - dimensionalen Feldlisten speichern, werden freigegeben.
    delete anzahl_punkte_in_spalte;
    delete anzahl_punkte_in_zeile;
    }

// Kommentar: Die Klasse Startegie wird initialisiert.
void Strategie::initialisieren(int _n, int _m, int _rang, int _groesse, int _ebene)
    {
// Kommentar: Die bergabeparameter werden gespeichert.
    n = _n;
    m = _m;
    rang = _rang;
    groesse = _groesse;
    ebene = _ebene;

// Kommentar: Das Maximum von m und n wird gespeichert.
    max_n_m = maximum(n, m);
#ifdef KURZ_TESTFELD_F1D
// Kommentar: Entsprechend dem Maximum werden zwei eindimensionale Testfelder angelegt.
    testfeld = new bool [max_n_m];
    testfeld_indexliste = new int [max_n_m];
#else
    testfeld = new int [max_n_m];
    testfeld_indexliste = new int [max_n_m];
#endif

// Kommentar: Das testfeld wird resettet - alles wird zu false.
    for(i=0; i<max_n_m; i++)
        {
        testfeld[i] = false;
        }
    testfeld_indexanzahl = 0;

// Kommentar: Die eindimensionalen markierten Feldlisten fr West - Ost und Nord - Sd werden angelegt.
    west_ost = new FeldListe1DMf[n];
    nord_sued = new FeldListe1DMf[m];

// Kommentar: Die die Punktanzahl speichernden eindimensionalen Listen werden angelegt.
    anzahl_punkte_in_spalte = new int [m]; // m Spalten
    anzahl_punkte_in_zeile = new int [n]; // n Zeilen

// Kommentar: Die West - Ost - Feldlisten werden initialisiert.
    for(i=0; i<n; i++)
        {
// Kommentar: Zuerst werden sie im eigentlichen Sinne initialisiert, d.h. sie werden vorbereitet.
        (west_ost[i]).initialisieren(m);
// Kommentar: Dann bekommen sie selber die Koordinate, unter der sie in dieser Klasse Strategie gespeichert sind.
        (west_ost[i]).querkoordinate = i;
// Kommentar: Und dann werden die Testfelder diesen Listen zur Verfgung gestellt.
        (west_ost[i]).testfeld = testfeld;
        (west_ost[i]).testfeld_indexliste = testfeld_indexliste;
        (west_ost[i]).rang = rang;
        }

// Kommentar: Mache dasselbe fr die Nord - Sd - Feldlisten.
    for(i=0; i<m; i++)
        {
        (nord_sued[i]).initialisieren(n);
        (nord_sued[i]).querkoordinate = i;
        (nord_sued[i]).testfeld = testfeld;
        (nord_sued[i]).testfeld_indexliste = testfeld_indexliste;
        (nord_sued[i]).rang = rang;
        }

// Kommentar: Dann werden die folgenden Parameter so gewhlt, wie es fr eine leere Klasse Strategie der Fall ist:
// Man Setzt das Maximum auf einen kleinsteren Wert als die zulssigen Werte, und das Minimum auf einen greren
// Wert als die zulssigen Werte. Mit der Folge, dass bei einer Maximumbildung mit einem neuen Wert dieser Wert angenommen wird.
// Analog frs Minimum.
    maximale_spalte = -1;
    maximale_zeile = -1;
    minimale_spalte = m;
    minimale_zeile = n;
// Kommentar: Die Struktur ist leer => es gibt keine, also 0 Punkte.
    gesamtpunkteanzahl = 0;

// Kommentar: In jeder NS - und OW - Feldliste gibt es noch keine Punkte. Das wird hier verzeichnet.
    for(i=0; i<m; i++)
        {
        anzahl_punkte_in_spalte [i] = 0;
        }
    for(i=0; i<n; i++)
        {
        anzahl_punkte_in_zeile [i] = 0;
        }
// Kommentar: Und hier wird Speicherplatz fr die Ausgabe bestimmt. Frs Debugging.
    ausgabefeld = new int * [n];
    for(i=0; i<n; i++)
        {
        ausgabefeld[i] = new int [m];
        }
    datei_ausgabe.initialisieren(rang, text);
    }

// Kommentar: Hier wird ein Punkt (f,g) eingefgt.
void Strategie::einfuegen(int f, int g)
    {
#ifdef AUSGABEN_STRATEGIE
    if(f==2)
        {
        if(g==1)
            {
            if(n==17)
                {
                cout << "Se n " << n << " rang " << rang << endl;
                }
            }
        }
#endif
// Kommentar: War er in der entsprechenden Ost - West - Feldliste verzeichnet => Fehlermeldung.
    if(west_ost[f].belegt[g]==true)
        {
        cout << " Fehler: Strategie: Doppeltes Einfuegen in f = " << f << " g " << g << " also Fehler " << " rang " << rang << endl;
        exit(-1);
        }

// Kommentar: Ansonsten fge ihn in die entsprechende West - Ost - Feldliste und die entsprechende Nord - Sd - Feldliste ein.
    (west_ost[f]).einfuegen(g);
    (nord_sued[g]).einfuegen(f);

// Kommentar: Aktualisiere durch Maximumsbildung von f und maximale_zeile den Wert fr die Maximale Zeile.
    if(f>maximale_zeile)
        {
        maximale_zeile = f;
        }
// Kommentar: Aktualisiere durch Minimumbildung von f und minimale_zeile den Wert fr die Minimale Zeile.
    if(f<minimale_zeile)
        {
        minimale_zeile = f;
        }
// Kommentar: Mache dasselbe fr die maximale und minimale Spalte.
    if(g>maximale_spalte)
        {
        maximale_spalte = g;
        }
    if(g<minimale_spalte)
        {
        minimale_spalte = g;
        }
// Kommentar: Bemerkung: Man braucht das, um direkten Zugriff auf die stlichste, westlichste usw. Feldliste zu haben.

// Kommentar: Durch das Hinzufgen eines Punktes steigt die Gesamtpunktanzahl um 1.
    gesamtpunkteanzahl ++;

// Kommentar: Auch die Anzahlen in Zeile und Spalte erhhen sich um 1.
    anzahl_punkte_in_spalte[g] ++;
    anzahl_punkte_in_zeile[f] ++;
    }

// Kommentar: Ein Punkt (f,g) wird entfernt.
void Strategie::entfernen(int f, int g)
    {
#ifdef AUSGABEN_STRATEGIE
#endif
#ifdef PROGRAMM_TESTS

// Kommentar: Ein Test: Falls der Punkt nicht existiert, wird eine Fehlermeldung ausgegeben, zusammen mit Informationen ber die
// verzeichneten Punkte.
    if(west_ost[f].belegt[g]==false)
        {
        cout << "Strategie: Loeschen in f = " << f << " g " << g << " obwohl kein Punkt vorhanden, also Fehler / rang " << rang << endl;
        ausgabe();
        cout << "Ende Ausgabe der Strategiepunkte / rang " << rang << endl;
        exit(-1);
        }
#endif

// Kommentar: Der Punkt wird aus den Feldlisten entfernt.
    (west_ost[f]).entfernen(g);
    (nord_sued[g]).entfernen(f);

// Kommentar: Die Gesamtpunktanzahl verringert sich um 1.
    gesamtpunkteanzahl --;

// Kommentar: Die Anzahl der Punkte in Zeile und Spalte verringert sich an dieser Stelle um 1.
    apis = anzahl_punkte_in_spalte[g];
    apiz = anzahl_punkte_in_zeile[f];

    anzahl_punkte_in_spalte[g] = apis-1;
    anzahl_punkte_in_zeile[f] = apiz-1;

// Kommentar: Bei einer leeren Struktur werden die Maximal - und Minimalwerte wie bei der Initialisierung gesetzt.
// Mehr ist dann nicht zu tun.
    if(gesamtpunkteanzahl==0)
    // vgl. gesamtpunkteanzahl -- 5 Befehle nach oben.
        {
        maximale_spalte = -1;
        maximale_zeile = -1;
        minimale_spalte = m;
        minimale_zeile = n;
        return;
        }

// Kommentar: Falls g die maximale Spalte war ...
    if(g==maximale_spalte)
        {
#ifdef AUSGABEN
        cout << "APIS " << apis << endl;
#endif

// Kommentar: ... und das der letzte Gitterpunkt war.
        if(apis==1)
            {
// Kommentar: Dann veringere die Zahl i, bis eine Spalte mit mindestens einem Punkt erreicht wird. Das wird der Fall
// sein, weil die Gesamtpunktanzahl > 0 ist.
            for(i=g-1; i>=0; i--)
                {
                if(anzahl_punkte_in_spalte[i]!=0)
                    {
                    break;
                    }
                }
// Kommentar: Und schreibe den neuen Wert fr die maximale Spalte.
            maximale_spalte = i;
            }
        }
// Kommentar: Falls g die minimale Spalte war ...
    if(g==minimale_spalte)
        {
#ifdef AUSGABEN
        cout << "APis " << apis << endl;
#endif
// Kommentar: ... und das der letzte Gitterpunkt war.
        if(apis==1)
            {
#ifdef AUSGABEN
            cout << "APis ==1 " << endl;
#endif

// Kommentar: Dann erhhe die Zahl i, bis eine Spalte mit mindestens einem Punkt erreicht wird. Das wird der Fall
// sein, weil die Gesamtpunktanzahl > 0 ist.
            for(i=g+1; i<m; i++)
                {
                if(anzahl_punkte_in_spalte[i]!=0)
                    {
                    break;
                    }
                }
#ifdef AUSGABEN
            cout << " Minimale Spalte " << i << endl;
#endif
// Kommentar: Und schreibe den neuen Wert fr die minimale Spalte.
            minimale_spalte = i;
            }
        }

// Kommentar: Gehe analog vor fr die mgliche nderung der maximalen und minimalen Zeile.
    if(f==maximale_zeile)
        {
        if(apiz==1)
            {
            for(i=f-1; i>=0; i--)
                {
                if(anzahl_punkte_in_zeile[i]!=0)
                    {
                    break;
                    }
                }
            maximale_zeile = i;
            }
        }
    if(f==minimale_zeile)
        {
        if(apiz==1)
            {
            for(i=f+1; i<n; i++)
                {
                if(anzahl_punkte_in_zeile[i]!=0)
                    {
                    break;
                    }
                }
            minimale_zeile = i;
            }
        }

    }

// Kommentar: Hier wird ein stlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten.
void Strategie::finde_oestlichsten_vektor(int _lastmenge)
    {
#ifdef AUSGABEN_STRATEGIE
    cout << "Gesamtpunkteanzahl " << gesamtpunkteanzahl << " max Spalte " << maximale_spalte << " rang " << rang << endl;
    cout << " vvektor_f1 " << vvektor_f1 << endl;
#endif

// Kommentar: Kein Gitterpunkt, dann ist auch kein stlichster Vektor zu bestimmen.
    if(gesamtpunkteanzahl==0)
        {
#ifdef AUSGABEN_STRATEGIE
        cout << "Kein Punkt mehr in der Klasse Strategie " << endl;
#endif
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==13)&&(gesamtpunkteanzahl<=2))
        {
        cout << " Vor vektorbildung LLMMNN " << " maximale_spalte " << maximale_spalte << " laenge " << nord_sued[maximale_spalte].laenge << endl;
        }
#endif

// Kommentar: Der stlichste Vektor ist ein Nord - Sd - Vektor. Nutze nun die Funktion Vektorbildung der Nord - Sd - Feldliste mit dem Index
// maximale Spalte, um einen Vektor zu finden, der die Maximallnge nicht berschreitet.
    (nord_sued[maximale_spalte]).vektorbildung(_lastmenge);
#ifdef AKTUELLE_KOMMENTARE
    if((rang==13)&&(gesamtpunkteanzahl<=2))
        {
        cout << " Nach vektorbildung LLMMNN " << endl;
        }
#endif

// Kommentar: Und dann speichere man den Vektor.
    vvektor_f1 = (nord_sued[maximale_spalte]).vektoranfang;
    vvektor_f2 = (nord_sued[maximale_spalte]).vektorende;
    vvektor_g = maximale_spalte;
#ifdef AUSGABEN_STRATEGIE
    cout << "Vektoranfang " << vvektor_f1 << " Vektorende " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
    }

// Kommentar: Hier wird ein westlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten.
// Da es analog zu finde_oestlichsten_vektor erfolgt, wird keine weitere Kommentierung angegeben.
void Strategie::finde_westlichsten_vektor(int _lastmenge)
    {
    if(gesamtpunkteanzahl==0)
        {
        return;
        }
    (nord_sued[minimale_spalte]).vektorbildung(_lastmenge);
    // nord-sued - vektor also spalte. minimale Spalte ist am Westlichsten 30.08.2014
    vvektor_f1 = (nord_sued[minimale_spalte]).vektoranfang;
    vvektor_f2 = (nord_sued[minimale_spalte]).vektorende;
    vvektor_g = minimale_spalte;
    }

// Kommentar: Hier wird ein suedlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten.
// Da es analog zu finde_oestlichsten_vektor erfolgt, wird keine weitere Kommentierung angegeben.
void Strategie::finde_suedlichsten_vektor(int _lastmenge)
    {
    if(gesamtpunkteanzahl==0)
        {
        return;
        }
    (west_ost[maximale_zeile]).vektorbildung(_lastmenge);
    hvektor_f = maximale_zeile;
    hvektor_g1 = (west_ost[maximale_zeile]).vektoranfang;
    hvektor_g2 = (west_ost[maximale_zeile]).vektorende;
    }

// Kommentar: Hier wird ein noerdlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten.
// Da es analog zu finde_oestlichsten_vektor erfolgt, wird keine weitere Kommentierung angegeben.
void Strategie::finde_noerdlichsten_vektor(int _lastmenge)
    {
    if(gesamtpunkteanzahl==0)
        {
        return;
        }
    (west_ost[minimale_zeile]).vektorbildung(_lastmenge);
    hvektor_f = minimale_zeile;
    hvektor_g1 = (west_ost[minimale_zeile]).vektoranfang;
    hvektor_g2 = (west_ost[minimale_zeile]).vektorende;
    }

// Kommentar: Diese einfach Funktion bildet das Maximum zweier Integer - Werte.
int Strategie::maximum(int a, int b)
    {
    if(a>b)
        {
        return(a);
        }
    return(b);
    }

#ifdef KURZ
// Kommentar: Hier wird die Klasse Strategie benutzt, die Koordinaten aller Punkte dieser Klasse zu sammeln. Man braucht sowas z.B. bei einer
// Visualisierung. Es geht einfach darum, die Aufteilung der Punktmengen - hier die der Klasse Strategie - auf die Kerne zu bekommen.
// Bemerkung: Das Ergebnis wird in einem Buffer gespeichert.
int Strategie::sammeln_koordinaten(short int * koordinaten)
#else
int Strategie::sammeln_koordinaten(int * koordinaten)
#endif
    {
#ifdef AUSGABEN_STRATEGIE
    cout << "Sammeln Koordinaten gesamtpunkteanzahl " << gesamtpunkteanzahl << " rang " << rang << endl;
#endif

// Kommentar: Keine Punkte. Dann schreibe in den Buffer die minimale Lnge, und sage, dass in WEST_OST - Richtung gepackt worden ist.
// Man knnte genausogut koordinaten[i] = NORD_SUED schreiben.
    if(gesamtpunkteanzahl == 0)
        {
        koordinaten[0] = 2;
        koordinaten[1] = WEST_OST;
        return(0);
        }

#ifdef AUSGABEN_STRATEGIE
    cout << "Anfang Sammeln_Koordinaten " << endl;
#endif

// Kommentar: Ansonsten setze den Bufferindex auf 2. Die ersten beiden Eintrge haben eine besondere Funktion
    bufferindex = 2;

// Kommentar: Erkenne, ob es weniger Spalten oder Zeilen gibt. Gibt es weniger Zeilen, dann werden die gepackt.
    if(maximale_spalte-minimale_spalte>maximale_zeile-minimale_zeile)
        {
// Kommentar: Es gibt weniger Zeilen. Dann werden West - Ost - Vektoren verschickt. Man schreibe das in wons.
        wons = WEST_OST; // west-ost ist die Ausrichtung: der Vektor erstreckt sich von West nach Ost, also horizontal 30.08.2014
//        wons = HORIZONTALE_VEKTOREN; // West - Ost ist

// Kommentar: Die Zeilen werden durchlaufen.
        for(i=minimale_zeile; i<=maximale_zeile; i++)
        // minimale Zeile: Am nrdlichsten horizontaler Vektor 30.08.2014
            {
// Kommentar: Gibt es in einer Zeile Punkte ...
            if(anzahl_punkte_in_zeile[i]!=0)
                {
#ifdef AUSGABEN_STRATEGIE
                cout << anzahl_punkte_in_zeile[i] << " ";
#endif
// Kommentar: ... dann lasse diese durch die West - Ost - Feldliste in den Buffer packen.
                bufferindex = west_ost[i].alle_vektoren_horizontal(koordinaten, bufferindex, i);
                }
            }
        }
// Kommentar: Es gibt weniger Spalten. Dann werden Nord - Sd - Vektoren verschickt. Alles weitere folgt analog zum Fall weniger
// Zeilen. Daher: Kein weiterer Kommentar.
    else
        {
        wons = NORD_SUED;
        for(i=minimale_spalte; i<=maximale_spalte; i++)
            {
            if(anzahl_punkte_in_spalte[i]!=0)
                {
                bufferindex = nord_sued[i].alle_vektoren_vertikal(koordinaten, bufferindex, i);
                }
            }

        }

// Kommentar: Bufferlnge, und wons (West - Ost oder Nord - Sd packen) werden an den Anfang des Buffers geschrieben.
    koordinaten[0] = bufferindex;
    koordinaten[1] = wons;

#ifdef AUSGABEN_STRATEGIE
    cout << "Ende Sammeln Koordinaten" << endl;
#endif

// Kommentar: Und die Bufferlnge wird zurckgegeben.
    return(bufferindex);
    }

// Kommentar: Das ist eine Ausgabe - Funktion zu Debugging - Zwecken. Hier wird ein Buffer ausgegeben.
void Strategie::ausgeben_koordinaten(short int * koordinaten)
    {
#ifdef AUSGABEN_STRATEGIE
    cout << " Strategie::ausgeben_koordinaten rang " << rang << endl;
#endif
    bufferindex = koordinaten[0];
    wons = koordinaten[1];

#ifdef AUSGABEN_STRATEGIE
    cout << " Strategie::ausgeben_koordinaten bufferindex " << bufferindex << " wons " << wons << endl;

    for(i=2; i<bufferindex; i++)
        {
        cout << " a " << koordinaten[i++];
        cout << " b " << koordinaten[i++];
        cout << " c " << koordinaten[i];
        }
    cout << " / rang " << rang << endl;
#endif
    }

// Kommentar: Das ist eine Ausgabe - Funktion zu Debugging - Zwecken. Hier wird ausgegeben, welche Punkte in der Klasse eingetragen sind.
void Strategie::ausgabe(void)
    {
#ifdef AUSGABEN_STRATEGIE
    cout << " Ausgaben Strategie / rang " << rang << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            ausgabefeld[i][j] = 0;
            }
        }
    for(i=0; i<m; i++)
        {
        nord_sued[i].anfangsposition();
        for(;nord_sued[i].ist_fertig()==false;nord_sued[i].naechster())
            {
            j = nord_sued[i].lesen();
            ausgabefeld[j][i] = 1;
            }
        }
    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << ausgabefeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << endl;
    cout << " Ende Ausgaben Strategie / rang " << rang << endl;
#endif
    }

// Kommentar: Das ist eine Ausgabe - Funktion zu Debugging - Zwecken. Hier wird auch ausgegeben, welche Punkte in der 2 -
// dimensionalen Ansicht vorhanden sind. Unterschied: Es wird in eine Datei ausgegeben.
void Strategie::da_ausgabe(DateiAusgabe * da)
    {
#ifdef AUSGABEN_DATEI
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            ausgabefeld[i][j] = 0;
            }
        }
    for(i=0; i<m; i++)
        {
        nord_sued[i].anfangsposition();
        for(;nord_sued[i].ist_fertig()==false;nord_sued[i].naechster())
            {
            j = nord_sued[i].lesen();
            ausgabefeld[j][i] = 1;
            }
        }
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            da->aus << ausgabefeld[i][j] << " ";
            }
        da->aus << endl;
        }
    da->aus << endl;
#endif
    }

// Kommentar: Auch das ist eine Ausgabe zu Debugging Zwecken. Hier wird dasselbe wie in der Klasse zuvor ausgegeben -
// auch in eine Datei.
void Strategie::datei_ausgabe_machen(char * text2, int t)
    {
#ifdef AKTUELLE_KOMMENTARE
    datei_ausgabe.oeffnen();
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            ausgabefeld[i][j] = 0;
            }
        }
    for(i=0; i<m; i++)
        {
        nord_sued[i].anfangsposition();
        for(;nord_sued[i].ist_fertig()==false;nord_sued[i].naechster())
            {
            j = nord_sued[i].lesen();
            ausgabefeld[j][i] = 1;
            }
        }
    * datei_ausgabe.aus << " Text " << text2 << " t " << t << " anzahl " << gesamtpunkteanzahl << endl;
    for(i=0; i<n; i++)
        {
        * datei_ausgabe.aus << i << " ";
        if(i<10)
            {
            * datei_ausgabe.aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * datei_ausgabe.aus << "(" << ausgabefeld[i][j] << "," << nord_sued[j].belegt[i] << ")";
            }
        * datei_ausgabe.aus << endl;
        }
    * datei_ausgabe.aus << endl;
    datei_ausgabe.schliessen();
#endif
    }

// Kommentar: Hier wird fr einen Punkt berprft, ob die Nord - Sd - Feldliste dieselbe Entscheidung ber die Existenz des Punktes
// angibt wie die Ost - West - Feldliste.
bool Strategie::teste_existenz(int f, int g)
    {
    testwert1 = nord_sued[g].teste_existenz(f);
    testwert2 = west_ost[f].teste_existenz(g);
    if(testwert1 != testwert2)
        {
        cout << "Interner Fehler der Klasse Strategie: testwert1!=testwert2 " << endl;
        exit(-1);
        }
    return(testwert1);
    }

///////////////////////////////////////////////////////
//// LwK                                           ////
///////////////////////////////////////////////////////

// Kommentar: Hier wird ein stlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten. Dabei
// werden echte Randpunkte nicht als Last angesehen, wegen der Lastwertekorrektur (LWK).
void Strategie::finde_oestlichsten_vektor_lwk(int _lastmenge)
    {
#ifdef AUSGABEN_STRATEGIE
    cout << "Gesamtpunkteanzahl " << gesamtpunkteanzahl << " max Spalte " << maximale_spalte << " rang " << rang << endl;
    cout << " vvektor_f1 " << vvektor_f1 << endl;
#endif

// Kommentar: Kein Gitterpunkt, dann ist auch kein stlichster Vektor zu bestimmen.
    if(gesamtpunkteanzahl==0)
        {
#ifdef AUSGABEN_STRATEGIE
        cout << "Kein Punkt mehr in der Klasse Strategie " << endl;
#endif
        return;
        }
#ifdef AKTUELLE_KOMMENTARE
    if((rang==13)&&(gesamtpunkteanzahl<=2))
        {
        cout << " Vor vektorbildung LLMMNN " << " maximale_spalte " << maximale_spalte << " laenge " << nord_sued[maximale_spalte].laenge << endl;
        }
#endif

// Kommentar: Der stlichste Vektor ist ein Nord - Sd - Vektor. Nutze nun die Funktion Vektorbildung der Nord - Sd - Feldliste
// mit dem Index maximale Spalte, um einen Vektor zu finden, der die Maximallnge nicht berschreitet. Verwende aber den Suffix LWK,
// damit echte Randpunkte nicht als Last gewertet werden.
    (nord_sued[maximale_spalte]).vektorbildung_lwk(_lastmenge);
#ifdef AKTUELLE_KOMMENTARE
    if((rang==13)&&(gesamtpunkteanzahl<=2))
        {
        cout << " Nach vektorbildung LLMMNN " << endl;
        }
#endif

// Kommentar: Und dann speichere man den Vektor.
    vvektor_f1 = (nord_sued[maximale_spalte]).vektoranfang;
    vvektor_f2 = (nord_sued[maximale_spalte]).vektorende;
    vvektor_g = maximale_spalte;
#ifdef AUSGABEN_STRATEGIE
    cout << " oestlichster Vektor f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << " lastabzug " << nord_sued[maximale_spalte].gefundene_last << " lastmenge " << _lastmenge << " Ebene " << ebene << endl;
#endif

// Kommentar: Und dann speichere man in der Variablen lastabzug, wieviel Last dieser ausgewhlte Vektor hat.
    lastabzug = nord_sued[maximale_spalte].gefundene_last;
#ifdef AUSGABEN_STRATEGIE
    cout << "Vektoranfang " << vvektor_f1 << " Vektorende " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
    }

// Kommentar: Hier wird ein westlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten. Und er
// bewertet - entsprechend der Lastwertekorrektur - echte Randpunkte nicht als Last.
// Da es analog zu finde_oestlichsten_vektor_lwk erfolgt, wird keine weitere Kommentierung angegeben.
void Strategie::finde_westlichsten_vektor_lwk(int _lastmenge)
    {
    if(gesamtpunkteanzahl==0)
        {
        return;
        }
    (nord_sued[minimale_spalte]).vektorbildung_lwk(_lastmenge);
    vvektor_f1 = (nord_sued[minimale_spalte]).vektoranfang;
    vvektor_f2 = (nord_sued[minimale_spalte]).vektorende;
    vvektor_g = minimale_spalte;
    lastabzug = nord_sued[minimale_spalte].gefundene_last;
#ifdef AUSGABEN_STRATEGIE
    cout << " westlichster Vektor f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << " lastabzug " << nord_sued[minimale_spalte].gefundene_last << " Ebene " << ebene << endl;
#endif
    }

// Kommentar: Hier wird ein suedlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten. Und er
// bewertet - entsprechend der Lastwertekorrektur - echte Randpunkte nicht als Last.
// Da es analog zu finde_oestlichsten_vektor_lwk erfolgt, wird keine weitere Kommentierung angegeben.
void Strategie::finde_suedlichsten_vektor_lwk(int _lastmenge)
    {
    if(gesamtpunkteanzahl==0)
        {
        return;
        }
    (west_ost[maximale_zeile]).vektorbildung_lwk(_lastmenge);
    hvektor_f = maximale_zeile;
    hvektor_g1 = (west_ost[maximale_zeile]).vektoranfang;
    hvektor_g2 = (west_ost[maximale_zeile]).vektorende;
    lastabzug = west_ost[maximale_zeile].gefundene_last;
#ifdef AUSGABEN_STRATEGIE
    cout << " suedlichster Vektor f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << " lastabzug " << west_ost[maximale_zeile].gefundene_last << " Ebene " << ebene << endl;
#endif
    }

// Kommentar: Hier wird ein noerdlichster Vektor gefunden. Er darf den bergebenen Wert fr die Lastmenge nicht berschreiten. Und er
// bewertet - entsprechend der Lastwertekorrektur - echte Randpunkte nicht als Last.
// Da es analog zu finde_oestlichsten_vektor_lwk erfolgt, wird keine weitere Kommentierung angegeben.
void Strategie::finde_noerdlichsten_vektor_lwk(int _lastmenge)
    {
    if(gesamtpunkteanzahl==0)
        {
        return;
        }
    (west_ost[minimale_zeile]).vektorbildung_lwk(_lastmenge);
    hvektor_f = minimale_zeile;
    hvektor_g1 = (west_ost[minimale_zeile]).vektoranfang;
    hvektor_g2 = (west_ost[minimale_zeile]).vektorende;
    lastabzug = west_ost[minimale_zeile].gefundene_last;
#ifdef AUSGABEN_STRATEGIE
    cout << " noerdlichster Vektor f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << " lastabzug " << west_ost[minimale_zeile].gefundene_last << " Ebene " << ebene << endl;
#endif
    }

// Kommentar: Durch diese Ausgabe der west_ost Feldlisten ist einsehbar, welche Punkte in der Strategieklasse verzeichnet sind.
void Strategie::dateiausgabe(DateiAusgabe * da)
    {
#ifdef AUSGABEN_STRATEGIE
    * da->aus << " Strategieausgabe " << endl;
    for(i=0; i<n; i++)
        {
        west_ost[i].anfangsposition();
        for(;west_ost[i].ist_fertig()==false;west_ost[i].naechster())
            {
            j = west_ost[i].lesen();
            * da->aus << " i " << i << " j " << j;
            }
        * da->aus << endl;
        }
#endif
    }
