#include "timer_vektor.h"

// Kommentar: Das hier ist keine echte Stoppuhr. Hier wird nur zwei gemeinsame Startzeiten, sowie die verschiedenen Ankunftszeiten
// gespeichert - und dann auch ausgegeben.

// Kommentar: Es werden die 2 Startzeiten und die Ankunftszeiten der anderen Kerne ausgegeben.
void TimerVektor::ausgabe(void)
    {
    cout << " TimerVektor: rang " << rang << " Startzeit " << gemeinsame_startzeit;
    cout << " Startzeit 2 " << gemeinsame_startzeit2;
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            cout << " i " << i << " Zeit " << kommunikation_ankunftszeiten[i];
            }
        }
    cout << endl;
    }

// Kommentar: Hier werden die Übergabeparameter groesse und rang gespeichert, und es wird Speicherplatz für die Ankunftszeiten
// auf den Kernen bereitgestellt.
void TimerVektor::initialisieren(int _groesse, int _rang)
    {
    groesse = _groesse;
    rang = _rang;
    kommunikation_ankunftszeiten = new double [groesse];
    }

// Kommentar: Der Timer gibt seinen allokierten Speicher wieder frei.
void TimerVektor::finalisieren(void)
    {
    delete kommunikation_ankunftszeiten;
    }

// Kommentar: Die gemeinsame Startzeit wird bestimmt.
void TimerVektor::starten(void)
    {
    gemeinsame_startzeit = MPI_Wtime();
    }

// Kommentar: Die zweite gemeinsame Startzeit wird bestimmt.
void TimerVektor::starten2(void)
    {
    gemeinsame_startzeit2 = MPI_Wtime();
    }

// Kommentar: Die Ankunftszeit der Nachricht eines Kerns wird gespeichert.
void TimerVektor::ankunft(int prozessor)
    {
    kommunikation_ankunftszeiten[prozessor] = MPI_Wtime();
    }
