#ifndef UEBERMITTELN
#define UEBERMITTELN 1

#include <mpi.h>

#include <iostream>

using namespace std;

#include "ausgaben.h"

class Uebermitteln
    {
private:
    int ** uebermitteln_sendebuffer;
    int ** einfuegebuffer;
public:
    int ** uebermitteln_empfangsbuffer;
private:
public:
    int uebermitteln_rang, uebermitteln_groesse;
    int uebermitteln_m, uebermitteln_n;
public:
    void uebermitteln_initialisierung(int _rang, int _groesse, int _n, int _m);
    void uebermitteln_finalisierung(void);
private:
    int i, j, k;
    int buffergroesse, buffergroesse2;
private:
    MPI_Request * sende_request;
    MPI_Request * empfangs_request;

    MPI_Status sende_status;
    MPI_Status empfangs_status;
private:
    int * sende_indizes, sende_index;
public:
    void uebermitteln_aufloesen(int farbe, int f, int g);
    void uebermitteln_bilden(int farbe, int f, int g);
private:
    int index;
    int einfuege_index;
    int * einfuege_indizes;
public:
    void reset_uebermitteln(void);
public:
    int * ist_nachbar;
public:
    void senden(void);
    void empfangen(void);
private:
    void eines_senden(int i);
    void eines_empfangen(int i);
public:
    bool uebermitteln_ist_fertig(void);
private:
    bool eines_testen(int i);
    int flag;
public:
    void aneinander_haengen(void);
private:
    void eines_aneinander_haengen(int farbe);
public:
    int * laengen_einfuegen;
private:
public:
    int * laengen_aufloesen, * laengen_aendern;
    int laenge_einfuegen, laenge_aufloesen, laenge_aendern;
private:
    int * anfangsindizes_aufloesen, anfangsindex_aufloesen;
    int * anfangsindizes_einfuegen, anfangsindex_einfuegen;
    int * anfangsindizes_einfuegen_alleine, anfangsindex_einfuegen_alleine;
    int * anfangsindizes_aendern, anfangsindex_aendern;
private:
    int h, hh, hhh;
    int * aktuelle_indizes_alleine;
public:
    void uebermitteln_aendern(int farbe, int f, int g, int speicher_farbe);
    void nach_testen(void);
public:
    int * farben, * farbliste;
    int farblistenindex;
    int farbwert;
public:
    void uebermitteln_ausgeben(void);
    void uebermitteln_ausgeben_senden(void);
private:
    void eines_ausgeben(void);
    void eines_ausgeben_senden(void);
    };


#endif

