#ifndef KLASSE_UEBERTRAGE_GITTERWERTE
#define KLASSE_UEBERTRAGE_GITTERWERTE 1

#include "ausgaben.h"

#include <mpi.h>

#include <iostream>

using namespace std;

class UebertrageGitterwerte
    {
public:
#ifdef KURZ
private:
    short int ** koordinatenbuffer; // groesse an Zahl viele einzelne Buffer;
public:
    short int * ein_koordinatenbuffer;
private:
    short int * koord;
#else
private:
    int ** koordinatenbuffer; // groesse an Zahl viele einzelne Buffer;
public:
    int * ein_koordinatenbuffer;
private:
    int * koord;
#endif
private:
    double ** wertebuffer;
    double * ein_wertebuffer;
    double * werte;
private:
    int rang, groesse;
    int m, n, gitterebene;
    int m_hilfe, n_hilfe;
    double ** gitterwerte1, ** gitterwerte2, ** gitterwerte3, ** gitterwerte4;
    double ** gitterwerte_zerstreuen1, ** gitterwerte_zerstreuen2, ** gitterwerte_zerstreuen3, ** gitterwerte_zerstreuen4;
    double ** gitterwerte_sammeln1, ** gitterwerte_sammeln2, ** gitterwerte_sammeln3, ** gitterwerte_sammeln4;
    double ** u0;
public:
    #ifdef dimensionen1
    void initialisieren(int _n, int _m, int _groesse, int _rang, int _gitterebene, bool _oben_nicht_adaptiv, double ** _gitterwerte1);
    #endif
    #ifdef dimensionen2
    void initialisieren(int _n, int _m, int _groesse, int _rang, int _gitterebene, bool _oben_nicht_adaptiv, double ** _gitterwerte1, double ** _gitterwerte2);
    #endif
    #ifdef dimensionen3
    void initialisieren(int _n, int _m, int _groesse, int _rang, int _gitterebene, bool _oben_nicht_adaptiv, double ** _gitterwerte1, double ** _gitterwerte2, double ** _gitterwerte3);
    #endif
    #ifdef dimensionen4
    void initialisieren(int _n, int _m, int _groesse, int _rang, int _gitterebene, bool _oben_nicht_adaptiv, double ** _gitterwerte1, double ** _gitterwerte2, double ** _gitterwerte3, double ** _gitterwerte4);
    #endif
    #ifdef GEMEINSAME_BUFFER
    void initialisieren2(double ** buffer);
    #else
    void initialisieren2(void);
    #endif
    void finalisieren2(void);
    void finalisieren(void);
    void setze_u0(double ** _u0);
private:
    int i, j, k, l;
    int buffergroesse, buffergroesse2;
public:
    void sende_koordinaten_ungleich_0(void);
    void empfange_koordinaten_gleich_0(void);
private:
    MPI_Request sende_request, sende_request2;
    MPI_Request * sende_requests;
    MPI_Request * empfangs_requests, * empfangs_requests2;
    MPI_Request empfangs_request;
private:
    int hoechstindex, werteindex;
    int a, b, c;
    int wons;
private:

public:
    void wertebuffer_bestimmen(void);
    void wertebuffer_bestimmen_adapt(void);
    void sende_werte_ungleich_0(void);
    bool teste_empfange_koordinaten_gleich_0(void);
    bool teste_sende_koordinaten_gleich_0(void);
    void empfange_werte_gleich_0(void);
private:
    int flag;
    MPI_Status sende_status;
    MPI_Status empfangs_status;
public:
    bool teste_empfange_werte_gleich_0(void);
private:
    void trage_werte_einmal_ein_gleich_0(int auswahl_rang);
public:
    void trage_werte_ein_gleich_0(void);
private:
public:
    void alle_wertebuffer_bestimmen(void);
private:
    void einen_wertebuffer_bestimmen(int auswahl_rang);
private:
    int * werteindex_merken;
public:
    void sende_wertebuffer_gleich_0(void);
    void wertebuffer_eintragen(void);
public:
    void empfange_werte_ungleich_0(void);
    void sende_werte_gleich_0(void);
    bool teste_empfange_werte_ungleich_0(void);
public:
    void ausgabe_koordinaten(void);
public:
    void sehe_empfange_werte_gleich_0(void);
    void schreibe_x_i(double ** _gitterwerte1, double ** _gitterwerte2, double ** _gitterwerte3, double ** _gitterwerte4);
    void schreibe_sammeln_i(double ** _gitterwerte1, double ** _gitterwerte2, double ** _gitterwerte3, double ** _gitterwerte4);
    void schreibe_zerstreuen_i(double ** _gitterwerte1, double ** _gitterwerte2, double ** _gitterwerte3, double ** _gitterwerte4);
private:
    bool ausgeben_flag;
public:
    void ausgeben(void);
public:
    UebertrageGitterwerte(void);
private:
    int * flags;
public:
    void ausgabe_empfang(void);
    bool teste_ungleich_0(void);
public:
    void trage_werte_ein_gleich_0_ohne_nullen(void);
private:
    void trage_werte_einmal_ein_gleich_0_ohne_nullen(int auswahl_rang);
private:
    int * uebertrage_gitterwerte_flag;
    int anzahl_flag_true;
    int i_flag;
public:
    void empfangen0(void);
private:
    bool oben_nicht_adaptiv;
    int buffergroesse2_sammeln;
    };
#endif

