#include "uebertrage_grobgitter_u.h"

// Kommentar: Das ist eine Vaterklasse zur Klasse RandInterpolation. Hier wird die Kommunikation fr diese Klasse durchgefhrt.

// Kommentar: Hier wird ein Punkt in den Buffer der angegebenen Farbe eingetragen. Modulo dem, dass die Buffer dann kommuniziert
// werden, bedeutet das eine bertragung des Punktewertes. Hier wird auch die Struktur Markierungsfelder verwendet, damit derselbe
// Punkt nicht mehrfach eingetragen wird. Die ist aber nicht zu verwechseln mit der Struktur Markierung, die beim Entpacken
// bentigt wird - vgl. die Funktion entpacken.
void UebertrageGrobgitterU::uebertrage(int farbe, int f, int g)
    {
#ifdef AUSGABE_EFGH
    if((f==3)&&(g==9))
        {
        cout << " EFG (3,9) farbe " << farbe << " rang " << rang << " u0_grob " << u0_grob[f][g] << endl;
        }
#endif

#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 1 rang " << rang << " Farbe " << farbe << " f " << f << " g " << g << endl;
    cout << "MF(f,0,0) " << markierungsfelder[farbe].feld[0][0] << endl;
#endif

// Kommentar: Wenn dieser Punkt schon in den Buffer zu dem Kern mit der ID farbe eingetragen wurde, dann nichts machen.
    if(markierungsfelder[farbe].feld[f][g] == true)
        {
#ifdef AUSGABEN_UEBERTRAGE_GG
        cout << "Uebertrage GG 1a rang " << rang << endl;
#endif
        return;
        }
#ifdef AKTUELLE_WERTE
    if((f==1)&&(g>=1)&&(g<=3))
        {
        cout << " KKJJII nach mf in UGU f " << f << " g " << g << " rang " << rang << " farbe " << farbe << endl;
        }
#endif
#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 2 rang " << rang << endl;
#endif

// Kommentar: Man beschafft sich den Index und den Bufferzeiger des Buffers mit der ID farbe.
    index = sende_indizes[farbe];
    ein_sendebuffer = sendebuffer[farbe];
#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 3 rang " << rang << endl;
#endif

// Kommentar: Man trgt in das Bufferelement unter dem Index des beschafften Indexes die Koordinaten f und g des Punktes ein.
    ein_sendebuffer[index].f = f;
#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 4 rang " << rang << endl;
#endif
    ein_sendebuffer[index].g = g;
#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 5 rang " << rang << endl;
#endif

// Kommentar: Dann trgt man in dasselbe Element den Grobgitterwert der Variablen u0 ein.
    ein_sendebuffer[index].wert1 = u0_grob[f][g];
#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 6 rang " << rang << endl;
#endif

// Kommentar: Dann wird der Punkt unter der Farbe markiert, damit er kein zweites Mal gepackt wird.
    markierungsfelder[farbe].setzen(f, g);
#ifdef AUSGABEN_UEBERTRAGE_GG
    cout << "Uebertrage GG 7 rang " << rang << endl;
#endif

// Kommentar: Am Ende wird der neue Index (1 + alter Index) in die Struktur sende_indizes unter der Farbe farbe zurckgeschrieben.
    sende_indizes[farbe] = index+1;
    }

// Kommentar: Die im Folgenden definierte MPI - Struktur wird hier freigegeben.
void UebertrageGrobgitterU::finalisieren_mpi_struktur(void)
    {
// Kommentar: Das geschieht mit dem Befehl MPI_Type_free.
    MPI_Type_free(&mpi_werte1d);
    }

// Kommentar: Hier wird eine MPI_Struktur angelegt, bestehend aus 2 short integer - Werte fr die Koordinaten des Punktes sowie einem
// double - Wert fr den Grobgitter u0 - Wert auf dieser Position. Dabei geht immer etwas Speicherplatz verloren, weil immer
// Vielfaches des Speicherbedarfes der double - Werte gebraucht wird.
void UebertrageGrobgitterU::initialisieren_mpi_struktur(void)
    {
    buffergroesse = 10* (n+m);
#ifdef JJIIHH_TEXT
    cout << " JJIIHH buffergroesse " << buffergroesse << endl;
#endif

// Kommentar: Als Typen: 2 Mal short int, 1 Mal double.
    type[0] = MPI_SHORT;
    type[1] = MPI_SHORT;
    type[2] = MPI_DOUBLE;

// Kommentar: Die 3 Blocklngen sind jeweils 1.
    blocklen[0] = 1;
    blocklen[1] = 1;
    #ifdef dimensionen1
    blocklen[2] = 1;
    #endif
    #ifdef dimensionen2
    blocklen[2] = 2;
    #endif
    #ifdef dimensionen3
    blocklen[2] = 3;
    #endif
    #ifdef dimensionen4
    blocklen[2] = 4;
    #endif

    blocklen[2] = 1;
// Der Type stimmt so: er besteht aus zwei MPI_SHORT und 1 bis 4 MPI_DOUBLE. blocklen[2] spezifiziert
// letzteres.

// Kommentar: Das Displacement der Eintrge, also von wo in der Struktur auf sie zugegriffen wird, sind 0 frs erste short int,
// sizeof(short) fr den zweiten Eintrag, und sizeof(double) fr den double - Eintrag.
    disp[0] = 0;
    disp[1] = sizeof(short);
    disp[2] = 8;

// Kommentar: Mit den eben erluterten Informationen wird die Struktur definiert.
    MPI_Type_struct(3, blocklen, disp, type, &mpi_werte1d);
// Kommentar: Es wird ein MPI_Type damit definiert.
    MPI_Type_commit(&mpi_werte1d);
// Kommentar: Der Wert extent gibt die Lnge der Struktur vom Anfang bis zum Ende an.
    MPI_Type_extent(mpi_werte1d, &extent);
    cout << "Extent " << extent << " short " << sizeof(short) << " double " << sizeof(double) << endl;
    }

void UebertrageGrobgitterU::finalisierenUGU(void)
    {
// Kommentar: Die Sende - und Empfangs - Buffer - Indizes zu allen Farben werden freigegeben.
    delete sende_indizes;
    delete empfangs_indizes;
// Kommentar: Die Sende - und Empfangs - Requests zu allen Farben werden freigegeben.
    delete sende_request;
    delete empfangs_request;
// Kommentar: Die MPI - Struktur wird freigegeben.
    finalisieren_mpi_struktur();
// Kommentar: Die Flags ist_empfangen - ob eine Nachricht angekommen ist - werden freigegeben.
    delete ist_empfangen;

// Kommentar: Die Markierungsfelder werden in der Klasse Zyklus Rechnen angelegt und freigegeben, so dass das hier nicht mehr
// erfolgen muss.
    }

// Kommentar: Hier wird diese Klasse initialisiert. Es werdn Parameter und die Klasse feld bergeben. Das Feld wird zur Markierung
// bzw. Remarkierung bentigt.
void UebertrageGrobgitterU::initialisierenUGU(int _groesse, int _rang, int _m, int _n, int ** _feld)
    {
// Kommentar: Die bergabeparameter werden gespeichert. Dabei werden auch m_grob und n_grob bestimmt.
    groesse = _groesse;
    rang = _rang;

    cout << " initUGU rang " << rang << " groesse " << groesse << endl;

    m = _m;
    n = _n;

    m_grob = (m+1)>>1;
    n_grob = (n+1)>>1;

// Kommentar: Die Bufferindizes und Kommunikationrequests werden angelegt.
    sende_indizes = new int [groesse];
    empfangs_indizes = new int [groesse];

    sende_request = new MPI_Request[groesse];
    empfangs_request = new MPI_Request[groesse];

// Kommentar: Die hier bentigte MPI - Struktur wird angelegt.
    initialisieren_mpi_struktur();
// Kommentar: Und die Flags werden zur Kontrolle, was empfangen worden ist, angelegt.
    ist_empfangen = new int [groesse];

// Kommentar: Setzt die Sende - Indizes auf 0, und die ist_empfangen_flags auf false.
    reset();

// Kommentar: Der Zeiger auf das zu markierende Feld wird gespeichert.
    feld = _feld;

// Kommentar: Die Markierungsfelder werden in der Klasse Zyklus Rechnen allokiert. Das braucht und darf hier nicht mehr angelegt
// werden.

// Kommentar: Die Markierung wird in der Funktion initialisieren_zyklus_rechnen der Klasse ZyklusRechnen initialisiert.
//    markierung.initialisieren(m, n, feld);
    }

// Kommentar: Hier werden die sende_indizes und die Flags ist_empfangen resettet.
void UebertrageGrobgitterU::reset(void)
    {
// Kommentar: Mache fr alle Farben das eben genannte reset.
    for(i=0; i<groesse; i++)
        {
        sende_indizes[i] = 0;
        ist_empfangen[i] = false;
        }
    }

// Kommentar: Resette die Markierungsfelder fr alle anderen Farben
void UebertrageGrobgitterU::reset_markierungsfelder(void)
    {
// Kommentar: Durchlaufe die Farbwerte aller anderen Kerne, und rufe das Zurcksetzen der Markierungsfelder auf.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            markierungsfelder[i].reset();
            }
        }
    }

// Kommentar: Hier wird die Kommunikation zu den Nachbarn bzgl. der Punktenachbarschaftskerntopologie initiiert, wobei die
// entsprechenden Sende - und Empfangsbuffer bzgl. des Nachbarn verwendet werden.
void UebertrageGrobgitterU::kommunikation_initiieren(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
#ifdef JJIIHH_TEXT
            cout << " JJIIHH komm init rang " << rang << " i " << i << " PT " << PT_grobgitter[i] << endl;
#endif
            if(PT_grobgitter[i]!=0) // vergessen PT bestimmen
                {
                eine_kommunikation_initiieren(i);
                }
            }
        }
    }

// Kommentar: Die Kommunikation zu einem Kerntopologienachbarn wird initiiert.
void UebertrageGrobgitterU::eine_kommunikation_initiieren(int ii)
    {
// Kommentar: Zum Kern ii wird der sendebuffer[ii] verschickt - mit der Anzahl an sende_indizes[ii] vielen Eintrgen.
    MPI_Isend(sendebuffer[ii], sende_indizes[ii], mpi_werte1d, ii, 600, MPI_COMM_WORLD, & (sende_request[ii]));

// Kommentar: Vom Kern ii wird der empfangsbuffer[ii] empfangen - mit einer Anzahl von maximal buffergroesse vielen Eintrgen.
    MPI_Irecv(empfangsbuffer[ii], buffergroesse, mpi_werte1d, ii, 600, MPI_COMM_WORLD, & (empfangs_request[ii]));
    }

// Kommentar: Hier wird getestet, ob alle Nachrichten angekommen sind. Falls ja, dann return true. Falls mindestens eine Nachricht
// noch nicht angekommen ist, dann return(false).
bool UebertrageGrobgitterU::ist_fertig(void)
    {
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            if(PT_grobgitter[i]!=0)
                {
                if(eines_testen(i)==false)
                    {
                    return(false);
                    }
                }
            }
        }
    return(true);
    }

// Kommentar: Hiermit wird getestet, ob zu einer bestimmten Farbe die Kommunikation abgeschlossen ist.
// Bemerkung: Die Flags ist_empfangen ermglichen keine frhere Bearbeitung. Es wird lediglich die Test - Abfrage sowie die
// get_count Abfrage nach einem erfolgreichen Durchlauf bzgl. einer Farbe vermieden.
bool UebertrageGrobgitterU::eines_testen(int ii)
    {
// Kommentar: Test, ob die Nachricht an den Kern ii schon abgeschickt worden ist. Wenn nein, dann return false.
    MPI_Test(& (sende_request[ii]), &flag, & sende_status);
    if(flag==false)
        {
        return(false);
        }

// Kommentar: Falls die Nachricht angekommen ist, und das hier schon einmal danach aufgerufen wurde,
// ist das Flag true, und hier ist nichts mehr zu tun.
    if(ist_empfangen[ii] == true)
        {
        return(true);
        }

// Kommentar: Es wird geprft, ob die Nachricht mittlerweile (seit dem letzten Test) eingetroffen ist.
    MPI_Test(& (empfangs_request[ii]), &flag, & empfangs_status);

// Kommentar: Wenn nein, dann return false - die Nachricht ist noch nicht angekommen.
    if(flag==false)
        {
        return(false);
        }

// Kommentar: Ansonsten speichere die Lnge der Nachricht, und markiere fr die Nachricht, dass fr den Epfang die Kommunikation
// abgeschlossen ist.
    MPI_Get_count(&empfangs_status, mpi_werte1d, &(empfangs_indizes[ii]));
    ist_empfangen[ii] = true;

    return(true);
    }

// Kommentar: Hier wird die Nachricht entpackt.
void UebertrageGrobgitterU::entpacken(void)
    {
// Kommentar: Man durchluft alle Nachbarn bzgl. der Punktnachbarschaftskerntopologie, und ...
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
#ifdef AKTUELLE_WERTE_NEU
            if((rang == 1)&&(i==0))
                {
                cout << " EFG PT_grobgitter " << PT_grobgitter[i] << endl;
                }
#endif
            if(PT_grobgitter[i]!=0)
                {
// Kommentar: ... entpackt fr den jeweils ausgewhlten Kern.
                eines_entpacken(i);
                }
            }
        }
    }

// Kommentar: Hier wird fr einen Kern die angekommene Nachricht entpackt. Dazu gehrt auch die Markierung einer vorhandenen
// Information im Feld.
void UebertrageGrobgitterU::eines_entpacken(int ii)
    {
// Kommentar: Die Anzahl an Eintrgen sowie der entsprechende Buffer zu der Kern ID werden gemerkt.
    laenge = empfangs_indizes[ii];
    ein_empfangsbuffer = empfangsbuffer[ii];

// Kommentar: Der Buffer wird durchlaufen.
    for(j=0; j<laenge; j++)
        {
// Kommentar: Die Koordinaten werden aus dem Buffer abgelesen, und gespeichert.
        f = ein_empfangsbuffer[j].f;
        g = ein_empfangsbuffer[j].g;
#ifdef AKTUELLE_WERTE
        if((f==1)&&(g>=1)&&(g<=3))
            {
            cout << " KKJJII eines_entpacken vorher f " << f << " g " << g << " rang " << rang << " ii " << ii << " laenge " << laenge << " feld " << feld[f][g] << endl;
            }
#endif

// Kommentar: Gibt es schon einen Eintrag oder eine Markierung in dem Feld, dann nichts tun.
        if(feld[f][g]>=0)
            {
#ifdef AKTUELLE_WERTE
            cout << " JJIIHH Feld auf vorhandenem Wert eingefgt rang " << rang << " f " << f << " g " << g;
            cout << " bisheriger Wert " << u0_grob[f][g] << " neuer Wert " << ein_empfangsbuffer[j].wert1 <<  " feld " << feld[f][g] << endl;
#endif
            continue;
            }

// Kommentar: ansonsten schreibe den bermittelten Wert auf die Koordinaten des Punktes.
        u0_grob[f][g] = ein_empfangsbuffer[j].wert1;
// Kommentar: Und nehme eine Markierung fr diesen Punkt vor.
        markierung.setzen(f, g);
        }
    }

// Kommentar: Hier wird das Feld ausgegeben. Da kann man - neben den Eintrgen, die aufgrund der Existenz von Gitterpunkten auf
// dem Kern sowieso schon da sind, auch die Markierungen sehen.

void UebertrageGrobgitterU::feld_ausgeben(char * text)
    {
    cout << " Feld - ausgeben " << text << endl;
    for(i=0; i<n_grob; i++)
        {
        for(j=0; j<m_grob; j++)
            {
            cout << feld[i][j] << " ";
            }
        cout << endl;
        }
    cout << endl;
    }
