#ifndef UEBERTRAGE_GROBGITTER_U
#define UEBERTRAGE_GROBGITTER_U

#include <iostream>

using namespace std;

#include "markierung.h"
#include "markierungsfeld.h"
#include <mpi.h>
#include "werte.h"

class UebertrageGrobgitterU
    {
private:
    MPI_Datatype mpi_werte1d;
    MPI_Datatype type[3];
    int blocklen[3];
    MPI_Aint disp[3];
    int base;
protected:
    Werte1d ** sendebuffer;
    Werte1d ** empfangsbuffer;
    Werte1d * ein_sendebuffer;
    Werte1d * ein_empfangsbuffer;
private:
    int * sende_indizes;
protected:
    int * empfangs_indizes;
public:
    int * PT_grobgitter;
public:
    double ** u0_grob;
private:
    MPI_Request * sende_request;
    MPI_Request * empfangs_request;

    MPI_Status sende_status;
    MPI_Status empfangs_status;
private:
    int * ist_empfangen;
private:
    int i, j;
    int laenge;
    int f, g;
private:
public:
    Markierung markierung;
    MarkierungsFeld * markierungsfelder;
private:
    int m, n;
protected:
    int ** feld;
protected:
    void reset(void);
    void kommunikation_initiieren(void);
    bool ist_fertig(void);
    void entpacken(void);
public:
    void initialisierenUGU(int _groesse, int _rang, int _m, int _n, int ** _feld);
    void finalisierenUGU(void);
    void uebertrage(int farbe, int f, int g);
public:
    void finalisieren_mpi_struktur(void);
    void initialisieren_mpi_struktur(void);
private:
    int buffergroesse;
public:
private:
    MPI_Aint extent;
private:
    int groesse, rang;
private:
    void eine_kommunikation_initiieren(int ii);
    bool eines_testen(int ii);
    void eines_entpacken(int ii);
private:
    int flag;
private:
    int index;
private:
public:
    void feld_ausgeben(char * text);
private:
    int m_grob, n_grob;
public:
    void reset_markierungsfelder(void);
    };

#endif

// vergessen: PT setzen
