#include "update_pt_schnell.h"

// Kommentar: Hier wird mit Hilfe der Randstruktur 'schnell' bestimmt, zu welchen Kernen eine Punktnachbarschaft existiert.

// Wo wird ist_nachbar auf 0 gesetzt? Sonst: Schnellrand geht schnell.

// Kommentar: Für die Nachbarpunkte wird gesehen, ob sie existieren. Falls ja, dann wird die Kerntopologie dort so gesetzt,
// dass eine Punktverbindung da ist.
void UpdatePTschnell::farbe_einfuegen(int f_s, int g_s)
    {
    ff = farbenfeld[f_s][g_s];
    if(ff>=0)
        {
        ist_nachbar[ff] = 1;
        }
    }

// Kommentar: Beim Initialisiern geht es um eine Gitterebene. Dazu wird die dynamische Randliste, Selbstnachbarn, das Farbenfeld
// und die Zielstruktur ist_nachbar übergeben. Die ersten drei braucht man, um die Struktur ist_nachbarn zu aktualisieren.
void UpdatePTschnell::initialisieren(FeldListe * _dynamischer_rand, int ** _selbstnachbarn, short int ** _farbenfeld, int * _ist_nachbar)
    {
    dynamischer_rand = _dynamischer_rand;
    selbstnachbarn = _selbstnachbarn;
    farbenfeld = _farbenfeld;
    ist_nachbar = _ist_nachbar;
    }

// Kommentar: Hier geschieht der Update der Struktur ist_nachbarn - für die Kerntopologie, ohne dass die Randstrukturen berechnet
// sein müssen.
// Bemerkung: Die Struktur ist_nachbarn muss mit 0 - Einträgen belegt sein.
void UpdatePTschnell::tun(void)
    {
// Kommentar: Der dynamische Rand wird durchlaufen. Nur für Randpunkte geschieht das hier.
    for(dynamischer_rand->anfangsposition(); dynamischer_rand->ist_fertig_fl()==false; dynamischer_rand->naechster())
        {
        f = dynamischer_rand->lesen_f();
        g = dynamischer_rand->lesen_g();

// Kommentar: Es werden die Nachbarpunkte, die nicht auf dem eigenen Kern sind, durchgegangen.
        switch(255 - selbstnachbarn[f][g])
            {

                case 0:
                    break;
// Kommentar: Und dann wird für diese Nachbarpunkte auf Nachbarschaft zu einem anderen Kern geprüft, was dann in ist_nachbarn
// gespeichert wird.
                case 1:
                    farbe_einfuegen_nord;
                    break;
                case 2:
                    farbe_einfuegen_nordost;
                    break;
                case 3:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    break;
                case 4:
                    farbe_einfuegen_ost;
                    break;
                case 5:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    break;
                case 6:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    break;
                case 7:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    break;
                case 8:
                    farbe_einfuegen_suedost;
                    break;
                case 9:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    break;
                case 10:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    break;
                case 11:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    break;
                case 12:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    break;
                case 13:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    break;
                case 14:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    break;
                case 15:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    break;
                case 16:
                    farbe_einfuegen_sued;
                    break;
                case 17:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;

                    break;
                case 18:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    break;
                case 19:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    break;
                case 20:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    break;
                case 21:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    break;
                case 22:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    break;
                case 23:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;

                    farbe_einfuegen_sued;

                    break;
                case 24:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 25:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 26:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 27:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 28:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    break;
                case 29:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 30:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 31:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    break;
                case 32:
                    farbe_einfuegen_suedwest;
                    break;
                case 33:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedwest;
                    break;
                case 34:
                    farbe_einfuegen_nordost;

                    farbe_einfuegen_suedwest;
                    break;
                case 35:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedwest;
                    break;
                case 36:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    break;
                case 37:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    break;
                case 38:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    break;
                case 39:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    break;
                case 40:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 41:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 42:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 43:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 44:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 45:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 46:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 47:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    break;
                case 48:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    break;
                case 49:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 50:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 51:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 52:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 53:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 54:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 55:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 56:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 57:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 58:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 59:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 60:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    break;
                case 61:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 62:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;
                case 63:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    break;

                case 64:
                    farbe_einfuegen_west;
                    break;

                case 65:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_west;
                    break;
                case 66:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_west;
                    break;
                case 67:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_west;
                    break;
                case 68:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    break;
                case 69:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    break;
                case 70:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    break;
                case 71:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    break;
                case 72:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 73:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 74:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 75:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 76:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 77:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 78:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 79:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    break;
                case 80:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    break;
                case 81:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 82:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 83:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 84:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 85:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 86:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 87:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;

                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 88:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 89:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 90:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 91:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 92:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    break;
                case 93:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 94:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 95:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    break;
                case 96:
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;

                case 97:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 98:
                    farbe_einfuegen_nordost;

                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 99:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 100:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 101:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 102:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 103:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 104:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 105:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 106:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 107:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 108:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 109:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 110:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 111:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 112:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 113:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 114:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 115:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 116:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 117:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 118:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 119:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 120:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 121:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 122:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 123:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 124:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    break;
                case 125:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 126:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;
                case 127:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    break;

                case 128:
                    farbe_einfuegen_nordwest;
                    break;
                case 129:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordwest; break;
                case 130:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_nordwest; break;
                case 131:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_nordwest; break;
                case 132:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_nordwest; break;
                case 133:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_nordwest; break;
                case 134:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_nordwest; break;
                case 135:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_nordwest; break;
                case 136:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 137:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 138:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 139:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 140:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 141:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 142:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 143:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_nordwest; break;
                case 144:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_nordwest; break;
                case 145:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 146:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 147:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 148:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 149:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 150:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 151:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;

                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 152:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 153:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 154:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 155:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 156:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_nordwest; break;
                case 157:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 158:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 159:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_nordwest; break;
                case 160:
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 161:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 162:
                    farbe_einfuegen_nordost;

                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 163:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 164:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 165:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 166:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 167:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 168:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 169:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 170:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 171:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 172:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 173:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 174:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 175:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 176:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 177:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 178:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 179:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 180:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 181:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 182:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 183:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 184:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 185:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 186:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 187:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 188:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_nordwest; break;
                case 189:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 190:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;
                case 191:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_nordwest; break;

                case 192:
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest;
                    break;

                case 193:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 194:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 195:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 196:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 197:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 198:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 199:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 200:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 201:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 202:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 203:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 204:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 205:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 206:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 207:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 208:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 209:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 210:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 211:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 212:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 213:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 214:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 215:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;

                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 216:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 217:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 218:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 219:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 220:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest;
                    break;
                case 221:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest;
                    break;
                case 222:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest;
                    break;
                case 223:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 224:
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;

                case 225:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 226:
                    farbe_einfuegen_nordost;

                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 227:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 228:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 229:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 230:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 231:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 232:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 233:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 234:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 235:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 236:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 237:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 238:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 239:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 240:
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 241:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 242:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 243:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 244:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 245:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 246:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 247:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 248:
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 249:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 250:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 251:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 252:
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;
                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 253:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 254:
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
                case 255:
                    farbe_einfuegen_nord;
                    farbe_einfuegen_nordost;
                    farbe_einfuegen_ost;
                    farbe_einfuegen_suedost;
                    farbe_einfuegen_sued;
                    farbe_einfuegen_suedwest;

                    farbe_einfuegen_west;
                    farbe_einfuegen_nordwest; break;
            }
        }
    }
