#ifndef WERTE_SAMMELN
#define WERTE_SAMMELN

#include <mpi.h>
#include <iostream>

using namespace std;

#include "paralleles_rechnen.h"
#include "datei_ausgabe.h"

class WerteSammeln
    {
protected:
    double ** ausgabe_werte;
private:
    ParallelesRechnen * paralleles_rechnen;
    void packen(int ebene);
// Die Kommunikationsbuffer
protected:
    short int ** fg_buffer_empfangen; // rang = 0
    short int * fg_buffer_senden; // rang != 0
    double ** werte_buffer_empfangen; // rang = 0
    double * werte_buffer_senden; // rang != 0
protected:
    int n, m;
    int * n_h, * m_h, n_hh, m_hh;
    int groesse, rang;
    int h_gesamt;
protected:
    double *** u0, *** e0, *** r0, *** rS0, *** Iu0;
protected:
    double ** werte_matrix;
    bool ** punkte_indikator_matrix; // true - false - Matrix
public:
    void initialisieren_werte_sammeln(int _n, int _m, int _h_gesamt, int _groesse, int _rang, ParallelesRechnen * _paralleles_rechenen, char * _auswertung_dateiname);
    void finalisieren_werte_sammeln(void);
    void tun(void);
private:
    void tun_ein_kern(void);
    void tun_mehrere_kerne(void);
private:
protected:
    DateiAusgabe datei_ausgabe;
private:
    int buffergroesse, buffergroesse_doppelt;
private:
    void buffer_anlegen_senden(void);
    void buffer_anlegen_empfangen(void);
    void matrizen_anlegen(void);

    void buffer_befreien_senden(void);
    void buffer_befreien_empfangen(void);
    void matrizen_befreien(void);
private:
protected:
    int i, j;
protected:
    bool punkte_indikator_matrix_schreiben;
private:
    ParallelesRechnen * paralleles_rechnen_ebene;
    int f, g;
    int bufferindex_koordinaten;
    int bufferindex_werte;
private:
    MPI_Status status_senden;
    MPI_Status status_empfangen;
    int flag_senden;
    bool test_auf_beenden_senden(void);
private:
    bool * fg_empfangen_flags, * werte_empfangen_flags;
    MPI_Request * fg_requests_empfangen;
    MPI_Request * werte_requests_empfangen;
    MPI_Request fg_sende_request;
    MPI_Request werte_sende_request;
// Initialisieren / Finalisieren zu diesen Variablen
    void flags_anlegen(void);
    void flags_befreien(void);
    void requests_anlegen(void);
    void requests_befreien(void);
private:
    int * bufferlaengen, laenge;
    short int * fg_buffer;
    double * werte_buffer;
private:
protected:
    int ebene;
private:
    int flag;
    void flags_reset(void);
    void kommunikation_empfangen_initiieren(void);
    bool test_auf_beenden_empfangen(void);
    void flags_aendern_und_schreiben(void);
    void kommunikation_senden_initiieren(void);
    void entpacken(int _kern_ID);
    int kernID;
    void entpacken_beides(void);
    void entpacken_eines(void);
    void tun_eigenes_beides(void);
    void tun_eigenes_eines(void);
    void matrizen_reset(void);
    void matrix_reset(void);
private:
    char * auswertung_dateiname;
protected:
    int t, t_v;
protected:
    void tun_kappe(void);
    };

#endif
