#include "werte_verschicken.h"

// Kommentar: Mit dieser Klasse werden die Werte beim Lastausgleich verschickt. Zustndig dafr sind die Funktionen packen und
// entpacken, sowie im Nord - Sd - Fall packen_ns und entpacken_ns. Da die Funktionen mit dem Suffix '_ns' (Nord - Sd)
// analog zu denen ohne Suffix funktionieren, werden diese Funktionen nicht kommentiert.
// Kommentar: Werte verschicken dient nur dem Packen der Variablenwerte in den Buffer, bzw. dem Entpacken der Variablenwerte aus
// dem Buffer. Die Kommunikation der Buffer bernimmt die Klasse LAKommunikationen. Beide Klassen werden durch die Klasse
// Lastausgleich aufgerufen, in der die Migration durchgefhrt wird.

// Kommentar: Mit dieser Funktion wird das Packen mit allen Mglichkeiten dafr umgesetzt. Dabei werden verschiedene Routinen von
// packen_eines aufgerufen - mit einer Fallunterscheidung.
void WerteVerschicken::packen(MV_vertikal * mv, WerteBuffer * werte_buffer)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2030" << endl;
#endif

// Kommentar: Zuerst werden alle Gitterebenen durchlaufen.
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2031 i " << i << endl;
#endif

// Dann werden die Vekorenlisten der ausgewhlten Gitterebene hierhin kopiert.
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2032 " << endl;
#endif

// Kommentar: Die Vektorenanzahl wird auch abgespeichert.
        index = mv->indizes[i];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2033" << endl;
#endif

// Kommentar: Ab hier werden die Variablenwerte diser konkreten Gitterebene in x0_h und ggf. weiteren Variablen x1_h, x2_h usw.
// gespeichert. Hier wird eine umfangreiche Fallunterscheidung getroffen.
#ifndef SHALLOW_WATER_EQUATIONS
        #ifdef dimensionen1
// Kommentar: Im Fall der Poissongleichung wird die Variable x0[i] gespeichert - unter x0_h.
        x0_h = x0[i];
//        x1_h = x1[i];
        #endif
        #ifdef dimensionen2
        x0_h = x0[i];
        x1_h = x1[i];
        #endif
        #ifdef dimensionen3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        #endif
        #ifdef dimensionen4
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        x3_h = x3[i];
        #endif
#else
// Kommentar: Das ist der Fall meiner Abnderung der Implementierung von Herrn Hess der SWE. Dabei werden entweder 3 oder 5 Variablen bertragen.
// Das hier wird bei Herrn Hess beim Lastausgleich gemacht, 9.12.14. Jeweils entweder 3 oder 5 Variablen bertragen.

// Kommentar: NUR_3 ist nicht definiert.
    #ifdef NUR_3
// Kommentar: Diese Speicherung der Variablen, wenn nur 3 Variablen bertragen werden.
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
    #else

        #ifdef ERST_LA
// Kommentar: Oder 5 Variablen, wenn ERST_LA definiert ist.
            x0_h = x0[i];
            x1_h = x1[i];
            x2_h = x2[i];
            x3_h = x3[i];
            x4_h = x4[i];
        #else
        #endif
    #endif
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2034" << endl;
#endif

// Kommentar: Buffer und Bufferindex werden geladen, wobei der bufferindex am Ende der Behandlung dieser Ebene wieder geschrieben
// wird.
        buffer = werte_buffer -> buffer;
        bufferindex = werte_buffer -> index;
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035 // bufferindex " << bufferindex << endl;
#endif

// Kommentar: Packen im Fall der Poisson - Gleichung:
#ifndef SHALLOW_WATER_EQUATIONS
// Kommentar: Im Folgenden ist zu unterscheiden, ob packen_eines oder packen_eines_mit_Iu0 aufgerufen wird.
// Beim adaptiven Fall, bzw. beim FAS wird Iu0 auf dem grberen Gitter mitbestimmt, d.h. fr h_min > gitterebene > 0.
// Auf der Ebene h_min = gitterebene wurde im Fall von ist_zusammen_aV_LA = false Iu0 ausgewertet, bevor der
// Lastausgleich erfolgt, d.h. hier muss Iu0 nicht mit bertragen werden. Bei ist_zusammen_aV_LA = true hingegen
// wurde Iu0 noch nicht vor dem Lastausgleich verwendet, und es muss der Wert daher mit bertragen werden.
// Fr die feineren Gitter wurde es aber in beiden Fllen nicht ausgewertet, muss also daher mit bertragen werden.
// Nur nicht fr die Gitterebene 0, weil dort kein Iu0 existiert.
        if(ist_zusammen_aV_LA==false)
            {
//            if((h_min > gitterebene)&&(gitterebene > 0))
            if((h_min > i)&&(i > 0))
                {
                packen_eines_mit_Iu0();
                }
            else
                {
                packen_eines();
                }
            }
        else
            {
//            if((h_min >= gitterebene)&&(gitterebene > 0))
            if((h_min >= i)&&(i > 0))
                {
                packen_eines_mit_Iu0();
                }
            else
                {
                packen_eines();
                }
            }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2036" << endl;
#endif
#else
// Kommentar: Ausfhren der Operatoren der von mir vernderten Version der Implementation von Herrn Hess der Shallow Water Equations.
// Kommentar: Wenn NUR_3, dann immer 3 Variablen packen.
// Kommentar: NUR_3 ist nicht definiert.
    #ifdef NUR_3
        packen_eines_swe_3();
    #else
// Kommentar: Ansonsten: Ist ERST_LA definiert, dann immer 5 Variablen packen.
        #ifdef ERST_LA
            packen_eines_swe_5();
        #else
        #endif
    #endif
#endif
// Kommentar: Am Ende wird, fr weiteres Packen, der bufferindex in den werte_buffer - Index zurckgeschrieben.
        werte_buffer -> index = bufferindex;
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2039" << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
    }

// Kommentar: Hier wird fr eine Variable gepackt.
void WerteVerschicken::packen_eines(void)
    {
// Kommentar: Die Vektoren werden durchlaufen.
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif

// Kommentar: Die Koordinaten des jeweiligen Vektors werden gespeichert.
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
// Kommentar: Die Koordinaten der Gitterpunkte werden durchlaufen.
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
            #ifdef dimensionen1
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex << endl;
            #endif
            #ifdef dimensionen2
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex;
            cout << " x1_h[][] " << x1_h[k][g_merken] << endl;
            #endif
#endif
            #ifdef dimensionen1

// Kommentar: Und es wird die Variable auf dem Punkt gelesen, und der Wert wird in den Buffer geschrieben. Der Bufferindex wird
// danach inkrementiert.
            buffer[bufferindex++] = x0_h[k][g_merken];
            #endif
            #ifdef dimensionen2
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            #endif
            #ifdef dimensionen3
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            buffer[bufferindex++] = x2_h[k][g_merken];
            #endif
            #ifdef dimensionen4
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            buffer[bufferindex++] = x2_h[k][g_merken];
            buffer[bufferindex++] = x3_h[k][g_merken];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Mit dieser Funktion wird das Entpacken mit allen Mglichkeiten dafr umgesetzt. Dabei werden verschiedene Routinen von
// entpacken_eines aufgerufen - mit einer Fallunterscheidung.
// Bemerkung: Diese Funktion ist analog zu packen geschrieben, nur dass am Ende statt den packen_eines - Varianten die
// entsprechenden entpacken_eines Varianten aufgerufen werden. Und die Auswahl der Variante 1 zu 1. Deshalb
// wird nur der Teil von entpacken kommentiert, der unterschiedlich ist.
void WerteVerschicken::entpacken(WerteBuffer * werte_buffer, MV_vertikal * mv)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Entpacken ";
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2060" << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2061" << endl;
#endif
        if(rang==1)
            {
            cout << " XXYYZZ WV Ebene " << i << endl;
            }
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " i " << i;
#endif

        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2062" << endl;
#endif
        index = mv->indizes[i];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2063" << endl;
#endif
    #ifndef SHALLOW_WATER_EQUATIONS
        #ifdef dimensionen1
        x0_h = x0[i];
        x1_h = x1[i];
        if(i>0)
            {
            u0_unten_h = u0_unten[i];
            }
        #endif
        #ifdef dimensionen2
        x0_h = x0[i];
        x1_h = x1[i];
        #endif
        #ifdef dimensionen3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        #endif
        #ifdef dimensionen4
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        x3_h = x3[i];
        #endif
    #else
// Kommentar: NUR_3 ist nicht definiert.
    #ifdef NUR_3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
    #else

        #ifdef ERST_LA
            x0_h = x0[i];
            x1_h = x1[i];
            x2_h = x2[i];
            x3_h = x3[i];
            x4_h = x4[i];
        #else
        #endif
        #endif
    #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2064" << endl;
#endif
        buffer = werte_buffer -> buffer;
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2065" << endl;
#endif
        bufferindex = werte_buffer -> index;
#ifdef AKTUELLE_KOMMENTARE
        cout << " wb l " << werte_buffer -> index;
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2066" << endl;
#endif

// Kommentar: Entpacken im Fall der Poisson - Gleichung:
#ifndef SHALLOW_WATER_EQUATIONS
// Kommentar: Im Folgenden ist zu unterscheiden, ob entpacken_eines oder entpacken_eines_mit_Iu0 aufgerufen wird.
// Beim adaptiven Fall, bzw. beim FAS wird Iu0 auf dem grberen Gitter mitbestimmt, d.h. fr h_min > gitterebene > 0.
// Auf der Ebene h_min = gitterebene wurde im Fall von ist_zusammen_aV_LA = false Iu0 ausgewertet, bevor der
// Lastausgleich erfolgt, d.h. hier muss Iu0 nicht mit bertragen werden. Bei ist_zusammen_aV_LA = true hingegen
// wurde Iu0 noch nicht vor dem Lastausgleich verwendet, und es muss der Wert daher mit bertragen werden.
// Fr die feineren Gitter wurde es aber in beiden Fllen nicht ausgewertet, muss also daher mit bertragen werden.
// Nur nicht fr die Gitterebene 0, weil dort kein Iu0 existiert.
        if(ist_zusammen_aV_LA == false)
            {
//            if((h_min > gitterebene)&&(gitterebene > 0))
            if((h_min > i)&&(i > 0))
                {
                entpacken_eines_mit_Iu0();
                }
            else
                {
                entpacken_eines();
                }
            }
        else
            {
//            if((h_min >= gitterebene)&&(gitterebene > 0))
            if((h_min >= i)&&(i > 0))
                {
                entpacken_eines_mit_Iu0();
                }
            else
                {
                entpacken_eines();
                }
            }
#else

// Kommentar: Ausfhren der Operatoren der von mir vernderten Version der Implementation von Herrn Hess der Shallow Water Equations.
// Kommentar: Wenn NUR_3, dann immer 3 Variablen entpacken.
    #ifdef NUR_3
        entpacken_eines_swe_3();
    #else
// Kommentar: Ansonsten: Ist ERST_LA definiert, dann immer 5 Variablen entpacken.
        #ifdef ERST_LA
            entpacken_eines_swe_5();
        #else
        #endif
    #endif
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2067" << endl;
#endif
        werte_buffer -> index = bufferindex;
#ifdef AKTUELLE_KOMMENTARE
        cout << " wb s " << werte_buffer -> index;
#endif
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
    }

// Kommentar: Hier wird fr eine Variable entpackt.
void WerteVerschicken::entpacken_eines(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif

// Kommentar: Die Vektoren werden durchlaufen.
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif

// Kommentar: Die Koordinaten des jeweiligen Vektors werden gespeichert.
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f1 " << f1_merken << " f2 " << f2_merken << " g " << g_merken << endl;
#endif
#endif

// Kommentar: Die Koordinaten der Gitterpunkte werden durchlaufen.
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d rang " << rang << " entpacken wo ohne bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif
            #ifdef dimensionen1

// Kommentar: Und es wird die Variable auf dem Punkt geschrieben, und der Wert wird aus dem Buffer gelesen. Der Bufferindex wird
// danach inkrementiert.
            x0_h[k][g_merken] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen2
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen3
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            x2_h[k][g_merken] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen4
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            x2_h[k][g_merken] = buffer[bufferindex++];
            x3_h[k][g_merken] = buffer[bufferindex++];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

// Kommentar: WerteVerschicken wird finalisiert.
void WerteVerschicken::finalisieren(void)
    {
// Kommentar: Die Zeiger auf die Variablen der Gitterebenen werden freigegeben.
#ifndef SHALLOW_WATER_EQUATIONS
    #ifdef dimensionen1
    delete x0;
    delete x1;
    delete u0_unten;
    #endif
    #ifdef dimensionen2
    delete x0;
    delete x1;
    #endif
    #ifdef dimensionen3
    delete x0;
    delete x1;
    delete x2;
    #endif
    #ifdef dimensionen4
    delete x0;
    delete x1;
    delete x2;
    delete x3;
    #endif
#endif
#ifdef SHALLOW_WATER_EQUATIONS
    delete x0;
    delete x1;
    delete x2;
    delete x3;
    delete x4;
    delete x5;
    delete x6;
#endif
    }

// Kommentar: Die Klasse WerteVerschicken wird initialisiert. Wichtige Parameter werden bergeben, und Speicherplatz fr die
// Variablen - Zeiger bereitgestellt.
void WerteVerschicken::initialisieren(int _h_gesamt, int n, int m, int _rang, int _h_min, bool _ist_zusammen_aV_LA)
    {
// Kommentar: Die Gitterebenenanzahl wird gespeichert.
    h_gesamt = _h_gesamt;
    h_min = _h_min;
// Kommentar: Dann wird - je nachdem wie die Prprozessorvariablen dimensionen1 ... dimensionen4, bzw. SHALLOW_WATER_EQUATIONS, definiert sind,
// wird Speicherplatz angelegt fr die Variablen aller Gitterebenen.
#ifndef SHALLOW_WATER_EQUATIONS
    #ifdef dimensionen1
    x0 = new double ** [h_gesamt];
    x1 = new double ** [h_gesamt];
    u0_unten = new double ** [h_gesamt];
    #endif
    #ifdef dimensionen2
    x0 = new double ** [h_gesamt];
    x1 = new double ** [h_gesamt];
    #endif
    #ifdef dimensionen3
    x0 = new double ** [h_gesamt];
    x1 = new double ** [h_gesamt];
    x2 = new double ** [h_gesamt];
    #endif
    #ifdef dimensionen4
    x0 = new double ** [h_gesamt];
    x1 = new double ** [h_gesamt];
    x2 = new double ** [h_gesamt];
    x3 = new double ** [h_gesamt];
    #endif
#endif
#ifdef SHALLOW_WATER_EQUATIONS
    x0 = new double ** [h_gesamt];
    x1 = new double ** [h_gesamt];
    x2 = new double ** [h_gesamt];
    x3 = new double ** [h_gesamt];
    x4 = new double ** [h_gesamt];
    x5 = new double ** [h_gesamt];
    x6 = new double ** [h_gesamt];
#endif

#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "WV-Bufferlaenge " << m*n << endl;
#endif

// Die Parameter rang, und ist_zusammen_aV_LA werden gespeichert.
    rang = _rang;
    ist_zusammen_aV_LA = _ist_zusammen_aV_LA;
    }

//////////////////////////////////////////////////////////////
///////// Nord Sued //////////////////////////////////////////
//////////////////////////////////////////////////////////////

// Kommentar: Diese Funktion ist analog zu packen, und wird daher nicht kommentiert.

void WerteVerschicken::packen_ns(MV_horizontal * mv, WerteBuffer * werte_buffer)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Packen_ns ";
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2030" << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2031 i " << i << endl;
#endif
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        f = mv->f_speichern[i];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2032 " << endl;
#endif
        index = mv->indizes[i];
#ifdef AKTUELLE_KOMMENTARE
        cout << " i " << i << " Index " << index << " ";
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2033" << endl;
#endif
#ifndef SHALLOW_WATER_EQUATIONS
        #ifdef dimensionen1
        x0_h = x0[i];
        x1_h = x1[i];
        #endif
        #ifdef dimensionen2
        x0_h = x0[i];
        x1_h = x1[i];
        #endif
        #ifdef dimensionen3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        #endif
        #ifdef dimensionen4
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        x3_h = x3[i];
        #endif
#else
// Kommentar: NUR_3 ist nicht definiert.
    #ifdef NUR_3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
    #else

        #ifdef ERST_LA
            x0_h = x0[i];
            x1_h = x1[i];
            x2_h = x2[i];
            x3_h = x3[i];
            x4_h = x4[i];
        #else
        #endif
    #endif
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2034" << endl;
#endif
        buffer = werte_buffer -> buffer;
        bufferindex = werte_buffer -> index;
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035 // bufferindex " << bufferindex << endl;
#endif
#ifndef SHALLOW_WATER_EQUATIONS
        if(ist_zusammen_aV_LA==false)
            {
//            if((h_min > gitterebene)&&(gitterebene > 0))
            if((h_min > i)&&(i > 0))
                {
                packen_eines_ns_mit_Iu0();
                }
            else
                {
                packen_eines_ns();
                }
            }
        else
            {
//            if((h_min >= gitterebene)&&(gitterebene > 0))
            if((h_min >= i)&&(i > 0))
                {
                packen_eines_ns_mit_Iu0();
                }
            else
                {
                packen_eines_ns();
                }
            }
#else
// Kommentar: NUR_3 ist nicht definiert.
// Kommentar: Ausfhren der Operatoren der von mir vernderten Version der Implementation von Herrn Hess der Shallow Water Equations.
    #ifdef NUR_3
        packen_eines_swe_3_ns();
    #else
        #ifdef ERST_LA
            packen_eines_swe_5_ns();
        #else
        #endif
    #endif
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2036" << endl;
#endif
        werte_buffer -> index = bufferindex;
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2039" << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu packen_eines_ns, und wird daher nicht kommentiert.
void WerteVerschicken::packen_eines_ns(void)
    {
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << " ";
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
            #ifdef dimensionen1
#ifdef AKTUELLE_KOMMENTARE
            cout << "x0_h[f_merken][k]" << x0_h[f_merken][k] << " bufferindex " << bufferindex << endl;
            cout << " (I=" << bufferindex-1 << ",W=" << x0_h[f_merken][k] << "," << f_merken << "," << k << ")";
#endif
            #endif
            #ifdef dimensionen2
            cout << "x0_h[f_merken][k]" << x0_h[f_merken][k] << " bufferindex " << bufferindex;
            cout << " x1_h[][] " << x1_h[f_merken][k] << endl;
            #endif
#endif
            #ifdef dimensionen1
            buffer[bufferindex++] = x0_h[f_merken][k];
#ifdef AKTUELLE_KOMMENTARE
            cout << " (I=" << bufferindex-1 << ",W=" << x0_h[f_merken][k] << "," << f_merken << "," << k << ")";
#endif
            #endif
            #ifdef dimensionen2
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            #endif
            #ifdef dimensionen3
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            buffer[bufferindex++] = x2_h[f_merken][k];
            #endif
            #ifdef dimensionen4
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            buffer[bufferindex++] = x2_h[f_merken][k];
            buffer[bufferindex++] = x3_h[f_merken][k];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu entpacken, und wird daher nicht kommentiert.
void WerteVerschicken::entpacken_ns(WerteBuffer * werte_buffer, MV_horizontal * mv)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Entpacken_ns ";
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2060" << endl;
#endif
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2061" << endl;
#endif
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        f = mv->f_speichern[i];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2062" << endl;
#endif
        index = mv->indizes[i];
#ifdef AKTUELLE_KOMMENTARE
        cout << " i " << i << " Index " << index << " ";
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2063" << endl;
#endif
#ifndef SHALLOW_WATER_EQUATIONS
        #ifdef dimensionen1
        x0_h = x0[i];
        x1_h = x1[i];
        if(i>0)
            {
            u0_unten_h = u0_unten[i];
            }
        #endif
        #ifdef dimensionen2
        x0_h = x0[i];
        x1_h = x1[i];
        #endif
        #ifdef dimensionen3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        #endif
        #ifdef dimensionen4
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
        x3_h = x3[i];
        #endif
#else
// Kommentar: NUR_3 ist nicht definiert.
    #ifdef NUR_3
        x0_h = x0[i];
        x1_h = x1[i];
        x2_h = x2[i];
    #else

        #ifdef ERST_LA
            x0_h = x0[i];
            x1_h = x1[i];
            x2_h = x2[i];
            x3_h = x3[i];
            x4_h = x4[i];
        #else
        #endif
    #endif
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2064" << endl;
#endif
        buffer = werte_buffer -> buffer;
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2065" << endl;
#endif
        bufferindex = werte_buffer -> index;
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2066" << endl;
#endif
#ifndef SHALLOW_WATER_EQUATIONS
        if(ist_zusammen_aV_LA == false)
            {
//            if((h_min > gitterebene)&&(gitterebene > 0))
            if((h_min > i)&&(i > 0))
                {
                entpacken_eines_ns_mit_Iu0();
                }
            else
                {
                entpacken_eines_ns();
                }
            }
        else
            {
//            if((h_min >= gitterebene)&&(gitterebene > 0))
            if((h_min >= i)&&(i > 0))
                {
                entpacken_eines_ns_mit_Iu0();
                }
            else
                {
                entpacken_eines_ns();
                }
            }
#else
// Kommentar: NUR_3 ist nicht definiert.
// Kommentar: Ausfhren der Operatoren der von mir vernderten Version der Implementation von Herrn Hess der Shallow Water Equations.
    #ifdef NUR_3
        entpacken_eines_swe_3_ns();
    #else
        #ifdef ERST_LA
            entpacken_eines_swe_5_ns();
        #else
        #endif
    #endif
#endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2067" << endl;
#endif
        werte_buffer -> index = bufferindex;
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu entpacken_eines, und wird daher nicht kommentiert.
void WerteVerschicken::entpacken_eines_ns(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << " ";
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d rang " << rang << " entpacken ns ohne bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif
            #ifdef dimensionen1
            x0_h[f_merken][k] = buffer[bufferindex++];
#ifdef AKTUELLE_KOMMENTARE
            cout << " (I=" << bufferindex-1 << ",W=" << x0_h[f_merken][k] << "," << f_merken << "," << k << ")";
#endif
            #endif
            #ifdef dimensionen2
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen3
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            x2_h[f_merken][k] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen4
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            x2_h[f_merken][k] = buffer[bufferindex++];
            x3_h[f_merken][k] = buffer[bufferindex++];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

// Kommentar: Hier wird fr eine Variable gepackt. Urspnglich sollte auch noch fr Iu0 gepackt werden, aber dazu
// weiter unten.
// Bemerkung: Die Kommentare sind analog zu packen_eines, bis auf die Zeilen, wo in den Buffer geschrieben wird.
// Das wird deswegen nochmal kommentiert.
void WerteVerschicken::packen_eines_mit_Iu0(void)
    {
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
            #ifdef dimensionen1
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex << endl;
            #endif
            #ifdef dimensionen2
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex;
            cout << " x1_h[][] " << x1_h[k][g_merken] << endl;
            #endif
#endif
            #ifdef dimensionen1
// Kommentar: Zuerst wird die Variablen x0_h an der Stelle des Punktes in den Buffer geschrieben, nebst Inkrementierung des
// Bufferindexes bufferindex.
            buffer[bufferindex++] = x0_h[k][g_merken];
            #endif
            #ifdef dimensionen2
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            #endif
            #ifdef dimensionen3
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            buffer[bufferindex++] = x2_h[k][g_merken];
            #endif
            #ifdef dimensionen4
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            buffer[bufferindex++] = x2_h[k][g_merken];
            buffer[bufferindex++] = x3_h[k][g_merken];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
//            bufferindex ++;
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Analog zu entpacken_eines, nur, dass man die Variable Iu0 auch bentigt. Ursprnglich wurde sie mitbertragen.
// Hier wurde eine andere Lsung gefunden.
// Kommentar: Nur die nderung zu entpacken_eines wird hier kommentiert. Der Rest sei analog zu entpacken_eines kommentiert.
void WerteVerschicken::entpacken_eines_mit_Iu0(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f1 " << f1_merken << " f2 " << f2_merken << " g " << g_merken << endl;
#endif
#endif
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d rang " << rang << " entpacken wo mit bufferindex " << bufferindex;
            cout << " k " << k << " g_merken " << g_merken << endl;
            cout << " rang " << rang << " buffer[bufferindex] " << buffer[bufferindex] << endl;
            cout << " rang " << rang << " u0_unten_h " << u0_unten_h[k<<1][g_merken<<1] << endl;
#endif
            #ifdef dimensionen1
// Kommentar: Diese Zeile ist genauso wie in entpacken_eines.
            x0_h[k][g_merken] = buffer[bufferindex++];
// Kommentar: Hier die Lsung: Iu0 ist eine Injektion. Da der u0 - Wert von unten mitverschickt wurde, kann Iu0 einfach
// abgelesen werden. Deswegen braucht Iu0 nicht mit bertragen zu werden. Wichtig noch: Es wird von fein nach grob entpackt,
// so dass die Werte der unteren Ebene verfgbar sind.
            x1_h[k][g_merken] = u0_unten_h[k<<1][g_merken<<1]; // Wegen der Injektion, 27.9.14; u0_unten wurde bereits bermittelt.
                                                               // Nur was, wenn unten(k, g_merken) nicht existiert.
            #endif
            #ifdef dimensionen2
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen3
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            x2_h[k][g_merken] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen4
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            x2_h[k][g_merken] = buffer[bufferindex++];
            x3_h[k][g_merken] = buffer[bufferindex++];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

// Kommentar: Diese Funktion ist analog zu packen_eines_mit_Iu0, und wird daher nicht kommentiert.
void WerteVerschicken::packen_eines_ns_mit_Iu0(void)
    {
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
            #ifdef dimensionen1
            cout << "x0_h[f_merken][k]" << x0_h[f_merken][k] << " bufferindex " << bufferindex << endl;
            #endif
            #ifdef dimensionen2
            cout << "x0_h[f_merken][k]" << x0_h[f_merken][k] << " bufferindex " << bufferindex;
            cout << " x1_h[][] " << x1_h[f_merken][k] << endl;
            #endif
#endif
//            buffer[0] = 0;
//            cout << "buffer[0]=0 gesetzt " << endl;
            #ifdef dimensionen1
            buffer[bufferindex++] = x0_h[f_merken][k];
#ifdef ALTER_CODE_WV // 27.9.14
            buffer[bufferindex++] = x1_h[f_merken][k];
#endif
            #endif
            #ifdef dimensionen2
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            #endif
            #ifdef dimensionen3
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            buffer[bufferindex++] = x2_h[f_merken][k];
            #endif
            #ifdef dimensionen4
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            buffer[bufferindex++] = x2_h[f_merken][k];
            buffer[bufferindex++] = x3_h[f_merken][k];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu entpacken_eines_mit_Iu0, und wird daher nicht kommentiert.
void WerteVerschicken::entpacken_eines_ns_mit_Iu0(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << endl;
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d rang " << rang << " entpacken ns mit bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif
            #ifdef dimensionen1
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = u0_unten_h[f_merken<<1][k<<1];
            #endif
            #ifdef dimensionen2
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen3
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            x2_h[f_merken][k] = buffer[bufferindex++];
            #endif
            #ifdef dimensionen4
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            x2_h[f_merken][k] = buffer[bufferindex++];
            x3_h[f_merken][k] = buffer[bufferindex++];
            #endif
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

/****************************************  Schicken im Falle der von mir vernderten Version der Implementierung von Hess der SWE ****************/
/****************************************  Das gilt fr alle folgenden Funktionen.                                                ****************/

#ifdef SHALLOW_WATER_EQUATIONS

// Kommentar: Analog zu packen_eines, nur dass hier 3 Variablen gepackt werden. Hier wird nur der Unterschied
// zu packen_eines kommentiert.
void WerteVerschicken::packen_eines_swe_3(void)
    {
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
            #ifdef dimensionen1
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex << endl;
            #endif
            #ifdef dimensionen2
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex;
            cout << " x1_h[][] " << x1_h[k][g_merken] << endl;
            #endif
#endif
// Kommentar: Die Auskommentierung reicht bis hier. Hier werden nacheinander die Werte der Variablen x0_h, x1_h und x2_h in den
// Buffer geschrieben - mit Inkrementierung des Buffer - Indexes.
            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            buffer[bufferindex++] = x2_h[k][g_merken];

#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Analog packen_eines_swe_3, nur dass hier zustzlich zu den Werten der Variablen x0_h, x1_h und x2_h, auch noch die
// Werte der Variablen x3_h und x4_h in den Buffer gepackt werden - nebst Inkrementierung des Bufferindexes.
void WerteVerschicken::packen_eines_swe_5(void)
    {
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
            #ifdef dimensionen1
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex << endl;
            #endif
            #ifdef dimensionen2
            cout << "x0_h[k][g_merken]" << x0_h[k][g_merken] << " bufferindex " << bufferindex;
            cout << " x1_h[][] " << x1_h[k][g_merken] << endl;
            #endif
#endif

            buffer[bufferindex++] = x0_h[k][g_merken];
            buffer[bufferindex++] = x1_h[k][g_merken];
            buffer[bufferindex++] = x2_h[k][g_merken];
            buffer[bufferindex++] = x3_h[k][g_merken];
            buffer[bufferindex++] = x4_h[k][g_merken];

#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Analog zu entpacken_eines, nur dass zustzlich zu der Variablen x0_h die Variablen x1_h und x2_h geschrieben werden.
// Bemerkung: Hier wird nur der Unterschied zu entpacken_eines kommentiert.
void WerteVerschicken::entpacken_eines_swe_3(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f1 " << f1_merken << " f2 " << f2_merken << " g " << g_merken << endl;
#endif
#endif
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif

// Kommentar: Nur dieses hier wird entpackt: Es geschieht fr alle drei Variablen x0_h, x1_h und x2_h dasselbe:
// Ein Wert wird aus dem Buffer gelesen, und dann in die jeweilige Variable an der Stelle des Punktes geschrieben.
// Dabei wird der Bufferindex inkrementiert.
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            x2_h[k][g_merken] = buffer[bufferindex++];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

// Kommentar: Vllig analog zu entpacken_eines_swe_3, nur dass hier zustzlich zu den Variablen x0_h, x1_h und x2_h
// in die Variablen x3_h und x4_h entpackt wird.
void WerteVerschicken::entpacken_eines_swe_5(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        f1_merken = f1[j];
        f2_merken = f2[j];
        g_merken = g[j];
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f1 " << f1_merken << " f2 " << f2_merken << " g " << g_merken << endl;
#endif
#endif
        for(k=f1_merken; k<=f2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif
            x0_h[k][g_merken] = buffer[bufferindex++];
            x1_h[k][g_merken] = buffer[bufferindex++];
            x2_h[k][g_merken] = buffer[bufferindex++];
            x3_h[k][g_merken] = buffer[bufferindex++];
            x4_h[k][g_merken] = buffer[bufferindex++];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

// Kommentar: Diese Funktion ist analog zu packen_eines_swe_3, und wird daher nicht kommentiert.
void WerteVerschicken::packen_eines_swe_3_ns(void)
    {
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " PEH packen_eines_swe_3_ns rang " << rang << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035b f1_merken " << f1_merken << " f2_merken " << f2_merken << " g_merken " << g_merken << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << " ";
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
#endif
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            buffer[bufferindex++] = x2_h[f_merken][k];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu packen_eines_swe_5, und wird daher nicht kommentiert.
void WerteVerschicken::packen_eines_swe_5_ns(void)
    {
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " PEH packen_eines_swe_5_ns rang " << rang << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "!2035a " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << " f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << " " << endl;
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035c" << endl;
#endif
            buffer[bufferindex++] = x0_h[f_merken][k];
            buffer[bufferindex++] = x1_h[f_merken][k];
            buffer[bufferindex++] = x2_h[f_merken][k];
            buffer[bufferindex++] = x3_h[f_merken][k];
            buffer[bufferindex++] = x4_h[f_merken][k];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "!2035d" << endl;
#endif
//            bufferindex ++;
            }
        }
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "!2035e" << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu entpacken_eines_swe_3, und wird daher nicht kommentiert.
void WerteVerschicken::entpacken_eines_swe_3_ns(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << endl;
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            x2_h[f_merken][k] = buffer[bufferindex++];

#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

// Kommentar: Diese Funktion ist analog zu entpacken_eines_swe_5, und wird daher nicht kommentiert.
void WerteVerschicken::entpacken_eines_swe_5_ns(void)
    {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
    cout << "2066 a " << endl;
#endif
    for(j=0; j<index; j++)
        {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 b " << endl;
#endif
        g1_merken = g1[j];
        g2_merken = g2[j];
        f_merken = f[j];
#ifdef AUSGABEN_WERTE_VERSCHICKEN
        cout << "2066 c f " << f_merken << " g1 " << g1_merken << " g2 " << g2_merken << endl;
#endif
        for(k=g1_merken; k<=g2_merken; k++)
            {
#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 d bufferindex " << bufferindex << endl;
            cout << "buffer[bufferindex] " << buffer[bufferindex] << endl;
#endif
            x0_h[f_merken][k] = buffer[bufferindex++];
            x1_h[f_merken][k] = buffer[bufferindex++];
            x2_h[f_merken][k] = buffer[bufferindex++];
            x3_h[f_merken][k] = buffer[bufferindex++];
            x4_h[f_merken][k] = buffer[bufferindex++];

#ifdef AUSGABEN_WERTE_VERSCHICKEN
            cout << "2066 e " << endl;
#endif
            }
        }
    }

#endif
