#ifndef WERTE_VERSCHICKEN
#define WERTE_VERSCHICKEN 1

#include "ausgaben.h"

#include "mv_vertikal.h"
#include "mv_horizontal.h"

#include "werte_buffer.h"

class WerteVerschicken
    {
public:
    void packen(MV_vertikal * mv, WerteBuffer * werte_buffer);
    void entpacken(WerteBuffer * werte_buffer, MV_vertikal * mv);
    void packen_ns(MV_horizontal * mv, WerteBuffer * werte_buffer);
    void entpacken_ns(WerteBuffer * werte_buffer, MV_horizontal * mv);
private:
    int h_gesamt;
    void packen_eines(void);
    void packen_eines_mit_Iu0(void);
    void packen_eines_ns(void);
    void packen_eines_ns_mit_Iu0(void);
    void entpacken_eines(void);
    void entpacken_eines_mit_Iu0(void);
    void entpacken_eines_ns(void);
    void entpacken_eines_ns_mit_Iu0(void);
    int * f1, *f2, *g, index;
    int * g1, *g2, *f;
    int f1_merken, f2_merken, g_merken;
    int g1_merken, g2_merken, f_merken;
    int i, j, k;
    int vvektor_f1, vvektor_f2, vvektor_g;
    int vvektor_g1, vvektor_g2, vvektor_f;
public:
    void finalisieren(void);
    void initialisieren(int _h_gesamt, int n, int m, int _rang, int _h_min, bool _ist_zusammen_aV_LA);
    #ifndef SHALLOW_WATER_EQUATIONS
    #ifdef dimensionen1
    double *** x0, ** x0_h;
    double *** x1, ** x1_h;
    #endif
    #ifdef dimensionen2
    double *** x0, ** x0_h;
    double *** x1, ** x1_h;
    #endif
    #ifdef dimensionen3
    double *** x0, ** x0_h;
    double *** x1, ** x1_h;
    double *** x2, ** x2_h;
    #endif
    #ifdef dimensionen4
    double *** x0, ** x0_h;
    double *** x1, ** x1_h;
    double *** x2, ** x2_h;
    double *** x3, ** x3_h;
    #endif
    #endif
    #ifdef SHALLOW_WATER_EQUATIONS
    double *** x0, ** x0_h;
    double *** x1, ** x1_h;
    double *** x2, ** x2_h;
    double *** x3, ** x3_h;
    double *** x4, ** x4_h;
    double *** x5, ** x5_h;
    double *** x6, ** x6_h;
    #endif
private:
    double * buffer;
    int bufferindex;
private:
    int rang;
public:
    int h_min, gitterebene;
public:
    double *** u0_unten, ** u0_unten_h;
private:
    bool ist_zusammen_aV_LA;
private:
    void packen_eines_swe_3(void);
    void entpacken_eines_swe_3(void);
    void packen_eines_swe_5(void);
    void entpacken_eines_swe_5(void);
    void packen_eines_swe_3_ns(void);
    void entpacken_eines_swe_3_ns(void);
    void packen_eines_swe_5_ns(void);
    void entpacken_eines_swe_5_ns(void);
    };

#endif

