#ifndef ZYKLUS_RECHNEN
#define ZYKLUS_RECHNEN 1

#include <iostream>
#include <fstream>
#include <string.h>
#include <stdio.h>

using namespace std;

#include "paralleles_rechnen.h"

#include "restriktion.h"
#include "prolongation.h"

#include "ausgaben.h"

#include "markierungsfeld.h"

#include "rand_interpolation.h"

#include "timer.h"

#include "sortierung_double.h"

#include "datei_ausgabe.h"

#include "datei_ausgabe_fuer_wertevergleich.h"

class ZyklusRechnen
    {
protected:
    ParallelesRechnen * paralleles_rechnen;

    Restriktion * restriktionen;
    Prolongation * prolongationen;

protected:
    void setze_restriktionswerte(int n, int m);
    void entferne_restriktionswerte(void);
    void setze_prolongationswerte(void);

protected:
#ifdef KURZ_MF
    bool ** markierungsfeld;
#else
    int ** markierungsfeld;
#endif
    MarkierungsFeld * neuer_punkt_ebenen;
private:
    int i, ii, m, n, m_hilfe, n_hilfe, h_gesamt;
    int mn;
    int rang;
    int groesse;
    int i_plus_1;
    int j;
    int n_1, m_1;
public:
    void setzen(int _n, int _m, int _h_gesamt, int _rang, int _h_kappe, int _h_min);
protected:
    void reset_markierungsfeld(void);
    int * markierung_f, * markierung_g;
    int markierung_groesse;
    int markierungs_index;

protected:
    int * nummern_rauf, laenge_rauf, * plizit_rauf;
    int * nummern_runter, laenge_runter, * plizit_runter;
    int * nummern_oben, laenge_oben, * plizit_oben;
public:
    int vektorisieren1;
public:
    void entferne_prolongationswerte(void);
///////////// Zustze fr die Kappe ////////////////////
public:
    int h_kappe, h_min;
private:
    void warten(void);
public:
    void MLAT_1_sequentiell(int k);
    void MLAT_1_sequentiell_nicht_adaptiv(int k);
    void MLAT_2_sequentiell(int k);
    void MLAT_3_sequentiell(int k);
    void MLAT_3a_sequentiell(int k);
    void MLAT_3a_sequentiell_nicht_adaptiv(int k);
    void MLAT_3b_sequentiell(int k);
    void MLAT_4_sequentiell(int k);
    void MLAT_1_oben(int k);
    void MLAT_1_oben_nicht_adaptiv(int k);
    void MLAT_2_oben(int k);
    void MLAT_3_oben(int k);
    void MLAT_3_oben_nicht_adaptiv(int k);
    void MLAT_3a_oben(int k);
    void MLAT_3a_oben_nicht_adaptiv(int k);
    void MLAT_3b_oben(int k);
    void MLAT_4_oben(int k);
    void MLAT_1_unten(int k);
    void MLAT_2_unten(int k);
    void MLAT_3_unten(int k);
    void MLAT_3_unten_korrektur(int k);
    void MLAT_4_unten(int k);
    void MLAT_tau_berechnen(int k);
    void MLAT_tau12_berechnen(int k);
    int mue1, mue2;
    int ebene;
    int ebene_minus_1;
    int ebene_plus1;
private:
    void vorglaettung(void);
    void vorglaettung_red_black(void);
    void vorglaettung_unten(void);
    void vorglaettung_unten_red_black(void);
    void berechne_residuum(void);
    void beide_restriktionen_oben(void);
    void restriktion_r0rS0_und_u0_reset_oben(void);
    void restriktion_r0rS0_und_u0_reset_sequentiell(void);
    void beide_restriktionen_unten(void);
    void berechne_rechte_seite_oben(void);
    void berechne_rechte_seite_unten(void);
    void loeser(void);
    void loeser_red_black(void);
    void loeser_sequentiell(void);
    void loeser_red_black_sequentiell(void);
    void berechne_e0_oben(void);
    void kopiere_u0_e0_oben(void);
    void berechne_e0_unten(void);
    void prolongationen_oben(void);
    void prolongationen_unten(void);
    void korrektur_auf_feinem_gitter(void);
    void korrektur_auf_feinem_gitter_gleiche_ebene(void);
    void korrektur_auf_feinem_gitter_ohne_kappe(void);
    void nachglaettung(void);
    void nachglaettung_red_black(void);
    void berechne_Lu0_oben(void);
    void berechne_Lu0_unten(void);
    void berechne_DF(void);
    void restriktion_Lu0_unten(void);
    void vorglaettung_sequentiell(void);
    void vorglaettung_sequentiell_red_black(void);
    void vorglaettung_red_black_sequentiell(void);
    void berechne_residuum_sequentiell(void);
    void beide_restriktionen_sequentiell(void);
    void berechne_rechte_seite_sequentiell(void);
    void berechne_e0_sequentiell(void);
    void prolongationen_sequentiell(void);
    void nachglaettung_sequentiell(void);
    void nachglaettung_sequentiell_red_black(void);
    void berechne_tau(void);
    void berechne_tau12(void);
private:
public:
    void MLAT_RI_unten(int k);
    void DiskretisierungsFehlerBerechnen(int k);
private:
    Werte1d ** sendebuffer;
private:
    Werte1d ** empfangsbuffer;
public:
    RandInterpolation * randinterpolationen;
private:
    int buffergroesse;
private:
    MarkierungsFeld * markierungsfelder;
    Markierung markierung;
    int n_1m_1;
public:
    void initialisieren_zyklus_rechnen(void);
    void finalisieren_zyklus_rechnen(void);
private:
    short int * f_liste;
    short int * g_liste;
public:
    void PTs_uebertragen(int ** topologien);
public:
    void randaustausch_u0(int k);
    void randaustausch_gg_u0(int k);
    void randaustausch_fg_u0(int k);
    void randaustausch_gg_u0_starten(int k);
    void randaustausch_gg_u0_beenden(int k);
    void randaustausch_gg_e0(int k);
    void randaustausch_gg_e0_starten(int k);
    void randaustausch_gg_e0_beenden(int k);

    void randaustausch_gg_e0_und_u0(int k);
    void randaustausch_gg_e0_und_u0_starten(int k);
    void randaustausch_gg_e0_und_u0_beenden(int k);

    int t0;
private:
    void u0_testen(char * text);
public:
    int wieviel_punktelast;
private:
    void rechnen_nur_als_punktelast_einmal(void);
    void rechnen_nur_als_punktelast(void);
public:
    Timer timer_zr_idle;
    Timer timer_zr_idle1;
    Timer timer_zr_idle2;
    Timer timer_zr_idle3;
    Timer timer_zr_idle4;
    Timer timer_zr_idle5;
    Timer timer_zr_idle6;
    Timer timer_zr_idle7;
    Timer timer_zr_idle8;
    Timer timer_zr_idle9;
    Timer timer_zr_idle10;
    Timer timer_zr_idle11;
    Timer timer_zr_idle12;
    Timer timer_zr_idle13;
    Timer timer_zr_idle14;
    Timer timer_zr_idle15;
    Timer timer_zr_idle16;
    Timer timer_zr_idle17;
    Timer timer_zr_kl_idle;
    Timer timer_zr_packen_entpacken_initiieren;
    Timer timer_mlat1_unten_vorglaettung;
    Timer timer_mlat1_unten_residuum;
    Timer timer_mlat1_unten_restriktion;
public:
    double zeit_anfang_zyklus;
private:
    DateiAusgabe da_punktliste;
    char zeichenkette[100];
private:
public:
    bool quantile_ausgeben;
private:
    SortierungDouble sortierung_double;
    ofstream * aus;
    char text_innen[50], text_rand[50], text_ebene[5], kommentar[40];
    void finalisieren_ausgeben(void);
    void initialisieren_ausgeben(void);
private:
    void suche(double ** x, int f, int g, int ebene);
    int f_hilfe, g_hilfe;
private:
    bool pruefe_auf_existenz(int f, int g, int h);
    void pruefe_auf_existenz_aggr(int f, int g, int h);
public:
    void u0_testen_3011(char * text);
public:
    int * n_h, * m_h;
private:
    int n_ebene, m_ebene;
public:
    void u0_ausgeben(char * text);
private:
public:
    void r0_ausgeben(char * text);
private:
    void e0_ausgeben(char * text);
    void e0_ausgeben_minus_1(char * text);
    void rS0_ausgeben(char * text);
    void f0_ausgeben(char * text);
    void u0_ausgeben_plus1(char * text);
    void Iu0_ausgeben_plus1(char * text);
    void Iu0_ausgeben(char * text);
    void r0_ausgeben_plus1(char * text);
    void u0_diff_ausgeben(char * text);
    void u0_ausgeben_minus_1(char * text);
    void ausgabe_darunter(char * text);
public:
    DateiAusgabe da_zr; // Zyklus Rechnen Datei Ausgabe, kurz zr_da
public:
    void koordinaten_ausgabe(int _ebene);
    void koordinaten_ausgabe_klein(int _ebene);
private:
    void koordinaten_ausgabe_sequentiell(int _ebene);
private:
    void ebene_ausgeben(char * text);
    int ebene_merken;
public:
    bool ist_gauss_seidel;
public:
    int solve_anzahl;
protected:
    DateiAusgabefuerWertevergleich datei_ausgabe_fuer_wertevergleich;
private:
    void u0_ausgeben_fwv(int updowntop, char * zusatztext);
protected:
    int t;
    void t_setzen_fuer_restriktionen(void);
    void t_setzen_fuer_prolongationen(void);
private:
    short int * f_s;
    short int * g_s;
private:
    void test_e0(char * text);
private:
    short int * f_kappe, * g_kappe;
protected:
    int anzahl_kappe;
private:
    int n_kappe, m_kappe, mn_kappe;
    int n_kappe_minus1, m_kappe_minus1;
public:
    void initialisieren_koordinaten_kappe(int _h_kappe);
    void finalisieren_koordinaten_kappe(void);
public:
protected:
    void MLAT_1a_oben_FAS(int k);
    void MLAT_1b_sequentiell_FAS(int k);
    void MLAT_3a_sequentiell_FAS(int k);
    void MLAT_3b_oben_FAS(int k);
private:
    void beide_restriktionen_sequentiell_FAS(void);
private:
    void ausgeben385(char * text);
    void text387(char * text);
    void test_feld_vergangen_385(char * text);

private:
    void restriktion_f_oben(void);
    void restriktion_f_unten(void);
protected:
    void MLAT_3_SWE(int k);
    void MLAT_RI_SWE(int k);
    void MLAT_4_SWE(int k);
    void MLAT_1_SWE(int k);
    void MLAT_2_SWE(int k);
private:
    void loesen_vorher(int k);
    void loesen_nachher(int k);
    void glaettung_red_black_swe(void);
    void restriktion_swe(int k);
    void prolongationen_unten_swe(void);
    void prolongationen_oben_swe(void);
    void randaustausch_gg_v9_starten(int k);
    void randaustausch_gg_v9_beenden(int k);
public:
    void zeitausgabe(char * text);
private:
    int ebene_ka;
private:
    void test_feld_vergangen_385zr(char * text);
    };

#endif
