#include "gitter.h"

// Kommentar zu selbstnachbarn: snb==255, dann innen. Denn dann Verbindungen zu allen anderen benachbarten Gitterpunkten
// Jede Verbindung hat Nord bis Nordwest.

//  Kommentar 30.11.2012: Ich habe den dynamischen Rand kontrolliert: Die jeweils 8 Unterfunktionen waren OK, die
//  zentralen einfuege / entfernen - Funktionen waren nicht OK und wurden verndert.
//  An der falschen Ausgabe von dynamischer Rand hat sich dabei nichts gendert!
//
//  Kein Eintrag von PED: oder PHD: erfolgte in 'sehen'.
//
//  Suche die Funktion, die die Verfeinerungsgitter reinitialisiert: gitter_zuruecksetzen();

// Bemerkung zur Startaufteilung: In initialisieren_gitter wird die Funktion farbe aufgerufen.

// Kommentar: Hier werden - wegen der Migration - fr die Ebene dieses Gitters die mv_vertikal Vektoren entfernt.
// Dabei wird unterschieden, ob in epd, d.h. ep_plus_dazu, diese Informationen mitgefhrt werden.
// Ferner geschieht das dynamische Entfernen, d.h. die Randliste wird mit gendert.
// Die Variable zielrang wird bentigt, um die Entfernten Punkte bzgl. des Farbenfeldes dem neuen Eigentmer
// zuzuordnen.

#ifdef GITTER_EP_PLUS_DAZU
void Gitter::entferne_ebene_auch_dynamisch(MV_vertikal * mv_vertikal, int zielrang)
    {
// Kommentar: Durch die if - Bedingung wird erreicht, dass nur fr adaptive Ebenen ungleich der feinsten
// Ebene epd mit gendert wird. Die entsprechenden Funktionen zur Entfernung werden aufgerufen.
    if((gitterebene>=1)&&(gitterebene<=h_min))
        {
        entferne_ebene_auch_dynamisch_mit_epd(mv_vertikal, zielrang);
        }
    else
        {
        entferne_ebene_auch_dynamisch_ohne_epd(mv_vertikal, zielrang);
        }
    }
#else
// Kommentar: In dieser Version vom 5.10.15 wird der Fall epd ausgeschlossen, weil epd in der adaptiven Verfeinerung sowieso einem Reset unterzogen wird.
void Gitter::entferne_ebene_auch_dynamisch(MV_vertikal * mv_vertikal, int zielrang)
    {
    entferne_ebene_auch_dynamisch_ohne_epd(mv_vertikal, zielrang);
    }
#endif

// Kommentar: Diese Funktion wird fr die Migration bentigt, damit der neue 'Eigentmer' der Punkte im Farbenfeld verzeichnet wird.
// Der zielrang ist der Rang des neuen Eigentmers.

void Gitter::ueberschreiben(int zielrang)
    {
// Kommentar: Man durchluft alle Vektoren der Koordinaten f1, f2 und g
    for(i=0; i<index; i++)
        {
        vvektor_f1 = f1[i];
        vvektor_f2 = f2[i];
        vvektor_g = g[i];

// Kommentar: Man durchluft alle Punkte des Vektors ...
        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
// Kommentar: ... und ndert das Farbenfeld auf die Farbe des neuen Punktebesitzers.
            farbenfeld[j][vvektor_g] = zielrang;
            }
        }
    }

// Kommentar: Es werden alle Punkte der eigenen Gitterebene, die in mv_vertikal stehen, entfernt. Das Farbenfeld wird
// dabei aktualisiert. ep_plus_dazu wird aktualisiert.
void Gitter::entferne_ebene_auch_dynamisch_mit_epd(MV_vertikal * mv_vertikal, int zielrang)
    {
#ifdef AUSGABEN_GITTER
    cout << "Entferne Ebene // rang " << rang << " gitterebene " << gitterebene << " zielrang " << zielrang << endl;
#endif
// Kommentar: Die Vektoren aus mv_vertikal fr die eigene Gitterebene wird zu Koordinaten von Nord - Sd - Vektoren
// dieser Klasse. Die Anzahl der Vektoren wird als index gespeichert.
    f1 = mv_vertikal->f1_speichern[gitterebene];
    f2 = mv_vertikal->f2_speichern[gitterebene];
    g = mv_vertikal->g_speichern[gitterebene];
    index = mv_vertikal->indizes[gitterebene];

#ifdef AKTUELLE_KOMMENTARE
    cout << " Index " << index << " rang " << rang << " gitterebene " << gitterebene << endl;
#endif

    for(i=0; i<index; i++)
// Kommentar: Man durchluft die Vektoren
        {
// Kommentar: Die folgende Variable ist immer true.
        if(punkt_aenderung_dynamisch==true)
            {
// Kommentar: Der i.te Vektor wird gelesen.
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " eeadme index " << index << " rang " << rang << " i " << i << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << " rang " << rang << " gitterebene " << gitterebene << endl;
#endif
// Kommentar: Die Punktemenge dieses Vektors wird durchlaufen.
            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
// Kommentar: Der Punkt wird aus der Feldliste entfernt.
                entfernen_fl(j, vvektor_g);
// Kommentar: Das Farbenfeld ndert seinen Eintrag auf diesem Punkt auf den des neuen Punkteigentmers.
                farbenfeld[j][vvektor_g] = zielrang;
// Kommentar: Man ndert die Randpunkteliste entsprechend der Tatsache, dass dieser Punkt nicht mehr zum eigenen Gitter gehrt.
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor punkt_entfernen_selbstnachbarn_dynamisch 1 rang " << rang << " ebene " << gitterebene << " j " << j << " vvektor_g " << vvektor_g << endl;
#endif
                punkt_entfernen_selbstnachbarn_dynamisch(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 1 rang " << rang << " ebene " << gitterebene << " j " << j << " vvektor_g " << vvektor_g << endl;
#endif
// Kommentar: Wegen eps wird ep_plus_dazu einen Eintrag auf dieser Stelle entfernen.
                ep_plus_dazu->hinweg(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 1 rang " << rang << endl;
#endif
                }
            }
        else
            {
// Kommentar: Hier geschieht dasselbe wie eben nur ohne die nderung der Randpunkteliste.
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
                entfernen_fl(j, vvektor_g);
//                P_minus->hinzu(j, vvektor_g);
//                P_plus->hinweg(j, vvektor_g);
                farbenfeld[j][vvektor_g] = zielrang;
                punkt_entfernen_selbstnachbarn(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 2 rang " << rang << endl;
#endif
                ep_plus_dazu->hinweg(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 2 rang " << rang << endl;
#endif
                }
            }
        }
    }

// Kommentar: Es werden alle Punkte der eigenen Gitterebene, die in mv_vertikal stehen, entfernt. Das Farbenfeld wird
// dabei aktualisiert. ep_plus_dazu wird hier nicht verndert.
// Fr die Kommentare nehme man die Kommentare der Funktion 'entferne_ebene_auch_dynamisch_mit_epd'.
void Gitter::entferne_ebene_auch_dynamisch_ohne_epd(MV_vertikal * mv_vertikal, int zielrang)
    {
#ifdef AUSGABEN_GITTER
    cout << "Entferne Ebene // rang " << rang << " gitterebene " << gitterebene << " zielrang " << zielrang << endl;
#endif
    f1 = mv_vertikal->f1_speichern[gitterebene];
    f2 = mv_vertikal->f2_speichern[gitterebene];
    g = mv_vertikal->g_speichern[gitterebene];
    index = mv_vertikal->indizes[gitterebene];
#ifdef AKTUELLE_KOMMENTARE
    cout << " Index " << index << " rang " << rang << " gitterebene " << gitterebene << endl;
#endif
    for(i=0; i<index; i++)
        {
        if(punkt_aenderung_dynamisch==true)
            {
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << " rang " << rang << " gitterebene " << gitterebene << endl;
#endif
            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
#ifdef AKTUELLE_KOMMENTARE
                cout << " eead 1 rang " << rang << endl;
#endif
                entfernen_fl(j, vvektor_g);
#ifdef AKTUELLE_KOMMENTARE
                cout << " eead 2 rang " << rang << endl;
#endif
                farbenfeld[j][vvektor_g] = zielrang;
#ifdef AKTUELLE_KOMMENTARE
                cout << " eead 3 rang " << rang << " farbenfeld (j,vvektor_g) " << farbenfeld[j][vvektor_g] << endl;
#endif
                punkt_entfernen_selbstnachbarn_dynamisch(j, vvektor_g);
#ifdef AKTUELLE_KOMMENTARE
                cout << " eead 4 rang " << rang << endl;
#endif
                }
            }
        else
            {
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
                entfernen_fl(j, vvektor_g);
                farbenfeld[j][vvektor_g] = zielrang;
                punkt_entfernen_selbstnachbarn(j, vvektor_g);
                }
            }
        }
    }

#ifdef GITTER_EP_PLUS_DAZU
// Kommentar: Diese Funktion ist das quivalent zu der Funktion entferne_ebene_auch_dynamisch, nur dass hier die
// Gitterpunkte eingefgt, statt entfernt werden. Entsprechend sind auch die Kommentare von
// 'entferne_ebene_auch_dynamisch' abzundern.
void Gitter::einfuegen_ebene_auch_dynamisch(MV_vertikal * mv_vertikal, int zielrang)
    {
    if((gitterebene>=1)&&(gitterebene<=h_min))
        {
        einfuegen_ebene_auch_dynamisch_mit_epd(mv_vertikal, zielrang);
        }
    else
        {
        einfuegen_ebene_auch_dynamisch_ohne_epd(mv_vertikal, zielrang);
        }
    }
#else
// Kommentar: In dieser Version vom 5.10.15 wird der Fall epd ausgeschlossen, weil epd in der adaptiven Verfeinerung sowieso einem Reset unterzogen wird.
void Gitter::einfuegen_ebene_auch_dynamisch(MV_vertikal * mv_vertikal, int zielrang)
    {
    einfuegen_ebene_auch_dynamisch_ohne_epd(mv_vertikal, zielrang);
    }
#endif

// Kommentar: Diese Funktion ist das quivalent zu der Funktion 'entferne_ebene_auch_dynamisch_mit_epd', nur
// dass Punkte eingefgt werden, und dementsprechend das Farbenfeld, die Feldliste und die Randpunktliste gendert werden.
// Da nicht alles ganz analog ist, wird diese Funktion kommentiert.
void Gitter::einfuegen_ebene_auch_dynamisch_mit_epd(MV_vertikal * mv_vertikal, int zielrang)
// Was genau fr einen Zweck hat epd?
    {
#ifdef AUSGABEN_GITTER
    cout << "Einfuegen Ebene // rang " << rang << " gitterebene " << gitterebene << endl;
#endif
// Kommentar: Wieder werden die Zeiger der Vektoren von mv_vertikal auf Zeiger dieser Klasse kopiert. AUch die
// Anzahl an Vektoren wird nach hier in die Variable index kopiert.
    f1 = mv_vertikal->f1_speichern[gitterebene];
    f2 = mv_vertikal->f2_speichern[gitterebene];
    g = mv_vertikal->g_speichern[gitterebene];
    index = mv_vertikal->indizes[gitterebene];

// Kommentar: Die Vektoren werden der Reihe nach durchlaufen.
    for(i=0; i<index; i++)
        {
// Kommentar: Diese Variable ist standardmig true.
        if(punkt_aenderung_dynamisch==true)
            {
// Kommentar: Der i.te Vektor wird erfat.
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

// Kommentar: Nun werden die Punkte durchlaufen
            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
// Kommentar: Der aktuelle Punkt wird in die Feldliste eingefgt.
                einfuegen_fl(j, vvektor_g);

// Kommentar: Das Farbenfeld verzeichnet den Punkt als eigenen Punkt.
                farbenfeld[j][vvektor_g] = rang;

// Kommentar: Die Randpunkteliste wird aktualisiert, weil dieser Punkt jetzt zum eigenen Gitter gehrt.
#ifdef AUSGABEN_GITTER
    cout << " Vor 1 phsd rang " << rang << " j " << j << " g " << vvektor_g << " ebene " << gitterebene << endl;
#endif
                punkt_hinzufuegen_selbstnachbarn_dynamisch(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 3 rang " << rang << endl;
#endif
// Kommentar: Der Punkt wird in ep_plus_dazu aufgenommen.
                ep_plus_dazu->hinzu(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 3 rang " << rang << endl;
#endif
                }
            }
        else
// Kommentar: Hier geschieht dasselbe wie bei der if - Abfrage, nur dass die Randpunktliste nicht aktualisiert wird.
            {
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
                einfuegen_fl(j, vvektor_g);
                farbenfeld[j][vvektor_g] = rang;
                punkt_hinzufuegen_selbstnachbarn(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 4 rang " << rang << endl;
#endif
                ep_plus_dazu->hinzu(j, vvektor_g);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 4 rang " << rang << endl;
#endif
                }
            }
        }
    }

// Kommentar: Hier geschieht dasselbe wie in der Funktion 'einfuegen_ebene_auch_dynamisch_mit_epd', nur dass
// die Struktur ep_plus_dazu nicht verndert wird. Die Kommentare sind entsprechend dieselben wie bei
// 'einfuegen_ebene_auch_dynamisch_mit_epd'.
void Gitter::einfuegen_ebene_auch_dynamisch_ohne_epd(MV_vertikal * mv_vertikal, int zielrang)
    {
#ifdef AUSGABEN_GITTER
    cout << "Einfuegen Ebene // rang " << rang << " gitterebene " << gitterebene << endl;
#endif
    f1 = mv_vertikal->f1_speichern[gitterebene];
    f2 = mv_vertikal->f2_speichern[gitterebene];
    g = mv_vertikal->g_speichern[gitterebene];
    index = mv_vertikal->indizes[gitterebene];

    for(i=0; i<index; i++)
        {
        if(punkt_aenderung_dynamisch==true)
            {
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
                einfuegen_fl(j, vvektor_g);
#ifdef AAHH
                if((rang==2)&&(j==20)&&(vvektor_g==7))
                    {
                    cout << " AAHH einfuegen t " << t << endl;
                    }
#endif
                farbenfeld[j][vvektor_g] = rang;
#ifdef AUSGABEN_GITTER
    cout << " Vor 2 phsd rang " << rang << " j " << j << " g " << vvektor_g << " ebene " << gitterebene << endl;
#endif
                punkt_hinzufuegen_selbstnachbarn_dynamisch(j, vvektor_g);
                }
            }
        else
            {
            vvektor_f1 = f1[i];
            vvektor_f2 = f2[i];
            vvektor_g = g[i];

#ifdef AUSGABEN_GITTER
            cout << " f1 " << vvektor_f1 << " f2 " << vvektor_f2 << " g " << vvektor_g << endl;
#endif

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
                einfuegen_fl(j, vvektor_g);
                farbenfeld[j][vvektor_g] = rang;
                punkt_hinzufuegen_selbstnachbarn(j, vvektor_g);
                }
            }
        }
    }



// Kommentar: Am Anfang werden alle Gitter voll belegt. Das ist fr die Verfeinerungsgitter so nicht richtig. Diese
// werden deshalb auf 'leer' zurckgesetzt.
void Gitter::gitter_zuruecksetzen(void)
    {
// Kommentar: Das Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();
// Kommentar: Falls ein Eintrag im dynamischen Rand liegt, wird der entfernt.
        if(dynamischer_rand.feld[j][k]>=0)
            {
            dynamischer_rand.entfernen_fl(j, k);
            }
// Kommentar: Der nchte Punkt wird schon geladen. Das ndert aber nicht den jetztigen Punkt (j,k)
        naechster();
// Kommentar: Der Punkte wird aus der Feldliste entfernt.
        punkt_entfernen(j, k);
// Kommentar: Und das Farbenfeld wird auf -1 gesetzt.
        farbenfeld[j][k] = -1;

        }
// Kommentar: Hier wird das Farbenfeld komplett resettet.
    for(j=0; j<n; j++)
        {
        for(k=0; k<m; k++)
            {
            farbenfeld[j][k] = -1;
            }
        }

// Kommentar: Die Punktlisten fr Rand und Inneres werden resettet.
    anzahl_innen = 0;
    anzahl_rand_innen = 0;

// Kommentar: Jetzt werden die Randlisten zurckgesetzt.
    for(j=0; j<groesse; j++)
        {
        if(j!=rang)
            {
            if(vektorisieren0==JA)
                {
                randstruktur_kommunikation[j].anzahl_h_vektor_e = 0;
                randstruktur_kommunikation[j].anzahl_v_vektor_e = 0;
                randstruktur_kommunikation[j].punkteanzahl_e = 0;
                }
            else
                {
                rand_werte_kommunikation[j].anzahl_a_rs = 0;
                }
            }
        }
    }

// Kommentar: Das ist eine Debugging - Funktion. Die Werte x0 werden ausgegeben. Keine weitere Kommentierung an dieser Stelle.
void Gitter::ausgeben_gitter(void)
    {
#ifdef AUSGABEN_GITTER
    cout << "Die Gitterwerte! Rang " << rang << endl;

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            #ifdef dimensionen1
            cout << x0[i][j] << " ";
            #endif
            #ifdef dimensionen2
            cout << "(" << x0[i][j] << " " << x1[i][j] << ")";
            #endif
            #ifdef dimensionen3
            cout << "(" << x0[i][j] << " " << x1[i][j] << " " << x2[i][j] << ")";
            #endif
            #ifdef dimensionen4
            cout << "(" << x0[i][j] << " " << x1[i][j] << " " << x2[i][j] << " " << x3[i][j] << ")";
            #endif
            }
        cout << endl;
        }
#endif
    }

// Kommentar: Hier werden Innenpunkte und Randpunkte bestimmt. Fr die Ebenen 1 bis h_min werden auch noch
// die Punktmengen unterschieden, die einen Punkt unter sich haben, bzw. fr die das nicht gilt.
// Bentigt werden diese zustzlichen Mengen bei der 'kleinen Randbertragung', bei der nur solche
// Randwerte bertragen werden, wo Gitterpunkt darunter nicht existieren.
// Dieses hier muss nach jeder neuen Gitterbildung neu durchlaufen werden.
void Gitter::bestimme_innenpunkte(void)
// Bestimme Aussenpunkte wrde ich verstehen. Aber die Innenpunkte zu bestimmen: Die hat man doch schon.
// Doch: Man unterscheidet Randpunkte und Innenpunkte. Von den eigenen Punkten.
    {
#ifdef AUSGEBEN_GITTER
    cout << " bestimme Innenpunkte rang " << rang << " gitterebene " << gitterebene << endl;
#endif
// Kommentar: Bentigt werden die 'kleinen Punktmengen' auf den grberen Gittern zu den Verfeinerungsebenen.
// Dort macht - je nach Funktion - ein eingeschrnkter Randaustausch Sinn.
    if(gitterebene==0)
        {
        bestimme_innenpunkte_ohne_klein();
        return;
        }
    if(gitterebene>h_min)
        {
        bestimme_innenpunkte_ohne_klein();
        return;
        }
    bestimme_innenpunkte_mit_klein();
    }

// Kommentar: Hier wird die Gesamtzahl an Gitterpunkten auf dem Kern und der Gitterebene gezhlt.
int Gitter::wieviele_punkte(void)
    {
// Kommentar: Anfangs ist die Punktanzahl 0
    anzahl_punkte = 0;
// Kommentar: Die Punktliste wird durchlaufen
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
// Kommentar: Fr jeden Gitterpunkt wird gezhlt.
        anzahl_punkte ++;
        }
    return(anzahl_punkte);
    }

// Kommentar: Rand - und Innenpunkte werden bestimmt, aber es werden nicht die eingeschrnkten Punktmengen,
// bei denen Gitterpunkte darunter liegen oder nicht, bestimmt. Dieses hier muss nach jeder neuen Gitterbildung
// neu durchlaufen werden.
void Gitter::bestimme_innenpunkte_ohne_klein(void)
    {
    anzahl_innen = 0;
    anzahl_rand_innen = 0;
    anzahl_rand_innen_echter_rand = 0;
#ifdef AUSGABEN_GITTER
    cout << "BI ";
#endif

// Kommentar: Das Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
// Kommentar: Der bestimmte Gitterpunkt wird gelesen.
        j = lesen_f();
        k = lesen_g();
// Kommentar: Ist der Gitterpunkt ein Innenpunkt ...
        if(selbstnachbarn[j][k]==255)
            {
// Kommentar: So wird er in die Innenliste eingefgt.
            f_innen[anzahl_innen] = j;
            g_innen[anzahl_innen] = k;
            anzahl_innen++;
            }
        else
            {
// Kommentar: Es wird geprft, ob ein echter Randpunkt vorliegt. Die sind nur fr die Restriktion und die Prolongation von Bedeutung.
// Deswegen werden sie dafr abgespeichert. Die normalen Funktionen sind fr den echten Rand (farbenfeld = -1) nicht gltig.
            if(iip.pruefen(j, k)==false) // Prfung: Nur innere Punkte in die Listen aufnehmen. Ggf. muss diese Abfrage direkt in rechnen erfolgen.
            // Die Randpunkte werden durch Interpolation gewonnen. Wenn sie anders gerechnet werden, ist das noch zu machen.
            // Auf den ganzen Gittern bleiben die Randpunktwerte so erhalten. Sonst sind die MLAT - Funktionen abzundern.
            // Jetzt habe ich einen schnelleren Test dafr.
                {
// Kommentar: Nehme diesen Punkt in den echten Rand auf.
                f_rand_innen_echter_rand[anzahl_rand_innen_echter_rand] = j;
                g_rand_innen_echter_rand[anzahl_rand_innen_echter_rand++] = k;
                continue;
                }
// Kommentar: Ansonsten wird der Punkt in den Rand aufgenommen
            f_rand_innen[anzahl_rand_innen] = j;
            g_rand_innen[anzahl_rand_innen] = k;
//            f_rand_innen_echter_rand[anzahl_rand_innen_echter_rand] = j;
//            g_rand_innen_echter_rand[anzahl_rand_innen_echter_rand] = k;
// 6.2.16: Diese Zeilen lasse ich drin, weil der echte Rand ggf. gebraucht werden knnte.
#ifdef AUSGABEN_GITTER
            cout << " f " << j << " g " << k;
#endif
            anzahl_rand_innen++;
            }
        }
#ifdef AUSGABEN_GITTER
    cout << endl;
    cout << "Bestimme Innenpunkte . Rang " << rang << " n " << n << " anzahl_innen " << anzahl_innen << " anzahl_rand_innen " << anzahl_rand_innen << endl;
#endif
    }

// Kommentar: Rand - und Innenpunkte werden bestimmt, und es werden auch noch die eingeschrnkten Punktmengen,
// bei denen Gitterpunkte darunter liegen oder nicht, bestimmt.
void Gitter::bestimme_innenpunkte_mit_klein(void) // Wurde berechnet, aber nicht verwendet!
    {
// Kommentar: Lsche die Punktmengen
    anzahl_innen = 0;
    anzahl_rand_innen = 0;
    anzahl_rand_innen_echter_rand = 0;
    anzahl_innen_klein = 0;
    anzahl_rand_innen_klein = 0;
    anzahl_rand_innen_klein_echter_rand = 0;
    anzahl_innen_nicht_klein = 0;
    anzahl_rand_innen_nicht_klein = 0;
#ifdef AUSGABEN_GITTER
    cout << "BI ";
#endif

// Kommentar: Durchlaufe das Gitter
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
// Kommentar: Lese den nchsten Gitterpunkt
        j = lesen_f();
        k = lesen_g();

// Kommentar: Wenn (j,k) ein innerer Punkt ist ...
        if(selbstnachbarn[j][k]==255)
            {
// Kommentar: ... dann nehme ihn in die innere Punkte Liste auf.
            f_innen[anzahl_innen] = j;
            g_innen[anzahl_innen] = k;
            anzahl_innen++;
// Kommentar: Gibt es was darunter, dann wird der Punkt in innen_klein, ansonsten in innen_nicht_klein aufgenommen
            if(ist_gemeinsamer_punkt(j, k)==true)
                {
                f_innen_klein[anzahl_innen_klein] = j;
                g_innen_klein[anzahl_innen_klein++] = k;
                }
            else
                {
                f_innen_nicht_klein[anzahl_innen_nicht_klein] = j;
                g_innen_nicht_klein[anzahl_innen_nicht_klein++] = k;
                }
            }
        else
            {
// Kommentar: Liegt ein echter Randpunkt vor ...
            if(iip.pruefen(j, k)==false) // Nur innere Punkte, Kommentar s.o. (iip.pruefen)
                {
// Kommentar: ... dann nehme ihn in die echte Randpunktliste auf.
                f_rand_innen_echter_rand[anzahl_rand_innen_echter_rand] = j;
                g_rand_innen_echter_rand[anzahl_rand_innen_echter_rand++] = k;
// Kommentar: Und liegt ein Gitterpunkt darunter ...
                if(ist_gemeinsamer_punkt(j, k)==true)
                    {
// Kommentar: ... dann nehme ihn in die echte kleine Randpunktliste auf.
                    f_rand_innen_klein_echter_rand[anzahl_rand_innen_klein_echter_rand] = j;
                    g_rand_innen_klein_echter_rand[anzahl_rand_innen_klein_echter_rand++] = k;
                    }
                continue;
                }
// Kommentar: Ansonsten nehme den Punkt in die normale Randpunktliste auf, und je nachdem,
// ob ein Punkt darunter liegt, oder nicht, in die kleine oder nicht kleine Randpunktliste auf.
            f_rand_innen[anzahl_rand_innen] = j;
            g_rand_innen[anzahl_rand_innen] = k;
//            f_rand_innen_echter_rand[anzahl_rand_innen_echter_rand] = j;
//            g_rand_innen_echter_rand[anzahl_rand_innen_echter_rand] = k; 6.2.16: Das noch Mal lassen
#ifdef AUSGABEN_GITTER
            cout << " f " << j << " g " << k;
#endif
            anzahl_rand_innen++;
            if(ist_gemeinsamer_punkt(j, k)==true)
                {
                f_rand_innen_klein[anzahl_rand_innen_klein] = j;
                g_rand_innen_klein[anzahl_rand_innen_klein++] = k;
//                f_rand_innen_klein_echter_rand[anzahl_rand_innen_echter_rand] = j;
//                g_rand_innen_klein_echter_rand[anzahl_rand_innen_echter_rand++] = k;
                }
            else
                {
                f_rand_innen_nicht_klein[anzahl_rand_innen_nicht_klein] = j;
                g_rand_innen_nicht_klein[anzahl_rand_innen_nicht_klein++] = k;
                }
            }
        }
#ifdef AUSGABEN_GITTER
    cout << endl;
    cout << "Bestimme Innenpunkte . Rang " << rang << " n " << n << " anzahl_innen " << anzahl_innen << " anzahl_rand_innen " << anzahl_rand_innen << endl;
#endif
    }


// Kommentar: Hier wird ein Punkt entfernt, indem er aus der Feldliste entfernt und selbstnachbarn aktualisiert wird.
// Da aber die Randpunktliste nicht aktualisiert ist, ist diese Funktion eigentlich nicht mehr aktuell. Er wird aber in gitter_zuruecksetzen gebraucht.
void Gitter::punkt_entfernen(int _f, int _g)
    {
    entfernen_fl(_f, _g);
    punkt_entfernen_selbstnachbarn(_f, _g);
#ifdef AUSGABEN_GITTER
    cout << "PE: " << _f << " " << _g << ";" << endl;
#endif
    }

// Kommentar: Analog zu punkt_entfernen
void Gitter::punkt_hinzufuegen(int _f, int _g)
    {
    punkt_hinzufuegen_selbstnachbarn(_f,_g);
    einfuegen_fl(_f, _g);
#ifdef AUSGABEN_GITTER
    cout << "PH: " << _f << " " << _g << " " << rang << ";" << " m " << m << " n " << n << endl;
#endif
    }

// Kommentar: Das ist die aktuelle Funktion zum Entfernen von Gitterpunkten. Hier wird der Punkt aus der Feldliste entfernt,
// und es wird selbstnachbarn gendert zusammen mit der Randpunktliste (der Suffix 'dynamisch' steht dafr).
void Gitter::punkt_entfernen_dynamisch(int _f, int _g)
    {
    entfernen_fl(_f, _g);
#ifdef AUSGABEN_GITTER
    cout << " Vor 3 phsd rang " << rang << " _f " << _f << " _g " << _g << " ebene " << gitterebene << endl;
#endif
    punkt_entfernen_selbstnachbarn_dynamisch(_f, _g);
#ifdef AUSGABEN_GITTER
    cout << "PED: " << _f << " " << _g << " " << rang << ";" << " m " << m << " n " << n << endl;
#endif
    }

// Kommentar: Das ist die aktuelle Funktion zum Einfgen von Gitterpunkten. Hier wird der Punkt in die Feldliste eingefgt,
// und es wird selbstnachbarn gendert zusammen mit der Randpunktliste (der Suffix 'dynamisch' steht dafr).
void Gitter::punkt_hinzufuegen_dynamisch(int _f, int _g)
    {
    punkt_hinzufuegen_selbstnachbarn_dynamisch(_f,_g);
    einfuegen_fl(_f, _g);
#ifdef AKTUELLE_KOMMENTARE
    if((rang==3)&&(gitterebene==0))
        {
        cout << "PHD: " << _f << " " << _g << " " << rang << ";" << " m " << m << " n " << n << endl;
        }
#endif
#ifdef AUSGABEN_GITTER
    cout << "PHD: " << _f << " " << _g << " " << rang << ";" << " m " << m << " n " << n << endl;
#endif
    }

// Kommentar: Der Punkt (i,j) wird eingefgt. In Richtung Nordwest muss ggf. das Farbenfeld 2 - fach abgewandelt werden:
void Gitter::hinzu_nordwest(int i, int j)
    {
// Kommentar: Falls in Nordwest - Richtung ein eigener Punkt existiert.
// Bemerkung: Eigenlich muss hier das Feld der Feldliste abgefragt werden. Die aktuellere Funktion ist hinzu_nordwest_dynamisch.
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j-1]==rang)
#else
    if(feld[i-1][j-1]>=0)
#endif
        {
// Kommentar: Vermerke das fr diesen Punkt.
        selbstnachbarn[i][j] |= NORD_WEST;
// Kommentar: Vermerke fr diesen Punkt, dass in dessen SUED_OST Richtung jetzt ein Punkt existiert.
        selbstnachbarn[i-1][j-1] |= SUED_OST;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_west(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j-1]==rang)
#else
    if(feld[i][j-1]>=0)
#endif
        {
        selbstnachbarn[i][j] |= WEST;
        selbstnachbarn[i][j-1] |= OST;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_suedwest(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j-1]==rang)
#else
    if(feld[i+1][j-1]>=0)
#endif
        {
        selbstnachbarn[i][j] |= SUED_WEST;
        selbstnachbarn[i+1][j-1] |= NORD_OST;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_sued(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j]==rang)
#else
    if(feld[i+1][j]>=0)
#endif
        {
        selbstnachbarn[i][j] |= SUED;
        selbstnachbarn[i+1][j] |= NORD;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_suedost(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j+1]==rang)
#else
    if(feld[i+1][j+1]>=0)
#endif
        {
        selbstnachbarn[i][j] |= SUED_OST;
        selbstnachbarn[i+1][j+1] |= NORD_WEST;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_ost(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j+1]==rang)
#else
    if(feld[i][j+1]>=0)
#endif
        {
        selbstnachbarn[i][j] |= OST;
        selbstnachbarn[i][j+1] |= WEST;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_nordost(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j+1]==rang)
#else
    if(feld[i-1][j+1]>=0)
#endif
        {
        selbstnachbarn[i][j] |= NORD_OST;
        selbstnachbarn[i-1][j+1] |= SUED_WEST;
        }
    }

// Kommentar: Vergleiche die Funktion hinzu_nordwest. Die Begrndungen gehen analog.
void Gitter::hinzu_nord(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j]==rang)
#else
    if(feld[i-1][j]>=0)
#endif
        {
        selbstnachbarn[i][j] |= NORD;
        selbstnachbarn[i-1][j] |= SUED;
        }
    }

// Kommentar: Der Punkt (i,j) wird eingefgt. In Richtung Nordwest muss ggf. die Struktur selbstnachbarn 2 - fach abgewandelt werden:
// Die dynamische Randpunktliste wird aktualisiert.
void Gitter::hinzu_nordwest_dynamisch(int i, int j)
    {
// Kommentar: Wenn in Nord - West - Richtung ein Gitterpunkt existiert ...
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j-1]==rang) //nderung 3.7.15
#else
    if(feld[i-1][j-1]>=0) //nderung 6.10.15
#endif
        {
// Kommentar: Vermerke das fr diesen Punkt.
//        selbstnachbarn[i][j] |= NORD_WEST;

// Kommentar: Wenn das fr den Punkt der einzige nicht eigene Punkt war ...
        if(selbstnachbarn[i-1][j-1]==_SUED_OST)
            {
// Kommentar: ... dann entferne ihn aus der Randliste, weil selbtnachbarn(i-1,j-1) = 255 sein wird nach sich anschlieenden Befehl.
            dynamischer_rand.entfernen_fl(i-1, j-1);
            }
        }
// Kommentar: Vermerke fr den Punkt in Nord - West - Richtung, dass in dessen SUED_OST Richtung jetzt ein Punkt existiert.
    selbstnachbarn[i-1][j-1] |= SUED_OST;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_west_dynamisch(int i, int j)
    {
#ifdef AUSGABEN_GITTER
    if(rang == 0)
        {
        if(i==0)
            {
            if(j==2)
                {
                cout << "hwd02 rang " << rang << " (0,2) ff " << farbenfeld[i][j-1] << endl;
                }
            }
        }
#endif
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j-1]==rang)
#else
    if(feld[i][j-1]>=0)
#endif
        {
        if(selbstnachbarn[i][j-1]==_OST)
            {
            dynamischer_rand.entfernen_fl(i, j-1);
            }
        }
    selbstnachbarn[i][j-1] |= OST;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_suedwest_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j-1]==rang)
#else
    if(feld[i+1][j-1]>=0)
#endif
        {
        if(selbstnachbarn[i+1][j-1]==_NORD_OST)
            {
            dynamischer_rand.entfernen_fl(i+1, j-1);
            }
        }
    selbstnachbarn[i+1][j-1] |= NORD_OST;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_sued_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j]==rang)
#else
    if(feld[i+1][j]>=0)
#endif
        {
        if(selbstnachbarn[i+1][j]==_NORD)
            {
            dynamischer_rand.entfernen_fl(i+1, j);
            }
        }
    selbstnachbarn[i+1][j] |= NORD;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_nord_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j]==rang)
#else
    if(feld[i-1][j]>=0)
#endif
        {
        if(selbstnachbarn[i-1][j]==_SUED)
            {
            dynamischer_rand.entfernen_fl(i-1, j);
            }
        }
    selbstnachbarn[i-1][j] |= SUED;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_nordost_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j+1]==rang)
#else
    if(feld[i-1][j+1]>=0)
#endif
        {

        if(selbstnachbarn[i-1][j+1]==_SUED_WEST)
            {
            dynamischer_rand.entfernen_fl(i-1, j+1);
            }
        }
    selbstnachbarn[i-1][j+1] |= SUED_WEST;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_ost_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j+1]==rang)
#else
    if(feld[i][j+1]>=0)
#endif
        {
        if(selbstnachbarn[i][j+1]==_WEST)
            {
            dynamischer_rand.entfernen_fl(i, j+1);
            }
        }
    selbstnachbarn[i][j+1] |= WEST;
    }

// Kommentar: Analog zu 'hinzu_nordwest_dynamisch'
void Gitter::hinzu_suedost_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j+1]==rang)
#else
    if(feld[i+1][j+1]>=0)
#endif
        {
        if(selbstnachbarn[i+1][j+1]==_NORD_WEST) // Mte korrekt sein. Denn vorher snb < 255, hinterher snb = 255.
            {
            dynamischer_rand.entfernen_fl(i+1, j+1);
            }
        }
    selbstnachbarn[i+1][j+1] |= NORD_WEST;
    }

// Kommentar: Selbstnachbarn wird aktualisiert fr einen hinzugefgten Punkt (i,j)
void Gitter::punkt_hinzufuegen_selbstnachbarn(int i, int j)
    {
// Kommentar: Fhre fr alle Himmelsrichtungen die hinzu_Himmelsrichtung - Funktion aus. Aber ohne nderung der Randstruktur.
                    hinzu_nordwest(i,j);
                    hinzu_west(i,j);
                    hinzu_suedwest(i,j);
                    hinzu_sued(i,j);
                    hinzu_nord(i,j);
                    hinzu_nordost(i,j);
                    hinzu_ost(i,j);
                    hinzu_suedost(i,j);

    }

// Kommentar: Selbstnachbarn wird aktualisiert fr einen hinzugefgten Punkt (i,j). Die dynamische Randliste wird auch aktualisiert.
void Gitter::punkt_hinzufuegen_selbstnachbarn_dynamisch(int i, int j)
    {
#ifdef AKTUELLE_KOMMENTARE
    if((rang==3)&&(gitterebene==0))
        {
        cout << " PHSD: " << i << " " << j << " " << rang << ";" << " m " << m << " n " << n << endl;
        }
#endif
#ifdef AUSGABEN_GITTER
    cout << "phsd 1.0 rang " << rang << " i " << i << " j " << j << " ebene " << gitterebene << endl;
#endif

// Kommentar: Es werden fr alle Himmelsrichtungen HR hinzu_HR_dynamisch aufgerufen. Das fhrt zu einem Update von
// selbstnachbarn und der dynamischen Randliste.
    hinzu_nordwest_dynamisch(i,j);
    hinzu_west_dynamisch(i,j);
#ifdef AUSGABEN_GITTER
    cout << "phsd 1.02 rang " << rang << " i " << i << " j " << j << " ebene " << gitterebene << endl;
#endif
    hinzu_suedwest_dynamisch(i,j);
#ifdef AUSGABEN_GITTER
    cout << "phsd 1.03 rang " << rang << " i " << i << " j " << j << " ebene " << gitterebene << endl;
    if((i<n-1)&&(j<m))
        {
        cout << " phsd 1.03a rang " << rang << " i " << i << " j " << j << " feld(i,j) " << feld[i][j] << " feld(i+1,j) " << feld[i+1][j] << " fgff(i,j) " << farbenfeld[i][j] << " fgff(i+1,j) " << farbenfeld[i+1][j] << endl;
        }
#endif
    hinzu_sued_dynamisch(i,j);
#ifdef AUSGABEN_GITTER
    cout << "phsd 1.04 rang " << rang << " i " << i << " j " << j << " ebene " << gitterebene << endl;
#endif
    hinzu_nord_dynamisch(i,j);
    hinzu_nordost_dynamisch(i,j);
    hinzu_ost_dynamisch(i,j);
    hinzu_suedost_dynamisch(i,j);

#ifdef AUSGABEN_GITTER
    cout << "phsd 1.1 rang " << rang << " i " << i << " j " << j << " ebene " << gitterebene << endl;
#endif

        {
// Kommentar: Der Punkt (i,j) existierte auf diesem Gitter noch nicht. Deswegen wird er bei selbstnachbarn(i,j)<255
// in die dynamische Randpunktliste eingefgt.
        if(selbstnachbarn[i][j]<255) // Hat nicht nur Nachbarpunkte auf dem eigenen Gitter
            {
            dynamischer_rand.einfuegen_fl(i, j);
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "phsd 1.2 rang " << rang << " i " << i << " j " << j << " ebene " << gitterebene << endl;
#endif
    }

// Kommentar: Diese Funktionen ndert selbstnachbarn beim entfernen von Punkten. Die aktuellere Variante ist hinweg_nordwest_dynamisch - mit der Aktualisierung
// der Randpunktliste. Das geschieht hier nicht.
void Gitter::hinweg_nordwest(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j-1]==rang)
#else
    if(feld[i-1][j-1]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _NORD_WEST;
        selbstnachbarn[i-1][j-1] &= _SUED_OST;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_west(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j-1]==rang)
#else
    if(feld[i][j-1]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _WEST;
        selbstnachbarn[i][j-1] &= _OST;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_suedwest(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j-1]==rang)
#else
    if(feld[i+1][j-1]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _SUED_WEST;
        selbstnachbarn[i+1][j-1] &= _NORD_OST;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_sued(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j]==rang)
#else
    if(feld[i+1][j]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _SUED;
        selbstnachbarn[i+1][j] &= _NORD;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_suedost(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j+1]==rang)
#else
    if(feld[i+1][j+1]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _SUED_OST;
        selbstnachbarn[i+1][j+1] &= _NORD_WEST;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_ost(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j+1]==rang)
#else
    if(feld[i][j+1]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _OST;
        selbstnachbarn[i][j+1] &= _WEST;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_nordost(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j+1]==rang)
#else
    if(feld[i-1][j+1]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _NORD_OST;
        selbstnachbarn[i-1][j+1] &= _SUED_WEST;
        }
    }

// Kommentar: Vergleiche den Kommentar von hinweg_nordwest.
void Gitter::hinweg_nord(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j]==rang)
#else
    if(feld[i-1][j]>=0)
#endif
        {
        selbstnachbarn[i][j] &= _NORD;
        selbstnachbarn[i-1][j] &= _SUED;
        }
    }

// Kommentar: Diese Funktion entspricht punkt_entfernen_selbstnachbarn_dynamisch, aber ohne nderung der Randpunktliste. Kommentare entsprechend der dortigen Funktion.
void Gitter::punkt_entfernen_selbstnachbarn(int i, int j)
    {
                    hinweg_nordwest(i,j);
                    hinweg_west(i,j);
                    hinweg_suedwest(i,j);
                    hinweg_sued(i,j);
                    hinweg_nord(i,j);
                    hinweg_nordost(i,j);
                    hinweg_ost(i,j);
                    hinweg_suedost(i,j);
    }

// Kommentar: Der Punkt (i,j) wird entfernt. In Richtung Nordwest muss ggf. die Struktur selbstnachbarn 2 - fach abgewandelt werden:
// Die dynamische Randpunktliste wird aktualisiert.
void Gitter::hinweg_nordwest_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j-1]==rang)
#else
// Kommentar: Wenn in Nord - West - Richtung ein Gitterpunkt existiert ...
    if(feld[i-1][j-1]>=0)
#endif
        {
// Kommentar: Wenn mit diesem Punkt fr den Punkt(i,j) ein Rand entsteht, er vorher aber im Inneren lag ...
        if(selbstnachbarn[i-1][j-1]==255)
            {
// Kommentar: ... dann fge ihn in die Randpunktliste ein.
            dynamischer_rand.einfuegen_fl(i-1, j-1);
            }
        }
// Kommentar: Verzeichne fr den Punkt (i-1,j-1) in Bezug auf die Struktur selbstnachbarn, dass in seiner Sd - Ost - Richtung
// kein Punkt mehr existiert.
    selbstnachbarn[i-1][j-1] &= _SUED_OST;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_west_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j-1]==rang)
#else
    if(feld[i][j-1]>=0)
#endif
        {
        if(selbstnachbarn[i][j-1]==255)
            {
            dynamischer_rand.einfuegen_fl(i, j-1);
            }
        }
    selbstnachbarn[i][j-1] &= _OST;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_suedwest_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j-1]==rang)
#else
    if(feld[i+1][j-1]>=0)
#endif
        {
        if(selbstnachbarn[i+1][j-1]==255)
            {
            dynamischer_rand.einfuegen_fl(i+1, j-1);
            }
        }
    selbstnachbarn[i+1][j-1] &= _NORD_OST;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_sued_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j]==rang)
#else
    if(feld[i+1][j]>=0)
#endif
        {
        if(selbstnachbarn[i+1][j]==255)
            {
            dynamischer_rand.einfuegen_fl(i+1, j);
            }
        }
    selbstnachbarn[i+1][j] &= _NORD;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_suedost_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i+1][j+1]==rang)
#else
    if(feld[i+1][j+1]>=0)
#endif
        {
        if(selbstnachbarn[i+1][j+1]==255)
            {
            dynamischer_rand.einfuegen_fl(i+1, j+1);
            }
        }
    selbstnachbarn[i+1][j+1] &= _NORD_WEST;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_ost_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i][j+1]==rang)
#else
    if(feld[i][j+1]>=0)
#endif
        {
        if(selbstnachbarn[i][j+1]==255)
            {
            dynamischer_rand.einfuegen_fl(i, j+1);
            }
        }
    selbstnachbarn[i][j+1] &= _WEST;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_nordost_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j+1]==rang)
#else
    if(feld[i-1][j+1]>=0)
#endif
        {
        if(selbstnachbarn[i-1][j+1]==255)
            {
            dynamischer_rand.einfuegen_fl(i-1, j+1);
            }
        }
    selbstnachbarn[i-1][j+1] &= _SUED_WEST;
    }

// Kommentar: Diese Funktion funktioniert genau wie hinweg_nordwest_dynamisch.
void Gitter::hinweg_nord_dynamisch(int i, int j)
    {
#ifdef FARBENFELD_PRUEFEN
    if(farbenfeld[i-1][j]==rang)
#else
    if(feld[i-1][j]>=0)
#endif
        {
        if(selbstnachbarn[i-1][j]==255) // Wenn vorher snb == 255 ist, entsteht ein Randpunkt, und der wird in dynamischer_rand eingefuegt.
                                        // Bei snb == 255 waren sie noch nicht eingetragen. Das erfolgt in dieser Funktion.
            {
            dynamischer_rand.einfuegen_fl(i-1, j);
            }
        }
    selbstnachbarn[i-1][j] &= _SUED;
    }

// Kommentar: Es wird die Struktur selbstnachbarn sowie die Randpunktliste dynamischer_rand so gendert, wie es
// sein muss, wenn ein Gitterpunkt entfernt wird.
void Gitter::punkt_entfernen_selbstnachbarn_dynamisch(int i, int j)
    {
#ifdef AUSGABEN_GITTER
    cout << " pesd: rang " << rang << " i " << i << " j " << j << endl;
#endif

//Der Punkt kann hinterher nicht mehr in der Liste stehen! Also: Entfernen falls er vorher drin stand

// Kommentar: War der Punkt (i,j) ein Randpunkt, dann ist er aus der Randpunktliste zu entfernen, da er
// nicht mehr zu diesem Gitter gehrt.
#ifdef AKTUELLE_KOMMENTARE
    cout << " In pesd: Vor dynamischem Rand entfernen rang " << rang << " i " << i << " j " << j << " gitterebene " << gitterebene << endl;
#endif
    if(dynamischer_rand.feld[i][j]>=0)
        {
        dynamischer_rand.entfernen_fl(i, j);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " In pesd: Nach dynamischem Rand entfernen rang " << rang << " i " << i << " j " << j << " gitterebene " << gitterebene << endl;
#endif
// Kommentar: selbstnachbarn(i,j) wird nicht gendert, da die benachbarten Punkte dableiben.
// Kommentar: Fhre hinweg_HR_dynamisch fr alle Himmelsrichtungen HR aus.
                    hinweg_nordwest_dynamisch(i,j);
                    hinweg_west_dynamisch(i,j);
                    hinweg_suedwest_dynamisch(i,j);
                    hinweg_sued_dynamisch(i,j);
                    hinweg_nord_dynamisch(i,j);
                    hinweg_nordost_dynamisch(i,j);
                    hinweg_ost_dynamisch(i,j);
                    hinweg_suedost_dynamisch(i,j);
#ifdef AKTUELLE_KOMMENTARE
    cout << " In pesd: Nach allen hinwegs " << rang << endl;
#endif
    }

// Kommentar: Die Listen f_innen_2 und g_innen_2 werden angelegt - fr sequentielle Rechnen ab h_kappe. Sie werden aber eigentlich
// nicht mehr gebraucht, vgl. das Anlegen von Restriktionen und Prolongationen in der Klasse ZyklusRechnen.
void Gitter::initialisieren_zusatzlisten(void)
// wird finalisiert, s.u.
    {
#ifdef KURZ_PUNKTE
    f_innen_2 = new short int [mn];
    g_innen_2 = new short int [mn];
#else
    f_innen_2 = new int [mn];
    g_innen_2 = new int [mn];
#endif
    }

// Kommentar: Der Speicher fr f_innnen_2 und g_innen_2 wird freigegeben.
void Gitter::finalisieren_zusatzlisten(void)
    {
    delete f_innen_2;
    delete g_innen_2;
    }

// Kommentar: Hier werden elementare Parameter definiert, und Felder angelegt. Es wird eben die Klasse initialisiert.
void Gitter::initialisieren_gitter(int _n, int _m, int _groesse, int _rang)
    {
#ifdef AUSGABEN_GITTER
    cout << " Beginn initialisieren gitter rang " << rang << endl;
#endif // AUSGABEN_GITTER
// Kommentar: Die bentigten Parameter werden angelegt.
    n = _n;
    m = _m;
    groesse = _groesse;
    rang = _rang;

    mn = m*n;
// Kommentar: Der Speicher fr die Punktmengen, die in Zyklus Rechnen an Rechnen und Prolongation bergeben werden,
// werden hier angelegt.
#ifdef KURZ_PUNKTE
    f_innen = new short int [mn];
    g_innen = new short int [mn];

    f_rand_innen = new short int [mn];
    g_rand_innen = new short int [mn];

    f_rand_innen_echter_rand = new short int [mn];
    g_rand_innen_echter_rand = new short int [mn];
#else
    f_innen = new int [mn];
    g_innen = new int [mn];

    f_rand_innen = new int [mn];
    g_rand_innen = new int [mn];

    f_rand_innen_echter_rand = new int [mn];
    g_rand_innen_echter_rand = new int [mn];
#endif

    f_innen_klein = new short int [mn];
    g_innen_klein = new short int [mn];

    f_rand_innen_klein = new short int [mn];
    g_rand_innen_klein = new short int [mn];

    f_rand_innen_klein_echter_rand = new short int [mn];
    g_rand_innen_klein_echter_rand = new short int [mn];

    f_innen_nicht_klein = new short int [mn];
    g_innen_nicht_klein = new short int [mn];

    f_rand_innen_nicht_klein = new short int [mn];
    g_rand_innen_nicht_klein = new short int [mn];


    f_aussen = new short int [mn];
    g_aussen = new short int [mn];

    // alle (f,g) werden freigegeben.

    anzahl = 0;

// Kommentar: Die Parameter m und n werden um 2 erhht, damit man beim Farbenfeld und selbstnachbarn einen Rand hat
// damit Zugriffe dort keine Fehlermeldung produzieren.
    n_plus_2 = n + 2;
    m_plus_2 = m + 2;

    n_minus1 = n - 1;
//    n_minus2 = n - 2; // 6.2.16: Lassen, falls es noch gebraucht werden sollte.
    m_minus1 = m - 1;
//    m_minus2 = m - 2;

// Kommentar: Die Zeiger fr farbenfeld und selbstnachbarn werden mit Speicherplatz versorgt.

#ifdef KURZ_FF
    farbenfeld_speichern = new short int * [n_plus_2];
#else
    farbenfeld_speichern = new int * [n_plus_2];
#endif
    selbstnachbarn_speichern = new int * [n_plus_2];

#ifdef KURZ_FF
    farbenfeld = new short int * [n_plus_2];
#else
    farbenfeld = new int * [n_plus_2];
#endif
    selbstnachbarn = new int * [n_plus_2];

    // farbenfeld und selbstnachbarn werden unten freigegeben.

// Kommentar: Die Farbenfeld und selbstnachbarn Strukturen werden so angelegt, dass drum herum ein Rand bleibt.
    for(i=0; i<n_plus_2; i++)
        {
#ifdef KURZ_FF
        farbenfeld_speichern[i] = new short int [m_plus_2];
#else
        farbenfeld_speichern[i] = new int [m_plus_2];
#endif
        selbstnachbarn_speichern[i] = new int [m_plus_2];

        farbenfeld [i] = farbenfeld_speichern[i] + 1;
        selbstnachbarn [i] = selbstnachbarn_speichern [i] + 1;

        for(j=0; j<m_plus_2; j++)
            {
// Kommentar: Selbstnachbarn wird mit 0,
            selbstnachbarn_speichern[i][j] = 0;
            farbenfeld_speichern[i][j] = rang;
            if((i==0)||(i==n_plus_2-1)||(j==0)||(j==m_plus_2-1))
                {
                farbenfeld_speichern[i][j] = -2;
                }
            else
                {
                farbenfeld_speichern[i][j] = -1;
                }
            }
        }

    farbenfeld = farbenfeld + 1;
    selbstnachbarn = selbstnachbarn + 1;
// farbenfeld_speichern und selbstnachbarn_speichern werden unten wieder freigegeben.

// Kommentar: Diese Struktur ausgabe_feld dient der Ausgabe, also dem Debugging, und wird hier mit Speicherplatz versorgt.
#ifdef KURZ_AF
    ausgabe_feld = new bool * [n];
#else
    ausgabe_feld = new int * [n];
#endif

    for(i=0; i<n; i++)
        {
#ifdef KURZ_AF
        ausgabe_feld[i] = new bool [m];
#else
        ausgabe_feld[i] = new int [m];
#endif
        for(j=0; j<m; j++)
            {
            ausgabe_feld[i][j] = false;
            }
        }
    // Wird unten wieder freigegeben.

// Kommentar: Das Farbenfeld wird mit der Anfangsaufteilung beschrieben.

    if(gitterebene>=h_min)
        {
        for(i=0; i<n; i++)
            {
            for(j=0; j<m; j++)
                {
                farbenfeld[i][j] = farbe(i,j);
                }
            }
        }

#ifdef AUSGABEN_GITTER
    if((rang==0)&&(gitterebene==2))
        {
        cout << " Farbaufteilung Rang 0 Gitterebene 2 " << endl;

        for(i=0; i<n; i++)
            {
            for(j=0; j<m; j++)
                {
                cout << farbenfeld[i][j] << " ";
                }
            cout << endl;
            }
        cout << " Ende Farbaufteilung Rang 0 Gitterebene 2 " << endl;
        }
#endif // AUSGABEN_GITTER

#ifdef AUSGABEN_GITTER
    cout << " Vor initialisieren_fl rang " << rang << endl;
#endif // AUSGABEN_GITTER

// Kommentar: Die Feldiste dieses Gitters wird angelegt.
    initialisieren_fl(n, m, rang); // Wird unten wieder freigegeben.

#ifdef AUSGABEN_GITTER
    cout << " Nach initialisieren_fl rang " << rang << endl;
#endif // AUSGABEN_GITTER
// Kommentar: Zum Sammeln der Koordinaten der Punkte des Gitters in Form von Vektoren wird hier der Speicher angelegt.
    initialisieren_gitter_sammeln(n, m, feld, rang);

// Kommentar: Das hier ist immer true. Deshalb wird die dynamische Randpunktliste als Feldliste angelegt.
    if(ist_dynamischer_rand==true)
        {
        dynamischer_rand.initialisieren_fl(n, m, rang); // Wird, ebenfalls optional, unten wieder freigegeben.
        }

// Kommentar: Entsprechend dem Farbenfeld werden die Punkte in die Feldliste eingefgt.
    if(gitterebene>=h_min)
        {
        lade_punkte(); // Kein anlegen von Speicherplatz
        }

// Kommentar: Hier werden sie ggf. ausgegeben.
    ausgeben_punkte();

//    selbstnachbarn_punkte_hinzu(f, g, anzahl);

// Kommentar: Bisher war selbstnachbarn auf 0 gesetzt. Aufgrund der in die Feldliste eingefgten Punkte
// wird nun selbstnachbarn aktualisiert - entsprechend den auf diesem Gitter existierenden Punkten.
    selbstnachbarn_punkte_hinzu(); // Kein anlegen von Speicherplatz.

// Kommentar: Die dynamische Randliste muss den Rand des anfnglichen Gitters speichern in der Randpunkte - Feldliste.
    if(ist_dynamischer_rand==true)
        {
        setze_dynamischen_rand(); // Hier wird kein Speicher angelegt.
        }

// Kommentar: Hier werden in Bezug auf die Mehrgittervariablen Matrizen angelegt.
    allokiere_werte(); // Unten Aufruf de_allokieren_werte. Speicher wird befreit.
// Kommentar: Hier werden die Anfangswerte dieser Variablen gesetzt.
    setzen_werte(); // legt keinen Speicher an.

// Kommentar: Diese Variable gehrt zu einem veralteten Zyklus. Sie bekommt noch Speicherplatz.
#ifdef MERKE_SCHIEBEN
    merke_schieben = new double * [n];
    for(i=0; i<n; i++)
        {
        merke_schieben[i] = new double [m];
        }
#endif
    // wird unten freigegeben
// Kommentar: Mit diesem Testfeld wird markiert, ob sich ein Punkt auf dem Auenrand des Gitters befindet. Hier
// wird dafr Speicher angelegt. Das wird nur gebraucht, falls die Randstruktur durch Vektorisierung entsteht.
    testfeld_aussen = new short int * [n];
    for(i=0; i<n; i++)
        {
        testfeld_aussen[i] = new short int [m];
        for(j=0; j<m; j++)
            {
            testfeld_aussen[i][j] = false;
            }
        }
    // wird unten freigegeben

// Kommentar: Das Folgende verknpft das testfeld_aussen mit der Klasse RandstrukturKommunikation.
    aussen_verknuepfen(); // legt keinen Speicherplatz an.
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "DA_Gitter");
    da_gitter.initialisieren(rang, zeichenkette);
    strcpy(zeichenkette, "DA_Gitterzwei");
    da_gitter2.initialisieren(rang, zeichenkette);
#endif
    strcpy(zeichenkette, "DA_Fehler");
    da_fehler.initialisieren(rang, zeichenkette);
    // Die da - Befehle legen bei initialisieren keinen Speicher an. Geoeffnetes wird geschlossen, s.u..
    da_gitter_ist_da = true;
// Kommentar: iip prft, ob ein Punkt ein echter Randpunkt ist. Diese Struktur wird hiermit vorbereitet.
    iip.initialisieren(farbenfeld, selbstnachbarn);
    // Hier wird kein Speicherplatz angelegt.

// Kommentar Diese Struktur ist veraltet aus der Zeit der EbeneEbenenZhler. Sie bekommt etwas Speicherplatz
    verbindungszaehler = new int [groesse];
    // wird freigegeben
// Kommentar: Hier wei schreibe_gp_datafile seine eigene ID.
    schreibe_gp_datafile.rang = rang;
// Kommentar: Diese Struktur wird auch nicht mehr gebraucht.
    f_alter_rand = new int [5*n+5*m];
    g_alter_rand = new int [5*n+5*m];
    // f,g werden freigegeben
    anzahl_alter_rand = 0;
// Kommentar: Diese Struktur dient nur dem Debugging.
    lasten = new int [groesse];
    // wird freigegeben
    fehler_festgestellt = false;
    }

// Kommentar: Verknpft das testfeld_aussen und f_aussen und g_aussen mit der Klasse randstruktur_kommununikation.
void Gitter::aussen_verknuepfen(void)
    {
    for(i=0; i<groesse; i++)
        {
        randstruktur_kommunikation[i].f_aussen = f_aussen;
        randstruktur_kommunikation[i].g_aussen = g_aussen;
        randstruktur_kommunikation[i].testfeld_aussen = testfeld_aussen;
        }
    }

// Kommentar: Hier werden die in initialisieren_gitter angelegten Strukturen freigegeben.
// Sie braucht also nicht kommentiert werden, weil die Informationen zu den Strukturen schon in
// initialisieren_gitter besprochen worden sind. Sie werden hier nur abgebaut statt angelegt.
void Gitter::finalisieren_gitter(void)
    {
    if(rang==0)
        {
        cout << " In finalisieren gitter a rang 0 " << endl;
        }
    delete lasten;
    if(rang==0)
        {
        cout << " In finalisieren gitter b rang 0 " << endl;
        }
    delete f_alter_rand;

    if(rang==0)
        {
        cout << " In finalisieren gitter c rang 0 " << endl;
        }

    delete g_alter_rand;

    if(rang==0)
        {
        cout << " In finalisieren gitter d rang 0 " << endl;
        }

    delete verbindungszaehler;

    if(rang==0)
        {
        cout << " In finalisieren gitter e rang 0 " << endl;
        }

// ist alles neu

    for(i=0; i<n; i++)
        {
        delete testfeld_aussen[i];
        }
    delete testfeld_aussen;

    if(rang==0)
        {
        cout << " In finalisieren gitter f rang 0 " << endl;
        }

#ifdef MERKE_SCHIEBEN
    for(i=0; i<n; i++)
        {
        delete merke_schieben[i];
        }
    delete merke_schieben;
#endif

    if(rang==0)
        {
        cout << " In finalisieren gitter g rang 0 " << endl;
        }

    if(ist_dynamischer_rand==true)
        {
        dynamischer_rand.finalisieren_fl();
        }

    if(rang==0)
        {
        cout << " In finalisieren gitter h rang 0 " << endl;
        }

    delete f_innen;
    delete g_innen;

    if(rang==0)
        {
        cout << " In finalisieren gitter i rang 0 " << endl;
        }

    delete f_rand_innen;
    delete g_rand_innen;

    delete f_rand_innen_echter_rand;
    delete g_rand_innen_echter_rand;

    delete f_rand_innen_klein_echter_rand;
    delete g_rand_innen_klein_echter_rand;


    if(rang==0)
        {
        cout << " In finalisieren gitter j rang 0 " << endl;
        }

    delete f_innen_klein;
    delete g_innen_klein;

    if(rang==0)
        {
        cout << " In finalisieren gitter k rang 0 " << endl;
        }

    delete f_rand_innen_klein;
    delete g_rand_innen_klein;

    if(rang==0)
        {
        cout << " In finalisieren gitter l rang 0 " << endl;
        }

    delete f_innen_nicht_klein;
    delete g_innen_nicht_klein;

    if(rang==0)
        {
        cout << " In finalisieren gitter m rang 0 " << endl;
        }

    delete f_rand_innen_nicht_klein;
    delete g_rand_innen_nicht_klein;

    if(rang==0)
        {
        cout << " In finalisieren gitter n rang 0 " << endl;
        }

    delete f_aussen;
    delete g_aussen;

    if(rang==0)
        {
        cout << " In finalisieren gitter o rang 0 " << endl;
        }

    for(i=0; i<n_plus_2; i++)
        {
        delete farbenfeld_speichern[i];
        delete selbstnachbarn_speichern[i];
        }

    if(rang==0)
        {
        cout << " In finalisieren gitter p rang 0 " << endl;
        }

    for(i=0; i<n; i++)
        {
        delete ausgabe_feld[i];
        }

    if(rang==0)
        {
        cout << " In finalisieren gitter q rang 0 " << endl;
        }

    delete farbenfeld_speichern;
    delete selbstnachbarn_speichern;

    if(rang==0)
        {
        cout << " In finalisieren gitter r rang 0 " << endl;
        }

    farbenfeld = farbenfeld - 1;
    selbstnachbarn = selbstnachbarn - 1;


    delete farbenfeld;
    delete selbstnachbarn;

    if(rang==0)
        {
        cout << " In finalisieren gitter s rang 0 " << endl;
        }

    delete ausgabe_feld;

    if(rang==0)
        {
        cout << " In finalisieren gitter t rang 0 " << endl;
        }

    finalisieren_gitter_sammeln();

    if(rang==0)
        {
        cout << " In finalisieren gitter u rang 0 " << endl;
        }

    finalisieren_fl();

    if(rang==0)
        {
        cout << " In finalisieren gitter v rang 0 " << endl;
        }

    de_allokiere_werte();

    if(rang==0)
        {
        cout << " In finalisieren gitter w rang 0 " << endl;
        }
    }

// Kommentar: Hier werden die Anfangswerte der Mehrgittervariablen angelegt. Zu den Formeln vergleiche man die Arbeit von Herrn Prof. Joppich.
void Gitter::setzen_werte(void)
    {
// Kommentar: Die Struktur x0 wird nicht mehr gebraucht.
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            #ifdef dimensionen1
            x0[i][j] = i*i*j*j;
            #endif
            #ifdef dimensionen2
            x0[i][j] = i*i*j*j;
            x1[i][j] = x0[i][j];
            #endif
            #ifdef dimensionen3
            x0[i][j] = i*i*j*j;
            x1[i][j] = x0[i][j];
            x2[i][j] = x0[i][j];
            #endif
            #ifdef dimensionen4
            x0[i][j] = i*i*j*j;
            x1[i][j] = x0[i][j];
            x2[i][j] = x0[i][j];
            x3[i][j] = x0[i][j];
            #endif
            }
        }

// Kommentar: Die Gitterabstnde werden bestimmt.
    h_y = 1 / (double(m) - 1);
    h_x = 1 / (double(n) - 1);

// Kommentar: Weitere Parameter werden bestimmt.
    h_xh_y = h_x * h_y;
    eins_durch_h_xh_y = 1 / h_xh_y;

// Kommentar: Die Werte x_i = i * h_x und y_1 = i * h_y werden angelegt.
    for(i=0; i<n; i++)
        {
        x_i [i] = h_x * double(i);
        }

    for(j=0; j<m; j++)
        {
        y_j [j] = h_y * double(j);
        }

// Kommentar: Im Folgenden werden die Werte nach dem Buch von Prof. Joppich - vgl. die Literaturliste - gesetzt.

// Kommentar: Am Rand des feinsten Gitters werden Lsungswerte der partiellen Differentialgleichung angegeben. Das entspricht
// u = g auf Rand(Omega) in der Differentialgleichung.

// Kommentar: Zuerst wird u0 auf 0 gesetzt.
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            u0[i][j] = 0;
            }
        }

    if(gitterebene==0)
        {
        for(i=0; i<n; i=i+n-1)
            {
            for(j=0; j<m; j++)
                {
                x = x_i[i];
                y = y_j[j];
                u0[i][j] = x*x*x*x*y*y*y;
                }
            }
        for(i=0; i<n; i++)
            {
            for(j=0; j<m; j=j+m-1)
                {
                x = x_i[i];
                y = y_j[j];
                u0[i][j] = x*x*x*x*y*y*y;
                }
            }
        }

// Kommentar: Um die durch das Programm berechneten WErte auf ihre Genauigkeit zu testen , wird mit exakt
// die perfekte Lsung der Differentialgleichungen auf dem Gebiet berechnet und gespeichert.

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            x = x_i[i];
            y = y_j[j];
            exakt[i][j] = x*x*x*x*y*y*y;
            }
        }

#ifdef AKTUELLE_WERTE
    cout << " setzen exakt / ebene " << gitterebene << endl;

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << exakt[i][j] << " ";
            }
        cout << endl;
        }
    cout << endl;
#endif

    cout << " setzen Werte f / ebene " << gitterebene << endl;

// Kommentar: die Funktionswerte f und die rechte Seite bekommen ihre Startwerte.
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            x = x_i[i];
            y = y_j[j];

            f0[i][j] = -6.0 * (x*x*y*(x*x+2*y*y));
            rS0[i][j] = f0[i][j];  // Deswegen muss fr Ebene 0 nicht glaetter und glaetter_f unterschieden werden.
#ifdef DEBUG
#ifndef AKTUELLE_WERTE
            cout << f0[i][j] << " ";
#endif
#endif
            }
#ifdef DEBUG
#ifndef AKTUELLE_WERTE
        cout << endl;
#endif
#endif
        }
#ifdef DEBUG
#ifndef AKTUELLE_WERTE
    cout << endl;
#endif
#endif
#ifdef SHALLOW_WATER_EQUATIONS
// Kommentar: Hier werden Variablenwerte der von mir genderten Version einer Implementierung von Herrn Hess der Shallow Water Equations auf Startwerte gesetzt.
// Da es um die Zeiten, und nicht um die Werte geht, spielt das hier keine so groe Rolle.
    for(i=0; i<n; i++)
        {
        for(j=0; j<n; j++)
            {
            laden[i][j] = double(i+j);
            }
        }
    for(i=0; i<m; i++)
        {
        vf[i] = (1.0+double(i))/10;
        }
    for(i=0; i<=2*m; i++)
        {
        vf_2[i] = (1.0+double(i))/10;
        }
#endif
    }

// Kommentar: Der Speicherplatz fr die Mehrgittervariablen wird angelegt.
void Gitter::allokiere_werte(void)
    {
// Kommentar: Zuerst werden die Variablen x0 und y0 angelegt. Diese spielen aber hchstens noch bei der Punktlastrechnung
// bzw. der Jacoby - Methode eine Rolle.
#ifdef dimensionen1
    x0 = new double * [n];
    y0 = new double * [n];

    for(i=0; i<n; i++)
        {
        x0[i] = new double [m];

        y0[i] = new double [m];
        }
#endif
#ifdef dimensionen2
    x0 = new double * [n];
    y0 = new double * [n];

    x1 = new double * [n];
    y1 = new double * [n];

    for(i=0; i<n; i++)
        {
        x0[i] = new double [m];
        y0[i] = new double [m];

        x1[i] = new double [m];
        y1[i] = new double [m];
        }
#endif
#ifdef dimensionen3
    x0 = new double * [n];
    y0 = new double * [n];

    x1 = new double * [n];
    y1 = new double * [n];

    x2 = new double * [n];
    y2 = new double * [n];

    for(i=0; i<n; i++)
        {
        x0[i] = new double [m];
        y0[i] = new double [m];

        x1[i] = new double [m];
        y1[i] = new double [m];

        x2[i] = new double [m];
        y2[i] = new double [m];
        }
#endif
#ifdef dimensionen4
    x0 = new double * [n];
    y0 = new double * [n];

    x1 = new double * [n];
    y1 = new double * [n];

    x2 = new double * [n];
    y2 = new double * [n];

    x3 = new double * [n];
    y3 = new double * [n];

    for(i=0; i<n; i++)
        {
        x0[i] = new double [m];
        y0[i] = new double [m];

        x1[i] = new double [m];
        y1[i] = new double [m];

        x2[i] = new double [m];
        y2[i] = new double [m];

        x3[i] = new double [m];
        y3[i] = new double [m];
        }
#endif

// Kommentar: Die Mehrgittervariablen der Poisson - Gleichungen wird angelegt. Die Variablen der von mir genderten Version der Implementierung von Herrn Hess der Shallow Water Equations
// werden darauf verknpft, damit dieser Speicher nicht doppelt vorliegt.

    u0 = new double * [n];
    r0 = new double * [n];
    Iu0 = new double * [n];
    f0 = new double * [n];
    If0 = new double * [n];
    rS0 = new double * [n];
    tau = new double * [n];
    e0 = new double * [n];
    Lu0 = new double * [n];
    ILu0 = new double * [n];
    DF0 = new double * [n];
    u0_hilf = new double * [n];
    exakt = new double * [n];

    for(i=0; i<n; i++)
        {
        u0[i] = new double [m];
        r0[i] = new double [m];
        Iu0[i] = new double [m];
        f0[i] = new double [m];
        If0[i] = new double [m];
        rS0[i] = new double [m];
        tau[i] = new double [m];
        e0[i] = new double [m];
        Lu0[i] = new double [m];
        ILu0[i] = new double [m];
        DF0[i] = new double [m];
        u0_hilf[i] = new double [m];
        exakt[i] = new double [m];
        }

// Kommentar: Hier die Verknpfung der 11 Mehrgittervariablen, die der genderten Version der Shallow Water Equations zugeordnet wurden.
// In seinem Programmcode stehen dafr andere Bezeichnungen.
#ifdef SHALLOW_WATER_EQUATIONS
    v1 = u0;
    v2 = r0;
    v3 = Iu0;
    v4 = f0;
    v5 = If0;
    v6 = rS0;
    v7 = tau;
    v8 = e0;
    v9 = Lu0;
    v10 = ILu0;
    v11 = DF0;
    laden = exakt;
    vf = new double [m];
    vf_2 = new double [(m<<1)+1];
#endif

// Kommentar: x_i und y_i werden zur schnelleren Berechnung vorher berechnet, und dann gespeichert. Dafr
// muss auch Speicherplatz angelegt werden.
    x_i = new double [n]; // gendert am 16.4.15
    y_j = new double [m];

// Kommentar: Das folgende ist eine Verknpfung von Zeigern, damit fr tau_1 und tau_2 kein extra Speicher angelegt werden muss.

    tau_1 = f0;
    tau_2 = tau;

    // Werden jetzt - 15.05.2014 - komplett deallokiert.
    }

// Kommentar: Hier wird der Speicher deallokiert, der in obiger Funktion allokiere_werte angelegt wurde. Da die
// Variablen schon dort kommentiert wurden, braucht das hier nicht mehr gemacht werden. Nur diese Bemerkung:
// Die verknpften Variablen brauchen und drfen nur einmal freigegeben werden.
void Gitter::de_allokiere_werte(void)
    {
    cout << " de allokiere werte ; n " << n << endl;
#ifdef dimensionen1
    for(i=0; i<n; i++)
        {
#ifdef AUSGABEN_GITTER
        cout << "delete x0[" << i << "]" << endl;
#endif
        delete x0[i];
#ifdef AUSGABEN_GITTER
        cout << "delete y0[" << i << "]" << endl;
#endif
        delete y0[i];
        }
    delete x0;
    delete y0;
#endif
#ifdef dimensionen2
    for(i=0; i<n; i++)
        {
        delete x0[i];
        delete y0[i];

        delete x1[i];
        delete y1[i];
        }
    delete x0;
    delete y0;
    delete x1;
    delete x2;
#endif
#ifdef dimensionen3
    for(i=0; i<n; i++)
        {
        delete x0[i];
        delete y0[i];

        delete x1[i];
        delete y1[i];

        delete x2[i];
        delete y2[i];
        }
    delete x0;
    delete y0;
    delete x1;
    delete y1;
    delete x2;
    delete y2;
#endif
#ifdef dimensionen4
    for(i=0; i<n; i++)
        {
        delete x0[i];
        delete y0[i];

        delete x1[i];
        delete y1[i];

        delete x2[i];
        delete y2[i];

        delete x3[i];
        delete y3[i];
        }
    delete x0;
    delete y0;
    delete x1;
    delete y1;
    delete x2;
    delete y2;
    delete x3;
    delete y3;
#endif
    delete x_i;
    delete y_j;

    for(i=0; i<n; i++)
        {
        delete u0[i];
        delete r0[i];
        delete Iu0[i];
        delete f0[i];
        delete If0[i];
        delete rS0[i];
        delete tau[i];
        delete e0[i];
        delete Lu0[i];
        delete ILu0[i];
        delete DF0[i];
        delete u0_hilf[i];
        delete exakt[i];
        }

    delete u0;
    delete r0;
    delete Iu0;
    delete If0;
    delete rS0;
    delete tau;
    delete e0;
    delete Lu0;
    delete ILu0;
    delete DF0;
    delete u0_hilf;
    delete exakt;

#ifdef SHALLOW_WATER_EQUATIONS
    delete vf;
    delete vf_2;
#endif

    cout << "Werte fertig de allokiert " << endl;
    }

// Kommentar: Eine Debugging - Funktion.
void Gitter::ausgeben_selbstnachbarn(void)
    {
#ifdef AUSGABEN_GITTER
    cout << "Ausgeben Selbstnachbarn " << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << selbstnachbarn[i][j] << " ";
            }
        cout << endl;
        }
#endif
    }

// Kommentar: Diese Funktion setzt die korrekten Selbstnachbarnwerte der Startaufteilung. Die dynamische Randpunktliste
// wird getrennt davon gefllt - zu Beginn der Iterationen.
void Gitter::selbstnachbarn_punkte_hinzu(void)
    {
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
#ifdef AUSGABEN_GITTER
        cout << "#" << j << "," << k ;
#endif
        punkt_hinzufuegen_selbstnachbarn(j,k);
        }
    }

// Kommentar: Das ist nur eine Debugging - Funktion.
void Gitter::ausgeben_punkte(void)
    {
#ifdef AUSGABEN_GITTER
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        cout << "(" << lesen_f() << " " << lesen_g() << ")";
        }
#endif
    }

// Kommentar: Das Anfangsfarbenfeld wird auf dem ganzen Gitter berechnet. Die Punkte, wo die eigene ID dieser Farbe entspricht,
// wird in die Feldliste eingefgt. So sind in der Feldliste nach Aufruf dieser Funktion genau die diesem Kern
// zugeteilten Gitterpunkte verzeichnet. In der Anfangsaufteilung.

void Gitter::lade_punkte(void)
    {
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            if(rang == farbenfeld[i][j])
                {
                einfuegen_fl(i, j);
                }
            }
        }
    }

// Kommentar: Das folgende ist die Startaufteilung der Ebenen h>h_kappe, wo alle Kerne auer dem rang = 0 Kern
// keine Punkt haben, und der rang = 0 Kern alle Punkte hat.
void Gitter::lade_punkte2(void)
    {
    if(rang!=0)
        {
        return;
        }

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            einfuegen_fl(i, j);
            }
        }
    }

// Kommentar: Die Farbenaufteilung beim Start wird hier berechnet.
int Gitter::farbe(int i, int j)
    {
    if(groesse==1)
        {
        return(0);
        }

    if(groesse==2)
        {
        farbe_g = (j * groesse_g+1)/m;
        return(farbe_g);
        }

// Kommentar: Man teilt einen vertikalen und horizontalen Farbwert zu, der jeweils linear in von der
// jeweiligen Koordiante abhngt.
    farbe_f = (i * groesse_f+1) / n;
    farbe_g = (j * groesse_g+1) / m;

// Kommentar: Zurckgegeben wird ein Farbwert, der den horizontalen und vertikalen Farbwert linear verknpft.
// Damit wird so, wie das hier erfolgt, das Gitter auf genau groesse_f * groesse_g viele Kerne verteilt.
    return(farbe_f * groesse_g + farbe_g);
    }

// Kommentar: Die warten - Funktionen warten eeine Zeit ab, die von dem eigenen Rang abhngt, nur zu dem Zweck,
// damit die cout - Ausgaben formatiert werden. Durch die Entwicklung von geeigneten Datei - Ausgaben
// konnte eine strukturierte Ausgabe ohne diese Wartezeiten erreicht werden.
void Gitter::wartenX(void)
    {
/*
    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
*/
    }

// Kommentar: Vergleiche den Kommentar von wartenX.
void Gitter::warten(void)
    {
#ifdef AUSGABEN
    #ifdef WARTEN
    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
    #endif
#endif
    }

// Kommentar: Vergleiche den Kommentar von wartenX.
void Gitter::warten3(void)
    {
#ifdef WARTEN
    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
#endif
    }

// Kommentar: Vergleiche den Kommentar von wartenX.
void Gitter::warten_fc(void)
    {
    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
    }

// Kommentar: Vergleiche den Kommentar von wartenX.
void Gitter::warten2(void)
    {
#ifdef AUSGABEN
    #ifdef WARTEN
    for(i=4000000; i<rang*4000000+4000000; i++)
        {
        cout << "";
        }
    #endif
#endif
    }

// Kommentar: Das gesamte Farbenfeld wird zurckgesetzt auf den Zustand eines leeren Gitters.
void Gitter::reset_farbenfeld(void)
    {
     for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            farbenfeld[i][j] = -1;
            }
        }
    }

// Das folgende ist eine Debugging - Funktion zur Farbenfeld - Ausgabe, die durch Warten (s.o.) eine Struktur
// in Bezug auf die Rnge erreicht.
void Gitter::ausgeben_farbenfeld(void)
    {
#ifdef WARTEN
    warten3();
#endif
#ifdef AUSGABEN_GITTER
    cout << endl;
    cout << "Ausgeben Farbenfeld. Rang: " << rang << " Gitterebene " << gitterebene << endl;

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
#endif
    }

// Kommentar: Die folgende Funktion ist auch eine Debugging - Funktion, die warten -  basierte cout - Ausgaben des
// Farbenfeldes macht, bzw. auch Dateiausgaben dieser Struktur.
void Gitter::ausgeben_farbenfeldX(void)
    {
    wartenX();

    cout << endl;
    cout << "Ausgeben FarbenfeldX. rang " << rang << " Gitterebene " << gitterebene << " Text " << fc_text << endl;
    cout << "Ausgeben FarbenfeldX. rang " << rang << " Gitterebene " << gitterebene << " Text " << endl;

    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Ausgeben FarbenfeldX Ende. rang " << rang << " Gitterebene " << gitterebene << endl;

    if(fehler_festgestellt==false)
        {
        return;
        }

    da_fehler.oeffnen(); // wird unten geschlossen

    * da_fehler.aus << endl;
    * da_fehler.aus << "Ausgeben FarbenfeldX. Rang: " << rang << " Gitterebene " << gitterebene << " Text " << fc_text << endl;

    for(i=0; i<n; i++)
        {
        * da_fehler.aus << i << " ";
        if(i<10)
            {
            * da_fehler.aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * da_fehler.aus << farbenfeld[i][j] << " ";
            }
        * da_fehler.aus << endl;
        }
    * da_fehler.aus << "Ausgeben FarbenfeldX Ende. Rang: " << rang << " Gitterebene " << gitterebene << endl;
    da_fehler.schliessen();
    }

// Das folgende ist eine Debugging - Funktion zur Farbenfeld - Ausgabe, die durch Warten (s.o.) eine Struktur
// in Bezug auf die Rnge erreicht.
void Gitter::ausgeben_farbenfeldXtext(char * text)
    {
    wartenX();

    cout << endl;
    cout << "Ausgeben FarbenfeldXtext. Rang: " << rang << " Gitterebene " << gitterebene << " Text " << text << endl;

    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Ausgeben FarbenfeldXtext Ende. Rang: " << rang << " Gitterebene " << gitterebene << " Text " << text << endl;
    }

// Kommentar: Diese Funktion bildet die Randstruktur des eigenen Gitters im Falle der Vektorisierung. Die Struktur
// des Nachbarkerns bzgl. der Punktenachbarschaft wird durch verschicken von Vektoren entsprechend diesen Punkten bestimmt.
void Gitter::randstruktur_bilden(void)
    {
// Kommentar: Dieses flag ist immer true
    if(punkt_aenderung_dynamisch==true)
        {
// Kommentar: Falls eine Lastwerte - Korrektur erfolgt, muss der echte Rand markiert werden.
        if(lastwerte_korrektur==true)
            {
// Kommentar: Die Menge echten Randpunkte wird gelscht.
            lastwerte_korrektur_punkte.reset();
// Kommentar: Man bildet die Randstruktur in der Menge (f_rs,g_rs) in der Klasse RandStruktur. Auerdem
// wird, wenn zu einem Punkt (i,j) ein Nachbarpunkt -1 ist, dieser in der Struktur lastwerte_korrektur_punkte markiert.
            randstruktur_bilden_dynamisch_mit_minus1_merken();
// Kommentar: Hier wird die Anzahl der markierten Punkte gezhlt, um bei Lastwert - Korrektur die
// eigene Last um diese Anzahl zu korrigieren.
//            lastwerte_korrektur_punkte.generiere_markiert_ev(); nderung 19.10.15
            }
        else
            {
// Kommentar: Ohne Lastwertekorrektur wird nur die Randstruktur in Form der Menge (f_rs,g_rs) gebildet, wo diese dann spter
// vektorisiert wird.
            randstruktur_bilden_dynamisch();
            }
        }
    else
        {
        randstruktur_bilden_statisch();
        }
    }

// Kommentar: Diese Funktion bildet die Randstruktur des eigenen Gitters im Falle der Sortierung. Es werden zu jeder
// Farbe die Innenrandpunkte in (f_rs,g_rs) sowie die Auenrandpunkte in (f_a_rs,g_a_rs) gespeichert. Diese
// Mengen werden dann einer 2 - dimensionalen 'Sortierung' unterzogen, vgl. die Dissertation.
void Gitter::randstruktur_bilden_beide(void)
    {
#ifdef AUSGABEN_RBB
    cout << " DDFFHH punkt_aenderung_dynamisch " << punkt_aenderung_dynamisch << " lastwerte_korrektur " << lastwerte_korrektur;
    cout << " rang " << rang << " ebene " << gitterebene << endl;
#endif
// Kommentar: Dieses flag ist immer true
    if(punkt_aenderung_dynamisch==true)
        {
#ifdef AUSGABEN_GITTER
#ifdef AUSGABEN_RBB
        cout << " rbb / rang " << rang << " dynamisch " << endl;
#endif
#endif
// Kommentar: Die Menge echten Randpunkte wird gelscht.
        if((lastwerte_korrektur==true))
            {
#ifdef AUSGABEN_RBB
            cout << " BBDDFF Randstruktur berarbeitet rang " << rang << endl;
#endif
// Kommentar: Die Menge echten Randpunkte wird gelscht.
            lastwerte_korrektur_punkte.reset();
// Kommentar: Man bildet die Randstruktur in der Mengen (f_rs,g_rs) und (f_a_rs,g_a_rs) in der Klasse RandStruktur. Auerdem
// wird, wenn zu einem Punkt (i,j) ein Nachbarpunkt -1 ist, dieser in der Struktur lastwerte_korrektur_punkte markiert.
            randstruktur_bilden_beide_dynamisch_mit_minus1_merken();

// Kommentar: Hier wird die Anzahl der markierten Punkte gezhlt, um bei Lastwert - Korrektur die
// eigene Last um diese Anzahl zu korrigieren.
//            lastwerte_korrektur_punkte.generiere_markiert_ev(); nderung 19.10.15
#ifdef AUSGABEN_RBB
            cout << " DDFFHH zum ersten Mal wird ev verwendet nicht init rang " << rang << " ebene " << gitterebene << " laenge " << lastwerte_korrektur_punkte.laenge;
            cout << " anzahl_markiert_ev " << lastwerte_korrektur_punkte.anzahl_markiert_ev << endl;
#endif
            }
        else
            {
// Kommentar: Ohne Lastwertekorrektur wird die Randstruktur in Form der Mengen (f_rs,g_rs) und (f_a_rs,g_a_rs)
// gebildet, wo diese dann spter durch Sortierung beider Mengen eine eindeutige Zuordnung bekommt.
#ifdef AUSGABEN_RBB
            cout << " Vor Randstruktur bilden beide dynamisch rang " << rang << endl;
#endif // AUSGABEN_RBB
            randstruktur_bilden_beide_dynamisch();
            }
        }
    else
        {
#ifdef AUSGABEN_RBB
#ifdef AUSGABEN_GITTER
        cout << " rbb / rang " << rang << " statisch " << endl;
#endif
#endif
        randstruktur_bilden_beide_statisch();
        }
    }

// Kommentar: Hier wird die Anzahl an Randpunkten bestimmt getrennt von der Randpunktbestimmung.
void Gitter::separat_lwk_generiere(void)
    {
    lastwerte_korrektur_punkte.generiere_markiert_ev();
    }

// Kommentar: Entsprechend randstruktur_bilden. Nur, dass hier im Falle der lastwerte_korrektur die Struktur
// lastwerte_korrektur_punkte gebildet wird, dann auch leer ist, und die Anzahl an Gitterpunkten nicht gezhlt wird.
// Das geschieht noch in der Initialisierungsphase in der Klasse Programm.

// Kommentar: Nur die nderungen zu randstruktur_bilden werden kommentiert.
void Gitter::randstruktur_bilden_fuer_init(void)
    {
    if(punkt_aenderung_dynamisch==true)
        {
        if(lastwerte_korrektur==true)
            {

// Kommentar: Statt des Resets von lastwerte_korrektur_punkte wird sie hier gebildet, ist dann aber auch leer.
            allokiere_lwk_punkte();
            randstruktur_bilden_dynamisch_mit_minus1_merken();
            }
        else
            {
            randstruktur_bilden_dynamisch();
            }
        }
    else
        {
        randstruktur_bilden_statisch();
        }
    }

// Kommentar: Entsprechend randstruktur_bilden_beide. Nur, dass hier im Falle der lastwerte_korrektur die Struktur
// lastwerte_korrektur_punkte gebildet wird, dann auch leer ist, und die Anzahl an Gitterpunkten nicht gezhlt wird.
// Das geschieht noch in der Initialisierungsphase in der Klasse Programm.

// Kommentar: Nur die nderungen zu randstruktur_bilden_beide werden kommentiert.
void Gitter::randstruktur_bilden_beide_fuer_init(void)
    {
#ifdef AUSGABEN_LWK
    cout << " DDFFHH rbb f init punkt_aenderung_dynamisch " << punkt_aenderung_dynamisch << " lastwerte_korrektur " << lastwerte_korrektur;
    cout << " rang " << rang << " ebene " << gitterebene << endl;
#endif
    if(punkt_aenderung_dynamisch==true)
        {
#ifdef AUSGABEN_GITTER
        cout << " rbb / rang " << rang << " dynamisch " << endl;
        cout << " lastwerte_korrektur " << lastwerte_korrektur << " rang " << rang << " gitterebene " << gitterebene << endl;
#endif
        if(lastwerte_korrektur==true)
            {
#ifdef AUSGABEN_LWK
            cout << " BBDDFF Randstruktur berarbeitet rang " << rang << endl;
#endif

// Kommentar: Statt des Resets von lastwerte_korrektur_punkte wird sie hier gebildet, ist dann aber auch leer.
            allokiere_lwk_punkte();
            randstruktur_bilden_beide_dynamisch_mit_minus1_merken();
#ifdef AUSGABEN_LWK
            cout << " DDFFHH zum ersten Mal wird ev verwendet Init rang " << rang << " ebene " << gitterebene << " laenge " << lastwerte_korrektur_punkte.laenge;
            cout << " anzahl_markiert_ev " << lastwerte_korrektur_punkte.anzahl_markiert_ev << endl;
#endif
            }
        else
            {
            randstruktur_bilden_beide_dynamisch();
            }
        }
    else
        {
#ifdef AUSGABEN_GITTER
        cout << " rbb / rang " << rang << " statisch " << endl;
#endif
        randstruktur_bilden_beide_statisch();
        }
    }

// Kommentar: Bei dem 'dynamischen Fall' ist es mglich, nicht mehr das ganze Gitter fr die Bildung der Randstruktur zu durchlaufen,
// sondern nur noch die dynamische Randpunktliste. Fr Kommentare vgl. man die Funktion randstruktur_bilden_dynamisch.
void Gitter::randstruktur_bilden_statisch(void)
// Hier wird die Randstruktur gebildet als Menge aller Punkte, wo der Wert zum jeweiligen
// Nachbarprozessor zu verschicken ist.
    {
#ifdef AUSGABEN_GITTER
    cout << "Zu Beginn von randstruktur_bilden Rang " << rang << endl;
#endif
// Kommentar: Das Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
            {
            switch(255-selbstnachbarn[j][k])
                {
                case 0:
                    break;
                case 1:
                    randpunkt_einfuegen_nord;
                    break;
                case 2:
                    randpunkt_einfuegen_nordost;
                    break;
                case 3:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    break;
                case 4:
                    randpunkt_einfuegen_ost;
                    break;
                case 5:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    break;
                case 6:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    break;
                case 7:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    break;
                case 8:
                    randpunkt_einfuegen_suedost;
                    break;
                case 9:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    break;
                case 10:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 11:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 12:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 13:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 14:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 15:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 16:
                    randpunkt_einfuegen_sued;
                    break;
                case 17:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    break;
                case 18:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    break;
                case 19:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    break;
                case 20:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    break;
                case 21:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    break;
                case 22:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    break;
                case 23:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    break;
                case 24:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 25:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 26:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 27:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 28:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    break;
                case 29:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 30:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 31:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 32:
                    randpunkt_einfuegen_suedwest;
                    break;
                case 33:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 34:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    break;
                case 35:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 36:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 37:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 38:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 39:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 40:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 41:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 42:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 43:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 44:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 45:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 46:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 47:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 48:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 49:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 50:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 51:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 52:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 53:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 54:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 55:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 56:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 57:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 58:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 59:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 60:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 61:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 62:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 63:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;

                case 64:
                    randpunkt_einfuegen_west;
                    break;

                case 65:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_west;
                    break;
                case 66:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    break;
                case 67:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    break;
                case 68:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 69:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 70:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 71:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 72:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 73:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 74:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 75:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 76:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 77:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 78:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 79:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 80:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    break;
                case 81:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 82:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 83:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 84:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 85:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 86:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 87:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 88:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 89:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 90:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 91:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 92:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    break;
                case 93:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 94:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 95:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 96:
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;

                case 97:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 98:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 99:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 100:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 101:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 102:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 103:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 104:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 105:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 106:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 107:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 108:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 109:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 110:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 111:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 112:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 113:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 114:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 115:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 116:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 117:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 118:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 119:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 120:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 121:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 122:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 123:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 124:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 125:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 126:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 127:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;

                case 128:
                    randpunkt_einfuegen_nordwest;
                    break;
                case 129:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordwest; break;
                case 130:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_nordwest; break;
                case 131:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_nordwest; break;
                case 132:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 133:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 134:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 135:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 136:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 137:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 138:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 139:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 140:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 141:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 142:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 143:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 144:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_nordwest; break;
                case 145:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 146:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 147:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 148:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 149:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 150:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 151:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 152:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 153:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 154:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 155:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 156:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_nordwest; break;
                case 157:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 158:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 159:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 160:
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 161:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 162:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 163:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 164:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 165:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 166:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 167:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 168:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 169:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 170:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 171:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 172:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 173:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 174:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 175:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 176:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 177:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 178:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 179:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 180:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 181:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 182:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 183:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 184:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 185:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 186:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 187:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 188:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 189:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 190:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 191:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;

                case 192:
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;

                case 193:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 194:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 195:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 196:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 197:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 198:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 199:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 200:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 201:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 202:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 203:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 204:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 205:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 206:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 207:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 208:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 209:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 210:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 211:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 212:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 213:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 214:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 215:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 216:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 217:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 218:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 219:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 220:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;
                case 221:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;
                case 222:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;
                case 223:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 224:
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;

                case 225:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 226:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 227:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 228:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 229:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 230:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 231:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 232:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 233:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 234:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 235:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 236:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 237:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 238:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 239:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 240:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 241:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 242:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 243:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 244:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 245:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 246:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 247:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 248:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 249:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 250:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 251:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 252:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 253:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 254:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 255:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                }
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "Am Ende von Randstruktur bilden " << endl;
#endif
    }

// Kommentar: Ds ist eine Ausgabe - Funktion, geschrieben aus Debugging - Grnden. Es werden die eigenen Punkte
// im Kontrast zu den nicht eigenen Punkten als Matrix dargestellt.

void Gitter::ausgeben_punkteII(void)
    {
//#ifdef AUSGABEN_GITTER
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        ff = lesen_f();
        gg = lesen_g();
        if(ausgabe_feld[ff][gg] ==true)
            {
            cout << " Fehler in ausgeben_punkteII: doppelter Punkt. f " << ff << " g " << gg << " rang " << rang << endl;
            }
        ausgabe_feld[ff][gg] = true;
        // Fehlerkontrolle
        if(farbenfeld[ff][gg]!=rang)
            {
            cout << " Fehler in ausgeben_PunkteII ";
            cout << " ff " << ff << " gg " << gg << " farbenfeld " << farbenfeld[ff][gg] << " Rang " << rang << " Ebene " << gitterebene << " t " << t << endl;
            exit(-1);
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "Ausgeben Punkte II Rang " << rang << endl;
    cout << "   " ;
    for(j=0; j<m;j++)
        {
        cout << j << " ";
        }
    cout << endl;
    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " " ;
            }
        for(j=0; j<m; j++)
            {
            if(ausgabe_feld[i][j]==true)
                {
                cout << "* ";
                }
            else
                {
                cout << ". ";
                }
            }
        cout << endl;
        }
#endif
#ifdef AUSGABEN_DATEI_NEU
    if((da_gitter_ist_da==true)&&(gitterebene <= 1))
        {
        da_gitter.oeffnen();
        // Speicher angelegt

        * da_gitter.aus << " II " << " rang " << rang << " ebene " << gitterebene << " t " << t << endl;

        for(i=0; i<n; i++)
            {
            * da_gitter.aus << i << " ";
            if(i<10)
                {
                * da_gitter.aus << " " ;
                }
            for(j=0; j<m; j++)
                {
                if(ausgabe_feld[i][j]==true)
                    {
                    * da_gitter.aus << "* ";
                    }
                else
                    {
                    * da_gitter.aus << ". ";
                    }
                }
            * da_gitter.aus << endl;
            }
        da_gitter.schliessen();
        // Speicher wieder freigegeben.
        }
#endif
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        ausgabe_feld[lesen_f()][lesen_g()] = false;
        }

    }


// Kommentar: Ds ist eine Ausgabe - Funktion, geschrieben aus Debugging - Grnden. Es werden die eigenen Punkte
// im Kontrast zu den nicht eigenen Punkten als Matrix dargestellt. Dabei werden Dateien geschrieben.

void Gitter::ausgeben_da(void)
    {
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            ausgabe_feld[i][j] = false;
            }
        }

    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        ff = lesen_f();
        gg = lesen_g();
        ausgabe_feld[ff][gg] = true;
        }

        da_gitter.oeffnen();
        // Speicher angelegt

        * da_gitter.aus << " ausgeben_da " << " rang " << rang << " ebene " << gitterebene << " t " << t << endl;

        for(i=0; i<n; i++)
            {
            * da_gitter.aus << i << " ";
            if(i<10)
                {
                * da_gitter.aus << " " ;
                }
            for(j=0; j<m; j++)
                {
                if(ausgabe_feld[i][j]==true)
                    {
                    * da_gitter.aus << "* ";
                    }
                else
                    {
                    * da_gitter.aus << ". ";
                    }
                }
            * da_gitter.aus << endl;
            }
        da_gitter.schliessen();

    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        ausgabe_feld[lesen_f()][lesen_g()] = false;
        }
    }

// Kommentar: Eine Ausgabe - Funktion zu Debugging - Zwecken - selber Zweck wie die beiden vorangehenden Funktionen.
void Gitter::ausgeben_punkteIII(void)
    {
//#ifdef AUSGABEN_GITTER
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        ff = lesen_f();
        gg = lesen_g();
        if(ausgabe_feld[ff][gg] ==true)
            {
            cout << "Fehler in ausgeben_punkteIII: doppelter Punkt. f " << ff << " g " << gg << endl;
            }
        ausgabe_feld[ff][gg] = true;
        // Fehlerkontrolle
        if(farbenfeld[ff][gg]!=rang)
            {
            cout << "Fehler in ausgeben_PunkteIII ";
            cout << " ff " << ff << " gg " << gg << " farbenfeld " << farbenfeld[ff][gg] << " Rang " << rang << " Ebene " << gitterebene << endl;
            exit(-1);
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "Ausgeben Punkte III Rang " << rang << endl;
    cout << "   " ;
    for(j=0; j<m;j++)
        {
        cout << j << " ";
        }
    cout << endl;
    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " " ;
            }
        for(j=0; j<m; j++)
            {
            if(ausgabe_feld[i][j]==true)
                {
                cout << "* ";
                }
            else
                {
                cout << ". ";
                }
            }
        cout << endl;
        }
#endif
#ifdef AUSGABEN_DATEI_NEU
    if((da_gitter_ist_da==true)&&(gitterebene <= 2))
        {
        da_gitter.oeffnen();
        // Speicher angelegt

        * da_gitter.aus << " III " << " rang " << rang << " ebene " << gitterebene << " t " << t << endl;

        for(i=0; i<n; i++)
            {
            * da_gitter.aus << i << " ";
            if(i<10)
                {
                * da_gitter.aus << " " ;
                }
            for(j=0; j<m; j++)
                {
                if(ausgabe_feld[i][j]==true)
                    {
                    * da_gitter.aus << "* ";
                    }
                else
                    {
                    * da_gitter.aus << ". ";
                    }
                }
            * da_gitter.aus << endl;
            }

        * da_gitter.aus << " III " << " rang " << rang << " ebene " << gitterebene << " t " << t << endl;

        if(gitterebene>0)
            {
            * da_gitter.aus << " IV " << " rang " << rang << " ebene " << gitterebene << " t " << t << endl;
            for(i=0; i<n; i++)
                {
                * da_gitter.aus << i << " ";
                if(i<10)
                    {
                    * da_gitter.aus << " " ;
                    }
                for(j=0; j<m; j++)
                    {
                    if((ausgabe_feld[i][j]==true)&&(feld_darunter[i+i][j+j]<0))
                        {
                        * da_gitter.aus << "* ";
                        }
                    else
                        {
                        * da_gitter.aus << ". ";
                        }
                    }
                * da_gitter.aus << endl;
                }
            * da_gitter.aus << " IV " << " rang " << rang << " ebene " << gitterebene << " t " << t << endl;
            }
        da_gitter.schliessen();
        // Speicher wieder freigegeben.
        }
#endif
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        ausgabe_feld[lesen_f()][lesen_g()] = false;
        }

    }
////////////////////////////////////////////////////////
//////  Farbenfeld checken                  ////////////
////////////////////////////////////////////////////////
//
// Was genau macht Farbenfeld_checken, und wie macht es das?
//
// Es wird das Farbenfeld auf Korrektheit berprft. Der Weg ist der folgende:
//
// Jeder Prozessor schickt zu jedem anderen Prozessor als Information die Punktemenge.
// Die wird dann unter der Farbe des ankommenden Buffer in das fc_farbenfeld geschrieben.
// Nachdem alle Nachrichten empfangen und bearbeitet sind wird das fc_farbenfeld und das
// 'normale' Farbenfeld verglichen. Bei einem auftretenden Fehler wird eine Nachricht darber
// abgesetzt. Aber kein Programmabbruch. Doch Programmabbruch.
// Die genaue Funktionsweise ist mir nicht klar. Die Funktionsweise ist aufzuschreiben.
// Wenn ich die Punkte aufschreibe, die ich selber habe, wird das zur Tautologie.
//
// void farbenfeld_checken(void) ist die aufrufende Funktion.
//
// Bisher ist soviel klar: Ein richtiger Test ist das nicht. Man berschreibt mit fremden Farben, wo man selber
// Punkte hatte, und ermittelt so einen Fehler. Ein richtiger Test des Farbenfeldes ist das aber nicht.
// Dafr msste man auch noch die Farbenfelder am ueren Rand kontrollieren. Wird gemacht, indem man
// fc_ueberpruefe zu 9 Mal fc_ueberpruefe_eines macht!
/////////////////////////////////////////////////////////

// Kommentar: In der Tat wird mit den Funktionen hier das Farbenfeld berprft, indem
// die eigenen Punkte verschickt, alle anderern Punkte der anderen Kerne empfangen und das
// gemeinsame Farbenfeld mit dem lokal vorliegenden Farbenfeld auf Gitter und Auenrand verglichen wird.
// Dabei wird auch geprft, dass kein Punkt doppelt vorliegt.
#ifdef GEMEINSAME_BUFFER_SI
// Hier werden die Strukturen angelegt, die fr den Farbenfeldvergleich bentigt werden.
void Gitter::initialisieren_farbenfeld_checken(short int ** sendebuffer)
#else
void Gitter::initialisieren_farbenfeld_checken(void)
#endif
// wird finalisiert
    {
// Kommentar: mn steht fr die Bufferlngen, wo die eigenen Punkte eingetragen werden, bzw. die fremden Punktmengen
// empfangen werden.
    mn = m*n;
#ifdef KURZ_FC
#ifdef GEMEINSAME_BUFFER_SI
// Kommentar: Der Buffer zum Senden und Empfangen ist nun verfgbar. Es liegen Buffer zu allen anderen vor. An dieser
// Stelle wird ein anderer Sendebuffer mit genutzt zum Speicherplatz - sparen.
    fc_buffer = sendebuffer;
#else
// Kommentar: Der Buffer zum Senden und Empfangen ist nun verfgbar. Es liegen Buffer zu allen anderen vor.
    fc_buffer = new short int * [groesse];

    for(i=0; i<groesse; i++)
        {
        fc_buffer[i] = new short int [2*mn+2];
        }
#endif
#else
// Kommentar: Der Buffer zum Senden und Empfangen ist nun verfgbar. Es liegen Buffer zu allen anderen vor.
    fc_buffer = new int * [groesse];

    for(i=0; i<groesse; i++)
        {
        fc_buffer[i] = new int [2*mn+1];
        }
#endif
// wird finalisiert
#ifdef KURZ_FC
    fc_index = 2;
#else
    fc_index = 1;
#endif

// Kommentar: Die Requests fr senden und empfangen werden angelegt. Bei jeder nicht - blockierenden Kommunikation
// werden solche Requests bentigt, um das Ende einer Kommunikation erfassen zu knnen.
    fc_sende_requests = new MPI_Request[groesse];
    fc_empfangs_requests = new MPI_Request[groesse];
// wird finalisiert
    n_plus_2 = n + 2;
    m_plus_2 = m + 2;

// Kommentar: Das gemeinsame Farbenfeld wird angelegt.
    fc_farbenfeld = new short int * [n_plus_2];
    for(i=0; i<n_plus_2; i++)
        {
        fc_farbenfeld[i] = new short int [m_plus_2];
        for(j=0; j<m_plus_2; j++)
            {
            fc_farbenfeld[i][j] = rang;
            }
        }
// wird finalisiert
    for(i=0; i<n_plus_2; i++)
        {
        fc_farbenfeld[i] = fc_farbenfeld[i] + 1;
        }
    fc_farbenfeld = fc_farbenfeld + 1;
    }

void Gitter::finalisieren_farbenfeld_checken(void)
    {
// Kommentar: Falls der fc_buffer angelegt wurde, wird er nun freigegeben.
#ifdef KURZ_FC
#ifndef GEMEINSAME_BUFFER_SI
    for(i=0; i<groesse; i++)
        {
        delete fc_buffer[i];
        }

    delete fc_buffer;
#endif
#else
    for(i=0; i<groesse; i++)
        {
        delete fc_buffer[i];
        }

    delete fc_buffer;
#endif

// Kommentar: Der Speicherplatz fr die Requests wird freigegeben

    delete fc_sende_requests;
    delete fc_empfangs_requests;

// Kommentar: Der Speicherplatz fr dsa gemeinsame Farbenfeld wird freigegeben.

    fc_farbenfeld = fc_farbenfeld - 1;

    for(i=0; i<n_plus_2; i++)
        {
        fc_farbenfeld[i] = fc_farbenfeld[i] - 1;
        }

    for(i=0; i<n_plus_2; i++)
        {
        delete fc_farbenfeld[i];
        }
    delete fc_farbenfeld;

    }

// Kommentar: Es wird das eigene lokale Farbenfeld anhand des hier gebildeten gemeinsamen Farbenfeldes berprft, und dann
// das gemeinsame Farbenfeld ausgegeben.
// Der bergebene Text soll angeben, von wo aus im Programmcode diese Funktion aufgerufen wurde.
void Gitter::farbenfeld_aus_punkten(char * fap_text)
    {
#ifdef AUSGABE_GITTER
    cout << " fap // rang " << rang << endl;
#endif
    farbenfeld_checken(gitterebene, fap_text);
    fc_farbenfeld_ausgebenX();
    }

// Kommentar: Es wird das eigene lokale Farbenfeld anhand des hier gebildeten gemeinsamen Farbenfeldes berprft.
// Der bergebene Text soll angeben, von wo aus im Programmcode diese Funktion aufgerufen wurde.
// Bemerkung: Das ist eine Testfunktion. Die Laufzeit hierfr ist irrelevant, da dieser Test bei Messungen
// ausgeschaltet wird.
void Gitter::farbenfeld_checken(int ebene, char * _fc_text)
    {
// Kommentar: Der bergebene Text wird gespeichert.
    fc_text = _fc_text;
    cout << " Farbenfeld Schicken ist an rang " << rang << endl;
#ifdef KURZ_FC
    fc_index = 2;
#else
    fc_index = 1;
#endif
#ifdef AUSGABEN_GITTER
    cout << " Ebene " << ebene << endl;
    cout << "1 Rang " << rang << endl;
#endif
// Kommentar: Der Buffer mit den eigenen Punkten wird gepackt.
    fc_buffer_packen();
#ifdef AUSGABEN_GITTER
    cout << "2 Rang " << rang << endl;
#endif
// Kommentar: Senden und Empfangen dieser Buffer - von jedem Kern, an jeden Kern - wird gestartet.
    fc_senden_empfangen();

#ifdef AUSGABEN_GITTER
    cout << "3 Rang " << rang << endl;
#endif
// Kommentar: Whrend der Kommunikation wird schon einmal fc_farbenfeld resettet.
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            fc_farbenfeld[i][j] = -1;
            }
        }

#ifdef AUSGABEN_GITTER
    cout << "4 Rang " << rang << endl;
#endif
// Kommentar: Es wird abgewartet, bis die gesamte Kommunikation abgeschlossen ist.
    for(;fc_ist_fertig()==false;)
        {
        ;
        }

#ifdef AUSGABEN_GITTER
    cout << "5 Rang " << rang << endl;
#endif
// Kommentar: Die eigenen Punkte bekommen im fc_farbenfeld den eigenen Rand zugeschrieben.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();
        naechster();
        fc_farbenfeld[j][k] = rang;
        }
    fc_farbenfeld_ausgeben2();
#ifdef AUSGABEN_GITTER
    cout << "6 Rang " << rang << endl;
#endif
// Kommentar: Nun werden die Punkte der anderen Kerne unter ihrer ID eingetragen. Man durchluft alle IDs.
    for(i=0; i<groesse; i++)
        {
// Kommentar: Fr die eigene ID wurden schon Eintragungen gemacht.
        if(i!=rang)
            {
// Kommentar: Das folgende ist nur eine Bufferkonvertierung, die ggf. durchgefhrt wird, damit
// die Anzahl an Gitterpunkten einen Integer - Wert annimmt. Denn: Man verschickt ggf. mehr als 65535 Gitterpunkte.
            h_fc_buffer = fc_buffer[i];
            #ifdef KURZ_FC
            j=2;
            konvert_pointer = (int * ) h_fc_buffer;
            j_max = konvert_pointer[0];
            #else
            j_max = h_fc_buffer[0];
            j=1;
            #endif
// Kommentar: Solange man nicht am Ende des Buffers angekommen ist:
            for(; j<j_max;)
                {
// Kommentar: Bestimme die Koordinaten des fremden Punktes.
                k = h_fc_buffer[j];
                j++;
                l = h_fc_buffer[j];
                j++;
// Kommentar: Wurde dort schon ein Punkt eingetragen, dann ist er jetzt doppelt, und man gibt eine Fehlermeldung aus.
                if(fc_farbenfeld[k][l]!=-1)
                    {
                    cout << " Fehler: Punkt (" << k << "," << l << ") kommt mindestens doppelt vor: auf Prozessor ";
                    cout << fc_farbenfeld[k][l] << " sowie Prozessor " << i << " rang " << rang << " ebene " << gitterebene << endl;
                    exit(-1);
                    }
// Ansonsten wird der Punkt (k,l) ins gemeinsame Farbenfeld unter der ID des sendenden Kerns eingetragen.
                fc_farbenfeld[k][l] = i;
                }
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "7 Rang " << rang << endl;
#endif
// Kommentar: Am Ende werden auf dem eigenen Gitter plus dem Auenrand das eigene und das gemeinsame Farbenfeld verglichen.
    vergleiche_farbenfelder();
#ifdef AUSGABEN_GITTER
    cout << "8 Rang " << rang << endl;
#endif
    }

// Kommentar: Das gemeinsame Farbenfeld wird auf allen Punkten der Reihe nach ausgegeben - als Matrix.
void Gitter::fc_farbenfeld_ausgeben(void)
    {
#ifdef WARTEN
    warten();
#endif
//#ifdef AUSGABEN_GITTER
    cout << "fc_farbenfeld rang " << rang << " t " << t << endl;

    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << fc_farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Ende fc_farbenfeld rang " << rang << " t " << t << endl;
//#endif
    }

void Gitter::da_fc_farbenfeld_ausgeben(void)
    {
//#ifdef AUSGABEN_GITTER

    da_gitter2.oeffnen();

    * da_gitter2.aus << "fc_farbenfeld rang " << rang << " t " << t << endl;

    for(i=0; i<n; i++)
        {
        * da_gitter2.aus << i << " ";
        if(i<10)
            {
            * da_gitter2.aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * da_gitter2.aus << fc_farbenfeld[i][j] << " ";
            }
        * da_gitter2.aus << endl;
        }
    * da_gitter2.aus << "Ende fc_farbenfeld rang " << rang << " t " << t << endl;
    da_gitter2.schliessen();
//#endif
    }

// Kommentar: Das eigene Farbenfeld wird auf allen Punkten als Matrix ausgegeben.
void Gitter::farbenfeld_ausgeben(void)
    {
#ifdef WARTEN
    warten();
#endif
//#ifdef AUSGABEN_GITTER
    cout << " farbenfeld rang " << rang << " t " << t << endl;

    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << " Ende farbenfeld rang " << rang << " t " << t << endl;
//#endif
    }

// Kommentar: Diese Funktion bestimmt fr den Kern i, wieviele Gitterpunkte der mglichen m*n Gitterpunkten
// auf diesem Kern liegen. Das wird in lasten(i) gespeichert.
void Gitter::lasten_sammeln(void)
    {
    for(i=0; i<groesse; i++)
        {
        lasten[i] = 0;
        }
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            if(fc_farbenfeld[i][j]>=0)
                {
                lasten[fc_farbenfeld[i][j]] += 1;
                }
            }
        }
    }

// Kommentar: Das gemeinsame Farbenfeld wird mit cout und als Datei als Matrix ausgegeben.
void Gitter::fc_farbenfeld_ausgebenX(void)
    {
    wartenX();


    cout << " fc_farbenfeld_ausgebenX rang " << rang << " Text " << fc_text << endl;

    for(i=0; i<n; i++)
        {
        cout << i << " ";
        if(i<10)
            {
            cout << " ";
            }
        for(j=0; j<m; j++)
            {
            cout << fc_farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Ende fc_farbenfeldX rang " << rang << endl;

    da_fehler.oeffnen(); // wird unten geschlossen.
    * da_fehler.aus << " fc_farbenfeld_ausgebenX rang " << rang << " Text " << fc_text << endl;

    for(i=0; i<n; i++)
        {
        * da_fehler.aus << i << " ";
        if(i<10)
            {
            * da_fehler.aus << " ";
            }
        for(j=0; j<m; j++)
            {
            * da_fehler.aus << fc_farbenfeld[i][j] << " ";
            }
        * da_fehler.aus << endl;
        }
    * da_fehler.aus << "Ende fc_farbenfeldX rang " << rang << endl;
    da_fehler.schliessen();
    }

// Kommentar: Das gemeinsame Farbenfeld wird mit cout als Matrix ausgegeben. -> Debugging
void Gitter::fc_farbenfeld_ausgeben2(void)
    {
#ifdef WARTEN
    warten();
#endif
#ifdef AUSGABEN_GITTER
    cout << "fc_farbenfeld nur eigenfarbe rang " << rang << endl;

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << fc_farbenfeld[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Ende fc_farbenfeld nur eigenfarbe rang " << rang << endl;
#endif
    }

// Kommentar: Es werden das eigene und das gemeinsame Farbenfeld in Hinblick auf Abweichungen verglichen.
void Gitter::vergleiche_farbenfelder(void)
    {
// Kommentar: Man durchluft das Gitter ...
    for(anfangsposition();ist_fertig_fl()==false;)
        {
// Kommentar: ... liest den jeweiligen Gitterpunkt
        j = lesen_f();
        k = lesen_g();
// Kommentar: bewirkt ein Setzen des nchsten Gitterpunktes.
        naechster();
// Kommentar: Und vergleicht fr den Punkt und die 8 Punkte drum herum beide Farbenfelder. Auf diese Weise
// wird insgesamt das Farbenfeld plus seinem Auenrand verglichen.
        fc_ueberpruefe(j, k);
        }
    }

// Kommentar: Hier wird das Farbenfeld auf einer Koordinate verglichen.
void Gitter::fc_ueberpruefe_eines(int f, int g)
    {
    if( (f < 0) || (g<0) || (f>=n) || (g>=m))
        {
        return;
        }
// Kommentar: Im Falle eines Fehlers werden beide Farbenfelder sowie die Fehlerstelle ausgegeben.
    if(farbenfeld[f][g]!=fc_farbenfeld[f][g])
        {
        cout << " Fehler: Falsches Farbenfeld in (" << f << "," << g << ")" << " soll ";
        cout << fc_farbenfeld[f][g] << " ist " << farbenfeld[f][g] << " Rang " << rang << " feld(f,g) " << feld[f][g];
        cout << " m " << m << " n " << n << " t " << t << " gitterebene " << gitterebene << endl;

        da_fehler.oeffnen(); // wird gleich geschlossen
        * da_fehler.aus << " Fehler: Falsches Farbenfeld in (" << f << "," << g << ")" << " soll ";
        * da_fehler.aus << fc_farbenfeld[f][g] << " ist " << farbenfeld[f][g] << " Rang " << rang << " feld(f,g) " << feld[f][g];
        * da_fehler.aus << " m " << m << " n " << n << " t " << t << " gitterebene " << gitterebene << endl;
        da_fehler.schliessen();
        warten_fc();
        fc_farbenfeld_ausgebenX();
        fehler_festgestellt = true;
        ausgeben_farbenfeldX();
        exit(-1);
        }
    }

// Kommentar: Hier wird das Farbenfeld auf einer Koordinate plus die 8 Punkte drum herum verglichen.
void Gitter::fc_ueberpruefe(int f, int g)
    {
    fc_ueberpruefe_eines(f-1, g-1);
    fc_ueberpruefe_eines(f, g-1);
    fc_ueberpruefe_eines(f+1, g-1);

    fc_ueberpruefe_eines(f-1, g);
    fc_ueberpruefe_eines(f, g);
    fc_ueberpruefe_eines(f+1, g);

    fc_ueberpruefe_eines(f-1, g+1);
    fc_ueberpruefe_eines(f, g+1);
    fc_ueberpruefe_eines(f+1, g+1);
    }

// Kommentar: Der eigene Kommunikationsbuffer wird gepackt.
void Gitter::fc_buffer_packen(void)
    {
// Kommentar: Zuerst wird der Bufferindex ausgewhlt.
    h_fc_buffer = fc_buffer[rang];

// Kommentar: Dann wird das Gitter durchlaufen
    for(anfangsposition(), hilfe=0;ist_fertig_fl()==false;)
        {
// Kommentar: Der jeweilige Gitterpunkt wird gelesen.
        j = lesen_f();
        k = lesen_g();
        naechster();
        hilfe++;
#ifdef AUSGABEN_GITTER
#ifdef KURZ_FC
// Kommentar: Falls die Bufferlnge berschritten wird, wird eine Warnung ausgegeben.
        if(fc_index >= mn * 2 + 2)
            {
            cout << "Zu viele Eintrge / rang " << rang << " fc_index " << fc_index << " mn*2+2 " << mn*2+2 << " hilfe " << hilfe << endl;
            }
#else
        if(fc_index >= mn * 2 + 1)
            {
            cout << "Zu viele Eintrge / rang " << rang << " fc_index " << fc_index << " mn*2+1 " << mn*2+1 << " hilfe " << hilfe << endl;
            }
#endif
#endif
// Kommentar: Die Koordinaten j und k werden in den Buffer geschrieben.
        h_fc_buffer[fc_index] = j;
        fc_index ++;
#ifdef AUSGABEN_GITTER
#ifdef KURZ_FC
        if(fc_index >= mn * 2 + 2)
            {
            cout << "Zu viele Eintrge / rang " << rang << " fc_index " << fc_index << " mn*2+2 " << mn*2+2 << " hilfe " << hilfe << endl;
            }
#else
        if(fc_index >= mn * 2 + 1)
            {
            cout << "Zu viele Eintrge / rang " << rang << " fc_index " << fc_index << " mn*2+1 " << mn*2+1 << " hilfe " << hilfe << endl;
            }
#endif
#endif
        h_fc_buffer[fc_index] = k;
        fc_index ++;
        }

// Kommentar: Ganz am Ende wird die Gesamtanzahl an Gitterpunkten an den Anfang des Buffers geschrieben.
// Dabei werden einer oder zwei Speicherpltze in Anspruch genommen, je nachdem ob man einen Int - oder Short Int - Buffer hat.
#ifdef KURZ_FC
    konvert_pointer = (int * ) h_fc_buffer;
    konvert_pointer[0] = fc_index;
#else
    h_fc_buffer[0] = fc_index;
#endif
//  Bei short int klappt das natrlich nicht!!!!! Man hat mehr als 32768 Punkte!
    }

// Kommentar: Das Senden und Empfangen der Farbenfeld - Checken (fc) - Buffer wird initiiert.
void Gitter::fc_senden_empfangen(void)
    {
#ifdef KURZ_FC
// Kommentar: Man durchluft die ID's der anderen Kerne.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: An den Kern i wird der Buffer mit dere Lnge fc_index und dem Bufferzeiger h_fc_buffer geschickt.
            MPI_Isend(h_fc_buffer, fc_index, MPI_SHORT, i, 200, MPI_COMM_WORLD, & (fc_sende_requests[i]));
// Kommentar: Vom Kern i wird der Buffer mit dem Bufferzeiger fc_buffer(i) und der Maximallnge 2*mn+1 empfangen.
            MPI_Irecv((fc_buffer[i]), 2*mn+1, MPI_SHORT, i, 200, MPI_COMM_WORLD, & (fc_empfangs_requests[i]));
            }
        }
#else
// Kommentar: Selbige Kommentare wie eben.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            MPI_Isend(h_fc_buffer, fc_index, MPI_INT, i, 200, MPI_COMM_WORLD, & (fc_sende_requests[i]));
            MPI_Irecv((fc_buffer[i]), 2*mn+1, MPI_INT, i, 200, MPI_COMM_WORLD, & (fc_empfangs_requests[i]));
            }
        }
#endif
    }

// Kommentar: Es wird geprft, ob alle Kommunikationen fr diesen Kern abgeschlossen sind.
bool Gitter::fc_ist_fertig(void)
    {
// Man durchluft alle anderen Kerne
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
// Kommentar: Wenn das Senden an einen Kern noch nicht erfolgt ist, oder die Nachricht von einem Kern nicht empfangen
// wurde, gebe 'false' zurck, d.h. die Kommunikation ist nicht beendet.
            MPI_Test(& (fc_sende_requests[i]), &fc_flag, & fc_status);
            if(fc_flag==false)
                {
                return(false);
                }
            MPI_Test(& (fc_empfangs_requests[i]), & fc_flag, & fc_status);
            if(fc_flag==false)
                {
                return(false);
                }

            }
        }
// Kommentar: Alle Kommunikation fr diesen Kern wurde beendet. Damit wird true zurckgegeben.
    return(true);
    }

//////////////////////////////////////////////////////////
////   Den Selbst - Nachbarn - Tester                 ////
//////////////////////////////////////////////////////////

// Kommentar: Hier wird selbstnachbarn nur ausgegeben - als Matrix.
void Gitter::selbstnachbarn_ausgeben(void)
    {
#ifdef AUSGABEN_GITTER
    cout << "SNA / rang " << rang << " " << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << selbstnachbarn[i][j] << " ";
            }
        cout << endl;
        }
    cout << "EndeSNA" << endl;
#endif
    }

// Kommentar: Hier wird die Struktur selbstnachbarn getestet.
bool Gitter::selbstnachbarn_testen(void)
    {
// Kommentar: Das Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();
// Kommentar: Selbstnachbarn wird an der Stelle (j,k) getestet. Tritt ein Fehler auf, wird false zurckgegeben.
        if(teste_j_k(j, k)==false)
            {
            return (false);
            }
        naechster();
        }
// Kommentar: Alles OK? Dann wird true zurckgegeben.
    return(true);
    }

// Kommentar: Hier wird getestet, ob selbstnachbarn an der Stelle (f,g) korrekt ist.
bool Gitter::teste_j_k(int f, int g)
    {
// Kommentar: Der Vergleichswert wird auf 0 gesetzt.
    hilfswert = 0;
// Kommentar: Die Farbenfelder sind fr alle eigenen Punkte in der 8 - Punkte Umgebung korrekt.
// Ist z.B. in Nordwesten ein eigener Punkt, dann wird das entsprechende Bit im hilfswert gesetzt.
// Analog fr alle anderen Himmelsrichtungen.
    if(farbenfeld[f-1][g-1]==rang)
        {
        hilfswert |= NORD_WEST;
        }
    if(farbenfeld[f][g-1]==rang)
        {
        hilfswert |= WEST;
        }
    if(farbenfeld[f+1][g-1]==rang)
        {
        hilfswert |= SUED_WEST;
        }

    if(farbenfeld[f-1][g]==rang)
        {
        hilfswert |= NORD;
        }

    if(farbenfeld[f+1][g]==rang)
        {
        hilfswert |= SUED;
        }

    if(farbenfeld[f-1][g+1]==rang)
        {
        hilfswert |= NORD_OST;
        }
    if(farbenfeld[f][g+1]==rang)
        {
        hilfswert |= OST;
        }
    if(farbenfeld[f+1][g+1]==rang)
        {
        hilfswert |= SUED_OST;
        }
// Kommentar: Am Ende wird geprft, ob der Vergleichswert mit selbstnachbarn bereinstimmt.
    if(hilfswert!=selbstnachbarn[f][g])
        {
        return(false);
        }
    return(true);
    }

////////////////////////////////////////////////////
////  Rnder erkennen - zu welchen Prozessoren  ////

// Kommentar: Das hier ist eine Kontrollfunktion, die nicht effizient ist, und erkennt,  zu welchem Kern
// eine Punktenachbarschaft existiert. Der vektor(i) charakterisiert die Punktenachbarschaft zu Kern i.

void Gitter::ink(int * vektor)
    {
    hilfsvektor = vektor;

// Kommentar: Man durchlaufe das Gitter.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
// Kommentar: Man liest den Gitterpunkt.
        j = lesen_f();
        k = lesen_g();

// Kommentar: In allen Himmelsrichtungen wird set_punkt aufgerufen, vgl. Kommentar unten.
        set_punkt(j-1, k);
        set_punkt(j+1, k);
        set_punkt(j-1, k-1);
        set_punkt(j, k-1);
        set_punkt(j+1, k-1);
        set_punkt(j-1, k+1);
        set_punkt(j, k+1);
        set_punkt(j+1, k+1);

        naechster();
        }
    }

// Kommentar: Wenn das farbenfeld in (f,g) zu einem Kern gehrt, wird verzeichnet, dass eine Nachbarschaft zu
// diesem Kern exsistiert.
void Gitter::set_punkt(int f, int g)
    {
    wert = farbenfeld[f][g];
    if(wert>=0)
        {
        hilfsvektor[wert] = 1;
        }
    }

// Kommentar: Diese Funktion wird in Programm::strategie_testen verwendet. Sie gibt 'false' aus, wenn das testfeld
// an einem Gitterpunkt false ist. Ansonsten wird das Testfeld berall auf false gesetzt.
bool Gitter::strategie_testen(bool ** testfeld)
    {
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();

        if(testfeld[j][k]==false)
            {
            return(false);
            }
        testfeld[j][k] = false;
        naechster();
        }
    return(true);
    }

// Kommentar: Das Testfeld wird auf allen Punkten des Gitters auf true gesetzt, vgl. Progamm::strategie_testen.
void Gitter::strategie_testen_2a(bool ** testfeld)
    {
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();

        testfeld[j][k] = true;
        naechster();
        }
    }

// Kommentar: Fr alle Grobgitterpunkte ber den eigenen Gitterpunkten wird das Testfeld auf false gesetzt, vgl.
// Programm::strategie_testen.
void Gitter::strategie_testen_2b(bool ** testfeld)
    {
#ifdef AUSGABEN_GITTER
    cout << "Anfang Strategie_testen_2b " << endl;
#endif
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();

        if((j & 1) ==0)
            {
            if((k & 1) ==0)
                {
                testfeld[j>>1][k>>1] = false;
                }
            }


        naechster();
        }
#ifdef AUSGABEN_GITTER
    cout << endl << "Ende Strategie_testen_2b " << endl;
#endif
    }

// Kommentar: Die Randstruktur soll bestimmt werden, aber indem das ganze Gitter durchlaufen wird, und nicht nur die
// Randpunktliste. Das wird dominiert durch randstruktur_bilden_beide_dynamisch. Zu Kommentaren vergleiche man diese Funktion.
void Gitter::randstruktur_bilden_beide_statisch(void)
// Hier wird die Randstruktur gebildet als Menge aller Punkte, wo der Wert zum jeweiligen
// Nachbarprozessor zu verschicken ist.
    {
#ifdef AUSGABEN_GITTER
    cout << "Zu Beginn von randstruktur_bilden_beide Rang " << rang << endl;
#endif
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
            {
            switch(255-selbstnachbarn[j][k])
                {
                case 0:
                    break;
                case 1:
                    randpunkte_einfuegen_nord;
                    break;
                case 2:
                    randpunkte_einfuegen_nordost;
                    break;
                case 3:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    break;
                case 4:
                    randpunkte_einfuegen_ost;
                    break;
                case 5:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    break;
                case 6:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    break;
                case 7:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    break;
                case 8:
                    randpunkte_einfuegen_suedost;
                    break;
                case 9:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    break;
                case 10:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 11:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 12:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 13:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 14:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 15:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 16:
                    randpunkte_einfuegen_sued;
                    break;
                case 17:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    break;
                case 18:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    break;
                case 19:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    break;
                case 20:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    break;
                case 21:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    break;
                case 22:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    break;
                case 23:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    break;
                case 24:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 25:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 26:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 27:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 28:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    break;
                case 29:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 30:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 31:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 32:
                    randpunkte_einfuegen_suedwest;
                    break;
                case 33:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 34:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    break;
                case 35:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 36:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 37:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 38:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 39:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 40:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 41:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 42:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 43:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 44:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 45:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 46:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 47:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 48:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 49:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 50:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 51:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 52:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 53:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 54:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 55:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 56:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 57:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 58:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 59:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 60:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 61:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 62:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 63:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;

                case 64:
                    randpunkte_einfuegen_west;
                    break;

                case 65:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_west;
                    break;
                case 66:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    break;
                case 67:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    break;
                case 68:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 69:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 70:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 71:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 72:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 73:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 74:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 75:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 76:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 77:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 78:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 79:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 80:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    break;
                case 81:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 82:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 83:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 84:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 85:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 86:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 87:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 88:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 89:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 90:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 91:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 92:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    break;
                case 93:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 94:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 95:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 96:
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;

                case 97:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 98:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 99:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 100:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 101:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 102:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 103:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 104:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 105:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 106:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 107:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 108:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 109:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 110:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 111:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 112:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 113:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 114:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 115:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 116:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 117:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 118:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 119:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 120:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 121:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 122:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 123:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 124:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 125:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 126:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 127:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;

                case 128:
                    randpunkte_einfuegen_nordwest;
                    break;
                case 129:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordwest; break;
                case 130:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_nordwest; break;
                case 131:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_nordwest; break;
                case 132:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;
                case 133:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;
                case 134:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;
                case 135:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;

                case 136:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 137:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 138:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 139:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 140:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 141:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 142:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 143:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 144:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_nordwest; break;
                case 145:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 146:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 147:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 148:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 149:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 150:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 151:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 152:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 153:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 154:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 155:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 156:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_nordwest; break;
                case 157:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 158:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 159:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 160:
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 161:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 162:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 163:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 164:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 165:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 166:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 167:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 168:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 169:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 170:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 171:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 172:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 173:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 174:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 175:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 176:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 177:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 178:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 179:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 180:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 181:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 182:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 183:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 184:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 185:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 186:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 187:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 188:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 189:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 190:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 191:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;

                case 192:
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;

                case 193:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 194:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 195:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 196:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 197:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 198:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 199:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 200:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 201:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 202:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 203:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 204:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 205:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 206:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 207:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 208:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 209:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 210:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 211:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 212:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 213:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 214:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 215:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 216:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 217:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 218:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 219:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 220:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;
                case 221:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;
                case 222:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;
                case 223:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 224:
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;

                case 225:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 226:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 227:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 228:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 229:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 230:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 231:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 232:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 233:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 234:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 235:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 236:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 237:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 238:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 239:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 240:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 241:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 242:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 243:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 244:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 245:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 246:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 247:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 248:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 249:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 250:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 251:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 252:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 253:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 254:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 255:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                default:
                    cout << " Fehler in der Randstruktur rang " << rang << endl;
                    exit(-1);
                    break;
                }
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "Am Ende von Randstruktur bilden rang " << rang << endl;
#endif
    }

// Kommentar: Das Gitter wird geleert. Das geschieht bei der Kappe auf den Ebenen > h_kappe auf den Kernen mit ID != 0
void Gitter::leer(void)
    {
// Kommentar: Die Feldliste wird geleert.
    leeren(); // 28.08.2014
// Kommentar: Die Gitterpunktlisten fr die Klasse Zyklus Rechnen werden geleert.
    anzahl_innen = 0;
    anzahl_rand_innen = 0;
    anzahl_rand_innen_echter_rand = 0;
    }

// Kommentar: Das Gitter wird komplett gefllt. Das geschieht bei der  Kappe auf den Ebenen > h_kappe auf dem Kern mit der ID 0.
void Gitter::voll(void)
    {
// Kommentar: Die Feldliste wird gefllt.
    fuellen(); // 28.08.2014
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            farbenfeld[i][j]=rang;
            }
        }
    anzahl_rand_innen = 0;
    anzahl_rand_innen_echter_rand = 0;
    anzahl_innen = 0;
// Kommentar: Alle mglichen Gitterpunkte werden durchlaufen.
    for(i=0, k=0, l=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
// Kommentar: Bei echten Randpunkten werden die in f_rand_innen_echter_rand und g_rand_innen_echter_rand gespeichert,
// damit Restriktionen und Prolongationen korrekt ablaufen.
            if(iip.pruefen(i,j)==false) // Nur innere Punkte
                {
                f_rand_innen_echter_rand[l] = i;
                g_rand_innen_echter_rand[l] = j;
                l++;
                continue;
                }
// Kommentar: Ansonsten werden sie als Innenpunkte gespeichert, denn es gibt keine nicht echten Randpunkte,
// wenn alle Gitterpunkte nur auf einem Kern liegen.
            f_innen[k] = i;
            g_innen[k] = j;
            k++;
            }
        }
    anzahl_innen = k;
    anzahl_rand_innen_echter_rand = l;
    }

// Kommentar: Diese Funktion gehrt zu einem berholten Zyklus, und ist daher irrelevant.
void Gitter::leer_2(void)
    {
    anzahl_innen_2 = 0;
    anzahl_rand_innen_2 = 0;
    }

// Kommentar: Diese Funktion gehrt zu einem berholten Zyklus, und ist daher irrelevant.
void Gitter::voll_2(void)
    {
//    anzahl_innen_2 = mn;
    anzahl_rand_innen_2 = 0;
    for(i=0, k=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            if(iip.pruefen(i,j)==false) // Nur innere Punkte
                {
                continue;
                }
            f_innen_2[k] = i;
            g_innen_2[k] = j;
            k++;
            }
        }
    anzahl_innen_2 = k;
    }

// Kommentar: Die x0 Werte werden als Matrix ausgegeben. -> Debugging

void Gitter::ausgeben(void)
    {
#ifdef AUSGABEN_GITTER
    cout << "Gitterausgabe rang " << rang << " n " << n << endl;
    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j++)
            {
            cout << x0[i][j] << " ";
            }
        cout << endl;
        }
    cout << "Ende Gitterausgabe " << endl;
#endif
    }

// Kommentar: Es wird x0 nach wk_x0 kopiert. Gehrt zur Wertekontrollebene der Klasse Programm, einem
// berholten Testkonzept fr die Prfung von sequentiellen und parallelen Gitterwerten von Variablen.
void Gitter::lade_wk_x0(double ** wk_x0)
    {
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
        wk_x0[j][k] = x0[j][k];
        }
    }


//int Gitter::aussenrand_bilden_bei_sortierung(short int * f_gesamt, short int * g_gesamt, int anzahl_gesamt)

// Kommentar: Die Funktion hat als Quelle des Aufrufes RandstrukturBilden::aussenrand_bilden. Diese Funktion
// wird aber nirgendwo aufgerufen. Daher ist diese Funktion berflssig.
int Gitter::aussenrand_bilden_bei_sortierung(void)
    {
    for(i=0, k=0; i<groesse; i++)
        {
        if(rang!=i)
            {
            anzahl_rs_farbe = anzahl_a_rs[i];
            f_a_rs_i = f_a_rs[i];
            g_a_rs_i = g_a_rs[i];
            for(j=0; j<anzahl_rs_farbe; j++)
                {
                fs = f_a_rs_i[j];
                gs = g_a_rs_i[j];
                if(testfeld_aussen[fs][gs]==false)
                    {
                    f_aussen [k] = fs;
                    g_aussen [k++] = gs;
                    testfeld_aussen[fs][gs] = true;
                    }
                }
            }
        }
    for(i=0; i<k; i++)
        {
        testfeld_aussen[f_aussen[i]][g_aussen[i]]=false;
        }
    return(k);
    }

//int Gitter::aussenrand_bilden_durch_vektoren(short int * f_gesamt, short int * g_gesamt, int anzahl_gesamt)

// Kommentar: Die Funktion hat als Quelle des Aufrufes RandstrukturBilden::aussenrand_bilden. Diese Funktion
// wird aber nirgendwo aufgerufen. Daher ist diese Funktion berflssig.
int Gitter::aussenrand_bilden_durch_vektoren(void)
    {
    for(i=0, k=0; i<groesse; i++)
        {
        if(rang!=i)
            {
            k = randstruktur_kommunikation[i].aussenrand_bestimmen(k);
            }
        }
    for(i=0; i<k; i++)
        {
        testfeld_aussen[f_aussen[i]][g_aussen[i]]=false;
        }
    return(k);
    }

// Kommentar: Mit dieser Funktion kann der dynamische Rand bei der Initialisierung gesetzt werden.
// Bemerkung: Danach wird diese Liste nicht mehr so bestimmt, sondern nur noch aktualisiert.
void Gitter::setze_dynamischen_rand(void)
    {
#ifdef AUSGABEN_GITTER
    cout << endl << "sdr Anfang rang " << rang << " " << " Ebene " << gitterebene << " ";
#endif
// Der Rand wird durchlaufen, und alle Punkte, die keine inneren Punkte sind (selbstnachbarn!=255),
// werden in die dynamische Randliste aufgenommen.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();

        if(selbstnachbarn[j][k]!=255)
            {
#ifdef AUSGABEN_GITTER
            cout << "(" << j << "," << k << ")";
#endif
            dynamischer_rand.einfuegen_fl(j, k);
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "sdr Ende rang " << rang << endl;
#endif
    }

// Kommentar: Diese Funktion ist aktuell. Basierend auf einem Durchlauf der Randpunktliste werden die Punkte, die
// einen Nachbarpunkt auf Kern ID haben, unter der ID und den Koordinaten in f_rs und g_rs eingefgt.
// Dabei wird mit Hilfe eines Testfeldes erreicht, dass die Punkte nur einmal eingefgt werden.
void Gitter::randstruktur_bilden_dynamisch(void)
// Hier wird die Randstruktur gebildet als Menge aller Punkte, wo der Wert zum jeweiligen
// Nachbarprozessor zu verschicken ist.
    {
#ifdef AUSGABEN_GITTER
    cout << "Zu Beginn von randstruktur_bilden dynamisch Rang " << rang << endl;
#endif
// Kommentar: Hier wird nur die Randliste durchlaufen, denn nur dort knnen Randpunkte sein.
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();
            {
// Kommentar: Diese switch - case Anweisung bewirkt, dass nur an den Stellen das Farbenfeld auf fremde Randpunkte
// geprft wird, wo keine eigenen Gitterpunkte liegen.
            switch(255-selbstnachbarn[j][k])
                {
                case 0:
                    break;
                case 1:
// Kommentar: Hier wird geprft, ob im Norden ein Farbenfeld >= 0 existiert. Es muss dort != dem eigenen Rand sein.
// Dann wird (j,k) unter der ID des Farbenfeldes in (f_rs,g_rs) eingefgt. Fr alle anderen Flle geschieht das analog.
                    randpunkt_einfuegen_nord;
                    break;
                case 2:
                    randpunkt_einfuegen_nordost;
                    break;
                case 3:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    break;
                case 4:
                    randpunkt_einfuegen_ost;
                    break;
                case 5:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    break;
                case 6:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    break;
                case 7:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    break;
                case 8:
                    randpunkt_einfuegen_suedost;
                    break;
                case 9:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    break;
                case 10:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 11:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 12:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 13:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 14:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 15:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    break;
                case 16:
                    randpunkt_einfuegen_sued;
                    break;
                case 17:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    break;
                case 18:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    break;
                case 19:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    break;
                case 20:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    break;
                case 21:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    break;
                case 22:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    break;
                case 23:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    break;
                case 24:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 25:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 26:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 27:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 28:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    break;
                case 29:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 30:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 31:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    break;
                case 32:
                    randpunkt_einfuegen_suedwest;
                    break;
                case 33:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 34:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    break;
                case 35:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 36:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 37:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 38:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 39:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 40:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 41:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 42:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 43:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 44:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 45:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 46:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 47:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 48:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 49:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 50:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 51:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 52:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 53:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 54:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 55:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 56:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 57:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 58:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 59:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 60:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    break;
                case 61:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 62:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;
                case 63:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    break;

                case 64:
                    randpunkt_einfuegen_west;
                    break;

                case 65:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_west;
                    break;
                case 66:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    break;
                case 67:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    break;
                case 68:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 69:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 70:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 71:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    break;
                case 72:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 73:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 74:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 75:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 76:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 77:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 78:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 79:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    break;
                case 80:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    break;
                case 81:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 82:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 83:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 84:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 85:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 86:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 87:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 88:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 89:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 90:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 91:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 92:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    break;
                case 93:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 94:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 95:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    break;
                case 96:
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;

                case 97:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 98:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 99:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 100:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 101:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 102:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 103:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 104:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 105:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 106:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 107:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 108:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 109:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 110:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 111:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 112:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 113:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 114:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 115:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 116:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 117:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 118:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 119:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 120:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 121:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 122:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 123:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 124:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    break;
                case 125:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 126:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;
                case 127:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    break;

                case 128:
                    randpunkt_einfuegen_nordwest;
                    break;
                case 129:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordwest; break;
                case 130:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_nordwest; break;
                case 131:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_nordwest; break;
                case 132:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 133:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 134:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 135:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_nordwest; break;
                case 136:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 137:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 138:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 139:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 140:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 141:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 142:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 143:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_nordwest; break;
                case 144:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_nordwest; break;
                case 145:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 146:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 147:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 148:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 149:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 150:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 151:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 152:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 153:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 154:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 155:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 156:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_nordwest; break;
                case 157:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 158:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 159:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_nordwest; break;
                case 160:
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 161:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 162:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 163:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 164:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 165:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 166:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 167:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 168:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 169:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 170:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 171:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 172:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 173:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 174:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 175:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 176:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 177:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 178:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 179:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 180:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 181:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 182:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 183:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 184:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 185:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 186:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 187:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 188:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_nordwest; break;
                case 189:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 190:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;
                case 191:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_nordwest; break;

                case 192:
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;

                case 193:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 194:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 195:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 196:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 197:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 198:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 199:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 200:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 201:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 202:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 203:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 204:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 205:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 206:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 207:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 208:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 209:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 210:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 211:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 212:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 213:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 214:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 215:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;

                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 216:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 217:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 218:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 219:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 220:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;
                case 221:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;
                case 222:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest;
                    break;
                case 223:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 224:
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;

                case 225:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 226:
                    randpunkt_einfuegen_nordost;

                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 227:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 228:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 229:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 230:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 231:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 232:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 233:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 234:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 235:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 236:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 237:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 238:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 239:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 240:
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 241:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 242:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 243:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 244:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 245:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 246:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 247:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 248:
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 249:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 250:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 251:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 252:
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;
                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 253:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 254:
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                case 255:
                    randpunkt_einfuegen_nord;
                    randpunkt_einfuegen_nordost;
                    randpunkt_einfuegen_ost;
                    randpunkt_einfuegen_suedost;
                    randpunkt_einfuegen_sued;
                    randpunkt_einfuegen_suedwest;

                    randpunkt_einfuegen_west;
                    randpunkt_einfuegen_nordwest; break;
                }
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "Am Ende von Randstruktur bilden rang " << rang << endl;
#endif
    }

// Kommentar: Zu Kontrollzwecken wird die Randpunkteliste Koordinate fr Koordinate ausgegeben.
void Gitter::ausgeben_dynamischer_rand(void)
    {
#ifdef AUSGABEN_GITTER
    cout << "Dynamischer Rand / Ebene " << gitterebene << " / rang " << rang << " ";
#endif
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();
#ifdef AUSGABEN_GITTER
        cout << "(" << j << " " << k << " " << 255-selbstnachbarn[j][k] << ")";
#endif
        }
#ifdef AUSGABEN_GITTER
    cout << endl;
#endif
    }

// Kommentar: Diese Funktion ist aktuell. Basierend auf einem Durchlauf der Randpunktliste werden die Punkte, die
// einen Nachbarpunkt auf Kern ID haben, unter der ID und den Koordinaten in f_rs und g_rs eingefgt,
// sowie der Nachbarpunkt unter seiner ID und Koordinaten in f_a_rs und g_a_rs.
// Dabei wird mit Hilfe eines Testfeldes erreicht, dass die Punkte nur einmal eingefgt werden. Dabei
// kann, da die Punktemengen disjunkt sind, beides mit demselben Testfeld erfolgen.
void Gitter::randstruktur_bilden_beide_dynamisch(void)
// Hier wird die Randstruktur gebildet als Menge aller Punkte, wo der Wert zum jeweiligen
// Nachbarprozessor zu verschicken ist.
    {
//#ifdef AUSGABEN_GITTER
#ifdef AKTUELLE_KOMMENTARE
    cout << "Zu Beginn von randstruktur_bilden_beide dynamisch Rang " << rang << endl;

    if((rang==1)&&(gitterebene==0))
        {
        cout << " Bilden beide 11 / rang " << rang << " ";
        }
#endif
//#endif

#ifdef AUSGABEN_GITTER
#ifdef DA_RANDSTRUKTUR
    * da_randstruktur.aus << " Code 13: rbbd rang " << rang << " ebene " << gitterebene << " " << endl;
#endif
#endif

// Kommentar: Die Randpunktliste wird durchlaufen. Nur hier knnen Eintrge in die Listen f_rs, g_rs, f_a_rs und g_a_rs erfolgen.
// Das geht viel schneller, als das ganze Gitter zu durchsuchen.
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_GITTER
        if((rang==1)&&(gitterebene==1)&&(j==2)&&(k==7))
            {
            cout << " Bilden beide 1127 / rang " << rang << " 255-snb " << 255-selbstnachbarn[j][k] << " " << " ff(1,6) " << farbenfeld[1][6];
            cout << " feld " << feld[2][7] << " dyn.feld " << dynamischer_rand.feld[2][7] << endl;
            }
        cout << " j " << j << " k " << k << " 255-snb " << 255-selbstnachbarn[j][k] << " ";

#endif
#endif
            {
// Kommentar: Diese switch - case Anweisung bewirkt, dass nur an den Stellen das Farbenfeld auf fremde Randpunkte
// geprft wird, wo keine eigenen Gitterpunkte liegen.
            switch(255-selbstnachbarn[j][k])
                {
                case 0:
                    break;
                case 1:
// Kommentar: Hier wird geprft, ob im Norden ein Farbenfeld >= 0 existiert. Es muss dort != dem eigenen Rand sein.
// Dann wird (j,k) unter der ID des Farbenfeldes in (f_rs,g_rs) eingefgt, sowie (j-1,k) unter dieser ID in (f_a_rs, g_a_rs).
// Fr alle anderen Flle geschieht das analog.
                    randpunkte_einfuegen_nord;
                    break;
                case 2:
                    randpunkte_einfuegen_nordost;
                    break;
                case 3:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    break;
                case 4:
                    randpunkte_einfuegen_ost;
                    break;
                case 5:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    break;
                case 6:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    break;
                case 7:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    break;
                case 8:
                    randpunkte_einfuegen_suedost;
                    break;
                case 9:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    break;
                case 10:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 11:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 12:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 13:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 14:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 15:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    break;
                case 16:
                    randpunkte_einfuegen_sued;
                    break;
                case 17:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    break;
                case 18:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    break;
                case 19:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    break;
                case 20:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    break;
                case 21:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    break;
                case 22:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    break;
                case 23:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    break;
                case 24:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 25:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 26:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 27:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 28:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    break;
                case 29:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 30:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 31:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    break;
                case 32:
                    randpunkte_einfuegen_suedwest;
                    break;
                case 33:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 34:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    break;
                case 35:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 36:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 37:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 38:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 39:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 40:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 41:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 42:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 43:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 44:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 45:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 46:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 47:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 48:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 49:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 50:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 51:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 52:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 53:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 54:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 55:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 56:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 57:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 58:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 59:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 60:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    break;
                case 61:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 62:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;
                case 63:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    break;

                case 64:
                    randpunkte_einfuegen_west;
                    break;

                case 65:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_west;
                    break;
                case 66:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    break;
                case 67:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    break;
                case 68:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 69:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 70:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 71:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    break;
                case 72:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 73:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 74:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 75:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 76:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 77:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 78:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 79:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    break;
                case 80:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    break;
                case 81:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 82:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 83:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 84:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 85:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 86:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 87:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 88:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 89:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 90:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 91:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 92:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    break;
                case 93:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 94:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 95:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    break;
                case 96:
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;

                case 97:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 98:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 99:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 100:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 101:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 102:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 103:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 104:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 105:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 106:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 107:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 108:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 109:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 110:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 111:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 112:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 113:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 114:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 115:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 116:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 117:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 118:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 119:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 120:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 121:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 122:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 123:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 124:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    break;
                case 125:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 126:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;
                case 127:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    break;

                case 128:
                    randpunkte_einfuegen_nordwest;
                    break;
                case 129:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordwest; break;
                case 130:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_nordwest; break;
                case 131:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_nordwest; break;
                case 132:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;
                case 133:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;
                case 134:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;
                case 135:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_nordwest; break;

                case 136:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 137:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 138:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 139:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 140:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 141:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 142:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 143:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_nordwest; break;
                case 144:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_nordwest; break;
                case 145:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 146:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 147:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 148:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 149:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 150:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 151:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 152:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 153:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 154:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 155:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 156:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_nordwest; break;
                case 157:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 158:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 159:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_nordwest; break;
                case 160:
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 161:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 162:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 163:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 164:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 165:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 166:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 167:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 168:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 169:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 170:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 171:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 172:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 173:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 174:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 175:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 176:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 177:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 178:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 179:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 180:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 181:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 182:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 183:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 184:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 185:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 186:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 187:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 188:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_nordwest; break;
                case 189:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 190:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;
                case 191:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_nordwest; break;

                case 192:
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;

                case 193:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 194:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 195:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 196:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 197:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 198:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 199:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 200:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 201:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 202:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 203:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 204:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 205:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 206:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 207:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 208:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 209:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 210:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 211:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 212:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 213:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 214:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 215:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;

                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 216:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 217:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 218:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 219:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 220:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;
                case 221:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;
                case 222:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;
                    break;
                case 223:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 224:
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;

                case 225:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 226:
                    randpunkte_einfuegen_nordost;

                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 227:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 228:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 229:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 230:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 231:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 232:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 233:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 234:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 235:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 236:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 237:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 238:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 239:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 240:
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 241:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 242:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 243:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 244:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 245:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 246:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 247:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 248:
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 249:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 250:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 251:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 252:
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;
                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 253:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 254:
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest; break;
                case 255:
                    randpunkte_einfuegen_nord;
                    randpunkte_einfuegen_nordost;
                    randpunkte_einfuegen_ost;
                    randpunkte_einfuegen_suedost;
                    randpunkte_einfuegen_sued;
                    randpunkte_einfuegen_suedwest;

                    randpunkte_einfuegen_west;
                    randpunkte_einfuegen_nordwest;

                    break;
                }
            }
        }
#ifdef AUSGABEN_GITTER
#ifdef DA_RANDSTRUKTUR
    * da_randstruktur.aus << endl;
#endif
#endif
#ifdef AUSGABEN_GITTER
    cout << "Am Ende von Randstruktur bilden beide dynamisch rang " << rang << endl;
#endif
    }

// Kommentar: Es wird geprft, ob der Punkt auf dem feinen Gitter darunter auf demselben Kern liegt. Falls ja, dann return true,
// ansonsten return false.
bool Gitter::ist_gemeinsamer_punkt(int f, int g)
    {
    ff = f+f;
    gg = g+g;
    if(feld_h_minus1[ff][gg]>=0)
        {
        return(true);
        }
    return false;
    }

// Kommentar: Beim Konstruktur bekommt die Dateiausgabe den default nicht ausgeben. Und es werden zwei Konstanten definiert.
Gitter::Gitter(void)
    {
    da_gitter_ist_da = false;
    zwei_drittel = 2.0 / 3.0;
    ein_sechstel = 1.0 / 6.0;
    }

// Kommentar: Der dynamische Rand wird auf Korrektheit getestet. Das geschieht mittels 2er Tests. -> Debugging.
void Gitter::teste_dynamischen_rand(void)
    {
    teste_dynamischen_rand1();
    teste_dynamischen_rand2();
    }

// Kommentar: Der erste Test fr den dynamischen Rand. Es wird getestet, ob alle Randpunkte dort verzeichnet sind.
void Gitter::teste_dynamischen_rand1(void)
    {
// Kommentar: Das ganze Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
// Kommentar: Wenn selbstnachbarn dort != 255 ist, muss der Punkt beim dynamischen Rand eingetragen sein. Ist er es nicht,
// dann ist der Rand unvollstndig, und es wird eine Fehlermeldung ausgegeben.
        if(selbstnachbarn[j][k]!=255) // Ein Rand
            {
            if(dynamischer_rand.feld[j][k]==-1)
                {
                cout << " Fehler: In teste_dyna_rand: Es fehlt das Feld j " << j << " k " << k << " Rang " << rang << " ebene " << gitterebene << endl;
                exit(-1);
                }
            }
        }
    }

// Kommentar: Der zweite Test fr den dynamischen Rand. Er wird durchlaufen, und es wird getestet, ob der Eintrag korrekt ist.
void Gitter::teste_dynamischen_rand2(void)
    {
// Kommentar: Die Randliste wird durchlaufen.
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();
// Kommentar: Ist dort selbstnachbarn = 255, haben wir dort einen inneren Punkt, und es liegt daher ein Fehler vor.
        if(selbstnachbarn[j][k]==255) // Ein Rand
            {
            cout << " Fehler: In teste_dynamischen_rand: Das Feld j " << j << " k " << k << " Rang " << rang << " ebene " << gitterebene << " ist Innen " << endl;
            exit(-1);
            }
// Kommentar: Ist dort kein Gitterpunkt, weil die Feldliste das zeigt, liegt ein Fehler vor.
        if(feld[j][k]==-1)
            {
            cout << " Fehler: In teste_dynamischen_rand: Das Feld j " << j << " k " << k << " Rang " << rang << " ebene " << gitterebene << " existiert nicht " << endl;
            exit(-1);
            }
        }
    }

// Kommentar: Eine 2.ter selbstnachbarn - Test.
void Gitter::teste_SNB(void)
    {
// Kommentar: Man durchluft die Gitterpunktmenge, und testet jeden Punkt durch.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
        teste_SNB_in_punkt();
        }
    }

// Kommentar: Es wird auf einem Punkt getestet, ob selbstnachbarn korrekt ist.
void Gitter::teste_SNB_in_punkt(void)
    {
// Der selbstnachbarn - Wert wird gelesen.
    snb_wert = selbstnachbarn[j][k];
// Fr jede Himmelsrichtung wird das entsprechend Bit von Selbstnachbarn aufgerufen, sowie die Koordinaten an dieser
// Stelle. Der Punkt muss dann existieren, genau dann, wenn das Bit gesetzt ist.
    test_hr_SNB(j-1, k, snb_wert&1);
    test_hr_SNB(j-1, k+1, snb_wert&2);
    test_hr_SNB(j, k+1, snb_wert&4);
    test_hr_SNB(j+1, k+1, snb_wert&8);
    test_hr_SNB(j+1, k, snb_wert&16);
    test_hr_SNB(j+1, k-1, snb_wert&32);
    test_hr_SNB(j, k-1, snb_wert&64);
    test_hr_SNB(j-1, k-1, snb_wert&128);
    }

// Kommentar: Hier wird getestet, ob das Bit genau dann gesetzt ist, wenn der Punkt auf dem eigenen Gitter existiert.
void Gitter::test_hr_SNB(int f, int g, int wert)
    {
// Kommentar: Zuerst wird geprft, ob die Koordinate auf dem Gitter liegt.
// Eigentlich darf das Bit dann nicht gesetzt sein.
    if(f<0)
        {
        if(wert!=0)
            {
            cout << " Der Wert von selbstnachbarn sieht einen Gitterpunkt auerhalb des Gitters " << endl;
            exit(-1);
            }
        return;
        }
    if(g<0)
        {
        if(wert!=0)
            {
            cout << " Der Wert von selbstnachbarn sieht einen Gitterpunkt auerhalb des Gitters " << endl;
            exit(-1);
            }
        return;
        }
    if(f>=n)
        {
        if(wert!=0)
            {
            cout << " Der Wert von selbstnachbarn sieht einen Gitterpunkt auerhalb des Gitters " << endl;
            exit(-1);
            }
        return;
        }
    if(g>=m)
        {
        if(wert!=0)
            {
            cout << " Der Wert von selbstnachbarn sieht einen Gitterpunkt auerhalb des Gitters " << endl;
            exit(-1);
            }
        return;
        }

// Kommentar: Es wird gesehen, ob der grprfte Punkt auf dem eigenen Gitter liegt. Falls ja ...
    if(feld[f][g]>=0) // (f,g) existiert
        {
// Kommentar: ... dann muss der wert das Bit enthalten. Sonst erfolgt eine Fehlermeldung,
        if(wert==0) // SNB sagt (f,g) existiert nicht.
            {
            cout << "Fehler: In test_hr_SNB rang " << rang << " ebene " << gitterebene << " f " << f << " g " << g << " wert ==0 " << endl;
            exit(-1);
            }
        }
// Kommentar: Falls nein ...
    else // (f,g) existiert nicht
        {
// Kommentar: ... jetzt gibt es keinen Punkt, weshalb das Bit nicht gesetzt sein kann, also der wert 0 sein muss. Sonst erfolgt
// eine Fehlermeldung.
        if(wert!=0) // SNB sagt (f,g) existiert
            {
            cout << "Fehler: In test_hr_SNB rang " << rang << " ebene " << gitterebene << " f " << f << " g " << g << " wert !=0 " << endl;
            exit(-1);
            }
        }
    }

// Kommentar: Diese Funktion zhlt die Anzahl an Punkte - Verbindung zu dem jeweiligen anderen Kern.
// Da diese nicht mehr verglichen werden knnen, weil das Konzept des Zhlens von Verbindungen zur Bestimmung der
// Topologie nicht mehr erfolgt, weil diese ber die Randliste schnell bestimmt werden kann, wird diese Funktion
// nicht mehr weiter kommentiert. Das gilt auch fr die Funktion zaehler_hr_SNB.
int * Gitter::test_zaehler(void)
    {
    for(i=0; i<groesse; i++)
        {
        verbindungszaehler[i] = 0;
        }

    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();

        snb_wert = selbstnachbarn[j][k];
        zaehler_hr_SNB(j-1, k, snb_wert&1);
        zaehler_hr_SNB(j-1, k+1, snb_wert&2);
        zaehler_hr_SNB(j, k+1, snb_wert&4);
        zaehler_hr_SNB(j+1, k+1, snb_wert&8);
        zaehler_hr_SNB(j+1, k, snb_wert&16);
        zaehler_hr_SNB(j+1, k-1, snb_wert&32);
        zaehler_hr_SNB(j, k-1, snb_wert&64);
        zaehler_hr_SNB(j-1, k-1, snb_wert&128);
        }
    return(verbindungszaehler);
    }

// Kommentar: Diese Funktion prft, ob eine Verbindung zwischen zwei Kernen existiert, und inkrementiert dann
// den Zhler zu dem Kern mit dem verbundenen Punkt. Diese Funktion ist berholt, vgl. die Funktion test_zaehler,
// die diese Funktion aufruft.
void Gitter::zaehler_hr_SNB(int f, int g, int wert)
    {
    if(f<0)
        {
        return;
        }
    if(g<0)
        {
        return;
        }
    if(f>=n)
        {
        return;
        }
    if(g>=m)
        {
        return;
        }

    if(wert == 0)
        {
        if(farbenfeld[f][g]>=0)
            {
            verbindungszaehler[farbenfeld[f][g]]++;
#ifdef AUSGABEN_GITTER
            cout << "VZ rang " << rang << " Ziel " << farbenfeld[f][g] << " StartPunkt (" << j << ",";
            cout << k << ") Zielpunkt (" << f << "," << g << ")" << endl;
#endif
            }
        }
    }

// Kommentar: Hier wird ausgegeben, wieviele Punkte des eigenen Gitters zu dem Kern der jeewiligen ID vorliegen.
void Gitter::ausgeben_anzahl_a_rs(void)
    {
#ifdef AUSGABEN_GITTER
    cout << "Ausgeben_anzahl_a_rs / Ebene " << gitterebene << " / rang " << rang << " ";
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            cout << " i " << i << " " << anzahl_a_rs[i] << " ";
            }
        }
    cout << endl;
#endif
    }

////////////////////////////////////////////////////////////
////////// Einfuegen Ebene Entferne Ebene ns     ///////////
////////////////////////////////////////////////////////////

#ifdef GITTER_EP_PLUS_DAZU
// Kommentar: Diese Funktion entspricht der Funktion entferne_ebene_auch_dynamisch, nur dass sie im Falle
// des Nord - Sd - Lastausgleichs verwendet wird und deshalb MV_horizontal statt MV_vertikal verwendet. D.h.
// sie arbeitet mit horizontalen Vektoren. Daher: Keine Kommentierung.
void Gitter::entferne_ebene_auch_dynamisch_ns(MV_horizontal * mv_horizontal, int zielrang)
    {
    if((gitterebene>=1)&&(gitterebene<=h_min))
        {
        entferne_ebene_auch_dynamisch_mit_epd_ns(mv_horizontal, zielrang);
        }
    else
        {
        entferne_ebene_auch_dynamisch_ohne_epd_ns(mv_horizontal, zielrang);
        }
    }
#else
// Kommentar: Vgl. die Ost-West-Funktion.
void Gitter::entferne_ebene_auch_dynamisch_ns(MV_horizontal * mv_horizontal, int zielrang)
    {
    entferne_ebene_auch_dynamisch_ohne_epd_ns(mv_horizontal, zielrang);
    }
#endif

// Kommentar: Sie ist genau wie die Funktion 'ueberschreiben', nur mit horizontalen Vektoren fr den Nord - Sd - Fall.
void Gitter::ueberschreiben_ns(int zielrang)
    {
    for(i=0; i<index; i++)
        {
        hvektor_g1 = g1[i];
        hvektor_g2 = g2[i];
        hvektor_f = f[i];

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            farbenfeld[hvektor_f][j] = zielrang;
            }
        }
    }

// Kommentar: Sie ist genau wue die Funktion 'entferne_ebene_auch_dynamisch_mit_epd', nur mit horizontalen
// Vektoren fr den Nord - Sd - Fall.
void Gitter::entferne_ebene_auch_dynamisch_mit_epd_ns(MV_horizontal * mv_horizontal, int zielrang)
    {
#ifdef AUSGABEN_GITTER
    cout << "Entferne Ebene // rang " << rang << " gitterebene " << gitterebene << " zielrang " << zielrang << endl;
#endif
    g1 = mv_horizontal->g1_speichern[gitterebene];
    g2 = mv_horizontal->g2_speichern[gitterebene];
    f = mv_horizontal->f_speichern[gitterebene];
    index = mv_horizontal->indizes[gitterebene];

    for(i=0; i<index; i++)
        {
        if(punkt_aenderung_dynamisch==true)
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
// Beim Entfernen: Zuerst Zhlen, und dann entfernen!
                entfernen_fl(hvektor_f, j);
                farbenfeld[hvektor_f][j] = zielrang;
                punkt_entfernen_selbstnachbarn_dynamisch(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 1 rang " << rang << " ebene " << gitterebene << endl;
#endif
                ep_plus_dazu->hinweg(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 1 rang " << rang << endl;
#endif
                }
            }
        else
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
// Beim Entfernen: Zuerst Zhlen, und dann entfernen!
                entfernen_fl(hvektor_f, j);
                farbenfeld[hvektor_f][j] = zielrang;
                punkt_entfernen_selbstnachbarn(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 1 rang " << rang << " ebene " << gitterebene << endl;
#endif
                ep_plus_dazu->hinweg(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 1 rang " << rang << endl;
#endif
                }
            }
        }
    }

// Kommentar: Sie ist genau wue die Funktion 'entferne_ebene_auch_dynamisch_ohne_epd', nur mit horizontalen
// Vektoren fr den Nord - Sd - Fall.
void Gitter::entferne_ebene_auch_dynamisch_ohne_epd_ns(MV_horizontal * mv_horizontal, int zielrang)
    {
#ifdef AUSGABEN_GITTER
    cout << "Entferne Ebene // rang " << rang << " gitterebene " << gitterebene << " zielrang " << zielrang << endl;
#endif
    g1 = mv_horizontal->g1_speichern[gitterebene];
    g2 = mv_horizontal->g2_speichern[gitterebene];
    f = mv_horizontal->f_speichern[gitterebene];
    index = mv_horizontal->indizes[gitterebene];

    for(i=0; i<index; i++)
        {
        if(punkt_aenderung_dynamisch==true)
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
// Beim Entfernen: Zuerst Zhlen, und dann entfernen!
                entfernen_fl(hvektor_f, j);
                farbenfeld[hvektor_f][j] = zielrang;
                punkt_entfernen_selbstnachbarn_dynamisch(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 1 rang " << rang << " ebene " << gitterebene << endl;
#endif
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 1 rang " << rang << endl;
#endif
                }
            }
        else
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
// Beim Entfernen: Zuerst Zhlen, und dann entfernen!
                entfernen_fl(hvektor_f, j);
                farbenfeld[hvektor_f][j] = zielrang;
                punkt_entfernen_selbstnachbarn(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 1 rang " << rang << " ebene " << gitterebene << endl;
#endif
//                ep_plus_dazu->hinweg(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 1 rang " << rang << endl;
#endif
                }
            }
        }
    }

#ifdef GITTER_EP_PLUS_DAZU
// Kommentar: Sie ist genau wue die Funktion  'einfuegen_ebene_auch_dynamisch', nur mit horizontalen
// Vektoren fr den Nord - Sd - Fall.
void Gitter::einfuegen_ebene_auch_dynamisch_ns(MV_horizontal * mv_horizontal, int zielrang)
    {
    if((gitterebene>=1)&&(gitterebene<=h_min))
        {
        einfuegen_ebene_auch_dynamisch_mit_epd_ns(mv_horizontal, zielrang);
        }
    else
        {
        einfuegen_ebene_auch_dynamisch_ohne_epd_ns(mv_horizontal, zielrang);
        }
    }
#else
void Gitter::einfuegen_ebene_auch_dynamisch_ns(MV_horizontal * mv_horizontal, int zielrang)
    {
    einfuegen_ebene_auch_dynamisch_ohne_epd_ns(mv_horizontal, zielrang);
    }
#endif

// Kommentar: Sie ist genau wue die Funktion  'einfuegen_ebene_auch_dynamisch_mit_epd', nur mit horizontalen
// Vektoren fr den Nord - Sd - Fall.
void Gitter::einfuegen_ebene_auch_dynamisch_mit_epd_ns(MV_horizontal * mv_horizontal, int zielrang)
// Was genau fr einen Zweck hat epd?
    {
#ifdef AUSGABEN_GITTER
    cout << "Einfuegen Ebene // rang " << rang << " gitterebene " << gitterebene << endl;
#endif
    g1 = mv_horizontal->g1_speichern[gitterebene];
    g2 = mv_horizontal->g2_speichern[gitterebene];
    f = mv_horizontal->f_speichern[gitterebene];
    index = mv_horizontal->indizes[gitterebene];

    for(i=0; i<index; i++)
        {
        if(punkt_aenderung_dynamisch==true)
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
                einfuegen_fl(hvektor_f, j);
//                P_minus->hinweg(j, vvektor_g);
//                P_plus->hinzu(j, vvektor_g);
                farbenfeld[hvektor_f][j] = rang;
                punkt_hinzufuegen_selbstnachbarn_dynamisch(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 3 rang " << rang << endl;
#endif
                ep_plus_dazu->hinzu(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 3 rang " << rang << endl;
#endif
// Beim Einfuegen: Zuerst einfuegen, und dann zhlen!
                }
            }
        else
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
                einfuegen_fl(hvektor_f, j);
                farbenfeld[hvektor_f][j] = rang;
                punkt_hinzufuegen_selbstnachbarn(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 3 rang " << rang << endl;
#endif
                ep_plus_dazu->hinzu(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 3 rang " << rang << endl;
#endif
// Beim Einfuegen: Zuerst einfuegen, und dann zhlen!
                }
            }
        }
    }

// Kommentar: Sie ist genau wue die Funktion  'einfuegen_ebene_auch_dynamisch_ohne_epd', nur mit horizontalen
// Vektoren fr den Nord - Sd - Fall.
void Gitter::einfuegen_ebene_auch_dynamisch_ohne_epd_ns(MV_horizontal * mv_horizontal, int zielrang)
// Was genau fr einen Zweck hat epd?
    {
#ifdef AUSGABEN_GITTER
    cout << "Einfuegen Ebene // rang " << rang << " gitterebene " << gitterebene << endl;
#endif
    g1 = mv_horizontal->g1_speichern[gitterebene];
    g2 = mv_horizontal->g2_speichern[gitterebene];
    f = mv_horizontal->f_speichern[gitterebene];
    index = mv_horizontal->indizes[gitterebene];

    for(i=0; i<index; i++)
        {
        if(punkt_aenderung_dynamisch==true)
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
                einfuegen_fl(hvektor_f, j);
                farbenfeld[hvektor_f][j] = rang;
                punkt_hinzufuegen_selbstnachbarn_dynamisch(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 3 rang " << rang << endl;
#endif
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 3 rang " << rang << endl;
#endif
// Beim Einfuegen: Zuerst einfuegen, und dann zhlen!
                }
            }
        else
            {
            hvektor_g1 = g1[i];
            hvektor_g2 = g2[i];
            hvektor_f = f[i];

#ifdef AUSGABEN_GITTER
            cout << " f " << hvektor_f << " g1 " << hvektor_g1 << " g2 " << hvektor_g2 << endl;
#endif

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
                einfuegen_fl(hvektor_f, j);
//                P_minus->hinweg(j, vvektor_g);
//                P_plus->hinzu(j, vvektor_g);
                farbenfeld[hvektor_f][j] = rang;
                punkt_hinzufuegen_selbstnachbarn(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Vor ep_plus_dazu 3 rang " << rang << endl;
#endif
//                ep_plus_dazu->hinzu(hvektor_f, j);
#ifdef AUSGABEN_GITTER
                cout << "In Gitter: Nach ep_plus_dazu 3 rang " << rang << endl;
#endif
                }
            }
        }
    }

// Kommentar: Diese Funktion schreibt die Punkte dieses Gitters in eine Datei unter dem Namen der eigenen ID / des eigenen Rangs.
// Gnuplot setzt die Informationen dieser Dateien dann zusammen. Die Zeit muss angegeben werden, damit die
// Gitteraufteilung jeweils mit einer Iteration verbunden weredn kann. Sie wird im Dateinamen mit angegeben.
void Gitter::schreibe_datafile(int zeit)
    {
// Kommentar: Die Datei zum Schreiben der Gitterpunkte wird geffnet.
    schreibe_gp_datafile.tun2anfang(zeit);

// Kommentar: Das Gitter wird durchlaufen, und der jeweilige Gitterpunkt in die Datei bzgl schreibe_gp_datafile.aus
// geschrieben.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();
        naechster();

        * schreibe_gp_datafile.aus << j << " " << k << endl;
        }
// Kommentar: Die Datei zum Schreiben der Gitterpunkte wird geschlossen.
    schreibe_gp_datafile.tun2ende();
    }

// Kommentar: Es wird geprft, ob ein gewisser Punkt auf dem Gitter vorhanden ist. Noralerweise zu Debugging - Zwecken.
bool Gitter::pruefe_auf_existenz(int f, int g)
    {
// Kommentar: Das Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
        j = lesen_f();
        k = lesen_g();

// Kommentar: Wenn der Punkt gefunden wurde, gebe true zurck.
        if(f==j)
            {
            if(g==k)
                {
                return(true);
                }
            }
        naechster();
        }
// Kommentar: Der Punkt wurde nicht gefunden. Also gebe false aus.
    return(false);
    }

// Kommentar: Die Randpunktliste wird ausgegeben, indem sie durchlaufen wird, und die Koordinaten ihrer Punkte ausgegeben werrden.
void Gitter::ausgeben_dynamisch(char * text)
    {
    if((rang==3)&&(gitterebene==0))
        {
        cout << " Ausgeben dynamisch " << text << " t " << t;
        for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
            {
            j = dynamischer_rand.lesen_f();
            k = dynamischer_rand.lesen_g();
            cout << " j " << j << " k " << k;
            }
        cout << endl;
        }
    }

// Kommentar: Auf dem Gitter wird u0 auf 0 gesetzt.
void Gitter::u_ruecksetzen(void)
    {
// Kommentar: Das Gitter wird durchlaufen.
    for(anfangsposition();ist_fertig_fl()==false;)
        {
// Kommentar: Der jeweilige Punkt wird gelesen.
        j = lesen_f();
        k = lesen_g();

// Kommentar: Und dort wird u0 auf 0 gesetzt.
        u0[j][k] = 0.0;

        naechster();
        }
    }

// Kommentar: Hier wird dasselbe wie bei randstruktur_bilden_dynamisch gemacht, nur dass zustzlich - fr die
// Lastwertekorrektur - die Punkte, die am echten Rand (es existiert ein Nachbarpunkt mit farbenfeld -1) liegen,
// in lastwerte_korrektur_punkte markiert werden.
void Gitter::randstruktur_bilden_dynamisch_mit_minus1_merken(void)
// Hier wird die Randstruktur gebildet als Menge aller Punkte, wo der Wert zum jeweiligen
// Nachbarprozessor zu verschicken ist.
    {
#ifdef AUSGABEN_GITTER
    cout << "Zu Beginn von randstruktur_bilden dynamisch Rang " << rang << endl;
#endif
// Kommentar: Die Randpunktliste wird durchlaufen, und die Koordinaten der Punkte werden gelesen.
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();

// Vergleiche mit der switch Anweisung von 'randstruktur_bilden_dynamisch'
        switch(255-selbstnachbarn[j][k])
            {
           case 0:
               break;
           case 1:
// Vergleiche mit der case Anweisung von '::randstruktur_bilden_dynamisch'. Einziger Unterschied: Zur Randbestimmung wird hier
// die Funktion 'randpunkte_einfuegen_mit_minus1_merken' aufgerufen, bei der, falls in der Himmelsrichtung das Farbenfeld < 0 ist,
// in 'lastwerte_korrektur_punkte' eingefgt wird.
               randpunkt_einfuegen_mit_minus1_merken_nord;
               break;
           case 2:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               break;
           case 3:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               break;
           case 4:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               break;
           case 5:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               break;
           case 6:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               break;
           case 7:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               break;
           case 8:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 9:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 10:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 11:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 12:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 13:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 14:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 15:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               break;
           case 16:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 17:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 18:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 19:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 20:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 21:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 22:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 23:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 24:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 25:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 26:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 27:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 28:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 29:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 30:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 31:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               break;
           case 32:
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 33:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 34:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 35:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 36:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 37:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 38:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 39:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 40:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 41:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 42:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 43:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 44:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 45:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 46:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 47:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 48:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 49:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 50:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 51:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 52:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 53:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 54:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 55:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 56:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 57:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 58:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 59:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 60:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 61:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 62:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 63:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 64:
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 65:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 66:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 67:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 68:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 69:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 70:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 71:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 72:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 73:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 74:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 75:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 76:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 77:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 78:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 79:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 80:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 81:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 82:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 83:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 84:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 85:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 86:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 87:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 88:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 89:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 90:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 91:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 92:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 93:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 94:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 95:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 96:
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 97:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 98:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 99:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 100:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 101:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 102:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 103:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 104:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 105:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 106:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 107:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 108:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 109:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 110:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 111:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 112:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 113:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 114:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 115:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 116:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 117:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 118:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 119:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 120:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 121:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 122:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 123:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 124:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 125:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 126:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 127:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               break;
           case 128:
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 129:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 130:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 131:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 132:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 133:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 134:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 135:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 136:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 137:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 138:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 139:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 140:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 141:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 142:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 143:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 144:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 145:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 146:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 147:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 148:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 149:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 150:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 151:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 152:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 153:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 154:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 155:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 156:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 157:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 158:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 159:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 160:
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 161:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 162:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 163:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 164:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 165:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 166:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 167:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 168:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 169:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 170:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 171:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 172:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 173:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 174:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 175:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 176:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 177:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 178:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 179:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 180:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 181:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 182:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 183:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 184:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 185:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 186:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 187:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 188:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 189:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 190:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 191:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 192:
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 193:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 194:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 195:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 196:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 197:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 198:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 199:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 200:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 201:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 202:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 203:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 204:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 205:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 206:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 207:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 208:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 209:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 210:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 211:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 212:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 213:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 214:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 215:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 216:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 217:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 218:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 219:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 220:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 221:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 222:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 223:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 224:
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 225:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 226:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 227:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 228:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 229:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 230:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 231:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 232:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 233:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 234:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 235:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 236:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 237:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 238:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 239:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 240:
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 241:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 242:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 243:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 244:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 245:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 246:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 247:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 248:
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 249:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 250:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 251:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 252:
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 253:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 254:
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 255:
               randpunkt_einfuegen_mit_minus1_merken_nord;
               randpunkt_einfuegen_mit_minus1_merken_nordost;
               randpunkt_einfuegen_mit_minus1_merken_ost;
               randpunkt_einfuegen_mit_minus1_merken_suedost;
               randpunkt_einfuegen_mit_minus1_merken_sued;
               randpunkt_einfuegen_mit_minus1_merken_suedwest;
               randpunkt_einfuegen_mit_minus1_merken_west;
               randpunkt_einfuegen_mit_minus1_merken_nordwest;
               break;
            }

        }
#ifdef AUSGABEN_GITTER
    cout << "Am Ende von Randstruktur bilden rang " << rang << endl;
#endif
    }

// Kommentar: Hier wird dasselbe wie bei randstruktur_bilden_beide_dynamisch gemacht, nur dass zustzlich - fr die
// Lastwertekorrektur - die Punkte, die am echten Rand (es existiert ein Nachbarpunkt mit farbenfeld -1) liegen,
// in lastwerte_korrektur_punkte markiert werden.
void Gitter::randstruktur_bilden_beide_dynamisch_mit_minus1_merken(void)
// Hier wird die Randstruktur gebildet als Menge aller Punkte, wo der Wert zum jeweiligen
// Nachbarprozessor zu verschicken ist.
    {
//#ifdef AUSGABEN_GITTER
#ifdef AKTUELLE_KOMMENTARE
    cout << "Zu Beginn von randstruktur_bilden_beide dynamisch mit minus1 merken Rang " << rang << endl;

    if((rang==1)&&(gitterebene==0))
        {
        cout << " Bilden beide 11 / rang " << rang << " ";
        }
#endif
//#endif

// Kommentar: Die Randpunktliste wird durchlaufen, und die Koordinaten der Punkte werden gelesen.
    for(dynamischer_rand.anfangsposition();dynamischer_rand.ist_fertig_fl()==false;dynamischer_rand.naechster())
        {
        j = dynamischer_rand.lesen_f();
        k = dynamischer_rand.lesen_g();

#ifdef AKTUELLE_KOMMENTARE
        if((rang==1)&&(gitterebene==0))
            {
            cout << " gitter j " << j << " k " << k << endl;
            }
#ifdef AUSGABEN_GITTER

        if((rang==1)&&(gitterebene==1)&&(j==2)&&(k==7))
            {
            cout << " Bilden beide 1127 / rang " << rang << " 255-snb " << 255-selbstnachbarn[j][k] << " " << " ff(1,6) " << farbenfeld[1][6];
            cout << " feld " << feld[2][7] << " dyn.feld " << dynamischer_rand.feld[2][7] << endl;
            }

        cout << " j " << j << " k " << k << " 255-snb " << 255-selbstnachbarn[j][k] << " ";

#endif
#endif

// Vergleiche mit der switch Anweisung von 'randstruktur_bilden_beide_dynamisch'
        switch(255-selbstnachbarn[j][k])
            {
           case 0:
               break;
           case 1:
// Vergleiche mit der case Anweisung von '::randstruktur_bilden_dynamisch'. Einziger Unterschied: Zur Randbestimmung wird hier
// die Funktion 'randpunkte_einfuegen_mit_minus1_merken' aufgerufen, bei der, falls in der Himmelsrichtung das Farbenfeld < 0 ist,
// in 'lastwerte_korrektur_punkte' eingefgt wird.
               randpunkte_einfuegen_mit_minus1_merken_nord;
               break;
           case 2:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               break;
           case 3:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               break;
           case 4:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               break;
           case 5:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               break;
           case 6:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               break;
           case 7:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               break;
           case 8:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 9:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 10:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 11:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 12:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 13:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 14:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 15:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               break;
           case 16:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 17:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 18:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 19:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 20:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 21:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 22:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 23:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 24:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 25:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 26:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 27:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 28:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 29:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 30:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 31:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               break;
           case 32:
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 33:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 34:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 35:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 36:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 37:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 38:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 39:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 40:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 41:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 42:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 43:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 44:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 45:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 46:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 47:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 48:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 49:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 50:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 51:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 52:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 53:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 54:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 55:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 56:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 57:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 58:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 59:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 60:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 61:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 62:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 63:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               break;
           case 64:
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 65:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 66:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 67:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 68:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 69:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 70:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 71:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 72:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 73:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 74:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 75:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 76:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 77:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 78:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 79:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 80:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 81:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 82:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 83:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 84:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 85:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 86:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 87:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 88:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 89:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 90:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 91:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 92:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 93:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 94:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 95:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 96:
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 97:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 98:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 99:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 100:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 101:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 102:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 103:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 104:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 105:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 106:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 107:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 108:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 109:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 110:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 111:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 112:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 113:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 114:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 115:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 116:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 117:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 118:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 119:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 120:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 121:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 122:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 123:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 124:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 125:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 126:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 127:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               break;
           case 128:
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 129:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 130:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 131:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 132:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 133:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 134:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 135:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 136:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 137:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 138:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 139:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 140:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 141:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 142:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 143:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 144:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 145:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 146:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 147:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 148:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 149:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 150:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 151:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 152:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 153:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 154:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 155:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 156:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 157:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 158:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 159:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 160:
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 161:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 162:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 163:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 164:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 165:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 166:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 167:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 168:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 169:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 170:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 171:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 172:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 173:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 174:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 175:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 176:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 177:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 178:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 179:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 180:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 181:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 182:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 183:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 184:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 185:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 186:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 187:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 188:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 189:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 190:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 191:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 192:
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 193:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 194:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 195:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 196:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 197:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 198:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 199:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 200:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 201:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 202:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 203:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 204:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 205:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 206:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 207:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 208:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 209:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 210:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 211:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 212:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 213:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 214:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 215:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 216:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 217:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 218:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 219:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 220:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 221:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 222:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 223:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 224:
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 225:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 226:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 227:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 228:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 229:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 230:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 231:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 232:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 233:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 234:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 235:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 236:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 237:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 238:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 239:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 240:
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 241:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 242:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 243:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 244:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 245:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 246:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 247:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 248:
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 249:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 250:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 251:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 252:
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 253:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 254:
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
           case 255:
               randpunkte_einfuegen_mit_minus1_merken_nord;
               randpunkte_einfuegen_mit_minus1_merken_nordost;
               randpunkte_einfuegen_mit_minus1_merken_ost;
               randpunkte_einfuegen_mit_minus1_merken_suedost;
               randpunkte_einfuegen_mit_minus1_merken_sued;
               randpunkte_einfuegen_mit_minus1_merken_suedwest;
               randpunkte_einfuegen_mit_minus1_merken_west;
               randpunkte_einfuegen_mit_minus1_merken_nordwest;
               break;
            }
        }
#ifdef AUSGABEN_GITTER
    cout << "Am Ende von Randstruktur bilden beide dynamisch mit minus1 merken rang " << rang << endl;
#endif
    }

// Kommentar: Das Gitter wird durchlaufen. Gibt es einen Gitterpunkt nicht, dann ist das Gitter nicht voll, und es wird
// false zurckgegeben.
bool Gitter::test_auf_volles_gitter(void)
    {
// Kommentar: Das Gitter wird durchlaufen.
    for(j=0; j<n; j++)
        {
        for(k=0; k<m; k++)
            {
// Kommentar: Gibt es einen Gitterpunkt nicht -> das Gitter ist nicht voll -> return(false)
            if(feld[j][k]<0)
                {
                return(false);
                }
            }
        }
    return(true);
    }

// Kommentar: Das Gitter wird durchlaufen. Gibt es einen Gitterpunkt, dann ist das Gitter nicht leer, und es wird
// false zurckgegeben.
bool Gitter::test_auf_leeres_gitter(void)
    {
// Kommentar: Das Gitter wird durchlaufen.
    for(j=0; j<n; j++)
        {
        for(k=0; k<m; k++)
            {
// Kommentar: Gibt es einen Gitterpunkt -> das Gitter ist nicht leer -> return(false)
            if(feld[j][k]>=0)
                {
                return(false);
                }
            }
        }
    return(true);
    }

#ifdef KURZ
// Kommentar: Hier werden alle Gitterpunkte in den Buffer 'koordinaten' eingefgt, und die Anzahl am Anfang des Buffers geschrieben.
void Gitter::sammeln(short int * _koordinaten)
#else
void Gitter::sammeln(int * _koordinaten)
#endif
    {
    koordinaten = _koordinaten;
// Kommentar: Der Buffer wird vorbereitet.
    sammeln_start();
// Kommentar: Das Gitter wird durchlaufen, und der jeweilige Gitterpunkt wird gelesen.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        j = lesen_f();
        k = lesen_g();
// Kommentar: Der Gitterpunkt wird in den Buffer eingetragen.
        sammeln_punkt_bearbeiten_nord_sued(j,k);
        }
// Kommentar: Das Sammeln wird beendet, wobei das nchste Sammeln vorbereitet wird.
    sammeln_ende();
// Kommentar: Schreiben, wieviele Punkte das Gitter hat.
    koordinaten[0] = index_sammeln;
    koordinaten[1] = NORD_SUED;
    }

// Kommentar: Entsprechend der Dissertation werden ggf. die Funktionswerte in der Zeit gendert. Das wird mit dieser
// Funktion erreicht. Zu den Formeln vergleiche man auch die Formeln in dem Buch von Herrn Prof. Joppich.
void Gitter::schreibe_f_werte(int t)
    {
// Zuerst wird die zeitabhngige Hilfsvariable t_d bestimmt.
#ifdef T_D_GLEICH_0
    t_d = 0;
#else
    t_d = t;
    t_d = t_d * h_y / t_konst;
#endif
// ausprobieren t_d = 0; 6.2.16: Diesen 'Kommentar' lassen.

#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " IJKL t_d " << t_d << " rang " << rang << " t " << t << endl;
#endif

// Kommentar: Dann wird das Gitter durchlaufen, und der jeweilige Gitterpunkt wird gelesen.
    for(anfangsposition();ist_fertig_fl()==false;naechster())
        {
        i = lesen_f();
        j = lesen_g();

// Kommentar: x_i bleibt, aber y_i bekommt einen Zeitzuschlag.
        x = x_i[i];
        y = y_j[j] + t_d;

// Kommentar: Wenn y 1.0 erreicht, geht es wieder runter mit y, so dass immer noch 0 <= f0 <= 1 gelten wird.
        if(y >= 1.0)
            {
            y = 2.0-y;
            }
// Kommentar: Der Funktionswert wird entsprechend der abgeleiteten Formel in der Arbeit von Prof. Joppich berechnet.
        f0[i][j] = -6.0 * (x*x*y*(x*x+2*y*y));
        }
    }

// Kommentar: Am Rand werden - und das gilt eigentlich nur auf dem feinsten Gitter - die Randwerte berechnet
// entsprechend der Formel in der Arbeit von Prof. Joppich. Die nderung in der y_j Variablen entspricht der
// der Funktion 'schreibe_f_werte'. Daher wird hier nichts weiter kommentiert.
void Gitter::schreibe_u_werte(int t)
    {
    t_d = t;
    t_d = t_d * h_y / t_konst;

    for(i=0; i<n; i=i+n-1)
        {
        for(j=0; j<m; j++)
            {
            if(feld[i][j]!=-1)
                {
                x = x_i[i];
                y = y_j[j] + t_d;
                y = y_j[j];

                if(y >= 1.0)
                    {
                    y = 2.0-y;
                    }

                u0[i][j] = x*x*x*x*y*y*y;
                }
            }
        }

    for(i=0; i<n; i++)
        {
        for(j=0; j<m; j=j+m-1)
            {
            if(feld[i][j]!=-1)
                {
                x = x_i[i];
                y = y_j[j] + t_d;
                y = y_j[j];

                if(y >= 1.0)
                    {
                    y = 2.0-y;
                    }
                u0[i][j] = x*x*x*x*y*y*y;
                }
            }
        }
    }

void Gitter::zeitausgabe(char * text)
    {
    if(rang!=0)
        {
        return;
        }
    cout << " Gitter Zeitausgabe rang " << rang << " text " << text << " Zeit " << MPI_Wtime() - zeit_anfang_zyklus << endl;
    }

// Kommentar: Kopiert von src nach dest auf dem eigenen Gitter
void Gitter::kopiere_werte(double ** dest, double ** src)
    {
    for(anfangsposition();ist_fertig_fl()==false;)
        {
// Kommentar: ... liest den jeweiligen Gitterpunkt
        j = lesen_f();
        k = lesen_g();
// Kommentar: bewirkt ein Setzen des nchsten Gitterpunktes.
        naechster();
// Kommentar: Kopiere
        dest[j][k] = src[j][k];
        }
    }
