// Kommentar: Hier geschieht die Migration. Kommentiert wird der Ost - West Lastausgleich. Der Nord - Süd - Lastausgleich folgt analog.
// Die Packen - und Entpacken - Funktionen brauchen nur für Ost oder nur für West kommentiert werden, der andere Fall geht analog.
// Nur die Initialisierungsroutinen und ähnliche Funktionen sind für alle Fälle da. Da kann man die Schritte in den Funktionen
// als analog erklären.
// Man hat bei der Migration die Hauptfunktionen lt_durchfuehren_1/2wo/ns, dann Hilfsberechnungen, packen und entpacken Funktionen,
// mit Unterfunktionen, und Initialisierung und Finalisierung. Beim Transport der ep-Information werden dann noch Funktionen wie
// packen/entpacken_ep_wo/ns_rumpf verwendet.

// Bemerkung: Bisher nur Ost - West - Lastausgleich. Nord - Sued - Lastausgleich fehlt noch.
// Bemerkung: Nachkorrektur auch für oben
// Bemerkung: Aufgabe: Lastdifferenzen korrigieren durch das Packen unten auf oben.
// Aufgabe: bei ep_packen kann man als offset nicht den Index verwenden. Wahrscheinlich doch. Der Index gibt jeweils an,
//          wie weit der mvf_Buffer bisher beschrieben worden ist. Also sozusagen erledigt, da es schon richtig war.
// Aufgabe: packen_ost_abschliessen machen vor dem Warten auf die Kommunikation.
// Aufgabe: Nachkorrektur oben!
// Die Nachkorrektur funktioniert nicht richtig. Bei allem Senden müssen auch die Buffer entsprechend beschrieben werden.
// Nachkorrektur ist auch oben korrekt, da alles über mv_westen und mv_osten läuft.

// Nachkorrektur oben korrekt. Es funktioniert so: Falls senden, oder senden_oben, dann wird die variable senden
// mit sende_ost oder sende_west gesetzt. Dann wird in nachkorrektur::logisch gesammelt. Übertragen wird in jedem Fall,
// weil der Nachbarprozessor nicht weiss, ob der Nachbar sendet oder empfaengt oder beides tut.
// So wird die Nachkorrektur für beides, oben wie unten, bearbeitet.
// Aufgabe: Die Nachkorrektur - Testfelder ggf. mit anderen Testfeldern kombinieren, um Speicherplatz zu sparen.
// Aufgabe: In Lsatausgleich sind Sendebuffer und Empfangsbuffer nicht getrennt. Das muss vielleicht korrigiert werden.

#include "lastausgleich.h"

// Kommentar: Diese Funktion dient nur dem Zweck, statt der übergebenen Lastmenge überall dieselbe Lastmenge 'faktor' zu übertragen.
// Aber: Eigentlich wird sie auch nicht mehr gebraucht.
void LastAusgleich::signum(int faktor)
    {
    if(west_differenz>0)
        {
        west_differenz = faktor;
        }
    if(west_differenz<0)
        {
        west_differenz = -faktor;
        }
    if(ost_differenz>0)
        {
        ost_differenz = faktor;
        }
    if(ost_differenz<0)
        {
        ost_differenz = -faktor;
        }
    if(west_differenz_oben>0)
        {
        west_differenz_oben = faktor;
        }
    if(west_differenz_oben<0)
        {
        west_differenz_oben = -faktor;
        }
    if(ost_differenz_oben>0)
        {
        ost_differenz_oben = faktor;
        }
    if(ost_differenz_oben<0)
        {
        ost_differenz_oben = -faktor;
        }
    }

// Kommentar: Bei 4 Kernen wird derselbe Lastwert von Westen nach Osten verschickt, und keine Last oben. Aber: Benötigt wird diese
// Funktion außerdem auch nicht mehr.
void LastAusgleich::signum2(int faktor)
    {
    if(rang==0)
        {
        west_differenz = 0;
        ost_differenz = faktor;
        west_differenz_oben = 0;
        ost_differenz_oben = 0;
        }
    if(rang==1)
        {
        west_differenz = -faktor;
        ost_differenz = 0;
        west_differenz_oben = 0;
        ost_differenz_oben = 0;
        }
    if(rang==2)
        {
        west_differenz = 0;
        ost_differenz = faktor;
        west_differenz_oben = 0;
        ost_differenz_oben = 0;
        }
    if(rang==3)
        {
        west_differenz = -faktor;
        ost_differenz = 0;
        west_differenz_oben = 0;
        ost_differenz_oben = 0;
        }
    }


// Kommentar: Eine Ausgabefunktion zu Debugging - Zwecken. Wird eigendlich nicht benötigt. Keine Kommentierung.
void LastAusgleich::test003(char * text)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
#endif
    }

// Kommentar: Diese Funktion wird nicht benötigt. Nur, weil lt_durchfuehren1_wo definiert ist, soll die entsprechende ns Funktion
// auch definiert sein. Sie darf leer sein, da eh nur lt_durchfuehren2_ns aufgerufen wird.
void LastAusgleich::lt_durchfuehren1_ns(int _rang, int _gitterebene)
    {
    }

// Kommentar: Eine Finalisierungsfunktion - um Speicherplatz freizugeben. Zu den Variablen vergleiche man die Initialisierung initialisieren_pr.

void LastAusgleich::finalisieren_pr(void)
    {
    farbmatrix.beenden();
    delete n_h;
    delete m_h;
    // la_kommuniktaionen.initialisieren belegt keinen Speicherplatz
    }

// Kommentar: Eine Initialisierungsfunktion dieser Klasse.
void LastAusgleich::initialisieren_pr(int _n, int _m, int _h_min, int _h_max, int _groesse, int _rang, int _h_kappe)
    {
// Kommentar: Zuerst werden die Übergabeparameter gespeichert.
    n = _n;
    m = _m;
    h_min = _h_min;
    h_max = _h_max;
    h_gesamt = h_min + h_max + 1;
    groesse = _groesse;
    rang = _rang;
    h_kappe = _h_kappe;
// Kommentar: Dann wird bestimmt, bis zur welcher Gitterebene der Lastausgleich reichen soll / muss.
    if(h_kappe==-1)
        {
        h_gesamt_variante = h_gesamt;
        }
    else
        {
        h_gesamt_variante = h_kappe + 1;
        }

// Kommentar: Die Farbmatrix wird angelegt. Damit hat man Zugriff auf die ID's des westliche, östlichen, nördlichen und südlichen Kerns.
    farbmatrix.starten(groesse); // durch beenden finalisiert
// Kommentar: Diese Informationen werden an die Kommunikationsklasse zu dieser Klasse, LAKommunikationen, weitergegeben, ohne weiteren
// Speicherplatz anzufordern.
    la_kommunikationen.initialisieren(farbmatrix.west[rang], farbmatrix.ost[rang], farbmatrix.nord[rang], farbmatrix.sued[rang], n*m, rang);
    // legt keinen Speicherplatz an.

// Komemntar: Mit diesem Feld werden n und m für alle Gitterebenen gespeichert. Erst wird der Speicherplatz angefordert, ...
    n_h = new int [h_gesamt];
    m_h = new int [h_gesamt];

// Kommentar: ... und dann werden n_h und m_h für alle Ebenen bestimmt.
    m_hilfe = m;
    n_hilfe = n;

    for(i=0; i<h_gesamt; i++)
        {
        n_h[i] = n_hilfe;
        m_h[i] = m_hilfe;

        n_hilfe = (n_hilfe+1)/2;
        m_hilfe = (m_hilfe+1)/2;
        }

    }

// Kommentar: Hier geschieht eine wesentliche Finalisierung dieser Klasse, d.h. es wird viel Speicherplatz freigegeben.
// Zu den einzelnen Variablen bzw. Strukturen vergleiche man die Funktion initialisierung_ausfuehren.
void LastAusgleich::finalisierung_ausfuehren(void)
    {
/////////////////////////////////////////////////
/**/
    nachkorrektur.finalisieren_nk(); // Änderung 6.2.16: In Code aufgenommen.
/**/
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor Ende finalisieren_LA " << endl;
#endif
    finalisieren_LA();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Ende finalisieren_LA " << endl;
#endif
//    lastmengen_v.finalisieren_vertikal();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende 5b " << endl;
#endif
//    lastmengen_v.finalisieren_pa();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende 5c " << endl;
#endif
//    lastmengen.finalisieren_pa();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende 5d " << endl;
#endif
//    lastmengen.finalisieren_normal();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende 5e " << endl;
#endif
//    lastmengen2.finalisieren_normal();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende 5f " << endl;
#endif
    }

// Kommentar: Hier geschieht eine wesentliche Bereitstellung von Speicherplatz für diese Klasse, wobei die Felder sendebuffer und empfangsbuffer
// übergeben werden können, um gewissen Speicherplatz mehrfach im Programm benutzen zu können. In dem Fall muss dieser Speicherplatz hier nur
// übernommen, aber nicht angelegt werden.
#ifdef GEMEINSAME_BUFFER
void LastAusgleich::initialisierung_ausfuehren(double ** sendebuffer, double ** empfangsbuffer)
#else
void LastAusgleich::initialisierung_ausfuehren(void)
#endif
// finalisieren dazu ist überprüft
    {
// Die Parameter rang ung groesse sind bekannt. Hier wird bestimmt, welche Art von Kern in der Kerntopologie vorliegt, ob er beispielsweise am Rand liegt,
// und wenn ja, an welchem, oder auch isoliert ist.
    NBI_horizontal = NBI_horizontal_machen(rang, groesse);
// Kommentar: Analog zu NBI_horizontal_machen, nur für den Nord - Süd - Lastausgleich, statt des Ost - West - Lastausgleiches.
    NBI_vertikal = NBI_vertikal_machen(rang, groesse);

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "lasttransfer.initialisieren durch Rang " << rang << endl;
#endif

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "lasttransfer initialisieren_lt durch Rang " << rang << endl;
#endif

// Kommentar: Urspünglich wurden die zu transferierenden Lastmengen in dieser Klasse bestimmt. Diese Klassen werden hier initialisiert.
// Mittlerweile ist das aus dieser Klasse entfernt, weshalb diese Initialisierungen jetzt eigentlich überflüssig sind.
//    lastmengen.initialisieren_normal(rang, groesse);
//    lastmengen2.initialisieren_normal(rang, groesse);
    // wird finalisiert

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "lastmengen initialisieren_normal durch Rang " << rang << endl;
#endif

// Kommentar: Hier wird Speicherplatz für die Ausgabe von Lastmengen bereitgestellt. Das diese Klasse hier nicht mehr verwendet wurde, wurde
// eben schon geschrieben.
//    lastmengen.initialisieren_pa(rang, groesse, 0);
    // wird finalisiert in der Unterklasse ParallelAusgeben.

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " initialisieren_pa durch Rang " << rang << endl;
#endif

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "lastmengen initialisieren durch Rang " << rang << endl;
#endif

// Kommentar: Hier wird eine Instanz für die Klasse LastMengen beim Nord - Süd Lastausgleich angelegt. Aber auch diese Funktion wird eigentlich nicht
// mehr verwendet.
//    lastmengen_v.initialisieren_vertikal(rang, groesse);
//    lastmengen_v.initialisieren_pa(rang, groesse, 1);
    // wird finalisiert

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " initialisieren_pa für vertikal durch Rang " << rang << endl;
#endif

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "lastmengen_v initialisieren durch Rang " << rang << endl;
#endif


#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "nachbar_prozessoren.initialisieren durch Rang " << rang << endl;
#endif
// Nachkorrektur

// Kommentar: Das Folgende ist eine wesentliche Initialisierung, die von dieser Initialisierungsfunktion aufgerufen wird. Dabei wird
// ggf. der Sendebuffer und Empfangsbuffer, die an diese Klasse übergeben wurden, weitergegeben. Es handelt sich dabei um relevant viel
// Speicherplatz.
#ifdef GEMEINSAME_BUFFER
    initialisieren_LA(sendebuffer, empfangsbuffer);
#else
    initialisieren_LA();
#endif

    cout << " Nach initialisieren_LA rang " << rang << endl;

    // wird finalisiert. ist überprüft, ggf. mit ep_aktuell ein Problem.

// Kommentar: Hier wird die Initialisierung der Klasse Nachkorrektur aufgerufen.
    nachkorrektur.initialisieren_nk(n, m, groesse, rang , h_gesamt, & mv_westen, & mv_osten, & mv_norden, & mv_sueden);

// Kommentar: Und die Klasse Nachkorrektur bekommt die Zeiger auf das Farbenfeld zugeteilt.
    for(i=0; i<nachkorrektur.h_gesamt; i++)
        {
        nachkorrektur.farbenfelder[i] = paralleles_rechnen_l[i]->farbenfeld;
        }
//  Wofür diese Nachkorrekturfelder setzen?

// Ende Initialisierung

    }

// Kommentar: Eine Ausgabefunktion zu Debugging - Zwecken.
void LastAusgleich::ausgeben(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "LT_DURCHFUEHREN" << endl;
#endif

// Kommentar: Es werden die Lastmengen ausgegeben. Die hier eigentlich nicht mehr benötigt werden.
//    lastmengen.ausgeben();
    }

//void LastAusgleich::bestimme_prozessornachbarn(void)

// Kommentar: Diese Funktion bewirkt nichts.
void LastAusgleich::aktiviere_ist_nachbarn(void)
// Hier wird ist_nachbar bestimmt!
    {
    }

// Kommentar: Bei dieser Funktion wird für die Klasse Nachkorrektur der Buffer ausgegeben - zu Debugging Zwecken.
void LastAusgleich::nachkorrektur_durchfuehren_sendebuffer_bestimmen_abschliessen(void)
    {
    nachkorrektur.buffer_ausgeben();
    }

// Kommentar: Hier werden die Sendebuffer für die Nachkorrektur vorbereitet.
void LastAusgleich::nachkorrektur_durchfuehren_sendebuffer_bestimmen(void)
    {
// Kommentar: Macht nichts mehr, siehe oben. Die Prozessortopologie in der Klasse Nachkorrektur wird mittels der Funktion
// 'setze_ebene_ebenen_zaehler' angelegt. Wobei dabei kein Zähler angelegt, sondern die PT_ml angelegt wird.
    aktiviere_ist_nachbarn(); // Aktiviert die Prozessortopologie!
//  Dieser Befehl wird vorübergehend herausgenommen.
    // Was bedeutet diese Zeile?

// Kommentar: Hier wird der Sendebuffer zurückgesetzt, indem die relevanten Sendebuffer_Indizes auf 2 gesetzt werden. 30.10.15: Ist wohl überflüssig.
//    nachkorrektur.sendebuffer_zuruecksetzen(); // Setzt die Sendebuffer zurueck.

// Kommentar: Eine Ausgabefunktion zu Debugging - Zwecken.
    paralleles_rechnen_l[0]->ausgeben_selbstnachbarn();

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nachkorrektur Listenlaenge " << nachkorrektur.listenlaenge << endl;
#endif
    }


// Kommentar: Hier wird der eigene Knoten gekennzeichnet. Die möglichen Einstufungen sind Isoliert, LINKER_RAND, RECHTER_RAND und MITTE.
// Die Übergabeparameter sind die Kernanzahl sowie der Rang.
int LastAusgleich::NBI_horizontal_machen(int rang, int p_anzahl)
    {
// Kommentar: Zuerst werden die Fälle von 1, 4 oder 16 Kernen unterschieden.
    switch(p_anzahl)
        {
        case 1:
// Kommentar: Ein Knoten ist isoliert.
            return(ISOLIERT);
        case 2:
            switch(rang)
                {
                case 0:
                    return(LINKER_RAND);
                case 1:
                    return(RECHTER_RAND);
                }
        case 4:
// Kommentar: Bei 4 Kernen sind die Kerne mit den ID's 0 und 2 links, und die mit den ID's 1 und 3 rechts.
            switch(rang)
                {
                case 0:
                    return(LINKER_RAND);
                case 1:
                    return(RECHTER_RAND);
                case 2:
                    return(LINKER_RAND);
                case 3:
                    return(RECHTER_RAND);
                }

        case 8:
            switch(rang)
                {
                case 0:
                case 4:
                    return(LINKER_RAND);
                case 3:
                case 7:
                    return(RECHTER_RAND);
                default:
                    return(MITTE);
                }

        case 16:
// Kommentar: Bei 16 Kernen sind die Kerne mit den ID's 0,4,8,12 links, mit den ID's 3,7,11,15 rechts, und die
// übrigen Kerne in der Mitte.
            switch(rang)
                {
                case 0:
                case 4:
                case 8:
                case 12:
                    return(LINKER_RAND);
                case 3:
                case 7:
                case 11:
                case 15:
                    return(RECHTER_RAND);
                default:
                    return(MITTE);
                }
        }
// Kommentar: In anderen Fällen wird eine Fehlermeldung zurückgegeben.
    return(-1);
    }

// Kommentar: Analog zu NBI_horizontal_machen, nur für den Nord-Süd-Lastausgleich. Die Ausprägungen sind
// ISOLIERT, OBIGER_RAND, UNTERER_RAND sowie MITTE.
int LastAusgleich::NBI_vertikal_machen(int rang, int p_anzahl)
    {
    switch(p_anzahl)
        {
        case 1:
            return(ISOLIERT);
        case 2:
            return(ISOLIERT);
        case 4:
            switch(rang)
                {
                case 0:
                    return(OBIGER_RAND);
                case 1:
                    return(OBIGER_RAND);
                case 2:
                    return(UNTERER_RAND);
                case 3:
                    return(UNTERER_RAND);
                }

        case 8:
            switch(rang)
                {
                case 0:
                case 1:
                case 2:
                case 3:
                    return(OBIGER_RAND);
                case 4:
                case 5:
                case 6:
                case 7:
                    return(UNTERER_RAND);
                }
        case 16:
            switch(rang)
                {
                case 0:
                case 1:
                case 2:
                case 3:
                    return(OBIGER_RAND);
                case 12:
                case 13:
                case 14:
                case 15:
                    return(UNTERER_RAND);
                default:
                    return(MITTE);
                }
        }
    return(-1);
    }

// Komemntar: Hier werden - in Abhängigkeit der eben definierten Funktion NBI, die Flags sende_west, sende_ost, empfange_west und
// empfange_ost gesetzt. Das Flag gibt an, ob eine solche Aktion erfolgen soll/muss, oder nicht.
void LastAusgleich::SendeEmpfangsFaelle(int NBI_h)
    {
    // Die einzelnen Faelle sind klar zu machen, um Fehler zu vermeiden!
    switch(NBI_h)
        {
// Kommentar: Beim isolierten Fall gibt es keine Kommunikation.
        case ISOLIERT:
            sende_west = false;
            sende_ost = false;
            empfange_west = false;
            empfange_ost = false;
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "ISOLIERT" << endl;
#endif
            break;
// Kommentar: Im Falle RECHTER_RAND gibt es keine Kommunikation nach Osten.
        case RECHTER_RAND:
            sende_ost = false;
            empfange_ost = false;
// Kommentar: Wie nach Westen kommuniziert wird hängt dann von der west_differenz ab.
            if(lastmengen.west_differenz>0)
            // was heisst das?
                {
                sende_west = true;
                empfange_west = false;
                break;
                }
            if(lastmengen.west_differenz==0)
                {
                sende_west = false;
                empfange_west = false;
                break;
                }
            sende_west = false;
            empfange_west = true;
            break;
// Kommentar: Der Fall LINKER_RAND ist analog zum Fall RECHTER_RAND.
        case LINKER_RAND:
            sende_west = false;
            empfange_west = false;
            if(lastmengen.ost_differenz>0)
                {
                sende_ost = true;
                empfange_ost = false;
                break;
                }
            if(lastmengen.ost_differenz==0)
                {
                sende_ost = false;
                empfange_ost = false;
                break;
                }
            sende_ost = false;
            empfange_ost = true;
            break;
// Kommentar: Im Fall MITTE muss die west_differenz und die ost_differenz herangezogen werden,
// ob nach Westen oder Osten gesendet, empfangen wird oder gar nicht kommuniziert wird. Entsprechend
// werden die Flags gesetzt - wie beim RECHTEN_RAND und LINKEN_RAND nah der Seite, wo der Rand nicht ist.
        case MITTE:
            if(lastmengen.west_differenz > 0)
                {
                sende_west = true;
                empfange_west = false;
                }
            else
                {
                if(lastmengen.west_differenz == 0)
                    {
                    sende_west = false;
                    empfange_west = false;
                    }
                else
                    {
                    sende_west = false;
                    empfange_west = true;
                    }
                }
            if(lastmengen.ost_differenz > 0)
                {
                sende_ost = true;
                empfange_ost = false;
                }
            else
                {
                if(lastmengen.ost_differenz == 0)
                    {
                    sende_ost = false;
                    empfange_ost = false;
                    }
                else
                    {
                    sende_ost = false;
                    empfange_ost = true;
                    }
                }
        }
    }

// Kommentar: Diese Funktion ist analog zu SendeEmpfangsFaelle, nur für die Nord - Süd - Richtung, statt der Ost - West - Richtung.
// Daher keine weiteren Kommentare.
void LastAusgleich::SendeEmpfangsFaelle_ns(int NBI_h)
    {
    // Die einzelnen Faelle sind klar zu machen, um Fehler zu vermeiden!
    switch(NBI_h)
        {
        case ISOLIERT:
            sende_nord = false;
            sende_sued = false;
            empfange_nord = false;
            empfange_sued = false;
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "ISOLIERT" << endl;
#endif
            break;
        case UNTERER_RAND:
            sende_sued = false;
            empfange_sued = false;
            if(nord_differenz>0)
            // Was heisst das? Offenbar heisst es, eine Last zu verschicken, wenn die Differenz positiv ist.
            // Umgekehrt bedutet das, bei negativer Differenz Last zu empfangen.
                {
                sende_nord = true;
                empfange_nord = false;
                break;
                }
            if(nord_differenz==0)
                {
                sende_nord = false;
                empfange_nord = false;
                break;
                }
            sende_nord = false;
            empfange_nord = true;
            break;
        case OBIGER_RAND:
            sende_nord = false;
            empfange_nord = false;
            if(sued_differenz>0)
                {
                sende_sued = true;
                empfange_sued = false;
                break;
                }
            if(sued_differenz==0)
                {
                sende_sued = false;
                empfange_sued = false;
                break;
                }
            sende_sued = false;
            empfange_sued = true;
            break;
        case MITTE:
            if(nord_differenz > 0)
                {
                sende_nord = true;
                empfange_nord = false;
                }
            else
                {
                if(nord_differenz == 0)
                    {
                    sende_nord = false;
                    empfange_nord = false;
                    }
                else
                    {
                    sende_nord = false;
                    empfange_nord = true;
                    }
                }
            if(sued_differenz > 0)
                {
                sende_sued = true;
                empfange_sued = false;
                }
            else
                {
                if(sued_differenz == 0)
                    {
                    sende_sued = false;
                    empfange_sued = false;
                    }
                else
                    {
                    sende_sued = false;
                    empfange_sued = true;
                    }
                }
        }
    }

//////////////////////////////////////////////////////////////
/////////////   Anfang finalisieren_LA    ////////////////////
//////////////////////////////////////////////////////////////

// Kommentar: Das ist eine wesentliche Finalisierungsfunktion der Klasse Lastausgleich. Hier wird Speicherplatz freigegeben. Die einzelnen betroffenen
// Strukturen werden in der Klasse initialisieren_LA diskutiert.
void LastAusgleich::finalisieren_LA(void)
    {
    cout << " 5a1 rang " << rang << endl;
    delete ep_aktuell; // habe vorher das nicht allokiert

    delete ep_updates ;

    delete ep_plus;
    delete ep_minus;

    delete felder_aktuell;
#ifdef NK_FARBENFELDER
    cout << " 5a2 rang " << rang << endl;
    for(i=0; i<h_gesamt; i++)
        {
        cout << " 5a2i rang " << rang << " i " << i << " n_h[i]+2 " << n_h[i]+2 << endl;
        nachkorrektur.nk_farbenfelder[i]= nachkorrektur.nk_farbenfelder[i] - 1;
        for(j=0; j<n_h[i]+2; j++)
            {
            cout << " 5a2ij rang " << rang << " i " << i << " j " << j << endl;
            nachkorrektur.nk_farbenfelder[i][j] = nachkorrektur.nk_farbenfelder[i][j] - 1;
            delete (nachkorrektur.nk_farbenfelder[i][j]);
            }
        delete (nachkorrektur.nk_farbenfelder[i]);
        }
#endif
///////////////////////////////////////////////

    cout << " 5a3 rang " << rang << endl;

    delete nachkorrektur.farbenfelder;
    delete nachkorrektur.selbstnachbaren;
#ifdef NK_FARBENFELDER
    delete nachkorrektur.nk_farbenfelder;
#endif
    werte_verschicken.finalisieren();

    aus_mvf_buffer_zu_mv.finalisieren();

    aus_mv_zu_mvf_buffer.finalisieren();

    aus_mv_zu_mhf_buffer.finalisieren();
    aus_mhf_buffer_zu_mv.finalisieren();

    farbenfelder_verschicken.finalisieren_fv();

    cout << " 5a4 rang " << rang << endl;

    farbenfelder_verschicken.finalisieren_hfv();

    mv_projektionen.finalisieren();
    mv_projektionen_ns.finalisieren();

    mvf_buffer_westen.finalisieren();
    mvf_buffer_osten.finalisieren();
    if(ev_dim == 2)
        {
        mvf_buffer_westen_oben.finalisieren();
        mvf_buffer_osten_oben.finalisieren();
        }
// Initialisiere Werte Buffer
    cout << " 5a5 rang " << rang << endl;
#ifdef GEMEINSAME_BUFFER
    if(groesse==1)
        {
        delete werte_buffer_osten.buffer;
        delete werte_buffer_westen.buffer;
        }
#else
    delete werte_buffer_osten.buffer;
    delete werte_buffer_westen.buffer;
#endif
    if(ev_dim == 2)
        {
        delete werte_buffer_osten_oben.buffer;
        delete werte_buffer_westen_oben.buffer;
        }

    mv_westen.finalisieren();
    mv_osten.finalisieren();
    mv_hilfe_westen.finalisieren();
    mv_hilfe_osten.finalisieren();

    mv_norden.finalisieren();
    mv_sueden.finalisieren();
    mv_hilfe_norden.finalisieren();
    mv_hilfe_sueden.finalisieren();

    cout << " 5a6 rang " << rang << endl;

    for(i=0; i<h_gesamt; i++)
        {
        if(ev_gilt==true)
            {
            ev[i].finalisieren();
            }
        if(ev2_gilt == true)
            {
            ev2[i].finalisieren();
            }
        }

    cout << " 5a7 rang " << rang << endl;

    delete ev;
    if(ev_dim == 2)
        {
        delete ev2;
        }
    cout << " 5a8 rang " << rang << endl;
    }
//////////////////////////////////////////////////////////////
/////////////   Ende finalisieren_LA    //////////////////////
//////////////////////////////////////////////////////////////

// Kommentar: Die Hauptinitialisierungsfunktion der Klasse Lastausgleich. Hierbei werden gegebenenfalls schon benutzte Sendebuffer und
// Empfangsbuffer mitverwendet.
#ifdef GEMEINSAME_BUFFER
void LastAusgleich::initialisieren_LA(double ** sendebuffer, double ** empfangsbuffer)
#else
void LastAusgleich::initialisieren_LA(void)
#endif
// Stimmt mit finalisierung überein.
    {
// initialisiere ev's
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Initialisiere_LA" << endl;
#endif

// Kommentar: Bei ev_gilt = true werden die Zeiger für die Instanzen ev der Klasse extreme Vektoren angelegt.
    if(ev_gilt == true) // Vom 23.04.2015
        {
        ev = new ExtremeVektoren [h_gesamt];
        }

// Kommentar: Bei ev2_gilt = true werden die Zeiger für die Instanzen ev2 der Klasse extreme Vektoren angelegt.
    if(ev2_gilt == true)
        {
        ev2 = new ExtremeVektoren [h_gesamt];
        }
    // beides wird finalisiert
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " ev allokiert " << endl;
#endif

// Kommentar: Es werden die Gitterindizes durchlaufen.
    for(i=0; i<h_gesamt; i++)
        {
// Kommentar: Bei ev_gilt = true wird die Dateiausgabe der Struktur ev angelegt, sowie diese Instanz der Klasse ExtremeVektoren initialisiert.
        if(ev_gilt == true) // Vom 23.04.2015
            {
            strcpy(ev[i].text, "da_ev_");
            }
        if(ev_gilt == true) // Vom 23.04.2015
            {
            ev[i].initialisieren(n_h[i], m_h[i], rang, groesse, i);
            }

// Kommentar: Bei ev2_gilt = true macht man dasselbe für ev2.
        if(ev2_gilt == true) // Vom 23.04.2015
            {
            strcpy(ev2[i].text, "da_ev2_");
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << " ev2 wird angelegt " << endl;
#endif
            ev2[i].initialisieren(n_h[i], m_h[i], rang, groesse, i);
            }
        // beides wird finalisiert

// Kommentar: paralleles_rechnen der Ebene i wird für den Zeiger pr_i zugreifbar.
        pr_i = (paralleles_rechnen_l[i]);

// Kommentar: Für ev2 wird, wenn möglich, ein Zugriff auf paralleles_rechnen[i-1] zugreifbar.
        if(ev2_gilt == true)
            {
            if(i>0)
                {
                pr_i_minus1 = (paralleles_rechnen_l[i-1]);
                }
            }
// Lastausgleich gilt für alle Ebenen. Deshalb gilt pr_i und pr_i_minus1 nur in dieser Funktion,
// nicht aber in der ganzen Klasse.

// Kommentar: Nun wird das Gitter der Ebene i durchlaufen.
        for(pr_i->anfangsposition();pr_i->ist_fertig_fl()==false;pr_i->naechster())
            {
            j = pr_i->lesen_f();
            k = pr_i->lesen_g();

// Kommentar: Im Falle ev_gilt = true wird der Gitterpunkt in ev[i] eingefügt.
            if(ev_gilt==true) // Vom 23.04.2015
                {
                ev[i].einfuegen(j, k);
                }

// Kommentar: Im Falle ev2_gilt = true wird bei i = 0 oder i>0 und keinem Gitterpunkt darunter der Gitterpunkt in ev2[i] eingefügt.
            if(ev2_gilt == true)
                {
                if(i>0)
// Was ist bei i=0: Wird dabei nichts in ev2 eingefuegt? ev2 ist dafür eigentlich nicht definiert.
                    {
                    if(pr_i_minus1->feld[j+j][k+k]==-1) // geändert am 8.10.14
                        {
                        ev2[i].einfuegen(j, k);
                        }
                    }
                else
                    {
                    ev2[i].einfuegen(j, k); // 13.8.2015 hinzugefügt.
                    }
                }
            }
#ifdef AUSGABEN_LASTAUSGLEICH
// Kommentar: Das folgende ist eine optionale Ausgabe zu Debugging - Zwecken.
        if(ev_gilt == true) // Vom 23.04.2015
            {
            cout << " i " << i << " ev[i].max_spalte " << ev[i].maximale_spalte  << endl;
            }
#endif
        }
// initialisiere mv's

// Kommentar: Die Instanzen der Klassen MV_vertikal und MV_horizontal werden nach den 4 Himmelsrichtungen NWSO sowie für unten und oben angelegt,
// wobei die Instanzen der Klasse MV_horizontal den Speicherplatz der Klassen MV_vertikal mitbenutzt.
    mv_westen.initialisieren(m, n, h_min, h_max, rang, h_kappe);
    mv_osten.initialisieren(m, n, h_min, h_max, rang, h_kappe);
    mv_hilfe_westen.initialisieren(m, n, h_min, h_max, rang, h_kappe);
    mv_hilfe_osten.initialisieren(m, n, h_min, h_max, rang, h_kappe);

    mv_norden.initialisieren(m, n, h_min, h_max, rang, & mv_westen, h_kappe);
    mv_sueden.initialisieren(m, n, h_min, h_max, rang, & mv_osten, h_kappe);
    mv_hilfe_norden.initialisieren(m, n, h_min, h_max, rang, & mv_hilfe_westen, h_kappe);
    mv_hilfe_sueden.initialisieren(m, n, h_min, h_max, rang, & mv_hilfe_osten, h_kappe);
// initialisiere mvf_buffer

// Kommentar: Die mvf - Buffer nach westen und osten und die mhf - Buffer nach Norden und Süden werden angelegt, wobei letztere den Speicher
// von ersteren mitbenutzen.
    mvf_buffer_westen.initialisieren(h_gesamt, m*n);
    mvf_buffer_osten.initialisieren(h_gesamt, m*n);
// Ab mv_westen wird alles finalisiert
    mhf_buffer_norden.initialisieren(h_gesamt, mvf_buffer_westen.buffer);
    mhf_buffer_sueden.initialisieren(h_gesamt, mvf_buffer_osten.buffer);
    // mhf_buffer brauchen nicht finalisiert werden.

// Kommentar: Beim reversen Lastausgleich werden auch mvf - und mhf - Buffer für den reversen Lastausgleich angelegt - wieder mit Mitbenutzung der
// Ost - West Buffer durch die Nord - Süd - Buffer.
    if(ev_dim == 2)
        {
        mvf_buffer_westen_oben.initialisieren(h_gesamt, m*n);
        mvf_buffer_osten_oben.initialisieren(h_gesamt, m*n);
        // wird optional (ev_dim == 2) finalisiert
        mhf_buffer_norden_oben.initialisieren(h_gesamt, mvf_buffer_westen_oben.buffer);
        mhf_buffer_sueden_oben.initialisieren(h_gesamt, mvf_buffer_osten_oben.buffer);
        // mhf - buffer brauchen nicht finalisiert werden.
        }
// Initialisiere Werte Buffer

// Kommentar: Die Werte - Buffer für die Klassen nach Westen und Osten werden angelegt. Im Falle von groesse > 1 werden ggf.
// die übergebenen Sende - und Empfangsbuffer mitbenutzt.
#ifdef GEMEINSAME_BUFFER
    if(groesse==1)
        {
// Kommentar: Hier werden Sende - und Empfangsbuffer nicht benutzt, sondern der Speicherplatz wird angelegt.
        werte_buffer_osten.buffer = new double [m*n]; // Bemerkung: Bei groesse = 1 braucht man keine Buffer, 13.8.2015
        werte_buffer_westen.buffer = new double [m*n];
        }
    else
        {
        if(rang!=0)
            {
            werte_buffer_osten.buffer = sendebuffer[0];
            werte_buffer_westen.buffer = empfangsbuffer[0];
            }
        else
            {
            werte_buffer_osten.buffer = sendebuffer[1];
            werte_buffer_westen.buffer = empfangsbuffer[1];
            }
        }
#else
// Kommentar: Ohne die Benutzung von gemeinsamem Speicher werden die Werte Buffer nach Osten und Westen neu angelegt.
    werte_buffer_osten.buffer = new double [m*n];
    werte_buffer_westen.buffer = new double [m*n];
#endif
    // wird finalisiert

// Kommentar: Beim reversen Lastausgleich werden für das grobe Gitter Werte Buffer nach Osten und Westen angelegt - aber mit dem
// Platz für nur einem Viertel an Gitterpunkten.
    if(ev_dim == 2)
        {
        werte_buffer_osten_oben.buffer = new double [(m*n)>>2];
        werte_buffer_westen_oben.buffer = new double [(m*n)>>2];
        }
    // wird finalisiert

// Kommentar: Die Wertebuffer nach Norden und Süden werden ünernommen von den Wertebuffern nach Osten und Westen.
    werte_buffer_norden.buffer = werte_buffer_westen.buffer;
    werte_buffer_sueden.buffer = werte_buffer_osten.buffer;

    if(ev_dim == 2)
        {
        werte_buffer_norden_oben.buffer = werte_buffer_westen_oben.buffer;
        werte_buffer_sueden_oben.buffer = werte_buffer_osten_oben.buffer;
        }
// initialisiere mv_projektionen

// Kommentar: Die Instanzen der Klasse MVProjektionen und MVProjektionenNS werden initialisiert. Damit die ausgewählten Gitterpunkte
// einer Gitterebene auch die entsprechend der Dissertation auszuwählenden Gitterpunkte aller anderen Gitterebenen nach sich ziehen kann.
    mv_projektionen.initialisieren(h_gesamt, rang, h_kappe);
    // wird finalisiert
    for(i=0; i<h_gesamt; i++)
        {
        mv_projektionen.schreibe_farbenfeld(i, paralleles_rechnen_l[i]->farbenfeld, n_h[i], m_h[i]);
        // Nichts wird allokiert
        }

    mv_projektionen_ns.initialisieren(h_gesamt, rang, h_kappe);
    // wird finalisiert
    for(i=0; i<h_gesamt; i++)
        {
        mv_projektionen_ns.schreibe_farbenfeld(i, paralleles_rechnen_l[i]->farbenfeld, n_h[i], m_h[i]);
        // nichts wird allokiert
        }
// initialisiere farbenfelder_verschicken

// Kommentar: Die Instanz der Klasse FarbenfelderVerschicken wird initialisiert.
    farbenfelder_verschicken.initialisieren_hfv(h_gesamt, rang, farbmatrix.west[rang], farbmatrix.ost[rang], farbmatrix.nord[rang], farbmatrix.sued[rang]);
// korrekt finalisiert
    for(i=0; i<h_gesamt; i++)
        {
        farbenfelder_verschicken.initialisieren_fv1(i, paralleles_rechnen_l[i]->farbenfeld);
        // brauch nicht finalisiert zu werden.
        }
// Initialisiere farbenfeld_verschicken !
    farbenfelder_verschicken.initialisieren_fv(n, m);
    // wird finalisiert. Hier geht es um ein Testfeld!
// initialisiere aus_mv_zu_mvf_buffer

// Kommentar: Die Klassen, die aus MV_Vertikal und MV_Horizontal mvf - und mhf - Buffer machen, und umgekehrt, werden angelegt.
    aus_mv_zu_mvf_buffer.initialisieren(h_gesamt);
    aus_mvf_buffer_zu_mv.initialisieren(h_gesamt);

    aus_mv_zu_mhf_buffer.initialisieren(h_gesamt);
    aus_mhf_buffer_zu_mv.initialisieren(h_gesamt);
    // wird alles finalisiert

// Kommentar: Bei der Migration müssen auch Werte verschickt werden. Die Kommunikationsklasse dafür wird initialisiert, und die
// Zeiger auf die Variablen werden aus paralleles Rechnen kopiert.

    werte_verschicken.initialisieren(h_gesamt, n, m, rang, h_min, ist_zusammen_aV_LA);
    // wird finalisiert
    for(i=0; i<h_gesamt; i++)
        {
#ifndef SHALLOW_WATER_EQUATIONS
// Kommentar: Im Falle der Poisson - Gleichung werden maximal u0 und Iu0 verschickt.
        werte_verschicken.x0[i] = paralleles_rechnen_l[i]->u0;
        werte_verschicken.x1[i] = paralleles_rechnen_l[i]->Iu0;
        if(i>0)
            {
            werte_verschicken.u0_unten[i] = paralleles_rechnen_l[i-1]->u0;
            }
#else
// Kommentar: Im Falle der von mir abgeänderten Version der Hess'schen Implementierung der Shallow Water Equations werden Zeiger zu bis zu 7 Variablen gespeichert.
        werte_verschicken.x0[i] = paralleles_rechnen_l[i]->v1;
        werte_verschicken.x1[i] = paralleles_rechnen_l[i]->v2;
        werte_verschicken.x2[i] = paralleles_rechnen_l[i]->v3;
        werte_verschicken.x3[i] = paralleles_rechnen_l[i]->v4;
        werte_verschicken.x4[i] = paralleles_rechnen_l[i]->v5;
        werte_verschicken.x5[i] = paralleles_rechnen_l[i]->v6;
        werte_verschicken.x6[i] = paralleles_rechnen_l[i]->v7;
#endif // geändert am 6.3.15
        // evtl. modifizieren
        }

// Kommentar: Es werden Zeiger der Klasse Nachkorrektur angelegt ...
#ifdef KURZ_FF
    nachkorrektur.farbenfelder = new short int ** [h_gesamt];
#else
    nachkorrektur.farbenfelder = new int ** [h_gesamt];
#endif
    nachkorrektur.selbstnachbaren = new int ** [h_gesamt];

#ifdef NK_FARBENFELDER
#ifdef KURZ_NKFF
    nachkorrektur.nk_farbenfelder = new short int ** [h_gesamt];
#else
    nachkorrektur.nk_farbenfelder = new int ** [h_gesamt];
#endif
#endif
    // nachkorrektur ** Felder werden deletet, also finalisiert

// Kommentar: ... und dann mit eigenen Zeigern verknüpft.
    for(i=0; i<h_gesamt; i++)
        {
        nachkorrektur.farbenfelder[i] = paralleles_rechnen_l[i]->farbenfeld;
        nachkorrektur.selbstnachbaren[i] = paralleles_rechnen_l[i]->selbstnachbarn;
        }

#ifdef NK_FARBENFELDER
// Kommentar: Hier wird es ermöglicht, nk_farbenfelder der Klasse Nachkorrektur anzulegen. Nur werden diese
// Felder eigentlich nicht mehr gebraucht.
    for(i=0; i<h_gesamt; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " NHMH i " << i << " n_h[i] " << n_h[i] << " m_h[i] " << m_h[i] << endl;
#endif
#ifdef KURZ_NKFF
        nk_farbenfeld_speichern = new short int * [n_h[i]+2];
#else
        nk_farbenfeld_speichern = new int * [n_h[i]+2];
#endif
        nachkorrektur.nk_farbenfelder[i] = nk_farbenfeld_speichern;
        for(j=0; j<n_h[i]+2; j++)
            {
#ifdef KURZ_NKFF
            nk_farbenfeld_speichern2 = new short int [m_h[i]+2];
#else
            nk_farbenfeld_speichern2 = new int [m_h[i]+2];
#endif
            nachkorrektur.nk_farbenfelder[i][j] = nk_farbenfeld_speichern2;
            nachkorrektur.nk_farbenfelder[i][j] = nachkorrektur.nk_farbenfelder[i][j] + 1;
            for(k=-1; k<m_h[i]+1; k++)
                {
                nachkorrektur.nk_farbenfelder[i][j][k] = -1;
                }
            }
        nachkorrektur.nk_farbenfelder[i] = nachkorrektur.nk_farbenfelder[i] + 1;
        }
#endif
    // Dieser Spericher wird freigegeben. Vielleicht später löschen, wie auch die Befehle mit nk_farbenfelder

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Ende Initialisieren_LA" << endl;
#endif

// Kommentar: Es werden Zeiger für ep_aktuell, ep_updates, ep_plus, ep_minus und felder_aktuell angelegt. Es sind aber nur Zeiger,
// d.h. sie müssen verknüpft werden, und brauchen kaum Speicherplatz.
    ep_aktuell = new short int ** [h_gesamt]; // Diese Zeile hatte ich auskommentiert. Warum? Fehler ?
    ep_updates = new EP_s_bestimmen * [h_gesamt];

    ep_plus = new PunktFeldListe * [h_gesamt];
    ep_minus = new PunktFeldListe * [h_gesamt];

    felder_aktuell = new short int ** [h_min+1];
    // wird alles finalisiert
    }

// Kommentar: Gemäß Dissertation wird hier alles gepackt,  damit der entpackende Kern seine Strukturen wie geplant verändern kann. Der
// entpackende Kern liegt im Westen.
void LastAusgleich::packen_west_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west 1 rang " << rang << endl;
#endif

// Kommentar: Zuerst werden die Koordinaten der verschickten Vektoren von mv - vertikal im Westen in den mvf - Buffer für Westen geschrieben.
    aus_mv_zu_mvf_buffer.bestimmen(&mv_westen, &mvf_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west 2 rang " << rang << endl;
#endif

// Kommentar: Dann wird die Farbenfeldinformation um das Gitter herum entsprechend der Dissertation gepackt.
    farbenfelder_verschicken.packen_westen(&mv_westen, &mvf_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west 3 rang " << rang << endl;
#endif
// Kommentar: Und am Ende werden die Eigenschaftspunktinformationen (die mit Hilfe des Diskretisierungsfehlers oder per Simulation generiert worden sind)
// gepackt.
    packen_ep(&mv_westen, &mvf_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west 4 rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu packen_west_ieS, nur dass hier zwar aus mv_vertikal für den Westen gelesen wird, aber in den
// mvf_buffer im Westen oben gepackt wird.
void LastAusgleich::packen_west_oben_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west oben 1 rang " << rang << endl;
#endif
    aus_mv_zu_mvf_buffer.bestimmen(&mv_westen, &mvf_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west oben 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.packen_westen(&mv_westen, &mvf_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west oben 3 rang " << rang << endl;
#endif
    packen_ep(&mv_westen, &mvf_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS west oben 4 rang " << rang << endl;
#endif
    }

// Kommentar: Hier geschieht zweierlei: Einerseits werden die Gitterpunkte von mv_westen Ebene für Ebene entfernt,
// andererseits wird auf den entfernten Gitterpunkten der Farbwert des Zielkerns eingetragen - denn dort befinden
// sich die Gitterpunkte jetzt. Deswegen wird an die Funktion entferne_ebene_auch_dynamisch auch der Wert
// der Farbmatrix nach Westen hin übergeben.
void LastAusgleich::packen_west_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene(&mv_westen, farbmatrix.west[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch(&mv_westen, farbmatrix.west[rang]);
        #endif
        }
    }

// Kommentar: Hier geschieht exakt dasselbe wie in packen_west_abschliessen. Nur wurde mv_westen auf eine andere
// Weise erzeugt als bei packen_west_abschliessen.
void LastAusgleich::packen_west_oben_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " !LA5by1 Vor paralleles_rechnen_l[" << i << "] rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene(&mv_westen, farbmatrix.west[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch(&mv_westen, farbmatrix.west[rang]);
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " !LA5by2 Nach paralleles_rechnen_l[" << i << "] rang " << rang << endl;
#endif
        }
    }

// Kommentar: Hier geschieht ein Packen Teil, bei dem die Punkte ausgewählt werden, mv_vertikal davon abgeleitet wird,
// und dann die ev - Strukturen bereinigt werden. In diesem Fall wird zum westlichen Kern geschickt, und von 'oben'
// werden die Gitterpunkte ausgewählt.
inline void LastAusgleich::packen_west_oben_mv(int gesamtlast)
    {
// Kommentar: Es wird unterschieden danach, ob ev, ev2 oder beides gemischt verwendet wird. Der Typ gemischt macht eigentlich
// keinen Sinn, nur TYP_EV beim einfachen und TYP_EV2EV2 beim reversen Lastausgleich.
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            packen_west_oben_mvEVEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
            packen_west_oben_mvEV2EV2(gesamtlast);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::packen_west_oben_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ west oben " << endl;
    strcpy(zeichenkette, " Packen_west_oben_mv ");
    mv_westen.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Obige Funktion packen_west_oben_mv wird im Falle von ev durchgeführt.
inline void LastAusgleich::packen_west_oben_mvEVEV(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " PackenLA1234 west oben EVEV rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif

// Kommentar: Da oben die Punkte ausgewählt werden, müssen die westlichen Vektoren auf der Gitterebene gitterebene_plus1 ausgewählt werden -
// mit Hilfe der Struktur ev. Sie werden nach mv_westen auf der Gitterebenen gitterebene_plus1 geschrieben werden.
    ev[gitterebene_plus1].bilde_west_vektoren(gesamtlast, &(mv_westen), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
// Kommentar: Dann werden die Projektionen durchgeführt, damit die zu verschickenden Punkte auf allen Gitterebenen bestimmt werden.
    mv_projektionen.durchfuehren(&(mv_westen), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_west_oben_mv ");
    mv_westen.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_westen);
    cout << "Packen 1c rang " << rang << endl;
#endif
// Kommentar: Nun wird auf allen relevanten Gitterebenen - aber ohne die, wo beim Aussuchen auch die Vektoren schon gelöscht wurden - die Gitterpunkte
// gelöscht - aus ev.
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene_plus1) // Was ist gitterebene_plus1? gitterebene und nach oben.
            {
// Kommentar: Das Löschen der Gitterpunkte aus ev übernimmt diese Funktion entferne_ebeneEV.
            entferne_ebeneEV(&mv_westen, i);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

// Kommentar: obige Funktion packen_west_oben_mv wird im Falle von ev2 durchgeführt. Die ersten Schritte sind analog wie bei
// packen_west_oben_mvEVEV, mit der Ausnahme, dass die Punkteauswahl durch ev2 geschieht. Außerdem:
// Es geschieht kein Löschen: Weil bei ev2 darunter und darüber keine Gitterpunkte existieren, muss
// in diesem Fall neben dem 'automatischen Löschen' beider Auswahl der zu verschickenden Gitterpunkte nichts weiter gelöscht werden.
// Die restlichen Befehle sind wie bei packen_west_oben_mvEVEV, d.h. es muss nichts weiter kommentiert werden.
void LastAusgleich::packen_west_oben_mvEV2EV2(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 west oben EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev2[gitterebene_plus1].bilde_west_vektoren(gesamtlast, &(mv_westen), gitterebene_plus1);
    // Soweit ist richtig, weil alles darüber entfernt wird.
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen.durchfuehren(&(mv_westen), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_west_oben_mv ");
    mv_westen.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_westen);

    cout << "Packen 1c rang " << rang << endl;
    // Bemerkung: Unterhalb gitterebene_plus1 existieren keine Punkte, überhalb keine Einträge in ev2.
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu packen_west_ieS. Deshalb keine eigene Kommentierung.
void LastAusgleich::packen_ost_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost 1 rang " << rang << endl;
#endif
    aus_mv_zu_mvf_buffer.bestimmen(&mv_osten, &mvf_buffer_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.packen_osten(&mv_osten, &mvf_buffer_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost 3 rang " << rang << endl;
#endif
    packen_ep(&mv_osten, &mvf_buffer_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost 4 rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu packen_west_oben_ieS. Deshalb keine eigene Kommentierung.
void LastAusgleich::packen_ost_oben_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost oben 1 rang " << rang << endl;
#endif
    aus_mv_zu_mvf_buffer.bestimmen(&mv_osten, &mvf_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost oben 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.packen_osten(&mv_osten, &mvf_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost oben 3 rang " << rang << endl;
#endif
    packen_ep(&mv_osten, &mvf_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS ost oben 4 rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu packen_west_abschliessen. Deshalb keine eigene Kommentierung.
void LastAusgleich::packen_ost_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene(&mv_osten, farbmatrix.ost[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch(&mv_osten, farbmatrix.ost[rang]);
        #endif
//  Hier wird auch das Farbenfeld geändert, vgl. oben.
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2009" << endl;
#endif
        }
    }

// Kommentar: Analog zu packen_west_oben_abschliessen. Deshalb keine eigene Kommentierung.
void LastAusgleich::packen_ost_oben_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !2017 rang " << rang << " i " << i << endl;
#endif
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene(&mv_osten, farbmatrix.ost[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch(&mv_osten, farbmatrix.ost[rang]);
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !2018 rang " << rang << " i " << i << endl;
#endif
        }
    }


// Kommentar: Diese Funktion wird nicht mehr gebraucht, und daher auch nicht kommentiert. Es gibt aber Funktionen desselben Namens - z.B.
// in der Klasse Gitter - die noch gebraucht werden.
void LastAusgleich::entferne_ebene(MV_vertikal * mv_vertikal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_vertikal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAente 1 rang " << rang << " ebene " << ebene << endl;
#endif
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        ev_ebene = &(ev[ebene]);
        #ifdef EV2
        if(ebene>0)
            {
            pr_i_minus1 = paralleles_rechnen_l[ebene-1];
            ev2_ebene = &(ev2[ebene]);
            }
        #endif
        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            ev_ebene->entfernen(j, vvektor_g);
//  Auch diesen Befehl, falls EV2 gilt?
            #ifdef EV2
            if(ebene>0)
                {
                if((pr_i_minus1->feld[j<<1][vvektor_g<<1])<0) // Ist unterster Punkt. Bei Ebene = 0 wuerde immer entfernt.

// D.h., dass in ev2 noch ein Punkt steht.
                    {
                    ev2_ebene->entfernen(j, vvektor_g);
                    }
                }
            #endif
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAente 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Diese Funktion wird auch nicht mehr gebraucht, und daher auch nicht mehr kommentiert.
void LastAusgleich::entferne_ebene_fuer_ev(MV_vertikal * mv_vertikal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_vertikal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe 1 rang " << rang << " ebene " << ebene << endl;
#endif
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        ev_ebene = &(ev[ebene]);

        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            ev_ebene->entfernen(j, vvektor_g);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Diese Funktion wird auch nicht mehr gebraucht, und daher auch nicht mehr kommentiert.
void LastAusgleich::entferne_ebene_fuer_ev2(MV_vertikal * mv_vertikal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_vertikal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe2 1 rang " << rang << " ebene " << ebene << endl;
#endif

    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        #ifdef EV2
        if(ebene>0)
            {
            pr_i_minus1 = paralleles_rechnen_l[ebene-1];
            ev2_ebene = &(ev2[ebene]);
            }
        #endif
        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << " j " << j << " vvektor_g " << vvektor_g << endl;
#endif
//  Auch diesen Befehl, falls EV2 gilt?
            #ifdef EV2
            if(ebene>0)
                {
                if((pr_i_minus1->feld[j<<1][vvektor_g<<1])<0) // Ist unterster Punkt. Bei Ebene = 0 wuerde immer entfernt.
// D.h., dass in ev2 noch ein Punkt steht.
                    {
                    ev2_ebene->entfernen(j, vvektor_g);
                    }
                }
/* Da es komplett entfernt wird, wird nichts eingefügt. */

            #endif
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe2 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Diese Funktion wird auch nicht mehr gebraucht, und daher auch nicht mehr kommentiert.
void LastAusgleich::einfuegen_ebene(MV_vertikal * mv_vertikal, int ebene)
//  Warum das hier? Und wenn: Muss nicht oben in ev2 eingefügt werden, und unten in ev?
//  Das wird hier nicht abgebildet.

//  Ich verstehe die Routine hier nicht. Die Idee dabei: Wenn ich Gitterpunkte entferne aus ev,
//  dann werden damit auch Punkte aus ev2 entfernt, bzw. selbiges mit Einfügen.

// für ev Einfügung ist es klar: Nur dort und mit der Ebene einfuegen. Zu ev2 ist es komplizierter: für Ebene 0: wird sie nicht
// gebraucht. Nur für einfuegen oben, also ab Ebene 0.
// Für Ebene > 0:
// Falls darunter nichts ist - z.B. bei neuen Punkten - dann dort einfuegen.
// Beim Einfuegen von Punkten gibt es noch eines: ev2 eine Ebene höher wird gelöscht, falls der Punkt existiert.
// Denn es gibt nun einen Punkt darunter.
    {
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        ev_ebene = &(ev[ebene]);
        #ifdef EV2
        if(ebene>0)
            {
            pr_i_minus1 = paralleles_rechnen_l[ebene-1];
            ev2_ebene = &(ev2[ebene]);
            }
        #endif
        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            ev_ebene->einfuegen(j, vvektor_g); // Hier einfuegen.
            #ifdef EV2
            if(ebene>0)
                {
                if((pr_i_minus1->feld[j<<1][vvektor_g<<1])<0) // Damit ist (j,vvektor_g) unterster Punkt.
// Falls daruntern kein Punkt liegt => einfuegen. Falsch: Da dort noch kein Punkt existiert, dann zwangsläufig nicht darunter.
                    {
                    ev2_ebene->einfuegen(j, vvektor_g);
                    }
                }
/* Hier wird nichts entfernt. Auf diesem Prozessor ist ev2 noch leer an dieser Position! */
            #endif
            }
        }
    }

// Kommentar: Diese Funktion wird ziemlich zu Beginn von lt_durchfuehren1/2_wo durchgeführt.
void LastAusgleich::lt_vorab(void) // Hier werden mv_westen und mv_osten resettet
    {
    h_LA = gitterebene;

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Vor SendeEmpfangsFaelle " << endl;
#endif

// Kommentar: Die Flags zum Senden und Empfangen in Hinblick auf NBI_horizontal wird aufgerufen.
    SendeEmpfangsFaelle(NBI_horizontal);

//  Schafft die Flag - Variablen sende_west, sende_ost, empfange_west, empfangs_ost.

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Sende_west " << sende_west << " Sende_ost " << sende_ost;
    cout << " NBI " << NBI_horizontal << " rang " << rang << endl;

    cout << " Nach SendeEmpfangsfaelle" << endl;

    cout << "!1004 rang " << rang << endl;
#endif

//  Lastausgleich: 1. Schritt: Flags setzen und Kommunikation initiieren, sowie beim Senden packen.

// Kommentar: Die Strukturen von MV_vertikal werden zurückgesetzt.
    mv_westen.reset();
    mv_osten.reset();
    mv_hilfe_westen.reset();
    mv_hilfe_osten.reset();
    }

// Kommentar: Analog zu lt_vorab, nur im Falle des Nord - Süd - Lastausgleiches.
void LastAusgleich::lt_vorab_ns(void) // Hier werden mv_westen und mv_osten resettet
    {
    h_LA = gitterebene;

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Vor SendeEmpfangsFaelle " << endl;
#endif

    SendeEmpfangsFaelle_ns(NBI_vertikal);

//  Schafft die Flag - Variablen sende_nord, sende_sued, empfange_nord, empfangs_sued.

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Sende_nord " << sende_nord << " Sende_sued " << sende_sued;
    cout << " NBI " << NBI_vertikal << " rang " << rang << endl;

    cout << " Nach SendeEmpfangsfaelle" << endl;

    cout << "!1004 rang " << rang << endl;
#endif

//  Lastausgleich: 1. Schritt: Flags setzen und Kommunikation initiieren, sowie beim Senden packen.

    mv_norden.reset();
    mv_sueden.reset();
    mv_hilfe_norden.reset();
    mv_hilfe_sueden.reset();
    }

// Kommentar: Diese Funktion test_und_entpacken beendet die Funktion lt_durchfuehren2_wo - vgl. die Dissertation. Hierbei wird getestet,
// welche Nachrichten angekommen sind. Die angekommenen Informationen werden direkt entpackt, während die Werte erst nach Entpacken der
// Informationen entpackt werden können.
void LastAusgleich::test_und_entpacken(void)
    {
#ifdef LAUFEN
    if(rang==2)
        {
        cout << " tue laufen rang " << rang << endl;
        }
#endif
// Kommentar: Wenn der Informationsbuffer von Westen noch empfangen werden muss.
        if(empfange_west_mvf==true)
            {
// Kommentar: Prüfe, ob der Buffer angekommen ist. Falls ja, dann entpacke den Buffer, und setze das Empfangsflag auf false zurück.
            if(la_kommunikationen.test_empfangen_west_mvf()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange west mvf ist durch " << endl;
                cout << "LAtue 1 rang " << rang << endl;
                if((rang==1)&&(n_h[1]>=33)&&(m_h[1]>=33)&&(t==9))
                    {
                    cout << " Code 102: fgff(1,11,19) " << paralleles_rechnen_l[1]->farbenfeld[11][19] << " fgff(1,12,19) " << paralleles_rechnen_l[1]->farbenfeld[12][19] << endl;
                    }
#endif
                entpacken_west(&mvf_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "LAtue 2 rang " << rang << endl;
#endif
                // Diese Funktion muss gecheckt werden!
                empfange_west_mvf=false;
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange west mvf ist gleich false " << endl;
#endif
                }
            }

// Kommentar: Wenn der Wertebuffer von Westen noch empfangen werden muss.
        if(empfange_west_werte==true)
            {
// Kommentar: Prüfe, ob der zugehörige Informationsbuffer schon entpackt worden ist.
            if(empfange_west_mvf==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
// Kommentar: Wenn der Wertebuffer angekommen ist, dann entpacke mit Hilfe der Klasse WerteVerschicken sowie der Instanz
// mv_hilfe_westen den Wertebuffer, und setze das zugehörige Empfangsflag auf false - als Beweis, dass in dieser Hinsicht
// - entpacken des Wertebuffer - nichts mehr getan werden muss.
                if(la_kommunikationen.test_empfangen_west_werte()==true)
                    {
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange west werte ist durch " << endl;
                    cout << "LAtue 3 rang " << rang << endl;
#endif
                    cout << " XXYYZZ vor werten verschicken entpacken westen " << endl;
#endif
                    werte_buffer_westen.index = 0;
                    werte_verschicken.entpacken(&werte_buffer_westen, &mv_hilfe_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "LAtue 4 rang " << rang << endl;
#endif
                    empfange_west_werte = false;
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange west werte ist gleich false " << endl;
#endif
                    }
                }
            }

// Kommentar: Jetzt mache dasselbe wie eben für den Westen für den Osten. Daher: Hierzu keine weiteren Kommentare.
        if(empfange_ost_mvf==true)
            {
            if(la_kommunikationen.test_empfangen_ost_mvf()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "LAtue 5 rang " << rang << endl;
#endif
#ifdef AAHH
                test_la1("4123");
#endif
                entpacken_ost(&mvf_buffer_osten);
#ifdef AAHH
                test_la1("4125");
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "LAtue 6 rang " << rang << endl;
#endif
                empfange_ost_mvf=false;
                }
            }

        if(empfange_ost_werte==true)
            {
            if(empfange_ost_mvf==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_ost_werte()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "LAtue 7 rang " << rang << endl;
#endif
                    werte_buffer_osten.index = 0;
                    werte_verschicken.entpacken(&werte_buffer_osten, &mv_hilfe_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "LAtue 8 rang " << rang << endl;
#endif
// Dabei werden Werte geschrieben, vgl. werte_verschicken!
//                    werte_verschicken.entpacken(&mvf_buffer_osten, &mv_osten);
                    empfange_ost_werte = false;
                    }
                }
            }

// Kommentar: Falls das sende - mvf - Flag true ist: setze es auf false, wenn der Test auf abschicken erfolgreich war.
        if(sende_west_mvf==true)
            {
            if(la_kommunikationen.test_senden_west_mvf()==true)
                {
                sende_west_mvf = false;
                }
            }

// Kommentar: Falls das sende - Werte - Flag true ist: setze es auf false, wenn der Test auf abschicken erfolgreich war.
        if(sende_west_werte==true)
            {
            if(la_kommunikationen.test_senden_west_werte()==true)
                {
                sende_west_werte = false;
                }
            }

// Kommentar: Mache dasselbe für den Osten.
        if(sende_ost_mvf==true)
            {
            if(la_kommunikationen.test_senden_ost_mvf()==true)
                {
                sende_ost_mvf = false;
                }
            }
        if(sende_ost_werte==true)
            {
            if(la_kommunikationen.test_senden_ost_werte()==true)
                {
                sende_ost_werte = false;
                }
            }
//////////////////////////////////////////////////////////////////////////////////////
// Die 'oben - Strukturen' ///////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////

// Mache dieselben Prozeduren, wie auf dem unteren Gitter, nun auf dem oberen Gitter - nur mit den
// Flags mit dem Suffix oben - und auch dem mvf_buffer oben und dem werte_buffer oben. Die mv_vertikal
// Strukturen sind allerdings dieselben, weil der jeweilige mvf_buffer dahin entpackt wird.
// Ansonten geschieht für 'oben' dasselbe wie für 'unten'. Und ds gilt sowohl für den Westen wie auch für den Osten.
        if(empfange_west_mvf_oben==true)
            {
            if(la_kommunikationen.test_empfangen_west_mvf_oben()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange west mvf oben ist durch " << endl;
                cout << "LAtue 9 rang " << rang << endl;
#endif
                entpacken_west(&mvf_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "LAtue 10 rang " << rang << endl;
#endif
                // Diese Funktion muss gecheckt werden!
                empfange_west_mvf_oben=false;
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange west mvf oben ist gleich false " << endl;
#endif
                }
            }

        if(empfange_west_werte_oben==true)
            {
            if(empfange_west_mvf_oben==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_west_werte_oben()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange west werte oben ist durch " << endl;
                    cout << "LAtue 11 rang " << rang << endl;
#endif
                    werte_buffer_westen_oben.index = 0;
                    werte_verschicken.entpacken(&werte_buffer_westen_oben, &mv_hilfe_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "LAtue 12 rang " << rang << endl;
#endif
                    empfange_west_werte_oben = false;
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange west werte oben ist gleich false " << endl;
#endif
                    }
                }
            }

        if(empfange_ost_mvf_oben==true)
            {
            if(la_kommunikationen.test_empfangen_ost_mvf_oben()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "LAtue 13 rang " << rang << endl;
#endif
                entpacken_ost(&mvf_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "LAtue 14 rang " << rang << endl;
#endif
                empfange_ost_mvf_oben=false;
                }
            }

        if(empfange_ost_werte_oben==true)
            {
            if(empfange_ost_mvf_oben==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_ost_werte_oben()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "LAtue 15 rang " << rang << endl;
#endif
                    werte_buffer_osten_oben.index = 0;
                    werte_verschicken.entpacken(&werte_buffer_osten_oben, &mv_hilfe_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "LAtue 16 rang " << rang << endl;
#endif
                    empfange_ost_werte_oben = false;
                    }
                }
            }

        if(sende_west_mvf_oben==true)
            {
            if(la_kommunikationen.test_senden_west_mvf_oben()==true)
                {
                sende_west_mvf_oben = false;
                }
            }
        if(sende_west_werte_oben==true)
            {
            if(la_kommunikationen.test_senden_west_werte_oben()==true)
                {
                sende_west_werte_oben = false;
                }
            }
        if(sende_ost_mvf_oben==true)
            {
            if(la_kommunikationen.test_senden_ost_mvf_oben()==true)
                {
                sende_ost_mvf_oben = false;
                }
            }
        if(sende_ost_werte_oben==true)
            {
            if(la_kommunikationen.test_senden_ost_werte_oben()==true)
                {
                sende_ost_werte_oben = false;
                }
            }
    }

// Kommentar: Analog zu test_und_entpacken, nur dass das hier für Norden und Süden, anstatt wie dort für den Osten und Westen erfolgt.
void LastAusgleich::test_und_entpacken_ns(void)
    {
        if(empfange_nord_mhf==true)
            {
            if(la_kommunikationen.test_empfangen_nord_mhf()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange nord mvf ist durch " << endl;
                cout << " LAtue ns 1 rang " << rang << endl;
#endif

#ifdef AKTUELLE_KOMMENTARE
                strcpy(zeichenkette, "Vor entpacken Nord");
                einpunktausgabe(zeichenkette);
#endif
                entpacken_nord(&mhf_buffer_norden);
#ifdef AKTUELLE_KOMMENTARE
                strcpy(zeichenkette, "Nach entpacken Nord");
                einpunktausgabe(zeichenkette);
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " LAtue ns 2 rang " << rang << endl;
#endif
                // Diese Funktion muss gecheckt werden!
                empfange_nord_mhf=false;
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange nord mvf ist gleich false " << endl;
#endif
                }
            }

        if(empfange_nord_werte==true)
            {
            if(empfange_nord_mhf==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_nord_werte()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange nord werte ist durch " << endl;
                    cout << " LAtue ns 3 rang " << rang << endl;
#endif
                    werte_buffer_norden.index = 0;
                    werte_verschicken.entpacken_ns(&werte_buffer_norden, &mv_hilfe_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << " LAtue ns 4 rang " << rang << endl;
#endif
//  Woher kommen die Koordinaten zu mv_westen?
                    empfange_nord_werte = false;
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange nord werte ist gleich false " << endl;
#endif
                    }
                }
            }

        if(empfange_sued_mhf==true)
            {
            if(la_kommunikationen.test_empfangen_sued_mhf()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " LAtue ns 5 rang " << rang << endl;
#endif
                entpacken_sued(&mhf_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " LAtue ns 6 rang " << rang << endl;
#endif
                empfange_sued_mhf=false;
                }
            }

        if(empfange_sued_werte==true)
            {
            if(empfange_sued_mhf==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_sued_werte()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << " LAtue ns 7 rang " << rang << endl;
#endif
                    werte_buffer_sueden.index = 0;
                    werte_verschicken.entpacken_ns(&werte_buffer_sueden, &mv_hilfe_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << " LAtue ns 8 rang " << rang << endl;
#endif
                    empfange_sued_werte = false;
                    }
                }
            }

        if(sende_nord_mhf==true)
            {
            if(la_kommunikationen.test_senden_nord_mhf()==true)
                {
                sende_nord_mhf = false;
                }
            }
        if(sende_nord_werte==true)
            {
            if(la_kommunikationen.test_senden_nord_werte()==true)
                {
                sende_nord_werte = false;
                }
            }
        if(sende_sued_mhf==true)
            {
            if(la_kommunikationen.test_senden_sued_mhf()==true)
                {
                sende_sued_mhf = false;
                }
            }
        if(sende_sued_werte==true)
            {
            if(la_kommunikationen.test_senden_sued_werte()==true)
                {
                sende_sued_werte = false;
                }
            }
//////////////////////////////////////////////////////////////////////////////////////
// Die 'oben - Strukturen' ///////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
        if(empfange_nord_mhf_oben==true)
            {
            if(la_kommunikationen.test_empfangen_nord_mhf_oben()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange nord mvf oben ist durch " << endl;
                cout << " LAtue ns 9 rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
                strcpy(zeichenkette, "Vor entpacken Nord Oben");
                einpunktausgabe(zeichenkette);
#endif
                entpacken_nord(&mhf_buffer_norden_oben);
#ifdef AKTUELLE_KOMMENTARE
                strcpy(zeichenkette, "Nach entpacken Nord Oben");
                einpunktausgabe(zeichenkette);
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " LAtue ns 10 rang " << rang << endl;
#endif
                // Diese Funktion muss gecheckt werden!
                empfange_nord_mhf_oben=false;
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Empfange nord mvf oben ist gleich false " << endl;
#endif
                }
            }

        if(empfange_nord_werte_oben==true)
            {
            if(empfange_nord_mhf_oben==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_nord_werte_oben()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange nord werte oben ist durch " << endl;
                    cout << " LAtue ns 11 rang " << rang << endl;
#endif
                    werte_buffer_norden_oben.index = 0;
                    werte_verschicken.entpacken_ns(&werte_buffer_norden_oben, &mv_hilfe_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << " LAtue ns 12 rang " << rang << endl;
#endif
                    empfange_nord_werte_oben = false;
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << "Empfange nord werte oben ist gleich false " << endl;
#endif
                    }
                }
            }

        if(empfange_sued_mhf_oben==true)
            {
            if(la_kommunikationen.test_empfangen_sued_mhf_oben()==true)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " LAtue ns 13 rang " << rang << endl;
#endif
                entpacken_sued(&mhf_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " LAtue ns 14 rang " << rang << endl;
#endif
                empfange_sued_mhf_oben=false;
                }
            }

        if(empfange_sued_werte_oben==true)
            {
            if(empfange_sued_mhf_oben==false)
// Braucht man, um den mvf_buffer_westen zu haben
                {
                if(la_kommunikationen.test_empfangen_sued_werte_oben()==true)
                    {
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << " LAtue ns 15 rang " << rang << endl;
#endif
                    werte_buffer_sueden_oben.index = 0;
                    werte_verschicken.entpacken_ns(&werte_buffer_sueden_oben, &mv_hilfe_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
                    cout << " LAtue ns 16 rang " << rang << endl;
#endif
                    empfange_sued_werte_oben = false;
                    }
                }
            }

        if(sende_nord_mhf_oben==true)
            {
            if(la_kommunikationen.test_senden_nord_mhf_oben()==true)
                {
                sende_nord_mhf_oben = false;
                }
            }
        if(sende_nord_werte_oben==true)
            {
            if(la_kommunikationen.test_senden_nord_werte_oben()==true)
                {
                sende_nord_werte_oben = false;
                }
            }
        if(sende_sued_mhf_oben==true)
            {
            if(la_kommunikationen.test_senden_sued_mhf_oben()==true)
                {
                sende_sued_mhf_oben = false;
                }
            }
        if(sende_sued_werte_oben==true)
            {
            if(la_kommunikationen.test_senden_sued_werte_oben()==true)
                {
                sende_sued_werte_oben = false;
                }
            }
        }

// Kommentar: Hier wird die ep - Information gepackt. Das ist durchaus kompliziert, und wird in Funktionen wie
// packen_ep_rumpf ausführlich dargestellt. Die ep - Information wird - ggf. zusammen mit der Information des
// Markierungsfeldes, ob ein Punkt neu ist oder nicht - in den mvf - Buffer gepackt.
inline void LastAusgleich::packen_ep(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
// Kommentar: Wenn direkt nach der parallelen adaptiven Verfeinerung der Lastausgleich erfolgt, muss die
// Markierungsfeldinformation auf den verschickten Punkten zusammen mit den ep - Informationen mitgepackt werden.
    if(ist_zusammen_aV_LA==true)
        {
        packen_ep_mit_markierungsfeld(mv, mvf_buffer);
        }
    else
        {
// Kommentar: Ansonsten werden nur die ep - Informationen für die verschickten Punkte mitgeschickt - als Flags, d.h. bitweise.
        packen_ep_ohne_markierungsfeld(mv, mvf_buffer);
        }
    }

// Kommentar: Hier wird die ep - Information ohne Markierungsfeld gepackt.
inline void LastAusgleich::packen_ep_ohne_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer)
//(int offset)
    {
// Kommentar: Zuerst muss die aktuelle Position im mvf - Buffer bestimmt werden.
    offset = mvf_buffer -> index;
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 1 rang " << rang << endl;
#endif
// Kommentar: Die Klassen, die bitweises Packen in den Buffer ermöglichen, bekommen den Buffer sowie den aktuellen Index mitgeteilt.
    #ifdef KURZ_MVF
    bool_short_int.anfang(mvf_buffer->buffer, offset);
    #else
    bool_int.anfang(mvf_buffer.buffer, offset);
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 2 rang " << rang << endl;
#endif

// Kommentar: Dann werden die Gitterebenen durchlaufen.
    for(i=0; i<h_gesamt_variante; i++)
        {
// Kommentar: Muss für eine Gitterebene nichts getan werden, gehe zur nächsten Gitterebene.
//        if(ep_ebenen[i]==false)
        if(ep_ebenen[i]<2)
            {
            continue;
            }
// Kommentar: Ansonsten lade die Zeiger auf die Vektoren, und lese die Vektorenanzahl - aus der jeweiligen Instanz der Klasse
// MV_vertikal.
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
        index = mv->indizes[i];

        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        ep_snb_update_i = ep_snb_update[i];

// Kommentar: Die Funktion packen_ep_rumpf erledigt alles weitere in Bezug auf das Packen.
        packen_ep_rumpf();
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Packen_ep 3 rang " << rang << endl;
#endif
// Kommentar: Am Ende schreibe den nun aktuellen Bufferindex zurück in den mvf - Buffer.
    #ifdef KURZ_MVF
    mvf_buffer->index = bool_short_int.laenge();
    #else
    mvf_buffer->index = bool_int.laenge();
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!2021" << endl;
#endif
    }

// Kommentar: Hier wird die ep - Information entpackt. Das ist durchaus kompliziert, und wird in Funktionen wie
// entpacken_ep_rumpf ausführlich dargestellt. Die ep - Information wird - ggf. zusammen mit der Information des
// Markierungsfeldes, ob ein Punkt neu ist oder nicht - aus dem mvf - Buffer entpackt.
inline void LastAusgleich::entpacken_ep(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
// Kommentar: Wenn direkt nach der parallelen adaptiven Verfeinerung der Lastausgleich erfolgt, muss die
// Markierungsfeldinformation auf den verschickten Punkten zusammen mit den ep - Informationen mitentpackt werden.
    if(ist_zusammen_aV_LA==true)
        {
        entpacken_ep_mit_markierungsfeld(mv, mvf_buffer);
//        entpacken_ep_ohne_markierungsfeld(mv, mvf_buffer);
        }
// Kommentar: Ansonsten werden nur die ep - Informationen für die empfangenen Punkte entpackt - als Flags, d.h. bitweise.
    else
        {
        entpacken_ep_ohne_markierungsfeld(mv, mvf_buffer);
        }
    }

// Kommentar: Hier wird die ep - Information ohne Markierungsfeld entpackt.
inline void LastAusgleich::entpacken_ep_ohne_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
// Kommentar: Zuerst muss die aktuelle Position im mvf - Buffer bestimmt werden.
    offset = mvf_buffer -> index;
    // Da fehlt noch Information: Man hat einen Index für die Zahl übermittelter Vektoren, dann einen für den umlaufenden
    // Teil. Obwohl: Die sind eindeutig. Weil eindeutig umlaufen ist. Aber das ist hier noch nicht verwendet!

// Kommentar: Die Klassen, die bitweises Entpacken aus dem Buffer ermöglichen, bekommen den Buffer sowie den aktuellen Index mitgeteilt.
    #ifdef KURZ_MVF
    bool_short_int.anfang(mvf_buffer->buffer, offset);
    #else
    bool_int.anfang(mvf_buffer->buffer, offset);
    #endif

// Kommentar: Dann werden die Gitterebenen durchlaufen.
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AKTUELLE_KOMMENTARE
        cout << " !100825 a entpacken_ep Ebene " << i << " rang " << rang << endl;
#endif
// Kommentar: Muss für eine Gitterebene nichts getan werden, gehe zur nächsten Gitterebene.
//        if(ep_ebenen[i]==false)
        if(ep_ebenen[i]<2)
            {
            continue;
            }
// Kommentar: Ansonsten lade die Zeiger auf die Vektoren, und lese die Vektorenanzahl - aus der jeweiligen Instanz der Klasse
// MV_vertikal.
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
        index = mv->indizes[i];

// Kommentar: Die Zeiger auf die Strukturen EP+ und EP- werden für die aktuelle Gitterebene kopiert.
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];

// Kommentar: Die Funktion entpacken_ep_rumpf erledigt alles weitere in Bezug auf das Entpacken.
        entpacken_ep_rumpf();
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Entpacken_ep 3 rang " << rang << endl;
#endif

// Kommentar: Am Ende schreibe den nun aktuellen Bufferindex zurück in den mvf - Buffer.
    #ifdef KURZ_MVF
    mvf_buffer->index = bool_short_int.laenge();
    #else
    mvf_buffer->index = bool_int.laenge();
    #endif
    }

// Kommentar: Mit dieser Funktion wird die Multi - Level - Kerntopologie für Punktnachbarschaften gespeichert.
void LastAusgleich::setze_ebene_ebenen_zaehler(int * PT_ml)
    {
// Kommentar: Die Multi - Level - Topologie wird gespeichert, und an die Nachkorrektur - das ist die Klasse, die die
// Zwischenkorrektur entsprechend der Dissertation durchführt - weitergegeben.
    ist_nachbar_zaehler_ml = PT_ml;
    nachkorrektur.setze_ebene_ebenen_zaehler(PT_ml);
    }

////////////////////////////////////////////////
////////////////////////////////////////////////

// Kommentar: Hier wird die Variable ev_dim in Abhängigkeit der Variablen ep_typen geschrieben - per switch - case - Anweisung.
void LastAusgleich::initialisierung_ev(int _ev_typen)
    {
    ev_typen = _ev_typen;
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EV2:
            ev_dim = 1;
            break;
        case TYP_EVEV:
        case TYP_EV2EV2:
            cout << " ev_dim 2 rang " << rang << endl;
            ev_dim = 2;
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
        default:
            cout << "Fehler in LastAusgleich::initialisierung_ev / ev_typen = " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
    }

////////////////////////////////////////////////
////////////////////////////////////////////////
///// einfuegen / entfernen  ///////////////////
////////////////////////////////////////////////
////////////////////////////////////////////////

// Kommentar: Hier werden die Vektoren aus mv_vertikal aus der Struktur ev für die angegebene Gitterebene entfernt.
void LastAusgleich::entferne_ebeneEV(MV_vertikal * mv_vertikal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_vertikal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe 1 rang " << rang << " ebene " << ebene << endl;
#endif

// Kommentar: Zuerst wird die 1-dimensionale Liste von Vektoren von mv_vertikal für die angegebene Gitterebene - nebst der Anzahl der
// Vektoren - als Zeiger gespeichert.
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

// Kommentar: ev wird für die Gitterebene als Zeiger gespeichert.
    ev_ebene = &(ev[ebene]);

// Kommentar: Diese Vektoren werden geladen und durchlaufen ...
    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
// Kommentar: ... und die Punkte aus ev entfernt.
            ev_ebene->entfernen(j, vvektor_g);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Diese Funktion wird nicht mehr benötigt. Wie schon oben erläutert, gibt es bei ev2 keine Punkte darüber oder darunter.
// Deswegen können auch keine Punkte aus mv_vertikal Punkte von ev2 darunter oder darüber entfernen. Alle Punkte, die zu entfernen
// sind, werden schon bei der Suche nach den Punkten entfernt. Daher ist diese Funktion überflüssig, und braucht nicht kommentiert werden.
void LastAusgleich::entferne_ebeneEV2(MV_vertikal * mv_vertikal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_vertikal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe2 1 rang " << rang << " ebene " << ebene << endl;
#endif

    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

    ev2_ebene = &(ev2[ebene]);

    if(ebene==0)
        {
        for(k=0; k<index; k++)
            {
            vvektor_f1 = f1[k];
            vvektor_f2 = f2[k];
            vvektor_g = g[k];
            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " j " << j << " vvektor_g " << vvektor_g << endl;
#endif
                ev2_ebene->entfernen(j, vvektor_g);
                }
            }
        return;
        }

    pr_i_minus1 = paralleles_rechnen_l[ebene-1];

    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " j " << j << " vvektor_g " << vvektor_g << endl;
#endif
                if((pr_i_minus1->feld[j<<1][vvektor_g<<1])<0) // Ist unterster Punkt. Bei Ebene = 0 wuerde immer entfernt.

// D.h., dass in ev2 noch ein Punkt steht.
                    {
                    ev2_ebene->entfernen(j, vvektor_g);
                    }
                }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe2 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Hier werden die Vektoren aus mv_vertikal in die Struktur ev für die angegebene Gitterebene eingefügt.
void LastAusgleich::einfuegen_ebeneEV(MV_vertikal * mv_vertikal, int ebene)
//  Warum das hier? Und wenn: Muss nicht oben in ev2 eingefügt werden, und unten in ev?
//  Das wird hier nicht abgebildet.

//  Ich verstehe die Routine hier nicht. Die Idee dabei: Wenn ich Gitterpunkte entferne aus ev,
//  dann werden damit auch Punkte aus ev2 entfernt, bzw. selbiges mit Einfügen.

// für ev Einfügung ist es klar: Nur dort und mit der Ebene einfuegen. Zu ev2 ist es komplizierter: für Ebene 0: wird sie nicht
// gebraucht. Nur für einfuegen oben, also ab Ebene 0.
// Für Ebene > 0:
// Falls darunter nichts ist - z.B. bei neuen Punkten - dann dort einfuegen.
// Beim Einfuegen von Punkten gibt es noch eines: ev2 eine Ebene höher wird gelöscht, falls der Punkt existiert.
// Denn es gibt nun einen Punkt darunter.
    {
// Kommentar: Zuerst wird die 1-dimensionale Liste von Vektoren von mv_vertikal für die angegebene Gitterebene - nebst der Anzahl der
// Vektoren - als Zeiger gespeichert.
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

// Kommentar: ev wird für die Gitterebene als Zeiger gespeichert.
    ev_ebene = &(ev[ebene]);

// Kommentar: Diese Vektoren werden geladen und durchlaufen ...
    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];


        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
// Kommentar: ... und die Punkte in ev eingefügt.
            ev_ebene->einfuegen(j, vvektor_g);
            }
        }
    }

// Kommentar: Hier wird für ev2 eingefügt. Voraussetzung ist, dass bei einer Ebene h > 0 die Werte von parallelem Rechnen
// auf der Ebene h-1 schon korrekt sind. Aber dass geschieht schon vor dem Aufruf dieser Funktion.
void LastAusgleich::einfuegen_ebeneEV2(MV_vertikal * mv_vertikal, int ebene)
//  Warum das hier? Und wenn: Muss nicht oben in ev2 eingefügt werden, und unten in ev?
//  Das wird hier nicht abgebildet.

//  Ich verstehe die Routine hier nicht. Die Idee dabei: Wenn ich Gitterpunkte entferne aus ev,
//  dann werden damit auch Punkte aus ev2 entfernt, bzw. selbiges mit Einfügen.

// für ev Einfügung ist es klar: Nur dort und mit der Ebene einfuegen. Zu ev2 ist es komplizierter: für Ebene 0: wird sie nicht
// gebraucht. Nur für einfuegen oben, also ab Ebene 0.
// Für Ebene > 0:
// Falls darunter nichts ist - z.B. bei neuen Punkten - dann dort einfuegen.
// Beim Einfuegen von Punkten gibt es noch eines: ev2 eine Ebene höher wird gelöscht, falls der Punkt existiert.
// Denn es gibt nun einen Punkt darunter.
    {
// Kommentar: Zuerst wird die 1-dimensionale Liste von Vektoren von mv_vertikal für die angegebene Gitterebene - nebst der Anzahl der
// Vektoren - als Zeiger gespeichert.
    f1 = mv_vertikal->f1_speichern[ebene];
    f2 = mv_vertikal->f2_speichern[ebene];
    g = mv_vertikal->g_speichern[ebene];
    index = mv_vertikal->indizes[ebene];

// Kommentar: ev2 wird für die Gitterebene als Zeiger gespeichert.
    ev2_ebene = &(ev2[ebene]);

// Kommentar: Auf Gitterebene 0 werden komplett alle Gitterpunkte aller Vektoren in ev2 eingefügt.
    if(ebene == 0)
        {
        for(k=0; k<index; k++)
            {
            vvektor_f1 = f1[k];
            vvektor_f2 = f2[k];
            vvektor_g = g[k];

            for(j=vvektor_f1; j<=vvektor_f2; j++)
                {
                ev2_ebene->einfuegen(j, vvektor_g);
                }
            }
        return;
        }

// Ansonsten ist paralleles_rechnen der Ebenen h-1 zu bestimmen.
    pr_i_minus1 = paralleles_rechnen_l[ebene-1];

// Kommentar: Auf Gitterebene h > 0 werden  alle Gitterpunkte aller Vektoren, die darunter keinen Gitterpunkt haben, in ev2 eingefügt.
    for(k=0; k<index; k++)
        {
        vvektor_f1 = f1[k];
        vvektor_f2 = f2[k];
        vvektor_g = g[k];

        for(j=vvektor_f1; j<=vvektor_f2; j++)
            {
            if((pr_i_minus1->feld[j<<1][vvektor_g<<1])<0) // Damit ist (j,vvektor_g) unterster Punkt.
                {
                ev2_ebene->einfuegen(j, vvektor_g);
                }
            }
        }
    }

//////////////////////////////////////////////////////////
///////// Ende einfuegen und entfernen ///////////////////
//////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////
//////// Beginn entpacken (ost / west)  //////////////////
//////////////////////////////////////////////////////////

// Kommentar: Hier wird der mvf - Buffer entpackt. Dabei wird mv_vertikal beschrieben, und es wird das umlaufende Farbenfeld
// erzeugt, und die Klassen Gitter und ev und / oder ev2 um die Punkte aus mv_vertikal ergänzt, bei ev2 ggf. nicht für alle Gitterpunkte.
void LastAusgleich::entpacken_west(MVFBuffer * mvf_buffer)
    {
// Kommentar: Es wird unterschieden nach ev_typen, ob nur die Struktur ev, nur die Struktur ev2 oder beide Strukturen geändert werden,
// wobei letzteres eigentlich nicht sinnvoll ist.
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
// Kommentar: Hier geschieht entpacken nach Westen für ev - in Bezug auf die Änderung der Instanzen von Extreme Vektoren.
            entpacken_westEV(mvf_buffer);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
// Kommentar: Hier geschieht entpacken nach Westen für ev2 - in Bezug auf die Änderung der Instanzen von Extreme Vektoren.
            entpacken_westEV2(mvf_buffer);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::entpacken_west // ev_typen " << ev_typen << endl;
            exit(-1);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ entpacken west " << endl;
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_westen.ausgeben2(zeichenkette);
#endif
    }

// Kommentar: Hier werden die Hauptinformationen entpackt - von einem Buffer, der aus Westen kommt.
inline void LastAusgleich::entpacken_westEV(MVFBuffer * mvf_buffer)
// Vielleicht braucht man beim entpacken nicht normal und oben zu unterscheiden, weil in beiden Fällen das schon als
// Multibuffer gepackt ist!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " EntPackenLA1234 west EVEV rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10080 // rang " << rang << endl;
#endif

// Kommentar: Zuerst werden mit Hilfe des Buffer die Instanz mv_hilfe_westen der Klasse MV_vertikal erzeugt.
    aus_mvf_buffer_zu_mv.bestimmen(mvf_buffer, & mv_hilfe_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10081 // rang " << rang << endl;
#endif
//    mv_westen.ausgeben();
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_westen.ausgeben(zeichenkette);
    cout << "!10082 // rang " << rang << endl;
#endif

// Kommentar: Hierbei wird in das Farbenfeld drum herum entpackt.
    farbenfelder_verschicken.entpacken_westen(mvf_buffer, &mv_hilfe_westen);
    // Es sieht so aus, als würde das Farbenfeld entpackt, bevor die Punkte eingefügt werden!
    // Das passt zusammen mit der Zählklasse.
    // Was ist mit mvf_buffer_westen? Klären, wenn ich den Lastausgleich korrigiere!
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!100825 rang " << rang << " entpacken_westEV " << endl;
#endif

// Kommentar: Hier wird in die Strukturen der Eigenschaftspunkte entpackt. Beim Packen geschieht die entsprechende Funktion packen_ep
// in der Klasse packen_west_ieS.
    entpacken_ep(&mv_hilfe_westen, mvf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10083 // rang " << rang << endl;
#endif

// Kommentar: Dann werden für alle relevanten Gitterebenen in die Klasse Gitter die Gitterpunkte aus mv_hilfe_westen eingefügt.
// Hier muss das nicht vor dem Aktualisieren von ev geschehen, weil ev immer komplett eingefügt wird.
    for(i=0; i<h_gesamt_variante; i++) // Immer erst die Punkte einfuegen VOR (!) der Bearbeitung von ev2.
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 a rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene(&mv_hilfe_westen, farbmatrix.west[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 b rang " << rang << endl;
#endif
        #else
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 c rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch(&mv_hilfe_westen, farbmatrix.west[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 d rang " << rang << endl;
#endif
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10085 rang " << rang << endl;
#endif
        }
// Kommentar: Und am Ende werden die Punkte aus mv_hilfe_westen für die relevanten Ebenen in ev eingefügt.
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 c rang " << rang << " Ebene " << i << endl;
#endif
        einfuegen_ebeneEV(&mv_hilfe_westen, i);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 d rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10086 // rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu entpacken_westEV, nur dass statt einfuegen_ebeneEV einfuegen_ebeneEV2 aufgerufen wird. Und das ist so,
// weil hier ev2 geändert wird.
inline void LastAusgleich::entpacken_westEV2(MVFBuffer * mvf_buffer)
// Vielleicht braucht man beim entpacken nicht normal und oben zu unterscheiden, weil in beiden Fällen das schon als
// Multibuffer gepackt ist!
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " EntPackenLA1234 west EV2 rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10080 // rang " << rang << endl;
#endif
    aus_mvf_buffer_zu_mv.bestimmen(mvf_buffer, & mv_hilfe_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10081 // rang " << rang << endl;
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_westen.ausgeben(zeichenkette);
    mv_hilfe_osten.ausgeben(zeichenkette);
    cout << "!10082 // rang " << rang << endl;
#endif
    farbenfelder_verschicken.entpacken_westen(mvf_buffer, &mv_hilfe_westen);
    // Es sieht so aus, als würde das Farbenfeld entpackt, bevor die Punkte eingefügt werden!
    // Das passt zusammen mit der Zählklasse.
    // Was ist mit mvf_buffer_westen? Klären, wenn ich den Lastausgleich korrigiere!
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!100825 rang " << rang << " entpacken_westEV2 " << endl;
#endif
    entpacken_ep(&mv_hilfe_westen, mvf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10083 // rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++) // Immer erst die Punkte einfuegen VOR (!) der Bearbeitung von ev2.
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 a rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene(&mv_hilfe_westen, farbmatrix.west[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 b rang " << rang << endl;
#endif
        #else
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 c rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch(&mv_hilfe_westen, farbmatrix.west[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 d rang " << rang << endl;
#endif
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10085 rang " << rang << endl;
#endif
        }
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 c rang " << rang << " Ebene " << i << endl;
#endif
        einfuegen_ebeneEV2(&mv_hilfe_westen, i);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 d rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10086 // rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu entpacken_west. Daher hier keine eigenen Kommentare.
void LastAusgleich::entpacken_ost(MVFBuffer * mvf_buffer)
    {
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            entpacken_ostEV(mvf_buffer);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
            entpacken_ostEV2(mvf_buffer);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::entpacken_west // ev_typen " << ev_typen << endl;
            exit(-1);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ entpacken ost " << endl;
    strcpy(zeichenkette, " entpacken Ost ");
    mv_hilfe_osten.ausgeben2(zeichenkette);
#endif
    }

// Kommentar: Analog zu entpacken_westEV. Daher keine eigenen Kommentare.
void LastAusgleich::entpacken_ostEV(MVFBuffer * mvf_buffer)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " EntPackenLA1234 ost EVEV rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 1 rang " << rang << endl;
#endif
    aus_mvf_buffer_zu_mv.bestimmen(mvf_buffer, & mv_hilfe_osten);
// Wofür sind die Listen aktuell? Sollen da nur die Änderungen vorgenommen werden?
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken Ost");
    mv_hilfe_osten.ausgeben(zeichenkette);
    cout << "!LAeo 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.entpacken_osten(mvf_buffer, &mv_hilfe_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 3 rang " << rang << endl;
#endif
    // Hier auch: Die Farbenfelder werden behandelt, bevor (!) eingefügt wird.
    entpacken_ep(&mv_hilfe_osten, mvf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 4 rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++) // Erst paralleles_rechnen machen.
        {
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->einfuegen_ebene(&mv_hilfe_osten, farbmatrix.ost[rang]);
        #else
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch(&mv_hilfe_osten, farbmatrix.ost[rang]);
        #endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 5 rang " << rang << " EV " << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        einfuegen_ebeneEV(&mv_hilfe_osten, i);
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 6 rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu entpacken_westEV2. Daher keine eigenen Kommentare.
void LastAusgleich::entpacken_ostEV2(MVFBuffer * mvf_buffer)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " EntPackenLA1234 ost EV2EV2 rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 1 rang " << rang << endl;
#endif
    aus_mvf_buffer_zu_mv.bestimmen(mvf_buffer, & mv_hilfe_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken Ost");
    mv_hilfe_osten.ausgeben(zeichenkette);
    cout << "!LAeo 2 rang " << rang << endl;
#endif
#ifdef AAHH
    test_la1("6475");
#endif
    farbenfelder_verschicken.entpacken_osten(mvf_buffer, &mv_hilfe_osten);
#ifdef AAHH
    test_la1("6477");
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " !LAeo 3 rang " << rang << endl;
#endif
    // Hier auch: Die Farbenfelder werden behandelt, bevor (!) eingefügt wird.
    entpacken_ep(&mv_hilfe_osten, mvf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " !LAeo 4 rang " << rang << endl;
#endif
#ifdef AAHH
    test_la1("6487");
#endif
    for(i=0; i<h_gesamt_variante; i++) // Erst paralleles_rechnen machen.
        {
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->einfuegen_ebene(&mv_hilfe_osten, farbmatrix.ost[rang]);
        #else

#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " Vor eead einfuegen rang " << rang << " i " << i << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch(&mv_hilfe_osten, farbmatrix.ost[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " Nach eead einfuegen rang " << rang << " i " << i << endl;
#endif
        #endif
        }
#ifdef AAHH
    test_la1("6500");
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " !LAeo 5 rang " << rang << " EV2 " << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        einfuegen_ebeneEV2(&mv_hilfe_osten, i);
        }
#ifdef AAHH
    test_la1("6508");
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAeo 6 rang " << rang << endl;
#endif
    }

////////////////////////////////////////////////////////////////////////
////// Ende Entpacken Ost / West ///////////////////////////////////////
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
////// Start Packen Ost Oben mv ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

// Kommentar: Analog zu packen_west_oben_mv. Daher werden hier keinen eigenen Kommentare geschrieben.
inline void LastAusgleich::packen_ost_oben_mv(int gesamtlast)
    {
    switch(ev_typen)
        {
        case TYP_EVEV:
        case TYP_EV:
            packen_ost_oben_mvEVEV(gesamtlast);
            break;
        case TYP_EV2:
// Kommentar: Bemerkung: Bei TYP_EV2 gibt es kein oben.
        case TYP_EV2EV2:
            packen_ost_oben_mvEV2EV2(gesamtlast);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::packen_ost_oben_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ ost oben " << endl;
    strcpy(zeichenkette, " Packen_ost_oben_mv ");
    mv_osten.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Analog zu packen_west_oben_mvEVEV. Daher werden hier keinen eigenen Kommentare geschrieben.
inline void LastAusgleich::packen_ost_oben_mvEVEV(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " PackenLA1234 ost oben EVEV rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev[gitterebene_plus1].bilde_ost_vektoren(gesamtlast, &(mv_osten), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen.durchfuehren(&(mv_osten), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_ost_oben_mv ");
    mv_osten.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_osten);
    cout << "Packen 1c rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene_plus1) // Was ist gitterebene_plus1? gitterebene und nach oben.
            {
            entferne_ebeneEV(&mv_osten, i);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

// Kommentar: Analog zu packen_west_oben_mvEV2EV2. Daher werden hier keinen eigenen Kommentare geschrieben.
void LastAusgleich::packen_ost_oben_mvEV2EV2(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 ost oben EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev2[gitterebene_plus1].bilde_ost_vektoren(gesamtlast, &(mv_osten), gitterebene_plus1);
    // Soweit ist richtig, weil alles darüber entfernt wird.
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen.durchfuehren(&(mv_osten), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_ost_oben_mv ");
    mv_osten.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_osten);
    cout << "Packen 1c rang " << rang << endl;
    // Bemerkung: Unterhalb gitterebene_plus1 existieren keine Punkte, überhalb keine Einträge in ev2.
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

///////////////////////////////////////////////////////////////////
/////// Ende Packen oben ost mv ///////////////////////////////////
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
/////// Beginn Packen west mv /////////////////////////////////////
///////////////////////////////////////////////////////////////////

// Kommentar: Hier wird für den westlichen Kern gepackt.
inline void LastAusgleich::packen_west_mv(int gesamtlast)
    {
// Kommentar: Man unterscheidet die Fälle nur ev, nur ev2 oder beides.
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
// Kommentar: Im Fall von ev wird packen_west_mvEV aufgerufen.
            packen_west_mvEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
// Kommentar: Im Fall von ev2 wird unterschieden nach LA_OBEN_IMMER_AUSGLEICHEN.
// Ist das definiert, wird im Fall von west_differenz_oben > 0 Westen und Westen - oben für ev2 gemeinsam gepackt.
#ifdef LA_OBEN_IMMER_AUSGLEICHEN
            if(west_differenz_oben > 0)
                {
                packen_west_mvEV2_mit_oben(gesamtlast);
                }
// Kommentar: Sonst wird nur für Westen für ev2 gepackt
            else
                {
                packen_west_mvEV2(gesamtlast);
                }
#else
// Kommentar: Ohne die obige Präprozessor - Variable wird nur unten gepackt - in diesem Fall mit west_differenz > 0.
            packen_west_mvEV2(gesamtlast);
#endif
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::packen_west_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ west unten " << endl;
    strcpy(zeichenkette, " Packen_west_mv ");
    mv_westen.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Obige Funktion packen_west_mv wird im Falle von ev durchgeführt.
void LastAusgleich::packen_west_mvEV(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " PackenLA1234 west EVEV rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif
// Kommentar: Da oben die Punkte ausgewählt werden, müssen die westlichen Vektoren auf der Gitterebene gitterebene ausgewählt werden - aus der
// Struktur ev. Sie werden nach mv_westen auf der Gitterebenen gitterebene geschrieben werden.
    ev[gitterebene].bilde_west_vektoren(gesamtlast, &(mv_westen), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
//  Wie? Wann wird aus ev2 entfernt bie ev.bilde_west_vektoren?

// Kommentar: Dann werden die Projektionen durchgeführt, damit die zu verschickenden Punkte auf allen Gitterebenen bestimmt werden.
    mv_projektionen.durchfuehren(&(mv_westen), gitterebene);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_west_mvEV ");
    mv_westen.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_westen);
#endif

// Kommentar: Nun wird auf allen relevanten Gitterebenen - aber ohne die, wo beim Aussuchen auch die Vektoren schon gelöscht wurden - die Gitterpunkte
// gelöscht - aus ev.
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene)  // Warum dieser Befehl? Weil das beim Aufruf von bilde_west_vektoren automatisch passiert.
                            // Allerdings nur für ev, nicht für ev2!
            {
// Kommentar: Das Löschen der Gitterpunkte aus ev übernimmt diese Funktion entferne_ebeneEV.
            entferne_ebeneEV(&mv_westen, i);
            }
        }
    }

// Kommentar: obige Funktion packen_west_mv wird im Falle von ev2 durchgeführt. Die ersten Schritte sind analog wie bei
// packen_west_mvEV, mit der Ausnahme, dass die Punkteauswahl durch ev2 geschieht. Außerdem:
// Es geschieht kein Löschen: Weil bei ev2 darunter und darüber keine Gitterpunkte existieren, muss
// in diesem Fall neben dem 'automatischen Löschen' beider Auswahl der zu verschickenden Gitterpunkte nichts weiter gelöscht werden.
// Die restlichen Befehle sind wie bei packen_west_mvEV, d.h. es muss nichts weiter kommentiert werden.
void LastAusgleich::packen_west_mvEV2(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 west EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif
    ev2[gitterebene].bilde_west_vektoren(gesamtlast, &(mv_westen), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen.durchfuehren(&(mv_westen), gitterebene);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_west_mvEV2 ");
    mv_westen.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_westen);
#endif
    }

///////////////////////////////////////////////////////////////////
/////// Ende Packen west mv ///////////////////////////////////////
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
/////// Beginn Packen ost mv //////////////////////////////////////
///////////////////////////////////////////////////////////////////

// Kommentar: Analog zu packen_west_mv. Daher keine eigenen Kommentare.
inline void LastAusgleich::packen_ost_mv(int gesamtlast)
    {
#ifdef TYP_PPOOMM
    if((gitterebene == 0)&&(rang==2))
        {
        cout << " PPOOMM last " << gesamtlast << endl;
        }
#endif
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            packen_ost_mvEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
#ifdef LA_OBEN_IMMER_AUSGLEICHEN
            if(ost_differenz_oben > 0)
                {
                packen_ost_mvEV2_mit_oben(gesamtlast);
                }
            else
                {
                packen_ost_mvEV2(gesamtlast);
                }
#else
            packen_ost_mvEV2(gesamtlast);
#endif
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::packen_ost_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " XXYYZZ ost unten " << endl;
    strcpy(zeichenkette, " Packen_ost_mv ");
    mv_osten.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Analog zu packen_west_mvEV. Daher keine eigenen Kommentare.
void LastAusgleich::packen_ost_mvEV(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 ost EVEV rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif
    ev[gitterebene].bilde_ost_vektoren(gesamtlast, &(mv_osten), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen.durchfuehren(&(mv_osten), gitterebene);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_ost_mvEV ");
    mv_osten.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_osten);
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene)  // Warum dieser Befehl? Weil das beim Aufruf von bilde_west_vektoren automatisch passiert.
                            // Allerdings nur für ev, nicht für ev2!
            {
            entferne_ebeneEV(&mv_osten, i);
            }
        }
    }

// Kommentar: Analog zu packen_west_mvEV2. Daher keine eigenen Kommentare.
void LastAusgleich::packen_ost_mvEV2(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 ost EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif
    ev2[gitterebene].bilde_ost_vektoren(gesamtlast, &(mv_osten), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen.durchfuehren(&(mv_osten), gitterebene);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_ost_mvEV2 ");
    mv_osten.ausgeben(zeichenkette);
    mv_projektionen.ausgeben(zeichenkette, &mv_osten);
#endif
    }

///////////////////////////////////////////////////////////////////
/////// Ende Packen ost mv ////////////////////////////////////////
///////////////////////////////////////////////////////////////////


// Kommentar: Die Struktur felder_aktuell wird in Funktionen wie entferne_ep_listen(_ns), oder einfuegen_ep_listen(_ns)
// verwendet, die nicht mehr gebraucht werden. Daher wird diese Funktion nicht kommentiert.
void LastAusgleich::setze_felder_aktuell(short int ** _feld_aktuell, int ebene)
    {
    felder_aktuell[ebene] = _feld_aktuell;
    }

/////////////////////////////////////////////////////////
/////////////// packen nord sued     ////////////////////
/////////////// entpacken nord sued  ////////////////////
/////////////////////////////////////////////////////////

// Kommentar: Die folgenden Funktionen fürs Packen und Entpacken nach Norden und Süden sind analog den Funktionen fürs Packen und
// Entpacken nach Westen und Osten. Daher werden nun eine ganze Reihe von Nord - Süd - Funktionen nicht kommentiert.

void LastAusgleich::packen_sued_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued 1 rang " << rang << endl;
#endif
    aus_mv_zu_mhf_buffer.bestimmen(&mv_sueden, &mhf_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.packen_ns(&mv_sueden, &mhf_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued 3 rang " << rang << endl;
#endif
    packen_ep_ns(&mv_sueden, &mhf_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued 4 rang " << rang << endl;
#endif
    }

void LastAusgleich::packen_sued_oben_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 1 rang " << rang << endl;
#endif
    aus_mv_zu_mhf_buffer.bestimmen(&mv_sueden, &mhf_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.packen_ns(&mv_sueden, &mhf_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 3 rang " << rang << endl;
#endif
    packen_ep_ns(&mv_sueden, &mhf_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 4 rang " << rang << endl;
#endif
    }

void LastAusgleich::packen_nord_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS nord 1 rang " << rang << endl;
#endif
    aus_mv_zu_mhf_buffer.bestimmen(&mv_norden, &mhf_buffer_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS nord 2 rang " << rang << endl;
#endif

#ifdef AKTUELLE_KOMMENTARE
#endif
    farbenfelder_verschicken.packen_ns(&mv_norden, &mhf_buffer_norden);
#ifdef AKTUELLE_KOMMENTARE
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS nord 3 rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " GHIGHI vor packen_ep_ns ");
    mv_norden.ausgeben(zeichenkette);
#endif

    packen_ep_ns(&mv_norden, &mhf_buffer_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS nord 4 rang " << rang << endl;
#endif
    }

void LastAusgleich::packen_nord_oben_ieS(void)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 1 rang " << rang << endl;
#endif
    aus_mv_zu_mhf_buffer.bestimmen(&mv_norden, &mhf_buffer_norden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 2 rang " << rang << endl;
#endif
    farbenfelder_verschicken.packen_ns(&mv_norden, &mhf_buffer_norden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 3 rang " << rang << endl;
#endif

    packen_ep_ns(&mv_norden, &mhf_buffer_norden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "ieS sued oben 4 rang " << rang << endl;
#endif
    }


inline void LastAusgleich::packen_ep_ns(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
    if(ist_zusammen_aV_LA == true)
        {
        packen_ep_ns_mit_markierungsfeld(mv, mhf_buffer);
        }
    else
        {
        packen_ep_ns_ohne_markierungsfeld(mv, mhf_buffer);
        }
    }

inline void LastAusgleich::packen_ep_ns_ohne_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
    offset = mhf_buffer -> index;
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 1 ns oM rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
    bool_short_int.anfang(mhf_buffer->buffer, offset);
    #else
    bool_int.anfang(mhf_buffer.buffer, offset);
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 2 ns oM rang " << rang << " ep_ebenen[1] " << ep_ebenen[1] << endl;
#endif

    for(i=0; i<h_gesamt_variante; i++)
        {
//        if(ep_ebenen[i]==false)
        if(ep_ebenen[i]<2)
            {
            continue;
            }
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        f = mv->f_speichern[i];
        index = mv->indizes[i];

        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        ep_snb_update_i = ep_snb_update[i];

        packen_ep_ns_rumpf();
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Packen_ep_ns 3 rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
    mhf_buffer->index = bool_short_int.laenge();
    #else
    mhf_buffer->index = bool_int.laenge();
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!2021" << endl;
#endif
    }

inline void LastAusgleich::entpacken_ep_ns(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
    if(ist_zusammen_aV_LA == true)
        {
        entpacken_ep_ns_mit_markierungsfeld(mv, mhf_buffer);
        }
    else
        {
        entpacken_ep_ns_ohne_markierungsfeld(mv, mhf_buffer);
        }
    }

inline void LastAusgleich::entpacken_ep_ns_ohne_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
    offset = mhf_buffer -> index;
    // Da fehlt noch Information: Man hat einen Index für die Zahl übermittelter Vektoren, dann einen für den umlaufenden
    // Teil. Obwohl: Die sind eindeutig. Weil eindeutig umlaufen ist. Aber das ist hier noch nicht verwendet!
    #ifdef KURZ_MVF
    bool_short_int.anfang(mhf_buffer->buffer, offset);
    #else
    bool_int.anfang(mhf_buffer->buffer, offset);
    #endif

    for(i=0; i<h_gesamt_variante; i++)
        {
//        if(ep_ebenen[i]==false)
        if(ep_ebenen[i]<2)
            {
            continue;
            }
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        f = mv->f_speichern[i];
        index = mv->indizes[i];

        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];

        entpacken_ep_ns_rumpf();
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Entpacken_ep 3 rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
    mhf_buffer->index = bool_short_int.laenge();
    #else
    mhf_buffer->index = bool_int.laenge();
    #endif
    }

// Kommentar: Die folgende Funktion beendet eine Sequenz von Ost - West und Nord - Süd - Lastausgleichen. Sie wird aufgerufen, wenn
// alle Lastausgleichsrunden einer Iteration beendet sind. Sie ändert ep_snb und feld_vergangen bzw. pfl_vergangen, vgl.
// die folgenden Funktionen.
void LastAusgleich::LA_vollenden(void)
    {
// Kommentar: Es werden die Funktionen LA_vollenden_ep_plus/minus aufgerufen, vgl. die Kommentare zu diesen zwei Funktionen.
    LA_vollenden_ep_plus();
    LA_vollenden_ep_minus();
    }

// Kommentar: Es werden mit Hilfe der Menge EP+(gitterebene) ep_snb und feld_vergangen bzw. pfl_vergangen aktualisiert.
void LastAusgleich::LA_vollenden_ep_plus(void)
    {
// Kommentar: Es werden alle Gitterebenen durchlaufen.
    for(i=0; i<h_gesamt_variante; i++)
        {
// Kommentar: Werden die Gitterebenen zu ep - Zwecken nicht gebraucht, dann übergehe sie.
//        if(ep_ebenen[i]==false)
        if(ep_ebenen[i]<2)
            {
            continue;
            }

// Kommentar: Mache ep_plus[i] nebst Anzahl von Punkten zugänglich, und außerdem EP_SNB.
        ep_plus_i = ep_plus[i];
        ep_snb_update_i = ep_snb_update[i];
        anzahl = ep_plus_i->anzahl;
// Kommentar: Durchlaufe die Gitterpunkte von EP+, so wie sie beim Entpacken verfügbar sind.
        for(j=0; j<anzahl; j++)
            {
            k = ep_plus_i->f[j];
            l = ep_plus_i->g[j];
// Kommentar: Ist ep_snb_update an dieser Stelle nicht gesetzt, d.h. wurden die 8 Punkte drum herum noch nicht in Richtung Mitte (k,l)
// gesetzt, dann ...
            if(ep_snb_update_i->ist_gesetzt[k][l]==false)
                {
// Kommentar: ... mache EP_SNB - Update für diese Stelle - nebst dem setzen der Variablen ist_gesetzt.
                ep_snb_update_i->hinzu(k,l);
// Kommentar: Und sorge dafür, dass die Variable feld_vergangen bzw. im Falle der Existenz von EPS_PFLS auch pfl_vergangen gesetzt sind.
// Die Variablen feld_aktuell und pfl_aktuell sind nach der parallelen adaptiven Verfeinerung eh false, werden also nicht gebraucht.
                #ifdef EPS_PFLS
                ep_updates[i]->setze_feld_vergangen_gleich_true(k,l);
                #else
                ep_updates[i]->feld_vergangen[k][l] = true;
                #endif
                }
// Kommentar: Nachdem die nötigen Schritte gemacht worden sind, kann EP+ um diesen Punkt entfernt werden. Nur könnte das mit der Liste wechselwirken.
// Daher als Änderung am 14.8.2015: Am Ende mache ein Reset der Instanz der Klasse PunktFeldliste.
//            ep_plus_i->hinweg(k,l);
            }
        ep_plus_i->reset();
        }
    }

// Kommentar: Diese Funktion ist im wesentlichen Analog zu LA_vollenden_ep_plus. Es wird nur EP- statt EP+ durchlaufen, und im Falle
// das ep_snb->ist_gesetzt true ist, wird für EP_SNB an der Stelle entfernt, und ep_vergangen und ggf. pfl_vergangen auf false gesetzt,
// statt auf true.
void LastAusgleich::LA_vollenden_ep_minus(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
// 27.08.2014: ep_aendern auch für i=0 ? Sonst müßte es aber stimmen. Wohl ab i=1.
        {
//        if(ep_ebenen[i]==false)
        if(ep_ebenen[i]<2)
            {
            continue;
            }

        ep_minus_i = ep_minus[i];
        ep_snb_update_i = ep_snb_update[i];
        anzahl = ep_minus_i->anzahl;
        for(j=0; j<anzahl; j++)
            {
            k = ep_minus_i->f[j];
            l = ep_minus_i->g[j];
            if(ep_snb_update_i->ist_gesetzt[k][l]==true)
                {
                ep_snb_update_i->hinweg(k,l);
#ifdef AKTUELLE_KOMMENTARE
                if((rang==6)&&(k==15)&&(l==12))
                    {
                    cout << " LLMMNN ep_snb_update->hinweg(6,15,12) " << endl;
                    }
#endif
                #ifdef EPS_PFLS
                ep_updates[i]->setze_feld_vergangen_gleich_false(k,l);
                #else
                ep_updates[i]->feld_vergangen[k][l] = false;
                #endif
                }
            }
        ep_minus_i->reset(); // Änderung am 14.8.2015
        }
    }

// Kommentar: Die Folgenden Funktionen sind wieder für die Nord - und Süd - Lastausgleich zuständig. Da entsprechende Funktionen für den Ost - / West -
// Lastausgleich geschrieben worden sind, wird das hier nicht kommentiert. Die Kommentare wären analog.

void LastAusgleich::entpacken_nord(MHFBuffer * mhf_buffer)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " entpacken_nord // rang " << rang << " ev_typen " << ev_typen << endl;
#endif
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            entpacken_nordEV(mhf_buffer);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
            entpacken_nordEV2(mhf_buffer);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::entpacken_nord // ev_typen " << ev_typen << endl;
            exit(-1);
        }
    }

inline void LastAusgleich::entpacken_nordEV(MHFBuffer * mhf_buffer)
// Vielleicht braucht man beim entpacken nicht normal und oben zu unterscheiden, weil in beiden Fällen das schon als
// Multibuffer gepackt ist!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10080 // rang " << rang << endl;
#endif
    aus_mhf_buffer_zu_mv.bestimmen(mhf_buffer, & mv_hilfe_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10081 // rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_norden.ausgeben(zeichenkette);
    cout << "!10082 // rang " << rang << endl;
#endif
    farbenfelder_verschicken.entpacken_ns(mhf_buffer, &mv_hilfe_norden);
    // Es sieht so aus, als würde das Farbenfeld entpackt, bevor die Punkte eingefügt werden!
    // Das passt zusammen mit der Zählklasse.
    // Was ist mit mvf_buffer_westen? Klären, wenn ich den Lastausgleich korrigiere!
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!100825 rang " << rang << " entpacken_nordEV " << endl;
#endif
    entpacken_ep_ns(&mv_hilfe_norden, mhf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10083 // rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++) // Immer erst die Punkte einfuegen VOR (!) der Bearbeitung von ev2.
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 a rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_ns(&mv_hilfe_norden, farbmatrix.nord[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 b rang " << rang << endl;
#endif
        #else
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 c rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch_ns(&mv_hilfe_norden, farbmatrix.nord[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 d rang " << rang << endl;
#endif
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10085 rang " << rang << endl;
#endif
        }
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 c rang " << rang << " Ebene " << i << endl;
#endif
        einfuegen_ebeneEV_ns(&mv_hilfe_norden, i);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 d rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10086 // rang " << rang << endl;
#endif
    }

inline void LastAusgleich::entpacken_nordEV2(MHFBuffer * mhf_buffer)
// Vielleicht braucht man beim entpacken nicht normal und oben zu unterscheiden, weil in beiden Fällen das schon als
// Multibuffer gepackt ist!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10080 // rang " << rang << endl;
#endif
    aus_mhf_buffer_zu_mv.bestimmen(mhf_buffer, & mv_hilfe_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10081 // rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_norden.ausgeben(zeichenkette);
    cout << "!10082 // rang " << rang << endl;
#endif
    farbenfelder_verschicken.entpacken_ns(mhf_buffer, &mv_hilfe_norden);
    // Es sieht so aus, als würde das Farbenfeld entpackt, bevor die Punkte eingefügt werden!
    // Das passt zusammen mit der Zählklasse.
    // Was ist mit mvf_buffer_westen? Klären, wenn ich den Lastausgleich korrigiere!
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!100825 rang " << rang << " entpacken_nordEV2 " << endl;
#endif
    entpacken_ep_ns(&mv_hilfe_norden, mhf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10083 // rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++) // Immer erst die Punkte einfuegen VOR (!) der Bearbeitung von ev2.
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 a rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_ns(&mv_hilfe_norden, farbmatrix.nord[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 b rang " << rang << endl;
#endif
        #else
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 c rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch_ns(&mv_hilfe_norden, farbmatrix.nord[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 d rang " << rang << endl;
#endif
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10085 rang " << rang << endl;
#endif
        }
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 c rang " << rang << " Ebene " << i << endl;
#endif
        einfuegen_ebeneEV2_ns(&mv_hilfe_norden, i);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 d rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10086 // rang " << rang << endl;
#endif
    }

void LastAusgleich::einfuegen_ebeneEV2_ns(MV_horizontal * mv_horizontal, int ebene)
//  Warum das hier? Und wenn: Muss nicht oben in ev2 eingefügt werden, und unten in ev?
//  Das wird hier nicht abgebildet.

//  Ich verstehe die Routine hier nicht. Die Idee dabei: Wenn ich Gitterpunkte entferne aus ev,
//  dann werden damit auch Punkte aus ev2 entfernt, bzw. selbiges mit Einfügen.

// für ev Einfügung ist es klar: Nur dort und mit der Ebene einfuegen. Zu ev2 ist es komplizierter: für Ebene 0: wird sie nicht
// gebraucht. Nur für einfuegen oben, also ab Ebene 0.
// Für Ebene > 0:
// Falls darunter nichts ist - z.B. bei neuen Punkten - dann dort einfuegen.
// Beim Einfuegen von Punkten gibt es noch eines: ev2 eine Ebene höher wird gelöscht, falls der Punkt existiert.
// Denn es gibt nun einen Punkt darunter.
    {
    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];

    ev2_ebene = &(ev2[ebene]);

    if(ebene == 0)
        {
        for(k=0; k<index; k++)
            {
            hvektor_g1 = g1[k];
            hvektor_g2 = g2[k];
            hvektor_f = f[k];

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
                ev2_ebene->einfuegen(hvektor_f, j);
                }
            }
        return;
        }

    pr_i_minus1 = paralleles_rechnen_l[ebene-1];

    for(k=0; k<index; k++)
        {
        hvektor_g1 = g1[k];
        hvektor_g2 = g2[k];
        hvektor_f = f[k];

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            if((pr_i_minus1->feld[hvektor_f<<1][j<<1])<0) // Damit ist (j,vvektor_g) unterster Punkt.
                {
                ev2_ebene->einfuegen(hvektor_f, j);
                }
            }
        }
    }

void LastAusgleich::entpacken_sued(MHFBuffer * mhf_buffer)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " ev_typen " << ev_typen << endl;
#endif
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            entpacken_suedEV(mhf_buffer);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
            entpacken_suedEV2(mhf_buffer);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::entpacken_sued // ev_typen " << ev_typen << endl;
            exit(-1);
        }
    }

inline void LastAusgleich::entpacken_suedEV(MHFBuffer * mhf_buffer)
// Vielleicht braucht man beim entpacken nicht normal und oben zu unterscheiden, weil in beiden Fällen das schon als
// Multibuffer gepackt ist!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10080 // rang " << rang << endl;
#endif
    aus_mhf_buffer_zu_mv.bestimmen(mhf_buffer, & mv_hilfe_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10081 // rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_sueden.ausgeben(zeichenkette);
    cout << "!10082 // rang " << rang << endl;
#endif
    farbenfelder_verschicken.entpacken_ns(mhf_buffer, &mv_hilfe_sueden);
    // Es sieht so aus, als würde das Farbenfeld entpackt, bevor die Punkte eingefügt werden!
    // Das passt zusammen mit der Zählklasse.
    // Was ist mit mvf_buffer_westen? Klären, wenn ich den Lastausgleich korrigiere!
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!100825 rang " << rang << " entpacken_suedEV " << endl;
#endif
    entpacken_ep_ns(&mv_hilfe_sueden, mhf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10083 // rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++) // Immer erst die Punkte einfuegen VOR (!) der Bearbeitung von ev2.
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 a rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_ns(&mv_hilfe_sueden, farbmatrix.sued[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 b rang " << rang << endl;
#endif
        #else
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 c rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch_ns(&mv_hilfe_sueden, farbmatrix.sued[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 d rang " << rang << endl;
#endif
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10085 rang " << rang << endl;
#endif
        }
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 c rang " << rang << " Ebene " << i << endl;
#endif
        einfuegen_ebeneEV_ns(&mv_hilfe_sueden, i);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 d rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10086 // rang " << rang << endl;
#endif
    }

inline void LastAusgleich::entpacken_suedEV2(MHFBuffer * mhf_buffer)
// Vielleicht braucht man beim entpacken nicht normal und oben zu unterscheiden, weil in beiden Fällen das schon als
// Multibuffer gepackt ist!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10080 // rang " << rang << endl;
#endif
    aus_mhf_buffer_zu_mv.bestimmen(mhf_buffer, & mv_hilfe_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10081 // rang " << rang << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "entpacken West");
    mv_hilfe_sueden.ausgeben(zeichenkette);
    cout << "!10082 // rang " << rang << endl;
#endif
    farbenfelder_verschicken.entpacken_ns(mhf_buffer, &mv_hilfe_sueden);
    // Es sieht so aus, als würde das Farbenfeld entpackt, bevor die Punkte eingefügt werden!
    // Das passt zusammen mit der Zählklasse.
    // Was ist mit mvf_buffer_westen? Klären, wenn ich den Lastausgleich korrigiere!
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!100825 rang " << rang << " entpacken_suedEV2 " << endl;
#endif
    entpacken_ep_ns(&mv_hilfe_sueden, mhf_buffer);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10083 // rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++) // Immer erst die Punkte einfuegen VOR (!) der Bearbeitung von ev2.
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 rang " << rang << endl;
#endif
        #ifndef AUCH_DYNAMISCH
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 a rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_ns(&mv_hilfe_sueden, farbmatrix.sued[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 b rang " << rang << endl;
#endif
        #else
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 c rang " << rang << endl;
#endif
        paralleles_rechnen_l[i]->einfuegen_ebene_auch_dynamisch_ns(&mv_hilfe_sueden, farbmatrix.sued[rang]);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10084 d rang " << rang << endl;
#endif
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10085 rang " << rang << endl;
#endif
        }
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 c rang " << rang << " Ebene " << i << endl;
#endif
        einfuegen_ebeneEV2_ns(&mv_hilfe_sueden, i);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!10083 d rang " << rang << endl;
#endif
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!10086 // rang " << rang << endl;
#endif
    }

inline void LastAusgleich::packen_nord_mv(int gesamtlast)
    {
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            packen_nord_mvEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
#ifdef LA_OBEN_IMMER_AUSGLEICHEN
            if(nord_differenz_oben > 0)
                {
                packen_nord_mvEV2_mit_oben(gesamtlast);
                }
            else
                {
                packen_nord_mvEV2(gesamtlast);
                }
#else
            packen_nord_mvEV2(gesamtlast);
#endif
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << " Fehler in LastAusgleich::packen_nord_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
    }

void LastAusgleich::packen_nord_mvEV(int gesamtlast)
    {
    ev[gitterebene].bilde_nord_vektoren(gesamtlast, &(mv_norden), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen_ns.durchfuehren(&(mv_norden), gitterebene);
#ifdef AKTUELLE_KOMMENTARE
    if(rang==4)
        {
        strcpy(zeichenkette, " FFGGHH Norden 4 ");
        mv_norden.ausgeben(zeichenkette);
        }
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_nord_mvEV ");
    mv_norden.ausgeben(zeichenkette);
    mv_projektionen_ns.ausgeben(zeichenkette, &mv_norden);
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene)  // Warum dieser Befehl? Weil das beim Aufruf von bilde_west_vektoren automatisch passiert.
                            // Allerdings nur für ev, nicht für ev2!
            {
            entferne_ebeneEV_ns(&mv_norden, i);
            }
        }
    }

void LastAusgleich::packen_nord_mvEV2(int gesamtlast)
    {
    ev2[gitterebene].bilde_nord_vektoren(gesamtlast, &(mv_norden), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen_ns.durchfuehren(&(mv_norden), gitterebene);
#ifdef AKTUELLE_KOMMENTARE
    if(rang==4)
        {
        strcpy(zeichenkette, " FFGGHH Norden 4 ");
        mv_norden.ausgeben(zeichenkette);
        }
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_nord_mvEV2 ");
    mv_norden.ausgeben(zeichenkette);
    mv_projektionen_ns.ausgeben(zeichenkette, &mv_norden);
#endif
    }

inline void LastAusgleich::packen_sued_mv(int gesamtlast)
    {
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            packen_sued_mvEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
#ifdef LA_OBEN_IMMER_AUSGLEICHEN
            if(sued_differenz_oben > 0)
                {
                packen_sued_mvEV2_mit_oben(gesamtlast);
                }
            else
                {
                packen_sued_mvEV2(gesamtlast);
                }
#else
            packen_sued_mvEV2(gesamtlast);
#endif
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ EVEV2 " << endl;
            exit(-1);
            break;
        default:
            cout << " Fehler in LastAusgleich::packen_sued_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
    }

void LastAusgleich::packen_sued_mvEV(int gesamtlast)
    {
    ev[gitterebene].bilde_sued_vektoren(gesamtlast, &(mv_sueden), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen_ns.durchfuehren(&(mv_sueden), gitterebene);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_sued_mvEV ");
    mv_sueden.ausgeben(zeichenkette);
    mv_projektionen_ns.ausgeben(zeichenkette, &mv_sueden);
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene)  // Warum dieser Befehl? Weil das beim Aufruf von bilde_west_vektoren automatisch passiert.
                            // Allerdings nur für ev, nicht für ev2!
            {
            entferne_ebeneEV_ns(&mv_sueden, i);
            }
        }
    }

void LastAusgleich::packen_sued_mvEV2(int gesamtlast)
    {
    ev2[gitterebene].bilde_sued_vektoren(gesamtlast, &(mv_sueden), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen_ns.durchfuehren(&(mv_sueden), gitterebene);
#ifdef AKTUELLE_KOMMENTARE
        {
        strcpy(zeichenkette, " Code 1: Packen_sued_mvEV2 unten ");
        mv_sueden.ausgeben(zeichenkette);
        mv_projektionen_ns.ausgeben(zeichenkette, &mv_sueden);
        }
#endif
    }

////////////////////////////////////////////////
////////////////////////////////////////////////
///// einfuegen / entfernen  ///////////////////
////////////////////////////////////////////////
////////////////////////////////////////////////

void LastAusgleich::entferne_ebeneEV_ns(MV_horizontal * mv_horizontal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_horizontal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe 1 rang " << rang << " ebene " << ebene << endl;
#endif

    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];


    for(k=0; k<index; k++)
        {
        hvektor_g1 = g1[k];
        hvektor_g2 = g2[k];
        hvektor_f = f[k];

        ev_ebene = &(ev[ebene]);

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            ev_ebene->entfernen(hvektor_f, j);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Nach der Erklärung zu enterne_ebene_EV2 wird diese Funktion nicht gebraucht. Denn auf der Ebene wurden die Punkte entfernt,
// und darunter und darüber gibt es keine Einträge in ev2.
void LastAusgleich::entferne_ebeneEV2_ns(MV_horizontal * mv_horizontal, int ebene)
// Für ev klar: direkt auf der Ebene. Zu ev2: Auch entfernen. Wenn auf Ebene entfernt, dann wird auch alles darunter entfernt.
// GGf. ist ev2 aber schon entfernt, weil darunter ein Punkt existiert. Dann nicht entfernen. Aber: Im Zuge des LA's
// sind die darunter liegenden Punkte vielleicht schon entfernt. Darüber wird eingefuegt. Es sei denn, dass dieser Punkt
// entfernt wurde. Aber: Wenn dieser Punkt auch entfernt wurde, dann auch dort nicht einfuegen.
// Also genau auf das Timing achten.
// Timing: Diese Funktion wird aufgerufen, nachdem die zu entfernenden Punkte in mv_horizontal identifiziert worden sind -
// noch vor dem Entfernen. Sonst müsste ich das nachziehen.
// Folgendes gilt: Wenn (i,j) entfernt wird, dann auch der gröbere Punkt. Ich verschicke gemeinsam!
// Was ist die Konsequenz? ev2 wird wie ev gelöscht. Auch für alle Ebenen darüber. Die Punkte darunter werden - Hm.
// Wenn die Punkte ganz verschwinden, dann auf allen Ebenen. Sei es tief oder hoch. Beim Lastausgleich ist das so.
// Man muss dabei nur sehen, dass man nicht loescht, wo es schon nichts mehr gibt!
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe2 1 rang " << rang << " ebene " << ebene << endl;
#endif

    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];

    ev2_ebene = &(ev2[ebene]);

    if(ebene==0)
        {
        for(k=0; k<index; k++)
            {
            hvektor_g1 = g1[k];
            hvektor_g2 = g2[k];
            hvektor_f = f[k];
            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " hvektor_f " << hvektor_f << " j " << j << endl;
#endif
                ev2_ebene->entfernen(hvektor_f, j);
                }
            }
        return;
        }

    pr_i_minus1 = paralleles_rechnen_l[ebene-1];

    for(k=0; k<index; k++)
        {
        hvektor_g1 = g1[k];
        hvektor_g2 = g2[k];
        hvektor_f = f[k];

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " hvektor_f " << hvektor_f << " j " << j << endl;
#endif
                if((pr_i_minus1->feld[hvektor_f<<1][j<<1])<0) // Ist unterster Punkt. Bei Ebene = 0 wuerde immer entfernt.

// D.h., dass in ev2 noch ein Punkt steht.
                    {
                    ev2_ebene->entfernen(hvektor_f, j);
                    }
                }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LAentefe2 2 rang " << rang << " ebene " << ebene << endl;
#endif
    }

void LastAusgleich::einfuegen_ebeneEV_ns(MV_horizontal * mv_horizontal, int ebene)
//  Warum das hier? Und wenn: Muss nicht oben in ev2 eingefügt werden, und unten in ev?
//  Das wird hier nicht abgebildet.

//  Ich verstehe die Routine hier nicht. Die Idee dabei: Wenn ich Gitterpunkte entferne aus ev,
//  dann werden damit auch Punkte aus ev2 entfernt, bzw. selbiges mit Einfügen.

// für ev Einfügung ist es klar: Nur dort und mit der Ebene einfuegen. Zu ev2 ist es komplizierter: für Ebene 0: wird sie nicht
// gebraucht. Nur für einfuegen oben, also ab Ebene 0.
// Für Ebene > 0:
// Falls darunter nichts ist - z.B. bei neuen Punkten - dann dort einfuegen.
// Beim Einfuegen von Punkten gibt es noch eines: ev2 eine Ebene höher wird gelöscht, falls der Punkt existiert.
// Denn es gibt nun einen Punkt darunter.
    {
    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];


    ev_ebene = &(ev[ebene]);

    for(k=0; k<index; k++)
        {
        hvektor_g1 = g1[k];
        hvektor_g2 = g2[k];
        hvektor_f = f[k];


        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            ev_ebene->einfuegen(hvektor_f, j);
            }
        }
    }

// Kommentar: Das ist eigentlich die Funtion einfuegen_ebene_EV2_ns. Da diese Funktion schon definiert ist, s.o., ist diese Funktion
// überflüssig. Sie wäre definitiv für den Nord - Süd - Lastausgleich da - wegen MV_horizontal.
void LastAusgleich::einfuegen_ebeneEV2(MV_horizontal * mv_horizontal, int ebene)
//  Warum das hier? Und wenn: Muss nicht oben in ev2 eingefügt werden, und unten in ev?
//  Das wird hier nicht abgebildet.

//  Ich verstehe die Routine hier nicht. Die Idee dabei: Wenn ich Gitterpunkte entferne aus ev,
//  dann werden damit auch Punkte aus ev2 entfernt, bzw. selbiges mit Einfügen.

// für ev Einfügung ist es klar: Nur dort und mit der Ebene einfuegen. Zu ev2 ist es komplizierter: für Ebene 0: wird sie nicht
// gebraucht. Nur für einfuegen oben, also ab Ebene 0.
// Für Ebene > 0:
// Falls darunter nichts ist - z.B. bei neuen Punkten - dann dort einfuegen.
// Beim Einfuegen von Punkten gibt es noch eines: ev2 eine Ebene höher wird gelöscht, falls der Punkt existiert.
// Denn es gibt nun einen Punkt darunter.
    {
    g1 = mv_horizontal->g1_speichern[ebene];
    g2 = mv_horizontal->g2_speichern[ebene];
    f = mv_horizontal->f_speichern[ebene];
    index = mv_horizontal->indizes[ebene];


    ev2_ebene = &(ev2[ebene]);

    if(ebene == 0)
        {
        for(k=0; k<index; k++)
            {
            hvektor_g1 = g1[k];
            hvektor_g2 = g2[k];
            hvektor_f = f[k];

            for(j=hvektor_g1; j<=hvektor_g2; j++)
                {
                ev2_ebene->einfuegen(hvektor_f, j);
                }
            }
        return;
        }

    pr_i_minus1 = paralleles_rechnen_l[ebene-1];

    for(k=0; k<index; k++)
        {
        hvektor_g1 = g1[k];
        hvektor_g2 = g2[k];
        hvektor_f = f[k];

        for(j=hvektor_g1; j<=hvektor_g2; j++)
            {
            if((pr_i_minus1->feld[hvektor_f<<1][j<<1])<0) // Damit ist (j,hvektor_f) unterster Punkt.
                {
                ev2_ebene->einfuegen(hvektor_f, j);
                }
            }
        }
    }

//////////////////////////////////////////////////////////
///////// Ende einfuegen und entfernen ///////////////////
//////////////////////////////////////////////////////////

void LastAusgleich::packen_nord_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene_ns(&mv_norden, farbmatrix.nord[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch_ns(&mv_norden, farbmatrix.nord[rang]);
        #endif
//  Hier wird auch das Farbenfeld geändert, vgl. oben.
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2009" << endl;
#endif
        }
    }

void LastAusgleich::packen_nord_oben_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2017" << endl;
#endif
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene_ns(&mv_norden, farbmatrix.nord[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch_ns(&mv_norden, farbmatrix.nord[rang]);
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2018" << endl;
#endif
        }
    }

void LastAusgleich::packen_sued_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene_ns(&mv_sueden, farbmatrix.sued[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch_ns(&mv_sueden, farbmatrix.sued[rang]);
        #endif
//  Hier wird auch das Farbenfeld geändert, vgl. oben.
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2009" << endl;
#endif
        }
    }

void LastAusgleich::packen_sued_oben_abschliessen(void)
    {
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2017" << endl;
#endif
        #ifndef AUCH_DYNAMISCH
        paralleles_rechnen_l[i]->entferne_ebene_ns(&mv_sueden, farbmatrix.sued[rang]);
        #else
        paralleles_rechnen_l[i]->entferne_ebene_auch_dynamisch_ns(&mv_sueden, farbmatrix.sued[rang]);
        #endif
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!2018" << endl;
#endif
        }
    }

inline void LastAusgleich::packen_nord_oben_mv(int gesamtlast)
    {
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            packen_nord_oben_mvEVEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
            packen_nord_oben_mvEV2EV2(gesamtlast);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ " << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::packen_nord_oben_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
    }

inline void LastAusgleich::packen_nord_oben_mvEVEV(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev[gitterebene_plus1].bilde_nord_vektoren(gesamtlast, &(mv_norden), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen_ns.durchfuehren(&(mv_norden), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_nord_oben_mv ");
    mv_norden.ausgeben(zeichenkette);
    mv_projektionen_ns.ausgeben(zeichenkette, &mv_norden);
    cout << "Packen 1c rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene_plus1) // Was ist gitterebene_plus1? gitterebene und nach oben.
            {
            entferne_ebeneEV_ns(&mv_norden, i);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

void LastAusgleich::packen_nord_oben_mvEV2EV2(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev2[gitterebene_plus1].bilde_nord_vektoren(gesamtlast, &(mv_norden), gitterebene_plus1);
    // Soweit ist richtig, weil alles darüber entfernt wird.
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen_ns.durchfuehren(&(mv_norden), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_nord_oben_mv ");
    mv_norden.ausgeben(zeichenkette);
    mv_projektionen_ns.ausgeben(zeichenkette, &mv_norden);
    cout << "Packen 1c rang " << rang << endl;
    // Bemerkung: Unterhalb gitterebene_plus1 existieren keine Punkte, überhalb keine Einträge in ev2.
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

inline void LastAusgleich::packen_sued_oben_mv(int gesamtlast)
    {
    switch(ev_typen)
        {
        case TYP_EV:
        case TYP_EVEV:
            packen_sued_oben_mvEVEV(gesamtlast);
            break;
        case TYP_EV2:
        case TYP_EV2EV2:
            packen_sued_oben_mvEV2EV2(gesamtlast);
            break;
        case TYP_EVEV2:
            cout << " Falscher Typ" << endl;
            exit(-1);
            break;
        default:
            cout << "Fehler in LastAusgleich::packen_sued_oben_mv // ev_typen " << ev_typen << " rang " << rang << endl;
            exit(-1);
        }
    }

inline void LastAusgleich::packen_sued_oben_mvEVEV(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev[gitterebene_plus1].bilde_sued_vektoren(gesamtlast, &(mv_sueden), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen_ns.durchfuehren(&(mv_sueden), gitterebene_plus1);
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Code 1: Packen_sued_oben_mv ");
    mv_sueden.ausgeben(zeichenkette);
    mv_projektionen_ns.ausgeben(zeichenkette, &mv_sueden);
    cout << "Packen 1c rang " << rang << endl;
#endif
    for(i=0; i<h_gesamt_variante; i++)
        {
        if(i!=gitterebene_plus1) // Was ist gitterebene_plus1? gitterebene und nach oben.
            {
            entferne_ebeneEV_ns(&mv_sueden, i);
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

void LastAusgleich::packen_sued_oben_mvEV2EV2(int gesamtlast)
    {
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1a rang " << rang << " gesamtlast " << gesamtlast << " gitterebene_plus1 " << gitterebene_plus1 << endl;
#endif
    ev2[gitterebene_plus1].bilde_sued_vektoren(gesamtlast, &(mv_sueden), gitterebene_plus1);
    // Soweit ist richtig, weil alles darüber entfernt wird.
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1b rang " << rang << endl;
#endif
    mv_projektionen_ns.durchfuehren(&(mv_sueden), gitterebene_plus1);
#ifdef AKTUELLE_KOMMENTARE
        {
        strcpy(zeichenkette, " Code 1: Packen_sued_oben_mv ");
        mv_sueden.ausgeben(zeichenkette);
        mv_projektionen_ns.ausgeben(zeichenkette, &mv_sueden);
        }
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen 1c rang " << rang << endl;
    // Bemerkung: Unterhalb gitterebene_plus1 existieren keine Punkte, überhalb keine Einträge in ev2.
    cout << "Packen 1d rang " << rang << endl;
#endif
    }

// Kommentar: Das ist eine unwichtige Ausgabefunktion - zu Debugging - Zwecken.
void LastAusgleich::einpunktausgabe(char * position)
    {
    }

// Kommentar: Das ist eine unwichtige Ausgabefunktion - zu Debugging - Zwecken.
void LastAusgleich::positionsausgabe(char * text)
    {
    }

// Kommentar: Das ist eine unwichtige Ausgabefunktion - zu Debugging - Zwecken.
void LastAusgleich::fgff_info(char * text)
    {
    }

// Kommentar: Das ist eine unwichtige Ausgabefunktion - zu Debugging - Zwecken.
void LastAusgleich::ausgabe_ep_minus_wert(char * text)
    {
#ifdef AKTUELLE_KOMMENTARE
#endif
    }

// Kommentar: Diese Funktion wird nicht gebraucht. Sie ist ein Prototyp für ein gemeinsames Packen nach Westen - von den Punkten,
// die auf der feineren, und solchen die auf der gröberen Ebene gepackt werden. Der entsprechende nicht - Prototyp lautet
// packen_west_mvEV2_mit_oben. Also hier noch keine Kommentare.
void LastAusgleich::prototyp(void)
    {
    int gesamtlast;

    gesamtlast = west_differenz;
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 west EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif
    ev2[gitterebene].bilde_west_vektoren(gesamtlast, &(mv_westen), gitterebene);
    mv_projektionen.projektionen_bis_eine_ebene_hoeher(&(mv_westen), gitterebene);
    gesamtlast = west_differenz_oben;
    ev2[gitterebene+1].bilde_west_vektoren_hinzu(gesamtlast, &(mv_westen), gitterebene+1);
    mv_projektionen.grob_projektionen(&(mv_westen), gitterebene+1);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, " Prototyp : Packen_west_mvEV2 ");
    mv_westen.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Hier werden auf 2 Gitterebene Punkte ausgesucht. Daraus muss dann eine gemeinsame MV_vertikal Instanz beschrieben werden.
// Ansonsten ist diese analog zur Funktion packen_west_mvEV2.
void LastAusgleich::packen_west_mvEV2_mit_oben(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 west EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif

// Kommentar: Zuerst werden die Vektoren der Gitterebene in Bezug auf ev2 gesucht und gelöscht.
    ev2[gitterebene].bilde_west_vektoren(gesamtlast, &(mv_westen), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.

// Kommentar: Dann werden die Projektionen zum feinen Gitter hin komplett, und zum groben Gitter für eine Ebene gemacht.
    mv_projektionen.projektionen_bis_eine_ebene_hoeher(&(mv_westen), gitterebene);
    gesamtlast = west_differenz_oben;
// Kommentar: Dann werden die Vektoren auf der Gitterebene + 1 in BEzug auf ev2 gesucht und gelöscht und dazugepackt. Zu dem,
// was es auf dieser Ebene schon für Vektoren gab.
    ev2[gitterebene+1].bilde_west_vektoren_hinzu(gesamtlast, &(mv_westen), gitterebene+1);
// Kommentar: Dann werden die Grobprojektionen ab dieser Gitterebene komplett gemacht. Man beachte, dass es zum feinen Gitter hin
// keine weiteren Projektionen mehr gibt, weil unter den ev2 - Einträgen keine Gitterpunkte darunter gibt. Das geht also nur mit ev2.
    mv_projektionen.grob_projektionen(&(mv_westen), gitterebene+1);
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Packen_west_mvEV2_mit_oben ");
    mv_westen.ausgeben(zeichenkette);
#endif
// Alles bis auf die Entfernung von EV2 - einschliesslich Farbenfelder übertragen oder entfernen in Gitter -
// erfolgt für ganz mv_westen. Also ist ein zusammenpacken hier kein Problem.
// Da EV2 Punkte aber nur auf einer Ebene existieren, reicht das Entfernen bei bilde_west_vektoren und
// bilde_west_vektoren hinzu völlig aus. Sonst müsste in bilde_west_vektoren hinzu der bisherige Index gespeichert werden,
// um EV - Korrekturen damit durchzuführen. Offenbar wird dies aber nicht gebraucht.
//
// Beim Entpacken dann besteht der Befehl:
//
//              if((pr_i_minus1->feld[j<<1][vvektor_g<<1])<0) // Damit ist (j,vvektor_g) unterster Punkt.
//                    {
//                    ev2_ebene->einfuegen(j, vvektor_g);
//                    }
//
//
// Damit wird auch beim Zusammenpacken EV2 stehts auf der richtigen Ebene eingefügt.
    }

// Kommentar: Analog zu packen_west_mvEV2_mit_oben. Daher keine weiteren Kommentare zu dieser Funktion.
void LastAusgleich::packen_ost_mvEV2_mit_oben(int gesamtlast)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " PackenLA1234 ost EV2EV2 rang " << rang << " gesamtlast " << gesamtlast << " gitterebene " << gitterebene << endl;
#endif
    ev2[gitterebene].bilde_ost_vektoren(gesamtlast, &(mv_osten), gitterebene);
    mv_projektionen.projektionen_bis_eine_ebene_hoeher(&(mv_osten), gitterebene);
    gesamtlast = ost_differenz_oben;
    ev2[gitterebene+1].bilde_ost_vektoren_hinzu(gesamtlast, &(mv_osten), gitterebene+1);
    mv_projektionen.grob_projektionen(&(mv_osten), gitterebene+1);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
//    mv_projektionen.durchfuehren(&(mv_osten), gitterebene);
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Packen_ost_mvEV2_mit_oben ");
    mv_osten.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Analog zu packen_west_mvEV2_mit_oben. Daher keine weiteren Kommentare zu dieser Funktion.
void LastAusgleich::packen_sued_mvEV2_mit_oben(int gesamtlast)
    {
    ev2[gitterebene].bilde_sued_vektoren(gesamtlast, &(mv_sueden), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen_ns.projektionen_bis_eine_ebene_hoeher(&(mv_sueden), gitterebene);
    gesamtlast = sued_differenz_oben;
    ev2[gitterebene+1].bilde_sued_vektoren_hinzu(gesamtlast, &(mv_sueden), gitterebene+1);
    mv_projektionen_ns.grob_projektionen(&(mv_sueden), gitterebene+1);
#ifdef AKTUELLE_KOMMENTARE
        {
        strcpy(zeichenkette, " Packen_sued_mvEV2 unten ");
        mv_sueden.ausgeben(zeichenkette);
        }
#endif
    }

// Kommentar: Analog zu packen_west_mvEV2_mit_oben. Daher keine weiteren Kommentare zu dieser Funktion.
void LastAusgleich::packen_nord_mvEV2_mit_oben(int gesamtlast)
    {
    ev2[gitterebene].bilde_nord_vektoren(gesamtlast, &(mv_norden), gitterebene);
//  Hier wird mv_westen gebildet. Bei #ifdef EV2 entferne Ebene wird aber auch aus ev2 entfernt.
    mv_projektionen_ns.projektionen_bis_eine_ebene_hoeher(&(mv_norden), gitterebene);
    gesamtlast = nord_differenz_oben;
    ev2[gitterebene+1].bilde_nord_vektoren_hinzu(gesamtlast, &(mv_norden), gitterebene+1);
    mv_projektionen_ns.grob_projektionen(&(mv_norden), gitterebene+1);
#ifdef AKTUELLE_KOMMENTARE
    if(rang==4)
        {
        strcpy(zeichenkette, " FFGGHH Norden 4 ");
        mv_norden.ausgeben(zeichenkette);
        }
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Packen_nord_mvEV2_mit_oben ");
    mv_norden.ausgeben(zeichenkette);
#endif
    }

// Kommentar: Dieses ist die Hauptfunktion für die West - Ost - Migration einschließlich Punktauswahl.
void LastAusgleich::lt_durchfuehren2_wo(int rang, int _gitterebene)
// Wo geschieht der reset von mv_osten und mv_westen?

// Kommentar: Es wird nicht -1/4 der unteren Last zur oberen Last addiert. Denn: Durch die aV wird in ev2 automatisch
// die Last der höheren Ebene berücksichtigt.
    {
// Kommentar: Die Timer dienen der Zeitmessung.
    timer_la_anfang.starten();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!1001 rang " << rang << " gitterebene " << _gitterebene << endl;

    cout << "!LA0 // rang " << rang << endl;
    strcpy(zeichenkette, "Anfang");
    code103(zeichenkette);
#endif
#ifdef AAGG
    cout << " AAGG Anfang wo_lastausgleich " << rang << endl;
#endif
    timer_la_gesamt.starten();
// Kommentar: Die Gitterebene wird gespeichert, sowohl in dieser Klasse als auch der Klasse WerteVerschicken.
    gitterebene = _gitterebene;
    werte_verschicken.gitterebene = gitterebene;
    #ifdef EV2
    gitterebene_plus1 = gitterebene + 1;
    #endif

// Kommentar: Die Lasttransferwerte werden in der Klasse Lastmengen gespeichert. Eigentlich spielt die Klasse Lastmengen in der aktuellen
// Version des Programmes nur eine Rolle außerhalb dieser Klasse. Aber Teile des Programms greifen auf Lastmengen - Variablen zu.
    lastmengen.west_differenz = west_differenz;
    lastmengen.ost_differenz = ost_differenz;

#ifdef AUSGABEN_LASTAUSGLEICH_NEU
    cout << " VWXY 0 rang " << rang << " Am Anfang west_diff " << west_differenz << " west_diff oben " << west_differenz_oben << " ost_diff " << ost_differenz << " ost_diff oben " << ost_differenz_oben << endl;
#endif

#ifdef TYP_PPOOMM
    if(rang==2)
        {
        cout << " PPOOMM west_diff " << west_differenz << " ost_diff " << ost_differenz << " ebene " << gitterebene << endl;
        }
#endif
// Fehlerkontrolle für mehr Last da als übertragen.

#ifdef AUSGABEN_LASTAUSGLEICH_NEU
    cout << " VWXY 1 rang " << rang << endl;
#endif

// Kommentar: Es wird bestimmt, wieviel Gitterlast der Kern verschicken kann.
    if(ev2_gilt == true)
        {
        eigene_last = ev2[gitterebene].gesamtpunkteanzahl;
        }
    else
        {
        eigene_last = ev[gitterebene].gesamtpunkteanzahl;
        }

#ifdef AUSGABEN_LASTAUSGLEICH_NEU
    cout << " VWXY 2 rang " << rang << endl;
#endif
// Kommentar: Wenn mehr Last verschickt werden soll, als da ist, gebe eine Fehlermeldung aus.
    if((west_differenz>eigene_last)||(ost_differenz>eigene_last)||(west_differenz+ost_differenz>eigene_last)) // geändert am 14.8.2015
        {
        cout << " Fehler: Fehler : zu viel Last muss transferiert werden rang " << rang;
        cout << " eigene_last " << eigene_last << " west_diff " << west_differenz << " ost_diff " << ost_differenz << endl;
        exit(-1);
        }

// Kommentar: Hier werden mv_westen und mv_osten resettet, und sende_west und sende_ost und empfange_west und empfange_ost gesetzt.
    lt_vorab(); // Hier werden mv_westen und mv_osten resettet, und sende_west und sende_ost und empfange_west und empfange_ost
                // gesetzt.
#ifdef AUSGABEN_VORTRAG
    cout << " rang " << rang << " west-differenz " << west_differenz << " ost-differenz " << ost_differenz;
#endif

#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " AABBCC Lasten Differenzen rang " << rang << " west-differenz " << west_differenz << " ost-differenz " << ost_differenz;
    cout << " west-differenz-oben " << west_differenz_oben << " ost-differenz-oben " << ost_differenz_oben << endl;
    cout << " rang " << rang << " ew " << empfange_west << " eo " << empfange_ost << " sw " << sende_west << " so " << sende_ost << " NBI_horizontal " << NBI_horizontal << endl;
    cout << "!LA05 // rang " << rang << endl;
#endif
#endif

// Kommentar: Wenn von Westen Last empfangen werden soll, dann setze das Flag für den Empfang von mvf - Information und den Empfang der Werte,
// und initiiere den Empfang dieser Informationen.
    if(empfange_west==true)
        {
        empfange_west_mvf = true;
        empfange_west_werte = true;

        la_kommunikationen.initiiere_empfangen_west_mvf(&mvf_buffer_westen);
        la_kommunikationen.initiiere_empfangen_west_werte(&werte_buffer_westen);
        }
    else
        {
// Kommentar: Ansonsten setze diese Empfangsflags auf false.
        empfange_west_mvf = false;
        empfange_west_werte = false;
        }

// Kommentar: Im Falle des reziproken Lastausgleichs.
        if(ev_dim == 2)
            {
// Kommentar: Wenn nicht unten, aber oben gesendet werden soll.
            if((west_differenz <= 0)&&(west_differenz_oben > 0))
// POS ABC
                {
// Kommentar: Setze die Flags fürs obige Senden auf true ...
                sende_west_mvf_oben = true;
                sende_west_werte_oben = true;
                sende_west_oben = true;

#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Packen 0 rang " << rang << endl;
#endif
// Kommentar: ... und mache den ersten Packen - Befehl fürs Senden oben, wobei der Lasttransferwert übergeben wird.
                packen_west_oben_mv(west_differenz_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Packen 1 rang " << rang << endl;
                cout << "Packen 2 rang " << rang << endl;
#endif
                }
// Ansonsten setze die Flags fürs Senden oben auf false. Dann kann aber, wenn die west_differenz > 0 und west_differenz_oben > 0
// sind, immer noch Last mitverschickt werden - aber dann über packen_west_mv.
            else
                {
                sende_west_mvf_oben = false;
                sende_west_werte_oben = false;
                sende_west_oben = false;
                }
            }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!1005 rang " << rang << endl;

    cout << "Nach Empfangen_west" << endl;
#endif

// Kommentar: Nun dasselbe wie eben für Westen für Osten. Es wird weiterkommentiert, wenn dieser Abschnitt zu Ende ist.
    if(empfange_ost==true)
        {
        empfange_ost_mvf = true;
        empfange_ost_werte = true;

        la_kommunikationen.initiiere_empfangen_ost_mvf(&mvf_buffer_osten);
        la_kommunikationen.initiiere_empfangen_ost_werte(&werte_buffer_osten);

        }
    else
        {
        empfange_ost_mvf = false;
        empfange_ost_werte = false;
        if(ev_dim == 2)
            {
            sende_ost_mvf_oben = false;
            sende_ost_werte_oben = false;
            sende_ost_oben = false;
            }
        }

        if(ev_dim == 2)
            {
            if((ost_differenz <= 0) &&(ost_differenz_oben > 0))
// POS ABC
                {
                sende_ost_mvf_oben = true;
                sende_ost_werte_oben = true;
                sende_ost_oben = true;

                packen_ost_oben_mv(ost_differenz_oben);
                }

            else
                {
                sende_ost_mvf_oben = false;
                sende_ost_werte_oben = false;
                sende_ost_oben = false;
                }
            }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach empfangen_ost" << endl;

    cout << "!1006 rang " << rang << endl;
#endif

// Kommentar: Wenn das sende_west - Flag true ist, werden die Flags fürs Senden der mvf - Buffer - Information und fürs
// Senden der Werte auf true gesetzt. Anschließend werden entsprechend der Lasttransfermenge Gitterpunkte nach West auf
// der unteren Ebene gepackt.
    if(sende_west==true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1006a rang " << rang << endl;
#endif
        sende_west_mvf = true;
        sende_west_werte = true;

        packen_west_mv(lastmengen.west_differenz);
        }
// Kommentar: Ansonsten werden die Sende Flags von eben auf false gesetzt.
    else
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1006b rang " << rang << endl;
#endif
        sende_west_mvf = false;
        sende_west_werte = false;
        }

// Kommentar: Wenn ein reziproker Lastausgleich erfolgen soll, man also einen doppelten Lastausgleich hat.
        if(ev_dim == 2)
            {
// Kommentar: Soll oben, aber nicht unten Last empfangen werden.
            if((west_differenz >= 0) && (west_differenz_oben < 0))
// POS ABC
                {
// Kommentar: Dann setze die Empfangsflags nach Westen für oben auf true, und initiiere den Empfang von mvf - und Werte - Informationen.
                empfange_west_mvf_oben = true;
                empfange_west_werte_oben = true;

                la_kommunikationen.initiiere_empfangen_west_mvf_oben(&mvf_buffer_westen_oben);
                la_kommunikationen.initiiere_empfangen_west_werte_oben(&werte_buffer_westen_oben);
                }
            else
                {
// Kommentar: Ansonsten setze die obigen Empfangsflags nach Westen auf false.
                empfange_west_mvf_oben = false;
                empfange_west_werte_oben = false;
                }
            }
#ifdef AKTUELLE_KOMMENTARE
    if((sende_west==true)&&(rang==13))
        {
        strcpy(zeichenkette, " Packen_west nach packen_mv bzw. empfange mv_oben ");
        mv_westen.ausgeben(zeichenkette);
        }
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach senden_west" << endl;
    cout << "!1007 // rang " << rang << endl;
#endif

// Kommentar: Nach dem Stoppen läuft der Timer erst einmal nicht mehr weiter. Allerdings wird er gleich wieder danach gestartet.
    timer_la_anfang.stoppen();
    timer_la_senden.starten();

// Kommentar: Jetzt geschieht dasselbe wie eben für Westen für Osten. Am Ende des Blocks für die Kommunikationen nach Osten
// wird dann weiter kommentiert.
    if(sende_ost==true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1007a // rang " << rang << endl;
#endif
        sende_ost_mvf = true;
        sende_ost_werte = true;



#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1007b Vor packen_ost lastmengen_differenz" << lastmengen.ost_differenz << endl;
#endif
        packen_ost_mv(lastmengen.ost_differenz);
        }
    else
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1007z // rang " << rang << endl;
#endif
        sende_ost_mvf = false;
        sende_ost_werte = false;
        }

        if(ev_dim == 2)
            {
            if((ost_differenz >= 0)&&(ost_differenz_oben < 0))
                {
                empfange_ost_mvf_oben = true;
                empfange_ost_werte_oben = true;

                la_kommunikationen.initiiere_empfangen_ost_mvf_oben(&mvf_buffer_osten_oben);
                la_kommunikationen.initiiere_empfangen_ost_werte_oben(&werte_buffer_osten_oben);
                }
            else
                {
                empfange_ost_mvf_oben = false;
                empfange_ost_werte_oben = false;
                }
            }

// Kommentar: Hier wird der LA - Timer gestoppt.
    timer_la_senden.stoppen();

#ifdef AKTUELLE_KOMMENTARE
    if((sende_west==true)&&(rang==13))
        {
        strcpy(zeichenkette, " mv_westen nach packen_osten ");
        mv_westen.ausgeben(zeichenkette);
        }
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA4 // rang " << rang << endl;

    strcpy(zeichenkette, "LA4");
    test003(zeichenkette);

    cout << "Nach der Empfangs- / Sendekommunikation " << endl;
#endif

// Kommentar: Die Flags für sende_ost und sende_west werden gespeichert.
    sende_ost_speichern = sende_ost;
    sende_west_speichern = sende_west;

    timer_la_nachkorrektur.starten();
    timer_la_nachkorrektur1.starten();

// Kommentar: Die Nachkorrektur wird vorbereitet, indem ihre Variable sende_ost true ist, wenn unten oder oben nach Osten gesendet wird.
// Analog für die Variable sende_west.
    nachkorrektur.sende_ost = sende_ost;
    nachkorrektur.sende_west = sende_west;

#ifdef AUSGABEN_VORTRAG
    cout << " 80386 sende_west " << sende_west << " sende_ost " << sende_ost << " rang " << rang << endl;
#endif

    if(sende_ost_oben == true)
        {
        nachkorrektur.sende_ost = true;
        }

    if(sende_west_oben == true)
        {
        nachkorrektur.sende_west = true;
        }

//  Wichtiger Punkt: Hier kommen die Flags hin die bestimmen, ob nach Westen bzw. Osten gesendet wird oder nicht.
//  Sonst funktioniert Nachkorrektur::logisch_sammeln nicht.

// Kommentar: Die empfange Flags der Nachkorrektur werden von den entsprechenden Flags dieser Klasse abgeleitet.
    nachkorrektur.empfange_ost = empfange_ost;
    nachkorrektur.empfange_west = empfange_west;

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach Kopie nach der Nachkorrektur " << endl;


    cout << "!LA5 // rang " << rang << endl;
    strcpy(zeichenkette, "LA5");
    test003(zeichenkette);
    cout << "ist_nachbar ";

    for(i=0; i<groesse; i++)
        {
        cout << ist_nachbar_zaehler_ml[i] << " ";
        }
    cout << " // rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "Vor Nachkorrektur ");
    fgff_info(zeichenkette);
#endif
// Kommentar: Hier werden Timer für die Zwischenkorrektur gestartet.
    nachkorrektur.log_ent_tv.starten2();
    timer_la_nachkorrektur1a.starten();
// Zuerst werden die Sendebuffer der Nachkorrektur zurückgesetzt - vgl. oben.
    nachkorrektur_durchfuehren_sendebuffer_bestimmen();
    timer_la_nachkorrektur1a.stoppen();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5a // rang " << rang << " lt 2 wo 10211 " << endl;
    strcpy(zeichenkette, "LA5a");
    test003(zeichenkette);
#endif
    //  Evtl. zu ersetzen durch aktiviere_ist_nachbar.
    // Warum dieser Befehl NACH der ist_nachbar Ausgabe?
    timer_la_nachkorrektur1b.starten();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5aa wo // rang " << rang << endl;
    strcpy(zeichenkette, "LA5aa");
    test003(zeichenkette);
#endif

// Kommentar: Dann werden die Sendebuffer bestimmt - wobei auch senden und empfangen initiiert werden.
    nachkorrektur.logisch_sammeln(); // Das initiiert auch senden und empfangen !

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5b // rang " << rang << endl;
    strcpy(zeichenkette, "LA5b");
    test003(zeichenkette);
#endif

// Kommmentar: Damit ist der erste Schritt der Zwischenkorrektur abgeschlossen. Die Timer werden gestoppt.
    timer_la_nachkorrektur1b.stoppen();
    timer_la_nachkorrektur1.stoppen();
    timer_la_nachkorrektur.stoppen();
#ifdef AKTUELLE_KOMMENTARE
    if((sende_west==true)&&(rang==13))
        {
        strcpy(zeichenkette, " Packen_west vor den Packen Routinen ");
        mv_westen.ausgeben(zeichenkette);
        }
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "Zwischen Nachkorrektur ");
    fgff_info(zeichenkette);
#endif
    timer_la_packen.starten();
//////////////////////////////////////////////////////////////////
///////////////  Packen  /////////////////////////////////////////
//////////////////////////////////////////////////////////////////
        {

// Kommentar: Im Falle, dass oben nach Westen gesendet wird, wird der 2.te Teil des Packens, packen_abschließen,
// für Westen und Oben, durchgeführt.
        if(ev_dim == 2)
            {
            if((west_differenz<=0)&&(west_differenz_oben > 0))
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " !LA5by Vor packen_west_oben_abschliessen rang " << rang << endl;
#endif
                packen_west_oben_abschliessen(); // Warum nicht packen_west_oben_ieS?
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " !LA5bz Nach packen_west_oben_abschliessen rang " << rang << endl;
#endif
                }
            }
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5c // rang " << rang << " 9967 " << endl;
    strcpy(zeichenkette, "LA5c");
    test003(zeichenkette);
#endif

        {

// Kommentar: Mache dann dasselbe für den Osten.
        if(ev_dim == 2)
            {
            if((ost_differenz <= 0)&&(ost_differenz_oben > 0))
                {
#ifdef AKTUELLE_KOMMENTARE
                cout << " Ost Differenzen rang " << rang << " od " << ost_differenz << " od_oben " << ost_differenz_oben << endl;
#endif
                packen_ost_oben_abschliessen(); // Warum nicht packen_west_oben_ieS?
                }
            }
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5d // rang " << rang << endl;
    strcpy(zeichenkette, "LA5d");
    test003(zeichenkette);
#endif

// Kommentar: Falls nach Westen unten gesendet wird, machen auch Packen - Abschließen nach Westen für die untere Ebene.
    if(sende_west==true)
        {
        packen_west_abschliessen(); // muss immer nach packen_west_mv erfolgen. Aber vielleicht vor dem Warten machen.
                                    // pwa ist nämlich Buffer - unabhängig.
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5e // rang " << rang << endl;
    strcpy(zeichenkette, "LA5e");
    test003(zeichenkette);
#endif

// Kommentar: Und dann dasselbe für den Osten. Damit wurden alle möglichen packen - abschließen gemacht - während die
// Zwischenkorrektur - Kommunikation unterwegs ist, die möglich sind.
    if(sende_ost==true)
        {
        packen_ost_abschliessen();  // muss immer nach packen_west_mv erfolgen. Aber vielleicht vor dem Warten machen.
                                    // poa ist nämlich Buffer - unabhängig.
        }

#ifdef AAHH
    test_la1("10288");
#endif

    // Bemerkung:   ist_nachbar aendert sich mit der Nachkorrektur. Das muss trotzdem korrekt bleiben.
    //              Das ist zu überlegen!
//  Bemerkung: mv_westen und mv_osten, obwohl vielleicht überhaupt nicht gesendet wird?
//  mv_westen und mv_osten habe ich momentan doppelt belegt. Ich verstehe logisch_sammeln
//  noch nicht!
//  Bemerkung: Man braucht mv_westen, mv_osten, ist_nachbar und die Flags senden_west und senden_ost.
//  Wie komme ich an die Flags?

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach logisch sammeln " << endl;
    cout << "!LA6 wo // rang " << rang << endl;
#endif

// Kommentar: Jetzt wird die Zwischenkorrektur fortgführt.
    timer_la_packen.stoppen();
    timer_la_nachkorrektur.starten();
    timer_la_nachkorrektur2.starten();
    timer_la_nachkorrektur2a.starten();

#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "Vor Nachkorrektur entpacken");
    code103(zeichenkette);
#endif

// Kommentar: Zuerst wird gecheckt, ob alle Nachrichten erfolgreich verschickt worden sind.
    while(nachkorrektur.test_senden()==false)
        {
        ;
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA6a wo nach test_senden rang " << rang << endl;
#endif

    timer_la_nachkorrektur2a.stoppen();
    timer_la_nachkorrektur2b.starten();

    nachkorrektur.log_ent_tv.starten();

// Kommentar: Und dann wird gewartet und entpackt, bis für alle bzgl. der Multi - Level - Kerntopologie benachbarten Gitterpunkte
// die Zwischenkorrektur durchgeführt worden ist.
    while(nachkorrektur.logisch_entpacken()==false)
        {
        ;
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "Nach Nachkorrektur entpacken");
    code103(zeichenkette);
    cout << "!LA6b wo nach test_senden rang " << rang << endl;
#endif

// Kommentar: Dann werden die Timer abgeschaltet.
    timer_la_nachkorrektur2b.stoppen();
    timer_la_nachkorrektur2.stoppen();
    timer_la_nachkorrektur.stoppen();
    timer_la_senden_ies.starten();

#ifdef AAHH
    test_la1("10328");
#endif

#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "Nach Nachkorrektur ");
    fgff_info(zeichenkette);
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA7 // rang " << rang << endl;
    strcpy(zeichenkette, "LA7");
    test003(zeichenkette);
    cout << "Nach nachkorrektur.logisch_entpacken " << endl;
#endif
    // Bei lt_durchfuehren 2 wird logisch entpackt vor(!) dem eigentlichen Lasttransfer.

// Kommentar: Nun geschieht im Falle von sende_west_oben = true packen ieS für Westen und oben, nebst des Initiieren des
// Verschickens der mvf - Information, gefolgt vom packen der Werte nebst der Initiierung ihres Verschickens.
    if(sende_west_oben == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << " !LA7 gemeinsam rang " << rang << endl;
            cout << "!LA7a1 rang " << rang;
#endif
            packen_west_oben_ieS(); // Nach packen_west_oben_abschliessen?
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a2 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_west_mvf_oben(&mvf_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a3 rang " << rang;
#endif
            werte_buffer_westen_oben.index = 0;
            werte_verschicken.packen(&mv_westen, &werte_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a4 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_west_werte_oben(&werte_buffer_westen_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a5 rang " << rang;
#endif
        }

// Mache dasselbe für Osten und oben.
    if(sende_ost_oben == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << " !LA7 gemeinsam rang " << rang << endl;
            cout << "!LA7b1 rang " << rang;
#endif
            packen_ost_oben_ieS();
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b2 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_ost_mvf_oben(&mvf_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b3 rang " << rang;
#endif
            werte_buffer_osten_oben.index = 0;
            werte_verschicken.packen(&mv_osten, &werte_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b4 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_ost_werte_oben(&werte_buffer_osten_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b5 rang " << rang;
#endif
        }

// Kommentar: Ist das sende_west flag true, dann mache dasselbe auch für den Westen und unten.
    if(sende_west_speichern == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !LA7 gemeinsam rang " << rang << endl;
        cout << "!LA7c1 rang " << rang;
#endif
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, " Packen_west_mvEV2_vor_ieS ");
        mv_westen.ausgeben(zeichenkette);
#endif
        packen_west_ieS();
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c2 rang " << rang;
#endif
//  Was ist mit der Ebene, und wie wird mvf_buffer_westen geschrieben?
        la_kommunikationen.initiiere_senden_west_mvf(&mvf_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c3 rang " << rang;
#endif
        werte_buffer_westen.index = 0;
        werte_verschicken.packen(&mv_westen, &werte_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c4 rang " << rang;
#endif
        la_kommunikationen.initiiere_senden_west_werte(&werte_buffer_westen);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c5 rang " << rang;
#endif
        }

// Kommentar: Und wieder dasselbe für den Osten und unten.
    if(sende_ost_speichern == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !LA7 gemeinsam rang " << rang << endl;
        cout << "!LA7d1 rang " << rang;
#endif
        packen_ost_ieS();
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d2 rang " << rang;
#endif
        la_kommunikationen.initiiere_senden_ost_mvf(&mvf_buffer_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d3 rang " << rang;
#endif
        werte_buffer_osten.index = 0;
        // Ob das so stimmt? Aber: Der Werte_Buffer muss ja resettet werden!
        werte_verschicken.packen(&mv_osten, &werte_buffer_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d4 rang " << rang;
#endif
        la_kommunikationen.initiiere_senden_ost_werte(&werte_buffer_osten);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d5 rang " << rang;
#endif
        }

    timer_la_senden_ies.stoppen();
    timer_la_test_und_entpacken.starten();

#ifdef AAHH
    test_la1("10459");
#endif

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " !LA8 // rang " << rang << endl;
    strcpy(zeichenkette, "LA8");
    test003(zeichenkette);

// Kommentar: Zu Debugging - Zwecken werden - optional - alle Flags ausgegeben.
    cout << " swm " << sende_west_mvf << " sww " << sende_west_werte;
    cout << " som " << sende_ost_mvf << " sow " << sende_ost_werte;
    cout << " ewm " << empfange_west_mvf << " eww " << empfange_west_werte;
    cout << " eom " << empfange_ost_mvf << " eow " << empfange_ost_werte << endl;

    if(ev_dim == 2)
        {
        cout << " VWXY 3 rang " << rang << " west_diff " << west_differenz << " west_diff oben " << west_differenz_oben << " ost_diff " << ost_differenz << " ost_diff oben " << ost_differenz_oben;
        cout << " swmo " << sende_west_mvf_oben << " swwo " << sende_west_werte_oben;
        cout << " somo " << sende_ost_mvf_oben << " sowo " << sende_ost_werte_oben;
        cout << " ewmo " << empfange_west_mvf_oben << " ewwo " << empfange_west_werte_oben;
        cout << " eomo " << empfange_ost_mvf_oben << " eowo " << empfange_ost_werte_oben << endl;
        }
#endif

//  2. Schritt vom Lastausgleich: Flag Abfrage: Ist man fertig?


#ifdef AUSGABEN_LASTAUSGLEICH_NEU
    cout << " VWXY 4 rang " << rang << endl;
#endif

#ifdef AAGG
            cout << " AAGG wo_lastausgleich vor test_und_entpacken " << rang << endl;
#endif
// Kommentar: Im Falle des einfachen Lastausgleichs werden die Sende und Empfang - Flags für mvf - Information und Werte,
// sowie für Osten und Westen abgefragt, ob dafür noch etwas zu tun ist.
    if(ev_dim == 1)
        {
        while(( sende_west_mvf || sende_west_werte ||
                sende_ost_mvf || sende_ost_werte ||
                empfange_west_mvf || empfange_west_werte ||
                empfange_ost_mvf || empfange_ost_werte)==true)
                {
// Kommentar: Falls ja, wird die Funktion test_und_entpacken aufgerufen, die wartet, entpackt und die Flags auf false setzt.
                test_und_entpacken();
                }
        }

// Kommentar: Im Falle des reziproken Lastausgleichs werden dieselben Flags für unten und oben überprüft, ob da noch was zu tun ist.
    else
        {
        while(( sende_west_mvf || sende_west_werte ||
                sende_ost_mvf || sende_ost_werte ||
                empfange_west_mvf || empfange_west_werte ||
                empfange_ost_mvf || empfange_ost_werte ||
                sende_west_mvf_oben || sende_west_werte_oben ||
                sende_ost_mvf_oben || sende_ost_werte_oben ||
                empfange_west_mvf_oben || empfange_west_werte_oben ||
                empfange_ost_mvf_oben || empfange_ost_werte_oben)==true)
//  3.  Schritt: Test auf Kommunikation fertig. Resultierendes Flag setzen und beim Empfangen entpacken.
//      Damit ist der Lastausgleich durchgefuehrt.
                {
// Kommentar: Falls ja, wird die Funktion test_und_entpacken aufgerufen, die wartet, entpackt und die Flags auf false setzt.
                test_und_entpacken();
                }
        }

#ifdef AUSGABEN_LASTAUSGLEICH_NEU
    cout << " 3 Fertig mit Migration rang " << rang << endl;
#endif

    timer_la_test_und_entpacken.stoppen();
    timer_la_gesamt.stoppen();
//////////////////////////////////////////////////////////////
/////// Die Punkte wurden gepackt, verschickt, entpackt //////
//////////////////////////////////////////////////////////////
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "LA9");
    test003(zeichenkette);
    cout << " !LA9 ow rang " << rang << endl;
#endif
#ifdef AAHH
    test_la1("10523");
#endif
    }

// Kommentar: Hier kommt der Nord - Süd Lastausgleich ran. Der geschieht analog zum Ost - West - Lastausgleich. Daher hier keine weiteren Kommentare.
void LastAusgleich::lt_durchfuehren2_ns(int _rang, int _gitterebene)
// Wo geschieht der reset von mv_osten und mv_westen?
    {
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "ganz_am Anfang");
    ausgabe_ep_minus_wert(zeichenkette);
#endif
    timer_la_anfang.starten();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!1001 rang " << rang << " gitterebene " << _gitterebene << endl;
    cout << " !LA0 ns // rang " << rang << endl;
#endif
    timer_la_gesamt.starten();
    gitterebene = _gitterebene;
    werte_verschicken.gitterebene = gitterebene;
    #ifdef EV2
    gitterebene_plus1 = gitterebene + 1;
    #endif

    lt_vorab_ns(); // Hier werden mv_westen und mv_osten resettet, und sende_west und sende_ost und empfange_west und empfange_ost
                // gesetzt.

    if(ev2_gilt == true)
        {
        eigene_last = ev2[gitterebene].gesamtpunkteanzahl;
        }
    else
        {
        eigene_last = ev[gitterebene].gesamtpunkteanzahl;
        }

#ifdef AKTUELLE_KOMMENTARE
    cout << " rang " << rang << " nord-differenz " << nord_differenz << " sued-differenz " << sued_differenz;
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " rang " << rang << " nord-differenz " << nord_differenz << " sued-differenz " << sued_differenz;
    cout << " nord-differenz-oben " << nord_differenz_oben << " sued-differenz-oben " << sued_differenz_oben << " eigene_last " << eigene_last << " gitterebene " << gitterebene << endl;

    cout << "!LA05 ns // rang " << rang << endl;
#endif
#endif

    if((nord_differenz>eigene_last)||(sued_differenz>eigene_last)||(nord_differenz+sued_differenz>eigene_last)) // Korrektur vom 14.8.2015
        {
        cout << " Fehler: Fehler : zu viel Last muss transferiert werden in ns rang " << rang;
        cout << " eigene_last " << eigene_last << " nord_diff " << nord_differenz << " sued_diff " << sued_differenz << endl;
        exit(-1);
        }

    if(empfange_nord==true)
        {
        empfange_nord_mhf = true;
        empfange_nord_werte = true;

        la_kommunikationen.initiiere_empfangen_nord_mhf(&mhf_buffer_norden);
        la_kommunikationen.initiiere_empfangen_nord_werte(&werte_buffer_norden);

        }
    else
        {
        empfange_nord_mhf = false;
        empfange_nord_werte = false;
        }

        if(ev_dim == 2)
            {
            if((nord_differenz <= 0)&&(nord_differenz_oben > 0))
                {
                sende_nord_mhf_oben = true;
                sende_nord_werte_oben = true;
                sende_nord_oben = true;

#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Packen 0 rang " << rang << endl;
#endif
                packen_nord_oben_mv(nord_differenz_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << "Packen 1 rang " << rang << endl;
                cout << "Packen 2 rang " << rang << endl;
#endif
                }
            else
                {
                sende_nord_mhf_oben = false;
                sende_nord_werte_oben = false;
                sende_nord_oben = false;
                }
            }
//        #endif

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!1005 rang " << rang << endl;

    cout << "Nach Empfangen_nord" << endl;
#endif

    if(empfange_sued==true)
        {
        empfange_sued_mhf = true;
        empfange_sued_werte = true;

        la_kommunikationen.initiiere_empfangen_sued_mhf(&mhf_buffer_sueden);
        la_kommunikationen.initiiere_empfangen_sued_werte(&werte_buffer_sueden);
        }
    else
        {
        empfange_sued_mhf = false;
        empfange_sued_werte = false;
        }
        if(ev_dim == 2)
            {
            if((sued_differenz <= 0)&&(sued_differenz_oben > 0))
                {
                sende_sued_mhf_oben = true;
                sende_sued_werte_oben = true;
                sende_sued_oben = true;

                packen_sued_oben_mv(sued_differenz_oben);
                }

            else
                {
                sende_sued_mhf_oben = false;
                sende_sued_werte_oben = false;
                sende_sued_oben = false;
                }
            }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach empfangen_sued" << endl;

    cout << "!1006 rang " << rang << endl;
#endif

    if(sende_nord==true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !1006a ns rang " << rang << endl;
#endif
        sende_nord_mhf = true;
        sende_nord_werte = true;

#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "Vor packen_nord_mv");
        ausgabe_ep_minus_wert(zeichenkette);
#endif
        packen_nord_mv(nord_differenz);
#ifdef AKTUELLE_KOMMENTARE
        strcpy(zeichenkette, "Nach packen_nord_mv");
        ausgabe_ep_minus_wert(zeichenkette);
#endif
        }

    else
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1006b rang " << rang << endl;
#endif
        sende_nord_mhf = false;
        sende_nord_werte = false;
        }

        if(ev_dim == 2)
            {
            if((nord_differenz >= 0)&&(nord_differenz_oben < 0))
                {
                empfange_nord_mhf_oben = true;
                empfange_nord_werte_oben = true;

                la_kommunikationen.initiiere_empfangen_nord_mhf_oben(&mhf_buffer_norden_oben);
                la_kommunikationen.initiiere_empfangen_nord_werte_oben(&werte_buffer_norden_oben);
                }
            else
                {
                empfange_nord_mhf_oben = false;
                empfange_nord_werte_oben = false;
                }
            }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach senden_nord" << endl;
    cout << "!1007 // rang " << rang << endl;
#endif

    timer_la_anfang.stoppen();
    timer_la_senden.starten();

    if(sende_sued==true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1007a // rang " << rang << endl;
#endif
        sende_sued_mhf = true;
        sende_sued_werte = true;


#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1007b Vor packen_sued lastmengen_differenz" << sued_differenz << endl;
#endif
        packen_sued_mv(sued_differenz);
        }
    else
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!1007z // rang " << rang << endl;
#endif
        sende_sued_mhf = false;
        sende_sued_werte = false;
        }
        if(ev_dim == 2)
            {
            if((sued_differenz >= 0)&&(sued_differenz_oben < 0))
                {
                empfange_sued_mhf_oben = true;
                empfange_sued_werte_oben = true;

                la_kommunikationen.initiiere_empfangen_sued_mhf_oben(&mhf_buffer_sueden_oben);
                la_kommunikationen.initiiere_empfangen_sued_werte_oben(&werte_buffer_sueden_oben);
                }
            else
                {
                empfange_sued_mhf_oben = false;
                empfange_sued_werte_oben = false;
                }
            }

    timer_la_senden.stoppen();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " !LA4 ns // rang " << rang << endl;
    strcpy(zeichenkette, "LA4");
    test003(zeichenkette);

    cout << "Nach der Empfangs- / Sendekommunikation " << endl;
#endif

    sende_sued_speichern = sende_sued;
    sende_nord_speichern = sende_nord;

#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "Vor Nachkorrektur");
    ausgabe_ep_minus_wert(zeichenkette);
#endif

    timer_la_nachkorrektur.starten();
    timer_la_nachkorrektur1.starten();

    nachkorrektur.sende_sued = sende_sued;
    nachkorrektur.sende_nord = sende_nord;

#ifdef AKTUELLE_KOMMENTARE
    cout << " 80286 sende_nord " << sende_nord << " sende_sued " << sende_sued << " rang " << rang << endl;
#endif

    if(sende_sued_oben == true)
        {
        nachkorrektur.sende_sued = true;
        }

    if(sende_nord_oben == true)
        {
        nachkorrektur.sende_nord = true;
        }

//  Wichtiger Punkt: Hier kommen die Flags hin die bestimmen, ob nach Westen bzw. Osten gesendet wird oder nicht.
//  Sonst funktioniert Nachkorrektur::logisch_sammeln nicht.

    nachkorrektur.empfange_sued = empfange_sued;
    nachkorrektur.empfange_nord = empfange_nord;

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach Kopie nach der Nachkorrektur " << endl;


    cout << " !LA5 ns // rang " << rang << endl;
    strcpy(zeichenkette, "LA5");
    test003(zeichenkette);
    cout << "ist_nachbar ";

    for(i=0; i<groesse; i++)
        {
        cout << ist_nachbar_zaehler_ml[i] << " ";
        }
    cout << " // rang " << rang << endl;
#endif
    nachkorrektur.log_ent_tv.starten2();
    timer_la_nachkorrektur1a.starten();
    nachkorrektur_durchfuehren_sendebuffer_bestimmen();
    timer_la_nachkorrektur1a.stoppen();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5a ns // rang " << rang << " 10929 " << endl;
    strcpy(zeichenkette, "LA5a");
    test003(zeichenkette);
#endif
    //  Evtl. zu ersetzen durch aktiviere_ist_nachbar.
    // Warum dieser Befehl NACH der ist_nachbar Ausgabe?
    timer_la_nachkorrektur1b.starten();

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5aaa ns // rang " << rang << " 10940 " << endl;
#endif

    nachkorrektur.logisch_sammeln_ns(); // Das initiiert auch senden und empfangen !

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5aab ns // rang " << rang << " 10946 " << endl;
#endif

    timer_la_nachkorrektur1b.stoppen();
    timer_la_nachkorrektur1.stoppen();
    timer_la_nachkorrektur.stoppen();

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5aa ns // rang " << rang << " 10945 " << endl;
#endif

    timer_la_packen.starten();
//////////////////////////////////////////////////////////////////
///////////////  Packen  /////////////////////////////////////////
//////////////////////////////////////////////////////////////////
        {
        if(ev_dim == 2)
            {
            if((nord_differenz <= 0)&&(nord_differenz_oben > 0))
                {
                packen_nord_oben_abschliessen(); // Warum nicht packen_west_oben_ieS?
                }
            }
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5ab ns // rang " << rang << " 10967 " << endl;
#endif

        {
        if(ev_dim == 2)
            {
            if((sued_differenz <= 0)&&(sued_differenz_oben > 0))
                {
                packen_sued_oben_abschliessen(); // Warum nicht packen_west_oben_ieS?
                }
            }
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5ac ns // rang " << rang << " 10985 " << endl;
#endif

    if(sende_nord==true)
        {
        packen_nord_abschliessen(); // muss immer nach packen_west_mv erfolgen. Aber vielleicht vor dem Warten machen.
                                    // pwa ist nämlich Buffer - unabhängig.
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5ad ns // rang " << rang << " 10995 " << endl;
#endif

    if(sende_sued==true)
        {
        packen_sued_abschliessen();  // muss immer nach packen_west_mv erfolgen. Aber vielleicht vor dem Warten machen.
                                    // poa ist nämlich Buffer - unabhängig.
        }

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA5ae ns // rang " << rang << " 11005 " << endl;
#endif

    // Bemerkung:   ist_nachbar aendert sich mit der Nachkorrektur. Das muss trotzdem korrekt bleiben.
    //              Das ist zu überlegen!
//  Bemerkung: mv_westen und mv_osten, obwohl vielleicht überhaupt nicht gesendet wird?
//  mv_westen und mv_osten habe ich momentan doppelt belegt. Ich verstehe logisch_sammeln
//  noch nicht!
//  Bemerkung: Man braucht mv_westen, mv_osten, ist_nachbar und die Flags senden_west und senden_ost.
//  Wie komme ich an die Flags?

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Nach logisch sammeln " << endl;
    cout << " !LA6 ns // rang " << rang << endl;
#endif
    timer_la_packen.stoppen();
    timer_la_nachkorrektur.starten();
    timer_la_nachkorrektur2.starten();
    timer_la_nachkorrektur2a.starten();


    while(nachkorrektur.test_senden()==false)
        {
        ;
        }

    timer_la_nachkorrektur2a.stoppen();
    timer_la_nachkorrektur2b.starten();

    nachkorrektur.log_ent_tv.starten();

    while(nachkorrektur.logisch_entpacken_ns()==false)
        {
        ;
        }

#ifdef AKTUELLE_KOMMENTARE
    cout << " NachNK rang " << rang << " ff " << paralleles_rechnen_l[3]->farbenfeld[1][2] << endl;
#endif

    timer_la_nachkorrektur2b.stoppen();
    timer_la_nachkorrektur2.stoppen();
    timer_la_nachkorrektur.stoppen();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "nach Nachkorrektur");
    ausgabe_ep_minus_wert(zeichenkette);
#endif
    timer_la_senden_ies.starten();
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " !LA7 ns // rang " << rang << endl;
    strcpy(zeichenkette, "LA7");
    test003(zeichenkette);
    cout << "Nach nachkorrektur.logisch_entpacken " << endl;
#endif
    // Bei lt_durchfuehren 2 wird logisch entpackt vor(!) dem eigentlichen Lasttransfer.

    if(sende_nord_oben == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << " !LA7 gemeinsam rang " << rang << endl;
            cout << "!LA7a1 rang " << rang;
#endif
            packen_nord_oben_ieS(); // Nach packen_west_oben_abschliessen?
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a2 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_nord_mhf_oben(&mhf_buffer_norden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a3 rang " << rang;
#endif
            werte_buffer_norden_oben.index = 0;
            werte_verschicken.packen_ns(&mv_norden, &werte_buffer_norden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a4 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_nord_werte_oben(&werte_buffer_norden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7a5 rang " << rang;
#endif
        }

    if(sende_sued_oben == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << " !LA7 gemeinsam rang " << rang << endl;
            cout << "!LA7b1 rang " << rang;
#endif
            packen_sued_oben_ieS();
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b2 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_sued_mhf_oben(&mhf_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b3 rang " << rang;
#endif
            werte_buffer_sueden_oben.index = 0;
            werte_verschicken.packen_ns(&mv_sueden, &werte_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b4 rang " << rang;
#endif
            la_kommunikationen.initiiere_senden_sued_werte_oben(&werte_buffer_sueden_oben);
#ifdef AUSGABEN_LASTAUSGLEICH
            cout << "!LA7b5 rang " << rang;
#endif
        }

    if(sende_nord_speichern == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !LA7 gemeinsam rang " << rang << endl;
        cout << "!LA7c1 ns rang " << rang;
#endif
        packen_nord_ieS();
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c2 ns rang " << rang;
#endif
//  Was ist mit der Ebene, und wie wird mvf_buffer_westen geschrieben?
        la_kommunikationen.initiiere_senden_nord_mhf(&mhf_buffer_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c3 ns rang " << rang;
#endif
        werte_buffer_norden.index = 0;
        werte_verschicken.packen_ns(&mv_norden, &werte_buffer_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c4 ns rang " << rang;
#endif
        la_kommunikationen.initiiere_senden_nord_werte(&werte_buffer_norden);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7c5 ns rang " << rang;
#endif
        }

    if(sende_sued_speichern == true)
        {
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << " !LA7 gemeinsam rang " << rang << endl;
        cout << "!LA7d1 rang " << rang;
#endif
        packen_sued_ieS();
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d2 rang " << rang;
#endif
        la_kommunikationen.initiiere_senden_sued_mhf(&mhf_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d3 rang " << rang;
#endif
        werte_buffer_sueden.index = 0;
        // Ob das so stimmt? Aber: Der Werte_Buffer muss ja resettet werden!
        werte_verschicken.packen_ns(&mv_sueden, &werte_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d4 rang " << rang;
#endif
        la_kommunikationen.initiiere_senden_sued_werte(&werte_buffer_sueden);
#ifdef AUSGABEN_LASTAUSGLEICH
        cout << "!LA7d5 rang " << rang;
#endif
        }

    timer_la_senden_ies.stoppen();
    timer_la_test_und_entpacken.starten();

#ifdef AKTUELLE_KOMMENTARE
    cout << " !LA8 ns // rang " << rang << endl;
#endif

#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!LA8 ns // rang " << rang << endl;
    strcpy(zeichenkette, "LA8");
    test003(zeichenkette);

    cout << " snm " << sende_nord_mhf << " snw " << sende_nord_werte;
    cout << " ssm " << sende_sued_mhf << " ssw " << sende_sued_werte;
    cout << " enm " << empfange_nord_mhf << " enw " << empfange_nord_werte;
    cout << " esm " << empfange_sued_mhf << " esw " << empfange_sued_werte << endl;

    if(ev_dim == 2)
        {
    cout << " snmo " << sende_nord_mhf_oben << " snwo " << sende_nord_werte_oben;
    cout << " ssmo " << sende_sued_mhf_oben << " sswo " << sende_sued_werte_oben;
    cout << " enmo " << empfange_nord_mhf_oben << " enwo " << empfange_nord_werte_oben;
    cout << " esmo " << empfange_sued_mhf_oben << " eswo " << empfange_sued_werte_oben << endl;
        }
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " VorEntpacken rang " << rang << " ff " << paralleles_rechnen_l[3]->farbenfeld[1][2] << endl;
#endif

#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "ganz_am Ende");
    ausgabe_ep_minus_wert(zeichenkette);
#endif

//  2. Schritt vom Lastausgleich: Flag Abfrage: Ist man fertig?
    if(ev_dim == 1)
        {
        while(( sende_nord_mhf || sende_nord_werte ||
                sende_sued_mhf || sende_sued_werte ||
                empfange_nord_mhf || empfange_nord_werte ||
                empfange_sued_mhf || empfange_sued_werte)==true)
                {
                test_und_entpacken_ns();
                }
        }
    else
        {
        while(( sende_nord_mhf || sende_nord_werte ||
                sende_sued_mhf || sende_sued_werte ||
                empfange_nord_mhf || empfange_nord_werte ||
                empfange_sued_mhf || empfange_sued_werte ||
                sende_nord_mhf_oben || sende_nord_werte_oben ||
                sende_sued_mhf_oben || sende_sued_werte_oben ||
                empfange_nord_mhf_oben || empfange_nord_werte_oben ||
                empfange_sued_mhf_oben || empfange_sued_werte_oben)==true)
//  3.  Schritt: Test auf Kommunikation fertig. Resultierendes Flag setzen und beim Empfangen entpacken.
//      Damit ist der Lastausgleich durchgefuehrt.
                {
                test_und_entpacken_ns();
                }
        }

    if(ev2_gilt == true)
        {
        eigene_last = ev2[gitterebene].gesamtpunkteanzahl;
        }
    else
        {
        eigene_last = ev[gitterebene].gesamtpunkteanzahl;
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Last hinterher rang " << rang << " Last " << eigene_last << " gitterebene " << gitterebene << endl;
#endif
    timer_la_test_und_entpacken.stoppen();
    timer_la_gesamt.stoppen();
//////////////////////////////////////////////////////////////
/////// Die Punkte wurden gepackt, verschickt, entpackt //////
//////////////////////////////////////////////////////////////
#ifdef AKTUELLE_KOMMENTARE
    cout << " NachAllem rang " << rang << " ff " << paralleles_rechnen_l[3]->farbenfeld[1][2] << endl;
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
    strcpy(zeichenkette, "LA9");
    test003(zeichenkette);
    cout << " !LA9 ns rang " << rang << endl;
#endif
    }

void LastAusgleich::initialisieren_zusatz(MarkierungsFeld * _neuer_punkt_ebenen, bool _ist_zusammen_aV_LA) // Änderung 13.2.16
    {
    neuer_punkt_ebenen = _neuer_punkt_ebenen;
    ist_zusammen_aV_LA = _ist_zusammen_aV_LA;
    }

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////// packen entpacken mit markierungsfeld   //////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

////////// 29.09.2014 ////////////////////////////////////////

// Kommentar: Hier wird die ep - Information gepackt. Die entsprechenden bool'schen Werte werden zusammen mit den
// boolschen Werte gepackt, die angeben, ob ein Gitterpunkt neu entstanden ist.
inline void LastAusgleich::packen_ep_mit_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
// Kommentar: Zuerst wird die Stelle im mvf - Buffer bestimmt.
    offset = mvf_buffer -> index;
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 1 rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
// Kommentar: Dann wird der mvf - buffer zusammen mit dieser Stelle an die Bit - Pack - Klassen - Instanz weitergegeben - entweder
// für int oder short int Buffer.
    bool_short_int.anfang(mvf_buffer->buffer, offset);
    #else
    bool_int.anfang(mvf_buffer.buffer, offset);
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 2 rang " << rang << endl;
#endif

// Kommentar: Dann werden die Gitterebenen durchlaufen.
    for(i=0; i<h_gesamt_variante; i++)
        {
// Kommentar: Braucht man Merkfeld und ep - Information nicht, dann kann die entsprechende Ebene übergangen werden.
// GGGG
        ep_ebenen_hw = ep_ebenen[i];
        if(gitterebene!=i)
            {
            ep_ebenen_hw &= 2;
            }
        if(ep_ebenen_hw==0)
            {
            continue;
            }
// Kommentar: Man speichert die Vektorlisten nebst ihrer Länge ab.
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
        index = mv->indizes[i];

        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        ep_snb_update_i = ep_snb_update[i];

// Kommentar: Alles weitere Packen machen die Funktionen packen_ep_rumpf_mit_markierungsfeld bzw. packen_ep_rumpf.
// Das Markierungsfeld wird aber nur für die feinere Ebene der beiden Ebenen der parallelen adaptiven Verfeinerung
// gepackt.
        switch(ep_ebenen_hw)
            {
            case 1:
                packen_markierungsfeld();
                break;
            case 2:
                packen_ep_rumpf();
                break;
            case 3:
                packen_ep_rumpf_mit_markierungsfeld();
                break;
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Packen_ep 3 rang " << rang << endl;
#endif
// Kommentar: Am Ende wird der aktuelle Index des boolschen Buffers in den mvf - Buffer zurückgeschrieben.
    #ifdef KURZ_MVF
    mvf_buffer->index = bool_short_int.laenge();
    #else
    mvf_buffer->index = bool_int.laenge();
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!2021" << endl;
#endif
    }

// Kommentar: Hier geschieht das Packen der ep - Information für eine ausgewählte Gitterebene und Zeiger auf eine Vektorliste.
inline void LastAusgleich::packen_ep_rumpf(void)
    {
        ep_updates_i = ep_updates[i];
// Kommentar: Durchlaufe die Vektorliste
        for(j=0; j<index; j++)
        // Wo wird j abgefragt?
            {
// Kommentar: Lese den jeweiligen Vektor.
            f1_h = f1[j];
            f2_h = f2[j];
            g_h = g[j];

// Kommentar: Durchlaufe den Vektor.
            for(k=f1_h; k<=f2_h; k++)
                {
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " ep_vergangen[i][k][g_h] rang " << rang << " i " << i << " k " << k << " g_h " << g_h << endl;
                cout << ep_updates[i]->feld_vergangen[k][g_h]  << " rang " << rang << endl;
                cout << " weiter rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
                if((i==1)&&(k==8)&&(g_h==5))
                    {
                    cout << " GHIGHI packen_ep vorher rang " << rang << " fv " << ep_updates[i]->feld_vergangen[f_h][k] << endl;
                    }
#endif
// Kommentar: Die bool'sche Variable wird gepackt nach ep_plus_i und ep_minus_i - Variablen, die sowohl beim
// packen wie entpacken richtig gesetzt werden.

// Kommentar: Ist ein Eintrag in ep_plus_i auf der Gitterpunktstelle vorhanden, dann schreibe ein true in den Buffer, entferne
// den ep_plus_i - Eintrag und verlasse die 'if else else else' - Konstruktion.
                if(ep_plus_i->feld[k][g_h]!=-1)
                    {
                    #ifdef KURZ_MVF
                    bool_short_int.schreiben(true);
                    #else
                    bool_int.schreiben(true);
                    #endif
                    ep_plus_i->hinweg(k, g_h);
                    }
                else
                    {
// Kommentar: Ansonsten prüfe auf einen ep_minus_i Eintrag. In dem Falle schreibe false in den Buffer, entferne den ep_minus_i
// - Eintrag, und verlasse die 'if else else else' - Konstruktion.
                    if(ep_minus_i->feld[k][g_h]!=-1)
                        {
                        #ifdef KURZ_MVF
                        bool_short_int.schreiben(false);
                        #else
                        bool_int.schreiben(false);
                        #endif
                        ep_minus_i->hinweg(k, g_h);
                        }
                    else
                        {
// Kommentar: Gab es keine Einträge in EP+ und EP-, dann wird geschrieben, wie das feld_vergangen angibt - gelesen in ep_updates[i].
                        if(ep_updates_i->feld_vergangen[k][g_h] == true)
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(true);
                            #else
                            bool_int.schreiben(true);
                            #endif
                            }
                        else
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(false);
                            #else
                            bool_int.schreiben(false);
                            #endif
                            }
                        }
                    }
// Kommentar: Dieser Gitterpunkt wird verschickt. Gibt es dazu einen Eintrag - was man in ist_gesetzt von ep_snb_update lesen kann,
// muss das entfernt werden.
                if(ep_snb_update_i->ist_gesetzt[k][g_h]==true)
// Kommentar: Dieser Update von Farbenfeld und pfl geschieht nur beim ersten Verschicken, wenn Punkte weiterverschickt werden.
                    {
// Kommentar: Zuerst wird der Punkt aus EP_SNB entfernt - für die 8 Punkte um (k,g_h) in Richtung auf (k,g_h).
                    ep_snb_update_i->hinweg_ohne(k, g_h);
// Kommentar: Gibt es pfl_aktuell und pfl_vergangen, wird beides an dieser Stelle auf false gesetzt - zusasmmen mit feld_aktuell und
// feld_vergangen.
                    #ifdef EPS_PFLS
                    ep_updates_i->setze_feld_aktuell_gleich_false(k, g_h);
                    ep_updates_i->setze_feld_vergangen_gleich_false(k, g_h);
                    #else
// Kommentar: Ansonsten werden nur feld_aktuell und feld_vergangen an dieser Stelle auf false gesetzt - es gibt hier den Gitterpunkt ja
// nicht mehr.
                    ep_updates_i->feld_vergangen[k][g_h] = false;
                    ep_updates_i->feld_aktuell[k][g_h] = false;
                    #endif
                    // Letzte Zeile gesetzt.
                    }
                }
            }
    }

// Kommentar: Diese Funktion packt nur das Markierungsfeld.
inline void LastAusgleich::packen_markierungsfeld(void)
    {
        ep_updates_i = ep_updates[i];
// Kommentar: Zuerst geschieht ein Zugriff auf das Feld, wo neue Punkte gekennzeichnet sind.
//        hilfsfeld = neuer_punkt->feld;
        hilfsfeld = neuer_punkt_ebenen[i].feld;
        for(j=0; j<index; j++)
        // Wo wird j abgefragt?
            {
            f1_h = f1[j];
            f2_h = f2[j];
            g_h = g[j];
            for(k=f1_h; k<=f2_h; k++)
                {
// Kommentar: Macht man die Markierung, dann wird das Bit dafür, ob es den Punkt schon gab, als erstes in den Buffer geschrieben.
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                bool_short_int.schreiben(hilfsfeld[k][g_h]);
                #else
                bool_int.schreiben(hilfsfeld[k][g_h]);
                #endif
#endif
                }
            }
    }

// Kommentar: Diese Funktion ist sehr ähnlich zu packen_ep_rumpf. Daher werden nur die Befehle, die hinzukommen, kommentiert.
// Die restlichen können von der Funktion packen_ep_rumpf übernommen werden.
inline void LastAusgleich::packen_ep_rumpf_mit_markierungsfeld(void)
    {
        ep_updates_i = ep_updates[i];
// Kommentar: Zuerst geschieht ein Zugriff auf das Feld, wo neue Punkte gekennzeichnet sind.
        hilfsfeld = neuer_punkt_ebenen[i].feld;
        for(j=0; j<index; j++)
        // Wo wird j abgefragt?
            {
            f1_h = f1[j];
            f2_h = f2[j];
            g_h = g[j];
            for(k=f1_h; k<=f2_h; k++)
                {
// Kommentar: Macht man die Markierung, dann wird das Bit dafür, ob es den Punkt schon gab, als erstes in den Buffer geschrieben.
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                bool_short_int.schreiben(hilfsfeld[k][g_h]);
                #else
                bool_int.schreiben(hilfsfeld[k][g_h]);
                #endif
#endif

// Kommentar: Alles weitere wie bei packen_ep_rumpf.

#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " ep_vergangen[i][k][g_h] rang " << rang << " i " << i << " k " << k << " g_h " << g_h << endl;
                cout << ep_updates[i]->feld_vergangen[k][g_h]  << " rang " << rang << endl;
                cout << " weiter rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
                if((i==1)&&(k==8)&&(g_h==5))
                    {
                    cout << " GHIGHI packen_ep vorher rang " << rang << " fv " << ep_updates[i]->feld_vergangen[f_h][k] << endl;
                    }
#endif
// Kommentar: Die bool'sche Variable wird gepackt nach ep_plus_i und ep_minus_i - Variablen, die sowohl beim
// packen wie entpacken richtig gesetzt werden.
                if(ep_plus_i->feld[k][g_h]!=-1)
                    {
                    #ifdef KURZ_MVF
                    bool_short_int.schreiben(true);
                    #else
                    bool_int.schreiben(true);
                    #endif
                    ep_plus_i->hinweg(k, g_h);
                    }
                else
                    {
                    if(ep_minus_i->feld[k][g_h]!=-1)
                        {
                        #ifdef KURZ_MVF
                        bool_short_int.schreiben(false);
                        #else
                        bool_int.schreiben(false);
                        #endif
                        ep_minus_i->hinweg(k, g_h);
                        }
                    else
                        {
                        if(ep_updates_i->feld_vergangen[k][g_h] == true)
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(true);
                            #else
                            bool_int.schreiben(true);
                            #endif
                            }
                        else
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(false);
                            #else
                            bool_int.schreiben(false);
                            #endif
                            }
                        }
                    }
                if(ep_snb_update_i->ist_gesetzt[k][g_h]==true)
// Kommentar: Dieser Update von Farbenfeld und pfl geschieht nur beim ersten Verschicken, wenn Punkte weiterverschickt werden.
                    {
                    ep_snb_update_i->hinweg_ohne(k, g_h);
                    #ifdef EPS_PFLS
                    ep_updates_i->setze_feld_aktuell_gleich_false(k, g_h);
                    ep_updates_i->setze_feld_vergangen_gleich_false(k, g_h);
                    #else
                    ep_updates_i->feld_vergangen[k][g_h] = false;
                    ep_updates_i->feld_aktuell[k][g_h] = false;
                    #endif
                    // Letzte Zeile gesetzt.
                    }
                }
            }
    }

// Kommentar: Hier geschieht das Entpacken der ep - Information. Bei dieser Funktion zusammen mit dem Markierungsfeld.
inline void LastAusgleich::entpacken_ep_mit_markierungsfeld(MV_vertikal * mv, MVFBuffer * mvf_buffer)
    {
// Kommentar: Man liest den momentanen Bufferindex, und übergibt ihn zusammen mit dem MVFBuffer mvf_buffer an die Instanz der Bit - Lesenden Klasse.
    offset = mvf_buffer -> index;
    // Da fehlt noch Information: Man hat einen Index für die Zahl übermittelter Vektoren, dann einen für den umlaufenden
    // Teil. Obwohl: Die sind eindeutig. Weil eindeutig umlaufen ist. Aber das ist hier noch nicht verwendet!
    #ifdef KURZ_MVF
    bool_short_int.anfang(mvf_buffer->buffer, offset);
    #else
    bool_int.anfang(mvf_buffer->buffer, offset);
    #endif

// Kommentar: Dann werden die Gitterebenen durchlaufen.
    for(i=0; i<h_gesamt_variante; i++)
        {
#ifdef AKTUELLE_KOMMENTARE
        cout << " !100825 a entpacken_ep Ebene " << i << " rang " << rang << endl;
#endif

// Kommentar: Braucht für eine Gitterebene weder die Markierung noch die ep - Information behandelt werden, dann gehe zur nächsten Gitterebene.
        ep_ebenen_hw = ep_ebenen[i];
        if(gitterebene!=i)
            {
            ep_ebenen_hw &= 2;
            }
        if(ep_ebenen_hw==0)
            {
            continue;
            }
// Kommentar: Lese die Vektorenliste mit ihrer Länge. Die Vektorenliste wird in entsprechenden Zeigern gespeichert.
        f1 = mv->f1_speichern[i];
        f2 = mv->f2_speichern[i];
        g = mv->g_speichern[i];
        index = mv->indizes[i];

// Kommentar: Schreibe ep_plus_i und ep_minus_i für einen schnelleren Zugriff.
        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];

// Kommentar: Ist i die untere Gitterebene der parallelen adaptiven Verfeinerung, dann rufe entpacken_ep_rumpf_mit_markierungsfeld auf.

        switch(ep_ebenen_hw)
            {
            case 1:
                entpacken_markierungsfeld();
                break;
            case 2:
                entpacken_ep_rumpf();
                break;
            case 3:
                entpacken_ep_rumpf_mit_markierungsfeld();
                break;
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Entpacken_ep 3 rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
// Kommentar: Am Ende schreibe den nun aktuellen Index in den MVFBuffer zurück.
    mvf_buffer->index = bool_short_int.laenge();
    #else
    mvf_buffer->index = bool_int.laenge();
    #endif
    }

// Kommentar: Hier geschieht das Entpacken der ep - Information für eine ausgewählte Gitterebene und Zeiger auf eine Vektorliste.
inline void LastAusgleich::entpacken_ep_rumpf(void)
    {
// Kommentar: Durchlaufe die Vektorliste.
        for(j=0; j<index; j++)
            {
// Kommentar: Speichere den jeweils nächsten Vektor.
            f1_h = f1[j];
            f2_h = f2[j];
            g_h = g[j];
#ifdef AKTUELLE_KOMMENTARE
            cout << " !100825 b entpacken_ep Ebene " << i << " rang " << rang << " f1 " << f1[j];
            cout << " f2 " << f2[j] << " g " << g[j] << endl;
#endif

// Kommentar: Und durchlaufe diesen Vektor.
            for(k=f1_h; k<=f2_h; k++)
                {
// Kommentar: Je nach Art der Bitweise lesenden Klasse wird das jeweils nächste Bit gelesen, und in bool_hilfsvariable gespeichert.
                #ifdef KURZ_MVF
// Kommentar: Das hier richtig gelesen wird - vgl. packen_ep_rumpf.
                bool_hilfsvariable = bool_short_int.lesen();
// Völlig korrekt: In ep_updates[i] liegen die Informationen.
                #else
                bool_hilfsvariable = bool_int.lesen();
                #endif
#ifdef AKTUELLE_KOMMENTARE
                if((rang==4)&&(i==1))
                    {
                    cout << " NNOOPP entpacken ep f " << k << " g " << g_h << " bool " << bool_hilfsvariable << endl;
                    }
#endif

// Kommentar: Ist die boolsche Hilfsvariable true, dann nehme den Punkt zu EP+(i) dazu, und aus EP-(i) hinweg.
                if(bool_hilfsvariable==true)
                    {
                    ep_plus_i->hinzu(k, g_h);
                    ep_minus_i->hinweg(k, g_h);
                    }
                else
// Kommentar: Ansonsten genau umgekehrt.
                    {
                    ep_minus_i->hinzu(k, g_h);
                    ep_plus_i->hinweg(k, g_h);
                    }
// Kommentar: Auf diese Weise wird diese Information von feld_vergangen soweit weitergeben, bis sie am Ende der Reise mit
// den Funktionmen LA_vollenden_ep_plus und LA_vollenden_ep_minus eingetragen wird.

// Kommentar: Vgl. auch LA_vollenden_ep_plus und LA_vollenden_ep_minus wegen farbenfeldupdate mit pfl in ep_updates
// nur beim LETZTEN empfangen. Würde man hier die Updates machen, müßte man das beim Weiterverschicken wieder
// zurücksetzen.

// Was genau geschieht hier bei bool_hilfsvariable == true? Warum in ep_plus_i einfuegen?
// Bevor man ep_plus_i verwenden kann, muss es mit ep_plus verknuepft werden - vgl. ep_listen
// hinzufuegen oder entfernen. So liegt ein Fehler vor.
                }
            }
    }

// Kommentar: Diese Funktion entpackt nur das Markierungsfeld.
inline void LastAusgleich::entpacken_markierungsfeld(void)
    {
// Kommentar: Ein Zeiger wird auf das Feld neuer_punkt verknüpft, so dass man Punkte als neue Punkte markieren kann.
//        hilfsfeld = neuer_punkt->feld;
        hilfsmarkierung = &(neuer_punkt_ebenen[i]); // Änderung 13.2.16
        for(j=0; j<index; j++)
            {
            f1_h = f1[j];
            f2_h = f2[j];
            g_h = g[j];
#ifdef AKTUELLE_KOMMENTARE
            cout << " !100825 b entpacken_ep Ebene " << i << " rang " << rang << " f1 " << f1[j];
            cout << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
            for(k=f1_h; k<=f2_h; k++)
                {
// Kommentar: Wenn man die Markierung macht, und das sollte man machen, dann lese den Punkt in den oben bestimmten Zeiger
// hilfsfeld an der angegebenen Stelle ein.
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                if(bool_short_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(k,g_h);
                    }
                #else
                if(bool_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(k,g_h);
                    }
                #endif
#endif
                }
            }
    }


// Kommentar: Diese Funktion ist analog zu entpacken_ep_rumpf, nur dass auch noch Markierungsfeldinformationen gelesen werden.
// Daher wird hier nur kommentiert, was an Programm gegenüber entpacken_ep_rumpf hinzukommt.
inline void LastAusgleich::entpacken_ep_rumpf_mit_markierungsfeld(void)
    {
// Kommentar: Ein Zeiger wird auf das Feld neuer_punkt verknüpft, so dass man Punkte als neue Punkte markieren kann.
        hilfsmarkierung = &(neuer_punkt_ebenen[i]); // Änderung 13.2.16
        for(j=0; j<index; j++)
            {
            f1_h = f1[j];
            f2_h = f2[j];
            g_h = g[j];
#ifdef AKTUELLE_KOMMENTARE
            cout << " !100825 b entpacken_ep Ebene " << i << " rang " << rang << " f1 " << f1[j];
            cout << " f2 " << f2[j] << " g " << g[j] << endl;
#endif
            for(k=f1_h; k<=f2_h; k++)
                {
// Kommentar: Wenn man die Markierung macht, und das sollte man machen, dann lese den Punkt in den oben bestimmten Zeiger
// hilfsfeld an der angegebenen Stelle ein.
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                if(bool_short_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(k,g_h);
                    }
                #else
                if(bool_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(k, g_h);
                    }
                #endif
#endif

// Kommentar: Alles weitere geschieht genauso wie in der Funktion entpacken_ep_rumpf. Also enden hier die Zusatzkommentare dieser
// Funktion.

                #ifdef KURZ_MVF
// Kommentar: Das hier richtig gelesen wird - vgl. packen_ep_rumpf_mit_markierungsfeld.
                bool_hilfsvariable = bool_short_int.lesen();
// Völlig korrekt: In ep_updates[i] liegen die Informationen.
                #else
                bool_hilfsvariable = bool_int.lesen();
                #endif
                if(bool_hilfsvariable==true)
                    {
                    ep_plus_i->hinzu(k, g_h);
                    ep_minus_i->hinweg(k, g_h);
                    }
                else
                    {
                    ep_minus_i->hinzu(k, g_h);
                    ep_plus_i->hinweg(k, g_h);
                    }
// Kommentar: Vgl. auch LA_vollenden_ep_plus und LA_vollenden_ep_minus wegen farbenfeldupdate mit pfl in ep_updates
// nur beim LETZTEN empfangen. Würde man hier die Updates machen, müßte man das beim Weiterverschicken wieder
// zurücksetzen.

// Was genau geschieht hier bei bool_hilfsvariable == true? Warum in ep_plus_i einfuegen?
// Bevor man ep_plus_i verwenden kann, muss es mit ep_plus verknuepft werden - vgl. ep_listen
// hinzufuegen oder entfernen. So liegt ein Fehler vor.
                }
            }
    }

// Kommentar: Diese Funktion ist analog zu packen_ep_mit_markierungsfeld, wird also nicht weiter kommentiert.
inline void LastAusgleich::packen_ep_ns_mit_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
    offset = mhf_buffer -> index;
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 1 ns mM rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
    bool_short_int.anfang(mhf_buffer->buffer, offset);
    #else
    bool_int.anfang(mhf_buffer.buffer, offset);
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "Packen_ep 2 ns mM rang " << rang << endl;
#endif

    for(i=0; i<h_gesamt_variante; i++)
        {
        ep_ebenen_hw = ep_ebenen[i];
        if(gitterebene!=i)
            {
            ep_ebenen_hw &= 2;
            }
        if(ep_ebenen_hw==0)
            {
            continue;
            }
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        f = mv->f_speichern[i];
        index = mv->indizes[i];


        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];
        ep_snb_update_i = ep_snb_update[i];

        switch(ep_ebenen_hw)
            {
            case 1:
                packen_ns_markierungsfeld();
                break;
            case 2:
                packen_ep_ns_rumpf();
                break;
            case 3:
                packen_ep_ns_rumpf_mit_markierungsfeld();
                break;
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Packen_ep_ns 3 mM rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
    mhf_buffer->index = bool_short_int.laenge();
    #else
    mhf_buffer->index = bool_int.laenge();
    #endif
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << "!2021" << endl;
#endif
    }

// Kommentar: Diese Funktion ist analog zu packen_ep_rumpf, wird also nicht weiter kommentiert.
inline void LastAusgleich::packen_ep_ns_rumpf(void)
    {
        ep_updates_i = ep_updates[i];
        for(j=0; j<index; j++)
            {
            g1_h = g1[j];
            g2_h = g2[j];
            f_h = f[j];
            for(k=g1_h; k<=g2_h; k++)
                {
// Kommentar: Die bool'sche Variable wird gepackt nach ep_plus_i und ep_minus_i - Variablen, die sowohl beim
// packen wie entpacken richtig gesetzt werden.
                if(ep_plus_i->feld[f_h][k]!=-1)
                    {
                    #ifdef KURZ_MVF
                    bool_short_int.schreiben(true);
                    #else
                    bool_int.schreiben(true);
                    #endif
                    ep_plus_i->hinweg(f_h, k);
                    }
                else
                    {
                    if(ep_minus_i->feld[f_h][k]!=-1)
                        {
                        #ifdef KURZ_MVF
                        bool_short_int.schreiben(false);
                        #else
                        bool_int.schreiben(false);
                        #endif
#ifdef AKTUELLE_KOMMENTARE
                        if((rang==4)&&(i==1))
                            {
                            cout << " NNOOPP 2 f " << f_h << " g " << k << " bool false " << " ep_minus_i->feld " << ep_minus_i->feld[f_h][k] << endl;
                            }
#endif
                        ep_minus_i->hinweg(f_h, k);
                        }
                    else
                        {
                        if(ep_updates_i->feld_vergangen[f_h][k] == true)
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(true);
                            #else
                            bool_int.schreiben(true);
                            #endif
#ifdef AKTUELLE_KOMMENTARE
                            if((rang==4)&&(i==1))
                                {
                                cout << " NNOOPP 3 f " << f_h << " g " << k << " bool true " << endl;
                                }
#endif
                            }
                        else
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(false);
                            #else
                            bool_int.schreiben(false);
                            #endif
                            }
                        }
                    }
                if(ep_snb_update_i->ist_gesetzt[f_h][k]==true)
// Kommentar: Dieser Update von Farbenfeld und pfl geschieht nur beim ersten Verschicken, wenn Punkte weiterverschickt werden.
                    {
                    ep_snb_update_i->hinweg_ohne(f_h, k);
                    #ifdef EPS_PFLS
                    ep_updates_i->setze_feld_aktuell_gleich_false(f_h,k);
                    ep_updates_i->setze_feld_vergangen_gleich_false(f_h,k);
                    #else
                    ep_updates_i->feld_vergangen[f_h][k] = false;
                    ep_updates_i->feld_aktuell[f_h][k] = false;
                    #endif
                    // Ganz gelöscht, nachdem update OK
                    }
                }
            }
    }

// Kommentar: Diese Funktion ist analog zu packen_ep_rumpf_mit_markierungsfeld, wird also nicht weiter kommentiert.
inline void LastAusgleich::packen_ep_ns_rumpf_mit_markierungsfeld(void)
    {
        ep_updates_i = ep_updates[i];
        hilfsfeld = neuer_punkt_ebenen[i].feld;
        for(j=0; j<index; j++)
            {
            g1_h = g1[j];
            g2_h = g2[j];
            f_h = f[j];
            for(k=g1_h; k<=g2_h; k++)
                {
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                bool_short_int.schreiben(hilfsfeld[f_h][k]);
                #else
                bool_int.schreiben(hilfsfeld[f_h][k]);
                #endif
#endif
#ifdef AUSGABEN_LASTAUSGLEICH
                cout << " ep_vergangen[i][k][g_h] rang " << rang << " i " << i << " f_h " << f_h << " k " << k << endl;
                cout << ep_updates[i]->feld_vergangen[f_h][k]  << " rang " << rang << endl;
                cout << " weiter rang " << rang << endl;
#endif
// Kommentar: Die bool'sche Variable wird gepackt nach ep_plus_i und ep_minus_i - Variablen, die sowohl beim
// packen wie entpacken richtig gesetzt werden.
                if(ep_plus_i->feld[f_h][k]!=-1)
                    {
                    #ifdef KURZ_MVF
                    bool_short_int.schreiben(true);
                    #else
                    bool_int.schreiben(true);
                    #endif
                    ep_plus_i->hinweg(f_h, k);
                    }
                else
                    {
                    if(ep_minus_i->feld[f_h][k]!=-1)
                        {
                        #ifdef KURZ_MVF
                        bool_short_int.schreiben(false);
                        #else
                        bool_int.schreiben(false);
                        #endif
                        ep_minus_i->hinweg(f_h, k);
                        }
                    else
                        {
                        if(ep_updates_i->feld_vergangen[f_h][k] == true)
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(true);
                            #else
                            bool_int.schreiben(true);
                            #endif
                            }
                        else
                            {
                            #ifdef KURZ_MVF
                            bool_short_int.schreiben(false);
                            #else
                            bool_int.schreiben(false);
                            #endif
                            }
                        }
                    }
                if(ep_snb_update_i->ist_gesetzt[f_h][k]==true)
// Kommentar: Dieser Update von Farbenfeld und pfl geschieht nur beim ersten Verschicken, wenn Punkte weiterverschickt werden.
                    {
                    ep_snb_update_i->hinweg_ohne(f_h, k);
                    #ifdef EPS_PFLS
                    ep_updates_i->setze_feld_aktuell_gleich_false(f_h,k);
                    ep_updates_i->setze_feld_vergangen_gleich_false(f_h,k);
                    #else
                    ep_updates_i->feld_vergangen[f_h][k] = false;
                    ep_updates_i->feld_aktuell[f_h][k] = false;
                    #endif
                    // Ganz gelöscht, nachdem update OK
                    }
                }
            }
    }

// Kommentar: Diese Funktion ist analog zu packen_markierungsfeld.
inline void LastAusgleich::packen_ns_markierungsfeld(void)
    {
        hilfsfeld = neuer_punkt_ebenen[i].feld;
        for(j=0; j<index; j++)
            {
            g1_h = g1[j];
            g2_h = g2[j];
            f_h = f[j];
            for(k=g1_h; k<=g2_h; k++)
                {
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                bool_short_int.schreiben(hilfsfeld[f_h][k]);
                #else
                bool_int.schreiben(hilfsfeld[f_h][k]);
                #endif
#endif
                }
            }
    }

// Kommentar: Diese Funktion ist analog zu entpacken_ep_mit_markierungsfeld, wird also nicht weiter kommentiert.
inline void LastAusgleich::entpacken_ep_ns_mit_markierungsfeld(MV_horizontal * mv, MHFBuffer * mhf_buffer)
    {
    offset = mhf_buffer -> index;
    // Da fehlt noch Information: Man hat einen Index für die Zahl übermittelter Vektoren, dann einen für den umlaufenden
    // Teil. Obwohl: Die sind eindeutig. Weil eindeutig umlaufen ist. Aber das ist hier noch nicht verwendet!
    #ifdef KURZ_MVF
    bool_short_int.anfang(mhf_buffer->buffer, offset);
    #else
    bool_int.anfang(mhf_buffer->buffer, offset);
    #endif

    for(i=0; i<h_gesamt_variante; i++)
        {
        ep_ebenen_hw = ep_ebenen[i];
        if(gitterebene!=i)
            {
            ep_ebenen_hw &= 2;
            }
        if(ep_ebenen_hw==0)
//        if(ep_ebenen[i]==false)
            {
            continue;
            }
        g1 = mv->g1_speichern[i];
        g2 = mv->g2_speichern[i];
        f = mv->f_speichern[i];
        index = mv->indizes[i];

        ep_plus_i = ep_plus[i];
        ep_minus_i = ep_minus[i];

        switch(ep_ebenen_hw)
            {
            case 1:
                entpacken_ns_markierungsfeld();
                break;
            case 2:
                entpacken_ep_ns_rumpf();
                break;
            case 3:
                entpacken_ep_ns_rumpf_mit_markierungsfeld();
                break;
            }
        }
#ifdef AUSGABEN_LASTAUSGLEICH
    cout << " Entpacken_ep 3 rang " << rang << endl;
#endif
    #ifdef KURZ_MVF
    mhf_buffer->index = bool_short_int.laenge();
    #else
    mhf_buffer->index = bool_int.laenge();
    #endif
    }

// Kommentar: Diese Funktion ist analog zu entpacken_ep_rumpf, wird also nicht weiter kommentiert.
inline void LastAusgleich::entpacken_ep_ns_rumpf(void)
    {
        for(j=0; j<index; j++)
            {
            g1_h = g1[j];
            g2_h = g2[j];
            f_h = f[j];
            for(k=g1_h; k<=g2_h; k++)
                {
                #ifdef KURZ_MVF
// Kommentar: Das hier richtig gelesen wird - vgl. packen_ep_ns_rumpf.
                bool_hilfsvariable = bool_short_int.lesen();
// Völlig korrekt: In ep_updates[i] liegen die Informationen.
                #else
                bool_hilfsvariable = bool_int.lesen();
                #endif
                if(bool_hilfsvariable==true)
                    {
                    ep_plus_i->hinzu(f_h, k);
                    ep_minus_i->hinweg(f_h, k);
                    }
                else
                    {
                    ep_minus_i->hinzu(f_h, k);
                    ep_plus_i->hinweg(f_h, k);
                    }
// Kommentar: Vgl. auch LA_vollenden_ep_plus und LA_vollenden_ep_minus wegen farbenfeldupdate mit pfl in ep_updates
// nur beim LETZTEN empfangen. Würde man hier die Updates machen, müßte man das beim Weiterverschicken wieder
// zurücksetzen.
                }
            }
    }

// Kommentar: Diese Funktion ist analog zu entpacken_markierungsfeld, wird also nicht weiter kommentiert.
inline void LastAusgleich::entpacken_ns_markierungsfeld(void)
    {
        hilfsmarkierung = &(neuer_punkt_ebenen[i]); // Änderung 13.2.16
        for(j=0; j<index; j++)
            {
            g1_h = g1[j];
            g2_h = g2[j];
            f_h = f[j];
            for(k=g1_h; k<=g2_h; k++)
                {
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
//                hilfsfeld[f_h][k] = bool_short_int.lesen();
                if(bool_short_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(f_h,k);
                    }
                #else
//                hilfsfeld[f_h][k] = bool_int.lesen();
                if(bool_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(f_h,k);
                    }
                #endif
#endif
                }
            }
    }

// Kommentar: Diese Funktion ist analog zu entpacken_ep_rumpf_mit_markierungsfeld, wird also nicht weiter kommentiert.
inline void LastAusgleich::entpacken_ep_ns_rumpf_mit_markierungsfeld(void)
    {
        hilfsmarkierung = &(neuer_punkt_ebenen[i]); // Änderung 13.2.16
        for(j=0; j<index; j++)
            {
            g1_h = g1[j];
            g2_h = g2[j];
            f_h = f[j];
            for(k=g1_h; k<=g2_h; k++)
                {
#ifdef MARKIERUNG
                #ifdef KURZ_MVF
                if(bool_short_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(f_h,k);
                    }
                #else
                if(bool_int.lesen()==true)
                    {
                    hilfsmarkierung->setzen(f_h,k);
                    }
                #endif
#endif
                #ifdef KURZ_MVF
// Kommentar: Das hier richtig gelesen wird - vgl. packen_ep_ns_rumpf_mit_markierungsfeld.
                bool_hilfsvariable = bool_short_int.lesen();
// Völlig korrekt: In ep_updates[i] liegen die Informationen.
                #else
                bool_hilfsvariable = bool_int.lesen();
                #endif
                if(bool_hilfsvariable==true)
                    {
                    ep_plus_i->hinzu(f_h, k);
                    ep_minus_i->hinweg(f_h, k);
                    }
                else
                    {
                    ep_minus_i->hinzu(f_h, k);
                    ep_plus_i->hinweg(f_h, k);
                    }
// Kommentar: Vgl. auch LA_vollenden_ep_plus und LA_vollenden_ep_minus wegen farbenfeldupdate mit pfl in ep_updates
// nur beim LETZTEN empfangen. Würde man hier die Updates machen, müßte man das beim Weiterverschicken wieder
// zurücksetzen.
                }
            }
    }

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

// Kommentar: Das hier ist nur eine Ausgabefunktion zu Debugging - Zwecken. Man muss hier aufpassen, weil die
// Koordinate [20][7] evtl. nicht mehr auf dem Gitter liegt.
void LastAusgleich::test_la1(char * wo)
    {
    }

void LastAusgleich::code103(char * text)
    {
    }
