#include "zyklus_rechnen.h"

// Kommentar zur Klasse Zyklus rechnen: Wo paralleles_rechnen aufgerufen wird, um etwas auszurechnen, steht
// die entsprechende Funktion in der Klasse Rechnen. Wo paralleles_rechnen aufgerufen wird, um Rnder zu
// bertragen, steht die entsprechende Funktion in der Klasse Randstruktur.

// Finalisieren noch komplett machen

// Kommentar: Diese Funktion diente der Fehlersuche. Fr die Variable x, die bergeben wird, werden die
// Quantile der Werte der Matrix fr die Gitterpunkte dieses Gitters ausgegeben.

// Grundstzlich: mit den Prprozessordirektiven #ifdef DAFWV oder #ifdef AKTUELLE_WERTE oder #ifdef AKTUELLE_KOMMENTARE
// werden DEBUG - Informationen bereitgestellt. Zur Funktion des Programms tragen sie nicht bei, und werden daher
// nicht gesondert kommentiert. Sie stellen nur eine Hilfe fr den Programm - Entwickler dar.

// Bemerkung: zu rechnen_nur_als_punktelast(): Diese Funktion dient dem Zweck, eine Last zu der normalen Last der
// Poisson - Gleichung zu bilden, da diese Last sehr gering ist. Die eben genannte Funktion wird aber
// dazu eigentlich nicht verwendet. Die Prprozessor - Direktive '#ifdef ZUSATZLAST' bewirkt ein bergehen
// dieser Art von zugefgter Last. Statt dessen erfolgt eine Lastzuteilung in der Klasse rechnen.

// Kommentar: Hier wird nach einem Gitterpunkt gesucht, und, falls er existiert, wird das bergeben x dort ausgegeben.
void ZyklusRechnen::suche(double ** x, int f, int g, int ebene)
    {
    for(i=0; i<paralleles_rechnen[ebene].anzahl_innen; i++)
        {
        f_hilfe = paralleles_rechnen[ebene].f_innen[i];
        g_hilfe = paralleles_rechnen[ebene].g_innen[i];
        if(f_hilfe==f)
            {
            if(g_hilfe==g)
                {
                cout << " Suche erfolgreich Innen f " << f << " g " << g << " x " << x[f][g] << " rang " << rang << endl;
                }
            }
        }
    for(i=0; i<paralleles_rechnen[ebene].anzahl_rand_innen; i++)
        {
        f_hilfe = paralleles_rechnen[ebene].f_rand_innen[i];
        g_hilfe = paralleles_rechnen[ebene].g_rand_innen[i];
        if(f_hilfe==f)
            {
            if(g_hilfe==g)
                {
                cout << " Suche erfolgreich Rand Innen f " << f << " g " << g << " x " << x[f][g] << " rang " << rang << endl;
                }
            }
        }
    }

// Kommentar: Fr die Randinterpolationen werden die Zeiger auf die Kerntopologien kopiert fr alle Gitterebenen ohne der Feinsten.
// Die Topologie auf Ebene 0 wird fr die Randinterpolationen nicht bentigt.
void ZyklusRechnen::PTs_uebertragen(int ** topologien)
    {
    for(i=1; i<h_gesamt; i++)
        {
        randinterpolationen[i].PT_grobgitter = topologien[i];
        }
    }

// Kommentar: Den Speicher fr ZyklusRechnen freigeben.
void ZyklusRechnen::finalisieren_zyklus_rechnen(void)
    {
#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 1 rang " << rang << endl;
#endif
// Kommentar: Den Speicher fr die Quantile freigeben.
    if(quantile_ausgeben==true)
        {
        finalisieren_ausgeben();
#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 1a rang " << rang << endl;
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        cout << " VWX SortierungDouble wird finalisiert / rang " << rang << endl;
#endif
        sortierung_double.finalisieren();
        }
#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 2 rang " << rang << endl;
#endif

// Kommentar: Sendebuffer, Empfangsbuffer und Markierungsfelder freigeben. Alle 3 sind fr die Randinterpolationen da.
    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            delete sendebuffer[i];
            delete empfangsbuffer[i];

            markierungsfelder[i].finalisieren();
            }
        }

#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 3 rang " << rang << endl;
#endif

    delete sendebuffer;
    delete empfangsbuffer;

    delete markierungsfelder;

#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 4 rang " << rang << endl;
#endif

// Kommentar: Befreie den Speicher fr die Randinterpolationen.
    for(i=1; i<h_gesamt; i++)
        {
        randinterpolationen[i].finalisieren_randinterpolation();
        }
    delete randinterpolationen;

#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 5 rang " << rang << endl;
#endif

// Kommentar: Befreie Gitterpunktlisten. Die ersten 2 Koordinatenlisten fr die Randinterpolation.
    delete f_liste;
    delete g_liste;

// Kommentar: Befreie Gitterpunktlisten. Diese hier fr die Restriktion.
    delete f_s;
    delete g_s;

#ifdef AUSGABEN_ENDE
    cout << " Ende ZR 6 rang " << rang << endl;
#endif

    }

// Kommentar: Initialisiere ZyklusRechnen. Speicher wird angelegt.
void ZyklusRechnen::initialisieren_zyklus_rechnen(void)
// wird finalisiert.
    {
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " initialisieren_zyklus_rechnen rang " << rang << " n " << n << " m " << m << endl;
#endif
// Kommentar: Die Buffergre ist fr die Randinterpolationskommunikation festgelegt.
    buffergroesse = 10 * (m+n); // m und n sind fuers feine Gitter, die Buffer frs grobe Gitter!
    mn = m * n;
    n_1 = (n+1) >> 1;
    m_1 = (m+1) >> 1;

    if(quantile_ausgeben==true)
        {
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        cout << " VWX SortierungDouble initialisiert / rang " << rang << endl;
#endif
        sortierung_double.initialisieren(m*n);
        }

    groesse = paralleles_rechnen[0].groesse;
// Kommentar: Hier wird der Speicher fr die Randinterpolationen angelegt.
    sendebuffer = new Werte1d * [groesse];
    empfangsbuffer = new Werte1d * [groesse];

    markierungsfelder = new MarkierungsFeld [groesse];

    for(i=0; i<groesse; i++)
        {
        if(i!=rang)
            {
            sendebuffer[i] = new Werte1d [buffergroesse];
            empfangsbuffer[i] = new Werte1d [buffergroesse];

            markierungsfelder[i].initialisieren(n_1, m_1);
#ifdef AUSGABEN_ZYKLUS_RECHNEN
            cout << "Markierungsfelder initialisiert: rang " << rang << " i " << i << " n_1 " << n_1 << " m_1 " << m_1 << endl;
#endif
            }
        }

    n_1m_1 = n_1 * m_1;

// Kommentar: Hier wird Speicherplatz fr die Randinterpolation angelegt.
    f_liste = new short int [n_1m_1];
    g_liste = new short int [n_1m_1];
// Kommentar: Hier wird Speicherplatz fr die Restriktion angelegt.
    f_s = new short int [mn];
    g_s = new short int [mn];

// Kommentar: Im Folgenden wird die Randinterpolation auf allen Gitterebenen ab Ebene 1 angelegt.
    randinterpolationen = new RandInterpolation [h_gesamt];
    // Man braucht das nur bis h_min+1 zu machen, auch die Schleife unten.
    for(i=1; i<h_gesamt; i++)
        {
        randinterpolationen[i].initialisieren_randinterpolation(&(paralleles_rechnen[i]), &(paralleles_rechnen[i-1]), sendebuffer, empfangsbuffer);
        // wird finalisiert
        randinterpolationen[i].u0_grob = paralleles_rechnen[i].u0; // doppelt gemoppelt: wird in initialisieren schon gesetzt.
        randinterpolationen[i].markierungsfelder = markierungsfelder;
        (randinterpolationen[i].markierung).initialisieren(paralleles_rechnen[i].feld, f_liste, g_liste);
        // allokiert keinen Speicherplatz
        // Querverweis auf ri.markierung, zu sehen am 16.8.2014
        randinterpolationen[i].dynamischer_rand_fein = &(paralleles_rechnen[i-1].dynamischer_rand);
        randinterpolationen[i].ri_ebene = i;
        }
    randinterpolationen[0].ri_ebene = 0;

#ifdef QUANTILE_AUSGEBEN
    quantile_ausgeben = true; // Das knnte zu Fehlern fhren.
#endif

    if(quantile_ausgeben==true)
        {
        initialisieren_ausgeben();
        }
    strcpy(zeichenkette,"DA_ZR");
    da_zr.initialisieren(rang, zeichenkette);
    }

// Kommentar: Hier werden die wichtigsten Parameter geschrieben.
void ZyklusRechnen::setzen(int _n, int _m, int _h_gesamt, int _rang, int _h_kappe, int _h_min)
    {
    n = _n;
    m = _m;
    h_gesamt = _h_gesamt;
    rang = _rang;
    h_kappe = _h_kappe;
    h_min = _h_min;
    }

// Kommentar: Hier wird der Speicher fr die Restriktionen freigegeben.
void ZyklusRechnen::entferne_restriktionswerte(void)
    {
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " finalisiere restriktionen " << endl;
#endif

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " fi pro[0] " << endl;
#endif

    for(i=0; i<h_gesamt-1; i++)
        {
        restriktionen[i].finalisieren(); // Hier passiert nichts.
        }

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " fi restr[i] " << endl;
#endif

    delete restriktionen;

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " restriktionen sind finalisiert " << endl;
#endif
    }

// Kommentar: Hier werden die Restriktionen - die fr je zwei Gitterebenen zustndig sind - angelegt. Auch Zeiger fr die Listen
// von Gitterpunkten oben sowie die mglichen beteiligten Variablen oben und unten werden festgelegt.
// Damit knnen die verschiedenen Restriktionen per Befehl an die Klasse Restriktion durchgefhrt werden.
void ZyklusRechnen::setze_restriktionswerte(int n, int m)
// wird finalisiert
    {
    restriktionen = new Restriktion [h_gesamt];

    m_hilfe = (m+1)/2;
    n_hilfe = (n+1)/2;

    for(i=0; i<h_gesamt-1; i++)
        {
        i_plus_1 = i+1;
        restriktionen[i].feld_ebene = paralleles_rechnen[i].feld;
        if(1==1)
            {
// Kommentar: Anlegen der Gitterpunktmengen, die fr die jeweilige Restriktion zwischen 2 Gitterebenen bentigt werden.
// Es wird der Rand und das Innere sowie der echte Rand bergeben - hier aber nur mit Gitterpunkten darunter.
            if(i<h_min)
                {
                restriktionen[i].f_innen_oben = paralleles_rechnen[i_plus_1].f_innen_klein;

                restriktionen[i].g_innen_oben = paralleles_rechnen[i_plus_1].g_innen_klein;
                restriktionen[i].anzahl_innen_oben = paralleles_rechnen[i_plus_1].anzahl_innen_klein;

                restriktionen[i].f_rand_innen_oben = paralleles_rechnen[i_plus_1].f_rand_innen_klein;
                restriktionen[i].g_rand_innen_oben = paralleles_rechnen[i_plus_1].g_rand_innen_klein;
                restriktionen[i].anzahl_rand_innen_oben = paralleles_rechnen[i_plus_1].anzahl_rand_innen_klein;

// Kommentar: Die Restriktion wird oben durchlaufen. Deswegen zhlen hier nur die Punkte, die einerseits darunter Punkte haben, und andererseits
// echte Randpunkte sind. Entsprechend der Klasse Gitter sind das im adaptiven Bereich die Punkte mit '...rand_innen_klein_echter_rand', vgl. die Funktion
// bestimme_innenpunkte_mit_klein der Klasse Gitter. Fr nicht adaptive Gitter sind es die Punkte '...rand_innen_echter_rand', siehe 15 Zeilen tiefer.
                restriktionen[i].f_rand_innen_oben_echter_rand = paralleles_rechnen[i_plus_1].f_rand_innen_klein_echter_rand;
                restriktionen[i].g_rand_innen_oben_echter_rand = paralleles_rechnen[i_plus_1].g_rand_innen_klein_echter_rand;
                restriktionen[i].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[i_plus_1].anzahl_rand_innen_klein_echter_rand;
                }
            else
// Es wird der Rand und das Innere sowie der echte Rand bergeben - hier aber fr alle Gitterpunkte.
                {
                restriktionen[i].f_innen_oben = paralleles_rechnen[i_plus_1].f_innen;

                restriktionen[i].g_innen_oben = paralleles_rechnen[i_plus_1].g_innen;
                restriktionen[i].anzahl_innen_oben = paralleles_rechnen[i_plus_1].anzahl_innen;

                restriktionen[i].f_rand_innen_oben = paralleles_rechnen[i_plus_1].f_rand_innen;
                restriktionen[i].g_rand_innen_oben = paralleles_rechnen[i_plus_1].g_rand_innen;
                restriktionen[i].anzahl_rand_innen_oben = paralleles_rechnen[i_plus_1].anzahl_rand_innen;

                restriktionen[i].f_rand_innen_oben_echter_rand = paralleles_rechnen[i_plus_1].f_rand_innen_echter_rand;
                restriktionen[i].g_rand_innen_oben_echter_rand = paralleles_rechnen[i_plus_1].g_rand_innen_echter_rand;
                restriktionen[i].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[i_plus_1].anzahl_rand_innen_echter_rand;
                }

            }
        else
            {
            restriktionen[i].f_innen_oben = paralleles_rechnen[i_plus_1].f_innen_2;

            restriktionen[i].g_innen_oben = paralleles_rechnen[i_plus_1].g_innen_2;
            restriktionen[i].anzahl_innen_oben = paralleles_rechnen[i_plus_1].anzahl_innen_2;

            restriktionen[i].f_rand_innen_oben = paralleles_rechnen[i_plus_1].f_rand_innen_2;
            restriktionen[i].g_rand_innen_oben = paralleles_rechnen[i_plus_1].g_rand_innen_2;
            restriktionen[i].anzahl_rand_innen_oben = paralleles_rechnen[i_plus_1].anzahl_rand_innen_2;
            }
        restriktionen[i].initialisieren(n_hilfe, m_hilfe, paralleles_rechnen[i].farbenfeld, rang, i, paralleles_rechnen[i].selbstnachbarn, f_s, g_s);
        // allokiert keinen Speicher

        n_hilfe = (n_hilfe+1)/2;
        m_hilfe = (m_hilfe+1)/2;

// Kommentar: Anlegen der Zeiger fr die Variablen oben und unten der beiden Gitterebenen.
//        restriktionen[i].u0_oben = paralleles_rechnen[i_plus_1].u0;
        restriktionen[i].Iu0_oben = paralleles_rechnen[i_plus_1].Iu0;
        restriktionen[i].u0_oben = paralleles_rechnen[i_plus_1].u0;
        restriktionen[i].u0_unten = paralleles_rechnen[i].u0;

        restriktionen[i].r0_oben = paralleles_rechnen[i_plus_1].r0;
        restriktionen[i].r0_unten = paralleles_rechnen[i].r0;

        restriktionen[i].ILu0_oben = paralleles_rechnen[i_plus_1].ILu0;
        restriktionen[i].Lu0_unten = paralleles_rechnen[i].Lu0;

        restriktionen[i].rS0_oben = paralleles_rechnen[i_plus_1].rS0;

        restriktionen[i].f0_oben = paralleles_rechnen[i_plus_1].If0;
        restriktionen[i].f0_unten = paralleles_rechnen[i].f0;

        restriktionen[i].v6_unten = paralleles_rechnen[i].v6;
        restriktionen[i].v7_unten = paralleles_rechnen[i].v7;
        restriktionen[i].v8_unten = paralleles_rechnen[i].v8;
        restriktionen[i].vf_2_unten = paralleles_rechnen[i].vf_2;
        restriktionen[i].v9_oben = paralleles_rechnen[i_plus_1].v9;
        }

    }

// Kommentar: Der Speicher fr die Prolongationen wird freigegeben.
void ZyklusRechnen::entferne_prolongationswerte(void)
    {
    prolongationen[0].finalisiere(); // beim restringieren?
    delete prolongationen;
    }

// Kommentar: Die Prolongationen fr je 2 Gitterebenen werden angelegt. Dazu gehren Zeiger auf Gitterpunktlisten
// sowie Zeiger von Gittervariablen, so dass eine Prolongation per Befehl erfolgen kann.
void ZyklusRechnen::setze_prolongationswerte(void)
// wird finalisiert
    {


// Kommentar: Der Speicher fr die Prolongationen der Ebenen 0 bis h_gesamt-1 wird angelegt.
    prolongationen = new Prolongation [h_gesamt];

    for(i=0; i<h_gesamt-1; i++)
        {
        prolongationen[i].untere_gitterebene = i;
//        prolongationen[i].initialisiere(n_h[i], m_h[i], &(neuer_punkt), &(da_zr));
        prolongationen[i].initialisiere(n_h[i], m_h[i], &(neuer_punkt_ebenen[i]), &(da_zr));
        i_plus_1 = i+1;

// Kommentar: Die Gitterpunktlisten des unteren Gitters werden angelegt.
        if(1==1)
            {
            prolongationen[i].rang = rang;

            prolongationen[i].f_innen_unten = paralleles_rechnen[i].f_innen;
            prolongationen[i].g_innen_unten = paralleles_rechnen[i].g_innen;
            prolongationen[i].anzahl_innen_unten = paralleles_rechnen[i].anzahl_innen;

            prolongationen[i].f_rand_innen_unten = paralleles_rechnen[i].f_rand_innen;
            prolongationen[i].g_rand_innen_unten = paralleles_rechnen[i].g_rand_innen;
            prolongationen[i].anzahl_rand_innen_unten = paralleles_rechnen[i].anzahl_rand_innen;

            prolongationen[i].f_rand_innen_unten_echter_rand = paralleles_rechnen[i].f_rand_innen_echter_rand;
            prolongationen[i].g_rand_innen_unten_echter_rand = paralleles_rechnen[i].g_rand_innen_echter_rand;
            prolongationen[i].anzahl_rand_innen_unten_echter_rand = paralleles_rechnen[i].anzahl_rand_innen_echter_rand;
            }
        else
            {
            prolongationen[i].f_innen_unten = paralleles_rechnen[i].f_innen_2;
            prolongationen[i].g_innen_unten = paralleles_rechnen[i].g_innen_2;
            prolongationen[i].anzahl_innen_unten = paralleles_rechnen[i].anzahl_innen_2;

            prolongationen[i].f_rand_innen_unten = paralleles_rechnen[i].f_rand_innen_2;
            prolongationen[i].g_rand_innen_unten = paralleles_rechnen[i].g_rand_innen_2;
            prolongationen[i].anzahl_rand_innen_unten = paralleles_rechnen[i].anzahl_rand_innen_2;
            }

        if(h_kappe!=-1) // Wichtig, sonst Fehlermeldung. 01.09.2014
            {
            prolongationen[h_kappe].initialisiere_kappe(f_kappe, g_kappe, anzahl_kappe);
            }

// Kommentar: Die Variablen der 2 beteiligten Gitterebenen werden in die Zeiger dafr bertragen.
        prolongationen[i].y0_oben = paralleles_rechnen[i_plus_1].e0;
        prolongationen[i].y0_unten = paralleles_rechnen[i].e0;
        prolongationen[i].u0_oben = paralleles_rechnen[i_plus_1].u0;
        prolongationen[i].e0_unten = paralleles_rechnen[i].e0;
        prolongationen[i].u0_unten = paralleles_rechnen[i].u0;
        prolongationen[i].v6_unten = paralleles_rechnen[i].v6;
        prolongationen[i].v9_oben = paralleles_rechnen[i_plus_1].v9;

        prolongationen[i].selbstnachbarn = paralleles_rechnen[i].selbstnachbarn;

        prolongationen[i].markierungsfeld = markierungsfeld;
        }
    }


// Kommentar: Das Markierungsfeld wird auf false gesetzt, indem es fr die in der Liste (merkierung_f,markierung_g)(i)
// auftauchenden Punkte auf false gesetzt wird.
void ZyklusRechnen::reset_markierungsfeld(void)
    {
    for(i=0; i<markierungs_index; i++)
        {
        markierungsfeld[markierung_f[i]][markierung_g[i]] = false;
        }
    markierungs_index = 0;
    }

// Kommentar: Dieses ist eine Debug - Funktion. Durch das Warten - je nach Rang - werden die cout - Augaben in der
// Reihe der Rnge ausgegeben. Das schafft Struktur in der Ausgabe.
void ZyklusRechnen::warten(void)
    {
#ifdef WARTEN
    for(i=0; i<rang*4000000; i++)
        {
        cout << "";
        }
#endif
    }

// Kommentar: Die Folgenden Funktionen sind zwar relativ aktuell, also prinzipiell korrekt. Aber sie gehren zu der Variante
// des Kommunizierens whrend des Rechnens Innen, bei der man die aktuellen Werte auch auf dem Auenrand kennen muss.
// Deswegen mte beim Lastausgleich immer der Auenrand mit transferiert werden. Aus dem Grunde wurde die
// andere Variante gewhlt mit aktuellen Werten nur auf dem Gitter selber, und diese Funktionen hier bleiben unkommentiert.



// Kommentar: Hier erfolgt die Vorglttung sequentiell. Insbesondere nach dem Jacoby - Verfahren.
// Da sie sequentiell ist, erfolgt keine Randkommunikation.
void ZyklusRechnen::vorglaettung_sequentiell(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif
        {
        paralleles_rechnen[ebene].vorglaetter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].vorglaetter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
    strcpy(zeichenkette, "vorglaettung sequentiell");
    u0_ausgeben(zeichenkette);
#endif
#endif
    }

// Kommentar: Hier erfolgt die Glttung nach dem red - black - Gauss - Seidel - Verfahren. Da sie sequentiell ist,
// erfolgt nirgends eine Randkommunikation. Die Ebene wird unterschieden nach h_kappe - ja oder nein.
// Sie wird im Falle des normalen Mehrgitteralgorithmus verwendet.
void ZyklusRechnen::vorglaettung_red_black_sequentiell(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

    if(ebene!=h_kappe)
        {
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Black-rechnen");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 85+ii*5);
#endif

        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

#ifdef DAFWV
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 85+ii*5 + 2);
#endif

        }
    else
        {
        paralleles_rechnen[ebene].vorglaetter_black(f_kappe, g_kappe, anzahl_kappe);

#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Black-rechnen");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, U0, zeichenkette, 85+ii*5);
#endif

        paralleles_rechnen[ebene].vorglaetter_red(f_kappe, g_kappe, anzahl_kappe);

#ifdef DAFWV
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, U0, zeichenkette, 85+ii*5 + 2);
#endif

        }
    }

// Kommentar: Hier erfolgt die Glttung nach dem red - black - Gauss - Seidel - Verfahren. Da sie sequentiell ist,
// erfolgt nirgends eine Randkommunikation. Sie wird im Falle des FAS auf allen Ebenen verwendet.
void ZyklusRechnen::vorglaettung_sequentiell_red_black(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

        {
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }
    }

// Kommentar: Das Residuum wird sequentiell berechnet. Dabei wird die Gitterebene h_kappe besonders behandelt.
// Bei diesem sequentiellen Algorithmus kommt es zu keiner Randkommunikation.
void ZyklusRechnen::berechne_residuum_sequentiell(void)
    {
    if(ebene==h_kappe)
        {
        paralleles_rechnen[ebene].residuum_berechnen(f_kappe, g_kappe, anzahl_kappe);
        }
    else
        {
        paralleles_rechnen[ebene].residuum_berechnen(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].residuum_berechnen(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }
    }

// Kommentar: Hier werden - wie es beim FAS notwendig ist - u0 als Injektion und r0 als Full Weightimg einer Restriktion
// unterworfen. Bei diesem sequentiellen Algorithmus kommt es zu keiner Randkommunikation. Offenbar wird diese
// Funktion verwendet, wenn auf allen Ebenen das adaptive Schema, bzw. auf nicht adaptiven Ebenen das FAS berechnet wird.
void ZyklusRechnen::beide_restriktionen_sequentiell(void)
    {
#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen !
#endif
        {
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen;
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand;
        }
    restriktionen[ebene].injektion_nach_u0_und_Iu0();
    restriktionen[ebene].full_weighting_rand_innen_r0();
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_sequentiell: Nach restriktionen[ebene].full_weighting_rand_innen_r0();" << endl;
#endif
#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen !
#endif
        {
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen;
        }
    restriktionen[ebene].full_weighting_innen_r0();

    }

// Kommentar: Die grobe rechte Seite wird sequentiell berechnet, mit einem vollen Gitter darunter, weil die sequentiellen
// Ebenen oberhalb der Kappe erfolgen. Keine Randkommunikation bei sequentiellen Algorithmen.
void ZyklusRechnen::berechne_rechte_seite_sequentiell(void)
    {
    paralleles_rechnen[ebene].berechne_grobe_rechte_seite_volles_gitter_darunter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    paralleles_rechnen[ebene].berechne_grobe_rechte_seite_volles_gitter_darunter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " rS0 ausgeben sequentielle Berechnung ");
    rS0_ausgeben(zeichenkette);
#endif
    }

// Kommentar: Es folgt der Jacoby - Lser, der dem Jacoby - Gltter entspricht. Keine Randkommunikation wegen
// des sequentiellen Rechnens. Bei einem Jaqcoby - Schritt mssen die Werte zwischengespeichert und am
// Ende zurckkopiert werden.
void ZyklusRechnen::loeser_sequentiell(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

        {
        paralleles_rechnen[ebene].loeser(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].loeser(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }

    }

// Kommentar: e0 wird gem der Mehrgitterformel sequentiell berechnet - also auch ohne Randkommunikation.
void ZyklusRechnen::berechne_e0_sequentiell(void)
    {
    paralleles_rechnen[ebene].berechne_e0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    paralleles_rechnen[ebene].berechne_e0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    }

// Kommentar: Hier erfolgen die sequentiellen Prolongationen. Keine Randkommunikation wegen eines sequentiellen Algorithmus.
void ZyklusRechnen::prolongationen_sequentiell(void)
    {
// Kommentar: Je nachdem, ob die untere Ebene die Kappe ist, oder nicht, erfolgen die Prolongationen getrennt.
    if(ebene_minus_1==h_kappe)
        {
// Kommentar: Prolongationen fr die Kappe.
        prolongationen[ebene_minus_1].bi_quadratische_interpolation_kappe();
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        cout << " VWX prolongation kappe rang " << rang << endl;
#endif
        // Das stimmt sowohl fr adaptiv wie nicht adaptiv. Vorausssetzung ist nur die Kappe. 01.09.2014
        return;
        }
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " BCDE prolongationen_sequentiell 1 rang " << rang << " ebene_minus_1 " << ebene_minus_1 << endl;
#endif
// Kommentar: Die Anzahlen werden kopiert in die Klasse prolongationen der unteren Ebene.
        {
        prolongationen[ebene_minus_1].anzahl_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten_echter_rand = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen_echter_rand;
        }
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " BCDE prolongationen_sequentiell 2 rang " << rang << endl;
#endif
#ifdef AUSGABEN_PROLONGATION
    prolongationen[ebene_minus_1].ausgabe_neue_punkte(ebene_minus_1);
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " BCDE prolongationen_sequentiell 3 rang " << rang << " anzahl " << prolongationen[ebene_minus_1].anzahl_rand_innen_unten << endl;
#endif
// Kommentar: Die Prolongationen am Rand und im Inneren werden durchgefhrt.
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_rand();
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " BCDE prolongationen_sequentiell 4 rang " << rang << endl;
#endif
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_innen();
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " BCDE prolongationen_sequentiell 5 rang " << rang << endl;
    cout << " VWX prolongation nicht kappe rang " << rang << endl;
#endif
    }

// Kommentar: Die sequentielle Nachglttung erfolgt. Keine Randkommunikation
void ZyklusRechnen::nachglaettung_sequentiell(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

// Kommentar: Bei der Kappe hat man eigene Punktmengen f_kappe, g_kappe.
// Kommentar: In beiden Fllen muss man woanders hin rechnen und zurckkopieren, weil dieses bei
// Jacoby so gemacht werden muss.
    if(ebene == h_kappe)
        {
        paralleles_rechnen[ebene].nachglaetter(f_kappe, g_kappe, anzahl_kappe);
        paralleles_rechnen[ebene].rueckkopieren_u0(f_kappe, g_kappe, anzahl_kappe);
        }
    else
        {
        paralleles_rechnen[ebene].nachglaetter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].nachglaetter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }

    }

// Kommentar: Die Nachglttung in der red - black - Gauss - Seidel - Berechnung.
void ZyklusRechnen::nachglaettung_sequentiell_red_black(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

// Kommentar: Zuerst geschieht die Black - Nachglttung, und dann die Red Nachglttung.
// Dabei werden bei der Kappe die Punktmengen (f_kappe,g_kappe) verwendet. Andernfalls die
// Punktmengen fr den Rand und das Innere.
    if(ebene == h_kappe)
        {
        paralleles_rechnen[ebene].nachglaetter_black(f_kappe, g_kappe, anzahl_kappe);
        paralleles_rechnen[ebene].nachglaetter_red(f_kappe, g_kappe, anzahl_kappe);
        }
    else
        {
        paralleles_rechnen[ebene].nachglaetter_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].nachglaetter_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        paralleles_rechnen[ebene].nachglaetter_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].nachglaetter_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }
    }

// Kommentar: Hier werden alle Mehrgitterschritte gemacht, von einer Ebene zur nchsten Ebene - im sequentiellen Fall.
void ZyklusRechnen::MLAT_1_sequentiell(int k)
    {
    ebene = k;

#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Vorglaettung-seq-mlat1");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, RS0, zeichenkette, 60);
#endif

#ifdef DAFWV
    strcpy(zeichenkette, "Vor-Vorglaettung-seq-mlat1");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 80);
#endif

// Kommentar: Zuerst geschieht die Glttung - je nach Fall Gauss Seidel (red - black) oder Jacoby (2. Fall)
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_sequentiell_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_sequentiell();
            }
        }

#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Vorglaettung");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 100);
#endif

// Kommentar: Danach wird das Residuum berechnet.
    berechne_residuum_sequentiell();

// Kommentar: Danach werden die Restriktionen ausgefhrt.
    beide_restriktionen_sequentiell();
    ebene = k+1; // Hinzugefgt, weil meine Vermutung das fr korrekt hlt.
// Und nach den Restriktionen kann die rechte Seite eine Ebene hher berechnet werden.
    berechne_rechte_seite_sequentiell();
    }

// Kommentar: Hier wird dasselbe wie in obiger Funktion 'MLAT_1_sequentiell' gemacht, nur ab den Restriktionen
// Die Schritte davor werden nmlich parallel bearbeitet, wenn MLAT_1b_sequentiell_FAS berechnet wird.
// Die Kommentare vgl. man mit MLAT_1_sequentiell.
void ZyklusRechnen::MLAT_1b_sequentiell_FAS(int k)
// Man achte auf die Punktemengen 6.10.14
    {
    ebene = k;

    strcpy(zeichenkette,"1");
    ausgeben385(zeichenkette);

    berechne_residuum_sequentiell();

    strcpy(zeichenkette,"2");
    ausgeben385(zeichenkette);

#ifdef DAFWV
    strcpy(zeichenkette, "Residuum-berechnen");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 105);

    strcpy(zeichenkette, "Sequentiell-nach-Kappe");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, R0, zeichenkette, 110);
#endif
    // Punktemengen auf Ebene Kappe: f_kappe, g_kappe
    strcpy(zeichenkette,"2.5");
    ausgeben385(zeichenkette);
    beide_restriktionen_sequentiell_FAS(); // Definition am 6.10.14

    strcpy(zeichenkette,"3");
    ausgeben385(zeichenkette);

#ifdef DAFWV
    strcpy(zeichenkette, "Restriktion");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene+1, UP, R0, zeichenkette, 115);
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene+1, UP, IU0, zeichenkette, 120);
#endif

    ebene = k+1; // Hinzugefgt, weil meine Vermutung das fr korrekt hlt.
    berechne_rechte_seite_sequentiell(); // Da eine Ebene hher, stimmt das frs ganze Gitter.
    strcpy(zeichenkette,"4");
    ausgeben385(zeichenkette);
    }

// Kommentar: Eine Ausgabe die nur frs Debugging bentigt wurde.
void ZyklusRechnen::ausgeben385(char * text)
    {
    }

// Kommentar: Hier wird sequentiell mit dem normalen Mehrgitterverfahren gerechnet.
// Die Unterschiede zu MLAT_1_sequentiell ein paar Zeilen hher:
// 1. Die Restriktion erfolgt nur fr das Residuum, whrend u0 oben genullt wird durch
// restriktion_r0rS0_und_u0_reset_sequentiell().
// Und es wird keine rechte Seite berechnet, da dies beim normalen Mehrgitterverfahren nicht ntig ist.
void ZyklusRechnen::MLAT_1_sequentiell_nicht_adaptiv(int k)
    {
    ebene = k;
    ebene_plus1 = k+1;

#ifdef DAFWV
    if(ebene==h_kappe)
        {
        strcpy(zeichenkette, "Nach-Vorglaettung-seq-nicht_adaptiv-kappe");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, RS0, zeichenkette, 60);
        }
    else
        {
        strcpy(zeichenkette, "Nach-Vorglaettung-seq-nicht_adaptiv-nicht-kappe");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, RS0, zeichenkette, 60);
        }
#endif

#ifdef DAFWV
    strcpy(zeichenkette, "Vor-Vorglaettung");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 80);
#endif

// Kommentar: Zuerst wird geglttet.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_red_black_sequentiell();
            }
        }
    else
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_sequentiell();
            }
        }

#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Vorglaettung");
    if(ebene == h_kappe)
        {
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, U0, zeichenkette, 100);
        }
    else
        {
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 100);
        }
#endif

// Kommentar: Dann wird das Residuum berechnet.
    berechne_residuum_sequentiell();

#ifdef DAFWV
    strcpy(zeichenkette, "Nach_berechne_residuum");
    if(ebene == h_kappe)
        {
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, R0, zeichenkette, 120);
        }
    else
        {
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 120);
        }
#endif

// Kommentar: Dann erfolgt die Restriktion des Residuums, und fertig.
    restriktion_r0rS0_und_u0_reset_sequentiell();
    ebene = k+1; // Hinzugefgt, weil meine Vermutung das fr korrekt hlt. 3.9.14: Diese Zeile kann auskommentiert werden.
    }

// Kommentar: Hier wird auf der grbsten Ebene durch Gauss - Seidel oder Jacoby geglttet.
void ZyklusRechnen::MLAT_2_sequentiell(int k)
    {
    ebene = k;

#ifdef DAFWV
    strcpy(zeichenkette, "Vor-Loeser");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, TOP, U0, zeichenkette, 10);
#endif
#ifdef DAFWV
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, TOP, RS0, zeichenkette, 15);
#endif

// Kommentar: Es werden, je nach Fall, solve_anzahl Mal die jeweiligen Lser aufgerufen.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<solve_anzahl; ii++)
            {
            cout << " PQR vor loeser_red_black in MLAT2_seq / rang " << rang << endl;
            loeser_red_black_sequentiell();
            cout << " PQR nach loeser_red_black in MLAT2_seq / rang " << rang << endl;
            }
        }
    else
        {
        for(ii=0; ii<solve_anzahl; ii++)
            {
            cout << " PQR vor loeser in MLAT2_seq / rang " << rang << endl;
            loeser_sequentiell();
            cout << " PQR nach loeser in MLAT2_seq / rang " << rang << endl;
            }
        }
#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Loeser");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, TOP, U0, zeichenkette, 20);
#endif
    }

// Kommentar: Hier geschieht der Schritt, vom grberen auf die feinere Ebene, zusammen mit MLAT_4_sequentiell.
void ZyklusRechnen::MLAT_3_sequentiell(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
    berechne_e0_sequentiell();
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-3-seq");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, DOWN, E0, zeichenkette, 22); // 08.10.2014
#endif
    cout << " BCDE Vor prolongationen sequentiell rang " << rang << endl;
// Kommentar: Dann wird die Prolongation durchgefhrt.
    prolongationen_sequentiell();
    cout << " BCDE Nach prolongationen sequentiell rang " << rang << endl;
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-3-seq"); // 01.09.2014
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene_minus_1, DOWN, E0, zeichenkette, 25); // 01.09.2014
#endif
// Kommentar: Es kommt zur Grobgitterkorrektur auf dem feinen Gitter. Es fehlt nur noch die Nachglttung, was
// in MLAT4 geschieht.
    korrektur_auf_feinem_gitter();
#ifdef DAFWV
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene_minus_1, DOWN, U0, zeichenkette, 28); // 01.09.2014
#endif
    }

// Kommentar: Es werden dieselben Schritte wie in MLAT_3_sequentiell gemacht, bis auf die Grobgitterkorrektur
// Die wird dann nmlich parallel mit MLAT_3b_oben_FAS durchgefhrt.
// Die Kommentare wie bei MLAT_3_sequentiell.
void ZyklusRechnen::MLAT_3a_sequentiell_FAS(int k)
// Was ist mit den Punktemengen? 6.10.14
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
    berechne_e0_sequentiell(); // Auf der Ebene darber

    prolongationen_sequentiell(); // Das soll frs ganze Gitter gelten, 6.10.14
    // Ist schon richtig gemacht, vgl. die Funktion, fr Gitter(h_kappe) die richtige Prolongation.
    }

// Kommentar: Es wird nach dem sequentiellen MLAT_3a_sequentiell_FAS die parallele Grobgitterkorrektur durchgefhrt.
void ZyklusRechnen::MLAT_3b_oben_FAS(int k)
// Was ist mit den Punktemengen? 6.10.14
    {
    ebene_minus_1 = k-1;
// Kommentar: Das ist die parallele Grobgitterkorrektur.
    korrektur_auf_feinem_gitter_ohne_kappe();
    }

// Kommentar: Hier wird auch die Funktion MLAT 3 zerschnitten - in die Funktionen MLAT_3a_sequentiell im FAS - Fall,
// bzw. MLAT_3a_sequentiell_nicht_adaptiv im normalen Mehrgitterfall, sowie der ergnzenden Funktion
// MLAT_3b_sequentiell.
void ZyklusRechnen::MLAT_3a_sequentiell(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
// Kommentar: e0 wird berechnet.
    berechne_e0_sequentiell();
    }

// Kommentar: Vgl. den Kommentar zu MLAT_3a_sequentiell.
void ZyklusRechnen::MLAT_3a_sequentiell_nicht_adaptiv(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv-Anfang rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3a-oben-nicht_adaptiv_Anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 5);
#endif
// Im Gegensatz zu MLAT_3a_sequentiell wird hier e0 = u0 gerechnet.
    kopiere_u0_e0_oben();
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3a-oben-nicht-adaptiv");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, E0, zeichenkette, 10);
#endif
    }

// Kommentar: Hier kommen die MLAT_3_sequentiell - Berechnungen nach der e0 - Berechnung
void ZyklusRechnen::MLAT_3b_sequentiell(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;

// Kommentar: Zuerst die sequentielle Prolongation.
    prolongationen_sequentiell();
    if(h_kappe==ebene_minus_1)
        {
#ifdef DAFWV
//    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv rang " << rang << endl;
        strcpy(zeichenkette, "MLAT-3b");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene_minus_1, DOWN, E0, zeichenkette, 15); // 01.09.2014
#endif
        }
    else
        {
#ifdef DAFWV
//    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv rang " << rang << endl;
        strcpy(zeichenkette, "MLAT-3b");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene_minus_1, DOWN, E0, zeichenkette, 15); // 01.09.2014
#endif
        }

// Kommentar: Dann kommt die Grobgitterkorrektur
    korrektur_auf_feinem_gitter();
    if(h_kappe==ebene_minus_1)
        {
#ifdef DAFWV
        strcpy(zeichenkette, "MLAT-3b-sequentiell");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene_minus_1, DOWN, U0, zeichenkette, 20);
#endif
        }
    else
        {
#ifdef DAFWV
        strcpy(zeichenkette, "MLAT-3b-sequentiell");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene_minus_1, DOWN, U0, zeichenkette, 20);
#endif
        }
    }

// Kommentar: MLAT_4 ergnzt MLAT_3, egal, ob zerschnitten in MLAT_3a und MLAT_3b, oder MLAT_3 in einem Schritt.
// Danach ist man eine Ebene feiner.
void ZyklusRechnen::MLAT_4_sequentiell(int k)
    {
    ebene = k;

#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-4-sequentiell-anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, DOWN, U0, zeichenkette, 30);
#endif

// Kommentar: Je nach Gauss - Seidel oder Jacoby - Methode erfolgt die Nachglttung mue2 - fach.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue2; ii++)
            {
            nachglaettung_sequentiell_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue2; ii++)
            {
            nachglaettung_sequentiell();
            }
        }
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-4-sequentiell-ende");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, DOWN, U0, zeichenkette, 40);
#endif
    }

// Kommentar: MLAT_1_oben ist die parallele Variante zu MLAT_1_sequentiell, aber im nicht adaptiven Bereich, d.h.
// mit vollstndigen Gittern. Man kommt jeweils eine Ebene hher - parallel, aber mit vollen Gittern.
void ZyklusRechnen::MLAT_1_oben(int k)
    {
    ebene = k;

#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben anfang ");
#endif

// Kommentar: Zuerst wird wieder geglttet. Je nach Gauss - Seidel und Jacoby getrennt. Die
// Funktionen ohne den Suffix sequentiell sind parallele Funktionen.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung();
            }
        }
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " Nach Vorglaettung ");
    u0_ausgeben(zeichenkette);
    u0_ausgeben_fwv(UP, zeichenkette);
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben nach vorglttung ");
#endif

// Kommentar: Das Residuum wird parallel berechnet - aber nicht adaptiv.
    berechne_residuum();
#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben nach berechne residuum ");
#endif
// Kommentar: Es erfolgen die Restriktionen parallel, und im nicht adaptiven Bereich, aber mit dem adaptiven bzw. FAS - Schema.
// In diesem Fall sind die Restriktionen sowohl frs Residuum als auch u0 zu machen.
    beide_restriktionen_oben();

#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben ende ");
#endif
    ebene = k+1;
#ifdef DAFWV
    strcpy(zeichenkette, "Residuum-Restriktion-berechnen");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 110);
    strcpy(zeichenkette, "Restriktion");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv_kappe(ebene, UP, IU0, zeichenkette, 120);
#endif
// Kommentar: Wie beim FAS - oder adaptiven Schema wird die rechte Seite berechnet - wegen dem Suffix oben aber
// im nicht adaptiven Bereich.
    berechne_rechte_seite_oben();
    }

// Kommentar: Wie bei MLAT_1_oben wird hier im nicht adaptiven Bereich parallel das FAS Schema fr eine Gitterebene auf
// die nchste Gitterebene berechnet. Es wird aber nur die Vorglttung gemacht. Der Teil b wird sequentiell berechnet in
// MLAT_1b_sequentiell_FAS.
void ZyklusRechnen::MLAT_1a_oben_FAS(int k)
    {
    ebene = k;

#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben anfang ");
#endif

// Kommentar: Hier geschieht die parallele Glttung mue1 Mal - je nachdem Gauss - Seidel oder die Jacoby - Methode.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung();
            }
        }
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " Nach Vorglaettung ");
    u0_ausgeben(zeichenkette);
    u0_ausgeben_fwv(UP, zeichenkette);
#endif
#ifdef U0_TESTEN
    strcpy(zeichenkette, "MLAT_1_oben nach vorglttung ");
    u0_testen(zeichenkette);
#endif
    }

// Kommentar: Ist dasselbe wie MLAT_1_oben, nur mit dem normalen Mehrgitterschema, also insbesondere
// nur die Restriktion des Residuums.
void ZyklusRechnen::MLAT_1_oben_nicht_adaptiv(int k)
    {
    ebene = k;
    ebene_plus1 = k+1;

#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben anfang ");
#endif
        {
#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Vorglaettung-oben-nicht-adaptiv-zum-ersten");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, RS0, zeichenkette, 50);
#endif
        } // 3.9.14: Man skippt sonst.
// Die Idee: sequentiell beides ausgeben, mit transfer oder ohne.
#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Vorglaettung-oben-nicht-adaptiv");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, RS0, zeichenkette, 60);
#endif

#ifdef DAFWV
    strcpy(zeichenkette, "Vor-Vorglaettung-oben-nicht-adaptiv");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 80);
#endif

// Kommentar: Zuerst wieder die Vorglttung.
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Vor Glaettung");
            zeitausgabe(zeichenkette);
#endif
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung();
            }
        }
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Nach Glaettung");
            zeitausgabe(zeichenkette);
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Vorglaettung");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 100);
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " Nach Vorglaettung ");
    u0_ausgeben(zeichenkette);
#endif
#ifdef U0_TESTEN
    strcpy(zeichenkette, "MLAT_1_oben nach vorglttung ");
    u0_testen(zeichenkette);
#endif

// Kommentar: Dann erfolgt die Berechnung des Residuums.
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Vor berechne_Residuum");
            zeitausgabe(zeichenkette);
#endif
    berechne_residuum();
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Nach berechne_Residuum");
            zeitausgabe(zeichenkette);
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "Nach_berechne_residuum");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 120);
#endif

#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben nach berechne residuum ");
#endif

#ifdef AUSGABE_UVW
    cout << " UVW Vor restriktion_r0rS0_und_u0_reset_oben / rang " << rang << endl;
#endif
// Kommentar: Dann erfolgt die Restriktion des Residuums. u0 wird auf 0 gesetzt.

#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Vor Restriktion");
            zeitausgabe(zeichenkette);
#endif
    restriktion_r0rS0_und_u0_reset_oben();
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Nach Restriktion");
            zeitausgabe(zeichenkette);
#endif
#ifdef AUSGABE_UVW
    cout << " Nach restriktion_r0rS0_und_u0_reset_oben / rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_1_oben ende ");
#endif
    ebene = k+1;
    }

// Kommentar: Die Abarbeitung des Zyklus hin zum grberen Gitter, wobei Funktionen der von mir genderten Version der Implementierung von Herrn Hess der Shallow Water Equations
// aufgerufen werden. Hier wird die Laufzeit abgebildet - nicht die Werte.
void ZyklusRechnen::MLAT_1_SWE(int k)
    {
    ebene = k;
// Kommentar: Hier wird ein quivalent von mir zur Funktion solve-pre der Implementierung von Herrn Hess der SWE aufgerufen.
    loesen_vorher(k);

// Kommentar: Es folgt der Gltter der von mir genderten Version der Implementierung von Herrn Hess der SWE.
    for(ii=0; ii<mue1; ii++)
        {
        glaettung_red_black_swe();
        }
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " Vor restriktion_swe rang " << endl;
#endif
// Kommentar: Am Ende wird eine Restriktionsfunktion der von mir genderten Version der Implementierung von Herrn Hess der SWE aufgerufen.
    restriktion_swe(k);
#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " Nach Restriktion SWE rang " << rang << endl;
#endif
    }

// Kommentar: MLAT2 dient dem Lsen der Gleichung auf dem grbsten Gitter. Dieses erfolgt parallel, und natrlich nicht
// im adaptiven Bereich.
void ZyklusRechnen::MLAT_2_oben(int k)
    {
    ebene = k;

#ifdef U0_TESTEN
    u0_testen("MLAT_2_oben anfang ");
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " vor MLAT_2_oben");
    u0_ausgeben(zeichenkette);
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "Vor-Loeser");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, TOP, U0, zeichenkette, 10);
#endif
#ifdef DAFWV
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, TOP, RS0, zeichenkette, 15);
#endif

// Kommentar: Der Lser wird solve_anzahl Mal aufgerufen. Je nachdem bzgl. der Gauss - Seidel oder der Jacoby - Lser.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<solve_anzahl; ii++)
            {
            loeser_red_black();
            }
        }
    else
        {
        for(ii=0; ii<solve_anzahl; ii++)
            {
            loeser();
            }
        }

#ifdef DAFWV
    strcpy(zeichenkette, "Nach-Loeser");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, TOP, U0, zeichenkette, 20);
#endif

#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " nach MLAT_2_oben");
    u0_ausgeben(zeichenkette);
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_2_oben anfang ");
#endif
    }

// Kommentar: Hier kommt das Lsen auf dem grbsten Gitter, aber in meiner Abnderung von Formeln in Bezug auf die Implementation von Herrn Hess der Shallow Water Equations.
void ZyklusRechnen::MLAT_2_SWE(int k)
    {
    ebene = k;

// Kommentar: solve_anzahl hufig wird der Gltter aufgerufen.
    for(ii=0; ii<solve_anzahl; ii++)
        {
        glaettung_red_black_swe();
        }
    }

// Kommentar: MLAT_3 plus MLAT_4 mit dem Suffix 'oben' machen einen Mehrgitterschritt des FAS - Schemas im nichtadaptiven Bereich.
void ZyklusRechnen::MLAT_3_oben(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
#ifdef U0_TESTEN
    u0_testen("MLAT_3_oben anfang ");
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3_oben-Anfang rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3-oben-Anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 5);
#endif
// Kommentar: Es wird e0 berechnet.
    berechne_e0_oben();
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3_oben rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3-oben");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, E0, zeichenkette, 10);
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " nach berechne_e0_oben ");
    ebene_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach berechne in MLAT_3_oben");
    e0_ausgeben(zeichenkette);
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " vor prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
#endif
// Kommentar: Nach der Berechnung von e0 knnen die Prolongationen vorgenommen werden.
    prolongationen_oben();
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " nach prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
    strcpy(zeichenkette, " Nach prolongation oben noch Mal oben ");
    e0_ausgeben(zeichenkette);
    strcpy(zeichenkette, " Nach prolongation in MLAT_3_oben");
    e0_ausgeben_minus_1(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Prolongation oben / Rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Vor Korrektur ");
    u0_ausgeben_minus_1(zeichenkette);
#endif
// Kommentar: Am Ende von MLAT_3 steht die Grobgitterkorrektur auf dem feinen Gitter.
    korrektur_auf_feinem_gitter();
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach Korrektur ");
    e0_ausgeben_minus_1(zeichenkette);
    u0_ausgeben_minus_1(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Korrektur auf feinem Gitter / Rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_3_oben ende ");
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende MLAT_3_oben / Rang " << rang << endl;;
#endif
    }

// Kommentar: Hier geschieht MLAT_3 auch parallel und im nicht adaptiven Bereich, aber mit dem normalen Mehrgitterschema.
void ZyklusRechnen::MLAT_3_oben_nicht_adaptiv(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
#ifdef U0_TESTEN
    u0_testen("MLAT_3_oben anfang ");
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3_oben-nicht_adaptiv_Anfang rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3-oben-nicht_adaptiv_Anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 5);
#endif
// Kommentar: Es wird beim normalen Mehrgitterschema e0 durch kopieren der u0 - Werte bestimmt.
    kopiere_u0_e0_oben();
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3_oben_nicht_adaptiv rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3-oben-nicht-adaptiv");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, E0, zeichenkette, 10);
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " nach berechne_e0_oben ");
    ebene_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach berechne in MLAT_3_oben");
    e0_ausgeben(zeichenkette);
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " vor prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
#endif
// Kommentar: Dann werden die Prolongationen mit den eben bestimmten e0 - Werten durchgefhrt.
    prolongationen_oben();
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " nach prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
    strcpy(zeichenkette, " Nach prolongation oben noch Mal oben ");
    e0_ausgeben(zeichenkette);
    strcpy(zeichenkette, " Nach prolongation in MLAT_3_oben");
    e0_ausgeben_minus_1(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Prolongation oben / Rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Vor Korrektur ");
    u0_ausgeben_minus_1(zeichenkette);
#endif
// Kommentar: Am Ende der MLAT_3 Funktion steht die Grobgitterkorrektur.
    korrektur_auf_feinem_gitter();
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach Korrektur ");
    e0_ausgeben_minus_1(zeichenkette);
    u0_ausgeben_minus_1(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Korrektur auf feinem Gitter / Rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_3_oben ende ");
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende MLAT_3_oben / Rang " << rang << endl;;
#endif
    }

// Kommentar: Hier wird MLAT_3 gesplittet: Nur die e0 - Berechnug, nicht aber die Prolongation. Es wird parallel das FAS -
// Schema abgearbeitet - im nichtadaptiven Bereich.
void ZyklusRechnen::MLAT_3a_oben(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
#ifdef U0_TESTEN
    u0_testen("MLAT_3_oben anfang ");
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben-Anfang rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3a-oben-Anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 5);
#endif
// Kommentar: Es wird parallel e0 berechnet.
    berechne_e0_oben();
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3a-oben");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, E0, zeichenkette, 10);
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " nach berechne_e0_oben ");
    ebene_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach berechne in MLAT_3_oben");
    e0_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " vor prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
#endif
    }

// Kommentar: Hier geschieht MLAT_3a parallel fr das normale Mehrgitterschema. Das besteht nur aus der Kopie von u0 nach e0.
void ZyklusRechnen::MLAT_3a_oben_nicht_adaptiv(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
#ifdef U0_TESTEN
    u0_testen("MLAT_3_oben anfang ");
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv-Anfang rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3a-oben-nicht_adaptiv_Anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 5);
#endif
// Kommentar: e0 wird direkt durch u0 abgelesen.
    kopiere_u0_e0_oben();
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3a-oben-nicht-adaptiv");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, E0, zeichenkette, 10);
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " nach berechne_e0_oben ");
    ebene_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach berechne in MLAT_3_oben");
    e0_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Berechne_e0_oben kommt / Rang " << rang << endl;
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " vor prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
#endif
    }

// Kommentar: Diese Funktion arbeitet parallel, und ergnzt MLAT_3a_oben zu MLAT_3a
void ZyklusRechnen::MLAT_3b_oben(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
// Kommentar: Da e0 schon bestimmt wurde, geht es hier mit der Prolongation weiter.
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Vor Prolongationen ");
    test_feld_vergangen_385zr(zeichenkette);
#endif
    prolongationen_oben();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Nach Prolongationen ");
    test_feld_vergangen_385zr(zeichenkette);
#endif
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3a_oben_nicht_adaptiv rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3b");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene-1, DOWN, E0, zeichenkette, 15);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " nach prolongationen_oben ");
    ebene_ausgeben(zeichenkette);
    strcpy(zeichenkette, " Nach prolongation oben noch Mal oben ");
    e0_ausgeben(zeichenkette);
    strcpy(zeichenkette, " Nach prolongation in MLAT_3_oben");
    e0_ausgeben_minus_1(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Prolongation oben / Rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Vor Korrektur ");
    u0_ausgeben_minus_1(zeichenkette);
#endif
// Kommentar: Danach kommt die Grobgitterkorrektur.
#ifdef DAFWV
    strcpy(zeichenkette, "vor MLAT-3b-oben");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene_minus_1, DOWN, U0, zeichenkette, 18);
#endif
    korrektur_auf_feinem_gitter();
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-3b-oben");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene_minus_1, DOWN, U0, zeichenkette, 20);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach Korrektur ");
    e0_ausgeben_minus_1(zeichenkette);
    u0_ausgeben_minus_1(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach Korrektur auf feinem Gitter / Rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    strcpy(zeichenkette, "MLAT_3_oben ende ");
    u0_testen(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende MLAT_3_oben / Rang " << rang << endl;;
#endif
    }

// Kommentar: MLAT_3 fr die von mir vorgenommene Abnderung der Implementation von Herrn Hess der Shallow Water Equations. In seinem Code hat Herr Hess die Prolongation
// angegeben. Die Grobgitterkorrektur und das quivalent zur e0 - Berechnung liegen nicht vor.
void ZyklusRechnen::MLAT_3_SWE(int k)
    {
    ebene = k;
    ebene_minus_1 = k-1;
    prolongationen_oben_swe();
//    korrektur_auf_feinem_gitter_swe(); 16.2.16: Diese Funktion gibt es nicht. Man hat wohl die Funktion solve_post, die das beinhaltet.
    }

// Kommentar: MLAT_4 ergnzt MLAT_3 zu einem Schritt vom groben zum feinen Gitter - parallel und nicht bei vollstndigen Gittern.
void ZyklusRechnen::MLAT_4_oben(int k)
    {
    ebene = k;
#ifdef U0_TESTEN
    u0_testen("MLAT_4_oben anfang ");
#endif

#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-4-oben-mitte ");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 30);
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, RS0, zeichenkette, 35);
#endif

// Kommentar: Es wird die Nachglttung mue2 - Mal ausgefhrt. Je nach Wahl den Gauss - Seidel, oder den Jacoby - Gltter.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue2; ii++)
            {
            nachglaettung_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue2; ii++)
            {
            nachglaettung();
            }
        }
#ifdef U0_TESTEN
    u0_testen("MLAT_4_oben ende ");
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT-4-ende");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 40);
#endif
    }

// Kommentar: Hier geschieht die Nachglttung, sowie die von der Funktion solve-post der Implementation von Herrn Hess der SWE von mir abgewandelte Funktion loesen_nachher.
void ZyklusRechnen::MLAT_4_SWE(int k)
    {
    ebene = k;

#ifdef AKTUELLE_KOMMENTARE
    cout << " MLAT_4_SWE rang " << rang << endl;
#endif


// Kommentar: Zuerst wird geglttet.
    for(ii=0; ii<mue2; ii++)
        {
        glaettung_red_black_swe();
        }
// Kommentar: Und dann wird ein Solve-Post-Berechnungs-quivalent (Solve-Post von Herrn Hess) aufgerufen.
    loesen_nachher(ebene);
    }

// Kommentar: Ab hier kommen die MLAT - Funktionen im adaptiven Bereich.

// Kommentar: MLAT_1_unten macht einen kompletten Schritt vom Groben zum Feinen, parallel, aber es wird von einem
// unvollstndigen feinen Gitter auszugehen sein, also MLAT_1 im adaptiven Bereich.
void ZyklusRechnen::MLAT_1_unten(int k)
    {
    ebene = k;
#ifdef AKTUELLE_KOMMENTARE
//    u0_testen_3011("MLAT_1_unten vor vorglaettung");
    strcpy(zeichenkette, "MLAT_1_unten vor vorglaettung");
    u0_testen_3011(zeichenkette);
#ifdef U0_TESTEN
    u0_testen("MLAT_1_unten anfang ");
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten Vor Vorglaettung / rang " << rang << endl;
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor vorglaettung / rang " << rang << endl;
#endif

#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_1_unten_anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 2);
#endif

    timer_mlat1_unten_vorglaettung.starten();

// Kommentar: Zuerst geschieht auf dem feinen Gitter die Vorglttung, entweder fr Gauss - Seidel, oder fr Jacoby, aber
// adaptiv - mit dem Suffix 'unten'.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_unten_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue1; ii++)
            {
            vorglaettung_unten();
            }
        }

    timer_mlat1_unten_vorglaettung.stoppen();

#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_1_unten_nach_vorglaettung");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 4);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach vorglaettung u0 in MLAT_1_unten");
    u0_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach vorglaettung / rang " << rang << endl;
    strcpy(zeichenkette, "MLAT_1_unten nach vorglaettung");
    u0_testen_3011(zeichenkette);
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten Vor berechne_resduum / rang " << rang << endl;
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor berechne_residuum / rang " << rang << endl;
#endif
// Kommentar: Es wird das Residuum berechnet, auch adaptiv, d.h. mit Teilgittern, angegeben mit dem Suffix 'unten'.
    timer_mlat1_unten_residuum.starten();
    berechne_residuum();
    timer_mlat1_unten_residuum.stoppen();
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_1_unten_nach_berechne_residuum");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 6);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " u0 unten nach berechne_residuum ");
    u0_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach berechne_residuum / rang " << rang << endl;
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten Vor beide_restriktionen unten / rang " << rang << endl;
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE_NEU
    if((t0>=4)&&(rang<=1)&&(m>=33)&&(n>=33))
        {
        cout << " FGH MLAT 1 r0(7,18) " << paralleles_rechnen[0].r0[7][18] << " t " << t0 << " rang " << rang << endl;
        }
#endif
#ifdef AKTUELLE_KOMMENTARE
#endif
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, "MLAT_1_unten vor beide restriktionen unten");
    u0_testen_3011(zeichenkette);
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor beide_restriktionen unten / rang " << rang << endl;
#endif
// Kommentar: Dann geschieht die Full Weighting Prozedur fr das Residuum, sowie die Injektion fr u0, aber im adaptiven Bereich:
// Wieder wird das Suffix unten verwendet.
    timer_mlat1_unten_restriktion.starten();
    beide_restriktionen_unten();
    timer_mlat1_unten_restriktion.stoppen();
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_1_unten_r0_unten_nach_Restriktion");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 7);
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_1_unten_Iu0_nach_Restriktion");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene+1, UP, IU0, zeichenkette, 8);
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach beide_restriktionen unten / rang " << rang << endl;
#endif

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen unten Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen unten u0 unten");
    u0_ausgeben(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen unten r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene+1);
#endif
#endif
#endif
#ifdef AKTUELLE_KOMMENTARE
    cout << " VVWWXX Nach beide_restriktionen unten / rang " << rang << endl;
#endif
    strcpy(zeichenkette, "MLAT_1_unten nach beide restriktionen unten");
    u0_testen_3011(zeichenkette);
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten Vor berechne_rechte_seite_unten / rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_1_unten ende ");
#endif
    ebene = k+1;
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor berechne_rechte_seite_unten / rang " << rang << endl;
#endif
// Kommentar: Dann wird die rechte Seite des grberen Gitters berechnet, aber mit einem adaptiven feinen Gitter, wegen
// dem Suffix unten.
    berechne_rechte_seite_unten(); // berechne_rechte_seite_unten ist auf Ebene +1
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach berechne_rechte_seite_unten / rang " << rang << endl;
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten Nach berechne_rechte_seite_unten / rang " << rang << endl;
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_1_unten nach berechne rechte_Seite");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, RS0, zeichenkette, 10);
#endif
    }

// Kommentar: MLAT_2 bewirkt einen Lser auf dem grbsten Gitter. Da hier der adaptive Bereich vorliegt,
// ist das eigentlich eine unmgliche Situation.
void ZyklusRechnen::MLAT_2_unten(int k)
    {
    ebene = k;
#ifdef U0_TESTEN
    u0_testen("MLAT_2_unten anfang ");
#endif
// Kommentar: Es wird gelst auf einem unvollstndigen Gitter - Gauss Seidel oder Jacoby, und parallel.
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<solve_anzahl; ii++)
            {
            loeser_red_black();
            }
        }
    else
        {
        for(ii=0; ii<solve_anzahl; ii++)
            {
            loeser();
            }
        }

#ifdef U0_TESTEN
    u0_testen("MLAT_2_unten ende ");
#endif
    }

// Kommentar: Der erste der MLAT - Schritte von grob nach fein. Neben MLAT_4 kommt dann noch die Randinterpolation MLAT_RI
// ergnzend dazu. Alles im adaptiven Bereich, d.h. auf unvollstndigen Gittern.
void ZyklusRechnen::MLAT_3_unten(int k)
    {
    ebene = k;
    ebene_minus_1 = ebene - 1;
#ifdef U0_TESTEN
    strcpy(zeichenkette, "MLAT_3_unten anfang ");
    u0_testen(zeichenkette);
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "MLAT_3 a rang " << rang << endl;
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Vor berechne e0 in MLAT_3_unten");
    Iu0_ausgeben(zeichenkette);
#endif
#ifdef DAFWV
    cout << " PPOONN DAFWV MLAT_3_unten-Anfang rang " << rang << endl;
    strcpy(zeichenkette, "MLAT-3-unten-Anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 5);
#endif
#ifdef AAGG
            cout << " AAGG Vor MLAT_3_unten berechne_e0_unten rang " << rang << endl;
#endif
// Kommentar: Zuerst wird e0 berechnet - im adaptiven Bereich.
    berechne_e0_unten();
#ifdef TEST_E0
    strcpy(zeichenkette, " test_e0_1 ");
    test_e0(zeichenkette);
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_3_unten_berechne_e0");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, E0, zeichenkette, 10);
#endif
#ifdef TEST_E0
    strcpy(zeichenkette, " test_e0_2 ");
    test_e0(zeichenkette);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach berechne e0 in MLAT_3_unten");
    e0_ausgeben(zeichenkette);
    u0_ausgeben(zeichenkette);
#endif
#ifdef TEST_E0
    strcpy(zeichenkette, " test_e0_3 ");
    test_e0(zeichenkette);
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "MLAT_3 b rang " << rang << endl;
#endif
#ifdef TEST_E0
    strcpy(zeichenkette, " test_e0_4 ");
    test_e0(zeichenkette);
#endif
#ifdef AAGG
            cout << " AAGG Vor MLAT_3_unten prolongationen_unten rang " << rang << endl;
#endif
// Kommentar: Dann kommt es zu den Prolongationen - im adaptiven Bereich.
    prolongationen_unten();
#ifdef AAGG
            cout << " AAGG Nach MLAT_3_unten prolongationen_unten rang " << rang << endl;
#endif
#ifdef TEST_E0
    strcpy(zeichenkette, " test_e0_5 ");
    test_e0(zeichenkette);
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_3_unten_nach_prolongationen");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene-1, DOWN, E0, zeichenkette, 15);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach prolongation in MLAT_3_unten");
    e0_ausgeben_minus_1(zeichenkette);
    u0_ausgeben(zeichenkette);
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "MLAT_3 c rang " << rang << endl;
#endif
    // Zu tun: ggf nach MLAT_4_unten verschieben. Um Laufzeit zu sparen.
    // Nach MLAT_4_unten schieben
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "MLAT_3 d rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_3_unten ende ");
#endif
    }

// Kommentar: Diese Funktion macht die Grobgitterkorrektur auf dem feinen Gitter - im parallelen adaptiven Fall.
void ZyklusRechnen::MLAT_3_unten_korrektur(int k)
    {
    ebene = k;
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_3_unten_vor_korrektur");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 20);
#endif
// Kommentar: Die Grobgitterkorrektur - im parallelen adaptiven Fall.
    korrektur_auf_feinem_gitter_gleiche_ebene();
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_3_unten_nach_korrektur");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 30);
#endif

    }

// Kommentar: Es wird die Randinterpolation durchgefhrt. Die ist immer im parallelen adaptiven Fall.
void ZyklusRechnen::MLAT_RI_unten(int k)
// Was ist k: Die Grobgitterebene, oder die Feingitterebene? Entsprechend der Initialisierung ist es die Grobgitterebene.
    {
    ebene = k;
#ifdef U0_TESTEN
    u0_testen("MLAT_RI_unten anfang ");
#endif
    // Randaustausch u0
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " Vor MLAT_RI_unten ( " << ebene << ") rang " << rang << " nun wird der Rand u0 ausgetauscht " << endl;
#endif

// Kommentar: Zuerst geschieht auf groben Gitter ein Randaustauch, vgl. die Dissertation.
    paralleles_rechnen[ebene].packen_randwerte_u0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    timer_zr_idle.starten();
    timer_zr_idle14.starten();
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle14.stoppen();
    paralleles_rechnen[ebene].entpacken_randwerte_u0();

    // u0 wurde bertragen, damit die Werte der Auenpunkte da sind.
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " In MLAT_RI_unten ( " << ebene << ") rang " << rang << " nun wird der Rand interpoliert " << endl;
#endif
// Kommentar: Fhre die Randinterpolation aus.
    randinterpolationen[ebene].tun();
#ifdef DAFWV
    strcpy(zeichenkette, "Nach-RI");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene-1, DOWN, U0, zeichenkette, 50);
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " Nach MLAT_RI_unten ( " << ebene << ") rang " << rang << endl;
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_RI_unten ende ");
#endif
    }

// Kommentar: Diese ist eine abgeleitete Randinterpolation der von mir abgenderten Hess'schen Implementation der Shallow Water Equations.
void ZyklusRechnen::MLAT_RI_SWE(int k)
    {
    ebene = k;

// Kommentar: Zuerst geschieht der Randaustausch fr die Randinterpolation.
    paralleles_rechnen[ebene].packen_randwerte_v6();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    timer_zr_idle.starten();
    timer_zr_idle14.starten();
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle14.stoppen();
    paralleles_rechnen[ebene].entpacken_randwerte_v6();

// Kommentar: Dann werden die 'normalen' Randinterpolationsroutinen aufgerufen.
    randinterpolationen[ebene].tun(); // Macht 'automatisch randinterpolation fr v6. 5.12.14
    }

// Kommentar: MLAT_4_unten macht zusammen mit MLAT_3_unten und MLAT_RI einen Schritt vom grberen in adaptive feine Gitter,
// und das parallel. Hier geschieht allerdings nur die Nachglttung.
void ZyklusRechnen::MLAT_4_unten(int k)
    {
    ebene = k;
#ifdef U0_TESTEN
    u0_testen("MLAT_4_unten anfang ");
#endif
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_4_unten anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 60);
#endif
// Kommentar: Es geschieht die Nachglttung, etnweder nach dem Gauss - Seidel - Verfahren, oder nach der Jacoby -
// Methode
    if(ist_gauss_seidel==true)
        {
        for(ii=0; ii<mue2; ii++)
            {
            nachglaettung_red_black();
            }
        }
    else
        {
        for(ii=0; ii<mue2; ii++)
            {
            nachglaettung();
            }
        }
#ifdef DAFWV
    strcpy(zeichenkette, "MLAT_4_nach nachglaettung anfang");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, DOWN, U0, zeichenkette, 70);
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, " Nach nachglaettung u0 in MLAT_4_unten");
    u0_ausgeben(zeichenkette);
#endif
#ifdef U0_TESTEN
    u0_testen("MLAT_4_unten ende ");
#endif
    }

// MLAT_1: Diese Ebene, und die naechst hhere
// MLAT_2: Auf dieser Ebene
// MLAT_3: Diese Ebene und die naechstniedrigere
// MLAT_RI_unten: Diese Ebene und die naechstniedrigere
// MLAT_4: Auf dieser Ebene

// Also: Anwendung: MLAT_1(k) MLAT_2(k+1) MLAT_3(k+1) MLAT_4(k)

// Kommentar: Hier wird der Diskretisierungsfehler nach dem 'Experten' - Kriterium berechnet, vgl. Dissertation.
void ZyklusRechnen::DiskretisierungsFehlerBerechnen(int k)
    {
    ebene = k;
    ebene_plus1 = k + 1;
    // Berechne Lu0
// Kommentar: Zuerst wird Lu0 auf dem feineren Gitter berechnet - das Gitter, fr dessen Punkte die Verfeinerungsentscheidung
// getroffen wird.
    berechne_Lu0_unten();
// Kommentar: Es wird LIu0 berechnet, vgl. das Verfeinerungskriterium. Dieses wird auf dem grberen Gitter berechnet,
// da u0 dort durch Restrikion auf dem feineren Gitter gebildet wird.
    berechne_Lu0_oben();
// Kommentar: Man muss Lu0 einer Restriktion unternehmen.
    restriktion_Lu0_unten();
// Kommentar: Dann wird durch die Differenz von beidem auf dem grberen Gitter der Diskretisierungsfehler berechnet.
    berechne_DF();
    }

// Kommentar: Nun kommen - nach den MLAT - Routinen - die einzelnen Funktionen, die konkrete Teilaufgaben erledigen.

// Kommentar: Hier geschieht der Randaustausch der Variablen u0 - fr die Randinterpolation.
// Denn fr die Randinterpolation kann man die Kommunikationszeit nicht anderweitig nutzen.
void ZyklusRechnen::randaustausch_u0(int k)
    {
    ebene = k;

// Kommentar: Die Randwerte werden gepackt, und die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].packen_randwerte_u0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
// Kommentar: Es wird gewartet, bis die Werte eingetroffen sind.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
// Kommentar: Und dann wird entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_u0();
    }

// Kommentar: Auf dem Feingitterrand werden die Grobgitterwerte bertragen - fr die parallele Prolongation.
void ZyklusRechnen::randaustausch_gg_u0(int k)
    {
    ebene = k;

// Kommentar: Die Grobgitterwerte werden gepackt.
    paralleles_rechnen[ebene].packen_randwerte_gg_u0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
// Kommentar: Die Grobgitterwerte werden transferiert.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
// Kommentar: Die Grobgitterwerte werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_gg_u0();
    }

// Kommentar: Hier werden zu den Grobgitterrandpunkten die feinen Gitterpunkte bertragen. Dieses wird bentigt
// bei der Berechnung des vom Autor geschaffenen Verfeinerungskriterium - um die Weite der gltigen
// Feingitterwerte zu erweitern.
void ZyklusRechnen::randaustausch_fg_u0(int k)
    {
    ebene = k;

#ifdef AKTUELLE_KOMMENTARE_NEU
    cout << " RA_fg Ebene " << ebene << " rang " << rang << endl;

    strcpy(zeichenkette, " RA_fg Vor packen ");
    text387(zeichenkette);
#endif
// Kommentar: Die Feingitterwerte werden gepackt.
    paralleles_rechnen[ebene].packen_randwerte_fg_u0();
#ifdef AKTUELLE_KOMMENTARE_NEU
    strcpy(zeichenkette, " RA_fg Nach packen ");
    text387(zeichenkette);
#endif
// Kommentar: Die Feingitterwerte werden verschickt.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
#ifdef AKTUELLE_KOMMENTARE_NEU
    strcpy(zeichenkette, " RA_fg Nach kommunikation starten ");
    text387(zeichenkette);
#endif
// Kommentar: Es wird gewartet, bis die Feingitterwerte angekommen sind.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
#ifdef AKTUELLE_KOMMENTARE_NEU
    strcpy(zeichenkette, " RA_fg Nach kommunikation beenden ");
    text387(zeichenkette);
#endif
// Kommentar: Und am Ende werden die Feingitterwerte entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_fg_u0();
#ifdef AKTUELLE_KOMMENTARE_NEU
    strcpy(zeichenkette, " RA_fg Nach entpacken ");
    text387(zeichenkette);
#endif
    }

// Kommentar: Der Grobgitter - Randaustausch wird gestartet. Hier wird die Kommunikation indiziert, d.h.
// das Warten auf den Abschluss der Kommunikation kann prinzipiell genutzt werden.
void ZyklusRechnen::randaustausch_gg_u0_starten(int k)
    {
    ebene = k;

#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor packen_randwerte_gg_u0 1 / rang " << rang << endl;
#endif
// Kommentar: Die Grobgitter - Randwerte werden gepackt.
    paralleles_rechnen[ebene].packen_randwerte_gg_u0();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach packen_randwerte_gg_u0 1 / rang " << rang << endl;
#endif
// Kommentar: Die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    }

// Kommentar: Die Grobgitter - Randaustausch Kommunikation wird beendet. Das schliess die Funktion
// randaustausch_gg_u0_starten ab. Und zwischen beiden Funktionen kann noch gearbeitet werden.
void ZyklusRechnen::randaustausch_gg_u0_beenden(int k)
    {
    ebene = k;

    timer_zr_idle.starten();
    timer_zr_idle15.starten();
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
    paralleles_rechnen[ebene].entpacken_randwerte_gg_u0();
    }

// Kommentar: Hier geschieht die Grobgitterkommunikation, aber fr die Variable e0 statt u0. Die Kommentare sind analog zu
// randaustausch_gg_u0.
void ZyklusRechnen::randaustausch_gg_e0(int k)
    {
    ebene = k;

    paralleles_rechnen[ebene].packen_randwerte_gg_e0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
    paralleles_rechnen[ebene].entpacken_randwerte_gg_e0();
    }

// Kommentar: Hier geschieht die Grobgitterkommunikation Schritt 1, aber fr die Variable e0 statt u0. Die Kommentare sind analog zu
// randaustausch_gg_u0_starten.
void ZyklusRechnen::randaustausch_gg_e0_starten(int k)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor packen_randwerte_gg_u0 2 / rang " << rang << endl;
#endif
    paralleles_rechnen[k].packen_randwerte_gg_e0();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach packen_randwerte_gg_u0 2 / rang " << rang << endl;
#endif
    paralleles_rechnen[k].randwerte_kommunikation_starten_fu();
    }

// Kommentar: Hier geschieht die Grobgitterkommunikation Schritt 2, aber fr die Variable e0 statt u0. Die Kommentare sind analog zu
// randaustausch_gg_u0_beenden.
void ZyklusRechnen::randaustausch_gg_e0_beenden(int k)
    {
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
    for(;paralleles_rechnen[k].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
    paralleles_rechnen[k].entpacken_randwerte_gg_e0();
    }

// Kommentar: Hier geschieht die Grobgitterkommunikation Schritt 1, aber fr eine Variable der von mir genderten Version der Implementierung von Herrn Hess der
// Shallow Water Equations, statt u0. Die Kommentare sind analog zu randaustausch_gg_u0_starten.

void ZyklusRechnen::randaustausch_gg_v9_starten(int k)
    {

#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor packen_randwerte_gg_u0 3 / rang " << rang << endl;
#endif
    paralleles_rechnen[k].packen_randwerte_gg_v9();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach packen_randwerte_gg_u0 3 / rang " << rang << endl;
#endif
    paralleles_rechnen[k].randwerte_kommunikation_starten_fu();
    }

// Kommentar: Hier geschieht die Grobgitterkommunikation Schritt 2, aber fr eine Variable der von mir genderten Version der Implementierung von Herrn Hess der
// Shallow water equations, statt u0. Die Kommentare sind analog zu randaustausch_gg_u0_beenden.

void ZyklusRechnen::randaustausch_gg_v9_beenden(int k)
    {
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
    for(;paralleles_rechnen[k].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
    paralleles_rechnen[k].entpacken_randwerte_gg_v9();
    }

// Kommentar: Hier geschieht die Grobgitterkommunikation, aber fr die Variablen e0 und u0. Die Kommentare sind analog zu
// randaustausch_gg_u0.
void ZyklusRechnen::randaustausch_gg_e0_und_u0(int k)
    {
    ebene = k;

    paralleles_rechnen[ebene].packen_randwerte_gg_e0_und_u0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
    paralleles_rechnen[ebene].entpacken_randwerte_gg_e0_und_u0();
    }

// Kommentar: Hier geschieht der erste Schritt der Grobgitterkommunikation,
// aber fr die Variablen e0 und u0. Die Kommentare sind analog zu
// randaustausch_gg_u0_starten.
void ZyklusRechnen::randaustausch_gg_e0_und_u0_starten(int k)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor packen_randwerte_gg_u0 4 / rang " << rang << endl;
#endif
    paralleles_rechnen[k].packen_randwerte_gg_e0_und_u0();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach packen_randwerte_gg_u0 4 / rang " << rang << endl;
#endif
    paralleles_rechnen[k].randwerte_kommunikation_starten_fu();
    }

// Kommentar: Hier geschieht der zweite Schritt der Grobgitterkommunikation,
// aber fr die Variablen e0 und u0. Die Kommentare sind analog zu
// randaustausch_gg_u0_beenden.
void ZyklusRechnen::randaustausch_gg_e0_und_u0_beenden(int k)
    {
#ifdef AUSGABE_ABC_Pro
    cout << " ABC randaustausch gg_e0_und_u0 beenden vor rang " << rang;
#endif
    timer_zr_idle.starten();
    timer_zr_idle15.starten();
    for(;paralleles_rechnen[k].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle15.stoppen();
#ifdef AUSGABE_ABC_Pro
    cout << " ABC randaustausch gg_e0_und_u0 beenden nach rang " << rang;
#endif
    paralleles_rechnen[k].entpacken_randwerte_gg_e0_und_u0();
    }

// Kommentar: Eine Funktion der Ausgabe frs Debugging.
void ZyklusRechnen::u0_testen(char * text)
    {
    paralleles_rechnen[ebene].u0_testen(t0, text);
    }
#ifndef NUR_GITTER

// Kommentar: Hier wird die rechte Seite im adaptiven Bereich und parallel berechnet.
void ZyklusRechnen::berechne_rechte_seite_unten(void)
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nicht Nur Gitter rang " << rang << endl;
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten brsu a / rang " << rang << endl;
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " MLAT_1_unten brsu b / rang " << rang << endl;
#endif
#endif
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, " In berechne_rechte_seite_unten ");
    ausgabe_darunter(zeichenkette);
#endif

// Kommentar: Der Randaustausch der Variablen Iu0 und Ir0  wird initiiert - aber nur dort, wo Feingitterpunkte darunter vorhanden
// sind. Nur dort muss die rechte Seite berechnet werden.
    paralleles_rechnen[ebene].kleiner_randaustausch23_initiieren();
#ifdef AUSGABEN_ZYKLUS_RECHNEN
#ifdef AKTUELLE_KOMMENTARE
    cout << " MLAT_1_unten brsu c / rang " << rang << endl;
#endif
#endif

// Kommentar: Whrend die Kommunikation luft, wird im Inneren schon die rechte Seite berechnet.
    paralleles_rechnen[ebene].berechne_grobe_rechte_seite(paralleles_rechnen[ebene].f_innen_klein, paralleles_rechnen[ebene].g_innen_klein, paralleles_rechnen[ebene].anzahl_innen_klein);
#ifdef AUSGABEN_ZYKLUS_RECHNEN
#ifdef AKTUELLE_KOMMENTARE
    cout << " MLAT_1_unten brsu d / rang " << rang << endl;
#endif
#endif
    timer_zr_kl_idle.starten();

// Kommentar: Nachdem das innere berechnet worden ist, wird auf den Empfang der Nachricht gewartet - falls sie noch nicht
// angekommen ist.
    for(;paralleles_rechnen[ebene].kleiner_randaustausch23_testen()==false;)
        { ; }

#ifdef AKTUELLE_KOMMENTARE
    cout << " MLAT_1_unten brsu d (i) / rang " << rang << endl;
#endif

    timer_zr_kl_idle.stoppen();

// Kommentar: Zum Abschlu wird der Rand berechnet.
    paralleles_rechnen[ebene].berechne_grobe_rechte_seite(paralleles_rechnen[ebene].f_rand_innen_klein, paralleles_rechnen[ebene].g_rand_innen_klein, paralleles_rechnen[ebene].anzahl_rand_innen_klein);
#ifdef AUSGABEN_ZYKLUS_RECHNEN
#ifdef AKTUELLE_KOMMENTARE
    cout << " MLAT_1_unten brsu e / rang " << rang << endl;
#endif
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, "berechne rS0 unten");
    rS0_ausgeben(zeichenkette);
#endif
    }

#endif

#ifndef NUR_GITTER

// Kommentar: Es wird die parallele Vorglttung mit der Jacoby - Methode im adaptiven Bereich durchgefhrt.
void ZyklusRechnen::vorglaettung_unten(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

        {
// Kommentar: Die u0 Randwerte werden gepackt.
        paralleles_rechnen[ebene].packen_randwerte_u0(); // Korrektur 09.06.2014
// Kommentar: Die Kommunikation dazu wird initiiert.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
//        paralleles_rechnen[ebene].vorglaetter_f(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

// Kommentar: Die Vorglttung wird im Inneren durchgefhrt. Derweil luft die Kommunikation ab.
        paralleles_rechnen[ebene].vorglaetter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle16.starten();
// Kommentar: Es wird gewartet, bis die Kommunikation angekommen ist.
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
        timer_zr_idle.stoppen();
        timer_zr_idle16.stoppen();
// Kommentar: Die Randwerte werden entpackt.
        paralleles_rechnen[ebene].entpacken_randwerte_u0();
//        paralleles_rechnen[ebene].vorglaetter_f(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Kommentar: Mit der Berechnung der Vorglttung am Rand wird die Berechnung abgeschlossen.
        paralleles_rechnen[ebene].vorglaetter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Kommentar: Bei der Jacoby Methode mssen die berechneten Werte in die Ausgangsvariable zurck kopiert werden.
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene);
#endif
    strcpy(zeichenkette, "vorglaettung unten");
    u0_ausgeben(zeichenkette);
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "vorglaettung unten");
    u0_diff_ausgeben(zeichenkette);
#endif
#endif
#endif
    }

// Kommentar: Hier erfolgt eine Gauss - Seidel - Glttung, parallel, im adaptiven Bereich.
void ZyklusRechnen::vorglaettung_unten_red_black(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif
        {
// Kommentar: Die Red - Randwerte werden gepackt.
        paralleles_rechnen[ebene].packen_randwerte_u0_red(); // Korrektur 09.06.2014
// Kommentar: Die Kommunikation dieser Randwerte wird initiiert.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
// Kommentar: Im Inneren wird schon auf den Black - Koordinaten gerechnet. Fr die Berechnung der Black Punkte werden die
// Werte auf der Red - Werten bentigt. Diese liegen im Inneren schon vor.
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle16.starten();
// Kommentar: Es wird gewartet, bis die Red - Werte angekommen sind - in der Erwartung, dass die Kommunikation whrend
// der Berechnung der Innenpunkte weitgehend durchgefhrt wurde.
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
        timer_zr_idle.stoppen();
        timer_zr_idle16.stoppen();
// Kommentar: Die Red - Werte werden entpackt.
        paralleles_rechnen[ebene].entpacken_randwerte_u0_red();
// Kommentar: Nachdem die Red - Werte berall da sind, kann auch der Rand der Black - Punkte berechnet werden.
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

// Kommentar: Jetzt werden die Black - Punkte parallel berechnet, was analog zur Berechnung der Red - Punkte geschhieht.
        paralleles_rechnen[ebene].packen_randwerte_u0_black(); // Korrektur 09.06.2014
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle16.starten();
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
        timer_zr_idle.stoppen();
        timer_zr_idle16.stoppen();
        paralleles_rechnen[ebene].entpacken_randwerte_u0_black();
        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene);
#endif
    strcpy(zeichenkette, "vorglaettung unten");
    u0_ausgeben(zeichenkette);
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "vorglaettung unten");
    u0_diff_ausgeben(zeichenkette);
#endif
#endif
#endif
    }

#endif

// Kommentar: Hier wird das Gitter - als Ausgleich nur die geringe Last pro Gitterpunkt - mit zustzlicher Last belastet.
void ZyklusRechnen::rechnen_nur_als_punktelast_einmal(void)
    {
    paralleles_rechnen[ebene].rechnen_nur_als_punktelast(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    paralleles_rechnen[ebene].rechnen_nur_als_punktelast(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    }

// Kommentar: Hier wird soviel Last in einen Gitterpunkt gesetzt, wie die Variable wieviel_punktelast angibt.
void ZyklusRechnen::rechnen_nur_als_punktelast(void)
    {
    for(i=0; i<wieviel_punktelast; i++)
        {
        rechnen_nur_als_punktelast_einmal();
        }
    }

/////////////////////////////////////////////////////////////////////////////////////
////////////////////   Die Funktionen fr Punkte nur auf dem Gitter    //////////////
/////////////////////////////////////////////////////////////////////////////////////

#ifndef NUR_GITTER
// Kommentar: Die Vorglttung der Jacoby - Methode, parallel, nicht adaptiv.
void ZyklusRechnen::vorglaettung(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, "vor vorglaettung 2662");
    u0_ausgeben(zeichenkette);
#endif
        {

// Kommentar: Die Randwerte der Variablen u0 werden gepackt.
        paralleles_rechnen[ebene].packen_randwerte_u0();
// Kommentar: Die Randwerte werden kommuniziert.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
// Kommentar: Dann wird auf dem inneren Gebiet geglttet.
        paralleles_rechnen[ebene].vorglaetter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle1.starten();

// Kommentar: Vor dem Entpacken mssen alle versendeten Nachrichten angekommen sein.
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }

        timer_zr_idle.stoppen();
        timer_zr_idle1.stoppen();

// Kommentar: Die Randwerte werden entpackt.
        paralleles_rechnen[ebene].entpacken_randwerte_u0();
// Kommentar: Die Randpunkte werden geglttet.
        paralleles_rechnen[ebene].vorglaetter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Kommentar: Bei der Jacoby - Methode muss zurckkopiert werden.
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene);
    strcpy(zeichenkette, "vorglaettung 2739");
    u0_ausgeben(zeichenkette);
#endif
#endif
#endif
    }

#endif

#ifndef NUR_GITTER

// Kommentar: Im nichtadaptiven Bereicht erfolgt eine parallele Gauss - Seidel - Glttung. Die Kommentare sind
// analog zu denen in der Funktion vorglaettung_unten_red_black.
void ZyklusRechnen::vorglaettung_red_black(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, "vor vorglaettung 2662");
    u0_ausgeben(zeichenkette);
#endif
        {
        paralleles_rechnen[ebene].packen_randwerte_u0_red();
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Vor vorglaetter_black");
            zeitausgabe(zeichenkette);
#endif

        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle1.starten();

#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Vor Glaettung-Red warten");
            zeitausgabe(zeichenkette);
#endif
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Nach Glaettung-Red warten");
            zeitausgabe(zeichenkette);
#endif
        timer_zr_idle.stoppen();
        timer_zr_idle1.stoppen();

        paralleles_rechnen[ebene].entpacken_randwerte_u0_red();
        paralleles_rechnen[ebene].vorglaetter_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Black-rechnen");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 85+ii*5);
#endif
#ifdef AUSGABEN_DATEI_101214
        strcpy(zeichenkette, " Vorglaetter red-black nach erstem Teilschritt ");
        u0_ausgeben(zeichenkette);
#endif
        paralleles_rechnen[ebene].packen_randwerte_u0_black();
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle1.starten();

#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Vor Glaettung-Black warten");
            zeitausgabe(zeichenkette);
#endif
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
#ifdef TIMER_INFORMATIONEN
            strcpy(zeichenkette,"Nach Glaettung-Black warten");
            zeitausgabe(zeichenkette);
#endif
        timer_zr_idle.stoppen();
        timer_zr_idle1.stoppen();

        paralleles_rechnen[ebene].entpacken_randwerte_u0_black();
        paralleles_rechnen[ebene].vorglaetter_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Red-rechnen");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 85+ii*5 + 2);
#endif
#ifdef AUSGABEN_DATEI_101214
        strcpy(zeichenkette, " Vorglaetter red-black nach zweitem Teilschritt ");
        u0_ausgeben(zeichenkette);
#endif
        }
    }

#endif

// Kommentar: Parallel wird das Residuum berechnet.
void ZyklusRechnen::berechne_residuum(void)
    {
// Kommentar: Bzgl. der Variablen u0, die fr die Berechnung des Residuums bentigt wird, wird ein Randaustausch gemacht.
    paralleles_rechnen[ebene].packen_randwerte_u0();
// Kommentar: Die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
// Kommentar: Das Residuum wird im Inneren berechnet. Desweil luft die Kommunikation ab.
    paralleles_rechnen[ebene].residuum_berechnen(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

    timer_zr_idle.starten();
    timer_zr_idle3.starten();
// Kommentar: Hiermit wird gewartet, bis alle Kommunikationen abgeschlossen sind. Falls das nicht schon whrend der Berechnung
// des Inneren geschehen ist.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle3.stoppen();
// Kommentar: Die Randwerte werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_u0();
// Kommentar: Nun kann das Residuum auch auf dem Rand berechnet werden.
    paralleles_rechnen[ebene].residuum_berechnen(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

#ifdef DAFWV
    strcpy(zeichenkette, "Residuum-berechnen");
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, R0, zeichenkette, 105);
#endif
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "berechne_residuum");
    r0_ausgeben(zeichenkette);
#endif
#endif
#endif
    }

// Kommentar: Es werden die Restriktionen fr u0 und r0 gemeinsam erfllt - parallel, und im nichtadaptiven Bereich.
void ZyklusRechnen::beide_restriktionen_oben(void)
    {
#ifdef ALT_OHNE_INJEKTION // Ohne Injektion, 25.09.2014
    paralleles_rechnen[ebene].packen_randwerte_u0r0();
#else
// Kommentar: Da die Restriktion fr u0 eine Injektion ist, also ohne Rand berechnet wird, wird nur der Rand fr r0
// ausgetauscht.
    paralleles_rechnen[ebene].packen_randwerte_r0();
#endif
// Kommentar: Die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

        {
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen; // Die zu restriktierende Punkteanzahl
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen; // Die zu restriktierende Punkteanzahl
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand; // Die zu restriktierende Punkteanzahl
        // 5.9.14: Ist ja ein vollstndiges Gitter auf Ebene ebene.
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
        cout << " Anzahl Restriktionspunkte " << restriktionen[ebene].anzahl_innen_oben << " ebene " << ebene << endl;
#endif
#endif
        }

// Kommentar: Die Injektion fr u0 wird durchgefhrt.
    restriktionen[ebene].injektion_nach_u0_und_Iu0();

#ifdef RESTRIKTIONEN_ALT
    restriktionen[ebene].full_weighting_innen_r0();
#else
// Kommentar: Die Restriktion fr r0 - das Full Weighting - wird durchgefhrt, wo die Full Weighting Nachbarschaften
// schon bekannt sind.
    restriktionen[ebene].full_weighting_innen_r0_ohne_rand_unten();
#endif
    timer_zr_idle.starten();
    timer_zr_idle4.starten();
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle4.stoppen();
#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].entpacken_randwerte_u0r0();
#else
// Kommentar: Die Randwerte von r0 werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_r0();
#endif
    restriktionen[ebene].full_weighting_rand_innen_r0();
#ifdef RESTRIKTIONEN_ALT
#else
// Kommentar: Die oben aufgrund von Randnachbarschaften nicht durchgefhrten Full Weighting Schritte werden
// nach der Kommunikation von r0 durchgefhrt - und damit das FW - abgeschlossen.
    restriktionen[ebene].full_weighting_innen_r0_abschluss();
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_oben: Nach restriktionen[ebene].full_weighting_rand_innen_r0(); 5021 rang " << rang << endl;
#endif

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen oben Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen oben r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene+1);
#endif
#endif
#endif
    }

// Kommentar: Hier werden die sequentiellen Restriktionen entsprechend dem FAS durchgefhrt.
// Es sind keine Randkommunikationen ntig.
void ZyklusRechnen::beide_restriktionen_sequentiell_FAS(void)
    {
    strcpy(zeichenkette,"a");
    ausgeben385(zeichenkette);
        {
// Kommentar: Die Anzahl der Innenpunkte wird in die Klasse Restrikion(ebene) kopiert.
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen; // Die zu restriktierende Punkteanzahl
#ifdef AUSGABE_UVW
        cout << " UVW anzahl restriktionspunkte oben " << restriktionen[ebene].anzahl_innen_oben << " rang " << rang << " ebene " << ebene << endl;
#endif
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
        cout << " Anzahl Restriktionspunkte " << restriktionen[ebene].anzahl_innen_oben << " ebene " << ebene << endl;
#endif
#endif
        }

    strcpy(zeichenkette,"b");
    ausgeben385(zeichenkette);
// Kommentar: Das Full Weighting bzgl. r0 wird durchgefhrt fr das Innere.
    restriktionen[ebene].full_weighting_innen_r0();
        {
// Kommentar: Die Anzahl der Randpunkte fr die Restriktion wird nach Restriktion(ebene) kopiert.
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen;
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand;
#ifdef AUSGABE_UVW
        cout << " UVW anzahl restriktionspunkte oben rand " << restriktionen[ebene].anzahl_rand_innen_oben << " rang " << rang << " ebene " << ebene << endl;
#endif
        }
// Kommentar: Die komplette Injektion wird durchgefhrt.
    restriktionen[ebene].injektion_nach_u0_und_Iu0();
    strcpy(zeichenkette, "c");
    ausgeben385(zeichenkette);

// Kommentar: Und das Full Weighting fr den Rand wird durchgefhrt.
    restriktionen[ebene].full_weighting_rand_innen_r0();
    strcpy(zeichenkette, "d");
    ausgeben385(zeichenkette);

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_oben: Nach restriktionen[ebene].full_weighting_rand_innen_r0(); 5245 rang " << rang << " ebene " << ebene << endl;
#endif

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen oben Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen oben r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene+1);
#endif
#endif
#endif
    }

// Kommentar: Diese Funktion bewirkt die Restriktion im Fall, dass ein normales Mehrgitterverfahren gewhlt wird.
// Dabei kommt es statt der Injektiorn von u0 nur zur Lsung von u0. Sie liegt parallel vor.
void ZyklusRechnen::restriktion_r0rS0_und_u0_reset_oben(void)
    {

// Kommentar: Zuerst werden die Randwerte des Residuums gepackt, nebst starten der Kommunikation.
    paralleles_rechnen[ebene].packen_randwerte_r0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Falls es keine Kappe gibt, oder die Ebene im parallelen Bereich liegt ...
#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen ! Was ist das?
#endif
    // 5.9.14: Das immer setzen? h_kappe==2, ebene = 1. Dann gilt das.
        {
// Kommentar: Kopiere in die zugehrige Restriktionklasse die Anzahl der Innenpunkte.
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen; // Die zu restriktierende Punkteanzahl
#ifdef AUSGABE_UVW
        cout << " UVW anzahl restriktionspunkte oben " << restriktionen[ebene].anzahl_innen_oben << " rang " << rang << " ebene " << ebene << endl;
#endif
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
        cout << " Anzahl Restriktionspunkte " << restriktionen[ebene].anzahl_innen_oben << " ebene " << ebene << endl;
#endif
#endif
        }
#ifdef RESTRIKTIONEN_ALT
    restriktionen[ebene].full_weighting_innen_r0rS0();
#else
// Kommentar: Mache das Full Weighting, wo auf dem unteren Gitter die 8 Punkte drum herum schon aktuell sind.
    restriktionen[ebene].full_weighting_innen_r0rS0_ohne_rand_unten();
#endif
    timer_zr_idle.starten();
    timer_zr_idle4.starten();
// Warte auf die Vollendung der Kommunikation - falls das nicht schon der Fall ist wegen den FW auf dem Inneren.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle4.stoppen();

// Kommentar: Entpacke die Randwerte.
    paralleles_rechnen[ebene].entpacken_randwerte_r0();

// Kommentar: vergleiche diesselbe Zeile weiter oben auch in dieser Funktion.
#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen !
#endif
        {
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen;
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand;
#ifdef AUSGABE_UVW
        cout << " UVW anzahl restriktionspunkte oben rand " << restriktionen[ebene].anzahl_rand_innen_oben << " rang " << rang << " ebene " << ebene << endl;
#endif
        }

// Kommentar: Mache das Full Weighting auf den verbliebenen Gitterpunkten.
    restriktionen[ebene].full_weighting_rand_innen_r0rS0();
    restriktionen[ebene].full_weighting_innen_r0rS0_abschluss();
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_oben: Nach restriktionen[ebene].full_weighting_rand_innen_r0(); 5394 rang " << rang << endl;
#endif

// Kommentar: Wie oben beim Kommentar zur Gesamtfunktion erwhnt, muss u0 auf dem grberen Gitter gelscht werden.
    paralleles_rechnen[ebene_plus1].reset_u0(paralleles_rechnen[ebene_plus1].f_rand_innen, paralleles_rechnen[ebene_plus1].g_rand_innen, paralleles_rechnen[ebene_plus1].anzahl_rand_innen);
    paralleles_rechnen[ebene_plus1].reset_u0(paralleles_rechnen[ebene_plus1].f_innen, paralleles_rechnen[ebene_plus1].g_innen, paralleles_rechnen[ebene_plus1].anzahl_innen);
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen oben Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen oben r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene+1);
#endif
#endif
#endif
    }

// Kommentar: Diese Funktion bewirkt die Restriktion im Fall, dass ein normales Mehrgitterverfahren gewhlt wird.
// Dabei kommt es statt der Injektion von u0 nur zur Lsung von u0. Sie liegt parallel vor.
void ZyklusRechnen::restriktion_r0rS0_und_u0_reset_sequentiell(void)
    {
// Kommentar wie in der parallelen  Funktion restriktion_r0rS0_und_u0_reset_oben.
#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen ! Was ist das?
#endif
        {
// Kommentar: Der Wert anzahl_innen wird in die Klasse Restriktionen(ebene) kopiert.
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen; // Die zu restriktierende Punkteanzahl
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
        cout << " Anzahl Restriktionspunkte " << restriktionen[ebene].anzahl_innen_oben << " ebene " << ebene << endl;
#endif
#endif
        }

// Mache die Restriktionen fr die Innenwerte.
    restriktionen[ebene].full_weighting_innen_r0rS0();
    timer_zr_idle.starten();
    timer_zr_idle4.starten();
    timer_zr_idle.stoppen();
    timer_zr_idle4.stoppen();

// Kommentar, s.o.
#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen !
#endif
        {
// Kommentar: Kopiere den Wert anzahl_Rand_innen nach Restriktionen(ebene)
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen;
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand;
        }

// Mache das Full Weighting am Rand. Hier sind die Gitter vollstndig.
    restriktionen[ebene].full_weighting_rand_innen_r0rS0();
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_sequentiell + reset: Nach restriktionen[ebene].full_weighting_rand_innen_r0(); 5528 rang " << rang << endl;
#endif

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " In beide_restriktionen_oben: Vor reset_u0 5528 rang " << rang << endl;
#endif
// Kommentar: Und lsche u0 auf dem grberen Gitter.
    paralleles_rechnen[ebene_plus1].reset_u0(paralleles_rechnen[ebene_plus1].f_rand_innen, paralleles_rechnen[ebene_plus1].g_rand_innen, paralleles_rechnen[ebene_plus1].anzahl_rand_innen);
    paralleles_rechnen[ebene_plus1].reset_u0(paralleles_rechnen[ebene_plus1].f_innen, paralleles_rechnen[ebene_plus1].g_innen, paralleles_rechnen[ebene_plus1].anzahl_innen);
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " In beide_restriktionen_oben: Nach reset_u0 5528 rang " << rang << endl;
#endif

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen oben Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen oben r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "Restriktion im sequentiellen Bereich zu Ende 5528 Zwischenausgabe rang " << rang << " ebene " << ebene << endl;
#endif
// Kommentar: Debugging Ausgabe: Bei h_kappe!=-1 auch im Bereich, wo alles auf Kern 0 liegt.
#ifdef AUSGABEN_DATEI_101214
    if(h_kappe==-1)
        {
        koordinaten_ausgabe(ebene+1);
        }
    else
        {
        if(ebene<h_kappe)
            {
            koordinaten_ausgabe(ebene+1);
            }
        else
            {
            koordinaten_ausgabe_sequentiell(ebene+1);
//            koordinaten_ausgabe(ebene+1);
            }
        }
#endif
#endif
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "Restriktion im sequentiellen Bereich zu Ende 5528 rang " << rang << endl;
#endif
    }

// Kommentar: Das Full Weighting fr das Residuum und die Injektion fr u0 werden im adaptiven Bereich parallel durchgefhrt.
void ZyklusRechnen::beide_restriktionen_unten(void)
// Unten steht fr unten im Zyklus, das heisst im adaptiven Bereich.
// 18.08.2014: So ist es falsch: Ausgetauscht wird unten der Rand, Innen und Rand Innen aber nach oben entschieden.
// So wird nicht fr alle Innenpunkte der Rand unten komplett da sein.

// Stimmt jetzt doch (2.7.15): Am Anfang wird das Innere nur in den Punkten berechnet, wo alle
// bentiten Werte vorhanden sind.
    {
#ifdef AKTUELLE_KOMMENTARE
    if((m>=33)&&(n>=33))
        {
        cout << " beide_restriktionen_unten Anfang " << paralleles_rechnen[0].u0[30][12] << " ebene " << ebene << " rang " << rang << endl;
        }
    strcpy(zeichenkette, "Anfang von beide restriktionen unten");
    u0_testen_3011(zeichenkette);
#endif
#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].packen_randwerte_u0r0();
#else
// Kommentar: Fr das Full Weighting von r0 werden die r0 Randwerte gepackt.
    paralleles_rechnen[ebene].packen_randwerte_r0();
#endif
// Kommentar: Und es wird die Kommunikation initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Die Punktanzahlen werden kopiert.
    restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen_klein;
    restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen_klein;
//    restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand; nderung 31.10.15. Spte nderung lassen. 10.2.16
    restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_klein_echter_rand;

// Kommentar: Da bei einer Injektion keine Werte in der Umgebung gebraucht werden, geschieht diese sofort komplett.
    restriktionen[ebene].injektion_nach_u0_und_Iu0();
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " bdu 1 / rang " << rang << endl;
#endif
#ifdef RESTRIKTIONEN_ALT
// Kommentar: So geht es nicht, vgl. obige Bemerkung.
    restriktionen[ebene].full_weighting_innen_r0();
#else
// Kommentar: Das Full Weighting wird Innen gemacht, wo es geht.
    restriktionen[ebene].full_weighting_innen_r0_ohne_rand_unten();
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " bdu 2 / rang " << rang << endl;
#endif

    timer_zr_idle.starten();
    timer_zr_idle5.starten();
// Kommentar: Warten, bis die Kommunikation abgeschlossen ist.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle5.stoppen();

#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].entpacken_randwerte_u0r0();
#else
// Kommentar: Entpacke die Randwerte des Residuums.
    paralleles_rechnen[ebene].entpacken_randwerte_r0();
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Jetzt mten die Randwerte da sein / rang " << rang << " ebene " << ebene << endl;
#endif

// Kommentar: Mache FW auf dem Rand.
    restriktionen[ebene].full_weighting_rand_innen_r0();
#ifdef RESTRIKTIONEN_ALT // Vielleicht muss hier #ifdef stehen.
#else
// Kommentar: Und mache FW, wo es Innen noch nicht ging.
    restriktionen[ebene].full_weighting_innen_r0_abschluss();
#endif
    // Zwei Restriktionen sind geschehen: Fr u0 und r0.

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " bdu 2 / rang " << rang << endl;
#endif

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " bdu 4 / rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
    if((n>=33)&&(m>=33))
        {
        cout << " beide_restriktionen_unten Ende " << paralleles_rechnen[0].u0[30][12] << " rang " << rang << endl;
        }
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende beide Restriktionen unten / rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar an mich selber: Nur Iu0 - Randaustausch

// Kommentar: Berechne die rechte Seite im parallelen, nicht adaptiven Fall.
void ZyklusRechnen::berechne_rechte_seite_oben(void)
    {
// Kommentar: rS0 nur auf dem kleinen Bereich berechnen.!

// Kommentar: Packe die Werte von Iu0 und Ir0.
    paralleles_rechnen[ebene].packen_randwerte_Iu0r0();
// Kommentar: Starte die Kommunikation
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
// Kommentar: Berechne die grobe rechte Seite auf dem Inneren.
    paralleles_rechnen[ebene].berechne_grobe_rechte_seite(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

    timer_zr_idle.starten();
    timer_zr_idle6.starten();
// Kommentar: Warte die Kommunikation ab.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle6.stoppen();
// Kommentar: Entpacke die Randwerte fr Iu0 und Ir0.
    paralleles_rechnen[ebene].entpacken_randwerte_Iu0r0();
// Kommentar: Berechne die grobe rechte Seite auf dem Inneren.
    paralleles_rechnen[ebene].berechne_grobe_rechte_seite(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, "berechne rS0 oben");
    rS0_ausgeben(zeichenkette);
#endif
    }

// Kommentar: Das ist ein Lser, der auf Basis der Jacoby - Methode arbeitet, und zwar parallel, und nicht adaptiv.
void ZyklusRechnen::loeser(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif
        {

// Kommentar: Packen die Randwerte von u0.
        paralleles_rechnen[ebene].packen_randwerte_u0();
// Kommentar: Starte die Kommunikation.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Lse durch Glttung auf dem Inneren.
        paralleles_rechnen[ebene].loeser(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle7.starten();
// Kommentar: Warte auf den Abschluss der Kommunikation.
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
        timer_zr_idle.stoppen();
        timer_zr_idle7.stoppen();
// Kommentar: Entpacke die Randwerte bzgl. u0.
        paralleles_rechnen[ebene].entpacken_randwerte_u0();
//        paralleles_rechnen[ebene].loeser_f(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

// Kommentar: Lse nun mittels Jacoby - Verfahren auf dem Rand.
        paralleles_rechnen[ebene].loeser(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Kommentar: Nebst Rckkopieren der berechneten Werte auf u0 - wie es beim Jacoby - Verfahren ntig ist.
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }
    }

// Kommentar: Hier kommt es zum Gauss - Seidel lsen durch gltten.
void ZyklusRechnen::loeser_red_black(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

        {
// Kommentar: Packe die Red - Randpunkte, und initiiere die Kommunikation.
        paralleles_rechnen[ebene].packen_randwerte_u0_red();
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Lse auf den Black Punkten des Inneren. Dort liegen die bentigten Red - Punkte schon vor.
        paralleles_rechnen[ebene].loeser_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle7.starten();
// Kommentar: Warte auf das Ende der Kommunikation
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
        timer_zr_idle.stoppen();
        timer_zr_idle7.stoppen();
// Kommentar: Entpacke die noch nicht vorhandenen Red - Werte.
        paralleles_rechnen[ebene].entpacken_randwerte_u0_red();

// Kommentar: Lse die Black Werte auf den Randpunkten, wo jetzt die Red - Information vorliegt.
        paralleles_rechnen[ebene].loeser_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

// Kommentar: Mache dasselbe zur Lsung der Red - Punkte, also analog zu der Lsung der Black - Punkte.
        paralleles_rechnen[ebene].packen_randwerte_u0_black();
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
        paralleles_rechnen[ebene].loeser_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle7.starten();
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
        timer_zr_idle.stoppen();
        timer_zr_idle7.stoppen();
        paralleles_rechnen[ebene].entpacken_randwerte_u0_black();
        paralleles_rechnen[ebene].loeser_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }
    }

// Kommentar: Hier geschieht eine Gauss - Seidel - Glttung zur Lsung der Gleichung, aber sequentiell. Insbesondere
// kommt es zu keiner Kommunikation.
void ZyklusRechnen::loeser_red_black_sequentiell(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif
        {
// Kommentar: Lse fr die Black - Punkte auf dem Inneren.
        paralleles_rechnen[ebene].loeser_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

// Kommentar: Lse fr die Black - Punkte auf dem Rand.
        paralleles_rechnen[ebene].loeser_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

// Kommentar: Lse fr die Red - Punkte auf dem Inneren.
        paralleles_rechnen[ebene].loeser_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

// Kommentar: Lse fr die Red - Punkte auf dem Rand.
        paralleles_rechnen[ebene].loeser_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }
    }

// Kommentar: e0 wird berechnet im nicht adaptiven Fall. Ob sequentiell oder parallel spielt hier keine Rolle,
// da nicht in der Umgebung von Gitterpunkten gerechnet wird.
void ZyklusRechnen::berechne_e0_oben(void)
    {
// Kommentar: Rechne e0 aus auf dem Rand.
    paralleles_rechnen[ebene].berechne_e0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
//    paralleles_rechnen[ebene].packen_randwerte_e0();
//    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Rechne e0 aus auf dem Inneren.
    paralleles_rechnen[ebene].berechne_e0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    }

// Kommentar: e0 wird durch kopieren berechnet im nicht adaptiven Fall. Ob sequentiell oder parallel spielt hier keine Rolle,
// da nicht in der Umgebung von Gitterpunkten gerechnet wird.
void ZyklusRechnen::kopiere_u0_e0_oben(void)
    {
// Kommentar: Kopiere von u0 zu e0 auf dem Rand.
    paralleles_rechnen[ebene].kopiere_u0_e0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Kommentar: Kopiere von u0 zu e0 auf dem Inneren.
    paralleles_rechnen[ebene].kopiere_u0_e0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    }

// Kommentar: e0 wird im adaptiven Bereich verwendet. Ansonsten derselbe Kommentar wie bei berechne_e0.
// Die Kommentare sind wie bei berechne_e0.
void ZyklusRechnen::berechne_e0_unten(void)
    {
    paralleles_rechnen[ebene].berechne_e0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

    paralleles_rechnen[ebene].berechne_e0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    }

// Kommentar: Das ist der letzte Schritt der Funktion DiskretisierungsFehlerBerechnen, s.o.. Hier wird einfach die
// Differenz von ILu - LIu berechnet, wobei ILu und LIU schon vorliegen. Es ist eine einfach Differenz auf dem Punkt,
// d.h. ohne weitere Randbertragung.
void ZyklusRechnen::berechne_DF(void)
    {
    paralleles_rechnen[ebene_plus1].berechne_DF0(paralleles_rechnen[ebene].f_rand_innen_klein, paralleles_rechnen[ebene].g_rand_innen_klein, paralleles_rechnen[ebene].anzahl_rand_innen_klein);
    paralleles_rechnen[ebene_plus1].berechne_DF0(paralleles_rechnen[ebene].f_innen_klein, paralleles_rechnen[ebene].g_innen_klein, paralleles_rechnen[ebene].anzahl_innen_klein);
    }

// Kommentar: Die Prolongation, parallel, im nicht adaptiven Bereich.
void ZyklusRechnen::prolongationen_oben(void)
    {
        {
// Kommentar: Kopiere die Anzahl der Innen - und Randpunkte.
        prolongationen[ebene_minus_1].anzahl_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten_echter_rand = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen_echter_rand;
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor randaustausch_gg_u0_starten / Rang " << rang << endl;
#endif

// Kommentar: Starte den Grobgitter - Randaustausch fr e0. Der Rand ist dabei der des feinen Gitters,
// die Werte die des groben Gitters.
    randaustausch_gg_e0_starten(ebene_minus_1);
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach randaustausch_gg_u0_starten / Rang " << rang << endl;
#endif
    prolongationen[ebene_minus_1].ausgabe_neue_punkte(ebene_minus_1);
// Kommentar: Mache die bi - quadratische Interpolation fr die Innenpunkte.
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Vor Prolongationen Innen ");
    test_feld_vergangen_385zr(zeichenkette);
#endif
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_innen();
    timer_zr_idle.starten();
    timer_zr_idle9.starten();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor randaustausch_gg_u0_beenden / Rang " << rang << endl;
#endif

// Kommentar: Vollende den Grobgitter - Randaustausch bzgl. e0.
    randaustausch_gg_e0_beenden(ebene_minus_1);
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach randaustausch_gg_u0_beenden / Rang " << rang << endl;
#endif
    timer_zr_idle.stoppen();
    timer_zr_idle9.stoppen();
// Kommentar: Am Ende geschieht die bi-quadratische-Interpolation am Rand. Die Werte dort liegen auf dem groben Gitter vor.
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Vor Prolongationen Rand Innen ");
    test_feld_vergangen_385zr(zeichenkette);
#endif
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_rand();
#ifdef AKTUELLE_KOMMENTARE
    strcpy(zeichenkette, " Nach Prolongationen Rand Innen ");
    test_feld_vergangen_385zr(zeichenkette);
#endif
    }

// Kommentar: Die Prolongation wird durchgefhrt, parallel und im adaptiven Bereich.
void ZyklusRechnen::prolongationen_unten(void)
    {
#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 4427 unten rang " << rang;
#endif
        {
// Kommentar: Kopiere die Anzahlen der Punkte von Rand und Inneren in die gleich verwendete Prolongationsklasse.
        prolongationen[ebene_minus_1].anzahl_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten_echter_rand = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen_echter_rand;
#ifdef AUSGABE_ABC_Pro
        cout << " ai " << prolongationen[ebene_minus_1].anzahl_innen_unten << " ari " << prolongationen[ebene_minus_1].anzahl_rand_innen_unten;
#endif
        }
#ifdef AUSGABE_ABC_Pro
    cout << endl;
#endif

#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 6254 unten rang " << rang << endl;
#endif
// Kommentar: Hier wird der Grobgitterrandaustausch - feiner Rand mit den Grobgitterwerten darber - fr e0 und u0 gemacht.
// Denn die Prolongation muss fr alte und neue Punkte erfolgen.
    randaustausch_gg_e0_und_u0_starten(ebene_minus_1);
    // Was ist mit u0 auf neuen Punkten? Die Idee war, dass die u0 - Werte dort
    // nach aV bertragen werden. Nur: Nach aV kommt die Nachglttung, und die wird hier nicht bertragen.
    // So denke ich jetzt, am 14.08.2014

#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 6274 unten rang " << rang << endl;
#endif
    prolongationen[ebene_minus_1].ausgabe_neue_punkte(ebene_minus_1);
#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 6278 unten rang " << rang << endl;
#endif
// Kommentar: Fhre die Prolongation auf den Innenpunkten durch.
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_innen();
#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 6283 unten rang " << rang << endl;
#endif
    timer_zr_idle.starten();
    timer_zr_idle10.starten();

#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 6291 unten rang " << rang << endl;
#endif

// Kommentar: Vollende die Grobgitterkommunikation.
    randaustausch_gg_e0_und_u0_beenden(ebene_minus_1);

#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 6298 unten rang " << rang << endl;
#endif

        { ; }

    timer_zr_idle.stoppen();
    timer_zr_idle10.stoppen();

// Kommentar: Fhre die Prolongation auf dem Rand aus.
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_rand();
    }

// Kommentar: Das ist die Grobgitterkorrektur. Da ohne Randbeteiligung gearbeitet wird, entfallen Randkommunikationen.
void ZyklusRechnen::korrektur_auf_feinem_gitter(void)
    {
// Kommentar: Auf Ebene der Kappe wird die Korrektur fr die Punkte (f_kappe,g_kappe) durchgefhrt.
    if(ebene_minus_1==h_kappe)
        {
        paralleles_rechnen[ebene_minus_1].korrektur_auf_feinem_gitter(f_kappe, g_kappe, anzahl_kappe);
        }
    else
        {
// Kommentar: Ansonsten fhre die Korrektur im Inneren ...
        paralleles_rechnen[ebene_minus_1].korrektur_auf_feinem_gitter(paralleles_rechnen[ebene_minus_1].f_innen, paralleles_rechnen[ebene_minus_1].g_innen, paralleles_rechnen[ebene_minus_1].anzahl_innen);

// Kommentar: ... und auf dem Rand aus.
        paralleles_rechnen[ebene_minus_1].korrektur_auf_feinem_gitter(paralleles_rechnen[ebene_minus_1].f_rand_innen, paralleles_rechnen[ebene_minus_1].g_rand_innen, paralleles_rechnen[ebene_minus_1].anzahl_rand_innen);
        }
// Korrektur vermutet.
    }

// Kommentar: Das ist dasselbe wie bei korrektur_auf_feinem_gitter, nur ohne die Mglichkeit der Kappe. Die Kommentare
// sind also analog zu dort.
void ZyklusRechnen::korrektur_auf_feinem_gitter_ohne_kappe(void)
    {
    paralleles_rechnen[ebene_minus_1].korrektur_auf_feinem_gitter(paralleles_rechnen[ebene_minus_1].f_innen, paralleles_rechnen[ebene_minus_1].g_innen, paralleles_rechnen[ebene_minus_1].anzahl_innen);

    paralleles_rechnen[ebene_minus_1].korrektur_auf_feinem_gitter(paralleles_rechnen[ebene_minus_1].f_rand_innen, paralleles_rechnen[ebene_minus_1].g_rand_innen, paralleles_rechnen[ebene_minus_1].anzahl_rand_innen);
// Korrektur vermutet.
    }

// Kommentar: Dasselbe wie bei korrektur_auf_feinem_gitter_ohne_kappe, nur eine Ebene hher.
void ZyklusRechnen::korrektur_auf_feinem_gitter_gleiche_ebene(void)
    {
    paralleles_rechnen[ebene].korrektur_auf_feinem_gitter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    paralleles_rechnen[ebene].korrektur_auf_feinem_gitter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    }

//  Kommentar: Die parallele, nicht adaptive Jacoby - Nachglttung.
void ZyklusRechnen::nachglaettung(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

        {

// Kommentar: Packe die Randwerte fr die Nachglttung.
        paralleles_rechnen[ebene].packen_randwerte_u0();//korrigiertes u0 ist nicht u0_hilf.
// Kommentar: Starte die Kommunikation.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
            {
            cout << " W Ausgabe II / rang " << rang << " t0 " << t0 << " nach komm init " << MPI_Wtime() - zeit_anfang_zyklus << " Anzahl " << paralleles_rechnen[ebene].anzahl_innen << " Anzahl RI " << paralleles_rechnen[ebene].anzahl_rand_innen << " wlast " << paralleles_rechnen[ebene].wieviel_punktelast << " ebene " << ebene << endl;
            }

// Kommentar: Das hier sind Debug - Informationen.
#ifdef AKTUELLE_DA
        if(t0==30)
            {
            strcpy(zeichenkette, "da_punktliste_neu");
            da_punktliste.initialisieren(rang, zeichenkette);
            da_punktliste.oeffnen();
            for(i=0; i<paralleles_rechnen[ebene].anzahl_innen; i++)
                {
                * da_punktliste.aus << paralleles_rechnen[ebene].f_innen[i] << " " <<  paralleles_rechnen[ebene].g_innen[i] << endl;
                }
            * da_punktliste.aus << endl;
            da_punktliste.schliessen();
            }
#endif

// Kommentar: Mache die Nachglttung auf dem Inneren.
        paralleles_rechnen[ebene].nachglaetter(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#ifdef AKTUELLE_KOMMENTARE
        cout << " nach nachglaetter " << MPI_Wtime() - zeit_anfang_zyklus;
        cout << " Anzahl rand " << paralleles_rechnen[ebene].wieviel_mal_rand(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#endif

        timer_zr_idle.starten();
        timer_zr_idle11.starten();

#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        if(ii==0)
            {
            cout << " vor idle11 " << MPI_Wtime() - zeit_anfang_zyklus;
            }
#endif
// Kommentar: Warte auf die Beendigung der Kommunikation.
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        if(ii==0)
            {
            cout << " nach idle11 " << MPI_Wtime() - zeit_anfang_zyklus << endl;
            }
#endif
        timer_zr_idle.stoppen();
        timer_zr_idle11.stoppen();
// Kommentar: Entpacke die Randwerte
        paralleles_rechnen[ebene].entpacken_randwerte_u0();
// Kommentar: Mache die Nachglttung auf dem Rand.
        paralleles_rechnen[ebene].nachglaetter(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Kommentar: Und, wie immer bei der Jacoby - Methode, kopiere die berechneten Werte zurck nach u0.
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        paralleles_rechnen[ebene].rueckkopieren_u0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
        }

#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, "nachglaettung");
    u0_ausgeben(zeichenkette);
#endif
    }

// Kommentar: Mache die Nachglttung mit der Gauss - Seidel - Methode.
// Zu den Kommentaren: Vergleiche vorglaettung_red_black.
void ZyklusRechnen::nachglaettung_red_black(void)
    {
#ifdef ZUSATZLAST
    rechnen_nur_als_punktelast();
#endif

        {
        paralleles_rechnen[ebene].packen_randwerte_u0_red();//korrigiertes u0 ist nicht u0_hilf.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

//        if(ii==0) nderung 24.10.15 Spte nderung lassen 10.2.16
            {
            cout << " W Ausgabe II / rang " << rang << " t0 " << t0 << " nach komm init " << MPI_Wtime() - zeit_anfang_zyklus << " Anzahl " << paralleles_rechnen[ebene].anzahl_innen << " Anzahl RI " << paralleles_rechnen[ebene].anzahl_rand_innen << " Summe " << paralleles_rechnen[ebene].anzahl_innen + paralleles_rechnen[ebene].anzahl_rand_innen << " wlast " << paralleles_rechnen[ebene].wieviel_punktelast << " ebene " << ebene << endl;
            }

#ifdef AKTUELLE_DA
        if(t0==30)
            {
            strcpy(zeichenkette, "da_punktliste_neu");
            da_punktliste.initialisieren(rang, zeichenkette);
            da_punktliste.oeffnen();
            for(i=0; i<paralleles_rechnen[ebene].anzahl_innen; i++)
                {
                * da_punktliste.aus << paralleles_rechnen[ebene].f_innen[i] << " " <<  paralleles_rechnen[ebene].g_innen[i] << endl;
                }
            * da_punktliste.aus << endl;
            da_punktliste.schliessen();
            }
#endif
        paralleles_rechnen[ebene].nachglaetter_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#ifdef AUSGABEN_DATEI_101214
        strcpy(zeichenkette, " Nachglaetter red-black nach erstem Teilschritt ");
        u0_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " nach nachglaetter " << MPI_Wtime() - zeit_anfang_zyklus;
        cout << " Anzahl rand " << paralleles_rechnen[ebene].wieviel_mal_rand(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#endif

        timer_zr_idle.starten();
        timer_zr_idle11.starten();

#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        if(ii==0)
            {
            cout << " vor idle11 " << MPI_Wtime() - zeit_anfang_zyklus;
            }
#endif
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
        if(ii==0)
            {
            cout << " nach idle11 " << MPI_Wtime() - zeit_anfang_zyklus << endl;
            }
#endif
        timer_zr_idle.stoppen();
        timer_zr_idle11.stoppen();
        paralleles_rechnen[ebene].entpacken_randwerte_u0_red();
        paralleles_rechnen[ebene].nachglaetter_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

        paralleles_rechnen[ebene].packen_randwerte_u0_black();//korrigiertes u0 ist nicht u0_hilf.
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

#ifdef DOPPELT
        cout << " W Ausgabe II / rang " << rang << " t0 " << t0 << " nach komm init " << MPI_Wtime() - zeit_anfang_zyklus << " Anzahl " << paralleles_rechnen[ebene].anzahl_innen << " Anzahl RI " << paralleles_rechnen[ebene].anzahl_rand_innen << " wlast " << paralleles_rechnen[ebene].wieviel_punktelast << " ebene " << ebene;
#endif
        paralleles_rechnen[ebene].nachglaetter_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#ifdef AUSGABEN_DATEI_101214
        strcpy(zeichenkette, " Nachglaetter red-black nach zweitem Teilschritt ");
        u0_ausgeben(zeichenkette);
#endif
#ifdef AKTUELLE_KOMMENTARE
        cout << " nach nachglaetter " << MPI_Wtime() - zeit_anfang_zyklus;
        cout << " Anzahl rand " << paralleles_rechnen[ebene].wieviel_mal_rand(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
#endif

        timer_zr_idle.starten();
        timer_zr_idle11.starten();

#ifdef DOPPELT
        cout << " vor idle11 " << MPI_Wtime() - zeit_anfang_zyklus;
#endif
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }
#ifdef DOPPELT
        cout << " nach idle11 " << MPI_Wtime() - zeit_anfang_zyklus << endl;
#endif
        timer_zr_idle.stoppen();
        timer_zr_idle11.stoppen();
        paralleles_rechnen[ebene].entpacken_randwerte_u0_black();
        paralleles_rechnen[ebene].nachglaetter_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
        }
    }

// Kommentar: Es geht um die Berechnung des Diskretisierungsfehlers der Funktion
// DiskretisierungsFehlerBerechnen. Die Suffixe oben und unten stehen frs grobe und feine Gitter,
// wenn das feine Gitter auf der Entscheidungsebene liegt. 'oben' ist hier kein Suffix fr nicht adaptiv.
void ZyklusRechnen::berechne_Lu0_oben(void)
    {
// Kommentar: Mache auf dem groben Gitter den u0 - Randaustausch dort, wo Feingitterpunkte darunter liegen.
// Wo anders kann das Kriterium so nicht berechnet werden.
//    paralleles_rechnen[ebene_plus1].kleiner_randaustausch6_initiieren();
    paralleles_rechnen[ebene_plus1].kleiner_randaustausch1_initiieren();
// Kommentar: Berechne den L - Operator fr u0 im Inneren.
    paralleles_rechnen[ebene_plus1].berechne_Lu0(paralleles_rechnen[ebene].f_innen_klein, paralleles_rechnen[ebene].g_innen_klein, paralleles_rechnen[ebene].anzahl_innen_klein);

    timer_zr_kl_idle.starten();
// Kommentar: Beende die Randkommunikation.
    for(;paralleles_rechnen[ebene_plus1].kleiner_randaustausch1_testen()==false;)
        { ; }
    timer_zr_kl_idle.stoppen();
// Kommentar: Berechne den L - Operator fr u0 auf dem Rand.
    paralleles_rechnen[ebene_plus1].berechne_Lu0(paralleles_rechnen[ebene].f_rand_innen_klein, paralleles_rechnen[ebene].g_rand_innen_klein, paralleles_rechnen[ebene].anzahl_rand_innen_klein);
    }

// Kommentar: Vgl. den Kommentar zu berechne_Lu0_oben. Es wird hier der L - Operator berechnet auf dem feinen
// Gitter bei der Berechnung des Diskretisierungsfehlers. 'unten' ist hier kein Suffix fr adaptiv.
void ZyklusRechnen::berechne_Lu0_unten(void)
    {
// Kommentar: Packe die Randwerte von u0. Und starte die Kommunikation.
    paralleles_rechnen[ebene].packen_randwerte_u0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
// Kommentar: Berechne Lu0 auf dem Inneren.
    paralleles_rechnen[ebene].berechne_Lu0(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    timer_zr_idle.starten();
    timer_zr_idle13.starten();
// Kommentar: Warte die Kommunikation ab.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle13.stoppen();
// Kommentar: Entpacke die Randwerte
    paralleles_rechnen[ebene].entpacken_randwerte_u0();
// Kommentar: Berechne den Operator L auf dem Rand.
    paralleles_rechnen[ebene].berechne_Lu0(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    }

// Kommentar: Diese Funktion gehrt auch zur Funktion DiskretisierungsFehlerBerechnen. Es wird auf Lu0 das Fulll Weighting
// angewendet.
void ZyklusRechnen::restriktion_Lu0_unten(void)
    {
// Kommentar: Von Lu0 auf dem feinen Gitter wird der Rand gepackt, und die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].packen_randwerte_Lu0();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Die Anzahl an Innenpunkten wird in die entsprechende Klasse von restriktionen kopiert.
    restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene_plus1].anzahl_innen_klein;

// Kommentar: Die Restriktion FW wird fr Lu0 auf dem Inneren durchgefhrt.
    restriktionen[ebene].full_weighting_innen_Lu0();

    timer_zr_kl_idle.starten();

// Kommentar: Warten auf die Nachrichten ber Lu0.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_kl_idle.stoppen();

// Kommentar: Die Lu0 - Informationen werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_Lu0();

// Kommentar: Die Anzahl an Randpunkten wird in die entsprechende Klasse von restriktionen kopiert.
    restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene_plus1].anzahl_rand_innen_klein;
    restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene_plus1].anzahl_rand_innen_klein_echter_rand; // nderung 31.10.15
// Kommentar: Nun kann das FW fr die Lu0 - Werte auf dem Rand erfolgen.
    restriktionen[ebene].full_weighting_rand_innen_Lu0();
    }

// Kommentar: Der Speicher fr den Ausgabe - Stream aus wird freigegeben.
void ZyklusRechnen::finalisieren_ausgeben(void)
    {
    delete aus;
    }

// Kommentar: Der Ausgabestream aus wird angelegt.
void ZyklusRechnen::initialisieren_ausgeben(void)
    {
// Kommentar: Je nach rang und groesse werden Dateien mit den angegebenen Namen erffnet.
    if(groesse==1)
        {
        aus = new ofstream("Qseq", ios::out);
        return;
        }

      switch(rang)
        {
        case 0:
            aus = new ofstream("Q0", ios::out);
            break;
        case 1:
            aus = new ofstream("Q1", ios::out);
            break;


        case 2:
            aus = new ofstream("Q2", ios::out);
            break;
        case 3:
            aus = new ofstream("Q3", ios::out);

            break;

        case 4:
            aus = new ofstream("Q4", ios::out);
            break;
        case 5:
            aus = new ofstream("Q5", ios::out);
            break;


        case 6:
            aus = new ofstream("Q6", ios::out);
            break;
        case 7:
            aus = new ofstream("Q7", ios::out);
            break;

        case 8:
            aus = new ofstream("Q8", ios::out);
            break;
        case 9:
            aus = new ofstream("Q9", ios::out);
            break;


        case 10:
            aus = new ofstream("Q10", ios::out);
            break;
        case 11:
            aus = new ofstream("Q11", ios::out);
            break;

        case 12:
            aus = new ofstream("Q12", ios::out);
            break;
        case 13:
            aus = new ofstream("Q13", ios::out);
            break;


        case 14:
            aus = new ofstream("Q14", ios::out);
            break;
        case 15:
            aus = new ofstream("Q15", ios::out);
            break;
        }
    }

// Kommentar: Das Folgende ist eine Debugging - Information, aufgerufen in der Funktion 'pruefe_auf_existenz_aggr'
// Es wird gesehen, ob ein Punkt in den Listen Innen und Rand existiert.
bool ZyklusRechnen::pruefe_auf_existenz(int f, int g, int h)
    {
    for(i=0; i<paralleles_rechnen[h].anzahl_innen; i++)
        {
        if(paralleles_rechnen[h].f_innen[i]==f)
            {
            if(paralleles_rechnen[h].g_innen[i]==g)
                {
                return(true);
                }
            }
        }
    for(i=0; i<paralleles_rechnen[h].anzahl_rand_innen; i++)
        {
        if(paralleles_rechnen[h].f_rand_innen[i]==f)
            {
            if(paralleles_rechnen[h].g_rand_innen[i]==g)
                {
                return(true);
                }
            }
        }
    return(false);
    }

// Kommentar: Das ist eine Debugging - Funktion, um die Existenz eines Gitterpunktes zu protokollieren.
void ZyklusRechnen::pruefe_auf_existenz_aggr(int f, int g, int h)
    {
    cout << " pae f " << f << " g " << g << " h " << h << " rang " << rang << " ";
    if(pruefe_auf_existenz(f,g,h)==true)
        {
        cout << " in ZR vorhanden ";
        }
    else
        {
        cout << " in ZR nicht vorhanden ";
        }
    if(paralleles_rechnen[h].pruefe_auf_existenz(f,g)==true)
        {
        cout << " in Gitter vorhanden ";
        }
    else
        {
        cout << " in Gitter nicht vorhanden ";
        }
    cout << endl;
    }

// Kommentar: Nur ein Kommentar frs Debugging.
void ZyklusRechnen::u0_testen_3011(char * text)
    {
#ifdef AKTUELLE_KOMMENTARE
//    if(rang==0)
    if((n>=33)&&(m>=33))
        {
        cout << " u0_testen " << text << " ebene 0 u0(30,11) " << paralleles_rechnen[0].u0[30][11] << " rang " << rang << endl;
        }
#endif
    }

// Kommentar: Nur ein Kommentar frs Debugging.
void ZyklusRechnen::u0_ausgeben_fwv(int updowntop, char * zusatztext) // fwv fuer werte_verschicken
    {
    #ifdef DAFWV
    datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, updowntop, U0, zusatztext, 100);
    #endif
    }

// Kommentar: Nur ein Kommentar frs Debugging.
void ZyklusRechnen::u0_ausgeben(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:u0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:u0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].u0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].u0[i][j] << " ";
            }
        * da_zr.aus << endl;
        cout << endl;
        }
    * da_zr.aus << endl;
    cout << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur ein Kommentar frs Debugging.
void ZyklusRechnen::r0_ausgeben(char * text)
    {
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:r0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:r0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].r0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].r0[i][j] << " ";
            }
        * da_zr.aus << endl;
        cout << endl;
        }
    * da_zr.aus << endl;
    cout << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::e0_ausgeben(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:e0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:e0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].e0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].e0[i][j] << " ";
            }
        * da_zr.aus << endl;
        cout << endl;
        }
    * da_zr.aus << endl;
    cout << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::e0_ausgeben_minus_1(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene_minus_1];
    m_ebene = m_h[ebene_minus_1];

    da_zr.oeffnen();

    cout << " ZR:e0 ausgeben " << text << " rang " << rang << " Ebene " << ebene_minus_1 << endl;
    * da_zr.aus << " ZR:e0 ausgeben " << text << " rang " << rang << " Ebene " << ebene_minus_1 << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene_minus_1].e0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene_minus_1].e0[i][j] << " ";
            }
        * da_zr.aus << endl;
        cout << endl;
        }
    * da_zr.aus << endl;
    cout << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::rS0_ausgeben(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:rS0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:rS0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].rS0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].rS0[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::f0_ausgeben(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
#ifdef AUSGABEN_DATEI_101214
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:f0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:f0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].f0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].f0[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;

    da_zr.schliessen();
#endif
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::u0_ausgeben_plus1(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
#ifdef AUSGABEN_DATEI_101214
    n_ebene = n_h[ebene+1];
    m_ebene = m_h[ebene+1];

    da_zr.oeffnen();

    cout << " ZR:u0 ausgeben " << text << " rang " << rang << " Ebene " << ebene+1 << endl;
    * da_zr.aus << " ZR:u0 ausgeben " << text << " rang " << rang << " Ebene " << ebene+1 << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene+1].u0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene+1].u0[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;

    da_zr.schliessen();
#endif
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::Iu0_ausgeben(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:Iu0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:Iu0 ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].Iu0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].Iu0[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::Iu0_ausgeben_plus1(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene+1];
    m_ebene = m_h[ebene+1];

    da_zr.oeffnen();

    cout << " ZR:Iu0 ausgeben " << text << " rang " << rang << " Ebene " << ebene+1 << endl;
    * da_zr.aus << " ZR:Iu0 ausgeben " << text << " rang " << rang << " Ebene " << ebene+1 << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene+1].Iu0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene+1].Iu0[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::r0_ausgeben_plus1(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene+1];
    m_ebene = m_h[ebene+1];

    da_zr.oeffnen();

    cout << " ZR:r0 ausgeben " << text << " rang " << rang << " Ebene " << ebene+1 << endl;
    * da_zr.aus << " ZR:r0 ausgeben " << text << " rang " << rang << " Ebene " << ebene+1 << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene+1].r0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene+1].r0[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::u0_diff_ausgeben(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    cout << " ZR:u0_diff ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;
    * da_zr.aus << " ZR:u0_diff ausgeben " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene].u0[i][j] - paralleles_rechnen[ebene].exakt[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene].u0[i][j] - paralleles_rechnen[ebene].exakt[i][j] << " ";
            }
        cout << endl;
        * da_zr.aus << endl;
        }
    cout << endl;
    * da_zr.aus << endl;
    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::koordinaten_ausgabe(int _ebene)
    {
#ifdef AUSGABEN_DATEI_101214
    ebene_ka = _ebene;

    cout << " Anzahl Innen " << paralleles_rechnen[ebene_ka].anzahl_innen << " Anzahl Rand Innen " << paralleles_rechnen[ebene_ka].anzahl_rand_innen << " ebene " << ebene_ka << " rang " << rang << endl;

    da_zr.oeffnen();
    * da_zr.aus << " Ebene " << ebene_ka << endl;
    * da_zr.aus << " Innen: ";
    for(i=0; i<paralleles_rechnen[ebene_ka].anzahl_innen; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene_ka].f_innen[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene_ka].g_innen[i] << ")";
        }
    * da_zr.aus << endl;
    * da_zr.aus << " Rand Innen: ";
    for(i=0; i<paralleles_rechnen[ebene_ka].anzahl_rand_innen; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene_ka].f_rand_innen[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene_ka].g_rand_innen[i] << ")";
        }
    * da_zr.aus << endl;
    paralleles_rechnen[ebene_ka].ausgabe_randstruktur_sortieren(&da_zr);
    da_zr.schliessen();
#endif
    }

// Kommentar: Debugging Ausgabe im sequentiellen Fall.
void ZyklusRechnen::koordinaten_ausgabe_sequentiell(int _ebene)
    {
#ifdef AUSGABEN_DATEI_101214
    ebene_ka = _ebene;

    da_zr.oeffnen();
    * da_zr.aus << " Ebene " << ebene_ka << endl;
    * da_zr.aus << " Innen: ";
    for(i=0; i<paralleles_rechnen[ebene_ka].anzahl_innen; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene_ka].f_innen[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene_ka].g_innen[i] << ")";
        }
    * da_zr.aus << endl;
    * da_zr.aus << " Rand Innen: ";
    for(i=0; i<paralleles_rechnen[ebene_ka].anzahl_rand_innen; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene_ka].f_rand_innen[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene_ka].g_rand_innen[i] << ")";
        }
    * da_zr.aus << endl;
    da_zr.schliessen();
#endif
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::koordinaten_ausgabe_klein(int _ebene)
    {
#ifdef AUSGABEN_DATEI_101214
    ebene = _ebene;

    da_zr.oeffnen();
    * da_zr.aus << " Ebene " << ebene << endl;
    * da_zr.aus << " Innen klein: ";
    for(i=0; i<paralleles_rechnen[ebene].anzahl_innen_klein; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene].f_innen_klein[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene].g_innen_klein[i] << ")";
        }
    * da_zr.aus << endl;
    * da_zr.aus << " Innen nicht klein: ";
    for(i=0; i<paralleles_rechnen[ebene].anzahl_innen_nicht_klein; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene].f_innen_nicht_klein[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene].g_innen_nicht_klein[i] << ")";
        }
    * da_zr.aus << endl;
    * da_zr.aus << " Rand Innen klein: ";
    for(i=0; i<paralleles_rechnen[ebene].anzahl_rand_innen_klein; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene].f_rand_innen_klein[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene].g_rand_innen_klein[i] << ")";
        }
    * da_zr.aus << endl;
    * da_zr.aus << " Rand Innen nicht klein: ";
    for(i=0; i<paralleles_rechnen[ebene].anzahl_rand_innen_nicht_klein; i++)
        {
        * da_zr.aus << "(" << paralleles_rechnen[ebene].f_rand_innen_nicht_klein[i];
        * da_zr.aus << "," << paralleles_rechnen[ebene].g_rand_innen_nicht_klein[i] << ")";
        }
    * da_zr.aus << endl;
    da_zr.schliessen();
#endif
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::ebene_ausgeben(char * text)
    {
    da_zr.oeffnen();
    * da_zr.aus << " Ebene: " << ebene << " Text " << text << endl;
    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::u0_ausgeben_minus_1(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene_minus_1];
    m_ebene = m_h[ebene_minus_1];

    da_zr.oeffnen();

    cout << " ZR:u0 ausgeben " << text << " rang " << rang << " Ebene " << ebene_minus_1 << endl;
    * da_zr.aus << " ZR:u0 ausgeben " << text << " rang " << rang << " Ebene " << ebene_minus_1 << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            cout << paralleles_rechnen[ebene_minus_1].u0[i][j] << " ";
            * da_zr.aus << paralleles_rechnen[ebene_minus_1].u0[i][j] << " ";
            }
        * da_zr.aus << endl;
        cout << endl;
        }
    * da_zr.aus << endl;
    cout << endl;

    da_zr.schliessen();
    }

// Kommentar: Nur eine Ausgabe frs Debugging.
void ZyklusRechnen::ausgabe_darunter(char * text)
    {
    #ifndef AUSGABE_KUERZEN
    return;
    #endif
    n_ebene = n_h[ebene];
    m_ebene = m_h[ebene];

    da_zr.oeffnen();

    * da_zr.aus << " ZR:werte_darunter_existieren " << text << " rang " << rang << " Ebene " << ebene << endl;

    for(i=0; i<n_ebene; i++)
        {
        * da_zr.aus << i << " ";
        if(i<10)
            {
            * da_zr.aus << " ";
            }
        for(j=0; j<m_ebene; j++)
            {
            if(paralleles_rechnen[ebene].feld_darunter[i<<1][j<<1]>=0)
                {
                * da_zr.aus << " +";
                }
            else
                {
                * da_zr.aus << " -";
                }
            }
        * da_zr.aus << endl;
        }
    * da_zr.aus << endl;

    da_zr.schliessen();
    }

// Kommentar: Zur Ausgabe in Restriktionen wird die aktuelle Iterationszeit geschrieben.
void ZyklusRechnen::t_setzen_fuer_restriktionen(void)
    {
    for(i=0; i<h_gesamt-1; i++)
        {
        restriktionen[i].t = t0;
        }
    }

// Kommentar: Zur Ausgabe in Prolongationen wird die aktuelle Iterationszeit geschrieben.
void ZyklusRechnen::t_setzen_fuer_prolongationen(void)
    {
    for(i=0; i<h_gesamt-1; i++)
        {
        prolongationen[i].t = t0;
        }
    }

// Kommentar: Eine Debugging - Information.
void ZyklusRechnen::test_e0(char * text)
    {
    cout << " IJK text " << text << " rang " << rang;
    cout << endl;
    }

// Kommentar: Hier werden die Punktemengen (f_kappe,g_kappe) angelegt fr die obigen Funktionen, wenn sie auf der Ebene
// der Kappe rechnen. Das sind dann immer vollstndige Gitter auf der Gitterebene h_kappe.
void ZyklusRechnen::initialisieren_koordinaten_kappe(int _h_kappe)
    {
    n_kappe = n_h[_h_kappe];
    m_kappe = m_h[_h_kappe];
    mn_kappe = n_kappe * m_kappe;
    f_kappe = new short int [mn_kappe];
    g_kappe = new short int [mn_kappe];
    n_kappe_minus1 = n_kappe - 1;
    m_kappe_minus1 = m_kappe - 1;
    for(i=1, anzahl_kappe = 0; i<n_kappe_minus1; i++)
        {
        for(j=1; j<m_kappe_minus1; j++)
            {
            f_kappe[anzahl_kappe] = i;
            g_kappe[anzahl_kappe++] = j;
            }
        }
    }

// Kommentar: Hier wird die Punktliste (f_kappe,g_kappe) wieder frei gegeben,
void ZyklusRechnen::finalisieren_koordinaten_kappe(void)
    {
    delete f_kappe;
    delete g_kappe;
    }

/////////////////////////////////////////////////////////
///// Verfeinerungskriterium tau_h^H ////////////////////
/////////////////////////////////////////////////////////

// Berechne f_h^H

// Kommentar: Entsprechend der Dissertation wird das Experten - Verfeinerungskriterium mittels rechter Seite und f_h^H berechnet.
// Hier wird jetzt f_h^H berechnet.
void ZyklusRechnen::restriktion_f_oben(void)
    {
#ifdef ALT_OHNE_INJEKTION // Ohne Injektion, 25.09.2014
    paralleles_rechnen[ebene].packen_randwerte_f0();
#else
// Kommentar: Die Randwert von f auf dem feinen Gitter werden gepackt.
    paralleles_rechnen[ebene].packen_randwerte_f0();
#endif
// Kommentar: Die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Die Punktanzahlen von Innenpunktmenge und Randpunktmenge werden zu der passenden Restriktionen Klasse kopiert.
        {
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen; // Die zu restriktierende Punkteanzahl
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen; // Die zu restriktierende Punkteanzahl
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand; // Die zu restriktierende Punkteanzahl
        // 5.9.14: Ist ja ein vollstndiges Gitter auf Ebene ebene.
        // muss gesetzt werden.
        }

#ifdef RESTRIKTIONEN_ALT
    restriktionen[ebene].full_weighting_innen_f0();
#else
// Kommentar: Ds Full Weighting fr f0 wird ausgefhrt, wo dazu Randwerte noch nicht gebraucht wurden.
    restriktionen[ebene].full_weighting_innen_f0_ohne_rand_unten();
#endif
    timer_zr_idle.starten();
    timer_zr_idle4.starten();
// Kommentar: Die Kommunikation wird beendet. Darauf wird gewartet.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle4.stoppen();
#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].entpacken_randwerte_f0();
#else
// Kommentar: Die Randwerte auf dem feineren Gitter kamen an, und werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_f0();
#endif

#ifdef MIT_KAPPE_IFS
    if((h_kappe==-1)||(ebene < h_kappe)) // Ueberpruefen !
#endif
        {
// Kommentar: Die Anzahl der Randpunkte wird nach restriktionen(ebene) kopiert.
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen;
        restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand;
        }

// Kommentar: Da die Randwerte jetzt da ist, kann der Rand berechnet werden.
    restriktionen[ebene].full_weighting_rand_innen_f0();
#ifdef RESTRIKTIONEN_ALT
#else
// Kommentar: Die briggebliebenen nicht restriktierten Werte werden der Restriktion unterzogen.
    restriktionen[ebene].full_weighting_innen_f0_abschluss();
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_oben: Nach restriktionen[ebene].full_weighting_rand_innen_f0(); 7744 rang " << rang << endl;
#endif

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen oben Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen oben r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene+1);
#endif
#endif
#endif
    }

// Kommentar: Es erfolgt die Restriktion von f im adaptiven Bereich.
void ZyklusRechnen::restriktion_f_unten(void)
// Unten steht fr unten im Zyklus, das heisst im adaptiven Bereich.
// 18.08.2014: So ist es falsch: Ausgetauscht wird unten der Rand, Innen und Rand Innen aber nach oben entschieden.
// So wird nicht fr alle Innenpunkte der Rand unten komplett da sein.
// Dasselbe wie oben: Dieser Fehler wurde behoben. 2.7.15.
    {
#ifdef AKTUELLE_KOMMENTARE
    cout << " beide_restriktionen_unten Anfang " << paralleles_rechnen[0].u0[30][12] << " ebene " << ebene << " rang " << rang << endl;
    strcpy(zeichenkette, "Anfang von beide restriktionen unten");
    u0_testen_3011(zeichenkette);
#endif
#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].packen_randwerte_f0();
#else
// Kommentar: Die Werte von f0 auf dem feinen Gitter werden gepackt.
    paralleles_rechnen[ebene].packen_randwerte_f0();
#endif
// Kommentar: Die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
// Kommentar: Die Punktanzahlen werden nach der Restriktionsklasse kopiert.
    restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen_klein;
    restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen_klein;
    restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_klein_echter_rand; // nderung 31.10.15

#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " bdu 1 / rang " << rang << endl;
#endif
#ifdef RESTRIKTIONEN_ALT
    restriktionen[ebene].full_weighting_innen_f0();
#else
// Kommentar: Das Full Weightinmg fr Punkte, die unten nicht am Rand liegen, kann schon ausgefhrt werden. Das wird jetzt
// gemacht.
    restriktionen[ebene].full_weighting_innen_f0_ohne_rand_unten();
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << " bdu 2 / rang " << rang << endl;
#endif

    timer_zr_idle.starten();
    timer_zr_idle5.starten();
// Kommentar: Die Kommunikation wird abgewartet.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle5.stoppen();

#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].entpacken_randwerte_f0();
#else
// Kommentar: Die Randwerte von f werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_f0();
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Jetzt mten die Randwerte da sein / rang " << rang << " ebene " << ebene << endl;
#endif

// Kommentar: Das Full Weighting auf den Randpunkten (Rand grobes Gitter) wird vollendet.
    restriktionen[ebene].full_weighting_rand_innen_f0();
#ifndef RESTRIKTIONEN_ALT
#else
// Kommentar: Die verbliebenen Punkte - Rand des feinen Gitters fr die Innenpunkte des groben Gitters - werden der
// Restriktion unterzogen.
    restriktionen[ebene].full_weighting_innen_f0_abschluss();
#endif

#ifdef AKTUELLE_KOMMENTARE
    cout << " Ende Restriktion f unten / rang " << rang << " ebene " << ebene << endl;
#endif
    }

// Kommentar: Das Verfeinerungskriterium von Prof. Joppich - vgl. die Dissertation - wird berechnet.
void ZyklusRechnen::MLAT_tau_berechnen(int k)
    {
    ebene = k-1;
// Kommentar: Zuerst geschieht die Restriktion von f.
    restriktion_f_oben();
    ebene ++;
// Kommentar: Und dann wird aus If und der rechten Seite das Verfeinerungskriterium berechnet.
    berechne_tau();
    }

// Kommentar: Es wird aus If und der rechten Seite das Verfeinerungskriterium berechnet. Hier braucht nicht kommuniziert
// werden, da eine Variablendifferenz auf einem Punkt bestimmt wird.
void ZyklusRechnen::berechne_tau(void)
    {
// Kommentar: Berechne den Diskretisierungsfehler fr die Innenpunkte.
    paralleles_rechnen[ebene].berechne_tau(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

// Kommentar: Berechne den Diskretisierungsfehler fr die Randpunkte.
    paralleles_rechnen[ebene].berechne_tau(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
// Korrektur vermutet.
    }

// Kommentar: Hier wird der 'Diskretisierungsfehler' des Autors berechnet.
void ZyklusRechnen::MLAT_tau12_berechnen(int k) // k: Gitter zur Berechnung
    {
    ebene = k;
    ebene_plus1 = ebene+1;

#ifdef ZYKLUS_RECHNEN_NEU
    cout << " MLAT tau12 Beginn rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, " Vor tau12_berechnen vor randaustausch ");
            test_feld_vergangen_385zr(zeichenkette);
#endif
// Kommentar: Zuerst geschieht der Randaustausch auf der feineren Ebene.
    randaustausch_u0(k); // fr ebene
#ifdef ZYKLUS_RECHNEN_NEU
    cout << " MLAT tau12 nach ra u0 rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, " Vor tau12_berechnen vor randaustausch_fg ");
            test_feld_vergangen_385zr(zeichenkette);
#endif
// Kommentar: Der folgende Schritt ist ganz wichtig.
// Kommentar: Jetzt werden mit Hilfe des groben Gitters weiter entfernte Feingitterwerte auf dem feinen Gitter kommuniziert.
// Das geht aber nur fr 'gemeinsame Punkte', vgl. die Definition dieser Punkte in der Dissertation.
    randaustausch_fg_u0(ebene_plus1); // fr ebene+1, aber u0 auf Ebene ebene.
#ifdef ZYKLUS_RECHNEN_NEU
    cout << " MLAT tau12 nach ra_fg rang " << rang << endl;
#endif
#ifdef AKTUELLE_KOMMENTARE
            strcpy(zeichenkette, " Vor tau12_berechnen nach randaustausch_fg ");
            test_feld_vergangen_385zr(zeichenkette);
#endif
// Kommentar: Der 'Diskretisierungsfehler' des Autors wird berechnet.
    berechne_tau12(); // fr ebene
#ifdef ZYKLUS_RECHNEN_NEU
    cout << " MLAT tau12 nach berechne_tau12 rang " << rang << endl;
#endif
    }

// Kommentar: Berechnung des Diskretisierungsfehlers des Autors.
void ZyklusRechnen::berechne_tau12(void)
    {
// Kommentar: Fr die Innenpunkte und die Randpunkte wird der Diskretisierungsfehler berechnet. Dabei wird die notwendige
// Rand - Information von u0 vorausgesetzt, vgl. die Schritte der Funktion MLAT_tau12_berechnen.
    paralleles_rechnen[ebene].berechne_tau12(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

    paralleles_rechnen[ebene].berechne_tau12(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    }

// Kommentar: Eine Debugging - Ausgabe.
void ZyklusRechnen::text387(char * text)
    {
    cout << " KLMN text 387 " << text << " rang " << rang << " t0 " << t0 << endl;
    }

// Kommentar: Das hier entspricht einer von mir abgenderten solve-pre Funktion der Implementation von Herrn Hess der Shallow-Water-Equations. Man
// vergleiche die berechneten Variablen sowie die Menge an ausgetauschtem Rand.
void ZyklusRechnen::loesen_vorher(int k)
    {
    ebene = k;

// Kommentar: Den Rand packen von der Variablen v1, v2, v3, v4, und die Kommunikation starten.
    paralleles_rechnen[ebene].packen_randwerte_v1v2v3v4();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Teil 1 der von mir genderten Version der solve-pre Funktion der Implementation von Herrn Hess der SWE wird berechnet.
    paralleles_rechnen[ebene].loesen_vorher_teil1(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

// Kommentar: Die Randkommunikation wird abgewartet, und danach entpackt.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    paralleles_rechnen[ebene].entpacken_randwerte_v1v2v3v4();

// Kommentar: Fr die entpackten Variablen wird Teil 1 gelst.
    paralleles_rechnen[ebene].loesen_vorher_teil1(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

// Kommentar: Man macht selbiges jetzt fr die Variablen v5, v6, v7 sowie Teil 2 und Teil 3 der von mir genderten Version der Funktion solve-pre der Implementation von Herrn Hess der SWE.
    paralleles_rechnen[ebene].packen_randwerte_v5v6v7();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

    paralleles_rechnen[ebene].loesen_vorher_teil2(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    paralleles_rechnen[ebene].loesen_vorher_teil3(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    paralleles_rechnen[ebene].entpacken_randwerte_v5v6v7();

    paralleles_rechnen[ebene].loesen_vorher_teil2(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    paralleles_rechnen[ebene].loesen_vorher_teil3(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

// Kommentar: Man macht selbiges jetzt fr die Variablen v8 und v9 sowie Teil 4 und Teil 5 und Teil 6 der von mir genderten Version der Funktion solve-pre der Implementation von Herrn Hess der SWE,
// wobei die Randkommunikation nur fr den Teil 5 relevant ist.

    paralleles_rechnen[ebene].packen_randwerte_v8v9();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

    paralleles_rechnen[ebene].loesen_vorher_teil4(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    paralleles_rechnen[ebene].loesen_vorher_teil4(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

    paralleles_rechnen[ebene].loesen_vorher_teil5(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

    paralleles_rechnen[ebene].loesen_vorher_teil6(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    paralleles_rechnen[ebene].loesen_vorher_teil6(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    paralleles_rechnen[ebene].entpacken_randwerte_v8v9();

    paralleles_rechnen[ebene].loesen_vorher_teil5(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    }

// Kommentar: Das hier entspricht einer von mir abgenderten solve-post Funktion der Implementation von Herrn Hess der Shallow-Water-Equations. Man
// vergleiche die berechneten Variablen sowie die Menge an ausgetauschtem Rand.
void ZyklusRechnen::loesen_nachher(int k)
    {
    ebene = k;

// Kommentar: Man macht selbiges wie in loesen_vorher jetzt fr die Variablen v4, v6 und v11 sowie Teil 1 und Teil 2 der von mir genderten Version der Funktion
// solve-pre der Implementation von Herrn Hess der SWE, wobei die Randkommunikation nur fr den Teil 1 relevant ist.
    paralleles_rechnen[ebene].packen_randwerte_v4v6v11();
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

    paralleles_rechnen[ebene].loesen_nachher_teil1(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);


    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    paralleles_rechnen[ebene].entpacken_randwerte_v4v6v11();

    paralleles_rechnen[ebene].loesen_nachher_teil1(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    paralleles_rechnen[ebene].loesen_nachher_teil2(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);
    paralleles_rechnen[ebene].loesen_nachher_teil2(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);
    }

// Kommentar: Es wird ein Zeitquivalent zur Red-Black-Glttung der Implementation von Herrn Hess der SWE gebildet.
void ZyklusRechnen::glaettung_red_black_swe(void)
    {
#ifdef AKTUELLE_WERTE
    strcpy(zeichenkette, "vor vorglaettung 2662");
    u0_ausgeben(zeichenkette);
#endif
        {
// Kommentar: Die Red - Randwerte werden fr Variable v6 gepackt und verschickt.
        paralleles_rechnen[ebene].packen_randwerte_v6_red();
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

// Kommentar: Jetzt wird die Funktion glaetten_swe_black in Rechnen aufgerufen, wobei die Variable v6 verwendet wird.
// Berechnet werden nur die Black - Punkte.
        paralleles_rechnen[ebene].glaetten_swe_black(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle1.starten();

// Kommentar: Der Abschlu der Kommunikation wird abgewartet.
        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }

        timer_zr_idle.stoppen();
        timer_zr_idle1.stoppen();

// Kommentar: Danach werden die Randwerte der Variablen v6 entpackt.
        paralleles_rechnen[ebene].entpacken_randwerte_v6_red();

// Kommentar: Jetzt werden die Werte auf den Black - Punkten auf dem Rand berechnet.
        paralleles_rechnen[ebene].glaetten_swe_black(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);


#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Black-rechnen");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 85+ii*5);
#endif

#ifdef AUSGABEN_DATEI_101214
        strcpy(zeichenkette, " Vorglaetter red-black nach erstem Teilschritt ");
        u0_ausgeben(zeichenkette);
#endif

// Kommentar: Nun geschieht dieselbe Rechnung fr die Red - Punkte. Die Kommentare oben sind entsprechend analog zu verwenden.
        paralleles_rechnen[ebene].packen_randwerte_v6_black();
        paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();
        paralleles_rechnen[ebene].glaetten_swe_red(paralleles_rechnen[ebene].f_innen, paralleles_rechnen[ebene].g_innen, paralleles_rechnen[ebene].anzahl_innen);

        timer_zr_idle.starten();
        timer_zr_idle1.starten();

        for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
            { ; }

        timer_zr_idle.stoppen();
        timer_zr_idle1.stoppen();

        paralleles_rechnen[ebene].entpacken_randwerte_v6_black();
        paralleles_rechnen[ebene].glaetten_swe_red(paralleles_rechnen[ebene].f_rand_innen, paralleles_rechnen[ebene].g_rand_innen, paralleles_rechnen[ebene].anzahl_rand_innen);

#ifdef DAFWV
        strcpy(zeichenkette, "Nach-Red-rechnen");
        datei_ausgabe_fuer_wertevergleich.ausgeben_dafwv(ebene, UP, U0, zeichenkette, 85+ii*5 + 2);
#endif
#ifdef AUSGABEN_DATEI_101214
        strcpy(zeichenkette, " Vorglaetter red-black nach zweitem Teilschritt ");
        u0_ausgeben(zeichenkette);
#endif
        }
    }

// Kommentar: Eine Restriktion fr die Implementierung von Herrn Hess der SWE wird von mir 'zeitlich' abgebildet.
void ZyklusRechnen::restriktion_swe(int k)
    {
    ebene = k;
    ebene_plus1 = k+1;

#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Anfang restriktion_swe rang " << rang << endl;
#endif // AUSGABEN_ZYKLUS_RECHNEN_NEU
// Kommentar: In dem fw_operator_swe aaus der Klasse Restriktion wird v6 im Abstand 2 gebraucht. Das geschieht fr
// gemeinsame Punkte mit den folgenden 5 Programmzeilen.
    paralleles_rechnen[ebene_plus1].packen_randwerte_fg_v6();
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Nach packen_fg_v6 restriktion_swe rang " << rang << endl;
#endif // AUSGABEN_ZYKLUS_RECHNEN_NEU
    paralleles_rechnen[ebene_plus1].randwerte_kommunikation_starten_fu();
    for(;paralleles_rechnen[ebene_plus1].ist_fertig_fu()==false;)
        { ; }
#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Nach kommunikation starten restriktion_swe rang " << rang << endl;
#endif // AUSGABEN_ZYKLUS_RECHNEN_NEU
    paralleles_rechnen[ebene_plus1].entpacken_randwerte_fg_v6();

#ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Nach fg_v6 restriktion_swe rang " << rang << endl;
#endif // AUSGABEN_ZYKLUS_RECHNEN_NEU


    // Auf geraden Punkten fr den 2er - Abstand

#ifdef ALT_OHNE_INJEKTION // Ohne Injektion, 25.09.2014
    paralleles_rechnen[ebene].packen_randwerte_v6();
#else
// Kommentar: Dann werden die Werte der Variablen v6 am Rand gepackt.
    paralleles_rechnen[ebene].packen_randwerte_v6();
#endif
// Kommentar: Und die Kommunikation wird initiiert.
    paralleles_rechnen[ebene].randwerte_kommunikation_starten_fu();

        {
// Kommentar: Die Anzahlen Innen und am Rand werden nach restriktionen(ebene) kopiert.
        restriktionen[ebene].anzahl_innen_oben = paralleles_rechnen[ebene+1].anzahl_innen; // Die zu restriktierende Punkteanzahl
        restriktionen[ebene].anzahl_rand_innen_oben = paralleles_rechnen[ebene+1].anzahl_rand_innen; // Die zu restriktierende Punkteanzahl
        if(ebene<h_min)
            {
//            restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand; // Die zu restriktierende Punkteanzahl
            restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_klein_echter_rand; // Die zu restriktierende Punkteanzahl. nderung 31.10.15. Wegen spter nderung beide Zeilen lassen.
            }
        else
            {
            restriktionen[ebene].anzahl_rand_innen_oben_echter_rand = paralleles_rechnen[ebene+1].anzahl_rand_innen_echter_rand; // Die zu restriktierende Punkteanzahl
            }
        // 5.9.14: Ist ja ein vollstndiges Gitter auf Ebene ebene.
#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
        cout << " Anzahl Restriktionspunkte " << restriktionen[ebene].anzahl_innen_oben << " ebene " << ebene << endl;
#endif
#endif
        }
#ifdef RESTRIKTIONEN_ALT
    restriktionen[ebene].full_weighting_innen_r0();
#else
    #ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Vor Restriktionen 1 rang " << rang << endl;
    #endif
// Kommentar: Es erfolgen Restriktionen entsprechend der Funktion fw_operator_swe, wo die Werte dafr da sind.
    restriktionen[ebene].full_weighting_innen_ohne_rand_unten_swe();

#ifdef DEBUG
    cout << " Nach restriktionen.fwioruh / rang " << rang << endl;
#endif

    #ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Nach Restriktionen 1 rang " << rang << endl;
    #endif
#endif
    timer_zr_idle.starten();
    timer_zr_idle4.starten();
// Kommentar: Die Kommunikation muss abgewartet werden.
    for(;paralleles_rechnen[ebene].ist_fertig_fu()==false;)
        { ; }
    timer_zr_idle.stoppen();
    timer_zr_idle4.stoppen();
#ifdef ALT_OHNE_INJEKTION
    paralleles_rechnen[ebene].entpacken_randwerte_v6();
#else
// Kommentar: Und die Randwerte zu v6 werden entpackt.
    paralleles_rechnen[ebene].entpacken_randwerte_v6();
#endif

    #ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Vor Restriktionen 2 rang " << rang << endl;
    #endif
// Kommentar: Jetzt erfolgt das Full Weighting am Rand des grberen Gitters.
    restriktionen[ebene].full_weighting_rand_innen_swe();
    #ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Nach Restriktionen 2 rang " << rang << endl;
    #endif
#ifdef RESTRIKTIONEN_ALT
#else
    #ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Vor Restriktionen 3 rang " << rang << endl;
    #endif
// Kommentar: Und die restlichen Innenpunkte des groben Gitters werden der Restriktion unterzogen.
    restriktionen[ebene].full_weighting_innen_abschluss_swe();
    #ifdef AUSGABEN_ZYKLUS_RECHNEN_NEU
    cout << " Nach Restriktionen 3 rang " << rang << endl;
    #endif
#endif
#ifdef AUSGABEN_ZYKLUS_RECHNEN
    cout << "In beide_restriktionen_oben: Nach restriktionen[ebene].full_weighting_rand_innen_r0(); 8201 rang " << rang <<endl;
#endif

#ifdef AKTUELLE_WERTE
#ifdef AUSGABEN_SEQUENTIELL
#ifdef AUSGABEN_DATEI_101214
    strcpy(zeichenkette, "beide restriktionen oben Iu0");
    Iu0_ausgeben_plus1(zeichenkette);
    strcpy(zeichenkette, "beide restriktionen oben r0");
    r0_ausgeben_plus1(zeichenkette);
#endif
#ifdef AUSGABEN_DATEI_101214
    koordinaten_ausgabe(ebene+1);
#endif
#endif
#endif
#ifdef DEBUG
    cout << " Durch restriktionen swe durch / rang " << rang << endl;
#endif
    }

// Kommentar: Angabe meiner Prolongations-Zeitdarstellung der Implementation von Herrn Hess der SWE. Man vergleiche die Funktion
// prolongationen_oben.
void ZyklusRechnen::prolongationen_oben_swe(void)
    {
        {
// Kommentar: Zuerst werden die Punktanzahlen nach der Klasse prolongationen(ebene-1) kopiert.
        prolongationen[ebene_minus_1].anzahl_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten_echter_rand = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen_echter_rand;
        }
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor randaustausch_gg_u0_starten / Rang " << rang << endl;
#endif

// Kommentar: Entsprechend der Funktion prolongationen_oben aus Zeile 5940 wird hier mit der Variablen
// v9 verfahren. Man macht einen Grobgitterrandaustausch.
    randaustausch_gg_v9_starten(ebene_minus_1);
    // Das ist korrekt v9 und nicht v6, weil v9 die Quelle ist, also dort Daten dupliziert werden mssen. 5.12.2014
    // Besttigt: Denn: Bei prolongationen unten werden e0 und u0 kommuniziert. Ggf. Kommentar zu randaustausch_gg schreiben. 5.12.2014
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach randaustausch_gg_u0_starten / Rang " << rang << endl;
#endif
    prolongationen[ebene_minus_1].ausgabe_neue_punkte(ebene_minus_1);
// Kommentar: Dann wird die Prolongation fr die von mir genderte Version der Implementierung von Herrn Hess der SWE berechnet. Es geht dabei um die Zeit
// und nicht um die Werte.
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_innen_swe();
    timer_zr_idle.starten();
    timer_zr_idle9.starten();
#ifdef AKTUELLE_KOMMENTARE
    cout << " Vor randaustausch_gg_u0_beenden / Rang " << rang << endl;
#endif

// Kommentar: Der Grobgitter - Randaustausch bzgl. der Variablen v9 wird beendet.
    randaustausch_gg_v9_beenden(ebene_minus_1);
#ifdef AKTUELLE_KOMMENTARE
    cout << " Nach randaustausch_gg_u0_beenden / Rang " << rang << endl;
#endif
    timer_zr_idle.stoppen();
    timer_zr_idle9.stoppen();
// Kommentar: Die Prolongation wird auf den Randpunkten vollendet.
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_rand_swe();
    }

// Kommentar: Die Prolongationen fr die von mir genderte Version der Implementierung von Herrn Hess der SWE im adaptiven Bereich. Die Kommentare entsprechen denen
// aus der Funktion 'prolongationen_oben_swe'.
void ZyklusRechnen::prolongationen_unten_swe(void)
    {
#ifdef AUSGABE_ABC_Pro
    cout << " ABC Prolongationen 4427 unten rang " << rang;
#endif
        {
        prolongationen[ebene_minus_1].anzahl_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen;
        prolongationen[ebene_minus_1].anzahl_rand_innen_unten_echter_rand = paralleles_rechnen[ebene_minus_1].anzahl_rand_innen_echter_rand;
#ifdef AUSGABE_ABC_Pro
        cout << " ai " << prolongationen[ebene_minus_1].anzahl_innen_unten << " ari " << prolongationen[ebene_minus_1].anzahl_rand_innen_unten;
#endif
        }
    cout << endl;

    randaustausch_gg_v9_starten(ebene_minus_1);
    /********* Das wird gestartet, weil v9 - Punkte die Quelle fr die Rechnung sind. *****/
    // Was ist mit u0 auf neuen Punkten? Die Idee war, dass die u0 - Werte dort
    // nach aV bertragen werden. Nur: Nach aV kommt die Nachglttung, und die wird hier nicht bertragen.
    // So denke ich jetzt, am 14.08.2014
    prolongationen[ebene_minus_1].ausgabe_neue_punkte(ebene_minus_1);
    prolongationen[ebene_minus_1].bi_quadratische_interpolation_innen_swe();
    timer_zr_idle.starten();
    timer_zr_idle10.starten();

    randaustausch_gg_v9_beenden(ebene_minus_1);

        { ; }

    timer_zr_idle.stoppen();
    timer_zr_idle10.stoppen();

    prolongationen[ebene_minus_1].bi_quadratische_interpolation_rand_swe();
    }

void ZyklusRechnen::zeitausgabe(char * text)
    {
    if(rang!=0)
        {
        return;
        }
    cout << " Zeitausgabe rang " << rang << " text " << text << " Zeit " << MPI_Wtime() - zeit_anfang_zyklus << endl;
    }

// Kommentar: Das ist eine reine Ausgabe zu Debugging - Zwecken.
void ZyklusRechnen::test_feld_vergangen_385zr(char * text)
    {
    }
